/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/offsetRange","vs/editor/common/core/position","vs/base/common/arrays","vs/base/common/strings","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/arraysFind","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/core/lineRange","vs/base/common/assert","vs/base/common/objects","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/map","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(C){for(var t=[],i=0,F=C.length;i<F;i++)t[i]=ne[C[i]];return t};const xe=this,ze=typeof global=="object"?global:{};var oe;(function(C){C.global=xe;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof C.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}C.Environment=t})(oe||(oe={}));var oe;(function(C){class t{constructor(h,w,c){this.type=h,this.detail=w,this.timestamp=c}}C.LoaderEvent=t;class i{constructor(h){this._events=[new t(1,"",h)]}record(h,w){this._events.push(new t(h,w,C.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}C.LoaderEventRecorder=i;class F{record(h,w){}getEvents(){return[]}}F.INSTANCE=new F,C.NullLoaderEventRecorder=F})(oe||(oe={}));var oe;(function(C){class t{static fileUriToFilePath(F,y){if(y=decodeURI(y).replace(/%23/g,"#"),F){if(/^file:\/\/\//.test(y))return y.substr(8);if(/^file:\/\//.test(y))return y.substr(5)}else if(/^file:\/\//.test(y))return y.substr(7);return y}static startsWith(F,y){return F.length>=y.length&&F.substr(0,y.length)===y}static endsWith(F,y){return F.length>=y.length&&F.substr(F.length-y.length)===y}static containsQueryString(F){return/^[^\#]*\?/gi.test(F)}static isAbsolutePath(F){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(F)}static forEachProperty(F,y){if(F){let h;for(h in F)F.hasOwnProperty(h)&&y(h,F[h])}}static isEmpty(F){let y=!0;return t.forEachProperty(F,()=>{y=!1}),y}static recursiveClone(F){if(!F||typeof F!="object"||F instanceof RegExp||!Array.isArray(F)&&Object.getPrototypeOf(F)!==Object.prototype)return F;let y=Array.isArray(F)?[]:{};return t.forEachProperty(F,(h,w)=>{w&&typeof w=="object"?y[h]=t.recursiveClone(w):y[h]=w}),y}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(F){return t.startsWith(F,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=C.global.performance&&typeof C.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?C.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,C.Utilities=t})(oe||(oe={}));var oe;(function(C){function t(y){if(y instanceof Error)return y;const h=new Error(y.message||String(y)||"Unknown Error");return y.stack&&(h.stack=y.stack),h}C.ensureError=t;class i{static validateConfigurationOptions(h){function w(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory function of "'+c.moduleId+'" has thrown an exception'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}}if(h=h||{},typeof h.baseUrl!="string"&&(h.baseUrl=""),typeof h.isBuild!="boolean"&&(h.isBuild=!1),typeof h.paths!="object"&&(h.paths={}),typeof h.config!="object"&&(h.config={}),typeof h.catchError>"u"&&(h.catchError=!1),typeof h.recordStats>"u"&&(h.recordStats=!1),typeof h.urlArgs!="string"&&(h.urlArgs=""),typeof h.onError!="function"&&(h.onError=w),Array.isArray(h.ignoreDuplicateModules)||(h.ignoreDuplicateModules=[]),h.baseUrl.length>0&&(C.Utilities.endsWith(h.baseUrl,"/")||(h.baseUrl+="/")),typeof h.cspNonce!="string"&&(h.cspNonce=""),typeof h.preferScriptTags>"u"&&(h.preferScriptTags=!1),h.nodeCachedData&&typeof h.nodeCachedData=="object"&&(typeof h.nodeCachedData.seed!="string"&&(h.nodeCachedData.seed="seed"),(typeof h.nodeCachedData.writeDelay!="number"||h.nodeCachedData.writeDelay<0)&&(h.nodeCachedData.writeDelay=1e3*7),!h.nodeCachedData.path||typeof h.nodeCachedData.path!="string")){const c=t(new Error("INVALID cached data configuration, 'path' MUST be set"));c.phase="configuration",h.onError(c),h.nodeCachedData=void 0}return h}static mergeConfigurationOptions(h=null,w=null){let c=C.Utilities.recursiveClone(w||{});return C.Utilities.forEachProperty(h,(l,u)=>{l==="ignoreDuplicateModules"&&typeof c.ignoreDuplicateModules<"u"?c.ignoreDuplicateModules=c.ignoreDuplicateModules.concat(u):l==="paths"&&typeof c.paths<"u"?C.Utilities.forEachProperty(u,(o,E)=>c.paths[o]=E):l==="config"&&typeof c.config<"u"?C.Utilities.forEachProperty(u,(o,E)=>c.config[o]=E):c[l]=C.Utilities.recursiveClone(u)}),i.validateConfigurationOptions(c)}}C.ConfigurationOptionsUtil=i;class F{constructor(h,w){if(this._env=h,this.options=i.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let c=this.options.nodeRequire.main.filename,l=Math.max(c.lastIndexOf("/"),c.lastIndexOf("\\"));this.options.baseUrl=c.substring(0,l+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let h=0;h<this.options.ignoreDuplicateModules.length;h++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[h]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],C.Utilities.forEachProperty(this.options.paths,(h,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:h,to:w}):this.sortedPathsRules.push({from:h,to:[w]})}),this.sortedPathsRules.sort((h,w)=>w.from.length-h.from.length)}cloneAndMerge(h){return new F(this._env,i.mergeConfigurationOptions(h,this.options))}getOptionsLiteral(){return this.options}_applyPaths(h){let w;for(let c=0,l=this.sortedPathsRules.length;c<l;c++)if(w=this.sortedPathsRules[c],C.Utilities.startsWith(h,w.from)){let u=[];for(let o=0,E=w.to.length;o<E;o++)u.push(w.to[o]+h.substr(w.from.length));return u}return[h]}_addUrlArgsToUrl(h){return C.Utilities.containsQueryString(h)?h+"&"+this.options.urlArgs:h+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(h){return this.options.urlArgs?this._addUrlArgsToUrl(h):h}_addUrlArgsIfNecessaryToUrls(h){if(this.options.urlArgs)for(let w=0,c=h.length;w<c;w++)h[w]=this._addUrlArgsToUrl(h[w]);return h}moduleIdToPaths(h){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(h))return this.isBuild()?["empty:"]:["node|"+h];let w=h,c;if(!C.Utilities.endsWith(w,".js")&&!C.Utilities.isAbsolutePath(w)){c=this._applyPaths(w);for(let l=0,u=c.length;l<u;l++)this.isBuild()&&c[l]==="empty:"||(C.Utilities.isAbsolutePath(c[l])||(c[l]=this.options.baseUrl+c[l]),!C.Utilities.endsWith(c[l],".js")&&!C.Utilities.containsQueryString(c[l])&&(c[l]=c[l]+".js"))}else!C.Utilities.endsWith(w,".js")&&!C.Utilities.containsQueryString(w)&&(w=w+".js"),c=[w];return this._addUrlArgsIfNecessaryToUrls(c)}requireToUrl(h){let w=h;return C.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],C.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(h){return!!(!this.options.isBuild||C.Utilities.isAnonymousModule(h)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[h])}isDuplicateMessageIgnoredFor(h){return this.ignoreDuplicateModulesMap.hasOwnProperty(h)}getConfigForModule(h){if(this.options.config)return this.options.config[h]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(h){this.options.onError(h)}}C.Configuration=F})(oe||(oe={}));var oe;(function(C){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,o,E,b){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new y;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new i:this._scriptLoader=new h(this._env)}else this._env.isNode?this._scriptLoader=new h(this._env):this._scriptLoader=new i;let m={callback:E,errorback:b};if(this._callbackMap.hasOwnProperty(o)){this._callbackMap[o].push(m);return}this._callbackMap[o]=[m],this._scriptLoader.load(u,o,()=>this.triggerCallback(o),e=>this.triggerErrorback(o,e))}triggerCallback(u){let o=this._callbackMap[u];delete this._callbackMap[u];for(let E=0;E<o.length;E++)o[E].callback()}triggerErrorback(u,o){let E=this._callbackMap[u];delete this._callbackMap[u];for(let b=0;b<E.length;b++)E[b].errorback(o)}}class i{attachListeners(u,o,E){let b=()=>{u.removeEventListener("load",m),u.removeEventListener("error",e)},m=L=>{b(),o()},e=L=>{b(),E(L)};u.addEventListener("load",m),u.addEventListener("error",e)}load(u,o,E,b){if(/^node\|/.test(o)){let m=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=o.split("|"),A=null;try{A=e(L[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],()=>A),E()}else{let m=document.createElement("script");m.setAttribute("async","async"),m.setAttribute("type","text/javascript"),this.attachListeners(m,E,b);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(o=e.createScriptURL(o)),m.setAttribute("src",o);const{cspNonce:L}=u.getConfig().getOptionsLiteral();L&&m.setAttribute("nonce",L),document.getElementsByTagName("head")[0].appendChild(m)}}}function F(l){const{trustedTypesPolicy:u}=l.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class y{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=F(u)),this._cachedCanUseEval}load(u,o,E,b){if(/^node\|/.test(o)){const m=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=o.split("|");let A=null;try{A=e(L[1])}catch(N){b(N);return}u.enqueueDefineAnonymousModule([],function(){return A}),E()}else{const{trustedTypesPolicy:m}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(o)&&o.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(o).then(L=>{if(L.status!==200)throw new Error(L.statusText);return L.text()}).then(L=>{L=`${L}
//# sourceURL=${o}`,(m?self.eval(m.createScript("",L)):new Function(L)).call(self),E()}).then(void 0,b);return}try{m&&(o=m.createScriptURL(o)),importScripts(o),E()}catch(L){b(L)}}}}class h{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,o){const{nodeCachedData:E}=o.getConfig().getOptionsLiteral();if(!E||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const b=this,m=u("module");function e(L){const A=L.constructor;let N=function(d){try{return L.require(d)}finally{}};return N.resolve=function(d,a){return A._resolveFilename(d,L,!1,a)},N.resolve.paths=function(d){return A._resolveLookupPaths(d,L)},N.main=process.mainModule,N.extensions=A._extensions,N.cache=A._cache,N}m.prototype._compile=function(L,A){const N=m.wrap(L.replace(/^#!.*/,"")),$=o.getRecorder(),d=b._getCachedDataPath(E,A),a={filename:A};let f;try{const R=b._fs.readFileSync(d);f=R.slice(0,16),a.cachedData=R.slice(16),$.record(60,d)}catch{$.record(61,d)}const n=new b._vm.Script(N,a),s=n.runInThisContext(a),v=b._path.dirname(A),g=e(this),k=[this.exports,g,this,A,v,process,ze,Buffer],p=s.apply(this.exports,k);return b._handleCachedData(n,N,d,!a.cachedData,o),b._verifyCachedData(n,N,d,f,o),p}}load(u,o,E,b){const m=u.getConfig().getOptionsLiteral(),e=w(u.getRecorder(),m.nodeRequire||C.global.nodeRequire),L=m.nodeInstrumenter||function(N){return N};this._init(e),this._initNodeRequire(e,u);let A=u.getRecorder();if(/^node\|/.test(o)){let N=o.split("|"),$=null;try{$=e(N[1])}catch(d){b(d);return}u.enqueueDefineAnonymousModule([],()=>$),E()}else{o=C.Utilities.fileUriToFilePath(this._env.isWindows,o);const N=this._path.normalize(o),$=this._getElectronRendererScriptPathOrUri(N),d=!!m.nodeCachedData,a=d?this._getCachedDataPath(m.nodeCachedData,o):void 0;this._readSourceAndCachedData(N,a,A,(f,n,s,v)=>{if(f){b(f);return}let g;n.charCodeAt(0)===h._BOM?g=h._PREFIX+n.substring(1)+h._SUFFIX:g=h._PREFIX+n+h._SUFFIX,g=L(g,N);const k={filename:$,cachedData:s},p=this._createAndEvalScript(u,g,k,E,b);this._handleCachedData(p,g,a,d&&!s,u),this._verifyCachedData(p,g,a,v,u)})}}_createAndEvalScript(u,o,E,b,m){const e=u.getRecorder();e.record(31,E.filename);const L=new this._vm.Script(o,E),A=L.runInThisContext(E),N=u.getGlobalAMDDefineFunc();let $=!1;const d=function(){return $=!0,N.apply(null,arguments)};return d.amd=N.amd,A.call(C.global,u.getGlobalAMDRequireFunc(),d,E.filename,this._path.dirname(E.filename)),e.record(32,E.filename),$?b():m(new Error(`Didn't receive define call in ${E.filename}!`)),L}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let o=u.match(/^([a-z])\:(.*)/i);return o?`file:///${(o[1].toUpperCase()+":"+o[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,o){const E=this._crypto.createHash("md5").update(o,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),b=this._path.basename(o).replace(/\.js$/,"");return this._path.join(u.path,`${b}-${E}.code`)}_handleCachedData(u,o,E,b,m){u.cachedDataRejected?this._fs.unlink(E,e=>{m.getRecorder().record(62,E),this._createAndWriteCachedData(u,o,E,m),e&&m.getConfig().onError(e)}):b&&this._createAndWriteCachedData(u,o,E,m)}_createAndWriteCachedData(u,o,E,b){let m=Math.ceil(b.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,L=0,A;const N=()=>{setTimeout(()=>{A||(A=this._crypto.createHash("md5").update(o,"utf8").digest());const $=u.createCachedData();if(!($.length===0||$.length===e||L>=5)){if($.length<e){N();return}e=$.length,this._fs.writeFile(E,Buffer.concat([A,$]),d=>{d&&b.getConfig().onError(d),b.getRecorder().record(63,E),N()})}},m*Math.pow(4,L++))};N()}_readSourceAndCachedData(u,o,E,b){if(!o)this._fs.readFile(u,{encoding:"utf8"},b);else{let m,e,L,A=2;const N=$=>{$?b($):--A===0&&b(void 0,m,e,L)};this._fs.readFile(u,{encoding:"utf8"},($,d)=>{m=d,N($)}),this._fs.readFile(o,($,d)=>{!$&&d&&d.length>0?(L=d.slice(0,16),e=d.slice(16),E.record(60,o)):E.record(61,o),N()})}}_verifyCachedData(u,o,E,b,m){b&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(o,"utf8").digest();b.equals(e)||(m.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${E}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(E,L=>{L&&m.getConfig().onError(L)}))},Math.ceil(5e3*(1+Math.random()))))}}h._BOM=65279,h._PREFIX="(function (require, define, __filename, __dirname) { ",h._SUFFIX=`
});`;function w(l,u){if(u.__$__isRecorded)return u;const o=function(b){l.record(33,b);try{return u(b)}finally{l.record(34,b)}};return o.__$__isRecorded=!0,o}C.ensureRecordedNodeRequire=w;function c(l){return new t(l)}C.createScriptLoader=c})(oe||(oe={}));var oe;(function(C){class t{constructor(l){let u=l.lastIndexOf("/");u!==-1?this.fromModulePath=l.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(l){let u=l,o;for(o=/\/\.\//;o.test(u);)u=u.replace(o,"/");for(u=u.replace(/^\.\//g,""),o=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;o.test(u);)u=u.replace(o,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(l){let u=l;return C.Utilities.isAbsolutePath(u)||(C.Utilities.startsWith(u,"./")||C.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),C.ModuleIdResolver=t;class i{constructor(l,u,o,E,b,m){this.id=l,this.strId=u,this.dependencies=o,this._callback=E,this._errorback=b,this.moduleIdResolver=m,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(l,u){try{return{returnedValue:l.apply(C.global,u),producedError:null}}catch(o){return{returnedValue:null,producedError:o}}}static _invokeFactory(l,u,o,E){return l.shouldInvokeFactory(u)?l.shouldCatchError()?this._safeInvokeFunction(o,E):{returnedValue:o.apply(C.global,E),producedError:null}:{returnedValue:null,producedError:null}}complete(l,u,o,E){this._isComplete=!0;let b=null;if(this._callback)if(typeof this._callback=="function"){l.record(21,this.strId);let m=i._invokeFactory(u,this.strId,this._callback,o);b=m.producedError,l.record(22,this.strId),!b&&typeof m.returnedValue<"u"&&(!this.exportsPassedIn||C.Utilities.isEmpty(this.exports))&&(this.exports=m.returnedValue)}else this.exports=this._callback;if(b){let m=C.ensureError(b);m.phase="factory",m.moduleId=this.strId,m.neededBy=E(this.id),this.error=m,u.onError(m)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(l){return this._isComplete=!0,this.error=l,this._errorback?(this._errorback(l),!0):!1}isComplete(){return this._isComplete}}C.Module=i;class F{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(l){let u=this._strModuleIdToIntModuleId.get(l);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(l,u),this._intModuleIdToStrModuleId[u]=l),u}getStrModuleId(l){return this._intModuleIdToStrModuleId[l]}}class y{constructor(l){this.id=l}}y.EXPORTS=new y(0),y.MODULE=new y(1),y.REQUIRE=new y(2),C.RegularDependency=y;class h{constructor(l,u,o){this.id=l,this.pluginId=u,this.pluginParam=o}}C.PluginDependency=h;class w{constructor(l,u,o,E,b=0){this._env=l,this._scriptLoader=u,this._loaderAvailableTimestamp=b,this._defineFunc=o,this._requireFunc=E,this._moduleIdProvider=new F,this._config=new C.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(l,u){let o=m=>m.replace(/\\/g,"/"),E=o(l),b=u.split(/\n/);for(let m=0;m<b.length;m++){let e=b[m].match(/(.*):(\d+):(\d+)\)?$/);if(e){let L=e[1],A=e[2],N=e[3],$=Math.max(L.lastIndexOf(" ")+1,L.lastIndexOf("(")+1);if(L=L.substr($),L=o(L),L===E){let d={line:parseInt(A,10),col:parseInt(N,10)};return d.line===1&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+l)}getBuildInfo(){if(!this._config.isBuild())return null;let l=[],u=0;for(let o=0,E=this._modules2.length;o<E;o++){let b=this._modules2[o];if(!b)continue;let m=this._buildInfoPath[b.id]||null,e=this._buildInfoDefineStack[b.id]||null,L=this._buildInfoDependencies[b.id];l[u++]={id:b.strId,path:m,defineLocation:m&&e?w._findRelevantLocationInStack(m,e):null,dependencies:L,shim:null,exports:b.exports}}return l}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new C.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=C.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(l,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let o=null;this._config.isBuild()&&(o=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:o,dependencies:l,callback:u}}defineModule(l,u,o,E,b,m=new t(l)){let e=this._moduleIdProvider.getModuleId(l);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(l)||console.warn("Duplicate definition of module '"+l+"'");return}let L=new i(e,l,this._normalizeDependencies(u,m),o,E,m);this._modules2[e]=L,this._config.isBuild()&&(this._buildInfoDefineStack[e]=b,this._buildInfoDependencies[e]=(L.dependencies||[]).map(A=>this._moduleIdProvider.getStrModuleId(A.id))),this._resolve(L)}_normalizeDependency(l,u){if(l==="exports")return y.EXPORTS;if(l==="module")return y.MODULE;if(l==="require")return y.REQUIRE;let o=l.indexOf("!");if(o>=0){let E=u.resolveModule(l.substr(0,o)),b=u.resolveModule(l.substr(o+1)),m=this._moduleIdProvider.getModuleId(E+"!"+b),e=this._moduleIdProvider.getModuleId(E);return new h(m,e,b)}return new y(this._moduleIdProvider.getModuleId(u.resolveModule(l)))}_normalizeDependencies(l,u){let o=[],E=0;for(let b=0,m=l.length;b<m;b++)o[E++]=this._normalizeDependency(l[b],u);return o}_relativeRequire(l,u,o,E){if(typeof u=="string")return this.synchronousRequire(u,l);this.defineModule(C.Utilities.generateAnonymousModule(),u,o,E,null,l)}synchronousRequire(l,u=new t(l)){let o=this._normalizeDependency(l,u),E=this._modules2[o.id];if(!E)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This is the first mention of this module!");if(!E.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+l+"'. This module has not been resolved completely yet.");if(E.error)throw E.error;return E.exports}configure(l,u){let o=this._config.shouldRecordStats();u?this._config=new C.Configuration(this._env,l):this._config=this._config.cloneAndMerge(l),this._config.shouldRecordStats()&&!o&&(this._recorder=null)}getConfig(){return this._config}_onLoad(l){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(l),u.dependencies,u.callback,null,u.stack)}}_createLoadError(l,u){let o=this._moduleIdProvider.getStrModuleId(l),E=(this._inverseDependencies2[l]||[]).map(m=>this._moduleIdProvider.getStrModuleId(m));const b=C.ensureError(u);return b.phase="loading",b.moduleId=o,b.neededBy=E,b}_onLoadError(l,u){const o=this._createLoadError(l,u);this._modules2[l]||(this._modules2[l]=new i(l,this._moduleIdProvider.getStrModuleId(l),[],()=>{},null,null));let E=[];for(let e=0,L=this._moduleIdProvider.getMaxModuleId();e<L;e++)E[e]=!1;let b=!1,m=[];for(m.push(l),E[l]=!0;m.length>0;){let e=m.shift(),L=this._modules2[e];L&&(b=L.onDependencyError(o)||b);let A=this._inverseDependencies2[e];if(A)for(let N=0,$=A.length;N<$;N++){let d=A[N];E[d]||(m.push(d),E[d]=!0)}}b||this._config.onError(o)}_hasDependencyPath(l,u){let o=this._modules2[l];if(!o)return!1;let E=[];for(let m=0,e=this._moduleIdProvider.getMaxModuleId();m<e;m++)E[m]=!1;let b=[];for(b.push(o),E[l]=!0;b.length>0;){let e=b.shift().dependencies;if(e)for(let L=0,A=e.length;L<A;L++){let N=e[L];if(N.id===u)return!0;let $=this._modules2[N.id];$&&!E[N.id]&&(E[N.id]=!0,b.push($))}}return!1}_findCyclePath(l,u,o){if(l===u||o===50)return[l];let E=this._modules2[l];if(!E)return null;let b=E.dependencies;if(b)for(let m=0,e=b.length;m<e;m++){let L=this._findCyclePath(b[m].id,u,o+1);if(L!==null)return L.push(l),L}return null}_createRequire(l){let u=(o,E,b)=>this._relativeRequire(l,o,E,b);return u.toUrl=o=>this._config.requireToUrl(l.resolveModule(o)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(o,E=!1)=>{this.configure(o,E)},u.__$__nodeRequire=C.global.nodeRequire,u}_loadModule(l){if(this._modules2[l]||this._knownModules2[l])return;this._knownModules2[l]=!0;let u=this._moduleIdProvider.getStrModuleId(l),o=this._config.moduleIdToPaths(u),E=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||E.test(u))&&o.push("node|"+u);let b=-1,m=e=>{if(b++,b>=o.length)this._onLoadError(l,e);else{let L=o[b],A=this.getRecorder();if(this._config.isBuild()&&L==="empty:"){this._buildInfoPath[l]=L,this.defineModule(this._moduleIdProvider.getStrModuleId(l),[],null,null,null),this._onLoad(l);return}A.record(10,L),this._scriptLoader.load(this,L,()=>{this._config.isBuild()&&(this._buildInfoPath[l]=L),A.record(11,L),this._onLoad(l)},N=>{A.record(12,L),m(N)})}};m(null)}_loadPluginDependency(l,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let o=E=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],E,null,null)};o.error=E=>{this._config.onError(this._createLoadError(u.id,E))},l.load(u.pluginParam,this._createRequire(t.ROOT),o,this._config.getOptionsLiteral())}_resolve(l){let u=l.dependencies;if(u)for(let o=0,E=u.length;o<E;o++){let b=u[o];if(b===y.EXPORTS){l.exportsPassedIn=!0,l.unresolvedDependenciesCount--;continue}if(b===y.MODULE){l.unresolvedDependenciesCount--;continue}if(b===y.REQUIRE){l.unresolvedDependenciesCount--;continue}let m=this._modules2[b.id];if(m&&m.isComplete()){if(m.error){l.onDependencyError(m.error);return}l.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(b.id,l.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(b.id)+"' and '"+this._moduleIdProvider.getStrModuleId(l.id)+"'. The cyclic path follows:");let e=this._findCyclePath(b.id,l.id,0)||[];e.reverse(),e.push(b.id),console.warn(e.map(L=>this._moduleIdProvider.getStrModuleId(L)).join(` => 
`)),l.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[b.id]=this._inverseDependencies2[b.id]||[],this._inverseDependencies2[b.id].push(l.id),b instanceof h){let e=this._modules2[b.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,b);continue}let L=this._inversePluginDependencies2.get(b.pluginId);L||(L=[],this._inversePluginDependencies2.set(b.pluginId,L)),L.push(b),this._loadModule(b.pluginId);continue}this._loadModule(b.id)}l.unresolvedDependenciesCount===0&&this._onModuleComplete(l)}_onModuleComplete(l){let u=this.getRecorder();if(l.isComplete())return;let o=l.dependencies,E=[];if(o)for(let L=0,A=o.length;L<A;L++){let N=o[L];if(N===y.EXPORTS){E[L]=l.exports;continue}if(N===y.MODULE){E[L]={id:l.strId,config:()=>this._config.getConfigForModule(l.strId)};continue}if(N===y.REQUIRE){E[L]=this._createRequire(l.moduleIdResolver);continue}let $=this._modules2[N.id];if($){E[L]=$.exports;continue}E[L]=null}const b=L=>(this._inverseDependencies2[L]||[]).map(A=>this._moduleIdProvider.getStrModuleId(A));l.complete(u,this._config,E,b);let m=this._inverseDependencies2[l.id];if(this._inverseDependencies2[l.id]=null,m)for(let L=0,A=m.length;L<A;L++){let N=m[L],$=this._modules2[N];$.unresolvedDependenciesCount--,$.unresolvedDependenciesCount===0&&this._onModuleComplete($)}let e=this._inversePluginDependencies2.get(l.id);if(e){this._inversePluginDependencies2.delete(l.id);for(let L=0,A=e.length;L<A;L++)this._loadPluginDependency(l.exports,e[L])}}}C.ModuleManager=w})(oe||(oe={}));var te,oe;(function(C){const t=new C.Environment;let i=null;const F=function(c,l,u){typeof c!="string"&&(u=l,l=c,c=null),(typeof l!="object"||!Array.isArray(l))&&(u=l,l=null),l||(l=["require","exports","module"]),c?i.defineModule(c,l,u,null,null):i.enqueueDefineAnonymousModule(l,u)};F.amd={jQuery:!0};const y=function(c,l=!1){i.configure(c,l)},h=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){y(arguments[0]);return}if(typeof arguments[0]=="string")return i.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){i.defineModule(C.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};h.config=y,h.getConfig=function(){return i.getConfig().getOptionsLiteral()},h.reset=function(){i=i.reset()},h.getBuildInfo=function(){return i.getBuildInfo()},h.getStats=function(){return i.getLoaderEvents()},h.define=F;function w(){if(typeof C.global.require<"u"||typeof require<"u"){const c=C.global.require||require;if(typeof c=="function"&&typeof c.resolve=="function"){const l=C.ensureRecordedNodeRequire(i.getRecorder(),c);C.global.nodeRequire=l,h.nodeRequire=l,h.__$__nodeRequire=l}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=h:(t.isElectronRenderer||(C.global.define=F),C.global.require=h)}C.init=w,(typeof C.global.define!="function"||!C.global.define.amd)&&(i=new C.ModuleManager(t,C.createScriptLoader(t),F,h,C.Utilities.getHighPerformanceTimestamp()),typeof C.global.require<"u"&&typeof C.global.require!="function"&&h.config(C.global.require),te=function(){return F.apply(null,arguments)},te.amd=F.amd,typeof doNotInitLoader>"u"&&w())})(oe||(oe={})),te(ne[71],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function i(c,l,u,o){if(o=o||{},(o["vs/css"]||{}).disabled){u({});return}const b=l.toUrl(c+".css");F(c,b,()=>{u({})},m=>{typeof u.error=="function"&&u.error("Could not find "+b+".")})}t.load=i;function F(c,l,u,o){if(y(c,l)){u();return}h(c,l,u,o)}function y(c,l){const u=window.document.getElementsByTagName("link");for(let o=0,E=u.length;o<E;o++){const b=u[o].getAttribute("data-name"),m=u[o].getAttribute("href");if(b===c||m===l)return!0}return!1}function h(c,l,u,o){const E=document.createElement("link");E.setAttribute("rel","stylesheet"),E.setAttribute("type","text/css"),E.setAttribute("data-name",c),w(c,E,u,o),E.setAttribute("href",l),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild(E)}function w(c,l,u,o){const E=()=>{l.removeEventListener("load",b),l.removeEventListener("error",m)},b=e=>{E(),u()},m=e=>{E(),o(e)};l.addEventListener("load",b),l.addEventListener("error",m)}}),te("vs/nls",["require","exports"],function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize2=t.localize=void 0;let i=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const F="i-default";function y(A,N){let $;return N.length===0?$=A:$=A.replace(/\{(\d+)\}/g,(d,a)=>{const f=a[0],n=N[f];let s=d;return typeof n=="string"?s=n:(typeof n=="number"||typeof n=="boolean"||n===void 0||n===null)&&(s=String(n)),s}),i&&($="\uFF3B"+$.replace(/[aouei]/g,"$&$&")+"\uFF3D"),$}function h(A,N){let $=A[N];return $||($=A["*"],$)?$:null}function w(A){return A.charAt(A.length-1)==="/"?A:A+"/"}async function c(A,N,$){const d=w(A)+w(N)+"vscode/"+w($),a=await fetch(d);if(a.ok)return await a.json();throw new Error(`${a.status} - ${a.statusText}`)}function l(A){return function(N,$){const d=Array.prototype.slice.call(arguments,2);return y(A[N],d)}}function u(A){return(N,$,...d)=>({value:y(A[N],d),original:y($,d)})}function o(A,N,...$){return y(N,$)}t.localize=o;function E(A,N,...$){const d=y(N,$);return{value:d,original:d}}t.localize2=E;function b(A){}t.getConfiguredDefaultLocale=b;function m(A){i=A}t.setPseudoTranslation=m;function e(A,N){return{localize:l(N[A]),localize2:u(N[A]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??($=>{})}}t.create=e;function L(A,N,$,d){const a=d["vs/nls"]??{};if(!A||A.length===0)return $({localize:o,localize2:E,getConfiguredDefaultLocale:()=>a.availableLanguages?.["*"]});const f=a.availableLanguages?h(a.availableLanguages,A):null,n=f===null||f===F;let s=".nls";n||(s=s+"."+f);const v=g=>{Array.isArray(g)?(g.localize=l(g),g.localize2=u(g)):(g.localize=l(g[A]),g.localize2=u(g[A])),g.getConfiguredDefaultLocale=()=>a.availableLanguages?.["*"],$(g)};typeof a.loadBundle=="function"?a.loadBundle(A,f,(g,k)=>{g?N([A+".nls"],v):v(k)}):a.translationServiceUrl&&!n?(async()=>{try{const g=await c(a.translationServiceUrl,f,A);return v(g)}catch(g){if(!f.includes("-"))return console.error(g),N([A+".nls"],v);try{const k=f.split("-")[0],p=await c(a.translationServiceUrl,k,A);return a.availableLanguages??={},a.availableLanguages["*"]=k,v(p)}catch(k){return console.error(k),N([A+".nls"],v)}}})():N([A+s],v,g=>{if(s===".nls"){console.error("Failed trying to load default language strings",g);return}console.error(`Failed to load message bundle for language ${f}. Falling back to the default language:`,g),N([A+".nls"],v)})}t.load=L}),function(){const C=globalThis.MonacoEnvironment,t=C&&C.baseUrl?C.baseUrl:"../../../";function i(o,E){if(C?.createTrustedTypesPolicy)try{return C.createTrustedTypesPolicy(o,E)}catch(b){console.warn(b);return}try{return self.trustedTypes?.createPolicy(o,E)}catch(b){console.warn(b);return}}const F=i("amdLoader",{createScriptURL:o=>o,createScript:(o,...E)=>{const b=E.slice(0,-1).join(","),m=E.pop().toString();return`(function anonymous(${b}) { ${m}
})`}});function y(){try{return(F?globalThis.eval(F.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function h(){return new Promise((o,E)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return o();const b=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(b)&&b.substring(0,globalThis.origin.length)!==globalThis.origin)&&y()){fetch(b).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${b}`,(F?globalThis.eval(F.createScript("",e)):new Function(e)).call(globalThis),o()}).then(void 0,E);return}F?importScripts(F.createScriptURL(b)):importScripts(b),o()})}function w(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:F,amdModulesPattern:/^vs\//})}function c(o){h().then(()=>{w(),require([o],function(E){setTimeout(function(){const b=E.create((m,e)=>{globalThis.postMessage(m,e)},null);for(globalThis.onmessage=m=>b.onmessage(m.data,m.ports);u.length>0;){const m=u.shift();b.onmessage(m.data,m.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let l=!0;const u=[];globalThis.onmessage=o=>{if(!l){u.push(o);return}l=!1,c(o.data)}}(),te(ne[9],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function i(L,A,N){const $=F(L,A);if($!==-1)return L[$]}t.$fb=i;function F(L,A,N=L.length-1){for(let $=N;$>=0;$--){const d=L[$];if(A(d))return $}return-1}t.$gb=F;function y(L,A){const N=h(L,A);return N===-1?void 0:L[N]}t.$hb=y;function h(L,A,N=0,$=L.length){let d=N,a=$;for(;d<a;){const f=Math.floor((d+a)/2);A(L[f])?d=f+1:a=f}return d-1}t.$ib=h;function w(L,A){const N=c(L,A);return N===L.length?void 0:L[N]}t.$jb=w;function c(L,A,N=0,$=L.length){let d=N,a=$;for(;d<a;){const f=Math.floor((d+a)/2);A(L[f])?a=f:d=f+1}return d}t.$kb=c;function l(L,A,N=0,$=L.length){const d=c(L,A,N,$);return d===L.length?-1:d}t.$lb=l;class u{static{this.assertInvariants=!1}constructor(A){this.e=A,this.c=0}findLastMonotonous(A){if(u.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!A($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=A}const N=h(this.e,A,this.c);return this.c=N+1,N===-1?void 0:this.e[N]}}t.$mb=u;function o(L,A){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const d=L[$];A(d,N)>0&&(N=d)}return N}t.$nb=o;function E(L,A){if(L.length===0)return;let N=L[0];for(let $=1;$<L.length;$++){const d=L[$];A(d,N)>=0&&(N=d)}return N}t.$ob=E;function b(L,A){return o(L,(N,$)=>-A(N,$))}t.$pb=b;function m(L,A){if(L.length===0)return-1;let N=0;for(let $=1;$<L.length;$++){const d=L[$];A(d,L[N])>0&&(N=$)}return N}t.$qb=m;function e(L,A){for(const N of L){const $=A(N);if($!==void 0)return $}}t.$rb=e}),te(ne[35],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function i(w,c){const l=Object.create(null);for(const u of w){const o=c(u);let E=l[o];E||(E=l[o]=[]),E.push(u)}return l}t.$K=i;function F(w,c){const l=[],u=[];for(const o of w)c.has(o)||l.push(o);for(const o of c)w.has(o)||u.push(o);return{removed:l,added:u}}t.$L=F;function y(w,c){const l=[],u=[];for(const[o,E]of w)c.has(o)||l.push(E);for(const[o,E]of c)w.has(o)||u.push(E);return{removed:l,added:u}}t.$M=y;function h(w,c){const l=new Set;for(const u of c)w.has(u)&&l.add(u);return l}t.$N=h}),te(ne[36],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bt=t.$At=t.$zt=t.$yt=void 0;function i(c,l){const u=Math.pow(10,l);return Math.round(c*u)/u}class F{constructor(l,u,o,E=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,o))|0,this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.r===u.r&&l.g===u.g&&l.b===u.b&&l.a===u.a}}t.$yt=F;class y{constructor(l,u,o,E){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.l=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.l===u.l&&l.a===u.a}static fromRGBA(l){const u=l.r/255,o=l.g/255,E=l.b/255,b=l.a,m=Math.max(u,o,E),e=Math.min(u,o,E);let L=0,A=0;const N=(e+m)/2,$=m-e;if($>0){switch(A=Math.min(N<=.5?$/(2*N):$/(2-2*N),1),m){case u:L=(o-E)/$+(o<E?6:0);break;case o:L=(E-u)/$+2;break;case E:L=(u-o)/$+4;break}L*=60,L=Math.round(L)}return new y(L,A,N,b)}static i(l,u,o){return o<0&&(o+=1),o>1&&(o-=1),o<1/6?l+(u-l)*6*o:o<1/2?u:o<2/3?l+(u-l)*(2/3-o)*6:l}static toRGBA(l){const u=l.h/360,{s:o,l:E,a:b}=l;let m,e,L;if(o===0)m=e=L=E;else{const A=E<.5?E*(1+o):E+o-E*o,N=2*E-A;m=y.i(N,A,u+1/3),e=y.i(N,A,u),L=y.i(N,A,u-1/3)}return new F(Math.round(m*255),Math.round(e*255),Math.round(L*255),b)}}t.$zt=y;class h{constructor(l,u,o,E){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=i(Math.max(Math.min(1,u),0),3),this.v=i(Math.max(Math.min(1,o),0),3),this.a=i(Math.max(Math.min(1,E),0),3)}static equals(l,u){return l.h===u.h&&l.s===u.s&&l.v===u.v&&l.a===u.a}static fromRGBA(l){const u=l.r/255,o=l.g/255,E=l.b/255,b=Math.max(u,o,E),m=Math.min(u,o,E),e=b-m,L=b===0?0:e/b;let A;return e===0?A=0:b===u?A=((o-E)/e%6+6)%6:b===o?A=(E-u)/e+2:A=(u-o)/e+4,new h(Math.round(A*60),L,b,l.a)}static toRGBA(l){const{h:u,s:o,v:E,a:b}=l,m=E*o,e=m*(1-Math.abs(u/60%2-1)),L=E-m;let[A,N,$]=[0,0,0];return u<60?(A=m,N=e):u<120?(A=e,N=m):u<180?(N=m,$=e):u<240?(N=e,$=m):u<300?(A=e,$=m):u<=360&&(A=m,$=e),A=Math.round((A+L)*255),N=Math.round((N+L)*255),$=Math.round(($+L)*255),new F(A,N,$,b)}}t.$At=h;class w{static fromHex(l){return w.Format.CSS.parseHex(l)||w.red}static equals(l,u){return!l&&!u?!0:!l||!u?!1:l.equals(u)}get hsla(){return this.i?this.i:y.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:h.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof F)this.rgba=l;else if(l instanceof y)this.i=l,this.rgba=y.toRGBA(l);else if(l instanceof h)this.j=l,this.rgba=h.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&F.equals(this.rgba,l.rgba)&&y.equals(this.hsla,l.hsla)&&h.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=w.k(this.rgba.r),u=w.k(this.rgba.g),o=w.k(this.rgba.b),E=.2126*l+.7152*u+.0722*o;return i(E,4)}static k(l){const u=l/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u>o?(u+.05)/(o+.05):(o+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u>o}isDarkerThan(l){const u=this.getRelativeLuminance(),o=l.getRelativeLuminance();return u<o}lighten(l){return new w(new y(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new w(new y(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:u,g:o,b:E,a:b}=this.rgba;return new w(new F(u,o,E,b*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new F(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const u=l.rgba,o=this.rgba.a,E=u.a,b=o+E*(1-o);if(b<1e-6)return w.transparent;const m=this.rgba.r*o/b+u.r*E*(1-o)/b,e=this.rgba.g*o/b+u.g*E*(1-o)/b,L=this.rgba.b*o/b+u.b*E*(1-o)/b;return new w(new F(m,e,L,b))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:u,g:o,b:E,a:b}=this.rgba;return new w(new F(l.rgba.r-b*(l.rgba.r-u),l.rgba.g-b*(l.rgba.g-o),l.rgba.b-b*(l.rgba.b-E),1))}flatten(...l){const u=l.reduceRight((o,E)=>w.o(E,o));return w.o(this,u)}static o(l,u){const o=1-l.rgba.a;return new w(new F(o*u.rgba.r+l.rgba.a*l.rgba.r,o*u.rgba.g+l.rgba.a*l.rgba.g,o*u.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(l,u,o){if(l.isLighterThan(u))return l;o=o||.5;const E=l.getRelativeLuminance(),b=u.getRelativeLuminance();return o=o*(b-E)/b,l.lighten(o)}static getDarkerColor(l,u,o){if(l.isDarkerThan(u))return l;o=o||.5;const E=l.getRelativeLuminance(),b=u.getRelativeLuminance();return o=o*(E-b)/E,l.darken(o)}static{this.white=new w(new F(255,255,255,1))}static{this.black=new w(new F(0,0,0,1))}static{this.red=new w(new F(255,0,0,1))}static{this.blue=new w(new F(0,0,255,1))}static{this.green=new w(new F(0,255,0,1))}static{this.cyan=new w(new F(0,255,255,1))}static{this.lightgrey=new w(new F(211,211,211,1))}static{this.transparent=new w(new F(0,0,0,0))}}t.$Bt=w,function(c){let l;(function(u){let o;(function(E){function b(n){return n.rgba.a===1?`rgb(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b})`:c.Format.CSS.formatRGBA(n)}E.formatRGB=b;function m(n){return`rgba(${n.rgba.r}, ${n.rgba.g}, ${n.rgba.b}, ${+n.rgba.a.toFixed(2)})`}E.formatRGBA=m;function e(n){return n.hsla.a===1?`hsl(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%)`:c.Format.CSS.formatHSLA(n)}E.formatHSL=e;function L(n){return`hsla(${n.hsla.h}, ${(n.hsla.s*100).toFixed(2)}%, ${(n.hsla.l*100).toFixed(2)}%, ${n.hsla.a.toFixed(2)})`}E.formatHSLA=L;function A(n){const s=n.toString(16);return s.length!==2?"0"+s:s}function N(n){return`#${A(n.rgba.r)}${A(n.rgba.g)}${A(n.rgba.b)}`}E.formatHex=N;function $(n,s=!1){return s&&n.rgba.a===1?c.Format.CSS.formatHex(n):`#${A(n.rgba.r)}${A(n.rgba.g)}${A(n.rgba.b)}${A(Math.round(n.rgba.a*255))}`}E.formatHexA=$;function d(n){return n.isOpaque()?c.Format.CSS.formatHex(n):c.Format.CSS.formatRGBA(n)}E.format=d;function a(n){const s=n.length;if(s===0||n.charCodeAt(0)!==35)return null;if(s===7){const v=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),k=16*f(n.charCodeAt(5))+f(n.charCodeAt(6));return new c(new F(v,g,k,1))}if(s===9){const v=16*f(n.charCodeAt(1))+f(n.charCodeAt(2)),g=16*f(n.charCodeAt(3))+f(n.charCodeAt(4)),k=16*f(n.charCodeAt(5))+f(n.charCodeAt(6)),p=16*f(n.charCodeAt(7))+f(n.charCodeAt(8));return new c(new F(v,g,k,p/255))}if(s===4){const v=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),k=f(n.charCodeAt(3));return new c(new F(16*v+v,16*g+g,16*k+k))}if(s===5){const v=f(n.charCodeAt(1)),g=f(n.charCodeAt(2)),k=f(n.charCodeAt(3)),p=f(n.charCodeAt(4));return new c(new F(16*v+v,16*g+g,16*k+k,(16*p+p)/255))}return null}E.parseHex=a;function f(n){switch(n){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(o=u.CSS||(u.CSS={}))})(l=c.Format||(c.Format={}))}(w||(t.$Bt=w={}))}),te(ne[37],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$at=void 0;class i{constructor(y,h,w,c){this.originalStart=y,this.originalLength=h,this.modifiedStart=w,this.modifiedLength=c}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$at=i}),te(ne[3],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class i{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?d.isErrorNoTelemetry(n)?new d(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(s=>{s(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}t.$W=i,t.$X=new i;function F(f){t.$X.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=F;function y(f){if(!f||typeof f!="object")return!1;const n=f;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}t.$Z=y;function h(f){u(f)||t.$X.onUnexpectedError(f)}t.$1=h;function w(f){u(f)||t.$X.onUnexpectedExternalError(f)}t.$2=w;function c(f){if(f instanceof Error){const{name:n,message:s}=f,v=f.stacktrace||f.stack;return{$isError:!0,name:n,message:s,stack:v,noTelemetry:d.isErrorNoTelemetry(f)}}return f}t.$3=c;const l="Canceled";function u(f){return f instanceof o?!0:f instanceof Error&&f.name===l&&f.message===l}t.$4=u;class o extends Error{constructor(){super(l),this.name=this.message}}t.$5=o;function E(){const f=new Error(l);return f.name=f.message,f}t.$6=E;function b(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.$7=b;function m(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.$8=m;class e extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function L(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.$0=L;class A extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}t.$$=A;class N extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}t.$_=N;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=$;class d extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof d)return n;const s=new d;return s.message=n.message,s.stack=n.stack,s}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}t.$bb=d;class a extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,a.prototype)}}t.$cb=a}),te(ne[6],re([0,1,3,9]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function y(W,z=0){return W[W.length-(1+z)]}t.$sb=y;function h(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.$tb=h;function w(W,z,x=(Q,H)=>Q===H){if(W===z)return!0;if(!W||!z||W.length!==z.length)return!1;for(let Q=0,H=W.length;Q<H;Q++)if(!x(W[Q],z[Q]))return!1;return!0}t.$ub=w;function c(W,z){const x=W.length-1;z<x&&(W[z]=W[x]),W.pop()}t.$vb=c;function l(W,z,x){return u(W.length,Q=>x(W[Q],z))}t.$wb=l;function u(W,z){let x=0,Q=W-1;for(;x<=Q;){const H=(x+Q)/2|0,J=z(H);if(J<0)x=H+1;else if(J>0)Q=H-1;else return H}return-(x+1)}t.$xb=u;function o(W,z,x){if(W=W|0,W>=z.length)throw new TypeError("invalid index");const Q=z[Math.floor(z.length*Math.random())],H=[],J=[],U=[];for(const K of z){const ie=x(K,Q);ie<0?H.push(K):ie>0?J.push(K):U.push(K)}return W<H.length?o(W,H,x):W<H.length+U.length?U[0]:o(W-(H.length+U.length),J,x)}t.$yb=o;function E(W,z){const x=[];let Q;for(const H of W.slice(0).sort(z))!Q||z(Q[0],H)!==0?(Q=[H],x.push(Q)):Q.push(H);return x}t.$zb=E;function*b(W,z){let x,Q;for(const H of W)Q!==void 0&&z(Q,H)?x.push(H):(x&&(yield x),x=[H]),Q=H;x&&(yield x)}t.$Ab=b;function m(W,z){for(let x=0;x<=W.length;x++)z(x===0?void 0:W[x-1],x===W.length?void 0:W[x])}t.$Bb=m;function e(W,z){for(let x=0;x<W.length;x++)z(x===0?void 0:W[x-1],W[x],x+1===W.length?void 0:W[x+1])}t.$Cb=e;function L(W,z,x){const Q=[];function H(K,ie,le){if(ie===0&&le.length===0)return;const fe=Q[Q.length-1];fe&&fe.start+fe.deleteCount===K?(fe.deleteCount+=ie,fe.toInsert.push(...le)):Q.push({start:K,deleteCount:ie,toInsert:le})}let J=0,U=0;for(;;){if(J===W.length){H(J,0,z.slice(U));break}if(U===z.length){H(J,W.length-J,[]);break}const K=W[J],ie=z[U],le=x(K,ie);le===0?(J+=1,U+=1):le<0?(H(J,1,[]),J+=1):le>0&&(H(J,0,[ie]),U+=1)}return Q}t.$Db=L;function A(W,z,x){const Q=L(W,z,x),H=[],J=[];for(const U of Q)H.push(...W.slice(U.start,U.start+U.deleteCount)),J.push(...U.toInsert);return{removed:H,added:J}}t.$Eb=A;function N(W,z,x){if(x===0)return[];const Q=W.slice(0,x).sort(z);return d(W,z,Q,x,W.length),Q}t.top=N;function $(W,z,x,Q,H){return x===0?Promise.resolve([]):new Promise((J,U)=>{(async()=>{const K=W.length,ie=W.slice(0,x).sort(z);for(let le=x,fe=Math.min(x+Q,K);le<K;le=fe,fe=Math.min(fe+Q,K)){if(le>x&&await new Promise(ce=>setTimeout(ce)),H&&H.isCancellationRequested)throw new i.$5;d(W,z,ie,le,fe)}return ie})().then(J,U)})}t.$Gb=$;function d(W,z,x,Q,H){for(const J=x.length;Q<H;Q++){const U=W[Q];if(z(U,x[J-1])<0){x.pop();const K=(0,F.$kb)(x,ie=>z(U,ie)<0);x.splice(K,0,U)}}}function a(W){return W.filter(z=>!!z)}t.$Hb=a;function f(W){let z=0;for(let x=0;x<W.length;x++)W[x]&&(W[z]=W[x],z+=1);W.length=z}t.$Ib=f;function n(W,z,x){W.splice(x,0,W.splice(z,1)[0])}t.$Jb=n;function s(W){return!Array.isArray(W)||W.length===0}t.$Kb=s;function v(W){return Array.isArray(W)&&W.length>0}t.$Lb=v;function g(W,z=x=>x){const x=new Set;return W.filter(Q=>{const H=z(Q);return x.has(H)?!1:(x.add(H),!0)})}t.$Mb=g;function k(W){const z=new Set;return x=>{const Q=W(x);return z.has(Q)?!1:(z.add(Q),!0)}}t.$Nb=k;function p(W,z){return W.length>0?W[0]:z}t.$Ob=p;function R(W,z){return W.length>0?W[W.length-1]:z}t.$Pb=R;function P(W,z,x=(Q,H)=>Q===H){let Q=0;for(let H=0,J=Math.min(W.length,z.length);H<J&&x(W[H],z[H]);H++)Q++;return Q}t.$Qb=P;function D(W){return[].concat(...W)}t.$Rb=D;function M(W,z){let x=typeof z=="number"?W:0;typeof z=="number"?x=W:(x=0,z=W);const Q=[];if(x<=z)for(let H=x;H<z;H++)Q.push(H);else for(let H=x;H>z;H--)Q.push(H);return Q}t.$Sb=M;function I(W,z,x){return W.reduce((Q,H)=>(Q[z(H)]=x?x(H):H,Q),Object.create(null))}t.$Tb=I;function T(W,z){return W.push(z),()=>O(W,z)}t.$Ub=T;function O(W,z){const x=W.indexOf(z);if(x>-1)return W.splice(x,1),z}t.$Vb=O;function j(W,z,x){const Q=W.slice(0,z),H=W.slice(z);return Q.concat(x,H)}t.$Wb=j;function G(W,z){let x;if(typeof z=="number"){let Q=z;x=()=>{const H=Math.sin(Q++)*179426549;return H-Math.floor(H)}}else x=Math.random;for(let Q=W.length-1;Q>0;Q-=1){const H=Math.floor(x()*(Q+1)),J=W[Q];W[Q]=W[H],W[H]=J}}t.$Xb=G;function ee(W,z){const x=W.indexOf(z);x>-1&&(W.splice(x,1),W.unshift(z))}t.$Yb=ee;function S(W,z){const x=W.indexOf(z);x>-1&&(W.splice(x,1),W.push(z))}t.$Zb=S;function B(W,z){for(const x of z)W.push(x)}t.$1b=B;function _(W,z){return Array.isArray(W)?W.map(z):z(W)}t.$2b=_;function Y(W){return Array.isArray(W)?W:[W]}t.$3b=Y;function se(W){return W[Math.floor(Math.random()*W.length)]}t.$4b=se;function ae(W,z,x){const Q=ge(W,z),H=W.length,J=x.length;W.length=H+J;for(let U=H-1;U>=Q;U--)W[U+J]=W[U];for(let U=0;U<J;U++)W[U+Q]=x[U]}t.$5b=ae;function r(W,z,x,Q){const H=ge(W,z);let J=W.splice(H,x);return J===void 0&&(J=[]),ae(W,H,Q),J}t.$6b=r;function ge(W,z){return z<0?Math.max(z+W.length,0):Math.min(z,W.length)}var ke;(function(W){function z(J){return J<0}W.isLessThan=z;function x(J){return J<=0}W.isLessThanOrEqual=x;function Q(J){return J>0}W.isGreaterThan=Q;function H(J){return J===0}W.isNeitherLessOrGreaterThan=H,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(ke||(t.CompareResult=ke={}));function Ee(W,z){return(x,Q)=>z(W(x),W(Q))}t.$7b=Ee;function $e(...W){return(z,x)=>{for(const Q of W){const H=Q(z,x);if(!ke.isNeitherLessOrGreaterThan(H))return H}return ke.neitherLessOrGreaterThan}}t.$8b=$e;const ye=(W,z)=>W-z;t.$9b=ye;const Pe=(W,z)=>(0,t.$9b)(W?1:0,z?1:0);t.$0b=Pe;function Ie(W){return(z,x)=>-W(z,x)}t.$$b=Ie;class qe{constructor(z){this.g=z,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(z){let x=this.c;for(;x<this.g.length&&z(this.g[x]);)x++;const Q=x===this.c?null:this.g.slice(this.c,x);return this.c=x,Q}takeFromEndWhile(z){let x=this.d;for(;x>=0&&z(this.g[x]);)x--;const Q=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,Q}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const z=this.g[this.c];return this.c++,z}removeLast(){const z=this.g[this.d];return this.d--,z}takeCount(z){const x=this.g.slice(this.c,this.c+z);return this.c+=z,x}}t.$_b=qe;class Ae{static{this.empty=new Ae(z=>{})}constructor(z){this.iterate=z}forEach(z){this.iterate(x=>(z(x),!0))}toArray(){const z=[];return this.iterate(x=>(z.push(x),!0)),z}filter(z){return new Ae(x=>this.iterate(Q=>z(Q)?x(Q):!0))}map(z){return new Ae(x=>this.iterate(Q=>x(z(Q))))}some(z){let x=!1;return this.iterate(Q=>(x=z(Q),!x)),x}findFirst(z){let x;return this.iterate(Q=>z(Q)?(x=Q,!1):!0),x}findLast(z){let x;return this.iterate(Q=>(z(Q)&&(x=Q),!0)),x}findLastMaxBy(z){let x,Q=!0;return this.iterate(H=>((Q||ke.isGreaterThan(z(H,x)))&&(Q=!1,x=H),!0)),x}}t.$ac=Ae}),te(ne[13],re([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.ok=void 0;function F(u,o){if(!u)throw new Error(o?`Assertion failed (${o})`:"Assertion Failed")}t.ok=F;function y(u,o="Unreachable"){throw new Error(o)}t.$9c=y;function h(u){if(!u)throw new i.$cb("Assertion Failed")}t.$0c=h;function w(u){u||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}t.$$c=w;function c(u){if(!u()){debugger;u(),(0,i.$1)(new i.$cb("Assertion Failed"))}}t.$_c=c;function l(u,o){let E=0;for(;E<u.length-1;){const b=u[E],m=u[E+1];if(!o(b,m))return!1;E++}return!0}t.$ad=l}),te(ne[19],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function i(F,y){const h=this;let w=!1,c;return function(){if(w)return c;if(w=!0,y)try{c=F.apply(h,arguments)}finally{y()}else c=F.apply(h,arguments);return c}}t.$db=i}),te(ne[20],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var i;(function(F){function y(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}F.is=y;const h=Object.freeze([]);function w(){return h}F.empty=w;function*c(n){yield n}F.single=c;function l(n){return y(n)?n:c(n)}F.wrap=l;function u(n){return n||h}F.from=u;function*o(n){for(let s=n.length-1;s>=0;s--)yield n[s]}F.reverse=o;function E(n){return!n||n[Symbol.iterator]().next().done===!0}F.isEmpty=E;function b(n){return n[Symbol.iterator]().next().value}F.first=b;function m(n,s){for(const v of n)if(s(v))return!0;return!1}F.some=m;function e(n,s){for(const v of n)if(s(v))return v}F.find=e;function*L(n,s){for(const v of n)s(v)&&(yield v)}F.filter=L;function*A(n,s){let v=0;for(const g of n)yield s(g,v++)}F.map=A;function*N(...n){for(const s of n)yield*s}F.concat=N;function $(n,s,v){let g=v;for(const k of n)g=s(g,k);return g}F.reduce=$;function*d(n,s,v=n.length){for(s<0&&(s+=n.length),v<0?v+=n.length:v>n.length&&(v=n.length);s<v;s++)yield n[s]}F.slice=d;function a(n,s=Number.POSITIVE_INFINITY){const v=[];if(s===0)return[v,n];const g=n[Symbol.iterator]();for(let k=0;k<s;k++){const p=g.next();if(p.done)return[v,F.empty()];v.push(p.value)}return[v,{[Symbol.iterator](){return g}}]}F.consume=a;async function f(n){const s=[];for await(const v of n)s.push(v);return Promise.resolve(s)}F.asyncToArray=f})(i||(t.Iterable=i={}))}),te(ne[38],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jr=t.KeyMod=t.KeyCodeUtils=t.$ir=t.$hr=t.$gr=t.$fr=t.$er=t.ScanCode=t.KeyCode=void 0;var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(i||(t.KeyCode=i={}));var F;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(F||(t.ScanCode=F={}));class y{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(L,A){this._keyCodeToStr[L]=A,this._strToKeyCode[A.toLowerCase()]=L}keyCodeToStr(L){return this._keyCodeToStr[L]}strToKeyCode(L){return this._strToKeyCode[L.toLowerCase()]||0}}const h=new y,w=new y,c=new y;t.$er=new Array(230),t.$fr={};const l=[],u=Object.create(null),o=Object.create(null);t.$gr={lowerCaseToEnum:e=>o[e]||0,toEnum:e=>u[e]||0,toString:e=>l[e]||"None"},t.$hr=[],t.$ir=[];for(let e=0;e<=193;e++)t.$hr[e]=-1;for(let e=0;e<=132;e++)t.$ir[e]=-1;(function(){const e="",L=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],A=[],N=[];for(const $ of L){const[d,a,f,n,s,v,g,k,p]=$;if(N[a]||(N[a]=!0,l[a]=f,u[f]=a,o[f.toLowerCase()]=a,d&&(t.$hr[a]=n,n!==0&&n!==3&&n!==5&&n!==4&&n!==6&&n!==57&&(t.$ir[n]=a))),!A[n]){if(A[n]=!0,!s)throw new Error(`String representation missing for key code ${n} around scan code ${f}`);h.define(n,s),w.define(n,k||s),c.define(n,p||k||s)}v&&(t.$er[v]=n),g&&(t.$fr[g]=n)}t.$ir[3]=46})();var E;(function(e){function L(f){return h.keyCodeToStr(f)}e.toString=L;function A(f){return h.strToKeyCode(f)}e.fromString=A;function N(f){return w.keyCodeToStr(f)}e.toUserSettingsUS=N;function $(f){return c.keyCodeToStr(f)}e.toUserSettingsGeneral=$;function d(f){return w.strToKeyCode(f)||c.strToKeyCode(f)}e.fromUserSettings=d;function a(f){if(f>=98&&f<=113)return null;switch(f){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return h.keyCodeToStr(f)}e.toElectronAccelerator=a})(E||(t.KeyCodeUtils=E={}));var b;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(b||(t.KeyMod=b={}));function m(e,L){const A=(L&65535)<<16>>>0;return(e|A)>>>0}t.$jr=m}),te(ne[39],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class i{constructor(y){this.d=y,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(y){this.c=y}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=i}),te(ne[21],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(h){this.element=h,this.next=i.Undefined,this.prev=i.Undefined}}class F{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let h=this.a;for(;h!==i.Undefined;){const w=h.next;h.prev=i.Undefined,h.next=i.Undefined,h=w}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(h){return this.d(h,!1)}push(h){return this.d(h,!0)}d(h,w){const c=new i(h);if(this.a===i.Undefined)this.a=c,this.b=c;else if(w){const u=this.b;this.b=c,c.prev=u,u.next=c}else{const u=this.a;this.a=c,c.next=u,u.prev=c}this.c+=1;let l=!1;return()=>{l||(l=!0,this.e(c))}}shift(){if(this.a!==i.Undefined){const h=this.a.element;return this.e(this.a),h}}pop(){if(this.b!==i.Undefined){const h=this.b.element;return this.e(this.b),h}}e(h){if(h.prev!==i.Undefined&&h.next!==i.Undefined){const w=h.prev;w.next=h.next,h.next.prev=w}else h.prev===i.Undefined&&h.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):h.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):h.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let h=this.a;for(;h!==i.Undefined;)yield h.element,h=h.next}}t.$4c=F}),te(ne[22],re([0,1]),function(C,t){"use strict";var i,F,y;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function h(d,a,f){let n=d.get(a);return n===void 0&&(n=f,d.set(a,n)),n}t.$xc=h;function w(d){const a=[];return d.forEach((f,n)=>{a.push(`${n} => ${f}`)}),`Map(${d.size}) {${a.join(", ")}}`}t.$yc=w;function c(d){const a=[];return d.forEach(f=>{a.push(f)}),`Set(${d.size}) {${a.join(", ")}}`}t.$zc=c;class l{constructor(a,f){this.uri=a,this.value=f}}function u(d){return Array.isArray(d)}class o{static{this.c=a=>a.toString()}constructor(a,f){if(this[i]="ResourceMap",a instanceof o)this.d=new Map(a.d),this.e=f??o.c;else if(u(a)){this.d=new Map,this.e=f??o.c;for(const[n,s]of a)this.set(n,s)}else this.d=new Map,this.e=a??o.c}set(a,f){return this.d.set(this.e(a),new l(a,f)),this}get(a){return this.d.get(this.e(a))?.value}has(a){return this.d.has(this.e(a))}get size(){return this.d.size}clear(){this.d.clear()}delete(a){return this.d.delete(this.e(a))}forEach(a,f){typeof f<"u"&&(a=a.bind(f));for(const[n,s]of this.d)a(s.value,s.uri,this)}*values(){for(const a of this.d.values())yield a.value}*keys(){for(const a of this.d.values())yield a.uri}*entries(){for(const a of this.d.values())yield[a.uri,a.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.d)yield[a.uri,a.value]}}t.$Ac=o;class E{constructor(a,f){this[F]="ResourceSet",!a||typeof a=="function"?this.c=new o(a):(this.c=new o(f),a.forEach(this.add,this))}get size(){return this.c.size}add(a){return this.c.set(a,a),this}clear(){this.c.clear()}delete(a){return this.c.delete(a)}forEach(a,f){this.c.forEach((n,s)=>a.call(f,s,s,this))}has(a){return this.c.has(a)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=E;var b;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(b||(t.Touch=b={}));class m{constructor(){this[y]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(a){return this.c.has(a)}get(a,f=0){const n=this.c.get(a);if(n)return f!==0&&this.l(n,f),n.value}set(a,f,n=0){let s=this.c.get(a);if(s)s.value=f,n!==0&&this.l(s,n);else{switch(s={key:a,value:f,next:void 0,previous:void 0},n){case 0:this.j(s);break;case 1:this.i(s);break;case 2:this.j(s);break;default:this.j(s);break}this.c.set(a,s),this.f++}return this}delete(a){return!!this.remove(a)}remove(a){const f=this.c.get(a);if(f)return this.c.delete(a),this.k(f),this.f--,f.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const a=this.d;return this.c.delete(a.key),this.k(a),this.f--,a.value}forEach(a,f){const n=this.g;let s=this.d;for(;s;){if(f?a.bind(f)(s.value,s.key,this):a(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}values(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}entries(){const a=this,f=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(a.g!==f)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return s}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(a){if(a>=this.size)return;if(a===0){this.clear();return}let f=this.d,n=this.size;for(;f&&n>a;)this.c.delete(f.key),f=f.next,n--;this.d=f,this.f=n,f&&(f.previous=void 0),this.g++}i(a){if(!this.d&&!this.e)this.e=a;else if(this.d)a.next=this.d,this.d.previous=a;else throw new Error("Invalid list");this.d=a,this.g++}j(a){if(!this.d&&!this.e)this.d=a;else if(this.e)a.previous=this.e,this.e.next=a;else throw new Error("Invalid list");this.e=a,this.g++}k(a){if(a===this.d&&a===this.e)this.d=void 0,this.e=void 0;else if(a===this.d){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.d=a.next}else if(a===this.e){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.e=a.previous}else{const f=a.next,n=a.previous;if(!f||!n)throw new Error("Invalid list");f.previous=n,n.next=f}a.next=void 0,a.previous=void 0,this.g++}l(a,f){if(!this.d||!this.e)throw new Error("Invalid list");if(!(f!==1&&f!==2)){if(f===1){if(a===this.d)return;const n=a.next,s=a.previous;a===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),a.previous=void 0,a.next=this.d,this.d.previous=a,this.d=a,this.g++}else if(f===2){if(a===this.e)return;const n=a.next,s=a.previous;a===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),a.next=void 0,a.previous=this.e,this.e.next=a,this.e=a,this.g++}}}toJSON(){const a=[];return this.forEach((f,n)=>{a.push([n,f])}),a}fromJSON(a){this.clear();for(const[f,n]of a)this.set(f,n)}}t.$Cc=m;class e extends m{constructor(a,f=1){super(),this.m=a,this.n=Math.min(Math.max(0,f),1)}get limit(){return this.m}set limit(a){this.m=a,this.o()}get ratio(){return this.n}set ratio(a){this.n=Math.min(Math.max(0,a),1),this.o()}get(a,f=2){return super.get(a,f)}peek(a){return super.get(a,0)}set(a,f){return super.set(a,f,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class L{constructor(){this.c=new Map}add(a){return this.c.set(a,(this.c.get(a)||0)+1),this}delete(a){let f=this.c.get(a)||0;return f===0?!1:(f--,f===0?this.c.delete(a):this.c.set(a,f),!0)}has(a){return this.c.has(a)}}t.$Ec=L;class A{constructor(a){if(this.c=new Map,this.d=new Map,a)for(const[f,n]of a)this.set(f,n)}clear(){this.c.clear(),this.d.clear()}set(a,f){this.c.set(a,f),this.d.set(f,a)}get(a){return this.c.get(a)}getKey(a){return this.d.get(a)}delete(a){const f=this.c.get(a);return f===void 0?!1:(this.c.delete(a),this.d.delete(f),!0)}forEach(a,f){this.c.forEach((n,s)=>{a.call(f,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=A;class N{constructor(){this.c=new Map}add(a,f){let n=this.c.get(a);n||(n=new Set,this.c.set(a,n)),n.add(f)}delete(a,f){const n=this.c.get(a);n&&(n.delete(f),n.size===0&&this.c.delete(a))}forEach(a,f){const n=this.c.get(a);n&&n.forEach(f)}get(a){const f=this.c.get(a);return f||new Set}}t.$Gc=N;function $(d,a){if(d===a)return!0;if(d.size!==a.size)return!1;for(const[f,n]of d)if(!a.has(f)||a.get(f)!==n)return!1;for(const[f]of a)if(!d.has(f))return!1;return!0}t.$Hc=$}),te(ne[10],re([0,1,6,35,22,19,20]),function(C,t,i,F,y,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const c=!1;let l=null;class u{constructor(){this.b=new Map}static{this.a=0}c(T){let O=this.b.get(T);return O||(O={parent:null,source:null,isSingleton:!1,value:T,idx:u.a++},this.b.set(T,O)),O}trackDisposable(T){const O=this.c(T);O.source||(O.source=new Error().stack)}setParent(T,O){const j=this.c(T);j.parent=O}markAsDisposed(T){this.b.delete(T)}markAsSingleton(T){this.c(T).isSingleton=!0}f(T,O){const j=O.get(T);if(j)return j;const G=T.parent?this.f(this.c(T.parent),O):T;return O.set(T,G),G}getTrackedDisposables(){const T=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,T).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(T=10,O){let j;if(O)j=O;else{const _=new Map,Y=[...this.b.values()].filter(ae=>ae.source!==null&&!this.f(ae,_).isSingleton);if(Y.length===0)return;const se=new Set(Y.map(ae=>ae.value));if(j=Y.filter(ae=>!(ae.parent&&se.has(ae.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function G(_){function Y(ae,r){for(;ae.length>0&&r.some(ge=>typeof ge=="string"?ge===ae[0]:ae[0].match(ge));)ae.shift()}const se=_.source.split(`
`).map(ae=>ae.trim().replace("at ","")).filter(ae=>ae!=="");return Y(se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),se.reverse()}const ee=new y.$Gc;for(const _ of j){const Y=G(_);for(let se=0;se<=Y.length;se++)ee.add(Y.slice(0,se).join(`
`),_)}j.sort((0,i.$7b)(_=>_.idx,i.$9b));let S="",B=0;for(const _ of j.slice(0,T)){B++;const Y=G(_),se=[];for(let ae=0;ae<Y.length;ae++){let r=Y[ae];r=`(shared with ${ee.get(Y.slice(0,ae+1).join(`
`)).size}/${j.length} leaks) at ${r}`;const ke=ee.get(Y.slice(0,ae).join(`
`)),Ee=(0,F.$K)([...ke].map($e=>G($e)[ae]),$e=>$e);delete Ee[Y[ae]];for(const[$e,ye]of Object.entries(Ee))se.unshift(`    - stacktraces of ${ye.length} other leaks continue with ${$e}`);se.unshift(r)}S+=`


==================== Leaking disposable ${B}/${j.length}: ${_.value.constructor.name} ====================
${se.join(`
`)}
============================================================

`}return j.length>T&&(S+=`


... and ${j.length-T} more leaking disposables

`),{leaks:j,details:S}}}t.$Ic=u;function o(I){l=I}if(t.$Jc=o,c){const I="__is_disposable_tracked__";o(new class{trackDisposable(T){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{T[I]||console.log(O)},3e3)}setParent(T,O){if(T&&T!==n.None)try{T[I]=!0}catch{}}markAsDisposed(T){if(T&&T!==n.None)try{T[I]=!0}catch{}}markAsSingleton(T){}})}function E(I){return l?.trackDisposable(I),I}t.$Kc=E;function b(I){l?.markAsDisposed(I)}t.$Lc=b;function m(I,T){l?.setParent(I,T)}function e(I,T){if(l)for(const O of I)l.setParent(O,T)}function L(I){return l?.markAsSingleton(I),I}t.$Mc=L;function A(I){return typeof I.dispose=="function"&&I.dispose.length===0}t.$Nc=A;function N(I){if(w.Iterable.is(I)){const T=[];for(const O of I)if(O)try{O.dispose()}catch(j){T.push(j)}if(T.length===1)throw T[0];if(T.length>1)throw new AggregateError(T,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}t.$Oc=N;function $(I){for(const T of I)A(T)&&T.dispose();return[]}t.$Pc=$;function d(...I){const T=a(()=>N(I));return e(I,T),T}t.$Qc=d;function a(I){const T=E({dispose:(0,h.$db)(()=>{b(T),I()})});return T}t.$Rc=a;class f{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,E(this)}dispose(){this.g||(b(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{N(this.f)}finally{this.f.clear()}}add(T){if(!T)return T;if(T===this)throw new Error("Cannot register a disposable on itself!");return m(T,this),this.g?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(T),T}delete(T){if(T){if(T===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(T),T.dispose()}}deleteAndLeak(T){T&&this.f.has(T)&&(this.f.delete(T),m(T,null))}}t.$Sc=f;class n{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new f,E(this),m(this.q,this)}dispose(){b(this),this.q.dispose()}B(T){if(T===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(T)}}t.$Tc=n;class s{constructor(){this.b=!1,E(this)}get value(){return this.b?void 0:this.a}set value(T){this.b||T===this.a||(this.a?.dispose(),T&&m(T,this),this.a=T)}clear(){this.value=void 0}dispose(){this.b=!0,b(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const T=this.a;return this.a=void 0,T&&m(T,null),T}}t.$Uc=s;class v{constructor(T){this.a=new s,this.b=!1,this.a.value=T}get value(){return this.a.value}set value(T){this.b||T===this.a.value||(this.a.value=T)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=v;class g{constructor(T){this.b=T,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=g;class k{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,E(this)}set(T){let O=T;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,b(this))},this}}t.$Xc=k;class p{constructor(){this.a=new Map}acquire(T,...O){let j=this.a.get(T);j||(j={counter:0,object:this.b(T,...O)},this.a.set(T,j));const{object:G}=j,ee=(0,h.$db)(()=>{--j.counter===0&&(this.c(T,j.object),this.a.delete(T))});return j.counter++,{object:G,dispose:ee}}}t.$Yc=p;class R{constructor(T){this.a=T}async acquire(T,...O){const j=this.a.acquire(T,...O);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(G){throw j.dispose(),G}}}t.$Zc=R;class P{constructor(T){this.object=T}dispose(){}}t.$1c=P;function D(I){const T=new f;try{I(T)}finally{T.dispose()}}t.$2c=D;class M{constructor(){this.a=new Map,this.b=!1,E(this)}dispose(){b(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{N(this.a.values())}finally{this.a.clear()}}has(T){return this.a.has(T)}get size(){return this.a.size}get(T){return this.a.get(T)}set(T,O,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(T)?.dispose(),this.a.set(T,O)}deleteAndDispose(T){this.a.get(T)?.dispose(),this.a.delete(T)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=M}),te(ne[23],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(h){return new F(h)}constructor(h){this.c=i&&h===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$2d=F}),te(ne[11],re([0,1,3,19,10,21,23]),function(C,t,i,F,y,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.Event=void 0;const c=!1,l=!1;var u;(function(D){D.None=()=>y.$Tc.None;function M(H){if(l){const{onDidAddListener:J}=H,U=e.create();let K=0;H.onDidAddListener=()=>{++K===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),J?.()}}}function I(H,J){return se(H,()=>{},0,void 0,!0,void 0,J)}D.defer=I;function T(H){return(J,U=null,K)=>{let ie=!1,le;return le=H(fe=>{if(!ie)return le?le.dispose():ie=!0,J.call(U,fe)},null,K),ie&&le.dispose(),le}}D.once=T;function O(H,J,U){return _((K,ie=null,le)=>H(fe=>K.call(ie,J(fe)),null,le),U)}D.map=O;function j(H,J,U){return _((K,ie=null,le)=>H(fe=>{J(fe),K.call(ie,fe)},null,le),U)}D.forEach=j;function G(H,J,U){return _((K,ie=null,le)=>H(fe=>J(fe)&&K.call(ie,fe),null,le),U)}D.filter=G;function ee(H){return H}D.signal=ee;function S(...H){return(J,U=null,K)=>{const ie=(0,y.$Qc)(...H.map(le=>le(fe=>J.call(U,fe))));return Y(ie,K)}}D.any=S;function B(H,J,U,K){let ie=U;return O(H,le=>(ie=J(ie,le),ie),K)}D.reduce=B;function _(H,J){let U;const K={onWillAddFirstListener(){U=H(ie.fire,ie)},onDidRemoveLastListener(){U?.dispose()}};J||M(K);const ie=new d(K);return J?.add(ie),ie.event}function Y(H,J){return J instanceof Array?J.push(H):J&&J.add(H),H}function se(H,J,U=100,K=!1,ie=!1,le,fe){let ce,de,Me,Te=0,Fe;const Oe={leakWarningThreshold:le,onWillAddFirstListener(){ce=H(ve=>{Te++,de=J(de,ve),K&&!Me&&(De.fire(de),de=void 0),Fe=()=>{const We=de;de=void 0,Me=void 0,(!K||Te>1)&&De.fire(We),Te=0},typeof U=="number"?(clearTimeout(Me),Me=setTimeout(Fe,U)):Me===void 0&&(Me=0,queueMicrotask(Fe))})},onWillRemoveListener(){ie&&Te>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,ce.dispose()}};fe||M(Oe);const De=new d(Oe);return fe?.add(De),De.event}D.debounce=se;function ae(H,J=0,U){return D.debounce(H,(K,ie)=>K?(K.push(ie),K):[ie],J,void 0,!0,void 0,U)}D.accumulate=ae;function r(H,J=(K,ie)=>K===ie,U){let K=!0,ie;return G(H,le=>{const fe=K||!J(le,ie);return K=!1,ie=le,fe},U)}D.latch=r;function ge(H,J,U){return[D.filter(H,J,U),D.filter(H,K=>!J(K),U)]}D.split=ge;function ke(H,J=!1,U=[],K){let ie=U.slice(),le=H(de=>{ie?ie.push(de):ce.fire(de)});K&&K.add(le);const fe=()=>{ie?.forEach(de=>ce.fire(de)),ie=null},ce=new d({onWillAddFirstListener(){le||(le=H(de=>ce.fire(de)),K&&K.add(le))},onDidAddFirstListener(){ie&&(J?setTimeout(fe):fe())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return K&&K.add(ce),ce.event}D.buffer=ke;function Ee(H,J){return(K,ie,le)=>{const fe=J(new ye);return H(function(ce){const de=fe.evaluate(ce);de!==$e&&K.call(ie,de)},void 0,le)}}D.chain=Ee;const $e=Symbol("HaltChainable");class ye{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(U=>(J(U),U)),this}filter(J){return this.f.push(U=>J(U)?U:$e),this}reduce(J,U){let K=U;return this.f.push(ie=>(K=J(K,ie),K)),this}latch(J=(U,K)=>U===K){let U=!0,K;return this.f.push(ie=>{const le=U||!J(ie,K);return U=!1,K=ie,le?ie:$e}),this}evaluate(J){for(const U of this.f)if(J=U(J),J===$e)break;return J}}function Pe(H,J,U=K=>K){const K=(...ce)=>fe.fire(U(...ce)),ie=()=>H.on(J,K),le=()=>H.removeListener(J,K),fe=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return fe.event}D.fromNodeEventEmitter=Pe;function Ie(H,J,U=K=>K){const K=(...ce)=>fe.fire(U(...ce)),ie=()=>H.addEventListener(J,K),le=()=>H.removeEventListener(J,K),fe=new d({onWillAddFirstListener:ie,onDidRemoveLastListener:le});return fe.event}D.fromDOMEventEmitter=Ie;function qe(H){return new Promise(J=>T(H)(J))}D.toPromise=qe;function Ae(H){const J=new d;return H.then(U=>{J.fire(U)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}D.fromPromise=Ae;function W(H,J,U){return J(U),H(K=>J(K))}D.runAndSubscribe=W;class z{constructor(J,U){this._observable=J,this.f=0,this.g=!1;const K={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};U||M(K),this.emitter=new d(K),U&&U.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,U){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function x(H,J){return new z(H,J).emitter.event}D.fromObservable=x;function Q(H){return(J,U,K)=>{let ie=0,le=!1;const fe={beginUpdate(){ie++},endUpdate(){ie--,ie===0&&(H.reportChanges(),le&&(le=!1,J.call(U)))},handlePossibleChange(){},handleChange(){le=!0}};H.addObserver(fe),H.reportChanges();const ce={dispose(){H.removeObserver(fe)}};return K instanceof y.$Sc?K.add(ce):Array.isArray(K)&&K.push(ce),ce}}D.fromObservableLight=Q})(u||(t.Event=u={}));class o{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${o.f++}`,o.all.add(this)}start(M){this.g=new w.$2d,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}t.$4d=o;let E=-1;function b(D){const M=E;return E=D,{dispose(){E=M}}}t.$5d=b;class m{constructor(M,I=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=I,this.g=0}dispose(){this.f?.clear()}check(M,I){const T=this.threshold;if(T<=0||I<T)return;this.f||(this.f=new Map);const O=this.f.get(M.value)||0;if(this.f.set(M.value,O+1),this.g-=1,this.g<=0){this.g=T*.5;let j,G=0;for(const[ee,S]of this.f)(!j||G<S)&&(j=ee,G=S);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${G}):`),console.warn(j)}return()=>{const j=this.f.get(M.value)||0;this.f.set(M.value,j-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let L=0;class A{constructor(M){this.value=M,this.id=L++}}const N=2,$=(D,M)=>{if(D instanceof A)M(D);else for(let I=0;I<D.length;I++){const T=D[I];T&&M(T)}};class d{constructor(M){this.w=0,this.f=M,this.g=E>0||this.f?.leakWarningThreshold?new m(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new o(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(c){const M=this.t;queueMicrotask(()=>{$(M,I=>I.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,I,T)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),y.$Tc.None;if(this.m)return y.$Tc.None;I&&(M=M.bind(I));const O=new A(M);let j,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(O.stack=e.create(),j=this.g.check(O.stack,this.w+1)),c&&(O.stack=G??e.create()),this.t?this.t instanceof A?(this.u??=new f,this.t=[this.t,O]):this.t.push(O):(this.f?.onWillAddFirstListener?.(this),this.t=O,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,y.$Rc)(()=>{j?.(),this.x(O)});return T instanceof y.$Sc?T.add(ee):Array.isArray(T)&&T.push(ee),ee},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const I=this.t,T=I.indexOf(M);if(T===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,I[T]=void 0;const O=this.u.current===this;if(this.w*N<=I.length){let j=0;for(let G=0;G<I.length;G++)I[G]?I[j++]=I[G]:O&&(this.u.end--,j<this.u.i&&this.u.i--);I.length=j}}y(M,I){if(!M)return;const T=this.f?.onListenerError||i.$1;if(!T){M.value(I);return}try{M.value(I)}catch(O){T(O)}}z(M){const I=M.current.t;for(;M.i<M.end;)this.y(I[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof A)this.y(this.t,M);else{const I=this.u;I.enqueue(this,M,this.t.length),this.z(I)}this.j?.stop()}hasListeners(){return this.w>0}}t.$6d=d;const a=()=>new f;t.$7d=a;class f{constructor(){this.i=-1,this.end=0}enqueue(M,I,T){this.i=0,this.end=T,this.current=M,this.value=I}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends d{async fireAsync(M,I,T){if(this.t)for(this.h||(this.h=new h.$4c),$(this.t,O=>this.h.push([O.value,M]));this.h.size>0&&!I.isCancellationRequested;){const[O,j]=this.h.shift(),G=[],ee={...j,token:I,waitUntil:S=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");T&&(S=T(S,O)),G.push(S)}};try{O(ee)}catch(S){(0,i.$1)(S);continue}Object.freeze(G),await Promise.allSettled(G).then(S=>{for(const B of S)B.status==="rejected"&&(0,i.$1)(B.reason)})}}}t.$8d=n;class s extends d{get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new h.$4c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}t.$9d=s;class v extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}t.$0d=v;class g extends d{constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(I=>super.fire(I)),this.h=[]}))}}t.$$d=g;class k{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const I={event:M,listener:null};this.h.push(I),this.g&&this.m(I);const T=()=>{this.g&&this.o(I);const O=this.h.indexOf(I);this.h.splice(O,1)};return(0,y.$Rc)((0,F.$db)(T))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(I=>this.f.fire(I))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}t.$_d=k;class p{constructor(M,I,T,O){this.f=new y.$Sc;const j=this.f.add(new k),G=this.f.add(new y.$3c);function ee(S){G.set(S,j.add(O(S)))}for(const S of M)ee(S);this.f.add(I(S=>{ee(S)})),this.f.add(T(S=>{G.deleteAndDispose(S)})),this.event=j.event}dispose(){this.f.dispose()}}t.$ae=p;class R{constructor(){this.f=[]}wrapEvent(M){return(I,T,O)=>M(j=>{const G=this.f[this.f.length-1];G?G.push(()=>I.call(T,j)):I.call(T,j)},void 0,O)}bufferEvents(M){const I=[];this.f.push(I);const T=M();return this.f.pop(),I.forEach(O=>O()),T}}t.$be=R;class P{constructor(){this.f=!1,this.g=u.None,this.h=y.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ce=P}),te(ne[24],re([0,1,11]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$de=t.CancellationToken=void 0;const F=Object.freeze(function(c,l){const u=setTimeout(c.bind(l),0);return{dispose(){clearTimeout(u)}}});var y;(function(c){function l(u){return u===c.None||u===c.Cancelled||u instanceof h?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}c.isCancellationToken=l,c.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),c.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(y||(t.CancellationToken=y={}));class h{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new i.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new h),this.f}cancel(){this.f?this.f instanceof h&&this.f.cancel():this.f=y.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof h&&this.f.dispose():this.f=y.None}}t.$de=w}),te(ne[40],re([0,1,24]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qe=t.$Pe=t.$Oe=void 0;class F{constructor(c){this.b=c,this.a=null}get(){if(this.a)return this.a;const c=new i.$de,l=this.b(c.token);return this.a={promise:l,dispose:()=>{this.a=null,c.cancel(),c.dispose()}},this.a}}t.$Oe=F;class y{constructor(c){this.c=c,this.a=void 0,this.b=void 0}get(c){const l=JSON.stringify(c);return this.b!==l&&(this.b=l,this.a=this.c(c)),this.a}}t.$Pe=y;class h{get cachedValues(){return this.a}constructor(c){this.b=c,this.a=new Map}get(c){if(this.a.has(c))return this.a.get(c);const l=this.b(c);return this.a.set(c,l),l}}t.$Qe=h}),te(ne[7],re([0,1,40,39]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.GraphemeBreakType=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=void 0;function y(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.$Te=y;const h=/{(\d+)}/g;function w(q,...V){return V.length===0?q:q.replace(h,function(X,Z){const ue=parseInt(Z,10);return isNaN(ue)||ue<0||ue>=V.length?X:V[ue]})}t.$Ue=w;const c=/{([^}]+)}/g;function l(q,V){return Object.keys(V).length===0?q:q.replace(c,(X,Z)=>V[Z]??X)}t.$Ve=l;function u(q){return q.replace(/[<>"'&]/g,V=>{switch(V){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return V})}t.$We=u;function o(q){return q.replace(/[<>&]/g,function(V){switch(V){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return V}})}t.$Xe=o;function E(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Ye=E;function b(q,V){let X=0;const Z=V.charCodeAt(0);for(let ue=q.length-1;ue>=0;ue--)q.charCodeAt(ue)===Z&&X++;return X}t.$Ze=b;function m(q,V,X="\u2026"){return q.length<=V?q:`${q.substr(0,V)}${X}`}t.$1e=m;function e(q,V,X="\u2026"){if(q.length<=V)return q;const Z=Math.ceil(V/2)-X.length/2,ue=Math.floor(V/2)-X.length/2;return`${q.substr(0,Z)}${X}${q.substr(q.length-ue)}`}t.$2e=e;function L(q,V=" "){const X=A(q,V);return N(X,V)}t.$3e=L;function A(q,V){if(!q||!V)return q;const X=V.length;if(X===0||q.length===0)return q;let Z=0;for(;q.indexOf(V,Z)===Z;)Z=Z+X;return q.substring(Z)}t.$4e=A;function N(q,V){if(!q||!V)return q;const X=V.length,Z=q.length;if(X===0||Z===0)return q;let ue=Z,he=-1;for(;he=q.lastIndexOf(V,ue-1),!(he===-1||he+X!==ue);){if(he===0)return"";ue=he}return q.substring(0,ue)}t.$5e=N;function $(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$6e=$;function d(q){return q.replace(/\*/g,"")}t.$7e=d;function a(q,V,X={}){if(!q)throw new Error("Cannot create regex from empty string");V||(q=E(q)),X.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Z="";return X.global&&(Z+="g"),X.matchCase||(Z+="i"),X.multiline&&(Z+="m"),X.unicode&&(Z+="u"),new RegExp(q,Z)}t.$8e=a;function f(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.$9e=f;function n(q){return q.split(/\r\n|\r|\n/)}t.$0e=n;function s(q){const V=[],X=q.split(/(\r\n|\r|\n)/);for(let Z=0;Z<Math.ceil(X.length/2);Z++)V.push(X[2*Z]+(X[2*Z+1]??""));return V}t.$$e=s;function v(q){for(let V=0,X=q.length;V<X;V++){const Z=q.charCodeAt(V);if(Z!==32&&Z!==9)return V}return-1}t.$_e=v;function g(q,V=0,X=q.length){for(let Z=V;Z<X;Z++){const ue=q.charCodeAt(Z);if(ue!==32&&ue!==9)return q.substring(V,Z)}return q.substring(V,X)}t.$af=g;function k(q,V=q.length-1){for(let X=V;X>=0;X--){const Z=q.charCodeAt(X);if(Z!==32&&Z!==9)return X}return-1}t.$bf=k;function p(q,V,X){const Z=[];let ue=0;for(const he of q.matchAll(V)){if(Z.push(q.slice(ue,he.index)),he.index===void 0)throw new Error("match.index should be defined");ue=he.index+he[0].length,Z.push(X(he[0],...he.slice(1),he.index,q,he.groups))}return Z.push(q.slice(ue)),Promise.all(Z).then(he=>he.join(""))}t.$cf=p;function R(q,V){return q<V?-1:q>V?1:0}t.$df=R;function P(q,V,X=0,Z=q.length,ue=0,he=V.length){for(;X<Z&&ue<he;X++,ue++){const we=q.charCodeAt(X),Le=V.charCodeAt(ue);if(we<Le)return-1;if(we>Le)return 1}const me=Z-X,pe=he-ue;return me<pe?-1:me>pe?1:0}t.$ef=P;function D(q,V){return M(q,V,0,q.length,0,V.length)}t.$ff=D;function M(q,V,X=0,Z=q.length,ue=0,he=V.length){for(;X<Z&&ue<he;X++,ue++){let we=q.charCodeAt(X),Le=V.charCodeAt(ue);if(we===Le)continue;if(we>=128||Le>=128)return P(q.toLowerCase(),V.toLowerCase(),X,Z,ue,he);T(we)&&(we-=32),T(Le)&&(Le-=32);const be=we-Le;if(be!==0)return be}const me=Z-X,pe=he-ue;return me<pe?-1:me>pe?1:0}t.$gf=M;function I(q){return q>=48&&q<=57}t.$hf=I;function T(q){return q>=97&&q<=122}t.$if=T;function O(q){return q>=65&&q<=90}t.$jf=O;function j(q,V){return q.length===V.length&&M(q,V)===0}t.$kf=j;function G(q,V){const X=V.length;return V.length>q.length?!1:M(q,V,0,X)===0}t.$lf=G;function ee(q,V){const X=Math.min(q.length,V.length);let Z;for(Z=0;Z<X;Z++)if(q.charCodeAt(Z)!==V.charCodeAt(Z))return Z;return X}t.$mf=ee;function S(q,V){const X=Math.min(q.length,V.length);let Z;const ue=q.length-1,he=V.length-1;for(Z=0;Z<X;Z++)if(q.charCodeAt(ue-Z)!==V.charCodeAt(he-Z))return Z;return X}t.$nf=S;function B(q){return 55296<=q&&q<=56319}t.$of=B;function _(q){return 56320<=q&&q<=57343}t.$pf=_;function Y(q,V){return(q-55296<<10)+(V-56320)+65536}t.$qf=Y;function se(q,V,X){const Z=q.charCodeAt(X);if(B(Z)&&X+1<V){const ue=q.charCodeAt(X+1);if(_(ue))return Y(Z,ue)}return Z}t.$rf=se;function ae(q,V){const X=q.charCodeAt(V-1);if(_(X)&&V>1){const Z=q.charCodeAt(V-2);if(B(Z))return Y(Z,X)}return X}class r{get offset(){return this.e}constructor(V,X=0){this.c=V,this.d=V.length,this.e=X}setOffset(V){this.e=V}prevCodePoint(){const V=ae(this.c,this.e);return this.e-=V>=65536?2:1,V}nextCodePoint(){const V=se(this.c,this.d,this.e);return this.e+=V>=65536?2:1,V}eol(){return this.e>=this.d}}t.$sf=r;class ge{get offset(){return this.c.offset}constructor(V,X=0){this.c=new r(V,X)}nextGraphemeLength(){const V=ve.getInstance(),X=this.c,Z=X.offset;let ue=V.getGraphemeBreakType(X.nextCodePoint());for(;!X.eol();){const he=X.offset,me=V.getGraphemeBreakType(X.nextCodePoint());if(Oe(ue,me)){X.setOffset(he);break}ue=me}return X.offset-Z}prevGraphemeLength(){const V=ve.getInstance(),X=this.c,Z=X.offset;let ue=V.getGraphemeBreakType(X.prevCodePoint());for(;X.offset>0;){const he=X.offset,me=V.getGraphemeBreakType(X.prevCodePoint());if(Oe(me,ue)){X.setOffset(he);break}ue=me}return Z-X.offset}eol(){return this.c.eol()}}t.$tf=ge;function ke(q,V){return new ge(q,V).nextGraphemeLength()}t.$uf=ke;function Ee(q,V){return new ge(q,V).prevGraphemeLength()}t.$vf=Ee;function $e(q,V){V>0&&_(q.charCodeAt(V))&&V--;const X=V+ke(q,V);return[X-Ee(q,X),X]}t.$wf=$e;function ye(q){const V=new ge(q);let X=0;for(;!V.eol();)X++,V.nextGraphemeLength();return X}t.$xf=ye;let Pe;function Ie(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function qe(q){return Pe||(Pe=Ie()),Pe.test(q)}t.$yf=qe;const Ae=/^[\t\n\r\x20-\x7E]*$/;function W(q){return Ae.test(q)}t.$zf=W,t.$Af=/[\u2028\u2029]/;function z(q){return t.$Af.test(q)}t.$Bf=z;function x(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.$Cf=x;function Q(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.$Df=Q;function H(q,V,X=""){const Z=q.trimStart();if(Z.length<V)return Z;const ue=/\b/g;let he=0;for(;ue.test(Z)&&!(Z.length-ue.lastIndex<V);)he=ue.lastIndex,ue.lastIndex+=1;return he===0?Z:X+Z.substring(he).trimStart()}t.$Ef=H;const J=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,U=/\x1b\].*?\x07/g;function K(q){return q&&(q=q.replace(J,"").replace(U,"")),q}t.$Ff=K,t.$Gf="\uFEFF";function ie(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.$Hf=ie;function le(q){return ie(q)?q.substr(1):q}t.$If=le;function fe(q,V){if(!q||!V||q.length<V.length)return!1;const X=V.length,Z=q.toLowerCase();let ue=0,he=-1;for(;ue<X;){const me=Z.indexOf(V[ue],he+1);if(me<0)return!1;he=me,ue++}return!0}t.$Jf=fe;function ce(q,V=!1){return q?(V&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.$Kf=ce;function de(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.$Lf=de;function Me(q,V=1){if(V===0)return"";let X=-1;do X=q.indexOf(`
`,X+1),V--;while(V>0&&X>=0);return X===-1?q:(q[X-1]==="\r"&&X--,q.substr(0,X))}t.$Mf=Me;function Te(q){return q=q%(2*26),q<26?String.fromCharCode(97+q):String.fromCharCode(65+q-26)}t.$Nf=Te;function Fe(q){return ve.getInstance().getGraphemeBreakType(q)}t.$Of=Fe;function Oe(q,V){return q===0?V!==5&&V!==7:q===2&&V===3?!1:q===4||q===2||q===3||V===4||V===2||V===3?!0:!(q===8&&(V===8||V===9||V===11||V===12)||(q===11||q===9)&&(V===9||V===10)||(q===12||q===10)&&V===10||V===5||V===13||V===7||q===1||q===13&&V===14||q===6&&V===6)}var De;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(De||(t.GraphemeBreakType=De={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=We()}getGraphemeBreakType(V){if(V<32)return V===10?3:V===13?2:4;if(V<127)return 0;const X=this.d,Z=X.length/3;let ue=1;for(;ue<=Z;)if(V<X[3*ue])ue=2*ue;else if(V>X[3*ue+1])ue=2*ue+1;else return X[3*ue+2];return 0}}function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(q,V){if(q===0)return 0;const X=Ge(q,V);if(X!==void 0)return X;const Z=new r(V,q);return Z.prevCodePoint(),Z.offset}t.$Pf=He;function Ge(q,V){const X=new r(V,q);let Z=X.prevCodePoint();for(;Xe(Z)||Z===65039||Z===8419;){if(X.offset===0)return;Z=X.prevCodePoint()}if(!Q(Z))return;let ue=X.offset;return ue>0&&X.prevCodePoint()===8205&&(ue=X.offset),ue}function Xe(q){return 127995<=q&&q<=127999}var Ce;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Ce||(Ce={})),t.$Qf="\xA0";class Se{static{this.c=new F.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Pe(V=>{function X(be){const Re=new Map;for(let Ne=0;Ne<be.length;Ne+=2)Re.set(be[Ne],be[Ne+1]);return Re}function Z(be,Re){const Ne=new Map(be);for(const[Ve,je]of Re)Ne.set(Ve,je);return Ne}function ue(be,Re){if(!be)return Re;const Ne=new Map;for(const[Ve,je]of be)Re.has(Ve)&&Ne.set(Ve,je);return Ne}const he=this.c.value;let me=V.filter(be=>!be.startsWith("_")&&be in he);me.length===0&&(me=["_default"]);let pe;for(const be of me){const Re=X(he[be]);pe=ue(pe,Re)}const we=X(he._common),Le=Z(we,pe);return new Se(Le)})}static getInstance(V){return Se.d.get(Array.from(V))}static{this.e=new F.$V(()=>Object.keys(Se.c.value).filter(V=>!V.startsWith("_")))}static getLocales(){return Se.e.value}constructor(V){this.f=V}isAmbiguous(V){return this.f.has(V)}getPrimaryConfusable(V){return this.f.get(V)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Rf=Se;class Be{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Be.c())),this.d}static isInvisibleCharacter(V){return Be.e().has(V)}static get codePoints(){return Be.e()}}t.$Sf=Be}),te(ne[41],re([0,1,7]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aj=t.$_i=t.$$i=t.$0i=t.$9i=t.$8i=t.$7i=void 0;function F(N){return y(N,0)}t.$7i=F;function y(N,$){switch(typeof N){case"object":return N===null?h(349,$):Array.isArray(N)?l(N,$):u(N,$);case"string":return c(N,$);case"boolean":return w(N,$);case"number":return h(N,$);case"undefined":return h(937,$);default:return h(617,$)}}t.$8i=y;function h(N,$){return($<<5)-$+N|0}t.$9i=h;function w(N,$){return h(N?433:863,$)}function c(N,$){$=h(149417,$);for(let d=0,a=N.length;d<a;d++)$=h(N.charCodeAt(d),$);return $}t.$0i=c;function l(N,$){return $=h(104579,$),N.reduce((d,a)=>y(a,d),$)}function u(N,$){return $=h(181387,$),Object.keys(N).sort().reduce((d,a)=>(d=c(a,d),y(N[a],d)),$)}class o{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=y($,this.g),this.g}}t.$$i=o;var E;(function(N){N[N.BLOCK_SIZE=64]="BLOCK_SIZE",N[N.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function b(N,$,d=32){const a=d-$,f=~((1<<a)-1);return(N<<$|(f&N)>>>a)>>>0}function m(N,$=0,d=N.byteLength,a=0){for(let f=0;f<d;f++)N[$+f]=a}function e(N,$,d="0"){for(;N.length<$;)N=d+N;return N}function L(N,$=32){return N instanceof ArrayBuffer?Array.from(new Uint8Array(N)).map(d=>d.toString(16).padStart(2,"0")).join(""):e((N>>>0).toString(16),$/4)}t.$_i=L;class A{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const d=$.length;if(d===0)return;const a=this.p;let f=this.r,n=this.u,s,v;for(n!==0?(s=n,v=-1,n=0):(s=$.charCodeAt(0),v=0);;){let g=s;if(i.$of(s))if(v+1<d){const k=$.charCodeAt(v+1);i.$pf(k)?(v++,g=i.$qf(s,k)):g=65533}else{n=s;break}else i.$pf(s)&&(g=65533);if(f=this.w(a,f,g),v++,v<d)s=$.charCodeAt(v);else break}this.r=f,this.u=n}w($,d,a){return a<128?$[d++]=a:a<2048?($[d++]=192|(a&1984)>>>6,$[d++]=128|(a&63)>>>0):a<65536?($[d++]=224|(a&61440)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0):($[d++]=240|(a&1835008)>>>18,$[d++]=128|(a&258048)>>>12,$[d++]=128|(a&4032)>>>6,$[d++]=128|(a&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,$[0]=$[64],$[1]=$[65],$[2]=$[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),L(this.h)+L(this.l)+L(this.m)+L(this.n)+L(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=A.g,d=this.q;for(let R=0;R<64;R+=4)$.setUint32(R,d.getUint32(R,!1),!1);for(let R=64;R<320;R+=4)$.setUint32(R,b($.getUint32(R-12,!1)^$.getUint32(R-32,!1)^$.getUint32(R-56,!1)^$.getUint32(R-64,!1),1),!1);let a=this.h,f=this.l,n=this.m,s=this.n,v=this.o,g,k,p;for(let R=0;R<80;R++)R<20?(g=f&n|~f&s,k=1518500249):R<40?(g=f^n^s,k=1859775393):R<60?(g=f&n|f&s|n&s,k=2400959708):(g=f^n^s,k=3395469782),p=b(a,5)+g+v+k+$.getUint32(R*4,!1)&4294967295,v=s,s=n,n=b(f,30),f=a,a=p;this.h=this.h+a&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+s&4294967295,this.o=this.o+v&4294967295}}t.$aj=A}),te(ne[25],re([0,1,37,41]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dt=t.$ct=t.$bt=void 0;class y{constructor(b){this.a=b}getElements(){const b=this.a,m=new Int32Array(b.length);for(let e=0,L=b.length;e<L;e++)m[e]=b.charCodeAt(e);return m}}t.$bt=y;function h(E,b,m){return new o(new y(E),new y(b)).ComputeDiff(m).changes}t.$ct=h;class w{static Assert(b,m){if(!b)throw new Error(m)}}class c{static Copy(b,m,e,L,A){for(let N=0;N<A;N++)e[L+N]=b[m+N]}static Copy2(b,m,e,L,A){for(let N=0;N<A;N++)e[L+N]=b[m+N]}}var l;(function(E){E[E.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$at(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.d++}AddModifiedElement(b,m){this.b=Math.min(this.b,b),this.c=Math.min(this.c,m),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class o{constructor(b,m,e=null){this.a=e,this.b=b,this.c=m;const[L,A,N]=o.o(b),[$,d,a]=o.o(m);this.d=N&&a,this.e=L,this.f=A,this.g=$,this.h=d,this.k=[],this.m=[]}static n(b){return b.length>0&&typeof b[0]=="string"}static o(b){const m=b.getElements();if(o.n(m)){const e=new Int32Array(m.length);for(let L=0,A=m.length;L<A;L++)e[L]=(0,F.$0i)(m[L],0);return[m,e,!0]}return m instanceof Int32Array?[[],m,!1]:[[],new Int32Array(m),!1]}p(b,m){return this.f[b]!==this.h[m]?!1:this.d?this.e[b]===this.g[m]:!0}q(b,m){if(!this.p(b,m))return!1;const e=o.r(this.b,b),L=o.r(this.c,m);return e===L}static r(b,m){return typeof b.getStrictElement=="function"?b.getStrictElement(m):null}s(b,m){return this.f[b]!==this.f[m]?!1:this.d?this.e[b]===this.e[m]:!0}u(b,m){return this.h[b]!==this.h[m]?!1:this.d?this.g[b]===this.g[m]:!0}ComputeDiff(b){return this.v(0,this.f.length-1,0,this.h.length-1,b)}v(b,m,e,L,A){const N=[!1];let $=this.w(b,m,e,L,N);return A&&($=this.z($)),{quitEarly:N[0],changes:$}}w(b,m,e,L,A){for(A[0]=!1;b<=m&&e<=L&&this.p(b,e);)b++,e++;for(;m>=b&&L>=e&&this.p(m,L);)m--,L--;if(b>m||e>L){let n;return e<=L?(w.Assert(b===m+1,"originalStart should only be one more than originalEnd"),n=[new i.$at(b,0,e,L-e+1)]):b<=m?(w.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[new i.$at(b,m-b+1,e,0)]):(w.Assert(b===m+1,"originalStart should only be one more than originalEnd"),w.Assert(e===L+1,"modifiedStart should only be one more than modifiedEnd"),n=[]),n}const N=[0],$=[0],d=this.y(b,m,e,L,N,$,A),a=N[0],f=$[0];if(d!==null)return d;if(!A[0]){const n=this.w(b,a,e,f,A);let s=[];return A[0]?s=[new i.$at(a+1,m-(a+1)+1,f+1,L-(f+1)+1)]:s=this.w(a+1,m,f+1,L,A),this.H(n,s)}return[new i.$at(b,m-b+1,e,L-e+1)]}x(b,m,e,L,A,N,$,d,a,f,n,s,v,g,k,p,R,P){let D=null,M=null,I=new u,T=m,O=e,j=v[0]-p[0]-L,G=-1073741824,ee=this.k.length-1;do{const S=j+b;S===T||S<O&&a[S-1]<a[S+1]?(n=a[S+1],g=n-j-L,n<G&&I.MarkNextChange(),G=n,I.AddModifiedElement(n+1,g),j=S+1-b):(n=a[S-1]+1,g=n-j-L,n<G&&I.MarkNextChange(),G=n-1,I.AddOriginalElement(n,g+1),j=S-1-b),ee>=0&&(a=this.k[ee],b=a[0],T=1,O=a.length-1)}while(--ee>=-1);if(D=I.getReverseChanges(),P[0]){let S=v[0]+1,B=p[0]+1;if(D!==null&&D.length>0){const _=D[D.length-1];S=Math.max(S,_.getOriginalEnd()),B=Math.max(B,_.getModifiedEnd())}M=[new i.$at(S,s-S+1,B,k-B+1)]}else{I=new u,T=N,O=$,j=v[0]-p[0]-d,G=1073741824,ee=R?this.m.length-1:this.m.length-2;do{const S=j+A;S===T||S<O&&f[S-1]>=f[S+1]?(n=f[S+1]-1,g=n-j-d,n>G&&I.MarkNextChange(),G=n+1,I.AddOriginalElement(n+1,g+1),j=S+1-A):(n=f[S-1],g=n-j-d,n>G&&I.MarkNextChange(),G=n,I.AddModifiedElement(n+1,g+1),j=S-1-A),ee>=0&&(f=this.m[ee],A=f[0],T=1,O=f.length-1)}while(--ee>=-1);M=I.getChanges()}return this.H(D,M)}y(b,m,e,L,A,N,$){let d=0,a=0,f=0,n=0,s=0,v=0;b--,e--,A[0]=0,N[0]=0,this.k=[],this.m=[];const g=m-b+(L-e),k=g+1,p=new Int32Array(k),R=new Int32Array(k),P=L-e,D=m-b,M=b-e,I=m-L,O=(D-P)%2===0;p[P]=b,R[D]=m,$[0]=!1;for(let j=1;j<=g/2+1;j++){let G=0,ee=0;f=this.J(P-j,j,P,k),n=this.J(P+j,j,P,k);for(let B=f;B<=n;B+=2){B===f||B<n&&p[B-1]<p[B+1]?d=p[B+1]:d=p[B-1]+1,a=d-(B-P)-M;const _=d;for(;d<m&&a<L&&this.p(d+1,a+1);)d++,a++;if(p[B]=d,d+a>G+ee&&(G=d,ee=a),!O&&Math.abs(B-D)<=j-1&&d>=R[B])return A[0]=d,N[0]=a,_<=R[B]&&1447>0&&j<=1448?this.x(P,f,n,M,D,s,v,I,p,R,d,m,A,a,L,N,O,$):null}const S=(G-b+(ee-e)-j)/2;if(this.a!==null&&!this.a(G,S))return $[0]=!0,A[0]=G,N[0]=ee,S>0&&1447>0&&j<=1448?this.x(P,f,n,M,D,s,v,I,p,R,d,m,A,a,L,N,O,$):(b++,e++,[new i.$at(b,m-b+1,e,L-e+1)]);s=this.J(D-j,j,D,k),v=this.J(D+j,j,D,k);for(let B=s;B<=v;B+=2){B===s||B<v&&R[B-1]>=R[B+1]?d=R[B+1]-1:d=R[B-1],a=d-(B-D)-I;const _=d;for(;d>b&&a>e&&this.p(d,a);)d--,a--;if(R[B]=d,O&&Math.abs(B-P)<=j&&d<=p[B])return A[0]=d,N[0]=a,_>=p[B]&&1447>0&&j<=1448?this.x(P,f,n,M,D,s,v,I,p,R,d,m,A,a,L,N,O,$):null}if(j<=1447){let B=new Int32Array(n-f+2);B[0]=P-f+1,c.Copy2(p,f,B,1,n-f+1),this.k.push(B),B=new Int32Array(v-s+2),B[0]=D-s+1,c.Copy2(R,s,B,1,v-s+1),this.m.push(B)}}return this.x(P,f,n,M,D,s,v,I,p,R,d,m,A,a,L,N,O,$)}z(b){for(let m=0;m<b.length;m++){const e=b[m],L=m<b.length-1?b[m+1].originalStart:this.f.length,A=m<b.length-1?b[m+1].modifiedStart:this.h.length,N=e.originalLength>0,$=e.modifiedLength>0;for(;e.originalStart+e.originalLength<L&&e.modifiedStart+e.modifiedLength<A&&(!N||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!$||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const a=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!a)break;e.originalStart++,e.modifiedStart++}const d=[null];if(m<b.length-1&&this.I(b[m],b[m+1],d)){b[m]=d[0],b.splice(m+1,1),m--;continue}}for(let m=b.length-1;m>=0;m--){const e=b[m];let L=0,A=0;if(m>0){const n=b[m-1];L=n.originalStart+n.originalLength,A=n.modifiedStart+n.modifiedLength}const N=e.originalLength>0,$=e.modifiedLength>0;let d=0,a=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let n=1;;n++){const s=e.originalStart-n,v=e.modifiedStart-n;if(s<L||v<A||N&&!this.s(s,s+e.originalLength)||$&&!this.u(v,v+e.modifiedLength))break;const k=(s===L&&v===A?5:0)+this.G(s,e.originalLength,v,e.modifiedLength);k>a&&(a=k,d=n)}e.originalStart-=d,e.modifiedStart-=d;const f=[null];if(m>0&&this.I(b[m-1],b[m],f)){b[m-1]=f[0],b.splice(m,1),m++;continue}}if(this.d)for(let m=1,e=b.length;m<e;m++){const L=b[m-1],A=b[m],N=A.originalStart-L.originalStart-L.originalLength,$=L.originalStart,d=A.originalStart+A.originalLength,a=d-$,f=L.modifiedStart,n=A.modifiedStart+A.modifiedLength,s=n-f;if(N<5&&a<20&&s<20){const v=this.A($,a,f,s,N);if(v){const[g,k]=v;(g!==L.originalStart+L.originalLength||k!==L.modifiedStart+L.modifiedLength)&&(L.originalLength=g-L.originalStart,L.modifiedLength=k-L.modifiedStart,A.originalStart=g+N,A.modifiedStart=k+N,A.originalLength=d-A.originalStart,A.modifiedLength=n-A.modifiedStart)}}}return b}A(b,m,e,L,A){if(m<A||L<A)return null;const N=b+m-A+1,$=e+L-A+1;let d=0,a=0,f=0;for(let n=b;n<N;n++)for(let s=e;s<$;s++){const v=this.B(n,s,A);v>0&&v>d&&(d=v,a=n,f=s)}return d>0?[a,f]:null}B(b,m,e){let L=0;for(let A=0;A<e;A++){if(!this.p(b+A,m+A))return 0;L+=this.e[b+A].length}return L}C(b){return b<=0||b>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[b])}D(b,m){if(this.C(b)||this.C(b-1))return!0;if(m>0){const e=b+m;if(this.C(e-1)||this.C(e))return!0}return!1}E(b){return b<=0||b>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[b])}F(b,m){if(this.E(b)||this.E(b-1))return!0;if(m>0){const e=b+m;if(this.E(e-1)||this.E(e))return!0}return!1}G(b,m,e,L){const A=this.D(b,m)?1:0,N=this.F(e,L)?1:0;return A+N}H(b,m){const e=[];if(b.length===0||m.length===0)return m.length>0?m:b;if(this.I(b[b.length-1],m[0],e)){const L=new Array(b.length+m.length-1);return c.Copy(b,0,L,0,b.length-1),L[b.length-1]=e[0],c.Copy(m,1,L,b.length,m.length-1),L}else{const L=new Array(b.length+m.length);return c.Copy(b,0,L,0,b.length),c.Copy(m,0,L,b.length,m.length),L}}I(b,m,e){if(w.Assert(b.originalStart<=m.originalStart,"Left change is not less than or equal to right change"),w.Assert(b.modifiedStart<=m.modifiedStart,"Left change is not less than or equal to right change"),b.originalStart+b.originalLength>=m.originalStart||b.modifiedStart+b.modifiedLength>=m.modifiedStart){const L=b.originalStart;let A=b.originalLength;const N=b.modifiedStart;let $=b.modifiedLength;return b.originalStart+b.originalLength>=m.originalStart&&(A=m.originalStart+m.originalLength-b.originalStart),b.modifiedStart+b.modifiedLength>=m.modifiedStart&&($=m.modifiedStart+m.modifiedLength-b.modifiedStart),e[0]=new i.$at(L,A,N,$),!0}else return e[0]=null,!1}J(b,m,e,L){if(b>=0&&b<L)return b;const A=e,N=L-e-1,$=m%2===0;if(b<0){const d=A%2===0;return $===d?0:1}else{const d=N%2===0;return $===d?L-1:L-2}}}t.$dt=o}),te(ne[26],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=void 0;function i(f){return typeof f=="string"}t.$Tf=i;function F(f){return Array.isArray(f)&&f.every(n=>i(n))}t.$Uf=F;function y(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}t.$Vf=y;function h(f){const n=Object.getPrototypeOf(Uint8Array);return typeof f=="object"&&f instanceof n}t.$Wf=h;function w(f){return typeof f=="number"&&!isNaN(f)}t.$Xf=w;function c(f){return!!f&&typeof f[Symbol.iterator]=="function"}t.$Yf=c;function l(f){return f===!0||f===!1}t.$Zf=l;function u(f){return typeof f>"u"}t.$1f=u;function o(f){return!E(f)}t.$2f=o;function E(f){return u(f)||f===null}t.$3f=E;function b(f,n){if(!f)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}t.$4f=b;function m(f){if(E(f))throw new Error("Assertion Failed: argument is undefined or null");return f}t.$5f=m;function e(...f){const n=[];for(let s=0;s<f.length;s++){const v=f[s];if(E(v))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(v)}return n}t.$6f=e;const L=Object.prototype.hasOwnProperty;function A(f){if(!y(f))return!1;for(const n in f)if(L.call(f,n))return!1;return!0}t.$7f=A;function N(f){return typeof f=="function"}t.$8f=N;function $(...f){return f.length>0&&f.every(N)}t.$9f=$;function d(f,n){const s=Math.min(f.length,n.length);for(let v=0;v<s;v++)a(f[v],n[v])}t.$0f=d;function a(f,n){if(i(n)){if(typeof f!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(N(n)){try{if(f instanceof n)return}catch{}if(!E(f)&&f.constructor===n||n.length===1&&n.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$$f=a}),te(ne[27],re([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lk=t.$kk=void 0;const F=Object.create(null);function y(w,c){if((0,i.$Tf)(c)){const l=F[c];if(l===void 0)throw new Error(`${w} references an unknown codicon: ${c}`);c=l}return F[w]=c,{id:w}}t.$kk=y;function h(){return F}t.$lk=h}),te(ne[42],re([0,1,27]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mk=void 0,t.$mk={add:(0,i.$kk)("add",6e4),plus:(0,i.$kk)("plus",6e4),gistNew:(0,i.$kk)("gist-new",6e4),repoCreate:(0,i.$kk)("repo-create",6e4),lightbulb:(0,i.$kk)("lightbulb",60001),lightBulb:(0,i.$kk)("light-bulb",60001),repo:(0,i.$kk)("repo",60002),repoDelete:(0,i.$kk)("repo-delete",60002),gistFork:(0,i.$kk)("gist-fork",60003),repoForked:(0,i.$kk)("repo-forked",60003),gitPullRequest:(0,i.$kk)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$kk)("git-pull-request-abandoned",60004),recordKeys:(0,i.$kk)("record-keys",60005),keyboard:(0,i.$kk)("keyboard",60005),tag:(0,i.$kk)("tag",60006),tagAdd:(0,i.$kk)("tag-add",60006),tagRemove:(0,i.$kk)("tag-remove",60006),gitPullRequestLabel:(0,i.$kk)("git-pull-request-label",60006),person:(0,i.$kk)("person",60007),personFollow:(0,i.$kk)("person-follow",60007),personOutline:(0,i.$kk)("person-outline",60007),personFilled:(0,i.$kk)("person-filled",60007),gitBranch:(0,i.$kk)("git-branch",60008),gitBranchCreate:(0,i.$kk)("git-branch-create",60008),gitBranchDelete:(0,i.$kk)("git-branch-delete",60008),sourceControl:(0,i.$kk)("source-control",60008),mirror:(0,i.$kk)("mirror",60009),mirrorPublic:(0,i.$kk)("mirror-public",60009),star:(0,i.$kk)("star",60010),starAdd:(0,i.$kk)("star-add",60010),starDelete:(0,i.$kk)("star-delete",60010),starEmpty:(0,i.$kk)("star-empty",60010),comment:(0,i.$kk)("comment",60011),commentAdd:(0,i.$kk)("comment-add",60011),alert:(0,i.$kk)("alert",60012),warning:(0,i.$kk)("warning",60012),search:(0,i.$kk)("search",60013),searchSave:(0,i.$kk)("search-save",60013),logOut:(0,i.$kk)("log-out",60014),signOut:(0,i.$kk)("sign-out",60014),logIn:(0,i.$kk)("log-in",60015),signIn:(0,i.$kk)("sign-in",60015),eye:(0,i.$kk)("eye",60016),eyeUnwatch:(0,i.$kk)("eye-unwatch",60016),eyeWatch:(0,i.$kk)("eye-watch",60016),circleFilled:(0,i.$kk)("circle-filled",60017),primitiveDot:(0,i.$kk)("primitive-dot",60017),closeDirty:(0,i.$kk)("close-dirty",60017),debugBreakpoint:(0,i.$kk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$kk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,i.$kk)("debug-breakpoint-pending",60377),debugHint:(0,i.$kk)("debug-hint",60017),primitiveSquare:(0,i.$kk)("primitive-square",60018),edit:(0,i.$kk)("edit",60019),pencil:(0,i.$kk)("pencil",60019),info:(0,i.$kk)("info",60020),issueOpened:(0,i.$kk)("issue-opened",60020),gistPrivate:(0,i.$kk)("gist-private",60021),gitForkPrivate:(0,i.$kk)("git-fork-private",60021),lock:(0,i.$kk)("lock",60021),mirrorPrivate:(0,i.$kk)("mirror-private",60021),close:(0,i.$kk)("close",60022),removeClose:(0,i.$kk)("remove-close",60022),x:(0,i.$kk)("x",60022),repoSync:(0,i.$kk)("repo-sync",60023),sync:(0,i.$kk)("sync",60023),clone:(0,i.$kk)("clone",60024),desktopDownload:(0,i.$kk)("desktop-download",60024),beaker:(0,i.$kk)("beaker",60025),microscope:(0,i.$kk)("microscope",60025),vm:(0,i.$kk)("vm",60026),deviceDesktop:(0,i.$kk)("device-desktop",60026),file:(0,i.$kk)("file",60027),fileText:(0,i.$kk)("file-text",60027),more:(0,i.$kk)("more",60028),ellipsis:(0,i.$kk)("ellipsis",60028),kebabHorizontal:(0,i.$kk)("kebab-horizontal",60028),mailReply:(0,i.$kk)("mail-reply",60029),reply:(0,i.$kk)("reply",60029),organization:(0,i.$kk)("organization",60030),organizationFilled:(0,i.$kk)("organization-filled",60030),organizationOutline:(0,i.$kk)("organization-outline",60030),newFile:(0,i.$kk)("new-file",60031),fileAdd:(0,i.$kk)("file-add",60031),newFolder:(0,i.$kk)("new-folder",60032),fileDirectoryCreate:(0,i.$kk)("file-directory-create",60032),trash:(0,i.$kk)("trash",60033),trashcan:(0,i.$kk)("trashcan",60033),history:(0,i.$kk)("history",60034),clock:(0,i.$kk)("clock",60034),folder:(0,i.$kk)("folder",60035),fileDirectory:(0,i.$kk)("file-directory",60035),symbolFolder:(0,i.$kk)("symbol-folder",60035),logoGithub:(0,i.$kk)("logo-github",60036),markGithub:(0,i.$kk)("mark-github",60036),github:(0,i.$kk)("github",60036),terminal:(0,i.$kk)("terminal",60037),console:(0,i.$kk)("console",60037),repl:(0,i.$kk)("repl",60037),zap:(0,i.$kk)("zap",60038),symbolEvent:(0,i.$kk)("symbol-event",60038),error:(0,i.$kk)("error",60039),stop:(0,i.$kk)("stop",60039),variable:(0,i.$kk)("variable",60040),symbolVariable:(0,i.$kk)("symbol-variable",60040),array:(0,i.$kk)("array",60042),symbolArray:(0,i.$kk)("symbol-array",60042),symbolModule:(0,i.$kk)("symbol-module",60043),symbolPackage:(0,i.$kk)("symbol-package",60043),symbolNamespace:(0,i.$kk)("symbol-namespace",60043),symbolObject:(0,i.$kk)("symbol-object",60043),symbolMethod:(0,i.$kk)("symbol-method",60044),symbolFunction:(0,i.$kk)("symbol-function",60044),symbolConstructor:(0,i.$kk)("symbol-constructor",60044),symbolBoolean:(0,i.$kk)("symbol-boolean",60047),symbolNull:(0,i.$kk)("symbol-null",60047),symbolNumeric:(0,i.$kk)("symbol-numeric",60048),symbolNumber:(0,i.$kk)("symbol-number",60048),symbolStructure:(0,i.$kk)("symbol-structure",60049),symbolStruct:(0,i.$kk)("symbol-struct",60049),symbolParameter:(0,i.$kk)("symbol-parameter",60050),symbolTypeParameter:(0,i.$kk)("symbol-type-parameter",60050),symbolKey:(0,i.$kk)("symbol-key",60051),symbolText:(0,i.$kk)("symbol-text",60051),symbolReference:(0,i.$kk)("symbol-reference",60052),goToFile:(0,i.$kk)("go-to-file",60052),symbolEnum:(0,i.$kk)("symbol-enum",60053),symbolValue:(0,i.$kk)("symbol-value",60053),symbolRuler:(0,i.$kk)("symbol-ruler",60054),symbolUnit:(0,i.$kk)("symbol-unit",60054),activateBreakpoints:(0,i.$kk)("activate-breakpoints",60055),archive:(0,i.$kk)("archive",60056),arrowBoth:(0,i.$kk)("arrow-both",60057),arrowDown:(0,i.$kk)("arrow-down",60058),arrowLeft:(0,i.$kk)("arrow-left",60059),arrowRight:(0,i.$kk)("arrow-right",60060),arrowSmallDown:(0,i.$kk)("arrow-small-down",60061),arrowSmallLeft:(0,i.$kk)("arrow-small-left",60062),arrowSmallRight:(0,i.$kk)("arrow-small-right",60063),arrowSmallUp:(0,i.$kk)("arrow-small-up",60064),arrowUp:(0,i.$kk)("arrow-up",60065),bell:(0,i.$kk)("bell",60066),bold:(0,i.$kk)("bold",60067),book:(0,i.$kk)("book",60068),bookmark:(0,i.$kk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$kk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$kk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$kk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$kk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$kk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$kk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$kk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$kk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$kk)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$kk)("briefcase",60076),broadcast:(0,i.$kk)("broadcast",60077),browser:(0,i.$kk)("browser",60078),bug:(0,i.$kk)("bug",60079),calendar:(0,i.$kk)("calendar",60080),caseSensitive:(0,i.$kk)("case-sensitive",60081),check:(0,i.$kk)("check",60082),checklist:(0,i.$kk)("checklist",60083),chevronDown:(0,i.$kk)("chevron-down",60084),dropDownButton:(0,i.$kk)("drop-down-button",60084),chevronLeft:(0,i.$kk)("chevron-left",60085),chevronRight:(0,i.$kk)("chevron-right",60086),chevronUp:(0,i.$kk)("chevron-up",60087),chromeClose:(0,i.$kk)("chrome-close",60088),chromeMaximize:(0,i.$kk)("chrome-maximize",60089),chromeMinimize:(0,i.$kk)("chrome-minimize",60090),chromeRestore:(0,i.$kk)("chrome-restore",60091),circle:(0,i.$kk)("circle",60092),circleOutline:(0,i.$kk)("circle-outline",60092),debugBreakpointUnverified:(0,i.$kk)("debug-breakpoint-unverified",60092),circleSlash:(0,i.$kk)("circle-slash",60093),circuitBoard:(0,i.$kk)("circuit-board",60094),clearAll:(0,i.$kk)("clear-all",60095),clippy:(0,i.$kk)("clippy",60096),closeAll:(0,i.$kk)("close-all",60097),cloudDownload:(0,i.$kk)("cloud-download",60098),cloudUpload:(0,i.$kk)("cloud-upload",60099),code:(0,i.$kk)("code",60100),collapseAll:(0,i.$kk)("collapse-all",60101),colorMode:(0,i.$kk)("color-mode",60102),commentDiscussion:(0,i.$kk)("comment-discussion",60103),compareChanges:(0,i.$kk)("compare-changes",60157),creditCard:(0,i.$kk)("credit-card",60105),dash:(0,i.$kk)("dash",60108),dashboard:(0,i.$kk)("dashboard",60109),database:(0,i.$kk)("database",60110),debugContinue:(0,i.$kk)("debug-continue",60111),debugDisconnect:(0,i.$kk)("debug-disconnect",60112),debugPause:(0,i.$kk)("debug-pause",60113),debugRestart:(0,i.$kk)("debug-restart",60114),debugStart:(0,i.$kk)("debug-start",60115),debugStepInto:(0,i.$kk)("debug-step-into",60116),debugStepOut:(0,i.$kk)("debug-step-out",60117),debugStepOver:(0,i.$kk)("debug-step-over",60118),debugStop:(0,i.$kk)("debug-stop",60119),debug:(0,i.$kk)("debug",60120),deviceCameraVideo:(0,i.$kk)("device-camera-video",60121),deviceCamera:(0,i.$kk)("device-camera",60122),deviceMobile:(0,i.$kk)("device-mobile",60123),diffAdded:(0,i.$kk)("diff-added",60124),diffIgnored:(0,i.$kk)("diff-ignored",60125),diffModified:(0,i.$kk)("diff-modified",60126),diffRemoved:(0,i.$kk)("diff-removed",60127),diffRenamed:(0,i.$kk)("diff-renamed",60128),diff:(0,i.$kk)("diff",60129),discard:(0,i.$kk)("discard",60130),editorLayout:(0,i.$kk)("editor-layout",60131),emptyWindow:(0,i.$kk)("empty-window",60132),exclude:(0,i.$kk)("exclude",60133),extensions:(0,i.$kk)("extensions",60134),eyeClosed:(0,i.$kk)("eye-closed",60135),fileBinary:(0,i.$kk)("file-binary",60136),fileCode:(0,i.$kk)("file-code",60137),fileMedia:(0,i.$kk)("file-media",60138),filePdf:(0,i.$kk)("file-pdf",60139),fileSubmodule:(0,i.$kk)("file-submodule",60140),fileSymlinkDirectory:(0,i.$kk)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$kk)("file-symlink-file",60142),fileZip:(0,i.$kk)("file-zip",60143),files:(0,i.$kk)("files",60144),filter:(0,i.$kk)("filter",60145),flame:(0,i.$kk)("flame",60146),foldDown:(0,i.$kk)("fold-down",60147),foldUp:(0,i.$kk)("fold-up",60148),fold:(0,i.$kk)("fold",60149),folderActive:(0,i.$kk)("folder-active",60150),folderOpened:(0,i.$kk)("folder-opened",60151),gear:(0,i.$kk)("gear",60152),gift:(0,i.$kk)("gift",60153),gistSecret:(0,i.$kk)("gist-secret",60154),gist:(0,i.$kk)("gist",60155),gitCommit:(0,i.$kk)("git-commit",60156),gitCompare:(0,i.$kk)("git-compare",60157),gitMerge:(0,i.$kk)("git-merge",60158),githubAction:(0,i.$kk)("github-action",60159),githubAlt:(0,i.$kk)("github-alt",60160),globe:(0,i.$kk)("globe",60161),grabber:(0,i.$kk)("grabber",60162),graph:(0,i.$kk)("graph",60163),gripper:(0,i.$kk)("gripper",60164),heart:(0,i.$kk)("heart",60165),home:(0,i.$kk)("home",60166),horizontalRule:(0,i.$kk)("horizontal-rule",60167),hubot:(0,i.$kk)("hubot",60168),inbox:(0,i.$kk)("inbox",60169),issueClosed:(0,i.$kk)("issue-closed",60324),issueReopened:(0,i.$kk)("issue-reopened",60171),issues:(0,i.$kk)("issues",60172),italic:(0,i.$kk)("italic",60173),jersey:(0,i.$kk)("jersey",60174),json:(0,i.$kk)("json",60175),bracket:(0,i.$kk)("bracket",60175),kebabVertical:(0,i.$kk)("kebab-vertical",60176),key:(0,i.$kk)("key",60177),law:(0,i.$kk)("law",60178),lightbulbAutofix:(0,i.$kk)("lightbulb-autofix",60179),linkExternal:(0,i.$kk)("link-external",60180),link:(0,i.$kk)("link",60181),listOrdered:(0,i.$kk)("list-ordered",60182),listUnordered:(0,i.$kk)("list-unordered",60183),liveShare:(0,i.$kk)("live-share",60184),loading:(0,i.$kk)("loading",60185),location:(0,i.$kk)("location",60186),mailRead:(0,i.$kk)("mail-read",60187),mail:(0,i.$kk)("mail",60188),markdown:(0,i.$kk)("markdown",60189),megaphone:(0,i.$kk)("megaphone",60190),mention:(0,i.$kk)("mention",60191),milestone:(0,i.$kk)("milestone",60192),gitPullRequestMilestone:(0,i.$kk)("git-pull-request-milestone",60192),mortarBoard:(0,i.$kk)("mortar-board",60193),move:(0,i.$kk)("move",60194),multipleWindows:(0,i.$kk)("multiple-windows",60195),mute:(0,i.$kk)("mute",60196),noNewline:(0,i.$kk)("no-newline",60197),note:(0,i.$kk)("note",60198),octoface:(0,i.$kk)("octoface",60199),openPreview:(0,i.$kk)("open-preview",60200),package:(0,i.$kk)("package",60201),paintcan:(0,i.$kk)("paintcan",60202),pin:(0,i.$kk)("pin",60203),play:(0,i.$kk)("play",60204),run:(0,i.$kk)("run",60204),plug:(0,i.$kk)("plug",60205),preserveCase:(0,i.$kk)("preserve-case",60206),preview:(0,i.$kk)("preview",60207),project:(0,i.$kk)("project",60208),pulse:(0,i.$kk)("pulse",60209),question:(0,i.$kk)("question",60210),quote:(0,i.$kk)("quote",60211),radioTower:(0,i.$kk)("radio-tower",60212),reactions:(0,i.$kk)("reactions",60213),references:(0,i.$kk)("references",60214),refresh:(0,i.$kk)("refresh",60215),regex:(0,i.$kk)("regex",60216),remoteExplorer:(0,i.$kk)("remote-explorer",60217),remote:(0,i.$kk)("remote",60218),remove:(0,i.$kk)("remove",60219),replaceAll:(0,i.$kk)("replace-all",60220),replace:(0,i.$kk)("replace",60221),repoClone:(0,i.$kk)("repo-clone",60222),repoForcePush:(0,i.$kk)("repo-force-push",60223),repoPull:(0,i.$kk)("repo-pull",60224),repoPush:(0,i.$kk)("repo-push",60225),report:(0,i.$kk)("report",60226),requestChanges:(0,i.$kk)("request-changes",60227),rocket:(0,i.$kk)("rocket",60228),rootFolderOpened:(0,i.$kk)("root-folder-opened",60229),rootFolder:(0,i.$kk)("root-folder",60230),rss:(0,i.$kk)("rss",60231),ruby:(0,i.$kk)("ruby",60232),saveAll:(0,i.$kk)("save-all",60233),saveAs:(0,i.$kk)("save-as",60234),save:(0,i.$kk)("save",60235),screenFull:(0,i.$kk)("screen-full",60236),screenNormal:(0,i.$kk)("screen-normal",60237),searchStop:(0,i.$kk)("search-stop",60238),server:(0,i.$kk)("server",60240),settingsGear:(0,i.$kk)("settings-gear",60241),settings:(0,i.$kk)("settings",60242),shield:(0,i.$kk)("shield",60243),smiley:(0,i.$kk)("smiley",60244),sortPrecedence:(0,i.$kk)("sort-precedence",60245),splitHorizontal:(0,i.$kk)("split-horizontal",60246),splitVertical:(0,i.$kk)("split-vertical",60247),squirrel:(0,i.$kk)("squirrel",60248),starFull:(0,i.$kk)("star-full",60249),starHalf:(0,i.$kk)("star-half",60250),symbolClass:(0,i.$kk)("symbol-class",60251),symbolColor:(0,i.$kk)("symbol-color",60252),symbolCustomColor:(0,i.$kk)("symbol-customcolor",60252),symbolConstant:(0,i.$kk)("symbol-constant",60253),symbolEnumMember:(0,i.$kk)("symbol-enum-member",60254),symbolField:(0,i.$kk)("symbol-field",60255),symbolFile:(0,i.$kk)("symbol-file",60256),symbolInterface:(0,i.$kk)("symbol-interface",60257),symbolKeyword:(0,i.$kk)("symbol-keyword",60258),symbolMisc:(0,i.$kk)("symbol-misc",60259),symbolOperator:(0,i.$kk)("symbol-operator",60260),symbolProperty:(0,i.$kk)("symbol-property",60261),wrench:(0,i.$kk)("wrench",60261),wrenchSubaction:(0,i.$kk)("wrench-subaction",60261),symbolSnippet:(0,i.$kk)("symbol-snippet",60262),tasklist:(0,i.$kk)("tasklist",60263),telescope:(0,i.$kk)("telescope",60264),textSize:(0,i.$kk)("text-size",60265),threeBars:(0,i.$kk)("three-bars",60266),thumbsdown:(0,i.$kk)("thumbsdown",60267),thumbsup:(0,i.$kk)("thumbsup",60268),tools:(0,i.$kk)("tools",60269),triangleDown:(0,i.$kk)("triangle-down",60270),triangleLeft:(0,i.$kk)("triangle-left",60271),triangleRight:(0,i.$kk)("triangle-right",60272),triangleUp:(0,i.$kk)("triangle-up",60273),twitter:(0,i.$kk)("twitter",60274),unfold:(0,i.$kk)("unfold",60275),unlock:(0,i.$kk)("unlock",60276),unmute:(0,i.$kk)("unmute",60277),unverified:(0,i.$kk)("unverified",60278),verified:(0,i.$kk)("verified",60279),versions:(0,i.$kk)("versions",60280),vmActive:(0,i.$kk)("vm-active",60281),vmOutline:(0,i.$kk)("vm-outline",60282),vmRunning:(0,i.$kk)("vm-running",60283),watch:(0,i.$kk)("watch",60284),whitespace:(0,i.$kk)("whitespace",60285),wholeWord:(0,i.$kk)("whole-word",60286),window:(0,i.$kk)("window",60287),wordWrap:(0,i.$kk)("word-wrap",60288),zoomIn:(0,i.$kk)("zoom-in",60289),zoomOut:(0,i.$kk)("zoom-out",60290),listFilter:(0,i.$kk)("list-filter",60291),listFlat:(0,i.$kk)("list-flat",60292),listSelection:(0,i.$kk)("list-selection",60293),selection:(0,i.$kk)("selection",60293),listTree:(0,i.$kk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$kk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$kk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$kk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$kk)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$kk)("circle-small-filled",60298),debugStackframeDot:(0,i.$kk)("debug-stackframe-dot",60298),debugStackframe:(0,i.$kk)("debug-stackframe",60299),debugStackframeFocused:(0,i.$kk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$kk)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$kk)("symbol-string",60301),debugReverseContinue:(0,i.$kk)("debug-reverse-continue",60302),debugStepBack:(0,i.$kk)("debug-step-back",60303),debugRestartFrame:(0,i.$kk)("debug-restart-frame",60304),callIncoming:(0,i.$kk)("call-incoming",60306),callOutgoing:(0,i.$kk)("call-outgoing",60307),menu:(0,i.$kk)("menu",60308),expandAll:(0,i.$kk)("expand-all",60309),feedback:(0,i.$kk)("feedback",60310),gitPullRequestReviewer:(0,i.$kk)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$kk)("group-by-ref-type",60311),ungroupByRefType:(0,i.$kk)("ungroup-by-ref-type",60312),account:(0,i.$kk)("account",60313),gitPullRequestAssignee:(0,i.$kk)("git-pull-request-assignee",60313),bellDot:(0,i.$kk)("bell-dot",60314),debugConsole:(0,i.$kk)("debug-console",60315),library:(0,i.$kk)("library",60316),output:(0,i.$kk)("output",60317),runAll:(0,i.$kk)("run-all",60318),syncIgnored:(0,i.$kk)("sync-ignored",60319),pinned:(0,i.$kk)("pinned",60320),githubInverted:(0,i.$kk)("github-inverted",60321),debugAlt:(0,i.$kk)("debug-alt",60305),serverProcess:(0,i.$kk)("server-process",60322),serverEnvironment:(0,i.$kk)("server-environment",60323),pass:(0,i.$kk)("pass",60324),stopCircle:(0,i.$kk)("stop-circle",60325),playCircle:(0,i.$kk)("play-circle",60326),record:(0,i.$kk)("record",60327),debugAltSmall:(0,i.$kk)("debug-alt-small",60328),vmConnect:(0,i.$kk)("vm-connect",60329),cloud:(0,i.$kk)("cloud",60330),merge:(0,i.$kk)("merge",60331),exportIcon:(0,i.$kk)("export",60332),graphLeft:(0,i.$kk)("graph-left",60333),magnet:(0,i.$kk)("magnet",60334),notebook:(0,i.$kk)("notebook",60335),redo:(0,i.$kk)("redo",60336),checkAll:(0,i.$kk)("check-all",60337),pinnedDirty:(0,i.$kk)("pinned-dirty",60338),passFilled:(0,i.$kk)("pass-filled",60339),circleLargeFilled:(0,i.$kk)("circle-large-filled",60340),circleLarge:(0,i.$kk)("circle-large",60341),circleLargeOutline:(0,i.$kk)("circle-large-outline",60341),combine:(0,i.$kk)("combine",60342),gather:(0,i.$kk)("gather",60342),table:(0,i.$kk)("table",60343),variableGroup:(0,i.$kk)("variable-group",60344),typeHierarchy:(0,i.$kk)("type-hierarchy",60345),typeHierarchySub:(0,i.$kk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$kk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$kk)("git-pull-request-create",60348),runAbove:(0,i.$kk)("run-above",60349),runBelow:(0,i.$kk)("run-below",60350),notebookTemplate:(0,i.$kk)("notebook-template",60351),debugRerun:(0,i.$kk)("debug-rerun",60352),workspaceTrusted:(0,i.$kk)("workspace-trusted",60353),workspaceUntrusted:(0,i.$kk)("workspace-untrusted",60354),workspaceUnspecified:(0,i.$kk)("workspace-unspecified",60355),terminalCmd:(0,i.$kk)("terminal-cmd",60356),terminalDebian:(0,i.$kk)("terminal-debian",60357),terminalLinux:(0,i.$kk)("terminal-linux",60358),terminalPowershell:(0,i.$kk)("terminal-powershell",60359),terminalTmux:(0,i.$kk)("terminal-tmux",60360),terminalUbuntu:(0,i.$kk)("terminal-ubuntu",60361),terminalBash:(0,i.$kk)("terminal-bash",60362),arrowSwap:(0,i.$kk)("arrow-swap",60363),copy:(0,i.$kk)("copy",60364),personAdd:(0,i.$kk)("person-add",60365),filterFilled:(0,i.$kk)("filter-filled",60366),wand:(0,i.$kk)("wand",60367),debugLineByLine:(0,i.$kk)("debug-line-by-line",60368),inspect:(0,i.$kk)("inspect",60369),layers:(0,i.$kk)("layers",60370),layersDot:(0,i.$kk)("layers-dot",60371),layersActive:(0,i.$kk)("layers-active",60372),compass:(0,i.$kk)("compass",60373),compassDot:(0,i.$kk)("compass-dot",60374),compassActive:(0,i.$kk)("compass-active",60375),azure:(0,i.$kk)("azure",60376),issueDraft:(0,i.$kk)("issue-draft",60377),gitPullRequestClosed:(0,i.$kk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$kk)("git-pull-request-draft",60379),debugAll:(0,i.$kk)("debug-all",60380),debugCoverage:(0,i.$kk)("debug-coverage",60381),runErrors:(0,i.$kk)("run-errors",60382),folderLibrary:(0,i.$kk)("folder-library",60383),debugContinueSmall:(0,i.$kk)("debug-continue-small",60384),beakerStop:(0,i.$kk)("beaker-stop",60385),graphLine:(0,i.$kk)("graph-line",60386),graphScatter:(0,i.$kk)("graph-scatter",60387),pieChart:(0,i.$kk)("pie-chart",60388),bracketDot:(0,i.$kk)("bracket-dot",60389),bracketError:(0,i.$kk)("bracket-error",60390),lockSmall:(0,i.$kk)("lock-small",60391),azureDevops:(0,i.$kk)("azure-devops",60392),verifiedFilled:(0,i.$kk)("verified-filled",60393),newLine:(0,i.$kk)("newline",60394),layout:(0,i.$kk)("layout",60395),layoutActivitybarLeft:(0,i.$kk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$kk)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$kk)("layout-panel-left",60398),layoutPanelCenter:(0,i.$kk)("layout-panel-center",60399),layoutPanelJustify:(0,i.$kk)("layout-panel-justify",60400),layoutPanelRight:(0,i.$kk)("layout-panel-right",60401),layoutPanel:(0,i.$kk)("layout-panel",60402),layoutSidebarLeft:(0,i.$kk)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$kk)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$kk)("layout-statusbar",60405),layoutMenubar:(0,i.$kk)("layout-menubar",60406),layoutCentered:(0,i.$kk)("layout-centered",60407),layoutSidebarRightOff:(0,i.$kk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$kk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$kk)("layout-sidebar-left-off",60418),target:(0,i.$kk)("target",60408),indent:(0,i.$kk)("indent",60409),recordSmall:(0,i.$kk)("record-small",60410),errorSmall:(0,i.$kk)("error-small",60411),arrowCircleDown:(0,i.$kk)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$kk)("arrow-circle-left",60413),arrowCircleRight:(0,i.$kk)("arrow-circle-right",60414),arrowCircleUp:(0,i.$kk)("arrow-circle-up",60415),heartFilled:(0,i.$kk)("heart-filled",60420),map:(0,i.$kk)("map",60421),mapFilled:(0,i.$kk)("map-filled",60422),circleSmall:(0,i.$kk)("circle-small",60423),bellSlash:(0,i.$kk)("bell-slash",60424),bellSlashDot:(0,i.$kk)("bell-slash-dot",60425),commentUnresolved:(0,i.$kk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$kk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$kk)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$kk)("search-fuzzy",60429),commentDraft:(0,i.$kk)("comment-draft",60430),send:(0,i.$kk)("send",60431),sparkle:(0,i.$kk)("sparkle",60432),insert:(0,i.$kk)("insert",60433),mic:(0,i.$kk)("mic",60434),thumbsDownFilled:(0,i.$kk)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$kk)("thumbsup-filled",60436),coffee:(0,i.$kk)("coffee",60437),snake:(0,i.$kk)("snake",60438),game:(0,i.$kk)("game",60439),vr:(0,i.$kk)("vr",60440),chip:(0,i.$kk)("chip",60441),piano:(0,i.$kk)("piano",60442),music:(0,i.$kk)("music",60443),micFilled:(0,i.$kk)("mic-filled",60444),gitFetch:(0,i.$kk)("git-fetch",60445),copilot:(0,i.$kk)("copilot",60446),lightbulbSparkle:(0,i.$kk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,i.$kk)("lightbulb-sparkle-autofix",60447),robot:(0,i.$kk)("robot",60448),sparkleFilled:(0,i.$kk)("sparkle-filled",60449),diffSingle:(0,i.$kk)("diff-single",60450),diffMultiple:(0,i.$kk)("diff-multiple",60451),surroundWith:(0,i.$kk)("surround-with",60452),gitStash:(0,i.$kk)("git-stash",60454),gitStashApply:(0,i.$kk)("git-stash-apply",60455),gitStashPop:(0,i.$kk)("git-stash-pop",60456),runAllCoverage:(0,i.$kk)("run-all-coverage",60461),runCoverage:(0,i.$kk)("run-all-coverage",60460),coverage:(0,i.$kk)("coverage",60462),githubProject:(0,i.$kk)("github-project",60463)}}),te(ne[43],re([0,1,27,42]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pk=t.$ok=t.$nk=void 0;function y(){return Object.values(t.$pk)}t.$nk=y,t.$ok={dialogError:(0,i.$kk)("dialog-error","error"),dialogWarning:(0,i.$kk)("dialog-warning","warning"),dialogInfo:(0,i.$kk)("dialog-info","info"),dialogClose:(0,i.$kk)("dialog-close","close"),treeItemExpanded:(0,i.$kk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$kk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$kk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$kk)("tree-filter-clear","close"),treeItemLoading:(0,i.$kk)("tree-item-loading","loading"),menuSelection:(0,i.$kk)("menu-selection","check"),menuSubmenu:(0,i.$kk)("menu-submenu","chevron-right"),menuBarMore:(0,i.$kk)("menubar-more","more"),scrollbarButtonLeft:(0,i.$kk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$kk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$kk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$kk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$kk)("toolbar-more","more"),quickInputBack:(0,i.$kk)("quick-input-back","arrow-left")},t.$pk={...F.$mk,...t.$ok}}),te(ne[14],re([0,1,26]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wn=t.$Vn=t.$Un=t.$Tn=t.$Sn=t.$Rn=t.$Qn=t.$Pn=t.$On=t.$Nn=t.$Mn=t.$Ln=void 0;function F(N){if(!N||typeof N!="object"||N instanceof RegExp)return N;const $=Array.isArray(N)?[]:{};return Object.entries(N).forEach(([d,a])=>{$[d]=a&&typeof a=="object"?F(a):a}),$}t.$Ln=F;function y(N){if(!N||typeof N!="object")return N;const $=[N];for(;$.length>0;){const d=$.shift();Object.freeze(d);for(const a in d)if(h.call(d,a)){const f=d[a];typeof f=="object"&&!Object.isFrozen(f)&&!(0,i.$Wf)(f)&&$.push(f)}}return N}t.$Mn=y;const h=Object.prototype.hasOwnProperty;function w(N,$){return c(N,$,new Set)}t.$Nn=w;function c(N,$,d){if((0,i.$3f)(N))return N;const a=$(N);if(typeof a<"u")return a;if(Array.isArray(N)){const f=[];for(const n of N)f.push(c(n,$,d));return f}if((0,i.$Vf)(N)){if(d.has(N))throw new Error("Cannot clone recursive data-structure");d.add(N);const f={};for(const n in N)h.call(N,n)&&(f[n]=c(N[n],$,d));return d.delete(N),f}return N}function l(N,$,d=!0){return(0,i.$Vf)(N)?((0,i.$Vf)($)&&Object.keys($).forEach(a=>{a in N?d&&((0,i.$Vf)(N[a])&&(0,i.$Vf)($[a])?l(N[a],$[a],d):N[a]=$[a]):N[a]=$[a]}),N):$}t.$On=l;function u(N,$){if(N===$)return!0;if(N==null||$===null||$===void 0||typeof N!=typeof $||typeof N!="object"||Array.isArray(N)!==Array.isArray($))return!1;let d,a;if(Array.isArray(N)){if(N.length!==$.length)return!1;for(d=0;d<N.length;d++)if(!u(N[d],$[d]))return!1}else{const f=[];for(a in N)f.push(a);f.sort();const n=[];for(a in $)n.push(a);if(n.sort(),!u(f,n))return!1;for(d=0;d<f.length;d++)if(!u(N[f[d]],$[f[d]]))return!1}return!0}t.$Pn=u;function o(N){const $=new Set;return JSON.stringify(N,(d,a)=>{if((0,i.$Vf)(a)||Array.isArray(a)){if($.has(a))return"[Circular]";$.add(a)}return a})}t.$Qn=o;function E(N,$){const d=Object.create(null);return!N||!$||Object.keys($).forEach(f=>{const n=N[f],s=$[f];u(n,s)||(d[f]=s)}),d}t.$Rn=E;function b(N,$){const d=$.toLowerCase(),a=Object.keys(N).find(f=>f.toLowerCase()===d);return a?N[a]:N[$]}t.$Sn=b;function m(N,$){const d=Object.create(null);for(const[a,f]of Object.entries(N))$(a,f)&&(d[a]=f);return d}t.$Tn=m;function e(N){let $=[];for(;Object.prototype!==N;)$=$.concat(Object.getOwnPropertyNames(N)),N=Object.getPrototypeOf(N);return $}t.$Un=e;function L(N){const $=[];for(const d of e(N))typeof N[d]=="function"&&$.push(d);return $}t.$Vn=L;function A(N,$){const d=f=>function(){const n=Array.prototype.slice.call(arguments,0);return $(f,n)},a={};for(const f of N)a[f]=d(f);return a}t.$Wn=A}),te(ne[28],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Se=t.$Re=t.Constants=void 0;var i;(function(h){h[h.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",h[h.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",h[h.MAX_UINT_8=255]="MAX_UINT_8",h[h.MAX_UINT_16=65535]="MAX_UINT_16",h[h.MAX_UINT_32=4294967295]="MAX_UINT_32",h[h.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(i||(t.Constants=i={}));function F(h){return h<0?0:h>255?255:h|0}t.$Re=F;function y(h){return h<0?0:h>4294967295?4294967295:h|0}t.$Se=y}),te(ne[29],re([0,1,28]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vt=t.$ut=void 0;class F{constructor(c){const l=(0,i.$Re)(c);this.c=l,this.a=F.d(l),this.b=new Map}static d(c){const l=new Uint8Array(256);return l.fill(c),l}set(c,l){const u=(0,i.$Re)(l);c>=0&&c<256?this.a[c]=u:this.b.set(c,u)}get(c){return c>=0&&c<256?this.a[c]:this.b.get(c)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$ut=F;var y;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(y||(y={}));class h{constructor(){this.a=new F(0)}add(c){this.a.set(c,1)}has(c){return this.a.get(c)===1}clear(){return this.a.clear()}}t.$vt=h}),te(ne[4],re([0,1,3]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ft=t.$et=void 0;class F{static addRange(w,c){let l=0;for(;l<c.length&&c[l].endExclusive<w.start;)l++;let u=l;for(;u<c.length&&c[u].start<=w.endExclusive;)u++;if(l===u)c.splice(l,0,w);else{const o=Math.min(w.start,c[l].start),E=Math.max(w.endExclusive,c[u-1].endExclusive);c.splice(l,u-l,new F(o,E))}}static tryCreate(w,c){if(!(w>c))return new F(w,c)}static ofLength(w){return new F(0,w)}static ofStartAndLength(w,c){return new F(w,w+c)}constructor(w,c){if(this.start=w,this.endExclusive=c,w>c)throw new i.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new F(this.start+w,this.endExclusive+w)}deltaStart(w){return new F(this.start+w,this.endExclusive)}deltaEnd(w){return new F(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new F(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const c=Math.max(this.start,w.start),l=Math.min(this.endExclusive,w.endExclusive);if(c<=l)return new F(c,l)}intersects(w){const c=Math.max(this.start,w.start),l=Math.min(this.endExclusive,w.endExclusive);return c<l}intersectsOrTouches(w){const c=Math.max(this.start,w.start),l=Math.min(this.endExclusive,w.endExclusive);return c<=l}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new i.$cb(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const c=[];for(let l=this.start;l<this.endExclusive;l++)c.push(w(l));return c}forEach(w){for(let c=this.start;c<this.endExclusive;c++)w(c)}}t.$et=F;class y{constructor(){this.a=[]}addRange(w){let c=0;for(;c<this.a.length&&this.a[c].endExclusive<w.start;)c++;let l=c;for(;l<this.a.length&&this.a[l].start<=w.endExclusive;)l++;if(c===l)this.a.splice(c,0,w);else{const u=Math.min(w.start,this.a[c].start),o=Math.max(w.endExclusive,this.a[l-1].endExclusive);this.a.splice(c,l-c,new F(u,o))}}toString(){return this.a.map(w=>w.toString()).join(", ")}intersectsStrict(w){let c=0;for(;c<this.a.length&&this.a[c].endExclusive<=w.start;)c++;return c<this.a.length&&this.a[c].start<w.endExclusive}intersectWithRange(w){const c=new y;for(const l of this.a){const u=l.intersect(w);u&&c.addRange(u)}return c}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this.a.reduce((w,c)=>w+c.length,0)}}t.$ft=y}),te(ne[5],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9s=void 0;class i{constructor(y,h){this.lineNumber=y,this.column=h}with(y=this.lineNumber,h=this.column){return y===this.lineNumber&&h===this.column?this:new i(y,h)}delta(y=0,h=0){return this.with(this.lineNumber+y,this.column+h)}equals(y){return i.equals(this,y)}static equals(y,h){return!y&&!h?!0:!!y&&!!h&&y.lineNumber===h.lineNumber&&y.column===h.column}isBefore(y){return i.isBefore(this,y)}static isBefore(y,h){return y.lineNumber<h.lineNumber?!0:h.lineNumber<y.lineNumber?!1:y.column<h.column}isBeforeOrEqual(y){return i.isBeforeOrEqual(this,y)}static isBeforeOrEqual(y,h){return y.lineNumber<h.lineNumber?!0:h.lineNumber<y.lineNumber?!1:y.column<=h.column}static compare(y,h){const w=y.lineNumber|0,c=h.lineNumber|0;if(w===c){const l=y.column|0,u=h.column|0;return l-u}return w-c}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(y){return new i(y.lineNumber,y.column)}static isIPosition(y){return y&&typeof y.lineNumber=="number"&&typeof y.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}t.$9s=i}),te(ne[2],re([0,1,5]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0s=void 0;class F{constructor(h,w,c,l){h>c||h===c&&w>l?(this.startLineNumber=c,this.startColumn=l,this.endLineNumber=h,this.endColumn=w):(this.startLineNumber=h,this.startColumn=w,this.endLineNumber=c,this.endColumn=l)}isEmpty(){return F.isEmpty(this)}static isEmpty(h){return h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn}containsPosition(h){return F.containsPosition(this,h)}static containsPosition(h,w){return!(w.lineNumber<h.startLineNumber||w.lineNumber>h.endLineNumber||w.lineNumber===h.startLineNumber&&w.column<h.startColumn||w.lineNumber===h.endLineNumber&&w.column>h.endColumn)}static strictContainsPosition(h,w){return!(w.lineNumber<h.startLineNumber||w.lineNumber>h.endLineNumber||w.lineNumber===h.startLineNumber&&w.column<=h.startColumn||w.lineNumber===h.endLineNumber&&w.column>=h.endColumn)}containsRange(h){return F.containsRange(this,h)}static containsRange(h,w){return!(w.startLineNumber<h.startLineNumber||w.endLineNumber<h.startLineNumber||w.startLineNumber>h.endLineNumber||w.endLineNumber>h.endLineNumber||w.startLineNumber===h.startLineNumber&&w.startColumn<h.startColumn||w.endLineNumber===h.endLineNumber&&w.endColumn>h.endColumn)}strictContainsRange(h){return F.strictContainsRange(this,h)}static strictContainsRange(h,w){return!(w.startLineNumber<h.startLineNumber||w.endLineNumber<h.startLineNumber||w.startLineNumber>h.endLineNumber||w.endLineNumber>h.endLineNumber||w.startLineNumber===h.startLineNumber&&w.startColumn<=h.startColumn||w.endLineNumber===h.endLineNumber&&w.endColumn>=h.endColumn)}plusRange(h){return F.plusRange(this,h)}static plusRange(h,w){let c,l,u,o;return w.startLineNumber<h.startLineNumber?(c=w.startLineNumber,l=w.startColumn):w.startLineNumber===h.startLineNumber?(c=w.startLineNumber,l=Math.min(w.startColumn,h.startColumn)):(c=h.startLineNumber,l=h.startColumn),w.endLineNumber>h.endLineNumber?(u=w.endLineNumber,o=w.endColumn):w.endLineNumber===h.endLineNumber?(u=w.endLineNumber,o=Math.max(w.endColumn,h.endColumn)):(u=h.endLineNumber,o=h.endColumn),new F(c,l,u,o)}intersectRanges(h){return F.intersectRanges(this,h)}static intersectRanges(h,w){let c=h.startLineNumber,l=h.startColumn,u=h.endLineNumber,o=h.endColumn;const E=w.startLineNumber,b=w.startColumn,m=w.endLineNumber,e=w.endColumn;return c<E?(c=E,l=b):c===E&&(l=Math.max(l,b)),u>m?(u=m,o=e):u===m&&(o=Math.min(o,e)),c>u||c===u&&l>o?null:new F(c,l,u,o)}equalsRange(h){return F.equalsRange(this,h)}static equalsRange(h,w){return!h&&!w?!0:!!h&&!!w&&h.startLineNumber===w.startLineNumber&&h.startColumn===w.startColumn&&h.endLineNumber===w.endLineNumber&&h.endColumn===w.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(h){return new i.$9s(h.endLineNumber,h.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(h){return new i.$9s(h.startLineNumber,h.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(h,w){return new F(this.startLineNumber,this.startColumn,h,w)}setStartPosition(h,w){return new F(h,w,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(h){return new F(h.startLineNumber,h.startColumn,h.startLineNumber,h.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(h){return new F(h.endLineNumber,h.endColumn,h.endLineNumber,h.endColumn)}delta(h){return new F(this.startLineNumber+h,this.startColumn,this.endLineNumber+h,this.endColumn)}static fromPositions(h,w=h){return new F(h.lineNumber,h.column,w.lineNumber,w.column)}static lift(h){return h?new F(h.startLineNumber,h.startColumn,h.endLineNumber,h.endColumn):null}static isIRange(h){return h&&typeof h.startLineNumber=="number"&&typeof h.startColumn=="number"&&typeof h.endLineNumber=="number"&&typeof h.endColumn=="number"}static areIntersectingOrTouching(h,w){return!(h.endLineNumber<w.startLineNumber||h.endLineNumber===w.startLineNumber&&h.endColumn<w.startColumn||w.endLineNumber<h.startLineNumber||w.endLineNumber===h.startLineNumber&&w.endColumn<h.startColumn)}static areIntersecting(h,w){return!(h.endLineNumber<w.startLineNumber||h.endLineNumber===w.startLineNumber&&h.endColumn<=w.startColumn||w.endLineNumber<h.startLineNumber||w.endLineNumber===h.startLineNumber&&w.endColumn<=h.startColumn)}static compareRangesUsingStarts(h,w){if(h&&w){const u=h.startLineNumber|0,o=w.startLineNumber|0;if(u===o){const E=h.startColumn|0,b=w.startColumn|0;if(E===b){const m=h.endLineNumber|0,e=w.endLineNumber|0;if(m===e){const L=h.endColumn|0,A=w.endColumn|0;return L-A}return m-e}return E-b}return u-o}return(h?1:0)-(w?1:0)}static compareRangesUsingEnds(h,w){return h.endLineNumber===w.endLineNumber?h.endColumn===w.endColumn?h.startLineNumber===w.startLineNumber?h.startColumn-w.startColumn:h.startLineNumber-w.startLineNumber:h.endColumn-w.endColumn:h.endLineNumber-w.endLineNumber}static spansMultipleLines(h){return h.endLineNumber>h.startLineNumber}toJSON(){return this}}t.$0s=F}),te(ne[44],re([0,1,2]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$s=void 0;class F{static insert(h,w){return{range:new i.$0s(h.lineNumber,h.column,h.lineNumber,h.column),text:w,forceMoveMarkers:!0}}static delete(h){return{range:h,text:null}}static replace(h,w){return{range:h,text:w}}static replaceMove(h,w){return{range:h,text:w,forceMoveMarkers:!0}}}t.$$s=F}),te(ne[12],re([0,1,3,4,2,9]),function(C,t,i,F,y,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ht=t.$gt=void 0;class w{static fromRange(u){return new w(u.startLineNumber,u.endLineNumber)}static fromRangeInclusive(u){return new w(u.startLineNumber,u.endLineNumber+1)}static subtract(u,o){return o?u.startLineNumber<o.startLineNumber&&o.endLineNumberExclusive<u.endLineNumberExclusive?[new w(u.startLineNumber,o.startLineNumber),new w(o.endLineNumberExclusive,u.endLineNumberExclusive)]:o.startLineNumber<=u.startLineNumber&&u.endLineNumberExclusive<=o.endLineNumberExclusive?[]:o.endLineNumberExclusive<u.endLineNumberExclusive?[new w(Math.max(o.endLineNumberExclusive,u.startLineNumber),u.endLineNumberExclusive)]:[new w(u.startLineNumber,Math.min(o.startLineNumber,u.endLineNumberExclusive))]:[u]}static joinMany(u){if(u.length===0)return[];let o=new c(u[0].slice());for(let E=1;E<u.length;E++)o=o.getUnion(new c(u[E].slice()));return o.ranges}static ofLength(u,o){return new w(u,u+o)}static deserialize(u){return new w(u[0],u[1])}constructor(u,o){if(u>o)throw new i.$cb(`startLineNumber ${u} cannot be after endLineNumberExclusive ${o}`);this.startLineNumber=u,this.endLineNumberExclusive=o}contains(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(u){return new w(this.startLineNumber+u,this.endLineNumberExclusive+u)}deltaLength(u){return new w(this.startLineNumber,this.endLineNumberExclusive+u)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(u){return new w(Math.min(this.startLineNumber,u.startLineNumber),Math.max(this.endLineNumberExclusive,u.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(u){const o=Math.max(this.startLineNumber,u.startLineNumber),E=Math.min(this.endLineNumberExclusive,u.endLineNumberExclusive);if(o<=E)return new w(o,E)}intersectsStrict(u){return this.startLineNumber<u.endLineNumberExclusive&&u.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(u){return this.startLineNumber<=u.endLineNumberExclusive&&u.startLineNumber<=this.endLineNumberExclusive}equals(u){return this.startLineNumber===u.startLineNumber&&this.endLineNumberExclusive===u.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new y.$0s(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new y.$0s(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(u){const o=[];for(let E=this.startLineNumber;E<this.endLineNumberExclusive;E++)o.push(u(E));return o}forEach(u){for(let o=this.startLineNumber;o<this.endLineNumberExclusive;o++)u(o)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(u){return this.startLineNumber<=u&&u<this.endLineNumberExclusive}toOffsetRange(){return new F.$et(this.startLineNumber-1,this.endLineNumberExclusive-1)}}t.$gt=w;class c{constructor(u=[]){this.c=u}get ranges(){return this.c}addRange(u){if(u.length===0)return;const o=(0,h.$kb)(this.c,b=>b.endLineNumberExclusive>=u.startLineNumber),E=(0,h.$ib)(this.c,b=>b.startLineNumber<=u.endLineNumberExclusive)+1;if(o===E)this.c.splice(o,0,u);else if(o===E-1){const b=this.c[o];this.c[o]=b.join(u)}else{const b=this.c[o].join(this.c[E-1]).join(u);this.c.splice(o,E-o,b)}}contains(u){const o=(0,h.$hb)(this.c,E=>E.startLineNumber<=u);return!!o&&o.endLineNumberExclusive>u}intersects(u){const o=(0,h.$hb)(this.c,E=>E.startLineNumber<u.endLineNumberExclusive);return!!o&&o.endLineNumberExclusive>u.startLineNumber}getUnion(u){if(this.c.length===0)return u;if(u.c.length===0)return this;const o=[];let E=0,b=0,m=null;for(;E<this.c.length||b<u.c.length;){let e=null;if(E<this.c.length&&b<u.c.length){const L=this.c[E],A=u.c[b];L.startLineNumber<A.startLineNumber?(e=L,E++):(e=A,b++)}else E<this.c.length?(e=this.c[E],E++):(e=u.c[b],b++);m===null?m=e:m.endLineNumberExclusive>=e.startLineNumber?m=new w(m.startLineNumber,Math.max(m.endLineNumberExclusive,e.endLineNumberExclusive)):(o.push(m),m=e)}return m!==null&&o.push(m),new c(o)}subtractFrom(u){const o=(0,h.$kb)(this.c,e=>e.endLineNumberExclusive>=u.startLineNumber),E=(0,h.$ib)(this.c,e=>e.startLineNumber<=u.endLineNumberExclusive)+1;if(o===E)return new c([u]);const b=[];let m=u.startLineNumber;for(let e=o;e<E;e++){const L=this.c[e];L.startLineNumber>m&&b.push(new w(m,L.startLineNumber)),m=L.endLineNumberExclusive}return m<u.endLineNumberExclusive&&b.push(new w(m,u.endLineNumberExclusive)),new c(b)}toString(){return this.c.map(u=>u.toString()).join(", ")}getIntersection(u){const o=[];let E=0,b=0;for(;E<this.c.length&&b<u.c.length;){const m=this.c[E],e=u.c[b],L=m.intersect(e);L&&!L.isEmpty&&o.push(L),m.endLineNumberExclusive<e.endLineNumberExclusive?E++:b++}return new c(o)}getWithDelta(u){return new c(this.c.map(o=>o.delta(u)))}}t.$ht=c}),te(ne[45],re([0,1,5,2]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_s=t.SelectionDirection=void 0;var y;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(y||(t.SelectionDirection=y={}));class h extends F.$0s{constructor(c,l,u,o){super(c,l,u,o),this.selectionStartLineNumber=c,this.selectionStartColumn=l,this.positionLineNumber=u,this.positionColumn=o}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(c){return h.selectionsEqual(this,c)}static selectionsEqual(c,l){return c.selectionStartLineNumber===l.selectionStartLineNumber&&c.selectionStartColumn===l.selectionStartColumn&&c.positionLineNumber===l.positionLineNumber&&c.positionColumn===l.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(c,l){return this.getDirection()===0?new h(this.startLineNumber,this.startColumn,c,l):new h(c,l,this.startLineNumber,this.startColumn)}getPosition(){return new i.$9s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new i.$9s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(c,l){return this.getDirection()===0?new h(c,l,this.endLineNumber,this.endColumn):new h(this.endLineNumber,this.endColumn,c,l)}static fromPositions(c,l=c){return new h(c.lineNumber,c.column,l.lineNumber,l.column)}static fromRange(c,l){return l===0?new h(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):new h(c.endLineNumber,c.endColumn,c.startLineNumber,c.startColumn)}static liftSelection(c){return new h(c.selectionStartLineNumber,c.selectionStartColumn,c.positionLineNumber,c.positionColumn)}static selectionsArrEqual(c,l){if(c&&!l||!c&&l)return!1;if(!c&&!l)return!0;if(c.length!==l.length)return!1;for(let u=0,o=c.length;u<o;u++)if(!this.selectionsEqual(c[u],l[u]))return!1;return!0}static isISelection(c){return c&&typeof c.selectionStartLineNumber=="number"&&typeof c.selectionStartColumn=="number"&&typeof c.positionLineNumber=="number"&&typeof c.positionColumn=="number"}static createWithDirection(c,l,u,o,E){return E===0?new h(c,l,u,o):new h(u,o,c,l)}}t.$_s=h}),te(ne[46],re([0,1,29]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xt=t.$wt=t.WordCharacterClass=void 0;var F;(function(w){w[w.Regular=0]="Regular",w[w.Whitespace=1]="Whitespace",w[w.WordSeparator=2]="WordSeparator"})(F||(t.WordCharacterClass=F={}));class y extends i.$ut{constructor(c){super(0);for(let l=0,u=c.length;l<u;l++)this.set(c.charCodeAt(l),2);this.set(32,1),this.set(9,1)}}t.$wt=y;function h(w){const c={};return l=>(c.hasOwnProperty(l)||(c[l]=w(l)),c[l])}t.$xt=h(w=>new y(w))}),te(ne[30],re([0,1,20,10,21]),function(C,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ms=t.$Ls=t.$Ks=t.$Js=t.$Is=void 0,t.$Is="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function h(E=""){let b="(-?\\d*\\.\\d\\w*)|([^";for(const m of t.$Is)E.indexOf(m)>=0||(b+="\\"+m);return b+="\\s]+)",new RegExp(b,"g")}t.$Js=h();function w(E){let b=t.$Js;if(E&&E instanceof RegExp)if(E.global)b=E;else{let m="g";E.ignoreCase&&(m+="i"),E.multiline&&(m+="m"),E.unicode&&(m+="u"),b=new RegExp(E.source,m)}return b.lastIndex=0,b}t.$Ks=w;const c=new y.$4c;c.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function l(E){const b=c.unshift(E);return(0,F.$Rc)(b)}t.$Ls=l;function u(E,b,m,e,L){if(b=w(b),L||(L=i.Iterable.first(c)),m.length>L.maxLen){let a=E-L.maxLen/2;return a<0?a=0:e+=a,m=m.substring(a,E+L.maxLen/2),u(E,b,m,e,L)}const A=Date.now(),N=E-1-e;let $=-1,d=null;for(let a=1;!(Date.now()-A>=L.timeBudget);a++){const f=N-L.windowSize*a;b.lastIndex=Math.max(0,f);const n=o(b,m,N,$);if(!n&&d||(d=n,f<=0))break;$=f}if(d){const a={word:d[0],startColumn:e+1+d.index,endColumn:e+1+d.index+d[0].length};return b.lastIndex=0,a}return null}t.$Ms=u;function o(E,b,m,e){let L;for(;L=E.exec(b);){const A=L.index||0;if(A<=m&&E.lastIndex>=m)return L;if(e>0&&A>e)return null}return null}}),te(ne[8],re([0,1,6,3,4]),function(C,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$k2=t.$j2=t.$i2=t.$h2=t.$g2=void 0;class h{static trivial(E,b){return new h([new w(y.$et.ofLength(E.length),y.$et.ofLength(b.length))],!1)}static trivialTimedOut(E,b){return new h([new w(y.$et.ofLength(E.length),y.$et.ofLength(b.length))],!0)}constructor(E,b){this.diffs=E,this.hitTimeout=b}}t.$g2=h;class w{static invert(E,b){const m=[];return(0,i.$Bb)(E,(e,L)=>{m.push(w.fromOffsetPairs(e?e.getEndExclusives():c.zero,L?L.getStarts():new c(b,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+b)))}),m}static fromOffsetPairs(E,b){return new w(new y.$et(E.offset1,b.offset1),new y.$et(E.offset2,b.offset2))}constructor(E,b){this.seq1Range=E,this.seq2Range=b}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(E){return new w(this.seq1Range.join(E.seq1Range),this.seq2Range.join(E.seq2Range))}delta(E){return E===0?this:new w(this.seq1Range.delta(E),this.seq2Range.delta(E))}deltaStart(E){return E===0?this:new w(this.seq1Range.deltaStart(E),this.seq2Range.deltaStart(E))}deltaEnd(E){return E===0?this:new w(this.seq1Range.deltaEnd(E),this.seq2Range.deltaEnd(E))}intersectsOrTouches(E){return this.seq1Range.intersectsOrTouches(E.seq1Range)||this.seq2Range.intersectsOrTouches(E.seq2Range)}intersect(E){const b=this.seq1Range.intersect(E.seq1Range),m=this.seq2Range.intersect(E.seq2Range);if(!(!b||!m))return new w(b,m)}getStarts(){return new c(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new c(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}t.$h2=w;class c{static{this.zero=new c(0,0)}static{this.max=new c(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER)}constructor(E,b){this.offset1=E,this.offset2=b}toString(){return`${this.offset1} <-> ${this.offset2}`}delta(E){return E===0?this:new c(this.offset1+E,this.offset2+E)}equals(E){return this.offset1===E.offset1&&this.offset2===E.offset2}}t.$i2=c;class l{static{this.instance=new l}isValid(){return!0}}t.$j2=l;class u{constructor(E){if(this.e=E,this.c=Date.now(),this.d=!0,E<=0)throw new F.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}t.$k2=u}),te(ne[31],re([0,1,4,8]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p2=void 0;class y{compute(u,o,E=F.$j2.instance){if(u.length===0||o.length===0)return F.$g2.trivial(u,o);const b=u,m=o;function e(s,v){for(;s<b.length&&v<m.length&&b.getElement(s)===m.getElement(v);)s++,v++;return s}let L=0;const A=new w;A.set(0,e(0,0));const N=new c;N.set(0,A.get(0)===0?null:new h(null,0,0,A.get(0)));let $=0;e:for(;;){if(L++,!E.isValid())return F.$g2.trivialTimedOut(b,m);const s=-Math.min(L,m.length+L%2),v=Math.min(L,b.length+L%2);for($=s;$<=v;$+=2){let g=0;const k=$===v?-1:A.get($+1),p=$===s?-1:A.get($-1)+1;g++;const R=Math.min(Math.max(k,p),b.length),P=R-$;if(g++,R>b.length||P>m.length)continue;const D=e(R,P);A.set($,D);const M=R===k?N.get($+1):N.get($-1);if(N.set($,D!==R?new h(M,R,P,D-R):M),A.get($)===b.length&&A.get($)-$===m.length)break e}}let d=N.get($);const a=[];let f=b.length,n=m.length;for(;;){const s=d?d.x+d.length:0,v=d?d.y+d.length:0;if((s!==f||v!==n)&&a.push(new F.$h2(new i.$et(s,f),new i.$et(v,n))),!d)break;f=d.x,n=d.y,d=d.prev}return a.reverse(),new F.$g2(a,!1)}}t.$p2=y;class h{constructor(u,o,E,b){this.prev=u,this.x=o,this.y=E,this.length=b}}class w{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){if(u<0){if(u=-u-1,u>=this.b.length){const E=this.b;this.b=new Int32Array(E.length*2),this.b.set(E)}this.b[u]=o}else{if(u>=this.a.length){const E=this.a;this.a=new Int32Array(E.length*2),this.a.set(E)}this.a[u]=o}}}class c{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,o){u<0?(u=-u-1,this.b[u]=o):this.a[u]=o}}}),te(ne[47],re([0,1,6,4,8]),function(C,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$x2=t.$w2=t.$v2=t.$u2=t.$t2=void 0;function h(e,L,A){let N=A;return N=w(e,L,N),N=w(e,L,N),N=c(e,L,N),N}t.$t2=h;function w(e,L,A){if(A.length===0)return A;const N=[];N.push(A[0]);for(let d=1;d<A.length;d++){const a=N[N.length-1];let f=A[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=f.seq1Range.start-a.seq1Range.endExclusive;let s;for(s=1;s<=n&&!(e.getElement(f.seq1Range.start-s)!==e.getElement(f.seq1Range.endExclusive-s)||L.getElement(f.seq2Range.start-s)!==L.getElement(f.seq2Range.endExclusive-s));s++);if(s--,s===n){N[N.length-1]=new y.$h2(new F.$et(a.seq1Range.start,f.seq1Range.endExclusive-n),new F.$et(a.seq2Range.start,f.seq2Range.endExclusive-n));continue}f=f.delta(-s)}N.push(f)}const $=[];for(let d=0;d<N.length-1;d++){const a=N[d+1];let f=N[d];if(f.seq1Range.isEmpty||f.seq2Range.isEmpty){const n=a.seq1Range.start-f.seq1Range.endExclusive;let s;for(s=0;s<n&&!(!e.isStronglyEqual(f.seq1Range.start+s,f.seq1Range.endExclusive+s)||!L.isStronglyEqual(f.seq2Range.start+s,f.seq2Range.endExclusive+s));s++);if(s===n){N[d+1]=new y.$h2(new F.$et(f.seq1Range.start+n,a.seq1Range.endExclusive),new F.$et(f.seq2Range.start+n,a.seq2Range.endExclusive));continue}s>0&&(f=f.delta(s))}$.push(f)}return N.length>0&&$.push(N[N.length-1]),$}function c(e,L,A){if(!e.getBoundaryScore||!L.getBoundaryScore)return A;for(let N=0;N<A.length;N++){const $=N>0?A[N-1]:void 0,d=A[N],a=N+1<A.length?A[N+1]:void 0,f=new F.$et($?$.seq1Range.endExclusive+1:0,a?a.seq1Range.start-1:e.length),n=new F.$et($?$.seq2Range.endExclusive+1:0,a?a.seq2Range.start-1:L.length);d.seq1Range.isEmpty?A[N]=l(d,e,L,f,n):d.seq2Range.isEmpty&&(A[N]=l(d.swap(),L,e,n,f).swap())}return A}function l(e,L,A,N,$){let a=1;for(;e.seq1Range.start-a>=N.start&&e.seq2Range.start-a>=$.start&&A.isStronglyEqual(e.seq2Range.start-a,e.seq2Range.endExclusive-a)&&a<100;)a++;a--;let f=0;for(;e.seq1Range.start+f<N.endExclusive&&e.seq2Range.endExclusive+f<$.endExclusive&&A.isStronglyEqual(e.seq2Range.start+f,e.seq2Range.endExclusive+f)&&f<100;)f++;if(a===0&&f===0)return e;let n=0,s=-1;for(let v=-a;v<=f;v++){const g=e.seq2Range.start+v,k=e.seq2Range.endExclusive+v,p=e.seq1Range.start+v,R=L.getBoundaryScore(p)+A.getBoundaryScore(g)+A.getBoundaryScore(k);R>s&&(s=R,n=v)}return e.delta(n)}function u(e,L,A){const N=[];for(const $ of A){const d=N[N.length-1];if(!d){N.push($);continue}$.seq1Range.start-d.seq1Range.endExclusive<=2||$.seq2Range.start-d.seq2Range.endExclusive<=2?N[N.length-1]=new y.$h2(d.seq1Range.join($.seq1Range),d.seq2Range.join($.seq2Range)):N.push($)}return N}t.$u2=u;function o(e,L,A){const N=y.$h2.invert(A,e.length),$=[];let d=new y.$i2(0,0);function a(n,s){if(n.offset1<d.offset1||n.offset2<d.offset2)return;const v=e.findWordContaining(n.offset1),g=L.findWordContaining(n.offset2);if(!v||!g)return;let k=new y.$h2(v,g);const p=k.intersect(s);let R=p.seq1Range.length,P=p.seq2Range.length;for(;N.length>0;){const D=N[0];if(!(D.seq1Range.intersects(k.seq1Range)||D.seq2Range.intersects(k.seq2Range)))break;const I=e.findWordContaining(D.seq1Range.start),T=L.findWordContaining(D.seq2Range.start),O=new y.$h2(I,T),j=O.intersect(D);if(R+=j.seq1Range.length,P+=j.seq2Range.length,k=k.join(O),k.seq1Range.endExclusive>=D.seq1Range.endExclusive)N.shift();else break}R+P<(k.seq1Range.length+k.seq2Range.length)*2/3&&$.push(k),d=k.getEndExclusives()}for(;N.length>0;){const n=N.shift();n.seq1Range.isEmpty||(a(n.getStarts(),n),a(n.getEndExclusives().delta(-1),n))}return E(A,$)}t.$v2=o;function E(e,L){const A=[];for(;e.length>0||L.length>0;){const N=e[0],$=L[0];let d;N&&(!$||N.seq1Range.start<$.seq1Range.start)?d=e.shift():d=L.shift(),A.length>0&&A[A.length-1].seq1Range.endExclusive>=d.seq1Range.start?A[A.length-1]=A[A.length-1].join(d):A.push(d)}return A}function b(e,L,A){let N=A;if(N.length===0)return N;let $=0,d;do{d=!1;const a=[N[0]];for(let f=1;f<N.length;f++){let v=function(k,p){const R=new F.$et(s.seq1Range.endExclusive,n.seq1Range.start);return e.getText(R).replace(/\s/g,"").length<=4&&(k.seq1Range.length+k.seq2Range.length>5||p.seq1Range.length+p.seq2Range.length>5)};const n=N[f],s=a[a.length-1];v(s,n)?(d=!0,a[a.length-1]=a[a.length-1].join(n)):a.push(n)}N=a}while($++<10&&d);return N}t.$w2=b;function m(e,L,A){let N=A;if(N.length===0)return N;let $=0,d;do{d=!1;const f=[N[0]];for(let n=1;n<N.length;n++){let g=function(p,R){const P=new F.$et(v.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(P)>5||P.length>500)return!1;const M=e.getText(P).trim();if(M.length>20||M.split(/\r\n|\r|\n/).length>1)return!1;const I=e.countLinesIn(p.seq1Range),T=p.seq1Range.length,O=L.countLinesIn(p.seq2Range),j=p.seq2Range.length,G=e.countLinesIn(R.seq1Range),ee=R.seq1Range.length,S=L.countLinesIn(R.seq2Range),B=R.seq2Range.length,_=2*40+50;function Y(se){return Math.min(se,_)}return Math.pow(Math.pow(Y(I*40+T),1.5)+Math.pow(Y(O*40+j),1.5),1.5)+Math.pow(Math.pow(Y(G*40+ee),1.5)+Math.pow(Y(S*40+B),1.5),1.5)>(_**1.5)**1.5*1.3};const s=N[n],v=f[f.length-1];g(v,s)?(d=!0,f[f.length-1]=f[f.length-1].join(s)):f.push(s)}N=f}while($++<10&&d);const a=[];return(0,i.$Cb)(N,(f,n,s)=>{let v=n;function g(M){return M.length>0&&M.trim().length<=3&&n.seq1Range.length+n.seq2Range.length>100}const k=e.extendToFullLines(n.seq1Range),p=e.getText(new F.$et(k.start,n.seq1Range.start));g(p)&&(v=v.deltaStart(-p.length));const R=e.getText(new F.$et(n.seq1Range.endExclusive,k.endExclusive));g(R)&&(v=v.deltaEnd(R.length));const P=y.$h2.fromOffsetPairs(f?f.getEndExclusives():y.$i2.zero,s?s.getStarts():y.$i2.max),D=v.intersect(P);a.length>0&&D.getStarts().equals(a[a.length-1].getEndExclusives())?a[a.length-1]=a[a.length-1].join(D):a.push(D)}),a}t.$x2=m}),te(ne[48],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$s2=void 0;class i{constructor(h,w){this.a=h,this.b=w}getElement(h){return this.a[h]}get length(){return this.a.length}getBoundaryScore(h){const w=h===0?0:F(this.b[h-1]),c=h===this.b.length?0:F(this.b[h]);return 1e3-(w+c)}getText(h){return this.b.slice(h.start,h.endExclusive).join(`
`)}isStronglyEqual(h,w){return this.b[h]===this.b[w]}}t.$s2=i;function F(y){let h=0;for(;h<y.length&&(y.charCodeAt(h)===32||y.charCodeAt(h)===9);)h++;return h}}),te(ne[15],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$n2=t.$m2=t.$l2=void 0;class i{constructor(w,c){this.width=w,this.height=c,this.a=[],this.a=new Array(w*c)}get(w,c){return this.a[w+c*this.width]}set(w,c,l){this.a[w+c*this.width]=l}}t.$l2=i;function F(h){return h===32||h===9}t.$m2=F;class y{static{this.a=new Map}static b(w){let c=this.a.get(w);return c===void 0&&(c=this.a.size,this.a.set(w,c)),c}constructor(w,c,l){this.range=w,this.lines=c,this.source=l,this.d=[];let u=0;for(let o=w.startLineNumber-1;o<w.endLineNumberExclusive-1;o++){const E=c[o];for(let m=0;m<E.length;m++){u++;const e=E[m],L=y.b(e);this.d[L]=(this.d[L]||0)+1}u++;const b=y.b(`
`);this.d[b]=(this.d[b]||0)+1}this.c=u}computeSimilarity(w){let c=0;const l=Math.max(this.d.length,w.d.length);for(let u=0;u<l;u++)c+=Math.abs((this.d[u]??0)-(w.d[u]??0));return 1-c/(this.c+w.c)}}t.$n2=y}),te(ne[49],re([0,1,4,8,15]),function(C,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$o2=void 0;class h{compute(c,l,u=F.$j2.instance,o){if(c.length===0||l.length===0)return F.$g2.trivial(c,l);const E=new y.$l2(c.length,l.length),b=new y.$l2(c.length,l.length),m=new y.$l2(c.length,l.length);for(let a=0;a<c.length;a++)for(let f=0;f<l.length;f++){if(!u.isValid())return F.$g2.trivialTimedOut(c,l);const n=a===0?0:E.get(a-1,f),s=f===0?0:E.get(a,f-1);let v;c.getElement(a)===l.getElement(f)?(a===0||f===0?v=0:v=E.get(a-1,f-1),a>0&&f>0&&b.get(a-1,f-1)===3&&(v+=m.get(a-1,f-1)),v+=o?o(a,f):1):v=-1;const g=Math.max(n,s,v);if(g===v){const k=a>0&&f>0?m.get(a-1,f-1):0;m.set(a,f,k+1),b.set(a,f,3)}else g===n?(m.set(a,f,0),b.set(a,f,1)):g===s&&(m.set(a,f,0),b.set(a,f,2));E.set(a,f,g)}const e=[];let L=c.length,A=l.length;function N(a,f){(a+1!==L||f+1!==A)&&e.push(new F.$h2(new i.$et(a+1,L),new i.$et(f+1,A))),L=a,A=f}let $=c.length-1,d=l.length-1;for(;$>=0&&d>=0;)b.get($,d)===3?(N($,d),$--,d--):b.get($,d)===1?$--:d--;return N(-1,-1),e.reverse(),new F.$g2(e,!1)}}t.$o2=h}),te(ne[32],re([0,1,9,4,5,2,15]),function(C,t,i,F,y,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q2=void 0;class c{constructor(e,L,A){this.lines=e,this.considerWhitespaceChanges=A,this.b=[],this.c=[],this.d=[];let N=!1;L.start>0&&L.endExclusive>=e.length&&(L=new F.$et(L.start-1,L.endExclusive),N=!0),this.lineRange=L,this.c[0]=0;for(let $=this.lineRange.start;$<this.lineRange.endExclusive;$++){let d=e[$],a=0;if(N)a=d.length,d="",N=!1;else if(!A){const f=d.trimStart();a=d.length-f.length,d=f.trimEnd()}this.d.push(a);for(let f=0;f<d.length;f++)this.b.push(d.charCodeAt(f));$<e.length-1&&(this.b.push(10),this.c[$-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new F.$et(0,this.length))}getText(e){return this.b.slice(e.start,e.endExclusive).map(L=>String.fromCharCode(L)).join("")}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const L=b(e>0?this.b[e-1]:-1),A=b(e<this.b.length?this.b[e]:-1);if(L===7&&A===8)return 0;if(L===8)return 150;let N=0;return L!==A&&(N+=10,L===0&&A===1&&(N+=1)),N+=E(L),N+=E(A),N}translateOffset(e){if(this.lineRange.isEmpty)return new y.$9s(this.lineRange.start+1,1);const L=(0,i.$ib)(this.c,A=>A<=e);return new y.$9s(this.lineRange.start+L+1,e-this.c[L]+this.d[L]+1)}translateRange(e){return h.$0s.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}findWordContaining(e){if(e<0||e>=this.b.length||!l(this.b[e]))return;let L=e;for(;L>0&&l(this.b[L-1]);)L--;let A=e;for(;A<this.b.length&&l(this.b[A]);)A++;return new F.$et(L,A)}countLinesIn(e){return this.translateOffset(e.endExclusive).lineNumber-this.translateOffset(e.start).lineNumber}isStronglyEqual(e,L){return this.b[e]===this.b[L]}extendToFullLines(e){const L=(0,i.$hb)(this.c,N=>N<=e.start)??0,A=(0,i.$jb)(this.c,N=>e.endExclusive<=N)??this.b.length;return new F.$et(L,A)}}t.$q2=c;function l(m){return m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57}var u;(function(m){m[m.WordLower=0]="WordLower",m[m.WordUpper=1]="WordUpper",m[m.WordNumber=2]="WordNumber",m[m.End=3]="End",m[m.Other=4]="Other",m[m.Separator=5]="Separator",m[m.Space=6]="Space",m[m.LineBreakCR=7]="LineBreakCR",m[m.LineBreakLF=8]="LineBreakLF"})(u||(u={}));const o={0:0,1:0,2:0,3:10,4:2,5:30,6:3,7:10,8:10};function E(m){return o[m]}function b(m){return m===10?8:m===13?7:(0,w.$m2)(m)?6:m>=97&&m<=122?0:m>=65&&m<=90?1:m>=48&&m<=57?2:m===-1?3:m===44||m===59?5:4}}),te(ne[33],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mt=t.$lt=void 0;class i{constructor(h,w,c){this.changes=h,this.moves=w,this.hitTimeout=c}}t.$lt=i;class F{constructor(h,w){this.lineRangeMapping=h,this.changes=w}flip(){return new F(this.lineRangeMapping.flip(),this.changes.map(h=>h.flip()))}}t.$mt=F}),te(ne[16],re([0,1,12]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kt=t.$jt=t.$it=void 0;class F{static inverse(c,l,u){const o=[];let E=1,b=1;for(const e of c){const L=new F(new i.$gt(E,e.original.startLineNumber),new i.$gt(b,e.modified.startLineNumber));L.modified.isEmpty||o.push(L),E=e.original.endLineNumberExclusive,b=e.modified.endLineNumberExclusive}const m=new F(new i.$gt(E,l+1),new i.$gt(b,u+1));return m.modified.isEmpty||o.push(m),o}static clip(c,l,u){const o=[];for(const E of c){const b=E.original.intersect(l),m=E.modified.intersect(u);b&&!b.isEmpty&&m&&!m.isEmpty&&o.push(new F(b,m))}return o}constructor(c,l){this.original=c,this.modified=l}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new F(this.modified,this.original)}join(c){return new F(this.original.join(c.original),this.modified.join(c.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}}t.$it=F;class y extends F{constructor(c,l,u){super(c,l),this.innerChanges=u}flip(){return new y(this.modified,this.original,this.innerChanges?.map(c=>c.flip()))}}t.$jt=y;class h{constructor(c,l){this.originalRange=c,this.modifiedRange=l}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new h(this.modifiedRange,this.originalRange)}}t.$kt=h}),te(ne[50],re([0,1,8,16,6,9,22,12,4,32,15,31]),function(C,t,i,F,y,h,w,c,l,u,o,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$r2=void 0;function b(d,a,f,n,s,v){let{moves:g,excludedChanges:k}=e(d,a,f,v);if(!v.isValid())return[];const p=d.filter(P=>!k.has(P)),R=L(p,n,s,a,f,v);return(0,y.$1b)(g,R),g=N(g),g=g.filter(P=>{const D=P.original.toOffsetRange().slice(a).map(I=>I.trim());return D.join(`
`).length>=15&&m(D,I=>I.length>=2)>=2}),g=$(d,g),g}t.$r2=b;function m(d,a){let f=0;for(const n of d)a(n)&&f++;return f}function e(d,a,f,n){const s=[],v=d.filter(p=>p.modified.isEmpty&&p.original.length>=3).map(p=>new o.$n2(p.original,a,p)),g=new Set(d.filter(p=>p.original.isEmpty&&p.modified.length>=3).map(p=>new o.$n2(p.modified,f,p))),k=new Set;for(const p of v){let R=-1,P;for(const D of g){const M=p.computeSimilarity(D);M>R&&(R=M,P=D)}if(R>.9&&P&&(g.delete(P),s.push(new F.$it(p.range,P.range)),k.add(p.source),k.add(P.source)),!n.isValid())return{moves:s,excludedChanges:k}}return{moves:s,excludedChanges:k}}function L(d,a,f,n,s,v){const g=[],k=new w.$Gc;for(const M of d)for(let I=M.original.startLineNumber;I<M.original.endLineNumberExclusive-2;I++){const T=`${a[I-1]}:${a[I+1-1]}:${a[I+2-1]}`;k.add(T,{range:new c.$gt(I,I+3)})}const p=[];d.sort((0,y.$7b)(M=>M.modified.startLineNumber,y.$9b));for(const M of d){let I=[];for(let T=M.modified.startLineNumber;T<M.modified.endLineNumberExclusive-2;T++){const O=`${f[T-1]}:${f[T+1-1]}:${f[T+2-1]}`,j=new c.$gt(T,T+3),G=[];k.forEach(O,({range:ee})=>{for(const B of I)if(B.originalLineRange.endLineNumberExclusive+1===ee.endLineNumberExclusive&&B.modifiedLineRange.endLineNumberExclusive+1===j.endLineNumberExclusive){B.originalLineRange=new c.$gt(B.originalLineRange.startLineNumber,ee.endLineNumberExclusive),B.modifiedLineRange=new c.$gt(B.modifiedLineRange.startLineNumber,j.endLineNumberExclusive),G.push(B);return}const S={modifiedLineRange:j,originalLineRange:ee};p.push(S),G.push(S)}),I=G}if(!v.isValid())return[]}p.sort((0,y.$$b)((0,y.$7b)(M=>M.modifiedLineRange.length,y.$9b)));const R=new c.$ht,P=new c.$ht;for(const M of p){const I=M.modifiedLineRange.startLineNumber-M.originalLineRange.startLineNumber,T=R.subtractFrom(M.modifiedLineRange),O=P.subtractFrom(M.originalLineRange).getWithDelta(I),j=T.getIntersection(O);for(const G of j.ranges){if(G.length<3)continue;const ee=G,S=G.delta(-I);g.push(new F.$it(S,ee)),R.addRange(ee),P.addRange(S)}}g.sort((0,y.$7b)(M=>M.original.startLineNumber,y.$9b));const D=new h.$mb(d);for(let M=0;M<g.length;M++){const I=g[M],T=D.findLastMonotonous(Y=>Y.original.startLineNumber<=I.original.startLineNumber),O=(0,h.$hb)(d,Y=>Y.modified.startLineNumber<=I.modified.startLineNumber),j=Math.max(I.original.startLineNumber-T.original.startLineNumber,I.modified.startLineNumber-O.modified.startLineNumber),G=D.findLastMonotonous(Y=>Y.original.startLineNumber<I.original.endLineNumberExclusive),ee=(0,h.$hb)(d,Y=>Y.modified.startLineNumber<I.modified.endLineNumberExclusive),S=Math.max(G.original.endLineNumberExclusive-I.original.endLineNumberExclusive,ee.modified.endLineNumberExclusive-I.modified.endLineNumberExclusive);let B;for(B=0;B<j;B++){const Y=I.original.startLineNumber-B-1,se=I.modified.startLineNumber-B-1;if(Y>n.length||se>s.length||R.contains(se)||P.contains(Y)||!A(n[Y-1],s[se-1],v))break}B>0&&(P.addRange(new c.$gt(I.original.startLineNumber-B,I.original.startLineNumber)),R.addRange(new c.$gt(I.modified.startLineNumber-B,I.modified.startLineNumber)));let _;for(_=0;_<S;_++){const Y=I.original.endLineNumberExclusive+_,se=I.modified.endLineNumberExclusive+_;if(Y>n.length||se>s.length||R.contains(se)||P.contains(Y)||!A(n[Y-1],s[se-1],v))break}_>0&&(P.addRange(new c.$gt(I.original.endLineNumberExclusive,I.original.endLineNumberExclusive+_)),R.addRange(new c.$gt(I.modified.endLineNumberExclusive,I.modified.endLineNumberExclusive+_))),(B>0||_>0)&&(g[M]=new F.$it(new c.$gt(I.original.startLineNumber-B,I.original.endLineNumberExclusive+_),new c.$gt(I.modified.startLineNumber-B,I.modified.endLineNumberExclusive+_)))}return g}function A(d,a,f){if(d.trim()===a.trim())return!0;if(d.length>300&&a.length>300)return!1;const s=new E.$p2().compute(new u.$q2([d],new l.$et(0,1),!1),new u.$q2([a],new l.$et(0,1),!1),f);let v=0;const g=i.$h2.invert(s.diffs,d.length);for(const P of g)P.seq1Range.forEach(D=>{(0,o.$m2)(d.charCodeAt(D))||v++});function k(P){let D=0;for(let M=0;M<d.length;M++)(0,o.$m2)(P.charCodeAt(M))||D++;return D}const p=k(d.length>a.length?d:a);return v/p>.6&&p>10}function N(d){if(d.length===0)return d;d.sort((0,y.$7b)(f=>f.original.startLineNumber,y.$9b));const a=[d[0]];for(let f=1;f<d.length;f++){const n=a[a.length-1],s=d[f],v=s.original.startLineNumber-n.original.endLineNumberExclusive,g=s.modified.startLineNumber-n.modified.endLineNumberExclusive;if(v>=0&&g>=0&&v+g<=2){a[a.length-1]=n.join(s);continue}a.push(s)}return a}function $(d,a){const f=new h.$mb(d);return a=a.filter(n=>{const s=f.findLastMonotonous(k=>k.original.startLineNumber<n.original.endLineNumberExclusive)||new F.$it(new c.$gt(1,1),new c.$gt(1,1)),v=(0,h.$hb)(d,k=>k.modified.startLineNumber<n.modified.endLineNumberExclusive);return s!==v}),a}}),te(ne[51],re([0,1,6,13,12,4,2,8,49,31,50,47,48,32,33,16]),function(C,t,i,F,y,h,w,c,l,u,o,E,b,m,e,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A2=t.$z2=t.$y2=void 0;class A{constructor(){this.e=new l.$o2,this.f=new u.$p2}computeDiff(a,f,n){if(a.length<=1&&(0,i.$ub)(a,f,(_,Y)=>_===Y))return new e.$lt([],[],!1);if(a.length===1&&a[0].length===0||f.length===1&&f[0].length===0)return new e.$lt([new L.$jt(new y.$gt(1,a.length+1),new y.$gt(1,f.length+1),[new L.$kt(new w.$0s(1,1,a.length,a[0].length+1),new w.$0s(1,1,f.length,f[0].length+1))])],[],!1);const s=n.maxComputationTimeMs===0?c.$j2.instance:new c.$k2(n.maxComputationTimeMs),v=!n.ignoreTrimWhitespace,g=new Map;function k(_){let Y=g.get(_);return Y===void 0&&(Y=g.size,g.set(_,Y)),Y}const p=a.map(_=>k(_.trim())),R=f.map(_=>k(_.trim())),P=new b.$s2(p,a),D=new b.$s2(R,f),M=P.length+D.length<1700?this.e.compute(P,D,s,(_,Y)=>a[_]===f[Y]?f[Y].length===0?.1:1+Math.log(1+f[Y].length):.99):this.f.compute(P,D);let I=M.diffs,T=M.hitTimeout;I=(0,E.$t2)(P,D,I),I=(0,E.$w2)(P,D,I);const O=[],j=_=>{if(v)for(let Y=0;Y<_;Y++){const se=G+Y,ae=ee+Y;if(a[se]!==f[ae]){const r=this.j(a,f,new c.$h2(new h.$et(se,se+1),new h.$et(ae,ae+1)),s,v);for(const ge of r.mappings)O.push(ge);r.hitTimeout&&(T=!0)}}};let G=0,ee=0;for(const _ of I){(0,F.$_c)(()=>_.seq1Range.start-G===_.seq2Range.start-ee);const Y=_.seq1Range.start-G;j(Y),G=_.seq1Range.endExclusive,ee=_.seq2Range.endExclusive;const se=this.j(a,f,_,s,v);se.hitTimeout&&(T=!0);for(const ae of se.mappings)O.push(ae)}j(a.length-G);const S=N(O,a,f);let B=[];return n.computeMoves&&(B=this.h(S,a,f,p,R,s,v)),(0,F.$_c)(()=>{function _(se,ae){if(se.lineNumber<1||se.lineNumber>ae.length)return!1;const r=ae[se.lineNumber-1];return!(se.column<1||se.column>r.length+1)}function Y(se,ae){return!(se.startLineNumber<1||se.startLineNumber>ae.length+1||se.endLineNumberExclusive<1||se.endLineNumberExclusive>ae.length+1)}for(const se of S){if(!se.innerChanges)return!1;for(const ae of se.innerChanges)if(!(_(ae.modifiedRange.getStartPosition(),f)&&_(ae.modifiedRange.getEndPosition(),f)&&_(ae.originalRange.getStartPosition(),a)&&_(ae.originalRange.getEndPosition(),a)))return!1;if(!Y(se.modified,f)||!Y(se.original,a))return!1}return!0}),new e.$lt(S,B,T)}h(a,f,n,s,v,g,k){return(0,o.$r2)(a,f,n,s,v,g).map(P=>{const D=this.j(f,n,new c.$h2(P.original.toOffsetRange(),P.modified.toOffsetRange()),g,k),M=N(D.mappings,f,n,!0);return new e.$mt(P,M)})}j(a,f,n,s,v){const g=new m.$q2(a,n.seq1Range,v),k=new m.$q2(f,n.seq2Range,v),p=g.length+k.length<500?this.e.compute(g,k,s):this.f.compute(g,k,s);let R=p.diffs;return R=(0,E.$t2)(g,k,R),R=(0,E.$v2)(g,k,R),R=(0,E.$u2)(g,k,R),R=(0,E.$x2)(g,k,R),{mappings:R.map(D=>new L.$kt(g.translateRange(D.seq1Range),k.translateRange(D.seq2Range))),hitTimeout:p.hitTimeout}}}t.$y2=A;function N(d,a,f,n=!1){const s=[];for(const v of(0,i.$Ab)(d.map(g=>$(g,a,f)),(g,k)=>g.original.overlapOrTouch(k.original)||g.modified.overlapOrTouch(k.modified))){const g=v[0],k=v[v.length-1];s.push(new L.$jt(g.original.join(k.original),g.modified.join(k.modified),v.map(p=>p.innerChanges[0])))}return(0,F.$_c)(()=>!n&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||f.length-s[s.length-1].modified.endLineNumberExclusive!==a.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,F.$ad)(s,(v,g)=>g.original.startLineNumber-v.original.endLineNumberExclusive===g.modified.startLineNumber-v.modified.endLineNumberExclusive&&v.original.endLineNumberExclusive<g.original.startLineNumber&&v.modified.endLineNumberExclusive<g.modified.startLineNumber)),s}t.$z2=N;function $(d,a,f){let n=0,s=0;d.modifiedRange.endColumn===1&&d.originalRange.endColumn===1&&d.originalRange.startLineNumber+n<=d.originalRange.endLineNumber&&d.modifiedRange.startLineNumber+n<=d.modifiedRange.endLineNumber&&(s=-1),d.modifiedRange.startColumn-1>=f[d.modifiedRange.startLineNumber-1].length&&d.originalRange.startColumn-1>=a[d.originalRange.startLineNumber-1].length&&d.originalRange.startLineNumber<=d.originalRange.endLineNumber+s&&d.modifiedRange.startLineNumber<=d.modifiedRange.endLineNumber+s&&(n=1);const v=new y.$gt(d.originalRange.startLineNumber+n,d.originalRange.endLineNumber+1+s),g=new y.$gt(d.modifiedRange.startLineNumber+n,d.modifiedRange.endLineNumber+1+s);return new L.$jt(v,g,[d])}t.$A2=$}),te(ne[34],re([0,1,25,33,16,7,2,13,12]),function(C,t,i,F,y,h,w,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ot=t.$nt=void 0;const u=3;class o{computeDiff(n,s,v){const k=new N(n,s,{maxComputationTime:v.maxComputationTimeMs,shouldIgnoreTrimWhitespace:v.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),p=[];let R=null;for(const P of k.changes){let D;P.originalEndLineNumber===0?D=new l.$gt(P.originalStartLineNumber+1,P.originalStartLineNumber+1):D=new l.$gt(P.originalStartLineNumber,P.originalEndLineNumber+1);let M;P.modifiedEndLineNumber===0?M=new l.$gt(P.modifiedStartLineNumber+1,P.modifiedStartLineNumber+1):M=new l.$gt(P.modifiedStartLineNumber,P.modifiedEndLineNumber+1);let I=new y.$jt(D,M,P.charChanges?.map(T=>new y.$kt(new w.$0s(T.originalStartLineNumber,T.originalStartColumn,T.originalEndLineNumber,T.originalEndColumn),new w.$0s(T.modifiedStartLineNumber,T.modifiedStartColumn,T.modifiedEndLineNumber,T.modifiedEndColumn))));R&&(R.modified.endLineNumberExclusive===I.modified.startLineNumber||R.original.endLineNumberExclusive===I.original.startLineNumber)&&(I=new y.$jt(R.original.join(I.original),R.modified.join(I.modified),R.innerChanges&&I.innerChanges?R.innerChanges.concat(I.innerChanges):void 0),p.pop()),p.push(I),R=I}return(0,c.$_c)(()=>(0,c.$ad)(p,(P,D)=>D.original.startLineNumber-P.original.endLineNumberExclusive===D.modified.startLineNumber-P.modified.endLineNumberExclusive&&P.original.endLineNumberExclusive<D.original.startLineNumber&&P.modified.endLineNumberExclusive<D.modified.startLineNumber)),new F.$lt(p,[],k.quitEarly)}}t.$nt=o;function E(f,n,s,v){return new i.$dt(f,n,s).ComputeDiff(v)}class b{constructor(n){const s=[],v=[];for(let g=0,k=n.length;g<k;g++)s[g]=$(n[g],1),v[g]=d(n[g],1);this.lines=n,this.a=s,this.b=v}getElements(){const n=[];for(let s=0,v=this.lines.length;s<v;s++)n[s]=this.lines[s].substring(this.a[s]-1,this.b[s]-1);return n}getStrictElement(n){return this.lines[n]}getStartLineNumber(n){return n+1}getEndLineNumber(n){return n+1}createCharSequence(n,s,v){const g=[],k=[],p=[];let R=0;for(let P=s;P<=v;P++){const D=this.lines[P],M=n?this.a[P]:1,I=n?this.b[P]:D.length+1;for(let T=M;T<I;T++)g[R]=D.charCodeAt(T-1),k[R]=P+1,p[R]=T,R++;!n&&P<v&&(g[R]=10,k[R]=P+1,p[R]=D.length+1,R++)}return new m(g,k,p)}}class m{constructor(n,s,v){this.a=n,this.b=s,this.d=v}toString(){return"["+this.a.map((n,s)=>(n===10?"\\n":String.fromCharCode(n))+`-(${this.b[s]},${this.d[s]})`).join(", ")+"]"}e(n,s){if(n<0||n>=s.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(n){return n>0&&n===this.b.length?this.getEndLineNumber(n-1):(this.e(n,this.b),this.b[n])}getEndLineNumber(n){return n===-1?this.getStartLineNumber(n+1):(this.e(n,this.b),this.a[n]===10?this.b[n]+1:this.b[n])}getStartColumn(n){return n>0&&n===this.d.length?this.getEndColumn(n-1):(this.e(n,this.d),this.d[n])}getEndColumn(n){return n===-1?this.getStartColumn(n+1):(this.e(n,this.d),this.a[n]===10?1:this.d[n]+1)}}class e{constructor(n,s,v,g,k,p,R,P){this.originalStartLineNumber=n,this.originalStartColumn=s,this.originalEndLineNumber=v,this.originalEndColumn=g,this.modifiedStartLineNumber=k,this.modifiedStartColumn=p,this.modifiedEndLineNumber=R,this.modifiedEndColumn=P}static createFromDiffChange(n,s,v){const g=s.getStartLineNumber(n.originalStart),k=s.getStartColumn(n.originalStart),p=s.getEndLineNumber(n.originalStart+n.originalLength-1),R=s.getEndColumn(n.originalStart+n.originalLength-1),P=v.getStartLineNumber(n.modifiedStart),D=v.getStartColumn(n.modifiedStart),M=v.getEndLineNumber(n.modifiedStart+n.modifiedLength-1),I=v.getEndColumn(n.modifiedStart+n.modifiedLength-1);return new e(g,k,p,R,P,D,M,I)}}function L(f){if(f.length<=1)return f;const n=[f[0]];let s=n[0];for(let v=1,g=f.length;v<g;v++){const k=f[v],p=k.originalStart-(s.originalStart+s.originalLength),R=k.modifiedStart-(s.modifiedStart+s.modifiedLength);Math.min(p,R)<u?(s.originalLength=k.originalStart+k.originalLength-s.originalStart,s.modifiedLength=k.modifiedStart+k.modifiedLength-s.modifiedStart):(n.push(k),s=k)}return n}class A{constructor(n,s,v,g,k){this.originalStartLineNumber=n,this.originalEndLineNumber=s,this.modifiedStartLineNumber=v,this.modifiedEndLineNumber=g,this.charChanges=k}static createFromDiffResult(n,s,v,g,k,p,R){let P,D,M,I,T;if(s.originalLength===0?(P=v.getStartLineNumber(s.originalStart)-1,D=0):(P=v.getStartLineNumber(s.originalStart),D=v.getEndLineNumber(s.originalStart+s.originalLength-1)),s.modifiedLength===0?(M=g.getStartLineNumber(s.modifiedStart)-1,I=0):(M=g.getStartLineNumber(s.modifiedStart),I=g.getEndLineNumber(s.modifiedStart+s.modifiedLength-1)),p&&s.originalLength>0&&s.originalLength<20&&s.modifiedLength>0&&s.modifiedLength<20&&k()){const O=v.createCharSequence(n,s.originalStart,s.originalStart+s.originalLength-1),j=g.createCharSequence(n,s.modifiedStart,s.modifiedStart+s.modifiedLength-1);if(O.getElements().length>0&&j.getElements().length>0){let G=E(O,j,k,!0).changes;R&&(G=L(G)),T=[];for(let ee=0,S=G.length;ee<S;ee++)T.push(e.createFromDiffChange(G[ee],O,j))}}return new A(P,D,M,I,T)}}class N{constructor(n,s,v){this.a=v.shouldComputeCharChanges,this.b=v.shouldPostProcessCharChanges,this.d=v.shouldIgnoreTrimWhitespace,this.e=v.shouldMakePrettyDiff,this.f=n,this.g=s,this.h=new b(n),this.j=new b(s),this.k=a(v.maxComputationTime),this.l=a(v.maxComputationTime===0?0:Math.min(v.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const n=E(this.h,this.j,this.k,this.e),s=n.changes,v=n.quitEarly;if(this.d){const R=[];for(let P=0,D=s.length;P<D;P++)R.push(A.createFromDiffResult(this.d,s[P],this.h,this.j,this.l,this.a,this.b));return{quitEarly:v,changes:R}}const g=[];let k=0,p=0;for(let R=-1,P=s.length;R<P;R++){const D=R+1<P?s[R+1]:null,M=D?D.originalStart:this.f.length,I=D?D.modifiedStart:this.g.length;for(;k<M&&p<I;){const T=this.f[k],O=this.g[p];if(T!==O){{let j=$(T,1),G=$(O,1);for(;j>1&&G>1;){const ee=T.charCodeAt(j-2),S=O.charCodeAt(G-2);if(ee!==S)break;j--,G--}(j>1||G>1)&&this.m(g,k+1,1,j,p+1,1,G)}{let j=d(T,1),G=d(O,1);const ee=T.length+1,S=O.length+1;for(;j<ee&&G<S;){const B=T.charCodeAt(j-1),_=T.charCodeAt(G-1);if(B!==_)break;j++,G++}(j<ee||G<S)&&this.m(g,k+1,j,ee,p+1,G,S)}}k++,p++}D&&(g.push(A.createFromDiffResult(this.d,D,this.h,this.j,this.l,this.a,this.b)),k+=D.originalLength,p+=D.modifiedLength)}return{quitEarly:v,changes:g}}m(n,s,v,g,k,p,R){if(this.n(n,s,v,g,k,p,R))return;let P;this.a&&(P=[new e(s,v,s,g,k,p,k,R)]),n.push(new A(s,s,k,k,P))}n(n,s,v,g,k,p,R){const P=n.length;if(P===0)return!1;const D=n[P-1];return D.originalEndLineNumber===0||D.modifiedEndLineNumber===0?!1:D.originalEndLineNumber===s&&D.modifiedEndLineNumber===k?(this.a&&D.charChanges&&D.charChanges.push(new e(s,v,s,g,k,p,k,R)),!0):D.originalEndLineNumber+1===s&&D.modifiedEndLineNumber+1===k?(D.originalEndLineNumber=s,D.modifiedEndLineNumber=k,this.a&&D.charChanges&&D.charChanges.push(new e(s,v,s,g,k,p,k,R)),!0):!1}}t.$ot=N;function $(f,n){const s=h.$_e(f);return s===-1?n:s+1}function d(f,n){const s=h.$bf(f);return s===-1?n:s+2}function a(f){if(f===0)return()=>!0;const n=Date.now();return()=>Date.now()-n<f}}),te(ne[52],re([0,1,34,51]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$B2=void 0,t.$B2={getLegacy:()=>new i.$nt,getDefault:()=>new F.$y2}}),te(ne[53],re([0,1,36]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$C2=void 0;function F(b){const m=[];for(const e of b){const L=Number(e);(L||L===0&&e.replace(/\s/g,"")!=="")&&m.push(L)}return m}function y(b,m,e,L){return{red:b/255,blue:e/255,green:m/255,alpha:L}}function h(b,m){const e=m.index,L=m[0].length;if(!e)return;const A=b.positionAt(e);return{startLineNumber:A.lineNumber,startColumn:A.column,endLineNumber:A.lineNumber,endColumn:A.column+L}}function w(b,m){if(!b)return;const e=i.$Bt.Format.CSS.parseHex(m);if(e)return{range:b,color:y(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function c(b,m,e){if(!b||m.length!==1)return;const A=m[0].values(),N=F(A);return{range:b,color:y(N[0],N[1],N[2],e?N[3]:1)}}function l(b,m,e){if(!b||m.length!==1)return;const A=m[0].values(),N=F(A),$=new i.$Bt(new i.$zt(N[0],N[1]/100,N[2]/100,e?N[3]:1));return{range:b,color:y($.rgba.r,$.rgba.g,$.rgba.b,$.rgba.a)}}function u(b,m){return typeof b=="string"?[...b.matchAll(m)]:b.findMatches(m)}function o(b){const m=[],L=u(b,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(L.length>0)for(const A of L){const N=A.filter(f=>f!==void 0),$=N[1],d=N[2];if(!d)continue;let a;if($==="rgb"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;a=c(h(b,A),u(d,f),!1)}else if($==="rgba"){const f=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=c(h(b,A),u(d,f),!0)}else if($==="hsl"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;a=l(h(b,A),u(d,f),!1)}else if($==="hsla"){const f=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;a=l(h(b,A),u(d,f),!0)}else $==="#"&&(a=w(h(b,A),$+d));a&&m.push(a)}return m}function E(b){return!b||typeof b.getValue!="function"||typeof b.positionAt!="function"?[]:o(b)}t.$C2=E}),te(ne[54],re([0,1,29]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c2=t.$b2=t.$a2=t.State=void 0;var F;(function(m){m[m.Invalid=0]="Invalid",m[m.Start=1]="Start",m[m.H=2]="H",m[m.HT=3]="HT",m[m.HTT=4]="HTT",m[m.HTTP=5]="HTTP",m[m.F=6]="F",m[m.FI=7]="FI",m[m.FIL=8]="FIL",m[m.BeforeColon=9]="BeforeColon",m[m.AfterColon=10]="AfterColon",m[m.AlmostThere=11]="AlmostThere",m[m.End=12]="End",m[m.Accept=13]="Accept",m[m.LastKnownState=14]="LastKnownState"})(F||(t.State=F={}));class y{constructor(e,L,A){const N=new Uint8Array(e*L);for(let $=0,d=e*L;$<d;$++)N[$]=A;this.a=N,this.rows=e,this.cols=L}get(e,L){return this.a[e*this.cols+L]}set(e,L,A){this.a[e*this.cols+L]=A}}class h{constructor(e){let L=0,A=0;for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];f>L&&(L=f),a>A&&(A=a),n>A&&(A=n)}L++,A++;const N=new y(A,L,0);for(let $=0,d=e.length;$<d;$++){const[a,f,n]=e[$];N.set(a,f,n)}this.a=N,this.b=L}nextState(e,L){return L<0||L>=this.b?0:this.a.get(e,L)}}t.$a2=h;let w=null;function c(){return w===null&&(w=new h([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),w}var l;(function(m){m[m.None=0]="None",m[m.ForceTermination=1]="ForceTermination",m[m.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let u=null;function o(){if(u===null){u=new i.$ut(0);const m=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let L=0;L<m.length;L++)u.set(m.charCodeAt(L),1);const e=".,;:";for(let L=0;L<e.length;L++)u.set(e.charCodeAt(L),2)}return u}class E{static a(e,L,A,N,$){let d=$-1;do{const a=L.charCodeAt(d);if(e.get(a)!==2)break;d--}while(d>N);if(N>0){const a=L.charCodeAt(N-1),f=L.charCodeAt(d);(a===40&&f===41||a===91&&f===93||a===123&&f===125)&&d--}return{range:{startLineNumber:A,startColumn:N+1,endLineNumber:A,endColumn:d+2},url:L.substring(N,d+1)}}static computeLinks(e,L=c()){const A=o(),N=[];for(let $=1,d=e.getLineCount();$<=d;$++){const a=e.getLineContent($),f=a.length;let n=0,s=0,v=0,g=1,k=!1,p=!1,R=!1,P=!1;for(;n<f;){let D=!1;const M=a.charCodeAt(n);if(g===13){let I;switch(M){case 40:k=!0,I=0;break;case 41:I=k?0:1;break;case 91:R=!0,p=!0,I=0;break;case 93:R=!1,I=p?0:1;break;case 123:P=!0,I=0;break;case 125:I=P?0:1;break;case 39:case 34:case 96:v===M?I=1:v===39||v===34||v===96?I=0:I=1;break;case 42:I=v===42?1:0;break;case 124:I=v===124?1:0;break;case 32:I=R?0:1;break;default:I=A.get(M)}I===1&&(N.push(E.a(A,a,$,s,n)),D=!0)}else if(g===12){let I;M===91?(p=!0,I=0):I=A.get(M),I===1?D=!0:g=13}else g=L.nextState(g,M),g===0&&(D=!0);D&&(g=1,k=!1,p=!1,P=!1,s=n+1,v=M),n++}g===13&&N.push(E.a(A,a,$,s,f))}return N}}t.$b2=E;function b(m){return!m||typeof m.getLineCount!="function"||typeof m.getLineContent!="function"?[]:E.computeLinks(m)}t.$c2=b}),te(ne[55],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$d2=void 0;class i{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new i}navigateValueSet(y,h,w,c,l){if(y&&h){const u=this.a(h,l);if(u)return{range:y,value:u}}if(w&&c){const u=this.a(c,l);if(u)return{range:w,value:u}}return null}a(y,h){const w=this.b(y,h);return w!==null?w:this.d(y,h)}b(y,h){const w=Math.pow(10,y.length-(y.lastIndexOf(".")+1));let c=Number(y);const l=parseFloat(y);return!isNaN(c)&&!isNaN(l)&&c===l?c===0&&!h?null:(c=Math.floor(c*w),c+=h?w:-w,String(c/w)):null}d(y,h){return this.e(this.c,y,h)}e(y,h,w){let c=null;for(let l=0,u=y.length;c===null&&l<u;l++)c=this.f(y[l],h,w);return c}f(y,h,w){let c=y.indexOf(h);return c>=0?(c+=w?1:-1,c<0?c=y.length-1:c%=y.length,y[c]):null}}t.$d2=i}),te(ne[56],re([0,1,14]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vv=t.$uv=t.$tv=t.$sv=t.ModelConstants=t.PositionAffinity=t.$rv=t.TrackedRangeStickiness=t.$qv=t.$pv=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var F;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=4]="Right",a[a.Full=7]="Full"})(F||(t.OverviewRulerLane=F={}));var y;(function(a){a[a.Left=1]="Left",a[a.Center=2]="Center",a[a.Right=3]="Right"})(y||(t.GlyphMarginLane=y={}));var h;(function(a){a[a.Inline=1]="Inline",a[a.Gutter=2]="Gutter"})(h||(t.MinimapPosition=h={}));var w;(function(a){a[a.Both=0]="Both",a[a.Right=1]="Right",a[a.Left=2]="Left",a[a.None=3]="None"})(w||(t.InjectedTextCursorStops=w={}));var c;(function(a){a[a.TextDefined=0]="TextDefined",a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(c||(t.EndOfLinePreference=c={}));var l;(function(a){a[a.LF=1]="LF",a[a.CRLF=2]="CRLF"})(l||(t.DefaultEndOfLine=l={}));var u;(function(a){a[a.LF=0]="LF",a[a.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class o{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(f){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,f.tabSize|0),f.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,f.indentSize|0),this.a=!1),this.insertSpaces=!!f.insertSpaces,this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=!!f.trimAutoWhitespace,this.bracketPairColorizationOptions=f.bracketPairColorizationOptions}equals(f){return this.tabSize===f.tabSize&&this.a===f.a&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace&&(0,i.$Pn)(this.bracketPairColorizationOptions,f.bracketPairColorizationOptions)}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}t.$pv=o;class E{constructor(f,n){this._findMatchBrand=void 0,this.range=f,this.matches=n}}t.$qv=E;var b;(function(a){a[a.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",a[a.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",a[a.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",a[a.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(b||(t.TrackedRangeStickiness=b={}));function m(a){return a&&typeof a.read=="function"}t.$rv=m;var e;(function(a){a[a.Left=0]="Left",a[a.Right=1]="Right",a[a.None=2]="None",a[a.LeftOfInjectedText=3]="LeftOfInjectedText",a[a.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var L;(function(a){a[a.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(L||(t.ModelConstants=L={}));class A{constructor(f,n,s,v,g,k){this.identifier=f,this.range=n,this.text=s,this.forceMoveMarkers=v,this.isAutoWhitespaceEdit=g,this._isTracked=k}}t.$sv=A;class N{constructor(f,n,s){this.regex=f,this.wordSeparators=n,this.simpleSearch=s}}t.$tv=N;class ${constructor(f,n,s){this.reverseEdits=f,this.changes=n,this.trimAutoWhitespaceLineNumbers=s}}t.$uv=$;function d(a){return!a.isTooLargeForSyncing()&&!a.isForSimpleWidget}t.$vv=d}),te(ne[57],re([0,1,6,28]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Av=t.$zv=t.$yv=void 0;class y{constructor(l){this.a=l,this.b=new Uint32Array(l.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(l,u){l=(0,F.$Se)(l);const o=this.a,E=this.b,b=u.length;return b===0?!1:(this.a=new Uint32Array(o.length+b),this.a.set(o.subarray(0,l),0),this.a.set(o.subarray(l),l+b),this.a.set(u,l),l-1<this.c[0]&&(this.c[0]=l-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}setValue(l,u){return l=(0,F.$Se)(l),u=(0,F.$Se)(u),this.a[l]===u?!1:(this.a[l]=u,l-1<this.c[0]&&(this.c[0]=l-1),!0)}removeValues(l,u){l=(0,F.$Se)(l),u=(0,F.$Se)(u);const o=this.a,E=this.b;if(l>=o.length)return!1;const b=o.length-l;return u>=b&&(u=b),u===0?!1:(this.a=new Uint32Array(o.length-u),this.a.set(o.subarray(0,l),0),this.a.set(o.subarray(l+u),l),this.b=new Uint32Array(this.a.length),l-1<this.c[0]&&(this.c[0]=l-1),this.c[0]>=0&&this.b.set(E.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(l){return l<0?0:(l=(0,F.$Se)(l),this.d(l))}d(l){if(l<=this.c[0])return this.b[l];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),l>=this.a.length&&(l=this.a.length-1);for(let o=u;o<=l;o++)this.b[o]=this.b[o-1]+this.a[o];return this.c[0]=Math.max(this.c[0],l),this.b[l]}getIndexOf(l){l=Math.floor(l),this.getTotalSum();let u=0,o=this.a.length-1,E=0,b=0,m=0;for(;u<=o;)if(E=u+(o-u)/2|0,b=this.b[E],m=b-this.a[E],l<m)o=E-1;else if(l>=b)u=E+1;else break;return new w(E,l-m)}}t.$yv=y;class h{constructor(l){this.a=l,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(l){return this.g(),l===0?0:this.d[l-1]}getIndexOf(l){this.g();const u=this.e[l],o=u>0?this.d[u-1]:0;return new w(u,l-o)}removeValues(l,u){this.a.splice(l,u),this.f(l)}insertValues(l,u){this.a=(0,i.$Wb)(this.a,l,u),this.f(l)}f(l){this.b=!1,this.c=Math.min(this.c,l-1)}g(){if(!this.b){for(let l=this.c+1,u=this.a.length;l<u;l++){const o=this.a[l],E=l>0?this.d[l-1]:0;this.d[l]=E+o;for(let b=0;b<o;b++)this.e[E+b]=l}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(l,u){this.a[l]!==u&&(this.a[l]=u,this.f(l))}}t.$zv=h;class w{constructor(l,u){this.index=l,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=l,this.remainder=u}}t.$Av=w}),te(ne[58],re([0,1,7,5,57]),function(C,t,i,F,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bv=void 0;class h{constructor(c,l,u,o){this.d=c,this.f=l,this.g=u,this.h=o,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(c){c.eol&&c.eol!==this.g&&(this.g=c.eol,this.j=null);const l=c.changes;for(const u of l)this.o(u.range),this.p(new F.$9s(u.range.startLineNumber,u.range.startColumn),u.text);this.h=c.versionId,this.k=null}l(){if(!this.j){const c=this.g.length,l=this.f.length,u=new Uint32Array(l);for(let o=0;o<l;o++)u[o]=this.f[o].length+c;this.j=new y.$yv(u)}}n(c,l){this.f[c]=l,this.j&&this.j.setValue(c,this.f[c].length+this.g.length)}o(c){if(c.startLineNumber===c.endLineNumber){if(c.startColumn===c.endColumn)return;this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.startLineNumber-1].substring(c.endColumn-1));return}this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.endLineNumber-1].substring(c.endColumn-1)),this.f.splice(c.startLineNumber,c.endLineNumber-c.startLineNumber),this.j&&this.j.removeValues(c.startLineNumber,c.endLineNumber-c.startLineNumber)}p(c,l){if(l.length===0)return;const u=(0,i.$0e)(l);if(u.length===1){this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]+this.f[c.lineNumber-1].substring(c.column-1));return}u[u.length-1]+=this.f[c.lineNumber-1].substring(c.column-1),this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]);const o=new Uint32Array(u.length-1);for(let E=1;E<u.length;E++)this.f.splice(c.lineNumber+E-1,0,u[E]),o[E-1]=u[E].length+this.g.length;this.j&&this.j.insertValues(c.lineNumber,o)}}t.$Bv=h}),te(ne[59],re([0,1,7,46,5,2,56]),function(C,t,i,F,y,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lC=t.$kC=t.$jC=t.$iC=t.$hC=t.$gC=void 0;const c=999;class l{constructor($,d,a,f){this.searchString=$,this.isRegex=d,this.matchCase=a,this.wordSeparators=f}parseSearchRequest(){if(this.searchString==="")return null;let $;this.isRegex?$=u(this.searchString):$=this.searchString.indexOf(`
`)>=0;let d=null;try{d=i.$8e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:$,global:!0,unicode:!0})}catch{return null}if(!d)return null;let a=!this.isRegex&&!$;return a&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(a=this.matchCase),new w.$tv(d,this.wordSeparators?(0,F.$xt)(this.wordSeparators):null,a?this.searchString:null)}}t.$gC=l;function u(N){if(!N||N.length===0)return!1;for(let $=0,d=N.length;$<d;$++){const a=N.charCodeAt($);if(a===10)return!0;if(a===92){if($++,$>=d)break;const f=N.charCodeAt($);if(f===110||f===114||f===87)return!0}}return!1}t.$hC=u;function o(N,$,d){if(!d)return new w.$qv(N,null);const a=[];for(let f=0,n=$.length;f<n;f++)a[f]=$[f];return new w.$qv(N,a)}t.$iC=o;class E{constructor($){const d=[];let a=0;for(let f=0,n=$.length;f<n;f++)$.charCodeAt(f)===10&&(d[a++]=f);this.a=d}findLineFeedCountBeforeOffset($){const d=this.a;let a=0,f=d.length-1;if(f===-1||$<=d[0])return 0;for(;a<f;){const n=a+((f-a)/2>>0);d[n]>=$?f=n-1:d[n+1]>=$?(a=n,f=n):a=n+1}return a+1}}class b{static findMatches($,d,a,f,n){const s=d.parseSearchRequest();return s?s.regex.multiline?this.b($,a,new A(s.wordSeparators,s.regex),f,n):this.c($,a,s,f,n):[]}static a($,d,a,f,n,s){let v,g=0;f?(g=f.findLineFeedCountBeforeOffset(n),v=d+n+g):v=d+n;let k;if(f){const D=f.findLineFeedCountBeforeOffset(n+s.length)-g;k=v+s.length+D}else k=v+s.length;const p=$.getPositionAt(v),R=$.getPositionAt(k);return new h.$0s(p.lineNumber,p.column,R.lineNumber,R.column)}static b($,d,a,f,n){const s=$.getOffsetAt(d.getStartPosition()),v=$.getValueInRange(d,1),g=$.getEOL()===`\r
`?new E(v):null,k=[];let p=0,R;for(a.reset(0);R=a.next(v);)if(k[p++]=o(this.a($,s,v,g,R.index,R[0]),R,f),p>=n)return k;return k}static c($,d,a,f,n){const s=[];let v=0;if(d.startLineNumber===d.endLineNumber){const k=$.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return v=this.d(a,k,d.startLineNumber,d.startColumn-1,v,s,f,n),s}const g=$.getLineContent(d.startLineNumber).substring(d.startColumn-1);v=this.d(a,g,d.startLineNumber,d.startColumn-1,v,s,f,n);for(let k=d.startLineNumber+1;k<d.endLineNumber&&v<n;k++)v=this.d(a,$.getLineContent(k),k,0,v,s,f,n);if(v<n){const k=$.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);v=this.d(a,k,d.endLineNumber,0,v,s,f,n)}return s}static d($,d,a,f,n,s,v,g){const k=$.wordSeparators;if(!v&&$.simpleSearch){const P=$.simpleSearch,D=P.length,M=d.length;let I=-D;for(;(I=d.indexOf(P,I+D))!==-1;)if((!k||L(k,d,M,I,D))&&(s[n++]=new w.$qv(new h.$0s(a,I+1+f,a,I+1+D+f),null),n>=g))return n;return n}const p=new A($.wordSeparators,$.regex);let R;p.reset(0);do if(R=p.next(d),R&&(s[n++]=o(new h.$0s(a,R.index+1+f,a,R.index+1+R[0].length+f),R,v),n>=g))return n;while(R);return n}static findNextMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new A(n.wordSeparators,n.regex);return n.regex.multiline?this.e($,a,s,f):this.f($,a,s,f)}static e($,d,a,f){const n=new y.$9s(d.lineNumber,1),s=$.getOffsetAt(n),v=$.getLineCount(),g=$.getValueInRange(new h.$0s(n.lineNumber,n.column,v,$.getLineMaxColumn(v)),1),k=$.getEOL()===`\r
`?new E(g):null;a.reset(d.column-1);const p=a.next(g);return p?o(this.a($,s,g,k,p.index,p[0]),p,f):d.lineNumber!==1||d.column!==1?this.e($,new y.$9s(1,1),a,f):null}static f($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,v=$.getLineContent(s),g=this.g(a,v,s,d.column,f);if(g)return g;for(let k=1;k<=n;k++){const p=(s+k-1)%n,R=$.getLineContent(p+1),P=this.g(a,R,p+1,1,f);if(P)return P}return null}static g($,d,a,f,n){$.reset(f-1);const s=$.next(d);return s?o(new h.$0s(a,s.index+1,a,s.index+1+s[0].length),s,n):null}static findPreviousMatch($,d,a,f){const n=d.parseSearchRequest();if(!n)return null;const s=new A(n.wordSeparators,n.regex);return n.regex.multiline?this.h($,a,s,f):this.j($,a,s,f)}static h($,d,a,f){const n=this.b($,new h.$0s(1,1,d.lineNumber,d.column),a,f,10*c);if(n.length>0)return n[n.length-1];const s=$.getLineCount();return d.lineNumber!==s||d.column!==$.getLineMaxColumn(s)?this.h($,new y.$9s(s,$.getLineMaxColumn(s)),a,f):null}static j($,d,a,f){const n=$.getLineCount(),s=d.lineNumber,v=$.getLineContent(s).substring(0,d.column-1),g=this.k(a,v,s,f);if(g)return g;for(let k=1;k<=n;k++){const p=(n+s-k-1)%n,R=$.getLineContent(p+1),P=this.k(a,R,p+1,f);if(P)return P}return null}static k($,d,a,f){let n=null,s;for($.reset(0);s=$.next(d);)n=o(new h.$0s(a,s.index+1,a,s.index+1+s[0].length),s,f);return n}}t.$jC=b;function m(N,$,d,a,f){if(a===0)return!0;const n=$.charCodeAt(a-1);if(N.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a);if(N.get(s)!==0)return!0}return!1}function e(N,$,d,a,f){if(a+f===d)return!0;const n=$.charCodeAt(a+f);if(N.get(n)!==0||n===13||n===10)return!0;if(f>0){const s=$.charCodeAt(a+f-1);if(N.get(s)!==0)return!0}return!1}function L(N,$,d,a,f){return m(N,$,d,a,f)&&e(N,$,d,a,f)}t.$kC=L;class A{constructor($,d){this._wordSeparators=$,this.a=d,this.b=-1,this.c=0}reset($){this.a.lastIndex=$,this.b=-1,this.c=0}next($){const d=$.length;let a;do{if(this.b+this.c===d||(a=this.a.exec($),!a))return null;const f=a.index,n=a[0].length;if(f===this.b&&n===this.c){if(n===0){i.$rf($,d,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=f,this.c=n,!this._wordSeparators||L(this._wordSeparators,$,d,f,n))return a}while(a);return null}}t.$lC=A}),te(ne[60],re([0,1,2,59,7,13,30]),function(C,t,i,F,y,h,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$_1=void 0;class c{static computeUnicodeHighlights(e,L,A){const N=A?A.startLineNumber:1,$=A?A.endLineNumber:e.getLineCount(),d=new o(L),a=d.getCandidateCodePoints();let f;a==="allNonBasicAscii"?f=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):f=new RegExp(`${l(Array.from(a))}`,"g");const n=new F.$lC(null,f),s=[];let v=!1,g,k=0,p=0,R=0;e:for(let P=N,D=$;P<=D;P++){const M=e.getLineContent(P),I=M.length;n.reset(0);do if(g=n.next(M),g){let T=g.index,O=g.index+g[0].length;if(T>0){const S=M.charCodeAt(T-1);y.$of(S)&&T--}if(O+1<I){const S=M.charCodeAt(O-1);y.$of(S)&&O++}const j=M.substring(T,O);let G=(0,w.$Ms)(T+1,w.$Js,M,0);G&&G.endColumn<=T+1&&(G=null);const ee=d.shouldHighlightNonBasicASCII(j,G?G.word:null);if(ee!==0){if(ee===3?k++:ee===2?p++:ee===1?R++:(0,h.$9c)(ee),s.length>=1e3){v=!0;break e}s.push(new i.$0s(P,T+1,P,O+1))}}while(g)}return{ranges:s,hasMore:v,ambiguousCharacterCount:k,invisibleCharacterCount:p,nonBasicAsciiCharacterCount:R}}static computeUnicodeHighlightReason(e,L){const A=new o(L);switch(A.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const $=e.codePointAt(0),d=A.ambiguousCharacters.getPrimaryConfusable($),a=y.$Rf.getLocales().filter(f=>!y.$Rf.getInstance(new Set([...L.allowedLocales,f])).isAmbiguous($));return{kind:0,confusableWith:String.fromCodePoint(d),notAmbiguousInLocales:a}}case 1:return{kind:2}}}}t.$_1=c;function l(m,e){return`[${y.$Ye(m.map(A=>String.fromCodePoint(A)).join(""))}]`}var u;(function(m){m[m.Ambiguous=0]="Ambiguous",m[m.Invisible=1]="Invisible",m[m.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class o{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=y.$Rf.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const L of y.$Sf.codePoints)E(String.fromCodePoint(L))||e.add(L);if(this.b.ambiguousCharacters)for(const L of this.ambiguousCharacters.getConfusableCodePoints())e.add(L);for(const L of this.a)e.delete(L);return e}shouldHighlightNonBasicASCII(e,L){const A=e.codePointAt(0);if(this.a.has(A))return 0;if(this.b.nonBasicASCII)return 1;let N=!1,$=!1;if(L)for(const d of L){const a=d.codePointAt(0),f=y.$zf(d);N=N||f,!f&&!this.ambiguousCharacters.isAmbiguous(a)&&!y.$Sf.isInvisibleCharacter(a)&&($=!0)}return!N&&$?0:this.b.invisibleCharacters&&!E(e)&&y.$Sf.isInvisibleCharacter(A)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(A)?3:0}}function E(m){return m===" "||m===`
`||m==="	"}var b;(function(m){m[m.None=0]="None",m[m.NonBasicASCII=1]="NonBasicASCII",m[m.Invisible=2]="Invisible",m[m.Ambiguous=3]="Ambiguous"})(b||(b={}))}),te(ne[61],re([0,1]),function(C,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.ShowLightbulbIconMode=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.NewSymbolNameTag=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineEditTriggerKind=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var i;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(i||(t.AccessibilitySupport=i={}));var F;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(F||(t.CodeActionTriggerType=F={}));var y;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(y||(t.CompletionItemInsertTextRule=y={}));var h;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(h||(t.CompletionItemKind=h={}));var w;(function(r){r[r.Deprecated=1]="Deprecated"})(w||(t.CompletionItemTag=w={}));var c;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(t.CompletionTriggerKind=c={}));var l;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(l||(t.ContentWidgetPositionPreference=l={}));var u;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var o;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(o||(t.DefaultEndOfLine=o={}));var E;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})(E||(t.DocumentHighlightKind=E={}));var b;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(b||(t.EditorAutoIndentStrategy=b={}));var m;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSeparators=130]="wordSeparators",r[r.wordWrap=131]="wordWrap",r[r.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=134]="wordWrapColumn",r[r.wordWrapOverride1=135]="wordWrapOverride1",r[r.wordWrapOverride2=136]="wordWrapOverride2",r[r.wrappingIndent=137]="wrappingIndent",r[r.wrappingStrategy=138]="wrappingStrategy",r[r.showDeprecated=139]="showDeprecated",r[r.inlayHints=140]="inlayHints",r[r.editorClassName=141]="editorClassName",r[r.pixelRatio=142]="pixelRatio",r[r.tabFocusMode=143]="tabFocusMode",r[r.layoutInfo=144]="layoutInfo",r[r.wrappingInfo=145]="wrappingInfo",r[r.defaultColorDecorators=146]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(m||(t.EditorOption=m={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var L;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(L||(t.EndOfLineSequence=L={}));var A;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(A||(t.GlyphMarginLane=A={}));var N;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(N||(t.IndentAction=N={}));var $;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})($||(t.InjectedTextCursorStops=$={}));var d;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(d||(t.InlayHintKind=d={}));var a;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(a||(t.InlineCompletionTriggerKind=a={}));var f;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(f||(t.InlineEditTriggerKind=f={}));var n;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var s;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(s||(t.MarkerSeverity=s={}));var v;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(v||(t.MarkerTag=v={}));var g;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(g||(t.MinimapPosition=g={}));var k;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(k||(t.MouseTargetType=k={}));var p;(function(r){r[r.AIGenerated=1]="AIGenerated"})(p||(t.NewSymbolNameTag=p={}));var R;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(R||(t.OverlayWidgetPositionPreference=R={}));var P;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(P||(t.OverviewRulerLane=P={}));var D;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(D||(t.PositionAffinity=D={}));var M;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(M||(t.RenderLineNumbersType=M={}));var I;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(I||(t.RenderMinimap=I={}));var T;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(T||(t.ScrollType=T={}));var O;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(O||(t.ScrollbarVisibility=O={}));var j;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(j||(t.SelectionDirection=j={}));var G;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(G||(t.ShowLightbulbIconMode=G={}));var ee;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(ee||(t.SignatureHelpTriggerKind=ee={}));var S;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(S||(t.SymbolKind=S={}));var B;(function(r){r[r.Deprecated=1]="Deprecated"})(B||(t.SymbolTag=B={}));var _;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(_||(t.TextEditorCursorBlinkingStyle=_={}));var Y;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(Y||(t.TextEditorCursorStyle=Y={}));var se;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(se||(t.TrackedRangeStickiness=se={}));var ae;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(ae||(t.WrappingIndent=ae={}))}),te(ne[62],re([0,1,11,10]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$It=void 0;class y{constructor(){this.a=new Map,this.b=new Map,this.c=new i.$6d,this.onDidChange=this.c.event,this.d=null}handleChange(c){this.c.fire({changedLanguages:c,changedColorMap:!1})}register(c,l){return this.a.set(c,l),this.handleChange([c]),(0,F.$Rc)(()=>{this.a.get(c)===l&&(this.a.delete(c),this.handleChange([c]))})}get(c){return this.a.get(c)||null}registerFactory(c,l){this.b.get(c)?.dispose();const u=new h(this,c,l);return this.b.set(c,u),(0,F.$Rc)(()=>{const o=this.b.get(c);!o||o!==u||(this.b.delete(c),o.dispose())})}async getOrCreate(c){const l=this.get(c);if(l)return l;const u=this.b.get(c);return!u||u.isResolved?null:(await u.resolve(),this.get(c))}isResolved(c){if(this.get(c))return!0;const u=this.b.get(c);return!!(!u||u.isResolved)}setColorMap(c){this.d=c,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$It=y;class h extends F.$Tc{get isResolved(){return this.c}constructor(c,l,u){super(),this.f=c,this.g=l,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const c=await this.h.tokenizationSupport;this.c=!0,c&&!this.a&&this.B(this.f.register(this.g,c))}}}),te(ne[63],re([64,65]),function(C,t){return C.create("vs/base/common/platform",t)}),te(ne[17],re([0,1,63]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let F=!1,y=!1,h=!1,w=!1,c=!1,l=!1,u=!1,o=!1,E=!1,b=!1,m,e=t.$g,L=t.$g,A,N;const $=globalThis;let d;typeof $.vscode<"u"&&typeof $.vscode.process<"u"?d=$.vscode.process:typeof process<"u"&&(d=process);const a=typeof d?.versions?.electron=="string",f=a&&d?.type==="renderer";if(typeof d=="object"){F=d.platform==="win32",y=d.platform==="darwin",h=d.platform==="linux",w=h&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=a,E=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=t.$g,e=t.$g;const M=d.env.VSCODE_NLS_CONFIG;if(M)try{const I=JSON.parse(M),T=I.availableLanguages["*"];m=I.locale,L=I.osLocale,e=T||t.$g,A=I._translationsConfigFile}catch{}c=!0}else typeof navigator=="object"&&!f?(N=navigator.userAgent,F=N.indexOf("Windows")>=0,y=N.indexOf("Macintosh")>=0,o=(N.indexOf("Macintosh")>=0||N.indexOf("iPad")>=0||N.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,h=N.indexOf("Linux")>=0,b=N?.indexOf("Mobi")>=0,l=!0,m=i.getConfiguredDefaultLocale(i.localize(0,null))||t.$g,e=m,L=navigator.language):console.error("Unable to resolve platform.");var n;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(n||(t.Platform=n={}));function s(M){switch(M){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=s;let v=0;y?v=1:F?v=3:h&&(v=2),t.$i=F,t.$j=y,t.$k=h,t.$l=w,t.$m=c,t.$n=u,t.$o=l,t.$p=l&&typeof $.importScripts=="function",t.$q=t.$p?$.origin:void 0,t.$r=o,t.$s=b,t.$t=E,t.$u=v,t.$v=N,t.$w=e;var g;(function(M){function I(){return t.$w}M.value=I;function T(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}M.isDefaultVariant=T;function O(){return t.$w==="en"}M.isDefault=O})(g||(t.Language=g={})),t.$x=m,t.$y=L,t.$z=A,t.$A=typeof $.postMessage=="function"&&!$.importScripts,t.$B=(()=>{if(t.$A){const M=[];$.addEventListener("message",T=>{if(T.data&&T.data.vscodeScheduleAsyncWork)for(let O=0,j=M.length;O<j;O++){const G=M[O];if(G.id===T.data.vscodeScheduleAsyncWork){M.splice(O,1),G.callback();return}}});let I=0;return T=>{const O=++I;M.push({id:O,callback:T}),$.postMessage({vscodeScheduleAsyncWork:O},"*")}}return M=>setTimeout(M)})();var k;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(k||(t.OperatingSystem=k={})),t.OS=y||o?2:F?1:3;let p=!0,R=!1;function P(){if(!R){R=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,p=new Uint16Array(M.buffer)[0]===513}return p}t.$D=P,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function D(M){return parseFloat(M)>=20}t.$J=D}),te(ne[66],re([0,1,17]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let F;const y=globalThis.vscode;if(typeof y<"u"&&typeof y.process<"u"){const h=y.process;F={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=F.cwd,t.env=F.env,t.$dc=F.platform,t.$ec=F.arch}),te(ne[67],re([0,1,66]),function(C,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const F=65,y=97,h=90,w=122,c=46,l=47,u=92,o=58,E=63;class b extends Error{constructor(s,v,g){let k;typeof v=="string"&&v.indexOf("not ")===0?(k="must not be",v=v.replace(/^not /,"")):k="must be";const p=s.indexOf(".")!==-1?"property":"argument";let R=`The "${s}" ${p} ${k} of type ${v}`;R+=`. Received type ${typeof g}`,super(R),this.code="ERR_INVALID_ARG_TYPE"}}function m(n,s){if(n===null||typeof n!="object")throw new b(s,"Object",n)}function e(n,s){if(typeof n!="string")throw new b(s,"string",n)}const L=i.$dc==="win32";function A(n){return n===l||n===u}function N(n){return n===l}function $(n){return n>=F&&n<=h||n>=y&&n<=w}function d(n,s,v,g){let k="",p=0,R=-1,P=0,D=0;for(let M=0;M<=n.length;++M){if(M<n.length)D=n.charCodeAt(M);else{if(g(D))break;D=l}if(g(D)){if(!(R===M-1||P===1))if(P===2){if(k.length<2||p!==2||k.charCodeAt(k.length-1)!==c||k.charCodeAt(k.length-2)!==c){if(k.length>2){const I=k.lastIndexOf(v);I===-1?(k="",p=0):(k=k.slice(0,I),p=k.length-1-k.lastIndexOf(v)),R=M,P=0;continue}else if(k.length!==0){k="",p=0,R=M,P=0;continue}}s&&(k+=k.length>0?`${v}..`:"..",p=2)}else k.length>0?k+=`${v}${n.slice(R+1,M)}`:k=n.slice(R+1,M),p=M-R-1;R=M,P=0}else D===c&&P!==-1?++P:P=-1}return k}function a(n,s){m(s,"pathObject");const v=s.dir||s.root,g=s.base||`${s.name||""}${s.ext||""}`;return v?v===s.root?`${v}${g}`:`${v}${n}${g}`:g}t.$fc={resolve(...n){let s="",v="",g=!1;for(let k=n.length-1;k>=-1;k--){let p;if(k>=0){if(p=n[k],e(p,"path"),p.length===0)continue}else s.length===0?p=i.cwd():(p=i.env[`=${s}`]||i.cwd(),(p===void 0||p.slice(0,2).toLowerCase()!==s.toLowerCase()&&p.charCodeAt(2)===u)&&(p=`${s}\\`));const R=p.length;let P=0,D="",M=!1;const I=p.charCodeAt(0);if(R===1)A(I)&&(P=1,M=!0);else if(A(I))if(M=!0,A(p.charCodeAt(1))){let T=2,O=T;for(;T<R&&!A(p.charCodeAt(T));)T++;if(T<R&&T!==O){const j=p.slice(O,T);for(O=T;T<R&&A(p.charCodeAt(T));)T++;if(T<R&&T!==O){for(O=T;T<R&&!A(p.charCodeAt(T));)T++;(T===R||T!==O)&&(D=`\\\\${j}\\${p.slice(O,T)}`,P=T)}}}else P=1;else $(I)&&p.charCodeAt(1)===o&&(D=p.slice(0,2),P=2,R>2&&A(p.charCodeAt(2))&&(M=!0,P=3));if(D.length>0)if(s.length>0){if(D.toLowerCase()!==s.toLowerCase())continue}else s=D;if(g){if(s.length>0)break}else if(v=`${p.slice(P)}\\${v}`,g=M,M&&s.length>0)break}return v=d(v,!g,"\\",A),g?`${s}\\${v}`:`${s}${v}`||"."},normalize(n){e(n,"path");const s=n.length;if(s===0)return".";let v=0,g,k=!1;const p=n.charCodeAt(0);if(s===1)return N(p)?"\\":n;if(A(p))if(k=!0,A(n.charCodeAt(1))){let P=2,D=P;for(;P<s&&!A(n.charCodeAt(P));)P++;if(P<s&&P!==D){const M=n.slice(D,P);for(D=P;P<s&&A(n.charCodeAt(P));)P++;if(P<s&&P!==D){for(D=P;P<s&&!A(n.charCodeAt(P));)P++;if(P===s)return`\\\\${M}\\${n.slice(D)}\\`;P!==D&&(g=`\\\\${M}\\${n.slice(D,P)}`,v=P)}}}else v=1;else $(p)&&n.charCodeAt(1)===o&&(g=n.slice(0,2),v=2,s>2&&A(n.charCodeAt(2))&&(k=!0,v=3));let R=v<s?d(n.slice(v),!k,"\\",A):"";return R.length===0&&!k&&(R="."),R.length>0&&A(n.charCodeAt(s-1))&&(R+="\\"),g===void 0?k?`\\${R}`:R:k?`${g}\\${R}`:`${g}${R}`},isAbsolute(n){e(n,"path");const s=n.length;if(s===0)return!1;const v=n.charCodeAt(0);return A(v)||s>2&&$(v)&&n.charCodeAt(1)===o&&A(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let s,v;for(let p=0;p<n.length;++p){const R=n[p];e(R,"path"),R.length>0&&(s===void 0?s=v=R:s+=`\\${R}`)}if(s===void 0)return".";let g=!0,k=0;if(typeof v=="string"&&A(v.charCodeAt(0))){++k;const p=v.length;p>1&&A(v.charCodeAt(1))&&(++k,p>2&&(A(v.charCodeAt(2))?++k:g=!1))}if(g){for(;k<s.length&&A(s.charCodeAt(k));)k++;k>=2&&(s=`\\${s.slice(k)}`)}return t.$fc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s)return"";const v=t.$fc.resolve(n),g=t.$fc.resolve(s);if(v===g||(n=v.toLowerCase(),s=g.toLowerCase(),n===s))return"";let k=0;for(;k<n.length&&n.charCodeAt(k)===u;)k++;let p=n.length;for(;p-1>k&&n.charCodeAt(p-1)===u;)p--;const R=p-k;let P=0;for(;P<s.length&&s.charCodeAt(P)===u;)P++;let D=s.length;for(;D-1>P&&s.charCodeAt(D-1)===u;)D--;const M=D-P,I=R<M?R:M;let T=-1,O=0;for(;O<I;O++){const G=n.charCodeAt(k+O);if(G!==s.charCodeAt(P+O))break;G===u&&(T=O)}if(O!==I){if(T===-1)return g}else{if(M>I){if(s.charCodeAt(P+O)===u)return g.slice(P+O+1);if(O===2)return g.slice(P+O)}R>I&&(n.charCodeAt(k+O)===u?T=O:O===2&&(T=3)),T===-1&&(T=0)}let j="";for(O=k+T+1;O<=p;++O)(O===p||n.charCodeAt(O)===u)&&(j+=j.length===0?"..":"\\..");return P+=T,j.length>0?`${j}${g.slice(P,D)}`:(g.charCodeAt(P)===u&&++P,g.slice(P,D))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const s=t.$fc.resolve(n);if(s.length<=2)return n;if(s.charCodeAt(0)===u){if(s.charCodeAt(1)===u){const v=s.charCodeAt(2);if(v!==E&&v!==c)return`\\\\?\\UNC\\${s.slice(2)}`}}else if($(s.charCodeAt(0))&&s.charCodeAt(1)===o&&s.charCodeAt(2)===u)return`\\\\?\\${s}`;return n},dirname(n){e(n,"path");const s=n.length;if(s===0)return".";let v=-1,g=0;const k=n.charCodeAt(0);if(s===1)return A(k)?n:".";if(A(k)){if(v=g=1,A(n.charCodeAt(1))){let P=2,D=P;for(;P<s&&!A(n.charCodeAt(P));)P++;if(P<s&&P!==D){for(D=P;P<s&&A(n.charCodeAt(P));)P++;if(P<s&&P!==D){for(D=P;P<s&&!A(n.charCodeAt(P));)P++;if(P===s)return n;P!==D&&(v=g=P+1)}}}}else $(k)&&n.charCodeAt(1)===o&&(v=s>2&&A(n.charCodeAt(2))?3:2,g=v);let p=-1,R=!0;for(let P=s-1;P>=g;--P)if(A(n.charCodeAt(P))){if(!R){p=P;break}}else R=!1;if(p===-1){if(v===-1)return".";p=v}return n.slice(0,p)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let v=0,g=-1,k=!0,p;if(n.length>=2&&$(n.charCodeAt(0))&&n.charCodeAt(1)===o&&(v=2),s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,P=-1;for(p=n.length-1;p>=v;--p){const D=n.charCodeAt(p);if(A(D)){if(!k){v=p+1;break}}else P===-1&&(k=!1,P=p+1),R>=0&&(D===s.charCodeAt(R)?--R===-1&&(g=p):(R=-1,g=P))}return v===g?g=P:g===-1&&(g=n.length),n.slice(v,g)}for(p=n.length-1;p>=v;--p)if(A(n.charCodeAt(p))){if(!k){v=p+1;break}}else g===-1&&(k=!1,g=p+1);return g===-1?"":n.slice(v,g)},extname(n){e(n,"path");let s=0,v=-1,g=0,k=-1,p=!0,R=0;n.length>=2&&n.charCodeAt(1)===o&&$(n.charCodeAt(0))&&(s=g=2);for(let P=n.length-1;P>=s;--P){const D=n.charCodeAt(P);if(A(D)){if(!p){g=P+1;break}continue}k===-1&&(p=!1,k=P+1),D===c?v===-1?v=P:R!==1&&(R=1):v!==-1&&(R=-1)}return v===-1||k===-1||R===0||R===1&&v===k-1&&v===g+1?"":n.slice(v,k)},format:a.bind(null,"\\"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const v=n.length;let g=0,k=n.charCodeAt(0);if(v===1)return A(k)?(s.root=s.dir=n,s):(s.base=s.name=n,s);if(A(k)){if(g=1,A(n.charCodeAt(1))){let T=2,O=T;for(;T<v&&!A(n.charCodeAt(T));)T++;if(T<v&&T!==O){for(O=T;T<v&&A(n.charCodeAt(T));)T++;if(T<v&&T!==O){for(O=T;T<v&&!A(n.charCodeAt(T));)T++;T===v?g=T:T!==O&&(g=T+1)}}}}else if($(k)&&n.charCodeAt(1)===o){if(v<=2)return s.root=s.dir=n,s;if(g=2,A(n.charCodeAt(2))){if(v===3)return s.root=s.dir=n,s;g=3}}g>0&&(s.root=n.slice(0,g));let p=-1,R=g,P=-1,D=!0,M=n.length-1,I=0;for(;M>=g;--M){if(k=n.charCodeAt(M),A(k)){if(!D){R=M+1;break}continue}P===-1&&(D=!1,P=M+1),k===c?p===-1?p=M:I!==1&&(I=1):p!==-1&&(I=-1)}return P!==-1&&(p===-1||I===0||I===1&&p===P-1&&p===R+1?s.base=s.name=n.slice(R,P):(s.name=n.slice(R,p),s.base=n.slice(R,P),s.ext=n.slice(p,P))),R>0&&R!==g?s.dir=n.slice(0,R-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const f=(()=>{if(L){const n=/\\/g;return()=>{const s=i.cwd().replace(n,"/");return s.slice(s.indexOf("/"))}}return()=>i.cwd()})();t.$gc={resolve(...n){let s="",v=!1;for(let g=n.length-1;g>=-1&&!v;g--){const k=g>=0?n[g]:f();e(k,"path"),k.length!==0&&(s=`${k}/${s}`,v=k.charCodeAt(0)===l)}return s=d(s,!v,"/",N),v?`/${s}`:s.length>0?s:"."},normalize(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l,v=n.charCodeAt(n.length-1)===l;return n=d(n,!s,"/",N),n.length===0?s?"/":v?"./":".":(v&&(n+="/"),s?`/${n}`:n)},isAbsolute(n){return e(n,"path"),n.length>0&&n.charCodeAt(0)===l},join(...n){if(n.length===0)return".";let s;for(let v=0;v<n.length;++v){const g=n[v];e(g,"path"),g.length>0&&(s===void 0?s=g:s+=`/${g}`)}return s===void 0?".":t.$gc.normalize(s)},relative(n,s){if(e(n,"from"),e(s,"to"),n===s||(n=t.$gc.resolve(n),s=t.$gc.resolve(s),n===s))return"";const v=1,g=n.length,k=g-v,p=1,R=s.length-p,P=k<R?k:R;let D=-1,M=0;for(;M<P;M++){const T=n.charCodeAt(v+M);if(T!==s.charCodeAt(p+M))break;T===l&&(D=M)}if(M===P)if(R>P){if(s.charCodeAt(p+M)===l)return s.slice(p+M+1);if(M===0)return s.slice(p+M)}else k>P&&(n.charCodeAt(v+M)===l?D=M:M===0&&(D=0));let I="";for(M=v+D+1;M<=g;++M)(M===g||n.charCodeAt(M)===l)&&(I+=I.length===0?"..":"/..");return`${I}${s.slice(p+D)}`},toNamespacedPath(n){return n},dirname(n){if(e(n,"path"),n.length===0)return".";const s=n.charCodeAt(0)===l;let v=-1,g=!0;for(let k=n.length-1;k>=1;--k)if(n.charCodeAt(k)===l){if(!g){v=k;break}}else g=!1;return v===-1?s?"/":".":s&&v===1?"//":n.slice(0,v)},basename(n,s){s!==void 0&&e(s,"ext"),e(n,"path");let v=0,g=-1,k=!0,p;if(s!==void 0&&s.length>0&&s.length<=n.length){if(s===n)return"";let R=s.length-1,P=-1;for(p=n.length-1;p>=0;--p){const D=n.charCodeAt(p);if(D===l){if(!k){v=p+1;break}}else P===-1&&(k=!1,P=p+1),R>=0&&(D===s.charCodeAt(R)?--R===-1&&(g=p):(R=-1,g=P))}return v===g?g=P:g===-1&&(g=n.length),n.slice(v,g)}for(p=n.length-1;p>=0;--p)if(n.charCodeAt(p)===l){if(!k){v=p+1;break}}else g===-1&&(k=!1,g=p+1);return g===-1?"":n.slice(v,g)},extname(n){e(n,"path");let s=-1,v=0,g=-1,k=!0,p=0;for(let R=n.length-1;R>=0;--R){const P=n.charCodeAt(R);if(P===l){if(!k){v=R+1;break}continue}g===-1&&(k=!1,g=R+1),P===c?s===-1?s=R:p!==1&&(p=1):s!==-1&&(p=-1)}return s===-1||g===-1||p===0||p===1&&s===g-1&&s===v+1?"":n.slice(s,g)},format:a.bind(null,"/"),parse(n){e(n,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return s;const v=n.charCodeAt(0)===l;let g;v?(s.root="/",g=1):g=0;let k=-1,p=0,R=-1,P=!0,D=n.length-1,M=0;for(;D>=g;--D){const I=n.charCodeAt(D);if(I===l){if(!P){p=D+1;break}continue}R===-1&&(P=!1,R=D+1),I===c?k===-1?k=D:M!==1&&(M=1):k!==-1&&(M=-1)}if(R!==-1){const I=p===0&&v?1:p;k===-1||M===0||M===1&&k===R-1&&k===p+1?s.base=s.name=n.slice(I,R):(s.name=n.slice(I,k),s.base=n.slice(I,R),s.ext=n.slice(k,R))}return p>0?s.dir=n.slice(0,p-1):v&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=L?t.$fc.normalize:t.$gc.normalize,t.$ic=L?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=L?t.$fc.join:t.$gc.join,t.$kc=L?t.$fc.resolve:t.$gc.resolve,t.$lc=L?t.$fc.relative:t.$gc.relative,t.$mc=L?t.$fc.dirname:t.$gc.dirname,t.$nc=L?t.$fc.basename:t.$gc.basename,t.$oc=L?t.$fc.extname:t.$gc.extname,t.$pc=L?t.$fc.format:t.$gc.format,t.$qc=L?t.$fc.parse:t.$gc.parse,t.$rc=L?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=L?t.$fc.sep:t.$gc.sep,t.$tc=L?t.$fc.delimiter:t.$gc.delimiter}),te(ne[18],re([0,1,67,17]),function(C,t,i,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const y=/^\w[\w\d+.-]*$/,h=/^\//,w=/^\/\//;function c(g,k){if(!g.scheme&&k)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!y.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!h.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function l(g,k){return!g&&!k?"file":g}function u(g,k){switch(g){case"https":case"http":case"file":k?k[0]!==E&&(k=E+k):k=E;break}return k}const o="",E="/",b=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(k){return k instanceof m?!0:k?typeof k.authority=="string"&&typeof k.fragment=="string"&&typeof k.path=="string"&&typeof k.query=="string"&&typeof k.scheme=="string"&&typeof k.fsPath=="string"&&typeof k.with=="function"&&typeof k.toString=="function":!1}constructor(k,p,R,P,D,M=!1){typeof k=="object"?(this.scheme=k.scheme||o,this.authority=k.authority||o,this.path=k.path||o,this.query=k.query||o,this.fragment=k.fragment||o):(this.scheme=l(k,M),this.authority=p||o,this.path=u(this.scheme,R||o),this.query=P||o,this.fragment=D||o,c(this,M))}get fsPath(){return a(this,!1)}with(k){if(!k)return this;let{scheme:p,authority:R,path:P,query:D,fragment:M}=k;return p===void 0?p=this.scheme:p===null&&(p=o),R===void 0?R=this.authority:R===null&&(R=o),P===void 0?P=this.path:P===null&&(P=o),D===void 0?D=this.query:D===null&&(D=o),M===void 0?M=this.fragment:M===null&&(M=o),p===this.scheme&&R===this.authority&&P===this.path&&D===this.query&&M===this.fragment?this:new A(p,R,P,D,M)}static parse(k,p=!1){const R=b.exec(k);return R?new A(R[2]||o,v(R[4]||o),v(R[5]||o),v(R[7]||o),v(R[9]||o),p):new A(o,o,o,o,o)}static file(k){let p=o;if(F.$i&&(k=k.replace(/\\/g,E)),k[0]===E&&k[1]===E){const R=k.indexOf(E,2);R===-1?(p=k.substring(2),k=E):(p=k.substring(2,R),k=k.substring(R)||E)}return new A("file",p,k,o,o)}static from(k,p){return new A(k.scheme,k.authority,k.path,k.query,k.fragment,p)}static joinPath(k,...p){if(!k.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let R;return F.$i&&k.scheme==="file"?R=m.file(i.$fc.join(a(k,!0),...p)).path:R=i.$gc.join(k.path,...p),k.with({path:R})}toString(k=!1){return f(this,k)}toJSON(){return this}static revive(k){if(k){if(k instanceof m)return k;{const p=new A(k);return p._formatted=k.external??null,p._fsPath=k._sep===L?k.fsPath??null:null,p}}else return k}}t.URI=m;function e(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}t.$vc=e;const L=F.$i?1:void 0;class A extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=a(this,!1)),this._fsPath}toString(k=!1){return k?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const k={$mid:1};return this._fsPath&&(k.fsPath=this._fsPath,k._sep=L),this._formatted&&(k.external=this._formatted),this.path&&(k.path=this.path),this.scheme&&(k.scheme=this.scheme),this.authority&&(k.authority=this.authority),this.query&&(k.query=this.query),this.fragment&&(k.fragment=this.fragment),k}}const N={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function $(g,k,p){let R,P=-1;for(let D=0;D<g.length;D++){const M=g.charCodeAt(D);if(M>=97&&M<=122||M>=65&&M<=90||M>=48&&M<=57||M===45||M===46||M===95||M===126||k&&M===47||p&&M===91||p&&M===93||p&&M===58)P!==-1&&(R+=encodeURIComponent(g.substring(P,D)),P=-1),R!==void 0&&(R+=g.charAt(D));else{R===void 0&&(R=g.substr(0,D));const I=N[M];I!==void 0?(P!==-1&&(R+=encodeURIComponent(g.substring(P,D)),P=-1),R+=I):P===-1&&(P=D)}}return P!==-1&&(R+=encodeURIComponent(g.substring(P))),R!==void 0?R:g}function d(g){let k;for(let p=0;p<g.length;p++){const R=g.charCodeAt(p);R===35||R===63?(k===void 0&&(k=g.substr(0,p)),k+=N[R]):k!==void 0&&(k+=g[p])}return k!==void 0?k:g}function a(g,k){let p;return g.authority&&g.path.length>1&&g.scheme==="file"?p=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?k?p=g.path.substr(1):p=g.path[1].toLowerCase()+g.path.substr(2):p=g.path,F.$i&&(p=p.replace(/\//g,"\\")),p}t.$wc=a;function f(g,k){const p=k?d:$;let R="",{scheme:P,authority:D,path:M,query:I,fragment:T}=g;if(P&&(R+=P,R+=":"),(D||P==="file")&&(R+=E,R+=E),D){let O=D.indexOf("@");if(O!==-1){const j=D.substr(0,O);D=D.substr(O+1),O=j.lastIndexOf(":"),O===-1?R+=p(j,!1,!1):(R+=p(j.substr(0,O),!1,!1),R+=":",R+=p(j.substr(O+1),!1,!0)),R+="@"}D=D.toLowerCase(),O=D.lastIndexOf(":"),O===-1?R+=p(D,!1,!0):(R+=p(D.substr(0,O),!1,!0),R+=D.substr(O))}if(M){if(M.length>=3&&M.charCodeAt(0)===47&&M.charCodeAt(2)===58){const O=M.charCodeAt(1);O>=65&&O<=90&&(M=`/${String.fromCharCode(O+32)}:${M.substr(3)}`)}else if(M.length>=2&&M.charCodeAt(1)===58){const O=M.charCodeAt(0);O>=65&&O<=90&&(M=`${String.fromCharCode(O+32)}:${M.substr(2)}`)}R+=p(M,!0,!1)}return I&&(R+="?",R+=p(I,!1,!1)),T&&(R+="#",R+=k?T:$(T,!1,!1)),R}function n(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+n(g.substr(3)):g}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(g){return g.match(s)?g.replace(s,k=>n(k)):g}}),te(ne[72],re([0,1,3,11,10,14,17,7]),function(C,t,i,F,y,h,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let u=!1;function o(v){w.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(v.message))}t.logOnceWebWorkerWarning=o;var E;(function(v){v[v.Request=0]="Request",v[v.Reply=1]="Reply",v[v.SubscribeEvent=2]="SubscribeEvent",v[v.Event=3]="Event",v[v.UnsubscribeEvent=4]="UnsubscribeEvent"})(E||(E={}));class b{constructor(g,k,p,R){this.vsWorker=g,this.req=k,this.method=p,this.args=R,this.type=0}}class m{constructor(g,k,p,R){this.vsWorker=g,this.seq=k,this.res=p,this.err=R,this.type=1}}class e{constructor(g,k,p,R){this.vsWorker=g,this.req=k,this.eventName=p,this.arg=R,this.type=2}}class L{constructor(g,k,p){this.vsWorker=g,this.req=k,this.event=p,this.type=3}}class A{constructor(g,k){this.vsWorker=g,this.req=k,this.type=4}}class N{constructor(g){this.a=-1,this.g=g,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(g){this.a=g}sendMessage(g,k){const p=String(++this.b);return new Promise((R,P)=>{this.c[p]={resolve:R,reject:P},this.o(new b(this.a,p,g,k))})}listen(g,k){let p=null;const R=new F.$6d({onWillAddFirstListener:()=>{p=String(++this.b),this.d.set(p,R),this.o(new e(this.a,p,g,k))},onDidRemoveLastListener:()=>{this.d.delete(p),this.o(new A(this.a,p)),p=null}});return R.event}handleMessage(g){!g||!g.vsWorker||this.a!==-1&&g.vsWorker!==this.a||this.h(g)}h(g){switch(g.type){case 1:return this.j(g);case 0:return this.k(g);case 2:return this.l(g);case 3:return this.m(g);case 4:return this.n(g)}}j(g){if(!this.c[g.seq]){console.warn("Got reply to unknown seq");return}const k=this.c[g.seq];if(delete this.c[g.seq],g.err){let p=g.err;g.err.$isError&&(p=new Error,p.name=g.err.name,p.message=g.err.message,p.stack=g.err.stack),k.reject(p);return}k.resolve(g.res)}k(g){const k=g.req;this.g.handleMessage(g.method,g.args).then(R=>{this.o(new m(this.a,k,R,void 0))},R=>{R.detail instanceof Error&&(R.detail=(0,i.$3)(R.detail)),this.o(new m(this.a,k,void 0,(0,i.$3)(R)))})}l(g){const k=g.req,p=this.g.handleEvent(g.eventName,g.arg)(R=>{this.o(new L(this.a,k,R))});this.f.set(k,p)}m(g){if(!this.d.has(g.req)){console.warn("Got event for unknown req");return}this.d.get(g.req).fire(g.event)}n(g){if(!this.f.has(g.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(g.req).dispose(),this.f.delete(g.req)}o(g){const k=[];if(g.type===0)for(let p=0;p<g.args.length;p++)g.args[p]instanceof ArrayBuffer&&k.push(g.args[p]);else g.type===1&&g.res instanceof ArrayBuffer&&k.push(g.res);this.g.sendMessage(g,k)}}class $ extends y.$Tc{constructor(g,k,p){super();let R=null;this.a=this.B(g.create("vs/base/common/worker/simpleWorker",O=>{this.c.handleMessage(O)},O=>{R?.(O)})),this.c=new N({sendMessage:(O,j)=>{this.a.postMessage(O,j)},handleMessage:(O,j)=>{if(typeof p[O]!="function")return Promise.reject(new Error("Missing method "+O+" on main thread host."));try{return Promise.resolve(p[O].apply(p,j))}catch(G){return Promise.reject(G)}},handleEvent:(O,j)=>{if(a(O)){const G=p[O].call(p,j);if(typeof G!="function")throw new Error(`Missing dynamic event ${O} on main thread host.`);return G}if(d(O)){const G=p[O];if(typeof G!="function")throw new Error(`Missing event ${O} on main thread host.`);return G}throw new Error(`Malformed event name ${O}`)}}),this.c.setWorkerId(this.a.getId());let P=null;const D=globalThis.require;typeof D<"u"&&typeof D.getConfig=="function"?P=D.getConfig():typeof globalThis.requirejs<"u"&&(P=globalThis.requirejs.s.contexts._.config);const M=(0,h.$Vn)(p);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(P)),k,M]);const I=(O,j)=>this.g(O,j),T=(O,j)=>this.c.listen(O,j);this.f=new Promise((O,j)=>{R=j,this.b.then(G=>{O(f(G,I,T))},G=>{j(G),this.h("Worker failed to load "+k,G)})})}getProxyObject(){return this.f}g(g,k){return new Promise((p,R)=>{this.b.then(()=>{this.c.sendMessage(g,k).then(p,R)},R)})}h(g,k){console.error(g),console.info(k)}}t.SimpleWorkerClient=$;function d(v){return v[0]==="o"&&v[1]==="n"&&c.$jf(v.charCodeAt(2))}function a(v){return/^onDynamic/.test(v)&&c.$jf(v.charCodeAt(9))}function f(v,g,k){const p=D=>function(){const M=Array.prototype.slice.call(arguments,0);return g(D,M)},R=D=>function(M){return k(D,M)},P={};for(const D of v){if(a(D)){P[D]=R(D);continue}if(d(D)){P[D]=k(D,void 0);continue}P[D]=p(D)}return P}class n{constructor(g,k){this.a=k,this.b=null,this.c=new N({sendMessage:(p,R)=>{g(p,R)},handleMessage:(p,R)=>this.d(p,R),handleEvent:(p,R)=>this.f(p,R)})}onmessage(g){this.c.handleMessage(g)}d(g,k){if(g===l)return this.g(k[0],k[1],k[2],k[3]);if(!this.b||typeof this.b[g]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+g));try{return Promise.resolve(this.b[g].apply(this.b,k))}catch(p){return Promise.reject(p)}}f(g,k){if(!this.b)throw new Error("Missing requestHandler");if(a(g)){const p=this.b[g].call(this.b,k);if(typeof p!="function")throw new Error(`Missing dynamic event ${g} on request handler.`);return p}if(d(g)){const p=this.b[g];if(typeof p!="function")throw new Error(`Missing event ${g} on request handler.`);return p}throw new Error(`Malformed event name ${g}`)}g(g,k,p,R){this.c.setWorkerId(g);const M=f(R,(I,T)=>this.c.sendMessage(I,T),(I,T)=>this.c.listen(I,T));return this.a?(this.b=this.a(M),Promise.resolve((0,h.$Vn)(this.b))):(k&&(typeof k.baseUrl<"u"&&delete k.baseUrl,typeof k.paths<"u"&&typeof k.paths.vs<"u"&&delete k.paths.vs,typeof k.trustedTypesPolicy<"u"&&delete k.trustedTypesPolicy,k.catchError=!0,globalThis.require.config(k)),new Promise((I,T)=>{(globalThis.require||C)([p],j=>{if(this.b=j.create(M),!this.b){T(new Error("No RequestHandler!"));return}I((0,h.$Vn)(this.b))},T)}))}}t.SimpleWorkerServer=n;function s(v){return new n(v,null)}t.create=s}),te(ne[68],re([64,65]),function(C,t){return C.create("vs/editor/common/languages",t)}),te(ne[69],re([0,1,43,18,44,2,62,68]),function(C,t,i,F,y,h,w,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InlineEditTriggerKind=t.ExternalUriOpenerPriority=t.$3t=t.$2t=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.NewSymbolNameTag=t.$1t=t.$Zt=t.SymbolKinds=t.SymbolTag=t.$Yt=t.$Xt=t.SymbolKind=t.$Wt=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$Vt=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$Ut=t.$Tt=t.$St=void 0;class l{constructor(B,_,Y){this.offset=B,this.type=_,this.language=Y,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$St=l;class u{constructor(B,_){this.tokens=B,this.endState=_,this._tokenizationResultBrand=void 0}}t.$Tt=u;class o{constructor(B,_){this.tokens=B,this.endState=_,this._encodedTokenizationResultBrand=void 0}}t.$Ut=o;var E;(function(S){S[S.Method=0]="Method",S[S.Function=1]="Function",S[S.Constructor=2]="Constructor",S[S.Field=3]="Field",S[S.Variable=4]="Variable",S[S.Class=5]="Class",S[S.Struct=6]="Struct",S[S.Interface=7]="Interface",S[S.Module=8]="Module",S[S.Property=9]="Property",S[S.Event=10]="Event",S[S.Operator=11]="Operator",S[S.Unit=12]="Unit",S[S.Value=13]="Value",S[S.Constant=14]="Constant",S[S.Enum=15]="Enum",S[S.EnumMember=16]="EnumMember",S[S.Keyword=17]="Keyword",S[S.Text=18]="Text",S[S.Color=19]="Color",S[S.File=20]="File",S[S.Reference=21]="Reference",S[S.Customcolor=22]="Customcolor",S[S.Folder=23]="Folder",S[S.TypeParameter=24]="TypeParameter",S[S.User=25]="User",S[S.Issue=26]="Issue",S[S.Snippet=27]="Snippet"})(E||(t.CompletionItemKind=E={}));var b;(function(S){const B=new Map;B.set(0,i.$pk.symbolMethod),B.set(1,i.$pk.symbolFunction),B.set(2,i.$pk.symbolConstructor),B.set(3,i.$pk.symbolField),B.set(4,i.$pk.symbolVariable),B.set(5,i.$pk.symbolClass),B.set(6,i.$pk.symbolStruct),B.set(7,i.$pk.symbolInterface),B.set(8,i.$pk.symbolModule),B.set(9,i.$pk.symbolProperty),B.set(10,i.$pk.symbolEvent),B.set(11,i.$pk.symbolOperator),B.set(12,i.$pk.symbolUnit),B.set(13,i.$pk.symbolValue),B.set(15,i.$pk.symbolEnum),B.set(14,i.$pk.symbolConstant),B.set(15,i.$pk.symbolEnum),B.set(16,i.$pk.symbolEnumMember),B.set(17,i.$pk.symbolKeyword),B.set(27,i.$pk.symbolSnippet),B.set(18,i.$pk.symbolText),B.set(19,i.$pk.symbolColor),B.set(20,i.$pk.symbolFile),B.set(21,i.$pk.symbolReference),B.set(22,i.$pk.symbolCustomColor),B.set(23,i.$pk.symbolFolder),B.set(24,i.$pk.symbolTypeParameter),B.set(25,i.$pk.account),B.set(26,i.$pk.issues);function _(ae){let r=B.get(ae);return r||(console.info("No codicon found for CompletionItemKind "+ae),r=i.$pk.symbolProperty),r}S.toIcon=_;const Y=new Map;Y.set("method",0),Y.set("function",1),Y.set("constructor",2),Y.set("field",3),Y.set("variable",4),Y.set("class",5),Y.set("struct",6),Y.set("interface",7),Y.set("module",8),Y.set("property",9),Y.set("event",10),Y.set("operator",11),Y.set("unit",12),Y.set("value",13),Y.set("constant",14),Y.set("enum",15),Y.set("enum-member",16),Y.set("enumMember",16),Y.set("keyword",17),Y.set("snippet",27),Y.set("text",18),Y.set("color",19),Y.set("file",20),Y.set("reference",21),Y.set("customcolor",22),Y.set("folder",23),Y.set("type-parameter",24),Y.set("typeParameter",24),Y.set("account",25),Y.set("issue",26);function se(ae,r){let ge=Y.get(ae);return typeof ge>"u"&&!r&&(ge=9),ge}S.fromString=se})(b||(t.CompletionItemKinds=b={}));var m;(function(S){S[S.Deprecated=1]="Deprecated"})(m||(t.CompletionItemTag=m={}));var e;(function(S){S[S.None=0]="None",S[S.KeepWhitespace=1]="KeepWhitespace",S[S.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var L;(function(S){S[S.Invoke=0]="Invoke",S[S.TriggerCharacter=1]="TriggerCharacter",S[S.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(L||(t.CompletionTriggerKind=L={}));var A;(function(S){S[S.Automatic=0]="Automatic",S[S.Explicit=1]="Explicit"})(A||(t.InlineCompletionTriggerKind=A={}));class N{constructor(B,_,Y,se){this.range=B,this.text=_,this.completionKind=Y,this.isSnippetText=se}equals(B){return h.$0s.lift(this.range).equalsRange(B.range)&&this.text===B.text&&this.completionKind===B.completionKind&&this.isSnippetText===B.isSnippetText}}t.$Vt=N;var $;(function(S){S[S.Invoke=1]="Invoke",S[S.Auto=2]="Auto"})($||(t.CodeActionTriggerType=$={}));var d;(function(S){S[S.Invoke=1]="Invoke",S[S.TriggerCharacter=2]="TriggerCharacter",S[S.ContentChange=3]="ContentChange"})(d||(t.SignatureHelpTriggerKind=d={}));var a;(function(S){S[S.Text=0]="Text",S[S.Read=1]="Read",S[S.Write=2]="Write"})(a||(t.DocumentHighlightKind=a={}));function f(S){return S&&F.URI.isUri(S.uri)&&h.$0s.isIRange(S.range)&&(h.$0s.isIRange(S.originSelectionRange)||h.$0s.isIRange(S.targetSelectionRange))}t.$Wt=f;var n;(function(S){S[S.File=0]="File",S[S.Module=1]="Module",S[S.Namespace=2]="Namespace",S[S.Package=3]="Package",S[S.Class=4]="Class",S[S.Method=5]="Method",S[S.Property=6]="Property",S[S.Field=7]="Field",S[S.Constructor=8]="Constructor",S[S.Enum=9]="Enum",S[S.Interface=10]="Interface",S[S.Function=11]="Function",S[S.Variable=12]="Variable",S[S.Constant=13]="Constant",S[S.String=14]="String",S[S.Number=15]="Number",S[S.Boolean=16]="Boolean",S[S.Array=17]="Array",S[S.Object=18]="Object",S[S.Key=19]="Key",S[S.Null=20]="Null",S[S.EnumMember=21]="EnumMember",S[S.Struct=22]="Struct",S[S.Event=23]="Event",S[S.Operator=24]="Operator",S[S.TypeParameter=25]="TypeParameter"})(n||(t.SymbolKind=n={})),t.$Xt={17:(0,c.localize)(0,null),16:(0,c.localize)(1,null),4:(0,c.localize)(2,null),13:(0,c.localize)(3,null),8:(0,c.localize)(4,null),9:(0,c.localize)(5,null),21:(0,c.localize)(6,null),23:(0,c.localize)(7,null),7:(0,c.localize)(8,null),0:(0,c.localize)(9,null),11:(0,c.localize)(10,null),10:(0,c.localize)(11,null),19:(0,c.localize)(12,null),5:(0,c.localize)(13,null),1:(0,c.localize)(14,null),2:(0,c.localize)(15,null),20:(0,c.localize)(16,null),15:(0,c.localize)(17,null),18:(0,c.localize)(18,null),24:(0,c.localize)(19,null),3:(0,c.localize)(20,null),6:(0,c.localize)(21,null),14:(0,c.localize)(22,null),22:(0,c.localize)(23,null),25:(0,c.localize)(24,null),12:(0,c.localize)(25,null)};function s(S,B){return(0,c.localize)(26,null,S,t.$Xt[B])}t.$Yt=s;var v;(function(S){S[S.Deprecated=1]="Deprecated"})(v||(t.SymbolTag=v={}));var g;(function(S){const B=new Map;B.set(0,i.$pk.symbolFile),B.set(1,i.$pk.symbolModule),B.set(2,i.$pk.symbolNamespace),B.set(3,i.$pk.symbolPackage),B.set(4,i.$pk.symbolClass),B.set(5,i.$pk.symbolMethod),B.set(6,i.$pk.symbolProperty),B.set(7,i.$pk.symbolField),B.set(8,i.$pk.symbolConstructor),B.set(9,i.$pk.symbolEnum),B.set(10,i.$pk.symbolInterface),B.set(11,i.$pk.symbolFunction),B.set(12,i.$pk.symbolVariable),B.set(13,i.$pk.symbolConstant),B.set(14,i.$pk.symbolString),B.set(15,i.$pk.symbolNumber),B.set(16,i.$pk.symbolBoolean),B.set(17,i.$pk.symbolArray),B.set(18,i.$pk.symbolObject),B.set(19,i.$pk.symbolKey),B.set(20,i.$pk.symbolNull),B.set(21,i.$pk.symbolEnumMember),B.set(22,i.$pk.symbolStruct),B.set(23,i.$pk.symbolEvent),B.set(24,i.$pk.symbolOperator),B.set(25,i.$pk.symbolTypeParameter);function _(Y){let se=B.get(Y);return se||(console.info("No codicon found for SymbolKind "+Y),se=i.$pk.symbolProperty),se}S.toIcon=_})(g||(t.SymbolKinds=g={}));class k{static asEditOperation(B){return y.$$s.replace(h.$0s.lift(B.range),B.text)}}t.$Zt=k;class p{static{this.Comment=new p("comment")}static{this.Imports=new p("imports")}static{this.Region=new p("region")}static fromValue(B){switch(B){case"comment":return p.Comment;case"imports":return p.Imports;case"region":return p.Region}return new p(B)}constructor(B){this.value=B}}t.$1t=p;var R;(function(S){S[S.AIGenerated=1]="AIGenerated"})(R||(t.NewSymbolNameTag=R={}));var P;(function(S){function B(_){return!_||typeof _!="object"?!1:typeof _.id=="string"&&typeof _.title=="string"}S.is=B})(P||(t.Command=P={}));var D;(function(S){S[S.Collapsed=0]="Collapsed",S[S.Expanded=1]="Expanded"})(D||(t.CommentThreadCollapsibleState=D={}));var M;(function(S){S[S.Unresolved=0]="Unresolved",S[S.Resolved=1]="Resolved"})(M||(t.CommentThreadState=M={}));var I;(function(S){S[S.Editing=0]="Editing",S[S.Preview=1]="Preview"})(I||(t.CommentMode=I={}));var T;(function(S){S[S.Published=0]="Published",S[S.Draft=1]="Draft"})(T||(t.CommentState=T={}));var O;(function(S){S[S.Type=1]="Type",S[S.Parameter=2]="Parameter"})(O||(t.InlayHintKind=O={}));class j{constructor(B){this.b=B,this.a=null}dispose(){this.a&&this.a.then(B=>{B&&B.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$2t=j,t.$3t=new w.$It;var G;(function(S){S[S.None=0]="None",S[S.Option=1]="Option",S[S.Default=2]="Default",S[S.Preferred=3]="Preferred"})(G||(t.ExternalUriOpenerPriority=G={}));var ee;(function(S){S[S.Invoke=0]="Invoke",S[S.Automatic=1]="Automatic"})(ee||(t.InlineEditTriggerKind=ee={}))}),te(ne[70],re([0,1,24,11,38,18,5,2,45,69,61]),function(C,t,i,F,y,h,w,c,l,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$f2=t.$e2=void 0;class E{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,L){return(0,y.$jr)(e,L)}}t.$e2=E;function b(){return{editor:void 0,languages:void 0,CancellationTokenSource:i.$de,Emitter:F.$6d,KeyCode:o.KeyCode,KeyMod:E,Position:w.$9s,Range:c.$0s,Selection:l.$_s,SelectionDirection:o.SelectionDirection,MarkerSeverity:o.MarkerSeverity,MarkerTag:o.MarkerTag,Uri:h.URI,Token:u.$St}}t.$f2=b}),te(ne[73],re([0,1,25,18,5,2,58,30,54,55,70,23,60,34,52,14,3,53]),function(C,t,i,F,y,h,w,c,l,u,o,E,b,m,e,L,A,N){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class $ extends w.$Bv{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(n){const s=[];for(let v=0;v<this.f.length;v++){const g=this.f[v],k=this.offsetAt(new y.$9s(v+1,1)),p=g.matchAll(n);for(const R of p)(R.index||R.index===0)&&(R.index=R.index+k),s.push(R)}return s}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(n){return this.f[n-1]}getWordAtPosition(n,s){const v=(0,c.$Ms)(n.column,(0,c.$Ks)(s),this.f[n.lineNumber-1],0);return v?new h.$0s(n.lineNumber,v.startColumn,n.lineNumber,v.endColumn):null}getWordUntilPosition(n,s){const v=this.getWordAtPosition(n,s);return v?{word:this.f[n.lineNumber-1].substring(v.startColumn-1,n.column-1),startColumn:v.startColumn,endColumn:n.column}:{word:"",startColumn:n.column,endColumn:n.column}}words(n){const s=this.f,v=this.q.bind(this);let g=0,k="",p=0,R=[];return{*[Symbol.iterator](){for(;;)if(p<R.length){const P=k.substring(R[p].start,R[p].end);p+=1,yield P}else if(g<s.length)k=s[g],R=v(k,n),p=0,g+=1;else break}}}getLineWords(n,s){const v=this.f[n-1],g=this.q(v,s),k=[];for(const p of g)k.push({word:v.substring(p.start,p.end),startColumn:p.start+1,endColumn:p.end+1});return k}q(n,s){const v=[];let g;for(s.lastIndex=0;(g=s.exec(n))&&g[0].length!==0;)v.push({start:g.index,end:g.index+g[0].length});return v}getValueInRange(n){if(n=this.r(n),n.startLineNumber===n.endLineNumber)return this.f[n.startLineNumber-1].substring(n.startColumn-1,n.endColumn-1);const s=this.g,v=n.startLineNumber-1,g=n.endLineNumber-1,k=[];k.push(this.f[v].substring(n.startColumn-1));for(let p=v+1;p<g;p++)k.push(this.f[p]);return k.push(this.f[g].substring(0,n.endColumn-1)),k.join(s)}offsetAt(n){return n=this.s(n),this.l(),this.j.getPrefixSum(n.lineNumber-2)+(n.column-1)}positionAt(n){n=Math.floor(n),n=Math.max(0,n),this.l();const s=this.j.getIndexOf(n),v=this.f[s.index].length;return{lineNumber:1+s.index,column:1+Math.min(s.remainder,v)}}r(n){const s=this.s({lineNumber:n.startLineNumber,column:n.startColumn}),v=this.s({lineNumber:n.endLineNumber,column:n.endColumn});return s.lineNumber!==n.startLineNumber||s.column!==n.startColumn||v.lineNumber!==n.endLineNumber||v.column!==n.endColumn?{startLineNumber:s.lineNumber,startColumn:s.column,endLineNumber:v.lineNumber,endColumn:v.column}:n}s(n){if(!y.$9s.isIPosition(n))throw new Error("bad position");let{lineNumber:s,column:v}=n,g=!1;if(s<1)s=1,v=1,g=!0;else if(s>this.f.length)s=this.f.length,v=this.f[s-1].length+1,g=!0;else{const k=this.f[s-1].length+1;v<1?(v=1,g=!0):v>k&&(v=k,g=!0)}return g?{lineNumber:s,column:v}:n}}class d{constructor(n,s){this.d=n,this.f=Object.create(null),this.g=s,this.h=null}dispose(){this.f=Object.create(null)}j(n){return this.f[n]}k(){const n=[];return Object.keys(this.f).forEach(s=>n.push(this.f[s])),n}acceptNewModel(n){this.f[n.url]=new $(F.URI.parse(n.url),n.lines,n.EOL,n.versionId)}acceptModelChanged(n,s){if(!this.f[n])return;this.f[n].onEvents(s)}acceptRemovedModel(n){this.f[n]&&delete this.f[n]}async computeUnicodeHighlights(n,s,v){const g=this.j(n);return g?b.$_1.computeUnicodeHighlights(g,s,v):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(n,s,v,g){const k=this.j(n),p=this.j(s);return!k||!p?null:d.l(k,p,v,g)}static l(n,s,v,g){const k=g==="advanced"?e.$B2.getDefault():e.$B2.getLegacy(),p=n.getLinesContent(),R=s.getLinesContent(),P=k.computeDiff(p,R,v),D=P.changes.length>0?!1:this.n(n,s);function M(I){return I.map(T=>[T.original.startLineNumber,T.original.endLineNumberExclusive,T.modified.startLineNumber,T.modified.endLineNumberExclusive,T.innerChanges?.map(O=>[O.originalRange.startLineNumber,O.originalRange.startColumn,O.originalRange.endLineNumber,O.originalRange.endColumn,O.modifiedRange.startLineNumber,O.modifiedRange.startColumn,O.modifiedRange.endLineNumber,O.modifiedRange.endColumn])])}return{identical:D,quitEarly:P.hitTimeout,changes:M(P.changes),moves:P.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,M(I.changes)])}}static n(n,s){const v=n.getLineCount(),g=s.getLineCount();if(v!==g)return!1;for(let k=1;k<=v;k++){const p=n.getLineContent(k),R=s.getLineContent(k);if(p!==R)return!1}return!0}async computeDirtyDiff(n,s,v){const g=this.j(n),k=this.j(s);if(!g||!k)return null;const p=g.getLinesContent(),R=k.getLinesContent();return new m.$ot(p,R,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:v,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(n,s,v){const g=this.j(n);if(!g)return s;const k=[];let p;s=s.slice(0).sort((P,D)=>{if(P.range&&D.range)return h.$0s.compareRangesUsingStarts(P.range,D.range);const M=P.range?0:1,I=D.range?0:1;return M-I});let R=0;for(let P=1;P<s.length;P++)h.$0s.getEndPosition(s[R].range).equals(h.$0s.getStartPosition(s[P].range))?(s[R].range=h.$0s.fromPositions(h.$0s.getStartPosition(s[R].range),h.$0s.getEndPosition(s[P].range)),s[R].text+=s[P].text):(R++,s[R]=s[P]);s.length=R+1;for(let{range:P,text:D,eol:M}of s){if(typeof M=="number"&&(p=M),h.$0s.isEmpty(P)&&!D)continue;const I=g.getValueInRange(P);if(D=D.replace(/\r\n|\n|\r/g,g.eol),I===D)continue;if(Math.max(D.length,I.length)>d.o){k.push({range:P,text:D});continue}const T=(0,i.$ct)(I,D,v),O=g.offsetAt(h.$0s.lift(P).getStartPosition());for(const j of T){const G=g.positionAt(O+j.originalStart),ee=g.positionAt(O+j.originalStart+j.originalLength),S={text:D.substr(j.modifiedStart,j.modifiedLength),range:{startLineNumber:G.lineNumber,startColumn:G.column,endLineNumber:ee.lineNumber,endColumn:ee.column}};g.getValueInRange(S.range)!==S.text&&k.push(S)}}return typeof p=="number"&&k.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),k}computeHumanReadableDiff(n,s,v){const g=this.j(n);if(!g)return s;const k=[];let p;s=s.slice(0).sort((R,P)=>{if(R.range&&P.range)return h.$0s.compareRangesUsingStarts(R.range,P.range);const D=R.range?0:1,M=P.range?0:1;return D-M});for(let{range:R,text:P,eol:D}of s){let G=function(S,B){return new y.$9s(S.lineNumber+B.lineNumber-1,B.lineNumber===1?S.column+B.column-1:B.column)},ee=function(S,B){const _=[];for(let Y=B.startLineNumber;Y<=B.endLineNumber;Y++){const se=S[Y-1];Y===B.startLineNumber&&Y===B.endLineNumber?_.push(se.substring(B.startColumn-1,B.endColumn-1)):Y===B.startLineNumber?_.push(se.substring(B.startColumn-1)):Y===B.endLineNumber?_.push(se.substring(0,B.endColumn-1)):_.push(se)}return _};if(typeof D=="number"&&(p=D),h.$0s.isEmpty(R)&&!P)continue;const M=g.getValueInRange(R);if(P=P.replace(/\r\n|\n|\r/g,g.eol),M===P)continue;if(Math.max(P.length,M.length)>d.o){k.push({range:R,text:P});continue}const I=M.split(/\r\n|\n|\r/),T=P.split(/\r\n|\n|\r/),O=e.$B2.getDefault().computeDiff(I,T,v),j=h.$0s.lift(R).getStartPosition();for(const S of O.changes)if(S.innerChanges)for(const B of S.innerChanges)k.push({range:h.$0s.fromPositions(G(j,B.originalRange.getStartPosition()),G(j,B.originalRange.getEndPosition())),text:ee(T,B.modifiedRange).join(g.eol)});else throw new A.$cb("The experimental diff algorithm always produces inner changes")}return typeof p=="number"&&k.push({eol:p,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),k}async computeLinks(n){const s=this.j(n);return s?(0,l.$c2)(s):null}async computeDefaultDocumentColors(n){const s=this.j(n);return s?(0,N.$C2)(s):null}static{this.p=1e4}async textualSuggest(n,s,v,g){const k=new E.$2d,p=new RegExp(v,g),R=new Set;e:for(const P of n){const D=this.j(P);if(D){for(const M of D.words(p))if(!(M===s||!isNaN(Number(M)))&&(R.add(M),R.size>d.p))break e}}return{words:Array.from(R),duration:k.elapsed()}}async computeWordRanges(n,s,v,g){const k=this.j(n);if(!k)return Object.create(null);const p=new RegExp(v,g),R=Object.create(null);for(let P=s.startLineNumber;P<s.endLineNumber;P++){const D=k.getLineWords(P,p);for(const M of D){if(!isNaN(Number(M.word)))continue;let I=R[M.word];I||(I=[],R[M.word]=I),I.push({startLineNumber:P,startColumn:M.startColumn,endLineNumber:P,endColumn:M.endColumn})}}return R}async navigateValueSet(n,s,v,g,k){const p=this.j(n);if(!p)return null;const R=new RegExp(g,k);s.startColumn===s.endColumn&&(s={startLineNumber:s.startLineNumber,startColumn:s.startColumn,endLineNumber:s.endLineNumber,endColumn:s.endColumn+1});const P=p.getValueInRange(s),D=p.getWordAtPosition({lineNumber:s.startLineNumber,column:s.startColumn},R);if(!D)return null;const M=p.getValueInRange(D);return u.$d2.INSTANCE.navigateValueSet(s,P,D,M,v)}loadForeignModule(n,s,v){const g=(R,P)=>this.d.fhr(R,P),p={host:(0,L.$Wn)(v,g),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(p,s),Promise.resolve((0,L.$Vn)(this.h))):new Promise((R,P)=>{C([n],D=>{this.h=D.create(p,s),R((0,L.$Vn)(this.h))},P)})}fmr(n,s){if(!this.h||typeof this.h[n]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+n));try{return Promise.resolve(this.h[n].apply(this.h,s))}catch(v){return Promise.reject(v)}}}t.EditorSimpleWorker=d;function a(f){return new d(f,null)}t.create=a,typeof importScripts=="function"&&(globalThis.monaco=(0,o.$f2)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b148975cafa8f034592310659f3dc989b124685c/core/vs/base/worker/workerMain.js.map
