/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/base/browser/ui/hover/updatableHoverWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/hover/updatableHoverWidget","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],$e=function(re){for(var e=[],i=0,C=re.length;i<C;i++)e[i]=me[re[i]];return e};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ht,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ft,construct:Ct}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(e,i,C){return e.apply(i,C)}),ot||(ot=function(e){return e}),ft||(ft=function(e){return e}),Ct||(Ct=function(e,i){return new e(...i)});const oi=ut(Array.prototype.forEach),jt=ut(Array.prototype.pop),wt=ut(Array.prototype.push),Et=ut(String.prototype.toLowerCase),Rt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),vt=ui(TypeError);function ut(re){return function(e){for(var i=arguments.length,C=new Array(i>1?i-1:0),j=1;j<i;j++)C[j-1]=arguments[j];return Ft(re,e,C)}}function ui(re){return function(){for(var e=arguments.length,i=new Array(e),C=0;C<e;C++)i[C]=arguments[C];return Ct(re,i)}}function We(re,e,i){var C;i=(C=i)!==null&&C!==void 0?C:Et,Ht&&Ht(re,null);let j=e.length;for(;j--;){let W=e[j];if(typeof W=="string"){const D=i(W);D!==W&&(ii(e)||(e[j]=D),W=D)}re[W]=!0}return re}function bt(re){const e=ri(null);for(const[i,C]of zt(re))e[i]=C;return e}function At(re,e){for(;re!==null;){const C=si(re,e);if(C){if(C.get)return ut(C.get);if(typeof C.value=="function")return ut(C.value)}re=ni(re)}function i(C){return console.warn("fallback value for",C),null}return i}const Wt=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Mt=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Ot=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),$i=ft(/^data-[\-\w.\u00B7-\uFFFF]/),bi=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),ki=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),xt=ft(/^html$/i);var Gt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:$i,ARIA_ATTR:bi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:ki,DOCTYPE_NAME:xt});const wi=()=>typeof window>"u"?null:window,vi=function(e,i){if(typeof e!="object"||typeof e.createPolicy!="function")return null;let C=null;const j="data-tt-policy-suffix";i&&i.hasAttribute(j)&&(C=i.getAttribute(j));const W="dompurify"+(C?"#"+C:"");try{return e.createPolicy(W,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Yt(){let re=arguments.length>0&&arguments[0]!==void 0?arguments[0]:wi();const e=ze=>Yt(ze);if(e.version="3.0.5",e.removed=[],!re||!re.document||re.document.nodeType!==9)return e.isSupported=!1,e;const i=re.document,C=i.currentScript;let{document:j}=re;const{DocumentFragment:W,HTMLTemplateElement:D,Node:y,Element:$,NodeFilter:p,NamedNodeMap:w=re.NamedNodeMap||re.MozNamedAttrMap,HTMLFormElement:B,DOMParser:f,trustedTypes:d}=re,t=$.prototype,s=At(t,"cloneNode"),a=At(t,"nextSibling"),m=At(t,"childNodes"),u=At(t,"parentNode");if(typeof D=="function"){const ze=j.createElement("template");ze.content&&ze.content.ownerDocument&&(j=ze.content.ownerDocument)}let k,l="";const{implementation:b,createNodeIterator:r,createDocumentFragment:A,getElementsByTagName:R}=j,{importNode:I}=i;let O={};e.isSupported=typeof zt=="function"&&typeof u=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:v,TMPLIT_EXPR:H,DATA_ATTR:V,ARIA_ATTR:S,IS_SCRIPT_OR_DATA:L,ATTR_WHITESPACE:M}=Gt;let{IS_ALLOWED_URI:X}=Gt,U=null;const de=We({},[...Wt,...Lt,...It,...Mt,...Vt]);let he=null;const ne=We({},[...qt,...Ot,...Qt,...St]);let ge=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Fe=null,Ce=null,Be=!0,le=!0,_=!1,ae=!0,oe=!1,J=!1,G=!1,ie=!1,ce=!1,De=!1,Ne=!1,ye=!0,K=!1;const g="user-content-";let E=!0,N=!1,o={},c=null;const n=We({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let h=null;const F=We({},["audio","video","img","source","image","track"]);let T=null;const P=We({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),q="http://www.w3.org/1998/Math/MathML",Z="http://www.w3.org/2000/svg",ee="http://www.w3.org/1999/xhtml";let be=ee,we=!1,ke=null;const Oe=We({},[q,Z,ee],Rt);let Ee;const Ae=["application/xhtml+xml","text/html"],Re="text/html";let Ie,Ge=null;const nt=j.createElement("form"),Ye=function(ue){return ue instanceof RegExp||ue instanceof Function},Ue=function(ue){if(!(Ge&&Ge===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=bt(ue),Ee=Ae.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Ee=Re:Ee=ue.PARSER_MEDIA_TYPE,Ie=Ee==="application/xhtml+xml"?Rt:Et,U="ALLOWED_TAGS"in ue?We({},ue.ALLOWED_TAGS,Ie):de,he="ALLOWED_ATTR"in ue?We({},ue.ALLOWED_ATTR,Ie):ne,ke="ALLOWED_NAMESPACES"in ue?We({},ue.ALLOWED_NAMESPACES,Rt):Oe,T="ADD_URI_SAFE_ATTR"in ue?We(bt(P),ue.ADD_URI_SAFE_ATTR,Ie):P,h="ADD_DATA_URI_TAGS"in ue?We(bt(F),ue.ADD_DATA_URI_TAGS,Ie):F,c="FORBID_CONTENTS"in ue?We({},ue.FORBID_CONTENTS,Ie):n,Fe="FORBID_TAGS"in ue?We({},ue.FORBID_TAGS,Ie):{},Ce="FORBID_ATTR"in ue?We({},ue.FORBID_ATTR,Ie):{},o="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Be=ue.ALLOW_ARIA_ATTR!==!1,le=ue.ALLOW_DATA_ATTR!==!1,_=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,oe=ue.SAFE_FOR_TEMPLATES||!1,J=ue.WHOLE_DOCUMENT||!1,ce=ue.RETURN_DOM||!1,De=ue.RETURN_DOM_FRAGMENT||!1,Ne=ue.RETURN_TRUSTED_TYPE||!1,ie=ue.FORCE_BODY||!1,ye=ue.SANITIZE_DOM!==!1,K=ue.SANITIZE_NAMED_PROPS||!1,E=ue.KEEP_CONTENT!==!1,N=ue.IN_PLACE||!1,X=ue.ALLOWED_URI_REGEXP||Kt,be=ue.NAMESPACE||ee,ge=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ge.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&Ye(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ge.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ge.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),oe&&(le=!1),De&&(ce=!0),o&&(U=We({},[...Vt]),he=[],o.html===!0&&(We(U,Wt),We(he,qt)),o.svg===!0&&(We(U,Lt),We(he,Ot),We(he,St)),o.svgFilters===!0&&(We(U,It),We(he,Ot),We(he,St)),o.mathMl===!0&&(We(U,Mt),We(he,Qt),We(he,St))),ue.ADD_TAGS&&(U===de&&(U=bt(U)),We(U,ue.ADD_TAGS,Ie)),ue.ADD_ATTR&&(he===ne&&(he=bt(he)),We(he,ue.ADD_ATTR,Ie)),ue.ADD_URI_SAFE_ATTR&&We(T,ue.ADD_URI_SAFE_ATTR,Ie),ue.FORBID_CONTENTS&&(c===n&&(c=bt(c)),We(c,ue.FORBID_CONTENTS,Ie)),E&&(U["#text"]=!0),J&&We(U,["html","head","body"]),U.table&&(We(U,["tbody"]),delete Fe.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');k=ue.TRUSTED_TYPES_POLICY,l=k.createHTML("")}else k===void 0&&(k=vi(d,C)),k!==null&&typeof l=="string"&&(l=k.createHTML(""));ot&&ot(ue),Ge=ue}},Y=We({},["mi","mo","mn","ms","mtext"]),se=We({},["foreignobject","desc","title","annotation-xml"]),pe=We({},["title","style","font","a","script"]),ve=We({},Lt);We(ve,It),We(ve,ci);const Le=We({},Mt);We(Le,fi);const je=function(ue){let Te=u(ue);(!Te||!Te.tagName)&&(Te={namespaceURI:be,tagName:"template"});const Me=Et(ue.tagName),Qe=Et(Te.tagName);return ke[ue.namespaceURI]?ue.namespaceURI===Z?Te.namespaceURI===ee?Me==="svg":Te.namespaceURI===q?Me==="svg"&&(Qe==="annotation-xml"||Y[Qe]):!!ve[Me]:ue.namespaceURI===q?Te.namespaceURI===ee?Me==="math":Te.namespaceURI===Z?Me==="math"&&se[Qe]:!!Le[Me]:ue.namespaceURI===ee?Te.namespaceURI===Z&&!se[Qe]||Te.namespaceURI===q&&!Y[Qe]?!1:!Le[Me]&&(pe[Me]||!ve[Me]):!!(Ee==="application/xhtml+xml"&&ke[ue.namespaceURI]):!1},qe=function(ue){wt(e.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},_e=function(ue,Te){try{wt(e.removed,{attribute:Te.getAttributeNode(ue),from:Te})}catch{wt(e.removed,{attribute:null,from:Te})}if(Te.removeAttribute(ue),ue==="is"&&!he[ue])if(ce||De)try{qe(Te)}catch{}else try{Te.setAttribute(ue,"")}catch{}},tt=function(ue){let Te,Me;if(ie)ue="<remove></remove>"+ue;else{const lt=li(ue,/^[\r\n\t ]+/);Me=lt&&lt[0]}Ee==="application/xhtml+xml"&&be===ee&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const Qe=k?k.createHTML(ue):ue;if(be===ee)try{Te=new f().parseFromString(Qe,Ee)}catch{}if(!Te||!Te.documentElement){Te=b.createDocument(be,"template",null);try{Te.documentElement.innerHTML=we?l:Qe}catch{}}const it=Te.body||Te.documentElement;return ue&&Me&&it.insertBefore(j.createTextNode(Me),it.childNodes[0]||null),be===ee?R.call(Te,J?"html":"body")[0]:J?Te.documentElement:it},st=function(ue){return r.call(ue.ownerDocument||ue,ue,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},Ze=function(ue){return ue instanceof B&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof w)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},rt=function(ue){return typeof y=="object"?ue instanceof y:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},et=function(ue,Te,Me){O[ue]&&oi(O[ue],Qe=>{Qe.call(e,Te,Me,Ge)})},gt=function(ue){let Te;if(et("beforeSanitizeElements",ue,null),Ze(ue))return qe(ue),!0;const Me=Ie(ue.nodeName);if(et("uponSanitizeElement",ue,{tagName:Me,allowedTags:U}),ue.hasChildNodes()&&!rt(ue.firstElementChild)&&(!rt(ue.content)||!rt(ue.content.firstElementChild))&&ht(/<[/\w]/g,ue.innerHTML)&&ht(/<[/\w]/g,ue.textContent))return qe(ue),!0;if(!U[Me]||Fe[Me]){if(!Fe[Me]&&$t(Me)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me)))return!1;if(E&&!c[Me]){const Qe=u(ue)||ue.parentNode,it=m(ue)||ue.childNodes;if(it&&Qe){const lt=it.length;for(let Xe=lt-1;Xe>=0;--Xe)Qe.insertBefore(s(it[Xe],!0),a(ue))}}return qe(ue),!0}return ue instanceof $&&!je(ue)||(Me==="noscript"||Me==="noembed"||Me==="noframes")&&ht(/<\/no(script|embed|frames)/i,ue.innerHTML)?(qe(ue),!0):(oe&&ue.nodeType===3&&(Te=ue.textContent,Te=dt(Te,z," "),Te=dt(Te,v," "),Te=dt(Te,H," "),ue.textContent!==Te&&(wt(e.removed,{element:ue.cloneNode()}),ue.textContent=Te)),et("afterSanitizeElements",ue,null),!1)},mt=function(ue,Te,Me){if(ye&&(Te==="id"||Te==="name")&&(Me in j||Me in nt))return!1;if(!(le&&!Ce[Te]&&ht(V,Te))){if(!(Be&&ht(S,Te))){if(!he[Te]||Ce[Te]){if(!($t(ue)&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,ue)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(ue))&&(ge.attributeNameCheck instanceof RegExp&&ht(ge.attributeNameCheck,Te)||ge.attributeNameCheck instanceof Function&&ge.attributeNameCheck(Te))||Te==="is"&&ge.allowCustomizedBuiltInElements&&(ge.tagNameCheck instanceof RegExp&&ht(ge.tagNameCheck,Me)||ge.tagNameCheck instanceof Function&&ge.tagNameCheck(Me))))return!1}else if(!T[Te]){if(!ht(X,dt(Me,M,""))){if(!((Te==="src"||Te==="xlink:href"||Te==="href")&&ue!=="script"&&ai(Me,"data:")===0&&h[ue])){if(!(_&&!ht(L,dt(Me,M,"")))){if(Me)return!1}}}}}}return!0},$t=function(ue){return ue.indexOf("-")>0},Tt=function(ue){let Te,Me,Qe,it;et("beforeSanitizeAttributes",ue,null);const{attributes:lt}=ue;if(!lt)return;const Xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:he};for(it=lt.length;it--;){Te=lt[it];const{name:ct,namespaceURI:pt}=Te;if(Me=ct==="value"?Te.value:hi(Te.value),Qe=Ie(ct),Xe.attrName=Qe,Xe.attrValue=Me,Xe.keepAttr=!0,Xe.forceKeepAttr=void 0,et("uponSanitizeAttribute",ue,Xe),Me=Xe.attrValue,Xe.forceKeepAttr||(_e(ct,ue),!Xe.keepAttr))continue;if(!ae&&ht(/\/>/i,Me)){_e(ct,ue);continue}oe&&(Me=dt(Me,z," "),Me=dt(Me,v," "),Me=dt(Me,H," "));const Dt=Ie(ue.nodeName);if(mt(Dt,Qe,Me)){if(K&&(Qe==="id"||Qe==="name")&&(_e(ct,ue),Me=g+Me),k&&typeof d=="object"&&typeof d.getAttributeType=="function"&&!pt)switch(d.getAttributeType(Dt,Qe)){case"TrustedHTML":{Me=k.createHTML(Me);break}case"TrustedScriptURL":{Me=k.createScriptURL(Me);break}}try{pt?ue.setAttributeNS(pt,ct,Me):ue.setAttribute(ct,Me),jt(e.removed)}catch{}}}et("afterSanitizeAttributes",ue,null)},Pt=function ze(ue){let Te;const Me=st(ue);for(et("beforeSanitizeShadowDOM",ue,null);Te=Me.nextNode();)et("uponSanitizeShadowNode",Te,null),!gt(Te)&&(Te.content instanceof W&&ze(Te.content),Tt(Te));et("afterSanitizeShadowDOM",ue,null)};return e.sanitize=function(ze){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Te,Me,Qe,it;if(we=!ze,we&&(ze="<!-->"),typeof ze!="string"&&!rt(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!e.isSupported)return ze;if(G||Ue(ue),e.removed=[],typeof ze=="string"&&(N=!1),N){if(ze.nodeName){const ct=Ie(ze.nodeName);if(!U[ct]||Fe[ct])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof y)Te=tt("<!---->"),Me=Te.ownerDocument.importNode(ze,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Te=Me:Te.appendChild(Me);else{if(!ce&&!oe&&!J&&ze.indexOf("<")===-1)return k&&Ne?k.createHTML(ze):ze;if(Te=tt(ze),!Te)return ce?null:Ne?l:""}Te&&ie&&qe(Te.firstChild);const lt=st(N?ze:Te);for(;Qe=lt.nextNode();)gt(Qe)||(Qe.content instanceof W&&Pt(Qe.content),Tt(Qe));if(N)return ze;if(ce){if(De)for(it=A.call(Te.ownerDocument);Te.firstChild;)it.appendChild(Te.firstChild);else it=Te;return(he.shadowroot||he.shadowrootmode)&&(it=I.call(i,it,!0)),it}let Xe=J?Te.outerHTML:Te.innerHTML;return J&&U["!doctype"]&&Te.ownerDocument&&Te.ownerDocument.doctype&&Te.ownerDocument.doctype.name&&ht(xt,Te.ownerDocument.doctype.name)&&(Xe="<!DOCTYPE "+Te.ownerDocument.doctype.name+`>
`+Xe),oe&&(Xe=dt(Xe,z," "),Xe=dt(Xe,v," "),Xe=dt(Xe,H," ")),k&&Ne?k.createHTML(Xe):Xe},e.setConfig=function(ze){Ue(ze),G=!0},e.clearConfig=function(){Ge=null,G=!1},e.isValidAttribute=function(ze,ue,Te){Ge||Ue({});const Me=Ie(ze),Qe=Ie(ue);return mt(Me,Qe,Te)},e.addHook=function(ze,ue){typeof ue=="function"&&(O[ze]=O[ze]||[],wt(O[ze],ue))},e.removeHook=function(ze){if(O[ze])return jt(O[ze])},e.removeHooks=function(ze){O[ze]&&(O[ze]=[])},e.removeAllHooks=function(){O={}},e}var Di=Yt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(me[45],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tS=e.$sS=void 0;class i{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const y=C(D);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(D){const y=C(D);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(D){const y=C(D);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(D){const y=C(D);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(D){const y=C(D);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(D){const y=C(D);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(D){const y=C(D);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(D){const y=C(D);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const y=C(D);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const y=C(D);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const y=C(D);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const y=C(D);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const y=C(D);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const y=C(D);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,y){this.domNode.classList.toggle(D,y),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,y){this.domNode.setAttribute(D,y)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}e.$sS=i;function C(W){return typeof W=="number"?`${W}px`:W}function j(W){return new i(W)}e.$tS=j}),define(me[72],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=e.$JQ=void 0;const i=new WeakMap;function C(y){if(!y.parent||y.parent===y)return null;try{const $=y.location,p=y.parent.location;if($.origin!=="null"&&p.origin!=="null"&&$.origin!==p.origin)return null}catch{return null}return y.parent}class j{static a($){let p=i.get($);if(!p){p=[],i.set($,p);let w=$,B;do B=C(w),B?p.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):p.push({window:new WeakRef(w),iframeElement:null}),w=B;while(w)}return p.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow($,p){if(!p||$===p)return{top:0,left:0};let w=0,B=0;const f=this.a($);for(const d of f){const t=d.window.deref();if(w+=t?.scrollY??0,B+=t?.scrollX??0,t===p||!d.iframeElement)break;const s=d.iframeElement.getBoundingClientRect();w+=s.top,B+=s.left}return{top:w,left:B}}}e.$JQ=j;async function W(y,$){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const p=JSON.stringify({parentOrigin:y,salt:$}),B=new TextEncoder().encode(p),f=await crypto.subtle.digest("sha-256",B);return D(f)}e.$KQ=W;function D(y){const p=Array.from(new Uint8Array(y)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${p}`).toString(32).padStart(52,"0")}}),define(me[73],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cT=e.$bT=e.$aT=e.ListDragOverEffectPosition=e.ListDragOverEffectType=void 0;var i;(function(D){D[D.Copy=0]="Copy",D[D.Move=1]="Move"})(i||(e.ListDragOverEffectType=i={}));var C;(function(D){D.Over="drop-target",D.Before="drop-target-before",D.After="drop-target-after"})(C||(e.ListDragOverEffectPosition=C={})),e.$aT={reject(){return{accept:!1}},accept(){return{accept:!0}}};class j extends Error{constructor(y,$){super(`ListError [${y}] ${$}`)}}e.$bT=j;class W{constructor(){this.c=new WeakMap}getHeight(y){return this.c.get(y)??this.d(y)}setDynamicHeight(y,$){$>0&&this.c.set(y,$)}}e.$cT=W}),define(me[74],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3S=void 0;class i{constructor(j){this.a=j}splice(j,W,D){this.a.forEach(y=>y.splice(j,W,D))}}e.$3S=i}),define(me[46],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yS=void 0;const i=20;class C{constructor(W,D,y,$,p,w){this.a=Math.round(D),this.b=Math.round(y),this.c=Math.round(W),this.d=$,this.e=p,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const D=Math.round(W);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(W){const D=Math.round(W);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(W){const D=Math.round(W);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,D,y,$,p){const w=Math.max(0,y-W),B=Math.max(0,w-2*D),f=$>0&&$>y;if(!f)return{computedAvailableSize:Math.round(w),computedIsNeeded:f,computedSliderSize:Math.round(B),computedSliderRatio:0,computedSliderPosition:0};const d=Math.round(Math.max(i,Math.floor(y*B/$))),t=(B-d)/($-y),s=p*t;return{computedAvailableSize:Math.round(w),computedIsNeeded:f,computedSliderSize:Math.round(d),computedSliderRatio:t,computedSliderPosition:Math.round(s)}}m(){const W=C.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const D=W-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const D=W-this.c;let y=this.f;return D<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const D=this.k+W;return Math.round(D/this.j)}}e.$yS=C}),define(me[27],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7U=e.$6U=e.$5U=e.TreeDragOverBubble=e.TreeMouseEventTarget=e.ObjectTreeElementCollapseState=e.TreeVisibility=void 0;var i;(function($){$[$.Hidden=0]="Hidden",$[$.Visible=1]="Visible",$[$.Recurse=2]="Recurse"})(i||(e.TreeVisibility=i={}));var C;(function($){$[$.Expanded=0]="Expanded",$[$.Collapsed=1]="Collapsed",$[$.PreserveOrExpanded=2]="PreserveOrExpanded",$[$.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(e.ObjectTreeElementCollapseState=C={}));var j;(function($){$[$.Unknown=0]="Unknown",$[$.Twistie=1]="Twistie",$[$.Element=2]="Element",$[$.Filter=3]="Filter"})(j||(e.TreeMouseEventTarget=j={}));var W;(function($){$[$.Down=0]="Down",$[$.Up=1]="Up"})(W||(e.TreeDragOverBubble=W={})),e.$5U={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown($=!1){return{accept:!0,bubble:0,autoExpand:$}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown($=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:$}}};class D extends Error{constructor(p,w){super(`TreeError [${p}] ${w}`)}}e.$6U=D;class y{constructor(p){this.a=p,this.b=new WeakMap}map(p){let w=this.b.get(p);return w||(w=this.a(p),this.b.set(p,w)),w}}e.$7U=y}),define(me[22],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=e.$window=e.$mQ=e.$lQ=void 0;function i(j,W){const D=j;typeof D.vscodeWindowId!="number"&&Object.defineProperty(D,"vscodeWindowId",{get:()=>W})}e.$lQ=i,e.$mQ=window,e.$window=e.$mQ;function C(j){return j===e.$mQ?!1:typeof j?.vscodeWindowId=="number"}e.$oQ=C}),define(me[75],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function i(s,a,m){const u=C(s,a);if(u!==-1)return s[u]}e.$fb=i;function C(s,a,m=s.length-1){for(let u=m;u>=0;u--){const k=s[u];if(a(k))return u}return-1}e.$gb=C;function j(s,a){const m=W(s,a);return m===-1?void 0:s[m]}e.$hb=j;function W(s,a,m=0,u=s.length){let k=m,l=u;for(;k<l;){const b=Math.floor((k+l)/2);a(s[b])?k=b+1:l=b}return k-1}e.$ib=W;function D(s,a){const m=y(s,a);return m===s.length?void 0:s[m]}e.$jb=D;function y(s,a,m=0,u=s.length){let k=m,l=u;for(;k<l;){const b=Math.floor((k+l)/2);a(s[b])?l=b:k=b+1}return k}e.$kb=y;function $(s,a,m=0,u=s.length){const k=y(s,a,m,u);return k===s.length?-1:k}e.$lb=$;class p{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(p.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!a(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const m=W(this.e,a,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=p;function w(s,a){if(s.length===0)return;let m=s[0];for(let u=1;u<s.length;u++){const k=s[u];a(k,m)>0&&(m=k)}return m}e.$nb=w;function B(s,a){if(s.length===0)return;let m=s[0];for(let u=1;u<s.length;u++){const k=s[u];a(k,m)>=0&&(m=k)}return m}e.$ob=B;function f(s,a){return w(s,(m,u)=>-a(m,u))}e.$pb=f;function d(s,a){if(s.length===0)return-1;let m=0;for(let u=1;u<s.length;u++){const k=s[u];a(k,s[m])>0&&(m=u)}return m}e.$qb=d;function t(s,a){for(const m of s){const u=a(m);if(u!==void 0)return u}}e.$rb=t}),define(me[76],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function i(D,y){const $=Object.create(null);for(const p of D){const w=y(p);let B=$[w];B||(B=$[w]=[]),B.push(p)}return $}e.$K=i;function C(D,y){const $=[],p=[];for(const w of D)y.has(w)||$.push(w);for(const w of y)D.has(w)||p.push(w);return{removed:$,added:p}}e.$L=C;function j(D,y){const $=[],p=[];for(const[w,B]of D)y.has(w)||$.push(B);for(const[w,B]of y)D.has(w)||p.push(B);return{removed:$,added:p}}e.$M=j;function W(D,y){const $=new Set;for(const p of y)D.has(p)&&$.add(p);return $}e.$N=W}),define(me[77],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.$zt=e.$yt=void 0;function i(y,$){const p=Math.pow(10,$);return Math.round(y*p)/p}class C{constructor($,p,w,B=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,$))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,p){return $.r===p.r&&$.g===p.g&&$.b===p.b&&$.a===p.a}}e.$yt=C;class j{constructor($,p,w,B){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=i(Math.max(Math.min(1,p),0),3),this.l=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,p){return $.h===p.h&&$.s===p.s&&$.l===p.l&&$.a===p.a}static fromRGBA($){const p=$.r/255,w=$.g/255,B=$.b/255,f=$.a,d=Math.max(p,w,B),t=Math.min(p,w,B);let s=0,a=0;const m=(t+d)/2,u=d-t;if(u>0){switch(a=Math.min(m<=.5?u/(2*m):u/(2-2*m),1),d){case p:s=(w-B)/u+(w<B?6:0);break;case w:s=(B-p)/u+2;break;case B:s=(p-w)/u+4;break}s*=60,s=Math.round(s)}return new j(s,a,m,f)}static i($,p,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?$+(p-$)*6*w:w<1/2?p:w<2/3?$+(p-$)*(2/3-w)*6:$}static toRGBA($){const p=$.h/360,{s:w,l:B,a:f}=$;let d,t,s;if(w===0)d=t=s=B;else{const a=B<.5?B*(1+w):B+w-B*w,m=2*B-a;d=j.i(m,a,p+1/3),t=j.i(m,a,p),s=j.i(m,a,p-1/3)}return new C(Math.round(d*255),Math.round(t*255),Math.round(s*255),f)}}e.$zt=j;class W{constructor($,p,w,B){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,$),0)|0,this.s=i(Math.max(Math.min(1,p),0),3),this.v=i(Math.max(Math.min(1,w),0),3),this.a=i(Math.max(Math.min(1,B),0),3)}static equals($,p){return $.h===p.h&&$.s===p.s&&$.v===p.v&&$.a===p.a}static fromRGBA($){const p=$.r/255,w=$.g/255,B=$.b/255,f=Math.max(p,w,B),d=Math.min(p,w,B),t=f-d,s=f===0?0:t/f;let a;return t===0?a=0:f===p?a=((w-B)/t%6+6)%6:f===w?a=(B-p)/t+2:a=(p-w)/t+4,new W(Math.round(a*60),s,f,$.a)}static toRGBA($){const{h:p,s:w,v:B,a:f}=$,d=B*w,t=d*(1-Math.abs(p/60%2-1)),s=B-d;let[a,m,u]=[0,0,0];return p<60?(a=d,m=t):p<120?(a=t,m=d):p<180?(m=d,u=t):p<240?(m=t,u=d):p<300?(a=t,u=d):p<=360&&(a=d,u=t),a=Math.round((a+s)*255),m=Math.round((m+s)*255),u=Math.round((u+s)*255),new C(a,m,u,f)}}e.$At=W;class D{static fromHex($){return D.Format.CSS.parseHex($)||D.red}static equals($,p){return!$&&!p?!0:!$||!p?!1:$.equals(p)}get hsla(){return this.i?this.i:j.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor($){if($)if($ instanceof C)this.rgba=$;else if($ instanceof j)this.i=$,this.rgba=j.toRGBA($);else if($ instanceof W)this.j=$,this.rgba=W.toRGBA($);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals($){return!!$&&C.equals(this.rgba,$.rgba)&&j.equals(this.hsla,$.hsla)&&W.equals(this.hsva,$.hsva)}getRelativeLuminance(){const $=D.k(this.rgba.r),p=D.k(this.rgba.g),w=D.k(this.rgba.b),B=.2126*$+.7152*p+.0722*w;return i(B,4)}static k($){const p=$/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio($){const p=this.getRelativeLuminance(),w=$.getRelativeLuminance();return p>w?(p+.05)/(w+.05):(w+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan($){const p=this.getRelativeLuminance(),w=$.getRelativeLuminance();return p>w}isDarkerThan($){const p=this.getRelativeLuminance(),w=$.getRelativeLuminance();return p<w}lighten($){return new D(new j(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*$,this.hsla.a))}darken($){return new D(new j(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*$,this.hsla.a))}transparent($){const{r:p,g:w,b:B,a:f}=this.rgba;return new D(new C(p,w,B,f*$))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend($){const p=$.rgba,w=this.rgba.a,B=p.a,f=w+B*(1-w);if(f<1e-6)return D.transparent;const d=this.rgba.r*w/f+p.r*B*(1-w)/f,t=this.rgba.g*w/f+p.g*B*(1-w)/f,s=this.rgba.b*w/f+p.b*B*(1-w)/f;return new D(new C(d,t,s,f))}makeOpaque($){if(this.isOpaque()||$.rgba.a!==1)return this;const{r:p,g:w,b:B,a:f}=this.rgba;return new D(new C($.rgba.r-f*($.rgba.r-p),$.rgba.g-f*($.rgba.g-w),$.rgba.b-f*($.rgba.b-B),1))}flatten(...$){const p=$.reduceRight((w,B)=>D.o(B,w));return D.o(this,p)}static o($,p){const w=1-$.rgba.a;return new D(new C(w*p.rgba.r+$.rgba.a*$.rgba.r,w*p.rgba.g+$.rgba.a*$.rgba.g,w*p.rgba.b+$.rgba.a*$.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor($,p,w){if($.isLighterThan(p))return $;w=w||.5;const B=$.getRelativeLuminance(),f=p.getRelativeLuminance();return w=w*(f-B)/f,$.lighten(w)}static getDarkerColor($,p,w){if($.isDarkerThan(p))return $;w=w||.5;const B=$.getRelativeLuminance(),f=p.getRelativeLuminance();return w=w*(B-f)/B,$.darken(w)}static{this.white=new D(new C(255,255,255,1))}static{this.black=new D(new C(0,0,0,1))}static{this.red=new D(new C(255,0,0,1))}static{this.blue=new D(new C(0,0,255,1))}static{this.green=new D(new C(0,255,0,1))}static{this.cyan=new D(new C(0,255,255,1))}static{this.lightgrey=new D(new C(211,211,211,1))}static{this.transparent=new D(new C(0,0,0,0))}}e.$Bt=D,function(y){let $;(function(p){let w;(function(B){function f(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:y.Format.CSS.formatRGBA(r)}B.formatRGB=f;function d(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}B.formatRGBA=d;function t(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(r)}B.formatHSL=t;function s(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}B.formatHSLA=s;function a(r){const A=r.toString(16);return A.length!==2?"0"+A:A}function m(r){return`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}`}B.formatHex=m;function u(r,A=!1){return A&&r.rgba.a===1?y.Format.CSS.formatHex(r):`#${a(r.rgba.r)}${a(r.rgba.g)}${a(r.rgba.b)}${a(Math.round(r.rgba.a*255))}`}B.formatHexA=u;function k(r){return r.isOpaque()?y.Format.CSS.formatHex(r):y.Format.CSS.formatRGBA(r)}B.format=k;function l(r){const A=r.length;if(A===0||r.charCodeAt(0)!==35)return null;if(A===7){const R=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),I=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),O=16*b(r.charCodeAt(5))+b(r.charCodeAt(6));return new y(new C(R,I,O,1))}if(A===9){const R=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),I=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),O=16*b(r.charCodeAt(5))+b(r.charCodeAt(6)),z=16*b(r.charCodeAt(7))+b(r.charCodeAt(8));return new y(new C(R,I,O,z/255))}if(A===4){const R=b(r.charCodeAt(1)),I=b(r.charCodeAt(2)),O=b(r.charCodeAt(3));return new y(new C(16*R+R,16*I+I,16*O+O))}if(A===5){const R=b(r.charCodeAt(1)),I=b(r.charCodeAt(2)),O=b(r.charCodeAt(3)),z=b(r.charCodeAt(4));return new y(new C(16*R+R,16*I+I,16*O+O,(16*z+z)/255))}return null}B.parseHex=l;function b(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=p.CSS||(p.CSS={}))})($=y.Format||(y.Format={}))}(D||(e.$Bt=D={}))}),define(me[28],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function i(D){return(y,$,p)=>{let w=null,B=null;if(typeof p.value=="function"?(w="value",B=p.value):typeof p.get=="function"&&(w="get",B=p.get),!B)throw new Error("not supported");p[w]=D(B,$)}}function C(D,y,$){let p=null,w=null;if(typeof $.value=="function"?(p="value",w=$.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(p="get",w=$.get),!w)throw new Error("not supported");const B=`$memoize$${y}`;$[p]=function(...f){return this.hasOwnProperty(B)||Object.defineProperty(this,B,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,f)}),this[B]}}e.$Kh=C;function j(D,y,$){return i((p,w)=>{const B=`$debounce$${w}`,f=`$debounce$result$${w}`;return function(...d){this[f]||(this[f]=$?$():void 0),clearTimeout(this[B]),y&&(this[f]=y(this[f],...d),d=[this[f]]),this[B]=setTimeout(()=>{p.apply(this,d),this[f]=$?$():void 0},D)}})}e.$Lh=j;function W(D,y,$){return i((p,w)=>{const B=`$throttle$timer$${w}`,f=`$throttle$result$${w}`,d=`$throttle$lastRun$${w}`,t=`$throttle$pending$${w}`;return function(...s){if(this[f]||(this[f]=$?$():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),y&&(this[f]=y(this[f],...s)),this[t])return;const a=this[d]+D;a<=Date.now()?(this[d]=Date.now(),p.apply(this,[this[f]]),this[f]=$?$():void 0):(this[t]=!0,this[B]=setTimeout(()=>{this[t]=!1,this[d]=Date.now(),p.apply(this,[this[f]]),this[f]=$?$():void 0},a-Date.now()))}})}e.$Mh=W}),define(me[78],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=void 0;class i{constructor(j,W,D,y){this.originalStart=j,this.originalLength=W,this.modifiedStart=D,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}e.$at=i}),define(me[6],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class i{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?k.isErrorNoTelemetry(r)?new k(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(A=>{A(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.$W=i,e.$X=new i;function C(b){e.$X.setUnexpectedErrorHandler(b)}e.setUnexpectedErrorHandler=C;function j(b){if(!b||typeof b!="object")return!1;const r=b;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.$Z=j;function W(b){p(b)||e.$X.onUnexpectedError(b)}e.$1=W;function D(b){p(b)||e.$X.onUnexpectedExternalError(b)}e.$2=D;function y(b){if(b instanceof Error){const{name:r,message:A}=b,R=b.stacktrace||b.stack;return{$isError:!0,name:r,message:A,stack:R,noTelemetry:k.isErrorNoTelemetry(b)}}return b}e.$3=y;const $="Canceled";function p(b){return b instanceof w?!0:b instanceof Error&&b.name===$&&b.message===$}e.$4=p;class w extends Error{constructor(){super($),this.name=this.message}}e.$5=w;function B(){const b=new Error($);return b.name=b.message,b}e.$6=B;function f(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}e.$7=f;function d(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}e.$8=d;class t extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=t;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}e.$0=s;class a extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.$$=a;class m extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.$_=m;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class k extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof k)return r;const A=new k;return A.message=r.message,A.stack=r.stack,A}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.$bb=k;class l extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}e.$cb=l}),define(me[12],$e([1,0,6,75]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function j(K,g=0){return K[K.length-(1+g)]}e.$sb=j;function W(K){if(K.length===0)throw new Error("Invalid tail call");return[K.slice(0,K.length-1),K[K.length-1]]}e.$tb=W;function D(K,g,E=(N,o)=>N===o){if(K===g)return!0;if(!K||!g||K.length!==g.length)return!1;for(let N=0,o=K.length;N<o;N++)if(!E(K[N],g[N]))return!1;return!0}e.$ub=D;function y(K,g){const E=K.length-1;g<E&&(K[g]=K[E]),K.pop()}e.$vb=y;function $(K,g,E){return p(K.length,N=>E(K[N],g))}e.$wb=$;function p(K,g){let E=0,N=K-1;for(;E<=N;){const o=(E+N)/2|0,c=g(o);if(c<0)E=o+1;else if(c>0)N=o-1;else return o}return-(E+1)}e.$xb=p;function w(K,g,E){if(K=K|0,K>=g.length)throw new TypeError("invalid index");const N=g[Math.floor(g.length*Math.random())],o=[],c=[],n=[];for(const h of g){const F=E(h,N);F<0?o.push(h):F>0?c.push(h):n.push(h)}return K<o.length?w(K,o,E):K<o.length+n.length?n[0]:w(K-(o.length+n.length),c,E)}e.$yb=w;function B(K,g){const E=[];let N;for(const o of K.slice(0).sort(g))!N||g(N[0],o)!==0?(N=[o],E.push(N)):N.push(o);return E}e.$zb=B;function*f(K,g){let E,N;for(const o of K)N!==void 0&&g(N,o)?E.push(o):(E&&(yield E),E=[o]),N=o;E&&(yield E)}e.$Ab=f;function d(K,g){for(let E=0;E<=K.length;E++)g(E===0?void 0:K[E-1],E===K.length?void 0:K[E])}e.$Bb=d;function t(K,g){for(let E=0;E<K.length;E++)g(E===0?void 0:K[E-1],K[E],E+1===K.length?void 0:K[E+1])}e.$Cb=t;function s(K,g,E){const N=[];function o(h,F,T){if(F===0&&T.length===0)return;const P=N[N.length-1];P&&P.start+P.deleteCount===h?(P.deleteCount+=F,P.toInsert.push(...T)):N.push({start:h,deleteCount:F,toInsert:T})}let c=0,n=0;for(;;){if(c===K.length){o(c,0,g.slice(n));break}if(n===g.length){o(c,K.length-c,[]);break}const h=K[c],F=g[n],T=E(h,F);T===0?(c+=1,n+=1):T<0?(o(c,1,[]),c+=1):T>0&&(o(c,0,[F]),n+=1)}return N}e.$Db=s;function a(K,g,E){const N=s(K,g,E),o=[],c=[];for(const n of N)o.push(...K.slice(n.start,n.start+n.deleteCount)),c.push(...n.toInsert);return{removed:o,added:c}}e.$Eb=a;function m(K,g,E){if(E===0)return[];const N=K.slice(0,E).sort(g);return k(K,g,N,E,K.length),N}e.top=m;function u(K,g,E,N,o){return E===0?Promise.resolve([]):new Promise((c,n)=>{(async()=>{const h=K.length,F=K.slice(0,E).sort(g);for(let T=E,P=Math.min(E+N,h);T<h;T=P,P=Math.min(P+N,h)){if(T>E&&await new Promise(q=>setTimeout(q)),o&&o.isCancellationRequested)throw new i.$5;k(K,g,F,T,P)}return F})().then(c,n)})}e.$Gb=u;function k(K,g,E,N,o){for(const c=E.length;N<o;N++){const n=K[N];if(g(n,E[c-1])<0){E.pop();const h=(0,C.$kb)(E,F=>g(n,F)<0);E.splice(h,0,n)}}}function l(K){return K.filter(g=>!!g)}e.$Hb=l;function b(K){let g=0;for(let E=0;E<K.length;E++)K[E]&&(K[g]=K[E],g+=1);K.length=g}e.$Ib=b;function r(K,g,E){K.splice(E,0,K.splice(g,1)[0])}e.$Jb=r;function A(K){return!Array.isArray(K)||K.length===0}e.$Kb=A;function R(K){return Array.isArray(K)&&K.length>0}e.$Lb=R;function I(K,g=E=>E){const E=new Set;return K.filter(N=>{const o=g(N);return E.has(o)?!1:(E.add(o),!0)})}e.$Mb=I;function O(K){const g=new Set;return E=>{const N=K(E);return g.has(N)?!1:(g.add(N),!0)}}e.$Nb=O;function z(K,g){return K.length>0?K[0]:g}e.$Ob=z;function v(K,g){return K.length>0?K[K.length-1]:g}e.$Pb=v;function H(K,g,E=(N,o)=>N===o){let N=0;for(let o=0,c=Math.min(K.length,g.length);o<c&&E(K[o],g[o]);o++)N++;return N}e.$Qb=H;function V(K){return[].concat(...K)}e.$Rb=V;function S(K,g){let E=typeof g=="number"?K:0;typeof g=="number"?E=K:(E=0,g=K);const N=[];if(E<=g)for(let o=E;o<g;o++)N.push(o);else for(let o=E;o>g;o--)N.push(o);return N}e.$Sb=S;function L(K,g,E){return K.reduce((N,o)=>(N[g(o)]=E?E(o):o,N),Object.create(null))}e.$Tb=L;function M(K,g){return K.push(g),()=>X(K,g)}e.$Ub=M;function X(K,g){const E=K.indexOf(g);if(E>-1)return K.splice(E,1),g}e.$Vb=X;function U(K,g,E){const N=K.slice(0,g),o=K.slice(g);return N.concat(E,o)}e.$Wb=U;function de(K,g){let E;if(typeof g=="number"){let N=g;E=()=>{const o=Math.sin(N++)*179426549;return o-Math.floor(o)}}else E=Math.random;for(let N=K.length-1;N>0;N-=1){const o=Math.floor(E()*(N+1)),c=K[N];K[N]=K[o],K[o]=c}}e.$Xb=de;function he(K,g){const E=K.indexOf(g);E>-1&&(K.splice(E,1),K.unshift(g))}e.$Yb=he;function ne(K,g){const E=K.indexOf(g);E>-1&&(K.splice(E,1),K.push(g))}e.$Zb=ne;function ge(K,g){for(const E of g)K.push(E)}e.$1b=ge;function Fe(K,g){return Array.isArray(K)?K.map(g):g(K)}e.$2b=Fe;function Ce(K){return Array.isArray(K)?K:[K]}e.$3b=Ce;function Be(K){return K[Math.floor(Math.random()*K.length)]}e.$4b=Be;function le(K,g,E){const N=ae(K,g),o=K.length,c=E.length;K.length=o+c;for(let n=o-1;n>=N;n--)K[n+c]=K[n];for(let n=0;n<c;n++)K[n+N]=E[n]}e.$5b=le;function _(K,g,E,N){const o=ae(K,g);let c=K.splice(o,E);return c===void 0&&(c=[]),le(K,o,N),c}e.$6b=_;function ae(K,g){return g<0?Math.max(g+K.length,0):Math.min(g,K.length)}var oe;(function(K){function g(c){return c<0}K.isLessThan=g;function E(c){return c<=0}K.isLessThanOrEqual=E;function N(c){return c>0}K.isGreaterThan=N;function o(c){return c===0}K.isNeitherLessOrGreaterThan=o,K.greaterThan=1,K.lessThan=-1,K.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function J(K,g){return(E,N)=>g(K(E),K(N))}e.$7b=J;function G(...K){return(g,E)=>{for(const N of K){const o=N(g,E);if(!oe.isNeitherLessOrGreaterThan(o))return o}return oe.neitherLessOrGreaterThan}}e.$8b=G;const ie=(K,g)=>K-g;e.$9b=ie;const ce=(K,g)=>(0,e.$9b)(K?1:0,g?1:0);e.$0b=ce;function De(K){return(g,E)=>-K(g,E)}e.$$b=De;class Ne{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let E=this.c;for(;E<this.g.length&&g(this.g[E]);)E++;const N=E===this.c?null:this.g.slice(this.c,E);return this.c=E,N}takeFromEndWhile(g){let E=this.d;for(;E>=0&&g(this.g[E]);)E--;const N=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,N}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const E=this.g.slice(this.c,this.c+g);return this.c+=g,E}}e.$_b=Ne;class ye{static{this.empty=new ye(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(E=>(g(E),!0))}toArray(){const g=[];return this.iterate(E=>(g.push(E),!0)),g}filter(g){return new ye(E=>this.iterate(N=>g(N)?E(N):!0))}map(g){return new ye(E=>this.iterate(N=>E(g(N))))}some(g){let E=!1;return this.iterate(N=>(E=g(N),!E)),E}findFirst(g){let E;return this.iterate(N=>g(N)?(E=N,!1):!0),E}findLast(g){let E;return this.iterate(N=>(g(N)&&(E=N),!0)),E}findLastMaxBy(g){let E,N=!0;return this.iterate(o=>((N||oe.isGreaterThan(g(o,E)))&&(N=!1,E=o),!0)),E}}e.$ac=ye}),define(me[79],$e([1,0,6]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function C(p,w){if(!p)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=C;function j(p,w="Unreachable"){throw new Error(w)}e.$9c=j;function W(p){if(!p)throw new i.$cb("Assertion Failed")}e.$0c=W;function D(p){p||(0,i.$1)(new i.$cb("Soft Assertion Failed"))}e.$$c=D;function y(p){if(!p()){debugger;p(),(0,i.$1)(new i.$cb("Assertion Failed"))}}e.$_c=y;function $(p,w){let B=0;for(;B<p.length-1;){const f=p[B],d=p[B+1];if(!w(f,d))return!1;B++}return!0}e.$ad=$}),define(me[47],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function i(C,j){const W=this;let D=!1,y;return function(){if(D)return y;if(D=!0,j)try{y=C.apply(W,arguments)}finally{j()}else y=C.apply(W,arguments);return y}}e.$db=i}),define(me[80],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=e.$uO=void 0;class i{constructor(j){this.a=j,this.b=0}nextId(){return this.a+ ++this.b}}e.$uO=i,e.$vO=new i("id#")}),define(me[29],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var i;(function(C){function j(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}C.is=j;const W=Object.freeze([]);function D(){return W}C.empty=D;function*y(r){yield r}C.single=y;function $(r){return j(r)?r:y(r)}C.wrap=$;function p(r){return r||W}C.from=p;function*w(r){for(let A=r.length-1;A>=0;A--)yield r[A]}C.reverse=w;function B(r){return!r||r[Symbol.iterator]().next().done===!0}C.isEmpty=B;function f(r){return r[Symbol.iterator]().next().value}C.first=f;function d(r,A){for(const R of r)if(A(R))return!0;return!1}C.some=d;function t(r,A){for(const R of r)if(A(R))return R}C.find=t;function*s(r,A){for(const R of r)A(R)&&(yield R)}C.filter=s;function*a(r,A){let R=0;for(const I of r)yield A(I,R++)}C.map=a;function*m(...r){for(const A of r)yield*A}C.concat=m;function u(r,A,R){let I=R;for(const O of r)I=A(I,O);return I}C.reduce=u;function*k(r,A,R=r.length){for(A<0&&(A+=r.length),R<0?R+=r.length:R>r.length&&(R=r.length);A<R;A++)yield r[A]}C.slice=k;function l(r,A=Number.POSITIVE_INFINITY){const R=[];if(A===0)return[R,r];const I=r[Symbol.iterator]();for(let O=0;O<A;O++){const z=I.next();if(z.done)return[R,C.empty()];R.push(z.value)}return[R,{[Symbol.iterator](){return I}}]}C.consume=l;async function b(r){const A=[];for await(const R of r)A.push(R);return Promise.resolve(A)}C.asyncToArray=b})(i||(e.Iterable=i={}))}),define(me[48],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.KeyMod=e.KeyCodeUtils=e.$ir=e.$hr=e.$gr=e.$fr=e.$er=e.ScanCode=e.KeyCode=void 0;var i;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.F20=78]="F20",t[t.F21=79]="F21",t[t.F22=80]="F22",t[t.F23=81]="F23",t[t.F24=82]="F24",t[t.NumLock=83]="NumLock",t[t.ScrollLock=84]="ScrollLock",t[t.Semicolon=85]="Semicolon",t[t.Equal=86]="Equal",t[t.Comma=87]="Comma",t[t.Minus=88]="Minus",t[t.Period=89]="Period",t[t.Slash=90]="Slash",t[t.Backquote=91]="Backquote",t[t.BracketLeft=92]="BracketLeft",t[t.Backslash=93]="Backslash",t[t.BracketRight=94]="BracketRight",t[t.Quote=95]="Quote",t[t.OEM_8=96]="OEM_8",t[t.IntlBackslash=97]="IntlBackslash",t[t.Numpad0=98]="Numpad0",t[t.Numpad1=99]="Numpad1",t[t.Numpad2=100]="Numpad2",t[t.Numpad3=101]="Numpad3",t[t.Numpad4=102]="Numpad4",t[t.Numpad5=103]="Numpad5",t[t.Numpad6=104]="Numpad6",t[t.Numpad7=105]="Numpad7",t[t.Numpad8=106]="Numpad8",t[t.Numpad9=107]="Numpad9",t[t.NumpadMultiply=108]="NumpadMultiply",t[t.NumpadAdd=109]="NumpadAdd",t[t.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=111]="NumpadSubtract",t[t.NumpadDecimal=112]="NumpadDecimal",t[t.NumpadDivide=113]="NumpadDivide",t[t.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",t[t.ABNT_C1=115]="ABNT_C1",t[t.ABNT_C2=116]="ABNT_C2",t[t.AudioVolumeMute=117]="AudioVolumeMute",t[t.AudioVolumeUp=118]="AudioVolumeUp",t[t.AudioVolumeDown=119]="AudioVolumeDown",t[t.BrowserSearch=120]="BrowserSearch",t[t.BrowserHome=121]="BrowserHome",t[t.BrowserBack=122]="BrowserBack",t[t.BrowserForward=123]="BrowserForward",t[t.MediaTrackNext=124]="MediaTrackNext",t[t.MediaTrackPrevious=125]="MediaTrackPrevious",t[t.MediaStop=126]="MediaStop",t[t.MediaPlayPause=127]="MediaPlayPause",t[t.LaunchMediaPlayer=128]="LaunchMediaPlayer",t[t.LaunchMail=129]="LaunchMail",t[t.LaunchApp2=130]="LaunchApp2",t[t.Clear=131]="Clear",t[t.MAX_VALUE=132]="MAX_VALUE"})(i||(e.KeyCode=i={}));var C;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(C||(e.ScanCode=C={}));class j{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,a){this._keyCodeToStr[s]=a,this._strToKeyCode[a.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const W=new j,D=new j,y=new j;e.$er=new Array(230),e.$fr={};const $=[],p=Object.create(null),w=Object.create(null);e.$gr={lowerCaseToEnum:t=>w[t]||0,toEnum:t=>p[t]||0,toString:t=>$[t]||"None"},e.$hr=[],e.$ir=[];for(let t=0;t<=193;t++)e.$hr[t]=-1;for(let t=0;t<=132;t++)e.$ir[t]=-1;(function(){const t="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[1,1,"Hyper",0,t,0,t,t,t],[1,2,"Super",0,t,0,t,t,t],[1,3,"Fn",0,t,0,t,t,t],[1,4,"FnLock",0,t,0,t,t,t],[1,5,"Suspend",0,t,0,t,t,t],[1,6,"Resume",0,t,0,t,t,t],[1,7,"Turbo",0,t,0,t,t,t],[1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[1,9,"WakeUp",0,t,0,t,t,t],[0,10,"KeyA",31,"A",65,"VK_A",t,t],[0,11,"KeyB",32,"B",66,"VK_B",t,t],[0,12,"KeyC",33,"C",67,"VK_C",t,t],[0,13,"KeyD",34,"D",68,"VK_D",t,t],[0,14,"KeyE",35,"E",69,"VK_E",t,t],[0,15,"KeyF",36,"F",70,"VK_F",t,t],[0,16,"KeyG",37,"G",71,"VK_G",t,t],[0,17,"KeyH",38,"H",72,"VK_H",t,t],[0,18,"KeyI",39,"I",73,"VK_I",t,t],[0,19,"KeyJ",40,"J",74,"VK_J",t,t],[0,20,"KeyK",41,"K",75,"VK_K",t,t],[0,21,"KeyL",42,"L",76,"VK_L",t,t],[0,22,"KeyM",43,"M",77,"VK_M",t,t],[0,23,"KeyN",44,"N",78,"VK_N",t,t],[0,24,"KeyO",45,"O",79,"VK_O",t,t],[0,25,"KeyP",46,"P",80,"VK_P",t,t],[0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[0,27,"KeyR",48,"R",82,"VK_R",t,t],[0,28,"KeyS",49,"S",83,"VK_S",t,t],[0,29,"KeyT",50,"T",84,"VK_T",t,t],[0,30,"KeyU",51,"U",85,"VK_U",t,t],[0,31,"KeyV",52,"V",86,"VK_V",t,t],[0,32,"KeyW",53,"W",87,"VK_W",t,t],[0,33,"KeyX",54,"X",88,"VK_X",t,t],[0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[0,36,"Digit1",22,"1",49,"VK_1",t,t],[0,37,"Digit2",23,"2",50,"VK_2",t,t],[0,38,"Digit3",24,"3",51,"VK_3",t,t],[0,39,"Digit4",25,"4",52,"VK_4",t,t],[0,40,"Digit5",26,"5",53,"VK_5",t,t],[0,41,"Digit6",27,"6",54,"VK_6",t,t],[0,42,"Digit7",28,"7",55,"VK_7",t,t],[0,43,"Digit8",29,"8",56,"VK_8",t,t],[0,44,"Digit9",30,"9",57,"VK_9",t,t],[0,45,"Digit0",21,"0",48,"VK_0",t,t],[1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,t,0,t,t,t],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[1,64,"F1",59,"F1",112,"VK_F1",t,t],[1,65,"F2",60,"F2",113,"VK_F2",t,t],[1,66,"F3",61,"F3",114,"VK_F3",t,t],[1,67,"F4",62,"F4",115,"VK_F4",t,t],[1,68,"F5",63,"F5",116,"VK_F5",t,t],[1,69,"F6",64,"F6",117,"VK_F6",t,t],[1,70,"F7",65,"F7",118,"VK_F7",t,t],[1,71,"F8",66,"F8",119,"VK_F8",t,t],[1,72,"F9",67,"F9",120,"VK_F9",t,t],[1,73,"F10",68,"F10",121,"VK_F10",t,t],[1,74,"F11",69,"F11",122,"VK_F11",t,t],[1,75,"F12",70,"F12",123,"VK_F12",t,t],[1,76,"PrintScreen",0,t,0,t,t,t],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",t,t],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[1,80,"Home",14,"Home",36,"VK_HOME",t,t],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[1,83,"End",13,"End",35,"VK_END",t,t],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",t,t],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",t,t],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",t,t],[1,94,"NumpadEnter",3,t,0,t,t,t],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",t,t],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",t,t],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",t,t],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",t,t],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",t,t],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",t,t],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",t,t],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",t,t],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",t,t],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",t,t],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",t,t],[1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[1,108,"Power",0,t,0,t,t,t],[1,109,"NumpadEqual",0,t,0,t,t,t],[1,110,"F13",71,"F13",124,"VK_F13",t,t],[1,111,"F14",72,"F14",125,"VK_F14",t,t],[1,112,"F15",73,"F15",126,"VK_F15",t,t],[1,113,"F16",74,"F16",127,"VK_F16",t,t],[1,114,"F17",75,"F17",128,"VK_F17",t,t],[1,115,"F18",76,"F18",129,"VK_F18",t,t],[1,116,"F19",77,"F19",130,"VK_F19",t,t],[1,117,"F20",78,"F20",131,"VK_F20",t,t],[1,118,"F21",79,"F21",132,"VK_F21",t,t],[1,119,"F22",80,"F22",133,"VK_F22",t,t],[1,120,"F23",81,"F23",134,"VK_F23",t,t],[1,121,"F24",82,"F24",135,"VK_F24",t,t],[1,122,"Open",0,t,0,t,t,t],[1,123,"Help",0,t,0,t,t,t],[1,124,"Select",0,t,0,t,t,t],[1,125,"Again",0,t,0,t,t,t],[1,126,"Undo",0,t,0,t,t,t],[1,127,"Cut",0,t,0,t,t,t],[1,128,"Copy",0,t,0,t,t,t],[1,129,"Paste",0,t,0,t,t,t],[1,130,"Find",0,t,0,t,t,t],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",t,t],[1,136,"KanaMode",0,t,0,t,t,t],[0,137,"IntlYen",0,t,0,t,t,t],[1,138,"Convert",0,t,0,t,t,t],[1,139,"NonConvert",0,t,0,t,t,t],[1,140,"Lang1",0,t,0,t,t,t],[1,141,"Lang2",0,t,0,t,t,t],[1,142,"Lang3",0,t,0,t,t,t],[1,143,"Lang4",0,t,0,t,t,t],[1,144,"Lang5",0,t,0,t,t,t],[1,145,"Abort",0,t,0,t,t,t],[1,146,"Props",0,t,0,t,t,t],[1,147,"NumpadParenLeft",0,t,0,t,t,t],[1,148,"NumpadParenRight",0,t,0,t,t,t],[1,149,"NumpadBackspace",0,t,0,t,t,t],[1,150,"NumpadMemoryStore",0,t,0,t,t,t],[1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[1,152,"NumpadMemoryClear",0,t,0,t,t,t],[1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",t,t],[1,156,"NumpadClearEntry",0,t,0,t,t,t],[1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[1,0,t,6,"Alt",18,"VK_MENU",t,t],[1,0,t,57,"Meta",91,"VK_COMMAND",t,t],[1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[1,165,"BrightnessUp",0,t,0,t,t,t],[1,166,"BrightnessDown",0,t,0,t,t,t],[1,167,"MediaPlay",0,t,0,t,t,t],[1,168,"MediaRecord",0,t,0,t,t,t],[1,169,"MediaFastForward",0,t,0,t,t,t],[1,170,"MediaRewind",0,t,0,t,t,t],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",t,t],[1,174,"Eject",0,t,0,t,t,t],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[1,180,"SelectTask",0,t,0,t,t,t],[1,181,"LaunchScreenSaver",0,t,0,t,t,t],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[1,189,"ZoomToggle",0,t,0,t,t,t],[1,190,"MailReply",0,t,0,t,t,t],[1,191,"MailForward",0,t,0,t,t,t],[1,192,"MailSend",0,t,0,t,t,t],[1,0,t,114,"KeyInComposition",229,t,t,t],[1,0,t,116,"ABNT_C2",194,"VK_ABNT_C2",t,t],[1,0,t,96,"OEM_8",223,"VK_OEM_8",t,t],[1,0,t,0,t,0,"VK_KANA",t,t],[1,0,t,0,t,0,"VK_HANGUL",t,t],[1,0,t,0,t,0,"VK_JUNJA",t,t],[1,0,t,0,t,0,"VK_FINAL",t,t],[1,0,t,0,t,0,"VK_HANJA",t,t],[1,0,t,0,t,0,"VK_KANJI",t,t],[1,0,t,0,t,0,"VK_CONVERT",t,t],[1,0,t,0,t,0,"VK_NONCONVERT",t,t],[1,0,t,0,t,0,"VK_ACCEPT",t,t],[1,0,t,0,t,0,"VK_MODECHANGE",t,t],[1,0,t,0,t,0,"VK_SELECT",t,t],[1,0,t,0,t,0,"VK_PRINT",t,t],[1,0,t,0,t,0,"VK_EXECUTE",t,t],[1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[1,0,t,0,t,0,"VK_HELP",t,t],[1,0,t,0,t,0,"VK_APPS",t,t],[1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[1,0,t,0,t,0,"VK_PACKET",t,t],[1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[1,0,t,0,t,0,"VK_ATTN",t,t],[1,0,t,0,t,0,"VK_CRSEL",t,t],[1,0,t,0,t,0,"VK_EXSEL",t,t],[1,0,t,0,t,0,"VK_EREOF",t,t],[1,0,t,0,t,0,"VK_PLAY",t,t],[1,0,t,0,t,0,"VK_ZOOM",t,t],[1,0,t,0,t,0,"VK_NONAME",t,t],[1,0,t,0,t,0,"VK_PA1",t,t],[1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]],a=[],m=[];for(const u of s){const[k,l,b,r,A,R,I,O,z]=u;if(m[l]||(m[l]=!0,$[l]=b,p[b]=l,w[b.toLowerCase()]=l,k&&(e.$hr[l]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(e.$ir[r]=l))),!a[r]){if(a[r]=!0,!A)throw new Error(`String representation missing for key code ${r} around scan code ${b}`);W.define(r,A),D.define(r,O||A),y.define(r,z||O||A)}R&&(e.$er[R]=r),I&&(e.$fr[I]=r)}e.$ir[3]=46})();var B;(function(t){function s(b){return W.keyCodeToStr(b)}t.toString=s;function a(b){return W.strToKeyCode(b)}t.fromString=a;function m(b){return D.keyCodeToStr(b)}t.toUserSettingsUS=m;function u(b){return y.keyCodeToStr(b)}t.toUserSettingsGeneral=u;function k(b){return D.strToKeyCode(b)||y.strToKeyCode(b)}t.fromUserSettings=k;function l(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(b)}t.toElectronAccelerator=l})(B||(e.KeyCodeUtils=B={}));var f;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(f||(e.KeyMod=f={}));function d(t,s){const a=(s&65535)<<16>>>0;return(t|a)>>>0}e.$jr=d}),define(me[81],$e([1,0,6]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=e.$pr=e.$or=e.$nr=e.$mr=e.$lr=e.$kr=void 0;var C;(function(B){B[B.CtrlCmd=2048]="CtrlCmd",B[B.Shift=1024]="Shift",B[B.Alt=512]="Alt",B[B.WinCtrl=256]="WinCtrl",B[B.KeyCode=255]="KeyCode"})(C||(C={}));function j(B,f){if(typeof B=="number"){if(B===0)return null;const d=(B&65535)>>>0,t=(B&4294901760)>>>16;return t!==0?new $([W(d,f),W(t,f)]):new $([W(d,f)])}else{const d=[];for(let t=0;t<B.length;t++)d.push(W(B[t],f));return new $(d)}}e.$kr=j;function W(B,f){const d=!!(B&2048),t=!!(B&256),s=f===2?t:d,a=!!(B&1024),m=!!(B&512),u=f===2?d:t,k=B&255;return new D(s,a,m,u,k)}e.$lr=W;class D{constructor(f,d,t,s,a){this.ctrlKey=f,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyCode=a}equals(f){return f instanceof D&&this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.keyCode===f.keyCode}getHashCode(){const f=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${f}${d}${t}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new $([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.$mr=D;class y{constructor(f,d,t,s,a){this.ctrlKey=f,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.scanCode=a}equals(f){return f instanceof y&&this.ctrlKey===f.ctrlKey&&this.shiftKey===f.shiftKey&&this.altKey===f.altKey&&this.metaKey===f.metaKey&&this.scanCode===f.scanCode}getHashCode(){const f=this.ctrlKey?"1":"0",d=this.shiftKey?"1":"0",t=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${f}${d}${t}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.$nr=y;class ${constructor(f){if(f.length===0)throw(0,i.$7)("chords");this.chords=f}getHashCode(){let f="";for(let d=0,t=this.chords.length;d<t;d++)d!==0&&(f+=";"),f+=this.chords[d].getHashCode();return f}equals(f){if(f===null||this.chords.length!==f.chords.length)return!1;for(let d=0;d<this.chords.length;d++)if(!this.chords[d].equals(f.chords[d]))return!1;return!0}}e.$or=$;class p{constructor(f,d,t,s,a,m){this.ctrlKey=f,this.shiftKey=d,this.altKey=t,this.metaKey=s,this.keyLabel=a,this.keyAriaLabel=m}}e.$pr=p;class w{}e.$qr=w}),define(me[23],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class i{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=i}),define(me[16],$e([1,0,23]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PS=e.$OS=e.$NS=void 0;let j=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const W=new i.$V(()=>j("mouse",!1)),D=new i.$V(()=>j("element",!1));function y(w){j=w}e.$NS=y;function $(w){return w==="element"?D.value:W.value}e.$OS=$;function p(){return j("element",!0)}e.$PS=p}),define(me[49],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class i{static{this.Undefined=new i(void 0)}constructor(W){this.element=W,this.next=i.Undefined,this.prev=i.Undefined}}class C{constructor(){this.a=i.Undefined,this.b=i.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===i.Undefined}clear(){let W=this.a;for(;W!==i.Undefined;){const D=W.next;W.prev=i.Undefined,W.next=i.Undefined,W=D}this.a=i.Undefined,this.b=i.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,D){const y=new i(W);if(this.a===i.Undefined)this.a=y,this.b=y;else if(D){const p=this.b;this.b=y,y.prev=p,p.next=y}else{const p=this.a;this.a=y,y.next=p,p.prev=y}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(y))}}shift(){if(this.a!==i.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==i.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==i.Undefined&&W.next!==i.Undefined){const D=W.prev;D.next=W.next,W.next.prev=D}else W.prev===i.Undefined&&W.next===i.Undefined?(this.a=i.Undefined,this.b=i.Undefined):W.next===i.Undefined?(this.b=this.b.prev,this.b.next=i.Undefined):W.prev===i.Undefined&&(this.a=this.a.next,this.a.prev=i.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==i.Undefined;)yield W.element,W=W.next}}e.$4c=C}),define(me[33],$e([1,0]),function(re,e){"use strict";var i,C,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function W(k,l,b){let r=k.get(l);return r===void 0&&(r=b,k.set(l,r)),r}e.$xc=W;function D(k){const l=[];return k.forEach((b,r)=>{l.push(`${r} => ${b}`)}),`Map(${k.size}) {${l.join(", ")}}`}e.$yc=D;function y(k){const l=[];return k.forEach(b=>{l.push(b)}),`Set(${k.size}) {${l.join(", ")}}`}e.$zc=y;class ${constructor(l,b){this.uri=l,this.value=b}}function p(k){return Array.isArray(k)}class w{static{this.c=l=>l.toString()}constructor(l,b){if(this[i]="ResourceMap",l instanceof w)this.d=new Map(l.d),this.e=b??w.c;else if(p(l)){this.d=new Map,this.e=b??w.c;for(const[r,A]of l)this.set(r,A)}else this.d=new Map,this.e=l??w.c}set(l,b){return this.d.set(this.e(l),new $(l,b)),this}get(l){return this.d.get(this.e(l))?.value}has(l){return this.d.has(this.e(l))}get size(){return this.d.size}clear(){this.d.clear()}delete(l){return this.d.delete(this.e(l))}forEach(l,b){typeof b<"u"&&(l=l.bind(b));for(const[r,A]of this.d)l(A.value,A.uri,this)}*values(){for(const l of this.d.values())yield l.value}*keys(){for(const l of this.d.values())yield l.uri}*entries(){for(const l of this.d.values())yield[l.uri,l.value]}*[(i=Symbol.toStringTag,Symbol.iterator)](){for(const[,l]of this.d)yield[l.uri,l.value]}}e.$Ac=w;class B{constructor(l,b){this[C]="ResourceSet",!l||typeof l=="function"?this.c=new w(l):(this.c=new w(b),l.forEach(this.add,this))}get size(){return this.c.size}add(l){return this.c.set(l,l),this}clear(){this.c.clear()}delete(l){return this.c.delete(l)}forEach(l,b){this.c.forEach((r,A)=>l.call(b,A,A,this))}has(l){return this.c.has(l)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=B;var f;(function(k){k[k.None=0]="None",k[k.AsOld=1]="AsOld",k[k.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class d{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(l){return this.c.has(l)}get(l,b=0){const r=this.c.get(l);if(r)return b!==0&&this.l(r,b),r.value}set(l,b,r=0){let A=this.c.get(l);if(A)A.value=b,r!==0&&this.l(A,r);else{switch(A={key:l,value:b,next:void 0,previous:void 0},r){case 0:this.j(A);break;case 1:this.i(A);break;case 2:this.j(A);break;default:this.j(A);break}this.c.set(l,A),this.f++}return this}delete(l){return!!this.remove(l)}remove(l){const b=this.c.get(l);if(b)return this.c.delete(l),this.k(b),this.f--,b.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const l=this.d;return this.c.delete(l.key),this.k(l),this.f--,l.value}forEach(l,b){const r=this.g;let A=this.d;for(;A;){if(b?l.bind(b)(A.value,A.key,this):l(A.value,A.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");A=A.next}}keys(){const l=this,b=this.g;let r=this.d;const A={[Symbol.iterator](){return A},next(){if(l.g!==b)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:r.key,done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return A}values(){const l=this,b=this.g;let r=this.d;const A={[Symbol.iterator](){return A},next(){if(l.g!==b)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:r.value,done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return A}entries(){const l=this,b=this.g;let r=this.d;const A={[Symbol.iterator](){return A},next(){if(l.g!==b)throw new Error("LinkedMap got modified during iteration.");if(r){const R={value:[r.key,r.value],done:!1};return r=r.next,R}else return{value:void 0,done:!0}}};return A}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(l){if(l>=this.size)return;if(l===0){this.clear();return}let b=this.d,r=this.size;for(;b&&r>l;)this.c.delete(b.key),b=b.next,r--;this.d=b,this.f=r,b&&(b.previous=void 0),this.g++}i(l){if(!this.d&&!this.e)this.e=l;else if(this.d)l.next=this.d,this.d.previous=l;else throw new Error("Invalid list");this.d=l,this.g++}j(l){if(!this.d&&!this.e)this.d=l;else if(this.e)l.previous=this.e,this.e.next=l;else throw new Error("Invalid list");this.e=l,this.g++}k(l){if(l===this.d&&l===this.e)this.d=void 0,this.e=void 0;else if(l===this.d){if(!l.next)throw new Error("Invalid list");l.next.previous=void 0,this.d=l.next}else if(l===this.e){if(!l.previous)throw new Error("Invalid list");l.previous.next=void 0,this.e=l.previous}else{const b=l.next,r=l.previous;if(!b||!r)throw new Error("Invalid list");b.previous=r,r.next=b}l.next=void 0,l.previous=void 0,this.g++}l(l,b){if(!this.d||!this.e)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(l===this.d)return;const r=l.next,A=l.previous;l===this.e?(A.next=void 0,this.e=A):(r.previous=A,A.next=r),l.previous=void 0,l.next=this.d,this.d.previous=l,this.d=l,this.g++}else if(b===2){if(l===this.e)return;const r=l.next,A=l.previous;l===this.d?(r.previous=void 0,this.d=r):(r.previous=A,A.next=r),l.next=void 0,l.previous=this.e,this.e.next=l,this.e=l,this.g++}}}toJSON(){const l=[];return this.forEach((b,r)=>{l.push([r,b])}),l}fromJSON(l){this.clear();for(const[b,r]of l)this.set(b,r)}}e.$Cc=d;class t extends d{constructor(l,b=1){super(),this.m=l,this.n=Math.min(Math.max(0,b),1)}get limit(){return this.m}set limit(l){this.m=l,this.o()}get ratio(){return this.n}set ratio(l){this.n=Math.min(Math.max(0,l),1),this.o()}get(l,b=2){return super.get(l,b)}peek(l){return super.get(l,0)}set(l,b){return super.set(l,b,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=t;class s{constructor(){this.c=new Map}add(l){return this.c.set(l,(this.c.get(l)||0)+1),this}delete(l){let b=this.c.get(l)||0;return b===0?!1:(b--,b===0?this.c.delete(l):this.c.set(l,b),!0)}has(l){return this.c.has(l)}}e.$Ec=s;class a{constructor(l){if(this.c=new Map,this.d=new Map,l)for(const[b,r]of l)this.set(b,r)}clear(){this.c.clear(),this.d.clear()}set(l,b){this.c.set(l,b),this.d.set(b,l)}get(l){return this.c.get(l)}getKey(l){return this.d.get(l)}delete(l){const b=this.c.get(l);return b===void 0?!1:(this.c.delete(l),this.d.delete(b),!0)}forEach(l,b){this.c.forEach((r,A)=>{l.call(b,r,A,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=a;class m{constructor(){this.c=new Map}add(l,b){let r=this.c.get(l);r||(r=new Set,this.c.set(l,r)),r.add(b)}delete(l,b){const r=this.c.get(l);r&&(r.delete(b),r.size===0&&this.c.delete(l))}forEach(l,b){const r=this.c.get(l);r&&r.forEach(b)}get(l){const b=this.c.get(l);return b||new Set}}e.$Gc=m;function u(k,l){if(k===l)return!0;if(k.size!==l.size)return!1;for(const[b,r]of k)if(!l.has(b)||l.get(b)!==r)return!1;for(const[b]of l)if(!k.has(b))return!1;return!0}e.$Hc=u}),define(me[3],$e([1,0,12,76,33,47,29]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const y=!1;let $=null;class p{constructor(){this.b=new Map}static{this.a=0}c(M){let X=this.b.get(M);return X||(X={parent:null,source:null,isSingleton:!1,value:M,idx:p.a++},this.b.set(M,X)),X}trackDisposable(M){const X=this.c(M);X.source||(X.source=new Error().stack)}setParent(M,X){const U=this.c(M);U.parent=X}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,X){const U=X.get(M);if(U)return U;const de=M.parent?this.f(this.c(M.parent),X):M;return X.set(M,de),de}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,M).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(M=10,X){let U;if(X)U=X;else{const Fe=new Map,Ce=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,Fe).isSingleton);if(Ce.length===0)return;const Be=new Set(Ce.map(le=>le.value));if(U=Ce.filter(le=>!(le.parent&&Be.has(le.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function de(Fe){function Ce(le,_){for(;le.length>0&&_.some(ae=>typeof ae=="string"?ae===le[0]:le[0].match(ae));)le.shift()}const Be=Fe.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ce(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const he=new j.$Gc;for(const Fe of U){const Ce=de(Fe);for(let Be=0;Be<=Ce.length;Be++)he.add(Ce.slice(0,Be).join(`
`),Fe)}U.sort((0,i.$7b)(Fe=>Fe.idx,i.$9b));let ne="",ge=0;for(const Fe of U.slice(0,M)){ge++;const Ce=de(Fe),Be=[];for(let le=0;le<Ce.length;le++){let _=Ce[le];_=`(shared with ${he.get(Ce.slice(0,le+1).join(`
`)).size}/${U.length} leaks) at ${_}`;const oe=he.get(Ce.slice(0,le).join(`
`)),J=(0,C.$K)([...oe].map(G=>de(G)[le]),G=>G);delete J[Ce[le]];for(const[G,ie]of Object.entries(J))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${G}`);Be.unshift(_)}ne+=`


==================== Leaking disposable ${ge}/${U.length}: ${Fe.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return U.length>M&&(ne+=`


... and ${U.length-M} more leaking disposables

`),{leaks:U,details:ne}}}e.$Ic=p;function w(L){$=L}if(e.$Jc=w,y){const L="__is_disposable_tracked__";w(new class{trackDisposable(M){const X=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[L]||console.log(X)},3e3)}setParent(M,X){if(M&&M!==r.None)try{M[L]=!0}catch{}}markAsDisposed(M){if(M&&M!==r.None)try{M[L]=!0}catch{}}markAsSingleton(M){}})}function B(L){return $?.trackDisposable(L),L}e.$Kc=B;function f(L){$?.markAsDisposed(L)}e.$Lc=f;function d(L,M){$?.setParent(L,M)}function t(L,M){if($)for(const X of L)$.setParent(X,M)}function s(L){return $?.markAsSingleton(L),L}e.$Mc=s;function a(L){return typeof L.dispose=="function"&&L.dispose.length===0}e.$Nc=a;function m(L){if(D.Iterable.is(L)){const M=[];for(const X of L)if(X)try{X.dispose()}catch(U){M.push(U)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(L)?[]:L}else if(L)return L.dispose(),L}e.$Oc=m;function u(L){for(const M of L)a(M)&&M.dispose();return[]}e.$Pc=u;function k(...L){const M=l(()=>m(L));return t(L,M),M}e.$Qc=k;function l(L){const M=B({dispose:(0,W.$db)(()=>{f(M),L()})});return M}e.$Rc=l;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,B(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return d(M,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),d(M,null))}}e.$Sc=b;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,B(this),d(this.q,this)}dispose(){f(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=r;class A{constructor(){this.b=!1,B(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&d(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&d(M,null),M}}e.$Uc=A;class R{constructor(M){this.a=new A,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=R;class I{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=I;class O{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,B(this)}set(M){let X=M;return this.unset=()=>X=void 0,this.isset=()=>X!==void 0,this.dispose=()=>{X&&(X(),X=void 0,f(this))},this}}e.$Xc=O;class z{constructor(){this.a=new Map}acquire(M,...X){let U=this.a.get(M);U||(U={counter:0,object:this.b(M,...X)},this.a.set(M,U));const{object:de}=U,he=(0,W.$db)(()=>{--U.counter===0&&(this.c(M,U.object),this.a.delete(M))});return U.counter++,{object:de,dispose:he}}}e.$Yc=z;class v{constructor(M){this.a=M}async acquire(M,...X){const U=this.a.acquire(M,...X);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(de){throw U.dispose(),de}}}e.$Zc=v;class H{constructor(M){this.object=M}dispose(){}}e.$1c=H;function V(L){const M=new b;try{L(M)}finally{M.dispose()}}e.$2c=V;class S{constructor(){this.a=new Map,this.b=!1,B(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,X,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(M)?.dispose(),this.a.set(M,X)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=S}),function(re,e){typeof define=="function"&&define.amd?define(me[82],$e([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(g,E){for(var N=0;N<E.length;N++){var o=E[N];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(g,o.key,o)}}function i(g,E,N){return E&&e(g.prototype,E),N&&e(g,N),Object.defineProperty(g,"prototype",{writable:!1}),g}function C(g,E){if(g){if(typeof g=="string")return j(g,E);var N=Object.prototype.toString.call(g).slice(8,-1);if(N==="Object"&&g.constructor&&(N=g.constructor.name),N==="Map"||N==="Set")return Array.from(g);if(N==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(N))return j(g,E)}}function j(g,E){(E==null||E>g.length)&&(E=g.length);for(var N=0,o=new Array(E);N<E;N++)o[N]=g[N];return o}function W(g,E){var N=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(N)return(N=N.call(g)).next.bind(N);if(Array.isArray(g)||(N=C(g))||E&&g&&typeof g.length=="number"){N&&(g=N);var o=0;return function(){return o>=g.length?{done:!0}:{done:!1,value:g[o++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=D();function y(g){re.defaults=g}var $=/[&<>"']/,p=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,B=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(E){return f[E]};function t(g,E){if(E){if($.test(g))return g.replace(p,d)}else if(w.test(g))return g.replace(B,d);return g}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(g){return g.replace(s,function(E,N){return N=N.toLowerCase(),N==="colon"?":":N.charAt(0)==="#"?N.charAt(1)==="x"?String.fromCharCode(parseInt(N.substring(2),16)):String.fromCharCode(+N.substring(1)):""})}var m=/(^|[^\[])\^/g;function u(g,E){g=typeof g=="string"?g:g.source,E=E||"";var N={replace:function(c,n){return n=n.source||n,n=n.replace(m,"$1"),g=g.replace(c,n),N},getRegex:function(){return new RegExp(g,E)}};return N}var k=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(g,E,N){if(g){var o;try{o=decodeURIComponent(a(N)).replace(k,"").toLowerCase()}catch{return null}if(o.indexOf("javascript:")===0||o.indexOf("vbscript:")===0||o.indexOf("data:")===0)return null}E&&!l.test(N)&&(N=O(E,N));try{N=encodeURI(N).replace(/%25/g,"%")}catch{return null}return N}var r={},A=/^[^:]+:\/*[^/]*$/,R=/^([^:]+:)[\s\S]*$/,I=/^([^:]+:\/*[^/]*)[\s\S]*$/;function O(g,E){r[" "+g]||(A.test(g)?r[" "+g]=g+"/":r[" "+g]=V(g,"/",!0)),g=r[" "+g];var N=g.indexOf(":")===-1;return E.substring(0,2)==="//"?N?E:g.replace(R,"$1")+E:E.charAt(0)==="/"?N?E:g.replace(I,"$1")+E:g+E}var z={exec:function(){}};function v(g){for(var E=1,N,o;E<arguments.length;E++){N=arguments[E];for(o in N)Object.prototype.hasOwnProperty.call(N,o)&&(g[o]=N[o])}return g}function H(g,E){var N=g.replace(/\|/g,function(n,h,F){for(var T=!1,P=h;--P>=0&&F[P]==="\\";)T=!T;return T?"|":" |"}),o=N.split(/ \|/),c=0;if(o[0].trim()||o.shift(),o.length>0&&!o[o.length-1].trim()&&o.pop(),o.length>E)o.splice(E);else for(;o.length<E;)o.push("");for(;c<o.length;c++)o[c]=o[c].trim().replace(/\\\|/g,"|");return o}function V(g,E,N){var o=g.length;if(o===0)return"";for(var c=0;c<o;){var n=g.charAt(o-c-1);if(n===E&&!N)c++;else if(n!==E&&N)c++;else break}return g.slice(0,o-c)}function S(g,E){if(g.indexOf(E[1])===-1)return-1;for(var N=g.length,o=0,c=0;c<N;c++)if(g[c]==="\\")c++;else if(g[c]===E[0])o++;else if(g[c]===E[1]&&(o--,o<0))return c;return-1}function L(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function M(g,E){if(E<1)return"";for(var N="";E>1;)E&1&&(N+=g),E>>=1,g+=g;return N+g}function X(g,E,N,o){var c=E.href,n=E.title?t(E.title):null,h=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){o.state.inLink=!0;var F={type:"link",raw:N,href:c,title:n,text:h,tokens:o.inlineTokens(h)};return o.state.inLink=!1,F}return{type:"image",raw:N,href:c,title:n,text:t(h)}}function U(g,E){var N=g.match(/^(\s+)(?:```)/);if(N===null)return E;var o=N[1];return E.split(`
`).map(function(c){var n=c.match(/^\s+/);if(n===null)return c;var h=n[0];return h.length>=o.length?c.slice(o.length):c}).join(`
`)}var de=function(){function g(N){this.options=N||re.defaults}var E=g.prototype;return E.space=function(o){var c=this.rules.block.newline.exec(o);if(c&&c[0].length>0)return{type:"space",raw:c[0]}},E.code=function(o){var c=this.rules.block.code.exec(o);if(c){var n=c[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:c[0],codeBlockStyle:"indented",text:this.options.pedantic?n:V(n,`
`)}}},E.fences=function(o){var c=this.rules.block.fences.exec(o);if(c){var n=c[0],h=U(n,c[3]||"");return{type:"code",raw:n,lang:c[2]?c[2].trim():c[2],text:h}}},E.heading=function(o){var c=this.rules.block.heading.exec(o);if(c){var n=c[2].trim();if(/#$/.test(n)){var h=V(n,"#");(this.options.pedantic||!h||/ $/.test(h))&&(n=h.trim())}return{type:"heading",raw:c[0],depth:c[1].length,text:n,tokens:this.lexer.inline(n)}}},E.hr=function(o){var c=this.rules.block.hr.exec(o);if(c)return{type:"hr",raw:c[0]}},E.blockquote=function(o){var c=this.rules.block.blockquote.exec(o);if(c){var n=c[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:c[0],tokens:this.lexer.blockTokens(n,[]),text:n}}},E.list=function(o){var c=this.rules.block.list.exec(o);if(c){var n,h,F,T,P,q,Z,ee,be,we,ke,Oe,Ee=c[1].trim(),Ae=Ee.length>1,Re={type:"list",raw:"",ordered:Ae,start:Ae?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Ae?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Ae?Ee:"[*+-]");for(var Ie=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");o&&(Oe=!1,!(!(c=Ie.exec(o))||this.rules.block.hr.test(o)));){if(n=c[0],o=o.substring(n.length),ee=c[2].split(`
`,1)[0],be=o.split(`
`,1)[0],this.options.pedantic?(T=2,ke=ee.trimLeft()):(T=c[2].search(/[^ ]/),T=T>4?1:T,ke=ee.slice(T),T+=c[1].length),q=!1,!ee&&/^ *$/.test(be)&&(n+=be+`
`,o=o.substring(be.length+1),Oe=!0),!Oe)for(var Ge=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ye=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),Ue=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");o&&(we=o.split(`
`,1)[0],ee=we,this.options.pedantic&&(ee=ee.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ye.test(ee)||Ue.test(ee)||Ge.test(ee)||nt.test(o)));){if(ee.search(/[^ ]/)>=T||!ee.trim())ke+=`
`+ee.slice(T);else if(!q)ke+=`
`+ee;else break;!q&&!ee.trim()&&(q=!0),n+=we+`
`,o=o.substring(we.length+1)}Re.loose||(Z?Re.loose=!0:/\n *\n *$/.test(n)&&(Z=!0)),this.options.gfm&&(h=/^\[[ xX]\] /.exec(ke),h&&(F=h[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Re.items.push({type:"list_item",raw:n,task:!!h,checked:F,loose:!1,text:ke}),Re.raw+=n}Re.items[Re.items.length-1].raw=n.trimRight(),Re.items[Re.items.length-1].text=ke.trimRight(),Re.raw=Re.raw.trimRight();var Y=Re.items.length;for(P=0;P<Y;P++){this.lexer.state.top=!1,Re.items[P].tokens=this.lexer.blockTokens(Re.items[P].text,[]);var se=Re.items[P].tokens.filter(function(ve){return ve.type==="space"}),pe=se.every(function(ve){for(var Le=ve.raw.split(""),je=0,qe=W(Le),_e;!(_e=qe()).done;){var tt=_e.value;if(tt===`
`&&(je+=1),je>1)return!0}return!1});!Re.loose&&se.length&&pe&&(Re.loose=!0,Re.items[P].loose=!0)}return Re}},E.html=function(o){var c=this.rules.block.html.exec(o);if(c){var n={type:"html",raw:c[0],pre:!this.options.sanitizer&&(c[1]==="pre"||c[1]==="script"||c[1]==="style"),text:c[0]};if(this.options.sanitize){var h=this.options.sanitizer?this.options.sanitizer(c[0]):t(c[0]);n.type="paragraph",n.text=h,n.tokens=this.lexer.inline(h)}return n}},E.def=function(o){var c=this.rules.block.def.exec(o);if(c){c[3]&&(c[3]=c[3].substring(1,c[3].length-1));var n=c[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:n,raw:c[0],href:c[2],title:c[3]}}},E.table=function(o){var c=this.rules.block.table.exec(o);if(c){var n={type:"table",header:H(c[1]).map(function(Z){return{text:Z}}),align:c[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:c[3]&&c[3].trim()?c[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(n.header.length===n.align.length){n.raw=c[0];var h=n.align.length,F,T,P,q;for(F=0;F<h;F++)/^ *-+: *$/.test(n.align[F])?n.align[F]="right":/^ *:-+: *$/.test(n.align[F])?n.align[F]="center":/^ *:-+ *$/.test(n.align[F])?n.align[F]="left":n.align[F]=null;for(h=n.rows.length,F=0;F<h;F++)n.rows[F]=H(n.rows[F],n.header.length).map(function(Z){return{text:Z}});for(h=n.header.length,T=0;T<h;T++)n.header[T].tokens=this.lexer.inline(n.header[T].text);for(h=n.rows.length,T=0;T<h;T++)for(q=n.rows[T],P=0;P<q.length;P++)q[P].tokens=this.lexer.inline(q[P].text);return n}}},E.lheading=function(o){var c=this.rules.block.lheading.exec(o);if(c)return{type:"heading",raw:c[0],depth:c[2].charAt(0)==="="?1:2,text:c[1],tokens:this.lexer.inline(c[1])}},E.paragraph=function(o){var c=this.rules.block.paragraph.exec(o);if(c){var n=c[1].charAt(c[1].length-1)===`
`?c[1].slice(0,-1):c[1];return{type:"paragraph",raw:c[0],text:n,tokens:this.lexer.inline(n)}}},E.text=function(o){var c=this.rules.block.text.exec(o);if(c)return{type:"text",raw:c[0],text:c[0],tokens:this.lexer.inline(c[0])}},E.escape=function(o){var c=this.rules.inline.escape.exec(o);if(c)return{type:"escape",raw:c[0],text:t(c[1])}},E.tag=function(o){var c=this.rules.inline.tag.exec(o);if(c)return!this.lexer.state.inLink&&/^<a /i.test(c[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(c[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(c[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(c[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:c[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(c[0]):t(c[0]):c[0]}},E.link=function(o){var c=this.rules.inline.link.exec(o);if(c){var n=c[2].trim();if(!this.options.pedantic&&/^</.test(n)){if(!/>$/.test(n))return;var h=V(n.slice(0,-1),"\\");if((n.length-h.length)%2===0)return}else{var F=S(c[2],"()");if(F>-1){var T=c[0].indexOf("!")===0?5:4,P=T+c[1].length+F;c[2]=c[2].substring(0,F),c[0]=c[0].substring(0,P).trim(),c[3]=""}}var q=c[2],Z="";if(this.options.pedantic){var ee=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(q);ee&&(q=ee[1],Z=ee[3])}else Z=c[3]?c[3].slice(1,-1):"";return q=q.trim(),/^</.test(q)&&(this.options.pedantic&&!/>$/.test(n)?q=q.slice(1):q=q.slice(1,-1)),X(c,{href:q&&q.replace(this.rules.inline._escapes,"$1"),title:Z&&Z.replace(this.rules.inline._escapes,"$1")},c[0],this.lexer)}},E.reflink=function(o,c){var n;if((n=this.rules.inline.reflink.exec(o))||(n=this.rules.inline.nolink.exec(o))){var h=(n[2]||n[1]).replace(/\s+/g," ");if(h=c[h.toLowerCase()],!h||!h.href){var F=n[0].charAt(0);return{type:"text",raw:F,text:F}}return X(n,h,n[0],this.lexer)}},E.emStrong=function(o,c,n){n===void 0&&(n="");var h=this.rules.inline.emStrong.lDelim.exec(o);if(h&&!(h[3]&&n.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var F=h[1]||h[2]||"";if(!F||F&&(n===""||this.rules.inline.punctuation.exec(n))){var T=h[0].length-1,P,q,Z=T,ee=0,be=h[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,c=c.slice(-1*o.length+T);(h=be.exec(c))!=null;)if(P=h[1]||h[2]||h[3]||h[4]||h[5]||h[6],!!P){if(q=P.length,h[3]||h[4]){Z+=q;continue}else if((h[5]||h[6])&&T%3&&!((T+q)%3)){ee+=q;continue}if(Z-=q,!(Z>0)){if(q=Math.min(q,q+Z+ee),Math.min(T,q)%2){var we=o.slice(1,T+h.index+q);return{type:"em",raw:o.slice(0,T+h.index+q+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ke=o.slice(2,T+h.index+q-1);return{type:"strong",raw:o.slice(0,T+h.index+q+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},E.codespan=function(o){var c=this.rules.inline.code.exec(o);if(c){var n=c[2].replace(/\n/g," "),h=/[^ ]/.test(n),F=/^ /.test(n)&&/ $/.test(n);return h&&F&&(n=n.substring(1,n.length-1)),n=t(n,!0),{type:"codespan",raw:c[0],text:n}}},E.br=function(o){var c=this.rules.inline.br.exec(o);if(c)return{type:"br",raw:c[0]}},E.del=function(o){var c=this.rules.inline.del.exec(o);if(c)return{type:"del",raw:c[0],text:c[2],tokens:this.lexer.inlineTokens(c[2])}},E.autolink=function(o,c){var n=this.rules.inline.autolink.exec(o);if(n){var h,F;return n[2]==="@"?(h=t(this.options.mangle?c(n[1]):n[1]),F="mailto:"+h):(h=t(n[1]),F=h),{type:"link",raw:n[0],text:h,href:F,tokens:[{type:"text",raw:h,text:h}]}}},E.url=function(o,c){var n;if(n=this.rules.inline.url.exec(o)){var h,F;if(n[2]==="@")h=t(this.options.mangle?c(n[0]):n[0]),F="mailto:"+h;else{var T;do T=n[0],n[0]=this.rules.inline._backpedal.exec(n[0])[0];while(T!==n[0]);h=t(n[0]),n[1]==="www."?F="http://"+h:F=h}return{type:"link",raw:n[0],text:h,href:F,tokens:[{type:"text",raw:h,text:h}]}}},E.inlineText=function(o,c){var n=this.rules.inline.text.exec(o);if(n){var h;return this.lexer.state.inRawBlock?h=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(n[0]):t(n[0]):n[0]:h=t(this.options.smartypants?c(n[0]):n[0]),{type:"text",raw:n[0],text:h}}},g}(),he={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};he._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,he._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,he.def=u(he.def).replace("label",he._label).replace("title",he._title).getRegex(),he.bullet=/(?:[*+-]|\d{1,9}[.)])/,he.listItemStart=u(/^( *)(bull) */).replace("bull",he.bullet).getRegex(),he.list=u(he.list).replace(/bull/g,he.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+he.def.source+")").getRegex(),he._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",he._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,he.html=u(he.html,"i").replace("comment",he._comment).replace("tag",he._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),he.paragraph=u(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.blockquote=u(he.blockquote).replace("paragraph",he.paragraph).getRegex(),he.normal=v({},he),he.gfm=v({},he.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),he.gfm.table=u(he.gfm.table).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.gfm.paragraph=u(he._paragraph).replace("hr",he.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",he.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",he._tag).getRegex(),he.pedantic=v({},he.normal,{html:u(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",he._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:u(he.normal._paragraph).replace("hr",he.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",he.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ne={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ne._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ne.punctuation=u(ne.punctuation).replace(/punctuation/g,ne._punctuation).getRegex(),ne.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ne.escapedEmSt=/\\\*|\\_/g,ne._comment=u(he._comment).replace("(?:-->|$)","-->").getRegex(),ne.emStrong.lDelim=u(ne.emStrong.lDelim).replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimAst=u(ne.emStrong.rDelimAst,"g").replace(/punct/g,ne._punctuation).getRegex(),ne.emStrong.rDelimUnd=u(ne.emStrong.rDelimUnd,"g").replace(/punct/g,ne._punctuation).getRegex(),ne._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ne._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ne._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ne.autolink=u(ne.autolink).replace("scheme",ne._scheme).replace("email",ne._email).getRegex(),ne._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ne.tag=u(ne.tag).replace("comment",ne._comment).replace("attribute",ne._attribute).getRegex(),ne._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ne._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ne._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ne.link=u(ne.link).replace("label",ne._label).replace("href",ne._href).replace("title",ne._title).getRegex(),ne.reflink=u(ne.reflink).replace("label",ne._label).replace("ref",he._label).getRegex(),ne.nolink=u(ne.nolink).replace("ref",he._label).getRegex(),ne.reflinkSearch=u(ne.reflinkSearch,"g").replace("reflink",ne.reflink).replace("nolink",ne.nolink).getRegex(),ne.normal=v({},ne),ne.pedantic=v({},ne.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:u(/^!?\[(label)\]\((.*?)\)/).replace("label",ne._label).getRegex(),reflink:u(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ne._label).getRegex()}),ne.gfm=v({},ne.normal,{escape:u(ne.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ne.gfm.url=u(ne.gfm.url,"i").replace("email",ne.gfm._extended_email).getRegex(),ne.breaks=v({},ne.gfm,{br:u(ne.br).replace("{2,}","*").getRegex(),text:u(ne.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ge(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Fe(g){var E="",N,o,c=g.length;for(N=0;N<c;N++)o=g.charCodeAt(N),Math.random()>.5&&(o="x"+o.toString(16)),E+="&#"+o+";";return E}var Ce=function(){function g(N){this.tokens=[],this.tokens.links=Object.create(null),this.options=N||re.defaults,this.options.tokenizer=this.options.tokenizer||new de,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var o={block:he.normal,inline:ne.normal};this.options.pedantic?(o.block=he.pedantic,o.inline=ne.pedantic):this.options.gfm&&(o.block=he.gfm,this.options.breaks?o.inline=ne.breaks:o.inline=ne.gfm),this.tokenizer.rules=o}g.lex=function(o,c){var n=new g(c);return n.lex(o)},g.lexInline=function(o,c){var n=new g(c);return n.inlineTokens(o)};var E=g.prototype;return E.lex=function(o){o=o.replace(/\r\n|\r/g,`
`),this.blockTokens(o,this.tokens);for(var c;c=this.inlineQueue.shift();)this.inlineTokens(c.src,c.tokens);return this.tokens},E.blockTokens=function(o,c){var n=this;c===void 0&&(c=[]),this.options.pedantic?o=o.replace(/\t/g,"    ").replace(/^ +$/gm,""):o=o.replace(/^( *)(\t+)/gm,function(Z,ee,be){return ee+"    ".repeat(be.length)});for(var h,F,T,P;o;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Z){return(h=Z.call({lexer:n},o,c))?(o=o.substring(h.raw.length),c.push(h),!0):!1}))){if(h=this.tokenizer.space(o)){o=o.substring(h.raw.length),h.raw.length===1&&c.length>0?c[c.length-1].raw+=`
`:c.push(h);continue}if(h=this.tokenizer.code(o)){o=o.substring(h.raw.length),F=c[c.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue[this.inlineQueue.length-1].src=F.text):c.push(h);continue}if(h=this.tokenizer.fences(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.heading(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.hr(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.blockquote(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.list(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.html(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.def(o)){o=o.substring(h.raw.length),F=c[c.length-1],F&&(F.type==="paragraph"||F.type==="text")?(F.raw+=`
`+h.raw,F.text+=`
`+h.raw,this.inlineQueue[this.inlineQueue.length-1].src=F.text):this.tokens.links[h.tag]||(this.tokens.links[h.tag]={href:h.href,title:h.title});continue}if(h=this.tokenizer.table(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.lheading(o)){o=o.substring(h.raw.length),c.push(h);continue}if(T=o,this.options.extensions&&this.options.extensions.startBlock&&function(){var Z=1/0,ee=o.slice(1),be=void 0;n.options.extensions.startBlock.forEach(function(we){be=we.call({lexer:this},ee),typeof be=="number"&&be>=0&&(Z=Math.min(Z,be))}),Z<1/0&&Z>=0&&(T=o.substring(0,Z+1))}(),this.state.top&&(h=this.tokenizer.paragraph(T))){F=c[c.length-1],P&&F.type==="paragraph"?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):c.push(h),P=T.length!==o.length,o=o.substring(h.raw.length);continue}if(h=this.tokenizer.text(o)){o=o.substring(h.raw.length),F=c[c.length-1],F&&F.type==="text"?(F.raw+=`
`+h.raw,F.text+=`
`+h.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=F.text):c.push(h);continue}if(o){var q="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(q);break}else throw new Error(q)}}return this.state.top=!0,c},E.inline=function(o,c){return c===void 0&&(c=[]),this.inlineQueue.push({src:o,tokens:c}),c},E.inlineTokens=function(o,c){var n=this;c===void 0&&(c=[]);var h,F,T,P=o,q,Z,ee;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(q=this.tokenizer.rules.inline.reflinkSearch.exec(P))!=null;)be.includes(q[0].slice(q[0].lastIndexOf("[")+1,-1))&&(P=P.slice(0,q.index)+"["+M("a",q[0].length-2)+"]"+P.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(q=this.tokenizer.rules.inline.blockSkip.exec(P))!=null;)P=P.slice(0,q.index)+"["+M("a",q[0].length-2)+"]"+P.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(q=this.tokenizer.rules.inline.escapedEmSt.exec(P))!=null;)P=P.slice(0,q.index)+"++"+P.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;o;)if(Z||(ee=""),Z=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(h=ke.call({lexer:n},o,c))?(o=o.substring(h.raw.length),c.push(h),!0):!1}))){if(h=this.tokenizer.escape(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.tag(o)){o=o.substring(h.raw.length),F=c[c.length-1],F&&h.type==="text"&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):c.push(h);continue}if(h=this.tokenizer.link(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.reflink(o,this.tokens.links)){o=o.substring(h.raw.length),F=c[c.length-1],F&&h.type==="text"&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):c.push(h);continue}if(h=this.tokenizer.emStrong(o,P,ee)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.codespan(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.br(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.del(o)){o=o.substring(h.raw.length),c.push(h);continue}if(h=this.tokenizer.autolink(o,Fe)){o=o.substring(h.raw.length),c.push(h);continue}if(!this.state.inLink&&(h=this.tokenizer.url(o,Fe))){o=o.substring(h.raw.length),c.push(h);continue}if(T=o,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,Oe=o.slice(1),Ee=void 0;n.options.extensions.startInline.forEach(function(Ae){Ee=Ae.call({lexer:this},Oe),typeof Ee=="number"&&Ee>=0&&(ke=Math.min(ke,Ee))}),ke<1/0&&ke>=0&&(T=o.substring(0,ke+1))}(),h=this.tokenizer.inlineText(T,ge)){o=o.substring(h.raw.length),h.raw.slice(-1)!=="_"&&(ee=h.raw.slice(-1)),Z=!0,F=c[c.length-1],F&&F.type==="text"?(F.raw+=h.raw,F.text+=h.text):c.push(h);continue}if(o){var we="Infinite loop on byte: "+o.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return c},i(g,null,[{key:"rules",get:function(){return{block:he,inline:ne}}}]),g}(),Be=function(){function g(N){this.options=N||re.defaults}var E=g.prototype;return E.code=function(o,c,n){var h=(c||"").match(/\S*/)[0];if(this.options.highlight){var F=this.options.highlight(o,h);F!=null&&F!==o&&(n=!0,o=F)}return o=o.replace(/\n$/,"")+`
`,h?'<pre><code class="'+this.options.langPrefix+t(h,!0)+'">'+(n?o:t(o,!0))+`</code></pre>
`:"<pre><code>"+(n?o:t(o,!0))+`</code></pre>
`},E.blockquote=function(o){return`<blockquote>
`+o+`</blockquote>
`},E.html=function(o){return o},E.heading=function(o,c,n,h){if(this.options.headerIds){var F=this.options.headerPrefix+h.slug(n);return"<h"+c+' id="'+F+'">'+o+"</h"+c+`>
`}return"<h"+c+">"+o+"</h"+c+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(o,c,n){var h=c?"ol":"ul",F=c&&n!==1?' start="'+n+'"':"";return"<"+h+F+`>
`+o+"</"+h+`>
`},E.listitem=function(o){return"<li>"+o+`</li>
`},E.checkbox=function(o){return"<input "+(o?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(o){return"<p>"+o+`</p>
`},E.table=function(o,c){return c&&(c="<tbody>"+c+"</tbody>"),`<table>
<thead>
`+o+`</thead>
`+c+`</table>
`},E.tablerow=function(o){return`<tr>
`+o+`</tr>
`},E.tablecell=function(o,c){var n=c.header?"th":"td",h=c.align?"<"+n+' align="'+c.align+'">':"<"+n+">";return h+o+("</"+n+`>
`)},E.strong=function(o){return"<strong>"+o+"</strong>"},E.em=function(o){return"<em>"+o+"</em>"},E.codespan=function(o){return"<code>"+o+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(o){return"<del>"+o+"</del>"},E.link=function(o,c,n){if(o=b(this.options.sanitize,this.options.baseUrl,o),o===null)return n;var h='<a href="'+t(o)+'"';return c&&(h+=' title="'+c+'"'),h+=">"+n+"</a>",h},E.image=function(o,c,n){if(o=b(this.options.sanitize,this.options.baseUrl,o),o===null)return n;var h='<img src="'+o+'" alt="'+n+'"';return c&&(h+=' title="'+c+'"'),h+=this.options.xhtml?"/>":">",h},E.text=function(o){return o},g}(),le=function(){function g(){}var E=g.prototype;return E.strong=function(o){return o},E.em=function(o){return o},E.codespan=function(o){return o},E.del=function(o){return o},E.html=function(o){return o},E.text=function(o){return o},E.link=function(o,c,n){return""+n},E.image=function(o,c,n){return""+n},E.br=function(){return""},g}(),_=function(){function g(){this.seen={}}var E=g.prototype;return E.serialize=function(o){return o.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(o,c){var n=o,h=0;if(this.seen.hasOwnProperty(n)){h=this.seen[o];do h++,n=o+"-"+h;while(this.seen.hasOwnProperty(n))}return c||(this.seen[o]=h,this.seen[n]=0),n},E.slug=function(o,c){c===void 0&&(c={});var n=this.serialize(o);return this.getNextSafeSlug(n,c.dryrun)},g}(),ae=function(){function g(N){this.options=N||re.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}g.parse=function(o,c){var n=new g(c);return n.parse(o)},g.parseInline=function(o,c){var n=new g(c);return n.parseInline(o)};var E=g.prototype;return E.parse=function(o,c){c===void 0&&(c=!0);var n="",h,F,T,P,q,Z,ee,be,we,ke,Oe,Ee,Ae,Re,Ie,Ge,nt,Ye,Ue,Y=o.length;for(h=0;h<Y;h++){if(ke=o[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&(Ue=this.options.extensions.renderers[ke.type].call({parser:this},ke),Ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){n+=Ue||"";continue}switch(ke.type){case"space":continue;case"hr":{n+=this.renderer.hr();continue}case"heading":{n+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,a(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{n+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(be="",ee="",P=ke.header.length,F=0;F<P;F++)ee+=this.renderer.tablecell(this.parseInline(ke.header[F].tokens),{header:!0,align:ke.align[F]});for(be+=this.renderer.tablerow(ee),we="",P=ke.rows.length,F=0;F<P;F++){for(Z=ke.rows[F],ee="",q=Z.length,T=0;T<q;T++)ee+=this.renderer.tablecell(this.parseInline(Z[T].tokens),{header:!1,align:ke.align[T]});we+=this.renderer.tablerow(ee)}n+=this.renderer.table(be,we);continue}case"blockquote":{we=this.parse(ke.tokens),n+=this.renderer.blockquote(we);continue}case"list":{for(Oe=ke.ordered,Ee=ke.start,Ae=ke.loose,P=ke.items.length,we="",F=0;F<P;F++)Ie=ke.items[F],Ge=Ie.checked,nt=Ie.task,Re="",Ie.task&&(Ye=this.renderer.checkbox(Ge),Ae?Ie.tokens.length>0&&Ie.tokens[0].type==="paragraph"?(Ie.tokens[0].text=Ye+" "+Ie.tokens[0].text,Ie.tokens[0].tokens&&Ie.tokens[0].tokens.length>0&&Ie.tokens[0].tokens[0].type==="text"&&(Ie.tokens[0].tokens[0].text=Ye+" "+Ie.tokens[0].tokens[0].text)):Ie.tokens.unshift({type:"text",text:Ye}):Re+=Ye),Re+=this.parse(Ie.tokens,Ae),we+=this.renderer.listitem(Re,nt,Ge);n+=this.renderer.list(we,Oe,Ee);continue}case"html":{n+=this.renderer.html(ke.text);continue}case"paragraph":{n+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(we=ke.tokens?this.parseInline(ke.tokens):ke.text;h+1<Y&&o[h+1].type==="text";)ke=o[++h],we+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);n+=c?this.renderer.paragraph(we):we;continue}default:{var se='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return n},E.parseInline=function(o,c){c=c||this.renderer;var n="",h,F,T,P=o.length;for(h=0;h<P;h++){if(F=o[h],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[F.type]&&(T=this.options.extensions.renderers[F.type].call({parser:this},F),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(F.type))){n+=T||"";continue}switch(F.type){case"escape":{n+=c.text(F.text);break}case"html":{n+=c.html(F.text);break}case"link":{n+=c.link(F.href,F.title,this.parseInline(F.tokens,c));break}case"image":{n+=c.image(F.href,F.title,F.text);break}case"strong":{n+=c.strong(this.parseInline(F.tokens,c));break}case"em":{n+=c.em(this.parseInline(F.tokens,c));break}case"codespan":{n+=c.codespan(F.text);break}case"br":{n+=c.br();break}case"del":{n+=c.del(this.parseInline(F.tokens,c));break}case"text":{n+=c.text(F.text);break}default:{var q='Token with "'+F.type+'" type was not found.';if(this.options.silent){console.error(q);return}else throw new Error(q)}}}return n},g}();function oe(g,E,N){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof E=="function"&&(N=E,E=null),E=v({},oe.defaults,E||{}),L(E),N){var o=E.highlight,c;try{c=Ce.lex(g,E)}catch(P){return N(P)}var n=function(q){var Z;if(!q)try{E.walkTokens&&oe.walkTokens(c,E.walkTokens),Z=ae.parse(c,E)}catch(ee){q=ee}return E.highlight=o,q?N(q):N(null,Z)};if(!o||o.length<3||(delete E.highlight,!c.length))return n();var h=0;oe.walkTokens(c,function(P){P.type==="code"&&(h++,setTimeout(function(){o(P.text,P.lang,function(q,Z){if(q)return n(q);Z!=null&&Z!==P.text&&(P.text=Z,P.escaped=!0),h--,h===0&&n()})},0))}),h===0&&n();return}function F(P){if(P.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+t(P.message+"",!0)+"</pre>";throw P}try{var T=Ce.lex(g,E);if(E.walkTokens){if(E.async)return Promise.all(oe.walkTokens(T,E.walkTokens)).then(function(){return ae.parse(T,E)}).catch(F);oe.walkTokens(T,E.walkTokens)}return ae.parse(T,E)}catch(P){F(P)}}oe.options=oe.setOptions=function(g){return v(oe.defaults,g),y(oe.defaults),oe},oe.getDefaults=D,oe.defaults=re.defaults,oe.use=function(){for(var g=arguments.length,E=new Array(g),N=0;N<g;N++)E[N]=arguments[N];var o=v.apply(void 0,[{}].concat(E)),c=oe.defaults.extensions||{renderers:{},childTokens:{}},n;E.forEach(function(h){if(h.extensions&&(n=!0,h.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var P=c.renderers?c.renderers[T.name]:null;P?c.renderers[T.name]=function(){for(var q=arguments.length,Z=new Array(q),ee=0;ee<q;ee++)Z[ee]=arguments[ee];var be=T.renderer.apply(this,Z);return be===!1&&(be=P.apply(this,Z)),be}:c.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");c[T.level]?c[T.level].unshift(T.tokenizer):c[T.level]=[T.tokenizer],T.start&&(T.level==="block"?c.startBlock?c.startBlock.push(T.start):c.startBlock=[T.start]:T.level==="inline"&&(c.startInline?c.startInline.push(T.start):c.startInline=[T.start]))}T.childTokens&&(c.childTokens[T.name]=T.childTokens)})),h.renderer&&function(){var T=oe.defaults.renderer||new Be,P=function(ee){var be=T[ee];T[ee]=function(){for(var we=arguments.length,ke=new Array(we),Oe=0;Oe<we;Oe++)ke[Oe]=arguments[Oe];var Ee=h.renderer[ee].apply(T,ke);return Ee===!1&&(Ee=be.apply(T,ke)),Ee}};for(var q in h.renderer)P(q);o.renderer=T}(),h.tokenizer&&function(){var T=oe.defaults.tokenizer||new de,P=function(ee){var be=T[ee];T[ee]=function(){for(var we=arguments.length,ke=new Array(we),Oe=0;Oe<we;Oe++)ke[Oe]=arguments[Oe];var Ee=h.tokenizer[ee].apply(T,ke);return Ee===!1&&(Ee=be.apply(T,ke)),Ee}};for(var q in h.tokenizer)P(q);o.tokenizer=T}(),h.walkTokens){var F=oe.defaults.walkTokens;o.walkTokens=function(T){var P=[];return P.push(h.walkTokens.call(this,T)),F&&(P=P.concat(F.call(this,T))),P}}n&&(o.extensions=c),oe.setOptions(o)})},oe.walkTokens=function(g,E){for(var N=[],o=function(){var F=n.value;switch(N=N.concat(E.call(oe,F)),F.type){case"table":{for(var T=W(F.header),P;!(P=T()).done;){var q=P.value;N=N.concat(oe.walkTokens(q.tokens,E))}for(var Z=W(F.rows),ee;!(ee=Z()).done;)for(var be=ee.value,we=W(be),ke;!(ke=we()).done;){var Oe=ke.value;N=N.concat(oe.walkTokens(Oe.tokens,E))}break}case"list":{N=N.concat(oe.walkTokens(F.items,E));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[F.type]?oe.defaults.extensions.childTokens[F.type].forEach(function(Ee){N=N.concat(oe.walkTokens(F[Ee],E))}):F.tokens&&(N=N.concat(oe.walkTokens(F.tokens,E)))}},c=W(g),n;!(n=c()).done;)o();return N},oe.parseInline=function(g,E){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");E=v({},oe.defaults,E||{}),L(E);try{var N=Ce.lexInline(g,E);return E.walkTokens&&oe.walkTokens(N,E.walkTokens),ae.parseInline(N,E)}catch(o){if(o.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+t(o.message+"",!0)+"</pre>";throw o}},oe.Parser=ae,oe.parser=ae.parse,oe.Renderer=Be,oe.TextRenderer=le,oe.Lexer=Ce,oe.lexer=Ce.lex,oe.Tokenizer=de,oe.Slugger=_,oe.parse=oe;var J=oe.options,G=oe.setOptions,ie=oe.use,ce=oe.walkTokens,De=oe.parseInline,Ne=oe,ye=ae.parse,K=Ce.lex;re.Lexer=Ce,re.Parser=ae,re.Renderer=Be,re.Slugger=_,re.TextRenderer=le,re.Tokenizer=de,re.getDefaults=D,re.lexer=K,re.marked=oe,re.options=J,re.parse=Ne,re.parseInline=De,re.parser=ye,re.setOptions=G,re.use=ie,re.walkTokens=ce,Object.defineProperty(re,"__esModule",{value:!0})}),define(me[83],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0;function i(s){const a=W(s);if(a&&a.length>0)return new Uint32Array(a)}e.$5j=i;let C=0;const j=new Uint32Array(10);function W(s){if(C=0,D(s,B,4352),C>0||(D(s,f,4449),C>0)||(D(s,d,4520),C>0)||(D(s,t,12593),C))return j.subarray(0,C);if(s>=44032&&s<=55203){const a=s-44032,m=a%588,u=Math.floor(a/588),k=Math.floor(m/28),l=m%28-1;if(u<B.length?D(u,B,0):4352+u-12593<t.length&&D(4352+u,t,12593),k<f.length?D(k,f,0):4449+k-12593<t.length&&D(4449+k-12593,t,12593),l>=0&&(l<d.length?D(l,d,0):4520+l-12593<t.length&&D(4520+l-12593,t,12593)),C>0)return j.subarray(0,C)}}function D(s,a,m){s>=m&&s<m+a.length&&y(a[s-m])}function y(s){s!==0&&(j[C++]=s&255,s>>8&&(j[C++]=s>>8&255),s>>16&&(j[C++]=s>>16&255))}var $;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var p;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(p||(p={}));var w;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(w||(w={}));const B=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),f=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),d=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),t=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[84],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lU=void 0;class i{constructor(j,W=0,D=j.length,y=W-1){this.a=j,this.b=W,this.c=D,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}e.$lU=i}),define(me[85],$e([1,0,84]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nU=e.$mU=void 0;class C{constructor(D=[],y=10){this.h(D),this.b=y,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new i.$lU(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const y of D)this.a.add(y)}get j(){const D=[];return this.a.forEach(y=>D.push(y)),D}}e.$mU=C;class j{get size(){return this.f}constructor(D,y=10){if(this.g=y,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let $=1;$<D.length;$++)this.add(D[$])}add(D){const y={value:D,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const y=this.c.value;return this.a.delete(y),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),y}prepend(D){if(this.f===this.g||this.a.has(D))return;const y={value:D,previous:void 0,next:this.b};this.b.previous=y,this.b=y,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let y=this.b;for(;y!==this.c;)y.value===D&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}e.$nU=j}),define(me[34],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function i(y,$,p){return Math.min(Math.max(y,$),p)}e.$fm=i;function C(y,$){return($+y%$)%$}e.rot=C;class j{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=j;class W{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=W;class D{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const p=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=D}),define(me[50],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;var i;(function(C){function j($,p){if($.start>=p.end||p.start>=$.end)return{start:0,end:0};const w=Math.max($.start,p.start),B=Math.min($.end,p.end);return B-w<=0?{start:0,end:0}:{start:w,end:B}}C.intersect=j;function W($){return $.end-$.start<=0}C.isEmpty=W;function D($,p){return!W(j($,p))}C.intersects=D;function y($,p){const w=[],B={start:$.start,end:Math.min(p.start,$.end)},f={start:Math.max(p.end,$.start),end:$.end};return W(B)||w.push(B),W(f)||w.push(f),w}C.relativeComplement=y})(i||(e.Range=i={}))}),define(me[86],$e([1,0,50]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7S=e.$6S=e.$5S=e.$4S=void 0;function C($,p){const w=[];for(const B of p){if($.start>=B.range.end)continue;if($.end<B.range.start)break;const f=i.Range.intersect($,B.range);i.Range.isEmpty(f)||w.push({range:f,size:B.size})}return w}e.$4S=C;function j({start:$,end:p},w){return{start:$+w,end:p+w}}e.$5S=j;function W($){const p=[];let w=null;for(const B of $){const f=B.range.start,d=B.range.end,t=B.size;if(w&&t===w.size){w.range.end=d;continue}w={range:{start:f,end:d},size:t},p.push(w)}return p}e.$6S=W;function D(...$){return W($.reduce((p,w)=>p.concat(w),[]))}class y{get paddingTop(){return this.c}set paddingTop(p){this.b=this.b+p-this.c,this.c=p}constructor(p){this.a=[],this.b=0,this.c=0,this.c=p??0,this.b=this.c}splice(p,w,B=[]){const f=B.length-w,d=C({start:0,end:p},this.a),t=C({start:p+w,end:Number.POSITIVE_INFINITY},this.a).map(a=>({range:j(a.range,f),size:a.size})),s=B.map((a,m)=>({range:{start:p+m,end:p+m+1},size:a.size}));this.a=D(d,s,t),this.b=this.c+this.a.reduce((a,m)=>a+m.size*(m.range.end-m.range.start),0)}get count(){const p=this.a.length;return p?this.a[p-1].range.end:0}get size(){return this.b}indexAt(p){if(p<0)return-1;if(p<this.c)return 0;let w=0,B=this.c;for(const f of this.a){const d=f.range.end-f.range.start,t=B+d*f.size;if(p<t)return w+Math.floor((p-B)/f.size);w+=d,B=t}return w}indexAfter(p){return Math.min(this.indexAt(p)+1,this.count)}positionAt(p){if(p<0)return-1;let w=0,B=0;for(const f of this.a){const d=f.range.end-f.range.start,t=B+d;if(p<t)return this.c+w+(p-B)*f.size;w+=d*f.size,B=t}return-1}}e.$7S=y}),define(me[87],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const i=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(W){return new C(W)}constructor(W){this.c=i&&W===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=C}),define(me[4],$e([1,0,6,47,3,49,87]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.Event=void 0;const y=!1,$=!1;var p;(function(V){V.None=()=>j.$Tc.None;function S(o){if($){const{onDidAddListener:c}=o,n=t.create();let h=0;o.onDidAddListener=()=>{++h===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),n.print()),c?.()}}}function L(o,c){return Be(o,()=>{},0,void 0,!0,void 0,c)}V.defer=L;function M(o){return(c,n=null,h)=>{let F=!1,T;return T=o(P=>{if(!F)return T?T.dispose():F=!0,c.call(n,P)},null,h),F&&T.dispose(),T}}V.once=M;function X(o,c,n){return Fe((h,F=null,T)=>o(P=>h.call(F,c(P)),null,T),n)}V.map=X;function U(o,c,n){return Fe((h,F=null,T)=>o(P=>{c(P),h.call(F,P)},null,T),n)}V.forEach=U;function de(o,c,n){return Fe((h,F=null,T)=>o(P=>c(P)&&h.call(F,P),null,T),n)}V.filter=de;function he(o){return o}V.signal=he;function ne(...o){return(c,n=null,h)=>{const F=(0,j.$Qc)(...o.map(T=>T(P=>c.call(n,P))));return Ce(F,h)}}V.any=ne;function ge(o,c,n,h){let F=n;return X(o,T=>(F=c(F,T),F),h)}V.reduce=ge;function Fe(o,c){let n;const h={onWillAddFirstListener(){n=o(F.fire,F)},onDidRemoveLastListener(){n?.dispose()}};c||S(h);const F=new k(h);return c?.add(F),F.event}function Ce(o,c){return c instanceof Array?c.push(o):c&&c.add(o),o}function Be(o,c,n=100,h=!1,F=!1,T,P){let q,Z,ee,be=0,we;const ke={leakWarningThreshold:T,onWillAddFirstListener(){q=o(Ee=>{be++,Z=c(Z,Ee),h&&!ee&&(Oe.fire(Z),Z=void 0),we=()=>{const Ae=Z;Z=void 0,ee=void 0,(!h||be>1)&&Oe.fire(Ae),be=0},typeof n=="number"?(clearTimeout(ee),ee=setTimeout(we,n)):ee===void 0&&(ee=0,queueMicrotask(we))})},onWillRemoveListener(){F&&be>0&&we?.()},onDidRemoveLastListener(){we=void 0,q.dispose()}};P||S(ke);const Oe=new k(ke);return P?.add(Oe),Oe.event}V.debounce=Be;function le(o,c=0,n){return V.debounce(o,(h,F)=>h?(h.push(F),h):[F],c,void 0,!0,void 0,n)}V.accumulate=le;function _(o,c=(h,F)=>h===F,n){let h=!0,F;return de(o,T=>{const P=h||!c(T,F);return h=!1,F=T,P},n)}V.latch=_;function ae(o,c,n){return[V.filter(o,c,n),V.filter(o,h=>!c(h),n)]}V.split=ae;function oe(o,c=!1,n=[],h){let F=n.slice(),T=o(Z=>{F?F.push(Z):q.fire(Z)});h&&h.add(T);const P=()=>{F?.forEach(Z=>q.fire(Z)),F=null},q=new k({onWillAddFirstListener(){T||(T=o(Z=>q.fire(Z)),h&&h.add(T))},onDidAddFirstListener(){F&&(c?setTimeout(P):P())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return h&&h.add(q),q.event}V.buffer=oe;function J(o,c){return(h,F,T)=>{const P=c(new ie);return o(function(q){const Z=P.evaluate(q);Z!==G&&h.call(F,Z)},void 0,T)}}V.chain=J;const G=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(c){return this.f.push(c),this}forEach(c){return this.f.push(n=>(c(n),n)),this}filter(c){return this.f.push(n=>c(n)?n:G),this}reduce(c,n){let h=n;return this.f.push(F=>(h=c(h,F),h)),this}latch(c=(n,h)=>n===h){let n=!0,h;return this.f.push(F=>{const T=n||!c(F,h);return n=!1,h=F,T?F:G}),this}evaluate(c){for(const n of this.f)if(c=n(c),c===G)break;return c}}function ce(o,c,n=h=>h){const h=(...q)=>P.fire(n(...q)),F=()=>o.on(c,h),T=()=>o.removeListener(c,h),P=new k({onWillAddFirstListener:F,onDidRemoveLastListener:T});return P.event}V.fromNodeEventEmitter=ce;function De(o,c,n=h=>h){const h=(...q)=>P.fire(n(...q)),F=()=>o.addEventListener(c,h),T=()=>o.removeEventListener(c,h),P=new k({onWillAddFirstListener:F,onDidRemoveLastListener:T});return P.event}V.fromDOMEventEmitter=De;function Ne(o){return new Promise(c=>M(o)(c))}V.toPromise=Ne;function ye(o){const c=new k;return o.then(n=>{c.fire(n)},()=>{c.fire(void 0)}).finally(()=>{c.dispose()}),c.event}V.fromPromise=ye;function K(o,c,n){return c(n),o(h=>c(h))}V.runAndSubscribe=K;class g{constructor(c,n){this._observable=c,this.f=0,this.g=!1;const h={onWillAddFirstListener:()=>{c.addObserver(this)},onDidRemoveLastListener:()=>{c.removeObserver(this)}};n||S(h),this.emitter=new k(h),n&&n.add(this.emitter)}beginUpdate(c){this.f++}handlePossibleChange(c){}handleChange(c,n){this.g=!0}endUpdate(c){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function E(o,c){return new g(o,c).emitter.event}V.fromObservable=E;function N(o){return(c,n,h)=>{let F=0,T=!1;const P={beginUpdate(){F++},endUpdate(){F--,F===0&&(o.reportChanges(),T&&(T=!1,c.call(n)))},handlePossibleChange(){},handleChange(){T=!0}};o.addObserver(P),o.reportChanges();const q={dispose(){o.removeObserver(P)}};return h instanceof j.$Sc?h.add(q):Array.isArray(h)&&h.push(q),q}}V.fromObservableLight=N})(p||(e.Event=p={}));class w{static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${w.f++}`,w.all.add(this)}start(S){this.g=new D.$2d,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}e.$4d=w;let B=-1;function f(V){const S=B;return B=V,{dispose(){B=S}}}e.$5d=f;class d{constructor(S,L=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=L,this.g=0}dispose(){this.f?.clear()}check(S,L){const M=this.threshold;if(M<=0||L<M)return;this.f||(this.f=new Map);const X=this.f.get(S.value)||0;if(this.f.set(S.value,X+1),this.g-=1,this.g<=0){this.g=M*.5;let U,de=0;for(const[he,ne]of this.f)(!U||de<ne)&&(U=he,de=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${L} listeners already. MOST frequent listener (${de}):`),console.warn(U)}return()=>{const U=this.f.get(S.value)||0;this.f.set(S.value,U-1)}}}class t{static create(){return new t(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class a{constructor(S){this.value=S,this.id=s++}}const m=2,u=(V,S)=>{if(V instanceof a)S(V);else for(let L=0;L<V.length;L++){const M=V[L];M&&S(M)}};class k{constructor(S){this.w=0,this.f=S,this.g=B>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??B):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(y){const S=this.t;queueMicrotask(()=>{u(S,L=>L.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,L,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),j.$Tc.None;if(this.m)return j.$Tc.None;L&&(S=S.bind(L));const X=new a(S);let U,de;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(X.stack=t.create(),U=this.g.check(X.stack,this.w+1)),y&&(X.stack=de??t.create()),this.t?this.t instanceof a?(this.u??=new b,this.t=[this.t,X]):this.t.push(X):(this.f?.onWillAddFirstListener?.(this),this.t=X,this.f?.onDidAddFirstListener?.(this)),this.w++;const he=(0,j.$Rc)(()=>{U?.(),this.x(X)});return M instanceof j.$Sc?M.add(he):Array.isArray(M)&&M.push(he),he},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const L=this.t,M=L.indexOf(S);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,L[M]=void 0;const X=this.u.current===this;if(this.w*m<=L.length){let U=0;for(let de=0;de<L.length;de++)L[de]?L[U++]=L[de]:X&&(this.u.end--,U<this.u.i&&this.u.i--);L.length=U}}y(S,L){if(!S)return;const M=this.f?.onListenerError||i.$1;if(!M){S.value(L);return}try{S.value(L)}catch(X){M(X)}}z(S){const L=S.current.t;for(;S.i<S.end;)this.y(L[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,S);else{const L=this.u;L.enqueue(this,S,this.t.length),this.z(L)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=k;const l=()=>new b;e.$7d=l;class b{constructor(){this.i=-1,this.end=0}enqueue(S,L,M){this.i=0,this.end=M,this.current=S,this.value=L}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends k{async fireAsync(S,L,M){if(this.t)for(this.h||(this.h=new W.$4c),u(this.t,X=>this.h.push([X.value,S]));this.h.size>0&&!L.isCancellationRequested;){const[X,U]=this.h.shift(),de=[],he={...U,token:L,waitUntil:ne=>{if(Object.isFrozen(de))throw new Error("waitUntil can NOT be called asynchronous");M&&(ne=M(ne,X)),de.push(ne)}};try{X(he)}catch(ne){(0,i.$1)(ne);continue}Object.freeze(de),await Promise.allSettled(de).then(ne=>{for(const ge of ne)ge.status==="rejected"&&(0,i.$1)(ge.reason)})}}}e.$8d=r;class A extends k{get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new W.$4c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}e.$9d=A;class R extends A{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}e.$0d=R;class I extends k{constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(L=>super.fire(L)),this.h=[]}))}}e.$$d=I;class O{constructor(){this.g=!1,this.h=[],this.f=new k({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const L={event:S,listener:null};this.h.push(L),this.g&&this.m(L);const M=()=>{this.g&&this.o(L);const X=this.h.indexOf(L);this.h.splice(X,1)};return(0,j.$Rc)((0,C.$db)(M))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(L=>this.f.fire(L))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}e.$_d=O;class z{constructor(S,L,M,X){this.f=new j.$Sc;const U=this.f.add(new O),de=this.f.add(new j.$3c);function he(ne){de.set(ne,U.add(X(ne)))}for(const ne of S)he(ne);this.f.add(L(ne=>{he(ne)})),this.f.add(M(ne=>{de.deleteAndDispose(ne)})),this.event=U.event}dispose(){this.f.dispose()}}e.$ae=z;class v{constructor(){this.f=[]}wrapEvent(S){return(L,M,X)=>S(U=>{const de=this.f[this.f.length-1];de?de.push(()=>L.call(M,U)):L.call(M,U)},void 0,X)}bufferEvents(S){const L=[];this.f.push(L);const M=S();return this.f.pop(),L.forEach(X=>X()),M}}e.$be=v;class H{constructor(){this.f=!1,this.g=p.None,this.h=j.$Tc.None,this.j=new k({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=H}),define(me[17],$e([1,0,22,4]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.$AQ=e.$zQ=e.$yQ=e.$xQ=e.$wQ=e.$vQ=e.$uQ=e.$tQ=e.$sQ=e.$rQ=e.$qQ=void 0;class j{constructor(){this.a=new Map,this.b=new C.$6d,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$6d,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new j}getZoomLevel(m){return this.a.get(this.f(m))??0}setZoomLevel(m,u){if(this.getZoomLevel(u)===m)return;const k=this.f(u);this.a.set(k,m),this.b.fire(k)}getZoomFactor(m){return this.c.get(this.f(m))??1}setZoomFactor(m,u){this.c.set(this.f(u),m)}setFullscreen(m,u){if(this.isFullscreen(u)===m)return;const k=this.f(u);this.e.set(k,m),this.d.fire(k)}isFullscreen(m){return!!this.e.get(this.f(m))}f(m){return m.vscodeWindowId}}function W(a,m,u){typeof m=="string"&&(m=a.matchMedia(m)),m.addEventListener("change",u)}e.$qQ=W;function D(a,m){j.INSTANCE.setZoomLevel(a,m)}e.$rQ=D;function y(a){return j.INSTANCE.getZoomLevel(a)}e.$sQ=y,e.$tQ=j.INSTANCE.onDidChangeZoomLevel;function $(a){return j.INSTANCE.getZoomFactor(a)}e.$uQ=$;function p(a,m){j.INSTANCE.setZoomFactor(a,m)}e.$vQ=p;function w(a,m){j.INSTANCE.setFullscreen(a,m)}e.$wQ=w;function B(a){return j.INSTANCE.isFullscreen(a)}e.$xQ=B,e.$yQ=j.INSTANCE.onDidChangeFullscreen;const f=navigator.userAgent;e.$zQ=f.indexOf("Firefox")>=0,e.$AQ=f.indexOf("AppleWebKit")>=0,e.$BQ=f.indexOf("Chrome")>=0,e.$CQ=!e.$BQ&&f.indexOf("Safari")>=0,e.$DQ=!e.$BQ&&!e.$CQ&&e.$AQ,e.$EQ=f.indexOf("Electron/")>=0,e.$FQ=f.indexOf("Android")>=0;let d=!1;if(typeof i.$mQ.matchMedia=="function"){const a=i.$mQ.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),m=i.$mQ.matchMedia("(display-mode: fullscreen)");d=a.matches,W(i.$mQ,a,({matches:u})=>{d&&m.matches||(d=u)})}function t(){return d}e.$GQ=t;function s(){return navigator?.windowControlsOverlay?.visible}e.$HQ=s}),define(me[24],$e([1,0,4]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YS=void 0;class C{get event(){return this.a.event}constructor(W,D,y){const $=p=>this.a.fire(p);this.a=new i.$6d({onWillAddFirstListener:()=>W.addEventListener(D,$,y),onDidRemoveLastListener:()=>W.removeEventListener(D,$,y)})}dispose(){this.a.dispose()}}e.$YS=C}),define(me[30],$e([1,0,4]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const C=Object.freeze(function(y,$){const p=setTimeout(y.bind($),0);return{dispose(){clearTimeout(p)}}});var j;(function(y){function $(p){return p===y.None||p===y.Cancelled||p instanceof W?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}y.isCancellationToken=$,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(j||(e.CancellationToken=j={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new i.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new W),this.f}cancel(){this.f?this.f instanceof W&&this.f.cancel():this.f=j.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof W&&this.f.dispose():this.f=j.None}}e.$de=D}),define(me[88],$e([1,0,30]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class C{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new i.$de,$=this.b(y.token);return this.a={promise:$,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}e.$Oe=C;class j{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const $=JSON.stringify(y);return this.b!==$&&(this.b=$,this.a=this.c(y)),this.a}}e.$Pe=j;class W{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const $=this.b(y);return this.a.set(y,$),$}}e.$Qe=W}),define(me[51],$e([1,0,4,3]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=e.$Bs=e.$As=e.$zs=e.ScrollbarVisibility=void 0;var j;(function(d){d[d.Auto=1]="Auto",d[d.Hidden=2]="Hidden",d[d.Visible=3]="Visible"})(j||(e.ScrollbarVisibility=j={}));class W{constructor(t,s,a,m,u,k,l){this.c=t,this._scrollStateBrand=void 0,this.c&&(s=s|0,a=a|0,m=m|0,u=u|0,k=k|0,l=l|0),this.rawScrollLeft=m,this.rawScrollTop=l,s<0&&(s=0),m+s>a&&(m=a-s),m<0&&(m=0),u<0&&(u=0),l+u>k&&(l=k-u),l<0&&(l=0),this.width=s,this.scrollWidth=a,this.scrollLeft=m,this.height=u,this.scrollHeight=k,this.scrollTop=l}equals(t){return this.rawScrollLeft===t.rawScrollLeft&&this.rawScrollTop===t.rawScrollTop&&this.width===t.width&&this.scrollWidth===t.scrollWidth&&this.scrollLeft===t.scrollLeft&&this.height===t.height&&this.scrollHeight===t.scrollHeight&&this.scrollTop===t.scrollTop}withScrollDimensions(t,s){return new W(this.c,typeof t.width<"u"?t.width:this.width,typeof t.scrollWidth<"u"?t.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof t.height<"u"?t.height:this.height,typeof t.scrollHeight<"u"?t.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(t){return new W(this.c,this.width,this.scrollWidth,typeof t.scrollLeft<"u"?t.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof t.scrollTop<"u"?t.scrollTop:this.rawScrollTop)}createScrollEvent(t,s){const a=this.width!==t.width,m=this.scrollWidth!==t.scrollWidth,u=this.scrollLeft!==t.scrollLeft,k=this.height!==t.height,l=this.scrollHeight!==t.scrollHeight,b=this.scrollTop!==t.scrollTop;return{inSmoothScrolling:s,oldWidth:t.width,oldScrollWidth:t.scrollWidth,oldScrollLeft:t.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:t.height,oldScrollHeight:t.scrollHeight,oldScrollTop:t.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:a,scrollWidthChanged:m,scrollLeftChanged:u,heightChanged:k,scrollHeightChanged:l,scrollTopChanged:b}}}e.$zs=W;class D extends C.$Tc{constructor(t){super(),this._scrollableBrand=void 0,this.j=this.B(new i.$6d),this.onScroll=this.j.event,this.c=t.smoothScrollDuration,this.f=t.scheduleAtNextAnimationFrame,this.g=new W(t.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(t){this.c=t}validateScrollPosition(t){return this.g.withScrollPosition(t)}getScrollDimensions(){return this.g}setScrollDimensions(t,s){const a=this.g.withScrollDimensions(t,s);this.n(a,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(t){const s=this.g.withScrollPosition(t);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(t,s){if(this.c===0)return this.setScrollPositionNow(t);if(this.h){t={scrollLeft:typeof t.scrollLeft>"u"?this.h.to.scrollLeft:t.scrollLeft,scrollTop:typeof t.scrollTop>"u"?this.h.to.scrollTop:t.scrollTop};const a=this.g.withScrollPosition(t);if(this.h.to.scrollLeft===a.scrollLeft&&this.h.to.scrollTop===a.scrollTop)return;let m;s?m=new w(this.h.from,a,this.h.startTime,this.h.duration):m=this.h.combine(this.g,a,this.c),this.h.dispose(),this.h=m}else{const a=this.g.withScrollPosition(t);this.h=w.start(this.g,a,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const t=this.h.tick(),s=this.g.withScrollPosition(t);if(this.n(s,!0),!!this.h){if(t.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(t,s){const a=this.g;a.equals(t)||(this.g=t,this.j.fire(this.g.createScrollEvent(a,s)))}}e.$As=D;class y{constructor(t,s,a){this.scrollLeft=t,this.scrollTop=s,this.isDone=a}}e.$Bs=y;function $(d,t){const s=t-d;return function(a){return d+s*f(a)}}function p(d,t,s){return function(a){return a<s?d(a/s):t((a-s)/(1-s))}}class w{constructor(t,s,a,m){this.from=t,this.to=s,this.duration=m,this.startTime=a,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(t,s,a){if(Math.abs(t-s)>2.5*a){let u,k;return t<s?(u=t+.75*a,k=s-.75*a):(u=t-.75*a,k=s+.75*a),p($(t,u),$(k,s),.33)}return $(t,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(t){this.to=t.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(t){const s=(t-this.startTime)/this.duration;if(s<1){const a=this.c(s),m=this.d(s);return new y(a,m,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(t,s,a){return w.start(t,s,a)}static start(t,s,a){a=a+10;const m=Date.now()-10;return new w(t,s,m,a)}}e.$Cs=w;function B(d){return Math.pow(d,3)}function f(d){return 1-B(1-d)}}),define(me[89],$e([1,0,6,3]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function j(l){const b=l;return b?typeof b.read=="function":!1}e.$ee=j;function W(l){const b=l;return b?[b.on,b.pause,b.resume,b.destroy].every(r=>typeof r=="function"):!1}e.$fe=W;function D(l){const b=l;return b?W(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}e.$ge=D;function y(l,b){return new $(l,b)}e.$he=y;class ${constructor(b,r){this.e=b,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(r=>r(b))}h(b){this.c.error.length===0?(0,i.$1)(b):this.c.error.slice(0).forEach(r=>r(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,r){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(b,r){if(this.a.destroyed)return;let A;switch(b){case"data":A=this.c.data;break;case"end":A=this.c.end;break;case"error":A=this.c.error;break}if(A){const R=A.indexOf(r);R>=0&&A.splice(R,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(A=>A())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(l,b){const r=[];let A;for(;(A=l.read())!==null;)r.push(A);return b(r)}e.$ie=p;function w(l,b,r){const A=[];let R;for(;(R=l.read())!==null&&A.length<r;)A.push(R);return R===null&&A.length>0?b(A):{read:()=>{if(A.length>0)return A.shift();if(typeof R<"u"){const I=R;return R=void 0,I}return l.read()}}}e.$je=w;function B(l,b){return new Promise((r,A)=>{const R=[];f(l,{onData:I=>{b&&R.push(I)},onError:I=>{b?A(I):r(void 0)},onEnd:()=>{r(b?b(R):void 0)}})})}e.$ke=B;function f(l,b,r){l.on("error",A=>{r?.isCancellationRequested||b.onError(A)}),l.on("end",()=>{r?.isCancellationRequested||b.onEnd()}),l.on("data",A=>{r?.isCancellationRequested||b.onData(A)})}e.$le=f;function d(l,b){return new Promise((r,A)=>{const R=new C.$Sc,I=[],O=H=>{if(I.push(H),I.length>b)return R.dispose(),l.pause(),r({stream:l,buffer:I,ended:!1})},z=H=>(R.dispose(),A(H)),v=()=>(R.dispose(),r({stream:l,buffer:I,ended:!0}));R.add((0,C.$Rc)(()=>l.removeListener("error",z))),l.on("error",z),R.add((0,C.$Rc)(()=>l.removeListener("end",v))),l.on("end",v),R.add((0,C.$Rc)(()=>l.removeListener("data",O))),l.on("data",O)})}e.$me=d;function t(l,b){const r=y(b);return r.end(l),r}e.$ne=t;function s(){const l=y(()=>{throw new Error("not supported")});return l.end(),l}e.$oe=s;function a(l){let b=!1;return{read:()=>b?null:(b=!0,l)}}e.$pe=a;function m(l,b,r){const A=y(r);return f(l,{onData:R=>A.write(b.data(R)),onError:R=>A.error(b.error?b.error(R):R),onEnd:()=>A.end()}),A}e.$qe=m;function u(l,b,r){let A=!1;return{read:()=>{const R=b.read();return A?R:(A=!0,R!==null?r([l,R]):l)}}}e.$re=u;function k(l,b,r){let A=!1;const R=y(r);return f(b,{onData:I=>A?R.write(I):(A=!0,R.write(r([l,I]))),onError:I=>R.error(I),onEnd:()=>{A||(A=!0,R.write(l)),R.end()}}),R}e.$se=k}),define(me[35],$e([1,0,23,89]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const j=typeof Buffer<"u",W=new i.$V(()=>new Uint8Array(256));let D,y;class ${static alloc(L){return j?new $(Buffer.allocUnsafe(L)):new $(new Uint8Array(L))}static wrap(L){return j&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new $(L)}static fromString(L,M){return!(M?.dontUseNodeBuffer||!1)&&j?new $(Buffer.from(L)):(D||(D=new TextEncoder),new $(D.encode(L)))}static fromByteArray(L){const M=$.alloc(L.length);for(let X=0,U=L.length;X<U;X++)M.buffer[X]=L[X];return M}static concat(L,M){if(typeof M>"u"){M=0;for(let de=0,he=L.length;de<he;de++)M+=L[de].byteLength}const X=$.alloc(M);let U=0;for(let de=0,he=L.length;de<he;de++){const ne=L[de];X.set(ne,U),U+=ne.byteLength}return X}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=$.alloc(this.byteLength);return L.set(this),L}toString(){return j?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(L,M){return new $(this.buffer.subarray(L,M))}set(L,M){if(L instanceof $)this.buffer.set(L.buffer,M);else if(L instanceof Uint8Array)this.buffer.set(L,M);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),M);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return f(this.buffer,L)}writeUInt32BE(L,M){d(this.buffer,L,M)}readUInt32LE(L){return t(this.buffer,L)}writeUInt32LE(L,M){s(this.buffer,L,M)}readUInt8(L){return a(this.buffer,L)}writeUInt8(L,M){m(this.buffer,L,M)}indexOf(L,M=0){return p(this.buffer,L instanceof $?L.buffer:L,M)}}e.$te=$;function p(S,L,M=0){const X=L.byteLength,U=S.byteLength;if(X===0)return 0;if(X===1)return S.indexOf(L[0]);if(X>U-M)return-1;const de=W.value;de.fill(L.length);for(let Fe=0;Fe<L.length;Fe++)de[L[Fe]]=L.length-Fe-1;let he=M+L.length-1,ne=he,ge=-1;for(;he<U;)if(S[he]===L[ne]){if(ne===0){ge=he;break}he--,ne--}else he+=Math.max(L.length-ne,de[S[he]]),ne=L.length-1;return ge}e.$ue=p;function w(S,L){return S[L+0]<<0>>>0|S[L+1]<<8>>>0}e.$ve=w;function B(S,L,M){S[M+0]=L&255,L=L>>>8,S[M+1]=L&255}e.$we=B;function f(S,L){return S[L]*2**24+S[L+1]*2**16+S[L+2]*2**8+S[L+3]}e.$xe=f;function d(S,L,M){S[M+3]=L,L=L>>>8,S[M+2]=L,L=L>>>8,S[M+1]=L,L=L>>>8,S[M]=L}e.$ye=d;function t(S,L){return S[L+0]<<0>>>0|S[L+1]<<8>>>0|S[L+2]<<16>>>0|S[L+3]<<24>>>0}e.$ze=t;function s(S,L,M){S[M+0]=L&255,L=L>>>8,S[M+1]=L&255,L=L>>>8,S[M+2]=L&255,L=L>>>8,S[M+3]=L&255}e.$Ae=s;function a(S,L){return S[L]}e.$Be=a;function m(S,L,M){S[M]=L}e.$Ce=m;function u(S){return C.$ie(S,L=>$.concat(L))}e.$De=u;function k(S){return C.$pe(S)}e.$Ee=k;function l(S){return C.$ke(S,L=>$.concat(L))}e.$Fe=l;async function b(S){return S.ended?$.concat(S.buffer):$.concat([...S.buffer,await l(S.stream)])}e.$Ge=b;function r(S){return C.$ne(S,L=>$.concat(L))}e.$He=r;function A(S){return C.$qe(S,{data:L=>typeof L=="string"?$.fromString(L):$.wrap(L)},L=>$.concat(L))}e.$Ie=A;function R(S){return C.$he(L=>$.concat(L),S)}e.$Je=R;function I(S,L){return C.$re(S,L,M=>$.concat(M))}e.$Ke=I;function O(S,L){return C.$se(S,L,M=>$.concat(M))}e.$Le=O;function z(S){let L=0,M=0,X=0;const U=new Uint8Array(Math.floor(S.length/4*3)),de=ne=>{switch(M){case 3:U[X++]=L|ne,M=0;break;case 2:U[X++]=L|ne>>>2,L=ne<<6,M=3;break;case 1:U[X++]=L|ne>>>4,L=ne<<4,M=2;break;default:L=ne<<2,M=1}};for(let ne=0;ne<S.length;ne++){const ge=S.charCodeAt(ne);if(ge>=65&&ge<=90)de(ge-65);else if(ge>=97&&ge<=122)de(ge-97+26);else if(ge>=48&&ge<=57)de(ge-48+52);else if(ge===43||ge===45)de(62);else if(ge===47||ge===95)de(63);else{if(ge===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ne]}`)}}const he=X;for(;M>0;)de(0);return $.wrap(U).slice(0,he)}e.$Me=z;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:S},L=!0,M=!1){const X=M?H:v;let U="";const de=S.byteLength%3;let he=0;for(;he<S.byteLength-de;he+=3){const ne=S[he+0],ge=S[he+1],Fe=S[he+2];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[(ge<<2|Fe>>>6)&63],U+=X[Fe&63]}if(de===1){const ne=S[he+0];U+=X[ne>>>2],U+=X[ne<<4&63],L&&(U+="==")}else if(de===2){const ne=S[he+0],ge=S[he+1];U+=X[ne>>>2],U+=X[(ne<<4|ge>>>4)&63],U+=X[ge<<2&63],L&&(U+="=")}return U}e.$Ne=V}),define(me[10],$e([1,0,88,23]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.GraphemeBreakType=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=void 0;function j(Y){return!Y||typeof Y!="string"?!0:Y.trim().length===0}e.$Te=j;const W=/{(\d+)}/g;function D(Y,...se){return se.length===0?Y:Y.replace(W,function(pe,ve){const Le=parseInt(ve,10);return isNaN(Le)||Le<0||Le>=se.length?pe:se[Le]})}e.$Ue=D;const y=/{([^}]+)}/g;function $(Y,se){return Object.keys(se).length===0?Y:Y.replace(y,(pe,ve)=>se[ve]??pe)}e.$Ve=$;function p(Y){return Y.replace(/[<>"'&]/g,se=>{switch(se){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return se})}e.$We=p;function w(Y){return Y.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.$Xe=w;function B(Y){return Y.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ye=B;function f(Y,se){let pe=0;const ve=se.charCodeAt(0);for(let Le=Y.length-1;Le>=0;Le--)Y.charCodeAt(Le)===ve&&pe++;return pe}e.$Ze=f;function d(Y,se,pe="\u2026"){return Y.length<=se?Y:`${Y.substr(0,se)}${pe}`}e.$1e=d;function t(Y,se,pe="\u2026"){if(Y.length<=se)return Y;const ve=Math.ceil(se/2)-pe.length/2,Le=Math.floor(se/2)-pe.length/2;return`${Y.substr(0,ve)}${pe}${Y.substr(Y.length-Le)}`}e.$2e=t;function s(Y,se=" "){const pe=a(Y,se);return m(pe,se)}e.$3e=s;function a(Y,se){if(!Y||!se)return Y;const pe=se.length;if(pe===0||Y.length===0)return Y;let ve=0;for(;Y.indexOf(se,ve)===ve;)ve=ve+pe;return Y.substring(ve)}e.$4e=a;function m(Y,se){if(!Y||!se)return Y;const pe=se.length,ve=Y.length;if(pe===0||ve===0)return Y;let Le=ve,je=-1;for(;je=Y.lastIndexOf(se,Le-1),!(je===-1||je+pe!==Le);){if(je===0)return"";Le=je}return Y.substring(0,Le)}e.$5e=m;function u(Y){return Y.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$6e=u;function k(Y){return Y.replace(/\*/g,"")}e.$7e=k;function l(Y,se,pe={}){if(!Y)throw new Error("Cannot create regex from empty string");se||(Y=B(Y)),pe.wholeWord&&(/\B/.test(Y.charAt(0))||(Y="\\b"+Y),/\B/.test(Y.charAt(Y.length-1))||(Y=Y+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(Y,ve)}e.$8e=l;function b(Y){return Y.source==="^"||Y.source==="^$"||Y.source==="$"||Y.source==="^\\s*$"?!1:!!(Y.exec("")&&Y.lastIndex===0)}e.$9e=b;function r(Y){return Y.split(/\r\n|\r|\n/)}e.$0e=r;function A(Y){const se=[],pe=Y.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)se.push(pe[2*ve]+(pe[2*ve+1]??""));return se}e.$$e=A;function R(Y){for(let se=0,pe=Y.length;se<pe;se++){const ve=Y.charCodeAt(se);if(ve!==32&&ve!==9)return se}return-1}e.$_e=R;function I(Y,se=0,pe=Y.length){for(let ve=se;ve<pe;ve++){const Le=Y.charCodeAt(ve);if(Le!==32&&Le!==9)return Y.substring(se,ve)}return Y.substring(se,pe)}e.$af=I;function O(Y,se=Y.length-1){for(let pe=se;pe>=0;pe--){const ve=Y.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}e.$bf=O;function z(Y,se,pe){const ve=[];let Le=0;for(const je of Y.matchAll(se)){if(ve.push(Y.slice(Le,je.index)),je.index===void 0)throw new Error("match.index should be defined");Le=je.index+je[0].length,ve.push(pe(je[0],...je.slice(1),je.index,Y,je.groups))}return ve.push(Y.slice(Le)),Promise.all(ve).then(je=>je.join(""))}e.$cf=z;function v(Y,se){return Y<se?-1:Y>se?1:0}e.$df=v;function H(Y,se,pe=0,ve=Y.length,Le=0,je=se.length){for(;pe<ve&&Le<je;pe++,Le++){const tt=Y.charCodeAt(pe),st=se.charCodeAt(Le);if(tt<st)return-1;if(tt>st)return 1}const qe=ve-pe,_e=je-Le;return qe<_e?-1:qe>_e?1:0}e.$ef=H;function V(Y,se){return S(Y,se,0,Y.length,0,se.length)}e.$ff=V;function S(Y,se,pe=0,ve=Y.length,Le=0,je=se.length){for(;pe<ve&&Le<je;pe++,Le++){let tt=Y.charCodeAt(pe),st=se.charCodeAt(Le);if(tt===st)continue;if(tt>=128||st>=128)return H(Y.toLowerCase(),se.toLowerCase(),pe,ve,Le,je);M(tt)&&(tt-=32),M(st)&&(st-=32);const Ze=tt-st;if(Ze!==0)return Ze}const qe=ve-pe,_e=je-Le;return qe<_e?-1:qe>_e?1:0}e.$gf=S;function L(Y){return Y>=48&&Y<=57}e.$hf=L;function M(Y){return Y>=97&&Y<=122}e.$if=M;function X(Y){return Y>=65&&Y<=90}e.$jf=X;function U(Y,se){return Y.length===se.length&&S(Y,se)===0}e.$kf=U;function de(Y,se){const pe=se.length;return se.length>Y.length?!1:S(Y,se,0,pe)===0}e.$lf=de;function he(Y,se){const pe=Math.min(Y.length,se.length);let ve;for(ve=0;ve<pe;ve++)if(Y.charCodeAt(ve)!==se.charCodeAt(ve))return ve;return pe}e.$mf=he;function ne(Y,se){const pe=Math.min(Y.length,se.length);let ve;const Le=Y.length-1,je=se.length-1;for(ve=0;ve<pe;ve++)if(Y.charCodeAt(Le-ve)!==se.charCodeAt(je-ve))return ve;return pe}e.$nf=ne;function ge(Y){return 55296<=Y&&Y<=56319}e.$of=ge;function Fe(Y){return 56320<=Y&&Y<=57343}e.$pf=Fe;function Ce(Y,se){return(Y-55296<<10)+(se-56320)+65536}e.$qf=Ce;function Be(Y,se,pe){const ve=Y.charCodeAt(pe);if(ge(ve)&&pe+1<se){const Le=Y.charCodeAt(pe+1);if(Fe(Le))return Ce(ve,Le)}return ve}e.$rf=Be;function le(Y,se){const pe=Y.charCodeAt(se-1);if(Fe(pe)&&se>1){const ve=Y.charCodeAt(se-2);if(ge(ve))return Ce(ve,pe)}return pe}class _{get offset(){return this.e}constructor(se,pe=0){this.c=se,this.d=se.length,this.e=pe}setOffset(se){this.e=se}prevCodePoint(){const se=le(this.c,this.e);return this.e-=se>=65536?2:1,se}nextCodePoint(){const se=Be(this.c,this.d,this.e);return this.e+=se>=65536?2:1,se}eol(){return this.e>=this.d}}e.$sf=_;class ae{get offset(){return this.c.offset}constructor(se,pe=0){this.c=new _(se,pe)}nextGraphemeLength(){const se=Ee.getInstance(),pe=this.c,ve=pe.offset;let Le=se.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const je=pe.offset,qe=se.getGraphemeBreakType(pe.nextCodePoint());if(ke(Le,qe)){pe.setOffset(je);break}Le=qe}return pe.offset-ve}prevGraphemeLength(){const se=Ee.getInstance(),pe=this.c,ve=pe.offset;let Le=se.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const je=pe.offset,qe=se.getGraphemeBreakType(pe.prevCodePoint());if(ke(qe,Le)){pe.setOffset(je);break}Le=qe}return ve-pe.offset}eol(){return this.c.eol()}}e.$tf=ae;function oe(Y,se){return new ae(Y,se).nextGraphemeLength()}e.$uf=oe;function J(Y,se){return new ae(Y,se).prevGraphemeLength()}e.$vf=J;function G(Y,se){se>0&&Fe(Y.charCodeAt(se))&&se--;const pe=se+oe(Y,se);return[pe-J(Y,pe),pe]}e.$wf=G;function ie(Y){const se=new ae(Y);let pe=0;for(;!se.eol();)pe++,se.nextGraphemeLength();return pe}e.$xf=ie;let ce;function De(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Ne(Y){return ce||(ce=De()),ce.test(Y)}e.$yf=Ne;const ye=/^[\t\n\r\x20-\x7E]*$/;function K(Y){return ye.test(Y)}e.$zf=K,e.$Af=/[\u2028\u2029]/;function g(Y){return e.$Af.test(Y)}e.$Bf=g;function E(Y){return Y>=11904&&Y<=55215||Y>=63744&&Y<=64255||Y>=65281&&Y<=65374}e.$Cf=E;function N(Y){return Y>=127462&&Y<=127487||Y===8986||Y===8987||Y===9200||Y===9203||Y>=9728&&Y<=10175||Y===11088||Y===11093||Y>=127744&&Y<=128591||Y>=128640&&Y<=128764||Y>=128992&&Y<=129008||Y>=129280&&Y<=129535||Y>=129648&&Y<=129782}e.$Df=N;function o(Y,se,pe=""){const ve=Y.trimStart();if(ve.length<se)return ve;const Le=/\b/g;let je=0;for(;Le.test(ve)&&!(ve.length-Le.lastIndex<se);)je=Le.lastIndex,Le.lastIndex+=1;return je===0?ve:pe+ve.substring(je).trimStart()}e.$Ef=o;const c=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,n=/\x1b\].*?\x07/g;function h(Y){return Y&&(Y=Y.replace(c,"").replace(n,"")),Y}e.$Ff=h,e.$Gf="\uFEFF";function F(Y){return!!(Y&&Y.length>0&&Y.charCodeAt(0)===65279)}e.$Hf=F;function T(Y){return F(Y)?Y.substr(1):Y}e.$If=T;function P(Y,se){if(!Y||!se||Y.length<se.length)return!1;const pe=se.length,ve=Y.toLowerCase();let Le=0,je=-1;for(;Le<pe;){const qe=ve.indexOf(se[Le],je+1);if(qe<0)return!1;je=qe,Le++}return!0}e.$Jf=P;function q(Y,se=!1){return Y?(se&&(Y=Y.replace(/\\./g,"")),Y.toLowerCase()!==Y):!1}e.$Kf=q;function Z(Y){return Y.charAt(0).toUpperCase()+Y.slice(1)}e.$Lf=Z;function ee(Y,se=1){if(se===0)return"";let pe=-1;do pe=Y.indexOf(`
`,pe+1),se--;while(se>0&&pe>=0);return pe===-1?Y:(Y[pe-1]==="\r"&&pe--,Y.substr(0,pe))}e.$Mf=ee;function be(Y){return Y=Y%(2*26),Y<26?String.fromCharCode(97+Y):String.fromCharCode(65+Y-26)}e.$Nf=be;function we(Y){return Ee.getInstance().getGraphemeBreakType(Y)}e.$Of=we;function ke(Y,se){return Y===0?se!==5&&se!==7:Y===2&&se===3?!1:Y===4||Y===2||Y===3||se===4||se===2||se===3?!0:!(Y===8&&(se===8||se===9||se===11||se===12)||(Y===11||Y===9)&&(se===9||se===10)||(Y===12||Y===10)&&se===10||se===5||se===13||se===7||Y===1||Y===13&&se===14||Y===6&&se===6)}var Oe;(function(Y){Y[Y.Other=0]="Other",Y[Y.Prepend=1]="Prepend",Y[Y.CR=2]="CR",Y[Y.LF=3]="LF",Y[Y.Control=4]="Control",Y[Y.Extend=5]="Extend",Y[Y.Regional_Indicator=6]="Regional_Indicator",Y[Y.SpacingMark=7]="SpacingMark",Y[Y.L=8]="L",Y[Y.V=9]="V",Y[Y.T=10]="T",Y[Y.LV=11]="LV",Y[Y.LVT=12]="LVT",Y[Y.ZWJ=13]="ZWJ",Y[Y.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=Ae()}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const pe=this.d,ve=pe.length/3;let Le=1;for(;Le<=ve;)if(se<pe[3*Le])Le=2*Le;else if(se>pe[3*Le+1])Le=2*Le+1;else return pe[3*Le+2];return 0}}function Ae(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(Y,se){if(Y===0)return 0;const pe=Ie(Y,se);if(pe!==void 0)return pe;const ve=new _(se,Y);return ve.prevCodePoint(),ve.offset}e.$Pf=Re;function Ie(Y,se){const pe=new _(se,Y);let ve=pe.prevCodePoint();for(;Ge(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!N(ve))return;let Le=pe.offset;return Le>0&&pe.prevCodePoint()===8205&&(Le=pe.offset),Le}function Ge(Y){return 127995<=Y&&Y<=127999}var nt;(function(Y){Y[Y.zwj=8205]="zwj",Y[Y.emojiVariantSelector=65039]="emojiVariantSelector",Y[Y.enclosingKeyCap=8419]="enclosingKeyCap"})(nt||(nt={})),e.$Qf="\xA0";class Ye{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new i.$Pe(se=>{function pe(Ze){const rt=new Map;for(let et=0;et<Ze.length;et+=2)rt.set(Ze[et],Ze[et+1]);return rt}function ve(Ze,rt){const et=new Map(Ze);for(const[gt,mt]of rt)et.set(gt,mt);return et}function Le(Ze,rt){if(!Ze)return rt;const et=new Map;for(const[gt,mt]of Ze)rt.has(gt)&&et.set(gt,mt);return et}const je=this.c.value;let qe=se.filter(Ze=>!Ze.startsWith("_")&&Ze in je);qe.length===0&&(qe=["_default"]);let _e;for(const Ze of qe){const rt=pe(je[Ze]);_e=Le(_e,rt)}const tt=pe(je._common),st=ve(tt,_e);return new Ye(st)})}static getInstance(se){return Ye.d.get(Array.from(se))}static{this.e=new C.$V(()=>Object.keys(Ye.c.value).filter(se=>!se.startsWith("_")))}static getLocales(){return Ye.e.value}constructor(se){this.f=se}isAmbiguous(se){return this.f.has(se)}getPrimaryConfusable(se){return this.f.get(se)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=Ye;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(se){return Ue.e().has(se)}static get codePoints(){return Ue.e()}}e.$Sf=Ue}),define(me[36],$e([1,0,33,83,10]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.FuzzyScore=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.or=void 0;function W(...T){return function(P,q){for(let Z=0,ee=T.length;Z<ee;Z++){const be=T[Z](P,q);if(be)return be}return null}}e.or=W,e.$7j=D.bind(void 0,!1),e.$8j=D.bind(void 0,!0);function D(T,P,q){if(!q||q.length<P.length)return null;let Z;return T?Z=j.$lf(q,P):Z=q.indexOf(P)===0,Z?P.length>0?[{start:0,end:P.length}]:[]:null}function y(T,P){const q=P.toLowerCase().indexOf(T.toLowerCase());return q===-1?null:[{start:q,end:q+T.length}]}e.$9j=y;function $(T,P){return p(T.toLowerCase(),P.toLowerCase(),0,0)}e.$0j=$;function p(T,P,q,Z){if(q===T.length)return[];if(Z===P.length)return null;if(T[q]===P[Z]){let ee=null;return(ee=p(T,P,q+1,Z+1))?l({start:Z,end:Z+1},ee):null}return p(T,P,q,Z+1)}function w(T){return 97<=T&&T<=122}function B(T){return 65<=T&&T<=90}e.$$j=B;function f(T){return 48<=T&&T<=57}function d(T){return T===32||T===9||T===10||T===13}const t=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>t.add(T.charCodeAt(0)));function s(T){return d(T)||t.has(T)}function a(T,P){return T===P||s(T)&&s(P)}const m=new Map;function u(T){if(m.has(T))return m.get(T);let P;const q=(0,C.$5j)(T);return q&&(P=q),m.set(T,P),P}function k(T){return w(T)||B(T)||f(T)}function l(T,P){return P.length===0?P=[T]:T.end===P[0].start?P[0].start=T.start:P.unshift(T),P}function b(T,P){for(let q=P;q<T.length;q++){const Z=T.charCodeAt(q);if(B(Z)||f(Z)||q>0&&!k(T.charCodeAt(q-1)))return q}return T.length}function r(T,P,q,Z){if(q===T.length)return[];if(Z===P.length)return null;if(T[q]!==P[Z].toLowerCase())return null;{let ee=null,be=Z+1;for(ee=r(T,P,q+1,Z+1);!ee&&(be=b(P,be))<P.length;)ee=r(T,P,q+1,be),be++;return ee===null?null:l({start:Z,end:Z+1},ee)}}function A(T){let P=0,q=0,Z=0,ee=0,be=0;for(let Ae=0;Ae<T.length;Ae++)be=T.charCodeAt(Ae),B(be)&&P++,w(be)&&q++,k(be)&&Z++,f(be)&&ee++;const we=P/T.length,ke=q/T.length,Oe=Z/T.length,Ee=ee/T.length;return{upperPercent:we,lowerPercent:ke,alphaPercent:Oe,numericPercent:Ee}}function R(T){const{upperPercent:P,lowerPercent:q}=T;return q===0&&P>.6}function I(T){const{upperPercent:P,lowerPercent:q,alphaPercent:Z,numericPercent:ee}=T;return q>.2&&P<.8&&Z>.6&&ee<.2}function O(T){let P=0,q=0,Z=0,ee=0;for(let be=0;be<T.length;be++)Z=T.charCodeAt(be),B(Z)&&P++,w(Z)&&q++,d(Z)&&ee++;return(P===0||q===0)&&ee===0?T.length<=30:P<=5}function z(T,P){if(!P||(P=P.trim(),P.length===0)||!O(T))return null;P.length>60&&(P=P.substring(0,60));const q=A(P);if(!I(q)){if(!R(q))return null;P=P.toLowerCase()}let Z=null,ee=0;for(T=T.toLowerCase();ee<P.length&&(Z=r(T,P,0,ee))===null;)ee=b(P,ee+1);return Z}e.$_j=z;function v(T,P,q=!1){if(!P||P.length===0)return null;let Z=null,ee=0;for(T=T.toLowerCase(),P=P.toLowerCase();ee<P.length&&(Z=H(T,P,0,ee,q),Z===null);)ee=V(P,ee+1);return Z}e.$ak=v;function H(T,P,q,Z,ee){let be=0;if(q===T.length)return[];if(Z===P.length)return null;if(!a(T.charCodeAt(q),P.charCodeAt(Z))){const Oe=u(T.charCodeAt(q));if(!Oe)return null;for(let Ee=0;Ee<Oe.length;Ee++)if(!a(Oe[Ee],P.charCodeAt(Z+Ee)))return null;be+=Oe.length-1}let we=null,ke=Z+be+1;if(we=H(T,P,q+1,ke,ee),!ee)for(;!we&&(ke=V(P,ke))<P.length;)we=H(T,P,q+1,ke,ee),ke++;if(!we)return null;if(T.charCodeAt(q)!==P.charCodeAt(Z)){const Oe=u(T.charCodeAt(q));if(!Oe)return we;for(let Ee=0;Ee<Oe.length;Ee++)if(Oe[Ee]!==P.charCodeAt(Z+Ee))return we}return l({start:Z,end:Z+be+1},we)}function V(T,P){for(let q=P;q<T.length;q++)if(s(T.charCodeAt(q))||q>0&&s(T.charCodeAt(q-1)))return q;return T.length}const S=W(e.$8j,z,y),L=W(e.$8j,z,$),M=new i.$Dc(1e4);function X(T,P,q=!1){if(typeof T!="string"||typeof P!="string")return null;let Z=M.get(T);Z||(Z=new RegExp(j.$6e(T),"i"),M.set(T,Z));const ee=Z.exec(P);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:q?L(T,P):S(T,P)}e.$bk=X;function U(T,P){const q=E(T,T.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return q?he(q):null}e.$ck=U;function de(T,P,q,Z,ee,be){const we=Math.min(13,T.length);for(;q<we;q++){const ke=E(T,P,q,Z,ee,be,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ke)return ke}return[0,be]}e.$dk=de;function he(T){if(typeof T>"u")return[];const P=[],q=T[1];for(let Z=T.length-1;Z>1;Z--){const ee=T[Z]+q,be=P[P.length-1];be&&be.end===ee?be.end=ee+1:P.push({start:ee,end:ee+1})}return P}e.$ek=he;const ne=128;function ge(){const T=[],P=[];for(let q=0;q<=ne;q++)P[q]=0;for(let q=0;q<=ne;q++)T.push(P.slice(0));return T}function Fe(T){const P=[];for(let q=0;q<=T;q++)P[q]=0;return P}const Ce=Fe(2*ne),Be=Fe(2*ne),le=ge(),_=ge(),ae=ge(),oe=!1;function J(T,P,q,Z,ee){function be(ke,Oe,Ee=" "){for(;ke.length<Oe;)ke=Ee+ke;return ke}let we=` |   |${Z.split("").map(ke=>be(ke,3)).join("|")}
`;for(let ke=0;ke<=q;ke++)ke===0?we+=" |":we+=`${P[ke-1]}|`,we+=T[ke].slice(0,ee+1).map(Oe=>be(Oe.toString(),3)).join("|")+`
`;return we}function G(T,P,q,Z){T=T.substr(P),q=q.substr(Z),console.log(J(_,T,T.length,q,q.length)),console.log(J(ae,T,T.length,q,q.length)),console.log(J(le,T,T.length,q,q.length))}function ie(T,P){if(P<0||P>=T.length)return!1;const q=T.codePointAt(P);switch(q){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!j.$Df(q)}}function ce(T,P){if(P<0||P>=T.length)return!1;switch(T.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function De(T,P,q){return P[T]!==q[T]}function Ne(T,P,q,Z,ee,be,we=!1){for(;P<q&&ee<be;)T[P]===Z[ee]&&(we&&(Ce[P]=ee),P+=1),ee+=1;return P===q}e.$fk=Ne;var ye;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var K;(function(T){T.Default=[-100,0];function P(q){return!q||q.length===2&&q[0]===-100&&q[1]===0}T.isDefault=P})(K||(e.FuzzyScore=K={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(P,q){this.firstMatchCanBeWeak=P,this.boostFullMatch=q}}e.$gk=g;function E(T,P,q,Z,ee,be,we=g.default){const ke=T.length>ne?ne:T.length,Oe=Z.length>ne?ne:Z.length;if(q>=ke||be>=Oe||ke-q>Oe-be||!Ne(P,q,ke,ee,be,Oe,!0))return;N(ke,Oe,q,be,P,ee);let Ee=1,Ae=1,Re=q,Ie=be;const Ge=[!1];for(Ee=1,Re=q;Re<ke;Ee++,Re++){const se=Ce[Re],pe=Be[Re],ve=Re+1<ke?Be[Re+1]:Oe;for(Ae=se-be+1,Ie=se;Ie<ve;Ae++,Ie++){let Le=Number.MIN_SAFE_INTEGER,je=!1;Ie<=pe&&(Le=o(T,P,Re,q,Z,ee,Ie,Oe,be,le[Ee-1][Ae-1]===0,Ge));let qe=0;Le!==Number.MAX_SAFE_INTEGER&&(je=!0,qe=Le+_[Ee-1][Ae-1]);const _e=Ie>se,tt=_e?_[Ee][Ae-1]+(le[Ee][Ae-1]>0?-5:0):0,st=Ie>se+1&&le[Ee][Ae-1]>0,Ze=st?_[Ee][Ae-2]+(le[Ee][Ae-2]>0?-5:0):0;if(st&&(!_e||Ze>=tt)&&(!je||Ze>=qe))_[Ee][Ae]=Ze,ae[Ee][Ae]=3,le[Ee][Ae]=0;else if(_e&&(!je||tt>=qe))_[Ee][Ae]=tt,ae[Ee][Ae]=2,le[Ee][Ae]=0;else if(je)_[Ee][Ae]=qe,ae[Ee][Ae]=1,le[Ee][Ae]=le[Ee-1][Ae-1]+1;else throw new Error("not possible")}}if(oe&&G(T,q,Z,be),!Ge[0]&&!we.firstMatchCanBeWeak)return;Ee--,Ae--;const nt=[_[Ee][Ae],be];let Ye=0,Ue=0;for(;Ee>=1;){let se=Ae;do{const pe=ae[Ee][se];if(pe===3)se=se-2;else if(pe===2)se=se-1;else break}while(se>=1);Ye>1&&P[q+Ee-1]===ee[be+Ae-1]&&!De(se+be-1,Z,ee)&&Ye+1>le[Ee][se]&&(se=Ae),se===Ae?Ye++:Ye=1,Ue||(Ue=se),Ee--,Ae=se-1,nt.push(Ae)}Oe===ke&&we.boostFullMatch&&(nt[0]+=2);const Y=Ue-ke;return nt[0]-=Y,nt}e.$hk=E;function N(T,P,q,Z,ee,be){let we=T-1,ke=P-1;for(;we>=q&&ke>=Z;)ee[we]===be[ke]&&(Be[we]=ke,we--),ke--}function o(T,P,q,Z,ee,be,we,ke,Oe,Ee,Ae){if(P[q]!==be[we])return Number.MIN_SAFE_INTEGER;let Re=1,Ie=!1;return we===q-Z?Re=T[q]===ee[we]?7:5:De(we,ee,be)&&(we===0||!De(we-1,ee,be))?(Re=T[q]===ee[we]?7:5,Ie=!0):ie(be,we)&&(we===0||!ie(be,we-1))?Re=5:(ie(be,we-1)||ce(be,we-1))&&(Re=5,Ie=!0),Re>1&&q===Z&&(Ae[0]=!0),Ie||(Ie=De(we,ee,be)||ie(be,we-1)||ce(be,we-1)),q===Z?we>Oe&&(Re-=Ie?3:5):Ee?Re+=Ie?2:0:Re+=Ie?0:1,we+1===ke&&(Re-=Ie?3:5),Re}function c(T,P,q,Z,ee,be,we){return h(T,P,q,Z,ee,be,!0,we)}e.$ik=c;function n(T,P,q,Z,ee,be,we){return h(T,P,q,Z,ee,be,!1,we)}e.$jk=n;function h(T,P,q,Z,ee,be,we,ke){let Oe=E(T,P,q,Z,ee,be,ke);if(Oe&&!we)return Oe;if(T.length>=3){const Ee=Math.min(7,T.length-1);for(let Ae=q+1;Ae<Ee;Ae++){const Re=F(T,Ae);if(Re){const Ie=E(Re,Re.toLowerCase(),q,Z,ee,be,ke);Ie&&(Ie[0]-=3,(!Oe||Ie[0]>Oe[0])&&(Oe=Ie))}}}return Oe}function F(T,P){if(P+1>=T.length)return;const q=T[P],Z=T[P+1];if(q!==Z)return T.slice(0,P)+Z+q+T.slice(P+2)}}),define(me[52],$e([1,0,10]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function C(m){return j(m,0)}e.$7i=C;function j(m,u){switch(typeof m){case"object":return m===null?W(349,u):Array.isArray(m)?$(m,u):p(m,u);case"string":return y(m,u);case"boolean":return D(m,u);case"number":return W(m,u);case"undefined":return W(937,u);default:return W(617,u)}}e.$8i=j;function W(m,u){return(u<<5)-u+m|0}e.$9i=W;function D(m,u){return W(m?433:863,u)}function y(m,u){u=W(149417,u);for(let k=0,l=m.length;k<l;k++)u=W(m.charCodeAt(k),u);return u}e.$0i=y;function $(m,u){return u=W(104579,u),m.reduce((k,l)=>j(l,k),u)}function p(m,u){return u=W(181387,u),Object.keys(m).sort().reduce((k,l)=>(k=y(l,k),j(m[l],k)),u)}class w{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=j(u,this.g),this.g}}e.$$i=w;var B;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(B||(B={}));function f(m,u,k=32){const l=k-u,b=~((1<<l)-1);return(m<<u|(b&m)>>>l)>>>0}function d(m,u=0,k=m.byteLength,l=0){for(let b=0;b<k;b++)m[u+b]=l}function t(m,u,k="0"){for(;m.length<u;)m=k+m;return m}function s(m,u=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(k=>k.toString(16).padStart(2,"0")).join(""):t((m>>>0).toString(16),u/4)}e.$_i=s;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const k=u.length;if(k===0)return;const l=this.p;let b=this.r,r=this.u,A,R;for(r!==0?(A=r,R=-1,r=0):(A=u.charCodeAt(0),R=0);;){let I=A;if(i.$of(A))if(R+1<k){const O=u.charCodeAt(R+1);i.$pf(O)?(R++,I=i.$qf(A,O)):I=65533}else{r=A;break}else i.$pf(A)&&(I=65533);if(b=this.w(l,b,I),R++,R<k)A=u.charCodeAt(R);else break}this.r=b,this.u=r}w(u,k,l){return l<128?u[k++]=l:l<2048?(u[k++]=192|(l&1984)>>>6,u[k++]=128|(l&63)>>>0):l<65536?(u[k++]=224|(l&61440)>>>12,u[k++]=128|(l&4032)>>>6,u[k++]=128|(l&63)>>>0):(u[k++]=240|(l&1835008)>>>18,u[k++]=128|(l&258048)>>>12,u[k++]=128|(l&4032)>>>6,u[k++]=128|(l&63)>>>0),k>=64&&(this.y(),k-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),k}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=a.g,k=this.q;for(let v=0;v<64;v+=4)u.setUint32(v,k.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)u.setUint32(v,f(u.getUint32(v-12,!1)^u.getUint32(v-32,!1)^u.getUint32(v-56,!1)^u.getUint32(v-64,!1),1),!1);let l=this.h,b=this.l,r=this.m,A=this.n,R=this.o,I,O,z;for(let v=0;v<80;v++)v<20?(I=b&r|~b&A,O=1518500249):v<40?(I=b^r^A,O=1859775393):v<60?(I=b&r|b&A|r&A,O=2400959708):(I=b^r^A,O=3395469782),z=f(l,5)+I+R+O+u.getUint32(v*4,!1)&4294967295,R=A,A=r,r=f(b,30),b=l,l=z;this.h=this.h+l&4294967295,this.l=this.l+b&4294967295,this.m=this.m+r&4294967295,this.n=this.n+A&4294967295,this.o=this.o+R&4294967295}}e.$aj=a}),define(me[90],$e([1,0,78,52]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.$ct=e.$bt=void 0;class j{constructor(f){this.a=f}getElements(){const f=this.a,d=new Int32Array(f.length);for(let t=0,s=f.length;t<s;t++)d[t]=f.charCodeAt(t);return d}}e.$bt=j;function W(B,f,d){return new w(new j(B),new j(f)).ComputeDiff(d).changes}e.$ct=W;class D{static Assert(f,d){if(!f)throw new Error(d)}}class y{static Copy(f,d,t,s,a){for(let m=0;m<a;m++)t[s+m]=f[d+m]}static Copy2(f,d,t,s,a){for(let m=0;m<a;m++)t[s+m]=f[d+m]}}var $;(function(B){B[B.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})($||($={}));class p{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new i.$at(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.d++}AddModifiedElement(f,d){this.b=Math.min(this.b,f),this.c=Math.min(this.c,d),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(f,d,t=null){this.a=t,this.b=f,this.c=d;const[s,a,m]=w.o(f),[u,k,l]=w.o(d);this.d=m&&l,this.e=s,this.f=a,this.g=u,this.h=k,this.k=[],this.m=[]}static n(f){return f.length>0&&typeof f[0]=="string"}static o(f){const d=f.getElements();if(w.n(d)){const t=new Int32Array(d.length);for(let s=0,a=d.length;s<a;s++)t[s]=(0,C.$0i)(d[s],0);return[d,t,!0]}return d instanceof Int32Array?[[],d,!1]:[[],new Int32Array(d),!1]}p(f,d){return this.f[f]!==this.h[d]?!1:this.d?this.e[f]===this.g[d]:!0}q(f,d){if(!this.p(f,d))return!1;const t=w.r(this.b,f),s=w.r(this.c,d);return t===s}static r(f,d){return typeof f.getStrictElement=="function"?f.getStrictElement(d):null}s(f,d){return this.f[f]!==this.f[d]?!1:this.d?this.e[f]===this.e[d]:!0}u(f,d){return this.h[f]!==this.h[d]?!1:this.d?this.g[f]===this.g[d]:!0}ComputeDiff(f){return this.v(0,this.f.length-1,0,this.h.length-1,f)}v(f,d,t,s,a){const m=[!1];let u=this.w(f,d,t,s,m);return a&&(u=this.z(u)),{quitEarly:m[0],changes:u}}w(f,d,t,s,a){for(a[0]=!1;f<=d&&t<=s&&this.p(f,t);)f++,t++;for(;d>=f&&s>=t&&this.p(d,s);)d--,s--;if(f>d||t>s){let r;return t<=s?(D.Assert(f===d+1,"originalStart should only be one more than originalEnd"),r=[new i.$at(f,0,t,s-t+1)]):f<=d?(D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[new i.$at(f,d-f+1,t,0)]):(D.Assert(f===d+1,"originalStart should only be one more than originalEnd"),D.Assert(t===s+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const m=[0],u=[0],k=this.y(f,d,t,s,m,u,a),l=m[0],b=u[0];if(k!==null)return k;if(!a[0]){const r=this.w(f,l,t,b,a);let A=[];return a[0]?A=[new i.$at(l+1,d-(l+1)+1,b+1,s-(b+1)+1)]:A=this.w(l+1,d,b+1,s,a),this.H(r,A)}return[new i.$at(f,d-f+1,t,s-t+1)]}x(f,d,t,s,a,m,u,k,l,b,r,A,R,I,O,z,v,H){let V=null,S=null,L=new p,M=d,X=t,U=R[0]-z[0]-s,de=-1073741824,he=this.k.length-1;do{const ne=U+f;ne===M||ne<X&&l[ne-1]<l[ne+1]?(r=l[ne+1],I=r-U-s,r<de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,I),U=ne+1-f):(r=l[ne-1]+1,I=r-U-s,r<de&&L.MarkNextChange(),de=r-1,L.AddOriginalElement(r,I+1),U=ne-1-f),he>=0&&(l=this.k[he],f=l[0],M=1,X=l.length-1)}while(--he>=-1);if(V=L.getReverseChanges(),H[0]){let ne=R[0]+1,ge=z[0]+1;if(V!==null&&V.length>0){const Fe=V[V.length-1];ne=Math.max(ne,Fe.getOriginalEnd()),ge=Math.max(ge,Fe.getModifiedEnd())}S=[new i.$at(ne,A-ne+1,ge,O-ge+1)]}else{L=new p,M=m,X=u,U=R[0]-z[0]-k,de=1073741824,he=v?this.m.length-1:this.m.length-2;do{const ne=U+a;ne===M||ne<X&&b[ne-1]>=b[ne+1]?(r=b[ne+1]-1,I=r-U-k,r>de&&L.MarkNextChange(),de=r+1,L.AddOriginalElement(r+1,I+1),U=ne+1-a):(r=b[ne-1],I=r-U-k,r>de&&L.MarkNextChange(),de=r,L.AddModifiedElement(r+1,I+1),U=ne-1-a),he>=0&&(b=this.m[he],a=b[0],M=1,X=b.length-1)}while(--he>=-1);S=L.getChanges()}return this.H(V,S)}y(f,d,t,s,a,m,u){let k=0,l=0,b=0,r=0,A=0,R=0;f--,t--,a[0]=0,m[0]=0,this.k=[],this.m=[];const I=d-f+(s-t),O=I+1,z=new Int32Array(O),v=new Int32Array(O),H=s-t,V=d-f,S=f-t,L=d-s,X=(V-H)%2===0;z[H]=f,v[V]=d,u[0]=!1;for(let U=1;U<=I/2+1;U++){let de=0,he=0;b=this.J(H-U,U,H,O),r=this.J(H+U,U,H,O);for(let ge=b;ge<=r;ge+=2){ge===b||ge<r&&z[ge-1]<z[ge+1]?k=z[ge+1]:k=z[ge-1]+1,l=k-(ge-H)-S;const Fe=k;for(;k<d&&l<s&&this.p(k+1,l+1);)k++,l++;if(z[ge]=k,k+l>de+he&&(de=k,he=l),!X&&Math.abs(ge-V)<=U-1&&k>=v[ge])return a[0]=k,m[0]=l,Fe<=v[ge]&&1447>0&&U<=1448?this.x(H,b,r,S,V,A,R,L,z,v,k,d,a,l,s,m,X,u):null}const ne=(de-f+(he-t)-U)/2;if(this.a!==null&&!this.a(de,ne))return u[0]=!0,a[0]=de,m[0]=he,ne>0&&1447>0&&U<=1448?this.x(H,b,r,S,V,A,R,L,z,v,k,d,a,l,s,m,X,u):(f++,t++,[new i.$at(f,d-f+1,t,s-t+1)]);A=this.J(V-U,U,V,O),R=this.J(V+U,U,V,O);for(let ge=A;ge<=R;ge+=2){ge===A||ge<R&&v[ge-1]>=v[ge+1]?k=v[ge+1]-1:k=v[ge-1],l=k-(ge-V)-L;const Fe=k;for(;k>f&&l>t&&this.p(k,l);)k--,l--;if(v[ge]=k,X&&Math.abs(ge-H)<=U&&k<=z[ge])return a[0]=k,m[0]=l,Fe>=z[ge]&&1447>0&&U<=1448?this.x(H,b,r,S,V,A,R,L,z,v,k,d,a,l,s,m,X,u):null}if(U<=1447){let ge=new Int32Array(r-b+2);ge[0]=H-b+1,y.Copy2(z,b,ge,1,r-b+1),this.k.push(ge),ge=new Int32Array(R-A+2),ge[0]=V-A+1,y.Copy2(v,A,ge,1,R-A+1),this.m.push(ge)}}return this.x(H,b,r,S,V,A,R,L,z,v,k,d,a,l,s,m,X,u)}z(f){for(let d=0;d<f.length;d++){const t=f[d],s=d<f.length-1?f[d+1].originalStart:this.f.length,a=d<f.length-1?f[d+1].modifiedStart:this.h.length,m=t.originalLength>0,u=t.modifiedLength>0;for(;t.originalStart+t.originalLength<s&&t.modifiedStart+t.modifiedLength<a&&(!m||this.s(t.originalStart,t.originalStart+t.originalLength))&&(!u||this.u(t.modifiedStart,t.modifiedStart+t.modifiedLength));){const l=this.q(t.originalStart,t.modifiedStart);if(this.q(t.originalStart+t.originalLength,t.modifiedStart+t.modifiedLength)&&!l)break;t.originalStart++,t.modifiedStart++}const k=[null];if(d<f.length-1&&this.I(f[d],f[d+1],k)){f[d]=k[0],f.splice(d+1,1),d--;continue}}for(let d=f.length-1;d>=0;d--){const t=f[d];let s=0,a=0;if(d>0){const r=f[d-1];s=r.originalStart+r.originalLength,a=r.modifiedStart+r.modifiedLength}const m=t.originalLength>0,u=t.modifiedLength>0;let k=0,l=this.G(t.originalStart,t.originalLength,t.modifiedStart,t.modifiedLength);for(let r=1;;r++){const A=t.originalStart-r,R=t.modifiedStart-r;if(A<s||R<a||m&&!this.s(A,A+t.originalLength)||u&&!this.u(R,R+t.modifiedLength))break;const O=(A===s&&R===a?5:0)+this.G(A,t.originalLength,R,t.modifiedLength);O>l&&(l=O,k=r)}t.originalStart-=k,t.modifiedStart-=k;const b=[null];if(d>0&&this.I(f[d-1],f[d],b)){f[d-1]=b[0],f.splice(d,1),d++;continue}}if(this.d)for(let d=1,t=f.length;d<t;d++){const s=f[d-1],a=f[d],m=a.originalStart-s.originalStart-s.originalLength,u=s.originalStart,k=a.originalStart+a.originalLength,l=k-u,b=s.modifiedStart,r=a.modifiedStart+a.modifiedLength,A=r-b;if(m<5&&l<20&&A<20){const R=this.A(u,l,b,A,m);if(R){const[I,O]=R;(I!==s.originalStart+s.originalLength||O!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=I-s.originalStart,s.modifiedLength=O-s.modifiedStart,a.originalStart=I+m,a.modifiedStart=O+m,a.originalLength=k-a.originalStart,a.modifiedLength=r-a.modifiedStart)}}}return f}A(f,d,t,s,a){if(d<a||s<a)return null;const m=f+d-a+1,u=t+s-a+1;let k=0,l=0,b=0;for(let r=f;r<m;r++)for(let A=t;A<u;A++){const R=this.B(r,A,a);R>0&&R>k&&(k=R,l=r,b=A)}return k>0?[l,b]:null}B(f,d,t){let s=0;for(let a=0;a<t;a++){if(!this.p(f+a,d+a))return 0;s+=this.e[f+a].length}return s}C(f){return f<=0||f>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[f])}D(f,d){if(this.C(f)||this.C(f-1))return!0;if(d>0){const t=f+d;if(this.C(t-1)||this.C(t))return!0}return!1}E(f){return f<=0||f>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[f])}F(f,d){if(this.E(f)||this.E(f-1))return!0;if(d>0){const t=f+d;if(this.E(t-1)||this.E(t))return!0}return!1}G(f,d,t,s){const a=this.D(f,d)?1:0,m=this.F(t,s)?1:0;return a+m}H(f,d){const t=[];if(f.length===0||d.length===0)return d.length>0?d:f;if(this.I(f[f.length-1],d[0],t)){const s=new Array(f.length+d.length-1);return y.Copy(f,0,s,0,f.length-1),s[f.length-1]=t[0],y.Copy(d,1,s,f.length,d.length-1),s}else{const s=new Array(f.length+d.length);return y.Copy(f,0,s,0,f.length),y.Copy(d,0,s,f.length,d.length),s}}I(f,d,t){if(D.Assert(f.originalStart<=d.originalStart,"Left change is not less than or equal to right change"),D.Assert(f.modifiedStart<=d.modifiedStart,"Left change is not less than or equal to right change"),f.originalStart+f.originalLength>=d.originalStart||f.modifiedStart+f.modifiedLength>=d.modifiedStart){const s=f.originalStart;let a=f.originalLength;const m=f.modifiedStart;let u=f.modifiedLength;return f.originalStart+f.originalLength>=d.originalStart&&(a=d.originalStart+d.originalLength-f.originalStart),f.modifiedStart+f.modifiedLength>=d.modifiedStart&&(u=d.modifiedStart+d.modifiedLength-f.modifiedStart),t[0]=new i.$at(s,a,m,u),!0}else return t[0]=null,!1}J(f,d,t,s){if(f>=0&&f<s)return f;const a=t,m=s-t-1,u=d%2===0;if(f<0){const k=a%2===0;return u===k?0:1}else{const k=m%2===0;return u===k?s-1:s-2}}}e.$dt=w}),define(me[53],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(me[91],$e([1,0,12,10]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class j{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const t=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return t-s}value(){return this.b[this.c]}}e.$ii=j;class W{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,C.$ef)(d,this.b,0,d.length,this.c,this.d):(0,C.$gf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=W;class D{constructor(d=!0,t=!0){this.f=d,this.g=t}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let t=d.length-1;t>=0;t--,this.c--){const s=this.b.charCodeAt(t);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const t=this.b.charCodeAt(this.e);if(t===47||this.f&&t===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,C.$ef)(d,this.b,0,d.length,this.d,this.e):(0,C.$gf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=D;var y;(function(f){f[f.Scheme=1]="Scheme",f[f.Authority=2]="Authority",f[f.Path=3]="Path",f[f.Query=4]="Query",f[f.Fragment=5]="Fragment"})(y||(y={}));class ${constructor(d,t){this.f=d,this.g=t,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,C.$ff)(d,this.c.scheme);if(this.d[this.e]===2)return(0,C.$ff)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,C.$df)(d,this.c.query);if(this.d[this.e]===5)return(0,C.$df)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=$;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(f){f[f.Left=-1]="Left",f[f.Mid=0]="Mid",f[f.Right=1]="Right"})(w||(w={}));class B{static forUris(d=()=>!1,t=()=>!1){return new B(new $(d,t))}static forPaths(d=!1){return new B(new D(void 0,!d))}static forStrings(){return new B(new j)}static forConfigKeys(){return new B(new W)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,t){if(t){const s=t.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a,d)}else{const s=d.slice(0);(0,i.$Xb)(s);for(const a of s)this.set(a[0],a[1])}}set(d,t){const s=this.b.reset(d);let a;this.c||(this.c=new p,this.c.segment=s.value());const m=[];for(a=this.c;;){const k=s.cmp(a.segment);if(k>0)a.left||(a.left=new p,a.left.segment=s.value()),m.push([-1,a]),a=a.left;else if(k<0)a.right||(a.right=new p,a.right.segment=s.value()),m.push([1,a]),a=a.right;else if(s.hasNext())s.next(),a.mid||(a.mid=new p,a.mid.segment=s.value()),m.push([0,a]),a=a.mid;else break}const u=a.value;a.value=t,a.key=d;for(let k=m.length-1;k>=0;k--){const l=m[k][1];l.updateHeight();const b=l.balanceFactor();if(b<-1||b>1){const r=m[k][0],A=m[k+1][0];if(r===1&&A===1)m[k][1]=l.rotateLeft();else if(r===-1&&A===-1)m[k][1]=l.rotateRight();else if(r===1&&A===-1)l.right=m[k+1][1]=m[k+1][1].rotateRight(),m[k][1]=l.rotateLeft();else if(r===-1&&A===1)l.left=m[k+1][1]=m[k+1][1].rotateLeft(),m[k][1]=l.rotateRight();else throw new Error;if(k>0)switch(m[k-1][0]){case-1:m[k-1][1].left=m[k][1];break;case 1:m[k-1][1].right=m[k][1];break;case 0:m[k-1][1].mid=m[k][1];break}else this.c=m[0][1]}}return u}get(d){return this.d(d)?.value}d(d){const t=this.b.reset(d);let s=this.c;for(;s;){const a=t.cmp(s.segment);if(a>0)s=s.left;else if(a<0)s=s.right;else if(t.hasNext())t.next(),s=s.mid;else break}return s}has(d){const t=this.d(d);return!(t?.value===void 0&&t?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,t){const s=this.b.reset(d),a=[];let m=this.c;for(;m;){const u=s.cmp(m.segment);if(u>0)a.push([-1,m]),m=m.left;else if(u<0)a.push([1,m]),m=m.right;else if(s.hasNext())s.next(),a.push([0,m]),m=m.mid;else break}if(m){if(t?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const u=this.f(m.right);if(u.key){const{key:k,value:l,segment:b}=u;this.e(u.key,!1),m.key=k,m.value=l,m.segment=b}}else{const u=m.left??m.right;if(a.length>0){const[k,l]=a[a.length-1];switch(k){case-1:l.left=u;break;case 0:l.mid=u;break;case 1:l.right=u;break}}else this.c=u}for(let u=a.length-1;u>=0;u--){const k=a[u][1];k.updateHeight();const l=k.balanceFactor();if(l>1?(k.right.balanceFactor()>=0||(k.right=k.right.rotateRight()),a[u][1]=k.rotateLeft()):l<-1&&(k.left.balanceFactor()<=0||(k.left=k.left.rotateLeft()),a[u][1]=k.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this.c=a[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const t=this.b.reset(d);let s=this.c,a;for(;s;){const m=t.cmp(s.segment);if(m>0)s=s.left;else if(m<0)s=s.right;else if(t.hasNext())t.next(),a=s.value||a,s=s.mid;else break}return s&&s.value||a}findSuperstr(d){return this.g(d,!1)}g(d,t){const s=this.b.reset(d);let a=this.c;for(;a;){const m=s.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this.h(a.mid):t?a.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[t,s]of this)d(s,t)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const t=[];return this.j(d,t),t[Symbol.iterator]()}j(d,t){d&&(d.left&&this.j(d.left,t),d.value&&t.push([d.key,d.value]),d.mid&&this.j(d.mid,t),d.right&&this.j(d.right,t))}_isBalanced(){const d=t=>{if(!t)return!0;const s=t.balanceFactor();return s<-1||s>1?!1:d(t.left)&&d(t.right)};return d(this.c)}}e.$mi=B}),define(me[7],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function i(b){return typeof b=="string"}e.$Tf=i;function C(b){return Array.isArray(b)&&b.every(r=>i(r))}e.$Uf=C;function j(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.$Vf=j;function W(b){const r=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof r}e.$Wf=W;function D(b){return typeof b=="number"&&!isNaN(b)}e.$Xf=D;function y(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.$Yf=y;function $(b){return b===!0||b===!1}e.$Zf=$;function p(b){return typeof b>"u"}e.$1f=p;function w(b){return!B(b)}e.$2f=w;function B(b){return p(b)||b===null}e.$3f=B;function f(b,r){if(!b)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.$4f=f;function d(b){if(B(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.$5f=d;function t(...b){const r=[];for(let A=0;A<b.length;A++){const R=b[A];if(B(R))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);r.push(R)}return r}e.$6f=t;const s=Object.prototype.hasOwnProperty;function a(b){if(!j(b))return!1;for(const r in b)if(s.call(b,r))return!1;return!0}e.$7f=a;function m(b){return typeof b=="function"}e.$8f=m;function u(...b){return b.length>0&&b.every(m)}e.$9f=u;function k(b,r){const A=Math.min(b.length,r.length);for(let R=0;R<A;R++)l(b[R],r[R])}e.$0f=k;function l(b,r){if(i(r)){if(typeof b!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(m(r)){try{if(b instanceof r)return}catch{}if(!B(b)&&b.constructor===r||r.length===1&&r.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$$f=l}),define(me[37],$e([1,0,7]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=void 0;const C=Object.create(null);function j(D,y){if((0,i.$Tf)(y)){const $=C[y];if($===void 0)throw new Error(`${D} references an unknown codicon: ${y}`);y=$}return C[D]=y,{id:D}}e.$kk=j;function W(){return C}e.$lk=W}),define(me[92],$e([1,0,37]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=void 0,e.$mk={add:(0,i.$kk)("add",6e4),plus:(0,i.$kk)("plus",6e4),gistNew:(0,i.$kk)("gist-new",6e4),repoCreate:(0,i.$kk)("repo-create",6e4),lightbulb:(0,i.$kk)("lightbulb",60001),lightBulb:(0,i.$kk)("light-bulb",60001),repo:(0,i.$kk)("repo",60002),repoDelete:(0,i.$kk)("repo-delete",60002),gistFork:(0,i.$kk)("gist-fork",60003),repoForked:(0,i.$kk)("repo-forked",60003),gitPullRequest:(0,i.$kk)("git-pull-request",60004),gitPullRequestAbandoned:(0,i.$kk)("git-pull-request-abandoned",60004),recordKeys:(0,i.$kk)("record-keys",60005),keyboard:(0,i.$kk)("keyboard",60005),tag:(0,i.$kk)("tag",60006),tagAdd:(0,i.$kk)("tag-add",60006),tagRemove:(0,i.$kk)("tag-remove",60006),gitPullRequestLabel:(0,i.$kk)("git-pull-request-label",60006),person:(0,i.$kk)("person",60007),personFollow:(0,i.$kk)("person-follow",60007),personOutline:(0,i.$kk)("person-outline",60007),personFilled:(0,i.$kk)("person-filled",60007),gitBranch:(0,i.$kk)("git-branch",60008),gitBranchCreate:(0,i.$kk)("git-branch-create",60008),gitBranchDelete:(0,i.$kk)("git-branch-delete",60008),sourceControl:(0,i.$kk)("source-control",60008),mirror:(0,i.$kk)("mirror",60009),mirrorPublic:(0,i.$kk)("mirror-public",60009),star:(0,i.$kk)("star",60010),starAdd:(0,i.$kk)("star-add",60010),starDelete:(0,i.$kk)("star-delete",60010),starEmpty:(0,i.$kk)("star-empty",60010),comment:(0,i.$kk)("comment",60011),commentAdd:(0,i.$kk)("comment-add",60011),alert:(0,i.$kk)("alert",60012),warning:(0,i.$kk)("warning",60012),search:(0,i.$kk)("search",60013),searchSave:(0,i.$kk)("search-save",60013),logOut:(0,i.$kk)("log-out",60014),signOut:(0,i.$kk)("sign-out",60014),logIn:(0,i.$kk)("log-in",60015),signIn:(0,i.$kk)("sign-in",60015),eye:(0,i.$kk)("eye",60016),eyeUnwatch:(0,i.$kk)("eye-unwatch",60016),eyeWatch:(0,i.$kk)("eye-watch",60016),circleFilled:(0,i.$kk)("circle-filled",60017),primitiveDot:(0,i.$kk)("primitive-dot",60017),closeDirty:(0,i.$kk)("close-dirty",60017),debugBreakpoint:(0,i.$kk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,i.$kk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,i.$kk)("debug-breakpoint-pending",60377),debugHint:(0,i.$kk)("debug-hint",60017),primitiveSquare:(0,i.$kk)("primitive-square",60018),edit:(0,i.$kk)("edit",60019),pencil:(0,i.$kk)("pencil",60019),info:(0,i.$kk)("info",60020),issueOpened:(0,i.$kk)("issue-opened",60020),gistPrivate:(0,i.$kk)("gist-private",60021),gitForkPrivate:(0,i.$kk)("git-fork-private",60021),lock:(0,i.$kk)("lock",60021),mirrorPrivate:(0,i.$kk)("mirror-private",60021),close:(0,i.$kk)("close",60022),removeClose:(0,i.$kk)("remove-close",60022),x:(0,i.$kk)("x",60022),repoSync:(0,i.$kk)("repo-sync",60023),sync:(0,i.$kk)("sync",60023),clone:(0,i.$kk)("clone",60024),desktopDownload:(0,i.$kk)("desktop-download",60024),beaker:(0,i.$kk)("beaker",60025),microscope:(0,i.$kk)("microscope",60025),vm:(0,i.$kk)("vm",60026),deviceDesktop:(0,i.$kk)("device-desktop",60026),file:(0,i.$kk)("file",60027),fileText:(0,i.$kk)("file-text",60027),more:(0,i.$kk)("more",60028),ellipsis:(0,i.$kk)("ellipsis",60028),kebabHorizontal:(0,i.$kk)("kebab-horizontal",60028),mailReply:(0,i.$kk)("mail-reply",60029),reply:(0,i.$kk)("reply",60029),organization:(0,i.$kk)("organization",60030),organizationFilled:(0,i.$kk)("organization-filled",60030),organizationOutline:(0,i.$kk)("organization-outline",60030),newFile:(0,i.$kk)("new-file",60031),fileAdd:(0,i.$kk)("file-add",60031),newFolder:(0,i.$kk)("new-folder",60032),fileDirectoryCreate:(0,i.$kk)("file-directory-create",60032),trash:(0,i.$kk)("trash",60033),trashcan:(0,i.$kk)("trashcan",60033),history:(0,i.$kk)("history",60034),clock:(0,i.$kk)("clock",60034),folder:(0,i.$kk)("folder",60035),fileDirectory:(0,i.$kk)("file-directory",60035),symbolFolder:(0,i.$kk)("symbol-folder",60035),logoGithub:(0,i.$kk)("logo-github",60036),markGithub:(0,i.$kk)("mark-github",60036),github:(0,i.$kk)("github",60036),terminal:(0,i.$kk)("terminal",60037),console:(0,i.$kk)("console",60037),repl:(0,i.$kk)("repl",60037),zap:(0,i.$kk)("zap",60038),symbolEvent:(0,i.$kk)("symbol-event",60038),error:(0,i.$kk)("error",60039),stop:(0,i.$kk)("stop",60039),variable:(0,i.$kk)("variable",60040),symbolVariable:(0,i.$kk)("symbol-variable",60040),array:(0,i.$kk)("array",60042),symbolArray:(0,i.$kk)("symbol-array",60042),symbolModule:(0,i.$kk)("symbol-module",60043),symbolPackage:(0,i.$kk)("symbol-package",60043),symbolNamespace:(0,i.$kk)("symbol-namespace",60043),symbolObject:(0,i.$kk)("symbol-object",60043),symbolMethod:(0,i.$kk)("symbol-method",60044),symbolFunction:(0,i.$kk)("symbol-function",60044),symbolConstructor:(0,i.$kk)("symbol-constructor",60044),symbolBoolean:(0,i.$kk)("symbol-boolean",60047),symbolNull:(0,i.$kk)("symbol-null",60047),symbolNumeric:(0,i.$kk)("symbol-numeric",60048),symbolNumber:(0,i.$kk)("symbol-number",60048),symbolStructure:(0,i.$kk)("symbol-structure",60049),symbolStruct:(0,i.$kk)("symbol-struct",60049),symbolParameter:(0,i.$kk)("symbol-parameter",60050),symbolTypeParameter:(0,i.$kk)("symbol-type-parameter",60050),symbolKey:(0,i.$kk)("symbol-key",60051),symbolText:(0,i.$kk)("symbol-text",60051),symbolReference:(0,i.$kk)("symbol-reference",60052),goToFile:(0,i.$kk)("go-to-file",60052),symbolEnum:(0,i.$kk)("symbol-enum",60053),symbolValue:(0,i.$kk)("symbol-value",60053),symbolRuler:(0,i.$kk)("symbol-ruler",60054),symbolUnit:(0,i.$kk)("symbol-unit",60054),activateBreakpoints:(0,i.$kk)("activate-breakpoints",60055),archive:(0,i.$kk)("archive",60056),arrowBoth:(0,i.$kk)("arrow-both",60057),arrowDown:(0,i.$kk)("arrow-down",60058),arrowLeft:(0,i.$kk)("arrow-left",60059),arrowRight:(0,i.$kk)("arrow-right",60060),arrowSmallDown:(0,i.$kk)("arrow-small-down",60061),arrowSmallLeft:(0,i.$kk)("arrow-small-left",60062),arrowSmallRight:(0,i.$kk)("arrow-small-right",60063),arrowSmallUp:(0,i.$kk)("arrow-small-up",60064),arrowUp:(0,i.$kk)("arrow-up",60065),bell:(0,i.$kk)("bell",60066),bold:(0,i.$kk)("bold",60067),book:(0,i.$kk)("book",60068),bookmark:(0,i.$kk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,i.$kk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,i.$kk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,i.$kk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,i.$kk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,i.$kk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,i.$kk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,i.$kk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,i.$kk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,i.$kk)("debug-breakpoint-log-disabled",60075),briefcase:(0,i.$kk)("briefcase",60076),broadcast:(0,i.$kk)("broadcast",60077),browser:(0,i.$kk)("browser",60078),bug:(0,i.$kk)("bug",60079),calendar:(0,i.$kk)("calendar",60080),caseSensitive:(0,i.$kk)("case-sensitive",60081),check:(0,i.$kk)("check",60082),checklist:(0,i.$kk)("checklist",60083),chevronDown:(0,i.$kk)("chevron-down",60084),dropDownButton:(0,i.$kk)("drop-down-button",60084),chevronLeft:(0,i.$kk)("chevron-left",60085),chevronRight:(0,i.$kk)("chevron-right",60086),chevronUp:(0,i.$kk)("chevron-up",60087),chromeClose:(0,i.$kk)("chrome-close",60088),chromeMaximize:(0,i.$kk)("chrome-maximize",60089),chromeMinimize:(0,i.$kk)("chrome-minimize",60090),chromeRestore:(0,i.$kk)("chrome-restore",60091),circle:(0,i.$kk)("circle",60092),circleOutline:(0,i.$kk)("circle-outline",60092),debugBreakpointUnverified:(0,i.$kk)("debug-breakpoint-unverified",60092),circleSlash:(0,i.$kk)("circle-slash",60093),circuitBoard:(0,i.$kk)("circuit-board",60094),clearAll:(0,i.$kk)("clear-all",60095),clippy:(0,i.$kk)("clippy",60096),closeAll:(0,i.$kk)("close-all",60097),cloudDownload:(0,i.$kk)("cloud-download",60098),cloudUpload:(0,i.$kk)("cloud-upload",60099),code:(0,i.$kk)("code",60100),collapseAll:(0,i.$kk)("collapse-all",60101),colorMode:(0,i.$kk)("color-mode",60102),commentDiscussion:(0,i.$kk)("comment-discussion",60103),compareChanges:(0,i.$kk)("compare-changes",60157),creditCard:(0,i.$kk)("credit-card",60105),dash:(0,i.$kk)("dash",60108),dashboard:(0,i.$kk)("dashboard",60109),database:(0,i.$kk)("database",60110),debugContinue:(0,i.$kk)("debug-continue",60111),debugDisconnect:(0,i.$kk)("debug-disconnect",60112),debugPause:(0,i.$kk)("debug-pause",60113),debugRestart:(0,i.$kk)("debug-restart",60114),debugStart:(0,i.$kk)("debug-start",60115),debugStepInto:(0,i.$kk)("debug-step-into",60116),debugStepOut:(0,i.$kk)("debug-step-out",60117),debugStepOver:(0,i.$kk)("debug-step-over",60118),debugStop:(0,i.$kk)("debug-stop",60119),debug:(0,i.$kk)("debug",60120),deviceCameraVideo:(0,i.$kk)("device-camera-video",60121),deviceCamera:(0,i.$kk)("device-camera",60122),deviceMobile:(0,i.$kk)("device-mobile",60123),diffAdded:(0,i.$kk)("diff-added",60124),diffIgnored:(0,i.$kk)("diff-ignored",60125),diffModified:(0,i.$kk)("diff-modified",60126),diffRemoved:(0,i.$kk)("diff-removed",60127),diffRenamed:(0,i.$kk)("diff-renamed",60128),diff:(0,i.$kk)("diff",60129),discard:(0,i.$kk)("discard",60130),editorLayout:(0,i.$kk)("editor-layout",60131),emptyWindow:(0,i.$kk)("empty-window",60132),exclude:(0,i.$kk)("exclude",60133),extensions:(0,i.$kk)("extensions",60134),eyeClosed:(0,i.$kk)("eye-closed",60135),fileBinary:(0,i.$kk)("file-binary",60136),fileCode:(0,i.$kk)("file-code",60137),fileMedia:(0,i.$kk)("file-media",60138),filePdf:(0,i.$kk)("file-pdf",60139),fileSubmodule:(0,i.$kk)("file-submodule",60140),fileSymlinkDirectory:(0,i.$kk)("file-symlink-directory",60141),fileSymlinkFile:(0,i.$kk)("file-symlink-file",60142),fileZip:(0,i.$kk)("file-zip",60143),files:(0,i.$kk)("files",60144),filter:(0,i.$kk)("filter",60145),flame:(0,i.$kk)("flame",60146),foldDown:(0,i.$kk)("fold-down",60147),foldUp:(0,i.$kk)("fold-up",60148),fold:(0,i.$kk)("fold",60149),folderActive:(0,i.$kk)("folder-active",60150),folderOpened:(0,i.$kk)("folder-opened",60151),gear:(0,i.$kk)("gear",60152),gift:(0,i.$kk)("gift",60153),gistSecret:(0,i.$kk)("gist-secret",60154),gist:(0,i.$kk)("gist",60155),gitCommit:(0,i.$kk)("git-commit",60156),gitCompare:(0,i.$kk)("git-compare",60157),gitMerge:(0,i.$kk)("git-merge",60158),githubAction:(0,i.$kk)("github-action",60159),githubAlt:(0,i.$kk)("github-alt",60160),globe:(0,i.$kk)("globe",60161),grabber:(0,i.$kk)("grabber",60162),graph:(0,i.$kk)("graph",60163),gripper:(0,i.$kk)("gripper",60164),heart:(0,i.$kk)("heart",60165),home:(0,i.$kk)("home",60166),horizontalRule:(0,i.$kk)("horizontal-rule",60167),hubot:(0,i.$kk)("hubot",60168),inbox:(0,i.$kk)("inbox",60169),issueClosed:(0,i.$kk)("issue-closed",60324),issueReopened:(0,i.$kk)("issue-reopened",60171),issues:(0,i.$kk)("issues",60172),italic:(0,i.$kk)("italic",60173),jersey:(0,i.$kk)("jersey",60174),json:(0,i.$kk)("json",60175),bracket:(0,i.$kk)("bracket",60175),kebabVertical:(0,i.$kk)("kebab-vertical",60176),key:(0,i.$kk)("key",60177),law:(0,i.$kk)("law",60178),lightbulbAutofix:(0,i.$kk)("lightbulb-autofix",60179),linkExternal:(0,i.$kk)("link-external",60180),link:(0,i.$kk)("link",60181),listOrdered:(0,i.$kk)("list-ordered",60182),listUnordered:(0,i.$kk)("list-unordered",60183),liveShare:(0,i.$kk)("live-share",60184),loading:(0,i.$kk)("loading",60185),location:(0,i.$kk)("location",60186),mailRead:(0,i.$kk)("mail-read",60187),mail:(0,i.$kk)("mail",60188),markdown:(0,i.$kk)("markdown",60189),megaphone:(0,i.$kk)("megaphone",60190),mention:(0,i.$kk)("mention",60191),milestone:(0,i.$kk)("milestone",60192),gitPullRequestMilestone:(0,i.$kk)("git-pull-request-milestone",60192),mortarBoard:(0,i.$kk)("mortar-board",60193),move:(0,i.$kk)("move",60194),multipleWindows:(0,i.$kk)("multiple-windows",60195),mute:(0,i.$kk)("mute",60196),noNewline:(0,i.$kk)("no-newline",60197),note:(0,i.$kk)("note",60198),octoface:(0,i.$kk)("octoface",60199),openPreview:(0,i.$kk)("open-preview",60200),package:(0,i.$kk)("package",60201),paintcan:(0,i.$kk)("paintcan",60202),pin:(0,i.$kk)("pin",60203),play:(0,i.$kk)("play",60204),run:(0,i.$kk)("run",60204),plug:(0,i.$kk)("plug",60205),preserveCase:(0,i.$kk)("preserve-case",60206),preview:(0,i.$kk)("preview",60207),project:(0,i.$kk)("project",60208),pulse:(0,i.$kk)("pulse",60209),question:(0,i.$kk)("question",60210),quote:(0,i.$kk)("quote",60211),radioTower:(0,i.$kk)("radio-tower",60212),reactions:(0,i.$kk)("reactions",60213),references:(0,i.$kk)("references",60214),refresh:(0,i.$kk)("refresh",60215),regex:(0,i.$kk)("regex",60216),remoteExplorer:(0,i.$kk)("remote-explorer",60217),remote:(0,i.$kk)("remote",60218),remove:(0,i.$kk)("remove",60219),replaceAll:(0,i.$kk)("replace-all",60220),replace:(0,i.$kk)("replace",60221),repoClone:(0,i.$kk)("repo-clone",60222),repoForcePush:(0,i.$kk)("repo-force-push",60223),repoPull:(0,i.$kk)("repo-pull",60224),repoPush:(0,i.$kk)("repo-push",60225),report:(0,i.$kk)("report",60226),requestChanges:(0,i.$kk)("request-changes",60227),rocket:(0,i.$kk)("rocket",60228),rootFolderOpened:(0,i.$kk)("root-folder-opened",60229),rootFolder:(0,i.$kk)("root-folder",60230),rss:(0,i.$kk)("rss",60231),ruby:(0,i.$kk)("ruby",60232),saveAll:(0,i.$kk)("save-all",60233),saveAs:(0,i.$kk)("save-as",60234),save:(0,i.$kk)("save",60235),screenFull:(0,i.$kk)("screen-full",60236),screenNormal:(0,i.$kk)("screen-normal",60237),searchStop:(0,i.$kk)("search-stop",60238),server:(0,i.$kk)("server",60240),settingsGear:(0,i.$kk)("settings-gear",60241),settings:(0,i.$kk)("settings",60242),shield:(0,i.$kk)("shield",60243),smiley:(0,i.$kk)("smiley",60244),sortPrecedence:(0,i.$kk)("sort-precedence",60245),splitHorizontal:(0,i.$kk)("split-horizontal",60246),splitVertical:(0,i.$kk)("split-vertical",60247),squirrel:(0,i.$kk)("squirrel",60248),starFull:(0,i.$kk)("star-full",60249),starHalf:(0,i.$kk)("star-half",60250),symbolClass:(0,i.$kk)("symbol-class",60251),symbolColor:(0,i.$kk)("symbol-color",60252),symbolCustomColor:(0,i.$kk)("symbol-customcolor",60252),symbolConstant:(0,i.$kk)("symbol-constant",60253),symbolEnumMember:(0,i.$kk)("symbol-enum-member",60254),symbolField:(0,i.$kk)("symbol-field",60255),symbolFile:(0,i.$kk)("symbol-file",60256),symbolInterface:(0,i.$kk)("symbol-interface",60257),symbolKeyword:(0,i.$kk)("symbol-keyword",60258),symbolMisc:(0,i.$kk)("symbol-misc",60259),symbolOperator:(0,i.$kk)("symbol-operator",60260),symbolProperty:(0,i.$kk)("symbol-property",60261),wrench:(0,i.$kk)("wrench",60261),wrenchSubaction:(0,i.$kk)("wrench-subaction",60261),symbolSnippet:(0,i.$kk)("symbol-snippet",60262),tasklist:(0,i.$kk)("tasklist",60263),telescope:(0,i.$kk)("telescope",60264),textSize:(0,i.$kk)("text-size",60265),threeBars:(0,i.$kk)("three-bars",60266),thumbsdown:(0,i.$kk)("thumbsdown",60267),thumbsup:(0,i.$kk)("thumbsup",60268),tools:(0,i.$kk)("tools",60269),triangleDown:(0,i.$kk)("triangle-down",60270),triangleLeft:(0,i.$kk)("triangle-left",60271),triangleRight:(0,i.$kk)("triangle-right",60272),triangleUp:(0,i.$kk)("triangle-up",60273),twitter:(0,i.$kk)("twitter",60274),unfold:(0,i.$kk)("unfold",60275),unlock:(0,i.$kk)("unlock",60276),unmute:(0,i.$kk)("unmute",60277),unverified:(0,i.$kk)("unverified",60278),verified:(0,i.$kk)("verified",60279),versions:(0,i.$kk)("versions",60280),vmActive:(0,i.$kk)("vm-active",60281),vmOutline:(0,i.$kk)("vm-outline",60282),vmRunning:(0,i.$kk)("vm-running",60283),watch:(0,i.$kk)("watch",60284),whitespace:(0,i.$kk)("whitespace",60285),wholeWord:(0,i.$kk)("whole-word",60286),window:(0,i.$kk)("window",60287),wordWrap:(0,i.$kk)("word-wrap",60288),zoomIn:(0,i.$kk)("zoom-in",60289),zoomOut:(0,i.$kk)("zoom-out",60290),listFilter:(0,i.$kk)("list-filter",60291),listFlat:(0,i.$kk)("list-flat",60292),listSelection:(0,i.$kk)("list-selection",60293),selection:(0,i.$kk)("selection",60293),listTree:(0,i.$kk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,i.$kk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,i.$kk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,i.$kk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,i.$kk)("debug-stackframe-active",60297),circleSmallFilled:(0,i.$kk)("circle-small-filled",60298),debugStackframeDot:(0,i.$kk)("debug-stackframe-dot",60298),debugStackframe:(0,i.$kk)("debug-stackframe",60299),debugStackframeFocused:(0,i.$kk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,i.$kk)("debug-breakpoint-unsupported",60300),symbolString:(0,i.$kk)("symbol-string",60301),debugReverseContinue:(0,i.$kk)("debug-reverse-continue",60302),debugStepBack:(0,i.$kk)("debug-step-back",60303),debugRestartFrame:(0,i.$kk)("debug-restart-frame",60304),callIncoming:(0,i.$kk)("call-incoming",60306),callOutgoing:(0,i.$kk)("call-outgoing",60307),menu:(0,i.$kk)("menu",60308),expandAll:(0,i.$kk)("expand-all",60309),feedback:(0,i.$kk)("feedback",60310),gitPullRequestReviewer:(0,i.$kk)("git-pull-request-reviewer",60310),groupByRefType:(0,i.$kk)("group-by-ref-type",60311),ungroupByRefType:(0,i.$kk)("ungroup-by-ref-type",60312),account:(0,i.$kk)("account",60313),gitPullRequestAssignee:(0,i.$kk)("git-pull-request-assignee",60313),bellDot:(0,i.$kk)("bell-dot",60314),debugConsole:(0,i.$kk)("debug-console",60315),library:(0,i.$kk)("library",60316),output:(0,i.$kk)("output",60317),runAll:(0,i.$kk)("run-all",60318),syncIgnored:(0,i.$kk)("sync-ignored",60319),pinned:(0,i.$kk)("pinned",60320),githubInverted:(0,i.$kk)("github-inverted",60321),debugAlt:(0,i.$kk)("debug-alt",60305),serverProcess:(0,i.$kk)("server-process",60322),serverEnvironment:(0,i.$kk)("server-environment",60323),pass:(0,i.$kk)("pass",60324),stopCircle:(0,i.$kk)("stop-circle",60325),playCircle:(0,i.$kk)("play-circle",60326),record:(0,i.$kk)("record",60327),debugAltSmall:(0,i.$kk)("debug-alt-small",60328),vmConnect:(0,i.$kk)("vm-connect",60329),cloud:(0,i.$kk)("cloud",60330),merge:(0,i.$kk)("merge",60331),exportIcon:(0,i.$kk)("export",60332),graphLeft:(0,i.$kk)("graph-left",60333),magnet:(0,i.$kk)("magnet",60334),notebook:(0,i.$kk)("notebook",60335),redo:(0,i.$kk)("redo",60336),checkAll:(0,i.$kk)("check-all",60337),pinnedDirty:(0,i.$kk)("pinned-dirty",60338),passFilled:(0,i.$kk)("pass-filled",60339),circleLargeFilled:(0,i.$kk)("circle-large-filled",60340),circleLarge:(0,i.$kk)("circle-large",60341),circleLargeOutline:(0,i.$kk)("circle-large-outline",60341),combine:(0,i.$kk)("combine",60342),gather:(0,i.$kk)("gather",60342),table:(0,i.$kk)("table",60343),variableGroup:(0,i.$kk)("variable-group",60344),typeHierarchy:(0,i.$kk)("type-hierarchy",60345),typeHierarchySub:(0,i.$kk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,i.$kk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,i.$kk)("git-pull-request-create",60348),runAbove:(0,i.$kk)("run-above",60349),runBelow:(0,i.$kk)("run-below",60350),notebookTemplate:(0,i.$kk)("notebook-template",60351),debugRerun:(0,i.$kk)("debug-rerun",60352),workspaceTrusted:(0,i.$kk)("workspace-trusted",60353),workspaceUntrusted:(0,i.$kk)("workspace-untrusted",60354),workspaceUnspecified:(0,i.$kk)("workspace-unspecified",60355),terminalCmd:(0,i.$kk)("terminal-cmd",60356),terminalDebian:(0,i.$kk)("terminal-debian",60357),terminalLinux:(0,i.$kk)("terminal-linux",60358),terminalPowershell:(0,i.$kk)("terminal-powershell",60359),terminalTmux:(0,i.$kk)("terminal-tmux",60360),terminalUbuntu:(0,i.$kk)("terminal-ubuntu",60361),terminalBash:(0,i.$kk)("terminal-bash",60362),arrowSwap:(0,i.$kk)("arrow-swap",60363),copy:(0,i.$kk)("copy",60364),personAdd:(0,i.$kk)("person-add",60365),filterFilled:(0,i.$kk)("filter-filled",60366),wand:(0,i.$kk)("wand",60367),debugLineByLine:(0,i.$kk)("debug-line-by-line",60368),inspect:(0,i.$kk)("inspect",60369),layers:(0,i.$kk)("layers",60370),layersDot:(0,i.$kk)("layers-dot",60371),layersActive:(0,i.$kk)("layers-active",60372),compass:(0,i.$kk)("compass",60373),compassDot:(0,i.$kk)("compass-dot",60374),compassActive:(0,i.$kk)("compass-active",60375),azure:(0,i.$kk)("azure",60376),issueDraft:(0,i.$kk)("issue-draft",60377),gitPullRequestClosed:(0,i.$kk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,i.$kk)("git-pull-request-draft",60379),debugAll:(0,i.$kk)("debug-all",60380),debugCoverage:(0,i.$kk)("debug-coverage",60381),runErrors:(0,i.$kk)("run-errors",60382),folderLibrary:(0,i.$kk)("folder-library",60383),debugContinueSmall:(0,i.$kk)("debug-continue-small",60384),beakerStop:(0,i.$kk)("beaker-stop",60385),graphLine:(0,i.$kk)("graph-line",60386),graphScatter:(0,i.$kk)("graph-scatter",60387),pieChart:(0,i.$kk)("pie-chart",60388),bracketDot:(0,i.$kk)("bracket-dot",60389),bracketError:(0,i.$kk)("bracket-error",60390),lockSmall:(0,i.$kk)("lock-small",60391),azureDevops:(0,i.$kk)("azure-devops",60392),verifiedFilled:(0,i.$kk)("verified-filled",60393),newLine:(0,i.$kk)("newline",60394),layout:(0,i.$kk)("layout",60395),layoutActivitybarLeft:(0,i.$kk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,i.$kk)("layout-activitybar-right",60397),layoutPanelLeft:(0,i.$kk)("layout-panel-left",60398),layoutPanelCenter:(0,i.$kk)("layout-panel-center",60399),layoutPanelJustify:(0,i.$kk)("layout-panel-justify",60400),layoutPanelRight:(0,i.$kk)("layout-panel-right",60401),layoutPanel:(0,i.$kk)("layout-panel",60402),layoutSidebarLeft:(0,i.$kk)("layout-sidebar-left",60403),layoutSidebarRight:(0,i.$kk)("layout-sidebar-right",60404),layoutStatusbar:(0,i.$kk)("layout-statusbar",60405),layoutMenubar:(0,i.$kk)("layout-menubar",60406),layoutCentered:(0,i.$kk)("layout-centered",60407),layoutSidebarRightOff:(0,i.$kk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,i.$kk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,i.$kk)("layout-sidebar-left-off",60418),target:(0,i.$kk)("target",60408),indent:(0,i.$kk)("indent",60409),recordSmall:(0,i.$kk)("record-small",60410),errorSmall:(0,i.$kk)("error-small",60411),arrowCircleDown:(0,i.$kk)("arrow-circle-down",60412),arrowCircleLeft:(0,i.$kk)("arrow-circle-left",60413),arrowCircleRight:(0,i.$kk)("arrow-circle-right",60414),arrowCircleUp:(0,i.$kk)("arrow-circle-up",60415),heartFilled:(0,i.$kk)("heart-filled",60420),map:(0,i.$kk)("map",60421),mapFilled:(0,i.$kk)("map-filled",60422),circleSmall:(0,i.$kk)("circle-small",60423),bellSlash:(0,i.$kk)("bell-slash",60424),bellSlashDot:(0,i.$kk)("bell-slash-dot",60425),commentUnresolved:(0,i.$kk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,i.$kk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,i.$kk)("git-pull-request-new-changes",60428),searchFuzzy:(0,i.$kk)("search-fuzzy",60429),commentDraft:(0,i.$kk)("comment-draft",60430),send:(0,i.$kk)("send",60431),sparkle:(0,i.$kk)("sparkle",60432),insert:(0,i.$kk)("insert",60433),mic:(0,i.$kk)("mic",60434),thumbsDownFilled:(0,i.$kk)("thumbsdown-filled",60435),thumbsUpFilled:(0,i.$kk)("thumbsup-filled",60436),coffee:(0,i.$kk)("coffee",60437),snake:(0,i.$kk)("snake",60438),game:(0,i.$kk)("game",60439),vr:(0,i.$kk)("vr",60440),chip:(0,i.$kk)("chip",60441),piano:(0,i.$kk)("piano",60442),music:(0,i.$kk)("music",60443),micFilled:(0,i.$kk)("mic-filled",60444),gitFetch:(0,i.$kk)("git-fetch",60445),copilot:(0,i.$kk)("copilot",60446),lightbulbSparkle:(0,i.$kk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,i.$kk)("lightbulb-sparkle-autofix",60447),robot:(0,i.$kk)("robot",60448),sparkleFilled:(0,i.$kk)("sparkle-filled",60449),diffSingle:(0,i.$kk)("diff-single",60450),diffMultiple:(0,i.$kk)("diff-multiple",60451),surroundWith:(0,i.$kk)("surround-with",60452),gitStash:(0,i.$kk)("git-stash",60454),gitStashApply:(0,i.$kk)("git-stash-apply",60455),gitStashPop:(0,i.$kk)("git-stash-pop",60456),runAllCoverage:(0,i.$kk)("run-all-coverage",60461),runCoverage:(0,i.$kk)("run-all-coverage",60460),coverage:(0,i.$kk)("coverage",60462),githubProject:(0,i.$kk)("github-project",60463)}}),define(me[18],$e([1,0,37,92]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=void 0;function j(){return Object.values(e.$pk)}e.$nk=j,e.$ok={dialogError:(0,i.$kk)("dialog-error","error"),dialogWarning:(0,i.$kk)("dialog-warning","warning"),dialogInfo:(0,i.$kk)("dialog-info","info"),dialogClose:(0,i.$kk)("dialog-close","close"),treeItemExpanded:(0,i.$kk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,i.$kk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,i.$kk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,i.$kk)("tree-filter-clear","close"),treeItemLoading:(0,i.$kk)("tree-item-loading","loading"),menuSelection:(0,i.$kk)("menu-selection","check"),menuSubmenu:(0,i.$kk)("menu-submenu","chevron-right"),menuBarMore:(0,i.$kk)("menubar-more","more"),scrollbarButtonLeft:(0,i.$kk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,i.$kk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,i.$kk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,i.$kk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,i.$kk)("toolbar-more","more"),quickInputBack:(0,i.$kk)("quick-input-back","arrow-left")},e.$pk={...C.$mk,...e.$ok}}),define(me[54],$e([1,0,7]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function C(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const u=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([k,l])=>{u[k]=l&&typeof l=="object"?C(l):l}),u}e.$Ln=C;function j(m){if(!m||typeof m!="object")return m;const u=[m];for(;u.length>0;){const k=u.shift();Object.freeze(k);for(const l in k)if(W.call(k,l)){const b=k[l];typeof b=="object"&&!Object.isFrozen(b)&&!(0,i.$Wf)(b)&&u.push(b)}}return m}e.$Mn=j;const W=Object.prototype.hasOwnProperty;function D(m,u){return y(m,u,new Set)}e.$Nn=D;function y(m,u,k){if((0,i.$3f)(m))return m;const l=u(m);if(typeof l<"u")return l;if(Array.isArray(m)){const b=[];for(const r of m)b.push(y(r,u,k));return b}if((0,i.$Vf)(m)){if(k.has(m))throw new Error("Cannot clone recursive data-structure");k.add(m);const b={};for(const r in m)W.call(m,r)&&(b[r]=y(m[r],u,k));return k.delete(m),b}return m}function $(m,u,k=!0){return(0,i.$Vf)(m)?((0,i.$Vf)(u)&&Object.keys(u).forEach(l=>{l in m?k&&((0,i.$Vf)(m[l])&&(0,i.$Vf)(u[l])?$(m[l],u[l],k):m[l]=u[l]):m[l]=u[l]}),m):u}e.$On=$;function p(m,u){if(m===u)return!0;if(m==null||u===null||u===void 0||typeof m!=typeof u||typeof m!="object"||Array.isArray(m)!==Array.isArray(u))return!1;let k,l;if(Array.isArray(m)){if(m.length!==u.length)return!1;for(k=0;k<m.length;k++)if(!p(m[k],u[k]))return!1}else{const b=[];for(l in m)b.push(l);b.sort();const r=[];for(l in u)r.push(l);if(r.sort(),!p(b,r))return!1;for(k=0;k<b.length;k++)if(!p(m[b[k]],u[b[k]]))return!1}return!0}e.$Pn=p;function w(m){const u=new Set;return JSON.stringify(m,(k,l)=>{if((0,i.$Vf)(l)||Array.isArray(l)){if(u.has(l))return"[Circular]";u.add(l)}return l})}e.$Qn=w;function B(m,u){const k=Object.create(null);return!m||!u||Object.keys(u).forEach(b=>{const r=m[b],A=u[b];p(r,A)||(k[b]=A)}),k}e.$Rn=B;function f(m,u){const k=u.toLowerCase(),l=Object.keys(m).find(b=>b.toLowerCase()===k);return l?m[l]:m[u]}e.$Sn=f;function d(m,u){const k=Object.create(null);for(const[l,b]of Object.entries(m))u(l,b)&&(k[l]=b);return k}e.$Tn=d;function t(m){let u=[];for(;Object.prototype!==m;)u=u.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return u}e.$Un=t;function s(m){const u=[];for(const k of t(m))typeof m[k]=="function"&&u.push(k);return u}e.$Vn=s;function a(m,u){const k=b=>function(){const r=Array.prototype.slice.call(arguments,0);return u(b,r)},l={};for(const b of m)l[b]=k(b);return l}e.$Wn=a}),define(me[19],$e([1,0,18]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$qk=e.ThemeColor=void 0;var C;(function(D){function y($){return $&&typeof $=="object"&&typeof $.id=="string"}D.isThemeColor=y})(C||(e.ThemeColor=C={}));function j(D){return{id:D}}e.$qk=j;var W;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function $(u){const k=y.exec(u.id);if(!k)return $(i.$pk.error);const[,l,b]=k,r=["codicon","codicon-"+l];return b&&r.push("codicon-modifier-"+b.substring(1)),r}D.asClassNameArray=$;function p(u){return $(u).join(" ")}D.asClassName=p;function w(u){return"."+$(u).join(".")}D.asCSSSelector=w;function B(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||C.isThemeColor(u.color))}D.isThemeIcon=B;const f=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function d(u){const k=f.exec(u);if(!k)return;const[,l]=k;return{id:l}}D.fromString=d;function t(u){return{id:u}}D.fromId=t;function s(u,k){let l=u.id;const b=l.lastIndexOf("~");return b!==-1&&(l=l.substring(0,b)),k&&(l=`${l}~${k}`),{id:l}}D.modify=s;function a(u){const k=u.id.lastIndexOf("~");if(k!==-1)return u.id.substring(k+1)}D.getModifier=a;function m(u,k){return u.id===k.id&&u.color?.id===k.color?.id}D.isEqual=m})(W||(e.ThemeIcon=W={}))}),define(me[38],$e([1,0,36,10,19]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=void 0;const W="$(",D=new RegExp(`\\$\\(${j.ThemeIcon.iconNameExpression}(?:${j.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${D.source}`,"g");function $(m){return m.replace(y,(u,k)=>k?u:`\\${u}`)}e.$rk=$;const p=new RegExp(`\\\\${D.source}`,"g");function w(m){return m.replace(p,u=>`\\${u}`)}e.$sk=w;const B=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function f(m){return m.indexOf(W)===-1?m:m.replace(B,(u,k,l,b)=>l?u:k||b||"")}e.$tk=f;function d(m){return m?m.replace(/\$\((.*?)\)/g,(u,k)=>` ${k} `).trim():""}e.$uk=d;const t=new RegExp(`\\$\\(${j.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(m){t.lastIndex=0;let u="";const k=[];let l=0;for(;;){const b=t.lastIndex,r=t.exec(m),A=m.substring(b,r?.index);if(A.length>0){u+=A;for(let R=0;R<A.length;R++)k.push(l)}if(!r)break;l+=r[0].length}return{text:u,iconOffsets:k}}e.$vk=s;function a(m,u,k=!1){const{text:l,iconOffsets:b}=u;if(!b||b.length===0)return(0,i.$bk)(m,l,k);const r=(0,C.$4e)(l," "),A=l.length-r.length,R=(0,i.$bk)(m,r,k);if(R)for(const I of R){const O=b[I.start+A]+A;I.start+=O,I.end+=O}return R}e.$wk=a}),define(me[93],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OV=e.$NV=void 0,e.$NV="vscode:contextmenu",e.$OV="vscode:onCloseContextMenu"}),define(me[94],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VV=void 0;class i{constructor(j,W){this.a=j,this.onMessage=W}send(j){try{this.a.send("vscode:message",j.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$VV=i}),define(me[31],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=e.$Q=e.$P=e.$O=void 0;const i=globalThis.vscode;e.$O=i.ipcRenderer,e.$P=i.ipcMessagePort,e.$Q=i.webFrame,e.$R=i.process,e.$S=i.context}),define(me[95],$e([1,0,93,31]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RV=void 0;let j=0;function W(y,$,p){const w=[],B=j++,f=`vscode:onContextMenu${B}`,d=(t,s,a)=>{w[s].click?.(a)};C.$O.once(f,d),C.$O.once(i.$OV,(t,s)=>{s===B&&(C.$O.removeListener(f,d),p?.())}),C.$O.send(i.$NV,B,y.map(t=>D(t,w)),f,$)}e.$RV=W;function D(y,$){const p={id:$.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return $.push(y),Array.isArray(y.submenu)&&(p.submenu=y.submenu.map(w=>D(w,$))),p}}),define(me[55],$e([8]),{}),define(me[96],$e([8]),{}),define(me[97],$e([8]),{}),define(me[98],$e([8]),{}),define(me[99],$e([1,0,97,98]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0})}),define(me[100],$e([8]),{}),define(me[101],$e([8]),{}),define(me[102],$e([8]),{}),define(me[103],$e([8]),{}),define(me[104],$e([8]),{}),define(me[105],$e([8]),{}),define(me[106],$e([8]),{}),define(me[107],$e([8]),{}),define(me[108],$e([8]),{}),define(me[109],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/actionbar/actionViewItems",e)}),define(me[110],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/findinput/findInput",e)}),define(me[111],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/findinput/findInputToggles",e)}),define(me[112],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/hover/updatableHoverWidget",e)}),define(me[113],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/inputbox/inputBox",e)}),define(me[114],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/selectBox/selectBoxCustom",e)}),define(me[115],$e([13,11]),function(re,e){return re.create("vs/base/browser/ui/tree/abstractTree",e)}),define(me[116],$e([13,11]),function(re,e){return re.create("vs/base/common/actions",e)}),define(me[39],$e([1,0,4,3,116]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0;class W extends C.$Tc{constructor(f,d="",t="",s=!0,a){super(),this.h=this.B(new i.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=f,this.m=d,this.u=t,this.w=s,this.C=a}get id(){return this.j}get label(){return this.m}set label(f){this.D(f)}D(f){this.m!==f&&(this.m=f,this.h.fire({label:f}))}get tooltip(){return this.n||""}set tooltip(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.h.fire({tooltip:f}))}get class(){return this.u}set class(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.h.fire({class:f}))}get enabled(){return this.w}set enabled(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.h.fire({enabled:f}))}get checked(){return this.z}set checked(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.h.fire({checked:f}))}async run(f,d){this.C&&await this.C(f)}}e.$Xi=W;class D extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new i.$6d),this.onWillRun=this.f.event,this.m=this.B(new i.$6d),this.onDidRun=this.m.event}async run(f,d){if(!f.enabled)return;this.f.fire({action:f});let t;try{await this.u(f,d)}catch(s){t=s}this.m.fire({action:f,error:t})}async u(f,d){await f.run(d)}}e.$Yi=D;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let d=[];for(const t of f)t.length&&(d.length?d=[...d,new y,...t]:d=t);return d}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=y;class ${get actions(){return this.a}constructor(f,d,t,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=d,this.class=s,this.a=t}async run(){}}e.$1i=$;class p extends W{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,j.localize(0,null),void 0,!1)}}e.$2i=p;function w(B){return{id:B.id,label:B.label,class:B.class,enabled:B.enabled??!0,checked:B.checked,run:async(...f)=>B.run(...f),tooltip:B.label}}e.$3i=w}),define(me[117],$e([13,11]),function(re,e){return re.create("vs/base/common/platform",e)}),define(me[5],$e([1,0,117]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let C=!1,j=!1,W=!1,D=!1,y=!1,$=!1,p=!1,w=!1,B=!1,f=!1,d,t=e.$g,s=e.$g,a,m;const u=globalThis;let k;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?k=u.vscode.process:typeof process<"u"&&(k=process);const l=typeof k?.versions?.electron=="string",b=l&&k?.type==="renderer";if(typeof k=="object"){C=k.platform==="win32",j=k.platform==="darwin",W=k.platform==="linux",D=W&&!!k.env.SNAP&&!!k.env.SNAP_REVISION,p=l,B=!!k.env.CI||!!k.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$g,t=e.$g;const S=k.env.VSCODE_NLS_CONFIG;if(S)try{const L=JSON.parse(S),M=L.availableLanguages["*"];d=L.locale,s=L.osLocale,t=M||e.$g,a=L._translationsConfigFile}catch{}y=!0}else typeof navigator=="object"&&!b?(m=navigator.userAgent,C=m.indexOf("Windows")>=0,j=m.indexOf("Macintosh")>=0,w=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=m.indexOf("Linux")>=0,f=m?.indexOf("Mobi")>=0,$=!0,d=i.getConfiguredDefaultLocale(i.localize(0,null))||e.$g,t=d,s=navigator.language):console.error("Unable to resolve platform.");var r;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(r||(e.Platform=r={}));function A(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=A;let R=0;j?R=1:C?R=3:W&&(R=2),e.$i=C,e.$j=j,e.$k=W,e.$l=D,e.$m=y,e.$n=p,e.$o=$,e.$p=$&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=w,e.$s=f,e.$t=B,e.$u=R,e.$v=m,e.$w=t;var I;(function(S){function L(){return e.$w}S.value=L;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}S.isDefaultVariant=M;function X(){return e.$w==="en"}S.isDefault=X})(I||(e.Language=I={})),e.$x=d,e.$y=s,e.$z=a,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const S=[];u.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let X=0,U=S.length;X<U;X++){const de=S[X];if(de.id===M.data.vscodeScheduleAsyncWork){S.splice(X,1),de.callback();return}}});let L=0;return M=>{const X=++L;S.push({id:X,callback:M}),u.postMessage({vscodeScheduleAsyncWork:X},"*")}}return S=>setTimeout(S)})();var O;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(O||(e.OperatingSystem=O={})),e.OS=j||w?2:C?1:3;let z=!0,v=!1;function H(){if(!v){v=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,z=new Uint16Array(S.buffer)[0]===513}return z}e.$D=H,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function V(S){return parseFloat(S)>=20}e.$J=V}),define(me[118],$e([1,0,17,22,5]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=e.KeyboardSupport=void 0;var W;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(W||(e.KeyboardSupport=W={})),e.$IQ={clipboard:{writeText:j.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:j.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:j.$m||i.$GQ()?0:navigator.keyboard||i.$CQ?1:2,touch:"ontouchstart"in C.$mQ||navigator.maxTouchPoints>0,pointerEvents:C.$mQ.PointerEvent&&("ontouchstart"in C.$mQ||navigator.maxTouchPoints>0)}}),define(me[14],$e([1,0,17,48,81,5]),function(re,e,i,C,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QQ=e.$PQ=e.$OQ=void 0;function D(t){if(t.charCode){const a=String.fromCharCode(t.charCode).toUpperCase();return C.KeyCodeUtils.fromString(a)}const s=t.keyCode;if(s===3)return 7;if(i.$zQ)switch(s){case 59:return 85;case 60:if(W.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.$j)return 57;break}else if(i.$AQ){if(W.$j&&s===93)return 57;if(!W.$j&&s===92)return 57}return C.$er[s]||0}const y=W.$j?256:2048,$=512,p=1024,w=W.$j?2048:256;function B(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode}, key: ${t.key}`}e.$OQ=B;function f(t){const s=[];return t.ctrlKey&&s.push("ctrl"),t.shiftKey&&s.push("shift"),t.altKey&&s.push("alt"),t.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${t.code}, keyCode: ${t.keyCode} ('${C.KeyCodeUtils.toString(t.keyCode)}')`}e.$PQ=f;class d{constructor(s){this._standardKeyboardEventBrand=!0;const a=s;this.browserEvent=a,this.target=a.target,this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,this.altGraphKey=a.getModifierState("AltGraph"),this.keyCode=D(a),this.code=a.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let a=0;return this.ctrlKey&&(a|=y),this.altKey&&(a|=$),this.shiftKey&&(a|=p),this.metaKey&&(a|=w),a|=s,a}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new j.$mr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}e.$QQ=d}),define(me[20],$e([1,0,17,72,5]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NQ=e.$MQ=e.$LQ=void 0;class W{constructor(p,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const B=C.$JQ.getPositionOfChildWindowRelativeToAncestorWindow(p,w.view);this.posx-=B.left,this.posy-=B.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}e.$LQ=W;class D extends W{constructor(p,w){super(p,w),this.dataTransfer=w.dataTransfer}}e.$MQ=D;class y{constructor(p,w=0,B=0){this.browserEvent=p||null,this.target=p?p.target||p.targetNode||p.srcElement:null,this.deltaY=B,this.deltaX=w;let f=!1;if(i.$BQ){const d=navigator.userAgent.match(/Chrome\/(\d+)/);f=(d?parseInt(d[1]):123)<=122}if(p){const d=p,t=p,s=p.view?.devicePixelRatio||1;if(typeof d.wheelDeltaY<"u")f?this.deltaY=d.wheelDeltaY/(120*s):this.deltaY=d.wheelDeltaY/120;else if(typeof t.VERTICAL_AXIS<"u"&&t.axis===t.VERTICAL_AXIS)this.deltaY=-t.detail/3;else if(p.type==="wheel"){const a=p;a.deltaMode===a.DOM_DELTA_LINE?i.$zQ&&!j.$j?this.deltaY=-p.deltaY/3:this.deltaY=-p.deltaY:this.deltaY=-p.deltaY/40}if(typeof d.wheelDeltaX<"u")i.$CQ&&j.$i?this.deltaX=-(d.wheelDeltaX/120):f?this.deltaX=d.wheelDeltaX/(120*s):this.deltaX=d.wheelDeltaX/120;else if(typeof t.HORIZONTAL_AXIS<"u"&&t.axis===t.HORIZONTAL_AXIS)this.deltaX=-p.detail/3;else if(p.type==="wheel"){const a=p;a.deltaMode===a.DOM_DELTA_LINE?i.$zQ&&!j.$j?this.deltaX=-p.deltaX/3:this.deltaX=-p.deltaX:this.deltaX=-p.deltaX/40}this.deltaY===0&&this.deltaX===0&&p.wheelDelta&&(f?this.deltaY=p.wheelDelta/(120*s):this.deltaY=p.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}e.$NQ=y}),define(me[119],$e([1,0,5]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const W=j.process;C={get platform(){return W.platform},get arch(){return W.arch},get env(){return W.env},cwd(){return W.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return i.$i?"win32":i.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define(me[25],$e([1,0,119]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,j=97,W=90,D=122,y=46,$=47,p=92,w=58,B=63;class f extends Error{constructor(A,R,I){let O;typeof R=="string"&&R.indexOf("not ")===0?(O="must not be",R=R.replace(/^not /,"")):O="must be";const z=A.indexOf(".")!==-1?"property":"argument";let v=`The "${A}" ${z} ${O} of type ${R}`;v+=`. Received type ${typeof I}`,super(v),this.code="ERR_INVALID_ARG_TYPE"}}function d(r,A){if(r===null||typeof r!="object")throw new f(A,"Object",r)}function t(r,A){if(typeof r!="string")throw new f(A,"string",r)}const s=i.$dc==="win32";function a(r){return r===$||r===p}function m(r){return r===$}function u(r){return r>=C&&r<=W||r>=j&&r<=D}function k(r,A,R,I){let O="",z=0,v=-1,H=0,V=0;for(let S=0;S<=r.length;++S){if(S<r.length)V=r.charCodeAt(S);else{if(I(V))break;V=$}if(I(V)){if(!(v===S-1||H===1))if(H===2){if(O.length<2||z!==2||O.charCodeAt(O.length-1)!==y||O.charCodeAt(O.length-2)!==y){if(O.length>2){const L=O.lastIndexOf(R);L===-1?(O="",z=0):(O=O.slice(0,L),z=O.length-1-O.lastIndexOf(R)),v=S,H=0;continue}else if(O.length!==0){O="",z=0,v=S,H=0;continue}}A&&(O+=O.length>0?`${R}..`:"..",z=2)}else O.length>0?O+=`${R}${r.slice(v+1,S)}`:O=r.slice(v+1,S),z=S-v-1;v=S,H=0}else V===y&&H!==-1?++H:H=-1}return O}function l(r,A){d(A,"pathObject");const R=A.dir||A.root,I=A.base||`${A.name||""}${A.ext||""}`;return R?R===A.root?`${R}${I}`:`${R}${r}${I}`:I}e.$fc={resolve(...r){let A="",R="",I=!1;for(let O=r.length-1;O>=-1;O--){let z;if(O>=0){if(z=r[O],t(z,"path"),z.length===0)continue}else A.length===0?z=i.cwd():(z=i.env[`=${A}`]||i.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==A.toLowerCase()&&z.charCodeAt(2)===p)&&(z=`${A}\\`));const v=z.length;let H=0,V="",S=!1;const L=z.charCodeAt(0);if(v===1)a(L)&&(H=1,S=!0);else if(a(L))if(S=!0,a(z.charCodeAt(1))){let M=2,X=M;for(;M<v&&!a(z.charCodeAt(M));)M++;if(M<v&&M!==X){const U=z.slice(X,M);for(X=M;M<v&&a(z.charCodeAt(M));)M++;if(M<v&&M!==X){for(X=M;M<v&&!a(z.charCodeAt(M));)M++;(M===v||M!==X)&&(V=`\\\\${U}\\${z.slice(X,M)}`,H=M)}}}else H=1;else u(L)&&z.charCodeAt(1)===w&&(V=z.slice(0,2),H=2,v>2&&a(z.charCodeAt(2))&&(S=!0,H=3));if(V.length>0)if(A.length>0){if(V.toLowerCase()!==A.toLowerCase())continue}else A=V;if(I){if(A.length>0)break}else if(R=`${z.slice(H)}\\${R}`,I=S,S&&A.length>0)break}return R=k(R,!I,"\\",a),I?`${A}\\${R}`:`${A}${R}`||"."},normalize(r){t(r,"path");const A=r.length;if(A===0)return".";let R=0,I,O=!1;const z=r.charCodeAt(0);if(A===1)return m(z)?"\\":r;if(a(z))if(O=!0,a(r.charCodeAt(1))){let H=2,V=H;for(;H<A&&!a(r.charCodeAt(H));)H++;if(H<A&&H!==V){const S=r.slice(V,H);for(V=H;H<A&&a(r.charCodeAt(H));)H++;if(H<A&&H!==V){for(V=H;H<A&&!a(r.charCodeAt(H));)H++;if(H===A)return`\\\\${S}\\${r.slice(V)}\\`;H!==V&&(I=`\\\\${S}\\${r.slice(V,H)}`,R=H)}}}else R=1;else u(z)&&r.charCodeAt(1)===w&&(I=r.slice(0,2),R=2,A>2&&a(r.charCodeAt(2))&&(O=!0,R=3));let v=R<A?k(r.slice(R),!O,"\\",a):"";return v.length===0&&!O&&(v="."),v.length>0&&a(r.charCodeAt(A-1))&&(v+="\\"),I===void 0?O?`\\${v}`:v:O?`${I}\\${v}`:`${I}${v}`},isAbsolute(r){t(r,"path");const A=r.length;if(A===0)return!1;const R=r.charCodeAt(0);return a(R)||A>2&&u(R)&&r.charCodeAt(1)===w&&a(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let A,R;for(let z=0;z<r.length;++z){const v=r[z];t(v,"path"),v.length>0&&(A===void 0?A=R=v:A+=`\\${v}`)}if(A===void 0)return".";let I=!0,O=0;if(typeof R=="string"&&a(R.charCodeAt(0))){++O;const z=R.length;z>1&&a(R.charCodeAt(1))&&(++O,z>2&&(a(R.charCodeAt(2))?++O:I=!1))}if(I){for(;O<A.length&&a(A.charCodeAt(O));)O++;O>=2&&(A=`\\${A.slice(O)}`)}return e.$fc.normalize(A)},relative(r,A){if(t(r,"from"),t(A,"to"),r===A)return"";const R=e.$fc.resolve(r),I=e.$fc.resolve(A);if(R===I||(r=R.toLowerCase(),A=I.toLowerCase(),r===A))return"";let O=0;for(;O<r.length&&r.charCodeAt(O)===p;)O++;let z=r.length;for(;z-1>O&&r.charCodeAt(z-1)===p;)z--;const v=z-O;let H=0;for(;H<A.length&&A.charCodeAt(H)===p;)H++;let V=A.length;for(;V-1>H&&A.charCodeAt(V-1)===p;)V--;const S=V-H,L=v<S?v:S;let M=-1,X=0;for(;X<L;X++){const de=r.charCodeAt(O+X);if(de!==A.charCodeAt(H+X))break;de===p&&(M=X)}if(X!==L){if(M===-1)return I}else{if(S>L){if(A.charCodeAt(H+X)===p)return I.slice(H+X+1);if(X===2)return I.slice(H+X)}v>L&&(r.charCodeAt(O+X)===p?M=X:X===2&&(M=3)),M===-1&&(M=0)}let U="";for(X=O+M+1;X<=z;++X)(X===z||r.charCodeAt(X)===p)&&(U+=U.length===0?"..":"\\..");return H+=M,U.length>0?`${U}${I.slice(H,V)}`:(I.charCodeAt(H)===p&&++H,I.slice(H,V))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const A=e.$fc.resolve(r);if(A.length<=2)return r;if(A.charCodeAt(0)===p){if(A.charCodeAt(1)===p){const R=A.charCodeAt(2);if(R!==B&&R!==y)return`\\\\?\\UNC\\${A.slice(2)}`}}else if(u(A.charCodeAt(0))&&A.charCodeAt(1)===w&&A.charCodeAt(2)===p)return`\\\\?\\${A}`;return r},dirname(r){t(r,"path");const A=r.length;if(A===0)return".";let R=-1,I=0;const O=r.charCodeAt(0);if(A===1)return a(O)?r:".";if(a(O)){if(R=I=1,a(r.charCodeAt(1))){let H=2,V=H;for(;H<A&&!a(r.charCodeAt(H));)H++;if(H<A&&H!==V){for(V=H;H<A&&a(r.charCodeAt(H));)H++;if(H<A&&H!==V){for(V=H;H<A&&!a(r.charCodeAt(H));)H++;if(H===A)return r;H!==V&&(R=I=H+1)}}}}else u(O)&&r.charCodeAt(1)===w&&(R=A>2&&a(r.charCodeAt(2))?3:2,I=R);let z=-1,v=!0;for(let H=A-1;H>=I;--H)if(a(r.charCodeAt(H))){if(!v){z=H;break}}else v=!1;if(z===-1){if(R===-1)return".";z=R}return r.slice(0,z)},basename(r,A){A!==void 0&&t(A,"ext"),t(r,"path");let R=0,I=-1,O=!0,z;if(r.length>=2&&u(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(R=2),A!==void 0&&A.length>0&&A.length<=r.length){if(A===r)return"";let v=A.length-1,H=-1;for(z=r.length-1;z>=R;--z){const V=r.charCodeAt(z);if(a(V)){if(!O){R=z+1;break}}else H===-1&&(O=!1,H=z+1),v>=0&&(V===A.charCodeAt(v)?--v===-1&&(I=z):(v=-1,I=H))}return R===I?I=H:I===-1&&(I=r.length),r.slice(R,I)}for(z=r.length-1;z>=R;--z)if(a(r.charCodeAt(z))){if(!O){R=z+1;break}}else I===-1&&(O=!1,I=z+1);return I===-1?"":r.slice(R,I)},extname(r){t(r,"path");let A=0,R=-1,I=0,O=-1,z=!0,v=0;r.length>=2&&r.charCodeAt(1)===w&&u(r.charCodeAt(0))&&(A=I=2);for(let H=r.length-1;H>=A;--H){const V=r.charCodeAt(H);if(a(V)){if(!z){I=H+1;break}continue}O===-1&&(z=!1,O=H+1),V===y?R===-1?R=H:v!==1&&(v=1):R!==-1&&(v=-1)}return R===-1||O===-1||v===0||v===1&&R===O-1&&R===I+1?"":r.slice(R,O)},format:l.bind(null,"\\"),parse(r){t(r,"path");const A={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return A;const R=r.length;let I=0,O=r.charCodeAt(0);if(R===1)return a(O)?(A.root=A.dir=r,A):(A.base=A.name=r,A);if(a(O)){if(I=1,a(r.charCodeAt(1))){let M=2,X=M;for(;M<R&&!a(r.charCodeAt(M));)M++;if(M<R&&M!==X){for(X=M;M<R&&a(r.charCodeAt(M));)M++;if(M<R&&M!==X){for(X=M;M<R&&!a(r.charCodeAt(M));)M++;M===R?I=M:M!==X&&(I=M+1)}}}}else if(u(O)&&r.charCodeAt(1)===w){if(R<=2)return A.root=A.dir=r,A;if(I=2,a(r.charCodeAt(2))){if(R===3)return A.root=A.dir=r,A;I=3}}I>0&&(A.root=r.slice(0,I));let z=-1,v=I,H=-1,V=!0,S=r.length-1,L=0;for(;S>=I;--S){if(O=r.charCodeAt(S),a(O)){if(!V){v=S+1;break}continue}H===-1&&(V=!1,H=S+1),O===y?z===-1?z=S:L!==1&&(L=1):z!==-1&&(L=-1)}return H!==-1&&(z===-1||L===0||L===1&&z===H-1&&z===v+1?A.base=A.name=r.slice(v,H):(A.name=r.slice(v,z),A.base=r.slice(v,H),A.ext=r.slice(z,H))),v>0&&v!==I?A.dir=r.slice(0,v-1):A.dir=A.root,A},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(s){const r=/\\/g;return()=>{const A=i.cwd().replace(r,"/");return A.slice(A.indexOf("/"))}}return()=>i.cwd()})();e.$gc={resolve(...r){let A="",R=!1;for(let I=r.length-1;I>=-1&&!R;I--){const O=I>=0?r[I]:b();t(O,"path"),O.length!==0&&(A=`${O}/${A}`,R=O.charCodeAt(0)===$)}return A=k(A,!R,"/",m),R?`/${A}`:A.length>0?A:"."},normalize(r){if(t(r,"path"),r.length===0)return".";const A=r.charCodeAt(0)===$,R=r.charCodeAt(r.length-1)===$;return r=k(r,!A,"/",m),r.length===0?A?"/":R?"./":".":(R&&(r+="/"),A?`/${r}`:r)},isAbsolute(r){return t(r,"path"),r.length>0&&r.charCodeAt(0)===$},join(...r){if(r.length===0)return".";let A;for(let R=0;R<r.length;++R){const I=r[R];t(I,"path"),I.length>0&&(A===void 0?A=I:A+=`/${I}`)}return A===void 0?".":e.$gc.normalize(A)},relative(r,A){if(t(r,"from"),t(A,"to"),r===A||(r=e.$gc.resolve(r),A=e.$gc.resolve(A),r===A))return"";const R=1,I=r.length,O=I-R,z=1,v=A.length-z,H=O<v?O:v;let V=-1,S=0;for(;S<H;S++){const M=r.charCodeAt(R+S);if(M!==A.charCodeAt(z+S))break;M===$&&(V=S)}if(S===H)if(v>H){if(A.charCodeAt(z+S)===$)return A.slice(z+S+1);if(S===0)return A.slice(z+S)}else O>H&&(r.charCodeAt(R+S)===$?V=S:S===0&&(V=0));let L="";for(S=R+V+1;S<=I;++S)(S===I||r.charCodeAt(S)===$)&&(L+=L.length===0?"..":"/..");return`${L}${A.slice(z+V)}`},toNamespacedPath(r){return r},dirname(r){if(t(r,"path"),r.length===0)return".";const A=r.charCodeAt(0)===$;let R=-1,I=!0;for(let O=r.length-1;O>=1;--O)if(r.charCodeAt(O)===$){if(!I){R=O;break}}else I=!1;return R===-1?A?"/":".":A&&R===1?"//":r.slice(0,R)},basename(r,A){A!==void 0&&t(A,"ext"),t(r,"path");let R=0,I=-1,O=!0,z;if(A!==void 0&&A.length>0&&A.length<=r.length){if(A===r)return"";let v=A.length-1,H=-1;for(z=r.length-1;z>=0;--z){const V=r.charCodeAt(z);if(V===$){if(!O){R=z+1;break}}else H===-1&&(O=!1,H=z+1),v>=0&&(V===A.charCodeAt(v)?--v===-1&&(I=z):(v=-1,I=H))}return R===I?I=H:I===-1&&(I=r.length),r.slice(R,I)}for(z=r.length-1;z>=0;--z)if(r.charCodeAt(z)===$){if(!O){R=z+1;break}}else I===-1&&(O=!1,I=z+1);return I===-1?"":r.slice(R,I)},extname(r){t(r,"path");let A=-1,R=0,I=-1,O=!0,z=0;for(let v=r.length-1;v>=0;--v){const H=r.charCodeAt(v);if(H===$){if(!O){R=v+1;break}continue}I===-1&&(O=!1,I=v+1),H===y?A===-1?A=v:z!==1&&(z=1):A!==-1&&(z=-1)}return A===-1||I===-1||z===0||z===1&&A===I-1&&A===R+1?"":r.slice(A,I)},format:l.bind(null,"/"),parse(r){t(r,"path");const A={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return A;const R=r.charCodeAt(0)===$;let I;R?(A.root="/",I=1):I=0;let O=-1,z=0,v=-1,H=!0,V=r.length-1,S=0;for(;V>=I;--V){const L=r.charCodeAt(V);if(L===$){if(!H){z=V+1;break}continue}v===-1&&(H=!1,v=V+1),L===y?O===-1?O=V:S!==1&&(S=1):O!==-1&&(S=-1)}if(v!==-1){const L=z===0&&R?1:z;O===-1||S===0||S===1&&O===v-1&&O===z+1?A.base=A.name=r.slice(L,v):(A.name=r.slice(L,O),A.base=r.slice(L,v),A.ext=r.slice(O,v))}return z>0?A.dir=r.slice(0,z-1):R&&(A.dir="/"),A},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=s?e.$fc.normalize:e.$gc.normalize,e.$ic=s?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=s?e.$fc.join:e.$gc.join,e.$kc=s?e.$fc.resolve:e.$gc.resolve,e.$lc=s?e.$fc.relative:e.$gc.relative,e.$mc=s?e.$fc.dirname:e.$gc.dirname,e.$nc=s?e.$fc.basename:e.$gc.basename,e.$oc=s?e.$fc.extname:e.$gc.extname,e.$pc=s?e.$fc.format:e.$gc.format,e.$qc=s?e.$fc.parse:e.$gc.parse,e.$rc=s?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=s?e.$fc.sep:e.$gc.sep,e.$tc=s?e.$fc.delimiter:e.$gc.delimiter}),define(me[120],$e([1,0,25,5,10,7]),function(re,e,i,C,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function D(z){return z===47||z===92}e.$_f=D;function y(z){return z.replace(/[\\/]/g,i.$gc.sep)}e.$ag=y;function $(z){return z.indexOf("/")===-1&&(z=y(z)),/^[a-zA-Z]:(\/|$)/.test(z)&&(z="/"+z),z}e.$bg=$;function p(z,v=i.$gc.sep){if(!z)return"";const H=z.length,V=z.charCodeAt(0);if(D(V)){if(D(z.charCodeAt(1))&&!D(z.charCodeAt(2))){let L=3;const M=L;for(;L<H&&!D(z.charCodeAt(L));L++);if(M!==L&&!D(z.charCodeAt(L+1))){for(L+=1;L<H;L++)if(D(z.charCodeAt(L)))return z.slice(0,L+1).replace(/[\\/]/g,v)}}return v}else if(m(V)&&z.charCodeAt(1)===58)return D(z.charCodeAt(2))?z.slice(0,2)+v:z.slice(0,2);let S=z.indexOf("://");if(S!==-1){for(S+=3;S<H;S++)if(D(z.charCodeAt(S)))return z.slice(0,S+1)}return""}e.$cg=p;function w(z){if(!C.$i||!z||z.length<5)return!1;let v=z.charCodeAt(0);if(v!==92||(v=z.charCodeAt(1),v!==92))return!1;let H=2;const V=H;for(;H<z.length&&(v=z.charCodeAt(H),v!==92);H++);return!(V===H||(v=z.charCodeAt(H+1),isNaN(v)||v===92))}e.$dg=w;const B=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(z,v=C.$i){const H=v?B:f;return!(!z||z.length===0||/^\s+$/.test(z)||(H.lastIndex=0,H.test(z))||v&&d.test(z)||z==="."||z===".."||v&&z[z.length-1]==="."||v&&z.length!==z.trim().length||z.length>255)}e.$eg=t;function s(z,v,H){const V=z===v;return!H||V?V:!z||!v?!1:(0,j.$kf)(z,v)}e.$fg=s;function a(z,v,H,V=i.sep){if(z===v)return!0;if(!z||!v||v.length>z.length)return!1;if(H){if(!(0,j.$lf)(z,v))return!1;if(v.length===z.length)return!0;let L=v.length;return v.charAt(v.length-1)===V&&L--,z.charAt(L)===V}return v.charAt(v.length-1)!==V&&(v+=V),z.indexOf(v)===0}e.$gg=a;function m(z){return z>=65&&z<=90||z>=97&&z<=122}e.$hg=m;function u(z,v){return C.$i&&z.endsWith(":")&&(z+=i.sep),(0,i.$ic)(z)||(z=(0,i.$jc)(v,z)),z=(0,i.$hc)(z),C.$i?(z=(0,j.$5e)(z,i.sep),z.endsWith(":")&&(z+=i.sep)):(z=(0,j.$5e)(z,i.sep),z||(z=i.sep)),z}e.$ig=u;function k(z){const v=(0,i.$hc)(z);return C.$i?z.length>3?!1:l(v)&&(z.length===2||v.charCodeAt(2)===92):v===i.$gc.sep}e.$jg=k;function l(z,v=C.$i){return v?m(z.charCodeAt(0))&&z.charCodeAt(1)===58:!1}e.$kg=l;function b(z,v=C.$i){return l(z,v)?z[0]:void 0}e.$lg=b;function r(z,v,H){return v.length>z.length?-1:z===v?0:(H&&(z=z.toLowerCase(),v=v.toLowerCase()),z.indexOf(v))}e.$mg=r;function A(z){const v=z.split(":");let H,V,S;for(const L of v){const M=Number(L);(0,W.$Xf)(M)?V===void 0?V=M:S===void 0&&(S=M):H=H?[H,L].join(":"):L}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:V!==void 0?V:void 0,column:S!==void 0?S:V!==void 0?1:void 0}}e.$ng=A;const R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",I="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function O(z,v,H=8){let V="";for(let L=0;L<H;L++){let M;L===0&&C.$i&&!v&&(H===3||H===4)?M=I:M=R,V+=M.charAt(Math.floor(Math.random()*M.length))}let S;return v?S=`${v}-${V}`:S=V,z?(0,i.$jc)(z,S):S}e.$og=O}),define(me[121],$e([1,0,25]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},j={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(w){const B=(0,i.$oc)(w),f=C[B.toLowerCase()];return f!==void 0?f:D(w)}e.$vs=W;function D(w){const B=(0,i.$oc)(w);return j[B.toLowerCase()]}e.$ws=D;function y(w){for(const B in j)if(j[B]===w)return B}e.$xs=y;const $=/^(.+)\/(.+?)(;.+)?$/;function p(w,B){const f=$.exec(w);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:B?void 0:w}e.$ys=p}),define(me[15],$e([1,0,25,5]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const j=/^\w[\w\d+.-]*$/,W=/^\//,D=/^\/\//;function y(I,O){if(!I.scheme&&O)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${I.authority}", path: "${I.path}", query: "${I.query}", fragment: "${I.fragment}"}`);if(I.scheme&&!j.test(I.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(I.path){if(I.authority){if(!W.test(I.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(I.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(I,O){return!I&&!O?"file":I}function p(I,O){switch(I){case"https":case"http":case"file":O?O[0]!==B&&(O=B+O):O=B;break}return O}const w="",B="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(O){return O instanceof d?!0:O?typeof O.authority=="string"&&typeof O.fragment=="string"&&typeof O.path=="string"&&typeof O.query=="string"&&typeof O.scheme=="string"&&typeof O.fsPath=="string"&&typeof O.with=="function"&&typeof O.toString=="function":!1}constructor(O,z,v,H,V,S=!1){typeof O=="object"?(this.scheme=O.scheme||w,this.authority=O.authority||w,this.path=O.path||w,this.query=O.query||w,this.fragment=O.fragment||w):(this.scheme=$(O,S),this.authority=z||w,this.path=p(this.scheme,v||w),this.query=H||w,this.fragment=V||w,y(this,S))}get fsPath(){return l(this,!1)}with(O){if(!O)return this;let{scheme:z,authority:v,path:H,query:V,fragment:S}=O;return z===void 0?z=this.scheme:z===null&&(z=w),v===void 0?v=this.authority:v===null&&(v=w),H===void 0?H=this.path:H===null&&(H=w),V===void 0?V=this.query:V===null&&(V=w),S===void 0?S=this.fragment:S===null&&(S=w),z===this.scheme&&v===this.authority&&H===this.path&&V===this.query&&S===this.fragment?this:new a(z,v,H,V,S)}static parse(O,z=!1){const v=f.exec(O);return v?new a(v[2]||w,R(v[4]||w),R(v[5]||w),R(v[7]||w),R(v[9]||w),z):new a(w,w,w,w,w)}static file(O){let z=w;if(C.$i&&(O=O.replace(/\\/g,B)),O[0]===B&&O[1]===B){const v=O.indexOf(B,2);v===-1?(z=O.substring(2),O=B):(z=O.substring(2,v),O=O.substring(v)||B)}return new a("file",z,O,w,w)}static from(O,z){return new a(O.scheme,O.authority,O.path,O.query,O.fragment,z)}static joinPath(O,...z){if(!O.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return C.$i&&O.scheme==="file"?v=d.file(i.$fc.join(l(O,!0),...z)).path:v=i.$gc.join(O.path,...z),O.with({path:v})}toString(O=!1){return b(this,O)}toJSON(){return this}static revive(O){if(O){if(O instanceof d)return O;{const z=new a(O);return z._formatted=O.external??null,z._fsPath=O._sep===s?O.fsPath??null:null,z}}else return O}}e.URI=d;function t(I){return!I||typeof I!="object"?!1:typeof I.scheme=="string"&&(typeof I.authority=="string"||typeof I.authority>"u")&&(typeof I.path=="string"||typeof I.path>"u")&&(typeof I.query=="string"||typeof I.query>"u")&&(typeof I.fragment=="string"||typeof I.fragment>"u")}e.$vc=t;const s=C.$i?1:void 0;class a extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(O=!1){return O?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const O={$mid:1};return this._fsPath&&(O.fsPath=this._fsPath,O._sep=s),this._formatted&&(O.external=this._formatted),this.path&&(O.path=this.path),this.scheme&&(O.scheme=this.scheme),this.authority&&(O.authority=this.authority),this.query&&(O.query=this.query),this.fragment&&(O.fragment=this.fragment),O}}const m={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(I,O,z){let v,H=-1;for(let V=0;V<I.length;V++){const S=I.charCodeAt(V);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||O&&S===47||z&&S===91||z&&S===93||z&&S===58)H!==-1&&(v+=encodeURIComponent(I.substring(H,V)),H=-1),v!==void 0&&(v+=I.charAt(V));else{v===void 0&&(v=I.substr(0,V));const L=m[S];L!==void 0?(H!==-1&&(v+=encodeURIComponent(I.substring(H,V)),H=-1),v+=L):H===-1&&(H=V)}}return H!==-1&&(v+=encodeURIComponent(I.substring(H))),v!==void 0?v:I}function k(I){let O;for(let z=0;z<I.length;z++){const v=I.charCodeAt(z);v===35||v===63?(O===void 0&&(O=I.substr(0,z)),O+=m[v]):O!==void 0&&(O+=I[z])}return O!==void 0?O:I}function l(I,O){let z;return I.authority&&I.path.length>1&&I.scheme==="file"?z=`//${I.authority}${I.path}`:I.path.charCodeAt(0)===47&&(I.path.charCodeAt(1)>=65&&I.path.charCodeAt(1)<=90||I.path.charCodeAt(1)>=97&&I.path.charCodeAt(1)<=122)&&I.path.charCodeAt(2)===58?O?z=I.path.substr(1):z=I.path[1].toLowerCase()+I.path.substr(2):z=I.path,C.$i&&(z=z.replace(/\//g,"\\")),z}e.$wc=l;function b(I,O){const z=O?k:u;let v="",{scheme:H,authority:V,path:S,query:L,fragment:M}=I;if(H&&(v+=H,v+=":"),(V||H==="file")&&(v+=B,v+=B),V){let X=V.indexOf("@");if(X!==-1){const U=V.substr(0,X);V=V.substr(X+1),X=U.lastIndexOf(":"),X===-1?v+=z(U,!1,!1):(v+=z(U.substr(0,X),!1,!1),v+=":",v+=z(U.substr(X+1),!1,!0)),v+="@"}V=V.toLowerCase(),X=V.lastIndexOf(":"),X===-1?v+=z(V,!1,!0):(v+=z(V.substr(0,X),!1,!0),v+=V.substr(X))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const X=S.charCodeAt(1);X>=65&&X<=90&&(S=`/${String.fromCharCode(X+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const X=S.charCodeAt(0);X>=65&&X<=90&&(S=`${String.fromCharCode(X+32)}:${S.substr(2)}`)}v+=z(S,!0,!1)}return L&&(v+="?",v+=z(L,!1,!1)),M&&(v+="#",v+=O?M:u(M,!1,!1)),v}function r(I){try{return decodeURIComponent(I)}catch{return I.length>3?I.substr(0,3)+r(I.substr(3)):I}}const A=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function R(I){return I.match(A)?I.replace(A,O=>r(O)):I}}),define(me[56],$e([1,0,35,15]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function j($){return JSON.stringify($,D)}e.$Nh=j;function W($){let p=JSON.parse($);return p=y(p),p}e.$Oh=W;function D($,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function y($,p=0){if(!$||p>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return C.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof i.$te||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let w=0;w<$.length;++w)$[w]=y($[w],p+1);else for(const w in $)Object.hasOwnProperty.call($,w)&&($[w]=y($[w],p+1))}return $}e.$Ph=y}),define(me[32],$e([1,0,6,5,10,15,25]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var y;(function(t){t.inMemory="inmemory",t.vscode="vscode",t.internal="private",t.walkThrough="walkThrough",t.walkThroughSnippet="walkThroughSnippet",t.http="http",t.https="https",t.file="file",t.mailto="mailto",t.untitled="untitled",t.data="data",t.command="command",t.vscodeRemote="vscode-remote",t.vscodeRemoteResource="vscode-remote-resource",t.vscodeManagedRemoteResource="vscode-managed-remote-resource",t.vscodeUserData="vscode-userdata",t.vscodeCustomEditor="vscode-custom-editor",t.vscodeNotebookCell="vscode-notebook-cell",t.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",t.vscodeNotebookCellOutput="vscode-notebook-cell-output",t.vscodeInteractiveInput="vscode-interactive-input",t.vscodeSettings="vscode-settings",t.vscodeWorkspaceTrust="vscode-workspace-trust",t.vscodeTerminal="vscode-terminal",t.vscodeChatCodeBlock="vscode-chat-code-block",t.vscodeChatSesssion="vscode-chat-editor",t.webviewPanel="webview-panel",t.vscodeWebview="vscode-webview",t.extension="extension",t.vscodeFileResource="vscode-file",t.tmp="tmp",t.vsls="vsls",t.vscodeSourceControl="vscode-scm",t.codeSetting="code-setting"})(y||(e.Schemas=y={}));function $(t,s){return W.URI.isUri(t)?(0,j.$kf)(t.scheme,s):(0,j.$lf)(t,s+":")}e.$pg=$;function p(t,...s){return s.some(a=>$(t,a))}e.$qg=p,e.$rg="vscode-tkn",e.$sg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,a){this.f=B(s,a)}getServerRootPath(){return this.f}get g(){return D.$gc.join(this.f,y.vscodeRemoteResource)}set(s,a,m){this.a[s]=a,this.b[s]=m}setConnectionToken(s,a){this.c[s]=a}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(b){return i.$1(b),s}const a=s.authority;let m=this.a[a];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const u=this.b[a],k=this.c[a];let l=`path=${encodeURIComponent(s.path)}`;return typeof k=="string"&&(l+=`&${e.$sg}=${encodeURIComponent(k)}`),W.URI.from({scheme:C.$o?this.d:y.vscodeRemoteResource,authority:`${m}:${u}`,path:this.g,query:l})}}e.$tg=new w;function B(t,s){return D.$gc.join(s??"/",`${t.quality??"oss"}-${t.commit??"dev"}`)}e.$ug=B,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class f{static{this.a=e.$zg}asBrowserUri(s){const a=this.b(s,re);return this.uriToBrowserUri(a)}uriToBrowserUri(s){return s.scheme===y.vscodeRemote?e.$tg.rewrite(s):s.scheme===y.file&&(C.$m||C.$q===`${y.vscodeFileResource}://${f.a}`)?s.with({scheme:y.vscodeFileResource,authority:s.authority||f.a,query:null,fragment:null}):s}asFileUri(s){const a=this.b(s,re);return this.uriToFileUri(a)}uriToFileUri(s){return s.scheme===y.vscodeFileResource?s.with({scheme:y.file,authority:s.authority!==f.a?s.authority:null,query:null,fragment:null}):s}b(s,a){return W.URI.isUri(s)?s:W.URI.parse(a.toUrl(s))}}e.$Ag=new f;var d;(function(t){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);t.CoopAndCoep=Object.freeze(s.get("3"));const a="vscode-coi";function m(k){let l;typeof k=="string"?l=new URL(k).searchParams:k instanceof URL?l=k.searchParams:W.URI.isUri(k)&&(l=new URL(k.toString(!0)).searchParams);const b=l?.get(a);if(b)return s.get(b)}t.getHeadersFromQuery=m;function u(k,l,b){if(!globalThis.crossOriginIsolated)return;const r=l&&b?"3":b?"2":"1";k instanceof URLSearchParams?k.set(a,r):k[a]=r}t.addSearchParam=u})(d||(e.COI=d={}))}),define(me[40],$e([1,0,120,32,25,5,10,15]),function(re,e,i,C,j,W,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function $(d){return(0,y.$wc)(d,!0)}e.$Hg=$;class p{constructor(t){this.a=t}compare(t,s,a=!1){return t===s?0:(0,D.$df)(this.getComparisonKey(t,a),this.getComparisonKey(s,a))}isEqual(t,s,a=!1){return t===s?!0:!t||!s?!1:this.getComparisonKey(t,a)===this.getComparisonKey(s,a)}getComparisonKey(t,s=!1){return t.with({path:this.a(t)?t.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(t){return this.a(t)}isEqualOrParent(t,s,a=!1){if(t.scheme===s.scheme){if(t.scheme===C.Schemas.file)return i.$gg($(t),$(s),this.a(t))&&t.query===s.query&&(a||t.fragment===s.fragment);if((0,e.$Yg)(t.authority,s.authority))return i.$gg(t.path,s.path,this.a(t),"/")&&t.query===s.query&&(a||t.fragment===s.fragment)}return!1}joinPath(t,...s){return y.URI.joinPath(t,...s)}basenameOrAuthority(t){return(0,e.$Qg)(t)||t.authority}basename(t){return j.$gc.basename(t.path)}extname(t){return j.$gc.extname(t.path)}dirname(t){if(t.path.length===0)return t;let s;return t.scheme===C.Schemas.file?s=y.URI.file(j.$mc($(t))).path:(s=j.$gc.dirname(t.path),t.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),s="/")),t.with({path:s})}normalizePath(t){if(!t.path.length)return t;let s;return t.scheme===C.Schemas.file?s=y.URI.file(j.$hc($(t))).path:s=j.$gc.normalize(t.path),t.with({path:s})}relativePath(t,s){if(t.scheme!==s.scheme||!(0,e.$Yg)(t.authority,s.authority))return;if(t.scheme===C.Schemas.file){const u=j.$lc($(t),$(s));return W.$i?i.$ag(u):u}let a=t.path||"/";const m=s.path||"/";if(this.a(t)){let u=0;for(const k=Math.min(a.length,m.length);u<k&&!(a.charCodeAt(u)!==m.charCodeAt(u)&&a.charAt(u).toLowerCase()!==m.charAt(u).toLowerCase());u++);a=m.substr(0,u)+a.substr(u)}return j.$gc.relative(a,m)}resolvePath(t,s){if(t.scheme===C.Schemas.file){const a=y.URI.file(j.$kc($(t),s));return t.with({authority:a.authority,path:a.path})}return s=i.$bg(s),t.with({path:j.$gc.resolve(t.path,s)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,s){return t===s||t!==void 0&&s!==void 0&&(0,D.$kf)(t,s)}hasTrailingPathSeparator(t,s=j.sep){if(t.scheme===C.Schemas.file){const a=$(t);return a.length>i.$cg(a).length&&a[a.length-1]===s}else{const a=t.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,s=j.sep){return(0,e.$Zg)(t,s)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,s=j.sep){let a=!1;if(t.scheme===C.Schemas.file){const m=$(t);a=m!==void 0&&m.length===i.$cg(m).length&&m[m.length-1]===s}else{s="/";const m=t.path;a=m.length===1&&m.charCodeAt(m.length-1)===47}return!a&&!(0,e.$Zg)(t,s)?t.with({path:t.path+"/"}):t}}e.$Ig=p,e.$Jg=new p(()=>!1),e.$Kg=new p(d=>d.scheme===C.Schemas.file?!W.$k:!0),e.$Lg=new p(d=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function w(d,t){const s=[];for(let a=0;a<d.length;a++){const m=t(d[a]);d.some((u,k)=>k===a?!1:(0,e.$Ng)(m,t(u)))||s.push(d[a])}return s}e.$3g=w;var B;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function t(s){const a=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(k=>{const[l,b]=k.split(":");l&&b&&a.set(l,b)});const u=s.path.substring(0,s.path.indexOf(";"));return u&&a.set(d.META_DATA_MIME,u),a}d.parseMetaData=t})(B||(e.DataUri=B={}));function f(d,t,s){if(t){let a=d.path;return a&&a[0]!==j.$gc.sep&&(a=j.$gc.sep+a),d.with({scheme:s,authority:t,path:a})}return d.with({scheme:s})}e.$4g=f}),define(me[9],$e([1,0,30,6,4,3,40,5,53,23]),function(re,e,i,C,j,W,D,y,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function w(N){return!!N&&typeof N.then=="function"}e.$5g=w;function B(N){const o=new i.$de,c=N(o.token),n=new Promise((h,F)=>{const T=o.token.onCancellationRequested(()=>{T.dispose(),F(new C.$5)});Promise.resolve(c).then(P=>{T.dispose(),o.dispose(),h(P)},P=>{T.dispose(),o.dispose(),F(P)})});return new class{cancel(){o.cancel(),o.dispose()}then(h,F){return n.then(h,F)}catch(h){return this.then(void 0,h)}finally(h){return n.finally(h)}}}e.$6g=B;function f(N,o,c){return new Promise((n,h)=>{const F=o.onCancellationRequested(()=>{F.dispose(),n(c)});N.then(n,h).finally(()=>F.dispose())})}e.$7g=f;function d(N,o){return new Promise((c,n)=>{const h=o.onCancellationRequested(()=>{h.dispose(),n(new C.$5)});N.then(c,n).finally(()=>h.dispose())})}e.$8g=d;async function t(N){let o=-1;const c=N.map((n,h)=>n.then(F=>(o=h,F)));try{return await Promise.race(c)}finally{N.forEach((n,h)=>{h!==o&&n.cancel()})}}e.$9g=t;function s(N,o,c){let n;const h=setTimeout(()=>{n?.(void 0),c?.()},o);return Promise.race([N.finally(()=>clearTimeout(h)),new Promise(F=>n=F)])}e.$0g=s;function a(N){return new Promise((o,c)=>{const n=N();w(n)?n.then(o,c):o(n)})}e.$$g=a;function m(){let N,o;return{promise:new Promise((n,h)=>{N=n,o=h}),resolve:N,reject:o}}e.$_g=m;class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(o){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=o,!this.b){const c=()=>{if(this.b=null,this.f)return;const n=this.queue(this.d);return this.d=null,n};this.b=new Promise(n=>{this.a.then(c,c).then(n)})}return new Promise((c,n)=>{this.b.then(c,n)})}return this.a=o(),new Promise((c,n)=>{this.a.then(h=>{this.a=null,c(h)},h=>{this.a=null,n(h)})})}dispose(){this.f=!0}}e.$ah=u;class k{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.$bh=k;class l{constructor(){this.a=new Map}queue(o,c){const h=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(c).finally(()=>{this.a.get(o)===h&&this.a.delete(o)});return this.a.set(o,h),h}}e.$ch=l;const b=(N,o)=>{let c=!0;const n=setTimeout(()=>{c=!1,o()},N);return{isTriggered:()=>c,dispose:()=>{clearTimeout(n),c=!1}}},r=N=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,N())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class A{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,c=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((h,F)=>{this.d=h,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const h=this.g;return this.g=null,h()}}));const n=()=>{this.a=null,this.d?.(null)};return this.a=c===$.$3d?r(n):b(c,n),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=A;class R{constructor(o){this.a=new A(o),this.b=new u}trigger(o,c){return this.a.trigger(()=>this.b.queue(o),c)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=R;class I{constructor(){this.a=!1,this.b=new Promise((o,c)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=I;class O extends I{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.$gh=O;function z(N,o){return o?new Promise((c,n)=>{const h=setTimeout(()=>{F.dispose(),c()},N),F=o.onCancellationRequested(()=>{clearTimeout(h),F.dispose(),n(new C.$5)})}):B(c=>z(N,c))}e.$hh=z;function v(N,o=0,c){const n=setTimeout(()=>{N(),c&&h.dispose()},o),h=(0,W.$Rc)(()=>{clearTimeout(n),c?.deleteAndLeak(h)});return c?.add(h),h}e.$ih=v;function H(N){const o=[];let c=0;const n=N.length;function h(){return c<n?N[c++]():null}function F(T){T!=null&&o.push(T);const P=h();return P?P.then(F):Promise.resolve(o)}return Promise.resolve(null).then(F)}e.$jh=H;function V(N,o=n=>!!n,c=null){let n=0;const h=N.length,F=()=>{if(n>=h)return Promise.resolve(c);const T=N[n++];return Promise.resolve(T()).then(q=>o(q)?Promise.resolve(q):F())};return F()}e.$kh=V;function S(N,o=n=>!!n,c=null){if(N.length===0)return Promise.resolve(c);let n=N.length;const h=()=>{n=-1;for(const F of N)F.cancel?.()};return new Promise((F,T)=>{for(const P of N)P.then(q=>{--n>=0&&o(q)?(h(),F(q)):n===0&&F(c)}).catch(q=>{--n>=0&&(h(),T(q))})})}e.$lh=S;class L{constructor(o){this.a=0,this.b=!1,this.f=o,this.g=[],this.d=0,this.h=new j.$6d}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(o){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((c,n)=>{this.g.push({factory:o,c,e:n}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const o=this.g.shift();this.d++;const c=o.factory();c.then(o.c,o.e),c.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=L;class M extends L{constructor(){super(1)}}e.$nh=M;class X{constructor(){this.a=new ae,this.b=0}queue(o){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,o())):this.a.run(this.b++,o())}}e.$oh=X;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const o=new G;return this.b.add(o),o.p}g(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueSize(o,c=D.$Jg){const n=c.getComparisonKey(o);return this.a.get(n)?.size??0}queueFor(o,c,n=D.$Jg){const h=n.getComparisonKey(o);let F=this.a.get(h);if(!F){F=new M;const T=this.f++,P=j.Event.once(F.onDrained)(()=>{F?.dispose(),this.a.delete(h),this.h(),this.d?.deleteAndDispose(T),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new W.$3c),this.d.set(T,P),this.a.set(h,F)}return F.queue(c)}h(){this.g()&&this.j()}j(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=U;class de{constructor(o,c){this.a=-1,typeof o=="function"&&typeof c=="number"&&this.setIfNotSet(o,c)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,c){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},c)}setIfNotSet(o,c){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},c))}}e.$qh=de;class he{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(o,c,n=globalThis){this.cancel();const h=n.setInterval(()=>{o()},c);this.d=(0,W.$Rc)(()=>{n.clearInterval(h),this.d=void 0})}dispose(){this.cancel()}}e.$rh=he;class ne{constructor(o,c){this.b=-1,this.a=o,this.d=c,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=ne;class ge{constructor(o,c){c%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${c}ms is not a multiple of 1000ms.`),this.a=o,this.b=c,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=ge;class Fe extends ne{constructor(o,c){super(o,c),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.$uh=Fe;class Ce extends W.$Tc{constructor(o,c){super(),this.g=o,this.h=c,this.a=[],this.b=this.B(new W.$Uc),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const c of o)this.a.push(c);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ne(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=Ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(N,o)=>{(0,y.$B)(()=>{if(c)return;const n=Date.now()+15;o(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,n-Date.now())}}))});let c=!1;return{dispose(){c||(c=!0)}}}:e.$xh=(N,o,c)=>{const n=N.requestIdleCallback(o,typeof c=="number"?{timeout:c}:void 0);let h=!1;return{dispose(){h||(h=!0,N.cancelIdleCallback(n))}}},e.$wh=N=>(0,e.$xh)(globalThis,N)}();class Be{constructor(o,c){this.g=!1,this.d=()=>{try{this.j=c()}catch(n){this.l=n}finally{this.g=!0}},this.f=(0,e.$xh)(o,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=Be;class le extends Be{constructor(o){super(globalThis,o)}}e.$zh=le;async function _(N,o,c){let n;for(let h=0;h<c;h++)try{return await N()}catch(F){n=F,await z(o)}throw n}e.$Ah=_;class ae{isRunning(o){return typeof o=="number"?this.a?.taskId===o:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(o,c,n){return this.a={taskId:o,cancel:()=>n?.(),promise:c},c.then(()=>this.d(o),()=>this.d(o)),c}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}queue(o){if(this.b)this.b.run=o;else{const{promise:c,resolve:n,reject:h}=m();this.b={run:o,promise:c,promiseResolve:n,promiseReject:h}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=ae;class oe{constructor(o,c=()=>Date.now()){this.d=o,this.f=c,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.$Ch=oe;var J;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(J||(J={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((o,c)=>{this.a=o,this.b=c})}complete(o){return new Promise(c=>{this.a(o),this.d={outcome:0,value:o},c()})}error(o){return new Promise(c=>{this.b(o),this.d={outcome:1,value:o},c()})}cancel(){return this.error(new C.$5)}}e.$Dh=G;var ie;(function(N){async function o(n){let h;const F=await Promise.all(n.map(T=>T.then(P=>P,P=>{h||(h=P)})));if(typeof h<"u")throw h;return F}N.settled=o;function c(n){return new Promise(async(h,F)=>{try{await n(h,F)}catch(T){F(T)}})}N.withAsyncBody=c})(ie||(e.Promises=ie={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(o){this.a=void 0,this.b=void 0,this.d=!1,this.promise=o.then(c=>(this.a=c,this.d=!0,c),c=>{throw this.b=c,this.d=!0,c})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=ce;class De{constructor(o){this.b=o,this.a=new p.$V(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=De;var Ne;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(Ne||(Ne={}));class ye{static fromArray(o){return new ye(c=>{c.emitMany(o)})}static fromPromise(o){return new ye(async c=>{c.emitMany(await o)})}static fromPromises(o){return new ye(async c=>{await Promise.all(o.map(async n=>c.emitOne(await n)))})}static merge(o){return new ye(async c=>{await Promise.all(o.map(async n=>{for await(const h of n)c.emitOne(h)}))})}static{this.EMPTY=ye.fromArray([])}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new j.$6d,queueMicrotask(async()=>{const c={emitOne:n=>this.g(n),emitMany:n=>this.h(n),reject:n=>this.k(n)};try{await Promise.resolve(o(c)),this.j()}catch(n){this.k(n)}finally{c.emitOne=void 0,c.emitMany=void 0,c.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await j.Event.toPromise(this.f.event)}while(!0)}}}static map(o,c){return new ye(async n=>{for await(const h of o)n.emitOne(c(h))})}map(o){return ye.map(this,o)}static filter(o,c){return new ye(async n=>{for await(const h of o)c(h)&&n.emitOne(h)})}filter(o){return ye.filter(this,o)}static coalesce(o){return ye.filter(o,c=>!!c)}coalesce(){return ye.coalesce(this)}static async toPromise(o){const c=[];for await(const n of o)c.push(n);return c}toPromise(){return ye.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.$Gh=ye;class K extends ye{constructor(o,c){super(c),this.l=o}cancel(){this.l.cancel()}}e.$Hh=K;function g(N){const o=new i.$de,c=N(o.token);return new K(o,async n=>{const h=o.token.onCancellationRequested(()=>{h.dispose(),o.dispose(),n.reject(new C.$5)});try{for await(const F of c){if(o.token.isCancellationRequested)return;n.emitOne(F)}h.dispose(),o.dispose()}catch(F){h.dispose(),o.dispose(),n.reject(F)}})}e.$Ih=g;class E{constructor(){this.a=new G,this.b=new ye(n=>{if(o){n.reject(o);return}return c&&n.emitMany(c),this.d=h=>n.reject(h),this.f=h=>n.emitOne(h),this.a.p});let o,c;this.f=n=>{c||(c=[]),c.push(n)},this.d=n=>{o||(o=n)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(o){this.d(o),this.a.complete()}emitOne(o){this.f(o)}}e.$Jh=E}),define(me[2],$e([1,0,17,118,14,20,9,6,4,122,3,32,5,15,52,22]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=e.h=e.$kS=e.$jS=e.$iS=e.$hS=e.$gS=e.$fS=e.$eS=e.$dS=e.DetectedFullscreenMode=e.$cS=e.$bS=e.$aS=e.$_R=e.$$R=e.$0R=e.$9R=e.$8R=e.$7R=e.$6R=e.$5R=e.$4R=e.$3R=e.$2R=e.$1R=e.$ZR=e.$YR=e.$=e.Namespace=e.$WR=e.$VR=e.$UR=e.$TR=e.$SR=e.$RR=e.$QR=e.$PR=e.$OR=e.$NR=e.$MR=e.$LR=e.$KR=e.$JR=e.$IR=e.$HR=e.$GR=e.$FR=e.$ER=e.$DR=e.$CR=e.$BR=e.$AR=e.$zR=e.$yR=e.$xR=e.$wR=e.$vR=e.$uR=e.$tR=e.$sR=e.$rR=e.$qR=e.$pR=e.$oR=e.$nR=e.$mR=e.$lR=e.$kR=e.$jR=e.$iR=e.$hR=e.$gR=e.$fR=e.$eR=e.$dR=e.$cR=e.$bR=e.$aR=e.$_Q=e.$$Q=e.$0Q=e.$9Q=e.$8Q=e.$7Q=e.$6Q=e.$5Q=e.$4Q=e.$3Q=e.$2Q=e.$1Q=e.$ZQ=e.$YQ=e.$XQ=e.$WQ=e.$VQ=e.$UQ=e.$TQ=e.$SQ=e.onDidUnregisterWindow=e.onWillUnregisterWindow=e.onDidRegisterWindow=e.hasWindow=e.getWindowById=e.getWindowId=e.getWindowsCount=e.getWindows=e.getDocument=e.getWindow=e.registerWindow=void 0,a=function(){const Q=new Map;(0,s.$lQ)(s.$mQ,1);const x={window:s.$mQ,disposables:new w.$Sc};Q.set(s.$mQ.vscodeWindowId,x);const te=new $.$6d,fe=new $.$6d,Se=new $.$6d;function He(Pe,Ve){return(typeof Pe=="number"?Q.get(Pe):void 0)??(Ve?x:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Se.event,onDidUnregisterWindow:fe.event,registerWindow(Pe){if(Q.has(Pe.vscodeWindowId))return w.$Tc.None;const Ve=new w.$Sc,Ke={window:Pe,disposables:Ve.add(new w.$Sc)};return Q.set(Pe.vscodeWindowId,Ke),Ve.add((0,w.$Rc)(()=>{Q.delete(Pe.vscodeWindowId),fe.fire(Pe)})),Ve.add(k(Pe,e.$NR.BEFORE_UNLOAD,()=>{Se.fire(Pe)})),te.fire(Ke),Ve},getWindows(){return Q.values()},getWindowsCount(){return Q.size},getWindowId(Pe){return Pe.vscodeWindowId},hasWindow(Pe){return Q.has(Pe)},getWindowById:He,getWindow(Pe){const Ve=Pe;if(Ve?.ownerDocument?.defaultView)return Ve.ownerDocument.defaultView.window;const Ke=Pe;return Ke?.view?Ke.view.window:s.$mQ},getDocument(Pe){const Ve=Pe;return(0,e.getWindow)(Ve).document}}}(),e.registerWindow=a.registerWindow,e.getWindow=a.getWindow,e.getDocument=a.getDocument,e.getWindows=a.getWindows,e.getWindowsCount=a.getWindowsCount,e.getWindowId=a.getWindowId,e.getWindowById=a.getWindowById,e.hasWindow=a.hasWindow,e.onDidRegisterWindow=a.onDidRegisterWindow,e.onWillUnregisterWindow=a.onWillUnregisterWindow,e.onDidUnregisterWindow=a.onDidUnregisterWindow;function m(Q){for(;Q.firstChild;)Q.firstChild.remove()}e.$SQ=m;class u{constructor(x,te,fe,Se){this.f=x,this.g=te,this.d=fe,this.j=Se||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function k(Q,x,te,fe){return new u(Q,x,te,fe)}e.$TQ=k;function l(Q,x){return function(te){return x(new W.$LQ(Q,te))}}function b(Q){return function(x){return Q(new j.$QQ(x))}}const r=function(x,te,fe,Se){let He=fe;return te==="click"||te==="mousedown"?He=l((0,e.getWindow)(x),fe):(te==="keydown"||te==="keypress"||te==="keyup")&&(He=b(fe)),k(x,te,He,Se)};e.$UQ=r;const A=function(x,te,fe){const Se=l((0,e.getWindow)(x),te);return I(x,Se,fe)};e.$VQ=A;const R=function(x,te,fe){const Se=l((0,e.getWindow)(x),te);return z(x,Se,fe)};e.$WQ=R;function I(Q,x,te){return k(Q,f.$r&&C.$IQ.pointerEvents?e.$NR.POINTER_DOWN:e.$NR.MOUSE_DOWN,x,te)}e.$XQ=I;function O(Q,x,te){return k(Q,f.$r&&C.$IQ.pointerEvents?e.$NR.POINTER_MOVE:e.$NR.MOUSE_MOVE,x,te)}e.$YQ=O;function z(Q,x,te){return k(Q,f.$r&&C.$IQ.pointerEvents?e.$NR.POINTER_UP:e.$NR.MOUSE_UP,x,te)}e.$ZQ=z;function v(Q,x,te){return(0,D.$xh)(Q,x,te)}e.$1Q=v;class H extends D.$yh{constructor(x,te){super(x,te)}}e.$2Q=H;function V(Q,x,te,fe){let Se=0;const He=Q.setInterval(()=>{Se++,(typeof fe=="number"&&Se>=fe||x()===!0)&&Pe.dispose()},te),Pe=(0,w.$Rc)(()=>{Q.clearInterval(He)});return Pe}e.$5Q=V;class S extends D.$rh{constructor(x){super(),this.f=x&&(0,e.getWindow)(x)}cancelAndSet(x,te,fe){return super.cancelAndSet(x,te,fe??this.f)}}e.$6Q=S;class L{constructor(x,te=0){this.d=x,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(x){(0,y.$1)(x)}}static sort(x,te){return te.priority-x.priority}}(function(){const Q=new Map,x=new Map,te=new Map,fe=new Map,Se=He=>{te.set(He,!1);const Pe=Q.get(He)??[];for(x.set(He,Pe),Q.set(He,[]),fe.set(He,!0);Pe.length>0;)Pe.sort(L.sort),Pe.shift().execute();fe.set(He,!1)};e.$4Q=(He,Pe,Ve=0)=>{const Ke=(0,e.getWindowId)(He),xe=new L(Pe,Ve);let at=Q.get(Ke);return at||(at=[],Q.set(Ke,at)),at.push(xe),te.get(Ke)||(te.set(Ke,!0),He.requestAnimationFrame(()=>Se(Ke))),xe},e.$3Q=(He,Pe,Ve)=>{const Ke=(0,e.getWindowId)(He);if(fe.get(Ke)){const xe=new L(Pe,Ve);let at=x.get(Ke);return at||(at=[],x.set(Ke,at)),at.push(xe),xe}else return(0,e.$4Q)(He,Pe,Ve)}})();function M(Q,x){return(0,e.$4Q)(Q,x,1e4)}e.$7Q=M;function X(Q,x){return(0,e.$4Q)(Q,x,-1e4)}e.$8Q=X;const U=8,de=function(Q,x){return x};class he extends w.$Tc{constructor(x,te,fe,Se=de,He=U){super();let Pe=null,Ve=0;const Ke=this.B(new D.$qh),xe=()=>{Ve=new Date().getTime(),fe(Pe),Pe=null};this.B(k(x,te,at=>{Pe=Se(Pe,at);const Nt=new Date().getTime()-Ve;Nt>=He?(Ke.cancel(),xe()):Ke.setIfNotSet(xe,He-Nt)}))}}function ne(Q,x,te,fe,Se){return new he(Q,x,te,fe,Se)}e.$9Q=ne;function ge(Q){return(0,e.getWindow)(Q).getComputedStyle(Q,null)}e.$0Q=ge;function Fe(Q,x){const te=(0,e.getWindow)(Q),fe=te.document;if(Q!==fe.body)return new Be(Q.clientWidth,Q.clientHeight);if(f.$r&&te?.visualViewport)return new Be(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Be(te.innerWidth,te.innerHeight);if(fe.body&&fe.body.clientWidth&&fe.body.clientHeight)return new Be(fe.body.clientWidth,fe.body.clientHeight);if(fe.documentElement&&fe.documentElement.clientWidth&&fe.documentElement.clientHeight)return new Be(fe.documentElement.clientWidth,fe.documentElement.clientHeight);if(x)return Fe(x);throw new Error("Unable to figure out browser width and height")}e.$$Q=Fe;class Ce{static d(x,te){return parseFloat(te)||0}static f(x,te,fe){const Se=ge(x),He=Se?Se.getPropertyValue(te):"0";return Ce.d(x,He)}static getBorderLeftWidth(x){return Ce.f(x,"border-left-width","borderLeftWidth")}static getBorderRightWidth(x){return Ce.f(x,"border-right-width","borderRightWidth")}static getBorderTopWidth(x){return Ce.f(x,"border-top-width","borderTopWidth")}static getBorderBottomWidth(x){return Ce.f(x,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(x){return Ce.f(x,"padding-left","paddingLeft")}static getPaddingRight(x){return Ce.f(x,"padding-right","paddingRight")}static getPaddingTop(x){return Ce.f(x,"padding-top","paddingTop")}static getPaddingBottom(x){return Ce.f(x,"padding-bottom","paddingBottom")}static getMarginLeft(x){return Ce.f(x,"margin-left","marginLeft")}static getMarginTop(x){return Ce.f(x,"margin-top","marginTop")}static getMarginRight(x){return Ce.f(x,"margin-right","marginRight")}static getMarginBottom(x){return Ce.f(x,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(x,te){this.width=x,this.height=te}with(x=this.width,te=this.height){return x!==this.width||te!==this.height?new Be(x,te):this}static is(x){return typeof x=="object"&&typeof x.height=="number"&&typeof x.width=="number"}static lift(x){return x instanceof Be?x:new Be(x.width,x.height)}static equals(x,te){return x===te?!0:!x||!te?!1:x.width===te.width&&x.height===te.height}}e.$_Q=Be;function le(Q){let x=Q.offsetParent,te=Q.offsetTop,fe=Q.offsetLeft;for(;(Q=Q.parentNode)!==null&&Q!==Q.ownerDocument.body&&Q!==Q.ownerDocument.documentElement;){te-=Q.scrollTop;const Se=F(Q)?null:ge(Q);Se&&(fe-=Se.direction!=="rtl"?Q.scrollLeft:-Q.scrollLeft),Q===x&&(fe+=Ce.getBorderLeftWidth(Q),te+=Ce.getBorderTopWidth(Q),te+=Q.offsetTop,fe+=Q.offsetLeft,x=Q.offsetParent)}return{left:fe,top:te}}e.$aR=le;function _(Q,x,te){typeof x=="number"&&(Q.style.width=`${x}px`),typeof te=="number"&&(Q.style.height=`${te}px`)}e.$bR=_;function ae(Q,x,te,fe,Se,He="absolute"){typeof x=="number"&&(Q.style.top=`${x}px`),typeof te=="number"&&(Q.style.right=`${te}px`),typeof fe=="number"&&(Q.style.bottom=`${fe}px`),typeof Se=="number"&&(Q.style.left=`${Se}px`),Q.style.position=He}e.$cR=ae;function oe(Q){const x=Q.getBoundingClientRect(),te=(0,e.getWindow)(Q);return{left:x.left+te.scrollX,top:x.top+te.scrollY,width:x.width,height:x.height}}e.$dR=oe;function J(Q){let x=Q,te=1;do{const fe=ge(x).zoom;fe!=null&&fe!=="1"&&(te*=fe),x=x.parentElement}while(x!==null&&x!==x.ownerDocument.documentElement);return te}e.$eR=J;function G(Q){const x=Ce.getMarginLeft(Q)+Ce.getMarginRight(Q);return Q.offsetWidth+x}e.$fR=G;function ie(Q){const x=Ce.getBorderLeftWidth(Q)+Ce.getBorderRightWidth(Q),te=Ce.getPaddingLeft(Q)+Ce.getPaddingRight(Q);return Q.offsetWidth-x-te}e.$gR=ie;function ce(Q){const x=Ce.getMarginLeft(Q)+Ce.getMarginRight(Q);return Q.scrollWidth+x}e.$hR=ce;function De(Q){const x=Ce.getBorderTopWidth(Q)+Ce.getBorderBottomWidth(Q),te=Ce.getPaddingTop(Q)+Ce.getPaddingBottom(Q);return Q.offsetHeight-x-te}e.$iR=De;function Ne(Q){const x=Ce.getMarginTop(Q)+Ce.getMarginBottom(Q);return Q.offsetHeight+x}e.$jR=Ne;function ye(Q,x){if(Q===null)return 0;const te=le(Q),fe=le(x);return te.left-fe.left}function K(Q,x){const te=x.map(Se=>Math.max(ce(Se),G(Se))+ye(Se,Q)||0);return Math.max(...te)}e.$kR=K;function g(Q,x){return!!x?.contains(Q)}e.$lR=g;const E="parentFlowToElementId";function N(Q,x){Q.dataset[E]=x.id}e.$mR=N;function o(Q){const x=Q.dataset[E];return typeof x=="string"?Q.ownerDocument.getElementById(x):null}function c(Q,x){let te=Q;for(;te;){if(te===x)return!0;if(te instanceof HTMLElement){const fe=o(te);if(fe){te=fe;continue}}te=te.parentNode}return!1}e.$nR=c;function n(Q,x,te){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q.classList.contains(x))return Q;if(te){if(typeof te=="string"){if(Q.classList.contains(te))return null}else if(Q===te)return null}Q=Q.parentNode}return null}e.$oR=n;function h(Q,x,te){return!!n(Q,x,te)}e.$pR=h;function F(Q){return Q&&!!Q.host&&!!Q.mode}e.$qR=F;function T(Q){return!!P(Q)}e.$rR=T;function P(Q){for(;Q.parentNode;){if(Q===Q.ownerDocument?.body)return null;Q=Q.parentNode}return F(Q)?Q:null}e.$sR=P;function q(){let Q=we().activeElement;for(;Q?.shadowRoot;)Q=Q.shadowRoot.activeElement;return Q}e.$tR=q;function Z(Q){return q()===Q}e.$uR=Z;function ee(Q){return g(q(),Q)}e.$vR=ee;function be(Q){return Q.ownerDocument===we()}e.$wR=be;function we(){return(0,e.getWindowsCount)()<=1?s.$mQ.document:Array.from((0,e.getWindows)()).map(({window:x})=>x.document).find(x=>x.hasFocus())??s.$mQ.document}e.$xR=we;function ke(){return we().defaultView?.window??s.$mQ}e.$yR=ke;function Oe(Q){const x=(0,e.getWindow)(Q);x.document.hasFocus()||x.focus()}e.$zR=Oe;const Ee=new Map;function Ae(Q){return Ee.has(Q)}e.$AR=Ae;function Re(){return new Ie}e.$BR=Re;class Ie{constructor(){this.d="",this.f=void 0}setStyle(x){x!==this.d&&(this.d=x,this.f?this.f.innerText=x:this.f=Ge(s.$mQ.document.head,te=>te.innerText=x))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ge(Q=s.$mQ.document.head,x,te){const fe=document.createElement("style");if(fe.type="text/css",fe.media="screen",x?.(fe),Q.appendChild(fe),te&&te.add((0,w.$Rc)(()=>Q.removeChild(fe))),Q===s.$mQ.document.head){const Se=new Set;Ee.set(fe,Se);for(const{window:He,disposables:Pe}of(0,e.getWindows)()){if(He===s.$mQ)continue;const Ve=Pe.add(Ye(fe,Se,He));te?.add(Ve)}}return fe}e.$CR=Ge;function nt(Q){const x=new w.$Sc;for(const[te,fe]of Ee)x.add(Ye(te,fe,Q));return x}e.$DR=nt;function Ye(Q,x,te){const fe=new w.$Sc,Se=Q.cloneNode(!0);te.document.head.appendChild(Se),fe.add((0,w.$Rc)(()=>te.document.head.removeChild(Se)));for(const He of Le(Q))Se.sheet?.insertRule(He.cssText,Se.sheet?.cssRules.length);return fe.add(e.$ER.observe(Q,fe,{childList:!0})(()=>{Se.textContent=Q.textContent})),x.add(Se),fe.add((0,w.$Rc)(()=>x.delete(Se))),fe}e.$ER=new class{constructor(){this.mutationObservers=new Map}observe(Q,x,te){let fe=this.mutationObservers.get(Q);fe||(fe=new Map,this.mutationObservers.set(Q,fe));const Se=(0,t.$7i)(te);let He=fe.get(Se);if(He)He.users+=1;else{const Pe=new $.$6d,Ve=new MutationObserver(xe=>Pe.fire(xe));Ve.observe(Q,te);const Ke=He={users:1,observer:Ve,onDidMutate:Pe.event};x.add((0,w.$Rc)(()=>{Ke.users-=1,Ke.users===0&&(Pe.dispose(),Ve.disconnect(),fe?.delete(Se),fe?.size===0&&this.mutationObservers.delete(Q))})),fe.set(Se,He)}return He.onDidMutate}};function Ue(Q=s.$mQ.document.head){return se("meta",Q)}e.$FR=Ue;function Y(Q=s.$mQ.document.head){return se("link",Q)}e.$GR=Y;function se(Q,x=s.$mQ.document.head){const te=document.createElement(Q);return x.appendChild(te),te}let pe=null;function ve(){return pe||(pe=Ge()),pe}function Le(Q){return Q?.sheet?.rules?Q.sheet.rules:Q?.sheet?.cssRules?Q.sheet.cssRules:[]}function je(Q,x,te=ve()){if(!(!te||!x)){te.sheet?.insertRule(`${Q} {${x}}`,0);for(const fe of Ee.get(te)??[])je(Q,x,fe)}}e.$HR=je;function qe(Q,x=ve()){if(!x)return;const te=Le(x),fe=[];for(let Se=0;Se<te.length;Se++){const He=te[Se];_e(He)&&He.selectorText.indexOf(Q)!==-1&&fe.push(Se)}for(let Se=fe.length-1;Se>=0;Se--)x.sheet?.deleteRule(fe[Se]);for(const Se of Ee.get(x)??[])qe(Q,Se)}e.$IR=qe;function _e(Q){return typeof Q.selectorText=="string"}function tt(Q){return Q instanceof MouseEvent||Q instanceof(0,e.getWindow)(Q).MouseEvent}e.$JR=tt;function st(Q){return Q instanceof KeyboardEvent||Q instanceof(0,e.getWindow)(Q).KeyboardEvent}e.$KR=st;function Ze(Q){return Q instanceof PointerEvent||Q instanceof(0,e.getWindow)(Q).PointerEvent}e.$LR=Ze;function rt(Q){return Q instanceof DragEvent||Q instanceof(0,e.getWindow)(Q).DragEvent}e.$MR=rt,e.$NR={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:i.$AQ?"webkitAnimationStart":"animationstart",ANIMATION_END:i.$AQ?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:i.$AQ?"webkitAnimationIteration":"animationiteration"};function et(Q){const x=Q;return!!(x&&typeof x.preventDefault=="function"&&typeof x.stopPropagation=="function")}e.$OR=et,e.$PR={stop:(Q,x)=>(Q.preventDefault(),x&&Q.stopPropagation(),Q)};function gt(Q){const x=[];for(let te=0;Q&&Q.nodeType===Q.ELEMENT_NODE;te++)x[te]=Q.scrollTop,Q=Q.parentNode;return x}e.$QR=gt;function mt(Q,x){for(let te=0;Q&&Q.nodeType===Q.ELEMENT_NODE;te++)Q.scrollTop!==x[te]&&(Q.scrollTop=x[te]),Q=Q.parentNode}e.$RR=mt;class $t extends w.$Tc{static m(x){if(x instanceof HTMLElement){const te=P(x),fe=te?te.activeElement:x.ownerDocument.activeElement;return g(fe,x)}else{const te=x;return g(te.document.activeElement,te.document)}}constructor(x){super(),this.f=this.B(new $.$6d),this.onDidFocus=this.f.event,this.g=this.B(new $.$6d),this.onDidBlur=this.g.event;let te=$t.m(x),fe=!1;const Se=()=>{fe=!1,te||(te=!0,this.f.fire())},He=()=>{te&&(fe=!0,(x instanceof HTMLElement?(0,e.getWindow)(x):x).setTimeout(()=>{fe&&(fe=!1,te=!1,this.g.fire())},0))};this.j=()=>{$t.m(x)!==te&&(te?He():Se())},this.B(k(x,e.$NR.FOCUS,Se,!0)),this.B(k(x,e.$NR.BLUR,He,!0)),x instanceof HTMLElement&&(this.B(k(x,e.$NR.FOCUS_IN,()=>this.j())),this.B(k(x,e.$NR.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Tt(Q){return new $t(Q)}e.$SR=Tt;function Pt(Q,x){return Q.after(x),x}e.$TR=Pt;function ze(Q,...x){if(Q.append(...x),x.length===1&&typeof x[0]!="string")return x[0]}e.$UR=ze;function ue(Q,x){return Q.insertBefore(x,Q.firstChild),x}e.$VR=ue;function Te(Q,...x){Q.innerText="",ze(Q,...x)}e.$WR=Te;const Me=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Qe;(function(Q){Q.HTML="http://www.w3.org/1999/xhtml",Q.SVG="http://www.w3.org/2000/svg"})(Qe||(e.Namespace=Qe={}));function it(Q,x,te,...fe){const Se=Me.exec(x);if(!Se)throw new Error("Bad use of emmet");const He=Se[1]||"div";let Pe;return Q!==Qe.HTML?Pe=document.createElementNS(Q,He):Pe=document.createElement(He),Se[3]&&(Pe.id=Se[3]),Se[4]&&(Pe.className=Se[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([Ve,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(Ve)?Pe[Ve]=Ke:Ve==="selected"?Ke&&Pe.setAttribute(Ve,"true"):Pe.setAttribute(Ve,Ke))}),Pe.append(...fe),Pe}function lt(Q,x,...te){return it(Qe.HTML,Q,x,...te)}e.$=lt,lt.SVG=function(Q,x,...te){return it(Qe.SVG,Q,x,...te)};function Xe(Q,x){const te=[];return Q.forEach((fe,Se)=>{Se>0&&(x instanceof Node?te.push(x.cloneNode()):te.push(document.createTextNode(x))),te.push(fe)}),te}e.$YR=Xe;function ct(Q,...x){Q?pt(...x):Dt(...x)}e.$ZR=ct;function pt(...Q){for(const x of Q)x.style.display="",x.removeAttribute("aria-hidden")}e.$1R=pt;function Dt(...Q){for(const x of Q)x.style.display="none",x.setAttribute("aria-hidden","true")}e.$2R=Dt;function Xt(Q,x){for(;Q&&Q.nodeType===Q.ELEMENT_NODE;){if(Q instanceof HTMLElement&&Q.hasAttribute(x))return Q;Q=Q.parentNode}return null}function Ei(Q){!Q||!Q.hasAttribute("tabIndex")||(Q.ownerDocument.activeElement===Q&&Xt(Q.parentElement,"tabIndex")?.focus(),Q.removeAttribute("tabindex"))}e.$3R=Ei;function Ai(Q){return x=>{x.preventDefault(),x.stopPropagation(),Q(x)}}e.$4R=Ai;function Si(Q){return new Promise(x=>{if(Q.document.readyState==="complete"||Q.document&&Q.document.body!==null)x(void 0);else{const fe=()=>{Q.window.removeEventListener("DOMContentLoaded",fe,!1),x()};Q.window.addEventListener("DOMContentLoaded",fe,!1)}})}e.$5R=Si;function Ti(Q,x){const te=Q.devicePixelRatio*x;return Math.max(1,Math.floor(te))/Q.devicePixelRatio}e.$6R=Ti;function Ni(Q){s.$mQ.open(Q,"_blank","noopener")}e.$7R=Ni;const Jt=780,Zt=640;function Fi(Q){const x=Math.floor(s.$mQ.screenLeft+s.$mQ.innerWidth/2-Jt/2),te=Math.floor(s.$mQ.screenTop+s.$mQ.innerHeight/2-Zt/2);s.$mQ.open(Q,"_blank",`width=${Jt},height=${Zt},top=${te},left=${x}`)}e.$8R=Fi;function Ci(Q,x=!0){const te=s.$mQ.open();return te?(x&&(te.opener=null),te.location.href=Q,!0):!1}e.$9R=Ci;function Ri(Q,x){const te=()=>{x(),fe=(0,e.$4Q)(Q,te)};let fe=(0,e.$4Q)(Q,te);return(0,w.$Rc)(()=>fe.dispose())}e.$0R=Ri,B.$tg.setPreferredWebSchema(/^https:/.test(s.$mQ.location.href)?"https":"http");function Li(Q){return Q?`url('${B.$Ag.uriToBrowserUri(Q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}e.$$R=Li;function Ii(Q){return`'${Q.replace(/'/g,"%27")}'`}e.$_R=Ii;function Ut(Q,x){if(Q!==void 0){const te=Q.match(/^\s*var\((.+)\)$/);if(te){const fe=te[1].split(",",2);return fe.length===2&&(x=Ut(fe[1].trim(),x)),`var(${fe[0]}, ${x})`}return Q}return x}e.$aS=Ut;function Mi(Q,x){let te;if(d.URI.isUri(Q))te=Q.toString(!0);else{const He=new Blob([Q]);te=URL.createObjectURL(He),setTimeout(()=>URL.revokeObjectURL(te))}const fe=ke(),Se=document.createElement("a");fe.document.body.appendChild(Se),Se.download=x,Se.href=te,Se.click(),setTimeout(()=>fe.document.body.removeChild(Se))}e.$bS=Mi;function Oi(){return new Promise(Q=>{const x=ke(),te=document.createElement("input");x.document.body.appendChild(te),te.type="file",te.multiple=!0,$.Event.once($.Event.fromDOMEventEmitter(te,"input"))(()=>{Q(te.files??void 0)}),te.click(),setTimeout(()=>x.document.body.removeChild(te))})}e.$cS=Oi;var yt;(function(Q){Q[Q.DOCUMENT=1]="DOCUMENT",Q[Q.BROWSER=2]="BROWSER"})(yt||(e.DetectedFullscreenMode=yt={}));function Pi(Q){return Q.document.fullscreenElement||Q.document.webkitFullscreenElement||Q.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:Q.innerHeight===Q.screen.height?{mode:yt.BROWSER,guess:!1}:(f.$j||f.$k)&&Q.outerHeight===Q.screen.height&&Q.outerWidth===Q.screen.width?{mode:yt.BROWSER,guess:!0}:null}e.$dS=Pi;function _t(Q,x=!1){const te=document.createElement("a");return p.addHook("afterSanitizeAttributes",fe=>{for(const Se of["href","src"])if(fe.hasAttribute(Se)){const He=fe.getAttribute(Se);if(Se==="href"&&He.startsWith("#"))continue;if(te.href=He,!Q.includes(te.protocol.replace(/:$/,""))){if(x&&Se==="src"&&te.href.startsWith("data:"))continue;fe.removeAttribute(Se)}}}),(0,w.$Rc)(()=>{p.removeHook("afterSanitizeAttributes")})}e.$eS=_t;const Bi=[B.Schemas.http,B.Schemas.https,B.Schemas.command];e.$fS=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Hi(Q,x){const te=_t(Bi);try{const fe=p.sanitize(x,zi);Q.innerHTML=fe}finally{te.dispose()}}e.$gS=Hi;function ji(Q){const x=new Uint16Array(Q.length);for(let Se=0;Se<x.length;Se++)x[Se]=Q.charCodeAt(Se);let te="";const fe=new Uint8Array(x.buffer);for(let Se=0;Se<fe.length;Se++)te+=String.fromCharCode(fe[Se]);return te}function Wi(Q){return btoa(ji(Q))}e.$hS=Wi;class kt extends $.$6d{constructor(){super(),this.o=new w.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add($.Event.runAndSubscribe(e.onDidRegisterWindow,({window:x,disposables:te})=>this.C(x,te),{window:s.$mQ,disposables:this.o}))}C(x,te){te.add(k(x,"keydown",fe=>{if(fe.defaultPrevented)return;const Se=new j.$QQ(fe);if(!(Se.keyCode===6&&fe.repeat)){if(fe.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(fe.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(fe.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(fe.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Se.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyPressed&&(this.A.event=fe,this.fire(this.A))}},!0)),te.add(k(x,"keyup",fe=>{fe.defaultPrevented||(!fe.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!fe.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!fe.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!fe.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=fe.altKey,this.A.ctrlKey=fe.ctrlKey,this.A.metaKey=fe.metaKey,this.A.shiftKey=fe.shiftKey,this.A.lastKeyReleased&&(this.A.event=fe,this.fire(this.A)))},!0)),te.add(k(x.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(k(x.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(k(x.document.body,"mousemove",fe=>{fe.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(k(x,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return kt.B||(kt.B=new kt),kt.B}dispose(){super.dispose(),this.o.dispose()}}e.$iS=kt;function Vi(Q){const x=document.cookie.match("(^|[^;]+)\\s*"+Q+"\\s*=\\s*([^;]+)");return x?x.pop():void 0}e.$jS=Vi;class qi extends w.$Tc{constructor(x,te){super(),this.j=x,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(k(this.j,e.$NR.DRAG_START,x=>{this.m.onDragStart?.(x)})),this.m.onDrag&&this.B(k(this.j,e.$NR.DRAG,x=>{this.m.onDrag?.(x)})),this.B(k(this.j,e.$NR.DRAG_ENTER,x=>{this.f++,this.g=x.timeStamp,this.m.onDragEnter?.(x)})),this.B(k(this.j,e.$NR.DRAG_OVER,x=>{x.preventDefault(),this.m.onDragOver?.(x,x.timeStamp-this.g)})),this.B(k(this.j,e.$NR.DRAG_LEAVE,x=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(x))})),this.B(k(this.j,e.$NR.DRAG_END,x=>{this.f=0,this.g=0,this.m.onDragEnd?.(x)})),this.B(k(this.j,e.$NR.DROP,x=>{this.f=0,this.g=0,this.m.onDrop?.(x)}))}}e.$kS=qi;const Qi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Ki(Q,...x){let te,fe;Array.isArray(x[0])?(te={},fe=x[0]):(te=x[0]||{},fe=x[1]);const Se=Qi.exec(Q);if(!Se||!Se.groups)throw new Error("Bad use of h");const He=Se.groups.tag||"div",Pe=document.createElement(He);Se.groups.id&&(Pe.id=Se.groups.id);const Ve=[];if(Se.groups.class)for(const xe of Se.groups.class.split("."))xe!==""&&Ve.push(xe);if(te.className!==void 0)for(const xe of te.className.split("."))xe!==""&&Ve.push(xe);Ve.length>0&&(Pe.className=Ve.join(" "));const Ke={};if(Se.groups.name&&(Ke[Se.groups.name]=Pe),fe)for(const xe of fe)xe instanceof HTMLElement?Pe.appendChild(xe):typeof xe=="string"?Pe.append(xe):"root"in xe&&(Object.assign(Ke,xe),Pe.appendChild(xe.root));for(const[xe,at]of Object.entries(te))if(xe!=="className")if(xe==="style")for(const[Nt,Bt]of Object.entries(at))Pe.style.setProperty(ei(Nt),typeof Bt=="number"?Bt+"px":""+Bt);else xe==="tabIndex"?Pe.tabIndex=at:Pe.setAttribute(ei(xe),at.toString());return Ke.root=Pe,Ke}e.h=Ki;function ei(Q){return Q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(Q,x,te){for(const{name:fe,value:Se}of Q.attributes)(!te||te.includes(fe))&&x.setAttribute(fe,Se)}e.$mS=ti;function xi(Q,x,te){const fe=Q.getAttribute(te);fe?x.setAttribute(te,fe):x.removeAttribute(te)}function Gi(Q,x,te){ti(Q,x,te);const fe=new w.$Sc;return fe.add(e.$ER.observe(Q,fe,{attributes:!0,attributeFilter:te})(Se=>{for(const He of Se)He.type==="attributes"&&He.attributeName&&xi(Q,x,He.attributeName)})),fe}e.$nS=Gi}),define(me[57],$e([1,0,2,3,121]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qS=e.$pS=e.$oS=void 0;class W extends C.$Tc{constructor($,p){super(),this.B((0,i.$TQ)($,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{p(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,i.$TQ)($,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}e.$oS=W,e.$pS={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:j.$us.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(y,$,p,w,B){const f=document.createElement("div");if(f.className=p,f.textContent=$,B&&(f.style.color=B),w&&(f.style.background=w),y.dataTransfer){const d=(0,i.getWindow)(y).document;d.body.appendChild(f),y.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>d.body.removeChild(f),0)}}e.$qS=D}),define(me[58],$e([1,0,2]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XS=e.$WS=e.$VS=void 0;function C(f,d={}){const t=W(d);return t.textContent=f,t}e.$VS=C;function j(f,d={}){const t=W(d);return $(t,p(f,!!d.renderCodeSegments),d.actionHandler,d.renderCodeSegments),t}e.$WS=j;function W(f){const d=f.inline?"span":"div",t=document.createElement(d);return f.className&&(t.className=f.className),t}e.$XS=W;class D{constructor(d){this.b=d,this.c=0}eos(){return this.c>=this.b.length}next(){const d=this.peek();return this.advance(),d}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(f){f[f.Invalid=0]="Invalid",f[f.Root=1]="Root",f[f.Text=2]="Text",f[f.Bold=3]="Bold",f[f.Italics=4]="Italics",f[f.Action=5]="Action",f[f.ActionClose=6]="ActionClose",f[f.Code=7]="Code",f[f.NewLine=8]="NewLine"})(y||(y={}));function $(f,d,t,s){let a;if(d.type===2)a=document.createTextNode(d.content||"");else if(d.type===3)a=document.createElement("b");else if(d.type===4)a=document.createElement("i");else if(d.type===7&&s)a=document.createElement("code");else if(d.type===5&&t){const m=document.createElement("a");t.disposables.add(i.$UQ(m,"click",u=>{t.callback(String(d.index),u)})),a=m}else d.type===8?a=document.createElement("br"):d.type===1&&(a=f);a&&f!==a&&f.appendChild(a),a&&Array.isArray(d.children)&&d.children.forEach(m=>{$(a,m,t,s)})}function p(f,d){const t={type:1,children:[]};let s=0,a=t;const m=[],u=new D(f);for(;!u.eos();){let k=u.next();const l=k==="\\"&&B(u.peek(),d)!==0;if(l&&(k=u.next()),!l&&w(k,d)&&k===u.peek()){u.advance(),a.type===2&&(a=m.pop());const b=B(k,d);if(a.type===b||a.type===5&&b===6)a=m.pop();else{const r={type:b,children:[]};b===5&&(r.index=s,s++),a.children.push(r),m.push(a),a=r}}else if(k===`
`)a.type===2&&(a=m.pop()),a.children.push({type:8});else if(a.type!==2){const b={type:2,content:k};a.children.push(b),m.push(a),a=b}else a.content+=k}return a.type===2&&(a=m.pop()),m.length,t}function w(f,d){return B(f,d)!==0}function B(f,d){switch(f){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return d?7:0;default:return 0}}}),define(me[59],$e([1,0,2,3]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uS=void 0;class j{constructor(){this.a=new C.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const $=this.c;this.c=null,D&&$&&$(y)}isMonitoring(){return!!this.b}startMonitoring(D,y,$,p,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=p,this.c=w;let B=D;try{D.setPointerCapture(y),this.a.add((0,C.$Rc)(()=>{try{D.releasePointerCapture(y)}catch{}}))}catch{B=i.getWindow(D)}this.a.add(i.$TQ(B,i.$NR.POINTER_MOVE,f=>{if(f.buttons!==$){this.stopMonitoring(!0);return}f.preventDefault(),this.b(f)})),this.a.add(i.$TQ(B,i.$NR.POINTER_UP,f=>this.stopMonitoring(!0)))}}e.$uS=j});var Je=this&&this.__decorate||function(re,e,i,C){var j=arguments.length,W=j<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,i):C,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(re,e,i,C);else for(var y=re.length-1;y>=0;y--)(D=re[y])&&(W=(j<3?D(W):j>3?D(e,i,W):D(e,i))||W);return j>3&&W&&Object.defineProperty(e,i,W),W};define(me[26],$e([1,0,2,22,12,28,4,3,49]),function(re,e,i,C,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rS=e.EventType=void 0;var p;(function(B){B.Tap="-monaco-gesturetap",B.Change="-monaco-gesturechange",B.Start="-monaco-gesturestart",B.End="-monaco-gesturesend",B.Contextmenu="-monaco-gesturecontextmenu"})(p||(e.EventType=p={}));class w extends y.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new $.$4c,this.h=new $.$4c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(i.onDidRegisterWindow,({window:f,disposables:d})=>{d.add(i.$TQ(f.document,"touchstart",t=>this.s(t),{passive:!1})),d.add(i.$TQ(f.document,"touchend",t=>this.u(f,t))),d.add(i.$TQ(f.document,"touchmove",t=>this.D(t),{passive:!1}))},{window:C.$mQ,disposables:this.q}))}static addTarget(f){if(!w.isTouchDevice())return y.$Tc.None;w.b||(w.b=(0,y.$Mc)(new w));const d=w.b.g.push(f);return(0,y.$Rc)(d)}static ignoreTarget(f){if(!w.isTouchDevice())return y.$Tc.None;w.b||(w.b=(0,y.$Mc)(new w));const d=w.b.h.push(f);return(0,y.$Rc)(d)}static isTouchDevice(){return"ontouchstart"in C.$mQ||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(f){const d=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let t=0,s=f.targetTouches.length;t<s;t++){const a=f.targetTouches.item(t);this.m[a.identifier]={id:a.identifier,initialTarget:a.target,initialTimeStamp:d,initialPageX:a.pageX,initialPageY:a.pageY,rollingTimestamps:[d],rollingPageX:[a.pageX],rollingPageY:[a.pageY]};const m=this.w(p.Start,a.target);m.pageX=a.pageX,m.pageY=a.pageY,this.z(m)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}u(f,d){const t=Date.now(),s=Object.keys(this.m).length;for(let a=0,m=d.changedTouches.length;a<m;a++){const u=d.changedTouches.item(a);if(!this.m.hasOwnProperty(String(u.identifier))){console.warn("move of an UNKNOWN touch",u);continue}const k=this.m[u.identifier],l=Date.now()-k.initialTimeStamp;if(l<w.c&&Math.abs(k.initialPageX-j.$sb(k.rollingPageX))<30&&Math.abs(k.initialPageY-j.$sb(k.rollingPageY))<30){const b=this.w(p.Tap,k.initialTarget);b.pageX=j.$sb(k.rollingPageX),b.pageY=j.$sb(k.rollingPageY),this.z(b)}else if(l>=w.c&&Math.abs(k.initialPageX-j.$sb(k.rollingPageX))<30&&Math.abs(k.initialPageY-j.$sb(k.rollingPageY))<30){const b=this.w(p.Contextmenu,k.initialTarget);b.pageX=j.$sb(k.rollingPageX),b.pageY=j.$sb(k.rollingPageY),this.z(b)}else if(s===1){const b=j.$sb(k.rollingPageX),r=j.$sb(k.rollingPageY),A=j.$sb(k.rollingTimestamps)-k.rollingTimestamps[0],R=b-k.rollingPageX[0],I=r-k.rollingPageY[0],O=[...this.g].filter(z=>k.initialTarget instanceof Node&&z.contains(k.initialTarget));this.C(f,O,t,Math.abs(R)/A,R>0?1:-1,b,Math.abs(I)/A,I>0?1:-1,r)}this.z(this.w(p.End,k.initialTarget)),delete this.m[u.identifier]}this.f&&(d.preventDefault(),d.stopPropagation(),this.f=!1)}w(f,d){const t=document.createEvent("CustomEvent");return t.initEvent(f,!1,!0),t.initialTarget=d,t.tapCount=0,t}z(f){if(f.type===p.Tap){const d=new Date().getTime();let t=0;d-this.n>w.r?t=1:t=2,this.n=d,f.tapCount=t}else(f.type===p.Change||f.type===p.Contextmenu)&&(this.n=0);if(f.initialTarget instanceof Node){for(const d of this.h)if(d.contains(f.initialTarget))return;for(const d of this.g)d.contains(f.initialTarget)&&(d.dispatchEvent(f),this.f=!0)}}C(f,d,t,s,a,m,u,k,l){this.j=i.$4Q(f,()=>{const b=Date.now(),r=b-t;let A=0,R=0,I=!0;s+=w.a*r,u+=w.a*r,s>0&&(I=!1,A=a*s*r),u>0&&(I=!1,R=k*u*r);const O=this.w(p.Change);O.translationX=A,O.translationY=R,d.forEach(z=>z.dispatchEvent(O)),I||this.C(f,d,b,s,a,m+A,u,k,l+R)})}D(f){const d=Date.now();for(let t=0,s=f.changedTouches.length;t<s;t++){const a=f.changedTouches.item(t);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("end of an UNKNOWN touch",a);continue}const m=this.m[a.identifier],u=this.w(p.Change,m.initialTarget);u.translationX=a.pageX-j.$sb(m.rollingPageX),u.translationY=a.pageY-j.$sb(m.rollingPageY),u.pageX=a.pageX,u.pageY=a.pageY,this.z(u),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(a.pageX),m.rollingPageY.push(a.pageY),m.rollingTimestamps.push(d)}this.f&&(f.preventDefault(),f.stopPropagation(),this.f=!1)}}e.$rS=w,Je([W.$Kh],w,"isTouchDevice",null)}),define(me[60],$e([1,0,2,96]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=e.$1S=e.$ZS=void 0;const C=2e4;let j,W,D,y,$;function p(d){j=document.createElement("div"),j.className="monaco-aria-container";const t=()=>{const a=document.createElement("div");return a.className="monaco-alert",a.setAttribute("role","alert"),a.setAttribute("aria-atomic","true"),j.appendChild(a),a};W=t(),D=t();const s=()=>{const a=document.createElement("div");return a.className="monaco-status",a.setAttribute("aria-live","polite"),a.setAttribute("aria-atomic","true"),j.appendChild(a),a};y=s(),$=s(),d.appendChild(j)}e.$ZS=p;function w(d){j&&(W.textContent!==d?(i.$SQ(D),f(W,d)):(i.$SQ(W),f(D,d)))}e.$1S=w;function B(d){j&&(y.textContent!==d?(i.$SQ($),f(y,d)):(i.$SQ(y),f($,d)))}e.$2S=B;function f(d,t){i.$SQ(d),t.length>C&&(t=t.substr(0,C)),d.textContent=t,d.style.visibility="hidden",d.style.visibility="visible"}}),define(me[123],$e([1,0,2,19]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tT=e.$sT=void 0;const j=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(y){const $=new Array;let p,w=0,B=0;for(;(p=j.exec(y))!==null;){B=p.index||0,w<B&&$.push(y.substring(w,B)),w=(p.index||0)+p[0].length;const[,f,d]=p;$.push(f?`$(${d})`:D({id:d}))}return w<y.length&&$.push(y.substring(w)),$}e.$sT=W;function D(y){const $=i.$("span");return $.classList.add(...C.ThemeIcon.asClassNameArray(y)),$}e.$tT=D}),define(me[124],$e([1,0,2]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8S=void 0;function C(W){try{W.parentElement?.removeChild(W)}catch{}}class j{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let y=this.h(D).pop(),$=!1;if(y)$=this.b.has(y.domNode),$&&this.b.delete(y.domNode);else{const p=(0,i.$)(".monaco-list-row"),B=this.i(D).renderTemplate(p);y={domNode:p,templateId:D,templateData:B}}return{row:y,isReusingConnectedDomNode:$}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(D){const{domNode:y,templateId:$}=D;y&&(this.c?this.b.add(y):this.g(y)),this.h($).push(D)}g(D){D.classList.remove("scrolling"),C(D)}h(D){let y=this.a.get(D);return y||(y=[],this.a.set(D,y)),y}dispose(){this.a.forEach((D,y)=>{for(const $ of D)this.i(y).disposeTemplate($.templateData),$.templateData=null}),this.a.clear(),this.b.clear()}i(D){const y=this.d.get(D);if(!y)throw new Error(`No renderer found for ${D}`);return y}}e.$8S=j}),define(me[125],$e([1,0,9,3]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zS=void 0;class j extends C.$Tc{constructor(D,y,$){super(),this.a=D,this.b=y,this.c=$,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new i.$qh)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}e.$zS=j}),define(me[126],$e([1,0,2,26,12,4,3,5]),function(re,e,i,C,j,W,D,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AT=void 0;class $ extends D.$Tc{constructor(w,B,f,d){super(),this.f=0,this.b=d||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.$6d),this.h=f,this.j(),this.setOptions(w,B)}j(){this.B(C.$rS.addTarget(this.a)),[C.EventType.Tap].forEach(w=>{this.B(i.$TQ(this.a,w,B=>{this.a.focus()}))}),this.B(i.$UQ(this.a,"click",w=>{i.$PR.stop(w,!0)})),this.B(i.$UQ(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(i.$UQ(this.a,"keydown",w=>{let B=!1;y.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(B=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(B=!0),B&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,B){(!this.c||!j.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((f,d)=>{this.a.add(this.m(f.text,d,f.isDisabled))})),B!==void 0&&this.select(B)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,B,f){const d=document.createElement("option");return d.value=w,d.text=w,d.disabled=!!f,d}}e.$AT=$}),define(me[61],$e([1,0,27,12,9,53,90,4,29]),function(re,e,i,C,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0U=e.$9U=e.$8U=void 0;function p(d){return typeof d=="object"&&"visibility"in d&&"data"in d}e.$8U=p;function w(d){switch(d){case!0:return 1;case!1:return 0;default:return d}}e.$9U=w;function B(d){return typeof d.collapsible=="boolean"}class f{constructor(t,s,a,m={}){this.o=t,this.p=s,this.rootRef=[],this.d=new y.$be,this.f=new y.$6d,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.$6d,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.$6d,this.onDidSplice=this.l.event,this.m=new j.$dh(W.$3d),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:a,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(t,s,a=$.Iterable.empty(),m={}){if(t.length===0)throw new i.$6U(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,t,s,a,m):this.s(t,s,a,m)}q(t,s,a,m=$.Iterable.empty(),u,k=u.diffDepth??0){const{parentNode:l}=this.G(s);if(!l.lastDiffIds)return this.s(s,a,m,u);const b=[...m],r=s[s.length-1],A=new D.$dt({getElements:()=>l.lastDiffIds},{getElements:()=>[...l.children.slice(0,r),...b,...l.children.slice(r+a)].map(v=>t.getId(v.element).toString())}).ComputeDiff(!1);if(A.quitEarly)return l.lastDiffIds=void 0,this.s(s,a,b,u);const R=s.slice(0,-1),I=(v,H,V)=>{if(k>0)for(let S=0;S<V;S++)v--,H--,this.q(t,[...R,v,0],Number.MAX_SAFE_INTEGER,b[H].children,u,k-1)};let O=Math.min(l.children.length,r+a),z=b.length;for(const v of A.changes.sort((H,V)=>V.originalStart-H.originalStart))I(O,z,O-(v.originalStart+v.originalLength)),O=v.originalStart,z=v.modifiedStart-r,this.s([...R,O],v.originalLength,$.Iterable.slice(b,z,z+v.modifiedLength),u);I(O,z,O)}s(t,s,a=$.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:u,diffIdentityProvider:k}){const{parentNode:l,listIndex:b,revealed:r,visible:A}=this.G(t),R=[],I=$.Iterable.map(a,X=>this.w(X,l,l.visible?1:0,r,R,m)),O=t[t.length-1];let z=0;for(let X=O;X>=0&&X<l.children.length;X--){const U=l.children[X];if(U.visible){z=U.visibleChildIndex;break}}const v=[];let H=0,V=0;for(const X of I)v.push(X),V+=X.renderNodeCount,X.visible&&(X.visibleChildIndex=z+H++);const S=(0,C.$6b)(l.children,O,s,v);k?l.lastDiffIds?(0,C.$6b)(l.lastDiffIds,O,s,v.map(X=>k.getId(X.element).toString())):l.lastDiffIds=l.children.map(X=>k.getId(X.element).toString()):l.lastDiffIds=void 0;let L=0;for(const X of S)X.visible&&L++;if(L!==0)for(let X=O+v.length;X<l.children.length;X++){const U=l.children[X];U.visible&&(U.visibleChildIndex-=L)}if(l.visibleChildrenCount+=H-L,r&&A){const X=S.reduce((U,de)=>U+(de.visible?de.renderNodeCount:0),0);this.B(l,V-X),this.p.splice(b,X,R)}if(S.length>0&&u){const X=U=>{u(U),U.children.forEach(X)};S.forEach(X)}this.l.fire({insertedNodes:v,deletedNodes:S});let M=l;for(;M;){if(M.visibility===2){this.m.trigger(()=>this.refilter());break}M=M.parent}}rerender(t){if(t.length===0)throw new i.$6U(this.o,"Invalid tree location");const{node:s,listIndex:a,revealed:m}=this.F(t);s.visible&&m&&this.p.splice(a,1,[s])}updateElementHeight(t,s){if(t.length===0)throw new i.$6U(this.o,"Invalid tree location");const{listIndex:a}=this.F(t);this.p.updateElementHeight(a,s)}has(t){return this.D(t)}getListIndex(t){const{listIndex:s,visible:a,revealed:m}=this.F(t);return a&&m?s:-1}getListRenderCount(t){return this.E(t).renderNodeCount}isCollapsible(t){return this.E(t).collapsible}setCollapsible(t,s){const a=this.E(t);typeof s>"u"&&(s=!a.collapsible);const m={collapsible:s};return this.d.bufferEvents(()=>this.t(t,m))}isCollapsed(t){return this.E(t).collapsed}setCollapsed(t,s,a){const m=this.E(t);typeof s>"u"&&(s=!m.collapsed);const u={collapsed:s,recursive:a||!1};return this.d.bufferEvents(()=>this.t(t,u))}t(t,s){const{node:a,listIndex:m,revealed:u}=this.F(t),k=this.u(a,m,u,s);if(a!==this.c&&this.k&&k&&!B(s)&&a.collapsible&&!a.collapsed&&!s.recursive){let l=-1;for(let b=0;b<a.children.length;b++)if(a.children[b].visible)if(l>-1){l=-1;break}else l=b;l>-1&&this.t([...t,l],s)}return k}u(t,s,a,m){const u=this.v(t,m,!1);if(!a||!t.visible||!u)return u;const k=t.renderNodeCount,l=this.x(t),b=k-(s===-1?0:1);return this.p.splice(s+1,b,l.slice(1)),u}v(t,s,a){let m;if(t===this.c?m=!1:(B(s)?(m=t.collapsible!==s.collapsible,t.collapsible=s.collapsible):t.collapsible?(m=t.collapsed!==s.collapsed,t.collapsed=s.collapsed):m=!1,m&&this.f.fire({node:t,deep:a})),!B(s)&&s.recursive)for(const u of t.children)m=this.v(u,s,!0)||m;return m}expandTo(t){this.d.bufferEvents(()=>{let s=this.E(t);for(;s.parent;)s=s.parent,t=t.slice(0,t.length-1),s.collapsed&&this.t(t,{collapsed:!1,recursive:!1})})}refilter(){const t=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,t,s),this.m.cancel()}w(t,s,a,m,u,k){const l={parent:s,element:t.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof t.collapsible=="boolean"?t.collapsible:typeof t.collapsed<"u",collapsed:typeof t.collapsed>"u"?this.h:t.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.C(l,a);l.visibility=b,m&&u.push(l);const r=t.children||$.Iterable.empty(),A=m&&b!==0&&!l.collapsed;let R=0,I=1;for(const O of r){const z=this.w(O,l,b,A,u,k);l.children.push(z),I+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=R++)}return l.collapsible=l.collapsible||l.children.length>0,l.visibleChildrenCount=R,l.visible=b===2?R>0:b===1,l.visible?l.collapsed||(l.renderNodeCount=I):(l.renderNodeCount=0,m&&u.pop()),k?.(l),l}x(t){const s=t.renderNodeCount,a=[];return this.y(t,a),this.B(t.parent,a.length-s),a}y(t,s){if(t.visible===!1)return 0;if(s.push(t),t.renderNodeCount=1,!t.collapsed)for(const a of t.children)t.renderNodeCount+=this.y(a,s);return this.g.fire(t),t.renderNodeCount}z(t){const s=t.renderNodeCount,a=[];return this.A(t,t.visible?1:0,a),this.B(t.parent,a.length-s),a}A(t,s,a,m=!0){let u;if(t!==this.c){if(u=this.C(t,s),u===0)return t.visible=!1,t.renderNodeCount=0,!1;m&&a.push(t)}const k=a.length;t.renderNodeCount=t===this.c?0:1;let l=!1;if(!t.collapsed||u!==0){let b=0;for(const r of t.children)l=this.A(r,u,a,m&&!t.collapsed)||l,r.visible&&(r.visibleChildIndex=b++);t.visibleChildrenCount=b}else t.visibleChildrenCount=0;return t!==this.c&&(t.visible=u===2?l:u===1,t.visibility=u),t.visible?t.collapsed||(t.renderNodeCount+=a.length-k):(t.renderNodeCount=0,m&&a.pop()),this.g.fire(t),t.visible}B(t,s){if(s!==0)for(;t;)t.renderNodeCount+=s,this.g.fire(t),t=t.parent}C(t,s){const a=this.j?this.j.filter(t.element,s):1;return typeof a=="boolean"?(t.filterData=void 0,a?1:0):p(a)?(t.filterData=a.data,w(a.visibility)):(t.filterData=void 0,w(a))}D(t,s=this.c){if(!t||t.length===0)return!0;const[a,...m]=t;return a<0||a>s.children.length?!1:this.D(m,s.children[a])}E(t,s=this.c){if(!t||t.length===0)return s;const[a,...m]=t;if(a<0||a>s.children.length)throw new i.$6U(this.o,"Invalid tree location");return this.E(m,s.children[a])}F(t){if(t.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:a,revealed:m,visible:u}=this.G(t),k=t[t.length-1];if(k<0||k>s.children.length)throw new i.$6U(this.o,"Invalid tree location");const l=s.children[k];return{node:l,listIndex:a,revealed:m,visible:u&&l.visible}}G(t,s=this.c,a=0,m=!0,u=!0){const[k,...l]=t;if(k<0||k>s.children.length)throw new i.$6U(this.o,"Invalid tree location");for(let b=0;b<k;b++)a+=s.children[b].renderNodeCount;return m=m&&!s.collapsed,u=u&&s.visible,l.length===0?{parentNode:s,listIndex:a,revealed:m,visible:u}:this.G(l,s.children[k],a+1,m,u)}getNode(t=[]){return this.E(t)}getNodeLocation(t){const s=[];let a=t;for(;a.parent;)s.push(a.parent.children.indexOf(a)),a=a.parent;return s.reverse()}getParentNodeLocation(t){if(t.length!==0)return t.length===1?[]:(0,C.$tb)(t)[0]}getFirstElementChild(t){const s=this.E(t);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(t=[]){const s=this.E(t);if(s.children.length!==0)return this.H(s)}H(t){return t.children.length===0?t.element:this.H(t.children[t.children.length-1])}}e.$0U=f}),define(me[127],$e([1,0,61,27,29]),function(re,e,i,C,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eV=void 0;class W{get size(){return this.d.size}constructor(y,$,p={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new i.$0U(y,$,null,p),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,p.sorter&&(this.j={compare(w,B){return p.sorter.compare(w.element,B.element)}}),this.h=p.identityProvider}setChildren(y,$=j.Iterable.empty(),p={}){const w=this.o(y);this.l(w,this.m($),p)}l(y,$=j.Iterable.empty(),p){const w=new Set,B=new Set,f=t=>{if(t.element===null)return;const s=t;if(w.add(s.element),this.d.set(s.element,s),this.h){const a=this.h.getId(s.element).toString();B.add(a),this.f.set(a,s)}p.onDidCreateNode?.(s)},d=t=>{if(t.element===null)return;const s=t;if(w.has(s.element)||this.d.delete(s.element),this.h){const a=this.h.getId(s.element).toString();B.has(a)||this.f.delete(a)}p.onDidDeleteNode?.(s)};this.c.splice([...y,0],Number.MAX_VALUE,$,{...p,onDidCreateNode:f,onDidDeleteNode:d})}m(y=j.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),j.Iterable.map(y,$=>{let p=this.d.get($.element);if(!p&&this.h){const f=this.h.getId($.element).toString();p=this.f.get(f)}if(!p){let f;return typeof $.collapsed>"u"?f=void 0:$.collapsed===C.ObjectTreeElementCollapseState.Collapsed||$.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?f=!0:$.collapsed===C.ObjectTreeElementCollapseState.Expanded||$.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?f=!1:f=!!$.collapsed,{...$,children:this.m($.children),collapsed:f}}const w=typeof $.collapsible=="boolean"?$.collapsible:p.collapsible;let B;return typeof $.collapsed>"u"||$.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||$.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?B=p.collapsed:$.collapsed===C.ObjectTreeElementCollapseState.Collapsed?B=!0:$.collapsed===C.ObjectTreeElementCollapseState.Expanded?B=!1:B=!!$.collapsed,{...$,collapsible:w,collapsed:B,children:this.m($.children)}})}rerender(y){const $=this.o(y);this.c.rerender($)}updateElementHeight(y,$){const p=this.o(y);this.c.updateElementHeight(p,$)}resort(y=null,$=!0){if(!this.j)return;const p=this.o(y),w=this.c.getNode(p);this.l(p,this.n(w,$),{})}n(y,$,p=!0){let w=[...y.children];return($||p)&&(w=w.sort(this.j.compare.bind(this.j))),j.Iterable.map(w,B=>({element:B.element,collapsible:B.collapsible,collapsed:B.collapsed,children:this.n(B,$,!1)}))}getFirstElementChild(y=null){const $=this.o(y);return this.c.getFirstElementChild($)}getLastElementAncestor(y=null){const $=this.o(y);return this.c.getLastElementAncestor($)}has(y){return this.d.has(y)}getListIndex(y){const $=this.o(y);return this.c.getListIndex($)}getListRenderCount(y){const $=this.o(y);return this.c.getListRenderCount($)}isCollapsible(y){const $=this.o(y);return this.c.isCollapsible($)}setCollapsible(y,$){const p=this.o(y);return this.c.setCollapsible(p,$)}isCollapsed(y){const $=this.o(y);return this.c.isCollapsed($)}setCollapsed(y,$,p){const w=this.o(y);return this.c.setCollapsed(w,$,p)}expandTo(y){const $=this.o(y);this.c.expandTo($)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const $=this.d.get(y);if(!$)throw new C.$6U(this.k,`Tree element not found: ${y}`);return $}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new C.$6U(this.k,"Invalid getParentNodeLocation call");const $=this.d.get(y);if(!$)throw new C.$6U(this.k,`Tree element not found: ${y}`);const p=this.c.getNodeLocation($),w=this.c.getParentNodeLocation(p);return this.c.getNode(w).element}o(y){if(y===null)return[];const $=this.d.get(y);if(!$)throw new C.$6U(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation($)}}e.$eV=W}),define(me[21],$e([1,0,2,14,20,26,3]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=void 0;class y extends D.$Tc{f(p,w){this.B(i.$TQ(p,i.$NR.CLICK,B=>w(new j.$LQ(i.getWindow(p),B))))}j(p,w){this.B(i.$TQ(p,i.$NR.MOUSE_DOWN,B=>w(new j.$LQ(i.getWindow(p),B))))}m(p,w){this.B(i.$TQ(p,i.$NR.MOUSE_OVER,B=>w(new j.$LQ(i.getWindow(p),B))))}u(p,w){this.B(i.$TQ(p,i.$NR.MOUSE_LEAVE,B=>w(new j.$LQ(i.getWindow(p),B))))}z(p,w){this.B(i.$TQ(p,i.$NR.KEY_DOWN,B=>w(new C.$QQ(B))))}C(p,w){this.B(i.$TQ(p,i.$NR.KEY_UP,B=>w(new C.$QQ(B))))}D(p,w){this.B(i.$TQ(p,i.$NR.INPUT,w))}F(p,w){this.B(i.$TQ(p,i.$NR.BLUR,w))}G(p,w){this.B(i.$TQ(p,i.$NR.FOCUS,w))}H(p,w){this.B(i.$TQ(p,i.$NR.CHANGE,w))}I(p){return W.$rS.ignoreTarget(p)}}e.$vS=y}),define(me[41],$e([1,0,59,21,9,19,2]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=e.$wS=void 0,e.$wS=11;class y extends C.$vS{constructor(p){super(),this.a=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top<"u"&&(this.bgDomNode.style.top="0px"),typeof p.left<"u"&&(this.bgDomNode.style.left="0px"),typeof p.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof p.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(p.icon)),this.domNode.style.position="absolute",this.domNode.style.width=e.$wS+"px",this.domNode.style.height=e.$wS+"px",typeof p.top<"u"&&(this.domNode.style.top=p.top+"px"),typeof p.left<"u"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom<"u"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right<"u"&&(this.domNode.style.right=p.right+"px"),this.g=this.B(new i.$uS),this.B(D.$UQ(this.bgDomNode,D.$NR.POINTER_DOWN,w=>this.h(w))),this.B(D.$UQ(this.domNode,D.$NR.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new D.$6Q),this.c=this.B(new j.$qh)}h(p){if(!p.target||!(p.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,D.getWindow(p))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring(p.target,p.pointerId,p.buttons,B=>{},()=>{this.b.cancel(),this.c.cancel()}),p.preventDefault()}}e.$xS=y}),define(me[62],$e([1,0,2,45,59,41,125,21,5]),function(re,e,i,C,j,W,D,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=void 0;const p=140;class w extends y.$vS{constructor(f){super(),this.g=f.lazyRender,this.a=f.host,this.b=f.scrollable,this.c=f.scrollByPage,this.h=f.scrollbarState,this.n=this.B(new D.$zS(f.visibility,"visible scrollbar "+f.extraScrollbarClassName,"invisible scrollbar "+f.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new j.$uS),this.s=!0,this.domNode=(0,C.$tS)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(i.$TQ(this.domNode.domNode,i.$NR.POINTER_DOWN,d=>this.M(d)))}t(f){const d=this.B(new W.$xS(f));this.domNode.domNode.appendChild(d.bgDomNode),this.domNode.domNode.appendChild(d.domNode)}w(f,d,t,s){this.slider=(0,C.$tS)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(f),this.slider.setLeft(d),typeof t=="number"&&this.slider.setWidth(t),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(i.$TQ(this.slider.domNode,i.$NR.POINTER_DOWN,a=>{a.button===0&&(a.preventDefault(),this.O(a))})),this.f(this.slider.domNode,a=>{a.leftButton&&a.stopPropagation()})}y(f){return this.h.setVisibleSize(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(f){return this.h.setScrollSize(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(f){return this.h.setScrollPosition(f)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(f){f.target===this.domNode.domNode&&this.N(f)}delegatePointerDown(f){const d=this.domNode.domNode.getClientRects()[0].top,t=d+this.h.getSliderPosition(),s=d+this.h.getSliderPosition()+this.h.getSliderSize(),a=this.U(f);t<=a&&a<=s?f.button===0&&(f.preventDefault(),this.O(f)):this.N(f)}N(f){let d,t;if(f.target===this.domNode.domNode&&typeof f.offsetX=="number"&&typeof f.offsetY=="number")d=f.offsetX,t=f.offsetY;else{const a=i.$dR(this.domNode.domNode);d=f.pageX-a.left,t=f.pageY-a.top}const s=this.S(d,t);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),f.button===0&&(f.preventDefault(),this.O(f))}O(f){if(!f.target||!(f.target instanceof Element))return;const d=this.U(f),t=this.W(f),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(f.target,f.pointerId,f.buttons,a=>{const m=this.W(a),u=Math.abs(m-t);if($.$i&&u>p){this.P(s.getScrollPosition());return}const l=this.U(a)-d;this.P(s.getDesiredScrollPositionFromDelta(l))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(f){const d={};this.writeScrollPosition(d,f),this.b.setScrollPositionNow(d)}updateScrollbarSize(f){this.X(f),this.h.setScrollbarSize(f),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}e.$AS=w}),define(me[128],$e([1,0,20,62,41,46,18]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BS=void 0;class y extends C.$AS{constructor(p,w,B){const f=p.getScrollDimensions(),d=p.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:B,scrollbarState:new W.$yS(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,f.width,f.scrollWidth,d.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const t=(w.arrowSize-j.$wS)/2,s=(w.horizontalScrollbarSize-j.$wS)/2;this.t({className:"scra",icon:D.$pk.scrollbarButtonLeft,top:s,left:t,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$NQ(null,1,0))}),this.t({className:"scra",icon:D.$pk.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:t,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new i.$NQ(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R(p,w){this.slider.setWidth(p),this.slider.setLeft(w)}Q(p,w){this.domNode.setWidth(p),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,w){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,w){p.scrollLeft=w}updateOptions(p){this.updateScrollbarSize(p.horizontal===2?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}e.$BS=y}),define(me[129],$e([1,0,20,62,41,46,18]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CS=void 0;class y extends C.$AS{constructor(p,w,B){const f=p.getScrollDimensions(),d=p.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:B,scrollbarState:new W.$yS(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,f.height,f.scrollHeight,d.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const t=(w.arrowSize-j.$wS)/2,s=(w.verticalScrollbarSize-j.$wS)/2;this.t({className:"scra",icon:D.$pk.scrollbarButtonUp,top:t,left:s,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$NQ(null,0,1))}),this.t({className:"scra",icon:D.$pk.scrollbarButtonDown,top:void 0,left:s,bottom:t,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new i.$NQ(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R(p,w){this.slider.setHeight(p),this.slider.setTop(w)}Q(p,w){this.domNode.setWidth(w),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,w){return w}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,w){p.scrollTop=w}updateOptions(p){this.updateScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}e.$CS=y}),define(me[63],$e([1,0,17,2,45,20,128,129,21,9,4,3,5,51,103]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HS=e.$GS=e.$FS=e.$ES=e.$DS=void 0;const t=500,s=50,a=!0;class m{constructor(I,O,z){this.timestamp=I,this.deltaX=O,this.deltaY=z,this.score=0}}class u{static{this.INSTANCE=new u}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let I=1,O=0,z=1,v=this.d;do{const H=v===this.c?I:Math.pow(2,-z);if(I-=H,O+=this.b[v].score*H,v===this.c)break;v=(this.a+v-1)%this.a,z++}while(!0);return O<=.5}acceptStandardWheelEvent(I){if(i.$BQ){const O=C.getWindow(I.browserEvent),z=(0,i.$uQ)(O);this.accept(Date.now(),I.deltaX*z,I.deltaY*z)}else this.accept(Date.now(),I.deltaX,I.deltaY)}accept(I,O,z){const v=new m(I,O,z);v.score=this.f(v),this.c===-1&&this.d===-1?(this.b[0]=v,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=v)}f(I){if(Math.abs(I.deltaX)>0&&Math.abs(I.deltaY)>0)return 1;let O=.5;const z=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(I.deltaX)||!this.g(I.deltaY))&&(O+=.25),Math.min(Math.max(O,0),1)}g(I){return Math.abs(Math.round(I)-I)<.01}}e.$DS=u;class k extends $.$vS{get options(){return this.a}constructor(I,O,z){super(),this.O=this.B(new w.$6d),this.onScroll=this.O.event,this.P=this.B(new w.$6d),this.onWillScroll=this.P.event,I.style.overflow="hidden",this.a=A(O),this.b=z,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const v={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new y.$CS(this.b,this.a,v)),this.g=this.B(new D.$BS(this.b,this.a,v)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(I),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,j.$tS)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,j.$tS)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,j.$tS)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new p.$qh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,B.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(I){this.c.delegatePointerDown(I)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(I){this.b.setScrollDimensions(I,!1)}updateClassName(I){this.a.className=I,f.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(I){typeof I.handleMouseWheel<"u"&&(this.a.handleMouseWheel=I.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof I.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=I.mouseWheelScrollSensitivity),typeof I.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=I.fastScrollSensitivity),typeof I.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=I.scrollPredominantAxis),typeof I.horizontal<"u"&&(this.a.horizontal=I.horizontal),typeof I.vertical<"u"&&(this.a.vertical=I.vertical),typeof I.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=I.horizontalScrollbarSize),typeof I.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=I.verticalScrollbarSize),typeof I.scrollByPage<"u"&&(this.a.scrollByPage=I.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(I){this.N=I}delegateScrollFromMouseWheelEvent(I){this.R(new W.$NQ(I))}Q(I){if(this.w.length>0!==I&&(this.w=(0,B.$Oc)(this.w),I)){const z=v=>{this.R(new W.$NQ(v))};this.w.push(C.$TQ(this.t,C.$NR.MOUSE_WHEEL,z,{passive:!1}))}}R(I){if(I.browserEvent?.defaultPrevented)return;const O=u.INSTANCE;a&&O.acceptStandardWheelEvent(I);let z=!1;if(I.deltaY||I.deltaX){let H=I.deltaY*this.a.mouseWheelScrollSensitivity,V=I.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+H===0?V=H=0:Math.abs(H)>=Math.abs(V)?V=0:H=0),this.a.flipAxes&&([H,V]=[V,H]);const S=!f.$j&&I.browserEvent&&I.browserEvent.shiftKey;(this.a.scrollYToX||S)&&!V&&(V=H,H=0),I.browserEvent&&I.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const L=this.b.getFutureScrollPosition();let M={};if(H){const X=s*H,U=L.scrollTop-(X<0?Math.floor(X):Math.ceil(X));this.c.writeScrollPosition(M,U)}if(V){const X=s*V,U=L.scrollLeft-(X<0?Math.floor(X):Math.ceil(X));this.g.writeScrollPosition(M,U)}M=this.b.validateScrollPosition(M),(L.scrollLeft!==M.scrollLeft||L.scrollTop!==M.scrollTop)&&(a&&this.a.mouseWheelSmoothScroll&&O.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(M):this.b.setScrollPositionNow(M),z=!0)}let v=z;!v&&this.a.alwaysConsumeMouseWheel&&(v=!0),!v&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(v=!0),v&&(I.preventDefault(),I.stopPropagation())}S(I){this.M=this.g.onDidScroll(I)||this.M,this.M=this.c.onDidScroll(I)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const I=this.b.getCurrentScrollPosition(),O=I.scrollTop>0,z=I.scrollLeft>0,v=z?" left":"",H=O?" top":"",V=z||O?" top-left-corner":"";this.n.setClassName(`shadow${v}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${V}${H}${v}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(I){this.J=!1,this.ab()}Z(I){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),t)}}e.$ES=k;class l extends k{constructor(I,O){O=O||{},O.mouseWheelSmoothScroll=!1;const z=new d.$As({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>C.$4Q(C.getWindow(I),v)});super(I,O,z),this.B(z)}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$FS=l;class b extends k{constructor(I,O,z){super(I,O,z)}setScrollPosition(I){I.reuseAnimation?this.b.setScrollPositionSmooth(I,I.reuseAnimation):this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}e.$GS=b;class r extends k{constructor(I,O){O=O||{},O.mouseWheelSmoothScroll=!1;const z=new d.$As({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:v=>C.$4Q(C.getWindow(I),v)});super(I,O,z),this.B(z),this.cb=I,this.B(this.onScroll(v=>{v.scrollTopChanged&&(this.cb.scrollTop=v.scrollTop),v.scrollLeftChanged&&(this.cb.scrollLeft=v.scrollLeft)})),this.scanDomNode()}setScrollPosition(I){this.b.setScrollPositionNow(I)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}e.$HS=r;function A(R){const I={lazyRender:typeof R.lazyRender<"u"?R.lazyRender:!1,className:typeof R.className<"u"?R.className:"",useShadows:typeof R.useShadows<"u"?R.useShadows:!0,handleMouseWheel:typeof R.handleMouseWheel<"u"?R.handleMouseWheel:!0,flipAxes:typeof R.flipAxes<"u"?R.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof R.consumeMouseWheelIfScrollbarIsNeeded<"u"?R.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof R.alwaysConsumeMouseWheel<"u"?R.alwaysConsumeMouseWheel:!1,scrollYToX:typeof R.scrollYToX<"u"?R.scrollYToX:!1,mouseWheelScrollSensitivity:typeof R.mouseWheelScrollSensitivity<"u"?R.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof R.fastScrollSensitivity<"u"?R.fastScrollSensitivity:5,scrollPredominantAxis:typeof R.scrollPredominantAxis<"u"?R.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof R.mouseWheelSmoothScroll<"u"?R.mouseWheelSmoothScroll:!0,arrowSize:typeof R.arrowSize<"u"?R.arrowSize:11,listenOnDomNode:typeof R.listenOnDomNode<"u"?R.listenOnDomNode:null,horizontal:typeof R.horizontal<"u"?R.horizontal:1,horizontalScrollbarSize:typeof R.horizontalScrollbarSize<"u"?R.horizontalScrollbarSize:10,horizontalSliderSize:typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:0,horizontalHasArrows:typeof R.horizontalHasArrows<"u"?R.horizontalHasArrows:!1,vertical:typeof R.vertical<"u"?R.vertical:1,verticalScrollbarSize:typeof R.verticalScrollbarSize<"u"?R.verticalScrollbarSize:10,verticalHasArrows:typeof R.verticalHasArrows<"u"?R.verticalHasArrows:!1,verticalSliderSize:typeof R.verticalSliderSize<"u"?R.verticalSliderSize:0,scrollByPage:typeof R.scrollByPage<"u"?R.scrollByPage:!1};return I.horizontalSliderSize=typeof R.horizontalSliderSize<"u"?R.horizontalSliderSize:I.horizontalScrollbarSize,I.verticalSliderSize=typeof R.verticalSliderSize<"u"?R.verticalSliderSize:I.verticalScrollbarSize,f.$j&&(I.className+=" mac"),I}}),define(me[64],$e([1,0,57,2,24,26,63,12,9,28,4,3,50,51,86,124,6,34]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_S=e.$$S=e.$0S=e.$9S=e.ListViewTargetSector=void 0;const u={CurrentDragAndDropData:void 0};var k;(function(z){z[z.TOP=0]="TOP",z[z.CENTER_TOP=1]="CENTER_TOP",z[z.CENTER_BOTTOM=2]="CENTER_BOTTOM",z[z.BOTTOM=3]="BOTTOM"})(k||(e.ListViewTargetSector=k={}));const l={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(z){return[z]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(v){this.d=v}constructor(v){this.elements=v}update(){}getData(){return this.elements}}e.$9S=b;class r{constructor(v){this.elements=v}update(){}getData(){return this.elements}}e.$0S=r;class A{constructor(){this.types=[],this.files=[]}update(v){if(v.types&&this.types.splice(0,this.types.length,...v.types),v.files){this.files.splice(0,this.files.length);for(let H=0;H<v.files.length;H++){const V=v.files.item(H);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}e.$$S=A;function R(z,v){return Array.isArray(z)&&Array.isArray(v)?(0,y.$ub)(z,v):z===v}class I{constructor(v){v?.getSetSize?this.getSetSize=v.getSetSize.bind(v):this.getSetSize=(H,V,S)=>S,v?.getPosInSet?this.getPosInSet=v.getPosInSet.bind(v):this.getPosInSet=(H,V)=>V+1,v?.getRole?this.getRole=v.getRole.bind(v):this.getRole=H=>"listitem",v?.isChecked?this.isChecked=v.isChecked.bind(v):this.isChecked=H=>{}}}class O{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(v){if(v!==this.P){if(v&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=v,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const H of this.d)this.ab(H);this.X(),this.q.setScrollDimensions({width:(0,C.$gR)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(v,H,V,S=l){if(this.R=H,this.domId=`list_id_${++O.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new $.$dh(50),this.v=!1,this.x=B.$Tc.None,this.y=0,this.G=!1,this.K=B.$Tc.None,this.L=B.$Tc.None,this.M=new B.$Sc,this.N=new w.$6d,this.O=new w.$6d,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,S.horizontalScrolling&&S.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(S.paddingTop??0);for(const M of V)this.j.set(M.templateId,M);this.h=this.M.add(new s.$8S(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof S.mouseSupport=="boolean"?S.mouseSupport:!0),this.P=S.horizontalScrolling??l.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof S.paddingBottom>"u"?0:S.paddingBottom,this.D=new I(S.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(S.transformOptimization??l.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(W.$rS.addTarget(this.o)),this.p=this.M.add(new d.$As({forceIntegerValues:!0,smoothScrollDuration:S.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:M=>(0,C.$4Q)((0,C.getWindow)(this.domNode),M)})),this.q=this.M.add(new D.$GS(this.o,{alwaysConsumeMouseWheel:S.alwaysConsumeMouseWheel??l.alwaysConsumeMouseWheel,horizontal:1,vertical:S.verticalScrollMode??l.verticalScrollMode,useShadows:S.useShadows??l.useShadows,mouseWheelScrollSensitivity:S.mouseWheelScrollSensitivity,fastScrollSensitivity:S.fastScrollSensitivity,scrollByPage:S.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),v.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$TQ)(this.o,W.EventType.Change,M=>this.jb(M))),this.M.add((0,C.$TQ)(this.q.getDomNode(),"scroll",M=>M.target.scrollTop=0)),this.M.add((0,C.$TQ)(this.domNode,"dragover",M=>this.lb(this.hb(M)))),this.M.add((0,C.$TQ)(this.domNode,"drop",M=>this.nb(this.hb(M)))),this.M.add((0,C.$TQ)(this.domNode,"dragleave",M=>this.mb(this.hb(M)))),this.M.add((0,C.$TQ)(this.domNode,"dragend",M=>this.ob(M))),this.z=S.setRowLineHeight??l.setRowLineHeight,this.A=S.setRowHeight??l.setRowHeight,this.B=S.supportDynamicHeights??l.supportDynamicHeights,this.F=S.dnd??this.M.add(l.dnd),this.layout(S.initialSize?.height,S.initialSize?.width)}updateOptions(v){v.paddingBottom!==void 0&&(this.C=v.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),v.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(v.smoothScrolling?125:0),v.horizontalScrolling!==void 0&&(this.Q=v.horizontalScrolling);let H;if(v.scrollByPage!==void 0&&(H={...H??{},scrollByPage:v.scrollByPage}),v.mouseWheelScrollSensitivity!==void 0&&(H={...H??{},mouseWheelScrollSensitivity:v.mouseWheelScrollSensitivity}),v.fastScrollSensitivity!==void 0&&(H={...H??{},fastScrollSensitivity:v.fastScrollSensitivity}),H&&this.q.updateOptions(H),v.paddingTop!==void 0&&v.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),S=v.paddingTop-this.g.paddingTop;this.g.paddingTop=v.paddingTop,this.Y(V,Math.max(0,this.k+S),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(v){this.q.delegateScrollFromMouseWheelEvent(v)}delegateVerticalScrollbarPointerDown(v){this.q.delegateVerticalScrollbarPointerDown(v)}updateElementHeight(v,H,V){if(v<0||v>=this.d.length)return;const S=this.d[v].size;if(typeof H>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[v].lastDynamicHeightWidth=void 0,H=S+this.xb(v)}if(S===H)return;const L=this.vb(this.k,this.m);let M=0;v<L.start||V!==null&&V>v&&V<L.end?M=H-S:M=0,this.g.splice(v,1,[{size:H}]),this.d[v].size=H,this.Y(L,Math.max(0,this.k+M),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(v){return new t.$7S(v)}splice(v,H,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(v,H,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(v,H,V=[]){const S=this.vb(this.k,this.m),L={start:v,end:v+H},M=f.Range.intersect(S,L),X=new Map;for(let G=M.end-1;G>=M.start;G--){const ie=this.d[G];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let ce=X.get(ie.templateId);ce||(ce=[],X.set(ie.templateId,ce));const De=this.j.get(ie.templateId);De&&De.disposeElement&&De.disposeElement(ie.element,G,ie.row.templateData,ie.size),ce.push(ie.row)}ie.row=null,ie.stale=!0}const U={start:v+H,end:this.d.length},de=f.Range.intersect(U,S),he=f.Range.relativeComplement(U,S),ne=V.map(G=>({id:String(this.f++),element:G,templateId:this.R.getTemplateId(G),size:this.R.getHeight(G),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(G),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:B.$Tc.None,checkedDisposable:B.$Tc.None,stale:!1}));let ge;v===0&&H>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ne),ge=this.d,this.d=ne):(this.g.splice(v,H,ne),ge=this.d.splice(v,H,...ne));const Fe=V.length-H,Ce=this.vb(this.k,this.m),Be=(0,t.$5S)(de,Fe),le=f.Range.intersect(Ce,Be);for(let G=le.start;G<le.end;G++)this.bb(this.d[G],G);const _=f.Range.relativeComplement(Be,Ce);for(const G of _)for(let ie=G.start;ie<G.end;ie++)this.db(ie);const ae=he.map(G=>(0,t.$5S)(G,Fe)),J=[{start:v,end:v+V.length},...ae].map(G=>f.Range.intersect(Ce,G)).reverse();for(const G of J)for(let ie=G.end-1;ie>=G.start;ie--){const ce=this.d[ie],Ne=X.get(ce.templateId)?.pop();this.Z(ie,Ne)}for(const G of X.values())for(const ie of G)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ge.map(G=>G.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$4Q)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let v=0;for(const H of this.d)typeof H.width<"u"&&(v=Math.max(v,H.width));this.E=v,this.q.setScrollDimensions({scrollWidth:v===0?0:v+10}),this.O.fire(this.E)}updateWidth(v){if(!this.Q||typeof this.E>"u")return;const H=this.d[v];this.ab(H),typeof H.width<"u"&&H.width>this.E&&(this.E=H.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const v of this.d)v.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const v=this.firstVisibleIndex,H=this.g.positionAt(v),V=this.g.positionAt(v+1);return V!==-1&&(V-H)/2+H<this.scrollTop?v+1:v}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(v){return this.d[v].element}indexOf(v){return this.d.findIndex(H=>H.element===v)}domElement(v){const H=this.d[v].row;return H&&H.domNode}elementHeight(v){return this.d[v].size}elementTop(v){return this.g.positionAt(v)}indexAt(v){return this.g.indexAt(v)}indexAfter(v){return this.g.indexAfter(v)}layout(v,H){const V={height:typeof v=="number"?v:(0,C.$iR)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof H<"u"&&(this.n=H,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof H=="number"?H:(0,C.$gR)(this.domNode)})}Y(v,H,V,S,L,M=!1){const X=this.vb(H,V),U=f.Range.relativeComplement(X,v).reverse(),de=f.Range.relativeComplement(v,X);if(M){const he=f.Range.intersect(v,X);for(let ne=he.start;ne<he.end;ne++)this.bb(this.d[ne],ne)}this.h.transact(()=>{for(const he of de)for(let ne=he.start;ne<he.end;ne++)this.db(ne);for(const he of U)for(let ne=he.end-1;ne>=he.start;ne--)this.Z(ne)}),S!==void 0&&(this.o.style.left=`-${S}px`),this.o.style.top=`-${H}px`,this.Q&&L!==void 0&&(this.o.style.width=`${Math.max(L,this.n)}px`),this.k=H,this.m=V}Z(v,H){const V=this.d[v];if(!V.row)if(H)V.row=H,V.stale=!0;else{const U=this.h.alloc(V.templateId);V.row=U.row,V.stale||=U.isReusingConnectedDomNode}const S=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",S);const L=this.D.isChecked(V.element);if(typeof L=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!L));else if(L){const U=de=>V.row.domNode.setAttribute("aria-checked",String(!!de));U(L.value),V.checkedDisposable=L.onDidChange(U)}if(V.stale||!V.row.domNode.parentElement){const U=this.d.at(v+1)?.row?.domNode??null;this.o.insertBefore(V.row.domNode,U),V.stale=!1}this.bb(V,v);const M=this.j.get(V.templateId);if(!M)throw new Error(`No renderer found for template id ${V.templateId}`);M?.renderElement(V.element,v,V.row.templateData,V.size);const X=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!X,X&&(V.dragStartDisposable=(0,C.$TQ)(V.row.domNode,"dragstart",U=>this.kb(V.element,X,U))),this.Q&&(this.ab(V),this.W())}ab(v){if(!v.row||!v.row.domNode)return;v.row.domNode.style.width="fit-content",v.width=(0,C.$gR)(v.row.domNode);const H=(0,C.getWindow)(v.row.domNode).getComputedStyle(v.row.domNode);H.paddingLeft&&(v.width+=parseFloat(H.paddingLeft)),H.paddingRight&&(v.width+=parseFloat(H.paddingRight)),v.row.domNode.style.width=""}bb(v,H){v.row.domNode.style.top=`${this.elementTop(H)}px`,this.A&&(v.row.domNode.style.height=`${v.size}px`),this.z&&(v.row.domNode.style.lineHeight=`${v.size}px`),v.row.domNode.setAttribute("data-index",`${H}`),v.row.domNode.setAttribute("data-last-element",H===this.length-1?"true":"false"),v.row.domNode.setAttribute("data-parity",H%2===0?"even":"odd"),v.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(v.element,H,this.length))),v.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(v.element,H))),v.row.domNode.setAttribute("id",this.getElementDomId(H)),v.row.domNode.classList.toggle("drop-target",v.dropTarget)}db(v){const H=this.d[v];if(H.dragStartDisposable.dispose(),H.checkedDisposable.dispose(),H.row){const V=this.j.get(H.templateId);V&&V.disposeElement&&V.disposeElement(H.element,v,H.row.templateData,H.size),this.h.release(H.row),H.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(v,H){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:v,reuseAnimation:H})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(v){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:v})}get scrollTop(){return this.getScrollTop()}set scrollTop(v){this.setScrollTop(v)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"click")).event,v=>this.eb(v),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"dblclick")).event,v=>this.eb(v),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new j.$YS(this.domNode,"auxclick")).event,v=>this.eb(v),this.M),v=>v.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"mouseup")).event,v=>this.eb(v),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"mousedown")).event,v=>this.eb(v),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"mouseover")).event,v=>this.eb(v),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"mousemove")).event,v=>this.eb(v),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"mouseout")).event,v=>this.eb(v),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new j.$YS(this.domNode,"contextmenu")).event,v=>this.eb(v),this.M),w.Event.map(this.M.add(new j.$YS(this.domNode,W.EventType.Contextmenu)).event,v=>this.gb(v),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new j.$YS(this.domNode,"touchstart")).event,v=>this.fb(v),this.M)}get onTap(){return w.Event.map(this.M.add(new j.$YS(this.o,W.EventType.Tap)).event,v=>this.gb(v),this.M)}eb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],S=V&&V.element;return{browserEvent:v,index:H,element:S}}fb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],S=V&&V.element;return{browserEvent:v,index:H,element:S}}gb(v){const H=this.ub(v.initialTarget||null),V=typeof H>"u"?void 0:this.d[H],S=V&&V.element;return{browserEvent:v,index:H,element:S}}hb(v){const H=this.ub(v.target||null),V=typeof H>"u"?void 0:this.d[H],S=V&&V.element,L=this.tb(v,H);return{browserEvent:v,index:H,element:S,sector:L}}ib(v){try{const H=this.vb(this.k,this.m);this.Y(H,v.scrollTop,v.height,v.scrollLeft,v.scrollWidth),this.B&&this.wb(v.scrollTop,v.height,v.inSmoothScrolling)}catch(H){throw console.error("Got bad scroll event:",v),H}}jb(v){v.preventDefault(),v.stopPropagation(),this.scrollTop-=v.translationY}kb(v,H,V){if(!V.dataTransfer)return;const S=this.F.getDragElements(v);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(i.$pS.TEXT,H),V.dataTransfer.setDragImage){let L;this.F.getDragLabel&&(L=this.F.getDragLabel(S,V)),typeof L>"u"&&(L=String(S.length));const M=(0,C.$)(".monaco-drag-image");M.textContent=L;const U=(de=>{for(;de&&!de.classList.contains("monaco-workbench");)de=de.parentElement;return de||this.domNode.ownerDocument})(this.domNode);U.appendChild(M),V.dataTransfer.setDragImage(M,-10,-10),setTimeout(()=>U.removeChild(M),0)}this.domNode.classList.add("dragging"),this.H=new b(S),u.CurrentDragAndDropData=new r(S),this.F.onDragStart?.(this.H,V)}lb(v){if(v.browserEvent.preventDefault(),this.L.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(v.browserEvent),!v.browserEvent.dataTransfer))return!1;if(!this.H)if(u.CurrentDragAndDropData)this.H=u.CurrentDragAndDropData;else{if(!v.browserEvent.dataTransfer.types)return!1;this.H=new A}const H=this.F.onDragOver(this.H,v.element,v.index,v.sector,v.browserEvent);if(this.G=typeof H=="boolean"?H:H.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;v.browserEvent.dataTransfer.dropEffect=typeof H!="boolean"&&H.effect?.type===0?"copy":"move";let V;typeof H!="boolean"&&H.feedback?V=H.feedback:typeof v.index>"u"?V=[-1]:V=[v.index],V=(0,y.$Mb)(V).filter(L=>L>=-1&&L<this.length).sort((L,M)=>L-M),V=V[0]===-1?[-1]:V;let S=typeof H!="boolean"&&H.effect&&H.effect.position?H.effect.position:"drop-target";if(R(this.I,V)&&this.J===S)return!0;if(this.I=V,this.J=S,this.K.dispose(),V[0]===-1)this.domNode.classList.add(S),this.o.classList.add(S),this.K=(0,B.$Rc)(()=>{this.domNode.classList.remove(S),this.o.classList.remove(S)});else{if(V.length>1&&S!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");S==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,S="drop-target-before");for(const L of V){const M=this.d[L];M.dropTarget=!0,M.row?.domNode.classList.add(S)}this.K=(0,B.$Rc)(()=>{for(const L of V){const M=this.d[L];M.dropTarget=!1,M.row?.domNode.classList.remove(S)}})}return!0}mb(v){this.L.dispose(),this.L=(0,$.$ih)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,v.element,v.index,v.browserEvent)}nb(v){if(!this.G)return;const H=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,!(!H||!v.browserEvent.dataTransfer)&&(v.browserEvent.preventDefault(),H.update(v.browserEvent.dataTransfer),this.F.drop(H,v.element,v.index,v.sector,v.browserEvent))}ob(v){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(v)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=B.$Tc.None}qb(v){if(!this.w){const H=(0,C.$aR)(this.domNode).top;this.w=(0,C.$0R)((0,C.getWindow)(this.domNode),this.rb.bind(this,H))}this.x.dispose(),this.x=(0,$.$ih)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=v.pageY}rb(v){if(this.y===void 0)return;const H=this.y-v,V=this.renderHeight-35;H<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(H-35))):H>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(H-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(v,H){if(H===void 0)return;const V=v.offsetY/this.d[H].size,S=Math.floor(V/.25);return(0,m.$fm)(S,0,3)}ub(v){const H=this.q.getDomNode();let V=v;for(;V instanceof HTMLElement&&V!==this.o&&H.contains(V);){const S=V.getAttribute("data-index");if(S){const L=Number(S);if(!isNaN(L))return L}V=V.parentElement}}vb(v,H){return{start:this.g.indexAt(v),end:this.g.indexAfter(v+H-1)}}wb(v,H,V){const S=this.vb(v,H);let L,M;v===this.elementTop(S.start)?(L=S.start,M=0):S.end-S.start>1&&(L=S.start+1,M=this.elementTop(L)-v);let X=0;for(;;){const U=this.vb(v,H);let de=!1;for(let he=U.start;he<U.end;he++){const ne=this.xb(he);ne!==0&&this.g.splice(he,1,[this.d[he]]),X+=ne,de=de||ne!==0}if(!de){X!==0&&this.V();const he=f.Range.relativeComplement(S,U);for(const ge of he)for(let Fe=ge.start;Fe<ge.end;Fe++)this.d[Fe].row&&this.db(Fe);const ne=f.Range.relativeComplement(U,S).reverse();for(const ge of ne)for(let Fe=ge.end-1;Fe>=ge.start;Fe--)this.Z(Fe);for(let ge=U.start;ge<U.end;ge++)this.d[ge].row&&this.bb(this.d[ge],ge);if(typeof L=="number"){const ge=this.p.getFutureScrollPosition().scrollTop-v,Fe=this.elementTop(L)-M+ge;this.setScrollTop(Fe,V)}this.N.fire(this.contentHeight);return}}}xb(v){const H=this.d[v];if(this.R.getDynamicHeight){const M=this.R.getDynamicHeight(H.element);if(M!==null){const X=H.size;return H.size=M,H.lastDynamicHeightWidth=this.n,M-X}}if(!H.hasDynamicHeight||H.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(H.element))return 0;const V=H.size;if(H.row)return H.row.domNode.style.height="",H.size=H.row.domNode.offsetHeight,H.lastDynamicHeightWidth=this.n,H.size-V;const{row:S}=this.h.alloc(H.templateId);S.domNode.style.height="",this.o.appendChild(S.domNode);const L=this.j.get(H.templateId);if(!L)throw new a.$cb("Missing renderer for templateId: "+H.templateId);return L.renderElement(H.element,v,S.templateData,void 0),H.size=S.domNode.offsetHeight,L.disposeElement?.(H.element,v,S.templateData,void 0),this.R.setDynamicHeight?.(H.element,H.size),H.lastDynamicHeightWidth=this.n,this.o.removeChild(S.domNode),this.h.release(S),H.size-V}getElementDomId(v){return`${this.domId}_${v}`}dispose(){for(const v of this.d)if(v.dragStartDisposable.dispose(),v.checkedDisposable.dispose(),v.row){const H=this.j.get(v.row.templateId);H&&(H.disposeElement?.(v.element,-1,v.row.templateData,void 0),H.disposeTemplate(v.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}e.$_S=O,Je([p.$Kh],O.prototype,"onMouseClick",null),Je([p.$Kh],O.prototype,"onMouseDblClick",null),Je([p.$Kh],O.prototype,"onMouseMiddleClick",null),Je([p.$Kh],O.prototype,"onMouseUp",null),Je([p.$Kh],O.prototype,"onMouseDown",null),Je([p.$Kh],O.prototype,"onMouseOver",null),Je([p.$Kh],O.prototype,"onMouseMove",null),Je([p.$Kh],O.prototype,"onMouseOut",null),Je([p.$Kh],O.prototype,"onContextMenu",null),Je([p.$Kh],O.prototype,"onTouchStart",null),Je([p.$Kh],O.prototype,"onTap",null)}),define(me[42],$e([1,0,2,24,14,26,60,74,12,9,77,28,4,36,3,34,5,7,73,64,20,102]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s,a,m,u,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rT=e.$qT=e.$pT=e.$oT=e.$nT=e.$mT=e.$lT=e.TypeNavigationMode=e.$kT=e.$jT=e.$iT=e.$hT=e.$gT=e.$fT=e.$eT=e.$dT=void 0;class b{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,E,N){const o=this.c.findIndex(c=>c.templateData===N);if(o>=0){const c=this.c[o];this.d.unrender(N),c.index=E}else{const c={index:E,templateData:N};this.c.push(c)}this.d.renderIndex(E,N)}splice(g,E,N){const o=[];for(const c of this.c)c.index<g?o.push(c):c.index>=g+E&&o.push({index:c.index+N-E,templateData:c.templateData});this.c=o}renderIndexes(g){for(const{index:E,templateData:N}of this.c)g.indexOf(E)>-1&&this.d.renderIndex(E,N)}disposeTemplate(g){const E=this.c.findIndex(N=>N.templateData===g);E<0||this.c.splice(E,1)}}class r{get name(){return this.g}get renderer(){return new b(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new f.$6d,this.onChange=this.f.event}splice(g,E,N){const o=N.length-E,c=g+E,n=[];let h=0;for(;h<this.d.length&&this.d[h]<g;)n.push(this.d[h++]);for(let F=0;F<N.length;F++)N[F]&&n.push(F+g);for(;h<this.d.length&&this.d[h]>=c;)n.push(this.d[h++]+o);this.renderer.splice(g,E,N.length),this.h(n,n)}renderIndex(g,E){E.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,E){return this.h(g,[...g].sort(ie),E)}h(g,E,N){const o=this.c,c=this.d;this.c=g,this.d=E;const n=J(c,g);return this.renderer.renderIndexes(n),this.f.fire({indexes:g,browserEvent:N}),o}get(){return this.c}contains(g){return(0,$.$wb)(this.d,g,ie)>=0}dispose(){(0,t.$Oc)(this.f)}}Je([B.$Kh],r.prototype,"renderer",null);class A extends r{constructor(g){super("selected"),this.k=g}renderIndex(g,E){super.renderIndex(g,E),this.k&&(this.contains(g)?E.setAttribute("aria-selected","true"):E.setAttribute("aria-selected","false"))}}class R{constructor(g,E,N){this.c=g,this.d=E,this.f=N}splice(g,E,N){if(!this.f)return this.c.splice(g,E,new Array(N.length).fill(!1));const o=this.c.get().map(h=>this.f.getId(this.d.element(h)).toString());if(o.length===0)return this.c.splice(g,E,new Array(N.length).fill(!1));const c=new Set(o),n=N.map(h=>c.has(this.f.getId(h).toString()));this.c.splice(g,E,n)}}function I(K){return K.tagName==="INPUT"||K.tagName==="TEXTAREA"}e.$dT=I;function O(K,g){return K.classList.contains(g)?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:O(K.parentElement,g)}function z(K){return O(K,"monaco-editor")}e.$eT=z;function v(K){return O(K,"monaco-custom-toggle")}e.$fT=v;function H(K){return O(K,"action-item")}e.$gT=H;function V(K){return O(K,"monaco-tl-twistie")}e.$hT=V;function S(K){return O(K,"monaco-tree-sticky-row")}e.$iT=S;function L(K){return K.classList.contains("monaco-tree-sticky-container")}e.$jT=L;function M(K){return K.tagName==="A"&&K.classList.contains("monaco-button")||K.tagName==="DIV"&&K.classList.contains("monaco-button-dropdown")?!0:K.classList.contains("monaco-list")||!K.parentElement?!1:M(K.parentElement)}e.$kT=M;class X{get g(){return f.Event.chain(this.c.add(new C.$YS(this.k.domNode,"keydown")).event,g=>g.filter(E=>!I(E.target)).map(E=>new j.$QQ(E)))}constructor(g,E,N){this.h=g,this.k=E,this.c=new t.$Sc,this.d=new t.$Sc,this.f=N.multipleSelectionSupport,this.c.add(this.g(o=>{switch(o.keyCode){case 3:return this.l(o);case 16:return this.o(o);case 18:return this.p(o);case 11:return this.q(o);case 12:return this.s(o);case 9:return this.u(o);case 31:this.f&&(a.$j?o.metaKey:o.ctrlKey)&&this.t(o)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const E=this.h.getFocus()[0];this.h.setAnchor(E),this.h.reveal(E),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const E=this.h.getFocus()[0];this.h.setAnchor(E),this.h.reveal(E),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const E=this.h.getFocus()[0];this.h.setAnchor(E),this.h.reveal(E),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const E=this.h.getFocus()[0];this.h.setAnchor(E),this.h.reveal(E),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,$.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Je([B.$Kh],X.prototype,"g",null);var U;(function(K){K[K.Automatic=0]="Automatic",K[K.Trigger=1]="Trigger"})(U||(e.TypeNavigationMode=U={}));var de;(function(K){K[K.Idle=0]="Idle",K[K.Typing=1]="Typing"})(de||(de={})),e.$lT=new class{mightProducePrintableCharacter(K){return K.ctrlKey||K.metaKey||K.altKey?!1:K.keyCode>=31&&K.keyCode<=56||K.keyCode>=21&&K.keyCode<=30||K.keyCode>=98&&K.keyCode<=107||K.keyCode>=85&&K.keyCode<=95}};class he{constructor(g,E,N,o,c){this.o=g,this.p=E,this.q=N,this.s=o,this.t=c,this.c=!1,this.d=de.Idle,this.f=U.Automatic,this.g=!1,this.h=-1,this.k=new t.$Sc,this.l=new t.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??U.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const E=f.Event.chain(this.k.add(new C.$YS(this.p.domNode,"keydown")).event,c=>c.filter(n=>!I(n.target)).filter(()=>this.f===U.Automatic||this.g).map(n=>new j.$QQ(n)).filter(n=>g||this.s(n)).filter(n=>this.t.mightProducePrintableCharacter(n)).forEach(n=>i.$PR.stop(n,!0)).map(n=>n.browserEvent.key)),N=f.Event.debounce(E,()=>null,800,void 0,void 0,void 0,this.k);f.Event.reduce(f.Event.any(E,N),(c,n)=>n===null?null:(c||"")+n,void 0,this.k)(this.x,this,this.k),N(this.w,this,this.k),E(()=>g=!0,void 0,this.k),N(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const E=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));E&&(0,D.$1S)(E)}this.h=-1}x(g){if(!g){this.d=de.Idle,this.g=!1;return}const E=this.o.getFocus(),N=E.length>0?E[0]:0,o=this.d===de.Idle?1:0;this.d=de.Typing;for(let c=0;c<this.o.length;c++){const n=(N+c+o)%this.o.length,h=this.q.getKeyboardNavigationLabel(this.p.element(n)),F=h&&h.toString();if(this.o.options.typeNavigationEnabled){if(typeof F<"u"){if((0,d.$8j)(g,F)){this.h=N,this.o.setFocus([n]),this.o.reveal(n);return}const T=(0,d.$ck)(g,F);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=N,this.o.setFocus([n]),this.o.reveal(n);return}}}else if(typeof F>"u"||(0,d.$8j)(g,F)){this.h=N,this.o.setFocus([n]),this.o.reveal(n);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ne{constructor(g,E){this.d=g,this.f=E,this.c=new t.$Sc;const N=f.Event.chain(this.c.add(new C.$YS(E.domNode,"keydown")).event,c=>c.filter(n=>!I(n.target)).map(n=>new j.$QQ(n)));f.Event.chain(N,c=>c.filter(n=>n.keyCode===2&&!n.ctrlKey&&!n.metaKey&&!n.shiftKey&&!n.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const E=this.d.getFocus();if(E.length===0)return;const N=this.f.domElement(E[0]);if(!N)return;const o=N.querySelector("[tabIndex]");if(!o||!(o instanceof HTMLElement)||o.tabIndex===-1)return;const c=(0,i.getWindow)(o).getComputedStyle(o);c.visibility==="hidden"||c.display==="none"||(g.preventDefault(),g.stopPropagation(),o.focus())}dispose(){this.c.dispose()}}function ge(K){return a.$j?K.browserEvent.metaKey:K.browserEvent.ctrlKey}e.$mT=ge;function Fe(K){return K.browserEvent.shiftKey}e.$nT=Fe;function Ce(K){return(0,i.$JR)(K)&&K.button===2}const Be={isSelectionSingleChangeEvent:ge,isSelectionRangeChangeEvent:Fe};class le{constructor(g){this.k=g,this.f=new t.$Sc,this.g=new f.$6d,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(W.$rS.addTarget(g.getHTMLElement()))),f.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){z(g.browserEvent.target)||(0,i.$tR)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(I(g.browserEvent.target)||z(g.browserEvent.target))return;const E=typeof g.index>"u"?[]:[g.index];this.k.setFocus(E,g.browserEvent)}u(g){if(!this.d||I(g.browserEvent.target)||z(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const E=g.index;if(typeof E>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([E],g.browserEvent),this.k.setAnchor(E),Ce(g.browserEvent)||this.k.setSelection([E],g.browserEvent),this.g.fire(g)}v(g){if(I(g.browserEvent.target)||z(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const E=this.k.getFocus();this.k.setSelection(E,g.browserEvent)}w(g){const E=g.index;let N=this.k.getAnchor();if(this.p(g)){typeof N>"u"&&(N=this.k.getFocus()[0]??E,this.k.setAnchor(N));const o=Math.min(N,E),c=Math.max(N,E),n=(0,$.$Sb)(o,c+1),h=this.k.getSelection(),F=oe(J(h,[N]),N);if(F.length===0)return;const T=J(n,G(h,F));this.k.setSelection(T,g.browserEvent),this.k.setFocus([E],g.browserEvent)}else if(this.o(g)){const o=this.k.getSelection(),c=o.filter(n=>n!==E);this.k.setFocus([E]),this.k.setAnchor(E),o.length===c.length?this.k.setSelection([...c,E],g.browserEvent):this.k.setSelection(c,g.browserEvent)}}dispose(){this.f.dispose()}}e.$oT=le;class _{constructor(g,E){this.c=g,this.d=E}style(g){const E=this.d&&`.${this.d}`,N=[];g.listBackground&&N.push(`.monaco-list${E} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(N.push(`.monaco-list${E}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),N.push(`.monaco-list${E}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&N.push(`.monaco-list${E}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(N.push(`.monaco-list${E}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),N.push(`.monaco-list${E}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&N.push(`.monaco-list${E}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&N.push(`.monaco-list${E}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&N.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&N.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(N.push(`.monaco-list${E} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),N.push(`.monaco-list${E} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&N.push(`.monaco-list${E} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(N.push(`.monaco-list${E} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),N.push(`.monaco-list${E} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(N.push(`.monaco-list${E} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),N.push(`.monaco-list${E} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&N.push(`.monaco-list${E} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&N.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&N.push(`.monaco-list${E}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const o=(0,i.$aS)(g.listFocusAndSelectionOutline,(0,i.$aS)(g.listSelectionOutline,g.listFocusOutline??""));o&&N.push(`.monaco-list${E}:focus .monaco-list-row.focused.selected { outline: 1px solid ${o}; outline-offset: -1px;}`),g.listFocusOutline&&N.push(`
				.monaco-drag-image,
				.monaco-list${E}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const c=(0,i.$aS)(g.listSelectionOutline,g.listInactiveFocusOutline??"");c&&N.push(`.monaco-list${E} .monaco-list-row.focused.selected { outline: 1px dotted ${c}; outline-offset: -1px; }`),g.listSelectionOutline&&N.push(`.monaco-list${E} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&N.push(`.monaco-list${E} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&N.push(`.monaco-list${E} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&N.push(`
				.monaco-list${E}.drop-target,
				.monaco-list${E} .monaco-list-rows.drop-target,
				.monaco-list${E} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(N.push(`
			.monaco-list${E} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${E} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),N.push(`
			.monaco-list${E} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${E} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&N.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&N.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=N.join(`
`)}}e.$pT=_,e.$qT={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Bt.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Bt.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Bt.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function oe(K,g){const E=K.indexOf(g);if(E===-1)return[];const N=[];let o=E-1;for(;o>=0&&K[o]===g-(E-o);)N.push(K[o--]);for(N.reverse(),o=E;o<K.length&&K[o]===g+(o-E);)N.push(K[o++]);return N}function J(K,g){const E=[];let N=0,o=0;for(;N<K.length||o<g.length;)if(N>=K.length)E.push(g[o++]);else if(o>=g.length)E.push(K[N++]);else if(K[N]===g[o]){E.push(K[N]),N++,o++;continue}else K[N]<g[o]?E.push(K[N++]):E.push(g[o++]);return E}function G(K,g){const E=[];let N=0,o=0;for(;N<K.length||o<g.length;)if(N>=K.length)E.push(g[o++]);else if(o>=g.length)E.push(K[N++]);else if(K[N]===g[o]){N++,o++;continue}else K[N]<g[o]?E.push(K[N++]):o++;return E}const ie=(K,g)=>K-g;class ce{constructor(g,E){this.c=g,this.d=E}get templateId(){return this.c}renderTemplate(g){return this.d.map(E=>E.renderTemplate(g))}renderElement(g,E,N,o){let c=0;for(const n of this.d)n.renderElement(g,E,N[c++],o)}disposeElement(g,E,N,o){let c=0;for(const n of this.d)n.disposeElement?.(g,E,N[c],o),c+=1}disposeTemplate(g){let E=0;for(const N of this.d)N.disposeTemplate(g[E++])}}class De{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,E,N){const o=this.c.getAriaLabel(g);o?N.setAttribute("aria-label",o):N.removeAttribute("aria-label");const c=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof c=="number"?N.setAttribute("aria-level",`${c}`):N.removeAttribute("aria-level")}disposeTemplate(g){}}class Ne{constructor(g,E){this.c=g,this.d=E}getDragElements(g){const E=this.c.getSelectedElements();return E.indexOf(g)>-1?E:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,E){if(this.d.getDragLabel)return this.d.getDragLabel(g,E)}onDragStart(g,E){this.d.onDragStart?.(g,E)}onDragOver(g,E,N,o,c){return this.d.onDragOver(g,E,N,o,c)}onDragLeave(g,E,N,o){this.d.onDragLeave?.(g,E,N,o)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,E,N,o,c){this.d.drop(g,E,N,o,c)}dispose(){this.d.dispose()}}class ye{get onDidChangeFocus(){return f.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return f.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const E=f.Event.chain(this.y.add(new C.$YS(this.k.domNode,"keydown")).event,c=>c.map(n=>new j.$QQ(n)).filter(n=>g=n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$PR.stop(n,!0)).filter(()=>!1)),N=f.Event.chain(this.y.add(new C.$YS(this.k.domNode,"keyup")).event,c=>c.forEach(()=>g=!1).map(n=>new j.$QQ(n)).filter(n=>n.keyCode===58||n.shiftKey&&n.keyCode===68).map(n=>i.$PR.stop(n,!0)).map(({browserEvent:n})=>{const h=this.getFocus(),F=h.length?h[0]:void 0,T=typeof F<"u"?this.k.element(F):void 0,P=typeof F<"u"?this.k.domElement(F):this.k.domNode;return{index:F,element:T,anchor:P,browserEvent:n}})),o=f.Event.chain(this.k.onContextMenu,c=>c.filter(n=>!g).map(({element:n,index:h,browserEvent:F})=>({element:n,index:h,anchor:new l.$LQ((0,i.getWindow)(this.k.domNode),F),browserEvent:F})));return f.Event.any(E,N,o)}get onKeyDown(){return this.y.add(new C.$YS(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$YS(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$YS(this.k.domNode,"keypress")).event}get onDidFocus(){return f.Event.signal(this.y.add(new C.$YS(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return f.Event.signal(this.y.add(new C.$YS(this.k.domNode,"blur",!0)).event)}constructor(g,E,N,o,c=ae){this.A=g,this.B=c,this.c=new r("focused"),this.f=new r("anchor"),this.g=new f.$be,this.x="",this.y=new t.$Sc,this.z=new f.$6d,this.onDidDispose=this.z.event;const n=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new A(n!=="listbox");const h=[this.c.renderer,this.d.renderer];this.u=c.accessibilityProvider,this.u&&(h.push(new De(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),o=o.map(T=>new ce(T.templateId,[...h,T]));const F={...c,dnd:c.dnd&&new Ne(this,c.dnd)};if(this.k=this.C(E,N,o,F),this.k.domNode.setAttribute("role",n),c.styleController)this.q=c.styleController(this.k.domId);else{const T=(0,i.$CR)(this.k.domNode);this.q=new _(T,this.k.domId)}if(this.o=new y.$3S([new R(this.c,this.k,c.identityProvider),new R(this.d,this.k,c.identityProvider),new R(this.f,this.k,c.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ne(this,this.k)),(typeof c.keyboardSupport!="boolean"||c.keyboardSupport)&&(this.v=new X(this,this.k,c),this.y.add(this.v)),c.keyboardNavigationLabelProvider){const T=c.keyboardNavigationDelegate||e.$lT;this.t=new he(this,this.k,c.keyboardNavigationLabelProvider,c.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(c),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,E,N,o){return new k.$_S(g,E,N,o)}D(g){return new le(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,E,N=[]){if(g<0||g>this.k.length)throw new u.$bT(this.A,`Invalid start index: ${g}`);if(E<0)throw new u.$bT(this.A,`Invalid delete count: ${E}`);E===0&&N.length===0||this.g.bufferEvents(()=>this.o.splice(g,E,N))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,E){this.k.updateElementHeight(g,E,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}indexAt(g){return this.k.indexAt(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,E){this.k.layout(g,E)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,E){for(const N of g)if(N<0||N>=this.length)throw new u.$bT(this.A,`Invalid index ${N}`);this.d.set(g,E)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new u.$bT(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,$.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,E){for(const N of g)if(N<0||N>=this.length)throw new u.$bT(this.A,`Invalid index ${N}`);this.c.set(g,E)}focusNext(g=1,E=!1,N,o){if(this.length===0)return;const c=this.c.get(),n=this.E(c.length>0?c[0]+g:0,E,o);n>-1&&this.setFocus([n],N)}focusPrevious(g=1,E=!1,N,o){if(this.length===0)return;const c=this.c.get(),n=this.F(c.length>0?c[0]-g:0,E,o);n>-1&&this.setFocus([n],N)}async focusNextPage(g,E){let N=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);N=N===0?0:N-1;const o=this.getFocus()[0];if(o!==N&&(o===void 0||N>o)){const c=this.F(N,!1,E);c>-1&&o!==c?this.setFocus([c],g):this.setFocus([N],g)}else{const c=this.k.getScrollTop();let n=c+this.k.renderHeight;N>o&&(n-=this.k.elementHeight(N)),this.k.setScrollTop(n),this.k.getScrollTop()!==c&&(this.setFocus([]),await(0,p.$hh)(0),await this.focusNextPage(g,E))}}async focusPreviousPage(g,E,N=()=>0){let o;const c=N(),n=this.k.getScrollTop()+c;n===0?o=this.k.indexAt(n):o=this.k.indexAfter(n-1);const h=this.getFocus()[0];if(h!==o&&(h===void 0||h>=o)){const F=this.E(o,!1,E);F>-1&&h!==F?this.setFocus([F],g):this.setFocus([o],g)}else{const F=n;this.k.setScrollTop(n-this.k.renderHeight-c),this.k.getScrollTop()+N()!==F&&(this.setFocus([]),await(0,p.$hh)(0),await this.focusPreviousPage(g,E,N))}}focusLast(g,E){if(this.length===0)return;const N=this.F(this.length-1,!1,E);N>-1&&this.setFocus([N],g)}focusFirst(g,E){this.focusNth(0,g,E)}focusNth(g,E,N){if(this.length===0)return;const o=this.E(g,!1,N);o>-1&&this.setFocus([o],E)}E(g,E=!1,N){for(let o=0;o<this.length;o++){if(g>=this.length&&!E)return-1;if(g=g%this.length,!N||N(this.element(g)))return g;g++}return-1}F(g,E=!1,N){for(let o=0;o<this.length;o++){if(g<0&&!E)return-1;if(g=(this.length+g%this.length)%this.length,!N||N(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,E,N=0){if(g<0||g>=this.length)throw new u.$bT(this.A,`Invalid index ${g}`);const o=this.k.getScrollTop(),c=this.k.elementTop(g),n=this.k.elementHeight(g);if((0,m.$Xf)(E)){const h=n-this.k.renderHeight+N;this.k.setScrollTop(h*(0,s.$fm)(E,0,1)+c-N)}else{const h=c+n,F=o+this.k.renderHeight;c<o+N&&h>=F||(c<o+N||h>=F&&n>=this.k.renderHeight?this.k.setScrollTop(c-N):h>=F&&this.k.setScrollTop(h-this.k.renderHeight))}}getRelativeTop(g,E=0){if(g<0||g>=this.length)throw new u.$bT(this.A,`Invalid index ${g}`);const N=this.k.getScrollTop(),o=this.k.elementTop(g),c=this.k.elementHeight(g);if(o<N+E||o+c>N+this.k.renderHeight)return null;const n=c-this.k.renderHeight+E;return Math.abs((N+E-o)/n)}isDOMFocused(){return(0,i.$uR)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:E}){return{indexes:g,elements:g.map(N=>this.k.element(N)),browserEvent:E}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let E;this.u?.getActiveDescendantId&&(E=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",E||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}e.$rT=ye,Je([B.$Kh],ye.prototype,"onDidChangeFocus",null),Je([B.$Kh],ye.prototype,"onDidChangeSelection",null),Je([B.$Kh],ye.prototype,"onContextMenu",null),Je([B.$Kh],ye.prototype,"onKeyDown",null),Je([B.$Kh],ye.prototype,"onKeyUp",null),Je([B.$Kh],ye.prototype,"onKeyPress",null),Je([B.$Kh],ye.prototype,"onDidFocus",null),Je([B.$Kh],ye.prototype,"onDidBlur",null)}),define(me[65],$e([1,0,6,38,40,10,15]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.MarkdownStringTextNewlineStyle=void 0;var y;(function(m){m[m.Paragraph=0]="Paragraph",m[m.Break=1]="Break"})(y||(e.MarkdownStringTextNewlineStyle=y={}));class ${constructor(u="",k=!1){if(this.value=u,typeof this.value!="string")throw(0,i.$7)("value");typeof k=="boolean"?(this.isTrusted=k,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=k.isTrusted??void 0,this.supportThemeIcons=k.supportThemeIcons??!1,this.supportHtml=k.supportHtml??!1)}appendText(u,k=0){return this.value+=f(this.supportThemeIcons?(0,C.$rk)(u):u).replace(/([ \t]+)/g,(l,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,k===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,k){return this.value+=`
${d(k,u)}
`,this}appendLink(u,k,l){return this.value+="[",this.value+=this.c(k,"]"),this.value+="](",this.value+=this.c(String(u),")"),l&&(this.value+=` "${this.c(this.c(l,'"'),")")}"`),this.value+=")",this}c(u,k){const l=new RegExp((0,W.$Ye)(k),"g");return u.replace(l,(b,r)=>u.charAt(r-1)!=="\\"?`\\${b}`:b)}}e.$xk=$;function p(m){return w(m)?!m.value:Array.isArray(m)?m.every(p):!0}e.$yk=p;function w(m){return m instanceof $?!0:m&&typeof m=="object"?typeof m.value=="string"&&(typeof m.isTrusted=="boolean"||typeof m.isTrusted=="object"||m.isTrusted===void 0)&&(typeof m.supportThemeIcons=="boolean"||m.supportThemeIcons===void 0):!1}e.$zk=w;function B(m,u){return m===u?!0:!m||!u?!1:m.value===u.value&&m.isTrusted===u.isTrusted&&m.supportThemeIcons===u.supportThemeIcons&&m.supportHtml===u.supportHtml&&(m.baseUri===u.baseUri||!!m.baseUri&&!!u.baseUri&&(0,j.$Mg)(D.URI.from(m.baseUri),D.URI.from(u.baseUri)))}e.$Ak=B;function f(m){return m.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Bk=f;function d(m,u){const k=m.match(/^`+/gm)?.reduce((b,r)=>b.length>r.length?b:r).length??0,l=k>=3?k+1:3;return[`${"`".repeat(l)}${u}`,m,`${"`".repeat(l)}`].join(`
`)}e.$Ck=d;function t(m){return m.replace(/"/g,"&quot;")}e.$Dk=t;function s(m){return m&&m.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Ek=s;function a(m){const u=[],k=m.split("|").map(b=>b.trim());m=k[0];const l=k[1];if(l){const b=/height=(\d+)/.exec(l),r=/width=(\d+)/.exec(l),A=b?b[1]:"",R=r?r[1]:"",I=isFinite(parseInt(R)),O=isFinite(parseInt(A));I&&u.push(`width="${R}"`),O&&u.push(`height="${A}"`)}return{href:m,dimensions:u}}e.$Fk=a}),define(me[130],$e([1,0,2,122,24,58,14,20,123,6,4,65,38,80,23,3,82,56,32,54,40,10,15]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s,a,m,u,k,l,b,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yT=e.$xT=e.$wT=e.$vT=e.$uT=void 0;const A=Object.freeze({image:(G,ie,ce)=>{let De=[],Ne=[];return G&&({href:G,dimensions:De}=(0,B.$Fk)(G),Ne.push(`src="${(0,B.$Dk)(G)}"`)),ce&&Ne.push(`alt="${(0,B.$Dk)(ce)}"`),ie&&Ne.push(`title="${(0,B.$Dk)(ie)}"`),De.length&&(Ne=Ne.concat(De)),"<img "+Ne.join(" ")+">"},paragraph:G=>`<p>${G}</p>`,link:(G,ie,ce)=>typeof G!="string"?"":(G===ce&&(ce=(0,B.$Ek)(ce)),ie=typeof ie=="string"?(0,B.$Dk)((0,B.$Ek)(ie)):"",G=(0,B.$Ek)(G),G=G.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${G}" title="${ie||G}" draggable="false">${ce}</a>`)});function R(G,ie={},ce={}){const De=new s.$Sc;let Ne=!1;const ye=(0,W.$XS)(ie),K=function(T){let P;try{P=(0,m.$Oh)(decodeURIComponent(T))}catch{}return P?(P=(0,k.$Nn)(P,q=>{if(G.uris&&G.uris[q])return r.URI.revive(G.uris[q])}),encodeURIComponent(JSON.stringify(P))):T},g=function(T,P){const q=G.uris&&G.uris[T];let Z=r.URI.revive(q);return P?T.startsWith(u.Schemas.data+":")?T:(Z||(Z=r.URI.parse(T)),u.$Ag.uriToBrowserUri(Z).toString(!0)):!Z||r.URI.parse(T).toString()===Z.toString()?T:(Z.query&&(Z=Z.with({query:K(Z.query)})),Z.toString())},E=new a.marked.Renderer;E.image=A.image,E.link=A.link,E.paragraph=A.paragraph;const N=[],o=[];if(ie.codeBlockRendererSync?E.code=(T,P)=>{const q=d.$vO.nextId(),Z=ie.codeBlockRendererSync(I(P),T);return o.push([q,Z]),`<div class="code" data-code="${q}">${(0,b.$Xe)(T)}</div>`}:ie.codeBlockRenderer&&(E.code=(T,P)=>{const q=d.$vO.nextId(),Z=ie.codeBlockRenderer(I(P),T);return N.push(Z.then(ee=>[q,ee])),`<div class="code" data-code="${q}">${(0,b.$Xe)(T)}</div>`}),ie.actionHandler){const T=function(Z){let ee=Z.target;if(!(ee.tagName!=="A"&&(ee=ee.parentElement,!ee||ee.tagName!=="A")))try{let be=ee.dataset.href;be&&(G.baseUri&&(be=O(r.URI.from(G.baseUri),be)),ie.actionHandler.callback(be,Z))}catch(be){(0,p.$1)(be)}finally{Z.preventDefault()}},P=ie.actionHandler.disposables.add(new j.$YS(ye,"click")),q=ie.actionHandler.disposables.add(new j.$YS(ye,"auxclick"));ie.actionHandler.disposables.add(w.Event.any(P.event,q.event)(Z=>{const ee=new y.$LQ(i.getWindow(ye),Z);!ee.leftButton&&!ee.middleButton||T(ee)})),ie.actionHandler.disposables.add(i.$TQ(ye,"keydown",Z=>{const ee=new D.$QQ(Z);!ee.equals(10)&&!ee.equals(3)||T(ee)}))}G.supportHtml||(ce.sanitizer=T=>(G.isTrusted?T.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?T:"",ce.sanitize=!0,ce.silent=!0),ce.renderer=E;let c=G.value??"";c.length>1e5&&(c=`${c.substr(0,1e5)}\u2026`),G.supportThemeIcons&&(c=(0,f.$sk)(c));let n;if(ie.fillInIncompleteTokens){const T={...a.marked.defaults,...ce},P=a.marked.lexer(c,T),q=de(P);n=a.marked.parser(q,T)}else n=a.marked.parse(c,ce);G.supportThemeIcons&&(n=(0,$.$sT)(n).map(P=>typeof P=="string"?P:P.outerHTML).join(""));const F=new DOMParser().parseFromString(z(G,n),"text/html");if(F.body.querySelectorAll("img").forEach(T=>{const P=T.getAttribute("src");if(P){let q=P;try{G.baseUri&&(q=O(r.URI.from(G.baseUri),q))}catch{}T.src=g(q,!0)}}),F.body.querySelectorAll("a").forEach(T=>{const P=T.getAttribute("href");if(T.setAttribute("href",""),!P||/^data:|javascript:/i.test(P)||/^command:/i.test(P)&&!G.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(P))T.replaceWith(...T.childNodes);else{let q=g(P,!1);G.baseUri&&(q=O(r.URI.from(G.baseUri),P)),T.dataset.href=q}}),ye.innerHTML=z(G,F.body.innerHTML),N.length>0)Promise.all(N).then(T=>{if(Ne)return;const P=new Map(T),q=ye.querySelectorAll("div[data-code]");for(const Z of q){const ee=P.get(Z.dataset.code??"");ee&&i.$WR(Z,ee)}ie.asyncRenderCallback?.()});else if(o.length>0){const T=new Map(o),P=ye.querySelectorAll("div[data-code]");for(const q of P){const Z=T.get(q.dataset.code??"");Z&&i.$WR(q,Z)}}if(ie.asyncRenderCallback)for(const T of ye.getElementsByTagName("img")){const P=De.add(i.$TQ(T,"load",()=>{P.dispose(),ie.asyncRenderCallback()}))}return{element:ye,dispose:()=>{Ne=!0,De.dispose()}}}e.$uT=R;function I(G){if(!G)return"";const ie=G.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:G}function O(G,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:G.path.endsWith("/")?(0,l.$Wg)(G,ie).toString():(0,l.$Wg)((0,l.$Sg)(G),ie).toString()}function z(G,ie){const{config:ce,allowedSchemes:De}=v(G);C.addHook("uponSanitizeAttribute",(ye,K)=>{if(K.attrName==="style"||K.attrName==="class"){if(ye.tagName==="SPAN"){if(K.attrName==="style"){K.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(K.attrValue);return}else if(K.attrName==="class"){K.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(K.attrValue);return}}K.keepAttr=!1;return}else if(ye.tagName==="INPUT"&&ye.attributes.getNamedItem("type")?.value==="checkbox"){if(K.attrName==="type"&&K.attrValue==="checkbox"||K.attrName==="disabled"||K.attrName==="checked"){K.keepAttr=!0;return}K.keepAttr=!1}}),C.addHook("uponSanitizeElement",(ye,K)=>{K.tagName==="input"&&(ye.attributes.getNamedItem("type")?.value==="checkbox"?ye.setAttribute("disabled",""):ye.parentElement?.removeChild(ye))});const Ne=i.$eS(De);try{return C.sanitize(ie,{...ce,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),Ne.dispose()}}e.$vT=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function v(G){const ie=[u.Schemas.http,u.Schemas.https,u.Schemas.mailto,u.Schemas.data,u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemote,u.Schemas.vscodeRemoteResource];return G.isTrusted&&ie.push(u.Schemas.command),{config:{ALLOWED_TAGS:[...i.$fS],ALLOWED_ATTR:e.$vT,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function H(G){return typeof G=="string"?G:V(G)}e.$wT=H;function V(G){let ie=G.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const ce=a.marked.parse(ie,{renderer:L.value}).replace(/&(#\d+|[a-zA-Z]+);/g,De=>S.get(De)??De);return z({isTrusted:!1},ce).toString()}e.$xT=V;const S=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),L=new t.$V(()=>{const G=new a.marked.Renderer;return G.code=ie=>ie,G.blockquote=ie=>ie,G.html=ie=>"",G.heading=(ie,ce,De)=>ie+`
`,G.hr=()=>"",G.list=(ie,ce)=>ie,G.listitem=ie=>ie+`
`,G.paragraph=ie=>ie+`
`,G.table=(ie,ce)=>ie+ce+`
`,G.tablerow=ie=>ie,G.tablecell=(ie,ce)=>ie+" ",G.strong=ie=>ie,G.em=ie=>ie,G.codespan=ie=>ie,G.br=()=>`
`,G.del=ie=>ie,G.image=(ie,ce,De)=>"",G.text=ie=>ie,G.link=(ie,ce,De)=>De,G});function M(G){let ie="";return G.forEach(ce=>{ie+=ce.raw}),ie}function X(G){for(let ie=0;ie<G.tokens.length;ie++){const ce=G.tokens[ie];if(ce.type==="text"){const De=ce.raw.split(`
`),Ne=De[De.length-1];if(Ne.includes("`"))return ne(G);if(Ne.includes("**"))return _(G);if(Ne.match(/\*\w/))return ge(G);if(Ne.match(/(^|\s)__\w/))return ae(G);if(Ne.match(/(^|\s)_\w/))return Fe(G);if(Ne.match(/(^|\s)\[.*\]\(\w*/)){const ye=G.tokens.slice(ie+1);return ye[0]?.type==="link"&&ye[1]?.type==="text"&&ye[1].raw.match(/^ *"[^"]*$/)?Be(G):Ce(G)}else{if(U(Ne))return Ce(G);if(Ne.match(/(^|\s)\[\w/)&&!G.tokens.slice(ie+1).some(ye=>U(ye.raw)))return le(G)}}}}function U(G){return!!G.match(/^[^\[]*\]\([^\)]*$/)}function de(G){let ie,ce;for(ie=0;ie<G.length;ie++){const De=G[ie];let Ne;if(De.type==="paragraph"&&(Ne=De.raw.match(/(\n|^)(````*)/))){const ye=Ne[2];ce=he(G.slice(ie),ye);break}if(De.type==="paragraph"&&De.raw.match(/(\n|^)\|/)){ce=J(G.slice(ie));break}if(ie===G.length-1&&De.type==="paragraph"){const ye=X(De);if(ye){ce=[ye];break}}}if(ce){const De=[...G.slice(0,ie),...ce];return De.links=G.links,De}return G}e.$yT=de;function he(G,ie){const ce=M(G);return a.marked.lexer(ce+`
${ie}`)}function ne(G){return oe(G,"`")}function ge(G){return oe(G,"*")}function Fe(G){return oe(G,"_")}function Ce(G){return oe(G,")")}function Be(G){return oe(G,'")')}function le(G){return oe(G,"](about:blank)")}function _(G){return oe(G,"**")}function ae(G){return oe(G,"__")}function oe(G,ie){const ce=M(Array.isArray(G)?G:[G]);return a.marked.lexer(ce+ie)[0]}function J(G){const ie=M(G),ce=ie.split(`
`);let De,Ne=!1;for(let ye=0;ye<ce.length;ye++){const K=ce[ye].trim();if(typeof De>"u"&&K.match(/^\s*\|/)){const g=K.match(/(\|[^\|]+)(?=\||$)/g);g&&(De=g.length)}else if(typeof De=="number")if(K.match(/^\s*\|/)){if(ye!==ce.length-1)return;Ne=!0}else return}if(typeof De=="number"&&De>0){const ye=Ne?ce.slice(0,-1).join(`
`):ie,K=!!ye.match(/\|\s*$/),g=ye+(K?"":"|")+`
|${" --- |".repeat(De)}`;return a.marked.lexer(g)}}}),define(me[43],$e([1,0,2,9,30,65,38,3,7,112]),function(re,e,i,C,j,W,D,y,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MS=e.$LS=void 0;function w(t,s){(0,$.$Tf)(s)?t.title=(0,D.$tk)(s):s?.markdownNotSupportedFallback?t.title=s.markdownNotSupportedFallback:t.removeAttribute("title")}e.$LS=w;class B{constructor(s,a,m){this.c=s,this.d=a,this.f=m}async update(s,a,m){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let u;if(s===void 0||(0,$.$Tf)(s)||s instanceof HTMLElement)u=s;else if(!(0,$.$8f)(s.markdown))u=s.markdown??s.markdownNotSupportedFallback;else{this.a||this.g((0,p.localize)(0,null),a),this.b=new j.$de;const k=this.b.token;if(u=await s.markdown(k),u===void 0&&(u=s.markdownNotSupportedFallback),this.isDisposed||k.isCancellationRequested)return}this.g(u,a,m)}g(s,a,m){const u=this.a;if(this.h(s)){const k={content:s,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!u},position:{hoverPosition:2},...m};this.a=this.c.showHover(k,a)}u?.dispose()}h(s){return s?(0,W.$zk)(s)?!!s.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function f(t,s){for(s=s??i.getWindow(t).document.body;!t.hasAttribute("custom-hover")&&t!==s;)t=t.parentElement;return t}function d(t,s,a,m){s.setAttribute("custom-hover","true"),s.title!==""&&(console.warn("HTML element already has a title attribute, which will conflict with the custom hover. Please remove the title attribute."),console.trace("Stack trace:",s.title),s.title="");let u,k;const l=(S,L)=>{const M=k!==void 0;S&&(k?.dispose(),k=void 0),L&&(u?.dispose(),u=void 0),M&&(t.onDidHideHover?.(),k=void 0)},b=(S,L,M)=>new C.$qh(async()=>{(!k||k.isDisposed)&&(k=new B(t,M||s,S>0),await k.update(typeof a=="function"?a():a,L,m))},S);let r=!1;const A=i.$TQ(s,i.$NR.MOUSE_DOWN,()=>{r=!0,l(!0,!0)},!0),R=i.$TQ(s,i.$NR.MOUSE_UP,()=>{r=!1},!0),I=i.$TQ(s,i.$NR.MOUSE_LEAVE,S=>{r=!1,l(!1,S.fromElement===s)},!0),O=S=>{if(u)return;const L=new y.$Sc,M={targetElements:[s],dispose:()=>{}};if(t.placement===void 0||t.placement==="mouse"){const X=U=>{M.x=U.x+10,U.target instanceof HTMLElement&&f(U.target,s)!==s&&l(!0,!0)};L.add(i.$TQ(s,i.$NR.MOUSE_MOVE,X,!0))}u=L,!(S.target instanceof HTMLElement&&f(S.target,s)!==s)&&L.add(b(t.delay,!1,M))},z=i.$TQ(s,i.$NR.MOUSE_OVER,O,!0),v=()=>{if(r||u)return;const S={targetElements:[s],dispose:()=>{}},L=new y.$Sc,M=()=>l(!0,!0);L.add(i.$TQ(s,i.$NR.BLUR,M,!0)),L.add(b(t.delay,!1,S)),u=L},H=i.$TQ(s,i.$NR.FOCUS,v,!0);return{show:S=>{l(!1,!0),b(0,S)},hide:()=>{l(!0,!0)},update:async(S,L)=>{a=S,await k?.update(a,void 0,L)},dispose:()=>{z.dispose(),I.dispose(),A.dispose(),R.dispose(),H.dispose(),l(!0,!0)}}}e.$MS=d}),define(me[131],$e([1,0,2,24,14,130,16,43,42,12,4,48,3,5,114,105]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zT=void 0;const s=i.$,a="selectOption.entry.template";class m{get templateId(){return a}renderTemplate(l){const b=Object.create(null);return b.root=l,b.text=i.$UR(l,s(".option-text")),b.detail=i.$UR(l,s(".option-detail")),b.decoratorRight=i.$UR(l,s(".option-decorator-right")),b}renderElement(l,b,r){const A=r,R=l.text,I=l.detail,O=l.decoratorRight,z=l.isDisabled;A.text.textContent=R,A.detail.textContent=I||"",A.decoratorRight.innerText=O||"",z?A.root.classList.add("option-disabled"):A.root.classList.remove("option-disabled")}disposeTemplate(l){}}class u extends f.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(l,b,r,A,R){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=A,this.g=R||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=u.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$6d,this.B(this.r),this.Q(),this.P(r),this.n=b||0,l&&this.setOptions(l,b),this.S()}O(l){!this.M&&l?this.M=this.B((0,y.$MS)((0,D.$OS)("mouse"),this.h,l)):this.M&&this.M.update(l)}getHeight(){return 22}getTemplateId(){return a}P(l){this.u=l,this.w=i.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=i.$UR(this.w,s(".select-box-details-pane"));const b=i.$UR(this.w,s(".select-box-dropdown-container-width-control")),r=i.$UR(b,s(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",i.$UR(r,this.D),this.G=0,this.y=i.$CR(this.w),this.w.setAttribute("draggable","true"),this.B(i.$TQ(this.w,i.$NR.DRAG_START,A=>{i.$PR.stop(A,!0)}))}Q(){this.B(i.$UQ(this.h,"change",b=>{this.n=b.target.selectedIndex,this.r.fire({index:b.target.selectedIndex,selected:b.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(i.$TQ(this.h,i.$NR.CLICK,b=>{i.$PR.stop(b),this.f?this.Z(!0):this.Y()})),this.B(i.$TQ(this.h,i.$NR.MOUSE_DOWN,b=>{i.$PR.stop(b)}));let l;this.B(i.$TQ(this.h,"touchstart",b=>{l=this.f})),this.B(i.$TQ(this.h,"touchend",b=>{i.$PR.stop(b),l?this.Z(!0):this.Y()})),this.B(i.$TQ(this.h,i.$NR.KEY_DOWN,b=>{const r=new j.$QQ(b);let A=!1;d.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(A=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(A=!0),A&&(this.Y(),i.$PR.stop(b,!0))}))}get onDidSelect(){return this.r.event}setOptions(l,b){p.$ub(this.m,l)||(this.m=l,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,A)=>{this.h.add(this.X(r.text,A,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),b!==void 0&&(this.select(b),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(l){l>=0&&l<this.m.length?this.n=l:l>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(l){this.g.ariaLabel=l,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(l){this.h.tabIndex=l?0:-1}render(l){this.j=l,l.classList.add("select-container"),l.appendChild(this.h),this.U()}S(){const l=[];this.s.listFocusBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(l.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),l.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&l.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),l.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=l.join(`
`)}U(){const l=this.s.selectBackground??"",b=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=l,this.h.style.color=b,this.h.style.borderColor=r}W(){const l=this.s.selectBackground??"",b=i.$aS(this.s.selectListBackground,l);this.C.style.backgroundColor=b,this.I.style.backgroundColor=b;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(l,b,r){const A=document.createElement("option");return A.value=l,A.text=l,A.disabled=!!r,A}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.ab(l,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:l=>this.ab(l),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(l){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),l&&this.h.focus(),this.u.hideContextView())}ab(l,b){return l.appendChild(this.w),this.cb(b),{dispose:()=>{try{l.removeChild(this.w)}catch{}}}}bb(){let l=0;return this.m.forEach((b,r)=>{this.jb(r),this.I.offsetHeight>l&&(l=this.I.offsetHeight)}),l}cb(l){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const b=i.getWindow(this.h),r=i.$dR(this.h),A=i.getWindow(this.h).getComputedStyle(this.h),R=parseFloat(A.getPropertyValue("--dropdown-padding-top"))+parseFloat(A.getPropertyValue("--dropdown-padding-bottom")),I=b.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),O=r.top-u.b,z=this.h.offsetWidth,v=this.db(this.D),H=Math.max(v,Math.round(z)).toString()+"px";this.w.style.width=H,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const S=this.H?this.L:0,L=V+R+S,M=Math.floor((I-R-S)/this.getHeight()),X=Math.floor((O-R-S)/this.getHeight());if(l)return r.top+r.height>b.innerHeight-22||r.top<u.b||M<1&&X<1?!1:(M<u.c&&X>M&&this.m.length>M?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>b.innerHeight-22||r.top<u.b||this.G===0&&M<1||this.G===1&&X<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&M+X<1)return this.Z(!0),!1;L>I&&(V=M*this.getHeight())}else L>O&&(V=X*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+R+"px",this.w.style.height=""):this.w.style.height=V+R+"px",this.jb(this.n),this.w.style.width=H,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(l){let b=0;if(l){let r=0,A=0;this.m.forEach((R,I)=>{const O=R.detail?R.detail.length:0,z=R.decoratorRight?R.decoratorRight.length:0,v=R.text.length+O+z;v>A&&(r=I,A=v)}),l.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),b=i.$fR(l)}return b}eb(l){if(this.z)return;this.C=i.$UR(l,s(".select-box-dropdown-list-container")),this.t=new m,this.z=new $.$rT("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:A=>{let R=A.text;return A.detail&&(R+=`. ${A.detail}`),A.decoratorRight&&(R+=`. ${A.decoratorRight}`),A.description&&(R+=`. ${A.description}`),R},getWidgetAriaLabel:()=>(0,t.localize)(0,null),getRole:()=>d.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const b=this.B(new C.$YS(this.C,"keydown")),r=w.Event.chain(b.event,A=>A.filter(()=>this.z.length>0).map(R=>new j.$QQ(R)));this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,A=>A.filter(R=>R.keyCode>=21&&R.keyCode<=56||R.keyCode>=85&&R.keyCode<=113))(this.sb,this)),this.B(i.$TQ(this.z.getHTMLElement(),i.$NR.POINTER_UP,A=>this.fb(A))),this.B(this.z.onMouseOver(A=>typeof A.index<"u"&&this.z.setFocus([A.index]))),this.B(this.z.onDidChangeFocus(A=>this.ib(A))),this.B(i.$TQ(this.w,i.$NR.FOCUS_OUT,A=>{!this.f||i.$lR(A.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(l){if(!this.z.length)return;i.$PR.stop(l);const b=l.target;if(!b||b.classList.contains("slider"))return;const r=b.closest(".monaco-list-row");if(!r)return;const A=Number(r.getAttribute("data-index")),R=r.classList.contains("option-disabled");A>=0&&A<this.m.length&&!R&&(this.n=A,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(l,b){const r=R=>{for(let I=0;I<R.childNodes.length;I++){const O=R.childNodes.item(I);(O.tagName&&O.tagName.toLowerCase())==="img"?R.removeChild(O):r(O)}},A=(0,W.$uT)({value:l,supportThemeIcons:!0},{actionHandler:b});return A.element.classList.add("select-box-description-markdown"),r(A.element),A.element}ib(l){!this.f||!this.H||this.jb(l.indexes[0])}jb(l){this.I.innerText="";const b=this.m[l],r=b?.description??"",A=b?.descriptionIsMarkdown??!1;if(r){if(A){const R=b.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,R))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(l){i.$PR.stop(l),this.select(this.F),this.Z(!0)}lb(l){i.$PR.stop(l),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(l){if(this.n<this.m.length-1){i.$PR.stop(l,!0);const b=this.m[this.n+1].isDisabled;if(b&&this.m.length>this.n+2)this.n+=2;else{if(b)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(l){this.n>0&&(i.$PR.stop(l,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(l){i.$PR.stop(l),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(l){i.$PR.stop(l),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(l){i.$PR.stop(l),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(l){i.$PR.stop(l),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(l){const b=B.KeyCodeUtils.toString(l.keyCode);let r=-1;for(let A=0;A<this.m.length-1;A++)if(r=(A+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===b&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),i.$PR.stop(l);break}}dispose(){this.Z(!1),super.dispose()}}e.$zT=u}),define(me[132],$e([1,0,42,131,126,21,5,104]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CT=e.$BT=void 0,e.$BT={...i.$qT,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends W.$vS{constructor(p,w,B,f,d){super(),D.$j&&!d?.useCustomDrawn?this.a=new j.$AT(p,w,f,d):this.a=new C.$zT(p,w,B,f,d),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(p,w){this.a.setOptions(p,w)}select(p){this.a.select(p)}setAriaLabel(p){this.a.setAriaLabel(p)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(p){this.a.setFocusable(p)}render(p){this.a.render(p)}}e.$CT=y}),define(me[66],$e([1,0,17,57,2,26,16,43,132,39,3,5,7,109,55]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KT=e.$JT=e.$IT=void 0;class t extends w.$Tc{get action(){return this._action}constructor(u,k,l={}){super(),this.m=l,this._context=u||this,this._action=k,k instanceof p.$Xi&&this.B(k.onDidChange(b=>{this.element&&this.t(b)}))}t(u){u.enabled!==void 0&&this.u(),u.checked!==void 0&&this.H(),u.class!==void 0&&this.G(),u.label!==void 0&&(this.w(),this.D()),u.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new p.$Yi)),this.j}set actionRunner(u){this.j=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const k=this.element=u;this.B(W.$rS.addTarget(u));const l=this.m&&this.m.draggable;l&&(u.draggable=!0,i.$zQ&&this.B((0,j.$TQ)(u,j.$NR.DRAG_START,b=>b.dataTransfer?.setData(C.$pS.TEXT,this._action.label)))),this.B((0,j.$TQ)(k,W.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,j.$TQ)(k,j.$NR.MOUSE_DOWN,b=>{l||j.$PR.stop(b,!0),this._action.enabled&&b.button===0&&k.classList.add("active")})),B.$j&&this.B((0,j.$TQ)(k,j.$NR.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,j.$TQ)(k,j.$NR.CLICK,b=>{j.$PR.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,j.$TQ)(k,j.$NR.DBLCLICK,b=>{j.$PR.stop(b,!0)})),[j.$NR.MOUSE_UP,j.$NR.MOUSE_OUT].forEach(b=>{this.B((0,j.$TQ)(k,b,r=>{j.$PR.stop(r),k.classList.remove("active")}))})}onClick(u,k=!1){j.$PR.stop(u,!0);const l=f.$3f(this._context)?this.m?.useEventAsContext?u:{preserveFocus:k}:this._context;this.actionRunner.run(this._action,l)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const u=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=u;else if(!this.f&&u!==""){const k=this.m.hoverDelegate??(0,D.$OS)("element");this.f=this.q.add((0,y.$MS)(k,this.element,u))}else this.f&&this.f.update(u)}F(){if(this.element){const u=this.C()??"";this.element.setAttribute("aria-label",u)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}e.$IT=t;class s extends t{constructor(u,k,l){super(u,k,l),this.m=l,this.m.icon=l.icon!==void 0?l.icon:!1,this.m.label=l.label!==void 0?l.label:!0,this.L=""}render(u){super.render(u),f.$4f(this.element);const k=document.createElement("a");if(k.classList.add("action-label"),k.setAttribute("role",this.M()),this.I=k,this.element.appendChild(k),this.m.label&&this.m.keybinding){const l=document.createElement("span");l.classList.add("keybinding"),l.textContent=this.m.keybinding,this.element.appendChild(l)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===p.$Zi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(u){this.I&&(this.I.tabIndex=u?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(u=this.action.label,this.m.keybinding&&(u=d.localize(0,null,u,this.m.keybinding))),u??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const u=this.C()??"";this.I.setAttribute("aria-label",u)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}e.$JT=s;class a extends t{constructor(u,k,l,b,r,A,R){super(u,k),this.b=new $.$CT(l,b,r,A,R),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(u,k){this.b.setOptions(u,k)}select(u){this.b.select(u)}g(){this.B(this.b.onDidSelect(u=>this.n(u.selected,u.index)))}n(u,k){this.actionRunner.run(this._action,this.r(u,k))}r(u,k){return u}setFocusable(u){this.b.setFocusable(u)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(u){this.b.render(u)}}e.$KT=a}),define(me[67],$e([1,0,2,14,66,16,39,4,3,7,55]),function(re,e,i,C,j,W,D,y,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RS=e.$QS=e.ActionsOrientation=void 0;var w;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(w||(e.ActionsOrientation=w={}));class B extends $.$Tc{constructor(t,s={}){super(),this.j=this.B(new $.$Sc),this.s=this.B(new $.$3c),this.y=!1,this.z=!0,this.D=this.B(new y.$6d),this.onDidBlur=this.D.event,this.F=this.B(new y.$6d({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new y.$6d),this.onDidRun=this.H.event,this.I=this.B(new y.$6d),this.onWillRun=this.I.event,this.b=s,this.m=s.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=s.hoverDelegate??this.B((0,W.$PS)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new D.$Yi,this.j.add(this.g)),this.j.add(this.g.onDidRun(u=>this.H.fire(u))),this.j.add(this.g.onWillRun(u=>this.I.fire(u))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let a,m;switch(this.n){case 0:a=[15],m=[17];break;case 1:a=[16],m=[18],this.domNode.className+=" vertical";break}this.B(i.$TQ(this.domNode,i.$NR.KEY_DOWN,u=>{const k=new C.$QQ(u);let l=!0;const b=typeof this.u=="number"?this.viewItems[this.u]:void 0;a&&(k.equals(a[0])||k.equals(a[1]))?l=this.Q():m&&(k.equals(m[0])||k.equals(m[1]))?l=this.P():k.equals(9)&&this.G?this.F.fire():k.equals(14)?l=this.N():k.equals(13)?l=this.O():k.equals(2)&&b instanceof j.$IT&&b.trapsArrowNavigation?l=this.P():this.L(k)?this.r.keyDown?this.S(k):this.y=!0:l=!1,l&&(k.preventDefault(),k.stopPropagation())})),this.B(i.$TQ(this.domNode,i.$NR.KEY_UP,u=>{const k=new C.$QQ(u);this.L(k)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(k)),k.preventDefault(),k.stopPropagation()):(k.equals(2)||k.equals(1026)||k.equals(16)||k.equals(18)||k.equals(15)||k.equals(17))&&this.M()})),this.w=this.B(i.$SR(this.domNode)),this.B(this.w.onDidBlur(()=>{(i.$tR()===this.domNode||!i.$lR(i.$tR(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),t.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(t){t?this.C.setAttribute("aria-label",t):this.C.removeAttribute("aria-label")}setFocusable(t){if(this.z=t,this.z){const s=this.viewItems.find(a=>a instanceof j.$IT&&a.isEnabled());s instanceof j.$IT&&s.setFocusable(!0)}else this.viewItems.forEach(s=>{s instanceof j.$IT&&s.setFocusable(!1)})}L(t){let s=!1;return this.r.keys.forEach(a=>{s=s||t.equals(a)}),s}M(){for(let t=0;t<this.C.children.length;t++){const s=this.C.children[t];if(i.$lR(i.$tR(),s)){this.u=t,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(t){this.m=t,this.viewItems.forEach(s=>s.setActionContext(t))}get actionRunner(){return this.g}set actionRunner(t){this.g=t,this.j.clear(),this.j.add(this.g.onDidRun(s=>this.H.fire(s))),this.j.add(this.g.onWillRun(s=>this.I.fire(s))),this.viewItems.forEach(s=>s.actionRunner=t)}getContainer(){return this.domNode}hasAction(t){return this.viewItems.findIndex(s=>s.action.id===t.id)!==-1}getAction(t){if(typeof t=="number")return this.viewItems[t]?.action;if(t instanceof HTMLElement){for(;t.parentElement!==this.C;){if(!t.parentElement)return;t=t.parentElement}for(let s=0;s<this.C.childNodes.length;s++)if(this.C.childNodes[s]===t)return this.viewItems[s].action}}push(t,s={}){const a=Array.isArray(t)?t:[t];let m=p.$Xf(s.index)?s.index:null;a.forEach(u=>{const k=document.createElement("li");k.className="action-item",k.setAttribute("role","presentation");let l;const b={hoverDelegate:this.f,...s};this.b.actionViewItemProvider&&(l=this.b.actionViewItemProvider(u,b)),l||(l=new j.$JT(this.context,u,b)),this.b.allowContextMenu||this.s.set(l,i.$TQ(k,i.$NR.CONTEXT_MENU,r=>{i.$PR.stop(r,!0)})),l.actionRunner=this.g,l.setActionContext(this.context),l.render(k),this.z&&l instanceof j.$IT&&this.viewItems.length===0&&l.setFocusable(!0),m===null||m<0||m>=this.C.children.length?(this.C.appendChild(k),this.viewItems.push(l)):(this.C.insertBefore(k,this.C.children[m]),this.viewItems.splice(m,0,l),m++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientWidth}return 0}getHeight(t){if(t>=0&&t<this.C.children.length){const s=this.C.children.item(t);if(s)return s.clientHeight}return 0}pull(t){t>=0&&t<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[t]),this.s.deleteAndDispose(this.viewItems[t]),(0,$.$Oc)(this.viewItems.splice(t,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,$.$Oc)(this.viewItems),this.s.clearAndDisposeAll(),i.$SQ(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(t){let s=!1,a;if(t===void 0?s=!0:typeof t=="number"?a=t:typeof t=="boolean"&&(s=t),s&&typeof this.u>"u"){const m=this.viewItems.findIndex(u=>u.isEnabled());this.u=m===-1?void 0:m,this.R(void 0,void 0,!0)}else a!==void 0&&(this.u=a),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(t){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(!t&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=s,!1;this.u=(this.u+1)%this.viewItems.length,a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===D.$Zi.ID));return this.R(),!0}Q(t){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const s=this.u;let a;do{if(this.u=this.u-1,this.u<0){if(!t&&this.b.preventLoopNavigation)return this.u=s,!1;this.u=this.viewItems.length-1}a=this.viewItems[this.u]}while(this.u!==s&&(this.b.focusOnlyEnabledItems&&!a.isEnabled()||a.action.id===D.$Zi.ID));return this.R(!0),!0}R(t,s,a=!1){typeof this.u>"u"&&this.C.focus({preventScroll:s}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const m=this.u!==void 0?this.viewItems[this.u]:void 0;if(m){let u=!0;p.$8f(m.focus)||(u=!1),this.b.focusOnlyEnabledItems&&p.$8f(m.isEnabled)&&!m.isEnabled()&&(u=!1),m.action.id===D.$Zi.ID&&(u=!1),u?(a||this.t!==this.u)&&(m.focus(t),this.t=this.u):(this.C.focus({preventScroll:s}),this.t=void 0),u&&m.showHover?.()}}S(t){if(typeof this.u>"u")return;const s=this.viewItems[this.u];if(s instanceof j.$IT){const a=s._context===null||s._context===void 0?t:s._context;this.run(s._action,a)}}async run(t,s){await this.g.run(t,s)}dispose(){this.m=void 0,this.viewItems=(0,$.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}e.$QS=B;function f(d){if(!d.length)return d;let t=-1;for(let a=0;a<d.length;a++)if(d[a].id!==D.$Zi.ID){t=a;break}if(t===-1)return[];d=d.slice(t);for(let a=d.length-1;a>=0&&d[a].id===D.$Zi.ID;a--)d.splice(a,1);let s=!1;for(let a=d.length-1;a>=0;a--){const m=d[a].id===D.$Zi.ID;m&&!s?d.splice(a,1):m?m&&(s=!1):s=!0}return d}e.$RS=f}),define(me[68],$e([1,0,2,24,58,67,60,63,21,4,85,54,113,101]),function(re,e,i,C,j,W,D,y,$,p,w,B,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qU=e.$pU=e.$oU=e.MessageType=void 0;const d=i.$;var t;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(t||(e.MessageType=t={})),e.$oU={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends $.$vS{constructor(u,k,l){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new p.$6d),this.onDidChange=this.O.event,this.P=this.B(new p.$6d),this.onDidHeightChange=this.P.event,this.a=k,this.g=l,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=i.$UR(u,d(".monaco-inputbox.idle"));const b=this.g.flexibleHeight?"textarea":"input",r=i.$UR(this.element,d(".ibwrapper"));if(this.b=i.$UR(r,d(b+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=i.$UR(r,d("div.mirror")),this.y.innerText="\xA0",this.N=new y.$FS(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),i.$UR(u,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(I=>this.b.scrollTop=I.scrollTop));const A=this.B(new C.$YS(u.ownerDocument,"selectionchange")),R=p.Event.filter(A.event,()=>u.ownerDocument.getSelection()?.anchorNode===r);this.B(R(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new W.$QS(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(u){this.n=u,this.b.setAttribute("placeholder",u)}setTooltip(u){this.r=u,this.b.title=u}setAriaLabel(u){this.s=u,u?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(u){this.b.value!==u&&(this.b.value=u,this.Y())}get step(){return this.b.step}set step(u){this.b.step=u}get height(){return typeof this.J=="number"?this.J:i.$jR(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return i.$uR(this.b)}select(u=null){this.b.select(),u&&(this.b.setSelectionRange(u.start,u.end),u.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(u){u?this.enable():this.disable()}get width(){return i.$fR(this.b)}set width(u){if(this.g.flexibleHeight&&this.g.flexibleWidth){let k=0;if(this.y){const l=parseFloat(this.y.style.paddingLeft||"")||0,b=parseFloat(this.y.style.paddingRight||"")||0;k=l+b}this.b.style.width=u-k+"px"}else this.b.style.width=u+"px";this.y&&(this.y.style.width=u+"px")}set paddingRight(u){this.b.style.width=`calc(100% - ${u}px)`,this.y&&(this.y.style.paddingRight=u+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const u=this.L,k=this.J,l=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:u,height:k}),this.N.setScrollPosition({scrollTop:l})}showMessage(u,k){if(this.w==="open"&&(0,B.$Pn)(this.h,u))return;this.h=u,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(u.type));const l=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${i.$aS(l.border,"transparent")}`,this.h.content&&(this.hasFocus()||k)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let u=null;return this.t&&(u=this.t(this.value),u?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(u)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),u?.type}stylesForType(u){const k=this.g.inputBoxStyles;switch(u){case 1:return{border:k.inputValidationInfoBorder,background:k.inputValidationInfoBackground,foreground:k.inputValidationInfoForeground};case 2:return{border:k.inputValidationWarningBorder,background:k.inputValidationWarningBackground,foreground:k.inputValidationWarningForeground};default:return{border:k.inputValidationErrorBorder,background:k.inputValidationErrorBackground,foreground:k.inputValidationErrorForeground}}}U(u){switch(u){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let u;const k=()=>u.style.width=i.$fR(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:b=>{if(!this.h)return null;u=i.$UR(b,d(".monaco-inputbox-container")),k();const r={inline:!0,className:"monaco-inputbox-message"},A=this.h.formatContent?(0,j.$WS)(this.h.content,r):(0,j.$VS)(this.h.content,r);A.classList.add(this.U(this.h.type));const R=this.stylesForType(this.h.type);return A.style.backgroundColor=R.background??"",A.style.color=R.foreground??"",A.style.border=R.border?`1px solid ${R.border}`:"",i.$UR(u,A),null},onHide:()=>{this.w="closed"},layout:k});let l;this.h.type===3?l=f.localize(0,null,this.h.content):this.h.type===2?l=f.localize(1,null,this.h.content):l=f.localize(2,null,this.h.content),D.$1S(l),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const u=this.value,l=u.charCodeAt(u.length-1)===10?" ":"";(u+l).replace(/\u000c/g,"")?this.y.textContent=u+l:this.y.innerText="\xA0",this.layout()}ab(){const u=this.g.inputBoxStyles,k=u.inputBackground??"",l=u.inputForeground??"",b=u.inputBorder??"";this.element.style.backgroundColor=k,this.element.style.color=l,this.b.style.backgroundColor="inherit",this.b.style.color=l,this.element.style.border=`1px solid ${i.$aS(b,"transparent")}`}layout(){if(!this.y)return;const u=this.L;this.L=i.$jR(this.y),u!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(u){const k=this.inputElement,l=k.selectionStart,b=k.selectionEnd,r=k.value;l!==null&&b!==null&&(this.value=r.substr(0,l)+u+r.substr(b),k.setSelectionRange(l+1,l+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}e.$pU=s;class a extends s{constructor(u,k,l){const b=f.localize(3,null,"\u21C5"),r=f.localize(4,null,"\u21C5");super(u,k,l),this.db=this.B(new p.$6d),this.onDidFocus=this.db.event,this.eb=this.B(new p.$6d),this.onDidBlur=this.eb.event,this.bb=new w.$mU(l.history,100);const A=()=>{if(l.showHistoryHint&&l.showHistoryHint()&&!this.n.endsWith(b)&&!this.n.endsWith(r)&&this.bb.getHistory().length){const R=this.n.endsWith(")")?b:r,I=this.n+R;l.showPlaceholderOnFocus&&!i.$uR(this.b)?this.n=I:this.setPlaceHolder(I)}};this.cb=new MutationObserver((R,I)=>{R.forEach(O=>{O.target.textContent||A()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>A()),this.F(this.b,()=>{const R=I=>{if(this.n.endsWith(I)){const O=this.n.slice(0,this.n.length-I.length);return l.showPlaceholderOnFocus?this.n=O:this.setPlaceHolder(O),!0}else return!1};R(r)||R(b)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(u){this.value&&(u||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(u){const k=this.getHistory();this.clearHistory(),u.forEach(l=>{this.bb.add(l)}),k.forEach(l=>{this.bb.add(l)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let u=this.jb();u&&(u=u===this.value?this.jb():u),this.value=u??"",D.$2S(this.value?this.value:f.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let u=this.ib();u&&(u=u===this.value?this.ib():u),u&&(this.value=u,D.$2S(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(u){super.setPlaceHolder(u),this.setTooltip(u)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let u=this.bb.current();return u||(u=this.bb.last(),this.bb.next()),u}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}e.$qU=a}),define(me[69],$e([1,0,66,21,18,19,4,2,43,16,106]),function(re,e,i,C,j,W,D,y,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HT=e.$GT=e.$FT=e.$ET=e.$DT=void 0,e.$DT={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends i.$IT{constructor(s,a,m){super(s,a,m),this.a=this.B(new B({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:m.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:m.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:m.toggleStyles?.inputActiveOptionForeground,hoverDelegate:m.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$ET=w;class B extends C.$vS{constructor(s){super(),this.a=this.B(new D.$6d),this.onChange=this.a.event,this.b=this.B(new D.$6d),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,$.$MS)(s.hoverDelegate??(0,p.$OS)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,m=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),m.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,m=>{if(m.keyCode===10||m.keyCode===3){this.checked=!this.s,this.a.fire(!0),m.preventDefault(),m.stopPropagation();return}this.b.fire(m)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(s){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.t.update(s),this.domNode.setAttribute("aria-label",s)}}e.$FT=B;class f extends C.$vS{constructor(s,a,m){super(),this.g=s,this.h=a,this.a=this.B(new D.$6d),this.onChange=this.a.event,this.b=new B({title:this.g,isChecked:this.h,icon:j.$pk.check,actionClassName:"monaco-checkbox",...e.$DT}),this.domNode=this.b.domNode,this.c=m,this.n(),this.B(this.b.onChange(u=>{this.n(),this.a.fire(u)}))}get checked(){return this.b.checked}set checked(s){this.b.checked=s,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$uR)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}e.$GT=f;class d extends i.$IT{constructor(s,a,m){super(s,a,m),this.a=this.B(new f(this._action.label,!!this._action.checked,m.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(s){if(this.element=s,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const a=this.element.appendChild((0,y.$)("span.checkbox-label",void 0,this._action.label));this.B((0,y.$TQ)(a,y.$NR.CLICK,m=>{this.a.checked=!this.a.checked,m.stopPropagation(),m.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}e.$HT=d}),define(me[133],$e([1,0,16,69,18,111]),function(re,e,i,C,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DU=e.$CU=e.$BU=void 0;const D=W.localize(0,null),y=W.localize(1,null),$=W.localize(2,null);class p extends C.$FT{constructor(d){super({icon:j.$pk.caseSensitive,title:D+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$OS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$BU=p;class w extends C.$FT{constructor(d){super({icon:j.$pk.wholeWord,title:y+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$OS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$CU=w;class B extends C.$FT{constructor(d){super({icon:j.$pk.regex,title:$+d.appendTitle,isChecked:d.isChecked,hoverDelegate:d.hoverDelegate??(0,i.$OS)("element"),inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}e.$DU=B}),define(me[134],$e([1,0,2,133,68,21,4,110,3,16,100]),function(re,e,i,C,j,W,D,y,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EU=void 0;const w=y.localize(0,null);class B extends W.$vS{static{this.OPTION_CHANGE="optionChange"}constructor(d,t,s){super(),this.n=!0,this.s=!1,this.w=this.B(new $.$Uc),this.N=[],this.O=this.B(new D.$6d),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$6d),this.onKeyDown=this.P.event,this.Q=this.B(new D.$6d),this.onMouseDown=this.Q.event,this.R=this.B(new D.$6d),this.onInput=this.R.event,this.S=this.B(new D.$6d),this.onKeyUp=this.S.event,this.U=this.B(new D.$6d),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$6d),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=s.placeholder||"",this.b=s.validation,this.c=s.label||w,this.h=!!s.showCommonFindToggles;const a=s.appendCaseSensitiveLabel||"",m=s.appendWholeWordsLabel||"",u=s.appendRegexLabel||"",k=s.history||[],l=!!s.flexibleHeight,b=!!s.flexibleWidth,r=s.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new j.$qU(this.domNode,t,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:k,showHistoryHint:s.showHistoryHint,flexibleHeight:l,flexibleWidth:b,flexibleMaxHeight:r,inputBoxStyles:s.inputBoxStyles}));const A=this.B((0,p.$PS)());if(this.h){this.J=this.B(new C.$DU({appendTitle:u,isChecked:!1,hoverDelegate:A,...s.toggleStyles})),this.B(this.J.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(I=>{this.W.fire(I)})),this.L=this.B(new C.$CU({appendTitle:m,isChecked:!1,hoverDelegate:A,...s.toggleStyles})),this.B(this.L.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$BU({appendTitle:a,isChecked:!1,hoverDelegate:A,...s.toggleStyles})),this.B(this.M.onChange(I=>{this.O.fire(I),!I&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(I=>{this.U.fire(I)}));const R=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,I=>{if(I.equals(15)||I.equals(17)||I.equals(9)){const O=R.indexOf(this.domNode.ownerDocument.activeElement);if(O>=0){let z=-1;I.equals(17)?z=(O+1)%R.length:I.equals(15)&&(O===0?z=R.length-1:z=O-1),I.equals(9)?(R[O].blur(),this.inputBox.focus()):z>=0&&R[z].focus(),i.$PR.stop(I,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(s?.additionalToggles),this.y&&this.domNode.appendChild(this.y),d?.appendChild(this.domNode),this.B(i.$TQ(this.inputBox.inputElement,"compositionstart",R=>{this.s=!0})),this.B(i.$TQ(this.inputBox.inputElement,"compositionend",R=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,R=>this.P.fire(R)),this.C(this.inputBox.inputElement,R=>this.S.fire(R)),this.D(this.inputBox.inputElement,R=>this.R.fire()),this.j(this.inputBox.inputElement,R=>this.Q.fire(R))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(d){this.inputBox.layout(),this.X(d.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const d of this.N)d.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const d of this.N)d.disable()}setFocusInputOnOptionClick(d){this.n=d}setEnabled(d){d?this.enable():this.disable()}setAdditionalToggles(d){for(const t of this.N)t.domNode.remove();this.N=[],this.w.value=new $.$Sc;for(const t of d??[])this.w.value.add(t),this.y.appendChild(t.domNode),this.w.value.add(t.onChange(s=>{this.O.fire(s),!s&&this.n&&this.inputBox.focus()})),this.N.push(t);this.N.length>0&&(this.y.style.display=""),this.X()}X(d=!1){d?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((t,s)=>t+s.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(d){this.inputBox.value!==d&&(this.inputBox.value=d)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(d){this.M&&(this.M.checked=d)}getWholeWords(){return this.L?.checked??!1}setWholeWords(d){this.L&&(this.L.checked=d)}getRegex(){return this.J?.checked??!1}setRegex(d){this.J&&(this.J.checked=d,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(d){this.inputBox.showMessage(d)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}e.$EU=B}),define(me[135],$e([1,0,2,24,14,67,134,68,64,42,69,61,27,39,12,9,18,19,33,4,36,3,34,7,115,16,107]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s,a,m,u,k,l,b,r,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dV=e.AbstractTreePart=e.TreeFindMatchType=e.TreeFindMode=e.$cV=e.$bV=e.$aV=e.RenderIndentGuides=e.$_U=e.$$U=void 0;class O extends $.$9S{set context(n){this.c.context=n}get context(){return this.c.context}constructor(n){super(n.elements.map(h=>h.element)),this.c=n}}function z(c){return c instanceof $.$9S?new O(c):c}class v{constructor(n,h){this.d=n,this.f=h,this.b=b.$Tc.None,this.c=new b.$Sc}getDragURI(n){return this.f.getDragURI(n.element)}getDragLabel(n,h){if(this.f.getDragLabel)return this.f.getDragLabel(n.map(F=>F.element),h)}onDragStart(n,h){this.f.onDragStart?.(z(n),h)}onDragOver(n,h,F,T,P,q=!0){const Z=this.f.onDragOver(z(n),h&&h.element,F,T,P),ee=this.a!==h;if(ee&&(this.b.dispose(),this.a=h),typeof h>"u")return Z;if(ee&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,s.$ih)(()=>{const Ee=this.d(),Ae=Ee.getNodeLocation(h);Ee.isCollapsed(Ae)&&Ee.setCollapsed(Ae,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!q){const Ee=typeof Z=="boolean"?Z:Z.accept,Ae=typeof Z=="boolean"?void 0:Z.effect;return{accept:Ee,effect:Ae,feedback:[F]}}return Z}if(Z.bubble===1){const Ee=this.d(),Ae=Ee.getNodeLocation(h),Re=Ee.getParentNodeLocation(Ae),Ie=Ee.getNode(Re),Ge=Re&&Ee.getListIndex(Re);return this.onDragOver(n,Ie,Ge,T,P,!1)}const be=this.d(),we=be.getNodeLocation(h),ke=be.getListIndex(we),Oe=be.getListRenderCount(we);return{...Z,feedback:(0,t.$Sb)(ke,ke+Oe)}}drop(n,h,F,T,P){this.b.dispose(),this.a=void 0,this.f.drop(z(n),h&&h.element,F,T,P)}onDragEnd(n){this.f.onDragEnd?.(n)}dispose(){this.c.dispose(),this.f.dispose()}}function H(c,n){return n&&{...n,identityProvider:n.identityProvider&&{getId(h){return n.identityProvider.getId(h.element)}},dnd:n.dnd&&new v(c,n.dnd),multipleSelectionController:n.multipleSelectionController&&{isSelectionSingleChangeEvent(h){return n.multipleSelectionController.isSelectionSingleChangeEvent({...h,element:h.element})},isSelectionRangeChangeEvent(h){return n.multipleSelectionController.isSelectionRangeChangeEvent({...h,element:h.element})}},accessibilityProvider:n.accessibilityProvider&&{...n.accessibilityProvider,getSetSize(h){const F=c(),T=F.getNodeLocation(h),P=F.getParentNodeLocation(T);return F.getNode(P).visibleChildrenCount},getPosInSet(h){return h.visibleChildIndex+1},isChecked:n.accessibilityProvider&&n.accessibilityProvider.isChecked?h=>n.accessibilityProvider.isChecked(h.element):void 0,getRole:n.accessibilityProvider&&n.accessibilityProvider.getRole?h=>n.accessibilityProvider.getRole(h.element):()=>"treeitem",getAriaLabel(h){return n.accessibilityProvider.getAriaLabel(h.element)},getWidgetAriaLabel(){return n.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:n.accessibilityProvider&&n.accessibilityProvider.getWidgetRole?()=>n.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:n.accessibilityProvider&&n.accessibilityProvider.getAriaLevel?h=>n.accessibilityProvider.getAriaLevel(h.element):h=>h.depth,getActiveDescendantId:n.accessibilityProvider.getActiveDescendantId&&(h=>n.accessibilityProvider.getActiveDescendantId(h.element))},keyboardNavigationLabelProvider:n.keyboardNavigationLabelProvider&&{...n.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(h){return n.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(h.element)}}}}class V{constructor(n){this.a=n}getHeight(n){return this.a.getHeight(n.element)}getTemplateId(n){return this.a.getTemplateId(n.element)}hasDynamicHeight(n){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(n.element)}setDynamicHeight(n,h){this.a.setDynamicHeight?.(n.element,h)}}e.$$U=V;class S{static lift(n){return n instanceof S?n:new S(n)}static empty(n=0){return new S({focus:[],selection:[],expanded:Object.create(null),scrollTop:n})}constructor(n){if(this.focus=new Set(n.focus),this.selection=new Set(n.selection),n.expanded instanceof Array){this.expanded=Object.create(null);for(const h of n.expanded)this.expanded[h]=1}else this.expanded=n.expanded;this.expanded=n.expanded,this.scrollTop=n.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}e.$_U=S;var L;(function(c){c.None="none",c.OnHover="onHover",c.Always="always"})(L||(e.RenderIndentGuides=L={}));class M{get elements(){return this.b}constructor(n,h=[]){this.b=h,this.a=new b.$Sc,this.onDidChange=k.Event.forEach(n,F=>this.b=F,this.a)}dispose(){this.a.dispose()}}class X{static{this.a=8}constructor(n,h,F,T,P,q={}){this.o=n,this.p=h,this.q=T,this.s=P,this.b=new Map,this.c=new Map,this.d=X.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Tc.None,this.m=new b.$Sc,this.templateId=n.templateId,this.updateOptions(q),k.Event.map(F,Z=>Z.node)(this.u,this,this.m),n.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(n={}){if(typeof n.indent<"u"){const h=(0,r.$fm)(n.indent,0,40);if(h!==this.d){this.d=h;for(const[F,T]of this.c)this.v(F,T)}}if(typeof n.renderIndentGuides<"u"){const h=n.renderIndentGuides!==L.None;if(h!==this.g){this.g=h;for(const[F,T]of this.c)this.w(F,T);if(this.k.dispose(),h){const F=new b.$Sc;this.q.onDidChange(this.x,this,F),this.k=F,this.x(this.q.elements)}}}typeof n.hideTwistiesOfChildlessElements<"u"&&(this.f=n.hideTwistiesOfChildlessElements)}renderTemplate(n){const h=(0,i.$UR)(n,(0,i.$)(".monaco-tl-row")),F=(0,i.$UR)(h,(0,i.$)(".monaco-tl-indent")),T=(0,i.$UR)(h,(0,i.$)(".monaco-tl-twistie")),P=(0,i.$UR)(h,(0,i.$)(".monaco-tl-contents")),q=this.o.renderTemplate(P);return{container:n,indent:F,twistie:T,indentGuidesDisposable:b.$Tc.None,templateData:q}}renderElement(n,h,F,T){this.c.set(n,F),this.b.set(n.element,n),this.v(n,F),this.o.renderElement(n,h,F.templateData,T)}disposeElement(n,h,F,T){F.indentGuidesDisposable.dispose(),this.o.disposeElement?.(n,h,F.templateData,T),typeof T=="number"&&(this.c.delete(n),this.b.delete(n.element))}disposeTemplate(n){this.o.disposeTemplate(n.templateData)}t(n){const h=this.b.get(n);h&&this.u(h)}u(n){const h=this.c.get(n);h&&(this.x(this.q.elements),this.v(n,h))}v(n,h){const F=X.a+(n.depth-1)*this.d;h.twistie.style.paddingLeft=`${F}px`,h.indent.style.width=`${F+this.d-16}px`,n.collapsible?h.container.setAttribute("aria-expanded",String(!n.collapsed)):h.container.removeAttribute("aria-expanded"),h.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(a.$pk.treeItemExpanded));let T=!1;this.o.renderTwistie&&(T=this.o.renderTwistie(n.element,h.twistie)),n.collapsible&&(!this.f||n.visibleChildrenCount>0)?(T||h.twistie.classList.add(...m.ThemeIcon.asClassNameArray(a.$pk.treeItemExpanded)),h.twistie.classList.add("collapsible"),h.twistie.classList.toggle("collapsed",n.collapsed)):h.twistie.classList.remove("collapsible","collapsed"),this.w(n,h)}w(n,h){if((0,i.$SQ)(h.indent),h.indentGuidesDisposable.dispose(),!this.g)return;const F=new b.$Sc,T=this.p();for(;;){const P=T.getNodeLocation(n),q=T.getParentNodeLocation(P);if(!q)break;const Z=T.getNode(q),ee=(0,i.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&ee.classList.add("active"),h.indent.childElementCount===0?h.indent.appendChild(ee):h.indent.insertBefore(ee,h.indent.firstElementChild),this.s.add(Z,ee),F.add((0,b.$Rc)(()=>this.s.delete(Z,ee))),n=Z}h.indentGuidesDisposable=F}x(n){if(!this.g)return;const h=new Set,F=this.p();n.forEach(T=>{const P=F.getNodeLocation(T);try{const q=F.getParentNodeLocation(P);T.collapsible&&T.children.length>0&&!T.collapsed?h.add(T):q&&h.add(F.getNode(q))}catch{}}),this.j.forEach(T=>{h.has(T)||this.s.forEach(T,P=>P.classList.remove("active"))}),h.forEach(T=>{this.j.has(T)||this.s.forEach(T,P=>P.classList.add("active"))}),this.j=h}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Oc)(this.m)}}e.$aV=X;class U{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(n){this.c=n,this.d=n.toLowerCase()}constructor(n,h,F){this.g=n,this.j=h,this.k=F,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Sc,n.onWillRefilter(this.m,this,this.f)}filter(n,h){let F=1;if(this.k){const q=this.k.filter(n,h);if(typeof q=="boolean"?F=q?1:0:(0,B.$8U)(q)?F=(0,B.$9U)(q.visibility):F=q,F===0)return!1}if(this.a++,!this.c)return this.b++,{data:l.FuzzyScore.Default,visibility:F};const T=this.j.getKeyboardNavigationLabel(n),P=Array.isArray(T)?T:[T];for(const q of P){const Z=q&&q.toString();if(typeof Z>"u")return{data:l.FuzzyScore.Default,visibility:F};let ee;if(this.g.findMatchType===Fe.Contiguous){const be=Z.toLowerCase().indexOf(this.d);if(be>-1){ee=[Number.MAX_SAFE_INTEGER,0];for(let we=this.d.length;we>0;we--)ee.push(be+we-1)}}else ee=(0,l.$hk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ee)return this.b++,P.length===1?{data:ee,visibility:F}:{data:{label:Z,score:ee},visibility:F}}return this.g.findMode===ge.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(n):2:{data:l.FuzzyScore.Default,visibility:F}}m(){this.a=0,this.b=0}dispose(){(0,b.$Oc)(this.f)}}class de extends w.$FT{constructor(n){super({icon:a.$pk.listFilter,title:(0,R.localize)(0,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.$OS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}e.$bV=de;class he extends w.$FT{constructor(n){super({icon:a.$pk.searchFuzzy,title:(0,R.localize)(1,null),isChecked:n.isChecked??!1,hoverDelegate:n.hoverDelegate??(0,I.$OS)("element"),inputActiveOptionBorder:n.inputActiveOptionBorder,inputActiveOptionForeground:n.inputActiveOptionForeground,inputActiveOptionBackground:n.inputActiveOptionBackground})}}e.$cV=he;const ne={inputBoxStyles:y.$oU,toggleStyles:w.$DT,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ge;(function(c){c[c.Highlight=0]="Highlight",c[c.Filter=1]="Filter"})(ge||(e.TreeFindMode=ge={}));var Fe;(function(c){c[c.Fuzzy=0]="Fuzzy",c[c.Contiguous=1]="Contiguous"})(Fe||(e.TreeFindMatchType=Fe={}));class Ce extends b.$Tc{set mode(n){this.b.checked=n===ge.Filter,this.f.inputBox.setPlaceHolder(n===ge.Filter?(0,R.localize)(2,null):(0,R.localize)(3,null))}set matchType(n){this.c.checked=n===Fe.Fuzzy}get value(){return this.f.inputBox.value}set value(n){this.f.inputBox.value=n}constructor(n,h,F,T,P,q){super(),this.t=h,this.a=(0,i.h)(".monaco-tree-type-filter",[(0,i.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,i.h)(".monaco-tree-type-filter-input@findInput"),(0,i.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new k.$6d,this.onDidDisable=this._onDidDisable.event,n.appendChild(this.a.root),this.B((0,b.$Rc)(()=>n.removeChild(this.a.root)));const Z=q?.styles??ne;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const ee=this.B((0,I.$PS)());this.b=this.B(new de({...Z.toggleStyles,isChecked:T===ge.Filter,hoverDelegate:ee})),this.c=this.B(new he({...Z.toggleStyles,isChecked:P===Fe.Fuzzy,hoverDelegate:ee})),this.onDidChangeMode=k.Event.map(this.b.onChange,()=>this.b.checked?ge.Filter:ge.Highlight,this.q),this.onDidChangeMatchType=k.Event.map(this.c.onChange,()=>this.c.checked?Fe.Fuzzy:Fe.Contiguous,this.q),this.f=this.B(new D.$EU(this.a.findInput,F,{label:(0,R.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:q?.history})),this.g=this.B(new W.$QS(this.a.actionbar)),this.mode=T;const be=this.B(new C.$YS(this.f.inputBox.inputElement,"keydown")),we=k.Event.chain(be.event,Ae=>Ae.map(Re=>new j.$QQ(Re)));this.B(we(Ae=>{if(Ae.equals(3)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ae.equals(18)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ae.equals(16)){Ae.preventDefault(),Ae.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const ke=this.B(new d.$Xi("close",(0,R.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(ke,{icon:!0,label:!1});const Oe=this.B(new C.$YS(this.a.grab,"mousedown"));this.B(Oe.event(Ae=>{const Re=new b.$Sc,Ie=Re.add(new C.$YS((0,i.getWindow)(Ae),"mousemove")),Ge=Re.add(new C.$YS((0,i.getWindow)(Ae),"mouseup")),nt=this.m,Ye=Ae.pageX,Ue=this.s,Y=Ae.pageY;this.a.grab.classList.add("grabbing");const se=this.a.root.style.transition;this.a.root.style.transition="unset";const pe=ve=>{const Le=ve.pageX-Ye;this.m=nt-Le;const je=ve.pageY-Y;this.s=Ue+je,this.layout()};Re.add(Ie.event(pe)),Re.add(Ge.event(ve=>{pe(ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=se,Re.dispose()}))}));const Ee=k.Event.chain(this.B(new C.$YS(this.a.grab,"keydown")).event,Ae=>Ae.map(Re=>new j.$QQ(Re)));this.B(Ee(Ae=>{let Re,Ie;if(Ae.keyCode===15?Re=Number.POSITIVE_INFINITY:Ae.keyCode===17?Re=0:Ae.keyCode===10&&(Re=this.m===0?Number.POSITIVE_INFINITY:0),Ae.keyCode===16?Ie=0:Ae.keyCode===18&&(Ie=Number.POSITIVE_INFINITY),Re!==void 0&&(Ae.preventDefault(),Ae.stopPropagation(),this.m=Re,this.layout()),Ie!==void 0){Ae.preventDefault(),Ae.stopPropagation(),this.s=Ie;const Ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(n=this.j){this.j=n,this.m=(0,r.$fm)(this.m,0,Math.max(0,n-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$fm)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(n){this.f.showMessage(n)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$hh)(300),super.dispose()}}class Be{get pattern(){return this.b}get mode(){return this.d}set mode(n){n!==this.d&&(this.d=n,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(n))}get matchType(){return this.f}set matchType(n){n!==this.f&&(this.f=n,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(n))}constructor(n,h,F,T,P,q={}){this.t=n,this.u=F,this.v=T,this.w=P,this.x=q,this.b="",this.c="",this.j=0,this.k=new k.$6d,this.onDidChangeMode=this.k.event,this.m=new k.$6d,this.onDidChangeMatchType=this.m.event,this.o=new k.$6d,this.onDidChangePattern=this.o.event,this.p=new k.$6d,this.onDidChangeOpenState=this.p.event,this.q=new b.$Sc,this.s=new b.$Sc,this.d=n.options.defaultFindMode??ge.Highlight,this.f=n.options.defaultFindMatchType??Fe.Fuzzy,h.onDidSplice(this.z,this,this.s)}updateOptions(n={}){n.defaultFindMode!==void 0&&(this.mode=n.defaultFindMode),n.defaultFindMatchType!==void 0&&(this.matchType=n.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ce(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(n=>this.mode=n,void 0,this.q),this.g.onDidChangeMatchType(n=>this.matchType=n,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(n){this.b=n,this.o.fire(n),this.v.pattern=n,this.t.refilter(),n&&this.t.focusNext(0,!0,void 0,F=>!l.FuzzyScore.isDefault(F.filterData));const h=this.t.getFocus();if(h.length>0){const F=h[0];this.t.getRelativeTop(F)===null&&this.t.reveal(F,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const n=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&n?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,R.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(n){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!l.FuzzyScore.isDefault(n.filterData)}layout(n){this.j=n,this.g?.layout(n)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function le(c,n){return c.position===n.position&&_(c,n)}function _(c,n){return c.node.element===n.node.element&&c.startIndex===n.startIndex&&c.height===n.height&&c.endIndex===n.endIndex}class ae{constructor(n=[]){this.stickyNodes=n}get count(){return this.stickyNodes.length}equal(n){return(0,t.$ub)(this.stickyNodes,n.stickyNodes,le)}lastNodePartiallyVisible(){if(this.count===0)return!1;const n=this.stickyNodes[this.count-1];if(this.count===1)return n.position!==0;const h=this.stickyNodes[this.count-2];return h.position+h.height!==n.position}animationStateChanged(n){if(!(0,t.$ub)(this.stickyNodes,n.stickyNodes,_)||this.count===0)return!1;const h=this.stickyNodes[this.count-1],F=n.stickyNodes[n.count-1];return h.position!==F.position}}class oe{constrainStickyScrollNodes(n,h,F){for(let T=0;T<n.length;T++){const P=n[T];if(P.position+P.height>F||T>=h)return n.slice(0,T)}return n}}class J extends b.$Tc{constructor(n,h,F,T,P,q={}){super(),this.g=n,this.j=h,this.m=F,this.s=P,this.c=.4;const Z=this.validateStickySettings(q);this.b=Z.stickyScrollMaxItemCount,this.a=q.stickyScrollDelegate??new oe,this.f=this.B(new G(F.getScrollableElement(),F,n,T,P,q.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(F.onDidScroll(()=>this.u())),this.B(F.onDidChangeContentHeight(()=>this.u())),this.B(n.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(n){return this.f.getNode(n)}t(n){let h;if(n===0?h=this.m.firstVisibleIndex:h=this.m.indexAt(n+this.m.scrollTop),!(h<0||h>=this.m.length))return this.m.element(h)}u(){const n=this.t(0);if(!n||this.g.scrollTop===0){this.f.setState(void 0);return}const h=this.w(n);this.f.setState(h)}w(n){const h=[];let F=n,T=0,P=this.z(F,void 0,T);for(;P&&(h.push(P),T+=P.height,!(h.length<=this.b&&(F=this.y(P),!F)));)P=this.z(F,P.node,T);const q=this.H(h);return q.length?new ae(q):void 0}y(n){return this.t(n.position+n.height)}z(n,h,F){const T=this.F(n,h);if(T&&!(T===n&&(!this.J(n)||this.C(n,F))))return this.D(T,F)}C(n,h){const F=this.L(n),T=this.m.getElementTop(F),P=h;return this.m.scrollTop===T-P}D(n,h){const F=this.s.getHeight(n),{startIndex:T,endIndex:P}=this.M(n),q=this.G(P,h,F);return{node:n,position:q,height:F,startIndex:T,endIndex:P}}F(n,h=void 0){let F=n,T=this.I(F);for(;T;){if(T===h)return F;F=T,T=this.I(F)}if(h===void 0)return F}G(n,h,F){let T=this.m.getRelativeTop(n);if(T===null&&this.m.firstVisibleIndex===n&&n+1<this.m.length){const be=this.s.getHeight(this.m.element(n)),we=this.m.getRelativeTop(n+1);T=we?we-be/this.m.renderHeight:null}if(T===null)return h;const P=this.m.element(n),q=this.s.getHeight(P),ee=T*this.m.renderHeight+q;return h+F>ee&&h<=ee?ee-F:h}H(n){if(n.length===0)return[];const h=this.m.renderHeight*this.c,F=n[n.length-1];if(n.length<=this.b&&F.position+F.height<=h)return n;const T=this.a.constrainStickyScrollNodes(n,this.b,h);if(!T.length)return[];const P=T[T.length-1];if(T.length>this.b||P.position+P.height>h)throw new Error("stickyScrollDelegate violates constraints");return T}I(n){const h=this.j.getNodeLocation(n),F=this.j.getParentNodeLocation(h);return F?this.j.getNode(F):void 0}J(n){const h=this.j.getNodeLocation(n);return this.j.getListRenderCount(h)>1}L(n){const h=this.j.getNodeLocation(n);return this.j.getListIndex(h)}M(n){const h=this.j.getNodeLocation(n),F=this.j.getListIndex(h);if(F<0)throw new Error("Node not found in tree");const T=this.j.getListRenderCount(h),P=F+T-1;return{startIndex:F,endIndex:P}}nodePositionTopBelowWidget(n){const h=[];let F=this.I(n);for(;F;)h.push(F),F=this.I(F);let T=0;for(let P=0;P<h.length&&P<this.b;P++)T+=this.s.getHeight(h[P]);return T}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(n={}){if(!n.stickyScrollMaxItemCount)return;const h=this.validateStickySettings(n);this.b!==h.stickyScrollMaxItemCount&&(this.b=h.stickyScrollMaxItemCount,this.u())}validateStickySettings(n){let h=7;return typeof n.stickyScrollMaxItemCount=="number"&&(h=Math.max(n.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:h}}}class G{constructor(n,h,F,T,P,q){this.g=h,this.j=F,this.k=T,this.m=P,this.o=q,this.c=[],this.d=new b.$Sc,this.a=(0,i.$)(".monaco-tree-sticky-container.empty"),n.appendChild(this.a);const Z=(0,i.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new ie(this.a,h),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const n=this.b.stickyNodes[this.b.count-1];return n.position+n.height}get count(){return this.b?.count??0}getNode(n){return this.b?.stickyNodes.find(h=>h.node===n)}setState(n){const h=!!this.b&&this.b.count>0,F=!!n&&n.count>0;if(!h&&!F||h&&F&&this.b.equal(n))return;if(h!==F&&this.s(F),!F){this.b=void 0,this.c=[],this.d.clear();return}const T=n.stickyNodes[n.count-1];if(this.b&&n.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${T.position}px`;else{this.d.clear();const P=Array(n.count);for(let q=n.count-1;q>=0;q--){const Z=n.stickyNodes[q],{element:ee,disposable:be}=this.p(Z,q,n.count);P[q]=ee,this.a.appendChild(ee),this.d.add(be)}this.f.updateElements(P,n),this.c=P}this.b=n,this.a.style.height=`${T.position+T.height}px`}p(n,h,F){const T=n.startIndex,P=document.createElement("div");P.style.top=`${n.position}px`,P.style.height=`${n.height}px`,P.style.lineHeight=`${n.height}px`,P.classList.add("monaco-tree-sticky-row"),P.classList.add("monaco-list-row"),P.setAttribute("data-index",`${T}`),P.setAttribute("data-parity",T%2===0?"even":"odd"),P.setAttribute("id",this.g.getElementID(T)),this.q(P,n.node.element,h,F);const q=this.m.getTemplateId(n.node),Z=this.k.find(ke=>ke.templateId===q);if(!Z)throw new Error(`No renderer found for template id ${q}`);let ee=n.node;ee===this.j.getNode(this.j.getNodeLocation(n.node))&&(ee=new Proxy(n.node,{}));const be=Z.renderTemplate(P);Z.renderElement(ee,n.startIndex,be,n.height);const we=(0,b.$Rc)(()=>{Z.disposeElement(ee,n.startIndex,be,n.height),Z.disposeTemplate(be),P.remove()});return{element:P,disposable:we}}q(n,h,F,T){if(!this.o)return;this.o.getSetSize&&n.setAttribute("aria-setsize",String(this.o.getSetSize(h,F,T))),this.o.getPosInSet&&n.setAttribute("aria-posinset",String(this.o.getPosInSet(h,F))),this.o.getRole&&n.setAttribute("role",this.o.getRole(h)??"treeitem");const P=this.o.getAriaLabel(h);P&&n.setAttribute("aria-label",P);const q=this.o.getAriaLevel&&this.o.getAriaLevel(h);typeof q=="number"&&n.setAttribute("aria-level",`${q}`),n.setAttribute("aria-selected",String(!1))}s(n){this.a.classList.toggle("empty",!n),n||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ie extends b.$Tc{get m(){return this.j}set m(n){n!==this.j&&(this.f.fire(n),this.j=n)}constructor(n,h){super(),this.s=n,this.t=h,this.a=-1,this.b=[],this.f=new k.$6d,this.onDidChangeHasFocus=this.f.event,this.g=new k.$6d,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(F=>this.w(F))),this.B(this.t.onMouseDown(F=>this.y(F))),this.B(this.t.onContextMenu(F=>this.u(F)))}u(n){const h=n.browserEvent.target;if(!(0,p.$jT)(h)&&!(0,p.$iT)(h)){this.focusedLast()&&this.t.domFocus();return}if(!(0,i.$KR)(n.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const q=this.c.stickyNodes.findIndex(Z=>Z.node.element===n.element?.element);if(q===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(q);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const T=this.c.stickyNodes[this.a].node.element,P=this.b[this.a];this.g.fire({element:T,anchor:P,browserEvent:n.browserEvent,isStickyScroll:!0})}w(n){if(this.m&&this.c){if(n.key==="ArrowUp")this.z(Math.max(0,this.a-1)),n.preventDefault(),n.stopPropagation();else if(n.key==="ArrowDown"||n.key==="ArrowRight"){if(this.a>=this.c.count-1){const h=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([h]),this.C(h,this.c)}else this.z(this.a+1);n.preventDefault(),n.stopPropagation()}}}y(n){const h=n.browserEvent.target;!(0,p.$jT)(h)&&!(0,p.$iT)(h)||(n.browserEvent.preventDefault(),n.browserEvent.stopPropagation())}updateElements(n,h){if(h&&h.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(h&&h.count!==n.length)throw new Error("Sticky scroll focus received illigel state");const F=this.a;if(this.D(),this.b=n,this.c=h,h){const T=(0,r.$fm)(F,0,h.count-1);this.F(T)}else this.m&&this.t.domFocus();this.s.tabIndex=h?0:-1}z(n){const h=this.c;if(!h)throw new Error("Cannot set focus when state is undefined");if(this.F(n),!(n<h.count-1)&&h.lastNodePartiallyVisible()){const F=h.stickyNodes[n];this.C(F.endIndex+1,h)}}C(n,h){const F=h.stickyNodes[h.count-1],T=h.count>1?h.stickyNodes[h.count-2]:void 0,P=this.t.getElementTop(n),q=T?T.position+T.height+F.height:F.height;this.t.scrollTop=P-q}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(n){if(0>n)throw new Error("addFocus() can not remove focus");if(!this.c&&n>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&n>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const h=this.a;h>=0&&this.G(this.b[h],!1),n>=0&&this.G(this.b[n],!0),this.a=n}G(n,h){n.classList.toggle("focused",h)}H(n){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",n)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ce(c){let n=f.TreeMouseEventTarget.Unknown;return(0,i.$pR)(c.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?n=f.TreeMouseEventTarget.Twistie:(0,i.$pR)(c.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?n=f.TreeMouseEventTarget.Element:(0,i.$pR)(c.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(n=f.TreeMouseEventTarget.Filter),{browserEvent:c.browserEvent,element:c.element?c.element.element:null,target:n}}function De(c){const n=(0,p.$jT)(c.browserEvent.target);return{element:c.element?c.element.element:null,browserEvent:c.browserEvent,anchor:c.anchor,isStickyScroll:n}}function Ne(c,n){n(c),c.children.forEach(h=>Ne(h,n))}class ye{get f(){return this.d||(this.d=this.m()),this.d}constructor(n,h){this.g=n,this.j=h,this.a=[],this.c=new k.$6d,this.onDidChange=this.c.event}set(n,h){!h?.__forceEvent&&(0,t.$ub)(this.a,n)||this.k(n,!1,h)}k(n,h,F){if(this.a=[...n],this.b=void 0,this.d=void 0,!h){const T=this;this.c.fire({get elements(){return T.get()},browserEvent:F})}}get(){return this.b||(this.b=this.a.map(n=>n.element)),[...this.b]}getNodes(){return this.a}has(n){return this.f.has(n)}onDidModelSplice({insertedNodes:n,deletedNodes:h}){if(!this.j){const ee=this.m(),be=we=>ee.delete(we);h.forEach(we=>Ne(we,be)),this.set([...ee.values()]);return}const F=new Set,T=ee=>F.add(this.j.getId(ee.element).toString());h.forEach(ee=>Ne(ee,T));const P=new Map,q=ee=>P.set(this.j.getId(ee.element).toString(),ee);n.forEach(ee=>Ne(ee,q));const Z=[];for(const ee of this.a){const be=this.j.getId(ee.element).toString();if(!F.has(be))Z.push(ee);else{const ke=P.get(be);ke&&ke.visible&&Z.push(ke)}}if(this.a.length>0&&Z.length===0){const ee=this.g();ee&&Z.push(ee)}this.k(Z,!0)}m(){const n=new Set;for(const h of this.a)n.add(h);return n}}class K extends p.$oT{constructor(n,h,F){super(n),this.x=h,this.y=F}u(n){if((0,p.$kT)(n.browserEvent.target)||(0,p.$dT)(n.browserEvent.target)||(0,p.$eT)(n.browserEvent.target)||n.browserEvent.isHandledByList)return;const h=n.element;if(!h)return super.u(n);if(this.p(n)||this.o(n))return super.u(n);const F=n.browserEvent.target,T=F.classList.contains("monaco-tl-twistie")||F.classList.contains("monaco-icon-label")&&F.classList.contains("folder-icon")&&n.browserEvent.offsetX<16,P=(0,p.$iT)(n.browserEvent.target);let q=!1;if(P?q=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?q=this.x.expandOnlyOnTwistieClick(h.element):q=!!this.x.expandOnlyOnTwistieClick,P)this.A(n,h);else{if(q&&!T&&n.browserEvent.detail!==2)return super.u(n);if(!this.x.expandOnDoubleClick&&n.browserEvent.detail===2)return super.u(n)}if(h.collapsible&&(!P||T)){const Z=this.x.getNodeLocation(h),ee=n.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,ee),q&&T){n.browserEvent.isHandledByList=!0;return}}P||super.u(n)}A(n,h){if((0,p.$fT)(n.browserEvent.target)||(0,p.$gT)(n.browserEvent.target))return;const F=this.y();if(!F)throw new Error("Sticky scroll controller not found");const T=this.k.indexOf(h),P=this.k.getElementTop(T),q=F.nodePositionTopBelowWidget(h);this.x.scrollTop=P-q,this.k.domFocus(),this.k.setFocus([T]),this.k.setSelection([T])}v(n){n.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||n.browserEvent.isHandledByList||super.v(n)}s(n){const h=n.browserEvent.target;if(!(0,p.$jT)(h)&&!(0,p.$iT)(h)){super.s(n);return}}t(n){const h=n.browserEvent.target;if(!(0,p.$jT)(h)&&!(0,p.$iT)(h)){super.t(n);return}}}class g extends p.$rT{constructor(n,h,F,T,P,q,Z,ee){super(n,h,F,T,ee),this.p=P,this.s=q,this.K=Z}D(n){return new K(this,n.tree,n.stickyScrollProvider)}splice(n,h,F=[]){if(super.splice(n,h,F),F.length===0)return;const T=[],P=[];let q;F.forEach((Z,ee)=>{this.p.has(Z)&&T.push(n+ee),this.s.has(Z)&&P.push(n+ee),this.K.has(Z)&&(q=n+ee)}),T.length>0&&super.setFocus((0,t.$Mb)([...super.getFocus(),...T])),P.length>0&&super.setSelection((0,t.$Mb)([...super.getSelection(),...P])),typeof q=="number"&&super.setAnchor(q)}setFocus(n,h,F=!1){super.setFocus(n,h),F||this.p.set(n.map(T=>this.element(T)),h)}setSelection(n,h,F=!1){super.setSelection(n,h),F||this.s.set(n.map(T=>this.element(T)),h)}setAnchor(n,h=!1){super.setAnchor(n),h||(typeof n>"u"?this.K.set([]):this.K.set([this.element(n)]))}}var E;(function(c){c[c.Tree=0]="Tree",c[c.StickyScroll=1]="StickyScroll"})(E||(e.AbstractTreePart=E={}));class N{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return k.Event.map(this.j.onMouseClick,ce)}get onMouseDblClick(){return k.Event.filter(k.Event.map(this.j.onMouseDblClick,ce),n=>n.target!==f.TreeMouseEventTarget.Filter)}get onContextMenu(){return k.Event.any(k.Event.filter(k.Event.map(this.j.onContextMenu,De),n=>!n.isStickyScroll),this.B?.onContextMenu??k.Event.None)}get onTap(){return k.Event.map(this.j.onTap,ce)}get onPointer(){return k.Event.map(this.j.onPointer,ce)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return k.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??ge.Highlight}set findMode(n){this.z&&(this.z.mode=n)}get findMatchType(){return this.z?.matchType??Fe.Fuzzy}set findMatchType(n){this.z&&(this.z.matchType=n)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:k.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(n,h,F,T,P={}){this.G=n,this.H=P,this.y=new k.$be,this.onDidChangeFindOpenState=k.Event.None,this.onDidChangeStickyScrollFocused=k.Event.None,this.D=new b.$Sc,this.E=new k.$6d,this.onWillRefilter=this.E.event,this.F=new k.$6d,this.onDidUpdateOptions=this.F.event,this.p=new V(F);const q=new k.$ce,Z=new k.$ce,ee=this.D.add(new M(Z.event)),be=new u.$Gc;this.k=T.map(Ae=>new X(Ae,()=>this.o,q.event,ee,be,P));for(const Ae of this.k)this.D.add(Ae);let we;P.keyboardNavigationLabelProvider&&(we=new U(this,P.keyboardNavigationLabelProvider,P.filter),P={...P,filter:we},this.D.add(we)),this.q=new ye(()=>this.j.getFocusedElements()[0],P.identityProvider),this.w=new ye(()=>this.j.getSelectedElements()[0],P.identityProvider),this.x=new ye(()=>this.j.getAnchorElement(),P.identityProvider),this.j=new g(n,h,this.p,this.k,this.q,this.w,this.x,{...H(()=>this.o,P),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(n,this.j,P),q.input=this.o.onDidChangeCollapseState;const ke=k.Event.forEach(this.o.onDidSplice,Ae=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Ae),this.w.onDidModelSplice(Ae)})},this.D);ke(()=>null,null,this.D);const Oe=this.D.add(new k.$6d),Ee=this.D.add(new s.$dh(0));if(this.D.add(k.Event.any(ke,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const Ae=new Set;for(const Re of this.q.getNodes())Ae.add(Re);for(const Re of this.w.getNodes())Ae.add(Re);Oe.fire([...Ae.values()])})})),Z.input=Oe.event,P.keyboardSupport!==!1){const Ae=k.Event.chain(this.j.onKeyDown,Re=>Re.filter(Ie=>!(0,p.$dT)(Ie.target)).map(Ie=>new j.$QQ(Ie)));k.Event.chain(Ae,Re=>Re.filter(Ie=>Ie.keyCode===15))(this.J,this,this.D),k.Event.chain(Ae,Re=>Re.filter(Ie=>Ie.keyCode===17))(this.K,this,this.D),k.Event.chain(Ae,Re=>Re.filter(Ie=>Ie.keyCode===10))(this.L,this,this.D)}if((P.findWidgetEnabled??!0)&&P.keyboardNavigationLabelProvider&&P.contextViewProvider){const Ae=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Be(this,this.o,this.j,we,P.contextViewProvider,Ae),this.A=Re=>this.z.shouldAllowFocus(Re),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=k.Event.None,this.onDidChangeFindMatchType=k.Event.None;P.enableStickyScroll&&(this.B=new J(this,this.o,this.j,this.k,this.p,P),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,i.$CR)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}updateOptions(n={}){this.H={...this.H,...n};for(const h of this.k)h.updateOptions(n);this.j.updateOptions(this.H),this.z?.updateOptions(n),this.I(n),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===L.Always)}get options(){return this.H}I(n){!this.B&&this.H.enableStickyScroll?(this.B=new J(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=k.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(n)}updateWidth(n){const h=this.o.getListIndex(n);h!==-1&&this.j.updateWidth(h)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(n){this.j.scrollTop=n}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(n){this.j.scrollLeft=n}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let n=this.j.firstVisibleIndex;return this.B&&(n+=this.B.count),n<0||n>=this.j.length?void 0:this.j.element(n).element}get lastVisibleElement(){const n=this.j.lastVisibleIndex;return this.j.element(n).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(n){this.j.ariaLabel=n}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,i.$uR)(this.getHTMLElement())}layout(n,h){this.j.layout(n,h),(0,A.$Xf)(h)&&this.z?.layout(h)}style(n){const h=`.${this.j.domId}`,F=[];n.treeIndentGuidesStroke&&(F.push(`.monaco-list${h}:hover .monaco-tl-indent > .indent-guide, .monaco-list${h}.always .monaco-tl-indent > .indent-guide  { border-color: ${n.treeInactiveIndentGuidesStroke}; }`),F.push(`.monaco-list${h} .monaco-tl-indent > .indent-guide.active { border-color: ${n.treeIndentGuidesStroke}; }`)),n.listBackground&&(F.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${n.listBackground}; }`),F.push(`.monaco-list${h} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${n.listBackground}; }`)),n.listFocusForeground&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${n.listFocusForeground}; }`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const T=(0,i.$aS)(n.listFocusAndSelectionOutline,(0,i.$aS)(n.listSelectionOutline,n.listFocusOutline??""));T&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${T}; outline-offset: -1px;}`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),n.listFocusOutline&&(F.push(`.monaco-list${h}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${n.listFocusOutline}; outline-offset: -1px; }`),F.push(`.monaco-list${h}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),F.push(`.monaco-workbench.context-menu-visible .monaco-list${h}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=F.join(`
`),this.j.style(n)}getParentElement(n){const h=this.o.getParentNodeLocation(n);return this.o.getNode(h).element}getFirstElementChild(n){return this.o.getFirstElementChild(n)}getNode(n){return this.o.getNode(n)}getNodeLocation(n){return this.o.getNodeLocation(n)}collapse(n,h=!1){return this.o.setCollapsed(n,!0,h)}expand(n,h=!1){return this.o.setCollapsed(n,!1,h)}toggleCollapsed(n,h=!1){return this.o.setCollapsed(n,void 0,h)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(n){return this.o.isCollapsible(n)}setCollapsible(n,h){return this.o.setCollapsible(n,h)}isCollapsed(n){return this.o.isCollapsed(n)}expandTo(n){this.o.expandTo(n)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(n){if(typeof n>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const h=this.o.getNode(n);this.x.set([h]);const F=this.o.getListIndex(n);F>-1&&this.j.setAnchor(F,!0)})}getAnchor(){return(0,t.$Ob)(this.x.get(),void 0)}setSelection(n,h){this.y.bufferEvents(()=>{const F=n.map(P=>this.o.getNode(P));this.w.set(F,h);const T=n.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setSelection(T,h,!0)})}getSelection(){return this.w.get()}setFocus(n,h){this.y.bufferEvents(()=>{const F=n.map(P=>this.o.getNode(P));this.q.set(F,h);const T=n.map(P=>this.o.getListIndex(P)).filter(P=>P>-1);this.j.setFocus(T,h,!0)})}focusNext(n=1,h=!1,F,T=(0,i.$KR)(F)&&F.altKey?void 0:this.A){this.j.focusNext(n,h,F,T)}focusPrevious(n=1,h=!1,F,T=(0,i.$KR)(F)&&F.altKey?void 0:this.A){this.j.focusPrevious(n,h,F,T)}focusNextPage(n,h=(0,i.$KR)(n)&&n.altKey?void 0:this.A){return this.j.focusNextPage(n,h)}focusPreviousPage(n,h=(0,i.$KR)(n)&&n.altKey?void 0:this.A){return this.j.focusPreviousPage(n,h,()=>this.B?.height??0)}focusLast(n,h=(0,i.$KR)(n)&&n.altKey?void 0:this.A){this.j.focusLast(n,h)}focusFirst(n,h=(0,i.$KR)(n)&&n.altKey?void 0:this.A){this.j.focusFirst(n,h)}getFocus(){return this.q.get()}getStickyScrollFocus(){const n=this.B?.getFocus();return n!==void 0?[n]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(n,h){this.o.expandTo(n);const F=this.o.getListIndex(n);if(F!==-1)if(!this.B)this.j.reveal(F,h);else{const T=this.B.nodePositionTopBelowWidget(this.getNode(n));this.j.reveal(F,h,T)}}getRelativeTop(n){const h=this.o.getListIndex(n);if(h===-1)return null;const F=this.B?.getNode(this.getNode(n));return this.j.getRelativeTop(h,F?.position??this.B?.height)}getViewState(n=this.options.identityProvider){if(!n)throw new f.$6U(this.G,"Can't get tree view state without an identity provider");const h=q=>n.getId(q).toString(),F=S.empty(this.scrollTop);for(const q of this.getFocus())F.focus.add(h(q));for(const q of this.getSelection())F.selection.add(h(q));const T=this.o.getNode(),P=[T];for(;P.length>0;){const q=P.shift();q!==T&&q.collapsible&&(F.expanded[h(q.element)]=q.collapsed?0:1),P.push(...q.children)}return F}J(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],T=this.o.getNodeLocation(F);if(!this.o.setCollapsed(T,!0)){const q=this.o.getParentNodeLocation(T);if(!q)return;const Z=this.o.getListIndex(q);this.j.reveal(Z),this.j.setFocus([Z])}}K(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],T=this.o.getNodeLocation(F);if(!this.o.setCollapsed(T,!1)){if(!F.children.some(ee=>ee.visible))return;const[q]=this.j.getFocus(),Z=q+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(n){n.preventDefault(),n.stopPropagation();const h=this.j.getFocusedElements();if(h.length===0)return;const F=h[0],T=this.o.getNodeLocation(F),P=n.browserEvent.altKey;this.o.setCollapsed(T,void 0,P)}navigate(n){return new o(this.j,this.o,n)}dispose(){(0,b.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}e.$dV=N;class o{constructor(n,h,F){this.b=n,this.c=h,F?this.a=this.c.getListIndex(F):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[136],$e([1,0,135,127,27,29]),function(re,e,i,C,j,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oV=void 0;class D extends i.$dV{constructor($,p,w,B,f,d={}){super($,p,w,B,d),this.f=$,this.g=f,this.d=new Map,this.c=d.identityProvider}getInput(){return this.b}setInput($,p){if(p&&!this.c)throw new j.$6U(this.f,"Can't restore tree view state without an identity provider");if(this.b=$,!$){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!p){this.m($);return}const w=[],B=[],f=t=>{const s=this.c.getId(t).toString();return!p.expanded[s]},d=t=>{const s=this.c.getId(t.element).toString();p.focus.has(s)&&w.push(t.element),p.selection.has(s)&&B.push(t.element)};this.m($,f,d),this.setFocus(w),this.setSelection(B),p&&typeof p.scrollTop=="number"&&(this.scrollTop=p.scrollTop)}updateChildren($=this.b){if(typeof this.b>"u")throw new j.$6U(this.f,"Tree input not set");let p;this.c&&(p=w=>{const B=this.c.getId(w).toString(),f=this.d.get(B);if(f)return f.collapsed}),this.m($,p)}resort($=this.b,p=!0){this.o.resort($===this.b?null:$,p)}refresh($){if($===void 0){this.j.rerender();return}this.o.rerender($)}m($,p,w){let B;if(this.c){const f=new Set,d=w;w=t=>{const s=this.c.getId(t.element).toString();f.add(s),this.d.set(s,t),d?.(t)},B=t=>{const s=this.c.getId(t.element).toString();f.has(s)||this.d.delete(s)}}this.o.setChildren($===this.b?null:$,this.s($,p).elements,{onDidCreateNode:w,onDidDeleteNode:B})}s($,p){const w=[...this.g.getChildren($)];return{elements:W.Iterable.map(w,f=>{const{elements:d,size:t}=this.s(f,p),s=this.g.hasChildren?this.g.hasChildren(f):void 0,a=t===0?void 0:p&&p(f);return{element:f,children:d,collapsible:s,collapsed:a}}),size:w.length}}M($,p,w){return new C.$eV($,p,w)}}e.$oV=D}),define(me[70],$e([1,0,12,9,35,30,28,6,4,3,56,10,7]),function(re,e,i,C,j,W,D,y,$,p,w,B,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var d;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(d||(d={}));function t(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(s||(s={}));function a(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(m||(m={}));function u(le){let _=0;for(let ae=0;;ae+=7){const oe=le.read(1);if(_|=(oe.buffer[0]&127)<<ae,!(oe.buffer[0]&128))return _}}const k=R(0);function l(le,_){if(_===0){le.write(k);return}let ae=0;for(let J=_;J!==0;J=J>>>7)ae++;const oe=j.$te.alloc(ae);for(let J=0;_!==0;J++)oe.buffer[J]=_&127,_=_>>>7,_>0&&(oe.buffer[J]|=128);le.write(oe)}class b{constructor(_){this.b=_,this.a=0}read(_){const ae=this.b.slice(this.a,this.a+_);return this.a+=ae.byteLength,ae}}e.$Qh=b;class r{constructor(){this.a=[]}get buffer(){return j.$te.concat(this.a)}write(_){this.a.push(_)}}e.$Rh=r;var A;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(A||(A={}));function R(le){const _=j.$te.alloc(1);return _.writeUInt8(le,0),_}const I={Undefined:R(A.Undefined),String:R(A.String),Buffer:R(A.Buffer),VSBuffer:R(A.VSBuffer),Array:R(A.Array),Object:R(A.Object),Uint:R(A.Int)},O=typeof Buffer<"u";function z(le,_){if(typeof _>"u")le.write(I.Undefined);else if(typeof _=="string"){const ae=j.$te.fromString(_);le.write(I.String),l(le,ae.byteLength),le.write(ae)}else if(O&&Buffer.isBuffer(_)){const ae=j.$te.wrap(_);le.write(I.Buffer),l(le,ae.byteLength),le.write(ae)}else if(_ instanceof j.$te)le.write(I.VSBuffer),l(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(I.Array),l(le,_.length);for(const ae of _)z(le,ae)}else if(typeof _=="number"&&(_|0)===_)le.write(I.Uint),l(le,_);else{const ae=j.$te.fromString(JSON.stringify(_));le.write(I.Object),l(le,ae.byteLength),le.write(ae)}}e.$Sh=z;function v(le){switch(le.read(1).readUInt8(0)){case A.Undefined:return;case A.String:return le.read(u(le)).toString();case A.Buffer:return le.read(u(le)).buffer;case A.VSBuffer:return le.read(u(le));case A.Array:{const ae=u(le),oe=[];for(let J=0;J<ae;J++)oe.push(v(le));return oe}case A.Object:return JSON.parse(le.read(u(le)).toString());case A.Int:return u(le)}}e.$Th=v;class H{constructor(_,ae,oe=null,J=1e3){this.h=_,this.j=ae,this.k=oe,this.l=J,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(_,ae){this.b.set(_,ae),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ae=this.o([_.type]);this.k?.logOutgoing(ae,0,1,a(_.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ae,_.id,1,a(_.type),_.data);return}}}o(_,ae=void 0){const oe=new r;return z(oe,_),z(oe,ae),this.p(oe.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ae=new b(_),oe=v(ae),J=v(ae),G=oe[0];switch(G){case 100:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}: ${oe[2]}.${oe[3]}`,J),this.s({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 102:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}: ${oe[2]}.${oe[3]}`,J),this.t({type:G,id:oe[1],channelName:oe[2],name:oe[3],arg:J});case 101:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}`),this.u({type:G,id:oe[1]});case 103:return this.k?.logIncoming(_.byteLength,oe[1],1,`${t(G)}`),this.u({type:G,id:oe[1]})}}s(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=new W.$de;let J;try{J=ae.call(this.j,_.name,_.arg,oe.token)}catch(ce){J=Promise.reject(ce)}const G=_.id;J.then(ce=>{this.m({id:G,data:ce,type:201})},ce=>{ce instanceof Error?this.m({id:G,data:{message:ce.message,name:ce.name,stack:ce.stack?ce.stack.split?ce.stack.split(`
`):ce.stack:void 0},type:202}):this.m({id:G,data:ce,type:203})}).finally(()=>{ie.dispose(),this.d.delete(_.id)});const ie=(0,p.$Rc)(()=>oe.cancel());this.d.set(_.id,ie)}t(_){const ae=this.b.get(_.channelName);if(!ae){this.v(_);return}const oe=_.id,G=ae.listen(this.j,_.name,_.arg)(ie=>this.m({id:oe,data:ie,type:204}));this.d.set(_.id,G)}u(_){const ae=this.d.get(_.id);ae&&(ae.dispose(),this.d.delete(_.id))}v(_){let ae=this.g.get(_.channelName);ae||(ae=[],this.g.set(_.channelName,ae));const oe=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:_,timeoutTimer:oe})}w(_){const ae=this.g.get(_);if(ae){for(const oe of ae)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=H;var V;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(V||(e.RequestInitiator=V={}));class S{constructor(_,ae=null){this.l=_,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ae}getChannel(_){const ae=this;return{call(oe,J,G){return ae.a?Promise.reject(new y.$5):ae.m(_,oe,J,G)},listen(oe,J){return ae.a?$.Event.None:ae.o(_,oe,J)}}}m(_,ae,oe,J=W.CancellationToken.None){const G=this.g++,ce={id:G,type:100,channelName:_,name:ae,arg:oe};if(J.isCancellationRequested)return Promise.reject(new y.$5);let De;return new Promise((ye,K)=>{if(J.isCancellationRequested)return K(new y.$5);const g=()=>{const c=n=>{switch(n.type){case 201:this.f.delete(G),ye(n.data);break;case 202:{this.f.delete(G);const h=new Error(n.data.message);h.stack=Array.isArray(n.data.stack)?n.data.stack.join(`
`):n.data.stack,h.name=n.data.name,K(h);break}case 203:this.f.delete(G),K(n.data);break}};this.f.set(G,c),this.p(ce)};let E=null;this.b===m.Idle?g():(E=(0,C.$6g)(c=>this.u()),E.then(()=>{E=null,g()}));const N=()=>{E?(E.cancel(),E=null):this.p({id:G,type:101}),K(new y.$5)},o=J.onCancellationRequested(N);De=(0,p.$Qc)((0,p.$Rc)(N),o),this.d.add(De)}).finally(()=>{De.dispose(),this.d.delete(De)})}o(_,ae,oe){const J=this.g++,ie={id:J,type:102,channelName:_,name:ae,arg:oe};let ce=null;const De=new $.$6d({onWillAddFirstListener:()=>{ce=(0,C.$6g)(ye=>this.u()),ce.then(()=>{ce=null,this.d.add(De),this.p(ie)})},onDidRemoveLastListener:()=>{ce?(ce.cancel(),ce=null):(this.d.delete(De),this.p({id:J,type:103}))}}),Ne=ye=>De.fire(ye.data);return this.f.set(J,Ne),De.event}p(_){switch(_.type){case 100:case 102:{const ae=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ae,_.id,0,`${t(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ae=this.q([_.type,_.id]);this.j?.logOutgoing(ae,_.id,0,t(_.type));return}}}q(_,ae=void 0){const oe=new r;return z(oe,_),z(oe,ae),this.r(oe.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ae=new b(_),oe=v(ae),J=v(ae),G=oe[0];switch(G){case 200:return this.j?.logIncoming(_.byteLength,0,0,a(G)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,oe[1],0,a(G),J),this.t({type:oe[0],id:oe[1],data:J})}}t(_){if(_.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=S,Je([D.$Kh],S.prototype,"onDidInitializePromise",null);class L{get connections(){const _=[];return this.f.forEach(ae=>_.push(ae)),_}constructor(_){this.a=new Map,this.f=new Set,this.g=new $.$6d,this.onDidAddConnection=this.g.event,this.h=new $.$6d,this.onDidRemoveConnection=this.h.event,this.j=new p.$Sc,this.j.add(_(({protocol:ae,onDidClientDisconnect:oe})=>{const J=$.Event.once(ae.onMessage);this.j.add(J(G=>{const ie=new b(G),ce=v(ie),De=new H(ae,ce),Ne=new S(ae);this.a.forEach((K,g)=>De.registerChannel(g,K));const ye={channelServer:De,channelClient:Ne,ctx:ce};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{De.dispose(),Ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(_,ae){const oe=this;return{call(J,G,ie){let ce;if((0,f.$8f)(ae)){const Ne=(0,i.$4b)(oe.connections.filter(ae));ce=Ne?Promise.resolve(Ne):$.Event.toPromise($.Event.filter(oe.onDidAddConnection,ae))}else ce=ae.routeCall(oe,J,G);const De=ce.then(Ne=>Ne.channelClient.getChannel(_));return X(De).call(J,G,ie)},listen(J,G){if((0,f.$8f)(ae))return oe.k(_,ae,J,G);const ie=ae.routeEvent(oe,J,G).then(ce=>ce.channelClient.getChannel(_));return X(ie).listen(J,G)}}}k(_,ae,oe,J){const G=this;let ie;const ce=new $.$6d({onWillAddFirstListener:()=>{ie=new p.$Sc;const De=new $.$_d,Ne=new Map,ye=g=>{const N=g.channelClient.getChannel(_).listen(oe,J),o=De.add(N);Ne.set(g,o)},K=g=>{const E=Ne.get(g);E&&(E.dispose(),Ne.delete(g))};G.connections.filter(ae).forEach(ye),$.Event.filter(G.onDidAddConnection,ae)(ye,void 0,ie),G.onDidRemoveConnection(K,void 0,ie),De.event(ce.fire,ce,ie),ie.add(De)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return ce.event}registerChannel(_,ae){this.a.set(_,ae);for(const oe of this.f)oe.channelServer.registerChannel(_,ae)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=L;class M{constructor(_,ae,oe=null){const J=new r;z(J,ae),_.send(J.buffer),this.a=new S(_,oe),this.d=new H(_,ae,oe)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ae){this.d.registerChannel(_,ae)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=M;function X(le){return{call(_,ae,oe){return le.then(J=>J.call(_,ae,oe))},listen(_,ae){const oe=new $.$ce;return le.then(J=>oe.input=J.listen(_,ae)),oe.event}}}e.$Yh=X;function U(le){let _=!1;return{call(ae,oe,J){return _?le.call(ae,oe,J):(0,C.$hh)(0).then(()=>_=!0).then(()=>le.call(ae,oe,J))},listen(ae,oe){if(_)return le.listen(ae,oe);const J=new $.$ce;return(0,C.$hh)(0).then(()=>_=!0).then(()=>J.input=le.listen(ae,oe)),J.event}}}e.$Zh=U;class de{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ae of _.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await $.Event.toPromise(_.onDidAddConnection),await this.b(_)}}e.$1h=de;var he;(function(le){function _(G,ie,ce){const De=G,Ne=ce&&ce.disableMarshalling,ye=new Map;for(const K in De)oe(K)&&ye.set(K,$.Event.buffer(De[K],!0,void 0,ie));return new class{listen(K,g,E){const N=ye.get(g);if(N)return N;const o=De[g];if(typeof o=="function"){if(J(g))return o.call(De,E);if(oe(g))return ye.set(g,$.Event.buffer(De[g],!0,void 0,ie)),ye.get(g)}throw new y.$bb(`Event not found: ${g}`)}call(K,g,E){const N=De[g];if(typeof N=="function"){if(!Ne&&Array.isArray(E))for(let c=0;c<E.length;c++)E[c]=(0,w.$Ph)(E[c]);let o=N.apply(De,E);return o instanceof Promise||(o=Promise.resolve(o)),o}throw new y.$bb(`Method not found: ${g}`)}}}le.fromService=_;function ae(G,ie){const ce=ie&&ie.disableMarshalling;return new Proxy({},{get(De,Ne){if(typeof Ne=="string")return ie?.properties?.has(Ne)?ie.properties.get(Ne):J(Ne)?function(ye){return G.listen(Ne,ye)}:oe(Ne)?G.listen(Ne):async function(...ye){let K;ie&&!(0,f.$3f)(ie.context)?K=[ie.context,...ye]:K=ye;const g=await G.call(Ne,K);return ce?g:(0,w.$Ph)(g)};throw new y.$bb(`Property not found: ${String(Ne)}`)}})}le.toService=ae;function oe(G){return G[0]==="o"&&G[1]==="n"&&B.$jf(G.charCodeAt(2))}function J(G){return/^onDynamic/.test(G)&&B.$jf(G.charCodeAt(9))}})(he||(e.ProxyChannel=he={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function Fe(le){return Array.isArray(le)?le.map(ge):ge(le)}function Ce(le,_,ae,oe,J,G,ie){ie=Fe(ie);const ce=ne[J],De=ce[oe%ce.length];let Ne=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(G)?(Ne=Ne.concat(ie),Ne.push(")")):Ne.push(ie),console.log.apply(console,Ne)}class Be{constructor(_,ae){this.d=_,this.f=ae,this.a=0,this.b=0}logOutgoing(_,ae,oe,J,G){this.b+=_,Ce(this.d,this.b,_,ae,oe,J,G)}logIncoming(_,ae,oe,J,G){this.a+=_,Ce(this.f,this.a,_,ae,oe,J,G)}}e.$2h=Be}),define(me[137],$e([1,0,35,4,70,94,31]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZV=void 0;class y extends j.$Xh{static f(){const p=C.Event.fromNodeEventEmitter(D.$O,"vscode:message",(w,B)=>i.$te.wrap(B));return D.$O.send("vscode:hello"),new W.$VV(D.$O,p)}constructor(p){const w=y.f();super(w,p),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}e.$ZV=y}),define(me[138],$e([13,11]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(me[139],$e([13,11]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(me[44],$e([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var i;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function y($){return $[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=y})(i||(e._util=i={})),e.$fi=j("instantiationService");function C(D,y,$){y[i.DI_TARGET]===y?y[i.DI_DEPENDENCIES].push({id:D,index:$}):(y[i.DI_DEPENDENCIES]=[{id:D,index:$}],y[i.DI_TARGET]=y)}function j(D){if(i.serviceIds.has(D))return i.serviceIds.get(D);const y=function($,p,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(y,$,w)};return y.toString=()=>D,i.serviceIds.set(D,y),y}e.$gi=j;function W(D){return D}e.$hi=W}),define(me[140],$e([1,0,44]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Zm=e.$Ym=e.ID=void 0,e.ID="diagnosticsService",e.$Ym=(0,i.$gi)(e.ID);function C(W){return!!W.hostName&&!!W.errorMessage}e.$Zm=C;class j{async getPerformanceInfo(D,y){return{}}async getSystemInfo(D,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,y){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$1m=j}),define(me[141],$e([1,0,91,25,10,7,15,138,44,5,32,23]),function(re,e,i,C,j,W,D,y,$,p,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,$.$gi)("fileService");function f(J){return J.create===!0}e.$Hk=f;var d;(function(J){J[J.Unknown=0]="Unknown",J[J.File=1]="File",J[J.Directory=2]="Directory",J[J.SymbolicLink=64]="SymbolicLink"})(d||(e.FileType=d={}));var t;(function(J){J[J.Readonly=1]="Readonly",J[J.Locked=2]="Locked"})(t||(e.FilePermission=t={}));function s(J){const G=J;return!!G&&typeof G.onDidChange=="function"}e.$Ik=s;var a;(function(J){J[J.None=0]="None",J[J.FileReadWrite=2]="FileReadWrite",J[J.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",J[J.FileReadStream=16]="FileReadStream",J[J.FileFolderCopy=8]="FileFolderCopy",J[J.PathCaseSensitive=1024]="PathCaseSensitive",J[J.Readonly=2048]="Readonly",J[J.Trash=4096]="Trash",J[J.FileWriteUnlock=8192]="FileWriteUnlock",J[J.FileAtomicRead=16384]="FileAtomicRead",J[J.FileAtomicWrite=32768]="FileAtomicWrite",J[J.FileAtomicDelete=65536]="FileAtomicDelete",J[J.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function m(J){return!!(J.capabilities&2)}e.$Jk=m;function u(J){return!!(J.capabilities&8)}e.$Kk=u;function k(J){return!!(J.capabilities&131072)}e.$Lk=k;function l(J){return!!(J.capabilities&4)}e.$Mk=l;function b(J){return!!(J.capabilities&16)}e.$Nk=b;function r(J){return m(J)?!!(J.capabilities&16384):!1}e.$Ok=r;function A(J){return m(J)?!!(J.capabilities&32768):!1}e.$Pk=A;function R(J){return!!(J.capabilities&65536)}e.$Qk=R;function I(J){return!!(J.capabilities&2048)}e.$Rk=I;var O;(function(J){J.FileExists="EntryExists",J.FileNotFound="EntryNotFound",J.FileNotADirectory="EntryNotADirectory",J.FileIsADirectory="EntryIsADirectory",J.FileExceedsStorageQuota="EntryExceedsStorageQuota",J.FileTooLarge="EntryTooLarge",J.FileWriteLocked="EntryWriteLocked",J.NoPermissions="NoPermissions",J.Unavailable="Unavailable",J.Unknown="Unknown"})(O||(e.FileSystemProviderErrorCode=O={}));class z extends Error{static create(G,ie){const ce=new z(G.toString(),ie);return V(ce,ie),ce}constructor(G,ie){super(G),this.code=ie}}e.$Sk=z;function v(J,G){return z.create(J,G)}e.$Tk=v;function H(J){return J||v((0,y.localize)(0,null),O.Unknown)}e.$Uk=H;function V(J,G){return J.name=G?`${G} (FileSystemError)`:"FileSystemError",J}e.$Vk=V;function S(J){if(!J)return O.Unknown;if(J instanceof z)return J.code;const G=/^(.+) \(FileSystemError\)$/.exec(J.name);if(!G)return O.Unknown;switch(G[1]){case O.FileExists:return O.FileExists;case O.FileIsADirectory:return O.FileIsADirectory;case O.FileNotADirectory:return O.FileNotADirectory;case O.FileNotFound:return O.FileNotFound;case O.FileTooLarge:return O.FileTooLarge;case O.FileWriteLocked:return O.FileWriteLocked;case O.NoPermissions:return O.NoPermissions;case O.Unavailable:return O.Unavailable}return O.Unknown}e.$Wk=S;function L(J){if(J instanceof ne)return J.fileOperationResult;switch(S(J)){case O.FileNotFound:return 1;case O.FileIsADirectory:return 0;case O.FileNotADirectory:return 9;case O.FileWriteLocked:return 5;case O.NoPermissions:return 6;case O.FileExists:return 4;case O.FileTooLarge:return 7;default:return 10}}e.$Xk=L;var M;(function(J){J[J.CREATE=0]="CREATE",J[J.DELETE=1]="DELETE",J[J.MOVE=2]="MOVE",J[J.COPY=3]="COPY",J[J.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class X{constructor(G,ie,ce){this.resource=G,this.operation=ie,this.target=ce}isOperation(G){return this.operation===G}}e.$Yk=X;var U;(function(J){J[J.UPDATED=0]="UPDATED",J[J.ADDED=1]="ADDED",J[J.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class de{static{this.a=null}constructor(G,ie){this.c=ie,this.b=void 0,this.d=new B.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawAdded.map(De=>[De,!0])),ce}),this.f=new B.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(De=>[De,!0])),ce}),this.g=new B.$V(()=>{const ce=i.$mi.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(De=>[De,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of G){switch(ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}this.b!==de.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=de.a):this.b!==void 0&&(this.b=de.a))}}contains(G,...ie){return this.h(G,{includeChildren:!1},...ie)}affects(G,...ie){return this.h(G,{includeChildren:!0},...ie)}h(G,ie,...ce){if(!G)return!1;const De=ce.length>0;return!!((!De||ce.includes(1))&&(this.d.value.get(G)||ie.includeChildren&&this.d.value.findSuperstr(G))||(!De||ce.includes(0))&&(this.f.value.get(G)||ie.includeChildren&&this.f.value.findSuperstr(G))||(!De||ce.includes(2))&&(this.g.value.findSubstr(G)||ie.includeChildren&&this.g.value.findSuperstr(G)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(G){return this.b===G}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=de;function he(J,G,ie){return!J||!G||J===G||G.length>J.length?!1:(G.charAt(G.length-1)!==C.sep&&(G+=C.sep),ie?(0,j.$lf)(J,G):J.indexOf(G)===0)}e.$1k=he;class ne extends Error{constructor(G,ie,ce){super(G),this.fileOperationResult=ie,this.options=ce}}e.$2k=ne;class ge extends ne{constructor(G,ie,ce,De){super(G,ie,De),this.fileOperationResult=ie,this.size=ce}}e.$3k=ge;class Fe extends ne{constructor(G,ie,ce){super(G,2,ce),this.stat=ie}}e.$4k=Fe;var Ce;(function(J){J[J.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",J[J.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",J[J.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",J[J.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",J[J.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",J[J.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",J[J.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",J[J.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",J[J.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",J[J.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",J[J.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ce||(e.FileOperationResult=Ce={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var Be;(function(J){J[J.FILE=0]="FILE",J[J.FOLDER=1]="FOLDER",J[J.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(e.FileKind=Be={})),e.$_k="";function le(J){if(!(typeof J.size!="number"||typeof J.mtime!="number"))return J.mtime.toString(29)+J.size.toString(31)}e.$al=le;async function _(J,G){if(!G.hasProvider(D.URI.from({scheme:J.scheme})))return new Promise(ie=>{const ce=G.onDidChangeFileSystemProviderRegistrations(De=>{De.scheme===J.scheme&&De.added&&(ce.dispose(),ie())})})}e.$bl=_;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(G){return(0,W.$Xf)(G)||(G=0),G<ae.KB?(0,y.localize)(1,null,G.toFixed(0)):G<ae.MB?(0,y.localize)(2,null,(G/ae.KB).toFixed(2)):G<ae.GB?(0,y.localize)(3,null,(G/ae.MB).toFixed(2)):G<ae.TB?(0,y.localize)(4,null,(G/ae.GB).toFixed(2)):(0,y.localize)(5,null,(G/ae.TB).toFixed(2))}}e.$cl=ae;function oe(J){const G=typeof J=="string"||J?.scheme===w.Schemas.vscodeRemote;return typeof J!="string"&&J?.scheme===w.Schemas.file?1024*ae.MB:G?10*ae.MB:p.$o?50*ae.MB:1024*ae.MB}e.$dl=oe}),define(me[142],$e([1,0,44]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ac=e.$Zac=void 0,e.$Zac=(0,i.$gi)("mainProcessService");class C{constructor(W,D){this.a=W,this.b=D}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,D){this.a.registerChannel(W,D)}}e.$1ac=C}),define(me[143],$e([1,0,3,137]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ac=void 0;class j extends i.$Tc{constructor(D){super(),this.a=this.B(new C.$ZV(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,y){this.a.registerChannel(D,y)}}e.$2ac=j});var yi=this&&this.__param||function(re,e){return function(i,C){e(i,C,re)}};define(me[144],$e([1,0,70,142]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=void 0;let j=class{constructor(D,y){return this.windowId=D,i.ProxyChannel.toService(y.getChannel("nativeHost"),{context:D,properties:(()=>{const $=new Map;return $.set("windowId",D),$})()})}};e.$6ac=j,e.$6ac=j=Je([yi(1,C.$Zac)],j)}),define(me[71],$e([1,0,79,7]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class j{constructor(){this.a=new Map}add(D,y){i.ok(C.$Tf(D)),i.ok(C.$Vf(y)),i.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,y)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Xn=new j}),define(me[145],$e([1,0,4,71]),function(re,e,i,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function j(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class W{constructor(){this.b=new i.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,p){this.a[j($)]=p,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const D=new W;C.$Xn.add(e.$Yn.JSONContribution,D)}),define(me[146],$e([1,0,9,18,37,19,4,7,15,139,145,71]),function(re,e,i,C,j,W,D,y,$,p,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.IconFontDefinition=e.IconContribution=e.$Mw=void 0,e.$Mw={IconContribution:"base.contributions.icons"};var f;(function(b){function r(A,R){let I=A.defaults;for(;W.ThemeIcon.isThemeIcon(I);){const O=s.getIcon(I.id);if(!O)return;I=O.defaults}return I}b.getDefinition=r})(f||(e.IconContribution=f={}));var d;(function(b){function r(R){return{weight:R.weight,style:R.style,src:R.src.map(I=>({format:I.format,location:I.location.toString()}))}}b.toJSONObject=r;function A(R){const I=O=>(0,y.$Tf)(O)?O:void 0;if(R&&Array.isArray(R.src)&&R.src.every(O=>(0,y.$Tf)(O.format)&&(0,y.$Tf)(O.location)))return{weight:I(R.weight),style:I(R.style),src:R.src.map(O=>({format:O.format,location:$.URI.parse(O.location)}))}}b.fromJSONObject=A})(d||(e.IconFontDefinition=d={}));class t{constructor(){this.a=new D.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,p.localize)(0,null)},fontCharacter:{type:"string",description:(0,p.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${W.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,A,R,I){const O=this.b[r];if(O){if(R&&!O.description){O.description=R,this.d.properties[r].markdownDescription=`${R} $(${r})`;const H=this.e.enum.indexOf(r);H!==-1&&(this.e.enumDescriptions[H]=R),this.a.fire()}return O}const z={id:r,description:R,defaults:A,deprecationMessage:I};this.b[r]=z;const v={$ref:"#/definitions/icons"};return I&&(v.deprecationMessage=I),R&&(v.markdownDescription=`${R}: $(${r})`),this.d.properties[r]=v,this.e.enum.push(r),this.e.enumDescriptions.push(R||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const A=this.e.enum.indexOf(r);A!==-1&&(this.e.enum.splice(A,1),this.e.enumDescriptions.splice(A,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,A){const R=this.f[r];return R||(this.f[r]=A,this.a.fire(),A)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(O,z)=>O.id.localeCompare(z.id),A=O=>{for(;W.ThemeIcon.isThemeIcon(O.defaults);)O=this.b[O.defaults.id];return`codicon codicon-${O?O.id:""}`},R=[];R.push("| preview     | identifier                        | default codicon ID                | description"),R.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const I=Object.keys(this.b).map(O=>this.b[O]);for(const O of I.filter(z=>!!z.description).sort(r))R.push(`|<i class="${A(O)}"></i>|${O.id}|${W.ThemeIcon.isThemeIcon(O.defaults)?O.defaults.id:O.id}|${O.description||""}|`);R.push("| preview     | identifier                        "),R.push("| ----------- | --------------------------------- |");for(const O of I.filter(z=>!W.ThemeIcon.isThemeIcon(z.defaults)).sort(r))R.push(`|<i class="${A(O)}"></i>|${O.id}|`);return R.join(`
`)}}const s=new t;B.$Xn.add(e.$Mw.IconContribution,s);function a(b,r,A,R){return s.registerIcon(b,r,A,R)}e.$Nw=a;function m(){return s}e.$Ow=m;function u(){const b=(0,j.$lk)();for(const r in b){const A="\\"+b[r].toString(16);s.registerIcon(r,{fontCharacter:A})}}u(),e.$Pw="vscode://schemas/icons";const k=B.$Xn.as(w.$Yn.JSONContribution);k.registerSchema(e.$Pw,s.getIconSchema());const l=new i.$sh(()=>k.notifySchemaChanged(e.$Pw),200);s.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.$Qw=a("widget-close",C.$pk.close,(0,p.localize)(2,null)),e.$Rw=a("goto-previous-location",C.$pk.arrowUp,(0,p.localize)(3,null)),e.$Sw=a("goto-next-location",C.$pk.arrowDown,(0,p.localize)(4,null)),e.$Tw=W.ThemeIcon.modify(C.$pk.sync,"spin"),e.$Uw=W.ThemeIcon.modify(C.$pk.loading,"spin")}),define(me[147],$e([1,0,2,4,3,19,146]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aHb=e.$_Gb=void 0;function y(p){const w=new j.$Sc,B=w.add(new C.$6d),f=(0,D.$Ow)();return w.add(f.onDidChange(()=>B.fire())),p&&w.add(p.onDidProductIconThemeChange(()=>B.fire())),{dispose:()=>w.dispose(),onDidChange:B.event,getCSS(){const d=p?p.getProductIconTheme():new $,t={},s=m=>{const u=d.getIcon(m);if(!u)return;const k=u.font;return k?(t[k.id]=k.definition,`.codicon-${m.id}:before { content: '${u.fontCharacter}'; font-family: ${(0,i.$_R)(k.id)}; }`):`.codicon-${m.id}:before { content: '${u.fontCharacter}'; }`},a=[];for(const m of f.getIcons()){const u=s(m);u&&a.push(u)}for(const m in t){const u=t[m],k=u.weight?`font-weight: ${u.weight};`:"",l=u.style?`font-style: ${u.style};`:"",b=u.src.map(r=>`${(0,i.$$R)(r.location)} format('${r.format}')`).join(", ");a.push(`@font-face { src: ${b}; font-family: ${(0,i.$_R)(m)};${k}${l} font-display: block; }`)}return a.join(`
`)}}}e.$_Gb=y;class ${getIcon(w){const B=(0,D.$Ow)();let f=w.defaults;for(;W.ThemeIcon.isThemeIcon(f);){const d=B.getIcon(f.id);if(!d)return;f=d.defaults}return f}}e.$aHb=$}),define(me[148],$e([1,0,5]),function(re,e,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cD=e.$bD=e.$aD=e.$_C=e.$$C=e.$0C=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=void 0,e.$4C={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(m){return typeof m.parentId=="number"}e.$5C=C;function j(m){return!!m.workspaceUri}e.$6C=j;function W(m){return!!m.folderUri}e.$7C=W;function D(m){return!!m.fileUri}e.$8C=D;function y(m){const u=f(m),k=m.getValue("window.menuBarVisibility");return k==="default"||u&&k==="compact"||i.$j&&i.$m?"classic":k}e.$9C=y;var $;(function(m){m.TITLE_BAR_STYLE="window.titleBarStyle",m.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})($||(e.TitleBarSetting=$={}));var p;(function(m){m.NATIVE="native",m.CUSTOM="custom"})(p||(e.TitlebarStyle=p={}));var w;(function(m){m.AUTO="auto",m.WINDOWED="windowed",m.NEVER="never"})(w||(e.CustomTitleBarVisibility=w={}));function B(m,u){return!0}e.$0C=B;function f(m,u){return u||(u=d(m)),u==="native"}e.$$C=f;function d(m){if(i.$o)return"custom";const u=m.getValue("window");if(u){if(i.$j&&u.nativeTabs===!0||i.$j&&u.nativeFullScreen===!1)return"native";const b=u.titleBarStyle;if(b==="native"||b==="custom")return b}return i.$k?"native":"custom"}e.$_C=d;function t(m){return!(!i.$i||i.$o||f(m))}e.$aD=t;function s(m){const u=m.getValue("window");return!u||typeof u.nativeFullScreen!="boolean"||u.nativeTabs?!0:u.nativeFullScreen!==!1}e.$bD=s;function a(m=0){return Math.pow(1.2,m)}e.$cD=a}),define(me[149],$e([1,0,17,2,22,31,148]),function(re,e,i,C,j,W,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ac=e.$$ac=e.$0ac=e.$9ac=e.$8ac=e.ApplyZoomTarget=void 0;var y;(function(f){f[f.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",f[f.ALL_WINDOWS=2]="ALL_WINDOWS"})(y||(e.ApplyZoomTarget=y={})),e.$8ac=8,e.$9ac=-8;function $(f,d){f=Math.min(Math.max(f,e.$9ac),e.$8ac);const t=[];d===y.ACTIVE_WINDOW?t.push((0,C.$yR)()):d===y.ALL_WINDOWS?t.push(...Array.from((0,C.getWindows)()).map(({window:s})=>s)):t.push(d);for(const s of t)p(s)?.webFrame?.setZoomLevel(f),(0,i.$vQ)((0,D.$cD)(f),s),(0,i.$rQ)(f,s)}e.$0ac=$;function p(f){if(f===j.$mQ)return{ipcRenderer:W.$O,webFrame:W.$Q};{const d=f;if(d?.vscode?.ipcRenderer&&d?.vscode?.webFrame)return d.vscode}}function w(f){$((0,i.$sQ)(typeof f=="number"?(0,C.$yR)():f)+1,f)}e.$$ac=w;function B(f){$((0,i.$sQ)(typeof f=="number"?(0,C.$yR)():f)-1,f)}e.$_ac=B}),define(me[150],$e([1,0,11,2,136,9,95,31,140,141,143,144,147,149,14,22,108,99]),function(re,e,i,C,j,W,D,y,$,p,w,B,f,d,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startup=void 0;const a=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(S){return 22}getTemplateId(S){return O(S)?"process":R(S)?"machine":(0,$.$Zm)(S)?"error":I(S)?"header":""}}class k{hasChildren(S){return(0,$.$Zm)(S)?!1:O(S)?!!S.children?.length:!0}getChildren(S){return O(S)?S.children?S.children:[]:(0,$.$Zm)(S)?[]:I(S)?S.processRoots.length>1?S.processRoots:[S.processRoots[0].rootProcess]:R(S)?[S.rootProcess]:[S.processes]}}class l{constructor(){this.templateId="header"}renderTemplate(S){const L=(0,C.$UR)(S,(0,C.$)(".row")),M=(0,C.$UR)(L,(0,C.$)(".nameLabel")),X=(0,C.$UR)(L,(0,C.$)(".cpu")),U=(0,C.$UR)(L,(0,C.$)(".memory")),de=(0,C.$UR)(L,(0,C.$)(".pid"));return{name:M,CPU:X,memory:U,PID:de}}renderElement(S,L,M,X){M.name.textContent=(0,i.localize)(0,null),M.CPU.textContent=(0,i.localize)(1,null),M.PID.textContent=(0,i.localize)(2,null),M.memory.textContent=(0,i.localize)(3,null)}disposeTemplate(S){}}class b{constructor(){this.templateId="machine"}renderTemplate(S){const L=Object.create(null),M=(0,C.$UR)(S,(0,C.$)(".row"));return L.name=(0,C.$UR)(M,(0,C.$)(".nameLabel")),L}renderElement(S,L,M,X){M.name.textContent=S.element.name}disposeTemplate(S){}}class r{constructor(){this.templateId="error"}renderTemplate(S){const L=Object.create(null),M=(0,C.$UR)(S,(0,C.$)(".row"));return L.name=(0,C.$UR)(M,(0,C.$)(".nameLabel")),L}renderElement(S,L,M,X){M.name.textContent=S.element.errorMessage}disposeTemplate(S){}}class A{constructor(S,L,M){this.a=S,this.b=L,this.c=M,this.templateId="process"}renderTemplate(S){const L=(0,C.$UR)(S,(0,C.$)(".row")),M=(0,C.$UR)(L,(0,C.$)(".nameLabel")),X=(0,C.$UR)(L,(0,C.$)(".cpu")),U=(0,C.$UR)(L,(0,C.$)(".memory")),de=(0,C.$UR)(L,(0,C.$)(".pid"));return{name:M,CPU:X,PID:de,memory:U}}renderElement(S,L,M,X){const{element:U}=S,de=U.pid.toFixed(0);let he=U.name;this.c.has(U.pid)&&(he=this.c.get(U.pid)),M.name.textContent=he,M.name.title=U.cmd,M.CPU.textContent=U.load.toFixed(0),M.PID.textContent=de,M.PID.parentElement.id=`pid-${de}`;const ne=this.a==="win32"?U.mem:this.b*(U.mem/100);M.memory.textContent=(ne/p.$cl.MB).toFixed(0)}disposeTemplate(S){}}function R(V){return!!V.name&&!!V.rootProcess}function I(V){return!!V.processRoots}function O(V){return!!V.pid}class z{constructor(S,L){this.f=L,this.b=new Map;const M=new w.$2ac(S);this.c=new B.$6ac(S,M),this.k(L.styles),this.g(L),y.$O.on("vscode:pidToNameResponse",(X,U)=>{this.b.clear();for(const[de,he]of U)this.b.set(de,he)}),y.$O.on("vscode:listProcessesResponse",async(X,U)=>{U.forEach((de,he)=>{O(de.rootProcess)&&(de.rootProcess.name=he===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:U}}),this.d.layout(s.$mQ.innerHeight,s.$mQ.innerWidth)):await this.h(U),this.m(0)}),this.a=Date.now(),y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")}g(S){s.$mQ.document.onkeydown=L=>{const M=S.platform==="darwin"?L.metaKey:L.ctrlKey;M&&L.keyCode===87&&(L.stopPropagation(),L.preventDefault(),y.$O.send("vscode:closeProcessExplorer")),M&&L.keyCode===187&&(0,d.$$ac)(s.$mQ),M&&L.keyCode===189&&(0,d.$_ac)(s.$mQ)}}async h(S){const L=s.$mQ.document.getElementById("process-list");if(!L)return;const{totalmem:M}=await this.c.getOSStatistics(),X=[new A(this.f.platform,M,this.b),new l,new b,new r];this.d=new j.$oV("processExplorer",L,new u,X,new k,{identityProvider:{getId:U=>O(U)?U.pid.toString():(0,$.$Zm)(U)?U.hostName:I(U)?"processes":R(U)?U.name:"header"}}),this.d.setInput({processes:{processRoots:S}}),this.d.layout(s.$mQ.innerHeight,s.$mQ.innerWidth),this.d.onKeyDown(U=>{const de=new t.$QQ(U);if(de.keyCode===35&&de.altKey){const he=this.n();Promise.all(he.map(ne=>this.c.killProcess(ne,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(U=>{O(U.element)&&this.l(U.element,!0)}),L.style.height=`${s.$mQ.innerHeight}px`,s.$mQ.addEventListener("resize",()=>{L.style.height=`${s.$mQ.innerHeight}px`,this.d?.layout(s.$mQ.innerHeight,s.$mQ.innerWidth)})}i(S){const L=a.exec(S);return L&&L.groups.port!=="0"||S.indexOf("node ")>=0||S.indexOf("node.exe")>=0}j(S){const L={type:"node",request:"attach",name:`process ${S.pid}`};let M=a.exec(S.cmd);M?L.port=Number(M.groups.port):L.processId=String(S.pid),M=m.exec(S.cmd),M&&(L.port=Number(M.groups.port)),y.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[L]})}k(S){const L=(0,C.$CR)(),M=[];S.listFocusBackground&&(M.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&M.push(`.monaco-list:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&(M.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),M.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&M.push(`.monaco-list:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listHoverBackground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&M.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${S.listHoverForeground}; }`),S.listFocusOutline&&M.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&M.push(`.monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.scrollbarShadowColor&&M.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${S.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${S.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${S.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),S.scrollbarSliderBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${S.scrollbarSliderBackgroundColor};
				}
			`),S.scrollbarSliderHoverBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${S.scrollbarSliderHoverBackgroundColor};
				}
			`),S.scrollbarSliderActiveBackgroundColor&&M.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${S.scrollbarSliderActiveBackgroundColor};
				}
			`),L.textContent=M.join(`
`),S.color&&(s.$mQ.document.body.style.color=S.color)}l(S,L){const M=[],X=Number(S.pid);L&&(M.push({accelerator:"Alt+E",label:(0,i.localize)(4,null),click:()=>{this.c.killProcess(X,"SIGTERM")}}),M.push({label:(0,i.localize)(5,null),click:()=>{this.c.killProcess(X,"SIGKILL")}}),M.push({type:"separator"})),M.push({label:(0,i.localize)(6,null),click:()=>{const U=this.n();U?.includes(X)||(U.length=0,U.push(X));const de=U?.map(he=>s.$mQ.document.getElementById(`pid-${he}`)).filter(he=>!!he);if(de){const he=de.map(ne=>ne.innerText).filter(ne=>!!ne);this.c.writeClipboardText(he.join(`
`))}}}),M.push({label:(0,i.localize)(7,null),click:()=>{const U=s.$mQ.document.getElementById("process-list");U&&this.c.writeClipboardText(U.innerText)}}),S&&L&&this.i(S.cmd)&&(M.push({type:"separator"}),M.push({label:(0,i.localize)(8,null),click:()=>{this.j(S)}})),(0,D.$RV)(M)}m(S){setTimeout(()=>{const L=Date.now(),M=S+L-this.a;this.a=L,M>1e3?(y.$O.send("vscode:pidToNameRequest"),y.$O.send("vscode:listProcesses")):this.m(M)},200)}n(){return this.d?.getSelection()?.map(S=>{if(!(!S||!("pid"in S)))return S.pid}).filter(S=>!!S)}}function v(){const V=(0,C.$CR)();V.id="codiconStyles";const S=(0,f.$_Gb)(void 0);function L(){V.textContent=S.getCSS()}const M=new W.$sh(L,0);S.onDidChange(()=>M.schedule()),M.schedule()}function H(V){const S=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";s.$mQ.document.body.classList.add(S),v(),(0,d.$0ac)(V.data.zoomLevel,s.$mQ),new z(V.windowId,V.data)}e.startup=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b148975cafa8f034592310659f3dc989b124685c/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
