/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/async","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/buffer","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/codiconsUtil","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","crypto","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(fe){for(var e=[],l=0,N=fe.length;l<N;l++)e[l]=Se[fe[l]];return e};define(Se[161],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class l{static get(){const L=new Map,A=new Map,R=new Map,w=new Map;function p(S,y){S.has(y.detail)||S.set(y.detail,-y.timestamp)}function E(S,y){const u=S.get(y.detail);u&&(u>=0||S.set(y.detail,u+y.timestamp))}let M=[];typeof fe=="function"&&typeof fe.getStats=="function"&&(M=fe.getStats().slice(0).sort((S,y)=>S.timestamp-y.timestamp));for(const S of M)switch(S.type){case 10:p(L,S);break;case 11:case 12:E(L,S);break;case 21:p(A,S);break;case 22:E(A,S);break;case 33:p(R,S);break;case 34:E(R,S);break;case 31:p(w,S);break;case 32:E(w,S);break}let C=0;R.forEach(S=>C+=S);function v(S){const y=[];return S.forEach((u,m)=>y.push([m,u])),y}return{amdLoad:v(L),amdInvoke:v(A),nodeRequire:v(R),nodeEval:v(w),nodeRequireTotal:C}}static toMarkdownTable(L,A){let R="";const w=[];return L.forEach((p,E)=>{w[E]=p.length}),A.forEach(p=>{p.forEach((E,M)=>{typeof E>"u"&&(E=p[M]="-");const C=E.toString().length;w[M]=Math.max(C,w[M])})}),L.forEach((p,E)=>{R+=`| ${p+" ".repeat(w[E]-p.toString().length)} `}),R+=`|
`,L.forEach((p,E)=>{R+=`| ${"-".repeat(w[E])} `}),R+=`|
`,A.forEach(p=>{p.forEach((E,M)=>{typeof E<"u"&&(R+=`| ${E+" ".repeat(w[M]-E.toString().length)} `)}),R+=`|
`}),R}}e.$U=l}),define(Se[162],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function l(u,m,o){const i=N(u,m);if(i!==-1)return u[i]}e.$fb=l;function N(u,m,o=u.length-1){for(let i=o;i>=0;i--){const n=u[i];if(m(n))return i}return-1}e.$gb=N;function L(u,m){const o=A(u,m);return o===-1?void 0:u[o]}e.$hb=L;function A(u,m,o=0,i=u.length){let n=o,r=i;for(;n<r;){const c=Math.floor((n+r)/2);m(u[c])?n=c+1:r=c}return n-1}e.$ib=A;function R(u,m){const o=w(u,m);return o===u.length?void 0:u[o]}e.$jb=R;function w(u,m,o=0,i=u.length){let n=o,r=i;for(;n<r;){const c=Math.floor((n+r)/2);m(u[c])?r=c:n=c+1}return n}e.$kb=w;function p(u,m,o=0,i=u.length){const n=w(u,m,o,i);return n===u.length?-1:n}e.$lb=p;class E{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(E.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!m(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const o=A(this.e,m,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=E;function M(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>0&&(o=n)}return o}e.$nb=M;function C(u,m){if(u.length===0)return;let o=u[0];for(let i=1;i<u.length;i++){const n=u[i];m(n,o)>=0&&(o=n)}return o}e.$ob=C;function v(u,m){return M(u,(o,i)=>-m(o,i))}e.$pb=v;function S(u,m){if(u.length===0)return-1;let o=0;for(let i=1;i<u.length;i++){const n=u[i];m(n,u[o])>0&&(o=i)}return o}e.$qb=S;function y(u,m){for(const o of u){const i=m(o);if(i!==void 0)return i}}e.$rb=y}),define(Se[72],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function l(R,w){const p=Object.create(null);for(const E of R){const M=w(E);let C=p[M];C||(C=p[M]=[]),C.push(E)}return p}e.$K=l;function N(R,w){const p=[],E=[];for(const M of R)w.has(M)||p.push(M);for(const M of w)R.has(M)||E.push(M);return{removed:p,added:E}}e.$L=N;function L(R,w){const p=[],E=[];for(const[M,C]of R)w.has(M)||p.push(C);for(const[M,C]of w)R.has(M)||E.push(C);return{removed:p,added:E}}e.$M=L;function A(R,w){const p=new Set;for(const E of w)R.has(E)&&p.add(E);return p}e.$N=A}),define(Se[53],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mh=e.$Lh=e.$Kh=void 0;function l(R){return(w,p,E)=>{let M=null,C=null;if(typeof E.value=="function"?(M="value",C=E.value):typeof E.get=="function"&&(M="get",C=E.get),!C)throw new Error("not supported");E[M]=R(C,p)}}function N(R,w,p){let E=null,M=null;if(typeof p.value=="function"?(E="value",M=p.value,M.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(E="get",M=p.get),!M)throw new Error("not supported");const C=`$memoize$${w}`;p[E]=function(...v){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:M.apply(this,v)}),this[C]}}e.$Kh=N;function L(R,w,p){return l((E,M)=>{const C=`$debounce$${M}`,v=`$debounce$result$${M}`;return function(...S){this[v]||(this[v]=p?p():void 0),clearTimeout(this[C]),w&&(this[v]=w(this[v],...S),S=[this[v]]),this[C]=setTimeout(()=>{E.apply(this,S),this[v]=p?p():void 0},R)}})}e.$Lh=L;function A(R,w,p){return l((E,M)=>{const C=`$throttle$timer$${M}`,v=`$throttle$result$${M}`,S=`$throttle$lastRun$${M}`,y=`$throttle$pending$${M}`;return function(...u){if(this[v]||(this[v]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),w&&(this[v]=w(this[v],...u)),this[y])return;const m=this[S]+R;m<=Date.now()?(this[S]=Date.now(),E.apply(this,[this[v]]),this[v]=p?p():void 0):(this[y]=!0,this[C]=setTimeout(()=>{this[y]=!1,this[S]=Date.now(),E.apply(this,[this[v]]),this[v]=p?p():void 0},m-Date.now()))}})}e.$Mh=A}),define(Se[13],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class l{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(f=>{f(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=l,e.$X=new l;function N(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=N;function L(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=L;function A(c){E(c)||e.$X.onUnexpectedError(c)}e.$1=A;function R(c){E(c)||e.$X.onUnexpectedExternalError(c)}e.$2=R;function w(c){if(c instanceof Error){const{name:t,message:f}=c,h=c.stacktrace||c.stack;return{$isError:!0,name:t,message:f,stack:h,noTelemetry:n.isErrorNoTelemetry(c)}}return c}e.$3=w;const p="Canceled";function E(c){return c instanceof M?!0:c instanceof Error&&c.name===p&&c.message===p}e.$4=E;class M extends Error{constructor(){super(p),this.name=this.message}}e.$5=M;function C(){const c=new Error(p);return c.name=c.message,c}e.$6=C;function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=v;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=S;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function u(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=u;class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const f=new n;return f.message=t.message,f.stack=t.stack,f}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=n;class r extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,r.prototype)}}e.$cb=r}),define(Se[19],De([1,0,13,162]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function L(le,ue=0){return le[le.length-(1+ue)]}e.$sb=L;function A(le){if(le.length===0)throw new Error("Invalid tail call");return[le.slice(0,le.length-1),le[le.length-1]]}e.$tb=A;function R(le,ue,ce=(de,H)=>de===H){if(le===ue)return!0;if(!le||!ue||le.length!==ue.length)return!1;for(let de=0,H=le.length;de<H;de++)if(!ce(le[de],ue[de]))return!1;return!0}e.$ub=R;function w(le,ue){const ce=le.length-1;ue<ce&&(le[ue]=le[ce]),le.pop()}e.$vb=w;function p(le,ue,ce){return E(le.length,de=>ce(le[de],ue))}e.$wb=p;function E(le,ue){let ce=0,de=le-1;for(;ce<=de;){const H=(ce+de)/2|0,Y=ue(H);if(Y<0)ce=H+1;else if(Y>0)de=H-1;else return H}return-(ce+1)}e.$xb=E;function M(le,ue,ce){if(le=le|0,le>=ue.length)throw new TypeError("invalid index");const de=ue[Math.floor(ue.length*Math.random())],H=[],Y=[],he=[];for(const be of ue){const Pe=ce(be,de);Pe<0?H.push(be):Pe>0?Y.push(be):he.push(be)}return le<H.length?M(le,H,ce):le<H.length+he.length?he[0]:M(le-(H.length+he.length),Y,ce)}e.$yb=M;function C(le,ue){const ce=[];let de;for(const H of le.slice(0).sort(ue))!de||ue(de[0],H)!==0?(de=[H],ce.push(de)):de.push(H);return ce}e.$zb=C;function*v(le,ue){let ce,de;for(const H of le)de!==void 0&&ue(de,H)?ce.push(H):(ce&&(yield ce),ce=[H]),de=H;ce&&(yield ce)}e.$Ab=v;function S(le,ue){for(let ce=0;ce<=le.length;ce++)ue(ce===0?void 0:le[ce-1],ce===le.length?void 0:le[ce])}e.$Bb=S;function y(le,ue){for(let ce=0;ce<le.length;ce++)ue(ce===0?void 0:le[ce-1],le[ce],ce+1===le.length?void 0:le[ce+1])}e.$Cb=y;function u(le,ue,ce){const de=[];function H(be,Pe,we){if(Pe===0&&we.length===0)return;const Ae=de[de.length-1];Ae&&Ae.start+Ae.deleteCount===be?(Ae.deleteCount+=Pe,Ae.toInsert.push(...we)):de.push({start:be,deleteCount:Pe,toInsert:we})}let Y=0,he=0;for(;;){if(Y===le.length){H(Y,0,ue.slice(he));break}if(he===ue.length){H(Y,le.length-Y,[]);break}const be=le[Y],Pe=ue[he],we=ce(be,Pe);we===0?(Y+=1,he+=1):we<0?(H(Y,1,[]),Y+=1):we>0&&(H(Y,0,[Pe]),he+=1)}return de}e.$Db=u;function m(le,ue,ce){const de=u(le,ue,ce),H=[],Y=[];for(const he of de)H.push(...le.slice(he.start,he.start+he.deleteCount)),Y.push(...he.toInsert);return{removed:H,added:Y}}e.$Eb=m;function o(le,ue,ce){if(ce===0)return[];const de=le.slice(0,ce).sort(ue);return n(le,ue,de,ce,le.length),de}e.top=o;function i(le,ue,ce,de,H){return ce===0?Promise.resolve([]):new Promise((Y,he)=>{(async()=>{const be=le.length,Pe=le.slice(0,ce).sort(ue);for(let we=ce,Ae=Math.min(ce+de,be);we<be;we=Ae,Ae=Math.min(Ae+de,be)){if(we>ce&&await new Promise(Oe=>setTimeout(Oe)),H&&H.isCancellationRequested)throw new l.$5;n(le,ue,Pe,we,Ae)}return Pe})().then(Y,he)})}e.$Gb=i;function n(le,ue,ce,de,H){for(const Y=ce.length;de<H;de++){const he=le[de];if(ue(he,ce[Y-1])<0){ce.pop();const be=(0,N.$kb)(ce,Pe=>ue(he,Pe)<0);ce.splice(be,0,he)}}}function r(le){return le.filter(ue=>!!ue)}e.$Hb=r;function c(le){let ue=0;for(let ce=0;ce<le.length;ce++)le[ce]&&(le[ue]=le[ce],ue+=1);le.length=ue}e.$Ib=c;function t(le,ue,ce){le.splice(ce,0,le.splice(ue,1)[0])}e.$Jb=t;function f(le){return!Array.isArray(le)||le.length===0}e.$Kb=f;function h(le){return Array.isArray(le)&&le.length>0}e.$Lb=h;function s(le,ue=ce=>ce){const ce=new Set;return le.filter(de=>{const H=ue(de);return ce.has(H)?!1:(ce.add(H),!0)})}e.$Mb=s;function a(le){const ue=new Set;return ce=>{const de=le(ce);return ue.has(de)?!1:(ue.add(de),!0)}}e.$Nb=a;function d(le,ue){return le.length>0?le[0]:ue}e.$Ob=d;function $(le,ue){return le.length>0?le[le.length-1]:ue}e.$Pb=$;function D(le,ue,ce=(de,H)=>de===H){let de=0;for(let H=0,Y=Math.min(le.length,ue.length);H<Y&&ce(le[H],ue[H]);H++)de++;return de}e.$Qb=D;function b(le){return[].concat(...le)}e.$Rb=b;function g(le,ue){let ce=typeof ue=="number"?le:0;typeof ue=="number"?ce=le:(ce=0,ue=le);const de=[];if(ce<=ue)for(let H=ce;H<ue;H++)de.push(H);else for(let H=ce;H>ue;H--)de.push(H);return de}e.$Sb=g;function k(le,ue,ce){return le.reduce((de,H)=>(de[ue(H)]=ce?ce(H):H,de),Object.create(null))}e.$Tb=k;function P(le,ue){return le.push(ue),()=>F(le,ue)}e.$Ub=P;function F(le,ue){const ce=le.indexOf(ue);if(ce>-1)return le.splice(ce,1),ue}e.$Vb=F;function U(le,ue,ce){const de=le.slice(0,ue),H=le.slice(ue);return de.concat(ce,H)}e.$Wb=U;function z(le,ue){let ce;if(typeof ue=="number"){let de=ue;ce=()=>{const H=Math.sin(de++)*179426549;return H-Math.floor(H)}}else ce=Math.random;for(let de=le.length-1;de>0;de-=1){const H=Math.floor(ce()*(de+1)),Y=le[de];le[de]=le[H],le[H]=Y}}e.$Xb=z;function T(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.unshift(ue))}e.$Yb=T;function I(le,ue){const ce=le.indexOf(ue);ce>-1&&(le.splice(ce,1),le.push(ue))}e.$Zb=I;function O(le,ue){for(const ce of ue)le.push(ce)}e.$1b=O;function j(le,ue){return Array.isArray(le)?le.map(ue):ue(le)}e.$2b=j;function G(le){return Array.isArray(le)?le:[le]}e.$3b=G;function te(le){return le[Math.floor(Math.random()*le.length)]}e.$4b=te;function x(le,ue,ce){const de=X(le,ue),H=le.length,Y=ce.length;le.length=H+Y;for(let he=H-1;he>=de;he--)le[he+Y]=le[he];for(let he=0;he<Y;he++)le[he+de]=ce[he]}e.$5b=x;function Z(le,ue,ce,de){const H=X(le,ue);let Y=le.splice(H,ce);return Y===void 0&&(Y=[]),x(le,H,de),Y}e.$6b=Z;function X(le,ue){return ue<0?Math.max(ue+le.length,0):Math.min(ue,le.length)}var ae;(function(le){function ue(Y){return Y<0}le.isLessThan=ue;function ce(Y){return Y<=0}le.isLessThanOrEqual=ce;function de(Y){return Y>0}le.isGreaterThan=de;function H(Y){return Y===0}le.isNeitherLessOrGreaterThan=H,le.greaterThan=1,le.lessThan=-1,le.neitherLessOrGreaterThan=0})(ae||(e.CompareResult=ae={}));function _(le,ue){return(ce,de)=>ue(le(ce),le(de))}e.$7b=_;function ge(...le){return(ue,ce)=>{for(const de of le){const H=de(ue,ce);if(!ae.isNeitherLessOrGreaterThan(H))return H}return ae.neitherLessOrGreaterThan}}e.$8b=ge;const se=(le,ue)=>le-ue;e.$9b=se;const re=(le,ue)=>(0,e.$9b)(le?1:0,ue?1:0);e.$0b=re;function B(le){return(ue,ce)=>-le(ue,ce)}e.$$b=B;class ie{constructor(ue){this.g=ue,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ue){let ce=this.c;for(;ce<this.g.length&&ue(this.g[ce]);)ce++;const de=ce===this.c?null:this.g.slice(this.c,ce);return this.c=ce,de}takeFromEndWhile(ue){let ce=this.d;for(;ce>=0&&ue(this.g[ce]);)ce--;const de=ce===this.d?null:this.g.slice(ce+1,this.d+1);return this.d=ce,de}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ue=this.g[this.c];return this.c++,ue}removeLast(){const ue=this.g[this.d];return this.d--,ue}takeCount(ue){const ce=this.g.slice(this.c,this.c+ue);return this.c+=ue,ce}}e.$_b=ie;class ke{static{this.empty=new ke(ue=>{})}constructor(ue){this.iterate=ue}forEach(ue){this.iterate(ce=>(ue(ce),!0))}toArray(){const ue=[];return this.iterate(ce=>(ue.push(ce),!0)),ue}filter(ue){return new ke(ce=>this.iterate(de=>ue(de)?ce(de):!0))}map(ue){return new ke(ce=>this.iterate(de=>ce(ue(de))))}some(ue){let ce=!1;return this.iterate(de=>(ce=ue(de),!ce)),ce}findFirst(ue){let ce;return this.iterate(de=>ue(de)?(ce=de,!1):!0),ce}findLast(ue){let ce;return this.iterate(de=>(ue(de)&&(ce=de),!0)),ce}findLastMaxBy(ue){let ce,de=!0;return this.iterate(H=>((de||ae.isGreaterThan(ue(H,ce)))&&(de=!1,ce=H),!0)),ce}}e.$ac=ke}),define(Se[61],De([1,0,13]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.ok=void 0;function N(E,M){if(!E)throw new Error(M?`Assertion failed (${M})`:"Assertion Failed")}e.ok=N;function L(E,M="Unreachable"){throw new Error(M)}e.$9c=L;function A(E){if(!E)throw new l.$cb("Assertion Failed")}e.$0c=A;function R(E){E||(0,l.$1)(new l.$cb("Soft Assertion Failed"))}e.$$c=R;function w(E){if(!E()){debugger;E(),(0,l.$1)(new l.$cb("Assertion Failed"))}}e.$_c=w;function p(E,M){let C=0;for(;C<E.length-1;){const v=E[C],S=E[C+1];if(!M(v,S))return!1;C++}return!0}e.$ad=p}),define(Se[73],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function l(N,L){const A=this;let R=!1,w;return function(){if(R)return w;if(R=!0,L)try{w=N.apply(A,arguments)}finally{L()}else w=N.apply(A,arguments);return w}}e.$db=l}),define(Se[124],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vO=e.$uO=void 0;class l{constructor(L){this.a=L,this.b=0}nextId(){return this.a+ ++this.b}}e.$uO=l,e.$vO=new l("id#")}),define(Se[48],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var l;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function R(){return A}N.empty=R;function*w(t){yield t}N.single=w;function p(t){return L(t)?t:w(t)}N.wrap=p;function E(t){return t||A}N.from=E;function*M(t){for(let f=t.length-1;f>=0;f--)yield t[f]}N.reverse=M;function C(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=C;function v(t){return t[Symbol.iterator]().next().value}N.first=v;function S(t,f){for(const h of t)if(f(h))return!0;return!1}N.some=S;function y(t,f){for(const h of t)if(f(h))return h}N.find=y;function*u(t,f){for(const h of t)f(h)&&(yield h)}N.filter=u;function*m(t,f){let h=0;for(const s of t)yield f(s,h++)}N.map=m;function*o(...t){for(const f of t)yield*f}N.concat=o;function i(t,f,h){let s=h;for(const a of t)s=f(s,a);return s}N.reduce=i;function*n(t,f,h=t.length){for(f<0&&(f+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);f<h;f++)yield t[f]}N.slice=n;function r(t,f=Number.POSITIVE_INFINITY){const h=[];if(f===0)return[h,t];const s=t[Symbol.iterator]();for(let a=0;a<f;a++){const d=s.next();if(d.done)return[h,N.empty()];h.push(d.value)}return[h,{[Symbol.iterator](){return s}}]}N.consume=r;async function c(t){const f=[];for await(const h of t)f.push(h);return Promise.resolve(f)}N.asyncToArray=c})(l||(e.Iterable=l={}))}),define(Se[163],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var l;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(l||(e.ScanError=l={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function R(t,f=!1){let h=0;const s=t.length;let a="",d=0,$=16,D=0;function b(T){let I=0,O=0;for(;I<T;){const j=t.charCodeAt(h);if(j>=48&&j<=57)O=O*16+j-48;else if(j>=65&&j<=70)O=O*16+j-65+10;else if(j>=97&&j<=102)O=O*16+j-97+10;else break;h++,I++}return I<T&&(O=-1),O}function g(T){h=T,a="",d=0,$=16,D=0}function k(){const T=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&E(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&E(t.charCodeAt(h)))for(h++;h<t.length&&E(t.charCodeAt(h));)h++;else return D=3,t.substring(T,h);let I=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&E(t.charCodeAt(h))){for(h++;h<t.length&&E(t.charCodeAt(h));)h++;I=h}else D=3;return t.substring(T,I)}function P(){let T="",I=h;for(;;){if(h>=s){T+=t.substring(I,h),D=2;break}const O=t.charCodeAt(h);if(O===34){T+=t.substring(I,h),h++;break}if(O===92){if(T+=t.substring(I,h),h++,h>=s){D=2;break}switch(t.charCodeAt(h++)){case 34:T+='"';break;case 92:T+="\\";break;case 47:T+="/";break;case 98:T+="\b";break;case 102:T+="\f";break;case 110:T+=`
`;break;case 114:T+="\r";break;case 116:T+="	";break;case 117:{const G=b(4);G>=0?T+=String.fromCharCode(G):D=4;break}default:D=5}I=h;continue}if(O>=0&&O<=31)if(p(O)){T+=t.substring(I,h),D=2;break}else D=6;h++}return T}function F(){if(a="",D=0,d=h,h>=s)return d=s,$=17;let T=t.charCodeAt(h);if(w(T)){do h++,a+=String.fromCharCode(T),T=t.charCodeAt(h);while(w(T));return $=15}if(p(T))return h++,a+=String.fromCharCode(T),T===13&&t.charCodeAt(h)===10&&(h++,a+=`
`),$=14;switch(T){case 123:return h++,$=1;case 125:return h++,$=2;case 91:return h++,$=3;case 93:return h++,$=4;case 58:return h++,$=6;case 44:return h++,$=5;case 34:return h++,a=P(),$=10;case 47:{const I=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<s&&!p(t.charCodeAt(h));)h++;return a=t.substring(I,h),$=12}if(t.charCodeAt(h+1)===42){h+=2;const O=s-1;let j=!1;for(;h<O;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,j=!0;break}h++}return j||(h++,D=1),a=t.substring(I,h),$=13}return a+=String.fromCharCode(T),h++,$=16}case 45:if(a+=String.fromCharCode(T),h++,h===s||!E(t.charCodeAt(h)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=k(),$=11;default:for(;h<s&&U(T);)h++,T=t.charCodeAt(h);if(d!==h){switch(a=t.substring(d,h),a){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return a+=String.fromCharCode(T),h++,$=16}}function U(T){if(w(T)||p(T))return!1;switch(T){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let T;do T=F();while(T>=12&&T<=15);return T}return{setPosition:g,getPosition:()=>h,scan:f?z:F,getToken:()=>$,getTokenValue:()=>a,getTokenOffset:()=>d,getTokenLength:()=>h-d,getTokenError:()=>D}}e.$qn=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function p(t){return t===10||t===13||t===8232||t===8233}function E(t){return t>=48&&t<=57}var M;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(M||(M={}));function C(t,f){const h=[],s=new Object;let a;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function D(b,g,k,P){d.value=b,d.offset=g,d.length=k,d.type=P,d.colonOffset=void 0,a=d}try{n(t,{onObjectBegin:(b,g)=>{if(f<=b)throw s;a=void 0,$=f>b,h.push("")},onObjectProperty:(b,g,k)=>{if(f<g||(D(b,g,k,"property"),h[h.length-1]=b,f<=g+k))throw s},onObjectEnd:(b,g)=>{if(f<=b)throw s;a=void 0,h.pop()},onArrayBegin:(b,g)=>{if(f<=b)throw s;a=void 0,h.push(0)},onArrayEnd:(b,g)=>{if(f<=b)throw s;a=void 0,h.pop()},onLiteralValue:(b,g,k)=>{if(f<g||(D(b,g,k,c(b)),f<=g+k))throw s},onSeparator:(b,g,k)=>{if(f<=g)throw s;if(b===":"&&a&&a.type==="property")a.colonOffset=g,$=!1,a=void 0;else if(b===","){const P=h[h.length-1];typeof P=="number"?h[h.length-1]=P+1:($=!0,h[h.length-1]=""),a=void 0}}})}catch(b){if(b!==s)throw b}return{path:h,previousNode:a,isAtPropertyKey:$,matches:b=>{let g=0;for(let k=0;g<b.length&&k<h.length;k++)if(b[g]===h[k]||b[g]==="*")g++;else if(b[g]!=="**")return!1;return g===b.length}}}e.$rn=C;function v(t,f=[],h=A.DEFAULT){let s=null,a=[];const d=[];function $(b){Array.isArray(a)?a.push(b):s!==null&&(a[s]=b)}return n(t,{onObjectBegin:()=>{const b={};$(b),d.push(a),a=b,s=null},onObjectProperty:b=>{s=b},onObjectEnd:()=>{a=d.pop()},onArrayBegin:()=>{const b=[];$(b),d.push(a),a=b,s=null},onArrayEnd:()=>{a=d.pop()},onLiteralValue:$,onError:(b,g,k)=>{f.push({error:b,offset:g,length:k})}},h),a[0]}e.$sn=v;function S(t,f=[],h=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(b){s.type==="property"&&(s.length=b-s.offset,s=s.parent)}function d(b){return s.children.push(b),b}n(t,{onObjectBegin:b=>{s=d({type:"object",offset:b,length:-1,parent:s,children:[]})},onObjectProperty:(b,g,k)=>{s=d({type:"property",offset:g,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:b,offset:g,length:k,parent:s})},onObjectEnd:(b,g)=>{s.length=b+g-s.offset,s=s.parent,a(b+g)},onArrayBegin:(b,g)=>{s=d({type:"array",offset:b,length:-1,parent:s,children:[]})},onArrayEnd:(b,g)=>{s.length=b+g-s.offset,s=s.parent,a(b+g)},onLiteralValue:(b,g,k)=>{d({type:c(b),offset:g,length:k,parent:s,value:b}),a(g+k)},onSeparator:(b,g,k)=>{s.type==="property"&&(b===":"?s.colonOffset=g:b===","&&a(g))},onError:(b,g,k)=>{f.push({error:b,offset:g,length:k})}},h);const D=s.children[0];return D&&delete D.parent,D}e.$tn=S;function y(t,f){if(!t)return;let h=t;for(const s of f)if(typeof s=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let a=!1;for(const d of h.children)if(Array.isArray(d.children)&&d.children[0].value===s){h=d.children[1],a=!0;break}if(!a)return}else{const a=s;if(h.type!=="array"||a<0||!Array.isArray(h.children)||a>=h.children.length)return;h=h.children[a]}return h}e.$un=y;function u(t){if(!t.parent||!t.parent.children)return[];const f=u(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;f.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&f.push(h)}return f}e.$vn=u;function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const f=Object.create(null);for(const h of t.children){const s=h.children[1];s&&(f[h.children[0].value]=m(s))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$wn=m;function o(t,f,h=!1){return f>=t.offset&&f<t.offset+t.length||h&&f===t.offset+t.length}e.$xn=o;function i(t,f,h=!1){if(o(t,f,h)){const s=t.children;if(Array.isArray(s))for(let a=0;a<s.length&&s[a].offset<=f;a++){const d=i(s[a],f,h);if(d)return d}return t}}e.$yn=i;function n(t,f,h=A.DEFAULT){const s=R(t,!1);function a(_){return _?()=>_(s.getTokenOffset(),s.getTokenLength()):()=>!0}function d(_){return _?ge=>_(ge,s.getTokenOffset(),s.getTokenLength()):()=>!0}const $=a(f.onObjectBegin),D=d(f.onObjectProperty),b=a(f.onObjectEnd),g=a(f.onArrayBegin),k=a(f.onArrayEnd),P=d(f.onLiteralValue),F=d(f.onSeparator),U=a(f.onComment),z=d(f.onError),T=h&&h.disallowComments,I=h&&h.allowTrailingComma;function O(){for(;;){const _=s.scan();switch(s.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:T||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(_){case 12:case 13:T?j(10):U();break;case 16:j(1);break;case 15:case 14:break;default:return _}}}function j(_,ge=[],se=[]){if(z(_),ge.length+se.length>0){let re=s.getToken();for(;re!==17;){if(ge.indexOf(re)!==-1){O();break}else if(se.indexOf(re)!==-1)break;re=O()}}}function G(_){const ge=s.getTokenValue();return _?P(ge):D(ge),O(),!0}function te(){switch(s.getToken()){case 11:{let _=0;try{_=JSON.parse(s.getTokenValue()),typeof _!="number"&&(j(2),_=0)}catch{j(2)}P(_);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return O(),!0}function x(){return s.getToken()!==10?(j(3,[],[2,5]),!1):(G(!1),s.getToken()===6?(F(":"),O(),ae()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function Z(){$(),O();let _=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(_||j(4,[],[]),F(","),O(),s.getToken()===2&&I)break}else _&&j(6,[],[]);x()||j(4,[],[2,5]),_=!0}return b(),s.getToken()!==2?j(7,[2],[]):O(),!0}function X(){g(),O();let _=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(_||j(4,[],[]),F(","),O(),s.getToken()===4&&I)break}else _&&j(6,[],[]);ae()||j(4,[],[4,5]),_=!0}return k(),s.getToken()!==4?j(8,[4],[]):O(),!0}function ae(){switch(s.getToken()){case 3:return X();case 1:return Z();case 10:return G(!0);default:return te()}}return O(),s.getToken()===17?h.allowEmptyContent?!0:(j(4,[],[]),!1):ae()?(s.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.$zn=n;function r(t,f){const h=R(t),s=[];let a,d=0,$;do switch($=h.getPosition(),a=h.scan(),a){case 12:case 13:case 17:d!==$&&s.push(t.substring(d,$)),f!==void 0&&s.push(h.getTokenValue().replace(/[^\r\n]/g,f)),d=h.getPosition();break}while(a!==17);return s.join("")}e.$An=r;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Bn=c}),define(Se[43],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class l{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=l}),define(Se[74],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class l{static{this.Undefined=new l(void 0)}constructor(A){this.element=A,this.next=l.Undefined,this.prev=l.Undefined}}class N{constructor(){this.a=l.Undefined,this.b=l.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===l.Undefined}clear(){let A=this.a;for(;A!==l.Undefined;){const R=A.next;A.prev=l.Undefined,A.next=l.Undefined,A=R}this.a=l.Undefined,this.b=l.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,R){const w=new l(A);if(this.a===l.Undefined)this.a=w,this.b=w;else if(R){const E=this.b;this.b=w,w.prev=E,E.next=w}else{const E=this.a;this.a=w,w.next=E,E.prev=w}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(w))}}shift(){if(this.a!==l.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==l.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==l.Undefined&&A.next!==l.Undefined){const R=A.prev;R.next=A.next,A.next.prev=R}else A.prev===l.Undefined&&A.next===l.Undefined?(this.a=l.Undefined,this.b=l.Undefined):A.next===l.Undefined?(this.b=this.b.prev,this.b.next=l.Undefined):A.prev===l.Undefined&&(this.a=this.a.next,this.a.prev=l.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==l.Undefined;)yield A.element,A=A.next}}e.$4c=N}),define(Se[28],De([1,0]),function(fe,e){"use strict";var l,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(n,r,c){let t=n.get(r);return t===void 0&&(t=c,n.set(r,t)),t}e.$xc=A;function R(n){const r=[];return n.forEach((c,t)=>{r.push(`${t} => ${c}`)}),`Map(${n.size}) {${r.join(", ")}}`}e.$yc=R;function w(n){const r=[];return n.forEach(c=>{r.push(c)}),`Set(${n.size}) {${r.join(", ")}}`}e.$zc=w;class p{constructor(r,c){this.uri=r,this.value=c}}function E(n){return Array.isArray(n)}class M{static{this.c=r=>r.toString()}constructor(r,c){if(this[l]="ResourceMap",r instanceof M)this.d=new Map(r.d),this.e=c??M.c;else if(E(r)){this.d=new Map,this.e=c??M.c;for(const[t,f]of r)this.set(t,f)}else this.d=new Map,this.e=r??M.c}set(r,c){return this.d.set(this.e(r),new p(r,c)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,c){typeof c<"u"&&(r=r.bind(c));for(const[t,f]of this.d)r(f.value,f.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(l=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}e.$Ac=M;class C{constructor(r,c){this[N]="ResourceSet",!r||typeof r=="function"?this.c=new M(r):(this.c=new M(c),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,c){this.c.forEach((t,f)=>r.call(c,f,f,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=C;var v;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class S{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,c=0){const t=this.c.get(r);if(t)return c!==0&&this.l(t,c),t.value}set(r,c,t=0){let f=this.c.get(r);if(f)f.value=c,t!==0&&this.l(f,t);else{switch(f={key:r,value:c,next:void 0,previous:void 0},t){case 0:this.j(f);break;case 1:this.i(f);break;case 2:this.j(f);break;default:this.j(f);break}this.c.set(r,f),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const c=this.c.get(r);if(c)return this.c.delete(r),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.k(r),this.f--,r.value}forEach(r,c){const t=this.g;let f=this.d;for(;f;){if(c?r.bind(c)(f.value,f.key,this):r(f.value,f.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.key,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}values(){const r=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:t.value,done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}entries(){const r=this,c=this.g;let t=this.d;const f={[Symbol.iterator](){return f},next(){if(r.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const h={value:[t.key,t.value],done:!1};return t=t.next,h}else return{value:void 0,done:!0}}};return f}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>r;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}j(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}k(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const c=r.next,t=r.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}r.next=void 0,r.previous=void 0,this.g++}l(r,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(r===this.d)return;const t=r.next,f=r.previous;r===this.e?(f.next=void 0,this.e=f):(t.previous=f,f.next=t),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(c===2){if(r===this.e)return;const t=r.next,f=r.previous;r===this.d?(t.previous=void 0,this.d=t):(t.previous=f,f.next=t),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((c,t)=>{r.push([t,c])}),r}fromJSON(r){this.clear();for(const[c,t]of r)this.set(c,t)}}e.$Cc=S;class y extends S{constructor(r,c=1){super(),this.m=r,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(r){this.m=r,this.o()}get ratio(){return this.n}set ratio(r){this.n=Math.min(Math.max(0,r),1),this.o()}get(r,c=2){return super.get(r,c)}peek(r){return super.get(r,0)}set(r,c){return super.set(r,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=y;class u{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let c=this.c.get(r)||0;return c===0?!1:(c--,c===0?this.c.delete(r):this.c.set(r,c),!0)}has(r){return this.c.has(r)}}e.$Ec=u;class m{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[c,t]of r)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(r,c){this.c.set(r,c),this.d.set(c,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const c=this.c.get(r);return c===void 0?!1:(this.c.delete(r),this.d.delete(c),!0)}forEach(r,c){this.c.forEach((t,f)=>{r.call(c,t,f,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=m;class o{constructor(){this.c=new Map}add(r,c){let t=this.c.get(r);t||(t=new Set,this.c.set(r,t)),t.add(c)}delete(r,c){const t=this.c.get(r);t&&(t.delete(c),t.size===0&&this.c.delete(r))}forEach(r,c){const t=this.c.get(r);t&&t.forEach(c)}get(r){const c=this.c.get(r);return c||new Set}}e.$Gc=o;function i(n,r){if(n===r)return!0;if(n.size!==r.size)return!1;for(const[c,t]of n)if(!r.has(c)||r.get(c)!==t)return!1;for(const[c]of r)if(!n.has(c))return!1;return!0}e.$Hc=i}),define(Se[3],De([1,0,19,72,28,73,48]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const w=!1;let p=null;class E{constructor(){this.b=new Map}static{this.a=0}c(P){let F=this.b.get(P);return F||(F={parent:null,source:null,isSingleton:!1,value:P,idx:E.a++},this.b.set(P,F)),F}trackDisposable(P){const F=this.c(P);F.source||(F.source=new Error().stack)}setParent(P,F){const U=this.c(P);U.parent=F}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,F){const U=F.get(P);if(U)return U;const z=P.parent?this.f(this.c(P.parent),F):P;return F.set(P,z),z}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,P).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(P=10,F){let U;if(F)U=F;else{const j=new Map,G=[...this.b.values()].filter(x=>x.source!==null&&!this.f(x,j).isSingleton);if(G.length===0)return;const te=new Set(G.map(x=>x.value));if(U=G.filter(x=>!(x.parent&&te.has(x.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(j){function G(x,Z){for(;x.length>0&&Z.some(X=>typeof X=="string"?X===x[0]:x[0].match(X));)x.shift()}const te=j.source.split(`
`).map(x=>x.trim().replace("at ","")).filter(x=>x!=="");return G(te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),te.reverse()}const T=new L.$Gc;for(const j of U){const G=z(j);for(let te=0;te<=G.length;te++)T.add(G.slice(0,te).join(`
`),j)}U.sort((0,l.$7b)(j=>j.idx,l.$9b));let I="",O=0;for(const j of U.slice(0,P)){O++;const G=z(j),te=[];for(let x=0;x<G.length;x++){let Z=G[x];Z=`(shared with ${T.get(G.slice(0,x+1).join(`
`)).size}/${U.length} leaks) at ${Z}`;const ae=T.get(G.slice(0,x).join(`
`)),_=(0,N.$K)([...ae].map(ge=>z(ge)[x]),ge=>ge);delete _[G[x]];for(const[ge,se]of Object.entries(_))te.unshift(`    - stacktraces of ${se.length} other leaks continue with ${ge}`);te.unshift(Z)}I+=`


==================== Leaking disposable ${O}/${U.length}: ${j.value.constructor.name} ====================
${te.join(`
`)}
============================================================

`}return U.length>P&&(I+=`


... and ${U.length-P} more leaking disposables

`),{leaks:U,details:I}}}e.$Ic=E;function M(k){p=k}if(e.$Jc=M,w){const k="__is_disposable_tracked__";M(new class{trackDisposable(P){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[k]||console.log(F)},3e3)}setParent(P,F){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[k]=!0}catch{}}markAsSingleton(P){}})}function C(k){return p?.trackDisposable(k),k}e.$Kc=C;function v(k){p?.markAsDisposed(k)}e.$Lc=v;function S(k,P){p?.setParent(k,P)}function y(k,P){if(p)for(const F of k)p.setParent(F,P)}function u(k){return p?.markAsSingleton(k),k}e.$Mc=u;function m(k){return typeof k.dispose=="function"&&k.dispose.length===0}e.$Nc=m;function o(k){if(R.Iterable.is(k)){const P=[];for(const F of k)if(F)try{F.dispose()}catch(U){P.push(U)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}e.$Oc=o;function i(k){for(const P of k)m(P)&&P.dispose();return[]}e.$Pc=i;function n(...k){const P=r(()=>o(k));return y(k,P),P}e.$Qc=n;function r(k){const P=C({dispose:(0,A.$db)(()=>{v(P),k()})});return P}e.$Rc=r;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return S(P,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),S(P,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,C(this),S(this.q,this)}dispose(){v(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Tc=t;class f{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&S(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&S(P,null),P}}e.$Uc=f;class h{constructor(P){this.a=new f,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=h;class s{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class a{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let F=P;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,v(this))},this}}e.$Xc=a;class d{constructor(){this.a=new Map}acquire(P,...F){let U=this.a.get(P);U||(U={counter:0,object:this.b(P,...F)},this.a.set(P,U));const{object:z}=U,T=(0,A.$db)(()=>{--U.counter===0&&(this.c(P,U.object),this.a.delete(P))});return U.counter++,{object:z,dispose:T}}}e.$Yc=d;class ${constructor(P){this.a=P}async acquire(P,...F){const U=this.a.acquire(P,...F);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$Zc=$;class D{constructor(P){this.object=P}dispose(){}}e.$1c=D;function b(k){const P=new c;try{k(P)}finally{P.dispose()}}e.$2c=b;class g{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,F,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(P)?.dispose(),this.a.set(P,F)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=g}),function(fe,e){typeof define=="function"&&define.amd?define(Se[164],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(fe=typeof globalThis<"u"?globalThis:fe||self,e(fe.marked={}))}(this,function(fe){"use strict";function e(ue,ce){for(var de=0;de<ce.length;de++){var H=ce[de];H.enumerable=H.enumerable||!1,H.configurable=!0,"value"in H&&(H.writable=!0),Object.defineProperty(ue,H.key,H)}}function l(ue,ce,de){return ce&&e(ue.prototype,ce),de&&e(ue,de),Object.defineProperty(ue,"prototype",{writable:!1}),ue}function N(ue,ce){if(ue){if(typeof ue=="string")return L(ue,ce);var de=Object.prototype.toString.call(ue).slice(8,-1);if(de==="Object"&&ue.constructor&&(de=ue.constructor.name),de==="Map"||de==="Set")return Array.from(ue);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return L(ue,ce)}}function L(ue,ce){(ce==null||ce>ue.length)&&(ce=ue.length);for(var de=0,H=new Array(ce);de<ce;de++)H[de]=ue[de];return H}function A(ue,ce){var de=typeof Symbol<"u"&&ue[Symbol.iterator]||ue["@@iterator"];if(de)return(de=de.call(ue)).next.bind(de);if(Array.isArray(ue)||(de=N(ue))||ce&&ue&&typeof ue.length=="number"){de&&(ue=de);var H=0;return function(){return H>=ue.length?{done:!0}:{done:!1,value:ue[H++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}fe.defaults=R();function w(ue){fe.defaults=ue}var p=/[&<>"']/,E=/[&<>"']/g,M=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ce){return v[ce]};function y(ue,ce){if(ce){if(p.test(ue))return ue.replace(E,S)}else if(M.test(ue))return ue.replace(C,S);return ue}var u=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function m(ue){return ue.replace(u,function(ce,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(ue,ce){ue=typeof ue=="string"?ue:ue.source,ce=ce||"";var de={replace:function(Y,he){return he=he.source||he,he=he.replace(o,"$1"),ue=ue.replace(Y,he),de},getRegex:function(){return new RegExp(ue,ce)}};return de}var n=/[^\w:]/g,r=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function c(ue,ce,de){if(ue){var H;try{H=decodeURIComponent(m(de)).replace(n,"").toLowerCase()}catch{return null}if(H.indexOf("javascript:")===0||H.indexOf("vbscript:")===0||H.indexOf("data:")===0)return null}ce&&!r.test(de)&&(de=a(ce,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},f=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function a(ue,ce){t[" "+ue]||(f.test(ue)?t[" "+ue]=ue+"/":t[" "+ue]=b(ue,"/",!0)),ue=t[" "+ue];var de=ue.indexOf(":")===-1;return ce.substring(0,2)==="//"?de?ce:ue.replace(h,"$1")+ce:ce.charAt(0)==="/"?de?ce:ue.replace(s,"$1")+ce:ue+ce}var d={exec:function(){}};function $(ue){for(var ce=1,de,H;ce<arguments.length;ce++){de=arguments[ce];for(H in de)Object.prototype.hasOwnProperty.call(de,H)&&(ue[H]=de[H])}return ue}function D(ue,ce){var de=ue.replace(/\|/g,function(he,be,Pe){for(var we=!1,Ae=be;--Ae>=0&&Pe[Ae]==="\\";)we=!we;return we?"|":" |"}),H=de.split(/ \|/),Y=0;if(H[0].trim()||H.shift(),H.length>0&&!H[H.length-1].trim()&&H.pop(),H.length>ce)H.splice(ce);else for(;H.length<ce;)H.push("");for(;Y<H.length;Y++)H[Y]=H[Y].trim().replace(/\\\|/g,"|");return H}function b(ue,ce,de){var H=ue.length;if(H===0)return"";for(var Y=0;Y<H;){var he=ue.charAt(H-Y-1);if(he===ce&&!de)Y++;else if(he!==ce&&de)Y++;else break}return ue.slice(0,H-Y)}function g(ue,ce){if(ue.indexOf(ce[1])===-1)return-1;for(var de=ue.length,H=0,Y=0;Y<de;Y++)if(ue[Y]==="\\")Y++;else if(ue[Y]===ce[0])H++;else if(ue[Y]===ce[1]&&(H--,H<0))return Y;return-1}function k(ue){ue&&ue.sanitize&&!ue.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ue,ce){if(ce<1)return"";for(var de="";ce>1;)ce&1&&(de+=ue),ce>>=1,ue+=ue;return de+ue}function F(ue,ce,de,H){var Y=ce.href,he=ce.title?y(ce.title):null,be=ue[1].replace(/\\([\[\]])/g,"$1");if(ue[0].charAt(0)!=="!"){H.state.inLink=!0;var Pe={type:"link",raw:de,href:Y,title:he,text:be,tokens:H.inlineTokens(be)};return H.state.inLink=!1,Pe}return{type:"image",raw:de,href:Y,title:he,text:y(be)}}function U(ue,ce){var de=ue.match(/^(\s+)(?:```)/);if(de===null)return ce;var H=de[1];return ce.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var be=he[0];return be.length>=H.length?Y.slice(H.length):Y}).join(`
`)}var z=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.space=function(H){var Y=this.rules.block.newline.exec(H);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ce.code=function(H){var Y=this.rules.block.code.exec(H);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:b(he,`
`)}}},ce.fences=function(H){var Y=this.rules.block.fences.exec(H);if(Y){var he=Y[0],be=U(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:be}}},ce.heading=function(H){var Y=this.rules.block.heading.exec(H);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var be=b(he,"#");(this.options.pedantic||!be||/ $/.test(be))&&(he=be.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},ce.hr=function(H){var Y=this.rules.block.hr.exec(H);if(Y)return{type:"hr",raw:Y[0]}},ce.blockquote=function(H){var Y=this.rules.block.blockquote.exec(H);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},ce.list=function(H){var Y=this.rules.block.list.exec(H);if(Y){var he,be,Pe,we,Ae,Oe,ze,q,W,Q,J,$e,ve=Y[1].trim(),Te=ve.length>1,He={type:"list",raw:"",ordered:Te,start:Te?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Te?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Te?ve:"[*+-]");for(var Xe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");H&&($e=!1,!(!(Y=Xe.exec(H))||this.rules.block.hr.test(H)));){if(he=Y[0],H=H.substring(he.length),q=Y[2].split(`
`,1)[0],W=H.split(`
`,1)[0],this.options.pedantic?(we=2,J=q.trimLeft()):(we=Y[2].search(/[^ ]/),we=we>4?1:we,J=q.slice(we),we+=Y[1].length),Oe=!1,!q&&/^ *$/.test(W)&&(he+=W+`
`,H=H.substring(W.length+1),$e=!0),!$e)for(var tt=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,we-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),ut=new RegExp("^ {0,"+Math.min(3,we-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,we-1)+"}#");H&&(Q=H.split(`
`,1)[0],q=Q,this.options.pedantic&&(q=q.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(ut.test(q)||rt.test(q)||tt.test(q)||st.test(H)));){if(q.search(/[^ ]/)>=we||!q.trim())J+=`
`+q.slice(we);else if(!Oe)J+=`
`+q;else break;!Oe&&!q.trim()&&(Oe=!0),he+=Q+`
`,H=H.substring(Q.length+1)}He.loose||(ze?He.loose=!0:/\n *\n *$/.test(he)&&(ze=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(J),be&&(Pe=be[0]!=="[ ] ",J=J.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:he,task:!!be,checked:Pe,loose:!1,text:J}),He.raw+=he}He.items[He.items.length-1].raw=he.trimRight(),He.items[He.items.length-1].text=J.trimRight(),He.raw=He.raw.trimRight();var Ie=He.items.length;for(Ae=0;Ae<Ie;Ae++){this.lexer.state.top=!1,He.items[Ae].tokens=this.lexer.blockTokens(He.items[Ae].text,[]);var Be=He.items[Ae].tokens.filter(function(Ke){return Ke.type==="space"}),Le=Be.every(function(Ke){for(var ne=Ke.raw.split(""),oe=0,Ce=A(ne),Ge;!(Ge=Ce()).done;){var xe=Ge.value;if(xe===`
`&&(oe+=1),oe>1)return!0}return!1});!He.loose&&Be.length&&Le&&(He.loose=!0,He.items[Ae].loose=!0)}return He}},ce.html=function(H){var Y=this.rules.block.html.exec(H);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(Y[0]):y(Y[0]);he.type="paragraph",he.text=be,he.tokens=this.lexer.inline(be)}return he}},ce.def=function(H){var Y=this.rules.block.def.exec(H);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},ce.table=function(H){var Y=this.rules.block.table.exec(H);if(Y){var he={type:"table",header:D(Y[1]).map(function(ze){return{text:ze}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var be=he.align.length,Pe,we,Ae,Oe;for(Pe=0;Pe<be;Pe++)/^ *-+: *$/.test(he.align[Pe])?he.align[Pe]="right":/^ *:-+: *$/.test(he.align[Pe])?he.align[Pe]="center":/^ *:-+ *$/.test(he.align[Pe])?he.align[Pe]="left":he.align[Pe]=null;for(be=he.rows.length,Pe=0;Pe<be;Pe++)he.rows[Pe]=D(he.rows[Pe],he.header.length).map(function(ze){return{text:ze}});for(be=he.header.length,we=0;we<be;we++)he.header[we].tokens=this.lexer.inline(he.header[we].text);for(be=he.rows.length,we=0;we<be;we++)for(Oe=he.rows[we],Ae=0;Ae<Oe.length;Ae++)Oe[Ae].tokens=this.lexer.inline(Oe[Ae].text);return he}}},ce.lheading=function(H){var Y=this.rules.block.lheading.exec(H);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ce.paragraph=function(H){var Y=this.rules.block.paragraph.exec(H);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},ce.text=function(H){var Y=this.rules.block.text.exec(H);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ce.escape=function(H){var Y=this.rules.inline.escape.exec(H);if(Y)return{type:"escape",raw:Y[0],text:y(Y[1])}},ce.tag=function(H){var Y=this.rules.inline.tag.exec(H);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):y(Y[0]):Y[0]}},ce.link=function(H){var Y=this.rules.inline.link.exec(H);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var be=b(he.slice(0,-1),"\\");if((he.length-be.length)%2===0)return}else{var Pe=g(Y[2],"()");if(Pe>-1){var we=Y[0].indexOf("!")===0?5:4,Ae=we+Y[1].length+Pe;Y[2]=Y[2].substring(0,Pe),Y[0]=Y[0].substring(0,Ae).trim(),Y[3]=""}}var Oe=Y[2],ze="";if(this.options.pedantic){var q=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Oe);q&&(Oe=q[1],ze=q[3])}else ze=Y[3]?Y[3].slice(1,-1):"";return Oe=Oe.trim(),/^</.test(Oe)&&(this.options.pedantic&&!/>$/.test(he)?Oe=Oe.slice(1):Oe=Oe.slice(1,-1)),F(Y,{href:Oe&&Oe.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ce.reflink=function(H,Y){var he;if((he=this.rules.inline.reflink.exec(H))||(he=this.rules.inline.nolink.exec(H))){var be=(he[2]||he[1]).replace(/\s+/g," ");if(be=Y[be.toLowerCase()],!be||!be.href){var Pe=he[0].charAt(0);return{type:"text",raw:Pe,text:Pe}}return F(he,be,he[0],this.lexer)}},ce.emStrong=function(H,Y,he){he===void 0&&(he="");var be=this.rules.inline.emStrong.lDelim.exec(H);if(be&&!(be[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Pe=be[1]||be[2]||"";if(!Pe||Pe&&(he===""||this.rules.inline.punctuation.exec(he))){var we=be[0].length-1,Ae,Oe,ze=we,q=0,W=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,Y=Y.slice(-1*H.length+we);(be=W.exec(Y))!=null;)if(Ae=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!Ae){if(Oe=Ae.length,be[3]||be[4]){ze+=Oe;continue}else if((be[5]||be[6])&&we%3&&!((we+Oe)%3)){q+=Oe;continue}if(ze-=Oe,!(ze>0)){if(Oe=Math.min(Oe,Oe+ze+q),Math.min(we,Oe)%2){var Q=H.slice(1,we+be.index+Oe);return{type:"em",raw:H.slice(0,we+be.index+Oe+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var J=H.slice(2,we+be.index+Oe-1);return{type:"strong",raw:H.slice(0,we+be.index+Oe+1),text:J,tokens:this.lexer.inlineTokens(J)}}}}}},ce.codespan=function(H){var Y=this.rules.inline.code.exec(H);if(Y){var he=Y[2].replace(/\n/g," "),be=/[^ ]/.test(he),Pe=/^ /.test(he)&&/ $/.test(he);return be&&Pe&&(he=he.substring(1,he.length-1)),he=y(he,!0),{type:"codespan",raw:Y[0],text:he}}},ce.br=function(H){var Y=this.rules.inline.br.exec(H);if(Y)return{type:"br",raw:Y[0]}},ce.del=function(H){var Y=this.rules.inline.del.exec(H);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ce.autolink=function(H,Y){var he=this.rules.inline.autolink.exec(H);if(he){var be,Pe;return he[2]==="@"?(be=y(this.options.mangle?Y(he[1]):he[1]),Pe="mailto:"+be):(be=y(he[1]),Pe=be),{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ce.url=function(H,Y){var he;if(he=this.rules.inline.url.exec(H)){var be,Pe;if(he[2]==="@")be=y(this.options.mangle?Y(he[0]):he[0]),Pe="mailto:"+be;else{var we;do we=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(we!==he[0]);be=y(he[0]),he[1]==="www."?Pe="http://"+be:Pe=be}return{type:"link",raw:he[0],text:be,href:Pe,tokens:[{type:"text",raw:be,text:be}]}}},ce.inlineText=function(H,Y){var he=this.rules.inline.text.exec(H);if(he){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):y(he[0]):he[0]:be=y(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:be}}},ue}(),T={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:d,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};T._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,T._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,T.def=i(T.def).replace("label",T._label).replace("title",T._title).getRegex(),T.bullet=/(?:[*+-]|\d{1,9}[.)])/,T.listItemStart=i(/^( *)(bull) */).replace("bull",T.bullet).getRegex(),T.list=i(T.list).replace(/bull/g,T.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+T.def.source+")").getRegex(),T._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",T._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,T.html=i(T.html,"i").replace("comment",T._comment).replace("tag",T._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),T.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.blockquote=i(T.blockquote).replace("paragraph",T.paragraph).getRegex(),T.normal=$({},T),T.gfm=$({},T.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),T.gfm.table=i(T.gfm.table).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.gfm.paragraph=i(T._paragraph).replace("hr",T.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",T.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",T._tag).getRegex(),T.pedantic=$({},T.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",T._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:d,paragraph:i(T.normal._paragraph).replace("hr",T.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",T.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var I={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:d,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:d,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};I._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",I.punctuation=i(I.punctuation).replace(/punctuation/g,I._punctuation).getRegex(),I.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,I.escapedEmSt=/\\\*|\\_/g,I._comment=i(T._comment).replace("(?:-->|$)","-->").getRegex(),I.emStrong.lDelim=i(I.emStrong.lDelim).replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimAst=i(I.emStrong.rDelimAst,"g").replace(/punct/g,I._punctuation).getRegex(),I.emStrong.rDelimUnd=i(I.emStrong.rDelimUnd,"g").replace(/punct/g,I._punctuation).getRegex(),I._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,I._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,I._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,I.autolink=i(I.autolink).replace("scheme",I._scheme).replace("email",I._email).getRegex(),I._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,I.tag=i(I.tag).replace("comment",I._comment).replace("attribute",I._attribute).getRegex(),I._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,I._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,I._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,I.link=i(I.link).replace("label",I._label).replace("href",I._href).replace("title",I._title).getRegex(),I.reflink=i(I.reflink).replace("label",I._label).replace("ref",T._label).getRegex(),I.nolink=i(I.nolink).replace("ref",T._label).getRegex(),I.reflinkSearch=i(I.reflinkSearch,"g").replace("reflink",I.reflink).replace("nolink",I.nolink).getRegex(),I.normal=$({},I),I.pedantic=$({},I.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",I._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",I._label).getRegex()}),I.gfm=$({},I.normal,{escape:i(I.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),I.gfm.url=i(I.gfm.url,"i").replace("email",I.gfm._extended_email).getRegex(),I.breaks=$({},I.gfm,{br:i(I.br).replace("{2,}","*").getRegex(),text:i(I.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function O(ue){return ue.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function j(ue){var ce="",de,H,Y=ue.length;for(de=0;de<Y;de++)H=ue.charCodeAt(de),Math.random()>.5&&(H="x"+H.toString(16)),ce+="&#"+H+";";return ce}var G=function(){function ue(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||fe.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var H={block:T.normal,inline:I.normal};this.options.pedantic?(H.block=T.pedantic,H.inline=I.pedantic):this.options.gfm&&(H.block=T.gfm,this.options.breaks?H.inline=I.breaks:H.inline=I.gfm),this.tokenizer.rules=H}ue.lex=function(H,Y){var he=new ue(Y);return he.lex(H)},ue.lexInline=function(H,Y){var he=new ue(Y);return he.inlineTokens(H)};var ce=ue.prototype;return ce.lex=function(H){H=H.replace(/\r\n|\r/g,`
`),this.blockTokens(H,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ce.blockTokens=function(H,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?H=H.replace(/\t/g,"    ").replace(/^ +$/gm,""):H=H.replace(/^( *)(\t+)/gm,function(ze,q,W){return q+"    ".repeat(W.length)});for(var be,Pe,we,Ae;H;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(be=ze.call({lexer:he},H,Y))?(H=H.substring(be.raw.length),Y.push(be),!0):!1}))){if(be=this.tokenizer.space(H)){H=H.substring(be.raw.length),be.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(be);continue}if(be=this.tokenizer.code(H)){H=H.substring(be.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(be);continue}if(be=this.tokenizer.fences(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.heading(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.hr(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.blockquote(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.list(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.html(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.def(H)){H=H.substring(be.raw.length),Pe=Y[Y.length-1],Pe&&(Pe.type==="paragraph"||Pe.type==="text")?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.lheading(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(we=H,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,q=H.slice(1),W=void 0;he.options.extensions.startBlock.forEach(function(Q){W=Q.call({lexer:this},q),typeof W=="number"&&W>=0&&(ze=Math.min(ze,W))}),ze<1/0&&ze>=0&&(we=H.substring(0,ze+1))}(),this.state.top&&(be=this.tokenizer.paragraph(we))){Pe=Y[Y.length-1],Ae&&Pe.type==="paragraph"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(be),Ae=we.length!==H.length,H=H.substring(be.raw.length);continue}if(be=this.tokenizer.text(H)){H=H.substring(be.raw.length),Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+be.raw,Pe.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Pe.text):Y.push(be);continue}if(H){var Oe="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Oe);break}else throw new Error(Oe)}}return this.state.top=!0,Y},ce.inline=function(H,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:H,tokens:Y}),Y},ce.inlineTokens=function(H,Y){var he=this;Y===void 0&&(Y=[]);var be,Pe,we,Ae=H,Oe,ze,q;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Oe=this.tokenizer.rules.inline.reflinkSearch.exec(Ae))!=null;)W.includes(Oe[0].slice(Oe[0].lastIndexOf("[")+1,-1))&&(Ae=Ae.slice(0,Oe.index)+"["+P("a",Oe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Oe=this.tokenizer.rules.inline.blockSkip.exec(Ae))!=null;)Ae=Ae.slice(0,Oe.index)+"["+P("a",Oe[0].length-2)+"]"+Ae.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Oe=this.tokenizer.rules.inline.escapedEmSt.exec(Ae))!=null;)Ae=Ae.slice(0,Oe.index)+"++"+Ae.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;H;)if(ze||(q=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(J){return(be=J.call({lexer:he},H,Y))?(H=H.substring(be.raw.length),Y.push(be),!0):!1}))){if(be=this.tokenizer.escape(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.tag(H)){H=H.substring(be.raw.length),Pe=Y[Y.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Y.push(be);continue}if(be=this.tokenizer.link(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.reflink(H,this.tokens.links)){H=H.substring(be.raw.length),Pe=Y[Y.length-1],Pe&&be.type==="text"&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Y.push(be);continue}if(be=this.tokenizer.emStrong(H,Ae,q)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.codespan(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.br(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.del(H)){H=H.substring(be.raw.length),Y.push(be);continue}if(be=this.tokenizer.autolink(H,j)){H=H.substring(be.raw.length),Y.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(H,j))){H=H.substring(be.raw.length),Y.push(be);continue}if(we=H,this.options.extensions&&this.options.extensions.startInline&&function(){var J=1/0,$e=H.slice(1),ve=void 0;he.options.extensions.startInline.forEach(function(Te){ve=Te.call({lexer:this},$e),typeof ve=="number"&&ve>=0&&(J=Math.min(J,ve))}),J<1/0&&J>=0&&(we=H.substring(0,J+1))}(),be=this.tokenizer.inlineText(we,O)){H=H.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(q=be.raw.slice(-1)),ze=!0,Pe=Y[Y.length-1],Pe&&Pe.type==="text"?(Pe.raw+=be.raw,Pe.text+=be.text):Y.push(be);continue}if(H){var Q="Infinite loop on byte: "+H.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return Y},l(ue,null,[{key:"rules",get:function(){return{block:T,inline:I}}}]),ue}(),te=function(){function ue(de){this.options=de||fe.defaults}var ce=ue.prototype;return ce.code=function(H,Y,he){var be=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Pe=this.options.highlight(H,be);Pe!=null&&Pe!==H&&(he=!0,H=Pe)}return H=H.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+y(be,!0)+'">'+(he?H:y(H,!0))+`</code></pre>
`:"<pre><code>"+(he?H:y(H,!0))+`</code></pre>
`},ce.blockquote=function(H){return`<blockquote>
`+H+`</blockquote>
`},ce.html=function(H){return H},ce.heading=function(H,Y,he,be){if(this.options.headerIds){var Pe=this.options.headerPrefix+be.slug(he);return"<h"+Y+' id="'+Pe+'">'+H+"</h"+Y+`>
`}return"<h"+Y+">"+H+"</h"+Y+`>
`},ce.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ce.list=function(H,Y,he){var be=Y?"ol":"ul",Pe=Y&&he!==1?' start="'+he+'"':"";return"<"+be+Pe+`>
`+H+"</"+be+`>
`},ce.listitem=function(H){return"<li>"+H+`</li>
`},ce.checkbox=function(H){return"<input "+(H?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ce.paragraph=function(H){return"<p>"+H+`</p>
`},ce.table=function(H,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+H+`</thead>
`+Y+`</table>
`},ce.tablerow=function(H){return`<tr>
`+H+`</tr>
`},ce.tablecell=function(H,Y){var he=Y.header?"th":"td",be=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return be+H+("</"+he+`>
`)},ce.strong=function(H){return"<strong>"+H+"</strong>"},ce.em=function(H){return"<em>"+H+"</em>"},ce.codespan=function(H){return"<code>"+H+"</code>"},ce.br=function(){return this.options.xhtml?"<br/>":"<br>"},ce.del=function(H){return"<del>"+H+"</del>"},ce.link=function(H,Y,he){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var be='<a href="'+y(H)+'"';return Y&&(be+=' title="'+Y+'"'),be+=">"+he+"</a>",be},ce.image=function(H,Y,he){if(H=c(this.options.sanitize,this.options.baseUrl,H),H===null)return he;var be='<img src="'+H+'" alt="'+he+'"';return Y&&(be+=' title="'+Y+'"'),be+=this.options.xhtml?"/>":">",be},ce.text=function(H){return H},ue}(),x=function(){function ue(){}var ce=ue.prototype;return ce.strong=function(H){return H},ce.em=function(H){return H},ce.codespan=function(H){return H},ce.del=function(H){return H},ce.html=function(H){return H},ce.text=function(H){return H},ce.link=function(H,Y,he){return""+he},ce.image=function(H,Y,he){return""+he},ce.br=function(){return""},ue}(),Z=function(){function ue(){this.seen={}}var ce=ue.prototype;return ce.serialize=function(H){return H.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ce.getNextSafeSlug=function(H,Y){var he=H,be=0;if(this.seen.hasOwnProperty(he)){be=this.seen[H];do be++,he=H+"-"+be;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[H]=be,this.seen[he]=0),he},ce.slug=function(H,Y){Y===void 0&&(Y={});var he=this.serialize(H);return this.getNextSafeSlug(he,Y.dryrun)},ue}(),X=function(){function ue(de){this.options=de||fe.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new x,this.slugger=new Z}ue.parse=function(H,Y){var he=new ue(Y);return he.parse(H)},ue.parseInline=function(H,Y){var he=new ue(Y);return he.parseInline(H)};var ce=ue.prototype;return ce.parse=function(H,Y){Y===void 0&&(Y=!0);var he="",be,Pe,we,Ae,Oe,ze,q,W,Q,J,$e,ve,Te,He,Xe,tt,st,ut,rt,Ie=H.length;for(be=0;be<Ie;be++){if(J=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[J.type]&&(rt=this.options.extensions.renderers[J.type].call({parser:this},J),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(J.type))){he+=rt||"";continue}switch(J.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(J.tokens),J.depth,m(this.parseInline(J.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(J.text,J.lang,J.escaped);continue}case"table":{for(W="",q="",Ae=J.header.length,Pe=0;Pe<Ae;Pe++)q+=this.renderer.tablecell(this.parseInline(J.header[Pe].tokens),{header:!0,align:J.align[Pe]});for(W+=this.renderer.tablerow(q),Q="",Ae=J.rows.length,Pe=0;Pe<Ae;Pe++){for(ze=J.rows[Pe],q="",Oe=ze.length,we=0;we<Oe;we++)q+=this.renderer.tablecell(this.parseInline(ze[we].tokens),{header:!1,align:J.align[we]});Q+=this.renderer.tablerow(q)}he+=this.renderer.table(W,Q);continue}case"blockquote":{Q=this.parse(J.tokens),he+=this.renderer.blockquote(Q);continue}case"list":{for($e=J.ordered,ve=J.start,Te=J.loose,Ae=J.items.length,Q="",Pe=0;Pe<Ae;Pe++)Xe=J.items[Pe],tt=Xe.checked,st=Xe.task,He="",Xe.task&&(ut=this.renderer.checkbox(tt),Te?Xe.tokens.length>0&&Xe.tokens[0].type==="paragraph"?(Xe.tokens[0].text=ut+" "+Xe.tokens[0].text,Xe.tokens[0].tokens&&Xe.tokens[0].tokens.length>0&&Xe.tokens[0].tokens[0].type==="text"&&(Xe.tokens[0].tokens[0].text=ut+" "+Xe.tokens[0].tokens[0].text)):Xe.tokens.unshift({type:"text",text:ut}):He+=ut),He+=this.parse(Xe.tokens,Te),Q+=this.renderer.listitem(He,st,tt);he+=this.renderer.list(Q,$e,ve);continue}case"html":{he+=this.renderer.html(J.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(J.tokens));continue}case"text":{for(Q=J.tokens?this.parseInline(J.tokens):J.text;be+1<Ie&&H[be+1].type==="text";)J=H[++be],Q+=`
`+(J.tokens?this.parseInline(J.tokens):J.text);he+=Y?this.renderer.paragraph(Q):Q;continue}default:{var Be='Token with "'+J.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return he},ce.parseInline=function(H,Y){Y=Y||this.renderer;var he="",be,Pe,we,Ae=H.length;for(be=0;be<Ae;be++){if(Pe=H[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(we=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),we!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Pe.type))){he+=we||"";continue}switch(Pe.type){case"escape":{he+=Y.text(Pe.text);break}case"html":{he+=Y.html(Pe.text);break}case"link":{he+=Y.link(Pe.href,Pe.title,this.parseInline(Pe.tokens,Y));break}case"image":{he+=Y.image(Pe.href,Pe.title,Pe.text);break}case"strong":{he+=Y.strong(this.parseInline(Pe.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Pe.tokens,Y));break}case"codespan":{he+=Y.codespan(Pe.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Pe.tokens,Y));break}case"text":{he+=Y.text(Pe.text);break}default:{var Oe='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(Oe);return}else throw new Error(Oe)}}}return he},ue}();function ae(ue,ce,de){if(typeof ue>"u"||ue===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");if(typeof ce=="function"&&(de=ce,ce=null),ce=$({},ae.defaults,ce||{}),k(ce),de){var H=ce.highlight,Y;try{Y=G.lex(ue,ce)}catch(Ae){return de(Ae)}var he=function(Oe){var ze;if(!Oe)try{ce.walkTokens&&ae.walkTokens(Y,ce.walkTokens),ze=X.parse(Y,ce)}catch(q){Oe=q}return ce.highlight=H,Oe?de(Oe):de(null,ze)};if(!H||H.length<3||(delete ce.highlight,!Y.length))return he();var be=0;ae.walkTokens(Y,function(Ae){Ae.type==="code"&&(be++,setTimeout(function(){H(Ae.text,Ae.lang,function(Oe,ze){if(Oe)return he(Oe);ze!=null&&ze!==Ae.text&&(Ae.text=ze,Ae.escaped=!0),be--,be===0&&he()})},0))}),be===0&&he();return}function Pe(Ae){if(Ae.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+y(Ae.message+"",!0)+"</pre>";throw Ae}try{var we=G.lex(ue,ce);if(ce.walkTokens){if(ce.async)return Promise.all(ae.walkTokens(we,ce.walkTokens)).then(function(){return X.parse(we,ce)}).catch(Pe);ae.walkTokens(we,ce.walkTokens)}return X.parse(we,ce)}catch(Ae){Pe(Ae)}}ae.options=ae.setOptions=function(ue){return $(ae.defaults,ue),w(ae.defaults),ae},ae.getDefaults=R,ae.defaults=fe.defaults,ae.use=function(){for(var ue=arguments.length,ce=new Array(ue),de=0;de<ue;de++)ce[de]=arguments[de];var H=$.apply(void 0,[{}].concat(ce)),Y=ae.defaults.extensions||{renderers:{},childTokens:{}},he;ce.forEach(function(be){if(be.extensions&&(he=!0,be.extensions.forEach(function(we){if(!we.name)throw new Error("extension name required");if(we.renderer){var Ae=Y.renderers?Y.renderers[we.name]:null;Ae?Y.renderers[we.name]=function(){for(var Oe=arguments.length,ze=new Array(Oe),q=0;q<Oe;q++)ze[q]=arguments[q];var W=we.renderer.apply(this,ze);return W===!1&&(W=Ae.apply(this,ze)),W}:Y.renderers[we.name]=we.renderer}if(we.tokenizer){if(!we.level||we.level!=="block"&&we.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[we.level]?Y[we.level].unshift(we.tokenizer):Y[we.level]=[we.tokenizer],we.start&&(we.level==="block"?Y.startBlock?Y.startBlock.push(we.start):Y.startBlock=[we.start]:we.level==="inline"&&(Y.startInline?Y.startInline.push(we.start):Y.startInline=[we.start]))}we.childTokens&&(Y.childTokens[we.name]=we.childTokens)})),be.renderer&&function(){var we=ae.defaults.renderer||new te,Ae=function(q){var W=we[q];we[q]=function(){for(var Q=arguments.length,J=new Array(Q),$e=0;$e<Q;$e++)J[$e]=arguments[$e];var ve=be.renderer[q].apply(we,J);return ve===!1&&(ve=W.apply(we,J)),ve}};for(var Oe in be.renderer)Ae(Oe);H.renderer=we}(),be.tokenizer&&function(){var we=ae.defaults.tokenizer||new z,Ae=function(q){var W=we[q];we[q]=function(){for(var Q=arguments.length,J=new Array(Q),$e=0;$e<Q;$e++)J[$e]=arguments[$e];var ve=be.tokenizer[q].apply(we,J);return ve===!1&&(ve=W.apply(we,J)),ve}};for(var Oe in be.tokenizer)Ae(Oe);H.tokenizer=we}(),be.walkTokens){var Pe=ae.defaults.walkTokens;H.walkTokens=function(we){var Ae=[];return Ae.push(be.walkTokens.call(this,we)),Pe&&(Ae=Ae.concat(Pe.call(this,we))),Ae}}he&&(H.extensions=Y),ae.setOptions(H)})},ae.walkTokens=function(ue,ce){for(var de=[],H=function(){var Pe=he.value;switch(de=de.concat(ce.call(ae,Pe)),Pe.type){case"table":{for(var we=A(Pe.header),Ae;!(Ae=we()).done;){var Oe=Ae.value;de=de.concat(ae.walkTokens(Oe.tokens,ce))}for(var ze=A(Pe.rows),q;!(q=ze()).done;)for(var W=q.value,Q=A(W),J;!(J=Q()).done;){var $e=J.value;de=de.concat(ae.walkTokens($e.tokens,ce))}break}case"list":{de=de.concat(ae.walkTokens(Pe.items,ce));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Pe.type]?ae.defaults.extensions.childTokens[Pe.type].forEach(function(ve){de=de.concat(ae.walkTokens(Pe[ve],ce))}):Pe.tokens&&(de=de.concat(ae.walkTokens(Pe.tokens,ce)))}},Y=A(ue),he;!(he=Y()).done;)H();return de},ae.parseInline=function(ue,ce){if(typeof ue>"u"||ue===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ue!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ue)+", string expected");ce=$({},ae.defaults,ce||{}),k(ce);try{var de=G.lexInline(ue,ce);return ce.walkTokens&&ae.walkTokens(de,ce.walkTokens),X.parseInline(de,ce)}catch(H){if(H.message+=`
Please report this to https://github.com/markedjs/marked.`,ce.silent)return"<p>An error occurred:</p><pre>"+y(H.message+"",!0)+"</pre>";throw H}},ae.Parser=X,ae.parser=X.parse,ae.Renderer=te,ae.TextRenderer=x,ae.Lexer=G,ae.lexer=G.lex,ae.Tokenizer=z,ae.Slugger=Z,ae.parse=ae;var _=ae.options,ge=ae.setOptions,se=ae.use,re=ae.walkTokens,B=ae.parseInline,ie=ae,ke=X.parse,le=G.lex;fe.Lexer=G,fe.Parser=X,fe.Renderer=te,fe.Slugger=Z,fe.TextRenderer=x,fe.Tokenizer=z,fe.getDefaults=R,fe.lexer=le,fe.marked=ae,fe.options=_,fe.parse=ie,fe.parseInline=B,fe.parser=ke,fe.setOptions=ge,fe.use=se,fe.walkTokens=re,Object.defineProperty(fe,"__esModule",{value:!0})}),define(Se[165],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=void 0;function l(u){const m=A(u);if(m&&m.length>0)return new Uint32Array(m)}e.$5j=l;let N=0;const L=new Uint32Array(10);function A(u){if(N=0,R(u,C,4352),N>0||(R(u,v,4449),N>0)||(R(u,S,4520),N>0)||(R(u,y,12593),N))return L.subarray(0,N);if(u>=44032&&u<=55203){const m=u-44032,o=m%588,i=Math.floor(m/588),n=Math.floor(o/28),r=o%28-1;if(i<C.length?R(i,C,0):4352+i-12593<y.length&&R(4352+i,y,12593),n<v.length?R(n,v,0):4449+n-12593<y.length&&R(4449+n-12593,y,12593),r>=0&&(r<S.length?R(r,S,0):4520+r-12593<y.length&&R(4520+r-12593,y,12593)),N>0)return L.subarray(0,N)}}function R(u,m,o){u>=o&&u<o+m.length&&w(m[u-o])}function w(u){u!==0&&(L[N++]=u&255,u>>8&&(L[N++]=u>>8&255),u>>16&&(L[N++]=u>>16&255))}var p;(function(u){u[u.InitialConsonant=4352]="InitialConsonant",u[u.Vowel=4449]="Vowel",u[u.FinalConsonant=4520]="FinalConsonant",u[u.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var E;(function(u){u[u.NUL=0]="NUL",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z"})(E||(E={}));var M;(function(u){u[u.fa=24934]="fa",u[u.fg=26470]="fg",u[u.fq=29030]="fq",u[u.fr=29286]="fr",u[u.ft=29798]="ft",u[u.fv=30310]="fv",u[u.fx=30822]="fx",u[u.hk=27496]="hk",u[u.hl=27752]="hl",u[u.ho=28520]="ho",u[u.ml=27757]="ml",u[u.nj=27246]="nj",u[u.nl=27758]="nl",u[u.np=28782]="np",u[u.qt=29809]="qt",u[u.rt=29810]="rt",u[u.sg=26483]="sg",u[u.sw=30579]="sw"})(M||(M={}));const C=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),v=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),S=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),y=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[75],De([1,0,28]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=e.$Rl=void 0;const N=new l.$Dc(1e4);function L(E){return p(E,"NFC",N)}e.$Rl=L;const A=new l.$Dc(1e4);function R(E){return p(E,"NFD",A)}e.$Sl=R;const w=/[^\u0000-\u0080]/;function p(E,M,C){if(!E)return E;const v=C.get(E);if(v)return v;let S;return w.test(E)?S=E.normalize(M):S=E,C.set(E,S),S}e.$Tl=function(){const E=/[\u0300-\u036f]/g;return function(M){return R(M).replace(E,"")}}()}),define(Se[125],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=e.$im=e.$hm=e.rot=e.$fm=void 0;function l(w,p,E){return Math.min(Math.max(w,p),E)}e.$fm=l;function N(w,p){return(p+w%p)%p}e.rot=N;class L{constructor(){this.a=0}getNext(){return this.a++}}e.$hm=L;class A{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$im=A;class R{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const E=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$jm=R}),function(){function fe(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function R(p){A.push(p,Date.now())}function w(){const p=[];for(let E=0;E<A.length;E+=2)p.push({name:A[E],startTime:A[E+1]});return p}return{mark:R,getMarks:w}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?fe():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(L+R.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return fe(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),fe()}function l(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return l(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=l(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=l(N))}(),function(fe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var l=e();for(var N in l)(typeof exports=="object"?exports:fe)[N]=l[N]}}(typeof self<"u"?self:this,function(){return function(fe){var e={};function l(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return fe[N].call(L.exports,L,L.exports,l),L.l=!0,L.exports}return l.m=fe,l.c=e,l.d=function(N,L,A){l.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},l.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},l.t=function(N,L){if(1&L&&(N=l(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(l.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var R in N)l.d(A,R,function(w){return N[w]}.bind(null,R));return A},l.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return l.d(L,"a",L),L},l.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},l.p="",l(l.s=0)}([function(fe,e,l){(function(N){var L;e=fe.exports=se,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=e.re=[],p=e.src=[],E=0,M=E++;p[M]="0|[1-9]\\d*";var C=E++;p[C]="[0-9]+";var v=E++;p[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=E++;p[S]="("+p[M]+")\\.("+p[M]+")\\.("+p[M]+")";var y=E++;p[y]="("+p[C]+")\\.("+p[C]+")\\.("+p[C]+")";var u=E++;p[u]="(?:"+p[M]+"|"+p[v]+")";var m=E++;p[m]="(?:"+p[C]+"|"+p[v]+")";var o=E++;p[o]="(?:-("+p[u]+"(?:\\."+p[u]+")*))";var i=E++;p[i]="(?:-?("+p[m]+"(?:\\."+p[m]+")*))";var n=E++;p[n]="[0-9A-Za-z-]+";var r=E++;p[r]="(?:\\+("+p[n]+"(?:\\."+p[n]+")*))";var c=E++,t="v?"+p[S]+p[o]+"?"+p[r]+"?";p[c]="^"+t+"$";var f="[v=\\s]*"+p[y]+p[i]+"?"+p[r]+"?",h=E++;p[h]="^"+f+"$";var s=E++;p[s]="((?:<|>)?=?)";var a=E++;p[a]=p[C]+"|x|X|\\*";var d=E++;p[d]=p[M]+"|x|X|\\*";var $=E++;p[$]="[v=\\s]*("+p[d]+")(?:\\.("+p[d]+")(?:\\.("+p[d]+")(?:"+p[o]+")?"+p[r]+"?)?)?";var D=E++;p[D]="[v=\\s]*("+p[a]+")(?:\\.("+p[a]+")(?:\\.("+p[a]+")(?:"+p[i]+")?"+p[r]+"?)?)?";var b=E++;p[b]="^"+p[s]+"\\s*"+p[$]+"$";var g=E++;p[g]="^"+p[s]+"\\s*"+p[D]+"$";var k=E++;p[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;p[P]="(?:~>?)";var F=E++;p[F]="(\\s*)"+p[P]+"\\s+",w[F]=new RegExp(p[F],"g");var U=E++;p[U]="^"+p[P]+p[$]+"$";var z=E++;p[z]="^"+p[P]+p[D]+"$";var T=E++;p[T]="(?:\\^)";var I=E++;p[I]="(\\s*)"+p[T]+"\\s+",w[I]=new RegExp(p[I],"g");var O=E++;p[O]="^"+p[T]+p[$]+"$";var j=E++;p[j]="^"+p[T]+p[D]+"$";var G=E++;p[G]="^"+p[s]+"\\s*("+f+")$|^$";var te=E++;p[te]="^"+p[s]+"\\s*("+t+")$|^$";var x=E++;p[x]="(\\s*)"+p[s]+"\\s*("+f+"|"+p[$]+")",w[x]=new RegExp(p[x],"g");var Z=E++;p[Z]="^\\s*("+p[$]+")\\s+-\\s+("+p[$]+")\\s*$";var X=E++;p[X]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var ae=E++;p[ae]="(<|>)?=?\\s*\\*";for(var _=0;_<35;_++)L(_,p[_]),w[_]||(w[_]=new RegExp(p[_]));function ge(W,Q){if(W instanceof se)return W;if(typeof W!="string"||W.length>A||!(Q?w[h]:w[c]).test(W))return null;try{return new se(W,Q)}catch{return null}}function se(W,Q){if(W instanceof se){if(W.loose===Q)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof se))return new se(W,Q);L("SemVer",W,Q),this.loose=Q;var J=W.trim().match(Q?w[h]:w[c]);if(!J)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var ve=+$e;if(ve>=0&&ve<R)return ve}return $e}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}e.parse=ge,e.valid=function(W,Q){var J=ge(W,Q);return J?J.version:null},e.clean=function(W,Q){var J=ge(W.trim().replace(/^[=v]+/,""),Q);return J?J.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(W){return L("SemVer.compare",this.version,this.loose,W),W instanceof se||(W=new se(W,this.loose)),this.compareMain(W)||this.comparePre(W)},se.prototype.compareMain=function(W){return W instanceof se||(W=new se(W,this.loose)),B(this.major,W.major)||B(this.minor,W.minor)||B(this.patch,W.patch)},se.prototype.comparePre=function(W){if(W instanceof se||(W=new se(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var Q=0;do{var J=this.prerelease[Q],$e=W.prerelease[Q];if(L("prerelease compare",Q,J,$e),J===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(J===void 0)return-1;if(J!==$e)return B(J,$e)}while(++Q)},se.prototype.inc=function(W,Q){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,Q,J,$e){typeof J=="string"&&($e=J,J=void 0);try{return new se(W,J).inc(Q,$e).version}catch{return null}},e.diff=function(W,Q){if(ue(W,Q))return null;var J=ge(W),$e=ge(Q);if(J.prerelease.length||$e.prerelease.length){for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==$e[ve])return"pre"+ve;return"prerelease"}for(var ve in J)if((ve==="major"||ve==="minor"||ve==="patch")&&J[ve]!==$e[ve])return ve},e.compareIdentifiers=B;var re=/^[0-9]+$/;function B(W,Q){var J=re.test(W),$e=re.test(Q);return J&&$e&&(W=+W,Q=+Q),J&&!$e?-1:$e&&!J?1:W<Q?-1:W>Q?1:0}function ie(W,Q,J){return new se(W,J).compare(new se(Q,J))}function ke(W,Q,J){return ie(W,Q,J)>0}function le(W,Q,J){return ie(W,Q,J)<0}function ue(W,Q,J){return ie(W,Q,J)===0}function ce(W,Q,J){return ie(W,Q,J)!==0}function de(W,Q,J){return ie(W,Q,J)>=0}function H(W,Q,J){return ie(W,Q,J)<=0}function Y(W,Q,J,$e){var ve;switch(Q){case"===":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),ve=W===J;break;case"!==":typeof W=="object"&&(W=W.version),typeof J=="object"&&(J=J.version),ve=W!==J;break;case"":case"=":case"==":ve=ue(W,J,$e);break;case"!=":ve=ce(W,J,$e);break;case">":ve=ke(W,J,$e);break;case">=":ve=de(W,J,$e);break;case"<":ve=le(W,J,$e);break;case"<=":ve=H(W,J,$e);break;default:throw new TypeError("Invalid operator: "+Q)}return ve}function he(W,Q){if(W instanceof he){if(W.loose===Q)return W;W=W.value}if(!(this instanceof he))return new he(W,Q);L("comparator",W,Q),this.loose=Q,this.parse(W),this.semver===be?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(W,Q){return B(Q,W)},e.major=function(W,Q){return new se(W,Q).major},e.minor=function(W,Q){return new se(W,Q).minor},e.patch=function(W,Q){return new se(W,Q).patch},e.compare=ie,e.compareLoose=function(W,Q){return ie(W,Q,!0)},e.rcompare=function(W,Q,J){return ie(Q,W,J)},e.sort=function(W,Q){return W.sort(function(J,$e){return e.compare(J,$e,Q)})},e.rsort=function(W,Q){return W.sort(function(J,$e){return e.rcompare(J,$e,Q)})},e.gt=ke,e.lt=le,e.eq=ue,e.neq=ce,e.gte=de,e.lte=H,e.cmp=Y,e.Comparator=he;var be={};function Pe(W,Q){if(W instanceof Pe)return W.loose===Q?W:new Pe(W.raw,Q);if(W instanceof he)return new Pe(W.value,Q);if(!(this instanceof Pe))return new Pe(W,Q);if(this.loose=Q,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function we(W){return!W||W.toLowerCase()==="x"||W==="*"}function Ae(W,Q,J,$e,ve,Te,He,Xe,tt,st,ut,rt,Ie){return((Q=we(J)?"":we($e)?">="+J+".0.0":we(ve)?">="+J+"."+$e+".0":">="+Q)+" "+(Xe=we(tt)?"":we(st)?"<"+(+tt+1)+".0.0":we(ut)?"<"+tt+"."+(+st+1)+".0":rt?"<="+tt+"."+st+"."+ut+"-"+rt:"<="+Xe)).trim()}function Oe(W,Q){for(var J=0;J<W.length;J++)if(!W[J].test(Q))return!1;if(Q.prerelease.length){for(J=0;J<W.length;J++)if(L(W[J].semver),W[J].semver!==be&&W[J].semver.prerelease.length>0){var $e=W[J].semver;if($e.major===Q.major&&$e.minor===Q.minor&&$e.patch===Q.patch)return!0}return!1}return!0}function ze(W,Q,J){try{Q=new Pe(Q,J)}catch{return!1}return Q.test(W)}function q(W,Q,J,$e){var ve,Te,He,Xe,tt;switch(W=new se(W,$e),Q=new Pe(Q,$e),J){case">":ve=ke,Te=H,He=le,Xe=">",tt=">=";break;case"<":ve=le,Te=de,He=ke,Xe="<",tt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(W,Q,$e))return!1;for(var st=0;st<Q.set.length;++st){var ut=Q.set[st],rt=null,Ie=null;if(ut.forEach(function(Be){Be.semver===be&&(Be=new he(">=0.0.0")),rt=rt||Be,Ie=Ie||Be,ve(Be.semver,rt.semver,$e)?rt=Be:He(Be.semver,Ie.semver,$e)&&(Ie=Be)}),rt.operator===Xe||rt.operator===tt||(!Ie.operator||Ie.operator===Xe)&&Te(W,Ie.semver)||Ie.operator===tt&&He(W,Ie.semver))return!1}return!0}he.prototype.parse=function(W){var Q=this.loose?w[G]:w[te],J=W.match(Q);if(!J)throw new TypeError("Invalid comparator: "+W);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new se(J[2],this.loose):this.semver=be},he.prototype.toString=function(){return this.value},he.prototype.test=function(W){return L("Comparator.test",W,this.loose),this.semver===be||(typeof W=="string"&&(W=new se(W,this.loose)),Y(W,this.operator,this.semver,this.loose))},he.prototype.intersects=function(W,Q){if(!(W instanceof he))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new Pe(W.value,Q),ze(this.value,J,Q);if(W.operator==="")return J=new Pe(this.value,Q),ze(W.semver,J,Q);var $e=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Te=this.semver.version===W.semver.version,He=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Xe=Y(this.semver,"<",W.semver,Q)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),tt=Y(this.semver,">",W.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return $e||ve||Te&&He||Xe||tt},e.Range=Pe,Pe.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Pe.prototype.toString=function(){return this.range},Pe.prototype.parseRange=function(W){var Q=this.loose;W=W.trim(),L("range",W,Q);var J=Q?w[X]:w[Z];W=W.replace(J,Ae),L("hyphen replace",W),W=W.replace(w[x],"$1$2$3"),L("comparator trim",W,w[x]),W=(W=(W=W.replace(w[F],"$1~")).replace(w[I],"$1^")).split(/\s+/).join(" ");var $e=Q?w[G]:w[te],ve=W.split(" ").map(function(Te){return function(He,Xe){return L("comp",He),He=function(tt,st){return tt.trim().split(/\s+/).map(function(ut){return function(rt,Ie){L("caret",rt,Ie);var Be=Ie?w[j]:w[O];return rt.replace(Be,function(Le,Ke,ne,oe,Ce){var Ge;return L("caret",rt,Le,Ke,ne,oe,Ce),we(Ke)?Ge="":we(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":we(oe)?Ge=Ke==="0"?">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+".0 <"+(+Ke+1)+".0.0":Ce?(L("replaceCaret pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+Ce+" <"+(+Ke+1)+".0.0"):(L("no pr"),Ge=Ke==="0"?ne==="0"?">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+ne+"."+(+oe+1):">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0":">="+Ke+"."+ne+"."+oe+" <"+(+Ke+1)+".0.0"),L("caret return",Ge),Ge})}(ut,st)}).join(" ")}(He,Xe),L("caret",He),He=function(tt,st){return tt.trim().split(/\s+/).map(function(ut){return function(rt,Ie){var Be=Ie?w[z]:w[U];return rt.replace(Be,function(Le,Ke,ne,oe,Ce){var Ge;return L("tilde",rt,Le,Ke,ne,oe,Ce),we(Ke)?Ge="":we(ne)?Ge=">="+Ke+".0.0 <"+(+Ke+1)+".0.0":we(oe)?Ge=">="+Ke+"."+ne+".0 <"+Ke+"."+(+ne+1)+".0":Ce?(L("replaceTilde pr",Ce),Ce.charAt(0)!=="-"&&(Ce="-"+Ce),Ge=">="+Ke+"."+ne+"."+oe+Ce+" <"+Ke+"."+(+ne+1)+".0"):Ge=">="+Ke+"."+ne+"."+oe+" <"+Ke+"."+(+ne+1)+".0",L("tilde return",Ge),Ge})}(ut,st)}).join(" ")}(He,Xe),L("tildes",He),He=function(tt,st){return L("replaceXRanges",tt,st),tt.split(/\s+/).map(function(ut){return function(rt,Ie){rt=rt.trim();var Be=Ie?w[g]:w[b];return rt.replace(Be,function(Le,Ke,ne,oe,Ce,Ge){L("xRange",rt,Le,Ke,ne,oe,Ce,Ge);var xe=we(ne),nt=xe||we(oe),Fe=nt||we(Ce);return Ke==="="&&Fe&&(Ke=""),xe?Le=Ke===">"||Ke==="<"?"<0.0.0":"*":Ke&&Fe?(nt&&(oe=0),Fe&&(Ce=0),Ke===">"?(Ke=">=",nt?(ne=+ne+1,oe=0,Ce=0):Fe&&(oe=+oe+1,Ce=0)):Ke==="<="&&(Ke="<",nt?ne=+ne+1:oe=+oe+1),Le=Ke+ne+"."+oe+"."+Ce):nt?Le=">="+ne+".0.0 <"+(+ne+1)+".0.0":Fe&&(Le=">="+ne+"."+oe+".0 <"+ne+"."+(+oe+1)+".0"),L("xRange return",Le),Le})}(ut,st)}).join(" ")}(He,Xe),L("xrange",He),He=function(tt,st){return L("replaceStars",tt,st),tt.trim().replace(w[ae],"")}(He,Xe),L("stars",He),He}(Te,Q)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Te){return!!Te.match($e)})),ve=ve.map(function(Te){return new he(Te,Q)})},Pe.prototype.intersects=function(W,Q){if(!(W instanceof Pe))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function($e){return W.set.some(function(ve){return ve.every(function(Te){return $e.intersects(Te,Q)})})})})},e.toComparators=function(W,Q){return new Pe(W,Q).set.map(function(J){return J.map(function($e){return $e.value}).join(" ").trim().split(" ")})},Pe.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new se(W,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Oe(this.set[Q],W))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(W,Q,J){var $e=null,ve=null;try{var Te=new Pe(Q,J)}catch{return null}return W.forEach(function(He){Te.test(He)&&($e&&ve.compare(He)!==-1||(ve=new se($e=He,J)))}),$e},e.minSatisfying=function(W,Q,J){var $e=null,ve=null;try{var Te=new Pe(Q,J)}catch{return null}return W.forEach(function(He){Te.test(He)&&($e&&ve.compare(He)!==1||(ve=new se($e=He,J)))}),$e},e.validRange=function(W,Q){try{return new Pe(W,Q).range||"*"}catch{return null}},e.ltr=function(W,Q,J){return q(W,Q,"<",J)},e.gtr=function(W,Q,J){return q(W,Q,">",J)},e.outside=q,e.prerelease=function(W,Q){var J=ge(W,Q);return J&&J.prerelease.length?J.prerelease:null},e.intersects=function(W,Q,J){return W=new Pe(W,J),Q=new Pe(Q,J),W.intersects(Q)},e.coerce=function(W){if(W instanceof se)return W;if(typeof W!="string")return null;var Q=W.match(w[k]);return Q==null?null:ge((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,l(1))},function(fe,e){var l,N,L=fe.exports={};function A(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(m){if(l===setTimeout)return setTimeout(m,0);if((l===A||!l)&&setTimeout)return l=setTimeout,setTimeout(m,0);try{return l(m,0)}catch{try{return l.call(null,m,0)}catch{return l.call(this,m,0)}}}(function(){try{l=typeof setTimeout=="function"?setTimeout:A}catch{l=A}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var p,E=[],M=!1,C=-1;function v(){M&&p&&(M=!1,p.length?E=p.concat(E):C=-1,E.length&&S())}function S(){if(!M){var m=w(v);M=!0;for(var o=E.length;o;){for(p=E,E=[];++C<o;)p&&p[C].run();C=-1,o=E.length}p=null,M=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(m)}}function y(m,o){this.fun=m,this.array=o}function u(){}L.nextTick=function(m){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];E.push(new y(m,o)),E.length!==1||M||w(S)},y.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=u,L.addListener=u,L.once=u,L.off=u,L.removeListener=u,L.removeAllListeners=u,L.emit=u,L.prependListener=u,L.prependOnceListener=u,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Se[38],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=void 0;const l=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=l&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$2d=N}),define(Se[4],De([1,0,13,73,3,74,38]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.Event=void 0;const w=!1,p=!1;var E;(function(b){b.None=()=>L.$Tc.None;function g(H){if(p){const{onDidAddListener:Y}=H,he=y.create();let be=0;H.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),Y?.()}}}function k(H,Y){return te(H,()=>{},0,void 0,!0,void 0,Y)}b.defer=k;function P(H){return(Y,he=null,be)=>{let Pe=!1,we;return we=H(Ae=>{if(!Pe)return we?we.dispose():Pe=!0,Y.call(he,Ae)},null,be),Pe&&we.dispose(),we}}b.once=P;function F(H,Y,he){return j((be,Pe=null,we)=>H(Ae=>be.call(Pe,Y(Ae)),null,we),he)}b.map=F;function U(H,Y,he){return j((be,Pe=null,we)=>H(Ae=>{Y(Ae),be.call(Pe,Ae)},null,we),he)}b.forEach=U;function z(H,Y,he){return j((be,Pe=null,we)=>H(Ae=>Y(Ae)&&be.call(Pe,Ae),null,we),he)}b.filter=z;function T(H){return H}b.signal=T;function I(...H){return(Y,he=null,be)=>{const Pe=(0,L.$Qc)(...H.map(we=>we(Ae=>Y.call(he,Ae))));return G(Pe,be)}}b.any=I;function O(H,Y,he,be){let Pe=he;return F(H,we=>(Pe=Y(Pe,we),Pe),be)}b.reduce=O;function j(H,Y){let he;const be={onWillAddFirstListener(){he=H(Pe.fire,Pe)},onDidRemoveLastListener(){he?.dispose()}};Y||g(be);const Pe=new n(be);return Y?.add(Pe),Pe.event}function G(H,Y){return Y instanceof Array?Y.push(H):Y&&Y.add(H),H}function te(H,Y,he=100,be=!1,Pe=!1,we,Ae){let Oe,ze,q,W=0,Q;const J={leakWarningThreshold:we,onWillAddFirstListener(){Oe=H(ve=>{W++,ze=Y(ze,ve),be&&!q&&($e.fire(ze),ze=void 0),Q=()=>{const Te=ze;ze=void 0,q=void 0,(!be||W>1)&&$e.fire(Te),W=0},typeof he=="number"?(clearTimeout(q),q=setTimeout(Q,he)):q===void 0&&(q=0,queueMicrotask(Q))})},onWillRemoveListener(){Pe&&W>0&&Q?.()},onDidRemoveLastListener(){Q=void 0,Oe.dispose()}};Ae||g(J);const $e=new n(J);return Ae?.add($e),$e.event}b.debounce=te;function x(H,Y=0,he){return b.debounce(H,(be,Pe)=>be?(be.push(Pe),be):[Pe],Y,void 0,!0,void 0,he)}b.accumulate=x;function Z(H,Y=(be,Pe)=>be===Pe,he){let be=!0,Pe;return z(H,we=>{const Ae=be||!Y(we,Pe);return be=!1,Pe=we,Ae},he)}b.latch=Z;function X(H,Y,he){return[b.filter(H,Y,he),b.filter(H,be=>!Y(be),he)]}b.split=X;function ae(H,Y=!1,he=[],be){let Pe=he.slice(),we=H(ze=>{Pe?Pe.push(ze):Oe.fire(ze)});be&&be.add(we);const Ae=()=>{Pe?.forEach(ze=>Oe.fire(ze)),Pe=null},Oe=new n({onWillAddFirstListener(){we||(we=H(ze=>Oe.fire(ze)),be&&be.add(we))},onDidAddFirstListener(){Pe&&(Y?setTimeout(Ae):Ae())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return be&&be.add(Oe),Oe.event}b.buffer=ae;function _(H,Y){return(be,Pe,we)=>{const Ae=Y(new se);return H(function(Oe){const ze=Ae.evaluate(Oe);ze!==ge&&be.call(Pe,ze)},void 0,we)}}b.chain=_;const ge=Symbol("HaltChainable");class se{constructor(){this.f=[]}map(Y){return this.f.push(Y),this}forEach(Y){return this.f.push(he=>(Y(he),he)),this}filter(Y){return this.f.push(he=>Y(he)?he:ge),this}reduce(Y,he){let be=he;return this.f.push(Pe=>(be=Y(be,Pe),be)),this}latch(Y=(he,be)=>he===be){let he=!0,be;return this.f.push(Pe=>{const we=he||!Y(Pe,be);return he=!1,be=Pe,we?Pe:ge}),this}evaluate(Y){for(const he of this.f)if(Y=he(Y),Y===ge)break;return Y}}function re(H,Y,he=be=>be){const be=(...Oe)=>Ae.fire(he(...Oe)),Pe=()=>H.on(Y,be),we=()=>H.removeListener(Y,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:we});return Ae.event}b.fromNodeEventEmitter=re;function B(H,Y,he=be=>be){const be=(...Oe)=>Ae.fire(he(...Oe)),Pe=()=>H.addEventListener(Y,be),we=()=>H.removeEventListener(Y,be),Ae=new n({onWillAddFirstListener:Pe,onDidRemoveLastListener:we});return Ae.event}b.fromDOMEventEmitter=B;function ie(H){return new Promise(Y=>P(H)(Y))}b.toPromise=ie;function ke(H){const Y=new n;return H.then(he=>{Y.fire(he)},()=>{Y.fire(void 0)}).finally(()=>{Y.dispose()}),Y.event}b.fromPromise=ke;function le(H,Y,he){return Y(he),H(be=>Y(be))}b.runAndSubscribe=le;class ue{constructor(Y,he){this._observable=Y,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{Y.addObserver(this)},onDidRemoveLastListener:()=>{Y.removeObserver(this)}};he||g(be),this.emitter=new n(be),he&&he.add(this.emitter)}beginUpdate(Y){this.f++}handlePossibleChange(Y){}handleChange(Y,he){this.g=!0}endUpdate(Y){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ce(H,Y){return new ue(H,Y).emitter.event}b.fromObservable=ce;function de(H){return(Y,he,be)=>{let Pe=0,we=!1;const Ae={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(H.reportChanges(),we&&(we=!1,Y.call(he)))},handlePossibleChange(){},handleChange(){we=!0}};H.addObserver(Ae),H.reportChanges();const Oe={dispose(){H.removeObserver(Ae)}};return be instanceof L.$Sc?be.add(Oe):Array.isArray(be)&&be.push(Oe),Oe}}b.fromObservableLight=de})(E||(e.Event=E={}));class M{static{this.all=new Set}static{this.f=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${M.f++}`,M.all.add(this)}start(g){this.g=new R.$2d,this.listenerCount=g}stop(){if(this.g){const g=this.g.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.g=void 0}}}e.$4d=M;let C=-1;function v(b){const g=C;return C=b,{dispose(){C=g}}}e.$5d=v;class S{constructor(g,k=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=k,this.g=0}dispose(){this.f?.clear()}check(g,k){const P=this.threshold;if(P<=0||k<P)return;this.f||(this.f=new Map);const F=this.f.get(g.value)||0;if(this.f.set(g.value,F+1),this.g-=1,this.g<=0){this.g=P*.5;let U,z=0;for(const[T,I]of this.f)(!U||z<I)&&(U=T,z=I);console.warn(`[${this.name}] potential listener LEAK detected, having ${k} listeners already. MOST frequent listener (${z}):`),console.warn(U)}return()=>{const U=this.f.get(g.value)||0;this.f.set(g.value,U-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let u=0;class m{constructor(g){this.value=g,this.id=u++}}const o=2,i=(b,g)=>{if(b instanceof m)g(b);else for(let k=0;k<b.length;k++){const P=b[k];P&&g(P)}};class n{constructor(g){this.w=0,this.f=g,this.g=C>0||this.f?.leakWarningThreshold?new S(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(w){const g=this.t;queueMicrotask(()=>{i(g,k=>k.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(g,k,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Tc.None;if(this.m)return L.$Tc.None;k&&(g=g.bind(k));const F=new m(g);let U,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=y.create(),U=this.g.check(F.stack,this.w+1)),w&&(F.stack=z??y.create()),this.t?this.t instanceof m?(this.u??=new c,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const T=(0,L.$Rc)(()=>{U?.(),this.x(F)});return P instanceof L.$Sc?P.add(T):Array.isArray(P)&&P.push(T),T},this.q}x(g){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const k=this.t,P=k.indexOf(g);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,k[P]=void 0;const F=this.u.current===this;if(this.w*o<=k.length){let U=0;for(let z=0;z<k.length;z++)k[z]?k[U++]=k[z]:F&&(this.u.end--,U<this.u.i&&this.u.i--);k.length=U}}y(g,k){if(!g)return;const P=this.f?.onListenerError||l.$1;if(!P){g.value(k);return}try{g.value(k)}catch(F){P(F)}}z(g){const k=g.current.t;for(;g.i<g.end;)this.y(k[g.i++],g.value);g.reset()}fire(g){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,g);else{const k=this.u;k.enqueue(this,g,this.t.length),this.z(k)}this.j?.stop()}hasListeners(){return this.w>0}}e.$6d=n;const r=()=>new c;e.$7d=r;class c{constructor(){this.i=-1,this.end=0}enqueue(g,k,P){this.i=0,this.end=P,this.current=g,this.value=k}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(g,k,P){if(this.t)for(this.h||(this.h=new A.$4c),i(this.t,F=>this.h.push([F.value,g]));this.h.size>0&&!k.isCancellationRequested;){const[F,U]=this.h.shift(),z=[],T={...U,token:k,waitUntil:I=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");P&&(I=P(I,F)),z.push(I)}};try{F(T)}catch(I){(0,l.$1)(I);continue}Object.freeze(z),await Promise.allSettled(z).then(I=>{for(const O of I)O.status==="rejected"&&(0,l.$1)(O.reason)})}}}e.$8d=t;class f extends n{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new A.$4c,this.A=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.A(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.w&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$9d=f;class h extends f{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$0d=h;class s extends n{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(k=>super.fire(k)),this.h=[]}))}}e.$$d=s;class a{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(g){const k={event:g,listener:null};this.h.push(k),this.g&&this.m(k);const P=()=>{this.g&&this.o(k);const F=this.h.indexOf(k);this.h.splice(F,1)};return(0,L.$Rc)((0,N.$db)(P))}j(){this.g=!0,this.h.forEach(g=>this.m(g))}k(){this.g=!1,this.h.forEach(g=>this.o(g))}m(g){g.listener=g.event(k=>this.f.fire(k))}o(g){g.listener?.dispose(),g.listener=null}dispose(){this.f.dispose();for(const g of this.h)g.listener?.dispose();this.h=[]}}e.$_d=a;class d{constructor(g,k,P,F){this.f=new L.$Sc;const U=this.f.add(new a),z=this.f.add(new L.$3c);function T(I){z.set(I,U.add(F(I)))}for(const I of g)T(I);this.f.add(k(I=>{T(I)})),this.f.add(P(I=>{z.deleteAndDispose(I)})),this.event=U.event}dispose(){this.f.dispose()}}e.$ae=d;class ${constructor(){this.f=[]}wrapEvent(g){return(k,P,F)=>g(U=>{const z=this.f[this.f.length-1];z?z.push(()=>k.call(P,U)):k.call(P,U)},void 0,F)}bufferEvents(g){const k=[];this.f.push(k);const P=g();return this.f.pop(),k.forEach(F=>F()),P}}e.$be=$;class D{constructor(){this.f=!1,this.g=E.None,this.h=L.$Tc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(g){this.g=g,this.f&&(this.h.dispose(),this.h=g(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ce=D}),define(Se[22],De([1,0,4]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$de=e.CancellationToken=void 0;const N=Object.freeze(function(w,p){const E=setTimeout(w.bind(p),0);return{dispose(){clearTimeout(E)}}});var L;(function(w){function p(E){return E===w.None||E===w.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}w.isCancellationToken=p,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:l.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new l.$6d),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(p){this.f=void 0,this.g=void 0,this.g=p&&p.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(p=!1){p&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$de=R}),define(Se[166],De([1,0,22]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qe=e.$Pe=e.$Oe=void 0;class N{constructor(w){this.b=w,this.a=null}get(){if(this.a)return this.a;const w=new l.$de,p=this.b(w.token);return this.a={promise:p,dispose:()=>{this.a=null,w.cancel(),w.dispose()}},this.a}}e.$Oe=N;class L{constructor(w){this.c=w,this.a=void 0,this.b=void 0}get(w){const p=JSON.stringify(w);return this.b!==p&&(this.b=p,this.a=this.c(w)),this.a}}e.$Pe=L;class A{get cachedValues(){return this.a}constructor(w){this.b=w,this.a=new Map}get(w){if(this.a.has(w))return this.a.get(w);const p=this.b(w);return this.a.set(w,p),p}}e.$Qe=A}),define(Se[98],De([1,0,13,3]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=void 0;function L(r){const c=r;return c?typeof c.read=="function":!1}e.$ee=L;function A(r){const c=r;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$fe=A;function R(r){const c=r;return c?A(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$ge=R;function w(r,c){return new p(r,c)}e.$he=w;class p{constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,l.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let f;switch(c){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const h=f.indexOf(t);h>=0&&f.splice(h,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(r,c){const t=[];let f;for(;(f=r.read())!==null;)t.push(f);return c(t)}e.$ie=E;function M(r,c,t){const f=[];let h;for(;(h=r.read())!==null&&f.length<t;)f.push(h);return h===null&&f.length>0?c(f):{read:()=>{if(f.length>0)return f.shift();if(typeof h<"u"){const s=h;return h=void 0,s}return r.read()}}}e.$je=M;function C(r,c){return new Promise((t,f)=>{const h=[];v(r,{onData:s=>{c&&h.push(s)},onError:s=>{c?f(s):t(void 0)},onEnd:()=>{t(c?c(h):void 0)}})})}e.$ke=C;function v(r,c,t){r.on("error",f=>{t?.isCancellationRequested||c.onError(f)}),r.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),r.on("data",f=>{t?.isCancellationRequested||c.onData(f)})}e.$le=v;function S(r,c){return new Promise((t,f)=>{const h=new N.$Sc,s=[],a=D=>{if(s.push(D),s.length>c)return h.dispose(),r.pause(),t({stream:r,buffer:s,ended:!1})},d=D=>(h.dispose(),f(D)),$=()=>(h.dispose(),t({stream:r,buffer:s,ended:!0}));h.add((0,N.$Rc)(()=>r.removeListener("error",d))),r.on("error",d),h.add((0,N.$Rc)(()=>r.removeListener("end",$))),r.on("end",$),h.add((0,N.$Rc)(()=>r.removeListener("data",a))),r.on("data",a)})}e.$me=S;function y(r,c){const t=w(c);return t.end(r),t}e.$ne=y;function u(){const r=w(()=>{throw new Error("not supported")});return r.end(),r}e.$oe=u;function m(r){let c=!1;return{read:()=>c?null:(c=!0,r)}}e.$pe=m;function o(r,c,t){const f=w(t);return v(r,{onData:h=>f.write(c.data(h)),onError:h=>f.error(c.error?c.error(h):h),onEnd:()=>f.end()}),f}e.$qe=o;function i(r,c,t){let f=!1;return{read:()=>{const h=c.read();return f?h:(f=!0,h!==null?t([r,h]):r)}}}e.$re=i;function n(r,c,t){let f=!1;const h=w(t);return v(c,{onData:s=>f?h.write(s):(f=!0,h.write(t([r,s]))),onError:s=>h.error(s),onEnd:()=>{f||(f=!0,h.write(r)),h.end()}}),h}e.$se=n}),define(Se[21],De([1,0,43,98]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=void 0;const L=typeof Buffer<"u",A=new l.$V(()=>new Uint8Array(256));let R,w;class p{static alloc(k){return L?new p(Buffer.allocUnsafe(k)):new p(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new p(k)}static fromString(k,P){return!(P?.dontUseNodeBuffer||!1)&&L?new p(Buffer.from(k)):(R||(R=new TextEncoder),new p(R.encode(k)))}static fromByteArray(k){const P=p.alloc(k.length);for(let F=0,U=k.length;F<U;F++)P.buffer[F]=k[F];return P}static concat(k,P){if(typeof P>"u"){P=0;for(let z=0,T=k.length;z<T;z++)P+=k[z].byteLength}const F=p.alloc(P);let U=0;for(let z=0,T=k.length;z<T;z++){const I=k[z];F.set(I,U),U+=I.byteLength}return F}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=p.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(k,P){return new p(this.buffer.subarray(k,P))}set(k,P){if(k instanceof p)this.buffer.set(k.buffer,P);else if(k instanceof Uint8Array)this.buffer.set(k,P);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),P);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return v(this.buffer,k)}writeUInt32BE(k,P){S(this.buffer,k,P)}readUInt32LE(k){return y(this.buffer,k)}writeUInt32LE(k,P){u(this.buffer,k,P)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,P){o(this.buffer,k,P)}indexOf(k,P=0){return E(this.buffer,k instanceof p?k.buffer:k,P)}}e.$te=p;function E(g,k,P=0){const F=k.byteLength,U=g.byteLength;if(F===0)return 0;if(F===1)return g.indexOf(k[0]);if(F>U-P)return-1;const z=A.value;z.fill(k.length);for(let j=0;j<k.length;j++)z[k[j]]=k.length-j-1;let T=P+k.length-1,I=T,O=-1;for(;T<U;)if(g[T]===k[I]){if(I===0){O=T;break}T--,I--}else T+=Math.max(k.length-I,z[g[T]]),I=k.length-1;return O}e.$ue=E;function M(g,k){return g[k+0]<<0>>>0|g[k+1]<<8>>>0}e.$ve=M;function C(g,k,P){g[P+0]=k&255,k=k>>>8,g[P+1]=k&255}e.$we=C;function v(g,k){return g[k]*2**24+g[k+1]*2**16+g[k+2]*2**8+g[k+3]}e.$xe=v;function S(g,k,P){g[P+3]=k,k=k>>>8,g[P+2]=k,k=k>>>8,g[P+1]=k,k=k>>>8,g[P]=k}e.$ye=S;function y(g,k){return g[k+0]<<0>>>0|g[k+1]<<8>>>0|g[k+2]<<16>>>0|g[k+3]<<24>>>0}e.$ze=y;function u(g,k,P){g[P+0]=k&255,k=k>>>8,g[P+1]=k&255,k=k>>>8,g[P+2]=k&255,k=k>>>8,g[P+3]=k&255}e.$Ae=u;function m(g,k){return g[k]}e.$Be=m;function o(g,k,P){g[P]=k}e.$Ce=o;function i(g){return N.$ie(g,k=>p.concat(k))}e.$De=i;function n(g){return N.$pe(g)}e.$Ee=n;function r(g){return N.$ke(g,k=>p.concat(k))}e.$Fe=r;async function c(g){return g.ended?p.concat(g.buffer):p.concat([...g.buffer,await r(g.stream)])}e.$Ge=c;function t(g){return N.$ne(g,k=>p.concat(k))}e.$He=t;function f(g){return N.$qe(g,{data:k=>typeof k=="string"?p.fromString(k):p.wrap(k)},k=>p.concat(k))}e.$Ie=f;function h(g){return N.$he(k=>p.concat(k),g)}e.$Je=h;function s(g,k){return N.$re(g,k,P=>p.concat(P))}e.$Ke=s;function a(g,k){return N.$se(g,k,P=>p.concat(P))}e.$Le=a;function d(g){let k=0,P=0,F=0;const U=new Uint8Array(Math.floor(g.length/4*3)),z=I=>{switch(P){case 3:U[F++]=k|I,P=0;break;case 2:U[F++]=k|I>>>2,k=I<<6,P=3;break;case 1:U[F++]=k|I>>>4,k=I<<4,P=2;break;default:k=I<<2,P=1}};for(let I=0;I<g.length;I++){const O=g.charCodeAt(I);if(O>=65&&O<=90)z(O-65);else if(O>=97&&O<=122)z(O-97+26);else if(O>=48&&O<=57)z(O-48+52);else if(O===43||O===45)z(62);else if(O===47||O===95)z(63);else{if(O===61)break;throw new SyntaxError(`Unexpected base64 character ${g[I]}`)}}const T=F;for(;P>0;)z(0);return p.wrap(U).slice(0,T)}e.$Me=d;const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:g},k=!0,P=!1){const F=P?D:$;let U="";const z=g.byteLength%3;let T=0;for(;T<g.byteLength-z;T+=3){const I=g[T+0],O=g[T+1],j=g[T+2];U+=F[I>>>2],U+=F[(I<<4|O>>>4)&63],U+=F[(O<<2|j>>>6)&63],U+=F[j&63]}if(z===1){const I=g[T+0];U+=F[I>>>2],U+=F[I<<4&63],k&&(U+="==")}else if(z===2){const I=g[T+0],O=g[T+1];U+=F[I>>>2],U+=F[(I<<4|O>>>4)&63],U+=F[O<<2&63],k&&(U+="=")}return U}e.$Ne=b}),define(Se[14],De([1,0,166,43]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.GraphemeBreakType=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=void 0;function L(Ie){return!Ie||typeof Ie!="string"?!0:Ie.trim().length===0}e.$Te=L;const A=/{(\d+)}/g;function R(Ie,...Be){return Be.length===0?Ie:Ie.replace(A,function(Le,Ke){const ne=parseInt(Ke,10);return isNaN(ne)||ne<0||ne>=Be.length?Le:Be[ne]})}e.$Ue=R;const w=/{([^}]+)}/g;function p(Ie,Be){return Object.keys(Be).length===0?Ie:Ie.replace(w,(Le,Ke)=>Be[Ke]??Le)}e.$Ve=p;function E(Ie){return Ie.replace(/[<>"'&]/g,Be=>{switch(Be){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Be})}e.$We=E;function M(Ie){return Ie.replace(/[<>&]/g,function(Be){switch(Be){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Be}})}e.$Xe=M;function C(Ie){return Ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Ye=C;function v(Ie,Be){let Le=0;const Ke=Be.charCodeAt(0);for(let ne=Ie.length-1;ne>=0;ne--)Ie.charCodeAt(ne)===Ke&&Le++;return Le}e.$Ze=v;function S(Ie,Be,Le="\u2026"){return Ie.length<=Be?Ie:`${Ie.substr(0,Be)}${Le}`}e.$1e=S;function y(Ie,Be,Le="\u2026"){if(Ie.length<=Be)return Ie;const Ke=Math.ceil(Be/2)-Le.length/2,ne=Math.floor(Be/2)-Le.length/2;return`${Ie.substr(0,Ke)}${Le}${Ie.substr(Ie.length-ne)}`}e.$2e=y;function u(Ie,Be=" "){const Le=m(Ie,Be);return o(Le,Be)}e.$3e=u;function m(Ie,Be){if(!Ie||!Be)return Ie;const Le=Be.length;if(Le===0||Ie.length===0)return Ie;let Ke=0;for(;Ie.indexOf(Be,Ke)===Ke;)Ke=Ke+Le;return Ie.substring(Ke)}e.$4e=m;function o(Ie,Be){if(!Ie||!Be)return Ie;const Le=Be.length,Ke=Ie.length;if(Le===0||Ke===0)return Ie;let ne=Ke,oe=-1;for(;oe=Ie.lastIndexOf(Be,ne-1),!(oe===-1||oe+Le!==ne);){if(oe===0)return"";ne=oe}return Ie.substring(0,ne)}e.$5e=o;function i(Ie){return Ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$6e=i;function n(Ie){return Ie.replace(/\*/g,"")}e.$7e=n;function r(Ie,Be,Le={}){if(!Ie)throw new Error("Cannot create regex from empty string");Be||(Ie=C(Ie)),Le.wholeWord&&(/\B/.test(Ie.charAt(0))||(Ie="\\b"+Ie),/\B/.test(Ie.charAt(Ie.length-1))||(Ie=Ie+"\\b"));let Ke="";return Le.global&&(Ke+="g"),Le.matchCase||(Ke+="i"),Le.multiline&&(Ke+="m"),Le.unicode&&(Ke+="u"),new RegExp(Ie,Ke)}e.$8e=r;function c(Ie){return Ie.source==="^"||Ie.source==="^$"||Ie.source==="$"||Ie.source==="^\\s*$"?!1:!!(Ie.exec("")&&Ie.lastIndex===0)}e.$9e=c;function t(Ie){return Ie.split(/\r\n|\r|\n/)}e.$0e=t;function f(Ie){const Be=[],Le=Ie.split(/(\r\n|\r|\n)/);for(let Ke=0;Ke<Math.ceil(Le.length/2);Ke++)Be.push(Le[2*Ke]+(Le[2*Ke+1]??""));return Be}e.$$e=f;function h(Ie){for(let Be=0,Le=Ie.length;Be<Le;Be++){const Ke=Ie.charCodeAt(Be);if(Ke!==32&&Ke!==9)return Be}return-1}e.$_e=h;function s(Ie,Be=0,Le=Ie.length){for(let Ke=Be;Ke<Le;Ke++){const ne=Ie.charCodeAt(Ke);if(ne!==32&&ne!==9)return Ie.substring(Be,Ke)}return Ie.substring(Be,Le)}e.$af=s;function a(Ie,Be=Ie.length-1){for(let Le=Be;Le>=0;Le--){const Ke=Ie.charCodeAt(Le);if(Ke!==32&&Ke!==9)return Le}return-1}e.$bf=a;function d(Ie,Be,Le){const Ke=[];let ne=0;for(const oe of Ie.matchAll(Be)){if(Ke.push(Ie.slice(ne,oe.index)),oe.index===void 0)throw new Error("match.index should be defined");ne=oe.index+oe[0].length,Ke.push(Le(oe[0],...oe.slice(1),oe.index,Ie,oe.groups))}return Ke.push(Ie.slice(ne)),Promise.all(Ke).then(oe=>oe.join(""))}e.$cf=d;function $(Ie,Be){return Ie<Be?-1:Ie>Be?1:0}e.$df=$;function D(Ie,Be,Le=0,Ke=Ie.length,ne=0,oe=Be.length){for(;Le<Ke&&ne<oe;Le++,ne++){const xe=Ie.charCodeAt(Le),nt=Be.charCodeAt(ne);if(xe<nt)return-1;if(xe>nt)return 1}const Ce=Ke-Le,Ge=oe-ne;return Ce<Ge?-1:Ce>Ge?1:0}e.$ef=D;function b(Ie,Be){return g(Ie,Be,0,Ie.length,0,Be.length)}e.$ff=b;function g(Ie,Be,Le=0,Ke=Ie.length,ne=0,oe=Be.length){for(;Le<Ke&&ne<oe;Le++,ne++){let xe=Ie.charCodeAt(Le),nt=Be.charCodeAt(ne);if(xe===nt)continue;if(xe>=128||nt>=128)return D(Ie.toLowerCase(),Be.toLowerCase(),Le,Ke,ne,oe);P(xe)&&(xe-=32),P(nt)&&(nt-=32);const Fe=xe-nt;if(Fe!==0)return Fe}const Ce=Ke-Le,Ge=oe-ne;return Ce<Ge?-1:Ce>Ge?1:0}e.$gf=g;function k(Ie){return Ie>=48&&Ie<=57}e.$hf=k;function P(Ie){return Ie>=97&&Ie<=122}e.$if=P;function F(Ie){return Ie>=65&&Ie<=90}e.$jf=F;function U(Ie,Be){return Ie.length===Be.length&&g(Ie,Be)===0}e.$kf=U;function z(Ie,Be){const Le=Be.length;return Be.length>Ie.length?!1:g(Ie,Be,0,Le)===0}e.$lf=z;function T(Ie,Be){const Le=Math.min(Ie.length,Be.length);let Ke;for(Ke=0;Ke<Le;Ke++)if(Ie.charCodeAt(Ke)!==Be.charCodeAt(Ke))return Ke;return Le}e.$mf=T;function I(Ie,Be){const Le=Math.min(Ie.length,Be.length);let Ke;const ne=Ie.length-1,oe=Be.length-1;for(Ke=0;Ke<Le;Ke++)if(Ie.charCodeAt(ne-Ke)!==Be.charCodeAt(oe-Ke))return Ke;return Le}e.$nf=I;function O(Ie){return 55296<=Ie&&Ie<=56319}e.$of=O;function j(Ie){return 56320<=Ie&&Ie<=57343}e.$pf=j;function G(Ie,Be){return(Ie-55296<<10)+(Be-56320)+65536}e.$qf=G;function te(Ie,Be,Le){const Ke=Ie.charCodeAt(Le);if(O(Ke)&&Le+1<Be){const ne=Ie.charCodeAt(Le+1);if(j(ne))return G(Ke,ne)}return Ke}e.$rf=te;function x(Ie,Be){const Le=Ie.charCodeAt(Be-1);if(j(Le)&&Be>1){const Ke=Ie.charCodeAt(Be-2);if(O(Ke))return G(Ke,Le)}return Le}class Z{get offset(){return this.e}constructor(Be,Le=0){this.c=Be,this.d=Be.length,this.e=Le}setOffset(Be){this.e=Be}prevCodePoint(){const Be=x(this.c,this.e);return this.e-=Be>=65536?2:1,Be}nextCodePoint(){const Be=te(this.c,this.d,this.e);return this.e+=Be>=65536?2:1,Be}eol(){return this.e>=this.d}}e.$sf=Z;class X{get offset(){return this.c.offset}constructor(Be,Le=0){this.c=new Z(Be,Le)}nextGraphemeLength(){const Be=ve.getInstance(),Le=this.c,Ke=Le.offset;let ne=Be.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const oe=Le.offset,Ce=Be.getGraphemeBreakType(Le.nextCodePoint());if(J(ne,Ce)){Le.setOffset(oe);break}ne=Ce}return Le.offset-Ke}prevGraphemeLength(){const Be=ve.getInstance(),Le=this.c,Ke=Le.offset;let ne=Be.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const oe=Le.offset,Ce=Be.getGraphemeBreakType(Le.prevCodePoint());if(J(Ce,ne)){Le.setOffset(oe);break}ne=Ce}return Ke-Le.offset}eol(){return this.c.eol()}}e.$tf=X;function ae(Ie,Be){return new X(Ie,Be).nextGraphemeLength()}e.$uf=ae;function _(Ie,Be){return new X(Ie,Be).prevGraphemeLength()}e.$vf=_;function ge(Ie,Be){Be>0&&j(Ie.charCodeAt(Be))&&Be--;const Le=Be+ae(Ie,Be);return[Le-_(Ie,Le),Le]}e.$wf=ge;function se(Ie){const Be=new X(Ie);let Le=0;for(;!Be.eol();)Le++,Be.nextGraphemeLength();return Le}e.$xf=se;let re;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ie(Ie){return re||(re=B()),re.test(Ie)}e.$yf=ie;const ke=/^[\t\n\r\x20-\x7E]*$/;function le(Ie){return ke.test(Ie)}e.$zf=le,e.$Af=/[\u2028\u2029]/;function ue(Ie){return e.$Af.test(Ie)}e.$Bf=ue;function ce(Ie){return Ie>=11904&&Ie<=55215||Ie>=63744&&Ie<=64255||Ie>=65281&&Ie<=65374}e.$Cf=ce;function de(Ie){return Ie>=127462&&Ie<=127487||Ie===8986||Ie===8987||Ie===9200||Ie===9203||Ie>=9728&&Ie<=10175||Ie===11088||Ie===11093||Ie>=127744&&Ie<=128591||Ie>=128640&&Ie<=128764||Ie>=128992&&Ie<=129008||Ie>=129280&&Ie<=129535||Ie>=129648&&Ie<=129782}e.$Df=de;function H(Ie,Be,Le=""){const Ke=Ie.trimStart();if(Ke.length<Be)return Ke;const ne=/\b/g;let oe=0;for(;ne.test(Ke)&&!(Ke.length-ne.lastIndex<Be);)oe=ne.lastIndex,ne.lastIndex+=1;return oe===0?Ke:Le+Ke.substring(oe).trimStart()}e.$Ef=H;const Y=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function be(Ie){return Ie&&(Ie=Ie.replace(Y,"").replace(he,"")),Ie}e.$Ff=be,e.$Gf="\uFEFF";function Pe(Ie){return!!(Ie&&Ie.length>0&&Ie.charCodeAt(0)===65279)}e.$Hf=Pe;function we(Ie){return Pe(Ie)?Ie.substr(1):Ie}e.$If=we;function Ae(Ie,Be){if(!Ie||!Be||Ie.length<Be.length)return!1;const Le=Be.length,Ke=Ie.toLowerCase();let ne=0,oe=-1;for(;ne<Le;){const Ce=Ke.indexOf(Be[ne],oe+1);if(Ce<0)return!1;oe=Ce,ne++}return!0}e.$Jf=Ae;function Oe(Ie,Be=!1){return Ie?(Be&&(Ie=Ie.replace(/\\./g,"")),Ie.toLowerCase()!==Ie):!1}e.$Kf=Oe;function ze(Ie){return Ie.charAt(0).toUpperCase()+Ie.slice(1)}e.$Lf=ze;function q(Ie,Be=1){if(Be===0)return"";let Le=-1;do Le=Ie.indexOf(`
`,Le+1),Be--;while(Be>0&&Le>=0);return Le===-1?Ie:(Ie[Le-1]==="\r"&&Le--,Ie.substr(0,Le))}e.$Mf=q;function W(Ie){return Ie=Ie%(2*26),Ie<26?String.fromCharCode(97+Ie):String.fromCharCode(65+Ie-26)}e.$Nf=W;function Q(Ie){return ve.getInstance().getGraphemeBreakType(Ie)}e.$Of=Q;function J(Ie,Be){return Ie===0?Be!==5&&Be!==7:Ie===2&&Be===3?!1:Ie===4||Ie===2||Ie===3||Be===4||Be===2||Be===3?!0:!(Ie===8&&(Be===8||Be===9||Be===11||Be===12)||(Ie===11||Ie===9)&&(Be===9||Be===10)||(Ie===12||Ie===10)&&Be===10||Be===5||Be===13||Be===7||Ie===1||Ie===13&&Be===14||Ie===6&&Be===6)}var $e;(function(Ie){Ie[Ie.Other=0]="Other",Ie[Ie.Prepend=1]="Prepend",Ie[Ie.CR=2]="CR",Ie[Ie.LF=3]="LF",Ie[Ie.Control=4]="Control",Ie[Ie.Extend=5]="Extend",Ie[Ie.Regional_Indicator=6]="Regional_Indicator",Ie[Ie.SpacingMark=7]="SpacingMark",Ie[Ie.L=8]="L",Ie[Ie.V=9]="V",Ie[Ie.T=10]="T",Ie[Ie.LV=11]="LV",Ie[Ie.LVT=12]="LVT",Ie[Ie.ZWJ=13]="ZWJ",Ie[Ie.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class ve{static{this.c=null}static getInstance(){return ve.c||(ve.c=new ve),ve.c}constructor(){this.d=Te()}getGraphemeBreakType(Be){if(Be<32)return Be===10?3:Be===13?2:4;if(Be<127)return 0;const Le=this.d,Ke=Le.length/3;let ne=1;for(;ne<=Ke;)if(Be<Le[3*ne])ne=2*ne;else if(Be>Le[3*ne+1])ne=2*ne+1;else return Le[3*ne+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Ie,Be){if(Ie===0)return 0;const Le=Xe(Ie,Be);if(Le!==void 0)return Le;const Ke=new Z(Be,Ie);return Ke.prevCodePoint(),Ke.offset}e.$Pf=He;function Xe(Ie,Be){const Le=new Z(Be,Ie);let Ke=Le.prevCodePoint();for(;tt(Ke)||Ke===65039||Ke===8419;){if(Le.offset===0)return;Ke=Le.prevCodePoint()}if(!de(Ke))return;let ne=Le.offset;return ne>0&&Le.prevCodePoint()===8205&&(ne=Le.offset),ne}function tt(Ie){return 127995<=Ie&&Ie<=127999}var st;(function(Ie){Ie[Ie.zwj=8205]="zwj",Ie[Ie.emojiVariantSelector=65039]="emojiVariantSelector",Ie[Ie.enclosingKeyCap=8419]="enclosingKeyCap"})(st||(st={})),e.$Qf="\xA0";class ut{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new l.$Pe(Be=>{function Le(Fe){const $t=new Map;for(let Dt=0;Dt<Fe.length;Dt+=2)$t.set(Fe[Dt],Fe[Dt+1]);return $t}function Ke(Fe,$t){const Dt=new Map(Fe);for(const[Pt,jt]of $t)Dt.set(Pt,jt);return Dt}function ne(Fe,$t){if(!Fe)return $t;const Dt=new Map;for(const[Pt,jt]of Fe)$t.has(Pt)&&Dt.set(Pt,jt);return Dt}const oe=this.c.value;let Ce=Be.filter(Fe=>!Fe.startsWith("_")&&Fe in oe);Ce.length===0&&(Ce=["_default"]);let Ge;for(const Fe of Ce){const $t=Le(oe[Fe]);Ge=ne(Ge,$t)}const xe=Le(oe._common),nt=Ke(xe,Ge);return new ut(nt)})}static getInstance(Be){return ut.d.get(Array.from(Be))}static{this.e=new N.$V(()=>Object.keys(ut.c.value).filter(Be=>!Be.startsWith("_")))}static getLocales(){return ut.e.value}constructor(Be){this.f=Be}isAmbiguous(Be){return this.f.has(Be)}getPrimaryConfusable(Be){return this.f.get(Be)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Rf=ut;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(Be){return rt.e().has(Be)}static get codePoints(){return rt.e()}}e.$Sf=rt}),define(Se[126],De([1,0,28,165,14]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=e.$hk=e.$gk=e.FuzzyScore=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.or=void 0;function A(...we){return function(Ae,Oe){for(let ze=0,q=we.length;ze<q;ze++){const W=we[ze](Ae,Oe);if(W)return W}return null}}e.or=A,e.$7j=R.bind(void 0,!1),e.$8j=R.bind(void 0,!0);function R(we,Ae,Oe){if(!Oe||Oe.length<Ae.length)return null;let ze;return we?ze=L.$lf(Oe,Ae):ze=Oe.indexOf(Ae)===0,ze?Ae.length>0?[{start:0,end:Ae.length}]:[]:null}function w(we,Ae){const Oe=Ae.toLowerCase().indexOf(we.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+we.length}]}e.$9j=w;function p(we,Ae){return E(we.toLowerCase(),Ae.toLowerCase(),0,0)}e.$0j=p;function E(we,Ae,Oe,ze){if(Oe===we.length)return[];if(ze===Ae.length)return null;if(we[Oe]===Ae[ze]){let q=null;return(q=E(we,Ae,Oe+1,ze+1))?r({start:ze,end:ze+1},q):null}return E(we,Ae,Oe,ze+1)}function M(we){return 97<=we&&we<=122}function C(we){return 65<=we&&we<=90}e.$$j=C;function v(we){return 48<=we&&we<=57}function S(we){return we===32||we===9||we===10||we===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(we=>y.add(we.charCodeAt(0)));function u(we){return S(we)||y.has(we)}function m(we,Ae){return we===Ae||u(we)&&u(Ae)}const o=new Map;function i(we){if(o.has(we))return o.get(we);let Ae;const Oe=(0,N.$5j)(we);return Oe&&(Ae=Oe),o.set(we,Ae),Ae}function n(we){return M(we)||C(we)||v(we)}function r(we,Ae){return Ae.length===0?Ae=[we]:we.end===Ae[0].start?Ae[0].start=we.start:Ae.unshift(we),Ae}function c(we,Ae){for(let Oe=Ae;Oe<we.length;Oe++){const ze=we.charCodeAt(Oe);if(C(ze)||v(ze)||Oe>0&&!n(we.charCodeAt(Oe-1)))return Oe}return we.length}function t(we,Ae,Oe,ze){if(Oe===we.length)return[];if(ze===Ae.length)return null;if(we[Oe]!==Ae[ze].toLowerCase())return null;{let q=null,W=ze+1;for(q=t(we,Ae,Oe+1,ze+1);!q&&(W=c(Ae,W))<Ae.length;)q=t(we,Ae,Oe+1,W),W++;return q===null?null:r({start:ze,end:ze+1},q)}}function f(we){let Ae=0,Oe=0,ze=0,q=0,W=0;for(let Te=0;Te<we.length;Te++)W=we.charCodeAt(Te),C(W)&&Ae++,M(W)&&Oe++,n(W)&&ze++,v(W)&&q++;const Q=Ae/we.length,J=Oe/we.length,$e=ze/we.length,ve=q/we.length;return{upperPercent:Q,lowerPercent:J,alphaPercent:$e,numericPercent:ve}}function h(we){const{upperPercent:Ae,lowerPercent:Oe}=we;return Oe===0&&Ae>.6}function s(we){const{upperPercent:Ae,lowerPercent:Oe,alphaPercent:ze,numericPercent:q}=we;return Oe>.2&&Ae<.8&&ze>.6&&q<.2}function a(we){let Ae=0,Oe=0,ze=0,q=0;for(let W=0;W<we.length;W++)ze=we.charCodeAt(W),C(ze)&&Ae++,M(ze)&&Oe++,S(ze)&&q++;return(Ae===0||Oe===0)&&q===0?we.length<=30:Ae<=5}function d(we,Ae){if(!Ae||(Ae=Ae.trim(),Ae.length===0)||!a(we))return null;Ae.length>60&&(Ae=Ae.substring(0,60));const Oe=f(Ae);if(!s(Oe)){if(!h(Oe))return null;Ae=Ae.toLowerCase()}let ze=null,q=0;for(we=we.toLowerCase();q<Ae.length&&(ze=t(we,Ae,0,q))===null;)q=c(Ae,q+1);return ze}e.$_j=d;function $(we,Ae,Oe=!1){if(!Ae||Ae.length===0)return null;let ze=null,q=0;for(we=we.toLowerCase(),Ae=Ae.toLowerCase();q<Ae.length&&(ze=D(we,Ae,0,q,Oe),ze===null);)q=b(Ae,q+1);return ze}e.$ak=$;function D(we,Ae,Oe,ze,q){let W=0;if(Oe===we.length)return[];if(ze===Ae.length)return null;if(!m(we.charCodeAt(Oe),Ae.charCodeAt(ze))){const $e=i(we.charCodeAt(Oe));if(!$e)return null;for(let ve=0;ve<$e.length;ve++)if(!m($e[ve],Ae.charCodeAt(ze+ve)))return null;W+=$e.length-1}let Q=null,J=ze+W+1;if(Q=D(we,Ae,Oe+1,J,q),!q)for(;!Q&&(J=b(Ae,J))<Ae.length;)Q=D(we,Ae,Oe+1,J,q),J++;if(!Q)return null;if(we.charCodeAt(Oe)!==Ae.charCodeAt(ze)){const $e=i(we.charCodeAt(Oe));if(!$e)return Q;for(let ve=0;ve<$e.length;ve++)if($e[ve]!==Ae.charCodeAt(ze+ve))return Q}return r({start:ze,end:ze+W+1},Q)}function b(we,Ae){for(let Oe=Ae;Oe<we.length;Oe++)if(u(we.charCodeAt(Oe))||Oe>0&&u(we.charCodeAt(Oe-1)))return Oe;return we.length}const g=A(e.$8j,d,w),k=A(e.$8j,d,p),P=new l.$Dc(1e4);function F(we,Ae,Oe=!1){if(typeof we!="string"||typeof Ae!="string")return null;let ze=P.get(we);ze||(ze=new RegExp(L.$6e(we),"i"),P.set(we,ze));const q=ze.exec(Ae);return q?[{start:q.index,end:q.index+q[0].length}]:Oe?k(we,Ae):g(we,Ae)}e.$bk=F;function U(we,Ae){const Oe=ce(we,we.toLowerCase(),0,Ae,Ae.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?T(Oe):null}e.$ck=U;function z(we,Ae,Oe,ze,q,W){const Q=Math.min(13,we.length);for(;Oe<Q;Oe++){const J=ce(we,Ae,Oe,ze,q,W,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,W]}e.$dk=z;function T(we){if(typeof we>"u")return[];const Ae=[],Oe=we[1];for(let ze=we.length-1;ze>1;ze--){const q=we[ze]+Oe,W=Ae[Ae.length-1];W&&W.end===q?W.end=q+1:Ae.push({start:q,end:q+1})}return Ae}e.$ek=T;const I=128;function O(){const we=[],Ae=[];for(let Oe=0;Oe<=I;Oe++)Ae[Oe]=0;for(let Oe=0;Oe<=I;Oe++)we.push(Ae.slice(0));return we}function j(we){const Ae=[];for(let Oe=0;Oe<=we;Oe++)Ae[Oe]=0;return Ae}const G=j(2*I),te=j(2*I),x=O(),Z=O(),X=O(),ae=!1;function _(we,Ae,Oe,ze,q){function W(J,$e,ve=" "){for(;J.length<$e;)J=ve+J;return J}let Q=` |   |${ze.split("").map(J=>W(J,3)).join("|")}
`;for(let J=0;J<=Oe;J++)J===0?Q+=" |":Q+=`${Ae[J-1]}|`,Q+=we[J].slice(0,q+1).map($e=>W($e.toString(),3)).join("|")+`
`;return Q}function ge(we,Ae,Oe,ze){we=we.substr(Ae),Oe=Oe.substr(ze),console.log(_(Z,we,we.length,Oe,Oe.length)),console.log(_(X,we,we.length,Oe,Oe.length)),console.log(_(x,we,we.length,Oe,Oe.length))}function se(we,Ae){if(Ae<0||Ae>=we.length)return!1;const Oe=we.codePointAt(Ae);switch(Oe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$Df(Oe)}}function re(we,Ae){if(Ae<0||Ae>=we.length)return!1;switch(we.charCodeAt(Ae)){case 32:case 9:return!0;default:return!1}}function B(we,Ae,Oe){return Ae[we]!==Oe[we]}function ie(we,Ae,Oe,ze,q,W,Q=!1){for(;Ae<Oe&&q<W;)we[Ae]===ze[q]&&(Q&&(G[Ae]=q),Ae+=1),q+=1;return Ae===Oe}e.$fk=ie;var ke;(function(we){we[we.Diag=1]="Diag",we[we.Left=2]="Left",we[we.LeftLeft=3]="LeftLeft"})(ke||(ke={}));var le;(function(we){we.Default=[-100,0];function Ae(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}we.isDefault=Ae})(le||(e.FuzzyScore=le={}));class ue{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ae,Oe){this.firstMatchCanBeWeak=Ae,this.boostFullMatch=Oe}}e.$gk=ue;function ce(we,Ae,Oe,ze,q,W,Q=ue.default){const J=we.length>I?I:we.length,$e=ze.length>I?I:ze.length;if(Oe>=J||W>=$e||J-Oe>$e-W||!ie(Ae,Oe,J,q,W,$e,!0))return;de(J,$e,Oe,W,Ae,q);let ve=1,Te=1,He=Oe,Xe=W;const tt=[!1];for(ve=1,He=Oe;He<J;ve++,He++){const Be=G[He],Le=te[He],Ke=He+1<J?te[He+1]:$e;for(Te=Be-W+1,Xe=Be;Xe<Ke;Te++,Xe++){let ne=Number.MIN_SAFE_INTEGER,oe=!1;Xe<=Le&&(ne=H(we,Ae,He,Oe,ze,q,Xe,$e,W,x[ve-1][Te-1]===0,tt));let Ce=0;ne!==Number.MAX_SAFE_INTEGER&&(oe=!0,Ce=ne+Z[ve-1][Te-1]);const Ge=Xe>Be,xe=Ge?Z[ve][Te-1]+(x[ve][Te-1]>0?-5:0):0,nt=Xe>Be+1&&x[ve][Te-1]>0,Fe=nt?Z[ve][Te-2]+(x[ve][Te-2]>0?-5:0):0;if(nt&&(!Ge||Fe>=xe)&&(!oe||Fe>=Ce))Z[ve][Te]=Fe,X[ve][Te]=3,x[ve][Te]=0;else if(Ge&&(!oe||xe>=Ce))Z[ve][Te]=xe,X[ve][Te]=2,x[ve][Te]=0;else if(oe)Z[ve][Te]=Ce,X[ve][Te]=1,x[ve][Te]=x[ve-1][Te-1]+1;else throw new Error("not possible")}}if(ae&&ge(we,Oe,ze,W),!tt[0]&&!Q.firstMatchCanBeWeak)return;ve--,Te--;const st=[Z[ve][Te],W];let ut=0,rt=0;for(;ve>=1;){let Be=Te;do{const Le=X[ve][Be];if(Le===3)Be=Be-2;else if(Le===2)Be=Be-1;else break}while(Be>=1);ut>1&&Ae[Oe+ve-1]===q[W+Te-1]&&!B(Be+W-1,ze,q)&&ut+1>x[ve][Be]&&(Be=Te),Be===Te?ut++:ut=1,rt||(rt=Be),ve--,Te=Be-1,st.push(Te)}$e===J&&Q.boostFullMatch&&(st[0]+=2);const Ie=rt-J;return st[0]-=Ie,st}e.$hk=ce;function de(we,Ae,Oe,ze,q,W){let Q=we-1,J=Ae-1;for(;Q>=Oe&&J>=ze;)q[Q]===W[J]&&(te[Q]=J,Q--),J--}function H(we,Ae,Oe,ze,q,W,Q,J,$e,ve,Te){if(Ae[Oe]!==W[Q])return Number.MIN_SAFE_INTEGER;let He=1,Xe=!1;return Q===Oe-ze?He=we[Oe]===q[Q]?7:5:B(Q,q,W)&&(Q===0||!B(Q-1,q,W))?(He=we[Oe]===q[Q]?7:5,Xe=!0):se(W,Q)&&(Q===0||!se(W,Q-1))?He=5:(se(W,Q-1)||re(W,Q-1))&&(He=5,Xe=!0),He>1&&Oe===ze&&(Te[0]=!0),Xe||(Xe=B(Q,q,W)||se(W,Q-1)||re(W,Q-1)),Oe===ze?Q>$e&&(He-=Xe?3:5):ve?He+=Xe?2:0:He+=Xe?0:1,Q+1===J&&(He-=Xe?3:5),He}function Y(we,Ae,Oe,ze,q,W,Q){return be(we,Ae,Oe,ze,q,W,!0,Q)}e.$ik=Y;function he(we,Ae,Oe,ze,q,W,Q){return be(we,Ae,Oe,ze,q,W,!1,Q)}e.$jk=he;function be(we,Ae,Oe,ze,q,W,Q,J){let $e=ce(we,Ae,Oe,ze,q,W,J);if($e&&!Q)return $e;if(we.length>=3){const ve=Math.min(7,we.length-1);for(let Te=Oe+1;Te<ve;Te++){const He=Pe(we,Te);if(He){const Xe=ce(He,He.toLowerCase(),Oe,ze,q,W,J);Xe&&(Xe[0]-=3,(!$e||Xe[0]>$e[0])&&($e=Xe))}}}return $e}function Pe(we,Ae){if(Ae+1>=we.length)return;const Oe=we[Ae],ze=we[Ae+1];if(Oe!==ze)return we.slice(0,Ae)+ze+Oe+we.slice(Ae+2)}}),define(Se[54],De([1,0,14]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=void 0;function N(o){return L(o,0)}e.$7i=N;function L(o,i){switch(typeof o){case"object":return o===null?A(349,i):Array.isArray(o)?p(o,i):E(o,i);case"string":return w(o,i);case"boolean":return R(o,i);case"number":return A(o,i);case"undefined":return A(937,i);default:return A(617,i)}}e.$8i=L;function A(o,i){return(i<<5)-i+o|0}e.$9i=A;function R(o,i){return A(o?433:863,i)}function w(o,i){i=A(149417,i);for(let n=0,r=o.length;n<r;n++)i=A(o.charCodeAt(n),i);return i}e.$0i=w;function p(o,i){return i=A(104579,i),o.reduce((n,r)=>L(r,n),i)}function E(o,i){return i=A(181387,i),Object.keys(o).sort().reduce((n,r)=>(n=w(r,n),L(o[r],n)),i)}class M{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=L(i,this.g),this.g}}e.$$i=M;var C;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function v(o,i,n=32){const r=n-i,c=~((1<<r)-1);return(o<<i|(c&o)>>>r)>>>0}function S(o,i=0,n=o.byteLength,r=0){for(let c=0;c<n;c++)o[i+c]=r}function y(o,i,n="0"){for(;o.length<i;)o=n+o;return o}function u(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(n=>n.toString(16).padStart(2,"0")).join(""):y((o>>>0).toString(16),i/4)}e.$_i=u;class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const r=this.p;let c=this.r,t=this.u,f,h;for(t!==0?(f=t,h=-1,t=0):(f=i.charCodeAt(0),h=0);;){let s=f;if(l.$of(f))if(h+1<n){const a=i.charCodeAt(h+1);l.$pf(a)?(h++,s=l.$qf(f,a)):s=65533}else{t=f;break}else l.$pf(f)&&(s=65533);if(c=this.w(r,c,s),h++,h<n)f=i.charCodeAt(h);else break}this.r=c,this.u=t}w(i,n,r){return r<128?i[n++]=r:r<2048?(i[n++]=192|(r&1984)>>>6,i[n++]=128|(r&63)>>>0):r<65536?(i[n++]=224|(r&61440)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0):(i[n++]=240|(r&1835008)>>>18,i[n++]=128|(r&258048)>>>12,i[n++]=128|(r&4032)>>>6,i[n++]=128|(r&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64],i[1]=i[65],i[2]=i[66]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),u(this.h)+u(this.l)+u(this.m)+u(this.n)+u(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=m.g,n=this.q;for(let $=0;$<64;$+=4)i.setUint32($,n.getUint32($,!1),!1);for(let $=64;$<320;$+=4)i.setUint32($,v(i.getUint32($-12,!1)^i.getUint32($-32,!1)^i.getUint32($-56,!1)^i.getUint32($-64,!1),1),!1);let r=this.h,c=this.l,t=this.m,f=this.n,h=this.o,s,a,d;for(let $=0;$<80;$++)$<20?(s=c&t|~c&f,a=1518500249):$<40?(s=c^t^f,a=1859775393):$<60?(s=c&t|c&f|t&f,a=2400959708):(s=c^t^f,a=3395469782),d=v(r,5)+s+h+a+i.getUint32($*4,!1)&4294967295,h=f,f=t,t=v(c,30),c=r,r=d;this.h=this.h+r&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+f&4294967295,this.o=this.o+h&4294967295}}e.$aj=m}),define(Se[39],De([1,0,14]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",R="warning",w="warn",p="info",E="ignore";function M(v){return v?l.$kf(A,v)?L.Error:l.$kf(R,v)||l.$kf(w,v)?L.Warning:l.$kf(p,v)?L.Info:L.Ignore:L.Ignore}L.fromValue=M;function C(v){switch(v){case L.Error:return A;case L.Warning:return R;case L.Info:return p;default:return E}}L.toString=C}(N||(N={})),e.default=N}),define(Se[167],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3d=void 0,e.$3d=Symbol("MicrotaskDelay")}),define(Se[76],De([1,0,19,14]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;class L{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const y=S.charCodeAt(0),u=this.b.charCodeAt(this.c);return y-u}value(){return this.b[this.c]}}e.$ii=L;class A{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,N.$ef)(S,this.b,0,S.length,this.c,this.d):(0,N.$gf)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$ji=A;class R{constructor(S=!0,y=!0){this.f=S,this.g=y}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let y=S.length-1;y>=0;y--,this.c--){const u=this.b.charCodeAt(y);if(!(u===47||this.f&&u===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,N.$ef)(S,this.b,0,S.length,this.d,this.e):(0,N.$gf)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$ki=R;var w;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(w||(w={}));class p{constructor(S,y){this.f=S,this.g=y,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,N.$ff)(S,this.c.scheme);if(this.d[this.e]===2)return(0,N.$ff)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,N.$df)(S,this.c.query);if(this.d[this.e]===5)return(0,N.$df)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$li=p;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var M;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(M||(M={}));class C{static forUris(S=()=>!1,y=()=>!1){return new C(new p(S,y))}static forPaths(S=!1){return new C(new R(void 0,!S))}static forStrings(){return new C(new L)}static forConfigKeys(){return new C(new A)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,y){if(y){const u=y.slice(0);(0,l.$Xb)(u);for(const m of u)this.set(m,S)}else{const u=S.slice(0);(0,l.$Xb)(u);for(const m of u)this.set(m[0],m[1])}}set(S,y){const u=this.b.reset(S);let m;this.c||(this.c=new E,this.c.segment=u.value());const o=[];for(m=this.c;;){const n=u.cmp(m.segment);if(n>0)m.left||(m.left=new E,m.left.segment=u.value()),o.push([-1,m]),m=m.left;else if(n<0)m.right||(m.right=new E,m.right.segment=u.value()),o.push([1,m]),m=m.right;else if(u.hasNext())u.next(),m.mid||(m.mid=new E,m.mid.segment=u.value()),o.push([0,m]),m=m.mid;else break}const i=m.value;m.value=y,m.key=S;for(let n=o.length-1;n>=0;n--){const r=o[n][1];r.updateHeight();const c=r.balanceFactor();if(c<-1||c>1){const t=o[n][0],f=o[n+1][0];if(t===1&&f===1)o[n][1]=r.rotateLeft();else if(t===-1&&f===-1)o[n][1]=r.rotateRight();else if(t===1&&f===-1)r.right=o[n+1][1]=o[n+1][1].rotateRight(),o[n][1]=r.rotateLeft();else if(t===-1&&f===1)r.left=o[n+1][1]=o[n+1][1].rotateLeft(),o[n][1]=r.rotateRight();else throw new Error;if(n>0)switch(o[n-1][0]){case-1:o[n-1][1].left=o[n][1];break;case 1:o[n-1][1].right=o[n][1];break;case 0:o[n-1][1].mid=o[n][1];break}else this.c=o[0][1]}}return i}get(S){return this.d(S)?.value}d(S){const y=this.b.reset(S);let u=this.c;for(;u;){const m=y.cmp(u.segment);if(m>0)u=u.left;else if(m<0)u=u.right;else if(y.hasNext())y.next(),u=u.mid;else break}return u}has(S){const y=this.d(S);return!(y?.value===void 0&&y?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,y){const u=this.b.reset(S),m=[];let o=this.c;for(;o;){const i=u.cmp(o.segment);if(i>0)m.push([-1,o]),o=o.left;else if(i<0)m.push([1,o]),o=o.right;else if(u.hasNext())u.next(),m.push([0,o]),o=o.mid;else break}if(o){if(y?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:n,value:r,segment:c}=i;this.e(i.key,!1),o.key=n,o.value=r,o.segment=c}}else{const i=o.left??o.right;if(m.length>0){const[n,r]=m[m.length-1];switch(n){case-1:r.left=i;break;case 0:r.mid=i;break;case 1:r.right=i;break}}else this.c=i}for(let i=m.length-1;i>=0;i--){const n=m[i][1];n.updateHeight();const r=n.balanceFactor();if(r>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),m[i][1]=n.rotateLeft()):r<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),m[i][1]=n.rotateRight()),i>0)switch(m[i-1][0]){case-1:m[i-1][1].left=m[i][1];break;case 1:m[i-1][1].right=m[i][1];break;case 0:m[i-1][1].mid=m[i][1];break}else this.c=m[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const y=this.b.reset(S);let u=this.c,m;for(;u;){const o=y.cmp(u.segment);if(o>0)u=u.left;else if(o<0)u=u.right;else if(y.hasNext())y.next(),m=u.value||m,u=u.mid;else break}return u&&u.value||m}findSuperstr(S){return this.g(S,!1)}g(S,y){const u=this.b.reset(S);let m=this.c;for(;m;){const o=u.cmp(m.segment);if(o>0)m=m.left;else if(o<0)m=m.right;else if(u.hasNext())u.next(),m=m.mid;else return m.mid?this.h(m.mid):y?m.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[y,u]of this)S(u,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const y=[];return this.j(S,y),y[Symbol.iterator]()}j(S,y){S&&(S.left&&this.j(S.left,y),S.value&&y.push([S.key,S.value]),S.mid&&this.j(S.mid,y),S.right&&this.j(S.right,y))}_isBalanced(){const S=y=>{if(!y)return!0;const u=y.balanceFactor();return u<-1||u>1?!1:S(y.left)&&S(y.right)};return S(this.c)}}e.$mi=C}),define(Se[18],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=void 0;function l(c){return typeof c=="string"}e.$Tf=l;function N(c){return Array.isArray(c)&&c.every(t=>l(t))}e.$Uf=N;function L(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Vf=L;function A(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Wf=A;function R(c){return typeof c=="number"&&!isNaN(c)}e.$Xf=R;function w(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Yf=w;function p(c){return c===!0||c===!1}e.$Zf=p;function E(c){return typeof c>"u"}e.$1f=E;function M(c){return!C(c)}e.$2f=M;function C(c){return E(c)||c===null}e.$3f=C;function v(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$4f=v;function S(c){if(C(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$5f=S;function y(...c){const t=[];for(let f=0;f<c.length;f++){const h=c[f];if(C(h))throw new Error(`Assertion Failed: argument at index ${f} is undefined or null`);t.push(h)}return t}e.$6f=y;const u=Object.prototype.hasOwnProperty;function m(c){if(!L(c))return!1;for(const t in c)if(u.call(c,t))return!1;return!0}e.$7f=m;function o(c){return typeof c=="function"}e.$8f=o;function i(...c){return c.length>0&&c.every(o)}e.$9f=i;function n(c,t){const f=Math.min(c.length,t.length);for(let h=0;h<f;h++)r(c[h],t[h])}e.$0f=n;function r(c,t){if(l(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(c instanceof t)return}catch{}if(!C(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$$f=r}),define(Se[99],De([1,0,18]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lk=e.$kk=void 0;const N=Object.create(null);function L(R,w){if((0,l.$Tf)(w)){const p=N[w];if(p===void 0)throw new Error(`${R} references an unknown codicon: ${w}`);w=p}return N[R]=w,{id:R}}e.$kk=L;function A(){return N}e.$lk=A}),define(Se[168],De([1,0,99]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=void 0,e.$mk={add:(0,l.$kk)("add",6e4),plus:(0,l.$kk)("plus",6e4),gistNew:(0,l.$kk)("gist-new",6e4),repoCreate:(0,l.$kk)("repo-create",6e4),lightbulb:(0,l.$kk)("lightbulb",60001),lightBulb:(0,l.$kk)("light-bulb",60001),repo:(0,l.$kk)("repo",60002),repoDelete:(0,l.$kk)("repo-delete",60002),gistFork:(0,l.$kk)("gist-fork",60003),repoForked:(0,l.$kk)("repo-forked",60003),gitPullRequest:(0,l.$kk)("git-pull-request",60004),gitPullRequestAbandoned:(0,l.$kk)("git-pull-request-abandoned",60004),recordKeys:(0,l.$kk)("record-keys",60005),keyboard:(0,l.$kk)("keyboard",60005),tag:(0,l.$kk)("tag",60006),tagAdd:(0,l.$kk)("tag-add",60006),tagRemove:(0,l.$kk)("tag-remove",60006),gitPullRequestLabel:(0,l.$kk)("git-pull-request-label",60006),person:(0,l.$kk)("person",60007),personFollow:(0,l.$kk)("person-follow",60007),personOutline:(0,l.$kk)("person-outline",60007),personFilled:(0,l.$kk)("person-filled",60007),gitBranch:(0,l.$kk)("git-branch",60008),gitBranchCreate:(0,l.$kk)("git-branch-create",60008),gitBranchDelete:(0,l.$kk)("git-branch-delete",60008),sourceControl:(0,l.$kk)("source-control",60008),mirror:(0,l.$kk)("mirror",60009),mirrorPublic:(0,l.$kk)("mirror-public",60009),star:(0,l.$kk)("star",60010),starAdd:(0,l.$kk)("star-add",60010),starDelete:(0,l.$kk)("star-delete",60010),starEmpty:(0,l.$kk)("star-empty",60010),comment:(0,l.$kk)("comment",60011),commentAdd:(0,l.$kk)("comment-add",60011),alert:(0,l.$kk)("alert",60012),warning:(0,l.$kk)("warning",60012),search:(0,l.$kk)("search",60013),searchSave:(0,l.$kk)("search-save",60013),logOut:(0,l.$kk)("log-out",60014),signOut:(0,l.$kk)("sign-out",60014),logIn:(0,l.$kk)("log-in",60015),signIn:(0,l.$kk)("sign-in",60015),eye:(0,l.$kk)("eye",60016),eyeUnwatch:(0,l.$kk)("eye-unwatch",60016),eyeWatch:(0,l.$kk)("eye-watch",60016),circleFilled:(0,l.$kk)("circle-filled",60017),primitiveDot:(0,l.$kk)("primitive-dot",60017),closeDirty:(0,l.$kk)("close-dirty",60017),debugBreakpoint:(0,l.$kk)("debug-breakpoint",60017),debugBreakpointDisabled:(0,l.$kk)("debug-breakpoint-disabled",60017),debugBreakpointPending:(0,l.$kk)("debug-breakpoint-pending",60377),debugHint:(0,l.$kk)("debug-hint",60017),primitiveSquare:(0,l.$kk)("primitive-square",60018),edit:(0,l.$kk)("edit",60019),pencil:(0,l.$kk)("pencil",60019),info:(0,l.$kk)("info",60020),issueOpened:(0,l.$kk)("issue-opened",60020),gistPrivate:(0,l.$kk)("gist-private",60021),gitForkPrivate:(0,l.$kk)("git-fork-private",60021),lock:(0,l.$kk)("lock",60021),mirrorPrivate:(0,l.$kk)("mirror-private",60021),close:(0,l.$kk)("close",60022),removeClose:(0,l.$kk)("remove-close",60022),x:(0,l.$kk)("x",60022),repoSync:(0,l.$kk)("repo-sync",60023),sync:(0,l.$kk)("sync",60023),clone:(0,l.$kk)("clone",60024),desktopDownload:(0,l.$kk)("desktop-download",60024),beaker:(0,l.$kk)("beaker",60025),microscope:(0,l.$kk)("microscope",60025),vm:(0,l.$kk)("vm",60026),deviceDesktop:(0,l.$kk)("device-desktop",60026),file:(0,l.$kk)("file",60027),fileText:(0,l.$kk)("file-text",60027),more:(0,l.$kk)("more",60028),ellipsis:(0,l.$kk)("ellipsis",60028),kebabHorizontal:(0,l.$kk)("kebab-horizontal",60028),mailReply:(0,l.$kk)("mail-reply",60029),reply:(0,l.$kk)("reply",60029),organization:(0,l.$kk)("organization",60030),organizationFilled:(0,l.$kk)("organization-filled",60030),organizationOutline:(0,l.$kk)("organization-outline",60030),newFile:(0,l.$kk)("new-file",60031),fileAdd:(0,l.$kk)("file-add",60031),newFolder:(0,l.$kk)("new-folder",60032),fileDirectoryCreate:(0,l.$kk)("file-directory-create",60032),trash:(0,l.$kk)("trash",60033),trashcan:(0,l.$kk)("trashcan",60033),history:(0,l.$kk)("history",60034),clock:(0,l.$kk)("clock",60034),folder:(0,l.$kk)("folder",60035),fileDirectory:(0,l.$kk)("file-directory",60035),symbolFolder:(0,l.$kk)("symbol-folder",60035),logoGithub:(0,l.$kk)("logo-github",60036),markGithub:(0,l.$kk)("mark-github",60036),github:(0,l.$kk)("github",60036),terminal:(0,l.$kk)("terminal",60037),console:(0,l.$kk)("console",60037),repl:(0,l.$kk)("repl",60037),zap:(0,l.$kk)("zap",60038),symbolEvent:(0,l.$kk)("symbol-event",60038),error:(0,l.$kk)("error",60039),stop:(0,l.$kk)("stop",60039),variable:(0,l.$kk)("variable",60040),symbolVariable:(0,l.$kk)("symbol-variable",60040),array:(0,l.$kk)("array",60042),symbolArray:(0,l.$kk)("symbol-array",60042),symbolModule:(0,l.$kk)("symbol-module",60043),symbolPackage:(0,l.$kk)("symbol-package",60043),symbolNamespace:(0,l.$kk)("symbol-namespace",60043),symbolObject:(0,l.$kk)("symbol-object",60043),symbolMethod:(0,l.$kk)("symbol-method",60044),symbolFunction:(0,l.$kk)("symbol-function",60044),symbolConstructor:(0,l.$kk)("symbol-constructor",60044),symbolBoolean:(0,l.$kk)("symbol-boolean",60047),symbolNull:(0,l.$kk)("symbol-null",60047),symbolNumeric:(0,l.$kk)("symbol-numeric",60048),symbolNumber:(0,l.$kk)("symbol-number",60048),symbolStructure:(0,l.$kk)("symbol-structure",60049),symbolStruct:(0,l.$kk)("symbol-struct",60049),symbolParameter:(0,l.$kk)("symbol-parameter",60050),symbolTypeParameter:(0,l.$kk)("symbol-type-parameter",60050),symbolKey:(0,l.$kk)("symbol-key",60051),symbolText:(0,l.$kk)("symbol-text",60051),symbolReference:(0,l.$kk)("symbol-reference",60052),goToFile:(0,l.$kk)("go-to-file",60052),symbolEnum:(0,l.$kk)("symbol-enum",60053),symbolValue:(0,l.$kk)("symbol-value",60053),symbolRuler:(0,l.$kk)("symbol-ruler",60054),symbolUnit:(0,l.$kk)("symbol-unit",60054),activateBreakpoints:(0,l.$kk)("activate-breakpoints",60055),archive:(0,l.$kk)("archive",60056),arrowBoth:(0,l.$kk)("arrow-both",60057),arrowDown:(0,l.$kk)("arrow-down",60058),arrowLeft:(0,l.$kk)("arrow-left",60059),arrowRight:(0,l.$kk)("arrow-right",60060),arrowSmallDown:(0,l.$kk)("arrow-small-down",60061),arrowSmallLeft:(0,l.$kk)("arrow-small-left",60062),arrowSmallRight:(0,l.$kk)("arrow-small-right",60063),arrowSmallUp:(0,l.$kk)("arrow-small-up",60064),arrowUp:(0,l.$kk)("arrow-up",60065),bell:(0,l.$kk)("bell",60066),bold:(0,l.$kk)("bold",60067),book:(0,l.$kk)("book",60068),bookmark:(0,l.$kk)("bookmark",60069),debugBreakpointConditionalUnverified:(0,l.$kk)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,l.$kk)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,l.$kk)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,l.$kk)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,l.$kk)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,l.$kk)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,l.$kk)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,l.$kk)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,l.$kk)("debug-breakpoint-log-disabled",60075),briefcase:(0,l.$kk)("briefcase",60076),broadcast:(0,l.$kk)("broadcast",60077),browser:(0,l.$kk)("browser",60078),bug:(0,l.$kk)("bug",60079),calendar:(0,l.$kk)("calendar",60080),caseSensitive:(0,l.$kk)("case-sensitive",60081),check:(0,l.$kk)("check",60082),checklist:(0,l.$kk)("checklist",60083),chevronDown:(0,l.$kk)("chevron-down",60084),dropDownButton:(0,l.$kk)("drop-down-button",60084),chevronLeft:(0,l.$kk)("chevron-left",60085),chevronRight:(0,l.$kk)("chevron-right",60086),chevronUp:(0,l.$kk)("chevron-up",60087),chromeClose:(0,l.$kk)("chrome-close",60088),chromeMaximize:(0,l.$kk)("chrome-maximize",60089),chromeMinimize:(0,l.$kk)("chrome-minimize",60090),chromeRestore:(0,l.$kk)("chrome-restore",60091),circle:(0,l.$kk)("circle",60092),circleOutline:(0,l.$kk)("circle-outline",60092),debugBreakpointUnverified:(0,l.$kk)("debug-breakpoint-unverified",60092),circleSlash:(0,l.$kk)("circle-slash",60093),circuitBoard:(0,l.$kk)("circuit-board",60094),clearAll:(0,l.$kk)("clear-all",60095),clippy:(0,l.$kk)("clippy",60096),closeAll:(0,l.$kk)("close-all",60097),cloudDownload:(0,l.$kk)("cloud-download",60098),cloudUpload:(0,l.$kk)("cloud-upload",60099),code:(0,l.$kk)("code",60100),collapseAll:(0,l.$kk)("collapse-all",60101),colorMode:(0,l.$kk)("color-mode",60102),commentDiscussion:(0,l.$kk)("comment-discussion",60103),compareChanges:(0,l.$kk)("compare-changes",60157),creditCard:(0,l.$kk)("credit-card",60105),dash:(0,l.$kk)("dash",60108),dashboard:(0,l.$kk)("dashboard",60109),database:(0,l.$kk)("database",60110),debugContinue:(0,l.$kk)("debug-continue",60111),debugDisconnect:(0,l.$kk)("debug-disconnect",60112),debugPause:(0,l.$kk)("debug-pause",60113),debugRestart:(0,l.$kk)("debug-restart",60114),debugStart:(0,l.$kk)("debug-start",60115),debugStepInto:(0,l.$kk)("debug-step-into",60116),debugStepOut:(0,l.$kk)("debug-step-out",60117),debugStepOver:(0,l.$kk)("debug-step-over",60118),debugStop:(0,l.$kk)("debug-stop",60119),debug:(0,l.$kk)("debug",60120),deviceCameraVideo:(0,l.$kk)("device-camera-video",60121),deviceCamera:(0,l.$kk)("device-camera",60122),deviceMobile:(0,l.$kk)("device-mobile",60123),diffAdded:(0,l.$kk)("diff-added",60124),diffIgnored:(0,l.$kk)("diff-ignored",60125),diffModified:(0,l.$kk)("diff-modified",60126),diffRemoved:(0,l.$kk)("diff-removed",60127),diffRenamed:(0,l.$kk)("diff-renamed",60128),diff:(0,l.$kk)("diff",60129),discard:(0,l.$kk)("discard",60130),editorLayout:(0,l.$kk)("editor-layout",60131),emptyWindow:(0,l.$kk)("empty-window",60132),exclude:(0,l.$kk)("exclude",60133),extensions:(0,l.$kk)("extensions",60134),eyeClosed:(0,l.$kk)("eye-closed",60135),fileBinary:(0,l.$kk)("file-binary",60136),fileCode:(0,l.$kk)("file-code",60137),fileMedia:(0,l.$kk)("file-media",60138),filePdf:(0,l.$kk)("file-pdf",60139),fileSubmodule:(0,l.$kk)("file-submodule",60140),fileSymlinkDirectory:(0,l.$kk)("file-symlink-directory",60141),fileSymlinkFile:(0,l.$kk)("file-symlink-file",60142),fileZip:(0,l.$kk)("file-zip",60143),files:(0,l.$kk)("files",60144),filter:(0,l.$kk)("filter",60145),flame:(0,l.$kk)("flame",60146),foldDown:(0,l.$kk)("fold-down",60147),foldUp:(0,l.$kk)("fold-up",60148),fold:(0,l.$kk)("fold",60149),folderActive:(0,l.$kk)("folder-active",60150),folderOpened:(0,l.$kk)("folder-opened",60151),gear:(0,l.$kk)("gear",60152),gift:(0,l.$kk)("gift",60153),gistSecret:(0,l.$kk)("gist-secret",60154),gist:(0,l.$kk)("gist",60155),gitCommit:(0,l.$kk)("git-commit",60156),gitCompare:(0,l.$kk)("git-compare",60157),gitMerge:(0,l.$kk)("git-merge",60158),githubAction:(0,l.$kk)("github-action",60159),githubAlt:(0,l.$kk)("github-alt",60160),globe:(0,l.$kk)("globe",60161),grabber:(0,l.$kk)("grabber",60162),graph:(0,l.$kk)("graph",60163),gripper:(0,l.$kk)("gripper",60164),heart:(0,l.$kk)("heart",60165),home:(0,l.$kk)("home",60166),horizontalRule:(0,l.$kk)("horizontal-rule",60167),hubot:(0,l.$kk)("hubot",60168),inbox:(0,l.$kk)("inbox",60169),issueClosed:(0,l.$kk)("issue-closed",60324),issueReopened:(0,l.$kk)("issue-reopened",60171),issues:(0,l.$kk)("issues",60172),italic:(0,l.$kk)("italic",60173),jersey:(0,l.$kk)("jersey",60174),json:(0,l.$kk)("json",60175),bracket:(0,l.$kk)("bracket",60175),kebabVertical:(0,l.$kk)("kebab-vertical",60176),key:(0,l.$kk)("key",60177),law:(0,l.$kk)("law",60178),lightbulbAutofix:(0,l.$kk)("lightbulb-autofix",60179),linkExternal:(0,l.$kk)("link-external",60180),link:(0,l.$kk)("link",60181),listOrdered:(0,l.$kk)("list-ordered",60182),listUnordered:(0,l.$kk)("list-unordered",60183),liveShare:(0,l.$kk)("live-share",60184),loading:(0,l.$kk)("loading",60185),location:(0,l.$kk)("location",60186),mailRead:(0,l.$kk)("mail-read",60187),mail:(0,l.$kk)("mail",60188),markdown:(0,l.$kk)("markdown",60189),megaphone:(0,l.$kk)("megaphone",60190),mention:(0,l.$kk)("mention",60191),milestone:(0,l.$kk)("milestone",60192),gitPullRequestMilestone:(0,l.$kk)("git-pull-request-milestone",60192),mortarBoard:(0,l.$kk)("mortar-board",60193),move:(0,l.$kk)("move",60194),multipleWindows:(0,l.$kk)("multiple-windows",60195),mute:(0,l.$kk)("mute",60196),noNewline:(0,l.$kk)("no-newline",60197),note:(0,l.$kk)("note",60198),octoface:(0,l.$kk)("octoface",60199),openPreview:(0,l.$kk)("open-preview",60200),package:(0,l.$kk)("package",60201),paintcan:(0,l.$kk)("paintcan",60202),pin:(0,l.$kk)("pin",60203),play:(0,l.$kk)("play",60204),run:(0,l.$kk)("run",60204),plug:(0,l.$kk)("plug",60205),preserveCase:(0,l.$kk)("preserve-case",60206),preview:(0,l.$kk)("preview",60207),project:(0,l.$kk)("project",60208),pulse:(0,l.$kk)("pulse",60209),question:(0,l.$kk)("question",60210),quote:(0,l.$kk)("quote",60211),radioTower:(0,l.$kk)("radio-tower",60212),reactions:(0,l.$kk)("reactions",60213),references:(0,l.$kk)("references",60214),refresh:(0,l.$kk)("refresh",60215),regex:(0,l.$kk)("regex",60216),remoteExplorer:(0,l.$kk)("remote-explorer",60217),remote:(0,l.$kk)("remote",60218),remove:(0,l.$kk)("remove",60219),replaceAll:(0,l.$kk)("replace-all",60220),replace:(0,l.$kk)("replace",60221),repoClone:(0,l.$kk)("repo-clone",60222),repoForcePush:(0,l.$kk)("repo-force-push",60223),repoPull:(0,l.$kk)("repo-pull",60224),repoPush:(0,l.$kk)("repo-push",60225),report:(0,l.$kk)("report",60226),requestChanges:(0,l.$kk)("request-changes",60227),rocket:(0,l.$kk)("rocket",60228),rootFolderOpened:(0,l.$kk)("root-folder-opened",60229),rootFolder:(0,l.$kk)("root-folder",60230),rss:(0,l.$kk)("rss",60231),ruby:(0,l.$kk)("ruby",60232),saveAll:(0,l.$kk)("save-all",60233),saveAs:(0,l.$kk)("save-as",60234),save:(0,l.$kk)("save",60235),screenFull:(0,l.$kk)("screen-full",60236),screenNormal:(0,l.$kk)("screen-normal",60237),searchStop:(0,l.$kk)("search-stop",60238),server:(0,l.$kk)("server",60240),settingsGear:(0,l.$kk)("settings-gear",60241),settings:(0,l.$kk)("settings",60242),shield:(0,l.$kk)("shield",60243),smiley:(0,l.$kk)("smiley",60244),sortPrecedence:(0,l.$kk)("sort-precedence",60245),splitHorizontal:(0,l.$kk)("split-horizontal",60246),splitVertical:(0,l.$kk)("split-vertical",60247),squirrel:(0,l.$kk)("squirrel",60248),starFull:(0,l.$kk)("star-full",60249),starHalf:(0,l.$kk)("star-half",60250),symbolClass:(0,l.$kk)("symbol-class",60251),symbolColor:(0,l.$kk)("symbol-color",60252),symbolCustomColor:(0,l.$kk)("symbol-customcolor",60252),symbolConstant:(0,l.$kk)("symbol-constant",60253),symbolEnumMember:(0,l.$kk)("symbol-enum-member",60254),symbolField:(0,l.$kk)("symbol-field",60255),symbolFile:(0,l.$kk)("symbol-file",60256),symbolInterface:(0,l.$kk)("symbol-interface",60257),symbolKeyword:(0,l.$kk)("symbol-keyword",60258),symbolMisc:(0,l.$kk)("symbol-misc",60259),symbolOperator:(0,l.$kk)("symbol-operator",60260),symbolProperty:(0,l.$kk)("symbol-property",60261),wrench:(0,l.$kk)("wrench",60261),wrenchSubaction:(0,l.$kk)("wrench-subaction",60261),symbolSnippet:(0,l.$kk)("symbol-snippet",60262),tasklist:(0,l.$kk)("tasklist",60263),telescope:(0,l.$kk)("telescope",60264),textSize:(0,l.$kk)("text-size",60265),threeBars:(0,l.$kk)("three-bars",60266),thumbsdown:(0,l.$kk)("thumbsdown",60267),thumbsup:(0,l.$kk)("thumbsup",60268),tools:(0,l.$kk)("tools",60269),triangleDown:(0,l.$kk)("triangle-down",60270),triangleLeft:(0,l.$kk)("triangle-left",60271),triangleRight:(0,l.$kk)("triangle-right",60272),triangleUp:(0,l.$kk)("triangle-up",60273),twitter:(0,l.$kk)("twitter",60274),unfold:(0,l.$kk)("unfold",60275),unlock:(0,l.$kk)("unlock",60276),unmute:(0,l.$kk)("unmute",60277),unverified:(0,l.$kk)("unverified",60278),verified:(0,l.$kk)("verified",60279),versions:(0,l.$kk)("versions",60280),vmActive:(0,l.$kk)("vm-active",60281),vmOutline:(0,l.$kk)("vm-outline",60282),vmRunning:(0,l.$kk)("vm-running",60283),watch:(0,l.$kk)("watch",60284),whitespace:(0,l.$kk)("whitespace",60285),wholeWord:(0,l.$kk)("whole-word",60286),window:(0,l.$kk)("window",60287),wordWrap:(0,l.$kk)("word-wrap",60288),zoomIn:(0,l.$kk)("zoom-in",60289),zoomOut:(0,l.$kk)("zoom-out",60290),listFilter:(0,l.$kk)("list-filter",60291),listFlat:(0,l.$kk)("list-flat",60292),listSelection:(0,l.$kk)("list-selection",60293),selection:(0,l.$kk)("selection",60293),listTree:(0,l.$kk)("list-tree",60294),debugBreakpointFunctionUnverified:(0,l.$kk)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,l.$kk)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,l.$kk)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,l.$kk)("debug-stackframe-active",60297),circleSmallFilled:(0,l.$kk)("circle-small-filled",60298),debugStackframeDot:(0,l.$kk)("debug-stackframe-dot",60298),debugStackframe:(0,l.$kk)("debug-stackframe",60299),debugStackframeFocused:(0,l.$kk)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,l.$kk)("debug-breakpoint-unsupported",60300),symbolString:(0,l.$kk)("symbol-string",60301),debugReverseContinue:(0,l.$kk)("debug-reverse-continue",60302),debugStepBack:(0,l.$kk)("debug-step-back",60303),debugRestartFrame:(0,l.$kk)("debug-restart-frame",60304),callIncoming:(0,l.$kk)("call-incoming",60306),callOutgoing:(0,l.$kk)("call-outgoing",60307),menu:(0,l.$kk)("menu",60308),expandAll:(0,l.$kk)("expand-all",60309),feedback:(0,l.$kk)("feedback",60310),gitPullRequestReviewer:(0,l.$kk)("git-pull-request-reviewer",60310),groupByRefType:(0,l.$kk)("group-by-ref-type",60311),ungroupByRefType:(0,l.$kk)("ungroup-by-ref-type",60312),account:(0,l.$kk)("account",60313),gitPullRequestAssignee:(0,l.$kk)("git-pull-request-assignee",60313),bellDot:(0,l.$kk)("bell-dot",60314),debugConsole:(0,l.$kk)("debug-console",60315),library:(0,l.$kk)("library",60316),output:(0,l.$kk)("output",60317),runAll:(0,l.$kk)("run-all",60318),syncIgnored:(0,l.$kk)("sync-ignored",60319),pinned:(0,l.$kk)("pinned",60320),githubInverted:(0,l.$kk)("github-inverted",60321),debugAlt:(0,l.$kk)("debug-alt",60305),serverProcess:(0,l.$kk)("server-process",60322),serverEnvironment:(0,l.$kk)("server-environment",60323),pass:(0,l.$kk)("pass",60324),stopCircle:(0,l.$kk)("stop-circle",60325),playCircle:(0,l.$kk)("play-circle",60326),record:(0,l.$kk)("record",60327),debugAltSmall:(0,l.$kk)("debug-alt-small",60328),vmConnect:(0,l.$kk)("vm-connect",60329),cloud:(0,l.$kk)("cloud",60330),merge:(0,l.$kk)("merge",60331),exportIcon:(0,l.$kk)("export",60332),graphLeft:(0,l.$kk)("graph-left",60333),magnet:(0,l.$kk)("magnet",60334),notebook:(0,l.$kk)("notebook",60335),redo:(0,l.$kk)("redo",60336),checkAll:(0,l.$kk)("check-all",60337),pinnedDirty:(0,l.$kk)("pinned-dirty",60338),passFilled:(0,l.$kk)("pass-filled",60339),circleLargeFilled:(0,l.$kk)("circle-large-filled",60340),circleLarge:(0,l.$kk)("circle-large",60341),circleLargeOutline:(0,l.$kk)("circle-large-outline",60341),combine:(0,l.$kk)("combine",60342),gather:(0,l.$kk)("gather",60342),table:(0,l.$kk)("table",60343),variableGroup:(0,l.$kk)("variable-group",60344),typeHierarchy:(0,l.$kk)("type-hierarchy",60345),typeHierarchySub:(0,l.$kk)("type-hierarchy-sub",60346),typeHierarchySuper:(0,l.$kk)("type-hierarchy-super",60347),gitPullRequestCreate:(0,l.$kk)("git-pull-request-create",60348),runAbove:(0,l.$kk)("run-above",60349),runBelow:(0,l.$kk)("run-below",60350),notebookTemplate:(0,l.$kk)("notebook-template",60351),debugRerun:(0,l.$kk)("debug-rerun",60352),workspaceTrusted:(0,l.$kk)("workspace-trusted",60353),workspaceUntrusted:(0,l.$kk)("workspace-untrusted",60354),workspaceUnspecified:(0,l.$kk)("workspace-unspecified",60355),terminalCmd:(0,l.$kk)("terminal-cmd",60356),terminalDebian:(0,l.$kk)("terminal-debian",60357),terminalLinux:(0,l.$kk)("terminal-linux",60358),terminalPowershell:(0,l.$kk)("terminal-powershell",60359),terminalTmux:(0,l.$kk)("terminal-tmux",60360),terminalUbuntu:(0,l.$kk)("terminal-ubuntu",60361),terminalBash:(0,l.$kk)("terminal-bash",60362),arrowSwap:(0,l.$kk)("arrow-swap",60363),copy:(0,l.$kk)("copy",60364),personAdd:(0,l.$kk)("person-add",60365),filterFilled:(0,l.$kk)("filter-filled",60366),wand:(0,l.$kk)("wand",60367),debugLineByLine:(0,l.$kk)("debug-line-by-line",60368),inspect:(0,l.$kk)("inspect",60369),layers:(0,l.$kk)("layers",60370),layersDot:(0,l.$kk)("layers-dot",60371),layersActive:(0,l.$kk)("layers-active",60372),compass:(0,l.$kk)("compass",60373),compassDot:(0,l.$kk)("compass-dot",60374),compassActive:(0,l.$kk)("compass-active",60375),azure:(0,l.$kk)("azure",60376),issueDraft:(0,l.$kk)("issue-draft",60377),gitPullRequestClosed:(0,l.$kk)("git-pull-request-closed",60378),gitPullRequestDraft:(0,l.$kk)("git-pull-request-draft",60379),debugAll:(0,l.$kk)("debug-all",60380),debugCoverage:(0,l.$kk)("debug-coverage",60381),runErrors:(0,l.$kk)("run-errors",60382),folderLibrary:(0,l.$kk)("folder-library",60383),debugContinueSmall:(0,l.$kk)("debug-continue-small",60384),beakerStop:(0,l.$kk)("beaker-stop",60385),graphLine:(0,l.$kk)("graph-line",60386),graphScatter:(0,l.$kk)("graph-scatter",60387),pieChart:(0,l.$kk)("pie-chart",60388),bracketDot:(0,l.$kk)("bracket-dot",60389),bracketError:(0,l.$kk)("bracket-error",60390),lockSmall:(0,l.$kk)("lock-small",60391),azureDevops:(0,l.$kk)("azure-devops",60392),verifiedFilled:(0,l.$kk)("verified-filled",60393),newLine:(0,l.$kk)("newline",60394),layout:(0,l.$kk)("layout",60395),layoutActivitybarLeft:(0,l.$kk)("layout-activitybar-left",60396),layoutActivitybarRight:(0,l.$kk)("layout-activitybar-right",60397),layoutPanelLeft:(0,l.$kk)("layout-panel-left",60398),layoutPanelCenter:(0,l.$kk)("layout-panel-center",60399),layoutPanelJustify:(0,l.$kk)("layout-panel-justify",60400),layoutPanelRight:(0,l.$kk)("layout-panel-right",60401),layoutPanel:(0,l.$kk)("layout-panel",60402),layoutSidebarLeft:(0,l.$kk)("layout-sidebar-left",60403),layoutSidebarRight:(0,l.$kk)("layout-sidebar-right",60404),layoutStatusbar:(0,l.$kk)("layout-statusbar",60405),layoutMenubar:(0,l.$kk)("layout-menubar",60406),layoutCentered:(0,l.$kk)("layout-centered",60407),layoutSidebarRightOff:(0,l.$kk)("layout-sidebar-right-off",60416),layoutPanelOff:(0,l.$kk)("layout-panel-off",60417),layoutSidebarLeftOff:(0,l.$kk)("layout-sidebar-left-off",60418),target:(0,l.$kk)("target",60408),indent:(0,l.$kk)("indent",60409),recordSmall:(0,l.$kk)("record-small",60410),errorSmall:(0,l.$kk)("error-small",60411),arrowCircleDown:(0,l.$kk)("arrow-circle-down",60412),arrowCircleLeft:(0,l.$kk)("arrow-circle-left",60413),arrowCircleRight:(0,l.$kk)("arrow-circle-right",60414),arrowCircleUp:(0,l.$kk)("arrow-circle-up",60415),heartFilled:(0,l.$kk)("heart-filled",60420),map:(0,l.$kk)("map",60421),mapFilled:(0,l.$kk)("map-filled",60422),circleSmall:(0,l.$kk)("circle-small",60423),bellSlash:(0,l.$kk)("bell-slash",60424),bellSlashDot:(0,l.$kk)("bell-slash-dot",60425),commentUnresolved:(0,l.$kk)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,l.$kk)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,l.$kk)("git-pull-request-new-changes",60428),searchFuzzy:(0,l.$kk)("search-fuzzy",60429),commentDraft:(0,l.$kk)("comment-draft",60430),send:(0,l.$kk)("send",60431),sparkle:(0,l.$kk)("sparkle",60432),insert:(0,l.$kk)("insert",60433),mic:(0,l.$kk)("mic",60434),thumbsDownFilled:(0,l.$kk)("thumbsdown-filled",60435),thumbsUpFilled:(0,l.$kk)("thumbsup-filled",60436),coffee:(0,l.$kk)("coffee",60437),snake:(0,l.$kk)("snake",60438),game:(0,l.$kk)("game",60439),vr:(0,l.$kk)("vr",60440),chip:(0,l.$kk)("chip",60441),piano:(0,l.$kk)("piano",60442),music:(0,l.$kk)("music",60443),micFilled:(0,l.$kk)("mic-filled",60444),gitFetch:(0,l.$kk)("git-fetch",60445),copilot:(0,l.$kk)("copilot",60446),lightbulbSparkle:(0,l.$kk)("lightbulb-sparkle",60447),lightbulbSparkleAutofix:(0,l.$kk)("lightbulb-sparkle-autofix",60447),robot:(0,l.$kk)("robot",60448),sparkleFilled:(0,l.$kk)("sparkle-filled",60449),diffSingle:(0,l.$kk)("diff-single",60450),diffMultiple:(0,l.$kk)("diff-multiple",60451),surroundWith:(0,l.$kk)("surround-with",60452),gitStash:(0,l.$kk)("git-stash",60454),gitStashApply:(0,l.$kk)("git-stash-apply",60455),gitStashPop:(0,l.$kk)("git-stash-pop",60456),runAllCoverage:(0,l.$kk)("run-all-coverage",60461),runCoverage:(0,l.$kk)("run-all-coverage",60460),coverage:(0,l.$kk)("coverage",60462),githubProject:(0,l.$kk)("github-project",60463)}}),define(Se[77],De([1,0,99,168]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=void 0;function L(){return Object.values(e.$pk)}e.$nk=L,e.$ok={dialogError:(0,l.$kk)("dialog-error","error"),dialogWarning:(0,l.$kk)("dialog-warning","warning"),dialogInfo:(0,l.$kk)("dialog-info","info"),dialogClose:(0,l.$kk)("dialog-close","close"),treeItemExpanded:(0,l.$kk)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,l.$kk)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,l.$kk)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,l.$kk)("tree-filter-clear","close"),treeItemLoading:(0,l.$kk)("tree-item-loading","loading"),menuSelection:(0,l.$kk)("menu-selection","check"),menuSubmenu:(0,l.$kk)("menu-submenu","chevron-right"),menuBarMore:(0,l.$kk)("menubar-more","more"),scrollbarButtonLeft:(0,l.$kk)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,l.$kk)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,l.$kk)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,l.$kk)("scrollbar-button-down","triangle-down"),toolBarMore:(0,l.$kk)("toolbar-more","more"),quickInputBack:(0,l.$kk)("quick-input-back","arrow-left")},e.$pk={...N.$mk,...e.$ok}}),define(Se[24],De([1,0,18]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([n,r])=>{i[n]=r&&typeof r=="object"?N(r):r}),i}e.$Ln=N;function L(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const r in n)if(A.call(n,r)){const c=n[r];typeof c=="object"&&!Object.isFrozen(c)&&!(0,l.$Wf)(c)&&i.push(c)}}return o}e.$Mn=L;const A=Object.prototype.hasOwnProperty;function R(o,i){return w(o,i,new Set)}e.$Nn=R;function w(o,i,n){if((0,l.$3f)(o))return o;const r=i(o);if(typeof r<"u")return r;if(Array.isArray(o)){const c=[];for(const t of o)c.push(w(t,i,n));return c}if((0,l.$Vf)(o)){if(n.has(o))throw new Error("Cannot clone recursive data-structure");n.add(o);const c={};for(const t in o)A.call(o,t)&&(c[t]=w(o[t],i,n));return n.delete(o),c}return o}function p(o,i,n=!0){return(0,l.$Vf)(o)?((0,l.$Vf)(i)&&Object.keys(i).forEach(r=>{r in o?n&&((0,l.$Vf)(o[r])&&(0,l.$Vf)(i[r])?p(o[r],i[r],n):o[r]=i[r]):o[r]=i[r]}),o):i}e.$On=p;function E(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let n,r;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(n=0;n<o.length;n++)if(!E(o[n],i[n]))return!1}else{const c=[];for(r in o)c.push(r);c.sort();const t=[];for(r in i)t.push(r);if(t.sort(),!E(c,t))return!1;for(n=0;n<c.length;n++)if(!E(o[c[n]],i[c[n]]))return!1}return!0}e.$Pn=E;function M(o){const i=new Set;return JSON.stringify(o,(n,r)=>{if((0,l.$Vf)(r)||Array.isArray(r)){if(i.has(r))return"[Circular]";i.add(r)}return r})}e.$Qn=M;function C(o,i){const n=Object.create(null);return!o||!i||Object.keys(i).forEach(c=>{const t=o[c],f=i[c];E(t,f)||(n[c]=f)}),n}e.$Rn=C;function v(o,i){const n=i.toLowerCase(),r=Object.keys(o).find(c=>c.toLowerCase()===n);return r?o[r]:o[i]}e.$Sn=v;function S(o,i){const n=Object.create(null);for(const[r,c]of Object.entries(o))i(r,c)&&(n[r]=c);return n}e.$Tn=S;function y(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$Un=y;function u(o){const i=[];for(const n of y(o))typeof o[n]=="function"&&i.push(n);return i}e.$Vn=u;function m(o,i){const n=c=>function(){const t=Array.prototype.slice.call(arguments,0);return i(c,t)},r={};for(const c of o)r[c]=n(c);return r}e.$Wn=m}),define(Se[55],De([1,0,77]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$qk=e.ThemeColor=void 0;var N;(function(R){function w(p){return p&&typeof p=="object"&&typeof p.id=="string"}R.isThemeColor=w})(N||(e.ThemeColor=N={}));function L(R){return{id:R}}e.$qk=L;var A;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function p(i){const n=w.exec(i.id);if(!n)return p(l.$pk.error);const[,r,c]=n,t=["codicon","codicon-"+r];return c&&t.push("codicon-modifier-"+c.substring(1)),t}R.asClassNameArray=p;function E(i){return p(i).join(" ")}R.asClassName=E;function M(i){return"."+p(i).join(".")}R.asCSSSelector=M;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}R.isThemeIcon=C;const v=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(i){const n=v.exec(i);if(!n)return;const[,r]=n;return{id:r}}R.fromString=S;function y(i){return{id:i}}R.fromId=y;function u(i,n){let r=i.id;const c=r.lastIndexOf("~");return c!==-1&&(r=r.substring(0,c)),n&&(r=`${r}~${n}`),{id:r}}R.modify=u;function m(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}R.getModifier=m;function o(i,n){return i.id===n.id&&i.color?.id===n.color?.id}R.isEqual=o})(A||(e.ThemeIcon=A={}))}),define(Se[169],De([1,0,126,14,55]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=void 0;const A="$(",R=new RegExp(`\\$\\(${L.ThemeIcon.iconNameExpression}(?:${L.ThemeIcon.iconModifierExpression})?\\)`,"g"),w=new RegExp(`(\\\\)?${R.source}`,"g");function p(o){return o.replace(w,(i,n)=>n?i:`\\${i}`)}e.$rk=p;const E=new RegExp(`\\\\${R.source}`,"g");function M(o){return o.replace(E,i=>`\\${i}`)}e.$sk=M;const C=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function v(o){return o.indexOf(A)===-1?o:o.replace(C,(i,n,r,c)=>r?i:n||c||"")}e.$tk=v;function S(o){return o?o.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$uk=S;const y=new RegExp(`\\$\\(${L.ThemeIcon.iconNameCharacter}+\\)`,"g");function u(o){y.lastIndex=0;let i="";const n=[];let r=0;for(;;){const c=y.lastIndex,t=y.exec(o),f=o.substring(c,t?.index);if(f.length>0){i+=f;for(let h=0;h<f.length;h++)n.push(r)}if(!t)break;r+=t[0].length}return{text:i,iconOffsets:n}}e.$vk=u;function m(o,i,n=!1){const{text:r,iconOffsets:c}=i;if(!c||c.length===0)return(0,l.$bk)(o,r,n);const t=(0,N.$4e)(r," "),f=r.length-t.length,h=(0,l.$bk)(o,t,n);if(h)for(const s of h){const a=c[s.start+f]+f;s.start+=a,s.end+=a}return h}e.$wk=m}),define(Se[127],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Se=e.$Re=e.Constants=void 0;var l;(function(A){A[A.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",A[A.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",A[A.MAX_UINT_8=255]="MAX_UINT_8",A[A.MAX_UINT_16=65535]="MAX_UINT_16",A[A.MAX_UINT_32=4294967295]="MAX_UINT_32",A[A.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(l||(e.Constants=l={}));function N(A){return A<0?0:A>255?255:A|0}e.$Re=N;function L(A){return A<0?0:A>4294967295?4294967295:A|0}e.$Se=L}),define(Se[30],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cg=e.$Bg=void 0;const l=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return l.test(L)}e.$Bg=N,e.$Cg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(w){for(let p=0;p<w.length;p++)w[p]=Math.floor(Math.random()*256);return w};const A=new Uint8Array(16),R=[];for(let w=0;w<256;w++)R.push(w.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let p=0,E="";return E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E+="-",E+=R[A[p++]],E+=R[A[p++]],E+="-",E+=R[A[p++]],E+=R[A[p++]],E+="-",E+=R[A[p++]],E+=R[A[p++]],E+="-",E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E+=R[A[p++]],E}}()}),define(Se[170],De([1,0,19,48,30]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gt=e.$Ft=e.$Et=e.$Dt=e.$Ct=void 0;function A(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$Ct=A;function R(C,v,S){const y={id:(0,L.$Cg)(),name:C,uri:v,data:S};return{asString:async()=>"",asFile:()=>y,value:void 0}}e.$Dt=R;class w{constructor(){this.a=new Map}get size(){let v=0;for(const S of this.a)v++;return v}has(v){return this.a.has(this.b(v))}matches(v){const S=[...this.a.keys()];return N.Iterable.some(this,([y,u])=>u.asFile())&&S.push("files"),M(p(v),S)}get(v){return this.a.get(this.b(v))?.[0]}append(v,S){const y=this.a.get(v);y?y.push(S):this.a.set(this.b(v),[S])}replace(v,S){this.a.set(this.b(v),[S])}delete(v){this.a.delete(this.b(v))}*[Symbol.iterator](){for(const[v,S]of this.a)for(const y of S)yield[v,y]}b(v){return p(v)}}e.$Et=w;function p(C){return C.toLowerCase()}function E(C,v){return M(p(C),v.map(p))}e.$Ft=E;function M(C,v){if(C==="*/*")return v.length>0;if(v.includes(C))return!0;const S=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[y,u,m]=S;return m==="*"?v.some(o=>o.startsWith(u+"/")):!1}e.$Gt=Object.freeze({create:C=>(0,l.$Mb)(C.map(v=>v.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$Gt.split(C).filter(v=>!v.startsWith("#"))})}),define(Se[171],De([1,0,62]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gg=e.$Fg=e.$Eg=void 0;function N(w,p,E,M=1){let C=!1;return new Promise(v=>{const S=setTimeout(()=>{if(!C)return C=!0,v(0)},E);L(w,p,M,y=>{if(!C)return C=!0,clearTimeout(S),v(y)})})}e.$Eg=N;function L(w,p,E,M){if(p===0)return M(0);const C=new l.Socket;C.once("connect",()=>(R(C),L(w+E,p-1,E,M))),C.once("data",()=>{}),C.once("error",v=>(R(C),v.code!=="ECONNREFUSED"?L(w+E,p-1,E,M):M(w))),C.connect(w,"127.0.0.1")}e.$Fg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(w,p,E,M="127.0.0.1"){let C=!1,v,S=1;const y=l.createServer({pauseOnConnect:!0});function u(m,o){C||(C=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),o(m))}return new Promise(m=>{v=setTimeout(()=>{u(0,m)},E),y.on("listening",()=>{u(w,m)}),y.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&S<p?(w++,S++,y.listen(w,M)):u(0,m)}),y.on("close",()=>{u(0,m)}),y.listen(w,M)})}e.$Gg=A;function R(w){try{w.removeAllListeners("connect"),w.removeAllListeners("error"),w.end(),w.destroy(),w.unref()}catch(p){console.error(p)}}}),define(Se[128],De([1,0,127]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=e.$ut=void 0;class N{constructor(w){const p=(0,l.$Re)(w);this.c=p,this.a=N.d(p),this.b=new Map}static d(w){const p=new Uint8Array(256);return p.fill(w),p}set(w,p){const E=(0,l.$Re)(p);w>=0&&w<256?this.a[w]=E:this.b.set(w,E)}get(w){return w>=0&&w<256?this.a[w]:this.b.get(w)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ut=N;var L;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(L||(L={}));class A{constructor(){this.a=new N(0)}add(w){this.a.set(w,1)}has(w){return this.a.get(w)===1}clear(){return this.a.clear()}}e.$vt=A}),define(Se[172],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jt=e.StringEOL=void 0;var l;(function(L){L[L.Unknown=0]="Unknown",L[L.Invalid=3]="Invalid",L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(l||(e.StringEOL=l={}));function N(L){let A=0,R=0,w=0,p=0;for(let E=0,M=L.length;E<M;E++){const C=L.charCodeAt(E);C===13?(A===0&&(R=E),A++,E+1<M&&L.charCodeAt(E+1)===10?(p|=2,E++):p|=3,w=E+1):C===10&&(p|=1,A===0&&(R=E),A++,w=E+1)}return A===0&&(R=L.length),[A,R,L.length-w,p]}e.$Jt=N}),define(Se[49],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0;class l{constructor(L,A){this.lineNumber=L,this.column=A}with(L=this.lineNumber,A=this.column){return L===this.lineNumber&&A===this.column?this:new l(L,A)}delta(L=0,A=0){return this.with(this.lineNumber+L,this.column+A)}equals(L){return l.equals(this,L)}static equals(L,A){return!L&&!A?!0:!!L&&!!A&&L.lineNumber===A.lineNumber&&L.column===A.column}isBefore(L){return l.isBefore(this,L)}static isBefore(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<A.column}isBeforeOrEqual(L){return l.isBeforeOrEqual(this,L)}static isBeforeOrEqual(L,A){return L.lineNumber<A.lineNumber?!0:A.lineNumber<L.lineNumber?!1:L.column<=A.column}static compare(L,A){const R=L.lineNumber|0,w=A.lineNumber|0;if(R===w){const p=L.column|0,E=A.column|0;return p-E}return R-w}clone(){return new l(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(L){return new l(L.lineNumber,L.column)}static isIPosition(L){return L&&typeof L.lineNumber=="number"&&typeof L.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$9s=l}),define(Se[29],De([1,0,49]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0;class N{constructor(A,R,w,p){A>w||A===w&&R>p?(this.startLineNumber=w,this.startColumn=p,this.endLineNumber=A,this.endColumn=R):(this.startLineNumber=A,this.startColumn=R,this.endLineNumber=w,this.endColumn=p)}isEmpty(){return N.isEmpty(this)}static isEmpty(A){return A.startLineNumber===A.endLineNumber&&A.startColumn===A.endColumn}containsPosition(A){return N.containsPosition(this,A)}static containsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<A.startColumn||R.lineNumber===A.endLineNumber&&R.column>A.endColumn)}static strictContainsPosition(A,R){return!(R.lineNumber<A.startLineNumber||R.lineNumber>A.endLineNumber||R.lineNumber===A.startLineNumber&&R.column<=A.startColumn||R.lineNumber===A.endLineNumber&&R.column>=A.endColumn)}containsRange(A){return N.containsRange(this,A)}static containsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>A.endColumn)}strictContainsRange(A){return N.strictContainsRange(this,A)}static strictContainsRange(A,R){return!(R.startLineNumber<A.startLineNumber||R.endLineNumber<A.startLineNumber||R.startLineNumber>A.endLineNumber||R.endLineNumber>A.endLineNumber||R.startLineNumber===A.startLineNumber&&R.startColumn<=A.startColumn||R.endLineNumber===A.endLineNumber&&R.endColumn>=A.endColumn)}plusRange(A){return N.plusRange(this,A)}static plusRange(A,R){let w,p,E,M;return R.startLineNumber<A.startLineNumber?(w=R.startLineNumber,p=R.startColumn):R.startLineNumber===A.startLineNumber?(w=R.startLineNumber,p=Math.min(R.startColumn,A.startColumn)):(w=A.startLineNumber,p=A.startColumn),R.endLineNumber>A.endLineNumber?(E=R.endLineNumber,M=R.endColumn):R.endLineNumber===A.endLineNumber?(E=R.endLineNumber,M=Math.max(R.endColumn,A.endColumn)):(E=A.endLineNumber,M=A.endColumn),new N(w,p,E,M)}intersectRanges(A){return N.intersectRanges(this,A)}static intersectRanges(A,R){let w=A.startLineNumber,p=A.startColumn,E=A.endLineNumber,M=A.endColumn;const C=R.startLineNumber,v=R.startColumn,S=R.endLineNumber,y=R.endColumn;return w<C?(w=C,p=v):w===C&&(p=Math.max(p,v)),E>S?(E=S,M=y):E===S&&(M=Math.min(M,y)),w>E||w===E&&p>M?null:new N(w,p,E,M)}equalsRange(A){return N.equalsRange(this,A)}static equalsRange(A,R){return!A&&!R?!0:!!A&&!!R&&A.startLineNumber===R.startLineNumber&&A.startColumn===R.startColumn&&A.endLineNumber===R.endLineNumber&&A.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(A){return new l.$9s(A.endLineNumber,A.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(A){return new l.$9s(A.startLineNumber,A.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(A,R){return new N(this.startLineNumber,this.startColumn,A,R)}setStartPosition(A,R){return new N(A,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(A){return new N(A.startLineNumber,A.startColumn,A.startLineNumber,A.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(A){return new N(A.endLineNumber,A.endColumn,A.endLineNumber,A.endColumn)}delta(A){return new N(this.startLineNumber+A,this.startColumn,this.endLineNumber+A,this.endColumn)}static fromPositions(A,R=A){return new N(A.lineNumber,A.column,R.lineNumber,R.column)}static lift(A){return A?new N(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):null}static isIRange(A){return A&&typeof A.startLineNumber=="number"&&typeof A.startColumn=="number"&&typeof A.endLineNumber=="number"&&typeof A.endColumn=="number"}static areIntersectingOrTouching(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<A.startColumn)}static areIntersecting(A,R){return!(A.endLineNumber<R.startLineNumber||A.endLineNumber===R.startLineNumber&&A.endColumn<=R.startColumn||R.endLineNumber<A.startLineNumber||R.endLineNumber===A.startLineNumber&&R.endColumn<=A.startColumn)}static compareRangesUsingStarts(A,R){if(A&&R){const E=A.startLineNumber|0,M=R.startLineNumber|0;if(E===M){const C=A.startColumn|0,v=R.startColumn|0;if(C===v){const S=A.endLineNumber|0,y=R.endLineNumber|0;if(S===y){const u=A.endColumn|0,m=R.endColumn|0;return u-m}return S-y}return C-v}return E-M}return(A?1:0)-(R?1:0)}static compareRangesUsingEnds(A,R){return A.endLineNumber===R.endLineNumber?A.endColumn===R.endColumn?A.startLineNumber===R.startLineNumber?A.startColumn-R.startColumn:A.startLineNumber-R.startLineNumber:A.endColumn-R.endColumn:A.endLineNumber-R.endLineNumber}static spansMultipleLines(A){return A.endLineNumber>A.startLineNumber}toJSON(){return this}}e.$0s=N}),define(Se[173],De([1,0,29]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$s=void 0;class N{static insert(A,R){return{range:new l.$0s(A.lineNumber,A.column,A.lineNumber,A.column),text:R,forceMoveMarkers:!0}}static delete(A){return{range:A,text:null}}static replace(A,R){return{range:A,text:R}}static replaceMove(A,R){return{range:A,text:R,forceMoveMarkers:!0}}}e.$$s=N}),define(Se[174],De([1,0,49,29]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_s=e.SelectionDirection=void 0;var L;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(L||(e.SelectionDirection=L={}));class A extends N.$0s{constructor(w,p,E,M){super(w,p,E,M),this.selectionStartLineNumber=w,this.selectionStartColumn=p,this.positionLineNumber=E,this.positionColumn=M}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(w){return A.selectionsEqual(this,w)}static selectionsEqual(w,p){return w.selectionStartLineNumber===p.selectionStartLineNumber&&w.selectionStartColumn===p.selectionStartColumn&&w.positionLineNumber===p.positionLineNumber&&w.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(w,p){return this.getDirection()===0?new A(this.startLineNumber,this.startColumn,w,p):new A(w,p,this.startLineNumber,this.startColumn)}getPosition(){return new l.$9s(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new l.$9s(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(w,p){return this.getDirection()===0?new A(w,p,this.endLineNumber,this.endColumn):new A(this.endLineNumber,this.endColumn,w,p)}static fromPositions(w,p=w){return new A(w.lineNumber,w.column,p.lineNumber,p.column)}static fromRange(w,p){return p===0?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):new A(w.endLineNumber,w.endColumn,w.startLineNumber,w.startColumn)}static liftSelection(w){return new A(w.selectionStartLineNumber,w.selectionStartColumn,w.positionLineNumber,w.positionColumn)}static selectionsArrEqual(w,p){if(w&&!p||!w&&p)return!1;if(!w&&!p)return!0;if(w.length!==p.length)return!1;for(let E=0,M=w.length;E<M;E++)if(!this.selectionsEqual(w[E],p[E]))return!1;return!0}static isISelection(w){return w&&typeof w.selectionStartLineNumber=="number"&&typeof w.selectionStartColumn=="number"&&typeof w.positionLineNumber=="number"&&typeof w.positionColumn=="number"}static createWithDirection(w,p,E,M,C){return C===0?new A(w,p,E,M):new A(E,M,w,p)}}e.$_s=A}),define(Se[175],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Hs={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[176],De([1,0,128]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xt=e.$wt=e.WordCharacterClass=void 0;var N;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class L extends l.$ut{constructor(w){super(0);for(let p=0,E=w.length;p<E;p++)this.set(w.charCodeAt(p),2);this.set(32,1),this.set(9,1)}}e.$wt=L;function A(R){const w={};return p=>(w.hasOwnProperty(p)||(w[p]=R(p)),w[p])}e.$xt=A(R=>new L(R))}),define(Se[129],De([1,0,48,3,74]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=e.$Ls=e.$Ks=e.$Js=e.$Is=void 0,e.$Is="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function A(C=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Is)C.indexOf(S)>=0||(v+="\\"+S);return v+="\\s]+)",new RegExp(v,"g")}e.$Js=A();function R(C){let v=e.$Js;if(C&&C instanceof RegExp)if(C.global)v=C;else{let S="g";C.ignoreCase&&(S+="i"),C.multiline&&(S+="m"),C.unicode&&(S+="u"),v=new RegExp(C.source,S)}return v.lastIndex=0,v}e.$Ks=R;const w=new L.$4c;w.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(C){const v=w.unshift(C);return(0,N.$Rc)(v)}e.$Ls=p;function E(C,v,S,y,u){if(v=R(v),u||(u=l.Iterable.first(w)),S.length>u.maxLen){let r=C-u.maxLen/2;return r<0?r=0:y+=r,S=S.substring(r,C+u.maxLen/2),E(C,v,S,y,u)}const m=Date.now(),o=C-1-y;let i=-1,n=null;for(let r=1;!(Date.now()-m>=u.timeBudget);r++){const c=o-u.windowSize*r;v.lastIndex=Math.max(0,c);const t=M(v,S,o,i);if(!t&&n||(n=t,c<=0))break;i=c}if(n){const r={word:n[0],startColumn:y+1+n.index,endColumn:y+1+n.index+n[0].length};return v.lastIndex=0,r}return null}e.$Ms=E;function M(C,v,S,y){let u;for(;u=C.exec(v);){const m=u.index||0;if(m<=S&&C.lastIndex>=S)return u;if(y>0&&m>y)return null}return null}}),define(Se[177],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9t=e.$8t=e.IndentAction=void 0;var l;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(l||(e.IndentAction=l={}));class N{constructor(w){if(this.e=null,this.f=!1,this.open=w.open,this.close=w.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(w.notIn))for(let p=0,E=w.notIn.length;p<E;p++)switch(w.notIn[p]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(w){switch(w){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(w,p){if(w.getTokenCount()===0)return!0;const E=w.findTokenIndexAtOffset(p-2),M=w.getStandardTokenType(E);return this.isOK(M)}g(w,p){for(let E=w;E<=p;E++){const M=String.fromCharCode(E);if(!this.open.includes(M)&&!this.close.includes(M))return M}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$8t=N;class L{constructor(w){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const p of w)A(this.autoClosingPairsOpenByStart,p.open.charAt(0),p),A(this.autoClosingPairsOpenByEnd,p.open.charAt(p.open.length-1),p),A(this.autoClosingPairsCloseByStart,p.close.charAt(0),p),A(this.autoClosingPairsCloseByEnd,p.close.charAt(p.close.length-1),p),p.close.length===1&&p.open.length===1&&A(this.autoClosingPairsCloseSingleChar,p.close,p)}}e.$9t=L;function A(R,w,p){R.has(w)?R.get(w).push(p):R.set(w,[p])}}),define(Se[178],De([1,0,128]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c2=e.$b2=e.$a2=e.State=void 0;var N;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class L{constructor(y,u,m){const o=new Uint8Array(y*u);for(let i=0,n=y*u;i<n;i++)o[i]=m;this.a=o,this.rows=y,this.cols=u}get(y,u){return this.a[y*this.cols+u]}set(y,u,m){this.a[y*this.cols+u]=m}}class A{constructor(y){let u=0,m=0;for(let i=0,n=y.length;i<n;i++){const[r,c,t]=y[i];c>u&&(u=c),r>m&&(m=r),t>m&&(m=t)}u++,m++;const o=new L(m,u,0);for(let i=0,n=y.length;i<n;i++){const[r,c,t]=y[i];o.set(r,c,t)}this.a=o,this.b=u}nextState(y,u){return u<0||u>=this.b?0:this.a.get(y,u)}}e.$a2=A;let R=null;function w(){return R===null&&(R=new A([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var p;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(p||(p={}));let E=null;function M(){if(E===null){E=new l.$ut(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let u=0;u<S.length;u++)E.set(S.charCodeAt(u),1);const y=".,;:";for(let u=0;u<y.length;u++)E.set(y.charCodeAt(u),2)}return E}class C{static a(y,u,m,o,i){let n=i-1;do{const r=u.charCodeAt(n);if(y.get(r)!==2)break;n--}while(n>o);if(o>0){const r=u.charCodeAt(o-1),c=u.charCodeAt(n);(r===40&&c===41||r===91&&c===93||r===123&&c===125)&&n--}return{range:{startLineNumber:m,startColumn:o+1,endLineNumber:m,endColumn:n+2},url:u.substring(o,n+1)}}static computeLinks(y,u=w()){const m=M(),o=[];for(let i=1,n=y.getLineCount();i<=n;i++){const r=y.getLineContent(i),c=r.length;let t=0,f=0,h=0,s=1,a=!1,d=!1,$=!1,D=!1;for(;t<c;){let b=!1;const g=r.charCodeAt(t);if(s===13){let k;switch(g){case 40:a=!0,k=0;break;case 41:k=a?0:1;break;case 91:$=!0,d=!0,k=0;break;case 93:$=!1,k=d?0:1;break;case 123:D=!0,k=0;break;case 125:k=D?0:1;break;case 39:case 34:case 96:h===g?k=1:h===39||h===34||h===96?k=0:k=1;break;case 42:k=h===42?1:0;break;case 124:k=h===124?1:0;break;case 32:k=$?0:1;break;default:k=m.get(g)}k===1&&(o.push(C.a(m,r,i,f,t)),b=!0)}else if(s===12){let k;g===91?(d=!0,k=0):k=m.get(g),k===1?b=!0:s=13}else s=u.nextState(s,g),s===0&&(b=!0);b&&(s=1,a=!1,d=!1,D=!1,f=t+1,h=g),t++}s===13&&o.push(C.a(m,r,i,f,c))}return o}}e.$b2=C;function v(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:C.computeLinks(S)}e.$c2=v}),define(Se[78],De([1,0,24]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.$tv=e.$sv=e.ModelConstants=e.PositionAffinity=e.$rv=e.TrackedRangeStickiness=e.$qv=e.$pv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var L;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(L||(e.GlyphMarginLane=L={}));var A;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(A||(e.MinimapPosition=A={}));var R;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var w;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(w||(e.EndOfLinePreference=w={}));var p;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(p||(e.DefaultEndOfLine=p={}));var E;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class M{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(c){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,c.tabSize|0),c.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,c.indentSize|0),this.a=!1),this.insertSpaces=!!c.insertSpaces,this.defaultEOL=c.defaultEOL|0,this.trimAutoWhitespace=!!c.trimAutoWhitespace,this.bracketPairColorizationOptions=c.bracketPairColorizationOptions}equals(c){return this.tabSize===c.tabSize&&this.a===c.a&&this.indentSize===c.indentSize&&this.insertSpaces===c.insertSpaces&&this.defaultEOL===c.defaultEOL&&this.trimAutoWhitespace===c.trimAutoWhitespace&&(0,l.$Pn)(this.bracketPairColorizationOptions,c.bracketPairColorizationOptions)}createChangeEvent(c){return{tabSize:this.tabSize!==c.tabSize,indentSize:this.indentSize!==c.indentSize,insertSpaces:this.insertSpaces!==c.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==c.trimAutoWhitespace}}}e.$pv=M;class C{constructor(c,t){this._findMatchBrand=void 0,this.range=c,this.matches=t}}e.$qv=C;var v;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(v||(e.TrackedRangeStickiness=v={}));function S(r){return r&&typeof r.read=="function"}e.$rv=S;var y;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(y||(e.PositionAffinity=y={}));var u;(function(r){r[r.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(u||(e.ModelConstants=u={}));class m{constructor(c,t,f,h,s,a){this.identifier=c,this.range=t,this.text=f,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=s,this._isTracked=a}}e.$sv=m;class o{constructor(c,t,f){this.regex=c,this.wordSeparators=t,this.simpleSearch=f}}e.$tv=o;class i{constructor(c,t,f){this.reverseEdits=c,this.changes=t,this.trimAutoWhitespaceLineNumbers=f}}e.$uv=i;function n(r){return!r.isTooLargeForSyncing()&&!r.isForSimpleWidget}e.$vv=n}),define(Se[179],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=e.$0B=e.NodeColor=e.$9B=void 0;class l{constructor(m,o){this.piece=m,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$0B)return L(this.right);let m=this;for(;m.parent!==e.$0B&&m.parent.left!==m;)m=m.parent;return m.parent===e.$0B?e.$0B:m.parent}prev(){if(this.left!==e.$0B)return A(this.left);let m=this;for(;m.parent!==e.$0B&&m.parent.right!==m;)m=m.parent;return m.parent===e.$0B?e.$0B:m.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$9B=l;var N;(function(u){u[u.Black=0]="Black",u[u.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$0B=new l(null,0),e.$0B.parent=e.$0B,e.$0B.left=e.$0B,e.$0B.right=e.$0B,e.$0B.color=0;function L(u){for(;u.left!==e.$0B;)u=u.left;return u}e.$$B=L;function A(u){for(;u.right!==e.$0B;)u=u.right;return u}e.$_B=A;function R(u){return u===e.$0B?0:u.size_left+u.piece.length+R(u.right)}function w(u){return u===e.$0B?0:u.lf_left+u.piece.lineFeedCnt+w(u.right)}function p(){e.$0B.parent=e.$0B}function E(u,m){const o=m.right;o.size_left+=m.size_left+(m.piece?m.piece.length:0),o.lf_left+=m.lf_left+(m.piece?m.piece.lineFeedCnt:0),m.right=o.left,o.left!==e.$0B&&(o.left.parent=m),o.parent=m.parent,m.parent===e.$0B?u.root=o:m.parent.left===m?m.parent.left=o:m.parent.right=o,o.left=m,m.parent=o}e.$aC=E;function M(u,m){const o=m.left;m.left=o.right,o.right!==e.$0B&&(o.right.parent=m),o.parent=m.parent,m.size_left-=o.size_left+(o.piece?o.piece.length:0),m.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),m.parent===e.$0B?u.root=o:m===m.parent.right?m.parent.right=o:m.parent.left=o,o.right=m,m.parent=o}e.$bC=M;function C(u,m){let o,i;if(m.left===e.$0B?(i=m,o=i.right):m.right===e.$0B?(i=m,o=i.left):(i=L(m.right),o=i.right),i===u.root){u.root=o,o.color=0,m.detach(),p(),u.root.parent=e.$0B;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===m?(o.parent=i.parent,y(u,o)):(i.parent===m?o.parent=i:o.parent=i.parent,y(u,o),i.left=m.left,i.right=m.right,i.parent=m.parent,i.color=m.color,m===u.root?u.root=i:m===m.parent.left?m.parent.left=i:m.parent.right=i,i.left!==e.$0B&&(i.left.parent=i),i.right!==e.$0B&&(i.right.parent=i),i.size_left=m.size_left,i.lf_left=m.lf_left,y(u,i)),m.detach(),o.parent.left===o){const c=R(o),t=w(o);if(c!==o.parent.size_left||t!==o.parent.lf_left){const f=c-o.parent.size_left,h=t-o.parent.lf_left;o.parent.size_left=c,o.parent.lf_left=t,S(u,o.parent,f,h)}}if(y(u,o.parent),n){p();return}let r;for(;o!==u.root&&o.color===0;)o===o.parent.left?(r=o.parent.right,r.color===1&&(r.color=0,o.parent.color=1,E(u,o.parent),r=o.parent.right),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.right.color===0&&(r.left.color=0,r.color=1,M(u,r),r=o.parent.right),r.color=o.parent.color,o.parent.color=0,r.right.color=0,E(u,o.parent),o=u.root)):(r=o.parent.left,r.color===1&&(r.color=0,o.parent.color=1,M(u,o.parent),r=o.parent.left),r.left.color===0&&r.right.color===0?(r.color=1,o=o.parent):(r.left.color===0&&(r.right.color=0,r.color=1,E(u,r),r=o.parent.left),r.color=o.parent.color,o.parent.color=0,r.left.color=0,M(u,o.parent),o=u.root));o.color=0,p()}e.$cC=C;function v(u,m){for(y(u,m);m!==u.root&&m.parent.color===1;)if(m.parent===m.parent.parent.left){const o=m.parent.parent.right;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.right&&(m=m.parent,E(u,m)),m.parent.color=0,m.parent.parent.color=1,M(u,m.parent.parent))}else{const o=m.parent.parent.left;o.color===1?(m.parent.color=0,o.color=0,m.parent.parent.color=1,m=m.parent.parent):(m===m.parent.left&&(m=m.parent,M(u,m)),m.parent.color=0,m.parent.parent.color=1,E(u,m.parent.parent))}u.root.color=0}e.$dC=v;function S(u,m,o,i){for(;m!==u.root&&m!==e.$0B;)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}e.$eC=S;function y(u,m){let o=0,i=0;if(m!==u.root){for(;m!==u.root&&m===m.parent.right;)m=m.parent;if(m!==u.root)for(m=m.parent,o=R(m.left)-m.size_left,i=w(m.left)-m.lf_left,m.size_left+=o,m.lf_left+=i;m!==u.root&&(o!==0||i!==0);)m.parent.left===m&&(m.parent.size_left+=o,m.parent.lf_left+=i),m=m.parent}}e.$fC=y}),define(Se[180],De([1,0,19,127]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Av=e.$zv=e.$yv=void 0;class L{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,E){p=(0,N.$Se)(p);const M=this.a,C=this.b,v=E.length;return v===0?!1:(this.a=new Uint32Array(M.length+v),this.a.set(M.subarray(0,p),0),this.a.set(M.subarray(p),p+v),this.a.set(E,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue(p,E){return p=(0,N.$Se)(p),E=(0,N.$Se)(E),this.a[p]===E?!1:(this.a[p]=E,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,E){p=(0,N.$Se)(p),E=(0,N.$Se)(E);const M=this.a,C=this.b;if(p>=M.length)return!1;const v=M.length-p;return E>=v&&(E=v),E===0?!1:(this.a=new Uint32Array(M.length-E),this.a.set(M.subarray(0,p),0),this.a.set(M.subarray(p+E),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,N.$Se)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let E=this.c[0]+1;E===0&&(this.b[0]=this.a[0],E++),p>=this.a.length&&(p=this.a.length-1);for(let M=E;M<=p;M++)this.b[M]=this.b[M-1]+this.a[M];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let E=0,M=this.a.length-1,C=0,v=0,S=0;for(;E<=M;)if(C=E+(M-E)/2|0,v=this.b[C],S=v-this.a[C],p<S)M=C-1;else if(p>=v)E=C+1;else break;return new R(C,p-S)}}e.$yv=L;class A{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const E=this.e[p],M=E>0?this.d[E-1]:0;return new R(E,p-M)}removeValues(p,E){this.a.splice(p,E),this.f(p)}insertValues(p,E){this.a=(0,l.$Wb)(this.a,p,E),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,E=this.a.length;p<E;p++){const M=this.a[p],C=p>0?this.d[p-1]:0;this.d[p]=C+M;for(let v=0;v<M;v++)this.e[C+v]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,E){this.a[p]!==E&&(this.a[p]=E,this.f(p))}}e.$zv=A;class R{constructor(p,E){this.index=p,this.remainder=E,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=E}}e.$Av=R}),define(Se[181],De([1,0,14,49,180]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=void 0;class A{constructor(w,p,E,M){this.d=w,this.f=p,this.g=E,this.h=M,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(w){w.eol&&w.eol!==this.g&&(this.g=w.eol,this.j=null);const p=w.changes;for(const E of p)this.o(E.range),this.p(new N.$9s(E.range.startLineNumber,E.range.startColumn),E.text);this.h=w.versionId,this.k=null}l(){if(!this.j){const w=this.g.length,p=this.f.length,E=new Uint32Array(p);for(let M=0;M<p;M++)E[M]=this.f[M].length+w;this.j=new L.$yv(E)}}n(w,p){this.f[w]=p,this.j&&this.j.setValue(w,this.f[w].length+this.g.length)}o(w){if(w.startLineNumber===w.endLineNumber){if(w.startColumn===w.endColumn)return;this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.startLineNumber-1].substring(w.endColumn-1));return}this.n(w.startLineNumber-1,this.f[w.startLineNumber-1].substring(0,w.startColumn-1)+this.f[w.endLineNumber-1].substring(w.endColumn-1)),this.f.splice(w.startLineNumber,w.endLineNumber-w.startLineNumber),this.j&&this.j.removeValues(w.startLineNumber,w.endLineNumber-w.startLineNumber)}p(w,p){if(p.length===0)return;const E=(0,l.$0e)(p);if(E.length===1){this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+E[0]+this.f[w.lineNumber-1].substring(w.column-1));return}E[E.length-1]+=this.f[w.lineNumber-1].substring(w.column-1),this.n(w.lineNumber-1,this.f[w.lineNumber-1].substring(0,w.column-1)+E[0]);const M=new Uint32Array(E.length-1);for(let C=1;C<E.length;C++)this.f.splice(w.lineNumber+C-1,0,E[C]),M[C-1]=E[C].length+this.g.length;this.j&&this.j.insertValues(w.lineNumber,M)}}e.$Bv=A}),define(Se[100],De([1,0,14,176,49,29,78]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=e.$gC=void 0;const w=999;class p{constructor(i,n,r,c){this.searchString=i,this.isRegex=n,this.matchCase=r,this.wordSeparators=c}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=E(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=l.$8e(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let r=!this.isRegex&&!i;return r&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(r=this.matchCase),new R.$tv(n,this.wordSeparators?(0,N.$xt)(this.wordSeparators):null,r?this.searchString:null)}}e.$gC=p;function E(o){if(!o||o.length===0)return!1;for(let i=0,n=o.length;i<n;i++){const r=o.charCodeAt(i);if(r===10)return!0;if(r===92){if(i++,i>=n)break;const c=o.charCodeAt(i);if(c===110||c===114||c===87)return!0}}return!1}e.$hC=E;function M(o,i,n){if(!n)return new R.$qv(o,null);const r=[];for(let c=0,t=i.length;c<t;c++)r[c]=i[c];return new R.$qv(o,r)}e.$iC=M;class C{constructor(i){const n=[];let r=0;for(let c=0,t=i.length;c<t;c++)i.charCodeAt(c)===10&&(n[r++]=c);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let r=0,c=n.length-1;if(c===-1||i<=n[0])return 0;for(;r<c;){const t=r+((c-r)/2>>0);n[t]>=i?c=t-1:n[t+1]>=i?(r=t,c=t):r=t+1}return r+1}}class v{static findMatches(i,n,r,c,t){const f=n.parseSearchRequest();return f?f.regex.multiline?this.b(i,r,new m(f.wordSeparators,f.regex),c,t):this.c(i,r,f,c,t):[]}static a(i,n,r,c,t,f){let h,s=0;c?(s=c.findLineFeedCountBeforeOffset(t),h=n+t+s):h=n+t;let a;if(c){const b=c.findLineFeedCountBeforeOffset(t+f.length)-s;a=h+f.length+b}else a=h+f.length;const d=i.getPositionAt(h),$=i.getPositionAt(a);return new A.$0s(d.lineNumber,d.column,$.lineNumber,$.column)}static b(i,n,r,c,t){const f=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),s=i.getEOL()===`\r
`?new C(h):null,a=[];let d=0,$;for(r.reset(0);$=r.next(h);)if(a[d++]=M(this.a(i,f,h,s,$.index,$[0]),$,c),d>=t)return a;return a}static c(i,n,r,c,t){const f=[];let h=0;if(n.startLineNumber===n.endLineNumber){const a=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this.d(r,a,n.startLineNumber,n.startColumn-1,h,f,c,t),f}const s=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this.d(r,s,n.startLineNumber,n.startColumn-1,h,f,c,t);for(let a=n.startLineNumber+1;a<n.endLineNumber&&h<t;a++)h=this.d(r,i.getLineContent(a),a,0,h,f,c,t);if(h<t){const a=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this.d(r,a,n.endLineNumber,0,h,f,c,t)}return f}static d(i,n,r,c,t,f,h,s){const a=i.wordSeparators;if(!h&&i.simpleSearch){const D=i.simpleSearch,b=D.length,g=n.length;let k=-b;for(;(k=n.indexOf(D,k+b))!==-1;)if((!a||u(a,n,g,k,b))&&(f[t++]=new R.$qv(new A.$0s(r,k+1+c,r,k+1+b+c),null),t>=s))return t;return t}const d=new m(i.wordSeparators,i.regex);let $;d.reset(0);do if($=d.next(n),$&&(f[t++]=M(new A.$0s(r,$.index+1+c,r,$.index+1+$[0].length+c),$,h),t>=s))return t;while($);return t}static findNextMatch(i,n,r,c){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,r,f,c):this.f(i,r,f,c)}static e(i,n,r,c){const t=new L.$9s(n.lineNumber,1),f=i.getOffsetAt(t),h=i.getLineCount(),s=i.getValueInRange(new A.$0s(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),a=i.getEOL()===`\r
`?new C(s):null;r.reset(n.column-1);const d=r.next(s);return d?M(this.a(i,f,s,a,d.index,d[0]),d,c):n.lineNumber!==1||n.column!==1?this.e(i,new L.$9s(1,1),r,c):null}static f(i,n,r,c){const t=i.getLineCount(),f=n.lineNumber,h=i.getLineContent(f),s=this.g(r,h,f,n.column,c);if(s)return s;for(let a=1;a<=t;a++){const d=(f+a-1)%t,$=i.getLineContent(d+1),D=this.g(r,$,d+1,1,c);if(D)return D}return null}static g(i,n,r,c,t){i.reset(c-1);const f=i.next(n);return f?M(new A.$0s(r,f.index+1,r,f.index+1+f[0].length),f,t):null}static findPreviousMatch(i,n,r,c){const t=n.parseSearchRequest();if(!t)return null;const f=new m(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,r,f,c):this.j(i,r,f,c)}static h(i,n,r,c){const t=this.b(i,new A.$0s(1,1,n.lineNumber,n.column),r,c,10*w);if(t.length>0)return t[t.length-1];const f=i.getLineCount();return n.lineNumber!==f||n.column!==i.getLineMaxColumn(f)?this.h(i,new L.$9s(f,i.getLineMaxColumn(f)),r,c):null}static j(i,n,r,c){const t=i.getLineCount(),f=n.lineNumber,h=i.getLineContent(f).substring(0,n.column-1),s=this.k(r,h,f,c);if(s)return s;for(let a=1;a<=t;a++){const d=(t+f-a-1)%t,$=i.getLineContent(d+1),D=this.k(r,$,d+1,c);if(D)return D}return null}static k(i,n,r,c){let t=null,f;for(i.reset(0);f=i.next(n);)t=M(new A.$0s(r,f.index+1,r,f.index+1+f[0].length),f,c);return t}}e.$jC=v;function S(o,i,n,r,c){if(r===0)return!0;const t=i.charCodeAt(r-1);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const f=i.charCodeAt(r);if(o.get(f)!==0)return!0}return!1}function y(o,i,n,r,c){if(r+c===n)return!0;const t=i.charCodeAt(r+c);if(o.get(t)!==0||t===13||t===10)return!0;if(c>0){const f=i.charCodeAt(r+c-1);if(o.get(f)!==0)return!0}return!1}function u(o,i,n,r,c){return S(o,i,n,r,c)&&y(o,i,n,r,c)}e.$kC=u;class m{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let r;do{if(this.b+this.c===n||(r=this.a.exec(i),!r))return null;const c=r.index,t=r[0].length;if(c===this.b&&t===this.c){if(t===0){l.$rf(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=c,this.c=t,!this._wordSeparators||u(this._wordSeparators,i,n,c,t))return r}while(r);return null}}e.$lC=m}),define(Se[130],De([1,0,49,29,78,179,100]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qC=e.$pC=e.$oC=e.$nC=e.$mC=void 0;const w=65535;function p(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class E{constructor(i,n,r,c,t){this.lineStarts=i,this.cr=n,this.lf=r,this.crlf=c,this.isBasicASCII=t}}function M(o,i=!0){const n=[0];let r=1;for(let c=0,t=o.length;c<t;c++){const f=o.charCodeAt(c);f===13?c+1<t&&o.charCodeAt(c+1)===10?(n[r++]=c+2,c++):n[r++]=c+1:f===10&&(n[r++]=c+1)}return i?p(n):n}e.$mC=M;function C(o,i){o.length=0,o[0]=0;let n=1,r=0,c=0,t=0,f=!0;for(let s=0,a=i.length;s<a;s++){const d=i.charCodeAt(s);d===13?s+1<a&&i.charCodeAt(s+1)===10?(t++,o[n++]=s+2,s++):(r++,o[n++]=s+1):d===10?(c++,o[n++]=s+1):f&&d!==9&&(d<32||d>126)&&(f=!1)}const h=new E(p(o),r,c,t,f);return o.length=0,h}e.$nC=C;class v{constructor(i,n,r,c,t){this.bufferIndex=i,this.start=n,this.end=r,this.lineFeedCnt=c,this.length=t}}e.$oC=v;class S{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$pC=S;class y{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$0B&&i.iterate(i.root,r=>(r!==A.$0B&&this.a.push(r.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class u{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartOffset<=i&&r.nodeStartOffset+r.node.piece.length>=i)return r}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const r=this.b[n];if(r.nodeStartLineNumber&&r.nodeStartLineNumber<i&&r.nodeStartLineNumber+r.node.piece.lineFeedCnt>=i)return r}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const r=this.b;for(let c=0;c<r.length;c++){const t=r[c];if(t.node.parent===null||t.nodeStartOffset>=i){r[c]=null,n=!0;continue}}if(n){const c=[];for(const t of r)t!==null&&c.push(t);this.b=c}}}class m{constructor(i,n,r){this.create(i,n,r)}create(i,n,r){this.a=[new S("",[0])],this.g={line:0,column:0},this.root=A.$0B,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=r;let c=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=M(i[t].buffer));const h=new v(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),c=this.S(c,h)}this.h=new u(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=w,r=n-Math.floor(n/3),c=r*2;let t="",f=0;const h=[];if(this.iterate(this.root,s=>{const a=this.R(s),d=a.length;if(f<=r||f+d<c)return t+=a,f+=d,!0;const $=t.replace(/\r\n|\r|\n/g,i);return h.push(new S($,M($))),t=a,f=d,!0}),f>0){const s=t.replace(/\r\n|\r|\n/g,i);h.push(new S(s,M(s)))}this.create(h,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new y(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,c=>{if(c===A.$0B)return!0;const t=this.R(c),f=t.length,h=i.G(n),s=i.G(n+f),a=i.getValueInRange2(h,s);return n+=f,t===a})}getOffsetAt(i,n){let r=0,c=this.root;for(;c!==A.$0B;)if(c.left!==A.$0B&&c.lf_left+1>=i)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt+1>=i){r+=c.size_left;const t=this.B(c,i-c.lf_left-2);return r+=t+n-1}else i-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right;return r}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,r=0;const c=i;for(;n!==A.$0B;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(r+=n.lf_left+t.index,t.index===0){const f=this.getOffsetAt(r+1,1),h=c-f;return new l.$9s(r+1,h+1)}return new l.$9s(r+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,r+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$0B){const t=this.getOffsetAt(r+1,1),f=c-i-t;return new l.$9s(r+1,f+1)}else n=n.right;return new l.$9s(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const r=this.H(i.startLineNumber,i.startColumn),c=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(r,c);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,s=this.a[h.piece.bufferIndex].buffer,a=this.u(h.piece.bufferIndex,h.piece.start);return s.substring(a+i.remainder,a+n.remainder)}let r=i.node;const c=this.a[r.piece.bufferIndex].buffer,t=this.u(r.piece.bufferIndex,r.piece.start);let f=c.substring(t+i.remainder,t+r.piece.length);for(r=r.next();r!==A.$0B;){const h=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(r===n.node){f+=h.substring(s,s+n.remainder);break}else f+=h.substr(s,r.piece.length);r=r.next()}return f}getLinesContent(){const i=[];let n=0,r="",c=!1;return this.iterate(this.root,t=>{if(t===A.$0B)return!0;const f=t.piece;let h=f.length;if(h===0)return!0;const s=this.a[f.bufferIndex].buffer,a=this.a[f.bufferIndex].lineStarts,d=f.start.line,$=f.end.line;let D=a[d]+f.start.column;if(c&&(s.charCodeAt(D)===10&&(D++,h--),i[n++]=r,r="",c=!1,h===0))return!0;if(d===$)return!this.f&&s.charCodeAt(D+h-1)===13?(c=!0,r+=s.substr(D,h-1)):r+=s.substr(D,h),!0;r+=this.f?s.substring(D,Math.max(D,a[d+1]-this.e)):s.substring(D,a[d+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;for(let b=d+1;b<$;b++)r=this.f?s.substring(a[b],a[b+1]-this.e):s.substring(a[b],a[b+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=r;return!this.f&&s.charCodeAt(a[$]+f.end.column-1)===13?(c=!0,f.end.column===0?n--:r=s.substr(a[$],f.end.column-1)):r=s.substr(a[$],f.end.column),!0}),c&&(i[n++]=r,r=""),i[n++]=r,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const r=this.a[n.piece.bufferIndex],c=this.u(n.piece.bufferIndex,n.piece.start);return r.buffer.charCodeAt(c)}else{const n=this.a[i.node.piece.bufferIndex],c=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(c)}}getLineCharCode(i,n){const r=this.H(i,n+1);return this.l(r)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,r,c,t,f,h,s,a,d,$){const D=this.a[i.piece.bufferIndex],b=this.u(i.piece.bufferIndex,i.piece.start),g=this.u(i.piece.bufferIndex,t),k=this.u(i.piece.bufferIndex,f);let P;const F={line:0,column:0};let U,z;n._wordSeparators?(U=D.buffer.substring(g,k),z=T=>T+g,n.reset(0)):(U=D.buffer,z=T=>T,n.reset(g));do if(P=n.next(U),P){if(z(P.index)>=k)return d;this.s(i,z(P.index)-b,F);const T=this.t(i.piece.bufferIndex,t,F),I=F.line===t.line?F.column-t.column+c:F.column+1,O=I+P[0].length;if($[d++]=(0,R.$iC)(new N.$0s(r+T,I,r+T,O),P,s),z(P.index)+P[0].length>=k||d>=a)return d}while(P);return d}findMatchesLineByLine(i,n,r,c){const t=[];let f=0;const h=new R.$lC(n.wordSeparators,n.regex);let s=this.H(i.startLineNumber,i.startColumn);if(s===null)return[];const a=this.H(i.endLineNumber,i.endColumn);if(a===null)return[];let d=this.s(s.node,s.remainder);const $=this.s(a.node,a.remainder);if(s.node===a.node)return this.findMatchesInNode(s.node,h,i.startLineNumber,i.startColumn,d,$,n,r,c,f,t),t;let D=i.startLineNumber,b=s.node;for(;b!==a.node;){const k=this.t(b.piece.bufferIndex,d,b.piece.end);if(k>=1){const F=this.a[b.piece.bufferIndex].lineStarts,U=this.u(b.piece.bufferIndex,b.piece.start),z=F[d.line+k],T=D===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(b,h,D,T,d,this.s(b,z-U),n,r,c,f,t),f>=c)return t;D+=k}const P=D===i.startLineNumber?i.startColumn-1:0;if(D===i.endLineNumber){const F=this.getLineContent(D).substring(P,i.endColumn-1);return f=this.n(n,h,F,i.endLineNumber,P,f,t,r,c),t}if(f=this.n(n,h,this.getLineContent(D).substr(P),D,P,f,t,r,c),f>=c)return t;D++,s=this.H(D,1),b=s.node,d=this.s(s.node,s.remainder)}if(D===i.endLineNumber){const k=D===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(D).substring(k,i.endColumn-1);return f=this.n(n,h,P,i.endLineNumber,k,f,t,r,c),t}const g=D===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(a.node,h,D,g,d,$,n,r,c,f,t),t}n(i,n,r,c,t,f,h,s,a){const d=i.wordSeparators;if(!s&&i.simpleSearch){const D=i.simpleSearch,b=D.length,g=r.length;let k=-b;for(;(k=r.indexOf(D,k+b))!==-1;)if((!d||(0,R.$kC)(d,r,g,k,b))&&(h[f++]=new L.$qv(new N.$0s(c,k+1+t,c,k+1+b+t),null),f>=a))return f;return f}let $;n.reset(0);do if($=n.next(r),$&&(h[f++]=(0,R.$iC)(new N.$0s(c,$.index+1+t,c,$.index+1+$[0].length+t),$,s),f>=a))return f;while($);return f}insert(i,n,r=!1){if(this.f=this.f&&r,this.j.lineNumber=0,this.j.value="",this.root!==A.$0B){const{node:c,remainder:t,nodeStartOffset:f}=this.G(i),h=c.piece,s=h.bufferIndex,a=this.s(c,t);if(c.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&f+h.length===i&&n.length<w){this.F(c,n),this.y();return}if(f===i)this.o(n,c),this.h.validate(i);else if(f+c.piece.length>i){const d=[];let $=new v(h.bufferIndex,a,h.end,this.t(h.bufferIndex,a,h.end),this.u(s,h.end)-this.u(s,a));if(this.K()&&this.M(n)&&this.I(c,t)===10){const k={line:$.start.line+1,column:0};$=new v($.bufferIndex,k,$.end,this.t($.bufferIndex,k,$.end),$.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(c,t-1)===13){const k=this.s(c,t-1);this.C(c,k),n="\r"+n,c.piece.length===0&&d.push(c)}else this.C(c,a);else this.C(c,a);const D=this.w(n);$.length>0&&this.S(c,$);let b=c;for(let g=0;g<D.length;g++)b=this.S(b,D[g]);this.v(d)}else this.q(n,c)}else{const c=this.w(n);let t=this.T(null,c[0]);for(let f=1;f<c.length;f++)t=this.S(t,c[f])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$0B)return;const r=this.G(i),c=this.G(i+n),t=r.node,f=c.node;if(t===f){const D=this.s(t,r.remainder),b=this.s(t,c.remainder);if(r.nodeStartOffset===i){if(n===t.piece.length){const g=t.next();(0,A.$cC)(this,t),this.N(g),this.y();return}this.D(t,b),this.h.validate(i),this.N(t),this.y();return}if(r.nodeStartOffset+t.piece.length===i+n){this.C(t,D),this.O(t),this.y();return}this.E(t,D,b),this.y();return}const h=[],s=this.s(t,r.remainder);this.C(t,s),this.h.validate(i),t.piece.length===0&&h.push(t);const a=this.s(f,c.remainder);this.D(f,a),f.piece.length===0&&h.push(f);const d=t.next();for(let D=d;D!==A.$0B&&D!==f;D=D.next())h.push(D);const $=t.piece.length===0?t.prev():t;this.v(h),this.O($),this.y()}o(i,n){const r=[];if(this.K()&&this.M(i)&&this.L(n)){const f=n.piece,h={line:f.start.line+1,column:0},s=new v(f.bufferIndex,h,f.end,this.t(f.bufferIndex,h,f.end),f.length-1);n.piece=s,i+=`
`,(0,A.$eC)(this,n,-1,-1),n.piece.length===0&&r.push(n)}const c=this.w(i);let t=this.T(n,c[c.length-1]);for(let f=c.length-2;f>=0;f--)t=this.T(t,c[f]);this.N(t),this.v(r)}q(i,n){this.Q(i,n)&&(i+=`
`);const r=this.w(i),c=this.S(n,r[0]);let t=c;for(let f=1;f<r.length;f++)t=this.S(t,r[f]);this.N(c)}s(i,n,r){const c=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,s=f[c.start.line]+c.start.column+n;let a=c.start.line,d=c.end.line,$=0,D=0,b=0;for(;a<=d&&($=a+(d-a)/2|0,b=f[$],$!==d);)if(D=f[$+1],s<b)d=$-1;else if(s>=D)a=$+1;else break;return r?(r.line=$,r.column=s-b,null):{line:$,column:s-b}}t(i,n,r){if(r.column===0)return r.line-n.line;const c=this.a[i].lineStarts;if(r.line===c.length-1)return r.line-n.line;const t=c[r.line+1],f=c[r.line]+r.column;if(t>f+1)return r.line-n.line;const h=f-1;return this.a[i].buffer.charCodeAt(h)===13?r.line-n.line+1:r.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$cC)(this,i[n])}w(i){if(i.length>w){const d=[];for(;i.length>w;){const D=i.charCodeAt(w-1);let b;D===13||D>=55296&&D<=56319?(b=i.substring(0,w-1),i=i.substring(w-1)):(b=i.substring(0,w),i=i.substring(w));const g=M(b);d.push(new v(this.a.length,{line:0,column:0},{line:g.length-1,column:b.length-g[g.length-1]},g.length-1,b.length)),this.a.push(new S(b,g))}const $=M(i);return d.push(new v(this.a.length,{line:0,column:0},{line:$.length-1,column:i.length-$[$.length-1]},$.length-1,i.length)),this.a.push(new S(i,$)),d}let n=this.a[0].buffer.length;const r=M(i,!1);let c=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},c=this.g;for(let d=0;d<r.length;d++)r[d]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let d=0;d<r.length;d++)r[d]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(r.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[f],s={line:f,column:h},a=new v(0,c,s,this.t(0,c,s),t-n);return this.g=s,[a]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let r=this.root,c="";const t=this.h.get2(i);if(t){r=t.node;const f=this.B(r,i-t.nodeStartLineNumber-1),h=this.a[r.piece.bufferIndex].buffer,s=this.u(r.piece.bufferIndex,r.piece.start);if(t.nodeStartLineNumber+r.piece.lineFeedCnt===i)c=h.substring(s+f,s+r.piece.length);else{const a=this.B(r,i-t.nodeStartLineNumber);return h.substring(s+f,s+a-n)}}else{let f=0;const h=i;for(;r!==A.$0B;)if(r.left!==A.$0B&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const s=this.B(r,i-r.lf_left-2),a=this.B(r,i-r.lf_left-1),d=this.a[r.piece.bufferIndex].buffer,$=this.u(r.piece.bufferIndex,r.piece.start);return f+=r.size_left,this.h.set({node:r,nodeStartOffset:f,nodeStartLineNumber:h-(i-1-r.lf_left)}),d.substring($+s,$+a-n)}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const s=this.B(r,i-r.lf_left-2),a=this.a[r.piece.bufferIndex].buffer,d=this.u(r.piece.bufferIndex,r.piece.start);c=a.substring(d+s,d+r.piece.length);break}else i-=r.lf_left+r.piece.lineFeedCnt,f+=r.size_left+r.piece.length,r=r.right}for(r=r.next();r!==A.$0B;){const f=this.a[r.piece.bufferIndex].buffer;if(r.piece.lineFeedCnt>0){const h=this.B(r,0),s=this.u(r.piece.bufferIndex,r.piece.start);return c+=f.substring(s,s+h-n),c}else{const h=this.u(r.piece.bufferIndex,r.piece.start);c+=f.substr(h,r.piece.length)}r=r.next()}return c}y(){let i=this.root,n=1,r=0;for(;i!==A.$0B;)n+=i.lf_left+i.piece.lineFeedCnt,r+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=r,this.h.validate(this.c)}A(i,n){const r=i.piece,c=this.s(i,n),t=c.line-r.start.line;if(this.u(r.bufferIndex,r.end)-this.u(r.bufferIndex,r.start)===n){const f=this.t(i.piece.bufferIndex,r.start,c);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:c.column}}B(i,n){if(n<0)return 0;const r=i.piece,c=this.a[r.bufferIndex].lineStarts,t=r.start.line+n+1;return t>r.end.line?c[r.end.line]+r.end.column-c[r.start.line]-r.start.column:c[t]-c[r.start.line]-r.start.column}C(i,n){const r=i.piece,c=r.lineFeedCnt,t=this.u(r.bufferIndex,r.end),f=n,h=this.u(r.bufferIndex,f),s=this.t(r.bufferIndex,r.start,f),a=s-c,d=h-t,$=r.length+d;i.piece=new v(r.bufferIndex,r.start,f,s,$),(0,A.$eC)(this,i,d,a)}D(i,n){const r=i.piece,c=r.lineFeedCnt,t=this.u(r.bufferIndex,r.start),f=n,h=this.t(r.bufferIndex,f,r.end),s=this.u(r.bufferIndex,f),a=h-c,d=t-s,$=r.length+d;i.piece=new v(r.bufferIndex,f,r.end,h,$),(0,A.$eC)(this,i,d,a)}E(i,n,r){const c=i.piece,t=c.start,f=c.end,h=c.length,s=c.lineFeedCnt,a=n,d=this.t(c.bufferIndex,c.start,a),$=this.u(c.bufferIndex,n)-this.u(c.bufferIndex,t);i.piece=new v(c.bufferIndex,c.start,a,d,$),(0,A.$eC)(this,i,$-h,d-s);const D=new v(c.bufferIndex,r,f,this.t(c.bufferIndex,r,f),this.u(c.bufferIndex,f)-this.u(c.bufferIndex,r)),b=this.S(i,D);this.N(b)}F(i,n){this.Q(n,i)&&(n+=`
`);const r=this.K()&&this.L(n)&&this.M(i),c=this.a[0].buffer.length;this.a[0].buffer+=n;const t=M(n,!1);for(let b=0;b<t.length;b++)t[b]+=c;if(r){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:c-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[f],s={line:f,column:h},a=i.piece.length+n.length,d=i.piece.lineFeedCnt,$=this.t(0,i.piece.start,s),D=$-d;i.piece=new v(i.piece.bufferIndex,i.piece.start,s,$,a),this.g=s,(0,A.$eC)(this,i,n.length,D)}G(i){let n=this.root;const r=this.h.get(i);if(r)return{node:r.node,nodeStartOffset:r.nodeStartOffset,remainder:i-r.nodeStartOffset};let c=0;for(;n!==A.$0B;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){c+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:c};return this.h.set(t),t}else i-=n.size_left+n.piece.length,c+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let r=this.root,c=0;for(;r!==A.$0B;)if(r.left!==A.$0B&&r.lf_left>=i-1)r=r.left;else if(r.lf_left+r.piece.lineFeedCnt>i-1){const t=this.B(r,i-r.lf_left-2),f=this.B(r,i-r.lf_left-1);return c+=r.size_left,{node:r,remainder:Math.min(t+n-1,f),nodeStartOffset:c}}else if(r.lf_left+r.piece.lineFeedCnt===i-1){const t=this.B(r,i-r.lf_left-2);if(t+n-1<=r.piece.length)return{node:r,remainder:t+n-1,nodeStartOffset:c};n-=r.piece.length-t;break}else i-=r.lf_left+r.piece.lineFeedCnt,c+=r.size_left+r.piece.length,r=r.right;for(r=r.next();r!==A.$0B;){if(r.piece.lineFeedCnt>0){const t=this.B(r,0),f=this.J(r);return{node:r,remainder:Math.min(n-1,t),nodeStartOffset:f}}else if(r.piece.length>=n-1){const t=this.J(r);return{node:r,remainder:n-1,nodeStartOffset:t}}else n-=r.piece.length;r=r.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const r=this.a[i.piece.bufferIndex],c=this.u(i.piece.bufferIndex,i.piece.start)+n;return r.buffer.charCodeAt(c)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$0B||i.piece.lineFeedCnt===0)return!1;const n=i.piece,r=this.a[n.bufferIndex].lineStarts,c=n.start.line,t=r[c]+n.start.column;return c===r.length-1||r[c+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$0B||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const r=[],c=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:c[i.piece.end.line]-c[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new v(i.piece.bufferIndex,i.piece.start,t,h,f),(0,A.$eC)(this,i,-1,-1),i.piece.length===0&&r.push(i);const s={line:n.piece.start.line+1,column:0},a=n.piece.length-1,d=this.t(n.piece.bufferIndex,s,n.piece.end);n.piece=new v(n.piece.bufferIndex,s,n.piece.end,d,a),(0,A.$eC)(this,n,-1,-1),n.piece.length===0&&r.push(n);const $=this.w(`\r
`);this.S(i,$[0]);for(let D=0;D<r.length;D++)(0,A.$cC)(this,r[D])}Q(i,n){if(this.K()&&this.M(i)){const r=n.next();if(this.L(r)){if(i+=`
`,r.piece.length===1)(0,A.$cC)(this,r);else{const c=r.piece,t={line:c.start.line+1,column:0},f=c.length-1,h=this.t(c.bufferIndex,t,c.end);r.piece=new v(c.bufferIndex,t,c.end,h,f),(0,A.$eC)(this,r,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$0B)return n(A.$0B);const r=this.iterate(i.left,n);return r&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$0B)return"";const n=this.a[i.piece.bufferIndex],r=i.piece,c=this.u(r.bufferIndex,r.start),t=this.u(r.bufferIndex,r.end);return n.buffer.substring(c,t)}getPieceContent(i){const n=this.a[i.bufferIndex],r=this.u(i.bufferIndex,i.start),c=this.u(i.bufferIndex,i.end);return n.buffer.substring(r,c)}S(i,n){const r=new A.$9B(n,1);if(r.left=A.$0B,r.right=A.$0B,r.parent=A.$0B,r.size_left=0,r.lf_left=0,this.root===A.$0B)this.root=r,r.color=0;else if(i.right===A.$0B)i.right=r,r.parent=i;else{const t=(0,A.$$B)(i.right);t.left=r,r.parent=t}return(0,A.$dC)(this,r),r}T(i,n){const r=new A.$9B(n,1);if(r.left=A.$0B,r.right=A.$0B,r.parent=A.$0B,r.size_left=0,r.lf_left=0,this.root===A.$0B)this.root=r,r.color=0;else if(i.left===A.$0B)i.left=r,r.parent=i;else{const c=(0,A.$_B)(i.left);c.right=r,r.parent=c}return(0,A.$dC)(this,r),r}U(i){let n="";return this.iterate(i,r=>(n+=this.R(r),!0)),n}}e.$qC=m}),define(Se[182],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L9=e.$K9=void 0;class l{constructor(){this.a=new Map}removeDragOperationTransfer(A){if(A&&this.a.has(A)){const R=this.a.get(A);return this.a.delete(A),R}}addDragOperationTransfer(A,R){this.a.set(A,R)}}e.$K9=l;class N{constructor(A){this.identifier=A}}e.$L9=N}),define(Se[183],De([1,0,4,3]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$It=void 0;class L{constructor(){this.a=new Map,this.b=new Map,this.c=new l.$6d,this.onDidChange=this.c.event,this.d=null}handleChange(w){this.c.fire({changedLanguages:w,changedColorMap:!1})}register(w,p){return this.a.set(w,p),this.handleChange([w]),(0,N.$Rc)(()=>{this.a.get(w)===p&&(this.a.delete(w),this.handleChange([w]))})}get(w){return this.a.get(w)||null}registerFactory(w,p){this.b.get(w)?.dispose();const E=new A(this,w,p);return this.b.set(w,E),(0,N.$Rc)(()=>{const M=this.b.get(w);!M||M!==E||(this.b.delete(w),M.dispose())})}async getOrCreate(w){const p=this.get(w);if(p)return p;const E=this.b.get(w);return!E||E.isResolved?null:(await E.resolve(),this.get(w))}isResolved(w){if(this.get(w))return!0;const E=this.b.get(w);return!!(!E||E.isResolved)}setColorMap(w){this.d=w,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$It=L;class A extends N.$Tc{get isResolved(){return this.c}constructor(w,p,E){super(),this.f=w,this.g=p,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const w=await this.h.tokenizationSupport;this.c=!0,w&&!this.a&&this.B(this.f.register(this.g,w))}}}),define(Se[184],De([9,10]),function(fe,e){return fe.create("vs/base/common/actions",e)}),define(Se[185],De([1,0,4,3,184]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=void 0;class A extends N.$Tc{constructor(v,S="",y="",u=!0,m){super(),this.h=this.B(new l.$6d),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=S,this.u=y,this.w=u,this.C=m}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,S){this.C&&await this.C(v)}}e.$Xi=A;class R extends N.$Tc{constructor(){super(...arguments),this.f=this.B(new l.$6d),this.onWillRun=this.f.event,this.m=this.B(new l.$6d),this.onDidRun=this.m.event}async run(v,S){if(!v.enabled)return;this.f.fire({action:v});let y;try{await this.u(v,S)}catch(u){y=u}this.m.fire({action:v,error:y})}async u(v,S){await v.run(S)}}e.$Yi=R;class w{constructor(){this.id=w.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let S=[];for(const y of v)y.length&&(S.length?S=[...S,new w,...y]:S=y);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$Zi=w;class p{get actions(){return this.a}constructor(v,S,y,u){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=S,this.class=u,this.a=y}async run(){}}e.$1i=p;class E extends A{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,L.localize(0,null),void 0,!1)}}e.$2i=E;function M(C){return{id:C.id,label:C.label,class:C.class,enabled:C.enabled??!0,checked:C.checked,run:async(...v)=>C.run(...v),tooltip:C.label}}e.$3i=M}),define(Se[186],De([9,10]),function(fe,e){return fe.create("vs/base/common/date",e)}),define(Se[187],De([1,0,186]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=e.$Km=void 0;const N=60,L=N*60,A=L*24,R=A*7,w=A*30,p=A*365;function E(v,S,y,u){typeof v!="number"&&(v=v.getTime());const m=Math.round((new Date().getTime()-v)/1e3);if(m<-30)return(0,l.localize)(0,null,E(new Date().getTime()+m*1e3,!1));if(!u&&m<30)return(0,l.localize)(1,null);let o;return m<N?(o=m,S?o===1?y?(0,l.localize)(2,null,o):(0,l.localize)(3,null,o):y?(0,l.localize)(4,null,o):(0,l.localize)(5,null,o):o===1?y?(0,l.localize)(6,null,o):(0,l.localize)(7,null,o):y?(0,l.localize)(8,null,o):(0,l.localize)(9,null,o)):m<L?(o=Math.floor(m/N),S?o===1?y?(0,l.localize)(10,null,o):(0,l.localize)(11,null,o):y?(0,l.localize)(12,null,o):(0,l.localize)(13,null,o):o===1?y?(0,l.localize)(14,null,o):(0,l.localize)(15,null,o):y?(0,l.localize)(16,null,o):(0,l.localize)(17,null,o)):m<A?(o=Math.floor(m/L),S?o===1?y?(0,l.localize)(18,null,o):(0,l.localize)(19,null,o):y?(0,l.localize)(20,null,o):(0,l.localize)(21,null,o):o===1?y?(0,l.localize)(22,null,o):(0,l.localize)(23,null,o):y?(0,l.localize)(24,null,o):(0,l.localize)(25,null,o)):m<R?(o=Math.floor(m/A),S?o===1?(0,l.localize)(26,null,o):(0,l.localize)(27,null,o):o===1?(0,l.localize)(28,null,o):(0,l.localize)(29,null,o)):m<w?(o=Math.floor(m/R),S?o===1?y?(0,l.localize)(30,null,o):(0,l.localize)(31,null,o):y?(0,l.localize)(32,null,o):(0,l.localize)(33,null,o):o===1?y?(0,l.localize)(34,null,o):(0,l.localize)(35,null,o):y?(0,l.localize)(36,null,o):(0,l.localize)(37,null,o)):m<p?(o=Math.floor(m/w),S?o===1?y?(0,l.localize)(38,null,o):(0,l.localize)(39,null,o):y?(0,l.localize)(40,null,o):(0,l.localize)(41,null,o):o===1?y?(0,l.localize)(42,null,o):(0,l.localize)(43,null,o):y?(0,l.localize)(44,null,o):(0,l.localize)(45,null,o)):(o=Math.floor(m/p),S?o===1?y?(0,l.localize)(46,null,o):(0,l.localize)(47,null,o):y?(0,l.localize)(48,null,o):(0,l.localize)(49,null,o):o===1?y?(0,l.localize)(50,null,o):(0,l.localize)(51,null,o):y?(0,l.localize)(52,null,o):(0,l.localize)(53,null,o))}e.$Km=E;function M(v,S){const y=Math.abs(v/1e3);return y<1?S?(0,l.localize)(54,null,v):(0,l.localize)(55,null,v):y<N?S?(0,l.localize)(56,null,Math.round(v)/1e3):(0,l.localize)(57,null,Math.round(v)/1e3):y<L?S?(0,l.localize)(58,null,Math.round(v/(1e3*N))):(0,l.localize)(59,null,Math.round(v/(1e3*N))):y<A?S?(0,l.localize)(60,null,Math.round(v/(1e3*L))):(0,l.localize)(61,null,Math.round(v/(1e3*L))):(0,l.localize)(62,null,Math.round(v/(1e3*A)))}e.$Lm=M;function C(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Mm=C}),define(Se[188],De([9,10]),function(fe,e){return fe.create("vs/base/common/errorMessage",e)}),define(Se[44],De([1,0,19,18,188]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6i=e.$5i=e.$4i=void 0;function A(C,v){return v&&(C.stack||C.stacktrace)?L.localize(0,null,w(C),R(C.stack)||R(C.stacktrace)):w(C)}function R(C){return Array.isArray(C)?C.join(`
`):C}function w(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?L.localize(1,null,C.message):C.message||L.localize(2,null)}function p(C=null,v=!1){if(!C)return L.localize(3,null);if(Array.isArray(C)){const S=l.$Hb(C),y=p(S[0],v);return S.length>1?L.localize(4,null,y,S.length):y}if(N.$Tf(C))return C;if(C.detail){const S=C.detail;if(S.error)return A(S.error,v);if(S.exception)return A(S.exception,v)}return C.stack?A(C,v):C.message?C.message:L.localize(5,null)}e.$4i=p;function E(C){const v=C;return v instanceof Error&&Array.isArray(v.actions)}e.$5i=E;function M(C,v){let S;return typeof C=="string"?S=new Error(C):S=C,S.actions=v,S}e.$6i=M}),define(Se[189],De([9,10]),function(fe,e){return fe.create("vs/base/common/platform",e)}),define(Se[11],De([1,0,189]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,L=!1,A=!1,R=!1,w=!1,p=!1,E=!1,M=!1,C=!1,v=!1,S,y=e.$g,u=e.$g,m,o;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",c=r&&n?.type==="renderer";if(typeof n=="object"){N=n.platform==="win32",L=n.platform==="darwin",A=n.platform==="linux",R=A&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,E=r,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$g,y=e.$g;const g=n.env.VSCODE_NLS_CONFIG;if(g)try{const k=JSON.parse(g),P=k.availableLanguages["*"];S=k.locale,u=k.osLocale,y=P||e.$g,m=k._translationsConfigFile}catch{}w=!0}else typeof navigator=="object"&&!c?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,L=o.indexOf("Macintosh")>=0,M=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=o.indexOf("Linux")>=0,v=o?.indexOf("Mobi")>=0,p=!0,S=l.getConfiguredDefaultLocale(l.localize(0,null))||e.$g,y=S,u=navigator.language):console.error("Unable to resolve platform.");var t;(function(g){g[g.Web=0]="Web",g[g.Mac=1]="Mac",g[g.Linux=2]="Linux",g[g.Windows=3]="Windows"})(t||(e.Platform=t={}));function f(g){switch(g){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=f;let h=0;L?h=1:N?h=3:A&&(h=2),e.$i=N,e.$j=L,e.$k=A,e.$l=R,e.$m=w,e.$n=E,e.$o=p,e.$p=p&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=M,e.$s=v,e.$t=C,e.$u=h,e.$v=o,e.$w=y;var s;(function(g){function k(){return e.$w}g.value=k;function P(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}g.isDefaultVariant=P;function F(){return e.$w==="en"}g.isDefault=F})(s||(e.Language=s={})),e.$x=S,e.$y=u,e.$z=m,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const g=[];i.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let F=0,U=g.length;F<U;F++){const z=g[F];if(z.id===P.data.vscodeScheduleAsyncWork){g.splice(F,1),z.callback();return}}});let k=0;return P=>{const F=++k;g.push({id:F,callback:P}),i.postMessage({vscodeScheduleAsyncWork:F},"*")}}return g=>setTimeout(g)})();var a;(function(g){g[g.Windows=1]="Windows",g[g.Macintosh=2]="Macintosh",g[g.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=L||M?2:N?1:3;let d=!0,$=!1;function D(){if(!$){$=!0;const g=new Uint8Array(2);g[0]=1,g[1]=2,d=new Uint16Array(g.buffer)[0]===513}return d}e.$D=D,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(g){return parseFloat(g)>=20}e.$J=b}),define(Se[50],De([1,0,11]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return l.$i?"win32":l.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(Se[17],De([1,0,50]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,A=90,R=122,w=46,p=47,E=92,M=58,C=63;class v extends Error{constructor(f,h,s){let a;typeof h=="string"&&h.indexOf("not ")===0?(a="must not be",h=h.replace(/^not /,"")):a="must be";const d=f.indexOf(".")!==-1?"property":"argument";let $=`The "${f}" ${d} ${a} of type ${h}`;$+=`. Received type ${typeof s}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function S(t,f){if(t===null||typeof t!="object")throw new v(f,"Object",t)}function y(t,f){if(typeof t!="string")throw new v(f,"string",t)}const u=l.$dc==="win32";function m(t){return t===p||t===E}function o(t){return t===p}function i(t){return t>=N&&t<=A||t>=L&&t<=R}function n(t,f,h,s){let a="",d=0,$=-1,D=0,b=0;for(let g=0;g<=t.length;++g){if(g<t.length)b=t.charCodeAt(g);else{if(s(b))break;b=p}if(s(b)){if(!($===g-1||D===1))if(D===2){if(a.length<2||d!==2||a.charCodeAt(a.length-1)!==w||a.charCodeAt(a.length-2)!==w){if(a.length>2){const k=a.lastIndexOf(h);k===-1?(a="",d=0):(a=a.slice(0,k),d=a.length-1-a.lastIndexOf(h)),$=g,D=0;continue}else if(a.length!==0){a="",d=0,$=g,D=0;continue}}f&&(a+=a.length>0?`${h}..`:"..",d=2)}else a.length>0?a+=`${h}${t.slice($+1,g)}`:a=t.slice($+1,g),d=g-$-1;$=g,D=0}else b===w&&D!==-1?++D:D=-1}return a}function r(t,f){S(f,"pathObject");const h=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return h?h===f.root?`${h}${s}`:`${h}${t}${s}`:s}e.$fc={resolve(...t){let f="",h="",s=!1;for(let a=t.length-1;a>=-1;a--){let d;if(a>=0){if(d=t[a],y(d,"path"),d.length===0)continue}else f.length===0?d=l.cwd():(d=l.env[`=${f}`]||l.cwd(),(d===void 0||d.slice(0,2).toLowerCase()!==f.toLowerCase()&&d.charCodeAt(2)===E)&&(d=`${f}\\`));const $=d.length;let D=0,b="",g=!1;const k=d.charCodeAt(0);if($===1)m(k)&&(D=1,g=!0);else if(m(k))if(g=!0,m(d.charCodeAt(1))){let P=2,F=P;for(;P<$&&!m(d.charCodeAt(P));)P++;if(P<$&&P!==F){const U=d.slice(F,P);for(F=P;P<$&&m(d.charCodeAt(P));)P++;if(P<$&&P!==F){for(F=P;P<$&&!m(d.charCodeAt(P));)P++;(P===$||P!==F)&&(b=`\\\\${U}\\${d.slice(F,P)}`,D=P)}}}else D=1;else i(k)&&d.charCodeAt(1)===M&&(b=d.slice(0,2),D=2,$>2&&m(d.charCodeAt(2))&&(g=!0,D=3));if(b.length>0)if(f.length>0){if(b.toLowerCase()!==f.toLowerCase())continue}else f=b;if(s){if(f.length>0)break}else if(h=`${d.slice(D)}\\${h}`,s=g,g&&f.length>0)break}return h=n(h,!s,"\\",m),s?`${f}\\${h}`:`${f}${h}`||"."},normalize(t){y(t,"path");const f=t.length;if(f===0)return".";let h=0,s,a=!1;const d=t.charCodeAt(0);if(f===1)return o(d)?"\\":t;if(m(d))if(a=!0,m(t.charCodeAt(1))){let D=2,b=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==b){const g=t.slice(b,D);for(b=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return`\\\\${g}\\${t.slice(b)}\\`;D!==b&&(s=`\\\\${g}\\${t.slice(b,D)}`,h=D)}}}else h=1;else i(d)&&t.charCodeAt(1)===M&&(s=t.slice(0,2),h=2,f>2&&m(t.charCodeAt(2))&&(a=!0,h=3));let $=h<f?n(t.slice(h),!a,"\\",m):"";return $.length===0&&!a&&($="."),$.length>0&&m(t.charCodeAt(f-1))&&($+="\\"),s===void 0?a?`\\${$}`:$:a?`${s}\\${$}`:`${s}${$}`},isAbsolute(t){y(t,"path");const f=t.length;if(f===0)return!1;const h=t.charCodeAt(0);return m(h)||f>2&&i(h)&&t.charCodeAt(1)===M&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let f,h;for(let d=0;d<t.length;++d){const $=t[d];y($,"path"),$.length>0&&(f===void 0?f=h=$:f+=`\\${$}`)}if(f===void 0)return".";let s=!0,a=0;if(typeof h=="string"&&m(h.charCodeAt(0))){++a;const d=h.length;d>1&&m(h.charCodeAt(1))&&(++a,d>2&&(m(h.charCodeAt(2))?++a:s=!1))}if(s){for(;a<f.length&&m(f.charCodeAt(a));)a++;a>=2&&(f=`\\${f.slice(a)}`)}return e.$fc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f)return"";const h=e.$fc.resolve(t),s=e.$fc.resolve(f);if(h===s||(t=h.toLowerCase(),f=s.toLowerCase(),t===f))return"";let a=0;for(;a<t.length&&t.charCodeAt(a)===E;)a++;let d=t.length;for(;d-1>a&&t.charCodeAt(d-1)===E;)d--;const $=d-a;let D=0;for(;D<f.length&&f.charCodeAt(D)===E;)D++;let b=f.length;for(;b-1>D&&f.charCodeAt(b-1)===E;)b--;const g=b-D,k=$<g?$:g;let P=-1,F=0;for(;F<k;F++){const z=t.charCodeAt(a+F);if(z!==f.charCodeAt(D+F))break;z===E&&(P=F)}if(F!==k){if(P===-1)return s}else{if(g>k){if(f.charCodeAt(D+F)===E)return s.slice(D+F+1);if(F===2)return s.slice(D+F)}$>k&&(t.charCodeAt(a+F)===E?P=F:F===2&&(P=3)),P===-1&&(P=0)}let U="";for(F=a+P+1;F<=d;++F)(F===d||t.charCodeAt(F)===E)&&(U+=U.length===0?"..":"\\..");return D+=P,U.length>0?`${U}${s.slice(D,b)}`:(s.charCodeAt(D)===E&&++D,s.slice(D,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const f=e.$fc.resolve(t);if(f.length<=2)return t;if(f.charCodeAt(0)===E){if(f.charCodeAt(1)===E){const h=f.charCodeAt(2);if(h!==C&&h!==w)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(i(f.charCodeAt(0))&&f.charCodeAt(1)===M&&f.charCodeAt(2)===E)return`\\\\?\\${f}`;return t},dirname(t){y(t,"path");const f=t.length;if(f===0)return".";let h=-1,s=0;const a=t.charCodeAt(0);if(f===1)return m(a)?t:".";if(m(a)){if(h=s=1,m(t.charCodeAt(1))){let D=2,b=D;for(;D<f&&!m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&m(t.charCodeAt(D));)D++;if(D<f&&D!==b){for(b=D;D<f&&!m(t.charCodeAt(D));)D++;if(D===f)return t;D!==b&&(h=s=D+1)}}}}else i(a)&&t.charCodeAt(1)===M&&(h=f>2&&m(t.charCodeAt(2))?3:2,s=h);let d=-1,$=!0;for(let D=f-1;D>=s;--D)if(m(t.charCodeAt(D))){if(!$){d=D;break}}else $=!1;if(d===-1){if(h===-1)return".";d=h}return t.slice(0,d)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let h=0,s=-1,a=!0,d;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===M&&(h=2),f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let $=f.length-1,D=-1;for(d=t.length-1;d>=h;--d){const b=t.charCodeAt(d);if(m(b)){if(!a){h=d+1;break}}else D===-1&&(a=!1,D=d+1),$>=0&&(b===f.charCodeAt($)?--$===-1&&(s=d):($=-1,s=D))}return h===s?s=D:s===-1&&(s=t.length),t.slice(h,s)}for(d=t.length-1;d>=h;--d)if(m(t.charCodeAt(d))){if(!a){h=d+1;break}}else s===-1&&(a=!1,s=d+1);return s===-1?"":t.slice(h,s)},extname(t){y(t,"path");let f=0,h=-1,s=0,a=-1,d=!0,$=0;t.length>=2&&t.charCodeAt(1)===M&&i(t.charCodeAt(0))&&(f=s=2);for(let D=t.length-1;D>=f;--D){const b=t.charCodeAt(D);if(m(b)){if(!d){s=D+1;break}continue}a===-1&&(d=!1,a=D+1),b===w?h===-1?h=D:$!==1&&($=1):h!==-1&&($=-1)}return h===-1||a===-1||$===0||$===1&&h===a-1&&h===s+1?"":t.slice(h,a)},format:r.bind(null,"\\"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.length;let s=0,a=t.charCodeAt(0);if(h===1)return m(a)?(f.root=f.dir=t,f):(f.base=f.name=t,f);if(m(a)){if(s=1,m(t.charCodeAt(1))){let P=2,F=P;for(;P<h&&!m(t.charCodeAt(P));)P++;if(P<h&&P!==F){for(F=P;P<h&&m(t.charCodeAt(P));)P++;if(P<h&&P!==F){for(F=P;P<h&&!m(t.charCodeAt(P));)P++;P===h?s=P:P!==F&&(s=P+1)}}}}else if(i(a)&&t.charCodeAt(1)===M){if(h<=2)return f.root=f.dir=t,f;if(s=2,m(t.charCodeAt(2))){if(h===3)return f.root=f.dir=t,f;s=3}}s>0&&(f.root=t.slice(0,s));let d=-1,$=s,D=-1,b=!0,g=t.length-1,k=0;for(;g>=s;--g){if(a=t.charCodeAt(g),m(a)){if(!b){$=g+1;break}continue}D===-1&&(b=!1,D=g+1),a===w?d===-1?d=g:k!==1&&(k=1):d!==-1&&(k=-1)}return D!==-1&&(d===-1||k===0||k===1&&d===D-1&&d===$+1?f.base=f.name=t.slice($,D):(f.name=t.slice($,d),f.base=t.slice($,D),f.ext=t.slice(d,D))),$>0&&$!==s?f.dir=t.slice(0,$-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(u){const t=/\\/g;return()=>{const f=l.cwd().replace(t,"/");return f.slice(f.indexOf("/"))}}return()=>l.cwd()})();e.$gc={resolve(...t){let f="",h=!1;for(let s=t.length-1;s>=-1&&!h;s--){const a=s>=0?t[s]:c();y(a,"path"),a.length!==0&&(f=`${a}/${f}`,h=a.charCodeAt(0)===p)}return f=n(f,!h,"/",o),h?`/${f}`:f.length>0?f:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p,h=t.charCodeAt(t.length-1)===p;return t=n(t,!f,"/",o),t.length===0?f?"/":h?"./":".":(h&&(t+="/"),f?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let f;for(let h=0;h<t.length;++h){const s=t[h];y(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.$gc.normalize(f)},relative(t,f){if(y(t,"from"),y(f,"to"),t===f||(t=e.$gc.resolve(t),f=e.$gc.resolve(f),t===f))return"";const h=1,s=t.length,a=s-h,d=1,$=f.length-d,D=a<$?a:$;let b=-1,g=0;for(;g<D;g++){const P=t.charCodeAt(h+g);if(P!==f.charCodeAt(d+g))break;P===p&&(b=g)}if(g===D)if($>D){if(f.charCodeAt(d+g)===p)return f.slice(d+g+1);if(g===0)return f.slice(d+g)}else a>D&&(t.charCodeAt(h+g)===p?b=g:g===0&&(b=0));let k="";for(g=h+b+1;g<=s;++g)(g===s||t.charCodeAt(g)===p)&&(k+=k.length===0?"..":"/..");return`${k}${f.slice(d+b)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const f=t.charCodeAt(0)===p;let h=-1,s=!0;for(let a=t.length-1;a>=1;--a)if(t.charCodeAt(a)===p){if(!s){h=a;break}}else s=!1;return h===-1?f?"/":".":f&&h===1?"//":t.slice(0,h)},basename(t,f){f!==void 0&&y(f,"ext"),y(t,"path");let h=0,s=-1,a=!0,d;if(f!==void 0&&f.length>0&&f.length<=t.length){if(f===t)return"";let $=f.length-1,D=-1;for(d=t.length-1;d>=0;--d){const b=t.charCodeAt(d);if(b===p){if(!a){h=d+1;break}}else D===-1&&(a=!1,D=d+1),$>=0&&(b===f.charCodeAt($)?--$===-1&&(s=d):($=-1,s=D))}return h===s?s=D:s===-1&&(s=t.length),t.slice(h,s)}for(d=t.length-1;d>=0;--d)if(t.charCodeAt(d)===p){if(!a){h=d+1;break}}else s===-1&&(a=!1,s=d+1);return s===-1?"":t.slice(h,s)},extname(t){y(t,"path");let f=-1,h=0,s=-1,a=!0,d=0;for(let $=t.length-1;$>=0;--$){const D=t.charCodeAt($);if(D===p){if(!a){h=$+1;break}continue}s===-1&&(a=!1,s=$+1),D===w?f===-1?f=$:d!==1&&(d=1):f!==-1&&(d=-1)}return f===-1||s===-1||d===0||d===1&&f===s-1&&f===h+1?"":t.slice(f,s)},format:r.bind(null,"/"),parse(t){y(t,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return f;const h=t.charCodeAt(0)===p;let s;h?(f.root="/",s=1):s=0;let a=-1,d=0,$=-1,D=!0,b=t.length-1,g=0;for(;b>=s;--b){const k=t.charCodeAt(b);if(k===p){if(!D){d=b+1;break}continue}$===-1&&(D=!1,$=b+1),k===w?a===-1?a=b:g!==1&&(g=1):a!==-1&&(g=-1)}if($!==-1){const k=d===0&&h?1:d;a===-1||g===0||g===1&&a===$-1&&a===d+1?f.base=f.name=t.slice(k,$):(f.name=t.slice(k,a),f.base=t.slice(k,$),f.ext=t.slice(a,$))}return d>0?f.dir=t.slice(0,d-1):h&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=u?e.$fc.normalize:e.$gc.normalize,e.$ic=u?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=u?e.$fc.join:e.$gc.join,e.$kc=u?e.$fc.resolve:e.$gc.resolve,e.$lc=u?e.$fc.relative:e.$gc.relative,e.$mc=u?e.$fc.dirname:e.$gc.dirname,e.$nc=u?e.$fc.basename:e.$gc.basename,e.$oc=u?e.$fc.extname:e.$gc.extname,e.$pc=u?e.$fc.format:e.$gc.format,e.$qc=u?e.$fc.parse:e.$gc.parse,e.$rc=u?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=u?e.$fc.sep:e.$gc.sep,e.$tc=u?e.$fc.delimiter:e.$gc.delimiter}),define(Se[131],De([1,0,43,17]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=e.$8q=e.$7q=e.$6q=e.$5q=e.$4q=e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;const L=new l.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),A=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new l.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function w(D,b,g=!1){const k=D||"",P=b||"",F=L.value.collator.compare(k,P);return L.value.collatorIsNumeric&&F===0&&k!==P?k<P?-1:1:F}e.$Xq=w;function p(D,b){const g=A.value.collator;return D=D||"",b=b||"",r(g,D,b)}e.$Yq=p;function E(D,b){const g=A.value.collator;return D=D||"",b=b||"",h(D,b)||r(g,D,b)}e.$Zq=E;function M(D,b){const g=A.value.collator;return D=D||"",b=b||"",f(D,b)||r(g,D,b)}e.$1q=M;function C(D,b){return D=D||"",b=b||"",D===b?0:D<b?-1:1}e.$2q=C;function v(D,b){const[g,k]=i(D),[P,F]=i(b);let U=L.value.collator.compare(k,F);if(U===0){if(L.value.collatorIsNumeric&&k!==F)return k<F?-1:1;if(U=L.value.collator.compare(g,P),L.value.collatorIsNumeric&&U===0&&g!==P)return g<P?-1:1}return U}e.$3q=v;function S(D,b){D=D||"",b=b||"";const g=n(D),k=n(b),P=A.value.collator,F=R.value.collator;return r(F,g,k)||r(P,D,b)}e.$4q=S;function y(D,b){D=D||"",b=b||"";const g=n(D),k=n(b),P=A.value.collator,F=R.value.collator;return r(F,g,k)||h(D,b)||r(P,D,b)}e.$5q=y;function u(D,b){D=D||"",b=b||"";const g=n(D),k=n(b),P=A.value.collator,F=R.value.collator;return r(F,g,k)||f(D,b)||r(P,D,b)}e.$6q=u;function m(D,b){D=D||"",b=b||"";const g=n(D).toLowerCase(),k=n(b).toLowerCase();return g!==k?g<k?-1:1:D!==b?D<b?-1:1:0}e.$7q=m;const o=/^(.*?)(\.([^.]*))?$/;function i(D,b=!1){const g=D?o.exec(D):[];let k=[g&&g[1]||"",g&&g[3]||""];return b&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function n(D){const b=D?o.exec(D):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function r(D,b,g){const k=D.compare(b,g);return k!==0?k:b.length!==g.length?b.length<g.length?-1:1:0}function c(D){const b=D.charAt(0);return b.toLocaleUpperCase()!==b}function t(D){const b=D.charAt(0);return b.toLocaleLowerCase()!==b}function f(D,b){return c(D)&&t(b)?-1:t(D)&&c(b)?1:0}function h(D,b){return t(D)&&c(b)?-1:c(D)&&t(b)?1:0}function s(D,b,g=!1){return g||(D=D&&D.toLowerCase(),b=b&&b.toLowerCase()),D===b?0:D<b?-1:1}function a(D,b,g=!1){const k=D.split(N.sep),P=b.split(N.sep),F=k.length-1,U=P.length-1;let z,T;for(let I=0;;I++){if(z=F===I,T=U===I,z&&T)return w(k[I],P[I],g);if(z)return-1;if(T)return 1;const O=s(k[I],P[I],g);if(O!==0)return O}}e.$8q=a;function d(D,b,g){const k=D.toLowerCase(),P=b.toLowerCase(),F=$(D,b,g);if(F)return F;const U=k.endsWith(g),z=P.endsWith(g);if(U!==z)return U?-1:1;const T=w(k,P);return T!==0?T:k.localeCompare(P)}e.$9q=d;function $(D,b,g){const k=D.toLowerCase(),P=b.toLowerCase(),F=k.startsWith(g),U=P.startsWith(g);if(F!==U)return F?-1:1;if(F&&U){if(k.length<P.length)return-1;if(k.length>P.length)return 1}return 0}e.$0q=$}),define(Se[34],De([1,0,17,11,14,18]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=void 0;function R(d){return d===47||d===92}e.$_f=R;function w(d){return d.replace(/[\\/]/g,l.$gc.sep)}e.$ag=w;function p(d){return d.indexOf("/")===-1&&(d=w(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.$bg=p;function E(d,$=l.$gc.sep){if(!d)return"";const D=d.length,b=d.charCodeAt(0);if(R(b)){if(R(d.charCodeAt(1))&&!R(d.charCodeAt(2))){let k=3;const P=k;for(;k<D&&!R(d.charCodeAt(k));k++);if(P!==k&&!R(d.charCodeAt(k+1))){for(k+=1;k<D;k++)if(R(d.charCodeAt(k)))return d.slice(0,k+1).replace(/[\\/]/g,$)}}return $}else if(o(b)&&d.charCodeAt(1)===58)return R(d.charCodeAt(2))?d.slice(0,2)+$:d.slice(0,2);let g=d.indexOf("://");if(g!==-1){for(g+=3;g<D;g++)if(R(d.charCodeAt(g)))return d.slice(0,g+1)}return""}e.$cg=E;function M(d){if(!N.$i||!d||d.length<5)return!1;let $=d.charCodeAt(0);if($!==92||($=d.charCodeAt(1),$!==92))return!1;let D=2;const b=D;for(;D<d.length&&($=d.charCodeAt(D),$!==92);D++);return!(b===D||($=d.charCodeAt(D+1),isNaN($)||$===92))}e.$dg=M;const C=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(d,$=N.$i){const D=$?C:v;return!(!d||d.length===0||/^\s+$/.test(d)||(D.lastIndex=0,D.test(d))||$&&S.test(d)||d==="."||d===".."||$&&d[d.length-1]==="."||$&&d.length!==d.trim().length||d.length>255)}e.$eg=y;function u(d,$,D){const b=d===$;return!D||b?b:!d||!$?!1:(0,L.$kf)(d,$)}e.$fg=u;function m(d,$,D,b=l.sep){if(d===$)return!0;if(!d||!$||$.length>d.length)return!1;if(D){if(!(0,L.$lf)(d,$))return!1;if($.length===d.length)return!0;let k=$.length;return $.charAt($.length-1)===b&&k--,d.charAt(k)===b}return $.charAt($.length-1)!==b&&($+=b),d.indexOf($)===0}e.$gg=m;function o(d){return d>=65&&d<=90||d>=97&&d<=122}e.$hg=o;function i(d,$){return N.$i&&d.endsWith(":")&&(d+=l.sep),(0,l.$ic)(d)||(d=(0,l.$jc)($,d)),d=(0,l.$hc)(d),N.$i?(d=(0,L.$5e)(d,l.sep),d.endsWith(":")&&(d+=l.sep)):(d=(0,L.$5e)(d,l.sep),d||(d=l.sep)),d}e.$ig=i;function n(d){const $=(0,l.$hc)(d);return N.$i?d.length>3?!1:r($)&&(d.length===2||$.charCodeAt(2)===92):$===l.$gc.sep}e.$jg=n;function r(d,$=N.$i){return $?o(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.$kg=r;function c(d,$=N.$i){return r(d,$)?d[0]:void 0}e.$lg=c;function t(d,$,D){return $.length>d.length?-1:d===$?0:(D&&(d=d.toLowerCase(),$=$.toLowerCase()),d.indexOf($))}e.$mg=t;function f(d){const $=d.split(":");let D,b,g;for(const k of $){const P=Number(k);(0,A.$Xf)(P)?b===void 0?b=P:g===void 0&&(g=P):D=D?[D,k].join(":"):k}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:b!==void 0?b:void 0,column:g!==void 0?g:b!==void 0?1:void 0}}e.$ng=f;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function a(d,$,D=8){let b="";for(let k=0;k<D;k++){let P;k===0&&N.$i&&!$&&(D===3||D===4)?P=s:P=h,b+=P.charAt(Math.floor(Math.random()*P.length))}let g;return $?g=`${$}-${b}`:g=b,d?(0,l.$jc)(d,g):g}e.$og=a}),define(Se[132],De([1,0,131,126,54,17,11,14]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=e.$br=e.$ar=e.$_q=e.$$q=void 0;const p=0,E=[p,[]];function M(j,G,te,x){if(!j||!G)return E;const Z=j.length,X=G.length;if(Z<X)return E;const ae=j.toLowerCase();return C(G,te,X,j,ae,Z,x)}e.$$q=M;function C(j,G,te,x,Z,X,ae){const _=[],ge=[];for(let ie=0;ie<te;ie++){const ke=ie*X,le=ke-X,ue=ie>0,ce=j[ie],de=G[ie];for(let H=0;H<X;H++){const Y=H>0,he=ke+H,be=he-1,Pe=le+H-1,we=Y?_[be]:0,Ae=ue&&Y?_[Pe]:0,Oe=ue&&Y?ge[Pe]:0;let ze;!Ae&&ue?ze=0:ze=v(ce,de,x,Z,H,Oe),ze&&Ae+ze>=we&&(ae||ue||Z.startsWith(G,H))?(ge[he]=Oe+1,_[he]=Ae+ze):(ge[he]=p,_[he]=we)}}const se=[];let re=te-1,B=X-1;for(;re>=0&&B>=0;){const ie=re*X+B;ge[ie]===p||(se.push(B),re--),B--}return[_[te*X-1],se.reverse()]}function v(j,G,te,x,Z,X){let ae=0;if(!S(G,x[Z]))return ae;if(ae+=1,X>0&&(ae+=X*5),j===te[Z]&&(ae+=1),Z===0)ae+=8;else{const _=y(te.charCodeAt(Z-1));_?ae+=_:(0,N.$$j)(te.charCodeAt(Z))&&X===0&&(ae+=2)}return ae}function S(j,G){return j===G?!0:j==="/"||j==="\\"?G==="/"||G==="\\":!1}function y(j){switch(j){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const u=[void 0,[]];function m(j,G,te=0,x=0){const Z=G;return Z.values&&Z.values.length>1?o(j,Z.values,te,x):i(j,G,te,x)}e.$_q=m;function o(j,G,te,x){let Z=0;const X=[];for(const ae of G){const[_,ge]=i(j,ae,te,x);if(typeof _!="number")return u;Z+=_,X.push(...ge)}return[Z,D(X)]}function i(j,G,te,x){const Z=(0,N.$hk)(G.original,G.originalLowercase,te,j,j.toLowerCase(),x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Z?[Z[0],(0,N.$ek)(Z)]:u}const n=Object.freeze({score:0}),r=1<<18,c=1<<17,t=65536;function f(j,G,te,x){const Z=x.values?x.values:[x];return(0,L.$7i)({[x.normalized]:{values:Z.map(ae=>({value:ae.normalized,expectContiguousMatch:ae.expectContiguousMatch})),label:j,description:G,allowNonContiguousMatches:te}})}function h(j,G,te,x,Z){if(!j||!G.normalized)return n;const X=x.getItemLabel(j);if(!X)return n;const ae=x.getItemDescription(j),_=f(X,ae,te,G),ge=Z[_];if(ge)return ge;const se=s(X,ae,x.getItemPath(j),G,te);return Z[_]=se,se}e.$ar=h;function s(j,G,te,x,Z){const X=!te||!x.containsPathSeparator;return te&&(R.$k?x.pathNormalized===te:(0,w.$kf)(x.pathNormalized,te))?{score:r,labelMatch:[{start:0,end:j.length}],descriptionMatch:G?[{start:0,end:G.length}]:void 0}:x.values&&x.values.length>1?a(j,G,te,x.values,X,Z):d(j,G,te,x,X,Z)}function a(j,G,te,x,Z,X){let ae=0;const _=[],ge=[];for(const se of x){const{score:re,labelMatch:B,descriptionMatch:ie}=d(j,G,te,se,Z,X);if(re===p)return n;ae+=re,B&&_.push(...B),ie&&ge.push(...ie)}return{score:ae,labelMatch:D(_),descriptionMatch:D(ge)}}function d(j,G,te,x,Z,X){if(Z||!G){const[ae,_]=M(j,x.normalized,x.normalizedLowercase,X&&!x.expectContiguousMatch);if(ae){const ge=(0,N.$8j)(x.normalized,j);let se;if(ge){se=c;const re=Math.round(x.normalized.length/j.length*100);se+=re}else se=t;return{score:se+ae,labelMatch:ge||$(_)}}}if(G){let ae=G;te&&(ae=`${G}${A.sep}`);const _=ae.length,ge=`${ae}${j}`,[se,re]=M(ge,x.normalized,x.normalizedLowercase,X&&!x.expectContiguousMatch);if(se){const B=$(re),ie=[],ke=[];return B.forEach(le=>{le.start<_&&le.end>_?(ie.push({start:0,end:le.end-_}),ke.push({start:le.start,end:_})):le.start>=_?ie.push({start:le.start-_,end:le.end-_}):ke.push(le)}),{score:se,labelMatch:ie,descriptionMatch:ke}}}return n}function $(j){const G=[];if(!j)return G;let te;for(const x of j)te&&te.end===x?te.end+=1:(te={start:x,end:x+1},G.push(te));return G}function D(j){const G=j.sort((Z,X)=>Z.start-X.start),te=[];let x;for(const Z of G)!x||!b(x,Z)?(x=Z,te.push(Z)):(x.start=Math.min(x.start,Z.start),x.end=Math.max(x.end,Z.end));return te}function b(j,G){return!(j.end<G.start||G.end<j.start)}function g(j,G,te,x,Z,X){const ae=h(j,te,x,Z,X),_=h(G,te,x,Z,X),ge=ae.score,se=_.score;if((ge===r||se===r)&&ge!==se)return ge===r?-1:1;if(ge>t||se>t){if(ge!==se)return ge>se?-1:1;if(ge<c&&se<c){const ce=P(ae.labelMatch,_.labelMatch);if(ce!==0)return ce}const le=Z.getItemLabel(j)||"",ue=Z.getItemLabel(G)||"";if(le.length!==ue.length)return le.length-ue.length}if(ge!==se)return ge>se?-1:1;const re=Array.isArray(ae.labelMatch)&&ae.labelMatch.length>0,B=Array.isArray(_.labelMatch)&&_.labelMatch.length>0;if(re&&!B)return-1;if(B&&!re)return 1;const ie=k(j,ae,Z),ke=k(G,_,Z);return ie&&ke&&ie!==ke?ke>ie?-1:1:F(j,G,te,Z)}e.$br=g;function k(j,G,te){let x=-1,Z=-1;if(G.descriptionMatch&&G.descriptionMatch.length?x=G.descriptionMatch[0].start:G.labelMatch&&G.labelMatch.length&&(x=G.labelMatch[0].start),G.labelMatch&&G.labelMatch.length){if(Z=G.labelMatch[G.labelMatch.length-1].end,G.descriptionMatch&&G.descriptionMatch.length){const X=te.getItemDescription(j);X&&(Z+=X.length)}}else G.descriptionMatch&&G.descriptionMatch.length&&(Z=G.descriptionMatch[G.descriptionMatch.length-1].end);return Z-x}function P(j,G){if(!j&&!G||(!j||!j.length)&&(!G||!G.length))return 0;if(!G||!G.length)return-1;if(!j||!j.length)return 1;const te=j[0].start,Z=j[j.length-1].end-te,X=G[0].start,_=G[G.length-1].end-X;return Z===_?0:_<Z?1:-1}function F(j,G,te,x){const Z=x.getItemLabel(j)||"",X=x.getItemLabel(G)||"",ae=x.getItemDescription(j),_=x.getItemDescription(G),ge=Z.length+(ae?ae.length:0),se=X.length+(_?_.length:0);if(ge!==se)return ge-se;const re=x.getItemPath(j),B=x.getItemPath(G);return re&&B&&re.length!==B.length?re.length-B.length:Z!==X?(0,l.$9q)(Z,X,te.normalized):ae&&_&&ae!==_?(0,l.$9q)(ae,_,te.normalized):re&&B&&re!==B?(0,l.$9q)(re,B,te.normalized):0}function U(j){return j.startsWith('"')&&j.endsWith('"')}const z=" ";function T(j){typeof j!="string"&&(j="");const G=j.toLowerCase(),{pathNormalized:te,normalized:x,normalizedLowercase:Z}=I(j),X=te.indexOf(A.sep)>=0,ae=U(j);let _;const ge=j.split(z);if(ge.length>1)for(const se of ge){const re=U(se),{pathNormalized:B,normalized:ie,normalizedLowercase:ke}=I(se);ie&&(_||(_=[]),_.push({original:se,originalLowercase:se.toLowerCase(),pathNormalized:B,normalized:ie,normalizedLowercase:ke,expectContiguousMatch:re}))}return{original:j,originalLowercase:G,pathNormalized:te,normalized:x,normalizedLowercase:Z,values:_,containsPathSeparator:X,expectContiguousMatch:ae}}e.$cr=T;function I(j){let G;R.$i?G=j.replace(/\//g,A.sep):G=j.replace(/\\/g,A.sep);const te=(0,w.$7e)(G).replace(/\s|"/g,"");return{pathNormalized:G,normalized:te,normalizedLowercase:te.toLowerCase()}}function O(j){return Array.isArray(j)?T(j.map(G=>G.original).join(z)):T(j.original)}e.$dr=O}),define(Se[101],De([1,0,17]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=e.$xs=e.$ws=e.$vs=e.$us=void 0,e.$us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(M){const C=(0,l.$oc)(M),v=N[C.toLowerCase()];return v!==void 0?v:R(M)}e.$vs=A;function R(M){const C=(0,l.$oc)(M);return L[C.toLowerCase()]}e.$ws=R;function w(M){for(const C in L)if(L[C]===M)return C}e.$xs=w;const p=/^(.+)\/(.+?)(;.+)?$/;function E(M,C){const v=p.exec(M);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:C?void 0:M}e.$ys=E}),define(Se[102],De([1,0,11]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4l=e.$3l=e.TerminateResponseCode=e.Source=void 0;var N;(function(w){w[w.stdout=0]="stdout",w[w.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(w){w[w.Success=0]="Success",w[w.Unknown=1]="Unknown",w[w.AccessDenied=2]="AccessDenied",w[w.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(w,...p){const E=p.reduce((v,S)=>(v[S]=!0,v),{}),M=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(w).filter(v=>!E[v]).forEach(v=>{for(let S=0;S<M.length;S++)if(v.search(M[S])!==-1){delete w[v];break}})}e.$3l=A;function R(w){w&&(delete w.DEBUG,l.$j&&delete w.DYLD_LIBRARY_PATH,l.$k&&delete w.LD_PRELOAD)}e.$4l=R}),define(Se[2],De([1,0,17,11]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,R=/^\/\//;function w(s,a){if(!s.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function p(s,a){return!s&&!a?"file":s}function E(s,a){switch(s){case"https":case"http":case"file":a?a[0]!==C&&(a=C+a):a=C;break}return a}const M="",C="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(a){return a instanceof S?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,d,$,D,b,g=!1){typeof a=="object"?(this.scheme=a.scheme||M,this.authority=a.authority||M,this.path=a.path||M,this.query=a.query||M,this.fragment=a.fragment||M):(this.scheme=p(a,g),this.authority=d||M,this.path=E(this.scheme,$||M),this.query=D||M,this.fragment=b||M,w(this,g))}get fsPath(){return r(this,!1)}with(a){if(!a)return this;let{scheme:d,authority:$,path:D,query:b,fragment:g}=a;return d===void 0?d=this.scheme:d===null&&(d=M),$===void 0?$=this.authority:$===null&&($=M),D===void 0?D=this.path:D===null&&(D=M),b===void 0?b=this.query:b===null&&(b=M),g===void 0?g=this.fragment:g===null&&(g=M),d===this.scheme&&$===this.authority&&D===this.path&&b===this.query&&g===this.fragment?this:new m(d,$,D,b,g)}static parse(a,d=!1){const $=v.exec(a);return $?new m($[2]||M,h($[4]||M),h($[5]||M),h($[7]||M),h($[9]||M),d):new m(M,M,M,M,M)}static file(a){let d=M;if(N.$i&&(a=a.replace(/\\/g,C)),a[0]===C&&a[1]===C){const $=a.indexOf(C,2);$===-1?(d=a.substring(2),a=C):(d=a.substring(2,$),a=a.substring($)||C)}return new m("file",d,a,M,M)}static from(a,d){return new m(a.scheme,a.authority,a.path,a.query,a.fragment,d)}static joinPath(a,...d){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return N.$i&&a.scheme==="file"?$=S.file(l.$fc.join(r(a,!0),...d)).path:$=l.$gc.join(a.path,...d),a.with({path:$})}toString(a=!1){return c(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof S)return a;{const d=new m(a);return d._formatted=a.external??null,d._fsPath=a._sep===u?a.fsPath??null:null,d}}else return a}}e.URI=S;function y(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=y;const u=N.$i?1:void 0;class m extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=r(this,!1)),this._fsPath}toString(a=!1){return a?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=u),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const o={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function i(s,a,d){let $,D=-1;for(let b=0;b<s.length;b++){const g=s.charCodeAt(b);if(g>=97&&g<=122||g>=65&&g<=90||g>=48&&g<=57||g===45||g===46||g===95||g===126||a&&g===47||d&&g===91||d&&g===93||d&&g===58)D!==-1&&($+=encodeURIComponent(s.substring(D,b)),D=-1),$!==void 0&&($+=s.charAt(b));else{$===void 0&&($=s.substr(0,b));const k=o[g];k!==void 0?(D!==-1&&($+=encodeURIComponent(s.substring(D,b)),D=-1),$+=k):D===-1&&(D=b)}}return D!==-1&&($+=encodeURIComponent(s.substring(D))),$!==void 0?$:s}function n(s){let a;for(let d=0;d<s.length;d++){const $=s.charCodeAt(d);$===35||$===63?(a===void 0&&(a=s.substr(0,d)),a+=o[$]):a!==void 0&&(a+=s[d])}return a!==void 0?a:s}function r(s,a){let d;return s.authority&&s.path.length>1&&s.scheme==="file"?d=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?a?d=s.path.substr(1):d=s.path[1].toLowerCase()+s.path.substr(2):d=s.path,N.$i&&(d=d.replace(/\//g,"\\")),d}e.$wc=r;function c(s,a){const d=a?n:i;let $="",{scheme:D,authority:b,path:g,query:k,fragment:P}=s;if(D&&($+=D,$+=":"),(b||D==="file")&&($+=C,$+=C),b){let F=b.indexOf("@");if(F!==-1){const U=b.substr(0,F);b=b.substr(F+1),F=U.lastIndexOf(":"),F===-1?$+=d(U,!1,!1):($+=d(U.substr(0,F),!1,!1),$+=":",$+=d(U.substr(F+1),!1,!0)),$+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?$+=d(b,!1,!0):($+=d(b.substr(0,F),!1,!0),$+=b.substr(F))}if(g){if(g.length>=3&&g.charCodeAt(0)===47&&g.charCodeAt(2)===58){const F=g.charCodeAt(1);F>=65&&F<=90&&(g=`/${String.fromCharCode(F+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===58){const F=g.charCodeAt(0);F>=65&&F<=90&&(g=`${String.fromCharCode(F+32)}:${g.substr(2)}`)}$+=d(g,!0,!1)}return k&&($+="?",$+=d(k,!1,!1)),P&&($+="#",$+=a?P:i(P,!1,!1)),$}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(s){return s.match(f)?s.replace(f,a=>t(a)):s}}),define(Se[190],De([1,0,2]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Dq=e.$Cq=e.$Bq=void 0;function N(E){const M=E;return M&&typeof M.type=="string"&&typeof M.severity=="string"}e.$Bq=N;function L(E){const M=[];let C;try{const v=JSON.parse(E.arguments),S=v[v.length-1];S&&S.__$stack&&(v.pop(),C=S.__$stack),M.push(...v)}catch{M.push("Unable to log remote console arguments",E.arguments)}return{args:M,stack:C}}e.$Cq=L;function A(E){if(typeof E!="string")return A(L(E).stack);const M=E;if(M){const C=R(M),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(v&&v.length===4)return{uri:l.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$Dq=A;function R(E){if(!E)return E;const M=E.indexOf(`
`);return M===-1?E:E.substring(0,M)}function w(E,M){const{args:C,stack:v}=L(E),S=typeof C[0]=="string"&&C.length===1;let y=R(v);y&&(y=`(${y.trim()})`);let u=[];if(typeof C[0]=="string"?y&&S?u=[`%c[${M}] %c${C[0]} %c${y}`,p("blue"),p(""),p("grey")]:u=[`%c[${M}] %c${C[0]}`,p("blue"),p(""),...C.slice(1)]:u=[`%c[${M}]%`,p("blue"),...C],y&&!S&&u.push(y),typeof console[E.severity]!="function")throw new Error("Unknown console method");console[E.severity].apply(console,u)}e.log=w;function p(E){return`color: ${E}`}}),define(Se[56],De([1,0,21,2]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ph=e.$Oh=e.$Nh=void 0;function L(p){return JSON.stringify(p,R)}e.$Nh=L;function A(p){let E=JSON.parse(p);return E=w(E),E}e.$Oh=A;function R(p,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function w(p,E=0){if(!p||E>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return N.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 17:return new Date(p.source)}if(p instanceof l.$te||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let M=0;M<p.length;++M)p[M]=w(p[M],E+1);else for(const M in p)Object.hasOwnProperty.call(p,M)&&(p[M]=w(p[M],E+1))}return p}e.$Ph=w}),define(Se[15],De([1,0,13,11,14,2,17]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.Schemas=void 0;var w;(function(y){y.inMemory="inmemory",y.vscode="vscode",y.internal="private",y.walkThrough="walkThrough",y.walkThroughSnippet="walkThroughSnippet",y.http="http",y.https="https",y.file="file",y.mailto="mailto",y.untitled="untitled",y.data="data",y.command="command",y.vscodeRemote="vscode-remote",y.vscodeRemoteResource="vscode-remote-resource",y.vscodeManagedRemoteResource="vscode-managed-remote-resource",y.vscodeUserData="vscode-userdata",y.vscodeCustomEditor="vscode-custom-editor",y.vscodeNotebookCell="vscode-notebook-cell",y.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",y.vscodeNotebookCellOutput="vscode-notebook-cell-output",y.vscodeInteractiveInput="vscode-interactive-input",y.vscodeSettings="vscode-settings",y.vscodeWorkspaceTrust="vscode-workspace-trust",y.vscodeTerminal="vscode-terminal",y.vscodeChatCodeBlock="vscode-chat-code-block",y.vscodeChatSesssion="vscode-chat-editor",y.webviewPanel="webview-panel",y.vscodeWebview="vscode-webview",y.extension="extension",y.vscodeFileResource="vscode-file",y.tmp="tmp",y.vsls="vsls",y.vscodeSourceControl="vscode-scm",y.codeSetting="code-setting"})(w||(e.Schemas=w={}));function p(y,u){return A.URI.isUri(y)?(0,L.$kf)(y.scheme,u):(0,L.$lf)(y,u+":")}e.$pg=p;function E(y,...u){return u.some(m=>p(y,m))}e.$qg=E,e.$rg="vscode-tkn",e.$sg="tkn";class M{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u,m){this.f=C(u,m)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,w.vscodeRemoteResource)}set(u,m,o){this.a[u]=m,this.b[u]=o}setConnectionToken(u,m){this.c[u]=m}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(c){return l.$1(c),u}const m=u.authority;let o=this.a[m];o&&o.indexOf(":")!==-1&&o.indexOf("[")===-1&&(o=`[${o}]`);const i=this.b[m],n=this.c[m];let r=`path=${encodeURIComponent(u.path)}`;return typeof n=="string"&&(r+=`&${e.$sg}=${encodeURIComponent(n)}`),A.URI.from({scheme:N.$o?this.d:w.vscodeRemoteResource,authority:`${o}:${i}`,path:this.g,query:r})}}e.$tg=new M;function C(y,u){return R.$gc.join(u??"/",`${y.quality??"oss"}-${y.commit??"dev"}`)}e.$ug=C,e.$vg="vs/../../extensions",e.$wg="vs/../../node_modules",e.$xg="vs/../../node_modules.asar",e.$yg="vs/../../node_modules.asar.unpacked",e.$zg="vscode-app";class v{static{this.a=e.$zg}asBrowserUri(u){const m=this.b(u,fe);return this.uriToBrowserUri(m)}uriToBrowserUri(u){return u.scheme===w.vscodeRemote?e.$tg.rewrite(u):u.scheme===w.file&&(N.$m||N.$q===`${w.vscodeFileResource}://${v.a}`)?u.with({scheme:w.vscodeFileResource,authority:u.authority||v.a,query:null,fragment:null}):u}asFileUri(u){const m=this.b(u,fe);return this.uriToFileUri(m)}uriToFileUri(u){return u.scheme===w.vscodeFileResource?u.with({scheme:w.file,authority:u.authority!==v.a?u.authority:null,query:null,fragment:null}):u}b(u,m){return A.URI.isUri(u)?u:A.URI.parse(m.toUrl(u))}}e.$Ag=new v;var S;(function(y){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);y.CoopAndCoep=Object.freeze(u.get("3"));const m="vscode-coi";function o(n){let r;typeof n=="string"?r=new URL(n).searchParams:n instanceof URL?r=n.searchParams:A.URI.isUri(n)&&(r=new URL(n.toString(!0)).searchParams);const c=r?.get(m);if(c)return u.get(c)}y.getHeadersFromQuery=o;function i(n,r,c){if(!globalThis.crossOriginIsolated)return;const t=r&&c?"3":c?"2":"1";n instanceof URLSearchParams?n.set(m,t):n[m]=t}y.addSearchParam=i})(S||(e.COI=S={}))}),define(Se[191],De([1,0,161,15,11,2]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xD=void 0;class R{constructor(v,S,y){this.id=v,this.dependencies=S,this.callback=y}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,S,y)=>{typeof v!="string"&&(y=S,S=v,v=null),(typeof S!="object"||!Array.isArray(S))&&(y=S,S=null),this.c.push(new R(v,S,y))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const S=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!S)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h(v){return new Promise((S,y)=>{const u=document.createElement("script");u.setAttribute("async","async"),u.setAttribute("type","text/javascript");const m=()=>{u.removeEventListener("load",o),u.removeEventListener("error",i)},o=n=>{m(),S(this.c.pop())},i=n=>{m(),y(n)};u.addEventListener("load",o),u.addEventListener("error",i),this.f&&(v=this.f.createScriptURL(v)),u.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(u)})}i(v){return new Promise((S,y)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),S(this.c.pop())}catch(u){y(u)}})}async j(v){try{const S=globalThis._VSCODE_NODE_MODULES.fs,y=globalThis._VSCODE_NODE_MODULES.vm,u=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(v).fsPath,o=S.readFileSync(m).toString(),i=u.wrap(o.replace(/^#!.*/,""));return new y.Script(i).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const p=new Map;let E={};typeof globalThis.require=="object"&&(E=globalThis.require.paths??{});async function M(C,v,S){if(l.$T){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),E[C]&&(C=E[C]);const y=`${C}/${v}`;if(p.has(y))return p.get(y);let u;if(/^\w[\w\d+.-]*:\/\//.test(y))u=y;else{const n=`${S&&!L.$o?N.$xg:N.$wg}/${y}`;u=N.$Ag.asBrowserUri(n).toString(!0)}const m=w.INSTANCE.load(u);return p.set(y,m),m}else return await new Promise((y,u)=>{fe([C],y,u)})}e.$xD=M}),define(Se[23],De([1,0,34,15,17,11,14,2]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4g=e.DataUri=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=void 0;function p(S){return(0,w.$wc)(S,!0)}e.$Hg=p;class E{constructor(y){this.a=y}compare(y,u,m=!1){return y===u?0:(0,R.$df)(this.getComparisonKey(y,m),this.getComparisonKey(u,m))}isEqual(y,u,m=!1){return y===u?!0:!y||!u?!1:this.getComparisonKey(y,m)===this.getComparisonKey(u,m)}getComparisonKey(y,u=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:u?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,u,m=!1){if(y.scheme===u.scheme){if(y.scheme===N.Schemas.file)return l.$gg(p(y),p(u),this.a(y))&&y.query===u.query&&(m||y.fragment===u.fragment);if((0,e.$Yg)(y.authority,u.authority))return l.$gg(y.path,u.path,this.a(y),"/")&&y.query===u.query&&(m||y.fragment===u.fragment)}return!1}joinPath(y,...u){return w.URI.joinPath(y,...u)}basenameOrAuthority(y){return(0,e.$Qg)(y)||y.authority}basename(y){return L.$gc.basename(y.path)}extname(y){return L.$gc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let u;return y.scheme===N.Schemas.file?u=w.URI.file(L.$mc(p(y))).path:(u=L.$gc.dirname(y.path),y.authority&&u.length&&u.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),u="/")),y.with({path:u})}normalizePath(y){if(!y.path.length)return y;let u;return y.scheme===N.Schemas.file?u=w.URI.file(L.$hc(p(y))).path:u=L.$gc.normalize(y.path),y.with({path:u})}relativePath(y,u){if(y.scheme!==u.scheme||!(0,e.$Yg)(y.authority,u.authority))return;if(y.scheme===N.Schemas.file){const i=L.$lc(p(y),p(u));return A.$i?l.$ag(i):i}let m=y.path||"/";const o=u.path||"/";if(this.a(y)){let i=0;for(const n=Math.min(m.length,o.length);i<n&&!(m.charCodeAt(i)!==o.charCodeAt(i)&&m.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);m=o.substr(0,i)+m.substr(i)}return L.$gc.relative(m,o)}resolvePath(y,u){if(y.scheme===N.Schemas.file){const m=w.URI.file(L.$kc(p(y),u));return y.with({authority:m.authority,path:m.path})}return u=l.$bg(u),y.with({path:L.$gc.resolve(y.path,u)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,u){return y===u||y!==void 0&&u!==void 0&&(0,R.$kf)(y,u)}hasTrailingPathSeparator(y,u=L.sep){if(y.scheme===N.Schemas.file){const m=p(y);return m.length>l.$cg(m).length&&m[m.length-1]===u}else{const m=y.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,u=L.sep){return(0,e.$Zg)(y,u)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,u=L.sep){let m=!1;if(y.scheme===N.Schemas.file){const o=p(y);m=o!==void 0&&o.length===l.$cg(o).length&&o[o.length-1]===u}else{u="/";const o=y.path;m=o.length===1&&o.charCodeAt(o.length-1)===47}return!m&&!(0,e.$Zg)(y,u)?y.with({path:y.path+"/"}):y}}e.$Ig=E,e.$Jg=new E(()=>!1),e.$Kg=new E(S=>S.scheme===N.Schemas.file?!A.$k:!0),e.$Lg=new E(S=>!0),e.$Mg=e.$Jg.isEqual.bind(e.$Jg),e.$Ng=e.$Jg.isEqualOrParent.bind(e.$Jg),e.$Og=e.$Jg.getComparisonKey.bind(e.$Jg),e.$Pg=e.$Jg.basenameOrAuthority.bind(e.$Jg),e.$Qg=e.$Jg.basename.bind(e.$Jg),e.$Rg=e.$Jg.extname.bind(e.$Jg),e.$Sg=e.$Jg.dirname.bind(e.$Jg),e.$Tg=e.$Jg.joinPath.bind(e.$Jg),e.$Ug=e.$Jg.normalizePath.bind(e.$Jg),e.$Vg=e.$Jg.relativePath.bind(e.$Jg),e.$Wg=e.$Jg.resolvePath.bind(e.$Jg),e.$Xg=e.$Jg.isAbsolutePath.bind(e.$Jg),e.$Yg=e.$Jg.isEqualAuthority.bind(e.$Jg),e.$Zg=e.$Jg.hasTrailingPathSeparator.bind(e.$Jg),e.$1g=e.$Jg.removeTrailingPathSeparator.bind(e.$Jg),e.$2g=e.$Jg.addTrailingPathSeparator.bind(e.$Jg);function M(S,y){const u=[];for(let m=0;m<S.length;m++){const o=y(S[m]);S.some((i,n)=>n===m?!1:(0,e.$Ng)(o,y(i)))||u.push(S[m])}return u}e.$3g=M;var C;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function y(u){const m=new Map;u.path.substring(u.path.indexOf(";")+1,u.path.lastIndexOf(";")).split(";").forEach(n=>{const[r,c]=n.split(":");r&&c&&m.set(r,c)});const i=u.path.substring(0,u.path.indexOf(";"));return i&&m.set(S.META_DATA_MIME,i),m}S.parseMetaData=y})(C||(e.DataUri=C={}));function v(S,y,u){if(y){let m=S.path;return m&&m[0]!==L.$gc.sep&&(m=L.$gc.sep+m),S.with({scheme:u,authority:y,path:m})}return S.with({scheme:u})}e.$4g=v}),define(Se[8],De([1,0,22,13,4,3,23,11,167,43]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.Promises=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=void 0;function M(de){return!!de&&typeof de.then=="function"}e.$5g=M;function C(de){const H=new l.$de,Y=de(H.token),he=new Promise((be,Pe)=>{const we=H.token.onCancellationRequested(()=>{we.dispose(),Pe(new N.$5)});Promise.resolve(Y).then(Ae=>{we.dispose(),H.dispose(),be(Ae)},Ae=>{we.dispose(),H.dispose(),Pe(Ae)})});return new class{cancel(){H.cancel(),H.dispose()}then(be,Pe){return he.then(be,Pe)}catch(be){return this.then(void 0,be)}finally(be){return he.finally(be)}}}e.$6g=C;function v(de,H,Y){return new Promise((he,be)=>{const Pe=H.onCancellationRequested(()=>{Pe.dispose(),he(Y)});de.then(he,be).finally(()=>Pe.dispose())})}e.$7g=v;function S(de,H){return new Promise((Y,he)=>{const be=H.onCancellationRequested(()=>{be.dispose(),he(new N.$5)});de.then(Y,he).finally(()=>be.dispose())})}e.$8g=S;async function y(de){let H=-1;const Y=de.map((he,be)=>he.then(Pe=>(H=be,Pe)));try{return await Promise.race(Y)}finally{de.forEach((he,be)=>{be!==H&&he.cancel()})}}e.$9g=y;function u(de,H,Y){let he;const be=setTimeout(()=>{he?.(void 0),Y?.()},H);return Promise.race([de.finally(()=>clearTimeout(be)),new Promise(Pe=>he=Pe)])}e.$0g=u;function m(de){return new Promise((H,Y)=>{const he=de();M(he)?he.then(H,Y):H(he)})}e.$$g=m;function o(){let de,H;return{promise:new Promise((he,be)=>{de=he,H=be}),resolve:de,reject:H}}e.$_g=o;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=H(),new Promise((Y,he)=>{this.a.then(be=>{this.a=null,Y(be)},be=>{this.a=null,he(be)})})}dispose(){this.f=!0}}e.$ah=i;class n{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$bh=n;class r{constructor(){this.a=new Map}queue(H,Y){const be=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(H)===be&&this.a.delete(H)});return this.a.set(H,be),be}}e.$ch=r;const c=(de,H)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,H()},de);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},t=de=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,de())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class f{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,Y=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((be,Pe)=>{this.d=be,this.f=Pe}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===p.$3d?t(he):c(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$dh=f;class h{constructor(H){this.a=new f(H),this.b=new i}trigger(H,Y){return this.a.trigger(()=>this.b.queue(H),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$eh=h;class s{constructor(){this.a=!1,this.b=new Promise((H,Y)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$fh=s;class a extends s{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$gh=a;function d(de,H){return H?new Promise((Y,he)=>{const be=setTimeout(()=>{Pe.dispose(),Y()},de),Pe=H.onCancellationRequested(()=>{clearTimeout(be),Pe.dispose(),he(new N.$5)})}):C(Y=>d(de,Y))}e.$hh=d;function $(de,H=0,Y){const he=setTimeout(()=>{de(),Y&&be.dispose()},H),be=(0,A.$Rc)(()=>{clearTimeout(he),Y?.deleteAndLeak(be)});return Y?.add(be),be}e.$ih=$;function D(de){const H=[];let Y=0;const he=de.length;function be(){return Y<he?de[Y++]():null}function Pe(we){we!=null&&H.push(we);const Ae=be();return Ae?Ae.then(Pe):Promise.resolve(H)}return Promise.resolve(null).then(Pe)}e.$jh=D;function b(de,H=he=>!!he,Y=null){let he=0;const be=de.length,Pe=()=>{if(he>=be)return Promise.resolve(Y);const we=de[he++];return Promise.resolve(we()).then(Oe=>H(Oe)?Promise.resolve(Oe):Pe())};return Pe()}e.$kh=b;function g(de,H=he=>!!he,Y=null){if(de.length===0)return Promise.resolve(Y);let he=de.length;const be=()=>{he=-1;for(const Pe of de)Pe.cancel?.()};return new Promise((Pe,we)=>{for(const Ae of de)Ae.then(Oe=>{--he>=0&&H(Oe)?(be(),Pe(Oe)):he===0&&Pe(Y)}).catch(Oe=>{--he>=0&&(be(),we(Oe))})})}e.$lh=g;class k{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new L.$6d}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:H,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const Y=H.factory();Y.then(H.c,H.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$mh=k;class P extends k{constructor(){super(1)}}e.$nh=P;class F{constructor(){this.a=new X,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$oh=F;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new ge;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,Y=R.$Jg){const he=Y.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,Y,he=R.$Jg){const be=he.getComparisonKey(H);let Pe=this.a.get(be);if(!Pe){Pe=new P;const we=this.f++,Ae=L.Event.once(Pe.onDrained)(()=>{Pe?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(we,Ae),this.a.set(be,Pe)}return Pe.queue(Y)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ph=U;class z{constructor(H,Y){this.a=-1,typeof H=="function"&&typeof Y=="number"&&this.setIfNotSet(H,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},Y)}setIfNotSet(H,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},Y))}}e.$qh=z;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,Y,he=globalThis){this.cancel();const be=he.setInterval(()=>{H()},Y);this.d=(0,A.$Rc)(()=>{he.clearInterval(be),this.d=void 0})}dispose(){this.cancel()}}e.$rh=T;class I{constructor(H,Y){this.b=-1,this.a=H,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$sh=I;class O{constructor(H,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=H,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$th=O;class j extends I{constructor(H,Y){super(H,Y),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$uh=j;class G extends A.$Tc{constructor(H,Y){super(),this.g=H,this.h=Y,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of H)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new I(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$vh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$xh=(de,H)=>{(0,w.$B)(()=>{if(Y)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$xh=(de,H,Y)=>{const he=de.requestIdleCallback(H,typeof Y=="number"?{timeout:Y}:void 0);let be=!1;return{dispose(){be||(be=!0,de.cancelIdleCallback(he))}}},e.$wh=de=>(0,e.$xh)(globalThis,de)}();class te{constructor(H,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$xh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$yh=te;class x extends te{constructor(H){super(globalThis,H)}}e.$zh=x;async function Z(de,H,Y){let he;for(let be=0;be<Y;be++)try{return await de()}catch(Pe){he=Pe,await d(H)}throw he}e.$Ah=Z;class X{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,Y,he){return this.a={taskId:H,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(H),()=>this.d(H)),Y}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:Y,resolve:he,reject:be}=o();this.b={run:H,promise:Y,promiseResolve:he,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Bh=X;class ae{constructor(H,Y=()=>Date.now()){this.d=H,this.f=Y,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Ch=ae;var _;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(_||(_={}));class ge{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,Y)=>{this.a=H,this.b=Y})}complete(H){return new Promise(Y=>{this.a(H),this.d={outcome:0,value:H},Y()})}error(H){return new Promise(Y=>{this.b(H),this.d={outcome:1,value:H},Y()})}cancel(){return this.error(new N.$5)}}e.$Dh=ge;var se;(function(de){async function H(he){let be;const Pe=await Promise.all(he.map(we=>we.then(Ae=>Ae,Ae=>{be||(be=Ae)})));if(typeof be<"u")throw be;return Pe}de.settled=H;function Y(he){return new Promise(async(be,Pe)=>{try{await he(be,Pe)}catch(we){Pe(we)}})}de.withAsyncBody=Y})(se||(e.Promises=se={}));class re{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Eh=re;class B{constructor(H){this.b=H,this.a=new E.$V(()=>new re(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Fh=B;var ie;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(ie||(ie={}));class ke{static fromArray(H){return new ke(Y=>{Y.emitMany(H)})}static fromPromise(H){return new ke(async Y=>{Y.emitMany(await H)})}static fromPromises(H){return new ke(async Y=>{await Promise.all(H.map(async he=>Y.emitOne(await he)))})}static merge(H){return new ke(async Y=>{await Promise.all(H.map(async he=>{for await(const be of he)Y.emitOne(be)}))})}static{this.EMPTY=ke.fromArray([])}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new L.$6d,queueMicrotask(async()=>{const Y={emitOne:he=>this.g(he),emitMany:he=>this.h(he),reject:he=>this.k(he)};try{await Promise.resolve(H(Y)),this.j()}catch(he){this.k(he)}finally{Y.emitOne=void 0,Y.emitMany=void 0,Y.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.f.event)}while(!0)}}}static map(H,Y){return new ke(async he=>{for await(const be of H)he.emitOne(Y(be))})}map(H){return ke.map(this,H)}static filter(H,Y){return new ke(async he=>{for await(const be of H)Y(be)&&he.emitOne(be)})}filter(H){return ke.filter(this,H)}static coalesce(H){return ke.filter(H,Y=>!!Y)}coalesce(){return ke.coalesce(this)}static async toPromise(H){const Y=[];for await(const he of H)Y.push(he);return Y}toPromise(){return ke.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.$Gh=ke;class le extends ke{constructor(H,Y){super(Y),this.l=H}cancel(){this.l.cancel()}}e.$Hh=le;function ue(de){const H=new l.$de,Y=de(H.token);return new le(H,async he=>{const be=H.token.onCancellationRequested(()=>{be.dispose(),H.dispose(),he.reject(new N.$5)});try{for await(const Pe of Y){if(H.token.isCancellationRequested)return;he.emitOne(Pe)}be.dispose(),H.dispose()}catch(Pe){be.dispose(),H.dispose(),he.reject(Pe)}})}e.$Ih=ue;class ce{constructor(){this.a=new ge,this.b=new ke(he=>{if(H){he.reject(H);return}return Y&&he.emitMany(Y),this.d=be=>he.reject(be),this.f=be=>he.emitOne(be),this.a.p});let H,Y;this.f=he=>{Y||(Y=[]),Y.push(he)},this.d=he=>{H||(H=he)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Jh=ce}),define(Se[35],De([1,0,19,8,34,28,17,11,14]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=void 0;function E(){return Object.create(null)}e.$Uj=E,e.$Vj="**",e.$Wj="/";const M="[/\\\\]",C="[^/\\\\]",v=/\//g;function S(te,x){switch(te){case 0:return"";case 1:return`${C}*?`;default:return`(?:${M}|${C}+${M}${x?`|${M}${C}+`:""})*?`}}function y(te,x){if(!te)return[];const Z=[];let X=!1,ae=!1,_="";for(const ge of te){switch(ge){case x:if(!X&&!ae){Z.push(_),_="";continue}break;case"{":X=!0;break;case"}":X=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}_+=ge}return _&&Z.push(_),Z}e.$Xj=y;function u(te){if(!te)return"";let x="";const Z=y(te,e.$Wj);if(Z.every(X=>X===e.$Vj))x=".*";else{let X=!1;Z.forEach((ae,_)=>{if(ae===e.$Vj){if(X)return;x+=S(2,_===Z.length-1)}else{let ge=!1,se="",re=!1,B="";for(const ie of ae){if(ie!=="}"&&ge){se+=ie;continue}if(re&&(ie!=="]"||!B)){let ke;ie==="-"?ke=ie:(ie==="^"||ie==="!")&&!B?ke="^":ie===e.$Wj?ke="":ke=(0,p.$Ye)(ie),B+=ke;continue}switch(ie){case"{":ge=!0;continue;case"[":re=!0;continue;case"}":{const le=`(?:${y(se,",").map(ue=>u(ue)).join("|")})`;x+=le,ge=!1,se="";break}case"]":{x+="["+B+"]",re=!1,B="";break}case"?":x+=C;continue;case"*":x+=S(1);continue;default:x+=(0,p.$Ye)(ie)}}_<Z.length-1&&(Z[_+1]!==e.$Vj||_+2<Z.length)&&(x+=M)}X=ae===e.$Vj})}return x}const m=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,r=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),f=function(){return!1},h=function(){return null};function s(te,x){if(!te)return h;let Z;typeof te!="string"?Z=te.pattern:Z=te,Z=Z.trim();const X=`${Z}_${!!x.trimForExclusions}`;let ae=t.get(X);if(ae)return a(ae,te);let _;return m.test(Z)?ae=$(Z.substr(4),Z):(_=o.exec(d(Z,x)))?ae=D(_[1],Z):(x.trimForExclusions?n:i).test(Z)?ae=b(Z,x):(_=r.exec(d(Z,x)))?ae=g(_[1].substr(1),Z,!0):(_=c.exec(d(Z,x)))?ae=g(_[1],Z,!1):ae=k(Z),t.set(X,ae),a(ae,te)}function a(te,x){if(typeof x=="string")return te;const Z=function(X,ae){return(0,L.$gg)(X,x.base,!w.$k)?te((0,p.$4e)(X.substr(x.base.length),R.sep),ae):null};return Z.allBasenames=te.allBasenames,Z.allPaths=te.allPaths,Z.basenames=te.basenames,Z.patterns=te.patterns,Z}function d(te,x){return x.trimForExclusions&&te.endsWith("/**")?te.substr(0,te.length-2):te}function $(te,x){return function(Z,X){return typeof Z=="string"&&Z.endsWith(te)?x:null}}function D(te,x){const Z=`/${te}`,X=`\\${te}`,ae=function(ge,se){return typeof ge!="string"?null:se?se===te?x:null:ge===te||ge.endsWith(Z)||ge.endsWith(X)?x:null},_=[te];return ae.basenames=_,ae.patterns=[x],ae.allBasenames=_,ae}function b(te,x){const Z=j(te.slice(1,-1).split(",").map(se=>s(se,x)).filter(se=>se!==h),te),X=Z.length;if(!X)return h;if(X===1)return Z[0];const ae=function(se,re){for(let B=0,ie=Z.length;B<ie;B++)if(Z[B](se,re))return te;return null},_=Z.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=Z.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function g(te,x,Z){const X=R.sep===R.$gc.sep,ae=X?te:te.replace(v,R.sep),_=R.sep+ae,ge=R.$gc.sep+te;let se;return Z?se=function(re,B){return typeof re=="string"&&(re===ae||re.endsWith(_)||!X&&(re===te||re.endsWith(ge)))?x:null}:se=function(re,B){return typeof re=="string"&&(re===ae||!X&&re===te)?x:null},se.allPaths=[(Z?"*/":"./")+te],se}function k(te){try{const x=new RegExp(`^${u(te)}$`);return function(Z){return x.lastIndex=0,typeof Z=="string"&&x.test(Z)?te:null}}catch{return h}}function P(te,x,Z){return!te||typeof x!="string"?!1:F(te)(x,void 0,Z)}e.$Yj=P;function F(te,x={}){if(!te)return f;if(typeof te=="string"||U(te)){const Z=s(te,x);if(Z===h)return f;const X=function(ae,_){return!!Z(ae,_)};return Z.allBasenames&&(X.allBasenames=Z.allBasenames),Z.allPaths&&(X.allPaths=Z.allPaths),X}return I(te,x)}e.$Zj=F;function U(te){const x=te;return x?typeof x.base=="string"&&typeof x.pattern=="string":!1}e.$1j=U;function z(te){return te.allBasenames||[]}e.$2j=z;function T(te){return te.allPaths||[]}e.$3j=T;function I(te,x){const Z=j(Object.getOwnPropertyNames(te).map(se=>O(se,te[se],x)).filter(se=>se!==h)),X=Z.length;if(!X)return h;if(!Z.some(se=>!!se.requiresSiblings)){if(X===1)return Z[0];const se=function(ie,ke){let le;for(let ue=0,ce=Z.length;ue<ce;ue++){const de=Z[ue](ie,ke);if(typeof de=="string")return de;(0,N.$5g)(de)&&(le||(le=[]),le.push(de))}return le?(async()=>{for(const ue of le){const ce=await ue;if(typeof ce=="string")return ce}return null})():null},re=Z.find(ie=>!!ie.allBasenames);re&&(se.allBasenames=re.allBasenames);const B=Z.reduce((ie,ke)=>ke.allPaths?ie.concat(ke.allPaths):ie,[]);return B.length&&(se.allPaths=B),se}const ae=function(se,re,B){let ie,ke;for(let le=0,ue=Z.length;le<ue;le++){const ce=Z[le];ce.requiresSiblings&&B&&(re||(re=(0,R.$nc)(se)),ie||(ie=re.substr(0,re.length-(0,R.$oc)(se).length)));const de=ce(se,re,ie,B);if(typeof de=="string")return de;(0,N.$5g)(de)&&(ke||(ke=[]),ke.push(de))}return ke?(async()=>{for(const le of ke){const ue=await le;if(typeof ue=="string")return ue}return null})():null},_=Z.find(se=>!!se.allBasenames);_&&(ae.allBasenames=_.allBasenames);const ge=Z.reduce((se,re)=>re.allPaths?se.concat(re.allPaths):se,[]);return ge.length&&(ae.allPaths=ge),ae}function O(te,x,Z){if(x===!1)return h;const X=s(te,Z);if(X===h)return h;if(typeof x=="boolean")return X;if(x){const ae=x.when;if(typeof ae=="string"){const _=(ge,se,re,B)=>{if(!B||!X(ge,se))return null;const ie=ae.replace("$(basename)",()=>re),ke=B(ie);return(0,N.$5g)(ke)?ke.then(le=>le?te:null):ke?te:null};return _.requiresSiblings=!0,_}}return X}function j(te,x){const Z=te.filter(se=>!!se.basenames);if(Z.length<2)return te;const X=Z.reduce((se,re)=>{const B=re.basenames;return B?se.concat(B):se},[]);let ae;if(x){ae=[];for(let se=0,re=X.length;se<re;se++)ae.push(x)}else ae=Z.reduce((se,re)=>{const B=re.patterns;return B?se.concat(B):se},[]);const _=function(se,re){if(typeof se!="string")return null;if(!re){let ie;for(ie=se.length;ie>0;ie--){const ke=se.charCodeAt(ie-1);if(ke===47||ke===92)break}re=se.substr(ie)}const B=X.indexOf(re);return B!==-1?ae[B]:null};_.basenames=X,_.patterns=ae,_.allBasenames=X;const ge=te.filter(se=>!se.basenames);return ge.push(_),ge}function G(te,x){return(0,l.$ub)(te,x,(Z,X)=>typeof Z=="string"&&typeof X=="string"?Z===X:typeof Z!="string"&&typeof X!="string"?Z.base===X.base&&Z.pattern===X.pattern:!1)}e.$4j=G}),define(Se[79],De([1,0,13,169,23,14,2]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.MarkdownStringTextNewlineStyle=void 0;var w;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(w||(e.MarkdownStringTextNewlineStyle=w={}));class p{constructor(i="",n=!1){if(this.value=i,typeof this.value!="string")throw(0,l.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(i,n=0){return this.value+=v(this.supportThemeIcons?(0,N.$rk)(i):i).replace(/([ \t]+)/g,(r,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,n){return this.value+=`
${S(n,i)}
`,this}appendLink(i,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(i),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(i,n){const r=new RegExp((0,A.$Ye)(n),"g");return i.replace(r,(c,t)=>i.charAt(t-1)!=="\\"?`\\${c}`:c)}}e.$xk=p;function E(o){return M(o)?!o.value:Array.isArray(o)?o.every(E):!0}e.$yk=E;function M(o){return o instanceof p?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$zk=M;function C(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,L.$Mg)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$Ak=C;function v(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Bk=v;function S(o,i){const n=o.match(/^`+/gm)?.reduce((c,t)=>c.length>t.length?c:t).length??0,r=n>=3?n+1:3;return[`${"`".repeat(r)}${i}`,o,`${"`".repeat(r)}`].join(`
`)}e.$Ck=S;function y(o){return o.replace(/"/g,"&quot;")}e.$Dk=y;function u(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Ek=u;function m(o){const i=[],n=o.split("|").map(c=>c.trim());o=n[0];const r=n[1];if(r){const c=/height=(\d+)/.exec(r),t=/width=(\d+)/.exec(r),f=c?c[1]:"",h=t?t[1]:"",s=isFinite(parseInt(h)),a=isFinite(parseInt(f));s&&i.push(`width="${h}"`),a&&i.push(`height="${f}"`)}return{href:o,dimensions:i}}e.$Fk=m}),define(Se[103],De([1,0,19,34,17,11,23,14]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iw=e.$hw=e.$gw=e.$fw=e.$ew=e.$dw=e.$cw=e.$bw=e.$aw=e.$_v=void 0;function p(s,a){const{os:d,tildify:$,relative:D}=a;if(D){const k=E(s,D,d);if(typeof k=="string")return k}let b=s.fsPath;if(d===1&&!A.$i?b=b.replace(/\//g,"\\"):d!==1&&A.$i&&(b=b.replace(/\\/g,"/")),d!==1&&$?.userHome){const k=$.userHome.fsPath;let P;s.scheme!==$.userHome.scheme&&s.path[0]===L.$gc.sep&&s.path[1]!==L.$gc.sep?P=$.userHome.with({path:s.path}).fsPath:P=b,b=v(P,k,d)}return(d===1?L.$fc:L.$gc).normalize(M(b,d===1))}e.$_v=p;function E(s,a,d){const $=d===1?L.$fc:L.$gc,D=d===3?R.$Jg:R.$Lg,b=a.getWorkspace(),g=(0,l.$Ob)(b.folders);if(!g)return;s.scheme!==g.uri.scheme&&s.path[0]===L.$gc.sep&&s.path[1]!==L.$gc.sep&&(s=g.uri.with({path:s.path}));const k=a.getWorkspaceFolder(s);if(!k)return;let P;if(D.isEqual(k.uri,s)?P="":P=D.relativePath(k.uri,s)??"",P&&(P=$.normalize(P)),b.folders.length>1&&!a.noPrefix){const F=k.name?k.name:D.basenameOrAuthority(k.uri);P=P?`${F} \u2022 ${P}`:F}return P}function M(s,a=A.$i){return(0,N.$kg)(s,a)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$aw=M;let C=Object.create(null);function v(s,a,d=A.OS){if(d===1||!s||!a)return s;let $=C.original===a?C.normalized:void 0;$||($=a,A.$i&&($=(0,N.$ag)($)),$=`${(0,w.$5e)($,L.$gc.sep)}${L.$gc.sep}`,C={original:a,normalized:$});let D=s;return A.$i&&(D=(0,N.$ag)(D)),(d===3?D.startsWith($):(0,w.$lf)(D,$))?`~/${D.substr($.length)}`:s}e.$bw=v;function S(s,a){return s.replace(/^~($|\/|\\)/,`${a}$1`)}e.$cw=S;const y="\u2026",u="\\\\",m="~";function o(s,a=L.sep){const d=new Array(s.length);let $=!1;for(let D=0;D<s.length;D++){const b=s[D];if(b===""){d[D]=`.${a}`;continue}if(!b){d[D]=b;continue}$=!0;let g="",k=b;k.indexOf(u)===0?(g=k.substr(0,k.indexOf(u)+u.length),k=k.substr(k.indexOf(u)+u.length)):k.indexOf(a)===0?(g=k.substr(0,k.indexOf(a)+a.length),k=k.substr(k.indexOf(a)+a.length)):k.indexOf(m)===0&&(g=k.substr(0,k.indexOf(m)+m.length),k=k.substr(k.indexOf(m)+m.length));const P=k.split(a);for(let F=1;$&&F<=P.length;F++)for(let U=P.length-F;$&&U>=0;U--){$=!1;let z=P.slice(U,U+F).join(a);for(let T=0;!$&&T<s.length;T++)if(T!==D&&s[T]&&s[T].indexOf(z)>-1){const I=U+F===P.length,O=U>0&&s[T].indexOf(a)>-1?a+z:z,j=s[T].endsWith(O);$=!I||j}if(!$){let T="";(P[0].endsWith(":")||g!=="")&&(U===1&&(U=0,F++,z=P[0]+a+z),U>0&&(T=P[0]+a),T=g+T),U>0&&(T=T+y+a),T=T+z,U+F<P.length&&(T=T+a+y),d[D]=T}}$&&(d[D]=b)}return d}e.$dw=o;var i;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(s,a=Object.create(null)){const d=[];let $=!1,D="";for(const b of s)if(b==="$"||$&&b==="{")D&&d.push({value:D,type:i.TEXT}),D="",$=!0;else if(b==="}"&&$){const g=a[D];if(typeof g=="string")g.length&&d.push({value:g,type:i.VARIABLE});else if(g){const k=d[d.length-1];(!k||k.type!==i.SEPARATOR)&&d.push({value:g.label,type:i.SEPARATOR})}D="",$=!1}else D+=b;return D&&!$&&d.push({value:D,type:i.TEXT}),d.filter((b,g)=>{if(b.type===i.SEPARATOR){const k=d[g-1],P=d[g+1];return[k,P].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(b=>b.value).join("")}e.$ew=n;function r(s,a){return A.$j||a?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.$j?"&":"&&"):s.replace(/&&|&/g,d=>d==="&"?"&&":"&")}e.$fw=r;function c(s,a){return A.$j||a?s.replace(/\(&&\w\)|&&/g,""):A.$i?s.replace(/&&|&/g,d=>d==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$gw=c;function t(s){return s.replace(/&/g,"&&")}e.$hw=t;function f(s){if(s.endsWith("]")){const a=s.lastIndexOf(" [",s.length-2);if(a!==-1){const d=h(s.substring(0,a)),$=s.substring(a);return{name:d.name+$,parentPath:d.parentPath}}}return h(s)}e.$iw=f;function h(s){const a=s.indexOf("/")!==-1?L.$gc:L.$fc,d=a.basename(s),$=a.dirname(s);return d.length?{name:d,parentPath:$}:{name:$,parentPath:""}}}),define(Se[133],De([1,0,21,2]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=void 0;function L(C){return C.toJSON()}class A{constructor(v){this.a=v}transformIncoming(v){const S=this.a.transformIncoming(v);return S===v?v:L(N.URI.from(S))}transformOutgoing(v){const S=this.a.transformOutgoing(v);return S===v?v:L(N.URI.from(S))}transformOutgoingURI(v){const S=this.a.transformOutgoing(v);return S===v?v:N.URI.from(S)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$hn=A,e.$in=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return v.transformOutgoing(C);for(const y in C)if(Object.hasOwnProperty.call(C,y)){const u=R(C[y],v,S+1);u!==null&&(C[y]=u)}}return null}function w(C,v){const S=R(C,v,0);return S===null?C:S}e.$jn=w;function p(C,v,S,y){if(!C||y>200)return null;if(typeof C=="object"){if(C.$mid===1)return S?N.URI.revive(v.transformIncoming(C)):v.transformIncoming(C);if(C instanceof l.$te)return null;for(const u in C)if(Object.hasOwnProperty.call(C,u)){const m=p(C[u],v,S,y+1);m!==null&&(C[u]=m)}}return null}function E(C,v){const S=p(C,v,!1,0);return S===null?C:S}e.$kn=E;function M(C,v){const S=p(C,v,!0,0);return S===null?C:S}e.$ln=M}),define(Se[31],De([1,0,57,63,391,8,34,75,17,11,23,2]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function S(O,j=v.UNLINK,G){if((0,R.$jg)(O))throw new Error("rimraf - will refuse to recursively delete root");return j===v.UNLINK?u(O):y(O,G)}async function y(O,j=(0,R.$og)((0,N.tmpdir)())){try{try{await l.promises.rename(O,j)}catch(G){return G.code==="ENOENT"?void 0:u(O)}u(j).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function u(O){return(0,L.promisify)(l.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function m(O){if((0,R.$jg)(O))throw new Error("rimraf - will refuse to recursively delete root");l.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function o(O,j){return r(await(j?i(O):(0,L.promisify)(l.readdir)(O)))}async function i(O){try{return await(0,L.promisify)(l.readdir)(O,{withFileTypes:!0})}catch(te){console.warn("[node.js fs] readdir with filetypes failed with error: ",te)}const j=[],G=await o(O);for(const te of G){let x=!1,Z=!1,X=!1;try{const ae=await e.Promises.lstat((0,p.$jc)(O,te));x=ae.isFile(),Z=ae.isDirectory(),X=ae.isSymbolicLink()}catch(ae){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ae)}j.push({name:te,isFile:()=>x,isDirectory:()=>Z,isSymbolicLink:()=>X})}return j}function n(O){return r(l.readdirSync(O))}e.readdirSync=n;function r(O){return O.map(j=>typeof j=="string"?E.$j?(0,w.$Rl)(j):j:(j.name=E.$j?(0,w.$Rl)(j.name):j.name,j))}async function c(O){const j=await o(O),G=[];for(const te of j)await f.existsDirectory((0,p.$jc)(O,te))&&G.push(te);return G}function t(O,j=1e3){return new Promise(G=>{let te=!1;const x=setInterval(()=>{te||(te=!0,l.access(O,Z=>{te=!1,Z&&(clearInterval(x),G(void 0))}))},j)})}e.whenDeleted=t;var f;(function(O){async function j(x){let Z;try{if(Z=await e.Promises.lstat(x),!Z.isSymbolicLink())return{stat:Z}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:Z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};if(E.$i&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(ae){if(ae.code==="ENOENT"&&Z)return{stat:Z,symbolicLink:{dangling:!0}};throw ae}throw X}}O.stat=j;async function G(x){try{const{stat:Z,symbolicLink:X}=await O.stat(x);return Z.isFile()&&X?.dangling!==!0}catch{}return!1}O.existsFile=G;async function te(x){try{const{stat:Z,symbolicLink:X}=await O.stat(x);return Z.isDirectory()&&X?.dangling!==!0}catch{}return!1}O.existsDirectory=te})(f||(e.SymlinkSupport=f={}));const h=new A.$ph;function s(O,j,G){return h.queueFor(C.URI.file(O),()=>{const te=b(G);return new Promise((x,Z)=>$(O,j,te,X=>X?Z(X):x()))},M.$Kg)}let a=!0;function d(O){a=O}e.configureFlushOnWrite=d;function $(O,j,G,te){if(!a)return l.writeFile(O,j,{mode:G.mode,flag:G.flag},te);l.open(O,G.flag,G.mode,(x,Z)=>{if(x)return te(x);l.writeFile(Z,j,X=>{if(X)return l.close(Z,()=>te(X));l.fdatasync(Z,ae=>(ae&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ae),d(!1)),l.close(Z,_=>te(_))))})})}function D(O,j,G){const te=b(G);if(!a)return l.writeFileSync(O,j,{mode:te.mode,flag:te.flag});const x=l.openSync(O,te.flag,te.mode);try{l.writeFileSync(x,j);try{l.fdatasyncSync(x)}catch(Z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Z),d(!1)}}finally{l.closeSync(x)}}e.writeFileSync=D;function b(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function g(O,j,G=6e4){if(O!==j)try{E.$i&&typeof G=="number"?await k(O,j,Date.now(),G):await(0,L.promisify)(l.rename)(O,j)}catch(te){if(O.toLowerCase()!==j.toLowerCase()&&te.code==="EXDEV"||O.endsWith("."))await P(O,j,{preserveSymlinks:!1}),await S(O,v.MOVE);else throw te}}async function k(O,j,G,te,x=0){try{return await(0,L.promisify)(l.rename)(O,j)}catch(Z){if(Z.code!=="EACCES"&&Z.code!=="EPERM"&&Z.code!=="EBUSY")throw Z;if(Date.now()-G>=te)throw console.error(`[node.js fs] rename failed after ${x} retries with error: ${Z}`),Z;if(x===0){let X=!1;try{const{stat:ae}=await f.stat(j);ae.isFile()||(X=!0)}catch{}if(X)throw Z}return await(0,A.$hh)(Math.min(100,x*10)),k(O,j,G,te,x+1)}}async function P(O,j,G){return U(O,j,{root:{source:O,target:j},options:G,handledSourcePaths:new Set})}const F=511;async function U(O,j,G){if(G.handledSourcePaths.has(O))return;G.handledSourcePaths.add(O);const{stat:te,symbolicLink:x}=await f.stat(O);if(x){if(G.options.preserveSymlinks)try{return await I(O,j,G)}catch{}if(x.dangling)return}return te.isDirectory()?z(O,j,te.mode&F,G):T(O,j,te.mode&F)}async function z(O,j,G,te){await e.Promises.mkdir(j,{recursive:!0,mode:G});const x=await o(O);for(const Z of x)await U((0,p.$jc)(O,Z),(0,p.$jc)(j,Z),te)}async function T(O,j,G){await e.Promises.copyFile(O,j),await e.Promises.chmod(j,G)}async function I(O,j,G){let te=await e.Promises.readlink(O);(0,R.$gg)(te,G.root.source,!E.$k)&&(te=(0,p.$jc)(G.root.target,te.substr(G.root.source.length+1))),await e.Promises.symlink(te,j)}e.Promises=new class{get access(){return(0,L.promisify)(l.access)}get stat(){return(0,L.promisify)(l.stat)}get lstat(){return(0,L.promisify)(l.lstat)}get utimes(){return(0,L.promisify)(l.utimes)}get read(){return(O,j,G,te,x)=>new Promise((Z,X)=>{l.read(O,j,G,te,x,(ae,_,ge)=>ae?X(ae):Z({bytesRead:_,buffer:ge}))})}get readFile(){return(0,L.promisify)(l.readFile)}get write(){return(O,j,G,te,x)=>new Promise((Z,X)=>{l.write(O,j,G,te,x,(ae,_,ge)=>ae?X(ae):Z({bytesWritten:_,buffer:ge}))})}get appendFile(){return(0,L.promisify)(l.appendFile)}get fdatasync(){return(0,L.promisify)(l.fdatasync)}get truncate(){return(0,L.promisify)(l.truncate)}get copyFile(){return(0,L.promisify)(l.copyFile)}get open(){return(0,L.promisify)(l.open)}get close(){return(0,L.promisify)(l.close)}get symlink(){return(0,L.promisify)(l.symlink)}get readlink(){return(0,L.promisify)(l.readlink)}get chmod(){return(0,L.promisify)(l.chmod)}get mkdir(){return(0,L.promisify)(l.mkdir)}get unlink(){return(0,L.promisify)(l.unlink)}get rmdir(){return(0,L.promisify)(l.rmdir)}get realpath(){return(0,L.promisify)(l.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return c}get writeFile(){return s}get rm(){return S}get rename(){return g}get copy(){return P}}}),define(Se[104],De([1,0,57,17,11,14,31]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;function w(v){if(L.$k)return v;const S=(0,N.$mc)(v);if(v===S)return v;const y=((0,N.$nc)(v)||v).toLowerCase();try{const m=(0,R.readdirSync)(S).filter(o=>o.toLowerCase()===y);if(m.length===1){const o=w(S);if(o)return(0,N.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(y);if(o>=0){const i=w(S);if(i)return(0,N.$jc)(i,m[o])}}}catch{}return null}e.$Iq=w;async function p(v){if(L.$k)return v;const S=(0,N.$mc)(v);if(v===S)return v;const y=((0,N.$nc)(v)||v).toLowerCase();try{const m=(await R.Promises.readdir(S)).filter(o=>o.toLowerCase()===y);if(m.length===1){const o=await p(S);if(o)return(0,N.$jc)(o,m[0])}else if(m.length>1){const o=m.indexOf(y);if(o>=0){const i=await p(S);if(i)return(0,N.$jc)(i,m[o])}}}catch{}return null}e.$Jq=p;async function E(v){try{return await R.Promises.realpath(v)}catch{const y=C(v);return await R.Promises.access(y,l.constants.R_OK),y}}e.$Kq=E;function M(v){try{return l.realpathSync(v)}catch{const y=C(v);return l.accessSync(y,l.constants.R_OK),y}}e.$Lq=M;function C(v){return(0,A.$5e)((0,N.$hc)(v),N.sep)}}),define(Se[105],De([1,0,17,11,50,102,18,31]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$6l=e.$5l=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function p(C=L.env){return C.comspec||"cmd.exe"}e.$5l=p;function E(C){let v=[],S=!1;const y=function(u){if(S){v.push(u);return}(!C.send(u,o=>{if(o&&console.error(o),S=!1,v.length>0){const i=v.slice(0);v=[],i.forEach(n=>y(n))}})||N.$i)&&(S=!0)};return{send:y}}e.$6l=E;var M;(function(C){async function v(S,y,u){if(l.$ic(S))return S;if(y===void 0&&(y=L.cwd()),l.$mc(S)!=="."||(u===void 0&&R.$Tf(L.env.PATH)&&(u=L.env.PATH.split(l.$tc)),u===void 0||u.length===0))return l.$jc(y,S);async function o(i){if(await w.Promises.exists(i)){let n;try{n=await w.Promises.stat(i)}catch(r){r.message.startsWith("EACCES")&&(n=await w.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of u){let n;if(l.$ic(i)?n=l.$jc(i,S):n=l.$jc(y,i,S),await o(n))return n;let r=n+".com";if(await o(r)||(r=n+".exe",await o(r)))return r}return l.$jc(y,S)}C.findExecutable=v})(M||(e.win32=M={}))});var Qe=this&&this.__decorate||function(fe,e,l,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,l):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(fe,e,l,N);else for(var w=fe.length-1;w>=0;w--)(R=fe[w])&&(A=(L<3?R(A):L>3?R(e,l,A):R(e,l))||A);return L>3&&A&&Object.defineProperty(e,l,A),A};define(Se[80],De([1,0,19,8,21,22,53,13,4,3,56,14,18]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.ProxyChannel=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.RequestInitiator=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=void 0;var S;(function(x){x[x.Promise=100]="Promise",x[x.PromiseCancel=101]="PromiseCancel",x[x.EventListen=102]="EventListen",x[x.EventDispose=103]="EventDispose"})(S||(S={}));function y(x){switch(x){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var u;(function(x){x[x.Initialize=200]="Initialize",x[x.PromiseSuccess=201]="PromiseSuccess",x[x.PromiseError=202]="PromiseError",x[x.PromiseErrorObj=203]="PromiseErrorObj",x[x.EventFire=204]="EventFire"})(u||(u={}));function m(x){switch(x){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(x){x[x.Uninitialized=0]="Uninitialized",x[x.Idle=1]="Idle"})(o||(o={}));function i(x){let Z=0;for(let X=0;;X+=7){const ae=x.read(1);if(Z|=(ae.buffer[0]&127)<<X,!(ae.buffer[0]&128))return Z}}const n=h(0);function r(x,Z){if(Z===0){x.write(n);return}let X=0;for(let _=Z;_!==0;_=_>>>7)X++;const ae=L.$te.alloc(X);for(let _=0;Z!==0;_++)ae.buffer[_]=Z&127,Z=Z>>>7,Z>0&&(ae.buffer[_]|=128);x.write(ae)}class c{constructor(Z){this.b=Z,this.a=0}read(Z){const X=this.b.slice(this.a,this.a+Z);return this.a+=X.byteLength,X}}e.$Qh=c;class t{constructor(){this.a=[]}get buffer(){return L.$te.concat(this.a)}write(Z){this.a.push(Z)}}e.$Rh=t;var f;(function(x){x[x.Undefined=0]="Undefined",x[x.String=1]="String",x[x.Buffer=2]="Buffer",x[x.VSBuffer=3]="VSBuffer",x[x.Array=4]="Array",x[x.Object=5]="Object",x[x.Int=6]="Int"})(f||(f={}));function h(x){const Z=L.$te.alloc(1);return Z.writeUInt8(x,0),Z}const s={Undefined:h(f.Undefined),String:h(f.String),Buffer:h(f.Buffer),VSBuffer:h(f.VSBuffer),Array:h(f.Array),Object:h(f.Object),Uint:h(f.Int)},a=typeof Buffer<"u";function d(x,Z){if(typeof Z>"u")x.write(s.Undefined);else if(typeof Z=="string"){const X=L.$te.fromString(Z);x.write(s.String),r(x,X.byteLength),x.write(X)}else if(a&&Buffer.isBuffer(Z)){const X=L.$te.wrap(Z);x.write(s.Buffer),r(x,X.byteLength),x.write(X)}else if(Z instanceof L.$te)x.write(s.VSBuffer),r(x,Z.byteLength),x.write(Z);else if(Array.isArray(Z)){x.write(s.Array),r(x,Z.length);for(const X of Z)d(x,X)}else if(typeof Z=="number"&&(Z|0)===Z)x.write(s.Uint),r(x,Z);else{const X=L.$te.fromString(JSON.stringify(Z));x.write(s.Object),r(x,X.byteLength),x.write(X)}}e.$Sh=d;function $(x){switch(x.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return x.read(i(x)).toString();case f.Buffer:return x.read(i(x)).buffer;case f.VSBuffer:return x.read(i(x));case f.Array:{const X=i(x),ae=[];for(let _=0;_<X;_++)ae.push($(x));return ae}case f.Object:return JSON.parse(x.read(i(x)).toString());case f.Int:return i(x)}}e.$Th=$;class D{constructor(Z,X,ae=null,_=1e3){this.h=Z,this.j=X,this.k=ae,this.l=_,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ge=>this.q(ge)),this.m({type:200})}registerChannel(Z,X){this.b.set(Z,X),setTimeout(()=>this.w(Z),0)}m(Z){switch(Z.type){case 200:{const X=this.o([Z.type]);this.k?.logOutgoing(X,0,1,m(Z.type));return}case 201:case 202:case 204:case 203:{const X=this.o([Z.type,Z.id],Z.data);this.k?.logOutgoing(X,Z.id,1,m(Z.type),Z.data);return}}}o(Z,X=void 0){const ae=new t;return d(ae,Z),d(ae,X),this.p(ae.buffer)}p(Z){try{return this.h.send(Z),Z.byteLength}catch{return 0}}q(Z){const X=new c(Z),ae=$(X),_=$(X),ge=ae[0];switch(ge){case 100:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${y(ge)}: ${ae[2]}.${ae[3]}`,_),this.s({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 102:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${y(ge)}: ${ae[2]}.${ae[3]}`,_),this.t({type:ge,id:ae[1],channelName:ae[2],name:ae[3],arg:_});case 101:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${y(ge)}`),this.u({type:ge,id:ae[1]});case 103:return this.k?.logIncoming(Z.byteLength,ae[1],1,`${y(ge)}`),this.u({type:ge,id:ae[1]})}}s(Z){const X=this.b.get(Z.channelName);if(!X){this.v(Z);return}const ae=new A.$de;let _;try{_=X.call(this.j,Z.name,Z.arg,ae.token)}catch(re){_=Promise.reject(re)}const ge=Z.id;_.then(re=>{this.m({id:ge,data:re,type:201})},re=>{re instanceof Error?this.m({id:ge,data:{message:re.message,name:re.name,stack:re.stack?re.stack.split?re.stack.split(`
`):re.stack:void 0},type:202}):this.m({id:ge,data:re,type:203})}).finally(()=>{se.dispose(),this.d.delete(Z.id)});const se=(0,E.$Rc)(()=>ae.cancel());this.d.set(Z.id,se)}t(Z){const X=this.b.get(Z.channelName);if(!X){this.v(Z);return}const ae=Z.id,ge=X.listen(this.j,Z.name,Z.arg)(se=>this.m({id:ae,data:se,type:204}));this.d.set(Z.id,ge)}u(Z){const X=this.d.get(Z.id);X&&(X.dispose(),this.d.delete(Z.id))}v(Z){let X=this.g.get(Z.channelName);X||(X=[],this.g.set(Z.channelName,X));const ae=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.m({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);X.push({request:Z,timeoutTimer:ae})}w(Z){const X=this.g.get(Z);if(X){for(const ae of X)switch(clearTimeout(ae.timeoutTimer),ae.request.type){case 100:this.s(ae.request);break;case 102:this.t(ae.request);break}this.g.delete(Z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Uh=D;var b;(function(x){x[x.LocalSide=0]="LocalSide",x[x.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class g{constructor(Z,X=null){this.l=Z,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$6d,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ae=>this.s(ae)),this.j=X}getChannel(Z){const X=this;return{call(ae,_,ge){return X.a?Promise.reject(new w.$5):X.m(Z,ae,_,ge)},listen(ae,_){return X.a?p.Event.None:X.o(Z,ae,_)}}}m(Z,X,ae,_=A.CancellationToken.None){const ge=this.g++,re={id:ge,type:100,channelName:Z,name:X,arg:ae};if(_.isCancellationRequested)return Promise.reject(new w.$5);let B;return new Promise((ke,le)=>{if(_.isCancellationRequested)return le(new w.$5);const ue=()=>{const Y=he=>{switch(he.type){case 201:this.f.delete(ge),ke(he.data);break;case 202:{this.f.delete(ge);const be=new Error(he.data.message);be.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,be.name=he.data.name,le(be);break}case 203:this.f.delete(ge),le(he.data);break}};this.f.set(ge,Y),this.p(re)};let ce=null;this.b===o.Idle?ue():(ce=(0,N.$6g)(Y=>this.u()),ce.then(()=>{ce=null,ue()}));const de=()=>{ce?(ce.cancel(),ce=null):this.p({id:ge,type:101}),le(new w.$5)},H=_.onCancellationRequested(de);B=(0,E.$Qc)((0,E.$Rc)(de),H),this.d.add(B)}).finally(()=>{B.dispose(),this.d.delete(B)})}o(Z,X,ae){const _=this.g++,se={id:_,type:102,channelName:Z,name:X,arg:ae};let re=null;const B=new p.$6d({onWillAddFirstListener:()=>{re=(0,N.$6g)(ke=>this.u()),re.then(()=>{re=null,this.d.add(B),this.p(se)})},onDidRemoveLastListener:()=>{re?(re.cancel(),re=null):(this.d.delete(B),this.p({id:_,type:103}))}}),ie=ke=>B.fire(ke.data);return this.f.set(_,ie),B.event}p(Z){switch(Z.type){case 100:case 102:{const X=this.q([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.j?.logOutgoing(X,Z.id,0,`${y(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const X=this.q([Z.type,Z.id]);this.j?.logOutgoing(X,Z.id,0,y(Z.type));return}}}q(Z,X=void 0){const ae=new t;return d(ae,Z),d(ae,X),this.r(ae.buffer)}r(Z){try{return this.l.send(Z),Z.byteLength}catch{return 0}}s(Z){const X=new c(Z),ae=$(X),_=$(X),ge=ae[0];switch(ge){case 200:return this.j?.logIncoming(Z.byteLength,0,0,m(ge)),this.t({type:ae[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Z.byteLength,ae[1],0,m(ge),_),this.t({type:ae[0],id:ae[1],data:_})}}t(Z){if(Z.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Z.id)?.(Z)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,E.$Oc)(this.d.values()),this.d.clear()}}e.$Vh=g,Qe([R.$Kh],g.prototype,"onDidInitializePromise",null);class k{get connections(){const Z=[];return this.f.forEach(X=>Z.push(X)),Z}constructor(Z){this.a=new Map,this.f=new Set,this.g=new p.$6d,this.onDidAddConnection=this.g.event,this.h=new p.$6d,this.onDidRemoveConnection=this.h.event,this.j=new E.$Sc,this.j.add(Z(({protocol:X,onDidClientDisconnect:ae})=>{const _=p.Event.once(X.onMessage);this.j.add(_(ge=>{const se=new c(ge),re=$(se),B=new D(X,re),ie=new g(X);this.a.forEach((le,ue)=>B.registerChannel(ue,le));const ke={channelServer:B,channelClient:ie,ctx:re};this.f.add(ke),this.g.fire(ke),this.j.add(ae(()=>{B.dispose(),ie.dispose(),this.f.delete(ke),this.h.fire(ke)}))}))}))}getChannel(Z,X){const ae=this;return{call(_,ge,se){let re;if((0,v.$8f)(X)){const ie=(0,l.$4b)(ae.connections.filter(X));re=ie?Promise.resolve(ie):p.Event.toPromise(p.Event.filter(ae.onDidAddConnection,X))}else re=X.routeCall(ae,_,ge);const B=re.then(ie=>ie.channelClient.getChannel(Z));return F(B).call(_,ge,se)},listen(_,ge){if((0,v.$8f)(X))return ae.k(Z,X,_,ge);const se=X.routeEvent(ae,_,ge).then(re=>re.channelClient.getChannel(Z));return F(se).listen(_,ge)}}}k(Z,X,ae,_){const ge=this;let se;const re=new p.$6d({onWillAddFirstListener:()=>{se=new E.$Sc;const B=new p.$_d,ie=new Map,ke=ue=>{const de=ue.channelClient.getChannel(Z).listen(ae,_),H=B.add(de);ie.set(ue,H)},le=ue=>{const ce=ie.get(ue);ce&&(ce.dispose(),ie.delete(ue))};ge.connections.filter(X).forEach(ke),p.Event.filter(ge.onDidAddConnection,X)(ke,void 0,se),ge.onDidRemoveConnection(le,void 0,se),B.event(re.fire,re,se),se.add(B)},onDidRemoveLastListener:()=>{se?.dispose(),se=void 0}});return re.event}registerChannel(Z,X){this.a.set(Z,X);for(const ae of this.f)ae.channelServer.registerChannel(Z,X)}dispose(){this.j.dispose();for(const Z of this.f)Z.channelClient.dispose(),Z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Wh=k;class P{constructor(Z,X,ae=null){const _=new t;d(_,X),Z.send(_.buffer),this.a=new g(Z,ae),this.d=new D(Z,X,ae)}getChannel(Z){return this.a.getChannel(Z)}registerChannel(Z,X){this.d.registerChannel(Z,X)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Xh=P;function F(x){return{call(Z,X,ae){return x.then(_=>_.call(Z,X,ae))},listen(Z,X){const ae=new p.$ce;return x.then(_=>ae.input=_.listen(Z,X)),ae.event}}}e.$Yh=F;function U(x){let Z=!1;return{call(X,ae,_){return Z?x.call(X,ae,_):(0,N.$hh)(0).then(()=>Z=!0).then(()=>x.call(X,ae,_))},listen(X,ae){if(Z)return x.listen(X,ae);const _=new p.$ce;return(0,N.$hh)(0).then(()=>Z=!0).then(()=>_.input=x.listen(X,ae)),_.event}}}e.$Zh=U;class z{constructor(Z){this.a=Z}routeCall(Z){return this.b(Z)}routeEvent(Z){return this.b(Z)}async b(Z){for(const X of Z.connections)if(await Promise.resolve(this.a(X.ctx)))return Promise.resolve(X);return await p.Event.toPromise(Z.onDidAddConnection),await this.b(Z)}}e.$1h=z;var T;(function(x){function Z(ge,se,re){const B=ge,ie=re&&re.disableMarshalling,ke=new Map;for(const le in B)ae(le)&&ke.set(le,p.Event.buffer(B[le],!0,void 0,se));return new class{listen(le,ue,ce){const de=ke.get(ue);if(de)return de;const H=B[ue];if(typeof H=="function"){if(_(ue))return H.call(B,ce);if(ae(ue))return ke.set(ue,p.Event.buffer(B[ue],!0,void 0,se)),ke.get(ue)}throw new w.$bb(`Event not found: ${ue}`)}call(le,ue,ce){const de=B[ue];if(typeof de=="function"){if(!ie&&Array.isArray(ce))for(let Y=0;Y<ce.length;Y++)ce[Y]=(0,M.$Ph)(ce[Y]);let H=de.apply(B,ce);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new w.$bb(`Method not found: ${ue}`)}}}x.fromService=Z;function X(ge,se){const re=se&&se.disableMarshalling;return new Proxy({},{get(B,ie){if(typeof ie=="string")return se?.properties?.has(ie)?se.properties.get(ie):_(ie)?function(ke){return ge.listen(ie,ke)}:ae(ie)?ge.listen(ie):async function(...ke){let le;se&&!(0,v.$3f)(se.context)?le=[se.context,...ke]:le=ke;const ue=await ge.call(ie,le);return re?ue:(0,M.$Ph)(ue)};throw new w.$bb(`Property not found: ${String(ie)}`)}})}x.toService=X;function ae(ge){return ge[0]==="o"&&ge[1]==="n"&&C.$jf(ge.charCodeAt(2))}function _(ge){return/^onDynamic/.test(ge)&&C.$jf(ge.charCodeAt(9))}})(T||(e.ProxyChannel=T={}));const I=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O(x){if(Array.isArray(x))return x;if(x&&typeof x=="object"&&typeof x.toString=="function"){const Z=x.toString();if(Z!=="[object Object]")return Z}return x}function j(x){return Array.isArray(x)?x.map(O):O(x)}function G(x,Z,X,ae,_,ge,se){se=j(se);const re=I[_],B=re[ae%re.length];let ie=[`%c[${x}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(ae).padStart(5," ")} - ${ge}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(ge)?(ie=ie.concat(se),ie.push(")")):ie.push(se),console.log.apply(console,ie)}class te{constructor(Z,X){this.d=Z,this.f=X,this.a=0,this.b=0}logOutgoing(Z,X,ae,_,ge){this.b+=Z,G(this.d,this.b,Z,X,ae,_,ge)}logIncoming(Z,X,ae,_,ge){this.a+=Z,G(this.f,this.a,Z,X,ae,_,ge)}}e.$2h=te}),define(Se[81],De([1,0,21,4,3,80]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.ProtocolConstants=e.$3h=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var w;(function(s){s.enableDiagnostics=!1,s.records=[];const a=new WeakMap;let d=0;function $(b,g){if(!a.has(b)){const k=String(++d);a.set(b,k)}return a.get(b)}function D(b,g,k,P){if(!s.enableDiagnostics)return;const F=$(b,g);if(P instanceof l.$te||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const U=l.$te.alloc(P.byteLength);U.set(P),s.records.push({timestamp:Date.now(),id:F,label:g,type:k,buff:U})}else s.records.push({timestamp:Date.now(),id:F,label:g,type:k,data:P})}s.traceSocketEvent=D})(w||(e.SocketDiagnostics=w={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let E=null;function M(){return E||(E=l.$te.alloc(0)),E}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(a){this.a.push(a),this.b+=a.byteLength}read(a){return this.c(a,!0)}peek(a){return this.c(a,!1)}c(a,d){if(a===0)return M();if(a>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===a){const g=this.a[0];return d&&(this.a.shift(),this.b-=a),g}if(this.a[0].byteLength>a){const g=this.a[0].slice(0,a);return d&&(this.a[0]=this.a[0].slice(a),this.b-=a),g}const $=l.$te.alloc(a);let D=0,b=0;for(;a>0;){const g=this.a[b];if(g.byteLength>a){const k=g.slice(0,a);$.set(k,D),D+=a,d&&(this.a[b]=g.slice(a),this.b-=a),a-=a}else $.set(g,D),D+=g.byteLength,d?(this.a.shift(),this.b-=g.byteLength):b++,a-=g.byteLength}return $}}e.$3h=C;var v;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(v||(v={}));function S(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class u{constructor(a,d,$,D){this.type=a,this.id=d,this.ack=$,this.data=D,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Tc{constructor(a){super(),this.f=this.B(new N.$6d),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=a,this.b=!1,this.c=new C,this.B(this.a.onData(d=>this.acceptChunk(d))),this.lastReadTime=Date.now()}acceptChunk(a){if(!(!a||a.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(a);this.c.byteLength>=this.g.readLen;){const d=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=d.readUInt32BE(9),this.g.messageType=d.readUInt8(0),this.g.id=d.readUInt32BE(1),this.g.ack=d.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,D=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",d),this.f.fire(new u($,D,b,d)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(a){this.k=null,this.a=!1,this.b=!1,this.c=a,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(a){if(this.a)return;a.writtenTime=Date.now(),this.lastWriteTime=Date.now();const d=l.$te.alloc(13);d.writeUInt8(a.type,0),d.writeUInt32BE(a.id,1),d.writeUInt32BE(a.ack,5),d.writeUInt32BE(a.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(a.type),id:a.id,ack:a.ack,messageSize:a.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",a.data),this.j(d,a.data)}g(a,d){const $=this.f===0;return this.d.push(a,d),this.f+=a.byteLength+d.byteLength,$}h(){const a=l.$te.concat(this.d,this.f);return this.d.length=0,this.f=0,a}j(a,d){this.g(a,d)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const a=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:a.byteLength}),this.c.write(a)}}class i extends L.$Tc{constructor(a){super(),this.f=new N.$6d,this.onMessage=this.f.event,this.g=new N.$6d,this.onDidDispose=this.g.event,this.a=a,this.b=this.B(new o(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(d=>{d.type===1&&this.f.fire(d.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(a){this.b.write(new u(1,0,0,a))}}e.$4h=i;class n extends A.$Xh{static fromSocket(a,d){return new n(new i(a),d)}get onDidDispose(){return this.b.onDidDispose}constructor(a,d,$=null){super(a,d,$),this.b=a}dispose(){super.dispose();const a=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),a.end()}}e.$5h=n;class r{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$6d({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(a){this.b?this.d.length>0?this.d.push(a):this.a.fire(a):this.d.push(a)}flushBuffer(){this.d=[]}}e.$6h=r;class c{constructor(a){this.data=a,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let a=0,d=this.a;for(;d;)d=d.next,a++;return a}peek(){return this.a?this.a.data:null}toArray(){const a=[];let d=0,$=this.a;for(;$;)a[d++]=$.data,$=$.next;return a}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(a){const d=new c(a);if(!this.a){this.a=d,this.b=d;return}this.b.next=d,this.b=d}}class f{static{this.a=10}static{this.b=null}static getInstance(){return f.b||(f.b=new f),f.b}constructor(){this.c=[];const a=Date.now();for(let d=0;d<f.a;d++)this.c[d]=a-1e3*d;setInterval(()=>{for(let d=f.a;d>=1;d--)this.c[d]=this.c[d-1];this.c[0]=Date.now()},1e3)}d(){const a=Date.now(),d=(1+f.a)*1e3;let $=0;for(let D=0;D<f.a;D++)a-this.c[D]<=d&&$++;return 1-$/f.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(a){this.u=new r,this.onControlMessage=this.u.event,this.v=new r,this.onMessage=this.v.event,this.w=new r,this.onDidDispose=this.w.event,this.x=new r,this.onSocketClose=this.x.event,this.y=new r,this.onSocketTimeout=this.y.event,this.s=a.loadEstimator??f.getInstance(),this.t=a.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Sc,this.o=a.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(d=>this.z(d))),this.r.add(this.o.onClose(d=>this.x.fire(d))),a.initialChunk&&this.q.acceptChunk(a.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const a=new u(5,0,0,M());this.p.write(a),this.p.flush()}sendPause(){const a=new u(7,0,0,M());this.p.write(a)}sendResume(){const a=new u(8,0,0,M());this.p.write(a)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(a,d){this.a=!0,this.r.dispose(),this.r=new L.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=a,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(d)}endAcceptReconnection(){this.a=!1,this.h=this.g;const a=new u(3,0,this.h,M());this.p.write(a);const d=this.b.toArray();for(let $=0,D=d.length;$<D;$++)this.p.write(d[$]);this.B()}acceptDisconnect(){this.w.fire()}z(a){if(a.ack>this.d){this.d=a.ack;do{const d=this.b.peek();if(d&&d.id<=a.ack)this.b.pop();else break}while(!0)}switch(a.type){case 0:break;case 1:{if(a.id>this.g)if(a.id!==this.g+1){const d=Date.now();d-this.m>1e4&&(this.m=d,this.p.write(new u(6,0,0,M())))}else this.g=a.id,this.j=Date.now(),this.A(),this.v.fire(a.data);break}case 2:{this.u.fire(a.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const d=this.b.toArray();for(let $=0,D=d.length;$<D;$++)this.p.write(d[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(a){const d=++this.c;this.h=this.g;const $=new u(1,d,this.h,a);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(a){const d=new u(2,0,0,a);this.p.write(d)}A(){if(this.g<=this.h||this.k)return;const a=Date.now()-this.j;if(a>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-a+5)}B(){if(this.c<=this.d||this.f||this.a)return;const a=this.b.peek(),d=Date.now()-a.writtenTime,$=Date.now()-this.q.lastReadTime,D=Date.now()-this.n;if(d>=2e4&&$>=2e4&&D>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:d,timeSinceLastReceivedSomeData:$});return}const b=Math.max(2e4-d,2e4-$,2e4-D,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const a=new u(3,0,this.h,M());this.p.write(a)}D(){this.h=this.g;const a=new u(9,0,this.h,M());this.p.write(a)}}e.$7h=h}),define(Se[192],De([1,0,51,8,21,22,190,13,4,3,24,105,102,80]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=void 0;class y extends S.$Uh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",i=>L.$te.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$Fq=y;class u{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new p.$6d,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new N.$dh(n),this.d=null,this.f=null}getChannel(o){const i=this;return{call(n,r,c){return i.k(o,n,r,c)},listen(n,r){return i.l(o,n,r)}}}k(o,i,n,r=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(r.isCancellationRequested)return Promise.reject(w.$6());this.b.cancel();const c=this.n(o),t=(0,N.$6g)(s=>c.call(i,n,s)),f=r.onCancellationRequested(()=>t.cancel()),h=(0,E.$Rc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{f.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,n){if(!this.b)return p.Event.None;this.b.cancel();let r;const c=new p.$6d({onWillAddFirstListener:()=>{r=this.n(o).listen(i,n)(c.fire,c),this.c.add(r)},onDidRemoveLastListener:()=>{this.c.delete(r),r.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,M.$Ln)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(a=>!/^--inspect(-brk)?=/.test(a)).filter(a=>!a.startsWith("--vscode-"))),(0,v.$4l)(i.env),this.d=(0,l.fork)(this.i,o,i);const n=new p.$6d;p.Event.fromNodeEventEmitter(this.d,"message",a=>a)(a=>{if((0,R.$Bq)(a)){(0,R.log)(a,`IPC Library: ${this.j.serverName}`);return}n.fire(L.$te.wrap(Buffer.from(a,"base64")))});const c=this.j.useQueue?(0,C.$6l)(this.d):this.d,t=a=>this.d&&this.d.connected&&c.send(a.buffer.toString("base64")),f=n.event,h={send:t,onMessage:f};this.f=new S.$Vh(h);const s=()=>this.o();process.once("exit",s),this.d.on("error",a=>console.warn('IPC "'+this.j.serverName+'" errored with '+a)),this.d.on("exit",(a,d)=>{process.removeListener("exit",s),this.c.forEach($=>(0,E.$Oc)($)),this.c.clear(),a!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+a+" and signal "+d),this.b?.cancel(),this.o(),this.h.fire({code:a,signal:d})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Gq=u}),define(Se[193],De([1,0,8,4,3,56,18]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=e.StorageState=e.$Ep=e.StorageHint=void 0;var w;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(w||(e.StorageHint=w={}));function p(v){const S=v;return S?.changed instanceof Map||S?.deleted instanceof Set}e.$Ep=p;var E;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(E||(e.StorageState=E={}));class M extends L.$Tc{static{this.a=100}constructor(S,y=Object.create(null)){super(),this.r=S,this.s=y,this.b=this.B(new N.$9d),this.onDidChangeStorage=this.b.event,this.c=E.None,this.f=new Map,this.g=this.B(new l.$eh(M.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((y,u)=>this.w(u,y)),S.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(S,y){if(this.c===E.Closed)return;let u=!1;(0,R.$3f)(y)?u=this.f.delete(S):this.f.get(S)!==y&&(this.f.set(S,y),u=!0),u&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===E.None&&(this.c=E.Initialized,this.s.hint!==w.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,y){const u=this.f.get(S);return(0,R.$3f)(u)?y:u}getBoolean(S,y){const u=this.get(S);return(0,R.$3f)(u)?y:u==="true"}getNumber(S,y){const u=this.get(S);return(0,R.$3f)(u)?y:parseInt(u,10)}getObject(S,y){const u=this.get(S);return(0,R.$3f)(u)?y:(0,A.$Oh)(u)}async set(S,y,u=!1){if(this.c===E.Closed)return;if((0,R.$3f)(y))return this.delete(S,u);const m=(0,R.$Vf)(y)||Array.isArray(y)?(0,A.$Nh)(y):String(y);if(this.f.get(S)!==m)return this.f.set(S,m),this.j.set(S,m),this.h.delete(S),this.b.fire({key:S,external:u}),this.D()}async delete(S,y=!1){if(!(this.c===E.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:y}),this.D()}async optimize(){if(this.c!==E.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=E.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(this.z)return this.D(S)}async D(S){return this.s.hint===w.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===w.STORAGE_IN_MEMORY}}e.$Fp=M;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((y,u)=>this.a.set(u,y)),S.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$Gp=C}),define(Se[194],De([1,0,14,11,21]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=void 0;let A;function R(){return A||(A=new TextDecoder("UTF-16LE")),A}let w;function p(){return w||(w=new TextDecoder("UTF-16BE")),w}let E;function M(){return E||(E=N.$D()?R():p()),E}e.$pt=M;function C(y,u,m){const o=new Uint16Array(y.buffer,u,m);return m>0&&(o[0]===65279||o[0]===65534)?v(y,u,m):R().decode(o)}e.$qt=C;function v(y,u,m){const o=[];let i=0;for(let n=0;n<m;n++){const r=L.$ve(y,u);u+=2,o[i++]=String.fromCharCode(r)}return o.join("")}class S{constructor(u){this.a=u|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const u=new Uint16Array(this.b.buffer,0,this.d);return M().decode(u)}f(){const u=this.e();this.d=0,this.c===null?this.c=[u]:this.c[this.c.length]=u}appendCharCode(u){const m=this.a-this.d;m<=1&&(m===0||l.$of(u))&&this.f(),this.b[this.d++]=u}appendASCIICharCode(u){this.d===this.a&&this.f(),this.b[this.d++]=u}appendString(u){const m=u.length;if(this.d+m>=this.a){this.f(),this.c[this.c.length]=u;return}for(let o=0;o<m;o++)this.b[this.d++]=u.charCodeAt(o)}}e.$rt=S}),define(Se[195],De([1,0,21,194]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=void 0;function L(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class A{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,M,C,v){this.oldPosition=E,this.oldText=M,this.newPosition=C,this.newText=v}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${L(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${L(this.oldText)}")`:`(replace@${this.oldPosition} "${L(this.oldText)}" with "${L(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,M,C){const v=M.length;l.$ye(E,v,C),C+=4;for(let S=0;S<v;S++)l.$we(E,M.charCodeAt(S),C),C+=2;return C}static d(E,M){const C=l.$xe(E,M);return M+=4,(0,N.$qt)(E,M,C)}writeSize(){return 8+A.a(this.oldText)+A.a(this.newText)}write(E,M){return l.$ye(E,this.oldPosition,M),M+=4,l.$ye(E,this.newPosition,M),M+=4,M=A.c(E,this.oldText,M),M=A.c(E,this.newText,M),M}static read(E,M,C){const v=l.$xe(E,M);M+=4;const S=l.$xe(E,M);M+=4;const y=A.d(E,M);M+=A.a(y);const u=A.d(E,M);return M+=A.a(u),C.push(new A(v,y,S,u)),M}}e.$st=A;function R(p,E){return p===null||p.length===0?E:new w(p,E).compress()}e.$tt=R;class w{constructor(E,M){this.a=E,this.c=M,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,M=0,C=this.n(E),v=this.l(M);for(;E<this.f||M<this.h;){if(C===null){this.k(v),v=this.l(++M);continue}if(v===null){this.m(C),C=this.n(++E);continue}if(v.oldEnd<=C.newPosition){this.k(v),v=this.l(++M);continue}if(C.newEnd<=v.oldPosition){this.m(C),C=this.n(++E);continue}if(v.oldPosition<C.newPosition){const[o,i]=w.r(v,C.newPosition-v.oldPosition);this.k(o),v=i;continue}if(C.newPosition<v.oldPosition){const[o,i]=w.q(C,v.oldPosition-C.newPosition);this.m(o),C=i;continue}let u,m;if(v.oldEnd===C.newEnd)u=C,m=v,C=this.n(++E),v=this.l(++M);else if(v.oldEnd<C.newEnd){const[o,i]=w.q(C,v.oldLength);u=o,m=v,C=i,v=this.l(++M)}else{const[o,i]=w.r(v,C.newLength);u=C,m=o,C=this.n(++E),v=i}this.d[this.e++]=new A(u.oldPosition,u.oldText,m.newPosition,m.newText),this.g+=u.newLength-u.oldLength,this.j+=m.newLength-m.oldLength}const S=w.s(this.d);return w.t(S)}k(E){this.d[this.e++]=w.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=w.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,M){return new A(M.oldPosition-E,M.oldText,M.newPosition,M.newText)}static p(E,M){return new A(M.oldPosition,M.oldText,M.newPosition+E,M.newText)}static q(E,M){const C=E.newText.substr(0,M),v=E.newText.substr(M);return[new A(E.oldPosition,E.oldText,E.newPosition,C),new A(E.oldEnd,"",E.newPosition+M,v)]}static r(E,M){const C=E.oldText.substr(0,M),v=E.oldText.substr(M);return[new A(E.oldPosition,C,E.newPosition,E.newText),new A(E.oldPosition+M,v,E.newEnd,"")]}static s(E){if(E.length===0)return E;const M=[];let C=0,v=E[0];for(let S=1;S<E.length;S++){const y=E[S];v.oldEnd===y.oldPosition?v=new A(v.oldPosition,v.oldText+y.oldText,v.newPosition,v.newText+y.newText):(M[C++]=v,v=y)}return M[C++]=v,M}static t(E){if(E.length===0)return E;const M=[];let C=0;for(let v=0;v<E.length;v++){const S=E[v];S.oldText!==S.newText&&(M[C++]=S)}return M}}}),define(Se[196],De([1,0,35,17]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rt=e.$Qt=void 0;function L(R,w,p,E,M,C){if(Array.isArray(R)){let v=0;for(const S of R){const y=L(S,w,p,E,M,C);if(y===10)return y;y>v&&(v=y)}return v}else{if(typeof R=="string")return E?R==="*"?5:R===p?10:0:0;if(R){const{language:v,pattern:S,scheme:y,hasAccessToAllModels:u,notebookType:m}=R;if(!E&&!u)return 0;m&&M&&(w=M);let o=0;if(y)if(y===w.scheme)o=10;else if(y==="*")o=5;else return 0;if(v)if(v===p)o=10;else if(v==="*")o=Math.max(o,5);else return 0;if(m)if(m===C)o=10;else if(m==="*"&&C!==void 0)o=Math.max(o,5);else return 0;if(S){let i;if(typeof S=="string"?i=S:i={...S,base:(0,N.$hc)(S.base)},i===w.fsPath||(0,l.$Yj)(i,w.fsPath))o=10;else return 0}return o}else return 0}}e.$Qt=L;function A(R){return typeof R=="string"?!1:Array.isArray(R)?R.some(A):!!R.notebookType}e.$Rt=A}),define(Se[197],De([1,0,4,14,29,78,130,172,195,3]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rC=void 0;class M extends E.$Tc{constructor(v,S,y,u,m,o,i){super(),this.m=this.B(new l.$6d),this.onDidChangeContent=this.m.event,this.f=S,this.j=!o,this.g=u,this.h=m,this.c=new R.$qC(v,y,i)}equals(v){return!(v instanceof M)||this.f!==v.f||this.getEOL()!==v.getEOL()?!1:this.c.equal(v.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(v){return this.c.createSnapshot(v?this.f:"")}getOffsetAt(v,S){return this.c.getOffsetAt(v,S)}getPositionAt(v){return this.c.getPositionAt(v)}getRangeAt(v,S){const y=v+S,u=this.getPositionAt(v),m=this.getPositionAt(y);return new L.$0s(u.lineNumber,u.column,m.lineNumber,m.column)}getValueInRange(v,S=0){if(v.isEmpty())return"";const y=this.n(S);return this.c.getValueInRange(v,y)}getValueLengthInRange(v,S=0){if(v.isEmpty())return 0;if(v.startLineNumber===v.endLineNumber)return v.endColumn-v.startColumn;const y=this.getOffsetAt(v.startLineNumber,v.startColumn),u=this.getOffsetAt(v.endLineNumber,v.endColumn);let m=0;const o=this.n(S),i=this.getEOL();if(o.length!==i.length){const n=o.length-i.length,r=v.endLineNumber-v.startLineNumber;m=n*r}return u-y+m}getCharacterCountInRange(v,S=0){if(this.j){let y=0;const u=v.startLineNumber,m=v.endLineNumber;for(let o=u;o<=m;o++){const i=this.getLineContent(o),n=o===u?v.startColumn-1:0,r=o===m?v.endColumn-1:i.length;for(let c=n;c<r;c++)N.$of(i.charCodeAt(c))?(y=y+1,c=c+1):y=y+1}return y+=this.n(S).length*(m-u),y}return this.getValueLengthInRange(v,S)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(v){return this.c.getLineContent(v)}getLineCharCode(v,S){return this.c.getLineCharCode(v,S)}getCharCode(v){return this.c.getCharCode(v)}getLineLength(v){return this.c.getLineLength(v)}getLineMinColumn(v){return 1}getLineMaxColumn(v){return this.getLineLength(v)+1}getLineFirstNonWhitespaceColumn(v){const S=N.$_e(this.getLineContent(v));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(v){const S=N.$bf(this.getLineContent(v));return S===-1?0:S+2}n(v){switch(v){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(v){this.c.setEOL(v)}applyEdits(v,S,y){let u=this.g,m=this.h,o=this.j,i=!0,n=[];for(let a=0;a<v.length;a++){const d=v[a];i&&d._isTracked&&(i=!1);const $=d.range;if(d.text){let P=!0;o||(P=!N.$zf(d.text),o=P),!u&&P&&(u=N.$yf(d.text)),!m&&P&&(m=N.$Bf(d.text))}let D="",b=0,g=0,k=0;if(d.text){let P;[b,g,k,P]=(0,w.$Jt)(d.text);const F=this.getEOL();P===0||P===(F===`\r
`?2:1)?D=d.text:D=d.text.replace(/\r\n|\r|\n/g,F)}n[a]={sortIndex:a,identifier:d.identifier||null,range:$,rangeOffset:this.getOffsetAt($.startLineNumber,$.startColumn),rangeLength:this.getValueLengthInRange($),text:D,eolCount:b,firstLineLength:g,lastLineLength:k,forceMoveMarkers:!!d.forceMoveMarkers,isAutoWhitespaceEdit:d.isAutoWhitespaceEdit||!1}}n.sort(M.u);let r=!1;for(let a=0,d=n.length-1;a<d;a++){const $=n[a].range.getEndPosition(),D=n[a+1].range.getStartPosition();if(D.isBeforeOrEqual($)){if(D.isBefore($))throw new Error("Overlapping ranges are not allowed!");r=!0}}i&&(n=this.s(n));const c=y||S?M._getInverseEditRanges(n):[],t=[];if(S)for(let a=0;a<n.length;a++){const d=n[a],$=c[a];if(d.isAutoWhitespaceEdit&&d.range.isEmpty())for(let D=$.startLineNumber;D<=$.endLineNumber;D++){let b="";D===$.startLineNumber&&(b=this.getLineContent(d.range.startLineNumber),N.$_e(b)!==-1)||t.push({lineNumber:D,oldContent:b})}}let f=null;if(y){let a=0;f=[];for(let d=0;d<n.length;d++){const $=n[d],D=c[d],b=this.getValueInRange($.range),g=$.rangeOffset+a;a+=$.text.length-b.length,f[d]={sortIndex:$.sortIndex,identifier:$.identifier,range:D,text:b,textChange:new p.$st($.rangeOffset,b,g,$.text)}}r||f.sort((d,$)=>d.sortIndex-$.sortIndex)}this.g=u,this.h=m,this.j=o;const h=this.t(n);let s=null;if(S&&t.length>0){t.sort((a,d)=>d.lineNumber-a.lineNumber),s=[];for(let a=0,d=t.length;a<d;a++){const $=t[a].lineNumber;if(a>0&&t[a-1].lineNumber===$)continue;const D=t[a].oldContent,b=this.getLineContent($);b.length===0||b===D||N.$_e(b)!==-1||s.push($)}}return this.m.fire(),new A.$uv(f,h,s)}s(v){return v.length<1e3?v:[this._toSingleEditOperation(v)]}_toSingleEditOperation(v){let S=!1;const y=v[0].range,u=v[v.length-1].range,m=new L.$0s(y.startLineNumber,y.startColumn,u.endLineNumber,u.endColumn);let o=y.startLineNumber,i=y.startColumn;const n=[];for(let h=0,s=v.length;h<s;h++){const a=v[h],d=a.range;S=S||a.forceMoveMarkers,n.push(this.getValueInRange(new L.$0s(o,i,d.startLineNumber,d.startColumn))),a.text.length>0&&n.push(a.text),o=d.endLineNumber,i=d.endColumn}const r=n.join(""),[c,t,f]=(0,w.$Jt)(r);return{sortIndex:0,identifier:v[0].identifier,range:m,rangeOffset:this.getOffsetAt(m.startLineNumber,m.startColumn),rangeLength:this.getValueLengthInRange(m,0),text:r,eolCount:c,firstLineLength:t,lastLineLength:f,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(v){v.sort(M.w);const S=[];for(let y=0;y<v.length;y++){const u=v[y],m=u.range.startLineNumber,o=u.range.startColumn,i=u.range.endLineNumber,n=u.range.endColumn;if(m===i&&o===n&&u.text.length===0)continue;u.text?(this.c.delete(u.rangeOffset,u.rangeLength),this.c.insert(u.rangeOffset,u.text,!0)):this.c.delete(u.rangeOffset,u.rangeLength);const r=new L.$0s(m,o,i,n);S.push({range:r,rangeLength:u.rangeLength,text:u.text,rangeOffset:u.rangeOffset,forceMoveMarkers:u.forceMoveMarkers})}return S}findMatchesLineByLine(v,S,y,u){return this.c.findMatchesLineByLine(v,S,y,u)}getPieceTree(){return this.c}static _getInverseEditRange(v,S){const y=v.startLineNumber,u=v.startColumn,[m,o,i]=(0,w.$Jt)(S);let n;if(S.length>0){const r=m+1;r===1?n=new L.$0s(y,u,y,u+o):n=new L.$0s(y,u,y+r-1,i+1)}else n=new L.$0s(y,u,y,u);return n}static _getInverseEditRanges(v){const S=[];let y=0,u=0,m=null;for(let o=0,i=v.length;o<i;o++){const n=v[o];let r,c;m?m.range.endLineNumber===n.range.startLineNumber?(r=y,c=u+(n.range.startColumn-m.range.endColumn)):(r=y+(n.range.startLineNumber-m.range.endLineNumber),c=n.range.startColumn):(r=n.range.startLineNumber,c=n.range.startColumn);let t;if(n.text.length>0){const f=n.eolCount+1;f===1?t=new L.$0s(r,c,r,c+n.firstLineLength):t=new L.$0s(r,c,r+f-1,n.lastLineLength+1)}else t=new L.$0s(r,c,r,c);y=t.endLineNumber,u=t.endColumn,S.push(t),m=n}return S}static u(v,S){const y=L.$0s.compareRangesUsingEnds(v.range,S.range);return y===0?v.sortIndex-S.sortIndex:y}static w(v,S){const y=L.$0s.compareRangesUsingEnds(v.range,S.range);return y===0?S.sortIndex-v.sortIndex:-y}}e.$rC=M}),define(Se[198],De([1,0,14,130,197]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sC=void 0;class A{constructor(p,E,M,C,v,S,y,u,m){this.a=p,this.b=E,this.c=M,this.d=C,this.e=v,this.f=S,this.g=y,this.h=u,this.j=m}k(p){const E=this.c+this.d+this.e,M=this.c+this.e;return E===0?p===1?`
`:`\r
`:M>E/2?`\r
`:`
`}create(p){const E=this.k(p),M=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let v=0,S=M.length;v<S;v++){const y=M[v].buffer.replace(/\r\n|\r|\n/g,E),u=(0,N.$mC)(y);M[v]=new N.$pC(y,u)}const C=new L.$rC(M,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText(p){return this.a[0].buffer.substr(0,p).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(p){if(p.length===0)return;this.a.length===0&&l.$Hf(p)&&(this.b=l.$Gf,p=p.substr(1));const E=p.charCodeAt(p.length-1);E===13||E>=55296&&E<=56319?(this.m(p.substr(0,p.length-1),!1),this.c=!0,this.d=E):(this.m(p,!1),this.c=!1,this.d=E)}m(p,E){!E&&p.length===0||(this.c?this.n(String.fromCharCode(this.d)+p):this.n(p))}n(p){const E=(0,N.$nC)(this.e,p);this.a.push(new N.$pC(p,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=l.$yf(p)),this.k||(this.k=l.$Bf(p)))}finish(p=!0){return this.o(),new A(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,p)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const p=this.a[this.a.length-1];p.buffer+=String.fromCharCode(this.d);const E=(0,N.$mC)(p.buffer);p.lineStarts=E,this.d===13&&this.f++}}}e.$sC=R}),define(Se[134],De([1,0,21,11]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fab=e.$eab=void 0;var L;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(L||(L={}));function A(C){for(let v=0,S=C.length;v<S;v+=4){const y=C[v+0],u=C[v+1],m=C[v+2],o=C[v+3];C[v+0]=o,C[v+1]=m,C[v+2]=u,C[v+3]=y}}function R(C){const v=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||A(v),l.$te.wrap(v)}function w(C){const v=C.buffer;if(N.$D()||A(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const S=new Uint8Array(v.byteLength);return S.set(v),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(C){const v=new Uint32Array(E(C));let S=0;if(v[S++]=C.id,C.type==="full")v[S++]=1,v[S++]=C.data.length,v.set(C.data,S),S+=C.data.length;else{v[S++]=2,v[S++]=C.deltas.length;for(const y of C.deltas)v[S++]=y.start,v[S++]=y.deleteCount,y.data?(v[S++]=y.data.length,v.set(y.data,S),S+=y.data.length):v[S++]=0}return R(v)}e.$eab=p;function E(C){let v=0;if(v+=2,C.type==="full")v+=1+C.data.length;else{v+=1,v+=3*C.deltas.length;for(const S of C.deltas)S.data&&(v+=S.data.length)}return v}function M(C){const v=w(C);let S=0;const y=v[S++];if(v[S++]===1){const i=v[S++],n=v.subarray(S,S+i);return S+=i,{id:y,type:"full",data:n}}const m=v[S++],o=[];for(let i=0;i<m;i++){const n=v[S++],r=v[S++],c=v[S++];let t;c>0&&(t=v.subarray(S,S+c),S+=c),o[i]={start:n,deleteCount:r,data:t}}return{id:y,type:"delta",deltas:o}}e.$fab=M}),define(Se[199],De([9,10]),function(fe,e){return fe.create("vs/editor/common/config/editorOptions",e)}),define(Se[135],De([1,0,19,24,11,175,129,199]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var p;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})(p||(e.EditorAutoIndentStrategy=p={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(oe){this.c=oe}hasChanged(oe){return this.c[oe]}}e.ConfigurationChangedEvent=E;class M{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=M;class C{constructor(oe,Ce,Ge,xe){this.id=oe,this.name=Ce,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}compute(oe,Ce,Ge){return Ge}}class v{constructor(oe,Ce){this.newValue=oe,this.didChange=Ce}}e.ApplyUpdateResult=v;function S(ne,oe){if(typeof ne!="object"||typeof oe!="object"||!ne||!oe)return new v(oe,ne!==oe);if(Array.isArray(ne)||Array.isArray(oe)){const Ge=Array.isArray(ne)&&Array.isArray(oe)&&l.$ub(ne,oe);return new v(oe,!Ge)}let Ce=!1;for(const Ge in oe)if(oe.hasOwnProperty(Ge)){const xe=S(ne[Ge],oe[Ge]);xe.didChange&&(ne[Ge]=xe.newValue,Ce=!0)}return new v(ne,Ce)}class y{constructor(oe){this.schema=void 0,this.id=oe,this.name="_never_",this.defaultValue=void 0}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return this.defaultValue}}class u{constructor(oe,Ce,Ge,xe){this.id=oe,this.name=Ce,this.defaultValue=Ge,this.schema=xe}applyUpdate(oe,Ce){return S(oe,Ce)}validate(oe){return typeof oe>"u"?this.defaultValue:oe}compute(oe,Ce,Ge){return Ge}}function m(ne,oe){return typeof ne>"u"?oe:ne==="false"?!1:!!ne}e.boolean=m;class o extends u{constructor(oe,Ce,Ge,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Ge),super(oe,Ce,Ge,xe)}validate(oe){return m(oe,this.defaultValue)}}function i(ne,oe,Ce,Ge){if(typeof ne>"u")return oe;let xe=parseInt(ne,10);return isNaN(xe)?oe:(xe=Math.max(Ce,xe),xe=Math.min(Ge,xe),xe|0)}e.clampedInt=i;class n extends u{static clampedInt(oe,Ce,Ge,xe){return i(oe,Ce,Ge,xe)}constructor(oe,Ce,Ge,xe,nt,Fe=void 0){typeof Fe<"u"&&(Fe.type="integer",Fe.default=Ge,Fe.minimum=xe,Fe.maximum=nt),super(oe,Ce,Ge,Fe),this.minimum=xe,this.maximum=nt}validate(oe){return n.clampedInt(oe,this.defaultValue,this.minimum,this.maximum)}}function r(ne,oe,Ce,Ge){if(typeof ne>"u")return oe;const xe=c.float(ne,oe);return c.clamp(xe,Ce,Ge)}e.clampedFloat=r;class c extends u{static clamp(oe,Ce,Ge){return oe<Ce?Ce:oe>Ge?Ge:oe}static float(oe,Ce){if(typeof oe=="number")return oe;if(typeof oe>"u")return Ce;const Ge=parseFloat(oe);return isNaN(Ge)?Ce:Ge}constructor(oe,Ce,Ge,xe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ge),super(oe,Ce,Ge,nt),this.validationFn=xe}validate(oe){return this.validationFn(c.float(oe,this.defaultValue))}}class t extends u{static string(oe,Ce){return typeof oe!="string"?Ce:oe}constructor(oe,Ce,Ge,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Ge),super(oe,Ce,Ge,xe)}validate(oe){return t.string(oe,this.defaultValue)}}function f(ne,oe,Ce,Ge){return typeof ne!="string"?oe:Ge&&ne in Ge?Ge[ne]:Ce.indexOf(ne)===-1?oe:ne}e.stringSet=f;class h extends u{constructor(oe,Ce,Ge,xe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=xe,nt.default=Ge),super(oe,Ce,Ge,nt),this.c=xe}validate(oe){return f(oe,this.defaultValue,this.c)}}class s extends C{constructor(oe,Ce,Ge,xe,nt,Fe,$t=void 0){typeof $t<"u"&&($t.type="string",$t.enum=nt,$t.default=xe),super(oe,Ce,Ge,$t),this.c=nt,this.d=Fe}validate(oe){return typeof oe!="string"?this.defaultValue:this.c.indexOf(oe)===-1?this.defaultValue:this.d(oe)}}function a(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class d extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[w.localize(0,null),w.localize(1,null),w.localize(2,null)],default:"auto",tags:["accessibility"],description:w.localize(3,null)})}validate(oe){switch(oe){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(oe,Ce,Ge){return Ge===0?oe.accessibilitySupport:Ge}}class $ extends C{constructor(){const oe={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",oe,{"editor.comments.insertSpace":{type:"boolean",default:oe.insertSpace,description:w.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:oe.ignoreEmptyLines,description:w.localize(5,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertSpace:m(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function b(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(g||(e.TextEditorCursorStyle=g={}));function k(ne){switch(ne){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=k;function P(ne){switch(ne){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class F extends y{constructor(){super(141)}compute(oe,Ce,Ge){const xe=["monaco-editor"];return Ce.get(39)&&xe.push(Ce.get(39)),oe.extraEditorClassName&&xe.push(oe.extraEditorClassName),Ce.get(74)==="default"?xe.push("mouse-default"):Ce.get(74)==="copy"&&xe.push("mouse-copy"),Ce.get(111)&&xe.push("showUnused"),Ce.get(139)&&xe.push("showDeprecated"),xe.join(" ")}}class U extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:w.localize(6,null)})}compute(oe,Ce,Ge){return Ge&&oe.emptySelectionClipboard}}class z extends C{constructor(){const oe={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",oe,{"editor.find.cursorMoveOnType":{type:"boolean",default:oe.cursorMoveOnType,description:w.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:oe.seedSearchStringFromSelection,enumDescriptions:[w.localize(8,null),w.localize(9,null),w.localize(10,null)],description:w.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:oe.autoFindInSelection,enumDescriptions:[w.localize(12,null),w.localize(13,null),w.localize(14,null)],description:w.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:oe.globalFindClipboard,description:w.localize(16,null),included:L.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:oe.addExtraSpaceOnTop,description:w.localize(17,null)},"editor.find.loop":{type:"boolean",default:oe.loop,description:w.localize(18,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{cursorMoveOnType:m(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof oe.seedSearchStringFromSelection=="boolean"?oe.seedSearchStringFromSelection?"always":"never":f(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof oe.autoFindInSelection=="boolean"?oe.autoFindInSelection?"always":"never":f(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(Ce.loop,this.defaultValue.loop)}}}class T extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",T.OFF,{anyOf:[{type:"boolean",description:w.localize(19,null)},{type:"string",description:w.localize(20,null)}],description:w.localize(21,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"||oe.length===0?T.OFF:oe==="true"?T.ON:oe:oe?T.ON:T.OFF}}e.EditorFontLigatures=T;class I extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",I.OFF,{anyOf:[{type:"boolean",description:w.localize(22,null)},{type:"string",description:w.localize(23,null)}],description:w.localize(24,null),default:!1})}validate(oe){return typeof oe>"u"?this.defaultValue:typeof oe=="string"?oe==="false"?I.OFF:oe==="true"?I.TRANSLATE:oe:oe?I.TRANSLATE:I.OFF}compute(oe,Ce,Ge){return oe.fontInfo.fontVariationSettings}}e.EditorFontVariations=I;class O extends y{constructor(){super(50)}compute(oe,Ce,Ge){return oe.fontInfo}}class j extends u{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:w.localize(25,null)})}validate(oe){const Ce=c.float(oe,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:c.clamp(Ce,6,100)}compute(oe,Ce,Ge){return oe.fontInfo.fontSize}}class G extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:G.d,maximum:G.e,errorMessage:w.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:G.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:w.localize(27,null)})}validate(oe){return oe==="normal"||oe==="bold"?oe:String(n.clampedInt(oe,e.EDITOR_FONT_DEFAULTS.fontWeight,G.d,G.e))}}class te extends C{constructor(){const oe={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:oe.multiple,enumDescriptions:[w.localize(28,null),w.localize(29,null),w.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",oe,{"editor.gotoLocation.multiple":{deprecationMessage:w.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:w.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:w.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:w.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:w.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:w.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:oe.alternativeDefinitionCommand,enum:Ge,description:w.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:oe.alternativeTypeDefinitionCommand,enum:Ge,description:w.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:oe.alternativeDeclarationCommand,enum:Ge,description:w.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:oe.alternativeImplementationCommand,enum:Ge,description:w.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:oe.alternativeReferenceCommand,enum:Ge,description:w.localize(41,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{multiple:f(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??f(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??f(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??f(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??f(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??f(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends C{constructor(){const oe={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",oe,{"editor.hover.enabled":{type:"boolean",default:oe.enabled,description:w.localize(42,null)},"editor.hover.delay":{type:"number",default:oe.delay,minimum:0,maximum:1e4,description:w.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:oe.sticky,description:w.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:oe.hidingDelay,description:w.localize(45,null)},"editor.hover.above":{type:"boolean",default:oe.above,description:w.localize(46,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:m(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(Ce.above,this.defaultValue.above)}}}var Z;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(Z||(e.RenderMinimap=Z={}));class X extends y{constructor(){super(144)}compute(oe,Ce,Ge){return X.computeLayout(Ce,{memory:oe.memory,outerWidth:oe.outerWidth,outerHeight:oe.outerHeight,isDominatedByLongLines:oe.isDominatedByLongLines,lineHeight:oe.fontInfo.lineHeight,viewLineCount:oe.viewLineCount,lineNumbersDigitCount:oe.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:oe.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:oe.fontInfo.maxDigitWidth,pixelRatio:oe.pixelRatio,glyphMarginDecorationLaneCount:oe.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(oe){const Ce=oe.height/oe.lineHeight,Ge=Math.floor(oe.paddingTop/oe.lineHeight);let xe=Math.floor(oe.paddingBottom/oe.lineHeight);oe.scrollBeyondLastLine&&(xe=Math.max(xe,Ce-1));const nt=(Ge+oe.viewLineCount+xe)/(oe.pixelRatio*oe.height),Fe=Math.floor(oe.viewLineCount/nt);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:xe,desiredRatio:nt,minimapLineCount:Fe}}static c(oe,Ce){const Ge=oe.outerWidth,xe=oe.outerHeight,nt=oe.pixelRatio;if(!oe.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const Fe=Ce.stableMinimapLayoutInput,$t=Fe&&oe.outerHeight===Fe.outerHeight&&oe.lineHeight===Fe.lineHeight&&oe.typicalHalfwidthCharacterWidth===Fe.typicalHalfwidthCharacterWidth&&oe.pixelRatio===Fe.pixelRatio&&oe.scrollBeyondLastLine===Fe.scrollBeyondLastLine&&oe.paddingTop===Fe.paddingTop&&oe.paddingBottom===Fe.paddingBottom&&oe.minimap.enabled===Fe.minimap.enabled&&oe.minimap.side===Fe.minimap.side&&oe.minimap.size===Fe.minimap.size&&oe.minimap.showSlider===Fe.minimap.showSlider&&oe.minimap.renderCharacters===Fe.minimap.renderCharacters&&oe.minimap.maxColumn===Fe.minimap.maxColumn&&oe.minimap.scale===Fe.minimap.scale&&oe.verticalScrollbarWidth===Fe.verticalScrollbarWidth&&oe.isViewportWrapping===Fe.isViewportWrapping,Dt=oe.lineHeight,Pt=oe.typicalHalfwidthCharacterWidth,jt=oe.scrollBeyondLastLine,Zt=oe.minimap.renderCharacters;let Ct=nt>=2?Math.round(oe.minimap.scale*2):oe.minimap.scale;const Jt=oe.minimap.maxColumn,Qt=oe.minimap.size,_t=oe.minimap.side,ni=oe.verticalScrollbarWidth,et=oe.viewLineCount,Bt=oe.remainingWidth,ei=oe.isViewportWrapping,dt=Zt?2:3;let pt=Math.floor(nt*xe);const ti=pt/nt;let Ht=!1,Ut=!1,ft=dt*Ct,Rt=Ct/nt,ii=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:At,extraLinesBeyondLastLine:qt,desiredRatio:si,minimapLineCount:zt}=X.computeContainedMinimapLineCount({viewLineCount:et,scrollBeyondLastLine:jt,paddingTop:oe.paddingTop,paddingBottom:oe.paddingBottom,height:xe,lineHeight:Dt,pixelRatio:nt});if(et/zt>1)Ht=!0,Ut=!0,Ct=1,ft=1,Rt=Ct/nt;else{let yt=!1,Nt=Ct+1;if(Qt==="fit"){const Xt=Math.ceil((At+et+qt)*ft);ei&&$t&&Bt<=Ce.stableFitRemainingWidth?(yt=!0,Nt=Ce.stableFitMaxMinimapScale):yt=Xt>pt}if(Qt==="fill"||yt){Ht=!0;const Xt=Ct;ft=Math.min(Dt*nt,Math.max(1,Math.floor(1/si))),ei&&$t&&Bt<=Ce.stableFitRemainingWidth&&(Nt=Ce.stableFitMaxMinimapScale),Ct=Math.min(Nt,Math.max(1,Math.floor(ft/dt))),Ct>Xt&&(ii=Math.min(2,Ct/Xt)),Rt=Ct/nt/ii,pt=Math.ceil(Math.max(Ot,At+et+qt)*ft),ei?(Ce.stableMinimapLayoutInput=oe,Ce.stableFitRemainingWidth=Bt,Ce.stableFitMaxMinimapScale=Ct):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Yt=Math.floor(Jt*Rt),Ze=Math.min(Yt,Math.max(0,Math.floor((Bt-ni-2)*Rt/(Pt+Rt)))+e.MINIMAP_GUTTER_WIDTH);let Lt=Math.floor(nt*Ze);const Wt=Lt/nt;Lt=Math.floor(Lt*ii);const ri=Zt?1:2,gt=_t==="left"?0:Ge-Ze-ni;return{renderMinimap:ri,minimapLeft:gt,minimapWidth:Ze,minimapHeightIsEditorHeight:Ht,minimapIsSampling:Ut,minimapScale:Ct,minimapLineHeight:ft,minimapCanvasInnerWidth:Lt,minimapCanvasInnerHeight:pt,minimapCanvasOuterWidth:Wt,minimapCanvasOuterHeight:ti}}static computeLayout(oe,Ce){const Ge=Ce.outerWidth|0,xe=Ce.outerHeight|0,nt=Ce.lineHeight|0,Fe=Ce.lineNumbersDigitCount|0,$t=Ce.typicalHalfwidthCharacterWidth,Dt=Ce.maxDigitWidth,Pt=Ce.pixelRatio,jt=Ce.viewLineCount,Zt=oe.get(136),Ct=Zt==="inherit"?oe.get(135):Zt,Jt=Ct==="inherit"?oe.get(131):Ct,Qt=oe.get(134),_t=Ce.isDominatedByLongLines,ni=oe.get(57),et=oe.get(68).renderType!==0,Bt=oe.get(69),ei=oe.get(105),dt=oe.get(84),pt=oe.get(73),ti=oe.get(103),Ht=ti.verticalScrollbarSize,Ut=ti.verticalHasArrows,ft=ti.arrowSize,Rt=ti.horizontalScrollbarSize,ii=oe.get(43),Yt=oe.get(110)!=="never";let Ze=oe.get(66);ii&&Yt&&(Ze+=16);let Lt=0;if(et){const kt=Math.max(Fe,Bt);Lt=Math.round(kt*Dt)}let Wt=0;ni&&(Wt=nt*Ce.glyphMarginDecorationLaneCount);let ri=0,gt=ri+Wt,Ot=gt+Lt,At=Ot+Ze;const qt=Ge-Wt-Lt-Ze;let si=!1,zt=!1,Kt=-1;Ct==="inherit"&&_t?(si=!0,zt=!0):Jt==="on"||Jt==="bounded"?zt=!0:Jt==="wordWrapColumn"&&(Kt=Qt);const yt=X.c({outerWidth:Ge,outerHeight:xe,lineHeight:nt,typicalHalfwidthCharacterWidth:$t,pixelRatio:Pt,scrollBeyondLastLine:ei,paddingTop:dt.top,paddingBottom:dt.bottom,minimap:pt,verticalScrollbarWidth:Ht,viewLineCount:jt,remainingWidth:qt,isViewportWrapping:zt},Ce.memory||new M);yt.renderMinimap!==0&&yt.minimapLeft===0&&(ri+=yt.minimapWidth,gt+=yt.minimapWidth,Ot+=yt.minimapWidth,At+=yt.minimapWidth);const Nt=qt-yt.minimapWidth,Xt=Math.max(1,Math.floor((Nt-Ht-2)/$t)),Vt=Ut?ft:0;return zt&&(Kt=Math.max(1,Xt),Jt==="bounded"&&(Kt=Math.min(Kt,Qt))),{width:Ge,height:xe,glyphMarginLeft:ri,glyphMarginWidth:Wt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:gt,lineNumbersWidth:Lt,decorationsLeft:Ot,decorationsWidth:Ze,contentLeft:At,contentWidth:Nt,minimap:yt,viewportColumn:Xt,isWordWrapMinified:si,isViewportWrapping:zt,wrappingColumn:Kt,verticalScrollbarWidth:Ht,horizontalScrollbarHeight:Rt,overviewRuler:{top:Vt,width:Ht,height:xe-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=X;class ae extends C{constructor(){super(138,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[w.localize(47,null),w.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:w.localize(49,null)}})}validate(oe){return f(oe,"simple",["simple","advanced"])}compute(oe,Ce,Ge){return Ce.get(2)===2?"advanced":Ge}}var _;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(_||(e.ShowLightbulbIconMode=_={}));class ge extends C{constructor(){const oe={enabled:_.OnCode};super(65,"lightbulb",oe,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[_.Off,_.OnCode,_.On],default:oe.enabled,enumDescriptions:[w.localize(50,null),w.localize(51,null),w.localize(52,null)],description:w.localize(53,null)}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{enabled:f(oe.enabled,this.defaultValue.enabled,[_.Off,_.OnCode,_.On])}}}class se extends C{constructor(){const oe={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",oe,{"editor.stickyScroll.enabled":{type:"boolean",default:oe.enabled,description:w.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:oe.maxLineCount,minimum:1,maximum:20,description:w.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:oe.defaultModel,description:w.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:oe.scrollWithEditor,description:w.localize(57,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:f(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class re extends C{constructor(){const oe={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(140,"inlayHints",oe,{"editor.inlayHints.enabled":{type:"string",default:oe.enabled,description:w.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[w.localize(59,null),w.localize(60,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(61,null,L.$j?"Ctrl+Option":"Ctrl+Alt"),w.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:oe.fontSize,markdownDescription:w.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:oe.fontFamily,markdownDescription:w.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:oe.padding,description:w.localize(65,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:f(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:m(Ce.padding,this.defaultValue.padding)}}}class B extends C{constructor(){super(66,"lineDecorationsWidth",10)}validate(oe){return typeof oe=="string"&&/^\d+(\.\d+)?ch$/.test(oe)?-parseFloat(oe.substring(0,oe.length-2)):n.clampedInt(oe,this.defaultValue,0,1e3)}compute(oe,Ce,Ge){return Ge<0?n.clampedInt(-Ge*oe.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class ie extends c{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,oe=>c.clamp(oe,0,150),{markdownDescription:w.localize(66,null)})}compute(oe,Ce,Ge){return oe.fontInfo.lineHeight}}class ke extends C{constructor(){const oe={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(73,"minimap",oe,{"editor.minimap.enabled":{type:"boolean",default:oe.enabled,description:w.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:oe.autohide,description:w.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[w.localize(69,null),w.localize(70,null),w.localize(71,null)],default:oe.size,description:w.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:oe.side,description:w.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:oe.showSlider,description:w.localize(74,null)},"editor.minimap.scale":{type:"number",default:oe.scale,minimum:1,maximum:3,enum:[1,2,3],description:w.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:oe.renderCharacters,description:w.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:oe.maxColumn,description:w.localize(77,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),autohide:m(Ce.autohide,this.defaultValue.autohide),size:f(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(Ce.side,this.defaultValue.side,["right","left"]),showSlider:f(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function le(ne){return ne==="ctrlCmd"?L.$j?"metaKey":"ctrlKey":"altKey"}class ue extends C{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:w.localize(79,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class ce extends C{constructor(){const oe={enabled:!0,cycle:!0};super(86,"parameterHints",oe,{"editor.parameterHints.enabled":{type:"boolean",default:oe.enabled,description:w.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:oe.cycle,description:w.localize(81,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),cycle:m(Ce.cycle,this.defaultValue.cycle)}}}class de extends y{constructor(){super(142)}compute(oe,Ce,Ge){return oe.pixelRatio}}class H extends C{constructor(){const oe={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[w.localize(82,null),w.localize(83,null),w.localize(84,null)]}];super(89,"quickSuggestions",oe,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:oe.strings,description:w.localize(85,null)},comments:{anyOf:Ce,default:oe.comments,description:w.localize(86,null)},other:{anyOf:Ce,default:oe.other,description:w.localize(87,null)}},default:oe,markdownDescription:w.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=oe}validate(oe){if(typeof oe=="boolean"){const Pt=oe?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!oe||typeof oe!="object")return this.defaultValue;const{other:Ce,comments:Ge,strings:xe}=oe,nt=["on","inline","off"];let Fe,$t,Dt;return typeof Ce=="boolean"?Fe=Ce?"on":"off":Fe=f(Ce,this.defaultValue.other,nt),typeof Ge=="boolean"?$t=Ge?"on":"off":$t=f(Ge,this.defaultValue.comments,nt),typeof xe=="boolean"?Dt=xe?"on":"off":Dt=f(xe,this.defaultValue.strings,nt),{other:Fe,comments:$t,strings:Dt}}}var Y;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends C{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[w.localize(89,null),w.localize(90,null),w.localize(91,null),w.localize(92,null)],default:"on",description:w.localize(93,null)})}validate(oe){let Ce=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof oe<"u"&&(typeof oe=="function"?(Ce=4,Ge=oe):oe==="interval"?Ce=3:oe==="relative"?Ce=2:oe==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ge}}}function be(ne){const oe=ne.get(98);return oe==="editable"?ne.get(91):oe!=="on"}e.filterValidationDecorations=be;class Pe extends C{constructor(){const oe=[],Ce={type:"number",description:w.localize(94,null)};super(102,"rulers",oe,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:w.localize(95,null),format:"color-hex"}}}]},default:oe,description:w.localize(96,null)})}validate(oe){if(Array.isArray(oe)){const Ce=[];for(const Ge of oe)if(typeof Ge=="number")Ce.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const xe=Ge;Ce.push({column:n.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Ce.sort((Ge,xe)=>Ge.column-xe.column),Ce}return this.defaultValue}}class we extends C{constructor(){super(92,"readOnlyMessage",void 0)}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:oe}}function Ae(ne,oe){if(typeof ne!="string")return oe;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class Oe extends C{constructor(){const oe={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",oe,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(97,null),w.localize(98,null),w.localize(99,null)],default:"auto",description:w.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[w.localize(101,null),w.localize(102,null),w.localize(103,null)],default:"auto",description:w.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:oe.verticalScrollbarSize,description:w.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:oe.horizontalScrollbarSize,description:w.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:oe.scrollByPage,description:w.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:oe.ignoreHorizontalScrollbarInContentHeight,description:w.localize(108,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe,Ge=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ae(Ce.vertical,this.defaultValue.vertical),horizontal:Ae(Ce.horizontal,this.defaultValue.horizontal),useShadows:m(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,xe,0,1e3),scrollByPage:m(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends C{constructor(){const oe={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",oe,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.nonBasicASCII,description:w.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:oe.invisibleCharacters,description:w.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:oe.ambiguousCharacters,description:w.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeComments,description:w.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:oe.includeStrings,description:w.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:oe.allowedCharacters,description:w.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:oe.allowedLocales,description:w.localize(115,null)}})}applyUpdate(oe,Ce){let Ge=!1;Ce.allowedCharacters&&oe&&(N.$Pn(oe.allowedCharacters,Ce.allowedCharacters)||(oe={...oe,allowedCharacters:Ce.allowedCharacters},Ge=!0)),Ce.allowedLocales&&oe&&(N.$Pn(oe.allowedLocales,Ce.allowedLocales)||(oe={...oe,allowedLocales:Ce.allowedLocales},Ge=!0));const xe=super.applyUpdate(oe,Ce);return Ge?new v(xe.newValue,!0):xe}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{nonBasicASCII:$e(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:$e(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:$e(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(oe.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(oe.allowedLocales,this.defaultValue.allowedLocales)}}c(oe,Ce){if(typeof oe!="object"||!oe)return Ce;const Ge={};for(const[xe,nt]of Object.entries(oe))nt===!0&&(Ge[xe]=!0);return Ge}}class q extends C{constructor(){const oe={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",oe,{"editor.inlineSuggest.enabled":{type:"boolean",default:oe.enabled,description:w.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(117,null),w.localize(118,null),w.localize(119,null)],description:w.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:oe.suppressSuggestions,description:w.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(122,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),mode:f(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class W extends C{constructor(){const oe={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",oe,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:oe.enabled,description:w.localize(123,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:oe.showToolbar,enum:["always","onHover","never"],enumDescriptions:[w.localize(124,null),w.localize(125,null),w.localize(126,null)],description:w.localize(127,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:oe.fontFamily,description:w.localize(128,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:oe.backgroundColoring,description:w.localize(129,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showToolbar:f(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Q extends C{constructor(){const oe={enabled:A.$Hs.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$Hs.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",oe,{"editor.bracketPairColorization.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(130,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:oe.independentColorPoolPerBracketType,description:w.localize(131,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class J extends C{constructor(){const oe={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",oe,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(132,null),w.localize(133,null),w.localize(134,null)],default:oe.bracketPairs,description:w.localize(135,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[w.localize(136,null),w.localize(137,null),w.localize(138,null)],default:oe.bracketPairsHorizontal,description:w.localize(139,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:oe.highlightActiveBracketPair,description:w.localize(140,null)},"editor.guides.indentation":{type:"boolean",default:oe.indentation,description:w.localize(141,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[w.localize(142,null),w.localize(143,null),w.localize(144,null)],default:oe.highlightActiveIndentation,description:w.localize(145,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{bracketPairs:$e(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:$e(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:$e(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function $e(ne,oe,Ce){const Ge=Ce.indexOf(ne);return Ge===-1?oe:Ce[Ge]}class ve extends C{constructor(){const oe={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",oe,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[w.localize(146,null),w.localize(147,null)],default:oe.insertMode,description:w.localize(148,null)},"editor.suggest.filterGraceful":{type:"boolean",default:oe.filterGraceful,description:w.localize(149,null)},"editor.suggest.localityBonus":{type:"boolean",default:oe.localityBonus,description:w.localize(150,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:oe.shareSuggestSelections,markdownDescription:w.localize(151,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[w.localize(152,null),w.localize(153,null),w.localize(154,null),w.localize(155,null)],default:oe.selectionMode,markdownDescription:w.localize(156,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:oe.snippetsPreventQuickSuggestions,description:w.localize(157,null)},"editor.suggest.showIcons":{type:"boolean",default:oe.showIcons,description:w.localize(158,null)},"editor.suggest.showStatusBar":{type:"boolean",default:oe.showStatusBar,description:w.localize(159,null)},"editor.suggest.preview":{type:"boolean",default:oe.preview,description:w.localize(160,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:oe.showInlineDetails,description:w.localize(161,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:w.localize(162,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:w.localize(163,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:w.localize(164,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:w.localize(165,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:w.localize(166,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:w.localize(167,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:w.localize(168,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:w.localize(169,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:w.localize(170,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:w.localize(171,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:w.localize(172,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:w.localize(173,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:w.localize(174,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:w.localize(175,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:w.localize(176,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:w.localize(177,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:w.localize(178,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:w.localize(179,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:w.localize(180,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:w.localize(181,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:w.localize(182,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:w.localize(183,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:w.localize(184,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:w.localize(185,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:w.localize(186,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:w.localize(187,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:w.localize(188,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:w.localize(189,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:w.localize(190,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:w.localize(191,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:w.localize(192,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:w.localize(193,null)}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{insertMode:f(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:m(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:m(Ce.preview,this.defaultValue.preview),previewMode:f(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(Ce.showMethods,this.defaultValue.showMethods),showFunctions:m(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:m(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(Ce.showFields,this.defaultValue.showFields),showVariables:m(Ce.showVariables,this.defaultValue.showVariables),showClasses:m(Ce.showClasses,this.defaultValue.showClasses),showStructs:m(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:m(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:m(Ce.showModules,this.defaultValue.showModules),showProperties:m(Ce.showProperties,this.defaultValue.showProperties),showEvents:m(Ce.showEvents,this.defaultValue.showEvents),showOperators:m(Ce.showOperators,this.defaultValue.showOperators),showUnits:m(Ce.showUnits,this.defaultValue.showUnits),showValues:m(Ce.showValues,this.defaultValue.showValues),showConstants:m(Ce.showConstants,this.defaultValue.showConstants),showEnums:m(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:m(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(Ce.showKeywords,this.defaultValue.showKeywords),showWords:m(Ce.showWords,this.defaultValue.showWords),showColors:m(Ce.showColors,this.defaultValue.showColors),showFiles:m(Ce.showFiles,this.defaultValue.showFiles),showReferences:m(Ce.showReferences,this.defaultValue.showReferences),showFolders:m(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:m(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:m(Ce.showUsers,this.defaultValue.showUsers),showIssues:m(Ce.showIssues,this.defaultValue.showIssues)}}}class Te extends C{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:w.localize(194,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:w.localize(195,null),default:!0,type:"boolean"}})}validate(oe){return!oe||typeof oe!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(oe.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(oe.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Xe extends C{constructor(){super(137,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[w.localize(196,null),w.localize(197,null),w.localize(198,null),w.localize(199,null)],description:w.localize(200,null),default:"same"}})}validate(oe){switch(oe){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(oe,Ce,Ge){return Ce.get(2)===2?0:Ge}}class tt extends y{constructor(){super(145)}compute(oe,Ce,Ge){const xe=Ce.get(144);return{isDominatedByLongLines:oe.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class st extends C{constructor(){const oe={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",oe,{"editor.dropIntoEditor.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(201,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:w.localize(202,null),enum:["afterDrop","never"],enumDescriptions:[w.localize(203,null),w.localize(204,null)],default:"afterDrop"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showDropSelector:f(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ut extends C{constructor(){const oe={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",oe,{"editor.pasteAs.enabled":{type:"boolean",default:oe.enabled,markdownDescription:w.localize(205,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:w.localize(206,null),enum:["afterPaste","never"],enumDescriptions:[w.localize(207,null),w.localize(208,null)],default:"afterPaste"}})}validate(oe){if(!oe||typeof oe!="object")return this.defaultValue;const Ce=oe;return{enabled:m(Ce.enabled,this.defaultValue.enabled),showPasteSelector:f(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Ie="Menlo, Monaco, 'Courier New', monospace",Be="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.$j?Ie:L.$k?Be:rt,fontWeight:"normal",fontSize:L.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ke;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.inlineEdit=63]="inlineEdit",ne[ne.letterSpacing=64]="letterSpacing",ne[ne.lightbulb=65]="lightbulb",ne[ne.lineDecorationsWidth=66]="lineDecorationsWidth",ne[ne.lineHeight=67]="lineHeight",ne[ne.lineNumbers=68]="lineNumbers",ne[ne.lineNumbersMinChars=69]="lineNumbersMinChars",ne[ne.linkedEditing=70]="linkedEditing",ne[ne.links=71]="links",ne[ne.matchBrackets=72]="matchBrackets",ne[ne.minimap=73]="minimap",ne[ne.mouseStyle=74]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=76]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=78]="multiCursorModifier",ne[ne.multiCursorPaste=79]="multiCursorPaste",ne[ne.multiCursorLimit=80]="multiCursorLimit",ne[ne.occurrencesHighlight=81]="occurrencesHighlight",ne[ne.overviewRulerBorder=82]="overviewRulerBorder",ne[ne.overviewRulerLanes=83]="overviewRulerLanes",ne[ne.padding=84]="padding",ne[ne.pasteAs=85]="pasteAs",ne[ne.parameterHints=86]="parameterHints",ne[ne.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=89]="quickSuggestions",ne[ne.quickSuggestionsDelay=90]="quickSuggestionsDelay",ne[ne.readOnly=91]="readOnly",ne[ne.readOnlyMessage=92]="readOnlyMessage",ne[ne.renameOnType=93]="renameOnType",ne[ne.renderControlCharacters=94]="renderControlCharacters",ne[ne.renderFinalNewline=95]="renderFinalNewline",ne[ne.renderLineHighlight=96]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=98]="renderValidationDecorations",ne[ne.renderWhitespace=99]="renderWhitespace",ne[ne.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ne[ne.roundedSelection=101]="roundedSelection",ne[ne.rulers=102]="rulers",ne[ne.scrollbar=103]="scrollbar",ne[ne.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=105]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=106]="scrollPredominantAxis",ne[ne.selectionClipboard=107]="selectionClipboard",ne[ne.selectionHighlight=108]="selectionHighlight",ne[ne.selectOnLineNumbers=109]="selectOnLineNumbers",ne[ne.showFoldingControls=110]="showFoldingControls",ne[ne.showUnused=111]="showUnused",ne[ne.snippetSuggestions=112]="snippetSuggestions",ne[ne.smartSelect=113]="smartSelect",ne[ne.smoothScrolling=114]="smoothScrolling",ne[ne.stickyScroll=115]="stickyScroll",ne[ne.stickyTabStops=116]="stickyTabStops",ne[ne.stopRenderingLineAfter=117]="stopRenderingLineAfter",ne[ne.suggest=118]="suggest",ne[ne.suggestFontSize=119]="suggestFontSize",ne[ne.suggestLineHeight=120]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ne[ne.suggestSelection=122]="suggestSelection",ne[ne.tabCompletion=123]="tabCompletion",ne[ne.tabIndex=124]="tabIndex",ne[ne.unicodeHighlighting=125]="unicodeHighlighting",ne[ne.unusualLineTerminators=126]="unusualLineTerminators",ne[ne.useShadowDOM=127]="useShadowDOM",ne[ne.useTabStops=128]="useTabStops",ne[ne.wordBreak=129]="wordBreak",ne[ne.wordSeparators=130]="wordSeparators",ne[ne.wordWrap=131]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=132]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=133]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=134]="wordWrapColumn",ne[ne.wordWrapOverride1=135]="wordWrapOverride1",ne[ne.wordWrapOverride2=136]="wordWrapOverride2",ne[ne.wrappingIndent=137]="wrappingIndent",ne[ne.wrappingStrategy=138]="wrappingStrategy",ne[ne.showDeprecated=139]="showDeprecated",ne[ne.inlayHints=140]="inlayHints",ne[ne.editorClassName=141]="editorClassName",ne[ne.pixelRatio=142]="pixelRatio",ne[ne.tabFocusMode=143]="tabFocusMode",ne[ne.layoutInfo=144]="layoutInfo",ne[ne.wrappingInfo=145]="wrappingInfo",ne[ne.defaultColorDecorators=146]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=147]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=148]="inlineCompletionsAccessibilityVerbose"})(Ke||(e.EditorOption=Ke={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:w.localize(209,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",w.localize(210,null),""],markdownDescription:w.localize(211,null)})),accessibilitySupport:Le(new d),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:w.localize(212,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",w.localize(213,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:w.localize(214,null),tags:["accessibility"]})),autoClosingBrackets:Le(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(215,null),w.localize(216,null),""],description:w.localize(217,null)})),autoClosingComments:Le(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(218,null),w.localize(219,null),""],description:w.localize(220,null)})),autoClosingDelete:Le(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",w.localize(221,null),""],description:w.localize(222,null)})),autoClosingOvertype:Le(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",w.localize(223,null),""],description:w.localize(224,null)})),autoClosingQuotes:Le(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",w.localize(225,null),w.localize(226,null),""],description:w.localize(227,null)})),autoIndent:Le(new s(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],a,{enumDescriptions:[w.localize(228,null),w.localize(229,null),w.localize(230,null),w.localize(231,null),w.localize(232,null)],description:w.localize(233,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[w.localize(234,null),w.localize(235,null),w.localize(236,null),""],description:w.localize(237,null)})),bracketPairColorization:Le(new Q),bracketPairGuides:Le(new J),stickyTabStops:Le(new o(116,"stickyTabStops",!1,{description:w.localize(238,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:w.localize(239,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:w.localize(240,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:w.localize(241,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:w.localize(242,null)})),colorDecoratorActivatedOn:Le(new h(147,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[w.localize(243,null),w.localize(244,null),w.localize(245,null)],description:w.localize(246,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:w.localize(247,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:w.localize(248,null)})),comments:Le(new $),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:w.localize(249,null)})),cursorBlinking:Le(new s(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:w.localize(250,null)})),cursorSmoothCaretAnimation:Le(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[w.localize(251,null),w.localize(252,null),w.localize(253,null)],description:w.localize(254,null)})),cursorStyle:Le(new s(28,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:w.localize(255,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:w.localize(256,null)})),cursorSurroundingLinesStyle:Le(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[w.localize(257,null),w.localize(258,null)],markdownDescription:w.localize(259,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:w.localize(260,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:w.localize(261,null)})),emptySelectionClipboard:Le(new U),dropIntoEditor:Le(new st),stickyScroll:Le(new se),experimentalWhitespaceRendering:Le(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[w.localize(262,null),w.localize(263,null),w.localize(264,null)],description:w.localize(265,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new c(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:w.localize(266,null)})),find:Le(new z),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:w.localize(267,null)})),foldingStrategy:Le(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[w.localize(268,null),w.localize(269,null)],description:w.localize(270,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:w.localize(271,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:w.localize(272,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:w.localize(273,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:w.localize(274,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:w.localize(275,null)})),fontInfo:Le(new O),fontLigatures2:Le(new T),fontSize:Le(new j),fontWeight:Le(new G),fontVariations:Le(new I),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:w.localize(276,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:w.localize(277,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:w.localize(278,null)})),gotoLocation:Le(new te),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:w.localize(279,null)})),hover:Le(new x),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new c(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>c.clamp(ne,-5,20),{description:w.localize(280,null)})),lightbulb:Le(new ge),lineDecorationsWidth:Le(new B),lineHeight:Le(new ie),lineNumbers:Le(new he),lineNumbersMinChars:Le(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(70,"linkedEditing",!1,{description:w.localize(281,null)})),links:Le(new o(71,"links",!0,{description:w.localize(282,null)})),matchBrackets:Le(new h(72,"matchBrackets","always",["always","near","never"],{description:w.localize(283,null)})),minimap:Le(new ke),mouseStyle:Le(new h(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new c(75,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:w.localize(284,null)})),mouseWheelZoom:Le(new o(76,"mouseWheelZoom",!1,{markdownDescription:L.$j?w.localize(285,null):w.localize(286,null)})),multiCursorMergeOverlapping:Le(new o(77,"multiCursorMergeOverlapping",!0,{description:w.localize(287,null)})),multiCursorModifier:Le(new s(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[w.localize(288,null),w.localize(289,null)],markdownDescription:w.localize(290,null)})),multiCursorPaste:Le(new h(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[w.localize(291,null),w.localize(292,null)],markdownDescription:w.localize(293,null)})),multiCursorLimit:Le(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:w.localize(294,null)})),occurrencesHighlight:Le(new h(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[w.localize(295,null),w.localize(296,null),w.localize(297,null)],markdownDescription:w.localize(298,null)})),overviewRulerBorder:Le(new o(82,"overviewRulerBorder",!0,{description:w.localize(299,null)})),overviewRulerLanes:Le(new n(83,"overviewRulerLanes",3,0,3)),padding:Le(new ue),pasteAs:Le(new ut),parameterHints:Le(new ce),peekWidgetDefaultFocus:Le(new h(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[w.localize(300,null),w.localize(301,null)],description:w.localize(302,null)})),definitionLinkOpensInPeek:Le(new o(88,"definitionLinkOpensInPeek",!1,{description:w.localize(303,null)})),quickSuggestions:Le(new H),quickSuggestionsDelay:Le(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:w.localize(304,null)})),readOnly:Le(new o(91,"readOnly",!1)),readOnlyMessage:Le(new we),renameOnType:Le(new o(93,"renameOnType",!1,{description:w.localize(305,null),markdownDeprecationMessage:w.localize(306,null)})),renderControlCharacters:Le(new o(94,"renderControlCharacters",!0,{description:w.localize(307,null),restricted:!0})),renderFinalNewline:Le(new h(95,"renderFinalNewline",L.$k?"dimmed":"on",["off","on","dimmed"],{description:w.localize(308,null)})),renderLineHighlight:Le(new h(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",w.localize(309,null)],description:w.localize(310,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(97,"renderLineHighlightOnlyWhenFocus",!1,{description:w.localize(311,null)})),renderValidationDecorations:Le(new h(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",w.localize(312,null),w.localize(313,null),w.localize(314,null),""],description:w.localize(315,null)})),revealHorizontalRightPadding:Le(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(101,"roundedSelection",!0,{description:w.localize(316,null)})),rulers:Le(new Pe),scrollbar:Le(new Oe),scrollBeyondLastColumn:Le(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:w.localize(317,null)})),scrollBeyondLastLine:Le(new o(105,"scrollBeyondLastLine",!0,{description:w.localize(318,null)})),scrollPredominantAxis:Le(new o(106,"scrollPredominantAxis",!0,{description:w.localize(319,null)})),selectionClipboard:Le(new o(107,"selectionClipboard",!0,{description:w.localize(320,null),included:L.$k})),selectionHighlight:Le(new o(108,"selectionHighlight",!0,{description:w.localize(321,null)})),selectOnLineNumbers:Le(new o(109,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[w.localize(322,null),w.localize(323,null),w.localize(324,null)],description:w.localize(325,null)})),showUnused:Le(new o(111,"showUnused",!0,{description:w.localize(326,null)})),showDeprecated:Le(new o(139,"showDeprecated",!0,{description:w.localize(327,null)})),inlayHints:Le(new re),snippetSuggestions:Le(new h(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[w.localize(328,null),w.localize(329,null),w.localize(330,null),w.localize(331,null)],description:w.localize(332,null)})),smartSelect:Le(new Te),smoothScrolling:Le(new o(114,"smoothScrolling",!1,{description:w.localize(333,null)})),stopRenderingLineAfter:Le(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new ve),inlineSuggest:Le(new q),inlineEdit:Le(new W),inlineCompletionsAccessibilityVerbose:Le(new o(148,"inlineCompletionsAccessibilityVerbose",!1,{description:w.localize(334,null)})),suggestFontSize:Le(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:w.localize(335,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:w.localize(336,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(121,"suggestOnTriggerCharacters",!0,{description:w.localize(337,null)})),suggestSelection:Le(new h(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[w.localize(338,null),w.localize(339,null),w.localize(340,null)],description:w.localize(341,null)})),tabCompletion:Le(new h(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[w.localize(342,null),w.localize(343,null),w.localize(344,null)],description:w.localize(345,null)})),tabIndex:Le(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new ze),unusualLineTerminators:Le(new h(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[w.localize(346,null),w.localize(347,null),w.localize(348,null)],description:w.localize(349,null)})),useShadowDOM:Le(new o(127,"useShadowDOM",!0)),useTabStops:Le(new o(128,"useTabStops",!0,{description:w.localize(350,null)})),wordBreak:Le(new h(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[w.localize(351,null),w.localize(352,null)],description:w.localize(353,null)})),wordSeparators:Le(new t(130,"wordSeparators",R.$Is,{description:w.localize(354,null)})),wordWrap:Le(new h(131,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[w.localize(355,null),w.localize(356,null),w.localize(357,null),w.localize(358,null)],description:w.localize(359,null)})),wordWrapBreakAfterCharacters:Le(new t(132,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(133,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(134,"wordWrapColumn",80,1,1073741824,{markdownDescription:w.localize(360,null)})),wordWrapOverride1:Le(new h(135,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(136,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new F),defaultColorDecorators:Le(new o(146,"defaultColorDecorators",!1,{markdownDescription:w.localize(361,null)})),pixelRatio:Le(new de),tabFocusMode:Le(new o(143,"tabFocusMode",!1,{markdownDescription:w.localize(362,null)})),layoutInfo:Le(new X),wrappingInfo:Le(new tt),wrappingIndent:Le(new Xe),wrappingStrategy:Le(new ae)}}),define(Se[200],De([9,10]),function(fe,e){return fe.create("vs/editor/common/languages",e)}),define(Se[82],De([1,0,77,2,173,29,183,200]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$3t=e.$2t=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTag=e.$1t=e.$Zt=e.SymbolKinds=e.SymbolTag=e.$Yt=e.$Xt=e.SymbolKind=e.$Wt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Vt=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Ut=e.$Tt=e.$St=void 0;class p{constructor(O,j,G){this.offset=O,this.type=j,this.language=G,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$St=p;class E{constructor(O,j){this.tokens=O,this.endState=j,this._tokenizationResultBrand=void 0}}e.$Tt=E;class M{constructor(O,j){this.tokens=O,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$Ut=M;var C;(function(I){I[I.Method=0]="Method",I[I.Function=1]="Function",I[I.Constructor=2]="Constructor",I[I.Field=3]="Field",I[I.Variable=4]="Variable",I[I.Class=5]="Class",I[I.Struct=6]="Struct",I[I.Interface=7]="Interface",I[I.Module=8]="Module",I[I.Property=9]="Property",I[I.Event=10]="Event",I[I.Operator=11]="Operator",I[I.Unit=12]="Unit",I[I.Value=13]="Value",I[I.Constant=14]="Constant",I[I.Enum=15]="Enum",I[I.EnumMember=16]="EnumMember",I[I.Keyword=17]="Keyword",I[I.Text=18]="Text",I[I.Color=19]="Color",I[I.File=20]="File",I[I.Reference=21]="Reference",I[I.Customcolor=22]="Customcolor",I[I.Folder=23]="Folder",I[I.TypeParameter=24]="TypeParameter",I[I.User=25]="User",I[I.Issue=26]="Issue",I[I.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var v;(function(I){const O=new Map;O.set(0,l.$pk.symbolMethod),O.set(1,l.$pk.symbolFunction),O.set(2,l.$pk.symbolConstructor),O.set(3,l.$pk.symbolField),O.set(4,l.$pk.symbolVariable),O.set(5,l.$pk.symbolClass),O.set(6,l.$pk.symbolStruct),O.set(7,l.$pk.symbolInterface),O.set(8,l.$pk.symbolModule),O.set(9,l.$pk.symbolProperty),O.set(10,l.$pk.symbolEvent),O.set(11,l.$pk.symbolOperator),O.set(12,l.$pk.symbolUnit),O.set(13,l.$pk.symbolValue),O.set(15,l.$pk.symbolEnum),O.set(14,l.$pk.symbolConstant),O.set(15,l.$pk.symbolEnum),O.set(16,l.$pk.symbolEnumMember),O.set(17,l.$pk.symbolKeyword),O.set(27,l.$pk.symbolSnippet),O.set(18,l.$pk.symbolText),O.set(19,l.$pk.symbolColor),O.set(20,l.$pk.symbolFile),O.set(21,l.$pk.symbolReference),O.set(22,l.$pk.symbolCustomColor),O.set(23,l.$pk.symbolFolder),O.set(24,l.$pk.symbolTypeParameter),O.set(25,l.$pk.account),O.set(26,l.$pk.issues);function j(x){let Z=O.get(x);return Z||(console.info("No codicon found for CompletionItemKind "+x),Z=l.$pk.symbolProperty),Z}I.toIcon=j;const G=new Map;G.set("method",0),G.set("function",1),G.set("constructor",2),G.set("field",3),G.set("variable",4),G.set("class",5),G.set("struct",6),G.set("interface",7),G.set("module",8),G.set("property",9),G.set("event",10),G.set("operator",11),G.set("unit",12),G.set("value",13),G.set("constant",14),G.set("enum",15),G.set("enum-member",16),G.set("enumMember",16),G.set("keyword",17),G.set("snippet",27),G.set("text",18),G.set("color",19),G.set("file",20),G.set("reference",21),G.set("customcolor",22),G.set("folder",23),G.set("type-parameter",24),G.set("typeParameter",24),G.set("account",25),G.set("issue",26);function te(x,Z){let X=G.get(x);return typeof X>"u"&&!Z&&(X=9),X}I.fromString=te})(v||(e.CompletionItemKinds=v={}));var S;(function(I){I[I.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var y;(function(I){I[I.None=0]="None",I[I.KeepWhitespace=1]="KeepWhitespace",I[I.InsertAsSnippet=4]="InsertAsSnippet"})(y||(e.CompletionItemInsertTextRule=y={}));var u;(function(I){I[I.Invoke=0]="Invoke",I[I.TriggerCharacter=1]="TriggerCharacter",I[I.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(u||(e.CompletionTriggerKind=u={}));var m;(function(I){I[I.Automatic=0]="Automatic",I[I.Explicit=1]="Explicit"})(m||(e.InlineCompletionTriggerKind=m={}));class o{constructor(O,j,G,te){this.range=O,this.text=j,this.completionKind=G,this.isSnippetText=te}equals(O){return A.$0s.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$Vt=o;var i;(function(I){I[I.Invoke=1]="Invoke",I[I.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(I){I[I.Invoke=1]="Invoke",I[I.TriggerCharacter=2]="TriggerCharacter",I[I.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var r;(function(I){I[I.Text=0]="Text",I[I.Read=1]="Read",I[I.Write=2]="Write"})(r||(e.DocumentHighlightKind=r={}));function c(I){return I&&N.URI.isUri(I.uri)&&A.$0s.isIRange(I.range)&&(A.$0s.isIRange(I.originSelectionRange)||A.$0s.isIRange(I.targetSelectionRange))}e.$Wt=c;var t;(function(I){I[I.File=0]="File",I[I.Module=1]="Module",I[I.Namespace=2]="Namespace",I[I.Package=3]="Package",I[I.Class=4]="Class",I[I.Method=5]="Method",I[I.Property=6]="Property",I[I.Field=7]="Field",I[I.Constructor=8]="Constructor",I[I.Enum=9]="Enum",I[I.Interface=10]="Interface",I[I.Function=11]="Function",I[I.Variable=12]="Variable",I[I.Constant=13]="Constant",I[I.String=14]="String",I[I.Number=15]="Number",I[I.Boolean=16]="Boolean",I[I.Array=17]="Array",I[I.Object=18]="Object",I[I.Key=19]="Key",I[I.Null=20]="Null",I[I.EnumMember=21]="EnumMember",I[I.Struct=22]="Struct",I[I.Event=23]="Event",I[I.Operator=24]="Operator",I[I.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Xt={17:(0,w.localize)(0,null),16:(0,w.localize)(1,null),4:(0,w.localize)(2,null),13:(0,w.localize)(3,null),8:(0,w.localize)(4,null),9:(0,w.localize)(5,null),21:(0,w.localize)(6,null),23:(0,w.localize)(7,null),7:(0,w.localize)(8,null),0:(0,w.localize)(9,null),11:(0,w.localize)(10,null),10:(0,w.localize)(11,null),19:(0,w.localize)(12,null),5:(0,w.localize)(13,null),1:(0,w.localize)(14,null),2:(0,w.localize)(15,null),20:(0,w.localize)(16,null),15:(0,w.localize)(17,null),18:(0,w.localize)(18,null),24:(0,w.localize)(19,null),3:(0,w.localize)(20,null),6:(0,w.localize)(21,null),14:(0,w.localize)(22,null),22:(0,w.localize)(23,null),25:(0,w.localize)(24,null),12:(0,w.localize)(25,null)};function f(I,O){return(0,w.localize)(26,null,I,e.$Xt[O])}e.$Yt=f;var h;(function(I){I[I.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var s;(function(I){const O=new Map;O.set(0,l.$pk.symbolFile),O.set(1,l.$pk.symbolModule),O.set(2,l.$pk.symbolNamespace),O.set(3,l.$pk.symbolPackage),O.set(4,l.$pk.symbolClass),O.set(5,l.$pk.symbolMethod),O.set(6,l.$pk.symbolProperty),O.set(7,l.$pk.symbolField),O.set(8,l.$pk.symbolConstructor),O.set(9,l.$pk.symbolEnum),O.set(10,l.$pk.symbolInterface),O.set(11,l.$pk.symbolFunction),O.set(12,l.$pk.symbolVariable),O.set(13,l.$pk.symbolConstant),O.set(14,l.$pk.symbolString),O.set(15,l.$pk.symbolNumber),O.set(16,l.$pk.symbolBoolean),O.set(17,l.$pk.symbolArray),O.set(18,l.$pk.symbolObject),O.set(19,l.$pk.symbolKey),O.set(20,l.$pk.symbolNull),O.set(21,l.$pk.symbolEnumMember),O.set(22,l.$pk.symbolStruct),O.set(23,l.$pk.symbolEvent),O.set(24,l.$pk.symbolOperator),O.set(25,l.$pk.symbolTypeParameter);function j(G){let te=O.get(G);return te||(console.info("No codicon found for SymbolKind "+G),te=l.$pk.symbolProperty),te}I.toIcon=j})(s||(e.SymbolKinds=s={}));class a{static asEditOperation(O){return L.$$s.replace(A.$0s.lift(O.range),O.text)}}e.$Zt=a;class d{static{this.Comment=new d("comment")}static{this.Imports=new d("imports")}static{this.Region=new d("region")}static fromValue(O){switch(O){case"comment":return d.Comment;case"imports":return d.Imports;case"region":return d.Region}return new d(O)}constructor(O){this.value=O}}e.$1t=d;var $;(function(I){I[I.AIGenerated=1]="AIGenerated"})($||(e.NewSymbolNameTag=$={}));var D;(function(I){function O(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}I.is=O})(D||(e.Command=D={}));var b;(function(I){I[I.Collapsed=0]="Collapsed",I[I.Expanded=1]="Expanded"})(b||(e.CommentThreadCollapsibleState=b={}));var g;(function(I){I[I.Unresolved=0]="Unresolved",I[I.Resolved=1]="Resolved"})(g||(e.CommentThreadState=g={}));var k;(function(I){I[I.Editing=0]="Editing",I[I.Preview=1]="Preview"})(k||(e.CommentMode=k={}));var P;(function(I){I[I.Published=0]="Published",I[I.Draft=1]="Draft"})(P||(e.CommentState=P={}));var F;(function(I){I[I.Type=1]="Type",I[I.Parameter=2]="Parameter"})(F||(e.InlayHintKind=F={}));class U{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$2t=U,e.$3t=new R.$It;var z;(function(I){I[I.None=0]="None",I[I.Option=1]="Option",I[I.Default=2]="Default",I[I.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}));var T;(function(I){I[I.Invoke=0]="Invoke",I[I.Automatic=1]="Automatic"})(T||(e.InlineEditTriggerKind=T={}))}),define(Se[201],De([9,10]),function(fe,e){return fe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[202],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[203],De([9,10]),function(fe,e){return fe.create("vs/platform/contextkey/common/scanner",e)}),define(Se[204],De([9,10]),function(fe,e){return fe.create("vs/platform/dialogs/common/dialogs",e)}),define(Se[205],De([9,10]),function(fe,e){return fe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[206],De([9,10]),function(fe,e){return fe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[207],De([9,10]),function(fe,e){return fe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Se[208],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/files",e)}),define(Se[209],De([9,10]),function(fe,e){return fe.create("vs/platform/files/common/io",e)}),define(Se[210],De([9,10]),function(fe,e){return fe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[211],De([9,10]),function(fe,e){return fe.create("vs/platform/markers/common/markers",e)}),define(Se[212],De([9,10]),function(fe,e){return fe.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[213],De([9,10]),function(fe,e){return fe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[214],De([9,10]),function(fe,e){return fe.create("vs/platform/workspace/common/workspace",e)}),define(Se[215],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Se[216],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[217],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[218],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[219],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[220],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[221],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[222],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[223],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[224],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[225],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[226],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[227],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[228],De([9,10]),function(fe,e){return fe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Se[229],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/configuration",e)}),define(Se[230],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/editor",e)}),define(Se[231],De([9,10]),function(fe,e){return fe.create("vs/workbench/common/views",e)}),define(Se[232],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[233],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[234],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Se[235],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[236],De([9,10]),function(fe,e){return fe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[237],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[238],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[239],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[240],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Se[241],De([9,10]),function(fe,e){return fe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[242],De([1,0,13,203]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bj=e.TokenType=void 0;var L;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const R=(0,N.localize)(3,null),w=(0,N.localize)(4,null);class p{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(M){switch(M.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return M.isTripleEq?"===":"==";case 4:return M.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return M.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return M.lexeme;case 18:return M.lexeme;case 19:return M.lexeme;case 20:return"EOF";default:throw(0,l.$8)(`unhandled token type: ${JSON.stringify(M)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(M=>M.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(M){return this.c=M,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(M){return this.r()||this.c.charCodeAt(this.e)!==M?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(M){this.f.push({type:M,offset:this.d})}l(M){const C=this.d,v=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:v};this.g.push({offset:C,lexeme:v,additionalInfo:M}),this.f.push(S)}n(){this.m.lastIndex=this.d;const M=this.m.exec(this.c);if(M){this.e=this.d+M[0].length;const C=this.c.substring(this.d,this.e),v=p.b.get(C);v?this.k(v):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let M=this.e,C=!1,v=!1;for(;;){if(M>=this.c.length){this.e=M,this.l(w);return}const y=this.c.charCodeAt(M);if(C)C=!1;else if(y===47&&!v){M++;break}else y===91?v=!0:y===92?C=!0:y===93&&(v=!1);M++}for(;M<this.c.length&&p.a.has(this.c.charCodeAt(M));)M++;this.e=M;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$bj=p}),define(Se[243],De([1,0,23,39,206,392]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vp=e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function p(o){return o=o.trim(),o==="*"||R.test(o)}e.$pp=p;function E(o){if(!p(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$qp=E;function M(o){if(!o)return null;const i=o.majorBase,n=o.majorMustEqual,r=o.minorBase;let c=o.minorMustEqual;const t=o.patchBase;let f=o.patchMustEqual;o.hasCaret&&(i===0||(c=!1),f=!1);let h=0;if(o.preRelease){const s=w.exec(o.preRelease);if(s){const[,a,d,$]=s;h=Date.UTC(Number(a),Number(d)-1,Number($))}}return{majorBase:i,majorMustEqual:n,minorBase:r,minorMustEqual:c,patchBase:t,patchMustEqual:f,isMinimum:o.hasGreaterEquals,notBefore:h}}e.$rp=M;function C(o,i,n){let r;typeof o=="string"?r=M(E(o)):r=o;let c;i instanceof Date?c=i.getTime():typeof i=="string"&&(c=new Date(i).getTime());let t;if(typeof n=="string"?t=M(E(n)):t=n,!r||!t)return!1;const f=r.majorBase,h=r.minorBase,s=r.patchBase;let a=t.majorBase,d=t.minorBase,$=t.patchBase;const D=t.notBefore;let b=t.majorMustEqual,g=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?f>a?!0:f<a?!1:h>d?!0:h<d||c&&c<D?!1:s>=$:(f===1&&a===0&&(!b||!g||!k)&&(a=1,d=0,$=0,b=!0,g=!1,k=!1),f<a?!1:f>a?!b:h<d?!1:h>d?!g:s<$?!1:s>$?!k:!(c&&c<D))}e.$sp=C;function v(o,i,n,r,c){const t=[];if(typeof r.publisher<"u"&&typeof r.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof r.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof r.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!r.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof r.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof r.extensionDependencies<"u"&&!m(r.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof r.activationEvents<"u"){if(!m(r.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof r.main>"u"&&typeof r.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof r.extensionKind<"u"&&typeof r.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof r.main<"u"){if(typeof r.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const s=(0,l.$Tg)(n,r.main);(0,l.$Ng)(s,n)||t.push([N.default.Warning,L.localize(10,null,s.path,n.path)])}}if(typeof r.browser<"u"){if(typeof r.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const s=(0,l.$Tg)(n,r.browser);(0,l.$Ng)(s,n)||t.push([N.default.Warning,L.localize(12,null,s.path,n.path)])}}if(!A.valid(r.version))return t.push([N.default.Error,L.localize(13,null)]),t;const f=[];if(!S(o,i,r,c,f))for(const s of f)t.push([N.default.Error,s]);return t}e.$tp=v;function S(o,i,n,r,c){return r||typeof n.main>"u"&&typeof n.browser>"u"?!0:u(o,i,n.engines.vscode,c)}e.$up=S;function y(o,i,n){return o==="*"||u(i,n,o)}e.$vp=y;function u(o,i,n,r=[]){const c=M(E(n));if(!c)return r.push(L.localize(14,null,n)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return r.push(L.localize(15,null,n)),!1}else if(!c.majorMustEqual)return r.push(L.localize(16,null,n)),!1;return C(o,i,c)?!0:(r.push(L.localize(17,null,o,n)),!1)}function m(o){if(!Array.isArray(o))return!1;for(let i=0,n=o.length;i<n;i++)if(typeof o[i]!="string")return!1;return!0}}),define(Se[106],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=void 0;class l{constructor(L,A=[],R=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.$di=l}),define(Se[83],De([1,0,106]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.InstantiationType=void 0;const N=[];var L;(function(w){w[w.Eager=0]="Eager",w[w.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(w,p,E){p instanceof l.$di||(p=new l.$di(p,[],!!E)),N.push([w,p])}e.$bs=A;function R(){return N}e.$cs=R}),define(Se[244],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=void 0;class l{constructor(A,R){this.key=A,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Rq=l;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const R of this.a.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const w=this.lookupOrInsertNode(A),p=this.lookupOrInsertNode(R);w.outgoing.set(p.key,p),p.incoming.set(w.key,w)}removeNode(A){const R=this.b(A);this.a.delete(R);for(const w of this.a.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(A){const R=this.b(A);let w=this.a.get(R);return w||(w=new l(R,A),this.a.set(R,w)),w}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[R,w]of this.a)A.push(`${R}
	(-> incoming)[${[...w.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...w.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,R]of this.a){const w=new Set([A]),p=this.c(R,w);if(p)return p}}c(A,R){for(const[w,p]of A.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const E=this.c(p,R);if(E)return E;R.delete(w)}}}e.$Sq=N}),define(Se[5],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e._util=void 0;var l;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function w(p){return p[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=w})(l||(e._util=l={})),e.$fi=L("instantiationService");function N(R,w,p){w[l.DI_TARGET]===w?w[l.DI_DEPENDENCIES].push({id:R,index:p}):(w[l.DI_DEPENDENCIES]=[{id:R,index:p}],w[l.DI_TARGET]=w)}function L(R){if(l.serviceIds.has(R))return l.serviceIds.get(R);const w=function(p,E,M){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(w,p,M)};return w.toString=()=>R,l.serviceIds.set(R,w),w}e.$gi=L;function A(R){return R}e.$hi=A}),define(Se[52],De([1,0,18,2,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.ConfigurationTarget=e.$Oi=e.$Ni=e.$Mi=void 0,e.$Mi=(0,L.$gi)("configurationService");function A(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}e.$Ni=A;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}e.$Oi=R;var w;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(w||(e.ConfigurationTarget=w={}));function p(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Pi=p;function E(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Qi=E;function M(o,i){const n=Object.create(null);for(const r in o)C(n,r,o[r],i);return n}e.$Ri=M;function C(o,i,n,r){const c=i.split("."),t=c.pop();let f=o;for(let h=0;h<c.length;h++){const s=c[h];let a=f[s];switch(typeof a){case"undefined":a=f[s]=Object.create(null);break;case"object":break;default:r(`Ignoring ${i} as ${c.slice(0,h+1).join(".")} is ${JSON.stringify(a)}`);return}f=a}if(typeof f=="object"&&f!==null)try{f[t]=n}catch{r(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}else r(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(f)}`)}e.$Si=C;function v(o,i){const n=i.split(".");S(o,n)}e.$Ti=v;function S(o,i){const n=i.shift();if(i.length===0){delete o[n];return}if(Object.keys(o).indexOf(n)!==-1){const r=o[n];typeof r=="object"&&!Array.isArray(r)&&(S(r,i),Object.keys(r).length===0&&delete o[n])}}function y(o,i,n){function r(f,h){let s=f;for(const a of h){if(typeof s!="object"||s===null)return;s=s[a]}return s}const c=i.split("."),t=r(o,c);return typeof t>"u"?n:t}e.$Ui=y;function u(o,i,n){Object.keys(i).forEach(r=>{r!=="__proto__"&&(r in o?l.$Vf(o[r])&&l.$Vf(i[r])?u(o[r],i[r],n):n&&(o[r]=i[r]):o[r]=i[r])})}e.$Vi=u;function m(o){return o.replace(/[\[\]]/g,"")}e.$Wi=m}),define(Se[45],De([1,0,11,14,242,5,202,13]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.ContextKeyExprType=e.$cj=void 0;const p=new Map;p.set("false",!1),p.set("true",!0),p.set("isMac",l.$j),p.set("isLinux",l.$k),p.set("isWindows",l.$i),p.set("isWeb",l.$o),p.set("isMacNative",l.$j&&!l.$o),p.set("isEdge",l.$H),p.set("isFirefox",l.$F),p.set("isChrome",l.$E),p.set("isSafari",l.$G);function E(re,B){if(p.get(re)!==void 0)throw(0,w.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");p.set(re,B)}e.$cj=E;const M=Object.prototype.hasOwnProperty;var C;(function(re){re[re.False=0]="False",re[re.True=1]="True",re[re.Defined=2]="Defined",re[re.Not=3]="Not",re[re.Equals=4]="Equals",re[re.NotEquals=5]="NotEquals",re[re.And=6]="And",re[re.Regex=7]="Regex",re[re.NotRegex=8]="NotRegex",re[re.Or=9]="Or",re[re.In=10]="In",re[re.NotIn=11]="NotIn",re[re.Greater=12]="Greater",re[re.GreaterEquals=13]="GreaterEquals",re[re.Smaller=14]="Smaller",re[re.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const v={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),y=(0,R.localize)(1,null),u=(0,R.localize)(2,null),m=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),n=(0,R.localize)(6,null),r=(0,R.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=v){this.k=B,this.d=new L.$bj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ke=this.D(),le=ke.type===17?i:void 0;throw this.h.push({message:o,offset:ke.offset,lexeme:L.$bj.getLexeme(ke),additionalInfo:le}),c.c}return ie}catch(ie){if(ie!==c.c)throw ie;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const ie=this.o();B.push(ie)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const ie=this.s();B.push(ie)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),a.INSTANCE;case 12:return this.z(),d.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,m),ie?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,m),ie}case 17:{const ie=B.lexeme;if(this.z(),this.y(9)){const le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),le.type!==10)throw this.B("REGEX",le);const ue=le.lexeme,ce=ue.lastIndexOf("/"),de=ce===ue.length-1?void 0:this.w(ue.substring(ce+1));let H;try{H=new RegExp(ue.substring(1,ce),de)}catch{throw this.B("REGEX",le)}return O.create(ie,H)}switch(le.type){case 10:case 19:{const ue=[le.lexeme];this.z();let ce=this.D(),de=0;for(let Pe=0;Pe<le.lexeme.length;Pe++)le.lexeme.charCodeAt(Pe)===40?de++:le.lexeme.charCodeAt(Pe)===41&&de--;for(;!this.E()&&ce.type!==15&&ce.type!==16;){switch(ce.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let Pe=0;Pe<ce.lexeme.length;Pe++)ce.lexeme.charCodeAt(Pe)===40?de++:le.lexeme.charCodeAt(Pe)===41&&de--}if(de<0)break;ue.push(L.$bj.getLexeme(ce)),this.z(),ce=this.D()}const H=ue.join(""),Y=H.lastIndexOf("/"),he=Y===H.length-1?void 0:this.w(H.substring(Y+1));let be;try{be=new RegExp(H.substring(1,Y),he)}catch{throw this.B("REGEX",le)}return t.regex(ie,be)}case 18:{const ue=le.lexeme;this.z();let ce=null;if(!(0,N.$Te)(ue)){const de=ue.indexOf("/"),H=ue.lastIndexOf("/");if(de!==H&&de>=0){const Y=ue.slice(de+1,H),he=ue[H+1]==="i"?"i":"";try{ce=new RegExp(Y,he)}catch{throw this.B("REGEX",le)}}}if(ce===null)throw this.B("REGEX",le);return O.create(ie,ce)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,u);const le=this.u();return t.notIn(ie,le)}switch(this.D().type){case 3:{this.z();const le=this.u();if(this.x().type===18)return t.equals(ie,le);switch(le){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,le)}}case 4:{this.z();const le=this.u();if(this.x().type===18)return t.notEquals(ie,le);switch(le){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,le)}}case 5:return this.z(),T.create(ie,this.u());case 6:return this.z(),I.create(ie,this.u());case 7:return this.z(),U.create(ie,this.u());case 8:return this.z(),z.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:r}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ie){if(this.C(B))return this.z();throw this.B(ie,this.D())}B(B,ie,ke){const le=(0,R.localize)(8,null,B,L.$bj.getLexeme(ie)),ue=ie.offset,ce=L.$bj.getLexeme(ie);return this.h.push({message:le,offset:ue,lexeme:ce,additionalInfo:ke}),c.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$dj=c;class t{static false(){return a.INSTANCE}static true(){return d.INSTANCE}static has(B){return $.create(B)}static equals(B,ie){return D.create(B,ie)}static notEquals(B,ie){return k.create(B,ie)}static regex(B,ie){return O.create(B,ie)}static in(B,ie){return b.create(B,ie)}static notIn(B,ie){return g.create(B,ie)}static not(B){return P.create(B)}static and(...B){return te.create(B,null,!0)}static or(...B){return x.create(B,null,!0)}static greater(B,ie){return U.create(B,ie)}static greaterEquals(B,ie){return z.create(B,ie)}static smaller(B,ie){return T.create(B,ie)}static smallerEquals(B,ie){return I.create(B,ie)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$ej=t;function f(re){const B=new c({regexParsingWithErrorRecovery:!1});return re.map(ie=>(B.parse(ie),B.lexingErrors.length>0?B.lexingErrors.map(ke=>({errorMessage:ke.additionalInfo?(0,R.localize)(9,null,ke.additionalInfo):(0,R.localize)(10,null),offset:ke.offset,length:ke.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(ke=>({errorMessage:ke.additionalInfo?`${ke.message}. ${ke.additionalInfo}`:ke.message,offset:ke.offset,length:ke.lexeme.length})):[]))}e.$fj=f;function h(re,B){const ie=re?re.substituteConstants():void 0,ke=B?B.substituteConstants():void 0;return!ie&&!ke?!0:!ie||!ke?!1:ie.equals(ke)}e.$gj=h;function s(re,B){return re.cmp(B)}class a{static{this.INSTANCE=new a}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return d.INSTANCE}}e.$hj=a;class d{static{this.INSTANCE=new d}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return a.INSTANCE}}e.$ij=d;class ${static create(B,ie=null){const ke=p.get(B);return typeof ke=="boolean"?ke?d.INSTANCE:a.INSTANCE:new $(B,ie)}constructor(B,ie){this.key=B,this.c=ie,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:X(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=p.get(this.key);return typeof B=="boolean"?B?d.INSTANCE:a.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$jj=$;class D{static create(B,ie,ke=null){if(typeof ie=="boolean")return ie?$.create(B,ke):P.create(B,ke);const le=p.get(B);return typeof le=="boolean"?ie===(le?"true":"false")?d.INSTANCE:a.INSTANCE:new D(B,ie,ke)}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?d.INSTANCE:a.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$kj=D;class b{static create(B,ie){return new b(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.f),ke=B.getValue(this.d);return Array.isArray(ie)?ie.includes(ke):typeof ke=="string"&&typeof ie=="object"&&ie!==null?M.call(ie,ke):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=g.create(this.d,this.f)),this.c}}e.$lj=b;class g{static create(B,ie){return new g(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=11,this.c=b.create(B,ie)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$mj=g;class k{static create(B,ie,ke=null){if(typeof ie=="boolean")return ie?P.create(B,ke):$.create(B,ke);const le=p.get(B);return typeof le=="boolean"?ie===(le?"true":"false")?a.INSTANCE:d.INSTANCE:new k(B,ie,ke)}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=p.get(this.c);if(typeof B=="boolean"){const ie=B?"true":"false";return this.d===ie?a.INSTANCE:d.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$nj=k;class P{static create(B,ie=null){const ke=p.get(B);return typeof ke=="boolean"?ke?a.INSTANCE:d.INSTANCE:new P(B,ie)}constructor(B,ie){this.c=B,this.d=ie,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:X(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=p.get(this.c);return typeof B=="boolean"?B?a.INSTANCE:d.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$oj=P;function F(re,B){if(typeof re=="string"){const ie=parseFloat(re);isNaN(ie)||(re=ie)}return typeof re=="string"||typeof re=="number"?B(re):a.INSTANCE}class U{static create(B,ie,ke=null){return F(ie,le=>new U(B,le,ke))}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$pj=U;class z{static create(B,ie,ke=null){return F(ie,le=>new z(B,le,ke))}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$qj=z;class T{static create(B,ie,ke=null){return F(ie,le=>new T(B,le,ke))}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$rj=T;class I{static create(B,ie,ke=null){return F(ie,le=>new I(B,le,ke))}constructor(B,ie,ke){this.c=B,this.d=ie,this.f=ke,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:ae(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$sj=I;class O{static create(B,ie){return new O(B,ie)}constructor(B,ie){this.d=B,this.f=ie,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ie=this.f?this.f.source:"",ke=B.f?B.f.source:"";return ie<ke?-1:ie>ke?1:0}equals(B){if(B.type===this.type){const ie=this.f?this.f.source:"",ke=B.f?B.f.source:"";return this.d===B.d&&ie===ke}return!1}substituteConstants(){return this}evaluate(B){const ie=B.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=j.create(this)),this.c}}e.$tj=O;class j{static create(B){return new j(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new j(this.c.map(B))}negate(){return this.c}}e.$uj=j;function G(re){let B=null;for(let ie=0,ke=re.length;ie<ke;ie++){const le=re[ie].substituteConstants();if(re[ie]!==le&&B===null){B=[];for(let ue=0;ue<ie;ue++)B[ue]=re[ue]}B!==null&&(B[ie]=le)}return B===null?re:B}class te{static create(B,ie,ke){return te.d(B,ie,ke)}constructor(B,ie){this.expr=B,this.c=ie,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,ke=this.expr.length;ie<ke;ie++){const le=s(this.expr[ie],B.expr[ie]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,ke=this.expr.length;ie<ke;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=G(this.expr);return B===this.expr?this:te.create(B,this.c,!1)}evaluate(B){for(let ie=0,ke=this.expr.length;ie<ke;ie++)if(!this.expr[ie].evaluate(B))return!1;return!0}static d(B,ie,ke){const le=[];let ue=!1;for(const ce of B)if(ce){if(ce.type===1){ue=!0;continue}if(ce.type===0)return a.INSTANCE;if(ce.type===6){le.push(...ce.expr);continue}le.push(ce)}if(le.length===0&&ue)return d.INSTANCE;if(le.length!==0){if(le.length===1)return le[0];le.sort(s);for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];for(;le.length>1;){const ce=le[le.length-1];if(ce.type!==9)break;le.pop();const de=le.pop(),H=le.length===0,Y=x.create(ce.expr.map(he=>te.create([he,de],null,ke)),null,H);Y&&(le.push(Y),le.sort(s))}if(le.length===1)return le[0];if(ke){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return a.INSTANCE;if(le.length===1)return le[0]}return new te(le,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new te(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());this.c=x.create(B,this,!0)}return this.c}}e.$vj=te;class x{static create(B,ie,ke){return x.d(B,ie,ke)}constructor(B,ie){this.expr=B,this.c=ie,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ie=0,ke=this.expr.length;ie<ke;ie++){const le=s(this.expr[ie],B.expr[ie]);if(le!==0)return le}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ie=0,ke=this.expr.length;ie<ke;ie++)if(!this.expr[ie].equals(B.expr[ie]))return!1;return!0}return!1}substituteConstants(){const B=G(this.expr);return B===this.expr?this:x.create(B,this.c,!1)}evaluate(B){for(let ie=0,ke=this.expr.length;ie<ke;ie++)if(this.expr[ie].evaluate(B))return!0;return!1}static d(B,ie,ke){let le=[],ue=!1;if(B){for(let ce=0,de=B.length;ce<de;ce++){const H=B[ce];if(H){if(H.type===0){ue=!0;continue}if(H.type===1)return d.INSTANCE;if(H.type===9){le=le.concat(H.expr);continue}le.push(H)}}if(le.length===0&&ue)return a.INSTANCE;le.sort(s)}if(le.length!==0){if(le.length===1)return le[0];for(let ce=1;ce<le.length;ce++)le[ce-1].equals(le[ce])&&(le.splice(ce,1),ce--);if(le.length===1)return le[0];if(ke){for(let ce=0;ce<le.length;ce++)for(let de=ce+1;de<le.length;de++)if(le[ce].negate().equals(le[de]))return d.INSTANCE;if(le.length===1)return le[0]}return new x(le,ie)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ie of this.expr)B.push(...ie.keys());return B}map(B){return new x(this.expr.map(ie=>ie.map(B)),null)}negate(){if(!this.c){const B=[];for(const ie of this.expr)B.push(ie.negate());for(;B.length>1;){const ie=B.shift(),ke=B.shift(),le=[];for(const ue of se(ie))for(const ce of se(ke))le.push(te.create([ue,ce],null,!1));B.unshift(x.create(le,null,!1))}this.c=x.create(B,this,!0)}return this.c}}e.$wj=x;class Z extends ${static{this.d=[]}static all(){return Z.d.values()}constructor(B,ie,ke){super(B,null),this.f=ie,typeof ke=="object"?Z.d.push({...ke,key:B}):ke!==!0&&Z.d.push({key:B,description:ke,type:ie!=null?typeof ie:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return D.create(this.key,B)}notEqualsTo(B){return k.create(this.key,B)}}e.$xj=Z,e.$yj=(0,A.$gi)("contextKeyService");function X(re,B){return re<B?-1:re>B?1:0}function ae(re,B,ie,ke){return re<ie?-1:re>ie?1:B<ke?-1:B>ke?1:0}function _(re,B){if(re.type===0||B.type===1)return!0;if(re.type===9)return B.type===9?ge(re.expr,B.expr):!1;if(B.type===9){for(const ie of B.expr)if(_(re,ie))return!0;return!1}if(re.type===6){if(B.type===6)return ge(B.expr,re.expr);for(const ie of re.expr)if(_(ie,B))return!0;return!1}return re.equals(B)}e.$zj=_;function ge(re,B){let ie=0,ke=0;for(;ie<re.length&&ke<B.length;){const le=re[ie].cmp(B[ke]);if(le<0)return!1;le===0&&ie++,ke++}return ie===re.length}function se(re){return re.type===9?re.expr:[re]}}),define(Se[245],De([1,0,23,39,204,5,103,11,24]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nw=e.$mw=e.ConfirmResult=e.$lw=e.$kw=e.$jw=void 0,e.$jw=(0,A.$gi)("dialogService");var E;(function(u){u[u.Confirmation=1]="Confirmation",u[u.Prompt=2]="Prompt",u[u.Input=3]="Input"})(E||(E={}));class M{a(m){return this.d(m,E.Confirmation)}b(m){return this.d(m,E.Prompt)}c(m){return this.d(m,E.Input)}d(m,o){const i=[];switch(o){case E.Confirmation:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(1,null));break}case E.Prompt:{const n=m;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(r=>r.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,L.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,L.localize)(3,null))),i.length===0&&i.push((0,L.localize)(4,null));break}case E.Input:{const n=m;n.primaryButton?i.push(n.primaryButton):i.push((0,L.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,L.localize)(6,null));break}}return i}e(m){if(typeof m=="string")return m;if(typeof m=="number")return m===N.default.Info?"info":m===N.default.Error?"error":m===N.default.Warning?"warning":"none"}f(m,o,i){const n=[...m.buttons??[]];m.cancelButton&&typeof m.cancelButton!="string"&&typeof m.cancelButton!="boolean"&&n.push(m.cancelButton);let r=n[o]?.run({checkboxChecked:i});return r instanceof Promise||(r=Promise.resolve(r)),{result:r,checkboxChecked:i}}}e.$kw=M,e.$lw=(0,A.$gi)("fileDialogService");var C;(function(u){u[u.SAVE=0]="SAVE",u[u.DONT_SAVE=1]="DONT_SAVE",u[u.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const v=10;function S(u){const m=[];return m.push(...u.slice(0,v).map(o=>typeof o=="string"?o:(0,l.$Qg)(o))),u.length>v&&(u.length-v===1?m.push((0,L.localize)(7,null)):m.push((0,L.localize)(8,null,u.length-v))),m.push(""),m.join(`
`)}e.$mw=S;function y(u,m){const o=(0,p.$Ln)(u);let i=(o.buttons??[]).map(t=>(0,R.$gw)(t)),n=(u.buttons||[]).map((t,f)=>f),r=0,c=o.cancelId??i.length-1;if(i.length>1){const t=typeof c=="number"?i[c]:void 0;if(w.$k||w.$j){if(typeof t=="string"&&i.length>1&&c!==1){i.splice(c,1),i.splice(1,0,t);const f=n[c];n.splice(c,1),n.splice(1,0,f),c=1}w.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),r=i.length-1,typeof t=="string"&&(c=r-1))}else if(w.$i&&typeof t=="string"&&i.length>1&&c!==i.length-1){i.splice(c,1),i.push(t);const f=n[c];n.splice(c,1),n.push(f),c=i.length-1}}return o.buttons=i,o.defaultId=r,o.cancelId=c,o.noLink=!0,o.title=o.title||m.nameLong,{options:o,buttonIndeces:n}}e.$nw=y}),define(Se[136],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=void 0,e.$ni=(0,l.$gi)("environmentService"),e.$oi=(0,l.$hi)(e.$ni)}),define(Se[137],De([1,0,205,5]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.ExtensionGalleryErrorCode=e.$Po=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Oo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=void 0,e.$Co="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Do=new RegExp(e.$Co),e.$Eo="__web_extension",e.$Fo="skipWalkthrough",e.$Go="extensionsSync",e.$Ho="dependecyOrPackExtensionInstall";function L(n){switch(n){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Io=L;function A(n){switch(n){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Jo=A;function R(n,r){switch(n){case 3:return r==="x64"?"win32-x64":r==="arm64"?"win32-arm64":"unknown";case 2:return r==="x64"?"linux-x64":r==="arm64"?"linux-arm64":r==="arm"?"linux-armhf":"unknown";case"alpine":return r==="x64"?"alpine-x64":r==="arm64"?"alpine-arm64":"unknown";case 1:return r==="x64"?"darwin-x64":r==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Ko=R;function w(n,r){return r==="web"&&!n.includes("web")}e.$Lo=w;function p(n,r,c){return w(r,c)?!1:n==="undefined"||n==="universal"?!0:n==="unknown"?!1:n===c}e.$Mo=p;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.$No=E;var M;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(M||(e.SortBy=M={}));var C;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var v;(function(n){n.Install="install",n.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var S;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(S||(e.InstallOperation=S={})),e.$Oo=(0,N.$gi)("extensionGalleryService");var y;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.Delete="Delete",n.Rename="Rename",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Unknown="Unknown",n.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var u;(function(n){n.UnknownError="UnknownError",n.PackageIsInvalidZip="PackageIsInvalidZip",n.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(u||(e.ExtensionSignaturetErrorCode=u={}));class m extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$Po=m;var o;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(r,c){super(r),this.code=c,this.name=c}}e.$Qo=i,e.$Ro=(0,N.$gi)("extensionManagementService"),e.$So="extensionsIdentifiers/disabled",e.$To="extensionsIdentifiers/enabled",e.$Uo=(0,N.$gi)("IGlobalExtensionEnablementService"),e.$Vo=(0,N.$gi)("IExtensionTipsService"),e.$Wo=(0,l.localize2)(0,"Extensions"),e.$Xo=(0,l.localize2)(1,"Preferences")}),define(Se[246],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H4b=e.$G4b=void 0,e.$G4b=(0,l.$gi)("externalTerminal"),e.$H4b="Terminal.app"}),define(Se[247],De([1,0,51,53,15,17,11,102,31,105,207,246]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=e.$H_b=e.$G_b=void 0;const v=M.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await m.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends S{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(l,c,E.$5l(),t)}spawnTerminal(c,t,f,h){const s=t.windowsExec||y.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const a=A.$nc(s,".exe").toLowerCase();if(a==="cmder")return c.spawn(s,h?[h]:void 0),Promise.resolve(void 0);const d=["/c","start","/wait"];return s.indexOf(" ")>=0&&d.push('""'),d.push(s),a==="wt"&&d.push("-d ."),new Promise(($,D)=>{const b=o(process),g=c.spawn(f,d,{cwd:h,env:b,detached:!0});g.on("error",D),g.on("exit",()=>$())})}async runInTerminal(c,t,f,h,s){const a="windowsExec"in s&&s.windowsExec?s.windowsExec:y.getDefaultTerminalWindows(),d=await y.f();return new Promise(($,D)=>{const b=`"${t} - ${v}"`,g=`"${f.join('" "')}" & pause`,k=Object.assign({},o(process),h);Object.keys(k).filter(T=>k[T]===null).forEach(T=>delete k[T]);const P={cwd:t,env:k,windowsVerbatimArguments:!0};let F,U;A.$nc(a,".exe")==="wt"?(F=a,U=["-d",".",y.b,"/c",g]):d?(F=d,U=["-d",".",a,"/c",g]):(F=y.b,U=["/c","start",b,"/wait",a,"/c",`"${g}"`]),l.spawn(F,U,P).on("error",T=>{D(i(T))}),$(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const c=await E.win32.findExecutable("wt");return await p.Promises.exists(c)?c:void 0}catch{return}}}e.$G_b=y,Qe([N.$Kh],y,"f",null);class u extends S{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(l,c,t)}runInTerminal(c,t,f,h,s){const a=s.osxExec||C.$H4b;return new Promise((d,$)=>{if(a===C.$H4b||a==="iTerm.app"){const D=a===C.$H4b?"TerminalHelper":"iTermHelper",g=[L.$Ag.asFileUri(`vs/workbench/contrib/externalTerminal/node/${D}.scpt`).fsPath,"-t",c||v,"-w",t];for(const F of f)g.push("-a"),g.push(F);if(h){const F=Object.assign({},o(process),h);for(const U in F){const z=F[U];z===null?(g.push("-u"),g.push(U)):(g.push("-e"),g.push(`${U}=${z}`))}}let k="";const P=l.spawn(u.b,g);P.on("error",F=>{$(i(F))}),P.stderr.on("data",F=>{k+=F.toString()}),P.on("exit",F=>{if(F===0)d(void 0);else if(k){const U=k.split(`
`,1);$(new Error(U[0]))}else $(new Error(M.localize(1,null,D,F)))})}else $(new Error(M.localize(2,null,a)))})}spawnTerminal(c,t,f){const h=t.osxExec||C.$H4b;return new Promise((s,a)=>{const d=["-a",h];f&&d.push(f);const $=o(process),D=c.spawn("/usr/bin/open",d,{cwd:f,env:$});D.on("error",a),D.on("exit",()=>s())})}}e.$H_b=u;class m extends S{static{this.b=M.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(l,c,t)}runInTerminal(c,t,f,h,s){const a=s.linuxExec?Promise.resolve(s.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((d,$)=>{const D=[];a.then(b=>{b.indexOf("gnome-terminal")>=0?D.push("-x"):D.push("-e"),D.push("bash"),D.push("-c");const g=`${n(f)}; echo; read -p "${m.b}" -n1;`;D.push(`''${g}''`);const k=Object.assign({},o(process),h);Object.keys(k).filter(z=>k[z]===null).forEach(z=>delete k[z]);const P={cwd:t,env:k};let F="";const U=l.spawn(b,D,P);U.on("error",z=>{$(i(z))}),U.stderr.on("data",z=>{F+=z.toString()}),U.on("exit",z=>{if(z===0)d(void 0);else if(F){const T=F.split(`
`,1);$(new Error(T[0]))}else $(new Error(M.localize(4,null,b,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!m.d)if(!R.$k)m.d=Promise.resolve("xterm");else{const c=await p.Promises.exists("/etc/debian_version");m.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return m.d}spawnTerminal(c,t,f){const h=t.linuxExec?Promise.resolve(t.linuxExec):m.getDefaultTerminalLinuxReady();return new Promise((s,a)=>{h.then(d=>{const $=o(process),D=c.spawn(d,[],{cwd:f,env:$});D.on("error",a),D.on("exit",()=>s())})})}}e.$I_b=m;function o(r){const c={...r.env};return(0,w.$3l)(c),c}function i(r){return"errno"in r&&r.errno==="ENOENT"&&"path"in r&&typeof r.path=="string"?new Error(M.localize(5,null,r.path)):r}function n(r){let c="";for(const t of r)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(Se[32],De([1,0,76,17,14,18,2,208,5,11,15,43]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.FileKind=e.$$k=e.$0k=e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=e.FileOperationResult=e.$4k=e.$3k=e.$2k=e.$1k=e.$Zk=e.FileChangeType=e.$Yk=e.FileOperation=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.FileSystemProviderErrorCode=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileSystemProviderCapabilities=e.$Ik=e.FilePermission=e.FileType=e.$Hk=e.$Gk=void 0,e.$Gk=(0,p.$gi)("fileService");function v(_){return _.create===!0}e.$Hk=v;var S;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var y;(function(_){_[_.Readonly=1]="Readonly",_[_.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function u(_){const ge=_;return!!ge&&typeof ge.onDidChange=="function"}e.$Ik=u;var m;(function(_){_[_.None=0]="None",_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock",_[_.FileAtomicRead=16384]="FileAtomicRead",_[_.FileAtomicWrite=32768]="FileAtomicWrite",_[_.FileAtomicDelete=65536]="FileAtomicDelete",_[_.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function o(_){return!!(_.capabilities&2)}e.$Jk=o;function i(_){return!!(_.capabilities&8)}e.$Kk=i;function n(_){return!!(_.capabilities&131072)}e.$Lk=n;function r(_){return!!(_.capabilities&4)}e.$Mk=r;function c(_){return!!(_.capabilities&16)}e.$Nk=c;function t(_){return o(_)?!!(_.capabilities&16384):!1}e.$Ok=t;function f(_){return o(_)?!!(_.capabilities&32768):!1}e.$Pk=f;function h(_){return!!(_.capabilities&65536)}e.$Qk=h;function s(_){return!!(_.capabilities&2048)}e.$Rk=s;var a;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsStorageQuota="EntryExceedsStorageQuota",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(a||(e.FileSystemProviderErrorCode=a={}));class d extends Error{static create(ge,se){const re=new d(ge.toString(),se);return b(re,se),re}constructor(ge,se){super(ge),this.code=se}}e.$Sk=d;function $(_,ge){return d.create(_,ge)}e.$Tk=$;function D(_){return _||$((0,w.localize)(0,null),a.Unknown)}e.$Uk=D;function b(_,ge){return _.name=ge?`${ge} (FileSystemError)`:"FileSystemError",_}e.$Vk=b;function g(_){if(!_)return a.Unknown;if(_ instanceof d)return _.code;const ge=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!ge)return a.Unknown;switch(ge[1]){case a.FileExists:return a.FileExists;case a.FileIsADirectory:return a.FileIsADirectory;case a.FileNotADirectory:return a.FileNotADirectory;case a.FileNotFound:return a.FileNotFound;case a.FileTooLarge:return a.FileTooLarge;case a.FileWriteLocked:return a.FileWriteLocked;case a.NoPermissions:return a.NoPermissions;case a.Unavailable:return a.Unavailable}return a.Unknown}e.$Wk=g;function k(_){if(_ instanceof I)return _.fileOperationResult;switch(g(_)){case a.FileNotFound:return 1;case a.FileIsADirectory:return 0;case a.FileNotADirectory:return 9;case a.FileWriteLocked:return 5;case a.NoPermissions:return 6;case a.FileExists:return 4;case a.FileTooLarge:return 7;default:return 10}}e.$Xk=k;var P;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY",_[_.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class F{constructor(ge,se,re){this.resource=ge,this.operation=se,this.target=re}isOperation(ge){return this.operation===ge}}e.$Yk=F;var U;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(U||(e.FileChangeType=U={}));class z{static{this.a=null}constructor(ge,se){this.c=se,this.b=void 0,this.d=new C.$V(()=>{const re=l.$mi.forUris(()=>this.c);return re.fill(this.rawAdded.map(B=>[B,!0])),re}),this.f=new C.$V(()=>{const re=l.$mi.forUris(()=>this.c);return re.fill(this.rawUpdated.map(B=>[B,!0])),re}),this.g=new C.$V(()=>{const re=l.$mi.forUris(()=>this.c);return re.fill(this.rawDeleted.map(B=>[B,!0])),re}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const re of ge){switch(re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}this.b!==z.a&&(typeof re.cId=="number"?this.b===void 0?this.b=re.cId:this.b!==re.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(ge,...se){return this.h(ge,{includeChildren:!1},...se)}affects(ge,...se){return this.h(ge,{includeChildren:!0},...se)}h(ge,se,...re){if(!ge)return!1;const B=re.length>0;return!!((!B||re.includes(1))&&(this.d.value.get(ge)||se.includeChildren&&this.d.value.findSuperstr(ge))||(!B||re.includes(0))&&(this.f.value.get(ge)||se.includeChildren&&this.f.value.findSuperstr(ge))||(!B||re.includes(2))&&(this.g.value.findSubstr(ge)||se.includeChildren&&this.g.value.findSuperstr(ge)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ge){return this.b===ge}hasCorrelation(){return typeof this.b=="number"}}e.$Zk=z;function T(_,ge,se){return!_||!ge||_===ge||ge.length>_.length?!1:(ge.charAt(ge.length-1)!==N.sep&&(ge+=N.sep),se?(0,L.$lf)(_,ge):_.indexOf(ge)===0)}e.$1k=T;class I extends Error{constructor(ge,se,re){super(ge),this.fileOperationResult=se,this.options=re}}e.$2k=I;class O extends I{constructor(ge,se,re,B){super(ge,se,B),this.fileOperationResult=se,this.size=re}}e.$3k=O;class j extends I{constructor(ge,se,re){super(ge,2,re),this.stat=se}}e.$4k=j;var G;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.$5k={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$6k={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$7k="files.associations",e.$8k="files.exclude",e.$9k="files.readonlyInclude",e.$0k="files.readonlyExclude",e.$$k="files.readonlyFromPermissions";var te;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(te||(e.FileKind=te={})),e.$_k="";function x(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.$al=x;async function Z(_,ge){if(!ge.hasProvider(R.URI.from({scheme:_.scheme})))return new Promise(se=>{const re=ge.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===_.scheme&&B.added&&(re.dispose(),se())})})}e.$bl=Z;class X{static{this.KB=1024}static{this.MB=X.KB*X.KB}static{this.GB=X.MB*X.KB}static{this.TB=X.GB*X.KB}static formatSize(ge){return(0,A.$Xf)(ge)||(ge=0),ge<X.KB?(0,w.localize)(1,null,ge.toFixed(0)):ge<X.MB?(0,w.localize)(2,null,(ge/X.KB).toFixed(2)):ge<X.GB?(0,w.localize)(3,null,(ge/X.MB).toFixed(2)):ge<X.TB?(0,w.localize)(4,null,(ge/X.GB).toFixed(2)):(0,w.localize)(5,null,(ge/X.TB).toFixed(2))}}e.$cl=X;function ae(_){const ge=typeof _=="string"||_?.scheme===M.Schemas.vscodeRemote;return typeof _!="string"&&_?.scheme===M.Schemas.file?1024*X.MB:ge?10*X.MB:E.$o?50*X.MB:1024*X.MB}e.$dl=ae}),define(Se[248],De([1,0,21,13,209,32]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=void 0;async function R(M,C,v,S,y,u){let m;try{await w(M,C,v,S,y,u)}catch(o){m=o}finally{m&&y.errorTransformer&&(m=y.errorTransformer(m)),typeof m<"u"&&v.error(m),v.end()}}e.$qq=R;async function w(M,C,v,S,y,u){p(u);const m=await M.open(C,{create:!1});try{p(u);let o=0,i=0,n=y&&typeof y.length=="number"?y.length:void 0,r=l.$te.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),c=y&&typeof y.position=="number"?y.position:0,t=0;do i=await M.read(m,c,r.buffer,t,r.byteLength-t),c+=i,t+=i,o+=i,typeof n=="number"&&(n-=i),t===r.byteLength&&(await v.write(S(r)),r=l.$te.alloc(Math.min(y.bufferSize,typeof n=="number"?n:y.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&p(u)&&E(o,y));if(t>0){let f=t;typeof n=="number"&&(f=Math.min(t,n)),v.write(S(r.slice(0,f)))}}catch(o){throw(0,A.$Uk)(o)}finally{await M.close(m)}}function p(M){if(M.isCancellationRequested)throw(0,N.$6)();return!0}function E(M,C){if(typeof C?.limits?.size=="number"&&M>C.limits.size)throw(0,A.$Tk)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[84],De([1,0,35,3,17,11,2,32]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=void 0;function p(o){return o.recursive===!0}e.$sq=p;class E extends N.$Tc{static{this.a=5}constructor(i,n,r,c){super(),this.h=i,this.j=n,this.m=r,this.n=c,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const i=new N.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$tq=E;class M extends E{constructor(i,n,r){super(i,n,r,{type:"node.js",restartOnError:!1})}}e.$uq=M;class C extends E{constructor(i,n,r){super(i,n,r,{type:"universal",restartOnError:!0})}}e.$vq=C;function v(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$wq=v;function S(o){const i=new m;for(const n of o)i.processEvent(n);return i.coalesce()}e.$xq=S;function y(o,i){return typeof i=="string"&&!i.startsWith(l.$Vj)&&!(0,L.$ic)(i)?{base:o,pattern:i}:i}e.$yq=y;function u(o,i){const n=[];for(const r of i)n.push((0,l.$Zj)(y(o,r)));return n}e.$zq=u;class m{constructor(){this.a=new Set,this.b=new Map}c(i){return A.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let r=!1;if(n){const c=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?r=!0:c===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):c===2&&t===1?n.type=0:c===1&&t===0||(n.type=t)}else r=!0;r&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(r=>r.type!==2?(i.push(r),!1):!0).sort((r,c)=>r.resource.fsPath.length-c.resource.fsPath.length).filter(r=>n.some(c=>(0,w.$1k)(r.resource.fsPath,c,!A.$k))?!1:(n.push(r.resource.fsPath),!0)).concat(i)}}}),define(Se[249],De([1,0,57,8,22,34,3,75,17,11,23,2,104,31,84]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=void 0;class u extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,n,r,c){super(),this.m=i,this.n=n,this.r=r,this.s=c,this.c=this.B(new N.$vh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$uh(t=>this.z(t),u.b)),this.g=(0,y.$zq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$zq)(this.m.path,this.m.includes):void 0,this.j=new L.$de,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await S.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await S.Promises.realpath(i.path),i.path===n&&(n=await(0,v.$Jq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(E.$j&&(0,A.$gg)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const r=new L.$de(this.j.token),c=new R.$Sc;try{const t=C.URI.file(this.m.path),f=(0,p.$nc)(i),h=(0,l.watch)(i);c.add((0,R.$Rc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${i}'`);const s=new Set;if(n)try{for(const d of await S.Promises.readdir(i))s.add(d)}catch(d){this.D(d)}const a=new Map;c.add((0,R.$Rc)(()=>{for(const[,d]of a)d.dispose();a.clear()})),h.on("error",(d,$)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${d}, ${$})`),this.dispose()}),h.on("change",(d,$)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${d}"] ${$}`);let D="";if($&&(D=$.toString(),E.$j&&(D=(0,w.$Rl)(D))),!(!D||d!=="change"&&d!=="rename"))if(n)if(d==="rename"){a.get(D)?.dispose();const b=setTimeout(async()=>{if(a.delete(D),D===f&&!await S.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const g=await this.C((0,p.$jc)(i,D));if(r.token.isCancellationRequested)return;let k;g?s.has(D)?k=0:(k=1,s.add(D)):(s.delete(D),k=2),this.y({resource:(0,M.$Tg)(t,D),type:k,cId:this.m.correlationId})},u.a);a.set(D,(0,R.$Rc)(()=>clearTimeout(b)))}else{let b;s.has(D)?b=0:(b=1,s.add(D)),this.y({resource:(0,M.$Tg)(t,D),type:b,cId:this.m.correlationId})}else if(d==="rename"||D!==f){const b=setTimeout(async()=>{const g=await S.Promises.exists(i);r.token.isCancellationRequested||(g?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},u.a);c.clear(),c.add((0,R.$Rc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await S.Promises.exists(i)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{r.dispose(!0),c.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(r=>r(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,y.$xq)(i);if(n.length>0){if(this.s)for(const c of n)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(E.$k)return S.Promises.exists(i);try{const n=(0,p.$nc)(i);return(await S.Promises.readdir((0,p.$mc)(i))).some(c=>c===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Mq=u;async function m(o,i,n,r,c=512){const t=await S.Promises.open(o,"r"),f=Buffer.allocUnsafe(c),h=new L.$de(r);let s,a=!1;const d={path:o,excludes:[],recursive:!1},$=new u(d,D=>{(async()=>{for(const{type:b}of D)if(b===0){if(a)return;a=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:g}=await S.Promises.read(t,f,0,c,null);if(!g||h.token.isCancellationRequested)break;i(f.slice(0,g))}}catch(g){s=new Error(g),h.dispose(!0)}finally{a=!1}}})()});return await $.ready,n(),new Promise((D,b)=>{h.token.onCancellationRequested(async()=>{$.dispose();try{await S.Promises.close(t)}catch(g){s=new Error(g)}s?b(s):D()})})}e.$Nq=m}),define(Se[250],De([1,0,4,35,3,11,249]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;class w extends L.$Tc{constructor(){super(...arguments),this.a=this.B(new l.$6d),this.onDidChangeFile=this.a.event,this.b=this.B(new l.$6d),this.onDidLogMessage=this.b.event,this.onDidError=l.Event.None,this.c=new Map,this.f=!1}async watch(E){const M=this.j(E),C=M.filter(S=>{const y=this.c.get(S.path);return y?!(0,N.$4j)(y.request.excludes,S.excludes)||!(0,N.$4j)(y.request.includes,S.includes):!0}),v=Array.from(this.c.values()).filter(({request:S})=>!M.find(y=>y.path===S.path&&(0,N.$4j)(y.excludes,S.excludes)&&(0,N.$4j)(y.includes,S.includes))).map(({request:S})=>S.path);C.length&&this.m(`Request to start watching: ${C.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"}, correlationId: ${typeof S.correlationId=="number"?S.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const S of v)this.h(S);for(const S of C)this.g(S)}g(E){const M=new R.$Mq(E,v=>this.a.fire(v),v=>this.b.fire(v),this.f),C={request:E,instance:M};this.c.set(E.path,C)}async stop(){for(const[E]of this.c)this.h(E);this.c.clear()}h(E){const M=this.c.get(E);M&&(this.c.delete(E),M.instance.dispose())}j(E){const M=new Map;for(const C of E){const v=A.$k?C.path:C.path.toLowerCase();let S=M.get(C.correlationId);S||(S=new Map,M.set(C.correlationId,S)),S.set(v,C)}return Array.from(M.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(E){this.f=E;for(const[,M]of this.c)M.instance.setVerboseLogging(E)}m(E){this.f&&this.b.fire({type:"trace",message:this.n(E)})}n(E,M){return M?`[File Watcher (node.js)] ${E} (path: ${M.request.path})`:`[File Watcher (node.js)] ${E}`}}e.$Oq=w}),define(Se[251],De([1,0,84,250]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=void 0;class L extends l.$uq{constructor(R,w,p){super(R,w,p),this.s()}r(R){return R.add(new N.$Oq)}}e.$Pq=L}),define(Se[252],De([1,0,15,80,192,84]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;class R extends A.$vq{constructor(p,E,M){super(p,E,M),this.s()}r(p){const E=p.add(new L.$Gq(l.$Ag.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(E.onDidProcessExit(({code:M,signal:C})=>this.t(`terminated by itself with code ${M}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Zh)(E.getChannel("watcher")))}}e.$Hq=R}),define(Se[107],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=void 0;class l{constructor(...L){this.a=new Map;for(const[A,R]of L)this.set(A,R)}set(L,A){const R=this.a.get(L);return this.a.set(L,A),R}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$ei=l}),define(Se[253],De([1,0,8,13,3,106,244,5,107,74]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=void 0;const M=!1;class C extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class v{constructor(m=new p.$ei,o=!1,i,n=M){this.f=m,this.g=o,this.h=i,this.i=n,this.o=new Set,this.f.set(w.$fi,this),this._globalGraph=n?i?._globalGraph??new R.$Sq(r=>r):void 0}createChild(m){return new v(m,this.g,this,this.i)}invokeFunction(m,...o){const i=y.traceInvocation(this.i,m);let n=!1;try{return m({get:c=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,i);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...o)}finally{n=!0,i.stop()}}createInstance(m,...o){let i,n;return m instanceof A.$di?(i=y.traceCreation(this.i,m.ctor),n=this.j(m.ctor,m.staticArguments.concat(o),i)):(i=y.traceCreation(this.i,m),n=this.j(m,o,i)),i.stop(),n}j(m,o=[],i){const n=w._util.getServiceDependencies(m).sort((t,f)=>t.index-f.index),r=[];for(const t of n){const f=this.m(t.id,i);f||this.u(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),r.push(f)}const c=n.length>0?n[0].index:o.length;if(o.length!==c){console.trace(`[createInstance] First service dependency of ${m.name} at position ${c+1} conflicts with ${o.length} static arguments`);const t=c-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,c)}return Reflect.construct(m,o.concat(r))}k(m,o){if(this.f.get(m)instanceof A.$di)this.f.set(m,o);else if(this.h)this.h.k(m,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(m){const o=this.f.get(m);return!o&&this.h?this.h.l(m):o}m(m,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const i=this.l(m);return i instanceof A.$di?this.q(m,i,o.branch(m,!0)):(o.branch(m,!1),i)}q(m,o,i){if(this.o.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.o.add(m);try{return this.r(m,o,i)}finally{this.o.delete(m)}}r(m,o,i){const n=new R.$Sq(t=>t.id.toString());let r=0;const c=[{id:m,desc:o,_trace:i}];for(;c.length;){const t=c.pop();if(n.lookupOrInsertNode(t),r++>1e3)throw new C(n);for(const f of w._util.getServiceDependencies(t.desc.ctor)){const h=this.l(f.id);if(h||this.u(`[createInstance] ${m} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),h instanceof A.$di){const s={id:f.id,desc:h,_trace:t._trace.branch(f.id,!0)};n.insertEdge(t,s),c.push(s)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:f}of t){if(this.l(f.id)instanceof A.$di){const s=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,s)}n.removeNode(f)}}return this.l(m)}s(m,o,i=[],n,r){if(this.f.get(m)instanceof A.$di)return this.t(m,o,i,n,r);if(this.h)return this.h.s(m,o,i,n,r);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(m,o,i=[],n,r){if(n){const c=new v(void 0,this.g,this,this.i);c.c=String(m);const t=new Map,f=new l.$zh(()=>{const h=c.j(o,i,r);for(const[s,a]of t){const d=h[s];if(typeof d=="function")for(const $ of a)$.disposable=d.apply(h,$.listener)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,s){if(!f.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let $=t.get(s);return $||($=new E.$4c,t.set(s,$)),(b,g,k)=>{if(f.isInitialized)return f.value[s](b,g,k);{const P={listener:[b,g,k],disposable:void 0},F=$.push(P);return(0,L.$Rc)(()=>{F(),P.disposable?.dispose()})}}}if(s in h)return h[s];const a=f.value;let d=a[s];return typeof d!="function"||(d=d.bind(a),h[s]=d),d},set(h,s,a){return f.value[s]=a,!0},getPrototypeOf(h){return o.prototype}})}else return this.j(o,i,r)}u(m,o){if(o&&console.warn(m),this.g)throw new Error(m)}}e.$Tq=v;var S;(function(u){u[u.None=0]="None",u[u.Creation=1]="Creation",u[u.Invocation=2]="Invocation",u[u.Branch=3]="Branch"})(S||(S={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,o){return m?new y(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(m,o){return m?new y(1,o.name):y.c}static{this.f=0}constructor(m,o){this.type=m,this.name=o,this.g=Date.now(),this.h=[]}branch(m,o){const i=new y(3,m.toString());return this.h.push([m,o,i]),i}stop(){const m=Date.now()-this.g;y.f+=m;let o=!1;function i(r,c){const t=[],f=new Array(r+1).join("	");for(const[h,s,a]of c.h)if(s&&a){o=!0,t.push(`${f}CREATES -> ${h}`);const d=i(r+1,a);d&&t.push(d)}else t.push(`${f}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(m>2||o)&&y.all.add(n.join(`
`))}}e.$Uq=y}),define(Se[12],De([1,0,44,4,54,3,28,11,23,18,2,45,5]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.log=e.$Dj=e.LogLevel=e.$Cj=e.$Bj=e.$Aj=void 0,e.$Aj=(0,v.$gi)("logService"),e.$Bj=(0,v.$gi)("loggerService");function S(){return new Date().toISOString()}function y(b){return(0,E.$Xf)(b)}e.$Cj=y;var u;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(u||(e.LogLevel=u={})),e.$Dj=u.Info;function m(b,g,k){switch(g){case u.Trace:b.trace(k);break;case u.Debug:b.debug(k);break;case u.Info:b.info(k);break;case u.Warning:b.warn(k);break;case u.Error:b.error(k);break;case u.Off:break;default:throw new Error(`Invalid log level ${g}`)}}e.log=m;function o(b,g=!1){let k="";for(let P=0;P<b.length;P++){let F=b[P];if(F instanceof Error&&(F=(0,l.$4i)(F,g)),typeof F=="object")try{F=JSON.stringify(F)}catch{}k+=(P>0?" ":"")+F}return k}class i extends A.$Tc{constructor(){super(...arguments),this.b=e.$Dj,this.c=this.B(new N.$6d),this.onDidChangeLogLevel=this.c.event}setLevel(g){this.b!==g&&(this.b=g,this.c.fire(this.b))}getLevel(){return this.b}f(g){return this.b!==u.Off&&this.b<=g}}e.$Fj=i;class n extends i{constructor(g){super(),this.h=g}f(g){return this.h||super.f(g)}trace(g,...k){this.f(u.Trace)&&this.g(u.Trace,o([g,...k],!0))}debug(g,...k){this.f(u.Debug)&&this.g(u.Debug,o([g,...k]))}info(g,...k){this.f(u.Info)&&this.g(u.Info,o([g,...k]))}warn(g,...k){this.f(u.Warning)&&this.g(u.Warning,o([g,...k]))}error(g,...k){if(this.f(u.Error))if(g instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=g.stack,this.g(u.Error,o(P))}else this.g(u.Error,o([g,...k]))}flush(){}}e.$Gj=n;class r extends i{constructor(g=e.$Dj){super(),this.setLevel(g),this.g=!w.$i}trace(g,...k){this.f(u.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...k):console.log(`[main ${S()}]`,g,...k))}debug(g,...k){this.f(u.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...k):console.log(`[main ${S()}]`,g,...k))}info(g,...k){this.f(u.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,g,...k):console.log(`[main ${S()}]`,g,...k))}warn(g,...k){this.f(u.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,g,...k):console.warn(`[main ${S()}]`,g,...k))}error(g,...k){this.f(u.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,g,...k):console.error(`[main ${S()}]`,g,...k))}flush(){}}e.$Hj=r;class c extends i{constructor(g=e.$Dj,k=!0){super(),this.g=k,this.setLevel(g)}trace(g,...k){this.f(u.Trace)&&(this.g?console.log("%cTRACE","color: #888",g,...k):console.log(g,...k))}debug(g,...k){this.f(u.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",g,...k):console.log(g,...k))}info(g,...k){this.f(u.Info)&&(this.g?console.log("%c INFO","color: #33f",g,...k):console.log(g,...k))}warn(g,...k){this.f(u.Warning)&&(this.g?console.log("%c WARN","color: #993",g,...k):console.log(g,...k))}error(g,...k){this.f(u.Error)&&(this.g?console.log("%c  ERR","color: #f33",g,...k):console.error(g,...k))}flush(){}}e.$Ij=c;class t extends i{constructor(g,k=e.$Dj){super(),this.g=g,this.setLevel(k)}trace(g,...k){this.f(u.Trace)&&this.g.log(u.Trace,[this.h(g),...k])}debug(g,...k){this.f(u.Debug)&&this.g.log(u.Debug,[this.h(g),...k])}info(g,...k){this.f(u.Info)&&this.g.log(u.Info,[this.h(g),...k])}warn(g,...k){this.f(u.Warning)&&this.g.log(u.Warning,[this.h(g),...k])}error(g,...k){this.f(u.Error)&&this.g.log(u.Error,[this.h(g),...k])}h(g){return typeof g=="string"?g:(0,l.$4i)(g,this.f(u.Trace))}flush(){}}e.$Jj=t;class f extends i{constructor(g){super(),this.g=g,g.length&&this.setLevel(g[0].getLevel())}setLevel(g){for(const k of this.g)k.setLevel(g);super.setLevel(g)}trace(g,...k){for(const P of this.g)P.trace(g,...k)}debug(g,...k){for(const P of this.g)P.debug(g,...k)}info(g,...k){for(const P of this.g)P.info(g,...k)}warn(g,...k){for(const P of this.g)P.warn(g,...k)}error(g,...k){for(const P of this.g)P.error(g,...k)}flush(){for(const g of this.g)g.flush()}dispose(){for(const g of this.g)g.dispose();super.dispose()}}e.$Kj=f;class h extends A.$Tc{constructor(g,k,P){if(super(),this.h=g,this.j=k,this.b=new R.$Ac,this.c=this.B(new N.$6d),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$6d),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$6d),this.onDidChangeVisibility=this.g.event,P)for(const F of P)this.b.set(F.resource,{logger:void 0,info:F})}m(g){return(0,E.$Tf)(g)?[...this.b.values()].find(k=>k.info.id===g):this.b.get(g)}getLogger(g){return this.m(g)?.logger}createLogger(g,k){const P=this.n(g),F=(0,E.$Tf)(g)?g:k?.id??(0,L.$7i)(P.toString()).toString(16);let U=this.b.get(P)?.logger;const z=k?.logLevel==="always"?u.Trace:k?.logLevel;U||(U=this.s(P,z??this.getLogLevel(P)??this.h,{...k,id:F}));const T={logger:U,info:{resource:P,id:F,logLevel:z,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(T.info),this.b.set(P,T),U}n(g){return(0,E.$Tf)(g)?(0,p.$Tg)(this.j,`${g}.log`):g}setLogLevel(g,k){if(M.URI.isUri(g)){const P=g,F=k,U=this.b.get(P);U&&F!==U.info.logLevel&&(U.info.logLevel=F===this.h?void 0:F,U.logger?.setLevel(F),this.b.set(U.info.resource,U),this.f.fire([P,F]))}else{this.h=g;for(const[P,F]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(g,k){const P=this.m(g);P&&k!==!P.info.hidden&&(P.info.hidden=!k,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,k]))}getLogLevel(g){let k;return g&&(k=this.b.get(g)?.info.logLevel),k??this.h}registerLogger(g){const k=this.b.get(g.resource);k?k.info.hidden!==g.hidden&&this.setVisibility(g.resource,!g.hidden):(this.b.set(g.resource,{info:g,logger:void 0}),this.c.fire({added:[g],removed:[]}))}deregisterLogger(g){const k=this.b.get(g);k&&(k.logger&&k.logger.dispose(),this.b.delete(g),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const g of this.b.values())yield g.info}getRegisteredLogger(g){return this.b.get(g)?.info}dispose(){this.b.forEach(g=>g.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Lj=h;class s{constructor(){this.onDidChangeLogLevel=new N.$6d().event}setLevel(g){}getLevel(){return u.Info}trace(g,...k){}debug(g,...k){}info(g,...k){}warn(g,...k){}error(g,...k){}critical(g,...k){}dispose(){}flush(){}}e.$Mj=s;class a extends s{}e.$Nj=a;function d(b){if(b.verbose)return u.Trace;if(typeof b.logLevel=="string"){const g=D(b.logLevel.toLowerCase());if(g!==void 0)return g}return e.$Dj}e.$Oj=d;function $(b){switch(b){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Off:return"off"}}e.$Pj=$;function D(b){switch(b){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Error;case"off":return u.Off}}e.$Qj=D,e.$Rj=new C.$xj("logLevel",$(u.Info))}),define(Se[254],De([1,0,19,8,13,4,3,17,84,12]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class M extends R.$Tc{constructor(v,S){super(),this.a=v,this.b=S,this.c=this.B(new A.$6d),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$6d),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$eh(0)),this.w=[],this.y=this.B(new N.$eh(0))}watch(v,S){return S.recursive||this.b?.watcher?.forceUniversal?this.n(v,S):this.z(v,S)}n(v,S){const y={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:S.recursive,correlationId:S.correlationId},u=(0,l.$Ub)(this.j,y);return this.r(),(0,R.$Rc)(()=>{u(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,L.$1)(v))}s(){this.h||(this.h=this.B(this.t(S=>this.c.fire((0,p.$wq)(S)),S=>this.G(S),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const S of this.j)(0,p.$sq)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const S of this.j)(0,p.$sq)(S)&&v.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,S){const y={path:this.H(v),excludes:S.excludes,includes:S.includes,recursive:!1,correlationId:S.correlationId},u=(0,l.$Ub)(this.w,y);return this.C(),(0,R.$Rc)(()=>{u(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,L.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,p.$wq)(v)),v=>this.G(v),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,w.$hc)(v.fsPath)}}e.$Aq=M}),define(Se[255],De([1,0,57,393,8,28,21,4,34,3,17,11,23,98,31,210,32,248,254,44,252,251]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0,(()=>{try{(0,N.gracefulify)(l)}catch(f){console.error(`Error enabling graceful-fs: ${(0,n.$4i)(f)}`)}})();class t extends i.$Aq{static{this.I=!1}constructor(h,s){super(h,s),this.onDidChangeCapabilities=w.Event.None,this.N=new A.$Ac(a=>v.$Kg.getComparisonKey(a)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:s,symbolicLink:a}=await y.SymlinkSupport.stat(this.H(h));return{type:this.M(s,a),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const s=await y.Promises.readdir(this.H(h),{withFileTypes:!0}),a=[];return await Promise.all(s.map(async d=>{try{let $;d.isSymbolicLink()?$=(await this.stat((0,v.$Tg)(h,d.name))).type:$=this.M(d),a.push([d.name,$])}catch($){this.a.trace($)}})),a}catch(s){throw this.fb(s)}}M(h,s){let a;return s?.dangling?a=m.FileType.Unknown:h.isFile()?a=m.FileType.File:h.isDirectory()?a=m.FileType.Directory:a=m.FileType.Unknown,s&&(a|=m.FileType.SymbolicLink),a}async O(h){const s=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let a;for(;a=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await a.wait();const d=new L.$fh;return this.N.set(h,d),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,E.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(h)===d&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),d.open()})}async readFile(h,s){let a;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),a=await this.O(h));const d=this.H(h);return await y.Promises.readFile(d)}catch(d){throw this.fb(d)}finally{a?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,s,a){const d=(0,S.$he)($=>R.$te.concat($.map(D=>R.$te.wrap(D))).buffer);return(0,o.$qq)(this,h,d,$=>$.buffer,{...s,bufferSize:256*1024},a),d}async writeFile(h,s,a){return a?.atomic!==!1&&a?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,v.$Tg)((0,v.$Sg)(h),`${(0,v.$Qg)(h)}${a.atomic.postfix}`),s,a):this.S(h,s,a)}async Q(h){try{const s=this.H(h),{symbolicLink:a}=await y.SymlinkSupport.stat(s);if(a)return!1}catch{}return!0}async R(h,s,a,d){const $=new E.$Sc;try{$.add(await this.O(h)),$.add(await this.O(s)),await this.S(s,a,d,!0);try{await this.rename(s,h,{overwrite:!0})}catch(D){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw D}}finally{$.dispose()}}async S(h,s,a,d){let $;try{const D=this.H(h);if(!a.create||!a.overwrite){if(await y.Promises.exists(D)){if(!a.overwrite)throw(0,m.$Tk)((0,u.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!a.create)throw(0,m.$Tk)((0,u.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(h,{create:!0,unlock:a.unlock},d),await this.write($,0,s,0,s.byteLength)}catch(D){throw await this.gb(h,D)}finally{typeof $=="number"&&await this.close($)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,s,a){const d=this.H(h);let $;(0,m.$Hk)(s)&&!a&&($=await this.O(h));let D;try{if((0,m.$Hk)(s)&&s.unlock)try{const{stat:g}=await y.SymlinkSupport.stat(d);g.mode&128||await y.Promises.chmod(d,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let b;if((0,m.$Hk)(s)){if(C.$i)try{await y.Promises.truncate(d,0),b="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}b||(b="w")}else b="r";D=await y.Promises.open(d,b)}catch(b){throw $?.dispose(),(0,m.$Hk)(s)?await this.gb(h,b):this.fb(b)}if(this.U.set(D,0),(0,m.$Hk)(s)&&this.X.set(D,h),$){const b=this.W.get(D);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${D} (${d})`),this.W.set(D,$),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${D} (${d})`),b.dispose())}return D}async close(h){const s=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await y.Promises.fdatasync(h)}catch(a){t.configureFlushOnWrite(!1),this.a.error(a)}return await y.Promises.close(h)}catch(a){throw this.fb(a)}finally{s&&(this.W.get(h)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),s.dispose())}}async read(h,s,a,d,$){const D=this.Z(h,s);let b=null;try{b=(await y.Promises.read(h,a,d,$,D)).bytesRead}catch(g){throw this.fb(g)}finally{this.$(h,D,b)}return b}Z(h,s){return s===this.U.get(h)?null:s}$(h,s,a){const d=this.U.get(h);typeof d=="number"&&(typeof s=="number"||(typeof a=="number"?this.U.set(h,d+a):this.U.delete(h)))}async write(h,s,a,d,$){return(0,L.$Ah)(()=>this.ab(h,s,a,d,$),100,3)}async ab(h,s,a,d,$){const D=this.Z(h,s);let b=null;try{b=(await y.Promises.write(h,a,d,$,D)).bytesWritten}catch(g){throw await this.gb(this.X.get(h),g)}finally{this.$(h,D,b)}return b}async mkdir(h){try{await y.Promises.mkdir(this.H(h))}catch(s){throw this.fb(s)}}async delete(h,s){try{const a=this.H(h);if(s.recursive){let d;s?.atomic!==!1&&s.atomic.postfix&&(d=(0,M.$jc)((0,M.$mc)(a),`${(0,M.$nc)(a)}${s.atomic.postfix}`)),await y.Promises.rm(a,y.RimRafMode.MOVE,d)}else try{await y.Promises.unlink(a)}catch(d){if(d.code==="EPERM"||d.code==="EISDIR"){let $=!1;try{const{stat:D,symbolicLink:b}=await y.SymlinkSupport.stat(a);$=D.isDirectory()&&!b}catch{}if($)await y.Promises.rmdir(a);else throw d}else throw d}}catch(a){throw this.fb(a)}}async rename(h,s,a){const d=this.H(h),$=this.H(s);if(d!==$)try{await this.bb(h,s,"move",a.overwrite),await y.Promises.rename(d,$)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(2,null,(0,M.$nc)(d),(0,M.$nc)((0,M.$mc)($)),D.toString()))),this.fb(D)}}async copy(h,s,a){const d=this.H(h),$=this.H(s);if(d!==$)try{await this.bb(h,s,"copy",a.overwrite),await y.Promises.copy(d,$,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,u.localize)(3,null,(0,M.$nc)(d),(0,M.$nc)((0,M.$mc)($)),D.toString()))),this.fb(D)}}async bb(h,s,a,d){const $=this.H(h),D=this.H(s);let b=!1;if(!!(this.capabilities&1024)||(b=(0,p.$fg)($,D,!0)),b){if(a==="copy")throw(0,m.$Tk)((0,u.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(a==="move")return}const k=await this.L(h);if(!k)throw(0,m.$Tk)((0,u.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(s);if(P){if(!d)throw(0,m.$Tk)((0,u.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);k.type&m.FileType.File&&P.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,s){return this.cb(h,s,!1)}async cb(h,s,a){const d=this.H(h),$=this.H(s),D=!!(this.capabilities&1024);if((0,p.$fg)(d,$,!D))return;const b=new E.$Sc;try{b.add(await this.O(h)),b.add(await this.O(s)),a&&await y.Promises.mkdir((0,M.$mc)($),{recursive:!0}),await y.Promises.copyFile(d,$)}catch(g){if(g.code==="ENOENT"&&!a)return this.cb(h,s,!0);throw this.fb(g)}finally{b.dispose()}}t(h,s,a){return new r.$Hq(d=>h(d),d=>s(d),a)}F(h,s,a){return new c.$Pq(d=>h(d),d=>s(d),a)}fb(h){if(h instanceof m.$Sk)return h;let s=h,a;switch(h.code){case"ENOENT":a=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,a=m.FileSystemProviderErrorCode.Unknown;break;default:a=m.FileSystemProviderErrorCode.Unknown}return(0,m.$Tk)(s,a)}async gb(h,s){let a=this.fb(s);if(h&&a.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await y.SymlinkSupport.stat(this.H(h));d.mode&128||(a=(0,m.$Tk)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.a.trace(d)}return a}}e.$Qq=t}),define(Se[256],De([1,0,3,12]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NP=void 0;class L extends l.$Tc{constructor(R,w=[]){super(),this.a=new N.$Kj([R,...w]),this.B(R.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...w){this.a.trace(R,...w)}debug(R,...w){this.a.debug(R,...w)}info(R,...w){this.a.info(R,...w)}warn(R,...w){this.a.warn(R,...w)}error(R,...w){this.a.error(R,...w)}flush(){this.a.flush()}}e.$NP=L}),define(Se[257],De([1,0,32,12]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CP=void 0;var L;(function(E){E[E.Trace=0]="Trace",E[E.Debug=1]="Debug",E[E.Info=2]="Info",E[E.Warning=3]="Warning",E[E.Error=4]="Error",E[E.Critical=5]="Critical",E[E.Off=6]="Off"})(L||(L={}));async function A(E,M,C,v,S){try{const y=await new Promise((m,o)=>{fe(["@vscode/spdlog"],m,o)});y.setFlushOn(L.Trace);const u=await y.createAsyncRotatingLogger(E,M,C,v);return S?u.clearFormatters():u.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),u}catch(y){console.error(y)}return null}function R(E,M,C){switch(M){case N.LogLevel.Trace:E.trace(C);break;case N.LogLevel.Debug:E.debug(C);break;case N.LogLevel.Info:E.info(C);break;case N.LogLevel.Warning:E.warn(C);break;case N.LogLevel.Error:E.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function w(E,M){switch(M){case N.LogLevel.Trace:E.setLevel(L.Trace);break;case N.LogLevel.Debug:E.setLevel(L.Debug);break;case N.LogLevel.Info:E.setLevel(L.Info);break;case N.LogLevel.Warning:E.setLevel(L.Warning);break;case N.LogLevel.Error:E.setLevel(L.Error);break;case N.LogLevel.Off:E.setLevel(L.Off);break;default:throw new Error(`Invalid log level ${M}`)}}class p extends N.$Gj{constructor(M,C,v,S,y){super(),this.m=[],this.setLevel(y),this.n=this.s(M,C,v,S),this.B(this.onDidChangeLogLevel(u=>{this.r&&w(this.r,u)}))}async s(M,C,v,S){const y=v?6:1,u=30/y*l.$cl.MB,m=await A(M,C,u,y,S);if(m){this.r=m,w(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(M,C){this.r?R(this.r,M,C):this.getLevel()<=M&&this.m.push({level:M,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$CP=p}),define(Se[138],De([1,0,39,211,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(A||(e.MarkerTag=A={}));var R;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(p){function E(y,u){return u-y}p.compare=E;const M=Object.create(null);M[p.Error]=(0,N.localize)(0,null),M[p.Warning]=(0,N.localize)(1,null),M[p.Info]=(0,N.localize)(2,null);function C(y){return M[y]||""}p.toString=C;function v(y){switch(y){case l.default.Error:return p.Error;case l.default.Warning:return p.Warning;case l.default.Info:return p.Info;case l.default.Ignore:return p.Hint}}p.fromSeverity=v;function S(y){switch(y){case p.Error:return l.default.Error;case p.Warning:return l.default.Warning;case p.Info:return l.default.Info;case p.Hint:return l.default.Ignore}}p.toSeverity=S}(R||(e.MarkerSeverity=R={}));var w;(function(p){const E="";function M(v){return C(v,!0)}p.makeKey=M;function C(v,S){const y=[E];return v.source?y.push(v.source.replace("\xA6","\\\xA6")):y.push(E),v.code?typeof v.code=="string"?y.push(v.code.replace("\xA6","\\\xA6")):y.push(v.code.value.replace("\xA6","\\\xA6")):y.push(E),v.severity!==void 0&&v.severity!==null?y.push(R.toString(v.severity)):y.push(E),v.message&&S?y.push(v.message.replace("\xA6","\\\xA6")):y.push(E),v.startLineNumber!==void 0&&v.startLineNumber!==null?y.push(v.startLineNumber.toString()):y.push(E),v.startColumn!==void 0&&v.startColumn!==null?y.push(v.startColumn.toString()):y.push(E),v.endLineNumber!==void 0&&v.endLineNumber!==null?y.push(v.endLineNumber.toString()):y.push(E),v.endColumn!==void 0&&v.endColumn!==null?y.push(v.endColumn.toString()):y.push(E),y.push(E),y.join("\xA6")}p.makeKeyOptionalMessage=C})(w||(e.IMarkerData=w={})),e.$Pt=(0,L.$gi)("markerService")}),define(Se[258],De([1,0,4,39,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iv=e.$Hv=e.NotificationsFilter=e.$Gv=e.NeverShowAgainScope=e.NotificationPriority=e.$Fv=e.Severity=void 0,e.Severity=N.default,e.$Fv=(0,L.$gi)("notificationService");var A;(function(C){C[C.DEFAULT=0]="DEFAULT",C[C.SILENT=1]="SILENT",C[C.URGENT=2]="URGENT"})(A||(e.NotificationPriority=A={}));var R;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.PROFILE=1]="PROFILE",C[C.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function w(C){if(C){const v=C;return typeof v.id=="string"&&typeof v.label=="string"}return!1}e.$Gv=w;var p;(function(C){C[C.OFF=0]="OFF",C[C.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class E{constructor(){this.progress=new M,this.onDidClose=l.Event.None,this.onDidChangeVisibility=l.Event.None}updateSeverity(v){}updateMessage(v){}updateActions(v){}close(){}}e.$Hv=E;class M{infinite(){}done(){}total(v){}worked(v){}}e.$Iv=M}),define(Se[259],De([1,0,50]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,l.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Se[139],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=e.$Sj=void 0,e.$Sj=(0,l.$gi)("productService"),e.$Tj="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(fe,e){return function(l,N){e(l,N,fe)}};define(Se[108],De([1,0,8,22,3,5]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pv=e.$Ov=e.$Nv=e.$Mv=e.$Lv=e.$Kv=e.ProgressLocation=e.$Jv=void 0,e.$Jv=(0,A.$gi)("progressService");var R;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$Kv=Object.freeze({total(){},worked(){},done(){}});class w{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(v){this.b=v}report(v){this.a=v,this.b(this.a)}}e.$Lv=w;class p{get value(){return this.a}constructor(v){this.e=v}report(v){this.b?this.b.push(v):this.b=[v],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const v=this.b.shift();this.a=v,await this.e(this.a)}}finally{this.c=!1;const v=this.d;this.d=void 0,v?.()}}drain(){return this.c?new Promise(v=>{const S=this.d;this.d=()=>{S?.(),v()}}):Promise.resolve()}}e.$Mv=p;let E=class extends L.$Tc{constructor(v,S){super(),this.a=new l.$Dh,S.withProgress(v,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,L.$Rc)(()=>this.a.complete()))}report(v){this.b?this.b.report(v):this.c=v}};e.$Nv=E,e.$Nv=E=Qe([Ve(1,e.$Jv)],E);class M extends L.$Tc{constructor(v){super(),this.g=v,this.a=0,this.b=this.B(new L.$Sc)}start(v){this.stop();const S=++this.a,y=new N.$de;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},v),this.b.add((0,L.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,L.$Rc)(()=>y.cancel())),this.b.add((0,L.$Rc)(()=>this.c?this.c.done():void 0)),{id:S,token:y.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(v){this.a===v&&this.b.clear()}}e.$Ov=M,e.$Pv=(0,A.$gi)("editorProgressService")}),define(Se[37],De([1,0,61,18]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=void 0;class L{constructor(){this.a=new Map}add(R,w){l.ok(N.$Tf(R)),l.ok(N.$Vf(w)),l.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,w)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Xn=new L}),define(Se[109],De([1,0,4,37]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=void 0,e.$Yn={JSONContribution:"base.contributions.json"};function L(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class A{constructor(){this.b=new l.$6d,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,E){this.a[L(p)]=E,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const R=new A;N.$Xn.add(e.$Yn.JSONContribution,R)}),define(Se[85],De([1,0,19,4,18,201,52,109,37]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.ConfigurationScope=e.$3n=e.EditPresentationTypes=void 0;var E;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$3n={Configuration:"base.contributions.configuration"};var M;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(M||(e.ConfigurationScope=M={})),e.$4n={properties:{},patternProperties:{}},e.$5n={properties:{},patternProperties:{}},e.$6n={properties:{},patternProperties:{}},e.$7n={properties:{},patternProperties:{}},e.$8n={properties:{},patternProperties:{}},e.$9n={properties:{},patternProperties:{}},e.$0n="vscode://schemas/settings/resourceLanguage",e.$$n="vscode://schemas/settings/configurationDefaults";const C=p.$Xn.as(w.$Yn.JSONContribution);class v{constructor(){this.h=new Set,this.i=new N.$6d,this.onDidSchemaChange=this.i.event,this.j=new N.$6d,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$0n,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const h=new Set;this.n(t,f,h),C.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const f=new Set;this.o(t,f),C.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const h=new Set;this.o(f,h),this.n(t,!1,h),C.registerSchema(e.$0n,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const h=[];for(const{overrides:s,source:a}of t)for(const d in s)if(f.add(d),e.$ao.test(d)){const $=this.a.get(d),D=$?.valuesSources??new Map;if(a)for(const P of Object.keys(s[d]))D.set(P,a);const b={...$?.value||{},...s[d]};this.a.set(d,{source:a,value:b,valuesSources:D});const g=(0,R.$Wi)(d),k={type:"object",default:b,description:A.localize(1,null,g),$ref:e.$0n,defaultDefaultValue:b,source:L.$Tf(a)?void 0:a,defaultValueSource:a};h.push(...u(d)),this.d[d]=k,this.b.properties[d]=k}else{this.a.set(d,{value:s[d],source:a});const $=this.d[d];$&&(this.w(d,$),this.r(d,$))}this.m(h)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:h,source:s}of t)for(const a in h){const d=this.a.get(a),$=L.$Tf(s)?s:s?.id,D=L.$Tf(d?.source)?d?.source:d?.source?.id;if($===D)if(f.add(a),this.a.delete(a),e.$ao.test(a))delete this.d[a],delete this.b.properties[a];else{const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}}this.u()}deltaConfiguration(t){let f=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,h){t.forEach(s=>{this.p(s,f,s.extensionInfo,s.restrictedProperties,void 0,h),this.c.push(s),this.q(s)})}o(t,f){const h=s=>{if(s.properties)for(const a in s.properties){f.add(a);const d=this.d[a];d?.policy?.name&&this.e.delete(d.policy.name),delete this.d[a],this.s(a,s.properties[a])}s.allOf?.forEach(a=>h(a))};for(const s of t){h(s);const a=this.c.indexOf(s);a!==-1&&this.c.splice(a,1)}}p(t,f=!0,h,s,a=3,d){a=L.$3f(t.scope)?a:t.scope;const $=t.properties;if($)for(const b in $){const g=$[b];if(f&&n(b,g)){delete $[b];continue}if(g.source=h,g.defaultDefaultValue=$[b].default,this.w(b,g),e.$ao.test(b)?g.scope=void 0:(g.scope=L.$3f(g.scope)?a:g.scope,g.restricted=L.$3f(g.restricted)?!!s?.includes(b):g.restricted),$[b].hasOwnProperty("included")&&!$[b].included){this.f[b]=$[b],delete $[b];continue}else this.d[b]=$[b],$[b].policy?.name&&this.e.set($[b].policy.name,b);!$[b].deprecationMessage&&$[b].markdownDeprecationMessage&&($[b].deprecationMessage=$[b].markdownDeprecationMessage),d.add(b)}const D=t.allOf;if(D)for(const b of D)this.p(b,f,h,s,a,d)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=h=>{const s=h.properties;if(s)for(const d in s)this.r(d,s[d]);h.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$4n.properties[t]=f,f.scope){case 1:e.$5n.properties[t]=f;break;case 2:e.$6n.properties[t]=f;break;case 6:e.$7n.properties[t]=f;break;case 3:e.$8n.properties[t]=f;break;case 4:e.$9n.properties[t]=f;break;case 5:e.$9n.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$4n.properties[t],f.scope){case 1:delete e.$5n.properties[t];break;case 2:delete e.$6n.properties[t];break;case 6:delete e.$7n.properties[t];break;case 3:delete e.$8n.properties[t];break;case 4:case 5:delete e.$9n.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,h={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$0n};this.w(f,h),e.$4n.properties[f]=h,e.$5n.properties[f]=h,e.$6n.properties[f]=h,e.$7n.properties[f]=h,e.$8n.properties[f]=h,e.$9n.properties[f]=h}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$0n};e.$4n.patternProperties[e.$_n]=t,e.$5n.patternProperties[e.$_n]=t,e.$6n.patternProperties[e.$_n]=t,e.$7n.patternProperties[e.$_n]=t,e.$8n.patternProperties[e.$_n]=t,e.$9n.patternProperties[e.$_n]=t,this.i.fire()}w(t,f){const h=this.a.get(t);let s=h?.value,a=h?.source;L.$1f(s)&&(s=f.defaultDefaultValue,a=void 0),L.$1f(s)&&(s=o(f.type)),f.default=s,f.defaultValueSource=a}}const S="\\[([^\\]]+)\\]",y=new RegExp(S,"g");e.$_n=`^(${S})+$`,e.$ao=new RegExp(e.$_n);function u(c){const t=[];if(e.$ao.test(c)){let f=y.exec(c);for(;f?.length;){const h=f[1].trim();h&&t.push(h),f=y.exec(c)}}return(0,l.$Mb)(t)}e.$bo=u;function m(c){return c.reduce((t,f)=>`${t}[${f}]`,"")}e.$co=m;function o(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$do=o;const i=new v;p.$Xn.add(e.$3n.Configuration,i);function n(c,t){return c.trim()?e.$ao.test(c)?A.localize(7,null,c):i.getConfigurationProperties()[c]!==void 0?A.localize(8,null,c):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,c,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}e.$eo=n;function r(){const c=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))c.push([f,t[f].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$fo=r}),define(Se[260],De([1,0,19,4,163,3,28,24,18,2,52,85,37]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=void 0;function S(f){return Object.isFrozen(f)?f:w.$Mn(f)}class y{constructor(h={},s=[],a=[],d){this.b=h,this.c=s,this.d=a,this.raw=d,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(s=>{if(s instanceof y)return s;const a=new u("");return a.parseRaw(s),a.configurationModel});this.f=h.reduce((s,a)=>a===s?a:s.merge(a),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,M.$Ui)(this.contents,h):this.contents}inspect(h,s){const a=this;return{get value(){return S(a.rawConfiguration.getValue(h))},get override(){return s?S(a.rawConfiguration.getOverrideValue(h,s)):void 0},get merged(){return S(s?a.rawConfiguration.override(s).getValue(h):a.rawConfiguration.getValue(h))},get overrides(){const d=[];for(const{contents:$,identifiers:D,keys:b}of a.rawConfiguration.overrides){const g=new y($,b).getValue(h);g!==void 0&&d.push({identifiers:D,value:g})}return d.length?S(d):void 0}}}getOverrideValue(h,s){const a=this.i(s);return a?h?(0,M.$Ui)(a,h):a:void 0}getKeysForOverrideIdentifier(h){const s=[];for(const a of this.overrides)a.identifiers.includes(h)&&s.push(...a.keys);return l.$Mb(s)}getAllOverrideIdentifiers(){const h=[];for(const s of this.overrides)h.push(...s.identifiers);return l.$Mb(h)}override(h){let s=this.a.get(h);return s||(s=this.g(h),this.a.set(h,s)),s}merge(...h){const s=w.$Ln(this.contents),a=w.$Ln(this.overrides),d=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const D of h)if($.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.h(s,D.contents);for(const b of D.overrides){const[g]=a.filter(k=>l.$ub(k.identifiers,b.identifiers));g?(this.h(g.contents,b.contents),g.keys.push(...b.keys),g.keys=l.$Mb(g.keys)):a.push(w.$Ln(b))}for(const b of D.keys)d.indexOf(b)===-1&&d.push(b)}return new y(s,d,a,$.every(D=>D instanceof y)?void 0:$)}g(h){const s=this.i(h);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const a={};for(const d of l.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let $=this.contents[d];const D=s[d];D&&(typeof $=="object"&&typeof D=="object"?($=w.$Ln($),this.h($,D)):$=D),a[d]=$}return new y(a,this.keys,this.overrides)}h(h,s){for(const a of Object.keys(s)){if(a in h&&p.$Vf(h[a])&&p.$Vf(s[a])){this.h(h[a],s[a]);continue}h[a]=w.$Ln(s[a])}}i(h){let s=null,a=null;const d=$=>{$&&(a?this.h(a,$):a=w.$Ln($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===h?s=$.contents:$.identifiers.includes(h)&&d($.contents);return d(s),a}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,s){this.j(h,s,!0)}setValue(h,s){this.j(h,s,!1)}removeValue(h){const s=this.keys.indexOf(h);s!==-1&&(this.keys.splice(s,1),(0,M.$Ti)(this.contents,h),C.$ao.test(h)&&this.overrides.splice(this.overrides.findIndex(a=>l.$ub(a.identifiers,(0,C.$bo)(h))),1))}j(h,s,a){(0,M.$Si)(this.contents,h,s,d=>console.error(d)),a=a||this.keys.indexOf(h)===-1,a&&this.keys.push(h),C.$ao.test(h)&&this.overrides.push({identifiers:(0,C.$bo)(h),keys:Object.keys(this.contents[h]),contents:(0,M.$Ri)(this.contents[h],d=>console.error(d))})}}e.$go=y;class u{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,s){if(!p.$3f(h)){const a=this.g(h);this.parseRaw(a,s)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,s){this.a=h;const{contents:a,keys:d,overrides:$,restricted:D,hasExcludedProperties:b}=this.h(h,s);this.b=new y(a,d,$,b?[h]:void 0),this.c=D||[]}g(h){let s={},a=null,d=[];const $=[],D=[];function b(k){Array.isArray(d)?d.push(k):a!==null&&(d[a]=k)}const g={onObjectBegin:()=>{const k={};b(k),$.push(d),d=k,a=null},onObjectProperty:k=>{a=k},onObjectEnd:()=>{d=$.pop()},onArrayBegin:()=>{const k=[];b(k),$.push(d),d=k,a=null},onArrayEnd:()=>{d=$.pop()},onLiteralValue:b,onError:(k,P,F)=>{D.push({error:k,offset:P,length:F})}};if(h)try{L.$zn(h,g),s=d[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}h(h,s){const a=v.$Xn.as(C.$3n.Configuration).getConfigurationProperties(),d=this.i(h,a,!0,s);h=d.raw;const $=(0,M.$Ri)(h,g=>console.error(`Conflict in settings file ${this.f}: ${g}`)),D=Object.keys(h),b=this.j(h,g=>console.error(`Conflict in settings file ${this.f}: ${g}`));return{contents:$,keys:D,overrides:b,restricted:d.restricted,hasExcludedProperties:d.hasExcludedProperties}}i(h,s,a,d){let $=!1;if(!d?.scopes&&!d?.skipRestricted&&!d?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:$};const D={},b=[];for(const g in h)if(C.$ao.test(g)&&a){const k=this.i(h[g],s,!1,d);D[g]=k.raw,$=$||k.hasExcludedProperties,b.push(...k.restricted)}else{const k=s[g],P=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&b.push(g),!d.exclude?.includes(g)&&(d.include?.includes(g)||(P===void 0||d.scopes===void 0||d.scopes.includes(P))&&!(d.skipRestricted&&k?.restricted))?D[g]=h[g]:$=!0}return{raw:D,restricted:b,hasExcludedProperties:$}}j(h,s){const a=[];for(const d of Object.keys(h))if(C.$ao.test(d)){const $={};for(const D in h[d])$[D]=h[d][D];a.push({identifiers:(0,C.$bo)(d),keys:Object.keys($),contents:(0,M.$Ri)($,s)})}return a}}e.$ho=u;class m extends A.$Tc{constructor(h,s,a,d){super(),this.c=h,this.f=s,this.g=d,this.b=this.B(new N.$6d),this.onDidChange=this.b.event,this.a=new u(this.c.toString()),this.B(this.g.watch(a.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,$=>$.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,$=>($.isOperation(0)||$.isOperation(3)||$.isOperation(1)||$.isOperation(4))&&a.isEqual($.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$io=m;class o{constructor(h,s,a,d,$,D,b,g,k,P,F,U,z){this.a=h,this.b=s,this.c=a,this.overrideIdentifiers=d,this.d=$,this.f=D,this.g=b,this.h=g,this.i=k,this.j=P,this.k=F,this.l=U,this.m=z}get value(){return S(this.c)}n(h){return h?.value!==void 0||h?.override!==void 0||h?.overrides!==void 0?h:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(h,s,a,d,$=new y,D=new y,b=new R.$Ac,g=new y,k=new R.$Ac){this.c=h,this.d=s,this.f=a,this.g=d,this.h=$,this.i=D,this.j=b,this.l=g,this.m=k,this.a=null,this.b=new R.$Ac,this.n=null}getValue(h,s,a){return this.p(h,s,a).getValue(h)}updateValue(h,s,a={}){let d;a.resource?(d=this.m.get(a.resource),d||(d=new y,this.m.set(a.resource,d))):d=this.l,s===void 0?d.removeValue(h):d.setValue(h,s),a.resource||(this.a=null)}inspect(h,s,a){const d=this.p(h,s,a),$=this.t(s.resource,a),D=s.resource?this.m.get(s.resource)||this.l:this.l,b=new Set;for(const g of d.overrides)for(const k of g.identifiers)d.getOverrideValue(h,k)!==void 0&&b.add(k);return new o(h,s,d.getValue(h),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,a?this.i:void 0,$||void 0,D)}keys(h){const s=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,s){this.j.set(h,s),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,s){const a=[];if(!s){const{added:d,updated:$,removed:D}=c(this.c,h);s=[...d,...$,...D]}for(const d of s)for(const $ of(0,C.$bo)(d)){const D=this.c.getKeysForOverrideIdentifier($),b=h.getKeysForOverrideIdentifier($),g=[...b.filter(k=>D.indexOf(k)===-1),...D.filter(k=>b.indexOf(k)===-1),...D.filter(k=>!w.$Pn(this.c.override($).getValue(k),h.override($).getValue(k)))];a.push([$,g])}return this.updateDefaultConfiguration(h),{keys:s,overrides:a}}compareAndUpdatePolicyConfiguration(h){const{added:s,updated:a,removed:d}=c(this.d,h),$=[...s,...a,...d];return $.length&&this.updatePolicyConfiguration(h),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:s,updated:a,removed:d,overrides:$}=c(this.applicationConfiguration,h),D=[...s,...a,...d];return D.length&&this.updateApplicationConfiguration(h),{keys:D,overrides:$}}compareAndUpdateLocalUserConfiguration(h){const{added:s,updated:a,removed:d,overrides:$}=c(this.localUserConfiguration,h),D=[...s,...a,...d];return D.length&&this.updateLocalUserConfiguration(h),{keys:D,overrides:$}}compareAndUpdateRemoteUserConfiguration(h){const{added:s,updated:a,removed:d,overrides:$}=c(this.remoteUserConfiguration,h),D=[...s,...a,...d];return D.length&&this.updateRemoteUserConfiguration(h),{keys:D,overrides:$}}compareAndUpdateWorkspaceConfiguration(h){const{added:s,updated:a,removed:d,overrides:$}=c(this.workspaceConfiguration,h),D=[...s,...a,...d];return D.length&&this.updateWorkspaceConfiguration(h),{keys:D,overrides:$}}compareAndUpdateFolderConfiguration(h,s){const a=this.folderConfigurations.get(h),{added:d,updated:$,removed:D,overrides:b}=c(a,s),g=[...d,...$,...D];return(g.length||!a)&&this.updateFolderConfiguration(h,s),{keys:g,overrides:b}}compareAndDeleteFolderConfiguration(h){const s=this.folderConfigurations.get(h);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:a,updated:d,removed:$,overrides:D}=c(s,void 0);return{keys:[...a,...d,...$],overrides:D}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,s,a){let d=this.q(s,a);return s.overrideIdentifier&&(d=d.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(d=d.merge(this.d)),d}q({resource:h},s){let a=this.r();if(s&&h){const d=s.getFolder(h);d&&(a=this.s(d.uri)||a);const $=this.m.get(h);$&&(a=a.merge($))}return a}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let s=this.b.get(h);if(!s){const a=this.r(),d=this.j.get(h);d?(s=a.merge(d),this.b.set(h,s)):s=a}return s}t(h,s){if(s&&h){const a=s.getFolder(h);if(a)return this.j.get(a.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,s)=>{const{contents:a,overrides:d,keys:$}=this.j.get(s);return h.push([s,{contents:a,overrides:d,keys:$}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(s=>h.add(s)),this.userConfiguration.keys.forEach(s=>h.add(s)),this.i.keys.forEach(s=>h.add(s)),this.j.forEach(s=>s.keys.forEach(a=>h.add(a))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>h.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>h.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>h.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(a=>h.add(a))),[...h.values()]}v(h){const s=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(a=>s.add(a)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(a=>s.add(a)),this.i.getKeysForOverrideIdentifier(h).forEach(a=>s.add(a)),this.j.forEach(a=>a.getKeysForOverrideIdentifier(h).forEach(d=>s.add(d))),[...s.values()]}static parse(h){const s=this.w(h.defaults),a=this.w(h.policy),d=this.w(h.application),$=this.w(h.user),D=this.w(h.workspace),b=h.folders.reduce((g,k)=>(g.set(E.URI.revive(k[0]),this.w(k[1])),g),new R.$Ac);return new i(s,a,d,$,new y,D,b,new y,new R.$Ac)}static w(h){return new y(h.contents,h.keys,h.overrides)}}e.$jo=i;function n(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const h=new Set,s=new Map;for(const d of f)d.keys.forEach($=>h.add($)),d.overrides.forEach(([$,D])=>{const b=(0,R.$xc)(s,$,new Set);D.forEach(g=>b.add(g))});const a=[];return s.forEach((d,$)=>a.push([$,[...d.values()]])),{keys:[...h.values()],overrides:a}}e.$ko=n;class r{constructor(h,s,a,d){this.change=h,this.f=s,this.g=a,this.h=d,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const $ of h.keys)this.affectedKeys.add($);for(const[,$]of h.overrides)for(const D of $)this.affectedKeys.add(D);this.d=this.a;for(const $ of this.affectedKeys)this.d+=$+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(h,s){const a=this.a+h,d=this.d.indexOf(a);if(d<0)return!1;const $=d+a.length;if($>=this.d.length)return!1;const D=this.d.charCodeAt($);if(D!==this.b&&D!==this.c)return!1;if(s){const b=this.previousConfiguration?this.previousConfiguration.getValue(h,s,this.f?.workspace):void 0,g=this.g.getValue(h,s,this.h);return!w.$Pn(b,g)}return!0}}e.$lo=r;function c(f,h){const{added:s,removed:a,updated:d}=t(h?.rawConfiguration,f?.rawConfiguration),$=[],D=f?.getAllOverrideIdentifiers()||[],b=h?.getAllOverrideIdentifiers()||[];if(h){const g=b.filter(k=>!D.includes(k));for(const k of g)$.push([k,h.getKeysForOverrideIdentifier(k)])}if(f){const g=D.filter(k=>!b.includes(k));for(const k of g)$.push([k,f.getKeysForOverrideIdentifier(k)])}if(h&&f){for(const g of D)if(b.includes(g)){const k=t({contents:f.getOverrideValue(void 0,g)||{},keys:f.getKeysForOverrideIdentifier(g)},{contents:h.getOverrideValue(void 0,g)||{},keys:h.getKeysForOverrideIdentifier(g)});$.push([g,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:a,updated:d,overrides:$}}function t(f,h){const s=f?h?f.keys.filter($=>h.keys.indexOf($)===-1):[...f.keys]:[],a=h?f?h.keys.filter($=>f.keys.indexOf($)===-1):[...h.keys]:[],d=[];if(f&&h){for(const $ of h.keys)if(f.keys.indexOf($)!==-1){const D=(0,M.$Ui)(h.contents,$),b=(0,M.$Ui)(f.contents,$);w.$Pn(D,b)||d.push($)}}return{added:s,removed:a,updated:d}}}),define(Se[261],De([1,0,21,4,3,81]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ztb=e.$ytb=e.$xtb=e.$wtb=void 0;const R=(E,M,C)=>{const v=new Uint8Array(16);for(let u=0;u<16;u++)v[u]=Math.round(Math.random()*256);const S=(0,l.$Ne)(l.$te.wrap(v));return[`GET ws://localhost${E}?${M}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$wtb=R,e.$xtb=l.$te.fromString(`\r
\r
`);async function w(E,M,C,v,S){E.write(l.$te.fromString((0,e.$wtb)(M,C,v)));const y=new L.$Sc;try{return await new Promise((u,m)=>{let o;y.add(E.onData(i=>{o?o=l.$te.concat([o,i],o.byteLength+i.byteLength):o=i;const n=o.indexOf(e.$xtb);if(n===-1)return;u(E),E.pauseData();const r=o.slice(n+e.$xtb.byteLength);r.byteLength&&S.onData.fire(r)})),y.add(E.onClose(i=>m(i??new Error("socket closed")))),y.add(E.onEnd(()=>m(new Error("socket ended"))))})}catch(u){throw E.dispose(),u}finally{y.dispose()}}e.$ytb=w;class p extends L.$Tc{constructor(M,C){super(),this.g=M,this.a=this.B(new N.$9d),this.onData=(...v)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...v)),this.b=this.B(new N.$6d),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(v=>this.a.fire(v))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(M,C){A.SocketDiagnostics.traceSocketEvent(this,this.g,M,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$ztb=p}),define(Se[64],De([1,0,13,5]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pl=e.$ol=e.RemoteAuthorityResolverErrorCode=e.$nl=e.$ml=e.RemoteConnectionType=e.$ll=void 0,e.$ll=(0,N.$gi)("remoteAuthorityResolverService");var L;(function(M){M[M.WebSocket=0]="WebSocket",M[M.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$ml=A;class R{constructor(C,v){this.host=C,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$nl=R;var w;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound",M.InvalidAuthority="InvalidAuthority"})(w||(e.RemoteAuthorityResolverErrorCode=w={}));class p extends l.$bb{static isNotAvailable(C){return C instanceof p&&C._code===w.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof p&&C._code===w.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof p&&C._code===w.NoResolverFound}static isInvalidAuthority(C){return C instanceof p&&C._code===w.InvalidAuthority}static isHandled(C){return C instanceof p&&C.isHandled}constructor(C,v=w.Unknown,S){super(C),this._message=C,this._code=v,this._detail=S,this.isHandled=v===w.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.$ol=p;function E(M){const C=M.indexOf("+");return C===-1?M:M.substring(0,C)}e.$pl=E}),define(Se[262],De([1,0,8,21,22,13,4,3,15,58,38,30,81,64]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.PersistentConnectionEventType=e.$wl=e.$vl=e.$ul=e.ConnectionType=void 0;const y=30*1e3;var u;(function(re){re[re.Management=1]="Management",re[re.ExtensionHost=2]="ExtensionHost",re[re.Tunnel=3]="Tunnel"})(u||(e.ConnectionType=u={}));function m(re){switch(re){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(re){const B=new L.$de;return setTimeout(()=>B.cancel(),re),B.token}function i(re,B){if(re.isCancellationRequested||B.isCancellationRequested)return L.CancellationToken.Cancelled;const ie=new L.$de;return re.onCancellationRequested(()=>ie.cancel()),B.onCancellationRequested(()=>ie.cancel()),ie.token}class n{get didTimeout(){return this.c==="timedout"}constructor(B){this.c="pending",this.d=new w.$Sc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,l.$_g)(),B.isCancellationRequested?this.h():this.d.add(B.onCancellationRequested(()=>this.h()))}registerDisposable(B){this.c==="pending"?this.d.add(B):B.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const B=new Error("Time limit reached");return B.code="ETIMEDOUT",B.syscall="connect",B}resolve(B){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(B))}reject(B){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(B))}}function r(re,B){const ie=new n(B);return ie.registerDisposable(re.onControlMessage(ke=>{const le=JSON.parse(ke.toString()),ue=Z(le);ue?ie.reject(ue):ie.resolve(le)})),ie.promise}function c(re,B,ie,ke,le,ue,ce,de){const H=new n(de),Y=M.$2d.create(!1);return re.info(`Creating a socket (${ce})...`),E.mark(`code/willCreateSocket/${ue}`),B.connect(ie,ke,le,ce).then(he=>{H.didTimeout?(E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) finished after ${Y.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(E.mark(`code/didCreateSocketOK/${ue}`),re.info(`Creating a socket (${ce}) was successful after ${Y.elapsed()} ms.`),H.resolve(he))},he=>{E.mark(`code/didCreateSocketError/${ue}`),re.info(`Creating a socket (${ce}) returned an error after ${Y.elapsed()} ms.`),re.error(he),H.reject(he)}),H.promise}function t(re,B){const ie=new n(B);return re.then(ke=>{ie.didTimeout||ie.resolve(ke)},ke=>{ie.didTimeout||ie.reject(ke)}),ie.promise}async function f(re,B,ie,ke){const le=ge(re,B);re.logService.trace(`${le} 1/6. invoking socketFactory.connect().`);let ue;try{ue=await c(re.logService,re.remoteSocketFactoryService,re.connectTo,p.$tg.getServerRootPath(),`reconnectionToken=${re.reconnectionToken}&reconnection=${re.reconnectionProtocol?"true":"false"}`,m(B),`renderer-${m(B)}-${re.reconnectionToken}`,ke)}catch(he){throw re.logService.error(`${le} socketFactory.connect() failed or timed out. Error:`),re.logService.error(he),he}re.logService.trace(`${le} 2/6. socketFactory.connect() was successful.`);let ce,de;re.reconnectionProtocol?(re.reconnectionProtocol.beginAcceptReconnection(ue,null),ce=re.reconnectionProtocol,de=!1):(ce=new v.$7h({socket:ue}),de=!0),re.logService.trace(`${le} 3/6. sending AuthRequest control message.`);const H=await t(re.signService.createNewMessage((0,C.$Cg)()),ke),Y={type:"auth",auth:re.connectionToken||"00000000000000000000",data:H.data};ce.sendControl(N.$te.fromString(JSON.stringify(Y)));try{const he=await r(ce,i(ke,o(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(re.logService.trace(`${le} 4/6. received SignRequest control message.`),!await t(re.signService.validate(H,he.signedData),ke)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const Pe=await t(re.signService.sign(he.data),ke),we={type:"connectionType",commit:re.commit,signedData:Pe,desiredConnectionType:B};return ie&&(we.args=ie),re.logService.trace(`${le} 5/6. sending ConnectionTypeRequest control message.`),ce.sendControl(N.$te.fromString(JSON.stringify(we))),{protocol:ce,ownsProtocol:de}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(re.logService.error(`${le} the handshake timed out. Error:`),re.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(re.logService.error(`${le} received error control message when negotiating connection. Error:`),re.logService.error(he)),de&&x(ce),he}}async function h(re,B,ie,ke){const le=Date.now(),ue=ge(re,B),{protocol:ce,ownsProtocol:de}=await f(re,B,ie,ke),H=new n(ke);return H.registerDisposable(ce.onControlMessage(Y=>{const he=JSON.parse(Y.toString()),be=Z(he);be?(re.logService.error(`${ue} received error control message when negotiating connection. Error:`),re.logService.error(be),de&&x(ce),H.reject(be)):(re.reconnectionProtocol?.endAcceptReconnection(),re.logService.trace(`${ue} 6/6. handshake finished, connection is up and running after ${se(le)}!`),H.resolve({protocol:ce,firstMessage:he}))})),H.promise}async function s(re,B){const{protocol:ie}=await h(re,1,void 0,B);return{protocol:ie}}async function a(re,B,ie){const{protocol:ke,firstMessage:le}=await h(re,2,B,ie),ue=le&&le.debugPort;return{protocol:ke,debugPort:ue}}async function d(re,B,ie){const ke=Date.now(),le=ge(re,3),{protocol:ue}=await f(re,3,B,ie);return re.logService.trace(`${le} 6/6. handshake finished, connection is up and running after ${se(ke)}!`),ue}async function $(re,B,ie){const{connectTo:ke,connectionToken:le}=await re.addressProvider.getAddress();return{commit:re.commit,quality:re.quality,connectTo:ke,connectionToken:le,reconnectionToken:B,reconnectionProtocol:ie,remoteSocketFactoryService:re.remoteSocketFactoryService,signService:re.signService,logService:re.logService}}async function D(re,B,ie){return g(re,async ke=>{const{protocol:le}=await s(ke,L.CancellationToken.None);return new G(re,B,ie,ke.reconnectionToken,le)})}e.$ul=D;async function b(re,B){return g(re,async ie=>{const{protocol:ke,debugPort:le}=await a(ie,B,L.CancellationToken.None);return new te(re,B,ie.reconnectionToken,ke,le)})}e.$vl=b;async function g(re,B){for(let ke=1;;ke++)try{const le=(0,C.$Cg)(),ue=await $(re,le,null);return await B(ue)}catch(le){if(ke<5)re.logService.error(`[remote-connection][attempt ${ke}] An error occurred in initial connection! Will retry... Error:`),re.logService.error(le);else throw re.logService.error(`[remote-connection][attempt ${ke}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),re.logService.error(le),j.triggerPermanentFailure(0,0,S.$ol.isHandled(le)),le}}async function k(re,B,ie){const ke=await $(re,(0,C.$Cg)(),null);return await d(ke,{host:B,port:ie},L.CancellationToken.None)}e.$wl=k;function P(re){return(0,l.$6g)(B=>new Promise((ie,ke)=>{const le=setTimeout(ie,re*1e3);B.onCancellationRequested(()=>{clearTimeout(le),ie()})}))}var F;(function(re){re[re.ConnectionLost=0]="ConnectionLost",re[re.ReconnectionWait=1]="ReconnectionWait",re[re.ReconnectionRunning=2]="ReconnectionRunning",re[re.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",re[re.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class U{constructor(B,ie){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.type=0}}e.$xl=U;class z{constructor(B,ie,ke,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.durationSeconds=ke,this.c=le,this.type=1}skipWait(){this.c.cancel()}}e.$yl=z;class T{constructor(B,ie,ke){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ke,this.type=2}}e.$zl=T;class I{constructor(B,ie,ke){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ke,this.type=4}}e.$Al=I;class O{constructor(B,ie,ke,le){this.reconnectionToken=B,this.millisSinceLastIncomingData=ie,this.attempt=ke,this.handled=le,this.type=3}}e.$Bl=O;class j extends w.$Tc{static triggerPermanentFailure(B,ie,ke){this._permanentFailure=!0,this.f=B,this.g=ie,this.h=ke,this.j.forEach(le=>le.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(B=>B.y())}static debugPauseSocketWriting(){this.j.forEach(B=>B.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||j._permanentFailure}constructor(B,ie,ke,le,ue){super(),this.t=B,this.u=ie,this.reconnectionToken=ke,this.protocol=le,this.w=ue,this.m=this.B(new R.$6d),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new I(this.reconnectionToken,0,0)),this.B(le.onSocketClose(ce=>{const de=_(this.t,this.reconnectionToken,!0);ce?ce.type===0?(this.u.logService.info(`${de} received socket close event (hadError: ${ce.hadError}).`),ce.error&&this.u.logService.error(ce.error)):(this.u.logService.info(`${de} received socket close event (wasClean: ${ce.wasClean}, code: ${ce.code}, reason: ${ce.reason}).`),ce.event&&this.u.logService.error(ce.event)):this.u.logService.info(`${de} received socket close event.`),this.y()})),this.B(le.onSocketTimeout(ce=>{const de=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${de} received socket timeout event (unacknowledgedMsgCount: ${ce.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ce.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ce.timeSinceLastReceivedSomeData}).`),this.y()})),j.j.push(this),this.B((0,w.$Rc)(()=>{const ce=j.j.indexOf(this);ce>=0&&j.j.splice(ce,1)})),this.n&&this.D(j.f,j.g,j.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const B=_(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ke=-1;do{ke++;const le=ke<ie.length?ie[ke]:ie[ie.length-1];try{if(le>0){const ce=P(le);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),le,ce)),this.u.logService.info(`${B} waiting for ${le} seconds before reconnecting...`);try{await ce}catch{}}if(this.n){this.u.logService.error(`${B} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ke+1)),this.u.logService.info(`${B} resolving connection...`);const ue=await $(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${B} connecting to ${ue.connectTo}...`),await this.G(ue,o(y)),this.u.logService.info(`${B} reconnected!`),this.m.fire(new I(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ke+1));break}catch(ue){if(ue.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${B} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ke+1,!1);break}if(ke>360){this.u.logService.error(`${B} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ke+1,!1);break}if(S.$ol.isTemporarilyNotAvailable(ue)){this.u.logService.info(`${B} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((ue.code==="ETIMEDOUT"||ue.code==="ENETUNREACH"||ue.code==="ECONNREFUSED"||ue.code==="ECONNRESET")&&ue.syscall==="connect"){this.u.logService.info(`${B} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if((0,A.$4)(ue)){this.u.logService.info(`${B} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ue);continue}if(ue instanceof S.$ol){this.u.logService.error(`${B} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ke+1,S.$ol.isHandled(ue));break}this.u.logService.error(`${B} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ue),this.C(this.protocol.getMillisSinceLastIncomingData(),ke+1,!1);break}}while(!this.n&&!this.s)}C(B,ie,ke){this.w?j.triggerPermanentFailure(B,ie,ke):this.D(B,ie,ke)}D(B,ie,ke){this.m.fire(new O(this.reconnectionToken,B,ie,ke)),x(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Cl=j;class G extends j{constructor(B,ie,ke,le,ue){super(1,B,le,ue,!0),this.client=this.B(new v.$5h(ue,{remoteAuthority:ie,clientId:ke},B.ipcLogger))}async G(B,ie){await s(B,ie)}}e.$Dl=G;class te extends j{constructor(B,ie,ke,le,ue){super(2,B,ke,le,!1),this.H=ie,this.debugPort=ue}async G(B,ie){await a(B,this.H,ie)}}e.$El=te;function x(re){try{re.acceptDisconnect();const B=re.getSocket();re.dispose(),B.dispose()}catch(B){(0,A.$1)(B)}}function Z(re){if(re&&re.type==="error"){const B=new Error(`Connection error: ${re.reason}`);return B.code="VSCODE_CONNECTION_ERROR",B}return null}function X(re,B){for(;re.length<B;)re+=" ";return re}function ae(re,B){return`[remote-connection][${X(m(re),13)}][${B.substr(0,5)}\u2026]`}function _(re,B,ie){return`${ae(re,B)}[${ie?"reconnect":"initial"}]`}function ge(re,B){return`${_(B,re.reconnectionToken,!!re.reconnectionProtocol)}[${re.connectTo}]`}function se(re){return`${Date.now()-re} ms`}}),define(Se[86],De([1,0,15]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tm=e.$sm=e.$rm=e.$qm=void 0;function N(p){return p.scheme===l.Schemas.vscodeRemote?p.authority:void 0}e.$qm=N;function L(p){if(!p)return;const E=p.indexOf("+");return E<0?p:p.substr(0,E)}e.$rm=L;function A(p){const{host:E,port:M}=w(p);if(typeof M>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:M}}e.$sm=A;function R(p,E){let{host:M,port:C}=w(p);return typeof C>"u"&&(C=E),{host:M,port:C}}e.$tm=R;function w(p){const E=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const M=p.match(/^(\[[0-9a-z:]+\])$/);if(M)return{host:M[1],port:void 0};const C=p.match(/(.*):(\d+)$/);return C?{host:C[1],port:parseInt(C[2],10)}:{host:p,port:void 0}}}),define(Se[25],De([1,0,14,5,86]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.TargetPlatform=e.ExtensionType=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=void 0,e.$um="extensions.user.cache",e.$vm="extensions.builtin.cache",e.$wm="undefined_publisher",e.$xm=["ui","workspace","web"];function A(u){if(typeof u=="object"&&u!==null&&u.supported!==!0)return u.description}e.$ym=A,e.$zm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(u){u[u.System=0]="System",u[u.User=1]="User"})(R||(e.ExtensionType=R={}));var w;(function(u){u.WIN32_X64="win32-x64",u.WIN32_ARM64="win32-arm64",u.LINUX_X64="linux-x64",u.LINUX_ARM64="linux-arm64",u.LINUX_ARMHF="linux-armhf",u.ALPINE_X64="alpine-x64",u.ALPINE_ARM64="alpine-arm64",u.DARWIN_X64="darwin-x64",u.DARWIN_ARM64="darwin-arm64",u.WEB="web",u.UNIVERSAL="universal",u.UNKNOWN="unknown",u.UNDEFINED="undefined"})(w||(e.TargetPlatform=w={}));class p{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,o){if(typeof m>"u"||m===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof m=="string"||typeof o=="string"){const i=typeof m=="string"?m:m.value,n=typeof o=="string"?o:o.value;return l.$kf(i,n)}return m._lower===o._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Am=p;class E{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const o of m)this.add(o)}add(m){this.c.add(p.toKey(m))}delete(m){return this.c.delete(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}}e.$Bm=E;class M{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(p.toKey(m))}get(m){return this.c.get(p.toKey(m))}has(m){return this.c.has(p.toKey(m))}set(m,o){this.c.set(p.toKey(m),o)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Cm=M;function C(u){return v(u)}e.$Dm=C;function v(u){return u.contributes&&u.contributes.localizations?u.contributes.localizations.length>0:!1}e.$Em=v;function S(u){return u.contributes&&u.contributes.authentication?u.contributes.authentication.length>0:!1}e.$Fm=S;function y(u,m){if(m){const o=`onResolveRemoteAuthority:${(0,L.$rm)(m)}`;return!!u.activationEvents?.includes(o)}return!1}e.$Gm=y,e.$Hm=(0,N.$gi)("IBuiltinExtensionsScannerService")}),define(Se[140],De([1,0,13,25]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FF=e.$EF=void 0;class L{constructor(){this.a=new Map,this.b=new WeakMap}register(R,w){this.a.set(R,w)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const w=Object.create(null);for(const p of R){const E=this.readActivationEvents(p);E.length>0&&(w[N.$Am.toKey(p.identifier)]=E)}return w}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const w=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let p=0;p<w.length;p++)w[p]==="onUri"&&(w[p]=`onUri:${N.$Am.toKey(R.identifier)}`);if(!R.contributes)return w;for(const p in R.contributes){const E=this.a.get(p);if(!E)continue;const M=R.contributes[p],C=Array.isArray(M)?M:[M];try{E(C,w)}catch(v){(0,l.$1)(v)}}return w}}e.$EF=L,e.$FF=new L}),define(Se[263],De([1,0,3,5]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0,e.$ql=(0,N.$gi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(R,w){return this.a[R]??=[],this.a[R].push(w),(0,l.$Rc)(()=>{const p=this.a[R]?.indexOf(w);typeof p=="number"&&p>=0&&this.a[R]?.splice(p,1)})}b(R){return(this.a[R.type]||[]).find(p=>p.supports(R))}connect(R,w,p,E){const M=this.b(R);if(!M)throw new Error(`No socket factory found for ${R}`);return M.connect(R,w,p,E)}}e.$rl=L}),define(Se[264],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$28b=void 0;class l{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const R=String(l.a++);return this.b.set(R,A),{id:R,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const R=this.b.get(L.id);if(!R)return!1;this.b.delete(L.id);try{return R.validate(A)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$28b=l}),define(Se[110],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=void 0,e.$sl="signService",e.$tl=(0,l.$gi)(e.$sl)}),define(Se[141],De([1,0,264]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vac=void 0;class N extends l.$28b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(R=>new R.signer().sign(A))}h(){return new Promise((A,R)=>fe(["vsda"],A,R))}}e.$Vac=N}),define(Se[265],De([1,0,11,50,30]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=void 0;function A(p){if(l.$u===2&&/^penguin(\.|$)/i.test(p))return"chromebook"}function R(p,E,M,C,v,S,y,u,m){const o=Object.create(null);o["common.machineId"]=S,o["common.sqmId"]=y,o.sessionID=(0,L.$Cg)()+Date.now(),o.commitHash=C,o.version=v,o["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,l.$h)(l.$u),o["common.nodePlatform"]=N.$dc,o["common.nodeArch"]=M,o["common.product"]=m||"desktop",u&&(o["common.msftInternal"]=u);let i=0;const n=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),l.$l&&(o["common.snap"]="true");const r=A(E);return r&&(o["common.platformDetail"]=r),o}e.$Yo=R;function w(p){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const M=E.toLowerCase();return p.some(C=>M===C)}e.$Zo=w}),define(Se[266],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Pl=e.$Ol=e.$Nl=e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=void 0,e.$Fl=(0,l.$gi)("telemetryService"),e.$Gl=(0,l.$gi)("customEndpointTelemetryService"),e.$Hl="telemetry.currentSessionDate",e.$Il="telemetry.firstSessionDate",e.$Jl="telemetry.lastSessionDate",e.$Kl="telemetry.machineId",e.$Ll="telemetry.sqmId",e.$Ml="telemetry",e.$Nl="telemetry.telemetryLevel",e.$Ol="telemetry.enableCrashReporter",e.$Pl="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(Se[87],De([1,0,24,18,86,265,266]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;class w{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$1o=w;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$2o=p,e.$3o=new p;class E{async publicLog(f,h,s){}async publicLogError(f,h,s){}}e.$4o=E,e.$5o="telemetry",e.$6o="extensionTelemetryLog",e.$7o={log:()=>null,flush:()=>Promise.resolve(null)};function M(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}e.$8o=M;function C(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$9o=C;function v(t){const f=t.getValue(R.$Nl),h=t.getValue(R.$Ol);if(t.getValue(R.$Pl)===!1||h===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0o=v;function S(t){const f={},h={},s={};m(t,s);for(let a in s){a=a.length>150?a.substr(a.length-149):a;const d=s[a];typeof d=="number"?h[a]=d:typeof d=="boolean"?h[a]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${d.length}`),f[a]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(f[a]=d)}return{properties:f,measurements:h}}e.$$o=S;const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(t){if(!t)return"none";const f=(0,L.$rm)(t);return y.has(f)?f:"other"}e.$_o=u;function m(t,f,h=0,s){if(t)for(const a of Object.getOwnPropertyNames(t)){const d=t[a],$=s?s+a:a;Array.isArray(d)?f[$]=(0,l.$Qn)(d):d instanceof Date?f[$]=d.toISOString():(0,N.$Vf)(d)?h<2?m(d,f,h+1,$+"."):f[$]=(0,l.$Qn)(d):f[$]=d}}function o(t,f){const h=t.msftInternalDomains||[],s=f.getValue("telemetry.internalTesting");return(0,A.$Zo)(h)||s}e.$ap=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$bp=i;function n(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const s=[];for(const D of f)for(;;){const b=D.exec(t);if(!b)break;s.push([b.index,D.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(h="";;){const D=d.exec(t);if(!D)break;const b=s.some(([g,k])=>D.index<k&&g<d.lastIndex);!a.test(D[0])&&!b&&(h+=t.substring($,D.index)+"<REDACTED: user-file-path>",$=d.lastIndex)}return $<t.length&&(h+=t.substr($)),h}function r(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of f)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function c(t,f){return(0,l.$Nn)(t,h=>{if(h instanceof w||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let s=h.replaceAll("%20"," ");s=n(s,f);for(const a of f)s=s.replace(a,"");return s=r(s),s}})}e.$cp=c}),define(Se[267],De([1,0,14,137,25,11,2,13,50,87]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=void 0;function M(h,s){return h.uuid&&s.uuid?h.uuid===s.uuid:h.id===s.id?!0:(0,l.$ff)(h.id,s.id)===0}e.$dp=M;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(s){const a=s.manifest?s.manifest.version:s.version,d=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new v(s.identifier,a,d)}static parse(s){const a=C.exec(s);return a&&a[1]&&a[2]?new v({id:a[1]},a[2],a[4]||void 0):null}constructor(s,a,d="undefined"){this.version=a,this.targetPlatform=d,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof v?M(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$ep=v;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(h){const s=S.exec(h);return s&&s[1]?[m(s[1]),s[2]]:[m(h),void 0]}e.$fp=y;function u(h,s){return`${h}.${s}`}e.$gp=u;function m(h){return h.toLowerCase()}e.$hp=m;function o(h,s){return m(u(h??L.$wm,s))}e.$ip=o;function i(h,s){const a=[],d=$=>{for(const D of a)if(D.some(b=>M(s(b),s($))))return D;return null};for(const $ of h){const D=d($);D?D.push($):a.push([$])}return a}e.$jp=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.$kp=n;function r(h){return{id:new E.$1o(h.identifier.id),name:new E.$1o(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$lp=r,e.$mp=new L.$Am("pprice.better-merge");function c(h,s){const a=[],d=s.manifest.extensionDependencies?.slice(0)??[];for(;d.length;){const $=d.shift();if($&&a.every(D=>!M(D.identifier,{id:$}))){const D=h.filter(b=>M(b.identifier,{id:$}));D.length===1&&(a.push(D[0]),d.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return a}e.$np=c;async function t(h,s){if(!A.$k)return!1;let a;try{a=(await h.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{a=(await h.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch($){s.debug("Error while getting the os-release file.",(0,w.$0)($))}}return!!a&&(a.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(h,s){const a=await t(h,s),d=(0,N.$Ko)(a?"alpine":A.$u,p.$ec);return s.debug("ComputeTargetPlatform:",d),d}e.$op=f}),define(Se[268],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=e.$6r=e.$5r=e.$4r=e.$3r=e.$2r=void 0;function l(p){return[...p.entries()]}e.$2r=l;function N(p){return p?[...p.entries()]:[]}e.$3r=N;function L(p){return new Map(p)}e.$4r=L;function A(p){return new Map(p??[])}e.$5r=A;function R(p){return Array.from(p.entries()).map(E=>[E[0],l(E[1].map),N(E[1].descriptionMap)])}e.$6r=R;function w(p){return new Map(p.map(E=>[E[0],{map:L(E[1]),descriptionMap:A(E[2])}]))}e.$7r=w}),define(Se[269],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qtb=void 0;class l{constructor(L){this.b=L,this.a=new Map}dispose(){for(const L of this.a.values())L.dispose()}startBuffering(L,A,R=5){const w=A(p=>{const E=typeof p=="string"?p:p.data;let M=this.a.get(L);if(M){M.data.push(E);return}const C=setTimeout(()=>this.flushBuffer(L),R);M={data:[E],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(L),w.dispose()}},this.a.set(L,M)});return w}stopBuffering(L){this.a.get(L)?.dispose()}flushBuffer(L){const A=this.a.get(L);A&&(this.a.delete(L),this.b(L,A.data.join("")))}}e.$Qtb=l}),define(Se[270],De([1,0,8,77,99,55,4,18,2,212,109,37]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uw=e.$Tw=e.$Sw=e.$Rw=e.$Qw=e.$Pw=e.$Ow=e.$Nw=e.IconFontDefinition=e.IconContribution=e.$Mw=void 0,e.$Mw={IconContribution:"base.contributions.icons"};var v;(function(c){function t(f,h){let s=f.defaults;for(;A.ThemeIcon.isThemeIcon(s);){const a=u.getIcon(s.id);if(!a)return;s=a.defaults}return s}c.getDefinition=t})(v||(e.IconContribution=v={}));var S;(function(c){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}c.toJSONObject=t;function f(h){const s=a=>(0,w.$Tf)(a)?a:void 0;if(h&&Array.isArray(h.src)&&h.src.every(a=>(0,w.$Tf)(a.format)&&(0,w.$Tf)(a.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(a=>({format:a.format,location:p.URI.parse(a.location)}))}}c.fromJSONObject=f})(S||(e.IconFontDefinition=S={}));class y{constructor(){this.a=new R.$6d,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${A.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,f,h,s){const a=this.b[t];if(a){if(h&&!a.description){a.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const D=this.e.enum.indexOf(t);D!==-1&&(this.e.enumDescriptions[D]=h),this.a.fire()}return a}const d={id:t,description:h,defaults:f,deprecationMessage:s};this.b[t]=d;const $={$ref:"#/definitions/icons"};return s&&($.deprecationMessage=s),h&&($.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=$,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const f=this.e.enum.indexOf(t);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,f){const h=this.f[t];return h||(this.f[t]=f,this.a.fire(),f)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(a,d)=>a.id.localeCompare(d.id),f=a=>{for(;A.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(a=>this.b[a]);for(const a of s.filter(d=>!!d.description).sort(t))h.push(`|<i class="${f(a)}"></i>|${a.id}|${A.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const a of s.filter(d=>!A.ThemeIcon.isThemeIcon(d.defaults)).sort(t))h.push(`|<i class="${f(a)}"></i>|${a.id}|`);return h.join(`
`)}}const u=new y;C.$Xn.add(e.$Mw.IconContribution,u);function m(c,t,f,h){return u.registerIcon(c,t,f,h)}e.$Nw=m;function o(){return u}e.$Ow=o;function i(){const c=(0,L.$lk)();for(const t in c){const f="\\"+c[t].toString(16);u.registerIcon(t,{fontCharacter:f})}}i(),e.$Pw="vscode://schemas/icons";const n=C.$Xn.as(M.$Yn.JSONContribution);n.registerSchema(e.$Pw,u.getIconSchema());const r=new l.$sh(()=>n.notifySchemaChanged(e.$Pw),200);u.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Qw=m("widget-close",N.$pk.close,(0,E.localize)(2,null)),e.$Rw=m("goto-previous-location",N.$pk.arrowUp,(0,E.localize)(3,null)),e.$Sw=m("goto-next-location",N.$pk.arrowDown,(0,E.localize)(4,null)),e.$Tw=A.ThemeIcon.modify(N.$pk.sync,"spin"),e.$Uw=A.ThemeIcon.modify(N.$pk.loading,"spin")}),define(Se[88],De([1,0,4,52,5,12]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=e.$Uv=e.$Tv=e.ProvidedOnAutoForward=e.$Sv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Rv=e.$Qv=void 0,e.$Qv=(0,L.$gi)("tunnelService"),e.$Rv=(0,L.$gi)("sharedTunnelsService");var R;(function(m){m.Http="http",m.Https="https"})(R||(e.TunnelProtocol=R={}));var w;(function(m){m.ConstantPrivate="constantPrivate",m.Private="private",m.Public="public"})(w||(e.TunnelPrivacyId=w={}));function p(m){return!!m.forwardPort}e.$Sv=p;var E;(function(m){m[m.Notify=1]="Notify",m[m.OpenBrowser=2]="OpenBrowser",m[m.OpenPreview=3]="OpenPreview",m[m.Silent=4]="Silent",m[m.Ignore=5]="Ignore",m[m.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function M(m){if(m.scheme!=="http"&&m.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(m.authority);if(o)return{address:o[1],port:+o[2]}}e.$Tv=M,e.$Uv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(m){return e.$Uv.indexOf(m)>=0}e.$Vv=C,e.$Wv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(m){return e.$Wv.indexOf(m)>=0}e.$Xv=v;function S(m,o,i,n){if(i===1)return!1;if(i===2&&v(o)){const r=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(r?.length===4&&parseInt(r[1])>=18)return!1}return m<1024}e.$Yv=S;class y{constructor(o,i,n){this.remoteAddress=o,this.localAddress=i,this.b=n,this.a=new l.$6d,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Zv=y;let u=class{constructor(o,i){this.k=o,this.l=i,this.a=new l.$6d,this.onTunnelOpened=this.a.event,this.b=new l.$6d,this.onTunnelClosed=this.b.event,this.c=new l.$6d,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const n of i){const r=Array.from(n.values());for(const c of r){const t=await c.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,n,r,c){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:n,privacy:r,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(v(o)||C(o))&&(o=e.$Uv[0]);const n=this.s(o,i);if(n)return++n.refcount,n.value}openTunnel(o,i,n,r,c,t=!1,f,h){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${c}.`);const s=this.f??o;if(!s)return;if(i||(i="localhost"),r||(r=this.m),this.f&&this.j.has(n)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(s,i,n,r,c,t,f,h);return a?a.then(d=>{if(d){if(typeof d=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,n),d}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,n);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const $=this.o(d);return(d.tunnelRemoteHost!==i||d.tunnelRemotePort!==n)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),f&&d.privacy!==f&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire($),$}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const n=i.get(o.tunnelRemotePort);n&&(n.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,n))}}}}async p(o,i,n){if(n.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const r=n.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),r}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const n=this.e.get(o);if(n&&n.has(i)){const r=n.get(i);r.refcount=0,await this.p(o,i,r)}}q(o,i,n){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:n})}async r(o,i){const n=this.e.get(o);if(n){const r=n.get(i),c=r?await r.value:void 0;(!c||typeof c=="string")&&n.delete(i),n.size===0&&this.e.delete(o)}}s(o,i){const n=[o];C(o)?(n.push(...e.$Uv),n.push(...e.$Wv)):v(o)&&n.push(...e.$Wv);const r=n.map(c=>this.e.get(c));for(const c of r){const t=c?.get(i);if(t)return t}}canTunnel(o){return!!M(o)}u(o,i,n,r,c,t,f){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${r}.`);const h=n;this.j.add(h);const s=r===void 0?n:r,a={elevationRequired:c?this.isPortPrivileged(s):!1},d={remoteAddress:{host:i,port:n},localAddressPort:r,privacy:t,public:t?t!==w.Private:void 0,protocol:f},$=o.forwardPort(d,a);return $?(this.q(i,n,$),$.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(h)})):this.j.delete(h),$}};e.$1v=u,e.$1v=u=Qe([Ve(0,A.$Aj),Ve(1,N.$Mi)],u)}),define(Se[271],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=void 0,e.$el=(0,l.$gi)("IUriIdentityService")}),define(Se[272],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$2v=void 0,e.$2v=(0,l.$gi)("editSessionIdentityService");var N;(function(L){L[L.Complete=100]="Complete",L[L.Partial=50]="Partial",L[L.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Se[273],De([1,0,15]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=void 0;function N(p){return p.scheme!==l.Schemas.file&&p.scheme!==l.Schemas.vscodeRemote}e.$GL=N;function L(p){if(p.folders.length)return p.folders.every(E=>N(E.uri))?p.folders[0].uri:void 0;if(p.configuration&&N(p.configuration))return p.configuration}e.$HL=L;function A(p){return L(p)?.scheme}e.$IL=A;function R(p){return L(p)?.authority}e.$JL=R;function w(p){return L(p)!==void 0}e.$KL=w}),define(Se[40],De([1,0,214,17,76,23,2,5,15]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.WorkbenchState=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0,e.$pi=(0,w.$gi)("contextService");function E(s){const a=s;return typeof a?.id=="string"&&R.URI.isUri(a.uri)}e.$qi=E;function M(s){return typeof s?.id=="string"&&!E(s)&&!v(s)}e.$ri=M,e.$si={id:"ext-dev"},e.$ti={id:"empty-window"};function C(s,a){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$nc)(s)}:a?e.$si:e.$ti;const d=s;return d.configuration?{id:d.id,configPath:d.configuration}:d.folders.length===1?{id:d.id,uri:d.folders[0].uri}:{id:d.id}}e.$ui=C;function v(s){const a=s;return typeof a?.id=="string"&&R.URI.isUri(a.configPath)}e.$vi=v;function S(s){const a=s;if(a?.uri)return{id:a.id,uri:R.URI.revive(a.uri)};const d=s;if(d?.configPath)return{id:d.id,configPath:R.URI.revive(d.configPath)};if(s?.id)return{id:s.id}}e.$wi=S;var y;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function u(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&Array.isArray(a.folders))}e.$xi=u;function m(s){const a=s;return!!(a&&typeof a=="object"&&R.URI.isUri(a.uri)&&typeof a.name=="string"&&typeof a.toResource=="function")}e.$yi=m;class o{constructor(a,d,$,D,b){this.h=a,this.j=$,this.k=D,this.l=b,this.c=L.$mi.forUris(this.l,()=>!0),this.folders=d}update(a){this.h=a.id,this.k=a.configuration,this.j=a.transient,this.l=a.l,this.folders=a.folders}get folders(){return this.g}set folders(a){this.g=a,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(a){this.k=a}getFolder(a){return a&&this.c.findSubstr(a)||null}n(){this.c=L.$mi.forUris(this.l,()=>!0);for(const a of this.folders)this.c.set(a.uri,a)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$zi=o;class i{constructor(a,d){this.raw=d,this.uri=a.uri,this.index=a.index,this.name=a.name}toResource(a){return(0,A.$Tg)(this.uri,a)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ai=i;function n(s){return new i({uri:s,index:0,name:(0,A.$Pg)(s)},{uri:s.toString()})}e.$Bi=n,e.$Ci="code-workspace",e.$Di=`.${e.$Ci}`,e.$Ei=[{name:(0,l.localize)(0,null),extensions:[e.$Ci]}],e.$Fi="workspace.json";function r(s,a){return A.$Kg.isEqualOrParent(s,a.untitledWorkspacesHome)}e.$Gi=r;function c(s){let a;return R.URI.isUri(s)?a=s:a=s.configuration,a?.scheme===p.Schemas.tmp}e.$Hi=c,e.$Ii="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Ii}e.$Ji=t;function f(s,a){return!r(s,a)&&!c(s)}e.$Ki=f;function h(s){return(typeof s=="string"?(0,N.$oc)(s):(0,A.$Rg)(s))===e.$Di}e.$Li=h}),define(Se[274],De([1,0,54,4,3,23,2,213,136,32,5,12,40,28,271,8,30,14,18]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.ProfileResourceType=void 0;var n;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function r(s){const a=s;return!!(a&&typeof a=="object"&&typeof a.id=="string"&&typeof a.isDefault=="boolean"&&typeof a.name=="string"&&R.URI.isUri(a.location)&&R.URI.isUri(a.globalStorageHome)&&R.URI.isUri(a.settingsResource)&&R.URI.isUri(a.keybindingsResource)&&R.URI.isUri(a.tasksResource)&&R.URI.isUri(a.snippetsHome)&&R.URI.isUri(a.extensionsResource))}e.$fl=r,e.$gl=(0,M.$gi)("IUserDataProfilesService");function c(s,a){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:R.URI.revive(s.location).with({scheme:a}),globalStorageHome:R.URI.revive(s.globalStorageHome).with({scheme:a}),settingsResource:R.URI.revive(s.settingsResource).with({scheme:a}),keybindingsResource:R.URI.revive(s.keybindingsResource).with({scheme:a}),tasksResource:R.URI.revive(s.tasksResource).with({scheme:a}),snippetsHome:R.URI.revive(s.snippetsHome).with({scheme:a}),extensionsResource:R.URI.revive(s.extensionsResource).with({scheme:a}),cacheHome:R.URI.revive(s.cacheHome).with({scheme:a}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$hl=c;function t(s,a,d,$,D,b){return{id:s,name:a,location:d,isDefault:!1,shortName:D?.shortName,icon:D?.icon,globalStorageHome:b&&D?.useDefaultFlags?.globalState?b.globalStorageHome:(0,A.$Tg)(d,"globalStorage"),settingsResource:b&&D?.useDefaultFlags?.settings?b.settingsResource:(0,A.$Tg)(d,"settings.json"),keybindingsResource:b&&D?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,A.$Tg)(d,"keybindings.json"),tasksResource:b&&D?.useDefaultFlags?.tasks?b.tasksResource:(0,A.$Tg)(d,"tasks.json"),snippetsHome:b&&D?.useDefaultFlags?.snippets?b.snippetsHome:(0,A.$Tg)(d,"snippets"),extensionsResource:b&&D?.useDefaultFlags?.extensions?b.extensionsResource:(0,A.$Tg)(d,"extensions.json"),cacheHome:(0,A.$Tg)($,s),useDefaultFlags:D?.useDefaultFlags,isTransient:D?.transient}}e.$il=t;let f=class extends L.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(a,d,$,D){super(),this.t=a,this.u=d,this.w=$,this.y=D,this.f=!0,this.h=this.B(new N.$6d),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$6d),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$6d),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$6d),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Tg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Tg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(a){this.f!==a&&(this.z=void 0,this.f=a)}isEnabled(){return this.f}get C(){if(!this.z){const a=this.D(),d=[a];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,i.$Tf)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}d.push(t((0,A.$Qg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},a))}}catch(b){this.y.error(b)}const $=new S.$Ac,D=new Map;if(d.length)try{const b=this.Q();if(b.workspaces)for(const[g,k]of Object.entries(b.workspaces)){const P=R.URI.parse(g),F=d.find(U=>U.id===k);F&&$.set(P,F)}if(b.emptyWindows)for(const[g,k]of Object.entries(b.emptyWindows)){const P=d.find(F=>F.id===k);P&&D.set(g,P)}}catch(b){this.y.error(b)}this.z={profiles:d,workspaces:$,emptyWindows:D}}return this.z}D(){const a=t("__default__profile__",(0,w.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...a,extensionsResource:this.S()??a.extensionsResource,isDefault:!0}}async createTransientProfile(a){const d="Temp",$=new RegExp(`${(0,o.$Ye)(d)}\\s(\\d+)`);let D=0;for(const g of this.profiles){const k=$.exec(g.name),P=k?parseInt(k[1]):0;D=P>D?P:D}const b=`${d} ${D+1}`;return this.createProfile((0,l.$7i)((0,m.$Cg)()).toString(16),b,{transient:!0},a)}async createNamedProfile(a,d,$){return this.createProfile((0,l.$7i)((0,m.$Cg)()).toString(16),a,d,$)}async createProfile(a,d,$,D){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(a,d,$);return D&&await this.setProfileForWorkspace(D,b),b}async F(a,d,$){if(!(0,i.$Tf)(d)||!d)throw new Error("Name of the profile is mandatory and must be of type `string`");let D=this.r.get(d);return D||(D=(async()=>{try{const b=this.profiles.find(P=>P.name===d||P.id===a);if(b)return b;const g=t(a,d,(0,A.$Tg)(this.profilesHome,a),this.g,$,this.defaultProfile);await this.u.createFolder(g.location);const k=[];return this.j.fire({profile:g,join(P){k.push(P)}}),await u.Promises.settled(k),this.I([g],[],[]),g}finally{this.r.delete(d)}})(),this.r.set(d,D)),D}async updateProfile(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(D=>D.id===a.id);if(!$)throw new Error(`Profile '${a.name}' does not exist`);return $=t($.id,d.name??$.name,$.location,this.g,{shortName:d.shortName??$.shortName,icon:d.icon===null?void 0:d.icon??$.icon,transient:d.transient??$.isTransient,useDefaultFlags:d.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(a.isDefault)throw new Error("Cannot remove default profile");const d=this.profiles.find(D=>D.id===a.id);if(!d)throw new Error(`Profile '${a.name}' does not exist`);const $=[];this.m.fire({profile:d,join(D){$.push(D)}});try{await Promise.allSettled($)}catch(D){this.y.error(D)}for(const D of[...this.C.emptyWindows.keys()])d.id===this.C.emptyWindows.get(D)?.id&&this.C.emptyWindows.delete(D);for(const D of[...this.C.workspaces.keys()])d.id===this.C.workspaces.get(D)?.id&&this.C.workspaces.delete(D);this.M(),this.I([],[d],[]);try{await this.u.del(d.cacheHome,{recursive:!0})}catch(D){(0,E.$Xk)(D)!==1&&this.y.error(D)}}async setProfileForWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(D=>D.id===d.id);if(!$)throw new Error(`Profile '${d.name}' does not exist`);this.L(a,$)}unsetWorkspace(a,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(a,void 0,d)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const a=await this.u.resolve(this.profilesHome);await Promise.all((a.children||[]).filter(d=>d.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,d.resource))).map(d=>this.u.del(d.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const a=this.s.profiles.filter(d=>!this.H(d));await Promise.allSettled(a.map(d=>this.removeProfile(d)))}getProfileForWorkspace(a){const d=this.G(a);return R.URI.isUri(d)?this.s.workspaces.get(d)??this.C.workspaces.get(d):this.s.emptyWindows.get(d)??this.C.emptyWindows.get(d)}G(a){return(0,v.$qi)(a)?a.uri:(0,v.$vi)(a)?a.configPath:a.id}H(a){return!!([...this.s.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.s.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.emptyWindows.values()].some(d=>this.w.extUri.isEqual(d.location,a.location))||[...this.C.workspaces.values()].some(d=>this.w.extUri.isEqual(d.location,a.location)))}I(a,d,$){const D=[...this.profiles,...a],b=[];this.s.profiles=[];for(let g of D)g.isDefault||d.some(k=>g.id===k.id)||(g=$.find(k=>g.id===k.id)??g,g.isTransient?this.s.profiles.push(g):b.push({location:g.location,name:g.name,shortName:g.shortName,icon:g.icon,useDefaultFlags:g.useDefaultFlags}));this.P(b),this.z=void 0,this.J(a,d,$)}J(a,d,$){this.h.fire({added:a,removed:d,updated:$,all:this.profiles})}L(a,d,$){$=d?.isTransient?!0:$,$||this.L(a,void 0,!0);const D=this.G(a),b=$?this.s:this.C;R.URI.isUri(D)?(b.workspaces.delete(D),d&&b.workspaces.set(D,d)):(b.emptyWindows.delete(D),d&&b.emptyWindows.set(D,d)),$||this.M()}M(){const a={};for(const[$,D]of this.C.workspaces.entries())a[$.toString()]=D.id;const d={};for(const[$,D]of this.C.emptyWindows.entries())d[$.toString()]=D.id;this.R({workspaces:a,emptyWindows:d}),this.z=void 0}N(a){const d={},$=this.D();if(a.workspaces)for(const[b,g]of Object.entries(a.workspaces)){const k=R.URI.parse(g);d[b]=this.w.extUri.isEqual(k,$.location)?$.id:this.w.extUri.basename(k)}const D={};if(a.emptyWindows)for(const[b,g]of Object.entries(a.emptyWindows)){const k=R.URI.parse(g);D[b]=this.w.extUri.isEqual(k,$.location)?$.id:this.w.extUri.basename(k)}return{workspaces:d,emptyWindows:D}}O(){return[]}P(a){throw new Error("not implemented")}Q(){return{}}R(a){throw new Error("not implemented")}S(){}};e.$jl=f,e.$jl=f=Qe([Ve(0,p.$ni),Ve(1,E.$Gk),Ve(2,y.$el),Ve(3,C.$Aj)],f);class h extends f{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(a){this.a=a}Q(){return this.X}R(a){this.X=a}}e.$kl=h}),define(Se[275],De([1,0,8,4,3,58,18,193,5,274]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=e.$Mp=e.$Lp=e.$Kp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Jp=e.$Ip=e.$Hp=void 0,e.$Hp="__$__isNewStorageMarker",e.$Ip="__$__targetStorageMarker",e.$Jp=(0,p.$gi)("storageService");var M;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(M||(e.WillSaveStateReason=M={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var v;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function S(i){const n=i.get(e.$Ip);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$Kp=S;class y extends L.$Tc{static{this.a=60*1e3}constructor(n={flushInterval:y.a}){super(),this.m=n,this.b=this.B(new N.$9d),this.c=this.B(new N.$9d),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$6d),this.onWillSaveState=this.f.event,this.h=this.B(new l.$sh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,r,c){return N.Event.filter(this.b.event,t=>t.scope===n&&(r===void 0||t.key===r),c)}n(){this.j.value=(0,l.$wh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,r){const{key:c,external:t}=r;if(c===e.$Ip){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:c,target:this.J(n)[c],external:t})}w(n){this.f.fire({reason:n})}get(n,r,c){return this.P(r)?.get(n,c)}getBoolean(n,r,c){return this.P(r)?.getBoolean(n,c)}getNumber(n,r,c){return this.P(r)?.getNumber(n,c)}getObject(n,r,c){return this.P(r)?.getObject(n,c)}storeAll(n,r){this.y(()=>{for(const c of n)this.store(c.key,c.value,c.scope,c.target,r)})}store(n,r,c,t,f=!1){if((0,R.$3f)(r)){this.remove(n,c,f);return}this.y(()=>{this.z(n,c,t),this.P(c)?.set(n,r,f)})}remove(n,r,c=!1){this.y(()=>{this.z(n,r,void 0),this.P(r)?.delete(n,c)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,r){const c=[],t=this.J(n);for(const f of Object.keys(t))t[f]===r&&c.push(f);return c}z(n,r,c,t=!1){const f=this.J(r);typeof c=="number"?f[n]!==c&&(f[n]=c,this.P(r)?.set(e.$Ip,JSON.stringify(f),t)):typeof f[n]=="number"&&(delete f[n],this.P(r)?.set(e.$Ip,JSON.stringify(f),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const r=this.P(n);return r?S(r):Object.create(null)}isNew(n){return this.getBoolean(e.$Hp,n)===!0}async flush(n=M.NONE){this.f.fire({reason:n});const r=this.P(-1),c=this.P(0),t=this.P(1);switch(n){case M.NONE:await l.Promises.settled([r?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case M.SHUTDOWN:await l.Promises.settled([r?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,r=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return o(n,r,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,r){return this.w(M.NONE),(0,E.$fl)(n)?this.R(n,r):this.S(n,r)}M(n,r){return!(n.id===r.id||u(r)&&u(n))}N(n,r,c){this.y(()=>{const t=new Set;for(const[f,h]of n)t.add(f),r.get(f)!==h&&this.u(c,{key:f,external:!0});for(const[f]of r.items)t.has(f)||this.u(c,{key:f,external:!0})})}}e.$Lp=y;function u(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$Mp=u;class m extends y{constructor(){super(),this.U=this.B(new w.$Fp(new w.$Gp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new w.$Fp(new w.$Gp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new w.$Fp(new w.$Gp,{hint:w.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$Np=m;async function o(i,n,r,c,t,f){const h=P=>{try{return JSON.parse(P)}catch{return P}},s=new Map,a=new Map;i.forEach((P,F)=>{s.set(F,P),a.set(F,h(P))});const d=new Map,$=new Map;n.forEach((P,F)=>{d.set(F,P),$.set(F,h(P))});const D=new Map,b=new Map;r.forEach((P,F)=>{D.set(F,P),b.set(F,h(P))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const g=[];if(s.forEach((P,F)=>{g.push({key:F,value:P})}),console.table(g),console.groupEnd(),console.log(a),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];d.forEach((F,U)=>{P.push({key:U,value:F})}),console.table(P),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${f})`);const k=[];D.forEach((P,F)=>{k.push({key:F,value:P})}),console.table(k),console.groupEnd(),console.log(b)}e.$Op=o}),define(Se[111],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class l{static{this.a=!1}constructor(L){this.d=L,this.b=new Map,this.c=1}add(L){const A=this.c++;return this.b.set(A,L),this.e(),A}get(L,A){return this.b.has(L)?this.b.get(L)[A]:void 0}delete(L){this.b.delete(L),this.e()}e(){l.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$1hc=l}),define(Se[59],De([1,0,15,23,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=e.$6hc=void 0;class A{constructor(){this.a=new Set(Object.keys(l.Schemas)),this.b=new Map,this.extUri=new N.$Ig(w=>{const p=this.b.get(w.scheme);return!(p===void 0||p&1024)})}$acceptProviderInfos(w,p){p===null?this.b.delete(w.scheme):this.b.set(w.scheme,p)}isFreeScheme(w){return!this.b.has(w)&&!this.a.has(w)}getCapabilities(w){return this.b.get(w)}}e.$6hc=A,e.$7hc=(0,L.$gi)("IExtHostFileSystemInfo")}),define(Se[27],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FO=void 0,e.$FO=(0,l.$gi)("IExtHostInitDataService")}),define(Se[276],De([1,0,220,12,256,27]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$akc=void 0;let R=class extends L.$NP{constructor(p,E,M){const C=M.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",v=M.remote.isRemote?(0,l.localize)(0,null):p?(0,l.localize)(1,null):(0,l.localize)(2,null);super(E.createLogger(C,{name:v}))}};e.$akc=R,e.$akc=R=Qe([Ve(1,N.$Bj),Ve(2,A.$FO)],R)}),define(Se[277],De([1,0,8]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=e.$Oic=void 0;class N{constructor(R,w,p){this.h=new Map,this.a=R,this.b=w,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new l.$sh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const M of E.values())M.complete()}catch(M){for(const C of E.values())C.error(M)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,w){let p=this.f[R];return typeof p>"u"&&(p=w),p}update(R,w){this.f[R]=w;const p=this.h.get(R);if(p!==void 0)return p.p;const E=new l.$Dh;return this.h.set(R,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Oic=N;class L extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,w){super(R.identifier.value,!0,w),this.j=R}}e.$Pic=L}),define(Se[278],De([1,0,4,2]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cjc=void 0;class L{constructor(R){this.c=R,this.a=new l.$6d,this.onDidSaveNotebookDocument=this.a.event,this.b=new l.$6d,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,w,p,E){const C=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(w.value,p,E);this.b.fire(C)}$acceptDirtyStateChanged(R,w){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(w)}$acceptModelSaved(R){const w=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(w.apiNotebook)}}e.$Cjc=L}),define(Se[20],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=e.$pO=void 0,e.$pO=(0,l.$gi)("IExtHostRpcService");class N{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.dispose=A.dispose.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.$qO=N}),define(Se[279],De([1,0,25,4]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wic=void 0;class L{#e;constructor(R,w){this.b=new N.$6d,this.onDidChange=this.b.event,this.a=l.$Am.toKey(R.identifier),this.#e=w,this.#e.onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(R){return this.#e.get(this.a,R)}store(R,w){return this.#e.store(this.a,R,w)}delete(R){return this.#e.delete(this.a,R)}}e.$Wic=L}),define(Se[65],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=e.$mic=void 0,e.$mic=(0,l.$gi)("IURITransformerService");class N{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$nic=N}),define(Se[280],De([1,0,21]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knb=e.$jnb=void 0;class N{constructor(){this.buffers=[]}add(p){let E=this.buffers.indexOf(p);return E<0&&(E=this.buffers.length,this.buffers.push(p)),E}}function L(w,p){if(p.serializeBuffersForPostMessage){const E=new N,C=JSON.stringify(w,(S,y)=>{if(y instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(y)};if(ArrayBuffer.isView(y)){const u=A(y);if(u)return{$$vscode_array_buffer_reference$$:!0,index:E.add(y.buffer),view:{type:u,byteLength:y.byteLength,byteOffset:y.byteOffset}}}return y}),v=E.buffers.map(S=>{const y=new Uint8Array(S);return l.$te.wrap(y)});return{message:C,buffers:v}}else return{message:JSON.stringify(w),buffers:[]}}e.$jnb=L;function A(w){switch(w.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(w,p){const E=p.map(v=>{const S=new ArrayBuffer(v.byteLength);return new Uint8Array(S).set(v.buffer),S}),M=p.length?(v,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const y=S,{index:u}=y,m=E[u];if(y.view)switch(y.view.type){case 1:return new Int8Array(m,y.view.byteOffset,y.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(m,y.view.byteOffset,y.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(m,y.view.byteOffset,y.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(m,y.view.byteOffset,y.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(m,y.view.byteOffset,y.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(m,y.view.byteOffset,y.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(m,y.view.byteOffset,y.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(m,y.view.byteOffset,y.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(m,y.view.byteOffset,y.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(m,y.view.byteOffset,y.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(m,y.view.byteOffset,y.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return m}return S}:void 0;return{message:JSON.parse(w,M),arrayBuffers:E}}e.$knb=R}),define(Se[281],De([1,0,282,394,395,62,2,12,396]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ikc=void 0;const E=!1;function M(n,r,c,t,f,h){const s=h.environment.useHostProxy,a=typeof s=="boolean"?s:!h.remote.isRemote,d={resolveProxy:b=>n.resolveProxy(b),lookupProxyAuthorization:m.bind(void 0,t,f,r,{},h.remote.isRemote),getProxyURL:()=>r.getConfiguration("http").get("proxy"),getProxySupport:()=>r.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>v(r),addCertificatesV2:()=>S(r),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case w.LogLevel.Trace:return p.LogLevel.Trace;case w.LogLevel.Debug:return p.LogLevel.Debug;case w.LogLevel.Info:return p.LogLevel.Info;case w.LogLevel.Warning:return p.LogLevel.Warning;case w.LogLevel.Error:return p.LogLevel.Error;case w.LogLevel.Off:return p.LogLevel.Off;default:return g(b)}function g(k){return t.error("Unknown log level",k),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:a,loadAdditionalCertificates:async()=>{const b=[];if(h.remote.isRemote&&b.push((0,p.loadSystemCertificates)({log:t})),a){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const g=n.loadCertificates();g.then(k=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",k.length)),b.push(g)}return(await Promise.all(b)).flat()},env:process.env},$=(0,p.createProxyResolver)(d),D=C(d,$);return u(c,D)}e.$Ikc=M;function C(n,r){return{http:Object.assign(l,(0,p.createHttpPatch)(n,l,r)),https:Object.assign(N,(0,p.createHttpPatch)(n,N,r)),net:Object.assign(A,(0,p.createNetPatch)(n,A)),tls:Object.assign(L,(0,p.createTlsPatch)(n,L))}}function v(n){const r=n.getConfiguration("http");return!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}function S(n){const r=n.getConfiguration("http");return!!r.get("experimental.systemCertificatesV2",E)&&!!r.get("systemCertificates")}const y=new Map;function u(n,r){return n.getExtensionPathIndex().then(c=>{const t=globalThis._VSCODE_NODE_MODULES.module,f=t._load;t._load=function(s,a,d){if(s==="net")return r.net;if(s==="tls")return r.tls;if(s!=="http"&&s!=="https")return f.apply(this,arguments);const $=c.findSubstr(R.URI.file(a.filename));let D=y.get($);if(D||y.set($,D={}),!D[s]){const b=r[s];D[s]={...b}}return D[s]}})}async function m(n,r,c,t,f,h,s,a){const d=t[h];s&&(t[h]=s),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${d}`);const $=s||d,D=Array.isArray($)?$:typeof $=="string"?[$]:[];if(i(r,D,f),D.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!a.kerberosRequested)try{a.kerberosRequested=!0;const b=await new Promise((U,z)=>{fe(["kerberos"],U,z)}),g=new URL(h),k=c.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${g.hostname}`:`HTTP@${g.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${k}`),"Negotiate "+await(await b.initializeClient(k)).step("")}catch(b){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function i(n,r,c){o||!r.length||(o=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:r.map(t=>t.split(" ")[0]).join(","),extensionHostType:c?"remote":"local"}))}}),define(Se[283],De([1,0,133]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=void 0;function N(A){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:A,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function L(A){return new l.$hn(N(A))}e.$fs=L}),define(Se[142],De([1,0,230,18,2,3,5,37,32,15,44,185,39]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kF=e.$jF=e.$iF=e.EditorsOrder=e.$hF=e.CloseDirection=e.$gF=e.$fF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.EditorInputCapabilities=e.$9E=e.SaveReason=e.Verbosity=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=void 0,e.$VE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$WE={id:"default",displayName:(0,l.localize)(0,null),providerDisplayName:(0,l.localize)(1,null)},e.$XE="workbench.editor.sidebysideEditor",e.$YE="workbench.editors.textDiffEditor",e.$ZE="workbench.editors.binaryResourceDiffEditor";var S;(function(se){se[se.PROGRAMMATIC=1]="PROGRAMMATIC",se[se.USER=2]="USER",se[se.EDIT=3]="EDIT",se[se.NAVIGATION=4]="NAVIGATION",se[se.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var y;(function(se){se[se.IDENTICAL=1]="IDENTICAL",se[se.SIMILAR=2]="SIMILAR",se[se.DIFFERENT=3]="DIFFERENT"})(y||(e.EditorPaneSelectionCompareResult=y={}));function u(se){const re=se;return!!re&&typeof re.getSelection=="function"&&!!re.onDidChangeSelection}e.$1E=u;function m(se,re,B){for(const ie of B.visibleEditorPanes)if(ie.group.id===re&&se.matches(ie.input))return ie.getViewState()}e.$2E=m;function o(se){if($(se))return!1;const re=se;return L.URI.isUri(re?.resource)}e.$3E=o;function i(se){if($(se))return!1;const re=se;return re?.original!==void 0&&re.modified!==void 0}e.$4E=i;function n(se){if($(se))return!1;const re=se;return!re||re.resources&&!Array.isArray(re.resources)?!1:!!re.resources||!!re.multiDiffSource}e.$5E=n;function r(se){if($(se)||i(se))return!1;const re=se;return re?.primary!==void 0&&re.secondary!==void 0}e.$6E=r;function c(se){if($(se))return!1;const re=se;return re?re.resource===void 0||re.resource.scheme===E.Schemas.untitled||re.forceUntitled===!0:!1}e.$7E=c;function t(se){if($(se))return!1;const re=se;return L.URI.isUri(re?.base?.resource)&&L.URI.isUri(re?.input1?.resource)&&L.URI.isUri(re?.input2?.resource)&&L.URI.isUri(re?.result?.resource)}e.$8E=t;var f;(function(se){se[se.SHORT=0]="SHORT",se[se.MEDIUM=1]="MEDIUM",se[se.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var h;(function(se){se[se.EXPLICIT=1]="EXPLICIT",se[se.AUTO=2]="AUTO",se[se.FOCUS_CHANGE=3]="FOCUS_CHANGE",se[se.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class s{constructor(){this.a=new Map}registerSource(re,B){let ie=this.a.get(re);return ie||(ie={source:re,label:B},this.a.set(re,ie)),ie.source}getSourceLabel(re){return this.a.get(re)?.label??re}}e.$9E=new s;var a;(function(se){se[se.None=0]="None",se[se.Readonly=2]="Readonly",se[se.Untitled=4]="Untitled",se[se.Singleton=8]="Singleton",se[se.RequiresTrust=16]="RequiresTrust",se[se.CanSplitInGroup=32]="CanSplitInGroup",se[se.ForceDescription=64]="ForceDescription",se[se.CanDropIntoEditor=128]="CanDropIntoEditor",se[se.MultipleEditors=256]="MultipleEditors",se[se.Scratchpad=512]="Scratchpad",se[se.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(a||(e.EditorInputCapabilities=a={}));class d extends A.$Tc{}e.$0E=d;function $(se){return se instanceof d}e.$$E=$;function D(se){const re=se;return L.URI.isUri(re?.preferredResource)}function b(se){const re=se;return $(re?.primary)&&$(re?.secondary)}e.$_E=b;function g(se){const re=se;return $(re?.modified)&&$(re?.original)}e.$aF=g;function k(se,re,B,ie,ke){return ge(ie,[(0,C.$3i)({id:"workbench.action.openLargeFile",label:(0,l.localize)(2,null),run:()=>{const le={...B,limits:{size:Number.MAX_VALUE}};se.openEditor(re,le)}}),(0,C.$3i)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,l.localize)(3,null),run:()=>ke.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.$bF=k;function P(se){return $(se?.editor)}e.$cF=P;function F(se){const re=se;return P(se)&&re?.group!==void 0}e.$dF=F;function U(se){const re=se;return typeof re?.groupId=="number"&&$(re.editor)}e.$eF=U;var z;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.REPLACE=1]="REPLACE",se[se.MOVE=2]="MOVE",se[se.UNPIN=3]="UNPIN"})(z||(e.EditorCloseContext=z={}));var T;(function(se){se[se.GROUP_ACTIVE=0]="GROUP_ACTIVE",se[se.GROUP_INDEX=1]="GROUP_INDEX",se[se.GROUP_LABEL=2]="GROUP_LABEL",se[se.GROUP_LOCKED=3]="GROUP_LOCKED",se[se.EDITOR_OPEN=4]="EDITOR_OPEN",se[se.EDITOR_CLOSE=5]="EDITOR_CLOSE",se[se.EDITOR_MOVE=6]="EDITOR_MOVE",se[se.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",se[se.EDITOR_LABEL=8]="EDITOR_LABEL",se[se.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",se[se.EDITOR_PIN=10]="EDITOR_PIN",se[se.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",se[se.EDITOR_STICKY=12]="EDITOR_STICKY",se[se.EDITOR_DIRTY=13]="EDITOR_DIRTY",se[se.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var I;(function(se){se[se.PRIMARY=1]="PRIMARY",se[se.SECONDARY=2]="SECONDARY",se[se.BOTH=3]="BOTH",se[se.ANY=4]="ANY"})(I||(e.SideBySideEditor=I={}));class O{getOriginalUri(re,B){if(!re)return;if(t(re))return e.$gF.getOriginalUri(re.result,B);if(B?.supportSideBySide){const{primary:ke,secondary:le}=this.a(re);if(ke&&le){if(B?.supportSideBySide===I.BOTH)return{primary:this.getOriginalUri(ke,{filterByScheme:B.filterByScheme}),secondary:this.getOriginalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===I.ANY)return this.getOriginalUri(ke,{filterByScheme:B.filterByScheme})??this.getOriginalUri(le,{filterByScheme:B.filterByScheme});re=B.supportSideBySide===I.PRIMARY?ke:le}}if(i(re)||n(re)||r(re)||t(re))return;const ie=D(re)?re.preferredResource:re.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}a(re){return b(re)||r(re)?{primary:re.primary,secondary:re.secondary}:g(re)||i(re)?{primary:re.modified,secondary:re.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(re,B){if(!re)return;if(t(re))return e.$gF.getCanonicalUri(re.result,B);if(B?.supportSideBySide){const{primary:ke,secondary:le}=this.a(re);if(ke&&le){if(B?.supportSideBySide===I.BOTH)return{primary:this.getCanonicalUri(ke,{filterByScheme:B.filterByScheme}),secondary:this.getCanonicalUri(le,{filterByScheme:B.filterByScheme})};if(B?.supportSideBySide===I.ANY)return this.getCanonicalUri(ke,{filterByScheme:B.filterByScheme})??this.getCanonicalUri(le,{filterByScheme:B.filterByScheme});re=B.supportSideBySide===I.PRIMARY?ke:le}}if(i(re)||n(re)||r(re)||t(re))return;const ie=re.resource;return!ie||!B||!B.filterByScheme?ie:this.b(ie,B.filterByScheme)}b(re,B){if(Array.isArray(B)){if(B.some(ie=>re.scheme===ie))return re}else if(B===re.scheme)return re}}var j;(function(se){se[se.UNKNOWN=0]="UNKNOWN",se[se.KEYBOARD=1]="KEYBOARD",se[se.MOUSE=2]="MOUSE"})(j||(e.EditorCloseMethod=j={}));function G(se,re,B,ie){if(!se.isSticky(re))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return B===j.MOUSE||B===j.KEYBOARD;case"mouse":return B===j.MOUSE;case"keyboard":return B===j.KEYBOARD}return!1}e.$fF=G,e.$gF=new O;var te;(function(se){se[se.LEFT=0]="LEFT",se[se.RIGHT=1]="RIGHT"})(te||(e.CloseDirection=te={}));class x{constructor(){this.c=new Map,this.d=new Map}start(re){const B=this.a=re.get(R.$fi);for(const[ie,ke]of this.c)this.e(ie,ke,B);this.c.clear()}e(re,B,ie){const ke=ie.createInstance(B);this.d.set(re,ke)}registerFileEditorFactory(re){if(this.b)throw new Error("Can only register one file editor factory.");this.b=re}getFileEditorFactory(){return(0,N.$5f)(this.b)}registerEditorSerializer(re,B){if(this.c.has(re)||this.d.has(re))throw new Error(`A editor serializer with type ID '${re}' was already registered.`);return this.a?this.e(re,B,this.a):this.c.set(re,B),(0,A.$Rc)(()=>{this.c.delete(re),this.d.delete(re)})}getEditorSerializer(re){return this.d.get(typeof re=="string"?re:re.typeId)}}w.$Xn.add(e.$VE.EditorFactory,new x);async function Z(se,re,B){return!se||!se.length?[]:await Promise.all(se.map(async ie=>{const ke=L.URI.revive(ie.fileUri);if(!ke){B.info("Cannot resolve the path because it is not valid.",ie);return}if(!await re.canHandleResource(ke)){B.info("Cannot resolve the path because it cannot be handled",ie);return}let ue=ie.exists,ce=ie.type;if(typeof ue!="boolean"||typeof ce!="number")try{ce=(await re.stat(ke)).isDirectory?p.FileType.Directory:p.FileType.Unknown,ue=!0}catch(H){B.error(H),ue=!1}if(!ue&&ie.openOnlyIfExists){B.info("Cannot resolve the path because it does not exist",ie);return}if(ce===p.FileType.Directory){B.info("Cannot resolve the path because it is a directory",ie);return}const de={...ie.options,pinned:!0};return ue?{resource:ke,options:de}:{resource:ke,options:de,forceUntitled:!0}}))}e.$hF=Z;var X;(function(se){se[se.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",se[se.SEQUENTIAL=1]="SEQUENTIAL"})(X||(e.EditorsOrder=X={}));function ae(se){const re=se;if(!re)return!1;const B=re;if(B.modified)return ae(B.modified);const ie=re;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$iF=ae;function _(se){return(0,M.$5i)(se)}e.$jF=_;function ge(se,re,B){const ie=(0,M.$6i)(se,re);return ie.forceMessage=B?.forceMessage,ie.forceSeverity=B?.forceSeverity,ie.allowDialog=B?.allowDialog,ie}e.$kF=ge}),define(Se[284],De([1,0,4,231,5,3,28,37,19,24,77,270]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sF=e.$rF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$qF=e.ViewContentGroups=e.$pF=e.$oF=e.ViewContainerLocation=e.Extensions=e.$nF=e.$mF=e.$lF=void 0,e.$lF="views",e.$mF=(0,N.localize)(0,null),e.$nF=(0,C.$Nw)("default-view-icon",M.$pk.window,(0,N.localize)(1,null));var v;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(v||(e.Extensions=v={}));var S;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})(S||(e.ViewContainerLocation=S={})),e.$oF=[0,1,2];function y(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$pF=y;class u extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new l.$6d),this.onDidRegister=this.c.event,this.f=this.B(new l.$6d),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,p.$Rb)([...this.g.values()])}registerViewContainer(h,s,a){const d=this.get(h.id);if(d)return d;const $=h;return $.openCommandActionDescriptor=a?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,R.$xc)(this.g,s,[]).push($),a?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:s}),$}deregisterViewContainer(h){for(const s of this.g.keys()){const a=this.g.get(s),d=a?.indexOf(h);if(d!==-1){a?.splice(d,1),a.length===0&&this.g.delete(s),this.f.fire({viewContainer:h,viewContainerLocation:s});return}}}get(h){return this.all.filter(s=>s.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(s=>this.getViewContainers(s).filter(a=>a?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(s=>this.getViewContainerLocation(s)===h)}}w.$Xn.add(v.ViewContainersRegistry,new u);var m;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(m||(e.ViewContentGroups=m={}));function o(f,h){const s=f.group??m.More,a=h.group??m.More;return s!==a?s.localeCompare(a):(f.order??5)-(h.order??5)}class i extends A.$Tc{constructor(){super(...arguments),this.c=this.B(new l.$6d),this.onViewsRegistered=this.c.event,this.f=this.B(new l.$6d),this.onViewsDeregistered=this.f.event,this.g=this.B(new l.$6d),this.onDidChangeContainer=this.g.event,this.h=this.B(new l.$6d),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(h,s){this.registerViews2([{views:h,viewContainer:s}])}registerViews2(h){h.forEach(({views:s,viewContainer:a})=>this.r(s,a)),this.c.fire(h)}deregisterViews(h,s){const a=this.s(h,s);a.length&&this.f.fire({views:a,viewContainer:s})}moveViews(h,s){for(const a of this.m.keys())if(a!==s){const d=this.s(h,a);d.length&&(this.r(d,s),this.g.fire({views:d,from:a,to:s}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const s of this.j){const a=(this.m.get(s)||[]).filter(d=>d.id===h)[0];if(a)return a}return null}getViewContainer(h){for(const s of this.j)if((this.m.get(s)||[]).filter(d=>d.id===h)[0])return s;return null}registerViewWelcomeContent(h,s){return this.n.add(h,s),this.h.fire(h),(0,A.$Rc)(()=>{this.n.delete(h,s),this.h.fire(h)})}registerViewWelcomeContent2(h,s){const a=new Map;for(const[d,$]of s)this.n.add(h,$),a.set(d,(0,A.$Rc)(()=>{this.n.delete(h,$),this.h.fire(h)}));return this.h.fire(h),a}getViewWelcomeContent(h){const s=[];return this.n.forEach(h,a=>s.push(a)),s.sort(o)}r(h,s){let a=this.m.get(s);a||(a=[],this.m.set(s,a),this.j.push(s));for(const d of h){if(this.getView(d.id)!==null)throw new Error((0,N.localize)(2,null,d.id));a.push(d)}}s(h,s){const a=this.m.get(s);if(!a)return[];const d=[],$=[];for(const D of a)h.includes(D)?d.push(D):$.push(D);return d.length&&($.length?this.m.set(s,$):(this.m.delete(s),this.j.splice(this.j.indexOf(s),1))),d}}w.$Xn.add(v.ViewsRegistry,new i),e.$qF=(0,L.$gi)("viewDescriptorService");var n;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var r;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(r||(e.TreeItemCollapsibleState=r={}));class c{constructor(h,s){this.c=!1,this.d=!1,(0,E.$On)(this,h),this.d=!!s,this.resolve=async a=>{if(s&&!this.c){const d=await s(a);d&&(this.tooltip=this.tooltip??d.tooltip,this.command=this.command??d.command)}a.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$rF=c;class t extends Error{constructor(h){super((0,N.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$sF=t}),define(Se[285],De([1,0,2,29,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DF=e.$CF=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$BF=e.$AF=void 0;function A(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof l.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$0s.isIRange)}e.$AF=A;function R(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(A)}e.$BF=R;var w;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(w||(e.InteractiveSessionVoteDirection=w={}));var p;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$CF=(0,L.$gi)("IChatService"),e.$DF="accessibility.voice.keywordActivation"}),define(Se[143],De([1,0,4,8,232]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnb=void 0;class A{constructor(){this.f=new Map,this.m=[],this.n=new l.$6d,this.o=new l.$6d,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(w){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=w}onEvent(w){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=w}onRequest(w){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=w}sendResponse(w){w.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${w.command}`)):this.u("response",w)}sendRequest(w,p,E,M){const C={command:w};if(p&&Object.keys(p).length>0&&(C.arguments=p),this.u("request",C),typeof M=="number"){const v=setTimeout(()=>{clearTimeout(v);const S=this.f.get(C.seq);if(S){this.f.delete(C.seq);const y={type:"response",seq:0,request_seq:C.seq,success:!1,command:w,message:(0,L.localize)(0,null,M,w)};S(y)}},M)}return E&&this.f.set(C.seq,E),C.seq}acceptMessage(w){this.k?this.k(w):(this.m.push(w),this.m.length===1&&this.s())}q(w,p){return w.type!=="event"||p.type!=="event"}async s(){let w;for(;this.m.length;){if((!w||this.q(this.m[0],w))&&await(0,N.$hh)(0),w=this.m.shift(),!w)return;switch(w.type){case"event":this.j?.(w);break;case"request":this.g?.(w);break;case"response":{const p=w,E=this.f.get(p.request_seq);E&&(this.f.delete(p.request_seq),E(p));break}}}}u(w,p){p.type=w,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const w=new Map;this.f.forEach((p,E)=>w.set(E,p)),await(0,N.$hh)(500),w.forEach((p,E)=>{p({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$Pnb=A}),define(Se[286],De([1,0,2,233,45,5]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$EI=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$DI=e.MemoryRangeType=e.$CI=e.State=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.$4H=e.$3H=e.$2H=e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=void 0,e.$tH="workbench.view.debug",e.$uH="workbench.debug.variablesView",e.$vH="workbench.debug.watchExpressionsView",e.$wH="workbench.debug.callStackView",e.$xH="workbench.debug.loadedScriptsView",e.$yH="workbench.debug.breakPointsView",e.$zH="workbench.debug.disassemblyView",e.$AH="workbench.panel.repl",e.$BH="workbench.panel.repl.view",e.$CH=new L.$xj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$DH=new L.$xj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$EH=new L.$xj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$FH="debugUx",e.$GH=new L.$xj(e.$FH,"default",{type:"string",description:N.localize(3,null)}),e.$HH=new L.$xj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$IH=new L.$xj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$JH=new L.$xj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$KH=new L.$xj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$LH=new L.$xj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$MH=new L.$xj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$NH=new L.$xj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$OH=new L.$xj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$PH=new L.$xj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$QH=new L.$xj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$RH=new L.$xj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$SH=new L.$xj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$TH=new L.$xj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$UH=new L.$xj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$VH=new L.$xj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$WH=new L.$xj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$XH=new L.$xj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$YH=new L.$xj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$ZH=new L.$xj("breakpointHasModes",!1,{type:"boolean",description:N.localize(22,null)}),e.$1H=new L.$xj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(23,null)}),e.$2H=new L.$xj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(24,null)}),e.$3H=new L.$xj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(25,null)}),e.$4H=new L.$xj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(26,null)}),e.$5H=new L.$xj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(27,null)}),e.$6H=new L.$xj("stepBackSupported",!1,{type:"boolean",description:N.localize(28,null)}),e.$7H=new L.$xj("restartFrameSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$8H=new L.$xj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(30,null)}),e.$9H=new L.$xj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(31,null)}),e.$0H=new L.$xj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$$H=new L.$xj("breakpointsExist",!1,{type:"boolean",description:N.localize(33,null)}),e.$_H=new L.$xj("debuggersAvailable",!1,{type:"boolean",description:N.localize(34,null)}),e.$aI=new L.$xj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(35,null)}),e.$bI=new L.$xj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(36,null)}),e.$cI=new L.$xj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(37,null)}),e.$dI=new L.$xj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$eI=new L.$xj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$fI=new L.$xj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$gI=new L.$xj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$hI=new L.$xj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$iI=new L.$xj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$jI=new L.$xj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(44,null)}),e.$kI=new L.$xj("variableIsReadonly",!1,{type:"boolean",description:N.localize(45,null)}),e.$lI=new L.$xj("variableValue",!1,{type:"string",description:N.localize(46,null)}),e.$mI=new L.$xj("variableType",!1,{type:"string",description:N.localize(47,null)}),e.$nI=new L.$xj("variableName",!1,{type:"string",description:N.localize(48,null)}),e.$oI=new L.$xj("variableLanguage",!1,{type:"string",description:N.localize(49,null)}),e.$pI=new L.$xj("variableExtensionId",!1,{type:"string",description:N.localize(50,null)}),e.$qI=new L.$xj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(51,null)}),e.$rI=new L.$xj("multiSessionRepl",!1,{type:"boolean",description:N.localize(52,null)}),e.$sI=new L.$xj("multiSessionDebug",!1,{type:"boolean",description:N.localize(53,null)}),e.$tI=new L.$xj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(54,null)}),e.$uI=new L.$xj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(55,null)}),e.$vI=new L.$xj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(56,null)}),e.$wI=new L.$xj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(57,null)});const R=o=>N.localize(58,null,o);e.$xI=R,e.$yI="editor.contrib.debug",e.$zI="editor.contrib.breakpoint",e.$AI="debug",e.$BI={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(59,null)};var w;(function(o){o[o.Inactive=0]="Inactive",o[o.Initializing=1]="Initializing",o[o.Stopped=2]="Stopped",o[o.Running=3]="Running"})(w||(e.State=w={}));function p(o){switch(o){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$CI=p;var E;(function(o){o[o.Valid=0]="Valid",o[o.Unreadable=1]="Unreadable",o[o.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$DI="vscode-debug-memory";var M;(function(o){o[o.Initial=1]="Initial",o[o.Dynamic=2]="Dynamic"})(M||(e.DebugConfigurationProviderTriggerKind=M={}));var C;(function(o){o.UnverifiedBreakpoints="unverifiedBreakpoints"})(C||(e.DebuggerString=C={})),e.$EI=(0,A.$gi)("debugService");var v;(function(o){o[o.CONDITION=0]="CONDITION",o[o.HIT_COUNT=1]="HIT_COUNT",o[o.LOG_MESSAGE=2]="LOG_MESSAGE",o[o.TRIGGER_POINT=3]="TRIGGER_POINT"})(v||(e.BreakpointWidgetContext=v={}));var S;(function(o){o[o.Command=0]="Command",o[o.Tree=1]="Tree"})(S||(e.DebugVisualizationType=S={}));var y;(function(o){o[o.None=0]="None",o[o.Collapsed=1]="Collapsed",o[o.Expanded=2]="Expanded"})(y||(e.DebugTreeItemCollapsibleState=y={}));var u;(function(o){o.deserialize=i=>i,o.serialize=i=>i})(u||(e.IDebugVisualizationTreeItem=u={}));var m;(function(o){o.deserialize=i=>({id:i.id,name:i.name,iconPath:i.iconPath&&{light:l.URI.revive(i.iconPath.light),dark:l.URI.revive(i.iconPath.dark)},iconClass:i.iconClass,visualization:i.visualization}),o.serialize=i=>i})(m||(e.IDebugVisualization=m={}))}),define(Se[287],De([1,0,14,2,17,24,15,29,22,19]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=void 0;const M=/{([^}]+)}/g;function C(D,b,g){return D.replace(M,function(k,P){return b&&P.length>0&&P[0]!=="_"?k:g&&g.hasOwnProperty(P)?g[P]:k})}e.$vG=C;function v(D){const b={};for(const g of Object.keys(D))g.startsWith("!")||(b[g]=D[g]);return b}e.$wG=v;function S(D){return D.configuration.request==="attach"&&!y(D)&&(!D.parentSession||S(D.parentSession))}e.$xG=S;function y(D){let b=D.configuration.type;if(b)return b==="vslsShare"&&(b=D.configuration.adapterProxy.configuration.type),(0,l.$kf)(b,"extensionhost")||(0,l.$kf)(b,"pwa-extensionhost")?D:D.parentSession?y(D.parentSession):void 0}e.$yG=y;function u(D){return D.type&&(D.label||D.program||D.runtime)}e.$zG=u;function m(D,b,g){let k,P=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=F.exec(D);){const z=U.index+1,T=z+U[0].length;if(z<=b&&T>=g){k=U[0],P=z;break}}if(k){const z=/\w+/g;let T=null;for(;(T=z.exec(k))&&!(T.index+1+P+T[0].length>=g););T&&(k=k.substring(0,z.lastIndex))}return k?{start:P,end:P+k.length-1}:{start:0,end:0}}e.$AG=m;async function o(D,b,g,k){if(D.evaluatableExpressionProvider.has(b)){const P=D.evaluatableExpressionProvider.ordered(b),F=(0,E.$Hb)(await Promise.all(P.map(async U=>{try{return await U.provideEvaluatableExpression(b,g,k??p.CancellationToken.None)}catch{return}})));if(F.length>0){let U=F[0].expression;const z=F[0].range;return U||(U=b.getLineContent(g.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const P=b.getLineContent(g.lineNumber),{start:F,end:U}=m(P,g.column,g.column),z=P.substring(F-1,U);return{matchingExpression:z,range:new w.$0s(g.lineNumber,F,g.lineNumber,F+z.length)}}return null}e.$BG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(i))}e.$CG=n;function r(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return N.URI.parse(D.path);if((0,L.$ic)(D.path))return N.URI.file(D.path)}return D.path}function c(D){if(typeof D.path=="object"){const b=N.URI.revive(D.path);if(b)return b.scheme===R.Schemas.file?b.fsPath:b.toString()}return D.path}function t(D,b){const g=b?r:c,k=(0,A.$Ln)(D);return h(k,(P,F)=>{P&&F&&(F.path=g(F))}),k}e.$DG=t;function f(D,b){const g=b?r:c,k=(0,A.$Ln)(D);return h(k,(P,F)=>{!P&&F&&(F.path=g(F))}),k}e.$EG=f;function h(D,b){switch(D.type){case"event":{const g=D;switch(g.event){case"output":b(!1,g.body.source);break;case"loadedSource":b(!1,g.body.source);break;case"breakpoint":b(!1,g.body.breakpoint.source);break;default:break}break}case"request":{const g=D;switch(g.command){case"setBreakpoints":b(!0,g.arguments.source);break;case"breakpointLocations":b(!0,g.arguments.source);break;case"source":b(!0,g.arguments.source);break;case"gotoTargets":b(!0,g.arguments.source);break;case"launchVSCode":g.arguments.args.forEach(k=>b(!1,k));break;default:break}break}case"response":{const g=D;if(g.success&&g.body)switch(g.command){case"stackTrace":g.body.stackFrames.forEach(k=>b(!1,k.source));break;case"loadedSources":g.body.sources.forEach(k=>b(!1,k));break;case"scopes":g.body.scopes.forEach(k=>b(!1,k.source));break;case"setFunctionBreakpoints":g.body.breakpoints.forEach(k=>b(!1,k.source));break;case"setBreakpoints":g.body.breakpoints.forEach(k=>b(!1,k.source));break;case"disassemble":g.body?.instructions.forEach(P=>b(!1,P.location));break;default:break}break}}}function s(D){return D.filter(b=>!b.presentation?.hidden).sort((b,g)=>b.presentation?g.presentation?b.presentation.group?g.presentation.group?b.presentation.group!==g.presentation.group?b.presentation.group.localeCompare(g.presentation.group):a(b.presentation.order,g.presentation.order):-1:g.presentation.group?1:a(b.presentation.order,g.presentation.order):-1:g.presentation?1:0)}e.$FG=s;function a(D,b){return typeof D!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:D-b}async function d(D,b){const g=D.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(g!=="none"&&(await b.saveAll(),g==="allEditorsInActiveGroup")){const k=b.activeEditorPane;k&&k.input.resource?.scheme===R.Schemas.untitled&&await b.save({editor:k.input,groupId:k.group.id})}await D.reloadConfiguration()}e.$GG=d;const $=(D,b)=>!D||!b?D===b:D.name===b.name&&D.path===b.path&&D.sourceReference===b.sourceReference;e.$HG=$}),define(Se[288],De([1,0,51,62,24,17,11,14,31,234,143]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kkc=e.$jkc=e.$ikc=e.$hkc=e.$gkc=void 0;class C extends M.$Pnb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.i=/: */}constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(o,i){this.l=i,this.p=Buffer.allocUnsafe(0),this.r=-1,o.on("data",n=>this.v(n))}sendMessage(o){if(this.l){const i=JSON.stringify(o);this.l.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}v(o){for(this.p=Buffer.concat([this.p,o]);;){if(this.r>=0){if(this.p.length>=this.r){const i=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.n.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.p.indexOf(C.a);if(i!==-1){const r=this.p.toString("utf8",0,i).split(C.b);for(const c of r){const t=c.split(C.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice(i+C.a.length);continue}}break}}}e.$gkc=C;class v extends C{startSession(){return new Promise((o,i)=>{let n=!1;this.x=this.y(()=>{this.t(this.x,this.x),o(),n=!0}),this.x.on("close",()=>{n?this.n.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",r=>{n?this.n.fire(r):i(r)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$hkc=v;class S extends v{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$ikc=S;class y extends v{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$jkc=y;class u extends C{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,n=this.y.options||{};try{if(o)if(A.$ic(o)){if(!await p.Promises.exists(o))throw new Error(E.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(E.localize(1,null,this.z));let r=process.env;if(n.env&&Object.keys(n.env).length>0&&(r=L.$On(L.$Ln(process.env),n.env)),o==="node")if(Array.isArray(i)&&i.length>0){const c=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:r,execArgv:c?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const f=l.fork(i[0],i.slice(1),t);if(!f.pid)throw new Error(E.localize(2,null,i[0]));this.x=f}else throw new Error(E.localize(3,null));else{const c={env:r};n.cwd&&(c.cwd=n.cwd),this.x=l.spawn(o,i,c)}this.x.on("error",c=>{this.n.fire(c)}),this.x.on("exit",(c,t)=>{this.o.fire(c)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",c=>{this.n.fire(c)}),this.x.stdin.on("error",c=>{this.n.fire(c)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(r){this.n.fire(r)}}async stopSession(){return this.x?(await this.w(),R.$i?new Promise((o,i)=>{const n=l.exec(`taskkill /F /T /PID ${this.x.pid}`,function(r,c,t){if(r)return i(r)});n.on("exit",o),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const n=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?n.runtime=A.$jc(i,o.runtime):n.runtime=o.runtime),o.runtimeArgs&&(n.runtimeArgs=o.runtimeArgs),o.program&&(A.$ic(o.program)?n.program=o.program:n.program=A.$jc(i,o.program)),o.args&&(n.args=o.args);const r=o;return r.win&&(n.win=u.A(r.win,i)),r.winx86&&(n.winx86=u.A(r.winx86,i)),r.windows&&(n.windows=u.A(r.windows,i)),r.osx&&(n.osx=u.A(r.osx,i)),r.linux&&(n.linux=u.A(r.linux,i)),n}static platformAdapterExecutable(o,i){let n=Object.create(null);i=i.toLowerCase();for(const s of o)if(s.contributes){const a=s.contributes.debuggers;a&&a.length>0&&a.filter(d=>typeof d.type=="string"&&w.$kf(d.type,i)).forEach(d=>{const $=u.A(d,s.extensionLocation.fsPath);n=L.$On(n,$,s.isBuiltin)})}let r;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?r=n.winx86||n.win||n.windows:R.$i?r=n.win||n.windows:R.$j?r=n.osx:R.$k&&(r=n.linux),r=r||n;const c=r.program||n.program,t=r.args||n.args,f=r.runtime||n.runtime,h=r.runtimeArgs||n.runtimeArgs;if(f)return{type:"executable",command:f,args:(h||[]).concat(typeof c=="string"?[c]:[]).concat(t||[])};if(c)return{type:"executable",command:c,args:t||[]}}}e.$kkc=u}),define(Se[289],De([1,0,51,34,11]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mkc=e.$lkc=void 0;function A(E,M){return new Promise((C,v)=>{let S="";const y=l.spawn(E,M);y.pid&&y.stdout.on("data",u=>{S+=u.toString()}),y.on("error",u=>{v(u)}),y.on("close",u=>{C(S)})})}async function R(E){if(E)if(L.$i){const M=await new Promise((C,v)=>{fe(["@vscode/windows-process-tree"],C,v)});return new Promise(C=>{M.getProcessTree(E,v=>{C(!!v&&v.children.length>0)})})}else return A("/usr/bin/pgrep",["-lP",String(E)]).then(M=>{const C=M.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},M=>!0);return Promise.resolve(!0)}e.$lkc=R;var w;(function(E){E[E.cmd=0]="cmd",E[E.powershell=1]="powershell",E[E.bash=2]="bash"})(w||(w={}));function p(E,M,C,v){E=E.trim().toLowerCase();let S;E.indexOf("powershell")>=0||E.indexOf("pwsh")>=0?S=1:E.indexOf("cmd.exe")>=0?S=0:E.indexOf("bash")>=0?S=2:L.$i?S=0:S=2;let y,u=" ";switch(S){case 1:if(y=m=>(m=m.replace(/\'/g,"''"),m.length>0&&m.charAt(m.length-1)==="\\"?`'${m}\\'`:`'${m}'`),v){const m=(0,N.$lg)(v);m&&(u+=`${m}:; `),u+=`cd ${y(v)}; `}if(M.length>0){const m=M.shift(),o=C?m:y(m);u+=o[0]==="'"?`& ${o} `:`${o} `;for(const i of M)u+=i==="<"||i===">"||C?i:y(i),u+=" "}break;case 0:if(y=m=>(m=m.replace(/\"/g,'""'),m=m.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(o=>m.includes(o))||m.length===0?`"${m}"`:m),v){const m=(0,N.$lg)(v);m&&(u+=`${m}: && `),u+=`cd ${y(v)} && `}for(const m of M)u+=m==="<"||m===">"||C?m:y(m),u+=" ";break;case 2:{y=m=>(m=m.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),m.length===0?'""':m),v&&(u+=`cd ${y(v)} ; `);for(const m of M)u+=m==="<"||m===">"||C?m:y(m),u+=" ";break}}return u}e.$mkc=p}),define(Se[290],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.CellExecutionUpdateType=void 0;var N;(function(L){L[L.Output=1]="Output",L[L.OutputItems=2]="OutputItems",L[L.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$aK=(0,l.$gi)("INotebookExecutionService")}),define(Se[291],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gb=e.$$gb=e.ProxyKernelState=e.$0gb=void 0,e.$0gb=100;var N;(function(L){L[L.Disconnected=1]="Disconnected",L[L.Connected=2]="Connected",L[L.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$$gb=(0,l.$gi)("INotebookKernelService"),e.$_gb=(0,l.$gi)("INotebookKernelHistoryService")}),define(Se[292],De([1,0,3,29,198,100]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FTb=void 0;class R extends l.$Tc{constructor(p,E,M){super(),this._source=p,this.b=E,this.c=M,this.a=void 0}f(p){const E=p.getLineCount();return new N.$0s(1,1,E,this.g(p,E))}g(p,E){if(E<1||E>p.getLineCount())throw new Error("Illegal value for lineNumber");return p.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const p=new L.$sC;p.acceptChunk(this._source);const E=p.finish(!0),{textBuffer:M,disposable:C}=E.create(1);this.b=M,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(p=>{const E=new L.$sC;E.acceptChunk(p);const M=E.finish(!0),{textBuffer:C,disposable:v}=M.create(1);return this.B(v),C})),this.a}findInInputs(p){const M=new A.$gC(p,!1,!1,null).parseSearchRequest();if(!M)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,M,!0,5e3)}findInOutputs(p){const M=new A.$gC(p,!1,!1,null).parseSearchRequest();return M?this.outputTextBuffers.map(C=>{const v=C.findMatchesLineByLine(this.f(C),M,!0,5e3);if(v.length!==0)return{textBuffer:C,matches:v}}).filter(C=>!!C):[]}}e.$FTb=R}),define(Se[66],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZK=e.TestPosition=e.TestIdPathParts=void 0;var l;(function(A){A.Delimiter="\0"})(l||(e.TestIdPathParts=l={}));var N;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class L{static fromExtHostTestItem(R,w,p=R.parent){if(R._isRoot)return new L([w]);const E=[R.id];for(let M=p;M&&M.id!==w;M=M.parent)E.push(M.id);return E.push(w),new L(E.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const w=R.indexOf("\0");return w===-1?R:R.slice(0,w)}static fromString(R){return new L(R.split("\0"))}static join(R,w){return new L([...R.path,w])}static joinToString(R,w){return R.toString()+"\0"+w}static parentId(R){const w=R.lastIndexOf("\0");return w===-1?void 0:R.slice(0,w)}static localId(R){const w=R.lastIndexOf("\0");return w===-1?R:R.slice(w+1)}static isChild(R,w){return w.startsWith(R)&&w[R.length]==="\0"}static compare(R,w){return R===w?0:L.isChild(R,w)?2:L.isChild(w,R)?3:1}constructor(R,w=R.length){if(this.path=R,this.d=w,R.length===0||w<1)throw new Error("cannot create test with empty path")}get rootId(){return new L(this.path,1)}get parentId(){return this.d>1?new L(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new L(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new L(this.path,R)}compare(R){if(typeof R=="string")return L.compare(this.toString(),R);for(let w=0;w<R.d&&w<this.d;w++)if(R.path[w]!==this.path[w])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$ZK=L}),define(Se[89],De([1,0,2,49,29,66]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$7K=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$6K=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$5K=e.$4K=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$3K=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$2K=e.$1K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(I){I[I.Unset=0]="Unset",I[I.Queued=1]="Queued",I[I.Running=2]="Running",I[I.Passed=3]="Passed",I[I.Failed=4]="Failed",I[I.Skipped=5]="Skipped",I[I.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var w;(function(I){I[I.Run=1]="Run",I[I.Debug=2]="Debug",I[I.Coverage=3]="Coverage"})(w||(e.ExtTestRunProfileKind=w={}));var p;(function(I){I[I.Run=2]="Run",I[I.Debug=4]="Debug",I[I.Coverage=8]="Coverage",I[I.HasNonDefaultProfile=16]="HasNonDefaultProfile",I[I.HasConfigurable=32]="HasConfigurable",I[I.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$1K=[2,4,8,16,32,64];const E=I=>"runId"in I;e.$2K=E;var M;(function(I){I.serialize=O=>({range:O.range.toJSON(),uri:O.uri.toJSON()}),I.deserialize=(O,j)=>({range:L.$0s.lift(j.range),uri:O.asCanonicalUri(l.URI.revive(j.uri))})})(M||(e.IRichLocation=M={}));var C;(function(I){I[I.Error=0]="Error",I[I.Output=1]="Output"})(C||(e.TestMessageType=C={}));var v;(function(I){I.serialize=O=>({message:O.message,type:0,expected:O.expected,actual:O.actual,contextValue:O.contextValue,location:O.location&&M.serialize(O.location)}),I.deserialize=(O,j)=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&M.deserialize(O,j.location)})})(v||(e.ITestErrorMessage=v={}));const S=(I,O)=>`${O?"s":"e"}${I}`;e.$3K=S;var y;(function(I){I.serialize=O=>({message:O.message,type:1,offset:O.offset,length:O.length,location:O.location&&M.serialize(O.location)}),I.deserialize=(O,j)=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&M.deserialize(O,j.location)})})(y||(e.ITestOutputMessage=y={}));var u;(function(I){I.serialize=O=>O.type===0?v.serialize(O):y.serialize(O),I.deserialize=(O,j)=>j.type===0?v.deserialize(O,j):y.deserialize(O,j)})(u||(e.ITestMessage=u={}));var m;(function(I){I.serializeWithoutMessages=O=>({state:O.state,duration:O.duration,messages:[]}),I.serialize=O=>({state:O.state,duration:O.duration,messages:O.messages.map(u.serialize)}),I.deserialize=(O,j)=>({state:j.state,duration:j.duration,messages:j.messages.map(G=>u.deserialize(O,G))})})(m||(e.ITestTaskState=m={}));const o="\0",i=(I,O)=>I+o+O;e.$4K=i;const n=I=>{const O=I.indexOf(o);return{ctrlId:I.slice(0,O),tagId:I.slice(O+1)}};e.$5K=n;var r;(function(I){I.serialize=O=>({extId:O.extId,label:O.label,tags:O.tags,busy:O.busy,children:void 0,uri:O.uri?.toJSON(),range:O.range?.toJSON()||null,description:O.description,error:O.error,sortText:O.sortText}),I.deserialize=(O,j)=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?O.asCanonicalUri(l.URI.revive(j.uri)):void 0,range:j.range?L.$0s.lift(j.range):null,description:j.description,error:j.error,sortText:j.sortText})})(r||(e.ITestItem=r={}));var c;(function(I){I[I.NotExpandable=0]="NotExpandable",I[I.Expandable=1]="Expandable",I[I.BusyExpanding=2]="BusyExpanding",I[I.Expanded=3]="Expanded"})(c||(e.TestItemExpandState=c={}));var t;(function(I){I.serialize=O=>({expand:O.expand,item:r.serialize(O.item)}),I.deserialize=(O,j)=>({controllerId:A.$ZK.root(j.item.extId),expand:j.expand,item:r.deserialize(O,j.item)})})(t||(e.InternalTestItem=t={}));var f;(function(I){I.serialize=O=>{let j;return O.item&&(j={},O.item.label!==void 0&&(j.label=O.item.label),O.item.tags!==void 0&&(j.tags=O.item.tags),O.item.busy!==void 0&&(j.busy=O.item.busy),O.item.uri!==void 0&&(j.uri=O.item.uri?.toJSON()),O.item.range!==void 0&&(j.range=O.item.range?.toJSON()),O.item.description!==void 0&&(j.description=O.item.description),O.item.error!==void 0&&(j.error=O.item.error),O.item.sortText!==void 0&&(j.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:j}},I.deserialize=O=>{let j;return O.item&&(j={},O.item.label!==void 0&&(j.label=O.item.label),O.item.tags!==void 0&&(j.tags=O.item.tags),O.item.busy!==void 0&&(j.busy=O.item.busy),O.item.range!==void 0&&(j.range=O.item.range?L.$0s.lift(O.item.range):null),O.item.description!==void 0&&(j.description=O.item.description),O.item.error!==void 0&&(j.error=O.item.error),O.item.sortText!==void 0&&(j.sortText=O.item.sortText)),{extId:O.extId,expand:O.expand,item:j}}})(f||(e.ITestItemUpdate=f={}));const h=(I,O)=>{O.expand!==void 0&&(I.expand=O.expand),O.item!==void 0&&(I.item=I.item?Object.assign(I.item,O.item):O.item)};e.$6K=h;var s;(function(I){I.serializeWithoutMessages=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serializeWithoutMessages)}),I.serialize=O=>({...t.serialize(O),ownComputedState:O.ownComputedState,computedState:O.computedState,tasks:O.tasks.map(m.serialize)}),I.deserialize=(O,j)=>({...t.deserialize(O,j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(G=>m.deserialize(O,G)),retired:!0})})(s||(e.TestResultItem=s={}));var a;(function(I){I.empty=()=>({covered:0,total:0}),I.sum=(O,j)=>{O.covered+=j.covered,O.total+=j.total}})(a||(e.ICoveredCount=a={}));var d;(function(I){I.serialize=O=>({statement:O.statement,branch:O.branch,declaration:O.declaration,details:O.details?.map(g.serialize),uri:O.uri.toJSON()}),I.deserialize=(O,j)=>({statement:j.statement,branch:j.branch,declaration:j.declaration,details:j.details?.map(g.deserialize),uri:O.asCanonicalUri(l.URI.revive(j.uri))})})(d||(e.IFileCoverage=d={}));function $(I){return{...I,location:I.location?.toJSON()}}function D(I){return I.location=I.location?N.$9s.isIPosition(I.location)?N.$9s.lift(I.location):L.$0s.lift(I.location):void 0,I}e.$7K=3;var b;(function(I){I[I.Declaration=0]="Declaration",I[I.Statement=1]="Statement",I[I.Branch=2]="Branch"})(b||(e.DetailType=b={}));var g;(function(I){I.serialize=O=>O.type===0?P.serialize(O):F.serialize(O),I.deserialize=O=>O.type===0?P.deserialize(O):F.deserialize(O)})(g||(e.CoverageDetails=g={}));var k;(function(I){I.serialize=$,I.deserialize=D})(k||(e.IBranchCoverage=k={}));var P;(function(I){I.serialize=$,I.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var F;(function(I){I.serialize=O=>({...$(O),branches:O.branches?.map(k.serialize)}),I.deserialize=O=>({...D(O),branches:O.branches?.map(k.deserialize)})})(F||(e.IStatementCoverage=F={}));var U;(function(I){I[I.Add=0]="Add",I[I.Update=1]="Update",I[I.DocumentSynced=2]="DocumentSynced",I[I.Remove=3]="Remove",I[I.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",I[I.Retire=5]="Retire",I[I.AddTag=6]="AddTag",I[I.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(I){I.deserialize=(O,j)=>j.op===0?{op:j.op,item:t.deserialize(O,j.item)}:j.op===1?{op:j.op,item:f.deserialize(j.item)}:j.op===2?{op:j.op,uri:O.asCanonicalUri(l.URI.revive(j.uri)),docv:j.docv}:j,I.serialize=O=>O.op===0?{op:O.op,item:t.serialize(O.item)}:O.op===1?{op:O.op,item:f.serialize(O.item)}:O})(z||(e.TestsDiffOp=z={}));class T{constructor(O){this.k=O,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(O){const j=this.v();for(const G of O)switch(G.op){case 0:this.l(t.deserialize(this.k,G.item),j);break;case 1:this.o(f.deserialize(G.item),j);break;case 3:this.p(G.itemId,j);break;case 5:this.q(G.itemId);break;case 4:this.updatePendingRoots(G.amount);break;case 6:this.c.set(G.tag.id,G.tag);break;case 7:this.c.delete(G.id);break}j.complete?.()}l(O,j){const G=A.$ZK.parentId(O.item.extId)?.toString();let te;if(!G)te=this.w(O),this.g.add(te),this.f.set(O.item.extId,te);else if(this.f.has(G)){const x=this.f.get(G);x.children.add(O.item.extId),te=this.w(O,x),this.f.set(O.item.extId,te)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(O)}`);return}return j.add?.(te),O.expand===2&&this.h++,te}o(O,j){const G=this.f.get(O.extId);if(G)return O.expand!==void 0&&(G.expand===2&&this.h--,O.expand===2&&this.h++),(0,e.$6K)(G,O),j.update?.(G),G}p(O,j){const G=this.f.get(O);if(!G)return;const te=A.$ZK.parentId(G.item.extId)?.toString();te?this.f.get(te).children.delete(G.item.extId):this.g.delete(G);const x=[[O]];for(;x.length;)for(const Z of x.pop()){const X=this.f.get(Z);X&&(x.push(X.children),this.f.delete(Z),j.remove?.(X,X!==G),X.expand===2&&this.h--)}}q(O){}updatePendingRoots(O){this.j+=O}v(){return{}}}e.$8K=T}),define(Se[112],De([1,0,8,4,3,61,89,66]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.TestItemEventOp=void 0;var p;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const E=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(i,n)=>!(i.length!==n.length||i.some(r=>!n.includes(r)))}),v=(i,n)=>{let r;for(const[c,t]of C)t(i[c],n[c])||(r?r[c]=n[c]:r={[c]:n[c]});return r};class S extends L.$Tc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new l.$sh(()=>this.flushDiff(),200)),this.g=this.B(new N.$6d),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const r of this.tree.values())this.J(r)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const r of this.m)if(r.op===2&&r.uri===n.uri){r.docv=n.docv;return}break}case 1:{const r=this.m[this.m.length-1];if(r){if(r.op===1&&r.item.extId===n.item.extId){(0,R.$6K)(r.item,n.item);return}if(r.op===0&&r.item.item.extId===n.item.extId){(0,R.$6K)(r.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,r){const c=this.tree.get(n);if(c){if((c.expandLevels===void 0||r>c.expandLevels)&&(c.expandLevels=r),c.expand===1){const t=this.M(c);return t.isOpen()?this.L(c,r-1):t.wait().then(()=>this.L(c,r-1))}else if(c.expand===3)return c.resolveBarrier?.isOpen()===!1?c.resolveBarrier.wait().then(()=>this.L(c,r-1)):this.L(c,r-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,r){switch(r.op){case 3:this.O(w.$ZK.joinToString(n.fullId,r.id));break;case 0:this.z(r.item,n);break;case 5:for(const c of r.ops)this.w(n,c);break;case 1:this.C(r.new,r.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:r.update}});break;case 6:this.y(n.actual.uri);break;default:(0,A.$9c)(r)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,r){const c=w.$ZK.fromExtHostTestItem(n,this.root.id,r?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==r?.actual&&this.s.getChildren(t.parent).delete(n.id);let f=this.tree.get(c.toString());if(!f){f={fullId:c,actual:n,expandLevels:r?.expandLevels?r.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(n,r),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(n)}}),this.I(n,f,r);return}if(f.actual===n){this.H(n,f,r);return}if(f.actual.uri?.toString()!==n.uri?.toString())return this.O(c.toString()),this.z(n,r);const h=this.s.getChildren(f.actual),s=f.actual,a=v(this.s.toITestItem(s),this.s.toITestItem(n));this.s.getApiFor(s).listener=void 0,f.actual=n,f.expand=0,a&&(a.hasOwnProperty("tags")&&(this.C(n.tags,s.tags,c.toString()),delete a.tags),this.w(f,{op:4,update:a})),this.I(n,f,r);for(const[d,$]of h)this.s.getChildren(n).get($.id)||this.O(w.$ZK.joinToString(c,$.id));this.y(f.actual.uri)}C(n,r,c){const t=new Set(r.map(f=>f.id));for(const f of n)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:c,item:{tags:n.map(f=>(0,R.$4K)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(n){const r=this.j.get(n.id);r?r.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$4K)(this.s.controllerId,n.id)}}))}F(n){const r=this.j.get(n);r&&!--r.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,R.$4K)(this.s.controllerId,n)}))}G(n,r){this.s.getApiFor(n).parent=r&&r.actual!==this.root?r.actual:void 0}H(n,r,c){this.G(n,c);const t=this.s.getApiFor(n);t.parent=c?.actual,t.listener=f=>this.w(r,f),this.J(r)}I(n,r,c){this.H(n,r,c);for(const[t,f]of this.s.getChildren(n))this.z(f,r)}J(n){let r;this.h?n.resolveBarrier?r=n.resolveBarrier.isOpen()?3:2:r=n.actual.canResolveChildren?1:0:r=0,r!==n.expand&&(n.expand=r,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:r}}),r===1&&n.expandLevels!==void 0&&this.M(n))}L(n,r){if(r<0)return;const c=[];for(const[t,f]of this.s.getChildren(n.actual)){const h=this.expand(w.$ZK.joinToString(n.fullId,f.id),r);(0,l.$5g)(h)&&c.push(h)}if(c.length)return Promise.all(c).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const f=new l.$fh;return f.open(),f}n.expand=2,this.N(n);const r=n.resolveBarrier=new l.$fh,c=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(f){c(f)}return(0,l.$5g)(t)?t.catch(c).then(()=>{r.open(),this.J(n)}):(r.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const r=this.tree.get(n);if(!r)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const c=[r];for(;c.length;){const t=c.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,h]of this.s.getChildren(t.actual))c.push(this.tree.get(w.$ZK.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$fO=S;class y extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$gO=y;class u extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$hO=u;class m extends Error{constructor(n,r,c){super(`TestItem with ID "${n}" is from controller "${r}" and cannot be added as a child of an item from controller "${c}".`)}}e.$iO=m;const o=(i,n,r)=>{let c=new Map;return{get size(){return c.size},forEach(t,f){for(const h of c.values())t.call(f,h,this)},[Symbol.iterator](){return c.entries()},replace(t){const f=new Map,h=new Set(c.keys()),s={op:5,ops:[]};for(const a of t){if(!(a instanceof r))throw new u(a.id);const d=n(a).controllerId;if(d!==i.controllerId)throw new m(a.id,d,i.controllerId);if(f.has(a.id))throw new y(a.id);f.set(a.id,a),h.delete(a.id),s.ops.push({op:0,item:a})}for(const a of h.keys())s.ops.push({op:3,id:a});i.listener?.(s),c=f},add(t){if(!(t instanceof r))throw new u(t.id);c.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){c.delete(t)&&i.listener?.({op:3,id:t})},get(t){return c.get(t)},toJSON(){return Array.from(c.values())}}};e.$jO=o}),define(Se[144],De([1,0,112]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0;const N=new WeakMap,L=(R,w)=>{const p={controllerId:w};return N.set(R,p),p};e.$kO=L;const A=R=>{const w=N.get(R);if(!w)throw new l.$hO(R?.id||"<unknown>");return w};e.$lO=A}),define(Se[113],De([1,0,15,2]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lxb=e.$Kxb=e.$Jxb=e.$Ixb=e.$Hxb=void 0,e.$Hxb="vscode-cdn.net",e.$Ixb=`vscode-resource.${e.$Hxb}`,e.$Jxb=`'self' https://*.${e.$Hxb}`;function L(w,p){return w.scheme===l.Schemas.http||w.scheme===l.Schemas.https?w:(p&&p.authority&&p.isRemote&&w.scheme===l.Schemas.file&&(w=N.URI.from({scheme:l.Schemas.vscodeRemote,authority:p.authority,path:w.path})),N.URI.from({scheme:l.Schemas.https,authority:`${w.scheme}+${A(w.authority)}.${e.$Ixb}`,path:w.path,fragment:w.fragment,query:w.query}))}e.$Kxb=L;function A(w){return w.replace(/./g,p=>{const E=p.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?p:"-"+E.toString(16).padStart(4,"0")})}function R(w){return w.replace(/-([0-9a-f]{4})/g,(p,E)=>String.fromCharCode(parseInt(E,16)))}e.$Lxb=R}),define(Se[293],De([1,0,4,3,113]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;class A{constructor(w,p,E){this.d=w,this.e=p,this.f=E,this.a=0,this.b=new N.$Sc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const M=p.getVisibleTextEditors();for(const C of this.c.values())M.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(w=>w.inset.dispose()),this.b.dispose()}createWebviewEditorInset(w,p,E,M,C){let v;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===w){v=n;break}if(!v)throw new Error("not a visible editor");const S=this,y=this.a++,u=new l.$6d,m=new l.$6d,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,L.$Kxb)(n,S.f)}get cspSource(){return L.$Jxb}set options(n){this.b=n,S.d.$setOptions(y,n)}get options(){return this.b}set html(n){this.a=n,S.d.$setHtml(y,n)}get html(){return this.a}get onDidReceiveMessage(){return u.event}postMessage(n){return S.d.$postMessage(y,n)}},i=new class{constructor(){this.editor=w,this.line=p,this.height=E,this.webview=o,this.onDidDispose=m.event}dispose(){S.c.has(y)&&(S.c.delete(y),S.d.$disposeEditorInset(y),m.fire(),m.dispose(),u.dispose())}};return this.d.$createEditorInset(y,v.id,v.value.document.uri,p+1,E,M||{},C.identifier,C.extensionLocation),this.c.set(y,{editor:w,inset:i,onDidReceiveMessage:u}),i}$onDidDispose(w){const p=this.c.get(w);p&&p.inset.dispose()}$onDidReceiveMessage(w,p){this.c.get(w)?.onDidReceiveMessage.fire(p)}}e.$kic=A}),define(Se[145],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eL=e.$dL=e.$cL=void 0,e.$cL="__",e.$dL=(0,l.$gi)("IAuthenticationService"),e.$eL=(0,l.$gi)("IAuthenticationExtensionsService")}),define(Se[294],De([1,0,5]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.VariableKind=e.$bP=void 0,e.$bP=(0,l.$gi)("configurationResolverService");var N;(function(A){A.Unknown="unknown",A.Env="env",A.Config="config",A.Command="command",A.Input="input",A.ExtensionInstallFolder="extensionInstallFolder",A.WorkspaceFolder="workspaceFolder",A.Cwd="cwd",A.WorkspaceFolderBasename="workspaceFolderBasename",A.UserHome="userHome",A.LineNumber="lineNumber",A.SelectedText="selectedText",A.File="file",A.FileWorkspaceFolder="fileWorkspaceFolder",A.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",A.RelativeFile="relativeFile",A.RelativeFileDirname="relativeFileDirname",A.FileDirname="fileDirname",A.FileExtname="fileExtname",A.FileBasename="fileBasename",A.FileBasenameNoExtension="fileBasenameNoExtension",A.FileDirnameBasename="fileDirnameBasename",A.ExecPath="execPath",A.ExecInstallFolder="execInstallFolder",A.PathSeparator="pathSeparator",A.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class L extends Error{constructor(R,w){super(w),this.variable=R}}e.$cP=L}),define(Se[295],De([1,0,17,50,18,24,11,103,237,294,14]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,y,u,m){this.h=new Map,this.a=S,this.b=y,this.g=u,m&&(this.c=m.then(o=>this.i(o)))}i(S){if(R.$i){const y=Object.create(null);return Object.keys(S).forEach(u=>{y[u.toLowerCase()]=S[u]}),y}return S}resolveWithEnvironment(S,y,u){return this.l({env:this.i(S),userHome:void 0},y?y.uri:void 0,u)}async resolveAsync(S,y){const u={env:await this.c,userHome:await this.g};return this.l(u,S?S.uri:void 0,y)}async j(S,y,u,m){const o=A.$Ln(y);R.$i&&o.windows?Object.keys(o.windows).forEach(n=>o[n]=o.windows[n]):R.$j&&o.osx?Object.keys(o.osx).forEach(n=>o[n]=o.osx[n]):R.$k&&o.linux&&Object.keys(o.linux).forEach(n=>o[n]=o.linux[n]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,S?S.uri:void 0,o,u,m)}async resolveAnyAsync(S,y,u){return this.j(S,y,u)}async resolveAnyMap(S,y,u){const m=new Map;return{newConfig:await this.j(S,y,u,m),resolvedVariables:m}}resolveWithInteractionReplace(S,y,u,m){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,y,u,m){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,y){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,y)}async l(S,y,u,m,o){if(L.$Tf(u))return this.m(S,y,u,m,o);if(Array.isArray(u))return Promise.all(u.map(i=>this.l(S,y,i,m,o)));if(L.$Vf(u)){const i=Object.create(null),n=await Promise.all(Object.keys(u).map(async r=>[await this.m(S,y,r,m,o),await this.l(S,y,u[r],m,o)]));for(const[r,c]of n)i[r]=c;return i}return u}m(S,y,u,m,o){return(0,M.$cf)(u,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let r=await this.o(S,i,n,y,m);return o?.set(n,r),r!==i&&L.$Tf(r)&&r.match(C.VARIABLE_REGEXP)&&(r=await this.m(S,y,r,m,o)),r})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,y,u,m,o){let i;const n=u.split(":");n.length>1&&(u=n[0],i=n[1]);const r=f=>{const h=this.a.getFilePath();if(h)return(0,w.$aw)(h);throw new E.$cP(f,(0,p.localize)(0,null,y))},c=f=>{const h=r(f);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,w.$aw)(s)}throw new E.$cP(f,(0,p.localize)(1,null,y,l.$nc(h)))},t=f=>{if(i){const h=this.a.getFolderUri(i);if(h)return h;throw new E.$cP(f,(0,p.localize)(2,null,y,i))}if(m)return m;throw this.a.getWorkspaceFolderCount()>1?new E.$cP(f,(0,p.localize)(3,null,y)):new E.$cP(f,(0,p.localize)(4,null,y))};switch(u){case"env":if(i){if(S.env){const f=S.env[R.$i?i.toLowerCase():i];if(L.$Tf(f))return f}return""}throw new E.$cP(E.VariableKind.Env,(0,p.localize)(5,null,y));case"config":if(i){const f=this.a.getConfigurationValue(m,i);if(L.$3f(f))throw new E.$cP(E.VariableKind.Config,(0,p.localize)(6,null,y,i));if(L.$Vf(f))throw new E.$cP(E.VariableKind.Config,(0,p.localize)(7,null,y,i));return f}throw new E.$cP(E.VariableKind.Config,(0,p.localize)(8,null,y));case"command":return this.p(E.VariableKind.Command,y,i,o,"command");case"input":return this.p(E.VariableKind.Input,y,i,o,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new E.$cP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,y,i));return this.n(f.extensionLocation)}throw new E.$cP(E.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,y));default:switch(u){case"workspaceRoot":case"workspaceFolder":return(0,w.$aw)(this.n(t(E.VariableKind.WorkspaceFolder)));case"cwd":return m||i?(0,w.$aw)(this.n(t(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,w.$aw)(l.$nc(this.n(t(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new E.$cP(E.VariableKind.UserHome,(0,p.localize)(11,null,y))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new E.$cP(E.VariableKind.LineNumber,(0,p.localize)(12,null,y))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new E.$cP(E.VariableKind.SelectedText,(0,p.localize)(13,null,y))}case"file":return r(E.VariableKind.File);case"fileWorkspaceFolder":return c(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return l.$nc(c(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return m||i?l.$lc(this.n(t(E.VariableKind.RelativeFile)),r(E.VariableKind.RelativeFile)):r(E.VariableKind.RelativeFile);case"relativeFileDirname":{const f=l.$mc(r(E.VariableKind.RelativeFileDirname));if(m||i){const h=l.$lc(this.n(t(E.VariableKind.RelativeFileDirname)),f);return h.length===0?".":h}return f}case"fileDirname":return l.$mc(r(E.VariableKind.FileDirname));case"fileExtname":return l.$oc(r(E.VariableKind.FileExtname));case"fileBasename":return l.$nc(r(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=l.$nc(r(E.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-l.$oc(f).length)}case"fileDirnameBasename":return l.$nc(l.$mc(r(E.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||y}case"execInstallFolder":{const f=this.a.getAppRoot();return f||y}case"pathSeparator":case"/":return l.sep;default:try{const f=i?`${u}:${i}`:u;return this.p(E.VariableKind.Unknown,y,f,o,void 0)}catch{return y}}}}p(S,y,u,m,o){if(u&&m){const i=o===void 0?m[u]:m[o+":"+u];if(typeof i=="string")return i;throw new E.$cP(S,(0,p.localize)(14,null,y))}return y}}e.$rP=C}),define(Se[146],De([1,0,5,142]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rD=e.$qD=e.OpenEditorContext=e.GroupsOrder=e.$pD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$oD=void 0,e.$oD=(0,l.$gi)("editorGroupsService");var L;(function(y){y[y.UP=0]="UP",y[y.DOWN=1]="DOWN",y[y.LEFT=2]="LEFT",y[y.RIGHT=3]="RIGHT"})(L||(e.GroupDirection=L={}));var A;(function(y){y[y.HORIZONTAL=0]="HORIZONTAL",y[y.VERTICAL=1]="VERTICAL"})(A||(e.GroupOrientation=A={}));var R;(function(y){y[y.FIRST=0]="FIRST",y[y.LAST=1]="LAST",y[y.NEXT=2]="NEXT",y[y.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var w;(function(y){y[y.MAXIMIZE=0]="MAXIMIZE",y[y.EXPAND=1]="EXPAND",y[y.EVEN=2]="EVEN"})(w||(e.GroupsArrangement=w={}));var p;(function(y){y[y.COPY_EDITORS=0]="COPY_EDITORS",y[y.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function E(y){const u=y;return(0,N.$$E)(u?.editor)&&(0,N.$$E)(u?.replacement)}e.$pD=E;var M;(function(y){y[y.CREATION_TIME=0]="CREATION_TIME",y[y.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",y[y.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(M||(e.GroupsOrder=M={}));var C;(function(y){y[y.NEW_EDITOR=1]="NEW_EDITOR",y[y.MOVE_EDITOR=2]="MOVE_EDITOR",y[y.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function v(y){const u=y;return!!u&&typeof u.id=="number"&&Array.isArray(u.editors)}e.$qD=v;function S(y){return y.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$rD=S}),define(Se[296],De([1,0,5,146]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=void 0,e.$sD=(0,l.$gi)("editorService"),e.$tD=-1,e.$uD=-2,e.$vD=-3;function L(A){const R=A;return typeof A=="number"||(0,N.$qD)(R)}e.$wD=L}),define(Se[147],De([1,0,5,136]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uL=void 0,e.$uL=(0,l.$hi)(N.$ni)}),define(Se[148],De([1,0,25,4,17,3,8]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$59b=e.$49b=e.$39b=e.$29b=e.$19b=void 0;class w{constructor(i,n){this.versionId=i,this.removedDueToLooping=n}}e.$19b=w;class p{static isHostExtension(i,n,r){if(n.getExtensionDescription(i))return!1;const c=r.getExtensionDescription(i);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(i,n){this.j=i,this.c=new N.$6d,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(u),this.f=new l.$Cm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const n=this.j.readActivationEvents(i);for(const r of n)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,n){this.e=m(this.e,n),this.e=this.e.concat(i);const r=p.l(this.e);return this.e=m(this.e,r.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new w(this.d,r)}static l(i){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,s){this.addNode(h),this.addNode(s),this.c.has(h)?this.c.get(h).push(s):this.c.set(h,[s])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,s){const a=n.getArcs(h);for(let d=0;d<a.length;d++)if(!s.has(a[d]))return!1;return!0}getNodes(){return this.e}},r=new l.$Cm;for(const h of i)if(r.set(h.identifier,h),h.extensionDependencies)for(const s of h.extensionDependencies)n.addArc(l.$Am.toKey(h.identifier),l.$Am.toKey(s));const c=new Set;n.getNodes().filter(h=>n.getArcs(h).length===0).forEach(h=>c.add(h));const t=n.getNodes().filter(h=>!c.has(h));let f;do{f=!1;for(let h=0;h<t.length;h++){const s=t[h];n.hasOnlyGoodArcs(s,c)&&(t.splice(h,1),h--,c.add(s),f=!0)}}while(f);return t.map(h=>r.get(h))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const n=this.h.get(i);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const n=this.f.get(i);return n||void 0}getExtensionDescriptionByUUID(i){for(const n of this.g)if(n.uuid===i)return n}getExtensionDescriptionByIdOrUUID(i,n){return this.getExtensionDescription(i)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$29b=p;class E{constructor(i,n){this.versionId=i,this.extensions=n}}e.$39b=E;class M{constructor(i){this.d=new S,this.c=new p(i,[])}async acquireLock(i){const n=await this.d.acquire(i);return new C(this,n)}deltaExtensions(i,n,r){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,r)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,n){return this.c.getExtensionDescriptionByIdOrUUID(i,n)}}e.$49b=M;class C extends A.$Tc{constructor(i,n){super(),this.f=i,this.c=!1,this.B(n)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$59b=C;class v{constructor(i){this.name=i;const n=(0,R.$_g)();this.promise=n.promise,this.c=n.resolve}resolve(i){this.c(i)}}class S{constructor(){this.c=[],this.d=!1}async acquire(i){const n=new v(i);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let n=!0;const r=setTimeout(()=>{n&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(r),n=!1,this.d=!1,this.e())};i.resolve((0,A.$Rc)(c))}}var y;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(y||(y={}));function u(o,i){const n=o.isBuiltin?0:o.isUnderDevelopment?2:1,r=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(n!==r)return n-r;const c=L.$gc.basename(o.extensionLocation.path),t=L.$gc.basename(i.extensionLocation.path);return c<t?-1:c>t?1:0}function m(o,i){const n=new l.$Bm(i);return o.filter(r=>!n.has(r.identifier))}}),define(Se[297],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.ExtHostConnectionType=void 0;var l;(function(M){M[M.IPC=1]="IPC",M[M.Socket=2]="Socket",M[M.MessagePort=3]="MessagePort"})(l||(e.ExtHostConnectionType=l={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$6m=N;class L{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[L.ENV_KEY]="1"}}e.$7m=L;class A{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[A.ENV_KEY]="1"}}e.$8m=A;function R(M){delete M[N.ENV_KEY],delete M[L.ENV_KEY],delete M[A.ENV_KEY]}function w(M,C){R(C),M.serialize(C)}e.$9m=w;function p(M){if(M[N.ENV_KEY])return E(M,new N(M[N.ENV_KEY]));if(M[L.ENV_KEY])return E(M,new L);if(M[A.ENV_KEY])return E(M,new A);throw new Error("No connection information defined in environment!")}e.$0m=p;function E(M,C){return R(M),C}}),define(Se[114],De([1,0,21]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Jm=e.$Im=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var L;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(L||(e.ExtensionHostExitCode=L={}));var A;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(A||(e.MessageType=A={}));function R(E){const M=l.$te.alloc(1);switch(E){case 0:M.writeUInt8(1,0);break;case 1:M.writeUInt8(2,0);break;case 2:M.writeUInt8(3,0);break}return M}e.$Im=R;function w(E,M){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return M===0;case 2:return M===1;case 3:return M===2;default:return!1}}e.$Jm=w;var p;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Se[90],De([1,0,5,4,12,27,114,86,87,24,2,3,223]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=e.$GO=void 0;let S=class extends C.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new N.$6d),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$6d),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=M.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:p.$6o,name:(0,v.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,L.$Cj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===L.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,n){const r=this.getTelemetryDetails(),c=new y(i,n,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,c]),c.apiTelemetryLogger}$initializeTelemetryLevel(o,i,n){this.f=o,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=u(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,w.$rm)((0,p.$_o)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((n,r)=>{const c=n.filter(t=>!t.isDisposed);c.length===0?this.r.delete(r):this.r.set(r,c)}),this.r.forEach(n=>{for(const r of n)r.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const r=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!r)return this.r.delete(o.value),!1;let c=!1;for(const t of r)t.ignoreUnhandledExtHostErrors||(t.logError(i),c=!0);return c}};e.$GO=S,e.$GO=S=Qe([Ve(0,A.$FO),Ve(1,L.$Bj)],S);class y{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,n,r,c,t,f){this.g=n,this.h=r,this.i=c,this.j=t,this.a=new N.$6d,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,p.$cp)(i,[]),this.c&&(i=(0,E.$On)(i,this.c)),this.b||(i=(0,E.$On)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const n={name:o.name,message:o.message,stack:o.stack,cause:o.cause},r=(0,p.$cp)(n,[]),c=new Error(r.message,{cause:r.cause});c.stack=r.stack,c.name=r.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(c,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$HO=y;function u(m){const o=Date.now()-new Date(m).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$IO=u,e.$JO=(0,l.$gi)("IExtHostTelemetry")}),define(Se[26],De([1,0,4,2,267,140,25,5]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6F=e.$5F=e.$4F=e.ActivationKind=e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.ExtensionHostStartup=e.$XF=e.$WF=e.$VF=e.$UF=void 0,e.$UF=Object.freeze({identifier:new R.$Am("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$VF="extensions.webWorker",e.$WF=(0,w.$gi)("extensionService");class p{constructor(c){this.dependency=c}}e.$XF=p;var E;(function(r){r[r.EagerAutoStart=1]="EagerAutoStart",r[r.EagerManualStart=2]="EagerManualStart",r[r.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class M{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(c,t,f){this.c=c,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:A.$FF.createActivationEventsMap(this.d)}}set(c,t,f){if(this.c>c)throw new Error(`ExtensionHostExtensions: invalid versionId ${c} (current: ${this.c})`);const h=[],s=[],a=[],d=[],$=C(this.d),D=C(t),b=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=D.get(U.identifier);if(!z){h.push(U.identifier),$.delete(U.identifier);continue}if(!b(U,z)){h.push(U.identifier),$.delete(U.identifier);continue}}for(const U of t){const z=$.get(U.identifier);if(!z){s.push(U);continue}if(!b(z,U)){h.push(z.identifier),$.delete(z.identifier);continue}}const g=new R.$Bm(this.e),k=new R.$Bm(f);for(const U of this.e)k.has(U)||a.push(U);for(const U of f)g.has(U)||d.push(U);const P=A.$FF.createActivationEventsMap(s),F={versionId:c,toRemove:h,toAdd:s,addActivationEvents:P,myToRemove:a,myToAdd:d};return this.delta(F),F}delta(c){if(this.c>=c.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:h,myToAdd:s}=c,a=new R.$Bm(t),d=new R.$Bm(h);for(let $=0;$<this.d.length;$++)a.has(this.d[$].identifier)&&(this.d.splice($,1),$--);for(let $=0;$<this.e.length;$++)d.has(this.e[$])&&(this.e.splice($,1),$--);for(const $ of f)this.d.push($);for(const $ of s)this.e.push($);return this.f=null,c}containsExtension(c){for(const t of this.e)if(R.$Am.equals(t,c))return!0;return!1}containsActivationEvent(c){return this.f||(this.f=this.g()),this.f.has(c)}g(){const c=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=A.$FF.readActivationEvents(t);for(const h of f)c.add(h)}return c}}e.$YF=M;function C(r){const c=new R.$Cm;for(const t of r)c.set(t.identifier,t);return c}function v(r,c){return r.enabledApiProposals?r.enabledApiProposals.includes(c):!1}e.$ZF=v;function S(r,c){if(!v(r,c))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${c}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${c}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.$1F=S;class y{constructor(c,t,f,h){this.codeLoadingTime=c,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=h}}e.$2F=y;class u{constructor(c,t){this.description=c,this.value=t}}e.$3F=u;var m;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(m||(e.ActivationKind=m={}));function o(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,L.$ip)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.$4F=o;function i(r,c){return{identifier:new R.$Am((0,L.$gp)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!c,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.$5F=i;class n{constructor(){this.onDidRegisterExtensions=l.Event.None,this.onDidChangeExtensionsStatus=l.Event.None,this.onDidChangeExtensions=l.Event.None,this.onWillActivateByEvent=l.Event.None,this.onDidChangeResponsiveChange=l.Event.None,this.onWillStop=l.Event.None,this.extensions=[]}activateByEvent(c){return Promise.resolve(void 0)}activateById(c,t){return Promise.resolve(void 0)}activationEventIsDone(c){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(c,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$6F=n}),define(Se[298],De([1,0,13,148,25,26,12,8]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=e.$Kic=e.$Jic=e.$Iic=e.$Hic=e.$Gic=void 0;class p{static{this.NONE=new p(!1,-1,-1,-1)}constructor(o,i,n,r){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=r}}e.$Gic=p;class E{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Hic=E;class M{constructor(o,i,n,r,c,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=n,this.module=r,this.exports=c,this.subscriptions=t}}e.$Iic=M;class C extends M{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Jic=C;class v extends M{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Kic=v;class S extends M{constructor(o){super(!0,o,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let y=class{constructor(o,i,n,r){this.g=r,this.a=o,this.b=i,this.c=n,this.d=new L.$Cm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,n]of this.d)o.push(n.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const n=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(n.map(r=>({id:r.identifier,reason:{startup:i,extensionId:r.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const n=this.a.getExtensionDescription(o);if(!n)throw new Error(`Extension '${o}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(o){const i=o.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const c=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new S(c));return this.c.onExtensionActivationError(o.id,c,new A.$XF(o.id.value)),t}const n=[],r=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const c of r){if(this.m(c))continue;const t=this.d.get(c);if(t){n.push(t);continue}if(this.l(c)){n.push(this.j({id:this.b.getExtensionDescription(c).identifier,reason:o.reason}));continue}const f=this.a.getExtensionDescription(c);if(f){if(!f.main&&!f.browser)continue;n.push(this.j({id:f.identifier,reason:o.reason}));continue}const h=i.displayName||i.identifier.value,s=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${c}'`),a=this.k(o,i.displayName,[],new S(s));return this.c.onExtensionActivationError(i.identifier,s,new A.$XF(c)),a}return this.k(o,i.displayName,n,null)}k(o,i,n,r){const c=new u(o.id,i,o.reason,n,r,this.c,this.g);return this.d.set(o.id,c),c}l(o){return N.$29b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$Lic=y,e.$Lic=y=Qe([Ve(3,R.$Aj)],y);let u=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,n,r,c,t,f){this.c=o,this.d=i,this.f=n,this.g=r,this.h=c,this.j=t,this.k=f,this.a=new w.$fh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new S(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new S(i),this.b&&l.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};u=Qe([Ve(6,R.$Aj)],u)}),define(Se[299],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[300],De([1,0,239,13,39,137,109,37,25,299,139,140]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.$OF=void 0;const v=w.$Xn.as(R.$Yn.JSONContribution);class S{constructor(c,t,f){this.a=c,this.b=t,this.c=f}d(c,t){this.a({type:c,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(c){this.d(L.default.Error,c)}warn(c){this.d(L.default.Warning,c)}info(c){this.d(L.default.Info,c)}}e.$OF=S;class y{static a(c){const t=new p.$Bm;for(let f=0,h=c.length;f<h;f++)t.add(c[f].description.identifier);return t}static compute(c,t){if(!c||!c.length)return new y(t,[]);if(!t||!t.length)return new y([],c);const f=this.a(c),h=this.a(t),s=t.filter(d=>!f.has(d.description.identifier)),a=c.filter(d=>!h.has(d.description.identifier));return new y(s,a)}constructor(c,t){this.added=c,this.removed=t}}e.$PF=y;class u{constructor(c,t){this.name=c,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(c){if(this.a!==null)throw new Error("Handler already set!");this.a=c,this.d()}acceptUsers(c){this.c=y.compute(this.b,c),this.b=c,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(c){(0,N.$1)(c)}}}e.$QF=u;const m={type:"string",enum:["ui","workspace"],enumDescriptions:[l.localize(0,null),l.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$RF={properties:{engines:{type:"object",description:l.localize(2,null),properties:{vscode:{type:"string",description:l.localize(3,null),default:"^1.22.0"}}},publisher:{description:l.localize(4,null),type:"string"},displayName:{description:l.localize(5,null),type:"string"},categories:{description:l.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$zm},{type:"string",const:"Languages",deprecationMessage:l.localize(7,null)}]}},galleryBanner:{type:"object",description:l.localize(8,null),properties:{color:{description:l.localize(9,null),type:"string"},theme:{description:l.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:l.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:l.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:l.localize(13,null)},enabledApiProposals:{markdownDescription:l.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:l.localize(15,null),type:"string",enum:["none"],enumDescriptions:[l.localize(16,null)]},activationEvents:{description:l.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:l.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:l.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:l.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:l.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:l.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:l.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:l.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:l.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:l.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:l.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:l.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:l.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:l.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:l.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:l.localize(32,null)},{label:"onUri",body:"onUri",description:l.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:l.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:l.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:l.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:l.localize(37,null)},{label:"onRenderer",description:l.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:l.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:l.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:l.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:l.localize(42,null)},{label:"*",description:l.localize(43,null),body:"*"}]}},badges:{type:"array",description:l.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:l.localize(45,null)},href:{type:"string",description:l.localize(46,null)},description:{type:"string",description:l.localize(47,null)}}}},markdown:{type:"string",description:l.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:l.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:l.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Co}},extensionPack:{description:l.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:A.$Co}},extensionKind:{description:l.localize(52,null),type:"array",items:m,default:["workspace"],defaultSnippets:[{body:["ui"],description:l.localize(53,null)},{body:["workspace"],description:l.localize(54,null)},{body:["ui","workspace"],description:l.localize(55,null)},{body:["workspace","ui"],description:l.localize(56,null)},{body:[],description:l.localize(57,null)}]},capabilities:{description:l.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:l.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:l.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(61,null),l.localize(62,null),l.localize(63,null)]},description:{type:"string",markdownDescription:l.localize(64,null)}}},untrustedWorkspaces:{description:l.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:l.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[l.localize(67,null),l.localize(68,null),l.localize(69,null)]},restrictedConfigurations:{description:l.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:l.localize(71,null)}}}}},sponsor:{description:l.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:l.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:l.localize(74,null),type:"string"},"vscode:uninstall":{description:l.localize(75,null),type:"string"}}},icon:{type:"string",description:l.localize(76,null)},l10n:{type:"string",description:l.localize(77,null)},pricing:{type:"string",markdownDescription:l.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(c){if(this.a.has(c.extensionPoint))throw new Error("Duplicate extension point: "+c.extensionPoint);const t=new u(c.extensionPoint,c.defaultExtensionKind);return this.a.set(c.extensionPoint,t),c.activationEventsGenerator&&C.$FF.register(c.extensionPoint,c.activationEventsGenerator),e.$RF.properties.contributes.properties[c.extensionPoint]=c.jsonSchema,v.registerSchema(o,e.$RF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$SF=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};w.$Xn.add(n.ExtensionsRegistry,new i),e.$TF=w.$Xn.as(n.ExtensionsRegistry),v.registerSchema(o,e.$RF),v.registerSchema(M.$Tj,{properties:{extensionEnabledApiProposals:{description:l.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Se[301],De([1,0,235,18,24,300,45,4]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iH=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:l.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:l.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:l.localize(2,null),default:""}}};var E;(function(v){function S(y,u,m){if(!y)return;const o=N.$Tf(y.type)?y.type:void 0;if(!o||o.length===0){m.error(l.localize(3,null));return}const i=[];if(Array.isArray(y.required))for(const n of y.required)N.$Tf(n)&&i.push(n);return{extensionId:u.value,taskType:o,required:i,properties:y.properties?L.$Ln(y.properties):{},when:y.when?R.$ej.deserialize(y.when):void 0}}v.from=S})(E||(E={}));const M=A.$TF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,S)=>{for(const y of v)y.type&&S.push(`onTaskType:${y.type}`)},jsonSchema:{description:l.localize(4,null),type:"array",items:p}});class C{constructor(){this.d=new w.$6d,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,y)=>{M.setHandler((u,m)=>{this.c=void 0;try{for(const o of m.removed){const i=o.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const o of m.added){const i=o.value;for(const n of i){const r=E.from(n,o.description.identifier,o.collector);r&&(this.a[r.taskType]=r)}}(m.removed.length>0||m.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const y of this.all()){const u={type:"object",additionalProperties:!1};y.required.length>0&&(u.required=y.required.slice(0)),y.properties!==void 0?u.properties=L.$Ln(y.properties):u.properties=Object.create(null),u.properties.type={type:"string",enum:[y.taskType]},S.push(u)}this.c={oneOf:S}}return this.c}}e.$iH=new C}),define(Se[302],De([1,0,236,18,23,24,45,301]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$sH=e.JsonSchemaVersion=e.ExecutionEngine=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$mH=e.ShellQuoting=e.$lH=e.$kH=e.$jH=void 0,e.$jH="settings",e.$kH=new R.$xj("taskRunning",!1,l.localize(0,null)),e.$lH=l.localize2(2,"Tasks");var p;(function(I){I[I.Escape=1]="Escape",I[I.Strong=2]="Strong",I[I.Weak=3]="Weak"})(p||(e.ShellQuoting=p={})),e.$mH="$customized",function(I){function O(j){if(!j)return I.Strong;switch(j.toLowerCase()){case"escape":return I.Escape;case"strong":return I.Strong;case"weak":return I.Weak;default:return I.Strong}}I.from=O}(p||(e.ShellQuoting=p={}));var E;(function(I){I.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var M;(function(I){I[I.Always=1]="Always",I[I.Silent=2]="Silent",I[I.Never=3]="Never"})(M||(e.RevealKind=M={})),function(I){function O(j){switch(j.toLowerCase()){case"always":return I.Always;case"silent":return I.Silent;case"never":return I.Never;default:return I.Always}}I.fromString=O}(M||(e.RevealKind=M={}));var C;(function(I){I[I.Never=1]="Never",I[I.OnProblem=2]="OnProblem",I[I.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(I){function O(j){switch(j.toLowerCase()){case"always":return I.Always;case"never":return I.Never;case"onproblem":return I.OnProblem;default:return I.OnProblem}}I.fromString=O}(C||(e.RevealProblemKind=C={}));var v;(function(I){I[I.Shared=1]="Shared",I[I.Dedicated=2]="Dedicated",I[I.New=3]="New"})(v||(e.PanelKind=v={})),function(I){function O(j){switch(j.toLowerCase()){case"shared":return I.Shared;case"dedicated":return I.Dedicated;case"new":return I.New;default:return I.Shared}}I.fromString=O}(v||(e.PanelKind=v={}));var S;(function(I){I.defaults={echo:!0,reveal:M.Always,revealProblems:C.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var y;(function(I){I[I.Shell=1]="Shell",I[I.Process=2]="Process",I[I.CustomExecution=3]="CustomExecution"})(y||(e.RuntimeType=y={})),function(I){function O(G){switch(G.toLowerCase()){case"shell":return I.Shell;case"process":return I.Process;case"customExecution":return I.CustomExecution;default:return I.Process}}I.fromString=O;function j(G){switch(G){case I.Shell:return"shell";case I.Process:return"process";case I.CustomExecution:return"customExecution";default:return"process"}}I.toString=j}(y||(e.RuntimeType=y={}));var u;(function(I){function O(j){return N.$Tf(j)?j:j.value}I.value=O})(u||(e.CommandString=u={}));var m;(function(I){I.Clean={_id:"clean",isDefault:!1},I.Build={_id:"build",isDefault:!1},I.Rebuild={_id:"rebuild",isDefault:!1},I.Test={_id:"test",isDefault:!1};function O(G){return G===I.Clean._id||G===I.Build._id||G===I.Rebuild._id||G===I.Test._id}I.is=O;function j(G){if(G!==void 0)return N.$Tf(G)?O(G)?{_id:G,isDefault:!1}:void 0:G}I.from=j})(m||(e.TaskGroup=m={}));var o;(function(I){I[I.Global=1]="Global",I[I.Workspace=2]="Workspace",I[I.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(I){I.Workspace="workspace",I.Extension="extension",I.InMemory="inMemory",I.WorkspaceFile="workspaceFile",I.User="user";function O(j){switch(j){case I.User:return 2;case I.WorkspaceFile:return 5;default:return 6}}I.toConfigurationTarget=O})(i||(e.TaskSourceKind=i={}));var n;(function(I){I.parallel="parallel",I.sequence="sequence"})(n||(e.DependsOrder=n={}));var r;(function(I){I[I.default=1]="default",I[I.folderOpen=2]="folderOpen"})(r||(e.RunOnOptions=r={}));var c;(function(I){I.defaults={reevaluateOnRerun:!0,runOn:r.default,instanceLimit:1}})(c||(e.RunOptions=c={}));class t{constructor(O,j,G,te,x,Z){this._label="",this._id=O,j&&(this._label=j),G&&(this.type=G),this.runOptions=te,this.configurationProperties=x,this._source=Z}getDefinition(O){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const O={folder:this.d(),id:this._id};return JSON.stringify(O)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(O,j=!1){if(O===void 0)return!1;if(N.$Tf(O))return O===this._label||O===this.configurationProperties.identifier||j&&O===this._id;const G=this.getDefinition(!0);return G!==void 0&&G._key===O._key}getQualifiedLabel(){const O=this.getWorkspaceFolder();return O?`${this._label} (${O.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(O){this.c===void 0&&(this.c=[]),O&&(this.c=this.c.concat(O))}get taskLoadMessages(){return this.c}}e.$nH=t;class f extends t{constructor(O,j,G,te,x,Z,X,ae){super(O,G,void 0,X,ae,j),this.command={},this._source=j,this.hasDefinedMatchers=Z,x&&(this.command=x)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(O=!1){if(O&&this._source.customizes!==void 0)return this._source.customizes;{let j;switch(this.command?this.command.runtime:void 0){case y.Shell:j="shell";break;case y.Process:j="process";break;case y.CustomExecution:j="customExecution";break;case void 0:j="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:j,_key:this._id,id:this._id}}}static is(O){return O instanceof f}getMapKey(){const O=this._source.config.workspaceFolder;return O?`${O.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$jH:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const O=this.d();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const G={type:e.$mH,folder:O,id:j};return JSON.stringify(G)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Qg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(O){return new f(O._id,O._source,O._label,O.type,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$oH=f;class h extends t{constructor(O,j,G,te,x,Z,X){super(O,G,te,Z,X,j),this._source=j,this.configures=x}static is(O){return O instanceof h}f(O){return O}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?L.$Qg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$jH:this._source.config.workspaceFolder?.uri.toString()}getKey(){const O=this.d();if(!O)return;let j=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(j+=this._source.kind);const G={type:e.$mH,folder:O,id:j};return JSON.stringify(G)}}e.$pH=h;class s extends t{constructor(O,j,G,te,x,Z,X,ae,_){super(O,G,te,ae,_,j),this.defines=x,this.hasDefinedMatchers=X,this.command=Z,this.icon=_.icon,this.hide=_.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(O){return O instanceof s}getMapKey(){const O=this._source.workspaceFolder;return O?`${this._source.scope.toString()}|${O.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const O={type:"contributed",scope:this._source.scope,id:this._id};return O.folder=this.d(),JSON.stringify(O)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(O){return new s(O._id,O._source,O._label,O.type,O.defines,O.command,O.hasDefinedMatchers,O.runOptions,O.configurationProperties)}}e.$qH=s;class a extends t{constructor(O,j,G,te,x,Z){super(O,G,te,x,Z,j),this._source=j}clone(){return new a(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(O){return O instanceof a}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(O){return new a(O._id,O._source,O._label,O.type,O.runOptions,O.configurationProperties)}}e.$rH=a;var d;(function(I){I[I.Process=1]="Process",I[I.Terminal=2]="Terminal"})(d||(e.ExecutionEngine=d={})),function(I){I._default=I.Terminal}(d||(e.ExecutionEngine=d={}));var $;(function(I){I[I.V0_1_0=1]="V0_1_0",I[I.V2_0_0=2]="V2_0_0"})($||(e.JsonSchemaVersion=$={}));class D{constructor(O){this.c=new Map;for(let j=0;j<O.length;j++)this.c.set(O[j].uri.toString(),j)}compare(O,j){const G=O.getWorkspaceFolder(),te=j.getWorkspaceFolder();if(G&&te){let x=this.c.get(G.uri.toString());x=x===void 0?0:x+1;let Z=this.c.get(te.uri.toString());return Z=Z===void 0?0:Z+1,x===Z?O._label.localeCompare(j._label):x-Z}else return!G&&te?-1:G&&!te?1:0}}e.$sH=D;var b;(function(I){I.DependsOnStarted="dependsOnStarted",I.AcquiredInput="acquiredInput",I.Start="start",I.ProcessStarted="processStarted",I.Active="active",I.Inactive="inactive",I.Changed="changed",I.Terminated="terminated",I.ProcessEnded="processEnded",I.End="end"})(b||(e.TaskEventKind=b={}));var g;(function(I){I.SingleRun="singleRun",I.Background="background"})(g||(e.TaskRunType=g={}));var k;(function(I){I[I.System=0]="System",I[I.User=1]="User",I[I.FolderOpen=2]="FolderOpen",I[I.ConfigurationChange=3]="ConfigurationChange",I[I.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var P;(function(I){function O(ae){return{taskId:ae._id,taskName:ae.configurationProperties.name,runType:ae.configurationProperties.isBackground?"background":"singleRun",group:ae.configurationProperties.group,__task:ae}}function j(ae,_,ge){return{...O(ae),kind:"start",terminalId:_,resolvedVariables:ge}}I.start=j;function G(ae,_,ge){return{...O(ae),kind:"processStarted",terminalId:_,processId:ge}}I.processStarted=G;function te(ae,_,ge){return{...O(ae),kind:"processEnded",terminalId:_,exitCode:ge}}I.processEnded=te;function x(ae,_,ge){return{...O(ae),kind:"terminated",exitReason:ge,terminalId:_}}I.terminated=x;function Z(ae,_,ge){return{...O(_),kind:ae,terminalId:ge}}I.general=Z;function X(){return{kind:"changed"}}I.changed=X})(P||(e.TaskEvent=P={}));var F;(function(I){function O(G){const te=Object.keys(G).sort();let x="";for(const Z of te){let X=G[Z];X instanceof Object?X=O(X):typeof X=="string"&&(X=X.replace(/,/g,",,")),x+=Z+","+X+","}return x}function j(G){const x={_key:O(G),type:G.taskType};return Object.assign(x,G),x}I.create=j})(F||(e.KeyedTaskIdentifier=F={}));var U;(function(I){I.AutoDetect="task.autoDetect",I.SaveBeforeRun="task.saveBeforeRun",I.ShowDecorations="task.showDecorations",I.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",I.SlowProviderWarning="task.slowProviderWarning",I.QuickOpenHistory="task.quickOpen.history",I.QuickOpenDetail="task.quickOpen.detail",I.QuickOpenSkip="task.quickOpen.skip",I.QuickOpenShowAll="task.quickOpen.showAll",I.AllowAutomaticTasks="task.allowAutomaticTasks",I.Reconnection="task.reconnection",I.VerboseLogging="task.verboseLogging"})(U||(e.TaskSettingId=U={}));var z;(function(I){I.Tasks="tasks",I.SuppressTaskName="tasks.suppressTaskName",I.Windows="tasks.windows",I.Osx="tasks.osx",I.Linux="tasks.linux",I.ShowOutput="tasks.showOutput",I.IsShellCommand="tasks.isShellCommand",I.ServiceTestSetting="tasks.service.testSetting"})(z||(e.TasksSchemaProperties=z={}));var T;(function(I){function O(j,G){const te=w.$iH.get(j.type);if(te===void 0){const ae=A.$Ln(j);return delete ae._key,F.create(ae)}const x=Object.create(null);x.type=te.taskType;const Z=new Set;te.required.forEach(ae=>Z.add(ae));const X=te.properties;for(const ae of Object.keys(X)){const _=j[ae];if(_!=null)x[ae]=_;else if(Z.has(ae)){const ge=X[ae];if(ge.default!==void 0)x[ae]=A.$Ln(ge.default);else switch(ge.type){case"boolean":x[ae]=!1;break;case"number":case"integer":x[ae]=0;break;case"string":x[ae]="";break;default:G.error(l.localize(1,null,JSON.stringify(j,void 0,0),ae));return}}}return F.create(x)}I.createTaskIdentifier=O})(T||(e.TaskDefinition=T={}))}),define(Se[303],De([1,0,13]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$79b=e.$69b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,w)=>{this.b=R,this.d=w,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,l.$1)(R))}then(R,w){return this.j().then(R,w)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$69b=N;class L extends N{constructor(){super(),this.h=!0,this.i=new l.$5}}e.$79b=L}),define(Se[67],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.$8v=e.$7v=void 0;class l{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++l.count}}e.$7v=l;const N=[];function L(w){const p=new l(w);return N[p.nid]=p,p}e.$8v=L;function A(w){return N[w].sid}e.$9v=A;class R{constructor(p){this.value=p}}e.$0v=R}),define(Se[6],De([1,0,67]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$9L=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var L;(function(u){u[u.UnknownInput=0]="UnknownInput",u[u.TextInput=1]="TextInput",u[u.TextDiffInput=2]="TextDiffInput",u[u.TextMergeInput=3]="TextMergeInput",u[u.NotebookInput=4]="NotebookInput",u[u.NotebookDiffInput=5]="NotebookDiffInput",u[u.CustomEditorInput=6]="CustomEditorInput",u[u.WebviewEditorInput=7]="WebviewEditorInput",u[u.TerminalEditorInput=8]="TerminalEditorInput",u[u.InteractiveEditorInput=9]="InteractiveEditorInput",u[u.ChatEditorInput=10]="ChatEditorInput"})(L||(e.TabInputKind=L={}));var A;(function(u){u[u.TAB_OPEN=0]="TAB_OPEN",u[u.TAB_CLOSE=1]="TAB_CLOSE",u[u.TAB_UPDATE=2]="TAB_UPDATE",u[u.TAB_MOVE=3]="TAB_MOVE"})(A||(e.TabModelOperationKind=A={}));var R;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var w;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(w||(e.WebviewMessageArrayBufferViewType=w={}));var p;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var E;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var M;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(M||(e.CandidatePortSource=M={}));class C{static{this.a=0}static mixin(m){return m._id=C.a++,m}}e.$9L=C;var v;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.kindModifier="m",u.commandIdent="n",u.commandId="o",u.commandArguments="p"})(v||(e.ISuggestDataDtoField=v={}));var S;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var y;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(y||(e.ExtHostTestingResource=y={})),e.$0L={MainThreadAuthentication:(0,l.$8v)("MainThreadAuthentication"),MainThreadBulkEdits:(0,l.$8v)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,l.$8v)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,l.$8v)("MainThreadChatAgents2"),MainThreadChatVariables:(0,l.$8v)("MainThreadChatVariables"),MainThreadClipboard:(0,l.$8v)("MainThreadClipboard"),MainThreadCommands:(0,l.$8v)("MainThreadCommands"),MainThreadComments:(0,l.$8v)("MainThreadComments"),MainThreadConfiguration:(0,l.$8v)("MainThreadConfiguration"),MainThreadConsole:(0,l.$8v)("MainThreadConsole"),MainThreadDebugService:(0,l.$8v)("MainThreadDebugService"),MainThreadDecorations:(0,l.$8v)("MainThreadDecorations"),MainThreadDiagnostics:(0,l.$8v)("MainThreadDiagnostics"),MainThreadDialogs:(0,l.$8v)("MainThreadDiaglogs"),MainThreadDocuments:(0,l.$8v)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,l.$8v)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,l.$8v)("MainThreadTextEditors"),MainThreadEditorInsets:(0,l.$8v)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,l.$8v)("MainThreadEditorTabs"),MainThreadErrors:(0,l.$8v)("MainThreadErrors"),MainThreadTreeViews:(0,l.$8v)("MainThreadTreeViews"),MainThreadDownloadService:(0,l.$8v)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,l.$8v)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,l.$8v)("MainThreadLanguages"),MainThreadLogger:(0,l.$8v)("MainThreadLogger"),MainThreadMessageService:(0,l.$8v)("MainThreadMessageService"),MainThreadOutputService:(0,l.$8v)("MainThreadOutputService"),MainThreadProgress:(0,l.$8v)("MainThreadProgress"),MainThreadQuickDiff:(0,l.$8v)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,l.$8v)("MainThreadQuickOpen"),MainThreadStatusBar:(0,l.$8v)("MainThreadStatusBar"),MainThreadSecretState:(0,l.$8v)("MainThreadSecretState"),MainThreadStorage:(0,l.$8v)("MainThreadStorage"),MainThreadSpeech:(0,l.$8v)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,l.$8v)("MainThreadTelemetry"),MainThreadTerminalService:(0,l.$8v)("MainThreadTerminalService"),MainThreadWebviews:(0,l.$8v)("MainThreadWebviews"),MainThreadWebviewPanels:(0,l.$8v)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,l.$8v)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,l.$8v)("MainThreadCustomEditors"),MainThreadUrls:(0,l.$8v)("MainThreadUrls"),MainThreadUriOpeners:(0,l.$8v)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,l.$8v)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,l.$8v)("MainThreadWorkspace"),MainThreadFileSystem:(0,l.$8v)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,l.$8v)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,l.$8v)("MainThreadExtensionService"),MainThreadSCM:(0,l.$8v)("MainThreadSCM"),MainThreadSearch:(0,l.$8v)("MainThreadSearch"),MainThreadShare:(0,l.$8v)("MainThreadShare"),MainThreadTask:(0,l.$8v)("MainThreadTask"),MainThreadWindow:(0,l.$8v)("MainThreadWindow"),MainThreadLabelService:(0,l.$8v)("MainThreadLabelService"),MainThreadNotebook:(0,l.$8v)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,l.$8v)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,l.$8v)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,l.$8v)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,l.$8v)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,l.$8v)("MainThreadInteractive"),MainThreadChat:(0,l.$8v)("MainThreadChat"),MainThreadInlineChat:(0,l.$8v)("MainThreadInlineChatShape"),MainThreadTheming:(0,l.$8v)("MainThreadTheming"),MainThreadTunnelService:(0,l.$8v)("MainThreadTunnelService"),MainThreadManagedSockets:(0,l.$8v)("MainThreadManagedSockets"),MainThreadTimeline:(0,l.$8v)("MainThreadTimeline"),MainThreadTesting:(0,l.$8v)("MainThreadTesting"),MainThreadLocalization:(0,l.$8v)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,l.$8v)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,l.$8v)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,l.$8v)("MainThreadIssueReporter")},e.$$L={ExtHostCommands:(0,l.$8v)("ExtHostCommands"),ExtHostConfiguration:(0,l.$8v)("ExtHostConfiguration"),ExtHostDiagnostics:(0,l.$8v)("ExtHostDiagnostics"),ExtHostDebugService:(0,l.$8v)("ExtHostDebugService"),ExtHostDecorations:(0,l.$8v)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,l.$8v)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,l.$8v)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,l.$8v)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,l.$8v)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,l.$8v)("ExtHostEditors"),ExtHostTreeViews:(0,l.$8v)("ExtHostTreeViews"),ExtHostFileSystem:(0,l.$8v)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,l.$8v)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,l.$8v)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,l.$8v)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,l.$8v)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,l.$8v)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,l.$8v)("ExtHostQuickDiff"),ExtHostStatusBar:(0,l.$8v)("ExtHostStatusBar"),ExtHostShare:(0,l.$8v)("ExtHostShare"),ExtHostExtensionService:(0,l.$8v)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,l.$8v)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,l.$8v)("ExtHostTerminalService"),ExtHostSCM:(0,l.$8v)("ExtHostSCM"),ExtHostSearch:(0,l.$8v)("ExtHostSearch"),ExtHostTask:(0,l.$8v)("ExtHostTask"),ExtHostWorkspace:(0,l.$8v)("ExtHostWorkspace"),ExtHostWindow:(0,l.$8v)("ExtHostWindow"),ExtHostWebviews:(0,l.$8v)("ExtHostWebviews"),ExtHostWebviewPanels:(0,l.$8v)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,l.$8v)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,l.$8v)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,l.$8v)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,l.$8v)("ExtHostEditorTabs"),ExtHostProgress:(0,l.$8v)("ExtHostProgress"),ExtHostComments:(0,l.$8v)("ExtHostComments"),ExtHostSecretState:(0,l.$8v)("ExtHostSecretState"),ExtHostStorage:(0,l.$8v)("ExtHostStorage"),ExtHostUrls:(0,l.$8v)("ExtHostUrls"),ExtHostUriOpeners:(0,l.$8v)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,l.$8v)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,l.$8v)("ExtHostOutputService"),ExtHostLabelService:(0,l.$8v)("ExtHostLabelService"),ExtHostNotebook:(0,l.$8v)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,l.$8v)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,l.$8v)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,l.$8v)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,l.$8v)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,l.$8v)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,l.$8v)("ExtHostInteractive"),ExtHostInlineChat:(0,l.$8v)("ExtHostInlineChatShape"),ExtHostChat:(0,l.$8v)("ExtHostChat"),ExtHostChatAgents2:(0,l.$8v)("ExtHostChatAgents"),ExtHostChatVariables:(0,l.$8v)("ExtHostChatVariables"),ExtHostChatProvider:(0,l.$8v)("ExtHostChatProvider"),ExtHostSpeech:(0,l.$8v)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,l.$8v)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,l.$8v)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,l.$8v)("ExtHostTheming"),ExtHostTunnelService:(0,l.$8v)("ExtHostTunnelService"),ExtHostManagedSockets:(0,l.$8v)("ExtHostManagedSockets"),ExtHostAuthentication:(0,l.$8v)("ExtHostAuthentication"),ExtHostTimeline:(0,l.$8v)("ExtHostTimeline"),ExtHostTesting:(0,l.$8v)("ExtHostTesting"),ExtHostTelemetry:(0,l.$8v)("ExtHostTelemetry"),ExtHostLocalization:(0,l.$8v)("ExtHostLocalization"),ExtHostIssueReporter:(0,l.$8v)("ExtHostIssueReporter")}}),define(Se[91],De([1,0,5,12,6,20]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=e.$3hc=void 0,e.$3hc=(0,l.$gi)("IExtHostApiDeprecationService");let R=class{constructor(p,E){this.c=E,this.a=new Set,this.b=p.getProxy(L.$0L.MainThreadTelemetry)}report(p,E,M){const C=this.d(p,E);this.a.has(C)||(this.a.add(C),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${M}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:p}))}d(p,E){return`${p}-${E.identifier.value}`}};e.$4hc=R,e.$4hc=R=Qe([Ve(0,A.$pO),Ve(1,N.$Aj)],R),e.$5hc=Object.freeze(new class{report(w,p,E){}})}),define(Se[304],De([1,0,48,3,6]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class A{static{this.a=0}constructor(p,E){this.extension=p,this.provider=E,this.handle=A.a++}}class R{static{this.a=0}constructor(p){this.b=new Map,this.c=new Map,this.d=p.getProxy(L.$0L.MainThreadChat)}registerChatProvider(p,E,M){const C=new A(p,M);return this.b.set(C.handle,C),this.d.$registerChatProvider(C.handle,E),(0,N.$Rc)(()=>{this.d.$unregisterChatProvider(C.handle),this.b.delete(C.handle)})}transferChatSession(p,E){const M=l.Iterable.find(this.c.keys(),C=>this.c.get(C)===p)??0;typeof M=="number"&&this.d.$transferChatSession(M,E)}sendInteractiveRequestToProvider(p,E){this.d.$sendRequestToProvider(p,E)}async $prepareChat(p,E){const M=this.b.get(p);if(!M)return;const C=await M.provider.prepareSession(E);if(!C)return;const v=R.a++;return this.c.set(v,C),{id:v,requesterUsername:C.requester?.name,requesterAvatarIconUri:C.requester?.icon,responderUsername:C.responder?.name,responderAvatarIconUri:C.responder?.icon,inputPlaceholder:C.inputPlaceholder}}$releaseSession(p){this.c.delete(p)}}e.$dic=R}),define(Se[305],De([1,0,6]),function(fe,e,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;class N{constructor(A){const R=A.getProxy(l.$0L.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(w){return R.$writeText(w)}})}}e.$iic=N}),define(Se[306],De([1,0,24,6,27,20]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_jc=void 0;let R=class{constructor(M,C){this.a=M.getProxy(N.$0L.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(M,C){const v=this,S=console[M];Object.defineProperty(console,M,{set:()=>{},get:()=>function(){v.e(M,C,S,arguments)}})}e(M,C,v,S){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:p(S,this.b)}),this.c&&this.f(M,v,S)}};e.$_jc=R,e.$_jc=R=Qe([Ve(0,A.$pO),Ve(1,L.$FO)],R);const w=1e5;function p(E,M){const C=[];if(E.length)for(let v=0;v<E.length;v++){let S=E[v];if(typeof S>"u")S="undefined";else if(S instanceof Error){const y=S;y.stack?S=y.stack:S=y.toString()}C.push(S)}if(M){const v=new Error().stack;v&&C.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,l.$Qn)(C);return v.length>w?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(Se[307],De([1,0,2,6,26]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$djc=void 0;class A{constructor(w){this.a=w.getProxy(N.$0L.MainThreadDialogs)}showOpenDialog(w,p){return p?.allowUIResources&&(0,L.$1F)(w,"showLocal"),this.a.$showOpenDialog(p).then(E=>E?E.map(M=>l.URI.revive(M)):void 0)}showSaveDialog(w){return this.a.$showSaveDialog(w).then(p=>p?l.URI.revive(p):void 0)}}e.$djc=A}),define(Se[308],De([1,0,3,6]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class L{constructor(R){this.b=0,this.a=R.getProxy(N.$0L.MainThreadLabelService)}$registerResourceLabelFormatter(R){const w=this.b++;return this.a.$registerResourceLabelFormatter(w,R),(0,l.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(w)})}}e.$yjc=L}),define(Se[115],De([1,0,11,14,2,5,12,6,27,20]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=e.$Xic=void 0;let M=class{constructor(v,S,y){this.f=y,this.d=new Map,this.a=S.getProxy(w.$0L.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===l.$g}getMessage(v,S){const{message:y,args:u,comment:m}=S;if(this.c)return(0,N.$Ve)(y,u??{});let o=y;m&&m.length>0&&(o+=`/${Array.isArray(m)?m.join(""):m}`);const i=this.d.get(v)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$Ve)(i??y,u??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let S;const y=await this.g(v);if(!y){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const u=await this.a.$fetchBundleContents(y),m=JSON.parse(u);S=v.isBuiltin?m.contents?.bundle:m}catch(u){this.f.error(`Failed to load translations for ${v.identifier.value} from ${y}: ${u.message}`);return}S&&this.d.set(v.identifier.value,{contents:S,uri:y})}async g(v){if(v.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return L.URI.revive(S)}return v.l10n?L.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Xic=M,e.$Xic=M=Qe([Ve(0,p.$FO),Ve(1,E.$pO),Ve(2,R.$Aj)],M),e.$Yic=(0,A.$gi)("IExtHostLocalizationService")}),define(Se[149],De([1,0,12,6,27,20,2,56]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$jc=void 0;let p=class extends l.$Lj{constructor(C,v){super(v.logLevel,v.logsLocation,v.loggers.map(S=>(0,w.$Ph)(S))),this.r=C.getProxy(N.$0L.MainThreadLogger)}$setLogLevel(C,v){v?this.setLogLevel(R.URI.revive(v),C):this.setLogLevel(C)}setVisibility(C,v){super.setVisibility(C,v),this.r.$setVisibility(C,v)}s(C,v,S){return new E(this.r,C,v,S)}};e.$$jc=p,e.$$jc=p=Qe([Ve(0,A.$pO),Ve(1,L.$FO)],p);class E extends l.$Gj{constructor(C,v,S,y){super(y?.logLevel==="always"),this.r=C,this.s=v,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(v,y).then(()=>{this.u(this.n),this.m=!0})}g(C,v){const S=[[C,v]];this.m?this.u(S):this.n.push(...S)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Se[116],De([1,0,6,5,3,20,21]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=void 0,e.$Zic=(0,N.$gi)("IExtHostManagedSockets");let w=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(l.$0L.MainThreadManagedSockets)}setFactory(C,v){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(C,v),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const v=++this.b,S=await this.c.makeConnection(),y=new L.$Sc;return this.d.set(v,new E(v,S,y)),y.add((0,L.$Rc)(()=>this.d.delete(v))),y.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(v),y.dispose()})),y.add(S.onDidClose(u=>{this.a.$onDidManagedSocketClose(v,u?.stack??u?.message),y.dispose()})),y.add(S.onDidReceiveMessage(u=>this.a.$onDidManagedSocketHaveData(v,R.$te.wrap(u)))),v}$remoteSocketWrite(C,v){this.d.get(C)?.actual.send(v.buffer)}$remoteSocketEnd(C){const v=this.d.get(C);v&&(v.actual.end(),v.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$1ic=w,e.$1ic=w=Qe([Ve(0,A.$pO)],w);class p{constructor(C,v){this.socketFactoryId=C,this.makeConnection=v}}class E extends L.$Tc{constructor(C,v,S){super(),this.socketId=C,this.actual=v,this.B(S)}}}),define(Se[309],De([1,0,6,12,26]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ajc=void 0;function A(w){return w&&w.title}let R=class{constructor(p,E){this.b=E,this.a=p.getProxy(l.$0L.MainThreadMessageService)}showMessage(p,E,M,C,v){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let y;typeof C=="string"||A(C)?y=[C,...v]:(S.modal=C?.modal,S.useCustom=C?.useCustom,S.detail=C?.detail,y=v),S.useCustom&&(0,L.$1F)(p,"resolvers");const u=[];let m=!1;for(let o=0;o<y.length;o++){const i=y[o];if(typeof i=="string")u.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:n,isCloseAffordance:r}=i;u.push({title:n,isCloseAffordance:!!r,handle:o}),r&&(m?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,i):m=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,i)}return this.a.$showMessage(E,M,S,u).then(o=>{if(typeof o=="number")return y[o]})}};e.$Ajc=R,e.$Ajc=R=Qe([Ve(1,N.$Aj)],R)}),define(Se[310],De([1,0,3,18,2,26,6]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jjc=void 0;class w{constructor(E){this.b=new Map,this.a=E.getProxy(R.$0L.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,M,C){if((0,A.$1F)(E,"profileContentHandlers"),this.b.has(M))throw new Error(`Handler with id '${M}' already registered`);return this.b.set(M,C),this.a.$registerProfileContentHandler(M,C.name,C.description,E.identifier.value),(0,l.$Rc)(()=>{this.b.delete(M),this.a.$unregisterProfileContentHandler(M)})}async $saveProfile(E,M,C,v){const S=this.b.get(E);if(!S)throw new Error(`Unknown handler with id: ${E}`);return S.saveProfile(M,C,v)}async $readProfile(E,M,C){const v=this.b.get(E);if(!v)throw new Error(`Unknown handler with id: ${E}`);return v.readProfile((0,N.$Tf)(M)?M:L.URI.revive(M),C)}}e.$Jjc=w}),define(Se[117],De([1,0,6,4,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vic=e.$Uic=void 0;class A{constructor(w){this.b=new N.$6d,this.onDidChangePassword=this.b.event,this.a=w.getProxy(l.$0L.MainThreadSecretState)}async $onDidChangePassword(w){this.b.fire(w)}get(w,p){return this.a.$getPassword(w,p)}store(w,p,E){return this.a.$setPassword(w,p,E)}delete(w,p){return this.a.$deletePassword(w,p)}}e.$Uic=A,e.$Vic=(0,L.$gi)("IExtHostSecretState")}),define(Se[311],De([1,0,22,3,6]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qjc=void 0;class A{static{this.a=1}constructor(w){this.c=new Map,this.d=new Map,this.b=w.getProxy(L.$0L.MainThreadSpeech)}async $createSpeechToTextSession(w,p,E){const M=this.c.get(w);if(!M)return;const C=new N.$Sc,v=new l.$de;this.d.set(p,v);const S=C.add(M.provideSpeechToTextSession(v.token,E?{language:E}:void 0));C.add(S.onDidChange(y=>{v.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,y)})),C.add(v.token.onCancellationRequested(()=>C.dispose()))}async $cancelSpeechToTextSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}async $createKeywordRecognitionSession(w,p){const E=this.c.get(w);if(!E)return;const M=new N.$Sc,C=new l.$de;this.d.set(p,C);const v=M.add(E.provideKeywordRecognitionSession(C.token));M.add(v.onDidChange(S=>{C.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,S)})),M.add(C.token.onCancellationRequested(()=>M.dispose()))}async $cancelKeywordRecognitionSession(w){this.d.get(w)?.dispose(!0),this.d.delete(w)}registerProvider(w,p,E){const M=A.a++;return this.c.set(M,E),this.b.$registerProvider(M,p,{extension:w,displayName:w.value}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(M),this.c.delete(M)})}}e.$Qjc=A}),define(Se[118],De([1,0,6,4,5]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=e.$Mic=void 0;class A{constructor(w,p){this.c=p,this.b=new N.$6d,this.onDidChangeStorage=this.b.event,this.a=w.getProxy(l.$0L.MainThreadStorage)}registerExtensionStorageKeysToSync(w,p){this.a.$registerExtensionStorageKeysToSync(w,p)}async initializeExtensionStorage(w,p,E){const M=await this.a.$initializeExtensionStorage(w,p);let C;return M&&(C=this.d(w,p,M)),C||E}setValue(w,p,E){return this.a.$setValue(w,p,E)}$acceptValue(w,p,E){const M=this.d(w,p,E);M&&this.b.fire({shared:w,key:p,value:M})}d(w,p,E){try{return JSON.parse(E)}catch(M){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${w}): ${M}`)}}}e.$Mic=A,e.$Nic=(0,L.$gi)("IExtHostStorage")}),define(Se[312],De([1,0,3,15,2,6]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5jc=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(A.$0L.MainThreadUriOpeners)}registerExternalUriOpener(p,E,M,C){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const v=C.schemes.find(S=>!R.a.has(S));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(E,M),this.b.$registerUriOpener(E,C.schemes,p,C.label),(0,l.$Rc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(p,E,M){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener with id: ${p}`);const v=L.URI.revive(E);return C.canOpenExternalUri(v,M)}async $openUri(p,E,M){const C=this.c.get(p);if(!C)throw new Error(`Unknown opener id: '${p}'`);return C.openExternalUri(L.URI.revive(E.resolvedUri),{sourceUri:L.URI.revive(E.sourceUri)},M)}}e.$5jc=R}),define(Se[313],De([1,0,6,2,3,13,25]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6jc=void 0;class w{static{this.a=0}constructor(E){this.c=new R.$Bm,this.d=new Map,this.b=E.getProxy(l.$0L.MainThreadUrls)}registerUriHandler(E,M){const C=E.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const v=w.a++;return this.c.add(C),this.d.set(v,M),this.b.$registerUriHandler(v,C,E.displayName||E.name),(0,L.$Rc)(()=>{this.c.delete(C),this.d.delete(v),this.b.$unregisterUriHandler(v)})}$handleExternalUri(E,M){const C=this.d.get(E);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(M))}catch(v){(0,A.$1)(v)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$6jc=w}),define(Se[92],De([1,0,4,3,15,24,2,243,280,113,6]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=e.$zic=e.$yic=e.$xic=void 0;class C{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(r,c,t,f,h,s,a){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new l.$6d,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new l.$6d,this._onDidDispose=this.#h.event,this.#e=r,this.#t=c,this.#o=t,this.#n=f,this.#s=h,this.#r=s,this.#l=v(s),this.#d=S(s),this.#i=a}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(r){return this.#u=!0,(0,E.$Kxb)(r,this.#n)}get cspSource(){const r=this.#r.extensionLocation;if(r.scheme===L.Schemas.https||r.scheme===L.Schemas.http){let c=r.toString();return c.endsWith("/")||(c+="/"),c+" "+E.$Jxb}return E.$Jxb}get html(){return this.a(),this.#a}set html(r){this.a(),this.#a!==r&&(this.#a=r,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(r)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(r)))}get options(){return this.a(),this.#o}set options(r){this.a(),A.$Pn(this.#o,r)||this.#t.$setOptions(this.#e,m(this.#r,this.#s,r)),this.#o=r}async postMessage(r){if(this.#c)return!1;const c=(0,p.$jnb)(r,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,c.message,...c.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(r){if(!this.#d)return r;const c=this.#r.extensionLocation?.scheme===L.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return r.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,s,a,d,$)=>{const D=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),b=(0,E.$Kxb)(D,{isRemote:c,authority:t}).toString();return`${h}${b}${$}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,h,s,a,d,$)=>{const D=R.URI.from({scheme:a||"file",path:decodeURIComponent(d)}),b=(0,E.$Kxb)(D,{isRemote:c,authority:t}).toString();return`${h}${b}${$}`})}}e.$xic=C;function v(n){try{const r=(0,w.$rp)((0,w.$qp)(n.engines.vscode));return!!r&&r.majorBase>=1&&r.minorBase>=57}catch{return!1}}e.$yic=v;function S(n){try{const r=(0,w.$rp)((0,w.$qp)(n.engines.vscode));return r?r.majorBase<1||r.majorBase===1&&r.minorBase<60:!1}catch{return!1}}class y extends N.$Tc{constructor(r,c,t,f,h){super(),this.c=c,this.f=t,this.g=f,this.h=h,this.b=new Map,this.a=r.getProxy(M.$0L.MainThreadWebviews)}dispose(){super.dispose();for(const r of this.b.values())r.dispose();this.b.clear()}$onMessage(r,c,t){const f=this.j(r);if(f){const{message:h}=(0,p.$knb)(c,t.value);f._onMessageEmitter.fire(h)}}$onMissingCsp(r,c){this.g.warn(`${c} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(r,c,t){const f=new C(r,this.a,o(c),this.c,this.f,t,this.h);this.b.set(r,f);const h=f._onDidDispose(()=>{h.dispose(),this.deleteWebview(r)});return f}deleteWebview(r){this.b.delete(r)}j(r){return this.b.get(r)}}e.$zic=y;function u(n){return{id:n.identifier,location:n.extensionLocation}}e.$Aic=u;function m(n,r,c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots||i(n,r)}}e.$Bic=m;function o(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(r=>R.URI.from(r))}}function i(n,r){return[...(r?.getWorkspaceFolders()||[]).map(c=>c.uri),n.extensionLocation]}}),define(Se[150],De([1,0,4,6,2,15,14,5,20,26]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$9jc=e.$8jc=void 0;let C=class{static{M=this}static{this.a={focused:!0,active:!0}}getState(S){const y=this.d;return{get focused(){return y.focused},get active(){return(0,E.$1F)(S,"windowActivity"),y.active}}}constructor(S){this.c=new l.$6d,this.onDidChangeWindowState=this.c.event,this.d=M.a,this.b=S.getProxy(N.$0L.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:u})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",u)})}$onDidChangeWindowFocus(S){this.onDidChangeWindowProperty("focused",S)}$onDidChangeWindowActive(S){this.onDidChangeWindowProperty("active",S)}onDidChangeWindowProperty(S,y){y!==this.d[S]&&(this.d={...this.d,[S]:y},this.c.fire(this.d))}openUri(S,y){let u;if(typeof S=="string"){u=S;try{S=L.URI.parse(S)}catch{return Promise.reject(`Invalid uri - '${S}'`)}}return(0,R.$Te)(S.scheme)?Promise.reject("Invalid scheme - cannot be empty"):S.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${S.scheme}'`):this.b.$openUri(S,u,y)}async asExternalUri(S,y){if((0,R.$Te)(S.scheme))return Promise.reject("Invalid scheme - cannot be empty");const u=await this.b.$asExternalUri(S,y);return L.URI.from(u)}};e.$8jc=C,e.$8jc=C=M=Qe([Ve(0,p.$pO)],C),e.$9jc=(0,w.$gi)("IExtHostWindow")}),define(Se[314],De([1,0,306,27,20]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kkc=void 0;const A=1024*1024;let R=class extends l.$_jc{constructor(p,E){super(p,E),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(p,E,M){const C=p==="error"||p==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),E.apply(console,M),C.write(`
END_NATIVE_LOG
`),this.g=!1}j(p,E){const M=process[p],C=M.write;let v="";Object.defineProperty(M,"write",{set:()=>{},get:()=>(S,y,u)=>{if(!this.g){v+=S.toString(y);const m=v.length>A?v.length:v.lastIndexOf(`
`);m!==-1&&(console[E](v.slice(0,m)),v=v.slice(m+1))}C.call(M,S,y,u)}})}};e.$Kkc=R,e.$Kkc=R=Qe([Ve(0,L.$pO),Ve(1,N.$FO)],R)}),define(Se[315],De([1,0,149,15,257,30]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wkc=void 0;class R extends l.$$jc{s(p,E,M){return p.scheme===N.Schemas.file?new L.$CP(M?.name||(0,A.$Cg)(),p.fsPath,!M?.donotRotate,!!M?.donotUseFormatters,E):super.s(p,E,M)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Wkc=R}),define(Se[316],De([1,0,8,21,22,13,4,3,133,303,67]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$09b=e.ResponsiveState=e.RequestInitiator=e.$99b=e.$89b=void 0;function v(k,P){try{return JSON.stringify(k,P)}catch{return"null"}}const S="$$ref$$",y={[S]:-1};class u{constructor(P,F){this.jsonString=P,this.referencedBuffers=F}}function m(k,P=null,F=!1){const U=[];return{jsonString:(F?v:JSON.stringify)(k,(T,I)=>{if(typeof I>"u")return y;if(typeof I=="object"){if(I instanceof N.$te){const O=U.push(I)-1;return{[S]:O}}if(P)return P(T,I)}return I}),referencedBuffers:U}}e.$89b=m;function o(k,P,F){return JSON.parse(k,(U,z)=>{if(z){const T=z[S];if(typeof T=="number")return P[T];if(F&&z.$mid===1)return F.transformIncoming(z)}return z})}e.$99b=o;function i(k,P){return JSON.stringify(k,P)}function n(k){return k?(P,F)=>F&&F.$mid===1?k.transformOutgoing(F):F:null}var r;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(r||(e.RequestInitiator=r={}));var c;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const t=()=>{},f=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class s extends w.$Tc{static{C=f}static{this.a=3*1e3}constructor(P,F=null,U=null){super(),this[C]=!0,this.b=this.B(new R.$6d),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=F,this.g=U,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let z=0,T=M.$7v.count;z<T;z++)this.m[z]=null,this.s[z]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new l.$sh(()=>this.H(),1e3)),this.c.onMessage(z=>this.L(z))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const F=this.w[P];delete this.w[P],F.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+s.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+s.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,p.$kn)(P,this.g):P}getProxy(P){const{nid:F,sid:U}=P;return this.s[F]||(this.s[F]=this.J(F,U)),this.s[F]}J(P,F){const U={get:(z,T)=>(typeof T=="string"&&!z[T]&&T.charCodeAt(0)===36&&(z[T]=(...I)=>this.U(P,T,I)),T===h?F:z[T])};return new Proxy(Object.create(null),U)}set(P,F){return this.m[P.nid]=F,F}assertRegistered(P){for(let F=0,U=P.length;F<U;F++){const z=P[F];if(!this.m[z.nid])throw new Error(`Missing proxy instance ${z.sid}`)}}L(P){if(this.j)return;const F=P.byteLength,U=d.read(P,0),z=U.readUInt8(),T=U.readUInt32();switch(z){case 1:case 2:{let{rpcId:I,method:O,args:j}=D.deserializeRequestJSONArgs(U);this.g&&(j=(0,p.$kn)(j,this.g)),this.M(F,T,I,O,j,z===2);break}case 3:case 4:{let{rpcId:I,method:O,args:j}=D.deserializeRequestMixedArgs(U);this.g&&(j=(0,p.$kn)(j,this.g)),this.M(F,T,I,O,j,z===4);break}case 5:{this.f?.logIncoming(F,T,0,"ack"),this.G(T);break}case 6:{this.N(F,T);break}case 7:{this.O(F,T,void 0);break}case 9:{let I=D.deserializeReplyOKJSON(U);this.g&&(I=(0,p.$kn)(I,this.g)),this.O(F,T,I);break}case 10:{const I=D.deserializeReplyOKJSONWithBuffers(U,this.g);this.O(F,T,I);break}case 8:{const I=D.deserializeReplyOKVSBuffer(U);this.O(F,T,I);break}case 11:{let I=D.deserializeReplyErrError(U);this.g&&(I=(0,p.$kn)(I,this.g)),this.P(F,T,I);break}case 12:{this.P(F,T,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,F,U,z,T,I){this.f?.logIncoming(P,F,1,`receiveRequest ${(0,M.$9v)(U)}.${z}(`,T);const O=String(F);let j,G;if(I){const x=new L.$de;T.push(x.token),j=this.Q(U,z,T),G=()=>x.cancel()}else j=this.Q(U,z,T),G=t;this.u[O]=G;const te=D.serializeAcknowledged(F);this.f?.logOutgoing(te.byteLength,F,1,"ack"),this.c.send(te),j.then(x=>{delete this.u[O];const Z=D.serializeReplyOK(F,x,this.h);this.f?.logOutgoing(Z.byteLength,F,1,"reply:",x),this.c.send(Z)},x=>{delete this.u[O];const Z=D.serializeReplyErr(F,x);this.f?.logOutgoing(Z.byteLength,F,1,"replyErr:",x),this.c.send(Z)})}N(P,F){this.f?.logIncoming(P,F,1,"receiveCancel");const U=String(F);this.u[U]?.()}O(P,F,U){this.f?.logIncoming(P,F,0,"receiveReply:",U);const z=String(F);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z],T.resolveOk(U)}P(P,F,U){this.f?.logIncoming(P,F,0,"receiveReplyErr:",U);const z=String(F);if(!this.w.hasOwnProperty(z))return;const T=this.w[z];delete this.w[z];let I;U&&(U.$isError?(I=new Error,I.name=U.name,I.message=U.message,I.stack=U.stack):I=U),T.resolveErr(I)}Q(P,F,U){try{return Promise.resolve(this.S(P,F,U))}catch(z){return Promise.reject(z)}}S(P,F,U){const z=this.m[P];if(!z)throw new Error("Unknown actor "+(0,M.$9v)(P));const T=z[F];if(typeof T!="function")throw new Error("Unknown method "+F+" on actor "+(0,M.$9v)(P));return T.apply(z,U)}U(P,F,U){if(this.j)return new E.$79b;let z=null;if(U.length>0&&L.CancellationToken.isCancellationToken(U[U.length-1])&&(z=U.pop()),z&&z.isCancellationRequested)return Promise.reject(A.$6());const T=D.serializeRequestArguments(U,this.h),I=++this.t,O=String(I),j=new E.$69b,G=new w.$Sc;z&&G.add(z.onCancellationRequested(()=>{const x=D.serializeCancel(I);this.f?.logOutgoing(x.byteLength,I,0,"cancel"),this.c.send(D.serializeCancel(I))})),this.w[O]=new a(j,G),this.F(I);const te=D.serializeRequest(I,P,F,T,!!z);return this.f?.logOutgoing(te.byteLength,I,0,`request: ${(0,M.$9v)(P)}.${F}(`,U),this.c.send(te),j}}e.$09b=s;class a{constructor(P,F){this.a=P,this.b=F}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class d{static alloc(P,F,U){const z=new d(N.$te.alloc(U+1+4),0);return z.writeUInt8(P),z.writeUInt32(F),z}static read(P,F){return new d(P,F)}get buffer(){return this.a}constructor(P,F){this.a=P,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const U=this.a.slice(this.b,this.b+P).toString();return this.b+=P,U}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+P);return this.b+=P,F}static sizeMixedArray(P){let F=0;F+=1;for(let U=0,z=P.length;U<z;U++){const T=P[U];switch(F+=1,T.type){case 1:F+=this.sizeLongString(T.value);break;case 2:F+=this.sizeVSBuffer(T.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(T.value);for(let I=0;I<T.buffers.length;++I)F+=this.sizeVSBuffer(T.buffers[I]);break;case 4:break}}return F}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let F=0,U=P.length;F<U;F++){const z=P[F];switch(z.type){case 1:this.writeUInt8(1),this.writeLongString(z.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(z.value);break;case 3:this.writeUInt8(3),this.writeUInt32(z.buffers.length),this.writeLongString(z.value);for(let T=0;T<z.buffers.length;++T)this.writeBuffer(z.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const F=new Array(P);for(let U=0;U<P;U++)switch(this.readUInt8()){case 1:F[U]=this.readLongString();break;case 2:F[U]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),I=this.readLongString(),O=[];for(let j=0;j<T;++j)O.push(this.readVSBuffer());F[U]=new M.$0v(o(I,O,null));break}case 4:F[U]=void 0;break}return F}}var $;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})($||($={}));class D{static a(P){for(let F=0,U=P.length;F<U;F++)if(P[F]instanceof N.$te||P[F]instanceof M.$0v||typeof P[F]>"u")return!0;return!1}static serializeRequestArguments(P,F){if(this.a(P)){const U=[];for(let z=0,T=P.length;z<T;z++){const I=P[z];if(I instanceof N.$te)U[z]={type:2,value:I};else if(typeof I>"u")U[z]={type:4};else if(I instanceof M.$0v){const{jsonString:O,referencedBuffers:j}=m(I.value,F);U[z]={type:3,value:N.$te.fromString(O),buffers:j}}else U[z]={type:1,value:N.$te.fromString(i(I,F))}}return{type:1,args:U}}return{type:0,args:i(P,F)}}static serializeRequest(P,F,U,z,T){switch(z.type){case 0:return this.b(P,F,U,z.args,T);case 1:return this.c(P,F,U,z.args,T)}}static b(P,F,U,z,T){const I=N.$te.fromString(U),O=N.$te.fromString(z);let j=0;j+=d.sizeUInt8(),j+=d.sizeShortString(I),j+=d.sizeLongString(O);const G=d.alloc(T?2:1,P,j);return G.writeUInt8(F),G.writeShortString(I),G.writeLongString(O),G.buffer}static deserializeRequestJSONArgs(P){const F=P.readUInt8(),U=P.readShortString(),z=P.readLongString();return{rpcId:F,method:U,args:JSON.parse(z)}}static c(P,F,U,z,T){const I=N.$te.fromString(U);let O=0;O+=d.sizeUInt8(),O+=d.sizeShortString(I),O+=d.sizeMixedArray(z);const j=d.alloc(T?4:3,P,O);return j.writeUInt8(F),j.writeShortString(I),j.writeMixedArray(z),j.buffer}static deserializeRequestMixedArgs(P){const F=P.readUInt8(),U=P.readShortString(),z=P.readMixedArray(),T=new Array(z.length);for(let I=0,O=z.length;I<O;I++){const j=z[I];typeof j=="string"?T[I]=JSON.parse(j):T[I]=j}return{rpcId:F,method:U,args:T}}static serializeAcknowledged(P){return d.alloc(5,P,0).buffer}static serializeCancel(P){return d.alloc(6,P,0).buffer}static serializeReplyOK(P,F,U){if(typeof F>"u")return this.d(P);if(F instanceof N.$te)return this.e(P,F);if(F instanceof M.$0v){const{jsonString:z,referencedBuffers:T}=m(F.value,U,!0);return this.g(P,z,T)}else return this.f(P,v(F,U))}static d(P){return d.alloc(7,P,0).buffer}static e(P,F){let U=0;U+=d.sizeVSBuffer(F);const z=d.alloc(8,P,U);return z.writeVSBuffer(F),z.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,F){const U=N.$te.fromString(F);let z=0;z+=d.sizeLongString(U);const T=d.alloc(9,P,z);return T.writeLongString(U),T.buffer}static g(P,F,U){const z=N.$te.fromString(F);let T=0;T+=d.sizeUInt32,T+=d.sizeLongString(z);for(const O of U)T+=d.sizeVSBuffer(O);const I=d.alloc(10,P,T);I.writeUInt32(U.length),I.writeLongString(z);for(const O of U)I.writeBuffer(O);return I.buffer}static deserializeReplyOKJSON(P){const F=P.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(P,F){const U=P.readUInt32(),z=P.readLongString(),T=[];for(let I=0;I<U;++I)T.push(P.readVSBuffer());return new M.$0v(o(z,T,F))}static serializeReplyErr(P,F){const U=F?v(A.$3(F),null):void 0;if(typeof U!="string")return this.h(P);const z=N.$te.fromString(U);let T=0;T+=d.sizeLongString(z);const I=d.alloc(11,P,T);return I.writeLongString(z),I.buffer}static deserializeReplyErrError(P){const F=P.readLongString();return JSON.parse(F)}static h(P){return d.alloc(12,P,0).buffer}}var b;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var g;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(g||(g={}))}),define(Se[317],De([1,0,21,28,15,83,5]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0,e.$PJ=(0,R.$gi)("notebookDocumentService");const w=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${w.join("")}]+`),E=7;function M(S){if(S.scheme!==L.Schemas.vscodeNotebookCell)return;const y=S.fragment.indexOf("s");if(y<0)return;const u=parseInt(S.fragment.substring(0,y).replace(p,""),E),m=(0,l.$Me)(S.fragment.substring(y+1)).toString();if(!isNaN(u))return{handle:u,notebook:S.with({scheme:m,fragment:null})}}e.$QJ=M;function C(S,y){const u=y.toString(E),o=`${u.length<w.length?w[u.length-1]:"z"}${u}s${(0,l.$Ne)(l.$te.fromString(S.scheme),!0,!0)}`;return S.with({scheme:L.Schemas.vscodeNotebookCell,fragment:o})}e.$RJ=C;class v{constructor(){this.a=new N.$Ac}getNotebook(y){if(y.scheme===L.Schemas.vscodeNotebookCell){const u=M(y);if(u){const m=this.a.get(u.notebook);if(m)return m}}return this.a.get(y)}addNotebookDocument(y){this.a.set(y.uri,y)}removeNotebookDocument(y){this.a.delete(y.uri)}}e.$SJ=v,(0,A.$bs)(e.$PJ,v,1)}),define(Se[119],De([1,0,21,35,48,101,15,17,11,45,317]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=e.$8J=e.CellStatusbarAlignment=e.$7J=e.$6J=e.$5J=e.NotebookEditorPriority=e.$4J=e.$3J=e.$2J=e.$1J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.CellKind=e.$VJ=e.$UJ=e.$TJ=void 0,e.$TJ="workbench.editor.notebook",e.$UJ="workbench.editor.notebookTextDiffEditor",e.$VJ="workbench.editor.interactive";var C;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(C||(e.CellKind=C={})),e.$WJ=["application/json","application/javascript","text/html","image/svg+xml",A.$us.latex,A.$us.markdown,"image/png","image/jpeg",A.$us.text],e.$XJ=[A.$us.latex,A.$us.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",A.$us.text],e.$YJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$ZJ="_notAvailable";var v;(function(j){j[j.Running=1]="Running",j[j.Idle=2]="Idle"})(v||(e.NotebookRunState=v={}));var S;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var y;(function(j){j[j.Unconfirmed=1]="Unconfirmed",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var u;(function(j){j[j.WithHardKernelDependency=0]="WithHardKernelDependency",j[j.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",j[j.Pure=2]="Pure",j[j.Never=3]="Never"})(u||(e.NotebookRendererMatch=u={}));var m;(function(j){j.Always="always",j.Never="never",j.Optional="optional"})(m||(e.RendererMessagingSpec=m={}));var o;(function(j){j[j.ModelChange=1]="ModelChange",j[j.Move=2]="Move",j[j.ChangeCellLanguage=5]="ChangeCellLanguage",j[j.Initialize=6]="Initialize",j[j.ChangeCellMetadata=7]="ChangeCellMetadata",j[j.Output=8]="Output",j[j.OutputItem=9]="OutputItem",j[j.ChangeCellContent=10]="ChangeCellContent",j[j.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",j[j.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",j[j.ChangeCellMime=13]="ChangeCellMime",j[j.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(j){j[j.Handle=0]="Handle",j[j.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var n;(function(j){j[j.Replace=1]="Replace",j[j.Output=2]="Output",j[j.Metadata=3]="Metadata",j[j.CellLanguage=4]="CellLanguage",j[j.DocumentMetadata=5]="DocumentMetadata",j[j.Move=6]="Move",j[j.OutputItems=7]="OutputItems",j[j.PartialMetadata=8]="PartialMetadata",j[j.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var r;(function(j){j.scheme=R.Schemas.vscodeNotebookCell;function G(_,ge){return(0,M.$RJ)(_,ge)}j.generate=G;function te(_){return(0,M.$QJ)(_)}j.parse=te;function x(_,ge){return _.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${ge??""},${_.scheme!==R.Schemas.file?_.scheme:""}`})}j.generateCellOutputUri=x;function Z(_){if(_.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const ge=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(_.fragment);if(!ge)return;const se=ge[1]&&ge[1]!==""?ge[1]:void 0,re=ge[2];return{outputId:se,notebook:_.with({scheme:re||R.Schemas.file,fragment:null})}}j.parseCellOutputUri=Z;function X(_,ge,se){return j.generate(_,ge).with({scheme:se})}j.generateCellPropertyUri=X;function ae(_,ge){if(_.scheme===ge)return j.parse(_.with({scheme:j.scheme}))}j.parseCellPropertyUri=ae})(r||(e.CellUri=r={}));const c=j=>p.$i?j.replace(/\//g,"\\"):j;class t{constructor(G=[],te=e.$WJ){this.e=te,this.d=[...new Set(G)].map(x=>({pattern:x,matches:N.$Zj(c(x))}))}sort(G){const te=new Map(L.Iterable.map(G,Z=>[Z,c(Z)]));let x=[];for(const{matches:Z}of this.d)for(const[X,ae]of te)if(Z(ae)){x.push(X),te.delete(X);break}return te.size&&(x=x.concat([...te.keys()].sort((Z,X)=>this.e.indexOf(Z)-this.e.indexOf(X)))),x}prioritize(G,te){const x=this.f(G);if(x===-1){this.d.unshift({pattern:G,matches:N.$Zj(c(G))});return}const Z=new Set(te.map(ae=>this.f(ae,x)));Z.delete(-1);const X=Array.from(Z).sort();this.d.splice(x+1,0,...X.map(ae=>this.d[ae]));for(let ae=X.length-1;ae>=0;ae--)this.d.splice(X[ae],1)}toArray(){return this.d.map(G=>G.pattern)}f(G,te=this.d.length){const x=c(G);for(let Z=0;Z<te;Z++)if(this.d[Z].matches(x))return Z;return-1}}e.$1J=t;function f(j,G,te,x=(Z,X)=>Z===X){const Z=[];function X(ge,se,re){if(se===0&&re.length===0)return;const B=Z[Z.length-1];B&&B.start+B.deleteCount===ge?(B.deleteCount+=se,B.toInsert.push(...re)):Z.push({start:ge,deleteCount:se,toInsert:re})}let ae=0,_=0;for(;;){if(ae===j.length){X(ae,0,G.slice(_));break}if(_===G.length){X(ae,j.length-ae,[]);break}const ge=j[ae],se=G[_];if(x(ge,se)){ae+=1,_+=1;continue}te(se)?(X(ae,1,[]),ae+=1):(X(ae,0,[se]),_+=1)}return Z}e.$2J=f,e.$3J=new E.$xj("notebookEditorCursorAtBoundary","none"),e.$4J=new E.$xj("notebookEditorCursorAtLineBoundary","none");var h;(function(j){j.default="default",j.option="option"})(h||(e.NotebookEditorPriority=h={}));function s(j){const G=j;return!!((typeof G.include=="string"||N.$1j(G.include))&&(typeof G.exclude=="string"||N.$1j(G.exclude)))}e.$5J=s;function a(j,G,te){if(Array.isArray(j.viewType)&&j.viewType.indexOf(G)>=0||j.viewType===G)return!0;if(j.filenamePattern){const x=s(j.filenamePattern)?j.filenamePattern.include:j.filenamePattern,Z=s(j.filenamePattern)?j.filenamePattern.exclude:void 0;if(N.$Yj(x,(0,w.$nc)(te.fsPath).toLowerCase()))return!(Z&&N.$Yj(Z,(0,w.$nc)(te.fsPath).toLowerCase()))}return!1}e.$6J=a,e.$7J={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var d;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(d||(e.CellStatusbarAlignment=d={}));class ${static{this.d="notebook/"}static create(G){return`${$.d}${G}`}static parse(G){if(G.startsWith($.d))return G.substring($.d.length)}}e.$8J=$;function D(j){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(j)}e.$9J=D;const b=new TextDecoder;function g(j){const G=[];let te=!1;for(const ae of j)(G.length===0||te)&&(G.push(ae),te=!0);let x=F(G);const Z=l.$te.concat(G.map(ae=>l.$te.wrap(ae))),X=O(Z);return x=x||X.byteLength!==Z.byteLength,{data:X,didCompression:x}}e.$0J=g,e.$$J="\x1B[A";const k=e.$$J.split("").map(j=>j.charCodeAt(0)),P=10;function F(j){let G=!1;return j.forEach((te,x)=>{if(x===0||te.length<e.$$J.length)return;const Z=j[x-1],X=te.subarray(0,e.$$J.length);if(X[0]===k[0]&&X[1]===k[1]&&X[2]===k[2]){const ae=Z.lastIndexOf(P);if(ae===-1)return;G=!0,j[x-1]=Z.subarray(0,ae),j[x]=te.subarray(e.$$J.length)}}),G}function U(j){let G=j;do j=G,G=j.replace(/[^\n]\x08/gm,"");while(G.length<j.length);return j}function z(j){for(j=j.replace(/\r+\n/gm,`
`);j.search(/\r[^$]/g)>-1;){const G=j.match(/^(.*)\r+/m)[1];let te=j.match(/\r+(.*)$/m)[1];te=te+G.slice(te.length,G.length),j=j.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,te)}return j}const T=8,I=13;function O(j){return!j.buffer.includes(T)&&!j.buffer.includes(I)?j:l.$te.fromString(z(U(b.decode(j.buffer))))}}),define(Se[7],De([1,0,19,13,79,28,101,14,18,2,30,25,32,64,119]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";var u,m,o,i,n,r,c,t,f,h,s,a,d,$,D,b,g;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$eO=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$4N=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$3N=e.$2N=e.$1N=e.$ZN=e.$YN=e.$XN=e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$RN=e.$QN=e.$PN=e.$ON=e.$NN=e.$MN=e.$LN=e.$KN=e.TestRunProfileKind=e.TestResultState=e.$JN=e.$IN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$HN=e.NotebookVariablesRequestKind=e.$GN=e.$FN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$EN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.ColorThemeKind=e.$yN=e.$xN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$wN=e.$vN=e.DebugConsoleMode=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$pN=e.$oN=e.FileChangeType=e.$nN=e.NewSymbolNameTag=e.$mN=e.$lN=e.$kN=e.$jN=e.InlineCompletionTriggerKind=e.$iN=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.ConfigurationTarget=e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YM=e.ViewBadge=e.ProgressLocation=e.$XM=e.$WM=e.TaskScope=e.ShellQuoting=e.$VM=e.$UM=e.$TM=e.TaskPanelKind=e.TaskRevealKind=e.$SM=e.TerminalLocation=e.$RM=e.$QM=e.$PM=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$OM=e.$NM=e.$MM=e.$LM=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$KM=e.StatusBarAlignment=e.ViewColumn=e.$JM=e.$IM=e.$HM=e.$GM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FM=e.$EM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.LanguageStatusSeverity=e.$yM=e.$xM=e.$wM=e.$vM=e.$uM=e.$tM=e.CodeActionTriggerKind=e.$sM=e.$rM=e.SymbolTag=e.SymbolKind=e.$qM=e.$pM=e.DocumentHighlightKind=e.$oM=e.$nM=e.$mM=e.$lM=e.DiagnosticSeverity=e.DiagnosticTag=e.$kM=e.$jM=e.FileEditType=e.$iM=e.$hM=e.$gM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function k(K){return Object.assign(K,{apply:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const Ne=pe.length===1?[]:pe[1];return Reflect.construct(K,Ne,pe[0].constructor)}},call:function(...pe){if(pe.length===0)return Reflect.construct(K,[]);{const[Ne,...Ye]=pe;return Reflect.construct(K,Ye,Ne.constructor)}}})}var P;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var F;(function(K){K[K.TerminalCommand=0]="TerminalCommand",K[K.Opener=1]="Opener",K[K.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let U=u=class{static from(...V){let pe=V;return new u(function(){if(pe){for(const Ne of pe)Ne&&typeof Ne.dispose=="function"&&Ne.dispose();pe=void 0}})}#e;constructor(V){this.#e=V}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$_L=U,e.$_L=U=u=Qe([k],U);let z=m=class{static Min(...V){if(V.length===0)throw new TypeError;let pe=V[0];for(let Ne=1;Ne<V.length;Ne++){const Ye=V[Ne];Ye.isBefore(pe)&&(pe=Ye)}return pe}static Max(...V){if(V.length===0)throw new TypeError;let pe=V[0];for(let Ne=1;Ne<V.length;Ne++){const Ye=V[Ne];Ye.isAfter(pe)&&(pe=Ye)}return pe}static isPosition(V){if(!V)return!1;if(V instanceof m)return!0;const{line:pe,character:Ne}=V;return typeof pe=="number"&&typeof Ne=="number"}static of(V){if(V instanceof m)return V;if(this.isPosition(V))return new m(V.line,V.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(V,pe){if(V<0)throw(0,N.$7)("line must be non-negative");if(pe<0)throw(0,N.$7)("character must be non-negative");this.c=V,this.e=pe}isBefore(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<V.e}isBeforeOrEqual(V){return this.c<V.c?!0:V.c<this.c?!1:this.e<=V.e}isAfter(V){return!this.isBeforeOrEqual(V)}isAfterOrEqual(V){return!this.isBefore(V)}isEqual(V){return this.c===V.c&&this.e===V.e}compareTo(V){return this.c<V.c?-1:this.c>V.line?1:this.e<V.e?-1:this.e>V.e?1:0}translate(V,pe=0){if(V===null||pe===null)throw(0,N.$7)();let Ne;return typeof V>"u"?Ne=0:typeof V=="number"?Ne=V:(Ne=typeof V.lineDelta=="number"?V.lineDelta:0,pe=typeof V.characterDelta=="number"?V.characterDelta:0),Ne===0&&pe===0?this:new m(this.line+Ne,this.character+pe)}with(V,pe=this.character){if(V===null||pe===null)throw(0,N.$7)();let Ne;return typeof V>"u"?Ne=this.line:typeof V=="number"?Ne=V:(Ne=typeof V.line=="number"?V.line:this.line,pe=typeof V.character=="number"?V.character:this.character),Ne===this.line&&pe===this.character?this:new m(Ne,pe)}toJSON(){return{line:this.line,character:this.character}}};e.$aM=z,e.$aM=z=m=Qe([k],z);let T=o=class{static isRange(V){return V instanceof o?!0:V?z.isPosition(V.start)&&z.isPosition(V.end):!1}static of(V){if(V instanceof o)return V;if(this.isRange(V))return new o(V.start,V.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(V,pe,Ne,Ye){let it,lt;if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(it=new z(V,pe),lt=new z(Ne,Ye)):z.isPosition(V)&&z.isPosition(pe)&&(it=z.of(V),lt=z.of(pe)),!it||!lt)throw new Error("Invalid arguments");it.isBefore(lt)?(this.c=it,this.e=lt):(this.c=lt,this.e=it)}contains(V){return o.isRange(V)?this.contains(V.start)&&this.contains(V.end):z.isPosition(V)?!(z.of(V).isBefore(this.c)||this.e.isBefore(V)):!1}isEqual(V){return this.c.isEqual(V.c)&&this.e.isEqual(V.e)}intersection(V){const pe=z.Max(V.start,this.c),Ne=z.Min(V.end,this.e);if(!pe.isAfter(Ne))return new o(pe,Ne)}union(V){if(this.contains(V))return this;if(V.contains(this))return V;const pe=z.Min(V.start,this.c),Ne=z.Max(V.end,this.end);return new o(pe,Ne)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(V,pe=this.end){if(V===null||pe===null)throw(0,N.$7)();let Ne;return V?z.isPosition(V)?Ne=V:(Ne=V.start||this.start,pe=V.end||this.end):Ne=this.start,Ne.isEqual(this.c)&&pe.isEqual(this.end)?this:new o(Ne,pe)}toJSON(){return[this.start,this.end]}};e.$bM=T,e.$bM=T=o=Qe([k],T);let I=i=class extends T{static isSelection(V){return V instanceof i?!0:V?T.isRange(V)&&z.isPosition(V.anchor)&&z.isPosition(V.active)&&typeof V.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(V,pe,Ne,Ye){let it,lt;if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"?(it=new z(V,pe),lt=new z(Ne,Ye)):z.isPosition(V)&&z.isPosition(pe)&&(it=z.of(V),lt=z.of(pe)),!it||!lt)throw new Error("Invalid arguments");super(it,lt),this.f=it,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$cM=I,e.$cM=I=i=Qe([k],I);const O=K=>{if(typeof K!="string"||K.length===0||!/^[0-9A-Za-z_\-]+$/.test(K))throw(0,N.$7)("connectionToken")};class j{static isResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.host=="string"&&typeof V.port=="number"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,pe,Ne){if(typeof V!="string"||V.length===0)throw(0,N.$7)("host");if(typeof pe!="number"||pe===0||Math.round(pe)!==pe)throw(0,N.$7)("port");typeof Ne<"u"&&O(Ne),this.host=V,this.port=Math.round(pe),this.connectionToken=Ne}}e.$dM=j;class G{static isManagedResolvedAuthority(V){return V&&typeof V=="object"&&typeof V.makeConnection=="function"&&(V.connectionToken===void 0||typeof V.connectionToken=="string")}constructor(V,pe){this.makeConnection=V,this.connectionToken=pe,typeof pe<"u"&&O(pe)}}e.$eM=G;class te extends Error{static NotAvailable(V,pe){return new te(V,S.RemoteAuthorityResolverErrorCode.NotAvailable,pe)}static TemporarilyNotAvailable(V){return new te(V,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(V,pe=S.RemoteAuthorityResolverErrorCode.Unknown,Ne){super(V),this._message=V,this._code=pe,this._detail=Ne,Object.setPrototypeOf(this,te.prototype)}}e.$fM=te;var x;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(x||(e.EndOfLine=x={}));var Z;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(Z||(e.EnvironmentVariableMutatorType=Z={}));let X=n=class{static isTextEdit(V){return V instanceof n?!0:V?T.isRange(V)&&typeof V.newText=="string":!1}static replace(V,pe){return new n(V,pe)}static insert(V,pe){return n.replace(new T(V,V),pe)}static delete(V){return n.replace(V,"")}static setEndOfLine(V){const pe=new n(new T(new z(0,0),new z(0,0)),"");return pe.newEol=V,pe}get range(){return this.c}set range(V){if(V&&!T.isRange(V))throw(0,N.$7)("range");this.c=V}get newText(){return this.e||""}set newText(V){if(V&&typeof V!="string")throw(0,N.$7)("newText");this.e=V}get newEol(){return this.f}set newEol(V){if(V&&typeof V!="number")throw(0,N.$7)("newEol");this.f=V}constructor(V,pe){this.c=V,this.e=pe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$gM=X,e.$gM=X=n=Qe([k],X);let ae=r=class{static isNotebookCellEdit(V){return V instanceof r?!0:V?di.isNotebookRange(V)&&Array.isArray(V.newCells):!1}static replaceCells(V,pe){return new r(V,pe)}static insertCells(V,pe){return new r(new di(V,V),pe)}static deleteCells(V){return new r(V,[])}static updateCellMetadata(V,pe){const Ne=new r(new di(V,V),[]);return Ne.newCellMetadata=pe,Ne}static updateNotebookMetadata(V){const pe=new r(new di(0,0),[]);return pe.newNotebookMetadata=V,pe}constructor(V,pe){this.range=V,this.newCells=pe}};e.$hM=ae,e.$hM=ae=r=Qe([k],ae);class _{static isSnippetTextEdit(V){return V instanceof _?!0:V?T.isRange(V.range)&&re.isSnippetString(V.snippet):!1}static replace(V,pe){return new _(V,pe)}static insert(V,pe){return _.replace(new T(V,V),pe)}constructor(V,pe){this.range=V,this.snippet=pe}}e.$iM=_;var ge;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(ge||(e.FileEditType=ge={}));let se=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(V,pe,Ne,Ye){this.c.push({_type:1,from:V,to:pe,options:Ne,metadata:Ye})}createFile(V,pe,Ne){this.c.push({_type:1,from:void 0,to:V,options:pe,metadata:Ne})}deleteFile(V,pe,Ne){this.c.push({_type:1,from:V,to:void 0,options:pe,metadata:Ne})}e(V,pe,Ne){this.c.push({_type:3,metadata:Ne,uri:V,edit:{editType:5,metadata:pe},notebookMetadata:pe})}f(V,pe,Ne,Ye){const it=pe.start,lt=pe.end;(it!==lt||Ne.length>0)&&this.c.push({_type:5,uri:V,index:it,count:lt-it,cells:Ne,metadata:Ye})}g(V,pe,Ne,Ye){this.c.push({_type:3,metadata:Ye,uri:V,edit:{editType:3,index:pe,metadata:Ne}})}replace(V,pe,Ne,Ye){this.c.push({_type:2,uri:V,edit:new X(pe,Ne),metadata:Ye})}insert(V,pe,Ne,Ye){this.replace(V,new T(pe,pe),Ne,Ye)}delete(V,pe,Ne){this.replace(V,pe,"",Ne)}has(V){return this.c.some(pe=>pe._type===2&&pe.uri.toString()===V.toString())}set(V,pe){if(pe)for(const Ne of pe){if(!Ne)continue;let Ye,it;Array.isArray(Ne)?(Ye=Ne[0],it=Ne[1]):Ye=Ne,ae.isNotebookCellEdit(Ye)?Ye.newCellMetadata?this.g(V,Ye.range.start,Ye.newCellMetadata,it):Ye.newNotebookMetadata?this.e(V,Ye.newNotebookMetadata,it):this.f(V,Ye.range,Ye.newCells,it):_.isSnippetTextEdit(Ye)?this.c.push({_type:6,uri:V,range:Ye.range,edit:Ye.snippet,metadata:it}):this.c.push({_type:2,uri:V,edit:Ye,metadata:it})}else{for(let Ne=0;Ne<this.c.length;Ne++){const Ye=this.c[Ne];switch(Ye._type){case 2:case 6:case 3:case 5:Ye.uri.toString()===V.toString()&&(this.c[Ne]=void 0);break}}(0,l.$Ib)(this.c)}}get(V){const pe=[];for(const Ne of this.c)Ne._type===2&&Ne.uri.toString()===V.toString()&&pe.push(Ne.edit);return pe}entries(){const V=new A.$Ac;for(const pe of this.c)if(pe._type===2){let Ne=V.get(pe.uri);Ne||(Ne=[pe.uri,[]],V.set(pe.uri,Ne)),Ne[1].push(pe.edit)}return[...V.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$jM=se,e.$jM=se=Qe([k],se);let re=c=class{static isSnippetString(V){return V instanceof c?!0:V?typeof V.value=="string":!1}static c(V){return V.replace(/\$|}|\\/g,"\\$&")}constructor(V){this.e=1,this.value=V||""}appendText(V){return this.value+=c.c(V),this}appendTabstop(V=this.e++){return this.value+="$",this.value+=V,this}appendPlaceholder(V,pe=this.e++){if(typeof V=="function"){const Ne=new c;Ne.e=this.e,V(Ne),this.e=Ne.e,V=Ne.value}else V=c.c(V);return this.value+="${",this.value+=pe,this.value+=":",this.value+=V,this.value+="}",this}appendChoice(V,pe=this.e++){const Ne=V.map(Ye=>Ye.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=pe,this.value+="|",this.value+=Ne,this.value+="|}",this}appendVariable(V,pe){if(typeof pe=="function"){const Ne=new c;Ne.e=this.e,pe(Ne),this.e=Ne.e,pe=Ne.value}else typeof pe=="string"&&(pe=pe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=V,pe&&(this.value+=":",this.value+=pe),this.value+="}",this}};e.$kM=re,e.$kM=re=c=Qe([k],re);var B;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(B||(e.DiagnosticTag=B={}));var ie;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ke=t=class{static isLocation(V){return V instanceof t?!0:V?T.isRange(V.range)&&E.URI.isUri(V.uri):!1}constructor(V,pe){if(this.uri=V,pe)if(T.isRange(pe))this.range=T.of(pe);else if(z.isPosition(pe))this.range=new T(pe,pe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$lM=ke,e.$lM=ke=t=Qe([k],ke);let le=class{static is(V){return V?typeof V.message=="string"&&V.location&&T.isRange(V.location.range)&&E.URI.isUri(V.location.uri):!1}constructor(V,pe){this.location=V,this.message=pe}static isEqual(V,pe){return V===pe?!0:!V||!pe?!1:V.message===pe.message&&V.location.range.isEqual(pe.location.range)&&V.location.uri.toString()===pe.location.uri.toString()}};e.$mM=le,e.$mM=le=Qe([k],le);let ue=class{constructor(V,pe,Ne=ie.Error){if(!T.isRange(V))throw new TypeError("range must be set");if(!pe)throw new TypeError("message must be set");this.range=V,this.message=pe,this.severity=Ne}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(V,pe){return V===pe?!0:!V||!pe?!1:V.message===pe.message&&V.severity===pe.severity&&V.code===pe.code&&V.severity===pe.severity&&V.source===pe.source&&V.range.isEqual(pe.range)&&(0,l.$ub)(V.tags,pe.tags)&&(0,l.$ub)(V.relatedInformation,pe.relatedInformation,le.isEqual)}};e.$nM=ue,e.$nM=ue=Qe([k],ue);let ce=class{constructor(V,pe){if(!V)throw new Error("Illegal argument, contents must be defined");Array.isArray(V)?this.contents=V:this.contents=[V],this.range=pe}};e.$oM=ce,e.$oM=ce=Qe([k],ce);var de;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(de||(e.DocumentHighlightKind=de={}));let H=class{constructor(V,pe=de.Text){this.range=V,this.kind=pe}toJSON(){return{range:this.range,kind:de[this.kind]}}};e.$pM=H,e.$pM=H=Qe([k],H);let Y=class{constructor(V,pe){this.uri=V,this.highlights=pe}toJSON(){return{uri:this.uri,highlights:this.highlights.map(V=>V.toJSON())}}};e.$qM=Y,e.$qM=Y=Qe([k],Y);var he;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(he||(e.SymbolKind=he={}));var be;(function(K){K[K.Deprecated=1]="Deprecated"})(be||(e.SymbolTag=be={}));let Pe=f=class{static validate(V){if(!V.name)throw new Error("name must not be falsy")}constructor(V,pe,Ne,Ye,it){this.name=V,this.kind=pe,this.containerName=it,typeof Ne=="string"&&(this.containerName=Ne),Ye instanceof ke?this.location=Ye:Ne instanceof T&&(this.location=new ke(Ye,Ne)),f.validate(this)}toJSON(){return{name:this.name,kind:he[this.kind],location:this.location,containerName:this.containerName}}};e.$rM=Pe,e.$rM=Pe=f=Qe([k],Pe);let we=h=class{static validate(V){if(!V.name)throw new Error("name must not be falsy");if(!V.range.contains(V.selectionRange))throw new Error("selectionRange must be contained in fullRange");V.children?.forEach(h.validate)}constructor(V,pe,Ne,Ye,it){this.name=V,this.detail=pe,this.kind=Ne,this.range=Ye,this.selectionRange=it,this.children=[],h.validate(this)}};e.$sM=we,e.$sM=we=h=Qe([k],we);var Ae;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Ae||(e.CodeActionTriggerKind=Ae={}));let Oe=class{constructor(V,pe){this.title=V,this.kind=pe}};e.$tM=Oe,e.$tM=Oe=Qe([k],Oe);let ze=class{static{s=this}static{this.c="."}constructor(V){this.value=V}append(V){return new s(this.value?this.value+s.c+V:V)}intersects(V){return this.contains(V)||V.contains(this)}contains(V){return this.value===V.value||V.value.startsWith(this.value+s.c)}};e.$uM=ze,e.$uM=ze=s=Qe([k],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let q=class{constructor(V,pe){if(this.range=V,this.parent=pe,pe&&!pe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vM=q,e.$vM=q=Qe([k],q);class W{constructor(V,pe,Ne,Ye,it,lt){this.kind=V,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=it,this.selectionRange=lt}}e.$wM=W;class Q{constructor(V,pe){this.fromRanges=pe,this.from=V}}e.$xM=Q;class J{constructor(V,pe){this.fromRanges=pe,this.to=V}}e.$yM=J;var $e;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})($e||(e.LanguageStatusSeverity=$e={}));let ve=class{constructor(V,pe){this.range=V,this.command=pe}get isResolved(){return!!this.command}};e.$zM=ve,e.$zM=ve=Qe([k],ve);let Te=a=class{#e;static isMarkdownString(V){return V instanceof a?!0:V&&V.appendCodeblock&&V.appendMarkdown&&V.appendText&&V.value!==void 0}constructor(V,pe=!1){this.#e=new L.$xk(V,{supportThemeIcons:pe})}get value(){return this.#e.value}set value(V){this.#e.value=V}get isTrusted(){return this.#e.isTrusted}set isTrusted(V){this.#e.isTrusted=V}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(V){this.#e.supportThemeIcons=V}get supportHtml(){return this.#e.supportHtml}set supportHtml(V){this.#e.supportHtml=V}get baseUri(){return this.#e.baseUri}set baseUri(V){this.#e.baseUri=V}appendText(V){return this.#e.appendText(V),this}appendMarkdown(V){return this.#e.appendMarkdown(V),this}appendCodeblock(V,pe){return this.#e.appendCodeblock(pe??"",V),this}};e.$AM=Te,e.$AM=Te=a=Qe([k],Te);let He=class{constructor(V,pe){this.label=V,this.documentation=pe}};e.$BM=He,e.$BM=He=Qe([k],He);let Xe=class{constructor(V,pe){this.label=V,this.documentation=pe,this.parameters=[]}};e.$CM=Xe,e.$CM=Xe=Qe([k],Xe);let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DM=tt,e.$DM=tt=Qe([k],tt);var st;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var ut;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(ut||(e.InlayHintKind=ut={}));let rt=class{constructor(V){this.value=V}};e.$EM=rt,e.$EM=rt=Qe([k],rt);let Ie=class{constructor(V,pe,Ne){this.position=V,this.label=pe,this.kind=Ne}};e.$FM=Ie,e.$FM=Ie=Qe([k],Ie);var Be;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Be||(e.CompletionTriggerKind=Be={}));var Le;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(Le||(e.CompletionItemKind=Le={}));var Ke;(function(K){K[K.Deprecated=1]="Deprecated"})(Ke||(e.CompletionItemTag=Ke={}));let ne=class{constructor(V,pe){this.label=V,this.kind=pe}toJSON(){return{label:this.label,kind:this.kind&&Le[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GM=ne,e.$GM=ne=Qe([k],ne);let oe=class{constructor(V=[],pe=!1){this.items=V,this.isIncomplete=pe}};e.$HM=oe,e.$HM=oe=Qe([k],oe);let Ce=class{constructor(V,pe,Ne){this.insertText=V,this.range=pe,this.command=Ne}};e.$IM=Ce,e.$IM=Ce=Qe([k],Ce);let Ge=class{constructor(V){this.commands=void 0,this.suppressSuggestions=void 0,this.items=V}};e.$JM=Ge,e.$JM=Ge=Qe([k],Ge);var xe;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var nt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Fe(K,V){return`${C.$Am.toKey(K)}.${V}`}e.$KM=Fe;var $t;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative",K[K.Interval=3]="Interval"})($t||(e.TextEditorLineNumbersStyle=$t={}));var Dt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Pt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Pt||(e.TextEditorRevealType=Pt={}));var jt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var Zt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Ct;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ct||(e.DecorationRangeBehavior=Ct={})),function(K){function V(pe){switch(pe){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=V}(jt||(e.TextEditorSelectionChangeKind=jt={}));var Jt;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(Jt||(e.SyntaxTokenType=Jt={})),function(K){function V(pe){switch(pe){case K.Other:return"other";case K.Comment:return"comment";case K.String:return"string";case K.RegEx:return"regex"}return"other"}K.toString=V}(Jt||(e.SyntaxTokenType=Jt={}));let Qt=class{constructor(V,pe){if(pe&&!E.URI.isUri(pe))throw(0,N.$7)("target");if(!T.isRange(V)||V.isEmpty)throw(0,N.$7)("range");this.range=V,this.target=pe}};e.$LM=Qt,e.$LM=Qt=Qe([k],Qt);let _t=class{constructor(V,pe,Ne,Ye){this.red=V,this.green=pe,this.blue=Ne,this.alpha=Ye}};e.$MM=_t,e.$MM=_t=Qe([k],_t);let ni=class{constructor(V,pe){if(pe&&!(pe instanceof _t))throw(0,N.$7)("color");if(!T.isRange(V)||V.isEmpty)throw(0,N.$7)("range");this.range=V,this.color=pe}};e.$NM=ni,e.$NM=ni=Qe([k],ni);let et=class{constructor(V){if(!V||typeof V!="string")throw(0,N.$7)("label");this.label=V}};e.$OM=et,e.$OM=et=Qe([k],et);var Bt;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Bt||(e.ColorFormat=Bt={}));var ei;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(ei||(e.SourceControlInputBoxValidationType=ei={}));var dt;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(dt||(e.TerminalExitReason=dt={}));class pt{constructor(V,pe,Ne){if(this.startIndex=V,this.length=pe,this.tooltip=Ne,typeof V!="number"||V<0)throw(0,N.$7)("startIndex");if(typeof pe!="number"||pe<1)throw(0,N.$7)("length");if(Ne!==void 0&&typeof Ne!="string")throw(0,N.$7)("tooltip")}}e.$PM=pt;class ti{constructor(V){this.uri=V}}e.$QM=ti;class Ht{constructor(V){this.terminalCommand=V}}e.$RM=Ht;var Ut;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(Ut||(e.TerminalLocation=Ut={}));class ft{constructor(V){if(this.options=V,typeof V!="object")throw(0,N.$7)("options")}}e.$SM=ft;var Rt;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(Rt||(e.TaskRevealKind=Rt={}));var ii;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(ii||(e.TaskPanelKind=ii={}));let Yt=class{static{d=this}static{this.Clean=new d("clean","Clean")}static{this.Build=new d("build","Build")}static{this.Rebuild=new d("rebuild","Rebuild")}static{this.Test=new d("test","Test")}static from(V){switch(V){case"clean":return d.Clean;case"build":return d.Build;case"rebuild":return d.Rebuild;case"test":return d.Test;default:return}}constructor(V,pe){if(this.label=pe,typeof V!="string"||typeof pe!="string")throw(0,N.$7)("name");this.c=V}get id(){return this.c}};e.$TM=Yt,e.$TM=Yt=d=Qe([k],Yt);function Ze(K){let V="";for(let pe=0;pe<K.length;pe++)V+=K[pe].replace(/,/g,",,")+",";return V}let Lt=class{constructor(V,pe,Ne){if(typeof V!="string")throw(0,N.$7)("process");this.e=[],this.c=V,pe!==void 0&&(Array.isArray(pe)?(this.e=pe,this.f=Ne):this.f=pe)}get process(){return this.c}set process(V){if(typeof V!="string")throw(0,N.$7)("process");this.c=V}get args(){return this.e}set args(V){Array.isArray(V)||(V=[]),this.e=V}get options(){return this.f}set options(V){this.f=V}computeId(){const V=[];if(V.push("process"),this.c!==void 0&&V.push(this.c),this.e&&this.e.length>0)for(const pe of this.e)V.push(pe);return Ze(V)}};e.$UM=Lt,e.$UM=Lt=Qe([k],Lt);let Wt=class{constructor(V,pe,Ne){if(this.f=[],Array.isArray(pe)){if(!V)throw(0,N.$7)("command can't be undefined or null");if(typeof V!="string"&&typeof V.value!="string")throw(0,N.$7)("command");this.e=V,this.f=pe,this.g=Ne}else{if(typeof V!="string")throw(0,N.$7)("commandLine");this.c=V,this.g=pe}}get commandLine(){return this.c}set commandLine(V){if(typeof V!="string")throw(0,N.$7)("commandLine");this.c=V}get command(){return this.e?this.e:""}set command(V){if(typeof V!="string"&&typeof V.value!="string")throw(0,N.$7)("command");this.e=V}get args(){return this.f}set args(V){this.f=V||[]}get options(){return this.g}set options(V){this.g=V}computeId(){const V=[];if(V.push("shell"),this.c!==void 0&&V.push(this.c),this.e!==void 0&&V.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const pe of this.f)V.push(typeof pe=="string"?pe:pe.value);return Ze(V)}};e.$VM=Wt,e.$VM=Wt=Qe([k],Wt);var ri;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var gt;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Ot{constructor(V){this.c=V}computeId(){return"customExecution"+(0,M.$Cg)()}set callback(V){this.c=V}get callback(){return this.c}}e.$WM=Ot;let At=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(V,pe,Ne,Ye,it,lt){this.k=!1,this.l=this.definition=V;let mt;typeof pe=="string"?(this.o=this.name=pe,this.w=this.source=Ne,this.execution=Ye,mt=it,this.k=!0):pe===gt.Global||pe===gt.Workspace?(this.target=pe,this.o=this.name=Ne,this.w=this.source=Ye,this.execution=it,mt=lt):(this.target=pe,this.o=this.name=Ne,this.w=this.source=Ye,this.execution=it,mt=lt),typeof mt=="string"?(this.r=[mt],this.t=!0):Array.isArray(mt)?(this.r=mt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(V){this.j=V}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Lt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Ot?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,M.$Cg)()}}get definition(){return this.l}set definition(V){if(V==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=V}get scope(){return this.m}set target(V){this.B(),this.m=V}get name(){return this.o}set name(V){if(typeof V!="string")throw(0,N.$7)("name");this.B(),this.o=V}get execution(){return this.q}set execution(V){V===null&&(V=void 0),this.B(),this.q=V;const pe=this.l.type;($.g===pe||$.e===pe||$.f===pe||$.c===pe)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(V){if(Array.isArray(V))this.B(),this.r=V,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(V){V!==!0&&V!==!1&&(V=!1),this.B(),this.u=V}get source(){return this.w}set source(V){if(typeof V!="string"||V.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=V}get group(){return this.x}set group(V){V===null&&(V=void 0),this.B(),this.x=V}get detail(){return this.A}set detail(V){V===null&&(V=void 0),this.A=V}get presentationOptions(){return this.y}set presentationOptions(V){V==null&&(V=Object.create(null)),this.B(),this.y=V}get runOptions(){return this.z}set runOptions(V){V==null&&(V=Object.create(null)),this.B(),this.z=V}};e.$XM=At,e.$XM=At=$=Qe([k],At);var qt;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var si;(function(K){function V(pe){const Ne=pe;return(0,p.$Xf)(Ne.value)?Ne.tooltip&&!(0,p.$Tf)(Ne.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ne.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ne.value),!1)}K.isViewBadge=V})(si||(e.ViewBadge=si={}));let zt=D=class{static isTreeItem(V,pe){const Ne=V;if(Ne.checkboxState!==void 0){const Ye=(0,p.$Xf)(Ne.checkboxState)?Ne.checkboxState:(0,p.$Vf)(Ne.checkboxState)&&(0,p.$Xf)(Ne.checkboxState.state)?Ne.checkboxState.state:void 0,it=!(0,p.$Xf)(Ne.checkboxState)&&(0,p.$Vf)(Ne.checkboxState)?Ne.checkboxState.tooltip:void 0;if(Ye===void 0||Ye!==yt.Checked&&Ye!==yt.Unchecked||it!==void 0&&!(0,p.$Tf)(it))return console.log("INVALID tree item, invalid checkboxState",Ne.checkboxState),!1}if(V instanceof D)return!0;if(Ne.label!==void 0&&!(0,p.$Tf)(Ne.label)&&!Ne.label?.label)return console.log("INVALID tree item, invalid label",Ne.label),!1;if(Ne.id!==void 0&&!(0,p.$Tf)(Ne.id))return console.log("INVALID tree item, invalid id",Ne.id),!1;if(Ne.iconPath!==void 0&&!(0,p.$Tf)(Ne.iconPath)&&!E.URI.isUri(Ne.iconPath)&&(!Ne.iconPath||!(0,p.$Tf)(Ne.iconPath.id))){const Ye=Ne.iconPath;if(!Ye||!(0,p.$Tf)(Ye.light)&&!E.URI.isUri(Ye.light)&&!(0,p.$Tf)(Ye.dark)&&!E.URI.isUri(Ye.dark))return console.log("INVALID tree item, invalid iconPath",Ne.iconPath),!1}return Ne.description!==void 0&&!(0,p.$Tf)(Ne.description)&&typeof Ne.description!="boolean"?(console.log("INVALID tree item, invalid description",Ne.description),!1):Ne.resourceUri!==void 0&&!E.URI.isUri(Ne.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ne.resourceUri),!1):Ne.tooltip!==void 0&&!(0,p.$Tf)(Ne.tooltip)&&!(Ne.tooltip instanceof Te)?(console.log("INVALID tree item, invalid tooltip",Ne.tooltip),!1):Ne.command!==void 0&&!Ne.command.command?(console.log("INVALID tree item, invalid command",Ne.command),!1):Ne.collapsibleState!==void 0&&Ne.collapsibleState<Kt.None&&Ne.collapsibleState>Kt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ne.collapsibleState),!1):Ne.contextValue!==void 0&&!(0,p.$Tf)(Ne.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ne.contextValue),!1):Ne.accessibilityInformation!==void 0&&!Ne.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ne.accessibilityInformation),!1):!0}constructor(V,pe=Kt.None){this.collapsibleState=pe,E.URI.isUri(V)?this.resourceUri=V:this.label=V}};e.$YM=zt,e.$YM=zt=D=Qe([k],zt);var Kt;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(Kt||(e.TreeItemCollapsibleState=Kt={}));var yt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(yt||(e.TreeItemCheckboxState=yt={}));let Nt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(V){this.value=V}};e.$ZM=Nt,e.$ZM=Nt=Qe([k],Nt);class Xt extends Nt{}e.$1M=Xt;class Vt extends Xt{#e;constructor(V){super(""),this.#e=V}asFile(){return this.#e}}e.$2M=Vt;class kt{constructor(V,pe,Ne,Ye){this.name=V,this.uri=pe,this._itemId=Ne,this.c=Ye}data(){return this.c()}}e.$3M=kt;let It=class{#e=new Map;constructor(V){for(const[pe,Ne]of V??[]){const Ye=this.#e.get(this.#t(pe));Ye?Ye.push(Ne):this.#e.set(this.#t(pe),[Ne])}}get(V){return this.#e.get(this.#t(V))?.[0]}set(V,pe){this.#e.set(this.#t(V),[pe])}forEach(V,pe){for(const[Ne,Ye]of this.#e)for(const it of Ye)V.call(pe,it,Ne,this)}*[Symbol.iterator](){for(const[V,pe]of this.#e)for(const Ne of pe)yield[V,Ne]}#t(V){return V.toLowerCase()}};e.$4M=It,e.$4M=It=Qe([k],It);let Et=class{constructor(V){this.insertText=V}};e.$5M=Et,e.$5M=Et=Qe([k],Et);let ci=class{constructor(V,pe){this.label=pe,this.insertText=V}};e.$6M=ci,e.$6M=ci=Qe([k],ci);let Re=class{constructor(V,pe){this.id=V,this.color=pe}static isThemeIcon(V){return typeof V.id!="string"?(console.log("INVALID ThemeIcon, invalid id",V.id),!1):!0}};e.$7M=Re,e.$7M=Re=Qe([k],Re),Re.File=new Re("file"),Re.Folder=new Re("folder");let je=class{constructor(V){this.id=V}};e.$8M=je,e.$8M=je=Qe([k],je);var Ee;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ee||(e.ConfigurationTarget=Ee={}));let ee=class{get base(){return this.c}set base(V){this.c=V,this.e=E.URI.file(V)}get baseUri(){return this.e}set baseUri(V){this.e=V,this.c=V.fsPath}constructor(V,pe){if(typeof V!="string"&&(!V||!E.URI.isUri(V)&&!E.URI.isUri(V.uri)))throw(0,N.$7)("base");if(typeof pe!="string")throw(0,N.$7)("pattern");typeof V=="string"?this.baseUri=E.URI.file(V):E.URI.isUri(V)?this.baseUri=V:this.baseUri=V.uri,this.pattern=pe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$9M=ee,e.$9M=ee=Qe([k],ee);const Me=new WeakMap;function qe(K,V){Me.set(K,V)}e.$0M=qe;let _e=class{constructor(V,pe,Ne,Ye,it){this.enabled=typeof V=="boolean"?V:!0,typeof pe=="string"&&(this.condition=pe),typeof Ne=="string"&&(this.hitCondition=Ne),typeof Ye=="string"&&(this.logMessage=Ye),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Me.get(this)??(0,M.$Cg)()),this.c}};e.$$M=_e,e.$$M=_e=Qe([k],_e);let Je=class extends _e{constructor(V,pe,Ne,Ye,it,lt){if(super(pe,Ne,Ye,it,lt),V===null)throw(0,N.$7)("location");this.location=V}};e.$_M=Je,e.$_M=Je=Qe([k],Je);let ct=class extends _e{constructor(V,pe,Ne,Ye,it,lt){super(pe,Ne,Ye,it,lt),this.functionName=V}};e.$aN=ct,e.$aN=ct=Qe([k],ct);let vt=class extends _e{constructor(V,pe,Ne,Ye,it,lt,mt,Gt){if(super(Ye,it,lt,mt,Gt),!pe)throw(0,N.$7)("dataId");this.label=V,this.dataId=pe,this.canPersist=Ne}};e.$bN=vt,e.$bN=vt=Qe([k],vt);let Ft=class{constructor(V,pe,Ne){this.command=V,this.args=pe||[],this.options=Ne}};e.$cN=Ft,e.$cN=Ft=Qe([k],Ft);let xt=class{constructor(V,pe){this.port=V,this.host=pe}};e.$dN=xt,e.$dN=xt=Qe([k],xt);let Mt=class{constructor(V){this.path=V}};e.$eN=Mt,e.$eN=Mt=Qe([k],Mt);let St=class{constructor(V){this.implementation=V}};e.$fN=St,e.$fN=St=Qe([k],St);let vi=class{constructor(V,pe,Ne){this.session=V,this.threadId=pe,this.frameId=Ne}};e.$gN=vi,e.$gN=vi=Qe([k],vi);let Pi=class{constructor(V,pe){this.session=V,this.threadId=pe}};e.$hN=Pi,e.$hN=Pi=Qe([k],Pi);let bi=class{constructor(V,pe){this.range=V,this.expression=pe}};e.$iN=bi,e.$iN=bi=Qe([k],bi);var pi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let ht=class{constructor(V,pe){this.range=V,this.text=pe}};e.$jN=ht,e.$jN=ht=Qe([k],ht);let Ai=class{constructor(V,pe,Ne=!0){this.range=V,this.variableName=pe,this.caseSensitiveLookup=Ne}};e.$kN=Ai,e.$kN=Ai=Qe([k],Ai);let ui=class{constructor(V,pe){this.range=V,this.expression=pe}};e.$lN=ui,e.$lN=ui=Qe([k],ui);let gi=class{constructor(V,pe){this.frameId=V,this.stoppedLocation=pe}};e.$mN=gi,e.$mN=gi=Qe([k],gi);var Ri;(function(K){K[K.AIGenerated=1]="AIGenerated"})(Ri||(e.NewSymbolNameTag=Ri={}));class ln{constructor(V,pe){this.newSymbolName=V,this.tags=pe}}e.$nN=ln;var Zi;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Li=b=class extends Error{static FileExists(V){return new b(V,v.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(V){return new b(V,v.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(V){return new b(V,v.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(V){return new b(V,v.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(V){return new b(V,v.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(V){return new b(V,v.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(V,pe=v.FileSystemProviderErrorCode.Unknown,Ne){super(E.URI.isUri(V)?V.toString(!0):V),this.code=Ne?.name??"Unknown",(0,v.$Vk)(this,pe),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Ne=="function"&&Error.captureStackTrace(this,Ne)}};e.$oN=Li,e.$oN=Li=b=Qe([k],Li);let ki=class{constructor(V,pe,Ne){this.start=V,this.end=pe,this.kind=Ne}};e.$pN=ki,e.$pN=ki=Qe([k],ki);var Yi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Mi;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(Mi||(e.CommentThreadCollapsibleState=Mi={}));var xi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(xi||(e.CommentMode=xi={}));var yi;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})(yi||(e.CommentState=yi={}));var Ei;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Ei||(e.CommentThreadState=Ei={}));class hn{constructor(V,pe=[]){this.tokenTypes=V,this.tokenModifiers=pe}}e.$qN=hn;function dn(K){return typeof K>"u"||(0,p.$Uf)(K)}class mi{constructor(V){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,V){this.m=!0;for(let pe=0,Ne=V.tokenTypes.length;pe<Ne;pe++)this.k.set(V.tokenTypes[pe],pe);for(let pe=0,Ne=V.tokenModifiers.length;pe<Ne;pe++)this.l.set(V.tokenModifiers[pe],pe)}}push(V,pe,Ne,Ye,it){if(typeof V=="number"&&typeof pe=="number"&&typeof Ne=="number"&&typeof Ye=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(V,pe,Ne,Ye,it);if(T.isRange(V)&&typeof pe=="string"&&dn(Ne))return this.o(V,pe,Ne);throw(0,N.$7)()}o(V,pe,Ne){if(!this.m)throw new Error("Legend must be provided in constructor");if(V.start.line!==V.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(pe))throw new Error("`tokenType` is not in the provided legend");const Ye=V.start.line,it=V.start.character,lt=V.end.character-V.start.character,mt=this.k.get(pe);let Gt=0;if(Ne)for(const ai of Ne){if(!this.l.has(ai))throw new Error("`tokenModifier` is not in the provided legend");const hi=this.l.get(ai);Gt|=1<<hi>>>0}this.q(Ye,it,lt,mt,Gt)}q(V,pe,Ne,Ye,it){if(this.f&&(V<this.c||V===this.c&&pe<this.e)){this.f=!1;const Gt=this.g.length/5|0;let ai=0,hi=0;for(let fi=0;fi<Gt;fi++){let $i=this.g[5*fi],Qi=this.g[5*fi+1];$i===0?($i=ai,Qi+=hi):$i+=ai,this.g[5*fi]=$i,this.g[5*fi+1]=Qi,ai=$i,hi=Qi}}let lt=V,mt=pe;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Ne,this.g[this.j++]=Ye,this.g[this.j++]=it,this.c=V,this.e=pe}static r(V){const pe=[],Ne=V.length/5|0;for(let mt=0;mt<Ne;mt++)pe[mt]=mt;pe.sort((mt,Gt)=>{const ai=V[5*mt],hi=V[5*Gt];if(ai===hi){const fi=V[5*mt+1],$i=V[5*Gt+1];return fi-$i}return ai-hi});const Ye=new Uint32Array(V.length);let it=0,lt=0;for(let mt=0;mt<Ne;mt++){const Gt=5*pe[mt],ai=V[Gt+0],hi=V[Gt+1],fi=V[Gt+2],$i=V[Gt+3],Qi=V[Gt+4],An=ai-it,_n=An===0?hi-lt:hi,Xi=5*mt;Ye[Xi+0]=An,Ye[Xi+1]=_n,Ye[Xi+2]=fi,Ye[Xi+3]=$i,Ye[Xi+4]=Qi,it=ai,lt=hi}return Ye}build(V){return this.f?new Oi(new Uint32Array(this.g),V):new Oi(mi.r(this.g),V)}}e.$rN=mi;class Oi{constructor(V,pe){this.resultId=pe,this.data=V}}e.$sN=Oi;class fn{constructor(V,pe,Ne){this.start=V,this.deleteCount=pe,this.data=Ne}}e.$tN=fn;class gn{constructor(V,pe){this.resultId=pe,this.edits=V}}e.$uN=gn;var _i;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class mn{constructor(V){this.name=V}}e.$vN=mn;let wi=class{static{this.Back={iconPath:new Re("arrow-left")}}constructor(){}};e.$wN=wi,e.$wN=wi=Qe([k],wi);var Ni;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Ni||(e.QuickPickItemKind=Ni={}));var en;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(en||(e.InputBoxValidationSeverity=en={}));var Fi;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Fi||(e.ExtensionKind=Fi={}));class tn{static validate(V){if(typeof V.badge=="string"){let pe=(0,w.$uf)(V.badge,0);if(pe<V.badge.length&&(pe+=(0,w.$uf)(V.badge,pe)),V.badge.length>pe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(V.badge&&!Re.isThemeIcon(V.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!V.color&&!V.badge&&!V.tooltip)throw new Error("The decoration is empty");return!0}constructor(V,pe,Ne){this.badge=V,this.tooltip=pe,this.color=Ne}}e.$xN=tn;let Ti=class{constructor(V){this.kind=V}};e.$yN=Ti,e.$yN=Ti=Qe([k],Ti);var nn;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(nn||(e.ColorThemeKind=nn={}));class di{static isNotebookRange(V){return V instanceof di?!0:V?typeof V.start=="number"&&typeof V.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(V,pe){if(V<0)throw(0,N.$7)("start must be positive");if(pe<0)throw(0,N.$7)("end must be positive");V<=pe?(this.c=V,this.e=pe):(this.c=pe,this.e=V)}with(V){let pe=this.c,Ne=this.e;return V.start!==void 0&&(pe=V.start),V.end!==void 0&&(Ne=V.end),pe===this.c&&Ne===this.e?this:new di(pe,Ne)}}e.$zN=di;class Si{static validate(V){if(typeof V.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof V.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof V.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(V){return Array.isArray(V)&&V.every(pe=>Si.isNotebookCellData(pe))}static isNotebookCellData(V){return!0}constructor(V,pe,Ne,Ye,it,lt,mt){this.kind=V,this.value=pe,this.languageId=Ne,this.mime=Ye,this.outputs=it??[],this.metadata=lt,this.executionSummary=mt,Si.validate(this)}}e.$AN=Si;class ji{constructor(V){this.cells=V}}e.$BN=ji;class oi{static isNotebookCellOutputItem(V){return V instanceof oi?!0:V?typeof V.mime=="string"&&V.data instanceof Uint8Array:!1}static error(V){const pe={name:V.name,message:V.message,stack:V.stack};return oi.json(pe,"application/vnd.code.notebook.error")}static stdout(V){return oi.text(V,"application/vnd.code.notebook.stdout")}static stderr(V){return oi.text(V,"application/vnd.code.notebook.stderr")}static bytes(V,pe="application/octet-stream"){return new oi(V,pe)}static#e=new TextEncoder;static text(V,pe=R.$us.text){const Ne=oi.#e.encode(String(V));return new oi(Ne,pe)}static json(V,pe="text/x-json"){const Ne=JSON.stringify(V,void 0,"	");return oi.text(Ne,pe)}constructor(V,pe){this.data=V,this.mime=pe;const Ne=(0,R.$ys)(pe,!0);if(!Ne)throw new Error(`INVALID mime type: ${pe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ne}}e.$CN=oi;class Ue{static isNotebookCellOutput(V){return V instanceof Ue?!0:!V||typeof V!="object"?!1:typeof V.id=="string"&&Array.isArray(V.items)}static ensureUniqueMimeTypes(V,pe=!1){const Ne=new Set,Ye=new Set;for(let it=0;it<V.length;it++){const lt=V[it],mt=(0,R.$ys)(lt.mime);if(!Ne.has(mt)||(0,y.$9J)(mt)){Ne.add(mt);continue}Ye.add(it),pe&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ye.size===0?V:V.filter((it,lt)=>!Ye.has(lt))}constructor(V,pe,Ne){this.items=Ue.ensureUniqueMimeTypes(V,!0),typeof pe=="string"?(this.id=pe,this.metadata=Ne):(this.id=(0,M.$Cg)(),this.metadata=pe??Ne)}}e.$DN=Ue;var li;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(li||(e.NotebookCellKind=li={}));var zi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(zi||(e.NotebookCellExecutionState=zi={}));var ot;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(ot||(e.NotebookCellStatusBarAlignment=ot={}));var bt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(bt||(e.NotebookEditorRevealType=bt={}));class $n{constructor(V,pe){this.text=V,this.alignment=pe}}e.$EN=$n;var rn;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(rn||(e.NotebookControllerAffinity=rn={}));var Bi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(Bi||(e.NotebookControllerAffinity2=Bi={}));class bn{constructor(V,pe=[]){this.uri=V,this.provides=(0,l.$3b)(pe)}}e.$FN=bn;class Di{constructor(V){this.label=V}}e.$GN=Di;var sn;(function(K){K[K.Named=1]="Named",K[K.Indexed=2]="Indexed"})(sn||(e.NotebookVariablesRequestKind=sn={}));let Ui=class{constructor(V,pe){this.label=V,this.timestamp=pe}};e.$HN=Ui,e.$HN=Ui=Qe([k],Ui);var on;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(on||(e.ExtensionMode=on={}));var Wi;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(Wi||(e.ExtensionRuntime=Wi={}));var an;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(an||(e.StandardTokenType=an={}));class pn{constructor(V,pe){this.ranges=V,this.wordPattern=pe}}e.$IN=pn;class wn{constructor(V){this.c=V}get autoForwardAction(){return this.c}}e.$JN=wn;var cn;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let qi=class{constructor(V=void 0,pe=void 0,Ne=void 0,Ye=!1){this.include=V,this.exclude=pe,this.profile=Ne,this.continuous=Ye}};e.$KN=qi,e.$KN=qi=Qe([k],qi);let Vi=g=class{static diff(V,pe,Ne){const Ye=new g(V);return Ye.expectedOutput=pe,Ye.actualOutput=Ne,Ye}constructor(V){this.message=V}};e.$LN=Vi,e.$LN=Vi=g=Qe([k],Vi);let Hi=class{constructor(V){this.id=V}};e.$MN=Hi,e.$MN=Hi=Qe([k],Hi);class Ci{constructor(V,pe){this.covered=V,this.total=pe}}e.$NN=Ci;const Ki=K=>{if(K&&K.covered>K.total)throw new Error(`The total number of covered items (${K.covered}) cannot be greater than the total (${K.total})`)};class Gi{static fromDetails(V,pe){const Ne=new Ci(0,0),Ye=new Ci(0,0),it=new Ci(0,0);for(const mt of pe)if("branches"in mt){Ne.total+=1,Ne.covered+=mt.executed?1:0;for(const Gt of mt.branches)Ye.total+=1,Ye.covered+=Gt.executed?1:0}else it.total+=1,it.covered+=mt.executed?1:0;const lt=new Gi(V,Ne,Ye.total>0?Ye:void 0,it.total>0?it:void 0);return lt.detailedCoverage=pe,lt}constructor(V,pe,Ne,Ye){this.uri=V,this.statementCoverage=pe,this.branchCoverage=Ne,this.declarationCoverage=Ye,Ki(pe),Ki(Ne),Ki(Ye)}}e.$ON=Gi;class me{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne=[]){this.executed=V,this.location=pe,this.branches=Ne}}e.$PN=me;class ye{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne){this.executed=V,this.location=pe,this.label=Ne}}e.$QN=ye;class We{get executionCount(){return+this.executed}set executionCount(V){this.executed=V}constructor(V,pe,Ne){this.name=V,this.executed=pe,this.location=Ne}}e.$RN=We;var at;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(at||(e.ExternalUriOpenerPriority=at={}));var wt;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(wt||(e.WorkspaceTrustState=wt={}));var Tt;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(Tt||(e.PortAutoForwardAction=Tt={}));class Ji{constructor(V,pe,Ne,Ye,it,lt){this.kind=V,this.name=pe,this.detail=Ne,this.uri=Ye,this.range=it,this.selectionRange=lt}}e.$SN=Ji;class Rn{constructor(V){this.uri=V}}e.$TN=Rn;class Ln{constructor(V,pe){this.original=V,this.modified=pe}}e.$UN=Ln;class Mn{constructor(V,pe,Ne,Ye){this.base=V,this.input1=pe,this.input2=Ne,this.result=Ye}}e.$VN=Mn;class On{constructor(V,pe){this.uri=V,this.viewType=pe}}e.$WN=On;class Nn{constructor(V){this.viewType=V}}e.$XN=Nn;class Fn{constructor(V,pe){this.uri=V,this.notebookType=pe}}e.$YN=Fn;class Tn{constructor(V,pe,Ne){this.original=V,this.modified=pe,this.notebookType=Ne}}e.$ZN=Tn;class jn{constructor(){}}e.$1N=jn;class zn{constructor(V,pe){this.uri=V,this.inputBoxUri=pe}}e.$2N=zn;class Bn{constructor(V){this.providerId=V}}e.$3N=Bn;var vn;(function(K){K[K.Down=0]="Down",K[K.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var kn;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(kn||(e.ChatCopyKind=kn={}));var yn;(function(K){K[K.Short=1]="Short",K[K.Medium=2]="Medium",K[K.Full=3]="Full"})(yn||(e.ChatVariableLevel=yn={}));class Un{constructor(V,pe){this.label=V,this.values=pe}}e.$4N=Un;var En;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone",K[K.Accepted=3]="Accepted",K[K.Bug=4]="Bug"})(En||(e.InteractiveEditorResponseFeedbackKind=En={}));var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Wn{constructor(V){this.value=typeof V=="string"?new Te(V):V}}e.$5N=Wn;class qn{constructor(V,pe){this.value=V,this.baseUri=pe}}e.$6N=qn;class Vn{constructor(V,pe){this.value=V,this.title=pe}}e.$7N=Vn;class Hn{constructor(V){this.value=V}}e.$8N=Hn;class Kn{constructor(V){this.value=V}}e.$9N=Kn;class Gn{constructor(V){this.value=V}}e.$0N=Gn;class Jn{constructor(V,pe,Ne,Ye){this.prompt=V,this.command=pe,this.variables=Ne,this.participant=Ye}}e.$$N=Jn;class Qn{constructor(V,pe,Ne,Ye){this.response=V,this.result=pe,this.participant=Ne,this.command=Ye}}e.$_N=Qn;class Xn{constructor(V){this.content=V}}e.$aO=Xn;class Zn{constructor(V,pe){this.content=V,this.name=pe}}e.$bO=Zn;class Yn{constructor(V){this.content=V}}e.$cO=Yn;class Ii extends Error{static NotFound(V){return new Ii(V,Ii.NotFound.name)}static NoPermissions(V){return new Ii(V,Ii.NoPermissions.name)}constructor(V,pe,Ne){super(V,{cause:Ne}),this.name="LanguageModelError",this.code=pe??""}}e.$dO=Ii;var Dn;(function(K){K[K.SymbolInformation=1]="SymbolInformation",K[K.CommandInformation=2]="CommandInformation",K[K.SearchInformation=3]="SearchInformation",K[K.SettingInformation=4]="SettingInformation"})(Dn||(e.RelatedInformationType=Dn={}));var Cn;(function(K){K[K.Started=1]="Started",K[K.Recognizing=2]="Recognizing",K[K.Recognized=3]="Recognized",K[K.Stopped=4]="Stopped"})(Cn||(e.SpeechToTextStatus=Cn={}));var In;(function(K){K[K.Recognized=1]="Recognized",K[K.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}));class xn{constructor(V,pe){this.text=V,this.range=pe}}e.$eO=xn;var Pn;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(Pn||(e.InlineEditTriggerKind=Pn={}))}),define(Se[318],De([1,0,6,7]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$0L.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,w,p){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(R);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(w,p)??[]}getRelatedInformation(R,w,p){return this.c.$getAiRelatedInformation(w,p)}registerRelatedInformationProvider(R,w,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiRelatedInformationProvider(E,w),new N.$_L(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$2hc=L}),define(Se[120],De([1,0,4,6,7,25,145,5,20]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=e.$aic=void 0,e.$aic=(0,w.$gi)("IExtHostAuthentication");let E=class{constructor(v){this.b=new Map,this.c=new l.$6d,this.onDidChangeSessions=this.c.event,this.d=new M,this.f=new M,this.a=v.getProxy(N.$0L.MainThreadAuthentication)}async getSession(v,S,y,u={}){const m=A.$Am.toKey(v.identifier),o=[...y].sort().join(" ");return await this.d.getOrCreate(`${m} ${S} ${o}`,async()=>{await this.a.$ensureProvider(S);const i=v.displayName||v.name;return this.a.$getSession(S,y,m,i,u)})}async getSessions(v,S,y){const u=A.$Am.toKey(v.identifier),m=[...y].sort().join(" ");return await this.f.getOrCreate(`${u} ${m}`,async()=>{await this.a.$ensureProvider(S);const o=v.displayName||v.name;return this.a.$getSessions(S,y,u,o)})}async removeSession(v,S){const y=this.b.get(v);return y?y.provider.removeSession(S):this.a.$removeSession(v,S)}registerAuthenticationProvider(v,S,y,u){if(this.b.get(v))throw new Error(`An authentication provider with id '${v}' is already registered.`);this.b.set(v,{label:S,provider:y,options:u??{supportsMultipleAccounts:!1}});const m=y.onDidChangeSessions(o=>this.a.$sendDidChangeSessions(v,o));return this.a.$registerAuthenticationProvider(v,S,u?.supportsMultipleAccounts??!1),new L.$_L(()=>{m.dispose(),this.b.delete(v),this.a.$unregisterAuthenticationProvider(v)})}$createSession(v,S,y){const u=this.b.get(v);if(u)return Promise.resolve(u.provider.createSession(S,y));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$removeSession(v,S){const y=this.b.get(v);if(y)return Promise.resolve(y.provider.removeSession(S));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$getSessions(v,S){const y=this.b.get(v);if(y)return Promise.resolve(y.provider.getSessions(S));throw new Error(`Unable to find authentication provider with handle: ${v}`)}$onDidChangeAuthenticationSessions(v,S){return v.startsWith(R.$cL)||this.c.fire({provider:{id:v,label:S}}),Promise.resolve()}};e.$bic=E,e.$bic=E=Qe([Ve(0,p.$pO)],E);class M{constructor(){this.a=new Map}getOrCreate(v,S){const y=this.a.get(v);if(y)return y;const u=S().finally(()=>this.a.delete(v));return this.a.set(v,u),u}}}),define(Se[151],De([1,0,2,6,7,5,20,12,19,14,17,26]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$cjc=e.$bjc=void 0;let S=class{static{v=this}static{this.c=0}static{this.d=250}constructor(u,m){this.h=m,this.f=new Map,this.g=u.getProxy(N.$0L.MainThreadDecorations)}registerFileDecorationProvider(u,m){const o=v.c++;this.f.set(o,{provider:u,extensionDescription:m}),this.g.$registerDecorationProvider(o,m.identifier.value);const i=u.onDidChangeFileDecorations&&u.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(o,null);return}const r=(0,p.$3b)(n);if(r.length<=v.d){this.g.$onDidChange(o,r);return}this.h.warn("[Decorations] CAPPING events from decorations provider",m.identifier.value,r.length);const c=r.map(h=>({uri:h,rank:(0,E.$Ze)(h.path,"/")})),t=(0,p.$zb)(c,(h,s)=>h.rank-s.rank||(0,E.$df)(h.uri.path,s.uri.path)),f=[];e:for(const h of t){let s;for(const a of h){const d=(0,M.$mc)(a.uri.path);if(s!==d&&(s=d,f.push(a.uri)>=v.d))break e}}this.g.$onDidChange(o,f)});return new L.$_L(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(u,m,o){if(!this.f.has(u))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:r}=this.f.get(u);return await Promise.all(m.map(async c=>{try{const{uri:t,id:f}=c,h=await Promise.resolve(n.provideFileDecoration(l.URI.revive(t),o));if(!h)return;try{L.$xN.validate(h),h.badge&&typeof h.badge!="string"&&(0,C.$1F)(r,"codiconDecoration"),i[f]=[h.propagate,h.tooltip,h.badge,h.color]}catch(s){this.h.warn(`INVALID decoration from extension '${r.identifier.value}': ${s}`)}}catch(t){this.h.error(t)}})),i}};e.$bjc=S,e.$bjc=S=v=Qe([Ve(0,R.$pO),Ve(1,w.$Aj)],S),e.$cjc=(0,A.$gi)("IExtHostDecorations")}),define(Se[319],De([1,0,13,2,7,6,15,22,14]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=void 0;class E{static{this.a=0}constructor(C,v,S){this.d=v,this.e=S,this.b=new Map,this.c=C.getProxy(A.$0L.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,v){if(Object.keys(R.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const S=E.a++;this.b.set(S,v),this.c.$registerTextContentProvider(S,C);let y;if(typeof v.onDidChange=="function"){let u;y=v.onDidChange(async m=>{if(m.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${m.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(m))return;u&&await u;const o=this.$provideTextDocumentContent(S,m).then(async i=>{if(!i&&typeof i!="string")return;const n=this.d.getDocument(m);if(!n)return;const r=(0,p.$0e)(i);if(!n.equalLines(r))return this.c.$onVirtualDocumentChange(m,i)}).catch(l.$1).finally(()=>{u===o&&(u=void 0)});u=o})}return new L.$_L(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),y&&(y.dispose(),y=void 0)})}$provideTextDocumentContent(C,v){const S=this.b.get(C);return S?Promise.resolve(S.provideTextDocumentContent(N.URI.revive(v),w.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}e.$ejc=E}),define(Se[152],De([1,0,61,15,14,181,129,7,19]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tO=e.$sO=e.$rO=void 0;const E=new Map;function M(y,u){u?E.set(y,u):E.delete(y)}e.$rO=M;function C(y){return E.get(y)}class v extends A.$Bv{constructor(u,m,o,i,n,r,c){super(m,o,i,n),this.c=u,this.m=r,this.q=c,this.b=!1}dispose(){(0,l.ok)(!this.b),this.b=!0,this.q=!1}equalLines(u){return(0,p.$ub)(this.f,u)}get document(){if(!this.a){const u=this;this.a={get uri(){return u.d},get fileName(){return u.d.fsPath},get isUntitled(){return u.d.scheme===N.Schemas.untitled},get languageId(){return u.m},get version(){return u.h},get isClosed(){return u.b},get isDirty(){return u.q},save(){return u.r()},getText(m){return m?u.s(m):u.getText()},get eol(){return u.g===`
`?w.EndOfLine.LF:w.EndOfLine.CRLF},get lineCount(){return u.f.length},lineAt(m){return u.t(m)},offsetAt(m){return u.u(m)},positionAt(m){return u.v(m)},validateRange(m){return u.w(m)},validatePosition(m){return u.x(m)},getWordRangeAtPosition(m,o){return u.y(m,o)}}}return Object.freeze(this.a)}_acceptLanguageId(u){(0,l.ok)(!this.b),this.m=u}_acceptIsDirty(u){(0,l.ok)(!this.b),this.q=u}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(u){const m=this.w(u);if(m.isEmpty)return"";if(m.isSingleLine)return this.f[m.start.line].substring(m.start.character,m.end.character);const o=this.g,i=m.start.line,n=m.end.line,r=[];r.push(this.f[i].substring(m.start.character));for(let c=i+1;c<n;c++)r.push(this.f[c]);return r.push(this.f[n].substring(0,m.end.character)),r.join(o)}t(u){let m;if(u instanceof w.$aM?m=u.line:typeof u=="number"&&(m=u),typeof m!="number"||m<0||m>=this.f.length||Math.floor(m)!==m)throw new Error("Illegal value for `line`");return new S(m,this.f[m],m===this.f.length-1)}u(u){return u=this.x(u),this.l(),this.j.getPrefixSum(u.line-1)+u.character}v(u){u=Math.floor(u),u=Math.max(0,u),this.l();const m=this.j.getIndexOf(u),o=this.f[m.index].length;return new w.$aM(m.index,Math.min(m.remainder,o))}w(u){if(!(u instanceof w.$bM))throw new Error("Invalid argument");const m=this.x(u.start),o=this.x(u.end);return m===u.start&&o===u.end?u:new w.$bM(m.line,m.character,o.line,o.character)}x(u){if(!(u instanceof w.$aM))throw new Error("Invalid argument");if(this.f.length===0)return u.with(0,0);let{line:m,character:o}=u,i=!1;if(m<0)m=0,o=0,i=!0;else if(m>=this.f.length)m=this.f.length-1,o=this.f[m].length,i=!0;else{const n=this.f[m].length;o<0?(o=0,i=!0):o>n&&(o=n,i=!0)}return i?new w.$aM(m,o):u}y(u,m){const o=this.x(u);if(!m)m=C(this.m);else if((0,L.$9e)(m))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${m.source}' because it matches the empty string.`);const i=(0,R.$Ms)(o.character+1,(0,R.$Ks)(m),this.f[o.line],0);if(i)return new w.$bM(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$sO=v;class S{constructor(u,m,o){this.a=u,this.b=m,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new w.$bM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new w.$bM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$tO=S}),define(Se[320],De([1,0,6,7]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class L{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(l.$0L.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,w,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(R);if(!E)throw new Error("Embedding vector provider not found");const M=await E.provideEmbeddingVector(w,p);if(!M)throw new Error("Embedding vector provider returned undefined");return M}registerEmbeddingVectorProvider(R,w,p){const E=this.b;return this.b++,this.a.set(E,p),this.c.$registerAiEmbeddingVectorProvider(w,E),new N.$_L(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$gjc=L}),define(Se[68],De([1,0,6,32,7,21,5,20,59,3,8,23,15]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=void 0;let y=S=class{constructor(m,o){this.b=new Map,this.c=new M.$ph,this.a=m.getProxy(l.$0L.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let r;const c=i.b.get(n.scheme);return c?(await i.a.$ensureActivation(n.scheme),r=await c.impl.stat(n)):r=await i.a.$stat(n),{type:r.type,ctime:r.ctime,mtime:r.mtime,size:r.size,permissions:r.permissions===N.FilePermission.Readonly?1:void 0}}catch(r){S.e(r)}},async readDirectory(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(r){return S.e(r)}},async createDirectory(n){try{const r=i.b.get(n.scheme);return r&&!r.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(r.impl,r.extUri,n)):await i.a.$mkdir(n)}catch(r){return S.e(r)}},async readFile(n){try{const r=i.b.get(n.scheme);return r?(await i.a.$ensureActivation(n.scheme),(await r.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(r){return S.e(r)}},async writeFile(n,r){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(c.impl,c.extUri,c.extUri.dirname(n)),await i.c.queueFor(n,()=>Promise.resolve(c.impl.writeFile(n,r,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,A.$te.wrap(r))}catch(c){return S.e(c)}},async delete(n,r){try{const c=i.b.get(n.scheme);return c&&!c.isReadonly&&!r?.useTrash?(await i.a.$ensureActivation(n.scheme),await c.impl.delete(n,{recursive:!1,...r})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...r})}catch(c){return S.e(c)}},async rename(n,r,c){try{return await i.a.$rename(n,r,{overwrite:!1,...c})}catch(t){return S.e(t)}},async copy(n,r,c){try{return await i.a.$copy(n,r,{overwrite:!1,...c})}catch(t){return S.e(t)}},isWritableFileSystem(n){const r=o.getCapabilities(n);if(typeof r=="number")return!(r&2048)}})}async d(m,o,i){const n=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await m.stat(i)).type&N.FileType.Directory))throw L.$oN.FileExists(`Unable to create folder '${i.scheme===v.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(r){if(N.$Wk(r)!==N.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(o.basename(i)),i=o.dirname(i)}for(let r=n.length-1;r>=0;r--){i=o.joinPath(i,n[r]);try{await m.createDirectory(i)}catch(c){if(N.$Wk(c)!==N.FileSystemProviderErrorCode.FileExists)throw c}}}static e(m){if(m instanceof L.$oN)throw m;if(m instanceof N.$Sk)switch(m.code){case N.FileSystemProviderErrorCode.FileExists:throw L.$oN.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$oN.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$oN.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$oN.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$oN.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$oN.Unavailable(m.message);default:throw new L.$oN(m.message,m.name)}if(!(m instanceof Error))throw new L.$oN(String(m));if(m.name==="ENOPRO"||m.message.includes("ENOPRO"))throw L.$oN.Unavailable(m.message);switch(m.name){case N.FileSystemProviderErrorCode.FileExists:throw L.$oN.FileExists(m.message);case N.FileSystemProviderErrorCode.FileNotFound:throw L.$oN.FileNotFound(m.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw L.$oN.FileNotADirectory(m.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw L.$oN.FileIsADirectory(m.message);case N.FileSystemProviderErrorCode.NoPermissions:throw L.$oN.NoPermissions(m.message);case N.FileSystemProviderErrorCode.Unavailable:throw L.$oN.Unavailable(m.message);default:throw new L.$oN(m.message,m.name)}}addFileSystemProvider(m,o,i){return this.b.set(m,{impl:o,extUri:i?.isCaseSensitive?C.$Jg:C.$Lg,isReadonly:!!i?.isReadonly}),(0,E.$Rc)(()=>this.b.delete(m))}getFileSystemProviderExtUri(m){return this.b.get(m)?.extUri??C.$Jg}};e.$tic=y,e.$tic=y=S=Qe([Ve(0,w.$pO),Ve(1,p.$7hc)],y),e.$uic=(0,R.$gi)("IExtHostConsumerFileSystem")}),define(Se[321],De([1,0,6,7]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class L{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(l.$0L.MainThreadIssueReporter)}async $getIssueReporterUri(R,w){if(this.a.size===0)throw new Error("No issue request handlers registered");const p=this.a.get(R);if(!p)throw new Error("Issue request handler not found");const E=await p.handleIssueUrlRequest();if(!E)throw new Error("Issue request handler returned no result");return E}async $getIssueReporterData(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(R);if(!p)throw new Error("Issue data provider not found");const E=await p.provideIssueData(w);if(!E)throw new Error("Issue data provider returned no result");return E}async $getIssueReporterTemplate(R,w){if(this.b.size===0)throw new Error("No issue request handlers registered");const p=this.b.get(R);if(!p)throw new Error("Issue data provider not found");const E=await p.provideIssueTemplate(w);if(!E)throw new Error("Issue template provider returned no result");return E}registerIssueUriRequestHandler(R,w){const p=R.identifier.value;return this.a.set(p,w),this.c.$registerIssueUriRequestHandler(p),new N.$_L(()=>{this.c.$unregisterIssueUriRequestHandler(p),this.a.delete(p)})}registerIssueDataProvider(R,w){const p=R.identifier.value;return this.b.set(p,w),this.c.$registerIssueDataProvider(p),new N.$_L(()=>{this.c.$unregisterIssueDataProvider(p),this.b.delete(p)})}}e.$xjc=L}),define(Se[93],De([1,0,5,27,12,68,2]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=e.$vic=void 0,e.$vic=(0,l.$gi)("IExtensionStoragePaths");let w=class{constructor(E,M,C){this.d=M,this.f=C,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(E){return R.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,M=await this.g(E);try{return await this.f.value.stat(M),this.d.trace("[ExtHostStorage] storage dir already exists",M),M}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",M),await this.f.value.createDirectory(M),await this.f.value.writeFile(R.URI.joinPath(M,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),M}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(E){if(this.c)return R.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return R.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$wic=w,e.$wic=w=Qe([Ve(0,N.$FO),Ve(1,L.$Aj),Ve(2,A.$uic)],w)}),define(Se[322],De([1,0,7,20,4]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=void 0;let A=class{constructor(w){this.a=new l.$yN(l.ColorThemeKind.Dark),this.b=new L.$6d}get activeColorTheme(){return this.a}$onColorThemeChange(w){let p;switch(w){case"light":p=l.ColorThemeKind.Light;break;case"hcDark":p=l.ColorThemeKind.HighContrast;break;case"hcLight":p=l.ColorThemeKind.HighContrastLight;break;default:p=l.ColorThemeKind.Dark}this.a=new l.$yN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$1jc=A,e.$1jc=A=Qe([Ve(0,N.$pO)],A)}),define(Se[69],De([1,0,22,4,3,226,5,12,88,6,27,20,7]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BAb=e.$AAb=e.TunnelDtoConverter=void 0;class S extends p.$Zv{}var y;(function(m){function o(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:n.protocol}}m.fromApiTunnel=o;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==p.TunnelPrivacyId.ConstantPrivate&&n.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}m.fromServiceTunnel=i})(y||(e.TunnelDtoConverter=y={})),e.$AAb=(0,R.$gi)("IExtHostTunnelService");let u=class extends L.$Tc{constructor(o,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$6d,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(E.$0L.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,o.displayName);if(n){const r=new S(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(r),r}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){o.portRange===void 0&&o.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,n),new v.$_L(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(o,i,n,r,c){const t=[];for(const h of o){const s=this.r.get(h);if(!s)return[];t.push(...await Promise.all(i.map(async a=>{let d;try{d=await s.provider.providePortAttributes({port:a,pid:n,commandLine:r},c)}catch{d=await s.provider.providePortAttributes(a,n,r,c)}return{providedAttributes:d,port:a}})))}const f=t.filter(h=>!!h.providedAttributes);return f.length>0?f.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(r,c)=>await o.provideTunnel(r,c,l.CancellationToken.None)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,L.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const n=o.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let r=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&r.length===0&&(r=[{id:"private",label:A.localize(0,null),themeIcon:"lock"},{id:"public",label:A.localize(1,null),themeIcon:"eye"}]);const c=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:r,protocol:!0}:void 0;this.a.$setTunnelProvider(c)}}else this.b=void 0;return(0,L.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const n=this.g.get(o.host);n.has(o.port)&&(i&&n.get(o.port).disposeListener.dispose(),await n.get(o.port).tunnel.dispose(),n.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const r=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),r===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const c=this.B(r.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(r.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:r,disposeListener:c}),y.fromApiTunnel(r)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(r=>this.f(r.host,r.port,r.detail??""))),n=o.filter((r,c)=>i[c]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(r=>r.port).join(", ")} to ${n.map(r=>r.port).join(", ")}`),n}};e.$BAb=u,e.$BAb=u=Qe([Ve(0,C.$pO),Ve(1,M.$FO),Ve(2,w.$Aj)],u)}),define(Se[16],De([1,0,19,21,170,73,79,28,164,56,101,24,23,18,2,29,82,138,144,142,119,66,89,296,26,7]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$oO=e.$nO=e.MarkdownString=e.$mO=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var a;(function(Re){function je(ee){const{selectionStartLineNumber:Me,selectionStartColumn:qe,positionLineNumber:_e,positionColumn:Je}=ee,ct=new s.$aM(Me-1,qe-1),vt=new s.$aM(_e-1,Je-1);return new s.$cM(ct,vt)}Re.to=je;function Ee(ee){const{anchor:Me,active:qe}=ee;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:qe.line+1,positionColumn:qe.character+1}}Re.from=Ee})(a||(e.Selection=a={}));var d;(function(Re){function je(ee){if(!ee)return;const{start:Me,end:qe}=ee;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:qe.line+1,endColumn:qe.character+1}}Re.from=je;function Ee(ee){if(!ee)return;const{startLineNumber:Me,startColumn:qe,endLineNumber:_e,endColumn:Je}=ee;return new s.$bM(Me-1,qe-1,_e-1,Je-1)}Re.to=Ee})(d||(e.Range=d={}));var $;(function(Re){function je(ee){return{uri:ee.uri,range:d.from(ee.range)}}Re.from=je;function Ee(ee){return new s.$lM(y.URI.revive(ee.uri),d.to(ee.range))}Re.to=Ee})($||(e.Location=$={}));var D;(function(Re){function je(Ee){switch(Ee){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Re.to=je})(D||(e.TokenType=D={}));var b;(function(Re){function je(ee){return new s.$aM(ee.lineNumber-1,ee.column-1)}Re.to=je;function Ee(ee){return{lineNumber:ee.line+1,column:ee.character+1}}Re.from=Ee})(b||(e.Position=b={}));var g;(function(Re){function je(Me,qe,_e){return(0,l.$Hb)((0,l.$3b)(Me).map(Je=>Ee(Je,qe,_e)))}Re.from=je;function Ee(Me,qe,_e){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:_e?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ee(Me.scheme,qe),pattern:oe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:_e?.isBuiltin}}function ee(Me,qe){return qe&&typeof Me=="string"?qe.transformOutgoingScheme(Me):Me}})(g||(e.DocumentSelector=g={}));var k;(function(Re){function je(ee){switch(ee){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Re.from=je;function Ee(ee){switch(ee){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Re.to=Ee})(k||(e.DiagnosticTag=k={}));var P;(function(Re){function je(ee){let Me;return ee.code&&((0,S.$Tf)(ee.code)||(0,S.$Xf)(ee.code)?Me=String(ee.code):Me={value:String(ee.code.value),target:ee.code.target}),{...d.from(ee.range),message:ee.message,source:ee.source,code:Me,severity:U.from(ee.severity),relatedInformation:ee.relatedInformation&&ee.relatedInformation.map(F.from),tags:Array.isArray(ee.tags)?(0,l.$Hb)(ee.tags.map(k.from)):void 0}}Re.from=je;function Ee(ee){const Me=new s.$nM(d.to(ee),ee.message,U.to(ee.severity));return Me.source=ee.source,Me.code=(0,S.$Tf)(ee.code)?ee.code:ee.code?.value,Me.relatedInformation=ee.relatedInformation&&ee.relatedInformation.map(F.to),Me.tags=ee.tags&&(0,l.$Hb)(ee.tags.map(k.to)),Me}Re.to=Ee})(P||(e.Diagnostic=P={}));var F;(function(Re){function je(ee){return{...d.from(ee.location.range),message:ee.message,resource:ee.location.uri}}Re.from=je;function Ee(ee){return new s.$mM(new s.$lM(ee.resource,d.to(ee)),ee.message)}Re.to=Ee})(F||(e.DiagnosticRelatedInformation=F={}));var U;(function(Re){function je(ee){switch(ee){case s.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}Re.from=je;function Ee(ee){switch(ee){case o.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Re.to=Ee})(U||(e.DiagnosticSeverity=U={}));var z;(function(Re){function je(ee){return typeof ee=="number"&&ee>=s.ViewColumn.One?ee-1:ee===s.ViewColumn.Beside?f.$uD:f.$tD}Re.from=je;function Ee(ee){if(typeof ee=="number"&&ee>=0)return ee+1;throw new Error("invalid 'EditorGroupColumn'")}Re.to=Ee})(z||(e.ViewColumn=z={}));function T(Re){return typeof Re.range<"u"}function I(Re){return Re.length===0?!0:!!T(Re[0])}e.$mO=I;var O;(function(Re){function je(Je){return Je.map(Re.from)}Re.fromMany=je;function Ee(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ee(Je){let ct;if(Ee(Je)){const{language:Mt,value:St}=Je;ct={value:"```"+Mt+`
`+St+"\n```\n"}}else s.$AM.isMarkdownString(Je)?ct={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ct={value:Je}:ct={value:""};const vt=Object.create(null);ct.uris=vt;const Ft=Mt=>{try{let St=y.URI.parse(Mt,!0);St=St.with({query:Me(St.query,vt)}),vt[Mt]=St}catch{}return""},xt=new p.marked.Renderer;return xt.link=Ft,xt.image=Mt=>typeof Mt=="string"?Ft(R.$Fk(Mt).href):"",(0,p.marked)(ct.value,{renderer:xt}),ct}Re.from=ee;function Me(Je,ct){if(!Je)return Je;let vt;try{vt=(0,E.$Oh)(Je)}catch{}if(!vt)return Je;let Ft=!1;return vt=(0,C.$Nn)(vt,xt=>{if(y.URI.isUri(xt)){const Mt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Mt]=xt,Ft=!0,Mt}else return}),Ft?JSON.stringify(vt):Je}function qe(Je){const ct=new s.$AM(Je.value,Je.supportThemeIcons);return ct.isTrusted=Je.isTrusted,ct.supportHtml=Je.supportHtml,ct.baseUri=Je.baseUri?y.URI.from(Je.baseUri):void 0,ct}Re.to=qe;function _e(Je){if(Je)return typeof Je=="string"?Je:Re.from(Je)}Re.fromStrict=_e})(O||(e.MarkdownString=O={}));function j(Re){return I(Re)?Re.map(je=>({range:d.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?O.fromMany(je.hoverMessage):je.hoverMessage?O.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Re.map(je=>({range:d.from(je)}))}e.$nO=j;function G(Re){return typeof Re>"u"?Re:typeof Re=="string"?y.URI.file(Re):Re}e.$oO=G;var te;(function(Re){function je(Ee){return typeof Ee>"u"?Ee:{contentText:Ee.contentText,contentIconPath:Ee.contentIconPath?G(Ee.contentIconPath):void 0,border:Ee.border,borderColor:Ee.borderColor,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,color:Ee.color,backgroundColor:Ee.backgroundColor,margin:Ee.margin,width:Ee.width,height:Ee.height}}Re.from=je})(te||(e.ThemableDecorationAttachmentRenderOptions=te={}));var x;(function(Re){function je(Ee){return typeof Ee>"u"?Ee:{backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?te.from(Ee.before):void 0,after:Ee.after?te.from(Ee.after):void 0}}Re.from=je})(x||(e.ThemableDecorationRenderOptions=x={}));var Z;(function(Re){function je(Ee){if(typeof Ee>"u")return Ee;switch(Ee){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Re.from=je})(Z||(e.DecorationRangeBehavior=Z={}));var X;(function(Re){function je(Ee){return{isWholeLine:Ee.isWholeLine,rangeBehavior:Ee.rangeBehavior?Z.from(Ee.rangeBehavior):void 0,overviewRulerLane:Ee.overviewRulerLane,light:Ee.light?x.from(Ee.light):void 0,dark:Ee.dark?x.from(Ee.dark):void 0,backgroundColor:Ee.backgroundColor,outline:Ee.outline,outlineColor:Ee.outlineColor,outlineStyle:Ee.outlineStyle,outlineWidth:Ee.outlineWidth,border:Ee.border,borderColor:Ee.borderColor,borderRadius:Ee.borderRadius,borderSpacing:Ee.borderSpacing,borderStyle:Ee.borderStyle,borderWidth:Ee.borderWidth,fontStyle:Ee.fontStyle,fontWeight:Ee.fontWeight,textDecoration:Ee.textDecoration,cursor:Ee.cursor,color:Ee.color,opacity:Ee.opacity,letterSpacing:Ee.letterSpacing,gutterIconPath:Ee.gutterIconPath?G(Ee.gutterIconPath):void 0,gutterIconSize:Ee.gutterIconSize,overviewRulerColor:Ee.overviewRulerColor,before:Ee.before?te.from(Ee.before):void 0,after:Ee.after?te.from(Ee.after):void 0}}Re.from=je})(X||(e.DecorationRenderOptions=X={}));var ae;(function(Re){function je(ee){return{text:ee.newText,eol:ee.newEol&&Ie.from(ee.newEol),range:d.from(ee.range)}}Re.from=je;function Ee(ee){const Me=new s.$gM(d.to(ee.range),ee.text);return Me.newEol=typeof ee.eol>"u"?void 0:Ie.to(ee.eol),Me}Re.to=Ee})(ae||(e.TextEdit=ae={}));var _;(function(Re){function je(ee,Me){const qe={edits:[]};if(ee instanceof s.$jM){const _e=new w.$Bc;for(const Je of ee._allEntries())Je._type===1&&y.URI.isUri(Je.to)&&Je.from===void 0&&_e.add(Je.to);for(const Je of ee._allEntries())if(Je._type===1){let ct;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ct={type:"base64",value:(0,N.$Ne)(N.$te.wrap(Je.options.contents))}:ct={type:"dataTransferItem",id:Je.options.contents._itemId}),qe.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ct},metadata:Je.metadata})}else Je._type===2?qe.edits.push({resource:Je.uri,textEdit:ae.from(Je.edit),versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?qe.edits.push({resource:Je.uri,textEdit:{range:d.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:_e.has(Je.uri)?void 0:Me?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?qe.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&qe.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Pt.from)}})}return qe}Re.from=je;function Ee(ee){const Me=new s.$jM,qe=new w.$Ac;for(const _e of ee.edits)if(_e.textEdit){const Je=_e,ct=y.URI.revive(Je.resource),vt=d.to(Je.textEdit.range),Ft=Je.textEdit.text,xt=Je.textEdit.insertAsSnippet;let Mt;xt?Mt=s.$iM.replace(vt,new s.$kM(Ft)):Mt=s.$gM.replace(vt,Ft);const St=qe.get(ct);St?St.push(Mt):qe.set(ct,[Mt])}else Me.renameFile(y.URI.revive(_e.oldResource),y.URI.revive(_e.newResource),_e.options);for(const[_e,Je]of qe)Me.set(_e,Je);return Me}Re.to=Ee})(_||(e.WorkspaceEdit=_={}));var ge;(function(Re){const je=Object.create(null);je[s.SymbolKind.File]=0,je[s.SymbolKind.Module]=1,je[s.SymbolKind.Namespace]=2,je[s.SymbolKind.Package]=3,je[s.SymbolKind.Class]=4,je[s.SymbolKind.Method]=5,je[s.SymbolKind.Property]=6,je[s.SymbolKind.Field]=7,je[s.SymbolKind.Constructor]=8,je[s.SymbolKind.Enum]=9,je[s.SymbolKind.Interface]=10,je[s.SymbolKind.Function]=11,je[s.SymbolKind.Variable]=12,je[s.SymbolKind.Constant]=13,je[s.SymbolKind.String]=14,je[s.SymbolKind.Number]=15,je[s.SymbolKind.Boolean]=16,je[s.SymbolKind.Array]=17,je[s.SymbolKind.Object]=18,je[s.SymbolKind.Key]=19,je[s.SymbolKind.Null]=20,je[s.SymbolKind.EnumMember]=21,je[s.SymbolKind.Struct]=22,je[s.SymbolKind.Event]=23,je[s.SymbolKind.Operator]=24,je[s.SymbolKind.TypeParameter]=25;function Ee(Me){return typeof je[Me]=="number"?je[Me]:6}Re.from=Ee;function ee(Me){for(const qe in je)if(je[qe]===Me)return Number(qe);return s.SymbolKind.Property}Re.to=ee})(ge||(e.SymbolKind=ge={}));var se;(function(Re){function je(ee){switch(ee){case s.SymbolTag.Deprecated:return 1}}Re.from=je;function Ee(ee){switch(ee){case 1:return s.SymbolTag.Deprecated}}Re.to=Ee})(se||(e.SymbolTag=se={}));var re;(function(Re){function je(ee){return{name:ee.name,kind:ge.from(ee.kind),tags:ee.tags&&ee.tags.map(se.from),containerName:ee.containerName,location:ue.from(ee.location)}}Re.from=je;function Ee(ee){const Me=new s.$rM(ee.name,ge.to(ee.kind),ee.containerName,ue.to(ee.location));return Me.tags=ee.tags&&ee.tags.map(se.to),Me}Re.to=Ee})(re||(e.WorkspaceSymbol=re={}));var B;(function(Re){function je(ee){const Me={name:ee.name||"!!MISSING: name!!",detail:ee.detail,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),kind:ge.from(ee.kind),tags:ee.tags?.map(se.from)??[]};return ee.children&&(Me.children=ee.children.map(je)),Me}Re.from=je;function Ee(ee){const Me=new s.$sM(ee.name,ee.detail,ge.to(ee.kind),d.to(ee.range),d.to(ee.selectionRange));return(0,l.$Lb)(ee.tags)&&(Me.tags=ee.tags.map(se.to)),ee.children&&(Me.children=ee.children.map(Ee)),Me}Re.to=Ee})(B||(e.DocumentSymbol=B={}));var ie;(function(Re){function je(ee){const Me=new s.$wM(ge.to(ee.kind),ee.name,ee.detail||"",y.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Me._sessionId=ee._sessionId,Me._itemId=ee._itemId,Me}Re.to=je;function Ee(ee,Me,qe){if(Me=Me??ee._sessionId,qe=qe??ee._itemId,Me===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:qe,name:ee.name,detail:ee.detail,kind:ge.from(ee.kind),uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(se.from)}}Re.from=Ee})(ie||(e.CallHierarchyItem=ie={}));var ke;(function(Re){function je(Ee){return new s.$xM(ie.to(Ee.from),Ee.fromRanges.map(ee=>d.to(ee)))}Re.to=je})(ke||(e.CallHierarchyIncomingCall=ke={}));var le;(function(Re){function je(Ee){return new s.$yM(ie.to(Ee.to),Ee.fromRanges.map(ee=>d.to(ee)))}Re.to=je})(le||(e.CallHierarchyOutgoingCall=le={}));var ue;(function(Re){function je(ee){return{range:ee.range&&d.from(ee.range),uri:ee.uri}}Re.from=je;function Ee(ee){return new s.$lM(y.URI.revive(ee.uri),d.to(ee.range))}Re.to=Ee})(ue||(e.location=ue={}));var ce;(function(Re){function je(ee){const Me=ee,qe=ee;return{originSelectionRange:Me.originSelectionRange?d.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:qe.uri,range:d.from(Me.targetRange?Me.targetRange:qe.range),targetSelectionRange:Me.targetSelectionRange?d.from(Me.targetSelectionRange):void 0}}Re.from=je;function Ee(ee){return{targetUri:y.URI.revive(ee.uri),targetRange:d.to(ee.range),targetSelectionRange:ee.targetSelectionRange?d.to(ee.targetSelectionRange):void 0,originSelectionRange:ee.originSelectionRange?d.to(ee.originSelectionRange):void 0}}Re.to=Ee})(ce||(e.DefinitionLink=ce={}));var de;(function(Re){function je(ee){return{range:d.from(ee.range),contents:O.fromMany(ee.contents)}}Re.from=je;function Ee(ee){return new s.$oM(ee.contents.map(O.to),d.to(ee.range))}Re.to=Ee})(de||(e.Hover=de={}));var H;(function(Re){function je(ee){return{range:d.from(ee.range),expression:ee.expression}}Re.from=je;function Ee(ee){return new s.$iN(d.to(ee.range),ee.expression)}Re.to=Ee})(H||(e.EvaluatableExpression=H={}));var Y;(function(Re){function je(ee){if(ee instanceof s.$jN)return{type:"text",range:d.from(ee.range),text:ee.text};if(ee instanceof s.$kN)return{type:"variable",range:d.from(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};if(ee instanceof s.$lN)return{type:"expression",range:d.from(ee.range),expression:ee.expression};throw new Error("Unknown 'InlineValue' type")}Re.from=je;function Ee(ee){switch(ee.type){case"text":return{range:d.to(ee.range),text:ee.text};case"variable":return{range:d.to(ee.range),variableName:ee.variableName,caseSensitiveLookup:ee.caseSensitiveLookup};case"expression":return{range:d.to(ee.range),expression:ee.expression}}}Re.to=Ee})(Y||(e.InlineValue=Y={}));var he;(function(Re){function je(ee){return{frameId:ee.frameId,stoppedLocation:d.from(ee.stoppedLocation)}}Re.from=je;function Ee(ee){return new s.$mN(ee.frameId,d.to(ee.stoppedLocation))}Re.to=Ee})(he||(e.InlineValueContext=he={}));var be;(function(Re){function je(ee){return{range:d.from(ee.range),kind:ee.kind}}Re.from=je;function Ee(ee){return new s.$pM(d.to(ee.range),ee.kind)}Re.to=Ee})(be||(e.DocumentHighlight=be={}));var Pe;(function(Re){function je(ee){return{uri:ee.uri,highlights:ee.highlights.map(be.from)}}Re.from=je;function Ee(ee){return new s.$qM(y.URI.revive(ee.uri),ee.highlights.map(be.to))}Re.to=Ee})(Pe||(e.MultiDocumentHighlight=Pe={}));var we;(function(Re){function je(Ee){switch(Ee){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Re.to=je})(we||(e.CompletionTriggerKind=we={}));var Ae;(function(Re){function je(Ee){return{triggerKind:we.to(Ee.triggerKind),triggerCharacter:Ee.triggerCharacter}}Re.to=je})(Ae||(e.CompletionContext=Ae={}));var Oe;(function(Re){function je(ee){switch(ee){case s.CompletionItemTag.Deprecated:return 1}}Re.from=je;function Ee(ee){switch(ee){case 1:return s.CompletionItemTag.Deprecated}}Re.to=Ee})(Oe||(e.CompletionItemTag=Oe={}));var ze;(function(Re){const je=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ee(qe){return je.get(qe)??9}Re.from=Ee;const ee=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Me(qe){return ee.get(qe)??s.CompletionItemKind.Property}Re.to=Me})(ze||(e.CompletionItemKind=ze={}));var q;(function(Re){function je(Ee,ee){const Me=new s.$GM(Ee.label);return Me.insertText=Ee.insertText,Me.kind=ze.to(Ee.kind),Me.tags=Ee.tags?.map(Oe.to),Me.detail=Ee.detail,Me.documentation=R.$zk(Ee.documentation)?O.to(Ee.documentation):Ee.documentation,Me.sortText=Ee.sortText,Me.filterText=Ee.filterText,Me.preselect=Ee.preselect,Me.commitCharacters=Ee.commitCharacters,u.$0s.isIRange(Ee.range)?Me.range=d.to(Ee.range):typeof Ee.range=="object"&&(Me.range={inserting:d.to(Ee.range.insert),replacing:d.to(Ee.range.replace)}),Me.keepWhitespace=typeof Ee.insertTextRules>"u"?!1:!!(Ee.insertTextRules&1),typeof Ee.insertTextRules<"u"&&Ee.insertTextRules&4?Me.insertText=new s.$kM(Ee.insertText):(Me.insertText=Ee.insertText,Me.textEdit=Me.range instanceof s.$bM?new s.$gM(Me.range,Me.insertText):void 0),Ee.additionalTextEdits&&Ee.additionalTextEdits.length>0&&(Me.additionalTextEdits=Ee.additionalTextEdits.map(qe=>ae.to(qe))),Me.command=ee&&Ee.command?ee.fromInternal(Ee.command):void 0,Me}Re.to=je})(q||(e.CompletionItem=q={}));var W;(function(Re){function je(ee){if(typeof ee.label!="string"&&!Array.isArray(ee.label))throw new TypeError("Invalid label");return{label:ee.label,documentation:O.fromStrict(ee.documentation)}}Re.from=je;function Ee(ee){return{label:ee.label,documentation:R.$zk(ee.documentation)?O.to(ee.documentation):ee.documentation}}Re.to=Ee})(W||(e.ParameterInformation=W={}));var Q;(function(Re){function je(ee){return{label:ee.label,documentation:O.fromStrict(ee.documentation),parameters:Array.isArray(ee.parameters)?ee.parameters.map(W.from):[],activeParameter:ee.activeParameter}}Re.from=je;function Ee(ee){return{label:ee.label,documentation:R.$zk(ee.documentation)?O.to(ee.documentation):ee.documentation,parameters:Array.isArray(ee.parameters)?ee.parameters.map(W.to):[],activeParameter:ee.activeParameter}}Re.to=Ee})(Q||(e.SignatureInformation=Q={}));var J;(function(Re){function je(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.from):[]}}Re.from=je;function Ee(ee){return{activeSignature:ee.activeSignature,activeParameter:ee.activeParameter,signatures:Array.isArray(ee.signatures)?ee.signatures.map(Q.to):[]}}Re.to=Ee})(J||(e.SignatureHelp=J={}));var $e;(function(Re){function je(Ee,ee){const Me=new s.$FM(b.to(ee.position),typeof ee.label=="string"?ee.label:ee.label.map(ve.to.bind(void 0,Ee)),ee.kind&&Te.to(ee.kind));return Me.textEdits=ee.textEdits&&ee.textEdits.map(ae.to),Me.tooltip=R.$zk(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,Me.paddingLeft=ee.paddingLeft,Me.paddingRight=ee.paddingRight,Me}Re.to=je})($e||(e.InlayHint=$e={}));var ve;(function(Re){function je(Ee,ee){const Me=new s.$EM(ee.label);return Me.tooltip=R.$zk(ee.tooltip)?O.to(ee.tooltip):ee.tooltip,m.Command.is(ee.command)&&(Me.command=Ee.fromInternal(ee.command)),ee.location&&(Me.location=ue.to(ee.location)),Me}Re.to=je})(ve||(e.InlayHintLabelPart=ve={}));var Te;(function(Re){function je(ee){return ee}Re.from=je;function Ee(ee){return ee}Re.to=Ee})(Te||(e.InlayHintKind=Te={}));var He;(function(Re){function je(ee){return{range:d.from(ee.range),url:ee.target,tooltip:ee.tooltip}}Re.from=je;function Ee(ee){let Me;if(ee.url)try{Me=typeof ee.url=="string"?y.URI.parse(ee.url,!0):y.URI.revive(ee.url)}catch{}return new s.$LM(d.to(ee.range),Me)}Re.to=Ee})(He||(e.DocumentLink=He={}));var Xe;(function(Re){function je(ee){const Me=new s.$OM(ee.label);return ee.textEdit&&(Me.textEdit=ae.to(ee.textEdit)),ee.additionalTextEdits&&(Me.additionalTextEdits=ee.additionalTextEdits.map(qe=>ae.to(qe))),Me}Re.to=je;function Ee(ee){return{label:ee.label,textEdit:ee.textEdit?ae.from(ee.textEdit):void 0,additionalTextEdits:ee.additionalTextEdits?ee.additionalTextEdits.map(Me=>ae.from(Me)):void 0}}Re.from=Ee})(Xe||(e.ColorPresentation=Xe={}));var tt;(function(Re){function je(ee){return new s.$MM(ee[0],ee[1],ee[2],ee[3])}Re.to=je;function Ee(ee){return[ee.red,ee.green,ee.blue,ee.alpha]}Re.from=Ee})(tt||(e.Color=tt={}));var st;(function(Re){function je(ee){return{range:d.from(ee.range)}}Re.from=je;function Ee(ee){return new s.$vM(d.to(ee.range))}Re.to=Ee})(st||(e.SelectionRange=st={}));var ut;(function(Re){function je(Ee){switch(Ee){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Re.to=je})(ut||(e.TextDocumentSaveReason=ut={}));var rt;(function(Re){function je(ee){switch(ee){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.Interval:return 3;case s.TextEditorLineNumbersStyle.On:default:return 1}}Re.from=je;function Ee(ee){switch(ee){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 3:return s.TextEditorLineNumbersStyle.Interval;case 1:default:return s.TextEditorLineNumbersStyle.On}}Re.to=Ee})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Ie;(function(Re){function je(ee){if(ee===s.EndOfLine.CRLF)return 1;if(ee===s.EndOfLine.LF)return 0}Re.from=je;function Ee(ee){if(ee===1)return s.EndOfLine.CRLF;if(ee===0)return s.EndOfLine.LF}Re.to=Ee})(Ie||(e.EndOfLine=Ie={}));var Be;(function(Re){function je(Ee){if(typeof Ee=="object")return Ee.viewId;switch(Ee){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Re.from=je})(Be||(e.ProgressLocation=Be={}));var Le;(function(Re){function je(ee){const Me={start:ee.start+1,end:ee.end+1};return ee.kind&&(Me.kind=Ke.from(ee.kind)),Me}Re.from=je;function Ee(ee){const Me={start:ee.start-1,end:ee.end-1};return ee.kind&&(Me.kind=Ke.to(ee.kind)),Me}Re.to=Ee})(Le||(e.FoldingRange=Le={}));var Ke;(function(Re){function je(ee){if(ee)switch(ee){case s.FoldingRangeKind.Comment:return m.$1t.Comment;case s.FoldingRangeKind.Imports:return m.$1t.Imports;case s.FoldingRangeKind.Region:return m.$1t.Region}}Re.from=je;function Ee(ee){if(ee)switch(ee.value){case m.$1t.Comment.value:return s.FoldingRangeKind.Comment;case m.$1t.Imports.value:return s.FoldingRangeKind.Imports;case m.$1t.Region.value:return s.FoldingRangeKind.Region}}Re.to=Ee})(Ke||(e.FoldingRangeKind=Ke={}));var ne;(function(Re){function je(Ee){if(Ee)return{pinned:typeof Ee.preview=="boolean"?!Ee.preview:void 0,inactive:Ee.background,preserveFocus:Ee.preserveFocus,selection:typeof Ee.selection=="object"?d.from(Ee.selection):void 0,override:typeof Ee.override=="boolean"?n.$WE.id:void 0}}Re.from=je})(ne||(e.TextEditorOpenOptions=ne={}));var oe;(function(Re){function je(qe){return qe instanceof s.$9M?qe.toJSON():typeof qe=="string"?qe:Ee(qe)||ee(qe)?new s.$9M(qe.baseUri??qe.base,qe.pattern).toJSON():qe}Re.from=je;function Ee(qe){const _e=qe;return _e?y.URI.isUri(_e.baseUri)&&typeof _e.pattern=="string":!1}function ee(qe){const _e=qe;return _e?typeof _e.base=="string"&&typeof _e.pattern=="string":!1}function Me(qe){return typeof qe=="string"?qe:new s.$9M(y.URI.revive(qe.baseUri),qe.pattern)}Re.to=Me})(oe||(e.GlobPattern=oe={}));var Ce;(function(Re){function je(Ee){if(Ee){if(Array.isArray(Ee))return Ee.map(je);if(typeof Ee=="string")return Ee;{const ee=Ee;return{language:ee.language,scheme:ee.scheme,pattern:oe.from(ee.pattern),exclusive:ee.exclusive,notebookType:ee.notebookType}}}else return}Re.from=je})(Ce||(e.LanguageSelector=Ce={}));var Ge;(function(Re){function je(ee){return!!ee&&typeof ee=="object"&&"documents"in ee&&Array.isArray(ee.documents)&&ee.documents.every(Me=>Array.isArray(Me)&&Me.every(qe=>qe&&typeof qe=="object"&&"uri"in qe&&y.URI.isUri(qe.uri)&&"version"in qe&&typeof qe.version=="number"&&"ranges"in qe&&Array.isArray(qe.ranges)&&qe.ranges.every(_e=>_e instanceof s.$bM)))}Re.is=je;function Ee(ee){return{documents:ee.documents.map(Me=>Me.map(qe=>({uri:y.URI.from(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>d.from(_e))})))}}Re.from=Ee})(Ge||(e.MappedEditsContext=Ge={}));var xe;(function(Re){function je(ee){return{start:ee.start,end:ee.end}}Re.from=je;function Ee(ee){return new s.$zN(ee.start,ee.end)}Re.to=Ee})(xe||(e.NotebookRange=xe={}));var nt;(function(Re){function je(ee){return{timing:typeof ee.runStartTime=="number"&&typeof ee.runEndTime=="number"?{startTime:ee.runStartTime,endTime:ee.runEndTime}:void 0,executionOrder:ee.executionOrder,success:ee.lastRunSuccess}}Re.to=je;function Ee(ee){return{lastRunSuccess:ee.success,runStartTime:ee.timing?.startTime,runEndTime:ee.timing?.endTime,executionOrder:ee.executionOrder}}Re.from=Ee})(nt||(e.NotebookCellExecutionSummary=nt={}));var Fe;(function(Re){function je(Ee){if(Ee===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ee===r.NotebookCellExecutionState.Pending)return;if(Ee===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ee}`)}Re.to=je})(Fe||(e.NotebookCellExecutionState=Fe={}));var $t;(function(Re){function je(ee){switch(ee){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Re.from=je;function Ee(ee){switch(ee){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Re.to=Ee})($t||(e.NotebookCellKind=$t={}));var Dt;(function(Re){function je(ee){const Me={metadata:ee.metadata??Object.create(null),cells:[]};for(const qe of ee.cells)s.$AN.validate(qe),Me.cells.push(Pt.from(qe));return Me}Re.from=je;function Ee(ee){const Me=new s.$BN(ee.cells.map(Pt.to));return(0,S.$7f)(ee.metadata)||(Me.metadata=ee.metadata),Me}Re.to=Ee})(Dt||(e.NotebookData=Dt={}));var Pt;(function(Re){function je(ee){return{cellKind:$t.from(ee.kind),language:ee.languageId,mime:ee.mime,source:ee.value,metadata:ee.metadata,internalMetadata:nt.from(ee.executionSummary??{}),outputs:ee.outputs?ee.outputs.map(Zt.from):[]}}Re.from=je;function Ee(ee){return new s.$AN($t.to(ee.cellKind),ee.source,ee.language,ee.mime,ee.outputs?ee.outputs.map(Zt.to):void 0,ee.metadata,ee.internalMetadata?nt.to(ee.internalMetadata):void 0)}Re.to=Ee})(Pt||(e.NotebookCellData=Pt={}));var jt;(function(Re){function je(ee){return{mime:ee.mime,valueBytes:N.$te.wrap(ee.data)}}Re.from=je;function Ee(ee){return new s.$CN(ee.valueBytes.buffer,ee.mime)}Re.to=Ee})(jt||(e.NotebookCellOutputItem=jt={}));var Zt;(function(Re){function je(ee){return{outputId:ee.id,items:ee.items.map(jt.from),metadata:ee.metadata}}Re.from=je;function Ee(ee){const Me=ee.items.map(jt.to);return new s.$DN(Me,ee.outputId,ee.metadata)}Re.to=Ee})(Zt||(e.NotebookCellOutput=Zt={}));var Ct;(function(Re){function je(Me){return ee(Me)?{include:oe.from(Me.include)??void 0,exclude:oe.from(Me.exclude)??void 0}:oe.from(Me)??void 0}Re.from=je;function Ee(Me){return ee(Me)?{include:oe.to(Me.include),exclude:oe.to(Me.exclude)}:oe.to(Me)}Re.to=Ee;function ee(Me){const qe=Me;return qe?!(0,S.$3f)(qe.include)&&!(0,S.$3f)(qe.exclude):!1}})(Ct||(e.NotebookExclusiveDocumentPattern=Ct={}));var Jt;(function(Re){function je(Ee,ee,Me){const qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{alignment:Ee.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ee.toInternal(qe,Me),text:Ee.text,tooltip:Ee.tooltip,accessibilityInformation:Ee.accessibilityInformation,priority:Ee.priority}}Re.from=je})(Jt||(e.NotebookStatusBarItem=Jt={}));var Qt;(function(Re){function je(Ee,ee,Me){const qe=typeof Ee.command=="string"?{title:"",command:Ee.command}:Ee.command;return{command:ee.toInternal(qe,Me),label:Ee.label,description:Ee.description,detail:Ee.detail,documentation:Ee.documentation}}Re.from=je})(Qt||(e.NotebookKernelSourceAction=Qt={}));var _t;(function(Re){function je(Ee){return{transientOutputs:Ee?.transientOutputs??!1,transientCellMetadata:Ee?.transientCellMetadata??{},transientDocumentMetadata:Ee?.transientDocumentMetadata??{},cellContentMetadata:Ee?.cellContentMetadata??{}}}Re.from=je})(_t||(e.NotebookDocumentContentOptions=_t={}));var ni;(function(Re){function je(ee){return{uri:ee.uri,provides:ee.provides}}Re.from=je;function Ee(ee){return new s.$FN(y.URI.revive(ee.uri),ee.provides)}Re.to=Ee})(ni||(e.NotebookRendererScript=ni={}));var et;(function(Re){function je(ee){return{message:O.fromStrict(ee.message)||"",type:0,expected:ee.expectedOutput,actual:ee.actualOutput,contextValue:ee.contextValue,location:ee.location&&{range:d.from(ee.location.range),uri:ee.location.uri}}}Re.from=je;function Ee(ee){const Me=new s.$LN(typeof ee.message=="string"?ee.message:O.to(ee.message));return Me.actualOutput=ee.actual,Me.expectedOutput=ee.expected,Me.contextValue=ee.contextValue,Me.location=ee.location?ue.to(ee.location):void 0,Me}Re.to=Ee})(et||(e.TestMessage=et={}));var Bt;(function(Re){Re.namespace=t.$4K,Re.denamespace=t.$5K})(Bt||(e.TestTag=Bt={}));var ei;(function(Re){function je(ee){const Me=(0,i.$lO)(ee).controllerId;return{extId:c.$ZK.fromExtHostTestItem(ee,Me).toString(),label:ee.label,uri:y.URI.revive(ee.uri),busy:ee.busy,tags:ee.tags.map(qe=>Bt.namespace(Me,qe.id)),range:u.$0s.lift(d.from(ee.range)),description:ee.description||null,sortText:ee.sortText||null,error:ee.error&&O.fromStrict(ee.error)||null}}Re.from=je;function Ee(ee){return{parent:void 0,error:void 0,id:c.$ZK.fromString(ee.extId).localId,label:ee.label,uri:y.URI.revive(ee.uri),tags:(ee.tags||[]).map(Me=>{const{tagId:qe}=Bt.denamespace(Me);return new s.$MN(qe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:d.to(ee.range||void 0),canResolveChildren:!1,busy:ee.busy,description:ee.description||void 0,sortText:ee.sortText||void 0}}Re.toPlain=Ee})(ei||(e.TestItem=ei={})),function(Re){function je(ee){return{id:ee.id}}Re.from=je;function Ee(ee){return new s.$MN(ee.id)}Re.to=Ee}(Bt||(e.TestTag=Bt={}));var dt;(function(Re){const je=(ee,Me)=>{const qe=[];for(const[Je,ct]of Me)c.$ZK.compare(ct.item.extId,Je)===2&&(Me.delete(Je),qe.push(ct));const _e={...ei.toPlain(ee.item),parent:void 0,taskStates:ee.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ct=>ct.type===0).map(et.to)})),children:qe.map(Je=>je(Je,Me))};for(const Je of _e.children)Je.parent=_e;return _e};function Ee(ee){const Me=[],qe=new Map;for(const _e of ee.items){qe.set(_e.item.extId,_e);const Je=c.$ZK.root(_e.item.extId);ee.request.targets.some(ct=>ct.controllerId===Je&&ct.testIds.includes(_e.item.extId))&&Me.push(_e)}return{completedAt:ee.completedAt,results:Me.map(_e=>je(_e,qe))}}Re.to=Ee})(dt||(e.TestResults=dt={}));var pt;(function(Re){function je(qe){return{covered:qe.covered,total:qe.total}}function Ee(qe){return"line"in qe?b.from(qe):d.from(qe)}function ee(qe){return"branches"in qe?{count:qe.executed,location:Ee(qe.location),type:1,branches:qe.branches.length?qe.branches.map(_e=>({count:_e.executed,location:_e.location&&Ee(_e.location),label:_e.label})):void 0}:{type:0,name:qe.name,count:qe.executed,location:Ee(qe.location)}}Re.fromDetailed=ee;function Me(qe){return{uri:qe.uri,statement:je(qe.statementCoverage),branch:qe.branchCoverage&&je(qe.branchCoverage),declaration:qe.declarationCoverage&&je(qe.declarationCoverage),details:qe.detailedCoverage?.map(ee)}}Re.fromFile=Me})(pt||(e.TestCoverage=pt={}));var ti;(function(Re){function je(Ee){switch(Ee){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Re.to=je})(ti||(e.CodeActionTriggerKind=ti={}));var Ht;(function(Re){function je(ee){const Me=new s.$SN(ge.to(ee.kind),ee.name,ee.detail||"",y.URI.revive(ee.uri),d.to(ee.range),d.to(ee.selectionRange));return Me._sessionId=ee._sessionId,Me._itemId=ee._itemId,Me}Re.to=je;function Ee(ee,Me,qe){if(Me=Me??ee._sessionId,qe=qe??ee._itemId,Me===void 0||qe===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:qe,kind:ge.from(ee.kind),name:ee.name,detail:ee.detail??"",uri:ee.uri,range:d.from(ee.range),selectionRange:d.from(ee.selectionRange),tags:ee.tags?.map(se.from)}}Re.from=Ee})(Ht||(e.TypeHierarchyItem=Ht={}));var Ut;(function(Re){function je(Ee){if(Ee)return{value:Ee.value,tooltip:Ee.tooltip}}Re.from=je})(Ut||(e.ViewBadge=Ut={}));var ft;(function(Re){function je(qe,_e,Je){const ct=_e.fileData;return ct?new s.$2M(new s.$3M(ct.name,y.URI.revive(ct.uri),ct.id,(0,A.$db)(()=>Je(ct.id)))):qe===M.$us.uriList&&_e.uriListData?new s.$1M(Me(_e.uriListData)):new s.$1M(_e.asString)}Re.to=je;async function Ee(qe,_e){const Je=await _e.asString();if(qe===M.$us.uriList)return{asString:Je,fileData:void 0,uriListData:ee(Je)};const ct=_e.asFile();return{asString:Je,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Re.from=Ee;function ee(qe){return L.$Gt.split(qe).map(_e=>{if(_e.startsWith("#"))return _e;try{return y.URI.parse(_e)}catch{}return _e})}function Me(qe){return L.$Gt.create(qe.map(_e=>typeof _e=="string"?_e:y.URI.revive(_e)))}})(ft||(e.DataTransferItem=ft={}));var Rt;(function(Re){function je(ee,Me){const qe=ee.items.map(([_e,Je])=>[_e,ft.to(_e,Je,Me)]);return new s.$4M(qe)}Re.toDataTransfer=je;async function Ee(ee){const Me={items:[]},qe=[];for(const[_e,Je]of ee)qe.push((async()=>{Me.items.push([_e,await ft.from(_e,Je)])})());return await Promise.all(qe),Me}Re.from=Ee})(Rt||(e.DataTransfer=Rt={}));var ii;(function(Re){function je(ee,Me){return{kind:"reply",agentId:ee.participant??Me?.agentId??"",subCommand:ee.command??Me?.command,message:ee.prompt,title:ee.label}}Re.from=je;function Ee(ee){return{prompt:ee.message,label:ee.title,participant:ee.agentId,command:ee.subCommand}}Re.to=Ee})(ii||(e.ChatFollowup=ii={}));var Yt;(function(Re){function je(Ee){return"commandId"in Ee?{kind:"command",title:Ee.title??"",commandId:Ee.commandId??"",when:Ee.when??"",args:Ee.args}:{kind:"reply",message:Ee.message,title:Ee.title,tooltip:Ee.tooltip}}Re.from=je})(Yt||(e.ChatInlineFollowup=Yt={}));var Ze;(function(Re){function je(ee){switch(ee.role){case 0:return new s.$aO(ee.content);case 1:return new s.$bO(ee.content);case 2:return new s.$cO(ee.content)}}Re.to=je;function Ee(ee){if(ee instanceof s.$aO)return{role:0,content:ee.content};if(ee instanceof s.$bO)return{role:1,content:ee.content};if(ee instanceof s.$cO)return{role:2,content:ee.content};throw new Error("Invalid LanguageModelMessage")}Re.from=Ee})(Ze||(e.LanguageModelMessage=Ze={}));var Lt;(function(Re){function je(Me){const qe={};for(const _e of Object.keys(Me))qe[_e]=Me[_e].map(Re.to);return qe}Re.objectTo=je;function Ee(Me){return{level:Wt.to(Me.level),kind:Me.kind,value:(0,y.$vc)(Me.value)?y.URI.revive(Me.value):Me.value,description:Me.description}}Re.to=Ee;function ee(Me){return{level:Wt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}Re.from=ee})(Lt||(e.ChatVariable=Lt={}));var Wt;(function(Re){function je(ee){switch(ee){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Re.to=je;function Ee(ee){switch(ee){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Re.from=Ee})(Wt||(e.ChatVariableLevel=Wt={}));var ri;(function(Re){function je(Ee){switch(Ee){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Re.to=je})(ri||(e.InteractiveEditorResponseFeedbackKind=ri={}));var gt;(function(Re){function je(ee){return{kind:"markdownContent",content:O.from(ee.value)}}Re.to=je;function Ee(ee){return new s.$5N(O.to(ee.content))}Re.from=Ee})(gt||(e.ChatResponseMarkdownPart=gt={}));var Ot;(function(Re){function je(ee){const{value:Me,baseUri:qe}=ee;function _e(Je,ct){return Je.map(vt=>{const Ft=y.URI.joinPath(ct,vt.name);return{label:vt.name,uri:Ft,children:vt.children&&_e(vt.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,v.$Qg)(qe),uri:qe,children:_e(Me,qe)}}}Re.to=je;function Ee(ee){const Me=(0,E.$Ph)(ee.treeData);function qe(ct){return ct.map(vt=>({name:vt.label,children:vt.children&&qe(vt.children)}))}const _e=Me.uri,Je=Me.children?qe(Me.children):[];return new s.$6N(Je,_e)}Re.from=Ee})(Ot||(e.ChatResponseFilesPart=Ot={}));var At;(function(Re){function je(ee){return{kind:"inlineReference",name:ee.title,inlineReference:y.URI.isUri(ee.value)?ee.value:$.from(ee.value)}}Re.to=je;function Ee(ee){const Me=(0,E.$Ph)(ee);return new s.$7N(y.URI.isUri(Me.inlineReference)?Me.inlineReference:$.to(Me.inlineReference),ee.name)}Re.from=Ee})(At||(e.ChatResponseAnchorPart=At={}));var qt;(function(Re){function je(ee){return{kind:"progressMessage",content:O.from(ee.value)}}Re.to=je;function Ee(ee){return new s.$8N(ee.content.value)}Re.from=Ee})(qt||(e.ChatResponseProgressPart=qt={}));var si;(function(Re){function je(ee,Me,qe){return{kind:"command",command:Me.toInternal(ee.value,qe)??{command:ee.value.command,title:ee.value.title}}}Re.to=je;function Ee(ee,Me){return new s.$9N(Me.fromInternal(ee.command)??{command:ee.command.id,title:ee.command.title})}Re.from=Ee})(si||(e.ChatResponseCommandButtonPart=si={}));var zt;(function(Re){function je(ee){return{kind:"reference",reference:y.URI.isUri(ee.value)?ee.value:$.from(ee.value)}}Re.to=je;function Ee(ee){const Me=(0,E.$Ph)(ee);return new s.$0N(y.URI.isUri(Me.reference)?Me.reference:$.to(Me.reference))}Re.from=Ee})(zt||(e.ChatResponseReferencePart=zt={}));var Kt;(function(Re){function je(Me){return Me instanceof s.$5N?gt.to(Me):Me instanceof s.$7N?At.to(Me):Me instanceof s.$0N?zt.to(Me):Me instanceof s.$8N?qt.to(Me):Me instanceof s.$6N?Ot.to(Me):{kind:"content",content:""}}Re.to=je;function Ee(Me,qe){switch(Me.kind){case"reference":return zt.from(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return ee(Me,qe)}}Re.from=Ee;function ee(Me,qe){switch(Me.kind){case"markdownContent":return gt.from(Me);case"inlineReference":return At.from(Me);case"progressMessage":return;case"treeData":return Ot.from(Me);case"command":return si.from(Me,qe)}}Re.fromContent=ee})(Kt||(e.ChatResponsePart=Kt={}));var yt;(function(Re){function je(Me,qe){return"markdownContent"in qe?((0,h.$1F)(Me,"chatParticipantAdditions"),{content:O.from(qe.markdownContent),kind:"markdownContent"}):"content"in qe?"vulnerabilities"in qe&&qe.vulnerabilities?((0,h.$1F)(Me,"chatParticipantAdditions"),{content:qe.content,vulnerabilities:qe.vulnerabilities,kind:"vulnerability"}):typeof qe.content=="string"?{content:qe.content,kind:"content"}:((0,h.$1F)(Me,"chatParticipantAdditions"),{content:O.from(qe.content),kind:"markdownContent"}):"documents"in qe?{documents:qe.documents.map(_e=>({uri:_e.uri,version:_e.version,ranges:_e.ranges.map(Je=>d.from(Je))})),kind:"usedContext"}:"reference"in qe?{reference:"uri"in qe.reference?{uri:qe.reference.uri,range:d.from(qe.reference.range)}:qe.reference,kind:"reference"}:"inlineReference"in qe?{inlineReference:"uri"in qe.inlineReference?{uri:qe.inlineReference.uri,range:d.from(qe.inlineReference.range)}:qe.inlineReference,name:qe.title,kind:"inlineReference"}:"participant"in qe?((0,h.$1F)(Me,"chatParticipantAdditions"),{agentName:qe.participant,command:qe.command,kind:"agentDetection"}):"message"in qe?{content:O.from(qe.message),kind:"progressMessage"}:void 0}Re.from=je;function Ee(Me){switch(Me.kind){case"markdownContent":case"inlineReference":case"treeData":return Re.to(Me);case"content":return{content:Me.content};case"usedContext":return{documents:Me.documents.map(qe=>({uri:y.URI.revive(qe.uri),version:qe.version,ranges:qe.ranges.map(_e=>d.to(_e))}))};case"reference":return{reference:(0,y.$vc)(Me.reference)?y.URI.revive(Me.reference):$.to(Me.reference)};case"agentDetection":return;case"progressMessage":return{message:Me.content.value};case"vulnerability":return{content:Me.content,vulnerabilities:Me.vulnerabilities};default:return}}Re.to=Ee;function ee(Me,qe){switch(Me.kind){case"markdownContent":return{content:Me.content.value};case"inlineReference":return{inlineReference:(0,y.$vc)(Me.inlineReference)?y.URI.revive(Me.inlineReference):$.to(Me.inlineReference),title:Me.name};case"command":return{command:qe.fromInternal(Me.command)??{command:Me.command.id,title:Me.command.title}};default:return}}Re.toProgressContent=ee})(yt||(e.ChatResponseProgress=yt={}));var Nt;(function(Re){function je(Ee){return{prompt:Ee.message,command:Ee.command,variables:Ee.variables.variables.map(Xt.to)}}Re.to=je})(Nt||(e.ChatAgentRequest=Nt={}));var Xt;(function(Re){function je(Ee){return{name:Ee.name,range:[Ee.range.start,Ee.range.endExclusive],values:Ee.values.map(Lt.to)}}Re.to=je})(Xt||(e.ChatAgentResolvedVariable=Xt={}));var Vt;(function(Re){function je(Ee){return{label:Ee.label,values:Ee.values.map(Lt.from),insertText:Ee.insertText,detail:Ee.detail,documentation:Ee.documentation}}Re.from=je})(Vt||(e.ChatAgentCompletionItem=Vt={}));var kt;(function(Re){function je(Ee){return{errorDetails:Ee.errorDetails,metadata:Ee.metadata}}Re.to=je})(kt||(e.ChatAgentResult=kt={}));var It;(function(Re){function je(Ee,ee,Me){if(ee.action.kind==="vote")return;const qe=kt.to(Ee);return ee.action.kind==="command"?{action:{kind:"command",commandButton:yt.toProgressContent(ee.action.commandButton,Me)},result:qe}:ee.action.kind==="followUp"?{action:{kind:"followUp",followup:ii.to(ee.action.followup)},result:qe}:{action:ee.action,result:qe}}Re.to=je})(It||(e.ChatAgentUserActionEvent=It={}));var Et;(function(Re){function je(Ee,ee,Me){return"terminalCommand"in Ee?{terminalCommand:Ee.terminalCommand,shouldExecute:Ee.shouldExecute}:"uri"in Ee?{uri:Ee.uri}:ee.toInternal(Ee,Me)}Re.from=je})(Et||(e.TerminalQuickFix=Et={}));var ci;(function(Re){function je(Ee,ee){return{id:ee,label:Ee.label,description:Ee.description,canEdit:Ee.canEdit,collapsibleState:Ee.collapsibleState||0,contextValue:Ee.contextValue}}Re.from=je})(ci||(e.DebugTreeItem=ci={}))}),define(Se[323],De([1,0,6,20,16]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;let A=class{constructor(w,p){this.a=w.getProxy(l.$0L.MainThreadBulkEdits),this.b={getTextDocumentVersion:E=>p.getDocument(E)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(w,p,E){const M=L.WorkspaceEdit.from(w,this.b);return this.a.$tryApplyWorkspaceEdit(M,void 0,E?.isRefactoring??!1)}};e.$cic=A,e.$cic=A=Qe([Ve(0,N.$pO)],A)}),define(Se[324],De([1,0,19,8,44,4,48,3,38,18,2,215,25,6,16,7,285,26]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class i{constructor(t,f,h,s,a,d){this.i=t,this.j=f,this.k=h,this.l=s,this.m=a,this.n=d,this.b=p.$2d.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let f=function(s){if(t.c){const a=new Error("Response stream has been closed");throw Error.captureStackTrace(a,s),a}};const t=this;this.b.reset();const h=s=>{typeof this.d>"u"&&"content"in s&&(this.d=this.b.elapsed()),this.k.$handleProgressChunk(this.j.requestId,s)};this.g={markdown(s){f(this.markdown);const a=new u.$5N(s),d=y.ChatResponseMarkdownPart.to(a);return h(d),this},filetree(s,a){f(this.filetree);const d=new u.$6N(s,a),$=y.ChatResponseFilesPart.to(d);return h($),this},anchor(s,a){f(this.anchor);const d=new u.$7N(s,a),$=y.ChatResponseAnchorPart.to(d);return h($),this},button(s){f(this.anchor);const a=new u.$9N(s),d=y.ChatResponseCommandButtonPart.to(a,t.m,t.n);return h(d),this},progress(s){f(this.progress);const a=new u.$8N(s),d=y.ChatResponseProgressPart.to(a);return h(d),this},reference(s){f(this.reference);const a=new u.$0N(s),d=y.ChatResponseReferencePart.to(a);return h(d),this},push(s){f(this.push);const a=y.ChatResponsePart.to(s);return h(a),this},report(s){if(f(this.report),"placeholder"in s&&"resolvedContent"in s)return;const a=y.ChatResponseProgress.from(t.i,s);if(!a){t.l.error("Unknown progress type: "+JSON.stringify(s));return}return h(a),this}}}return this.g}}class n{static{this.b=0}constructor(t,f,h){this.i=f,this.j=h,this.c=new Map,this.g=new w.$3c,this.d=t.getProxy(S.$0L.MainThreadChatAgents2)}createChatAgent(t,f,h){const s=n.b++,a=new r(t,f,this.d,s,h);return this.c.set(s,a),this.d.$registerAgent(s,t.identifier,f,{},(0,o.$ZF)(t,"chatParticipantAdditions")),a.apiAgent}async $invokeAgent(t,f,h,s){const a=this.c.get(t);if(!a)throw new Error(`[CHAT](${t}) CANNOT invoke agent because the agent is not registered`);let d=this.g.get(f.sessionId);d||(d=new w.$Sc,this.g.set(f.sessionId,d));const $=new i(a.extension,f,this.d,this.i,this.j.converter,d);try{const D=await this.k(f.agentId,h),b=a.invoke(y.ChatAgentRequest.to(f),{history:D},$.apiObject,s);return await(0,N.$7g)(Promise.resolve(b).then(g=>{if(g?.metadata)try{JSON.stringify(g.metadata)}catch(k){const P=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.i.error(`[${a.extension.identifier.value}] [@${a.id}] ${P}`,a.extension),{errorDetails:{message:P},timings:$.timings}}return{errorDetails:g?.errorDetails,timings:$.timings,metadata:g?.metadata}}),s)}catch(D){return this.i.error(D,a.extension),{errorDetails:{message:(0,C.localize)(0,null,(0,L.$4i)(D)),responseIsIncomplete:!0}}}finally{$.close()}}async k(t,f){const h=[];for(const s of f.history){const a=y.ChatAgentResult.to(s.result),d=t===s.request.agentId?a:{...a,metadata:void 0};h.push(new u.$$N(s.request.message,s.request.command,s.request.variables.variables.map(y.ChatAgentResolvedVariable.to),{extensionId:"",name:s.request.agentId}));const $=(0,l.$Hb)(s.response.map(D=>y.ChatResponsePart.fromContent(D,this.j.converter)));h.push(new u.$_N($,d,{extensionId:"",name:s.request.agentId},s.request.command))}return h}$releaseSession(t){this.g.deleteAndDispose(t)}async $provideFollowups(t,f,h,s){const a=this.c.get(f);if(!a)return Promise.resolve([]);const d=y.ChatAgentResult.to(h);return(await a.provideFollowups(d,s)).filter($=>{const D=!$.participant||R.Iterable.some(this.c.values(),b=>b.id===$.participant&&v.$Am.equals(b.extension.identifier,a.extension.identifier));return D||this.i.warn(`[@${a.id}] ChatFollowup refers to an unknown participant: ${$.participant}`),D}).map($=>y.ChatFollowup.from($,t))}$acceptFeedback(t,f,h,s){const a=this.c.get(t);if(!a)return;const d=y.ChatAgentResult.to(f);let $;switch(h){case m.InteractiveSessionVoteDirection.Down:$=u.ChatResultFeedbackKind.Unhelpful;break;case m.InteractiveSessionVoteDirection.Up:$=u.ChatResultFeedbackKind.Helpful;break}a.acceptFeedback(Object.freeze(s?{result:d,kind:$,reportIssue:s}:{result:d,kind:$}))}$acceptAction(t,f,h){const s=this.c.get(t);if(!s||h.action.kind==="vote")return;const a=y.ChatAgentUserActionEvent.to(f,h,this.j.converter);a&&s.acceptAction(Object.freeze(a))}async $invokeCompletionProvider(t,f,h){const s=this.c.get(t);return s?(await s.invokeCompletionProvider(f,h)).map(y.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(t,f){const h=this.c.get(t);if(h)return await h.provideWelcomeMessage(f)}async $provideSampleQuestions(t,f){const h=this.c.get(t);if(h)return(await h.provideSampleQuestions(f)).map(s=>y.ChatFollowup.from(s,void 0))}}e.$eic=n;class r{constructor(t,f,h,s,a){this.extension=t,this.id=f,this.w=h,this.x=s,this.y=a,this.o=new A.$6d,this.p=new A.$6d}acceptFeedback(t){this.o.fire(t)}acceptAction(t){this.p.fire(t)}async invokeCompletionProvider(t,f){return this.s?await this.s.provider.provideCompletionItems(t,f)??[]:[]}async provideFollowups(t,f){if(!this.b)return[];const h=await this.b.provideFollowups(t,f);return h?h.filter(s=>!(s&&"commandId"in s)).filter(s=>!(s&&"message"in s)):[]}async provideWelcomeMessage(t){if(!this.t)return[];const f=await this.t.provideWelcomeMessage(t);return f?f.map(h=>typeof h=="string"?h:y.MarkdownString.from(h)):[]}async provideSampleQuestions(t){if(!this.t||!this.t.provideSampleQuestions)return[];const f=await this.t.provideSampleQuestions(t);return f||[]}get apiAgent(){let t=!1,f=!1;const h=()=>{t||f||(f=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.c??"",fullName:this.d,icon:this.g?this.g instanceof M.URI?this.g:"light"in this.g?this.g.light:void 0:void 0,iconDark:this.g&&"dark"in this.g?this.g.dark:void 0,themeIcon:this.g instanceof u.$7M?this.g:void 0,hasFollowups:this.b!==void 0,isSecondary:this.n,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:y.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:y.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:y.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q,isSticky:this.u}),f=!1}))},s=this;return{get name(){return s.id},get description(){return s.c??""},set description(a){s.c=a,h()},get fullName(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.d??s.extension.displayName??s.extension.name},set fullName(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.d=a,h()},get iconPath(){return s.g},set iconPath(a){s.g=a,h()},get requestHandler(){return s.y},set requestHandler(a){(0,E.$4f)(typeof a=="function","Invalid request handler"),s.y=a},get followupProvider(){return s.b},set followupProvider(a){s.b=a,h()},get isDefault(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.i},set isDefault(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.i=a,h()},get helpTextPrefix(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.j},set helpTextPrefix(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.j=a,h()},get helpTextVariablesPrefix(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.k},set helpTextVariablesPrefix(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.k=a,h()},get helpTextPostfix(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.l},set helpTextPostfix(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.l=a,h()},get isSecondary(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.n},set isSecondary(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.n=a,h()},get sampleRequest(){return s.m},set sampleRequest(a){s.m=a,h()},get supportIssueReporting(){return(0,o.$1F)(s.extension,"chatParticipantAdditions"),s.q},set supportIssueReporting(a){(0,o.$1F)(s.extension,"chatParticipantAdditions"),s.q=a,h()},get onDidReceiveFeedback(){return s.o.event},set participantVariableProvider(a){if((0,o.$1F)(s.extension,"chatParticipantAdditions"),s.s=a,a){if(!a.triggerCharacters.length)throw new Error("triggerCharacters are required");s.w.$registerAgentCompletionsProvider(s.x,a.triggerCharacters)}else s.w.$unregisterAgentCompletionsProvider(s.x)},get participantVariableProvider(){return(0,o.$1F)(s.extension,"chatParticipantAdditions"),s.s},set welcomeMessageProvider(a){(0,o.$1F)(s.extension,"defaultChatParticipant"),s.t=a,h()},get welcomeMessageProvider(){return(0,o.$1F)(s.extension,"defaultChatParticipant"),s.t},onDidPerformAction:(0,o.$ZF)(this.extension,"chatParticipantAdditions")?this.p.event:void 0,get isSticky(){return s.u},set isSticky(a){s.u=a,h()},dispose(){t=!0,s.b=void 0,s.o.dispose(),s.w.$unregisterAgent(s.x)}}}invoke(t,f,h,s){return this.y(t,f,h,s)}}}),define(Se[325],De([1,0,13,3,6,16,7,26]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=void 0;class p{static{this.a=0}constructor(C){this.b=new Map,this.c=C.getProxy(L.$0L.MainThreadChatVariables)}async $resolveVariable(C,v,S,y){const u=this.b.get(C);if(u)try{if(u.resolver.resolve2){(0,w.$1F)(u.extension,"chatParticipantAdditions");const m=new E(v,this.c),o=await u.resolver.resolve2(u.data.name,{prompt:S},m.apiObject,y);if(o)return o.map(A.ChatVariable.from)}else{const m=await u.resolver.resolve(u.data.name,{prompt:S},y);if(m)return m.map(A.ChatVariable.from)}}catch(m){(0,l.$2)(m)}}registerVariableResolver(C,v,S,y){const u=p.a++;return this.b.set(u,{extension:C,data:{name:v,description:S},resolver:y}),this.c.$registerVariable(u,{name:v,description:S}),(0,N.$Rc)(()=>{this.b.delete(u),this.c.$unregisterVariable(u)})}}e.$hic=p;class E{constructor(C,v){this.c=C,this.d=v,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let v=function(y){if(C.a){const u=new Error("Response stream has been closed");throw Error.captureStackTrace(u,y),u}};const C=this,S=y=>{this.d.$handleProgressChunk(this.c,y)};this.b={progress(y){v(this.progress);const u=new R.$8N(y),m=A.ChatResponseProgressPart.to(u);return S(m),this},reference(y){v(this.reference);const u=new R.$0N(y),m=A.ChatResponseReferencePart.to(u);return S(m),this},push(y){v(this.push);const u=A.ChatResponsePart.to(y);return S(u),this}}}return this.b}}}),define(Se[326],De([1,0,8,53,4,3,2,82,25,16,7,6,26]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;function S(y,u,m){const o=y.getProxy(C.$0L.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new p.$Cm,u.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===6){const $=this.b.get(d.handle);return $?$.value:d}else if(d&&d.$mid===7){const $=this.b.get(d.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.commentThreadHandle);return D?D.value:d}else if(d&&(d.$mid===9||d.$mid===8)){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);return D?d.$mid===8?D.value:{thread:D.value,text:d.text}:d}else if(d&&d.$mid===10){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const b=d.commentUniqueId,g=D.getCommentByUniqueId(b);return g||d}else if(d&&d.$mid===11){const $=this.b.get(d.thread.commentControlHandle);if(!$)return d;const D=$.getCommentThread(d.thread.commentThreadHandle);if(!D)return d;const b=d.text,g=d.commentUniqueId,k=D.getCommentByUniqueId(g);return k?(typeof k.body=="string"?k.body=b:k.body=new M.$AM(b),k):d}return d}})}createCommentController(d,$,D){const b=i.a++,g=new r(d,b,$,D);this.b.set(g.handle,g);const k=this.c.get(d.identifier)||[];return k.push(g),this.c.set(d.identifier,k),g.value}async $createCommentThreadTemplate(d,$,D){const b=this.b.get(d);b&&b.$createCommentThreadTemplate($,D)}async $setActiveComment(d,$){const D=this.b.get(d);D&&D.$setActiveComment($??void 0)}async $updateCommentThreadTemplate(d,$,D){const b=this.b.get(d);b&&b.$updateCommentThreadTemplate($,D)}$deleteCommentThread(d,$){this.b.get(d)?.$deleteCommentThread($)}async $provideCommentingRanges(d,$,D){const b=this.b.get(d);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const g=await m.ensureDocumentData(R.URI.revive($));return(0,l.$$g)(async()=>{const k=await b.commentingRangeProvider.provideCommentingRanges(g.document,D);let P;return Array.isArray(k)?P={ranges:k,fileComments:!1}:k?P={ranges:k.ranges||[],fileComments:k.fileComments||!1}:P=k??void 0,P}).then(k=>{let P;return k&&(P={ranges:k.ranges.map(F=>E.Range.from(F)),fileComments:k.fileComments}),P})}$toggleReaction(d,$,D,b,g){const k=this.b.get(d);return!k||!k.reactionHandler?Promise.resolve(void 0):(0,l.$$g)(()=>{const P=k.getCommentThread($);if(P){const F=P.getCommentByUniqueId(b.uniqueIdInThread);if(k!==void 0&&F&&k.reactionHandler)return k.reactionHandler(F,f(g))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(d){this.n=d}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(d){(d===void 0!=(this.p===void 0)||!d||!this.p||!d.isEqual(this.p))&&(this.p=d,this.b.range=d,this.c.fire())}get range(){return this.p}set canReply(d){this.d!==d&&(this.d=d,this.b.canReply=d,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(d){this.e=d,this.b.label=d,this.c.fire()}get contextValue(){return this.f}set contextValue(d){this.f=d,this.b.contextValue=d,this.c.fire()}get comments(){return this.q}set comments(d){this.q=d,this.b.comments=d,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(d){this.g=d,this.b.collapsibleState=d,this.c.fire()}get state(){return this.h}set state(d){this.h=d,this.b.state=d,this.c.fire()}get isDisposed(){return this.j}constructor(d,$,D,b,g,k,P,F){this.m=$,this.n=D,this.o=b,this.p=g,this.q=k,this.extensionDescription=P,this.r=F,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new L.$6d,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new A.$Uc,this.l.value=new A.$Sc,this.n===void 0&&(this.n=`${d}.${this.handle}`),o.$createCommentThread($,this.handle,this.n,this.o,E.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=k,this.i.push({dispose:()=>{o.$deleteCommentThread($,this.handle)}});const U=this;this.value={get uri(){return U.uri},get range(){return U.range},set range(z){U.range=z},get comments(){return U.comments},set comments(z){U.comments=z},get collapsibleState(){return U.collapsibleState},set collapsibleState(z){U.collapsibleState=z},get canReply(){return U.canReply},set canReply(z){U.canReply=z},get contextValue(){return U.contextValue},set contextValue(z){U.contextValue=z},get label(){return U.label},set label(z){U.label=z},get state(){return U.state},set state(z){U.state=z},dispose:()=>{U.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new A.$Sc);const d=D=>Object.prototype.hasOwnProperty.call(this.b,D),$={};d("range")&&($.range=E.Range.from(this.p)),d("label")&&($.label=this.label),d("contextValue")&&($.contextValue=this.contextValue??null),d("comments")&&($.comments=this.q.map(D=>c(this,D,this.k,this.extensionDescription))),d("collapsibleState")&&($.collapseState=h(this.g)),d("canReply")&&($.canReply=this.canReply),d("state")&&($.state=s(this.h)),d("isTemplate")&&($.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,$)}getCommentByUniqueId(d){for(const $ of this.k){const D=$[0],b=$[1];if(d===b)return D}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(d=>d.dispose())}}Qe([(0,N.$Lh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class r{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(d){this.b=d,d?.resourceHints&&(0,v.$1F)(this.h,"commentingRangeHint"),o.$updateCommentingRanges(this.handle,d?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(d){this.c=d,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this.d}set options(d){this.d=d,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,v.$1F)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,v.$1F)(this.h,"activeComment"),this.f}constructor(d,$,D,b){this.h=d,this.i=$,this.j=D,this.k=b,this.a=new Map,o.$registerCommentController(this.handle,D,b,this.h.identifier.value);const g=this;this.value=Object.freeze({id:g.id,label:g.label,get options(){return g.options},set options(k){g.options=k},get commentingRangeProvider(){return g.commentingRangeProvider},set commentingRangeProvider(k){g.commentingRangeProvider=k},get reactionHandler(){return g.reactionHandler},set reactionHandler(k){g.reactionHandler=k},get activeCommentThread(){return g.activeCommentThread},createCommentThread(k,P,F){return g.createCommentThread(k,P,F).value},dispose:()=>{g.dispose()}}),this.g=[],this.g.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(d,$,D){$===void 0&&(0,v.$1F)(this.h,"fileComments");const b=new n(this.id,this.handle,void 0,d,$,D,this.h,!1);return this.a.set(b.handle,b),b}$setActiveComment(d){if(!d){this.e=void 0,this.f=void 0;return}const $=this.a.get(d.commentThreadHandle);$&&(this.e=d.uniqueIdInThread?$.getCommentByUniqueId(d.uniqueIdInThread):void 0,this.f=$)}$createCommentThreadTemplate(d,$){const D=new n(this.id,this.handle,void 0,R.URI.revive(d),E.Range.to($),[],this.h,!0);return D.collapsibleState=w.CommentThreadCollapsibleState.Expanded,this.a.set(D.handle,D),D}$updateCommentThreadTemplate(d,$){const D=this.a.get(d);D&&(D.range=E.Range.to($))}$deleteCommentThread(d){this.a.get(d)?.dispose(),this.a.delete(d)}getCommentThread(d){return this.a.get(d)}dispose(){this.a.forEach(d=>{d.dispose()}),this.g.forEach(d=>d.dispose())}}function c(a,d,$,D){let b=$.get(d);return b||(b=++a.commentHandle,$.set(d,b)),d.state!==void 0&&(0,v.$1F)(D,"commentsDraftState"),d.reactions?.some(g=>g.reactors!==void 0)&&(0,v.$1F)(D,"commentReactor"),{mode:d.mode,contextValue:d.contextValue,uniqueIdInThread:b,body:typeof d.body=="string"?d.body:E.MarkdownString.from(d.body),userName:d.author.name,userIconPath:d.author.iconPath,label:d.label,commentReactions:d.reactions?d.reactions.map(g=>t(g)):void 0,state:d.state,timestamp:d.timestamp?.toJSON()}}function t(a){return{label:a.label,iconPath:a.iconPath?E.$oO(a.iconPath):void 0,count:a.count,hasReacted:a.authorHasReacted,reactors:a.reactors&&a.reactors.length>0&&typeof a.reactors[0]!="string"?a.reactors.map(d=>d.name):a.reactors}}function f(a){return{label:a.label||"",count:a.count||0,iconPath:a.iconPath?R.URI.revive(a.iconPath):"",authorHasReacted:a.hasReacted||!1,reactors:a.reactors?.map(d=>({name:d}))}}function h(a){if(a!==void 0)switch(a){case M.CommentThreadCollapsibleState.Expanded:return w.CommentThreadCollapsibleState.Expanded;case M.CommentThreadCollapsibleState.Collapsed:return w.CommentThreadCollapsibleState.Collapsed}return w.CommentThreadCollapsibleState.Collapsed}function s(a){if(a!==void 0)switch(a){case M.CommentThreadState.Unresolved:return w.CommentThreadState.Unresolved;case M.CommentThreadState.Resolved:return w.CommentThreadState.Resolved}return w.CommentThreadState.Unresolved}return new i}e.$lic=S}),define(Se[327],De([1,0,22,54,3,15,23,2,16,92,111,6,7]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;class S{constructor(f,h){this.document=f,this.b=h,this.a=1,this.c=new M.$1hc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,h){await this.f(f).undo(),h||this.disposeBackup()}async redo(f,h){await this.f(f).redo(),h||this.disposeBackup()}disposeEdits(f){for(const h of f)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=c(this.document.uri)+this.a++;return(0,R.$Tg)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const h=this.c.get(f,0);if(!h)throw new Error("No edit found");return h}}class y{constructor(){this.a=new Map}get(f,h){return this.a.get(this.b(f,h))}add(f,h,s){const a=this.b(f,h.uri);if(this.a.has(a))throw new Error(`Document already exists for viewType:${f} resource:${h.uri}`);const d=new S(h,s);return this.a.set(a,d),d}delete(f,h){const s=this.b(f,h.uri);this.a.delete(s)}b(f,h){return`${f}@@@${h}`}}var u;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(u||(u={}));class m{constructor(){this.a=new Map}addTextProvider(f,h,s){return this.b(0,f,h,s)}addCustomProvider(f,h,s){return this.b(1,f,h,s)}get(f){return this.a.get(f)}b(f,h,s,a){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:f,extension:s,provider:a}),new v.$_L(()=>this.a.delete(h))}}class o{constructor(f,h,s,a,d){this.d=h,this.f=s,this.g=a,this.h=d,this.b=new m,this.c=new y,this.a=f.getProxy(C.$0L.MainThreadCustomEditors)}registerCustomEditorProvider(f,h,s,a){const d=new L.$Sc;return n(s)?(d.add(this.b.addTextProvider(h,f,s)),this.a.$registerTextEditorProvider((0,E.$Aic)(f),h,a.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,E.$yic)(f))):(d.add(this.b.addCustomProvider(h,f,s)),i(s)&&d.add(s.onDidChangeCustomDocument($=>{const D=this.i(h,$.document.uri);if(r($)){const b=D.addEdit($);this.a.$onDidEdit($.document.uri,h,b,$.label)}else this.a.$onContentChange($.document.uri,h)})),this.a.$registerCustomEditorProvider((0,E.$Aic)(f),h,a.webviewOptions||{},!!a.supportsMultipleEditorsPerDocument,(0,E.$yic)(f))),v.$_L.from(d,new v.$_L(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(f,h,s,a,d){const $=this.b.get(h);if(!$)throw new Error(`No provider found for '${h}'`);if($.type!==1)throw new Error(`Invalid provide type for '${h}'`);const D=w.URI.revive(f),b=await $.provider.openCustomDocument(D,{backupId:s,untitledDocumentData:a?.buffer},d);let g;return i($.provider)&&this.f&&(g=this.f.workspaceValue($.extension)??this.f.globalValue($.extension)),this.c.add(h,b,g),{editable:i($.provider)}}async $disposeCustomDocument(f,h){const s=this.b.get(h);if(!s)throw new Error(`No provider found for '${h}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${h}'`);const a=w.URI.revive(f),{document:d}=this.i(h,a);this.c.delete(h,d),d.dispose()}async $resolveCustomEditor(f,h,s,a,d,$){const D=this.b.get(s);if(!D)throw new Error(`No provider found for '${s}'`);const b=p.ViewColumn.to(d),g=this.g.createNewWebview(h,a.contentOptions,D.extension),k=this.h.createNewWebviewPanel(h,s,a.title,b,a.options,g,a.active),P=w.URI.revive(f);switch(D.type){case 1:{const{document:F}=this.i(s,P);return D.provider.resolveCustomEditor(F,k,$)}case 0:{const F=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(F,k,$)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,h,s){this.i(h,f).disposeEdits(s)}async $onMoveCustomEditor(f,h,s){const a=this.b.get(s);if(!a)throw new Error(`No provider found for '${s}'`);if(!a.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const d=this.h.getWebviewPanel(f);if(!d)throw new Error("No webview found");const $=w.URI.revive(h),D=this.d.getDocument($);await a.provider.moveCustomTextEditor(D,d,l.CancellationToken.None)}async $undo(f,h,s,a){return this.i(h,f).undo(s,a)}async $redo(f,h,s,a){return this.i(h,f).redo(s,a)}async $revert(f,h,s){const a=this.i(h,f);await this.j(h).revertCustomDocument(a.document,s),a.disposeBackup()}async $onSave(f,h,s){const a=this.i(h,f);await this.j(h).saveCustomDocument(a.document,s),a.disposeBackup()}async $onSaveAs(f,h,s,a){const d=this.i(h,f);return this.j(h).saveCustomDocumentAs(d.document,w.URI.revive(s),a)}async $backup(f,h,s){const a=this.i(h,f),$=await this.j(h).backupCustomDocument(a.document,{destination:a.getNewBackupUri()},s);return a.updateBackup($),$.id}i(f,h){const s=this.c.get(f,w.URI.revive(h));if(!s)throw new Error("No custom document found");return s}j(f){const s=this.b.get(f)?.provider;if(!s||!i(s))throw new Error("Custom document is not editable");return s}}e.$Dic=o;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function r(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function c(t){const f=t.scheme===A.Schemas.file||t.scheme===A.Schemas.untitled?t.fsPath:t.toString();return(0,N.$7i)(f)+""}}),define(Se[328],De([1,0,216,138,2,6,7,16,4,12,28,59]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=void 0;class S{#e;#t;#i;constructor(m,o,i,n,r,c,t,f){this.d=m,this.e=o,this.f=i,this.g=n,this.h=r,this.c=!1,this.f=Math.max(n,i),this.#i=new M.$Ac(h=>c.getComparisonKey(h)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(m,o){if(!m){this.clear();return}this.j();let i=[];if(L.URI.isUri(m)){if(!o){this.delete(m);return}this.#i.set(m,o.slice()),i=[m]}else if(Array.isArray(m)){i=[];let c;m=[...m].sort(S.k);for(const t of m){const[f,h]=t;if((!c||f.toString()!==c.toString())&&(c&&this.#i.get(c).length===0&&this.#i.delete(c),c=f,i.push(f),this.#i.set(f,[])),h)this.#i.get(f)?.push(...h);else{const s=this.#i.get(f);s&&(s.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let r=0;for(const c of i){let t=[];const f=this.#i.get(c);if(f)if(f.length>this.g){t=[];const h=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let s=0;s<4;s++)for(const a of f)if(a.severity===h[s]&&t.push({...w.Diagnostic.from(a),modelVersionId:this.h(c)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,l.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(h=>({...w.Diagnostic.from(h),modelVersionId:this.h(c)}));if(n.push([c,t]),r+=t.length,r>this.f)break}this.#e.$changeMany(this.e,n)}delete(m){this.j(),this.#t.fire([m]),this.#i.delete(m),this.#e?.$changeMany(this.e,[[m,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(m,o){this.j();for(const[i,n]of this)m.call(o,i,n,this)}*[Symbol.iterator](){this.j();for(const m of this.#i.keys())yield[m,this.get(m)]}get(m){this.j();const o=this.#i.get(m);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(m){return this.j(),Array.isArray(this.#i.get(m))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(m,o){return m[0].toString()<o[0].toString()?-1:m[0].toString()>o[0].toString()?1:0}}e.$8hc=S;let y=class{static{v=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*v.d}static _mapper(m){const o=new M.$Ac;for(const i of m)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(m,o,i,n){this.j=o,this.k=i,this.l=n,this.g=new Map,this.h=new p.$0d({merge:r=>r.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,v._mapper),this.f=m.getProxy(A.$0L.MainThreadDiagnostics)}createDiagnosticCollection(m,o){const{g:i,f:n,h:r,j:c,k:t,l:f}=this,h=new class{$changeMany(d,$){n.$changeMany(d,$),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",m.value,d,$.length===0?"CLEARING":$)}$clear(d){n.$clear(d),c.trace("[DiagnosticCollection] remove all (extension, owner)",m.value,d)}dispose(){n.dispose()}};let s;if(!o)o="_generated_diagnostic_collection_name_#"+v.c++,s=o;else if(!i.has(o))s=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do s=o+v.c++;while(i.has(s))}return new class extends S{constructor(){super(o,s,v.e,v.d,d=>f.getDocument(d)?.version,t.extUri,h,r),i.set(s,this)}dispose(){super.dispose(),i.delete(s)}}}getDiagnostics(m){if(m)return this.m(m);{const o=new Map,i=[];for(const n of this.g.values())n.forEach((r,c)=>{let t=o.get(r.toString());typeof t>"u"&&(t=i.length,o.set(r.toString(),t),i.push([r,[]])),i[t][1]=i[t][1].concat(...c)});return i}}m(m){let o=[];for(const i of this.g.values())i.has(m)&&(o=o.concat(i.get(m)));return o}$acceptMarkersChange(m){if(!this.n){const o="_generated_mirror",i=new S(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of m)this.n.set(L.URI.revive(o),i.map(w.Diagnostic.to))}};e.$9hc=y,e.$9hc=y=v=Qe([Ve(1,E.$Aj),Ve(2,C.$7hc)],y)}),define(Se[329],De([1,0,2,13,7,16,74]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class w{constructor(E,M,C,v={timeout:1500,errors:3}){this.c=E,this.d=M,this.f=C,this.g=v,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(E){return(M,C,v)=>{const y={dispose:this.a.push([M,C,E])};return Array.isArray(v)&&v.push(y),y}}async $participateInSave(E,M){const C=l.URI.revive(E);let v=!1;const S=setTimeout(()=>v=!0,this.g.timeout),y=[];try{for(const u of[...this.a]){if(v)break;const m=this.d.getDocument(C),o=await this.h(u,{document:m,reason:A.TextDocumentSaveReason.to(M)});y.push(o)}}finally{clearTimeout(S)}return y}h([E,M,C],v){const S=this.b.get(E);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(C,E,M,v).then(()=>!0,y=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(y),!(y instanceof Error)||y.message!=="concurrent_edits"){const u=this.b.get(E);this.b.set(E,u?u+1:1),typeof u=="number"&&u>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(E,M,C,v){const S=[],y=Date.now(),{document:u,reason:m}=v,{version:o}=u,i=Object.freeze({document:u,reason:m,waitUntil(n){if(Object.isFrozen(S))throw(0,N.$8)("waitUntil can not be called async");S.push(Promise.resolve(n))}});try{M.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(S),new Promise((n,r)=>{const c=setTimeout(()=>r(new Error("timeout")),this.g.timeout);return Promise.all(S).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' finished after ${Date.now()-y}ms`),clearTimeout(c),n(t)}).catch(t=>{clearTimeout(c),r(t)})}).then(n=>{const r={edits:[]};for(const c of n)if(Array.isArray(c)&&c.every(t=>t instanceof L.$gM))for(const{newText:t,newEol:f,range:h}of c)r.edits.push({resource:u.uri,versionId:void 0,textEdit:{range:h&&A.Range.from(h),text:t,eol:f&&A.EndOfLine.from(f)}});if(r.edits.length!==0)return o===u.version?this.f.$tryApplyWorkspaceEdit(r):Promise.reject(new Error("concurrent_edits"))})}}e.$fjc=w}),define(Se[330],De([1,0,4,3,2,6,152,16,18,24,7]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class C{constructor(S,y){this.a=new l.$6d,this.b=new l.$6d,this.c=new l.$6d,this.d=new l.$6d,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Sc,this.h=new Map,this.f=S.getProxy(A.$0L.MainThreadDocuments),this.g=y,this.g.onDidRemoveDocuments(u=>{for(const m of u)this.b.fire(m.document)},void 0,this.e),this.g.onDidAddDocuments(u=>{for(const m of u)this.a.fire(m.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const y=this.g.getDocument(S);if(y)return y}getDocument(S){const y=this.getDocumentData(S);if(!y?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return y.document}ensureDocumentData(S){const y=this.g.getDocument(S);if(y)return Promise.resolve(y);let u=this.h.get(S.toString());return u||(u=this.f.$tryOpenDocument(S).then(m=>{this.h.delete(S.toString());const o=L.URI.revive(m);return(0,p.$5f)(this.g.getDocument(o))},m=>(this.h.delete(S.toString()),Promise.reject(m))),this.h.set(S.toString(),u)),u}createDocumentData(S){return this.f.$tryCreateDocument(S).then(y=>L.URI.revive(y))}$acceptModelLanguageChanged(S,y){const u=L.URI.revive(S),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");this.b.fire(m.document),m._acceptLanguageId(y),this.a.fire(m.document)}$acceptModelSaved(S){const y=L.URI.revive(S),u=this.g.getDocument(y);if(!u)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(u.document)}$acceptDirtyStateChanged(S,y){const u=L.URI.revive(S),m=this.g.getDocument(u);if(!m)throw new Error("unknown document");m._acceptIsDirty(y),this.c.fire({document:m.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,y,u){const m=L.URI.revive(S),o=this.g.getDocument(m);if(!o)throw new Error("unknown document");o._acceptIsDirty(u),o.onEvents(y);let i;y.isUndoing?i=M.TextDocumentChangeReason.Undo:y.isRedoing&&(i=M.TextDocumentChangeReason.Redo),this.c.fire((0,E.$Mn)({document:o.document,contentChanges:y.changes.map(n=>({range:w.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:i}))}setWordDefinitionFor(S,y){(0,R.$rO)(S,y)}}e.$0hc=C}),define(Se[70],De([1,0,72,4,18,2,5,6,20,16,7]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=e.$Eic=void 0,e.$Eic=(0,R.$gi)("IExtHostEditorTabs");class C{constructor(m,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(m)}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.id===m.e()},get label(){return m.b.label},get input(){return m.c},get isDirty(){return m.b.isDirty},get isPinned(){return m.b.isPinned},get isPreview(){return m.b.isPreview},get group(){return m.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(m){this.b=m,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new M.$TN(A.URI.revive(this.b.input.uri));case 2:return new M.$UN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified));case 3:return new M.$VN(A.URI.revive(this.b.input.base),A.URI.revive(this.b.input.input1),A.URI.revive(this.b.input.input2),A.URI.revive(this.b.input.result));case 6:return new M.$WN(A.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new M.$XN(this.b.input.viewType);case 4:return new M.$YN(A.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new M.$ZN(A.URI.revive(this.b.input.original),A.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new M.$1N;case 9:return new M.$2N(A.URI.revive(this.b.input.uri),A.URI.revive(this.b.input.inputBoxUri));case 10:return new M.$3N(this.b.input.providerId);default:return}}}class v{constructor(m,o){this.c=[],this.d="",this.b=m,this.e=o;for(const i of m.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const m=this,o={get isActive(){return m.b.groupId===m.e()},get viewColumn(){return E.ViewColumn.to(m.b.viewColumn)},get activeTab(){return m.c.find(i=>i.tabId===m.d)?.apiObject},get tabs(){return Object.freeze(m.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(m){this.b=m}acceptTabOperation(m){if(m.kind===0){const i=new C(m.tabDto,this,()=>this.activeTabId());return this.c.splice(m.index,0,i),m.tabDto.isActive&&(this.d=i.tabId),i}else if(m.kind===1){const i=this.c.splice(m.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${m.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(m.kind===3){if(m.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(m.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${m.oldIndex} which does not exist`);return this.c.splice(m.index,0,i),i}const o=this.c.find(i=>i.tabId===m.tabDto.id);if(!o)throw new Error("INVALID tab");return m.tabDto.isActive?this.d=m.tabDto.id:this.d===m.tabDto.id&&!m.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(m.tabDto),o}activeTabId(){return this.d}}let S=class{constructor(m){this.b=new N.$6d,this.c=new N.$6d,this.e=[],this.a=m.getProxy(w.$0L.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const m=this,o={onDidChangeTabGroups:m.c.event,onDidChangeTabs:m.b.event,get all(){return Object.freeze(m.e.map(i=>i.apiObject))},get activeTabGroup(){const i=m.d;return(0,L.$5f)(m.e.find(r=>r.groupId===i)?.apiObject)},close:async(i,n)=>{const r=Array.isArray(i)?i:[i];return r.length?y(r[0])?this.j(r,n):this.i(r,n):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(m){const o=new Set(this.e.map(h=>h.groupId)),i=new Set(m.map(h=>h.groupId)),n=(0,l.$L)(o,i),r=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),c=[],t=[];this.e=m.map(h=>{const s=new v(h,()=>this.d);return n.added.includes(s.groupId)?c.push(s.apiObject):t.push(s.apiObject),s});const f=(0,L.$5f)(m.find(h=>h.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:c,closed:r,changed:t}))}$acceptTabGroupUpdate(m){const o=this.e.find(i=>i.groupId===m.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(m),m.isActive&&(this.d=m.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(m){const o=this.e.find(n=>n.groupId===m.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(m);switch(m.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(m){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===m)return i}h(m){return this.e.find(o=>o.apiObject===m)}async i(m,o){const i=[];for(const n of m){const r=this.g(n);if(!r)throw new Error("Tab close: Invalid tab not found!");i.push(r.tabId)}return this.a.$closeTab(i,o)}async j(m,o){const i=[];for(const n of m){const r=this.h(n);if(!r)throw new Error("Group close: Invalid group not found!");i.push(r.groupId)}return this.a.$closeGroup(i,o)}};e.$Fic=S,e.$Fic=S=Qe([Ve(0,p.$pO)],S);function y(u){return u.tabs!==void 0}}),define(Se[331],De([1,0,2,6,3,7,16,178,14,21,26,79]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class v{constructor(){this.a=[]}add(u){this.b=void 0,this.a.push(u)}delete(u){const m=this.a.indexOf(u);m>=0&&(this.a.splice(m,1),this.b=void 0)}c(){if(!this.b){const u=this.a.sort(),m=[];let o,i,n=14,r=14;for(const c of u){let t=o?(0,p.$mf)(o,c):0;for(t===0?i=1:i=r;t<c.length;t++)t+1===c.length?(n=r,r=9):r+=1,m.push([i,c.toUpperCase().charCodeAt(t),r]),m.push([i,c.toLowerCase().charCodeAt(t),r]),i=r;o=c,r=n}m.push([9,58,10]),m.push([10,47,12]),this.b=new w.$a2(m)}}provideDocumentLinks(u){this.c();const m=[],o=w.$b2.computeLinks({getLineContent(i){return u.lineAt(i-1).text},getLineCount(){return u.lineCount}},this.b);for(const i of o){const n=R.DocumentLink.to(i);n.target&&m.push(n)}return m}}class S{constructor(u,m){this.i=m,this.b=new v,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=u.getProxy(N.$0L.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(u,m,o,i={}){if(S.j(o),this.d.has(m))throw new Error(`a provider for the scheme '${m}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(u,"*",this.b));const n=this.h++;this.b.add(m),this.d.add(m),this.c.set(n,o);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),typeof o.copy=="function"&&(r+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,M.$1F)(u,"fsChunks"),r+=4);let c;i.isReadonly&&(0,C.$zk)(i.isReadonly)&&i.isReadonly.value!==""&&(c={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,m,r,c).catch(f=>{console.error(`FAILED to register filesystem provider of ${u.identifier.value}-extension for the scheme ${m}`),console.error(f)});const t=o.onDidChangeFile(f=>{const h=[];for(const s of f){const{uri:a,type:d}=s;if(a.scheme!==m)continue;let $;switch(d){case A.FileChangeType.Changed:$=0;break;case A.FileChangeType.Created:$=1;break;case A.FileChangeType.Deleted:$=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:a,type:$})}this.a.$onFileSystemChange(n,h)});return(0,L.$Rc)(()=>{t.dispose(),this.b.delete(m),this.d.delete(m),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(u){if(!u)throw new Error("MISSING provider");if(typeof u.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof u.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof u.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof u.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof u.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof u.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof u.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof u.rename!="function")throw new Error("Provider does NOT implement rename")}static k(u){const{type:m,ctime:o,mtime:i,size:n,permissions:r}=u;return{type:m,ctime:o,mtime:i,size:n,permissions:r}}$stat(u,m){return Promise.resolve(this.l(u).stat(l.URI.revive(m))).then(o=>S.k(o))}$readdir(u,m){return Promise.resolve(this.l(u).readDirectory(l.URI.revive(m)))}$readFile(u,m){return Promise.resolve(this.l(u).readFile(l.URI.revive(m))).then(o=>E.$te.wrap(o))}$writeFile(u,m,o,i){return Promise.resolve(this.l(u).writeFile(l.URI.revive(m),o.buffer,i))}$delete(u,m,o){return Promise.resolve(this.l(u).delete(l.URI.revive(m),o))}$rename(u,m,o,i){return Promise.resolve(this.l(u).rename(l.URI.revive(m),l.URI.revive(o),i))}$copy(u,m,o,i){const n=this.l(u);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(l.URI.revive(m),l.URI.revive(o),i))}$mkdir(u,m){return Promise.resolve(this.l(u).createDirectory(l.URI.revive(m)))}$watch(u,m,o,i){const n=this.l(u).watch(l.URI.revive(o),i);this.f.set(m,n)}$unwatch(u,m){const o=this.f.get(m);o&&(o.dispose(),this.f.delete(m))}$open(u,m,o){const i=this.l(u);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(l.URI.revive(m),o))}$close(u,m){const o=this.l(u);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(m))}$read(u,m,o,i){const n=this.l(u);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const r=E.$te.alloc(i);return Promise.resolve(n.read(m,o,r.buffer,0,i)).then(c=>r.slice(0,c))}$write(u,m,o,i){const n=this.l(u);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(m,o,i.buffer,0,i.byteLength))}l(u){const m=this.c.get(u);if(!m){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return m}}e.$hjc=S}),define(Se[332],De([1,0,4,35,2,6,16,7,43]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(S,y,u,m,o,i){this.a=Math.random(),this.b=new l.$6d,this.c=new l.$6d,this.d=new l.$6d,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$Zj)(o),r=typeof o=="string",c=i?.correlate,t=m(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(c&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const h of f.created){const s=L.URI.revive(h);n(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.b.fire(s)}if(!i?.ignoreChangeEvents)for(const h of f.changed){const s=L.URI.revive(h);n(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.c.fire(s)}if(!i?.ignoreDeleteEvents)for(const h of f.deleted){const s=L.URI.revive(h);n(s.fsPath)&&(!r||y.getWorkspaceFolder(s))&&this.d.fire(s)}}});this.g=w.$_L.from(this.i(S,u,o,i,i?.correlate),this.b,this.c,this.d,t)}i(S,y,u,m,o){const i=w.$_L.from();if(typeof u=="string")return i;const n=S.getProxy(A.$0L.MainThreadFileSystemEventService);let r=!1;return(u.pattern.includes(N.$Vj)||u.pattern.includes(N.$Wj))&&(r=!0),n.$watch(y.identifier.value,this.a,u.baseUri,{recursive:r,excludes:m?.excludes??[]},!!o),w.$_L.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class M{constructor(S){this.a=S,this.session=this.a.session,this.b=new p.$V(()=>this.a.created.map(L.URI.revive)),this.c=new p.$V(()=>this.a.changed.map(L.URI.revive)),this.d=new p.$V(()=>this.a.deleted.map(L.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(S,y,u){this.j=S,this.k=y,this.l=u,this.a=new l.$6d,this.b=new l.$6d,this.c=new l.$6d,this.d=new l.$6d,this.g=new l.$8d,this.h=new l.$8d,this.i=new l.$8d,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(S,y,u,m){return new E(this.j,S,y,this.a.event,R.GlobPattern.from(u),m)}$onFileEvent(S){this.a.fire(new M(S))}$onDidRunFileOperation(S,y){switch(S){case 2:this.b.fire(Object.freeze({files:y.map(u=>({oldUri:L.URI.revive(u.source),newUri:L.URI.revive(u.target)}))}));break;case 1:this.d.fire(Object.freeze({files:y.map(u=>L.URI.revive(u.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:y.map(u=>L.URI.revive(u.target))}));break;default:}}getOnWillRenameFileEvent(S){return this.m(S,this.g)}getOnWillCreateFileEvent(S){return this.m(S,this.h)}getOnWillDeleteFileEvent(S){return this.m(S,this.i)}m(S,y){return(u,m,o)=>{const i=function(r){u.call(m,r)};return i.extension=S,y.event(i,void 0,o)}}async $onWillRunFileOperation(S,y,u,m){switch(S){case 2:return await this.n(this.g,{files:y.map(o=>({oldUri:L.URI.revive(o.source),newUri:L.URI.revive(o.target)}))},u,m);case 1:return await this.n(this.i,{files:y.map(o=>L.URI.revive(o.target))},u,m);case 0:case 3:return await this.n(this.h,{files:y.map(o=>L.URI.revive(o.target))},u,m)}}async n(S,y,u,m){const o=new Set,i=[];if(await S.fireAsync(y,m,async(r,c)=>{const t=Date.now(),f=await Promise.resolve(r);f instanceof w.$jM&&(i.push([c.extension,f]),o.add(c.extension.displayName??c.extension.identifier.value)),Date.now()-t>u&&this.k.warn("SLOW file-participant",c.extension.identifier)}),m.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,r]of i){const{edits:c}=R.WorkspaceEdit.from(r,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(c)}return{edit:n,extensionNames:Array.from(o)}}}e.$ijc=C}),define(Se[333],De([1,0,19,8,22,13,124,3,24,38,14,18,2,29,174,82,134,218,25,16,7,26,111,6]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class h{constructor(q,W){this.d=q,this.e=W}async provideDocumentSymbols(q,W){const Q=this.d.getDocument(q),J=await this.e.provideDocumentSymbols(Q,W);if(!(0,l.$Kb)(J))return J[0]instanceof r.$sM?J.map(n.DocumentSymbol.from):h.f(J)}static f(q){q=q.slice(0).sort((J,$e)=>{let ve=J.location.range.start.compareTo($e.location.range.start);return ve===0&&(ve=$e.location.range.end.compareTo(J.location.range.end)),ve});const W=[],Q=[];for(const J of q){const $e={name:J.name||"!!MISSING: name!!",kind:n.SymbolKind.from(J.kind),tags:J.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:J.containerName,range:n.Range.from(J.location.range),selectionRange:n.Range.from(J.location.range),children:[]};for(;;){if(Q.length===0){Q.push($e),W.push($e);break}const ve=Q[Q.length-1];if(S.$0s.containsRange(ve.range,$e.range)&&!S.$0s.equalsRange(ve.range,$e.range)){ve.children?.push($e),Q.push($e);break}Q.pop()}}return W}}class s{constructor(q,W,Q,J,$e,ve){this.f=q,this.g=W,this.h=Q,this.j=J,this.k=$e,this.l=ve,this.d=new t.$1hc("CodeLens"),this.e=new Map}async provideCodeLenses(q,W){const Q=this.f.getDocument(q),J=await this.h.provideCodeLenses(Q,W);if(!J||W.isCancellationRequested)return;const $e=this.d.add(J),ve=new w.$Sc;this.e.set($e,ve);const Te={cacheId:$e,lenses:[]};for(let He=0;He<J.length;He++)Te.lenses.push({cacheId:[$e,He],range:n.Range.from(J[He].range),command:this.g.toInternal(J[He].command,ve)});return Te}async resolveCodeLens(q,W){const Q=q.cacheId&&this.d.get(...q.cacheId);if(!Q)return;let J;if(typeof this.h.resolveCodeLens!="function"||Q.isResolved?J=Q:J=await this.h.resolveCodeLens(Q,W),J||(J=Q),W.isCancellationRequested)return;const $e=q.cacheId&&this.e.get(q.cacheId[0]);if($e){if(!J.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return q.command=this.g.toInternal(J.command,$e),q}}releaseCodeLenses(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}}function a(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class d{constructor(q,W){this.d=q,this.e=W}async provideDefinition(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDefinition(J,$e,Q);return a(ve)}}class ${constructor(q,W){this.d=q,this.e=W}async provideDeclaration(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDeclaration(J,$e,Q);return a(ve)}}class D{constructor(q,W){this.d=q,this.e=W}async provideImplementation(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideImplementation(J,$e,Q);return a(ve)}}class b{constructor(q,W){this.d=q,this.e=W}async provideTypeDefinition(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideTypeDefinition(J,$e,Q);return a(ve)}}class g{constructor(q,W){this.d=q,this.e=W}async provideHover(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideHover(J,$e,Q);if(!(!ve||(0,l.$Kb)(ve.contents)))return ve.range||(ve.range=J.getWordRangeAtPosition($e)),ve.range||(ve.range=new r.$bM($e,$e)),n.Hover.from(ve)}}class k{constructor(q,W){this.d=q,this.e=W}async provideEvaluatableExpression(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideEvaluatableExpression(J,$e,Q);if(ve)return n.EvaluatableExpression.from(ve)}}class P{constructor(q,W){this.d=q,this.e=W}async provideInlineValues(q,W,Q,J){const $e=this.d.getDocument(q),ve=await this.e.provideInlineValues($e,n.Range.to(W),n.InlineValueContext.to(Q),J);if(Array.isArray(ve))return ve.map(Te=>n.InlineValue.from(Te))}}class F{constructor(q,W){this.d=q,this.e=W}async provideDocumentHighlights(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideDocumentHighlights(J,$e,Q);if(Array.isArray(ve))return ve.map(n.DocumentHighlight.from)}}class U{constructor(q,W){this.d=q,this.e=W}async provideMultiDocumentHighlights(q,W,Q,J){const $e=this.d.getDocument(q),ve=Q.map(Xe=>this.d.getDocument(Xe)),Te=n.Position.to(W),He=await this.e.provideMultiDocumentHighlights($e,Te,ve,J);if(Array.isArray(He))return He.map(n.MultiDocumentHighlight.from)}}class z{constructor(q,W){this.d=q,this.e=W}async provideLinkedEditingRanges(q,W,Q){const J=this.d.getDocument(q),$e=n.Position.to(W),ve=await this.e.provideLinkedEditingRanges(J,$e,Q);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,l.$Hb)(ve.ranges.map(n.Range.from)),wordPattern:ve.wordPattern}}}class T{constructor(q,W){this.d=q,this.e=W}async provideReferences(q,W,Q,J){const $e=this.d.getDocument(q),ve=n.Position.to(W),Te=await this.e.provideReferences($e,ve,Q,J);if(Array.isArray(Te))return Te.map(n.location.from)}}class I{static{this.d=1e3}constructor(q,W,Q,J,$e,ve,Te){this.g=q,this.h=W,this.j=Q,this.k=J,this.l=$e,this.m=ve,this.n=Te,this.e=new t.$1hc("CodeAction"),this.f=new Map}async provideCodeActions(q,W,Q,J){const $e=this.g.getDocument(q),ve=y.$_s.isISelection(W)?n.Selection.to(W):n.Range.to(W),Te=[];for(const rt of this.j.getDiagnostics(q))if(ve.intersection(rt.range)&&Te.push(rt)>I.d)break;const He={diagnostics:Te,only:Q.only?new r.$uM(Q.only):void 0,triggerKind:n.CodeActionTriggerKind.to(Q.trigger)},Xe=await this.k.provideCodeActions($e,ve,He,J);if(!(0,l.$Lb)(Xe)||J.isCancellationRequested)return;const tt=this.e.add(Xe),st=new w.$Sc;this.f.set(tt,st);const ut=[];for(let rt=0;rt<Xe.length;rt++){const Ie=Xe[rt];if(Ie)if(I.o(Ie))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),ut.push({_isSynthetic:!0,title:Ie.title,command:this.h.toInternal(Ie,st)});else{He.only&&(Ie.kind?He.only.contains(Ie.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action is of kind '${Ie.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${He.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Be=Ie.ranges??[];ut.push({cacheId:[tt,rt],title:Ie.title,command:Ie.command&&this.h.toInternal(Ie.command,st),diagnostics:Ie.diagnostics&&Ie.diagnostics.map(n.Diagnostic.from),edit:Ie.edit&&n.WorkspaceEdit.from(Ie.edit,void 0),kind:Ie.kind&&Ie.kind.value,isPreferred:Ie.isPreferred,isAI:(0,c.$ZF)(this.m,"codeActionAI")?Ie.isAI:!1,ranges:(0,c.$ZF)(this.m,"codeActionRanges")?(0,l.$Hb)(Be.map(n.Range.from)):void 0,disabled:Ie.disabled?.reason})}}return{cacheId:tt,actions:ut}}async resolveCodeAction(q,W){const[Q,J]=q,$e=this.e.get(Q,J);if(!$e||I.o($e))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction($e,W)??$e;let Te;ve.edit&&(Te=n.WorkspaceEdit.from(ve.edit,void 0));let He;if(ve.command){const Xe=this.f.get(Q);Xe&&(He=this.h.toInternal(ve.command,Xe))}return{edit:Te,command:He}}releaseCodeActions(q){this.f.get(q)?.dispose(),this.f.delete(q),this.e.delete(q)}static o(q){return typeof q.command=="string"&&typeof q.title=="string"}}class O{static toInternalProviderId(q,W){return q+"."+W}constructor(q,W,Q,J,$e){this.d=q,this.e=W,this.f=Q,this.g=J,this.h=$e}async prepareDocumentPaste(q,W,Q,J){if(!this.f.prepareDocumentPaste)return;const $e=this.e.getDocument(q),ve=W.map(Xe=>n.Range.to(Xe)),Te=n.DataTransfer.toDataTransfer(Q,()=>{throw new A.$$});if(await this.f.prepareDocumentPaste($e,ve,Te,J),J.isCancellationRequested)return;const He=Array.from(Te).filter(([,Xe])=>!(Xe instanceof r.$1M));return n.DataTransfer.from(He)}async providePasteEdits(q,W,Q,J,$e){if(!this.f.provideDocumentPasteEdits)return;const ve=this.e.getDocument(W),Te=Q.map(tt=>n.Range.to(tt)),He=n.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolvePasteFileData(this.g,q,tt)).buffer),Xe=await this.f.provideDocumentPasteEdits(ve,Te,He,$e);if(Xe)return{label:Xe.label??(0,o.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Xe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:O.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?n.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class j{constructor(q,W){this.d=q,this.e=W}async provideDocumentFormattingEdits(q,W,Q){const J=this.d.getDocument(q),$e=await this.e.provideDocumentFormattingEdits(J,W,Q);if(Array.isArray($e))return $e.map(n.TextEdit.from)}}class G{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeFormattingEdits(q,W,Q,J){const $e=this.d.getDocument(q),ve=n.Range.to(W),Te=await this.e.provideDocumentRangeFormattingEdits($e,ve,Q,J);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(q,W,Q,J){(0,C.$4f)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const $e=this.d.getDocument(q),ve=W.map(n.Range.to),Te=await this.e.provideDocumentRangesFormattingEdits($e,ve,Q,J);if(Array.isArray(Te))return Te.map(n.TextEdit.from)}}class te{constructor(q,W){this.d=q,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(q,W,Q,J,$e){const ve=this.d.getDocument(q),Te=n.Position.to(W),He=await this.e.provideOnTypeFormattingEdits(ve,Te,Q,J,$e);if(Array.isArray(He))return He.map(n.TextEdit.from)}}class x{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1hc("WorkspaceSymbols")}async provideWorkspaceSymbols(q,W){const Q=await this.e.provideWorkspaceSymbols(q,W);if(!(0,l.$Lb)(Q))return{symbols:[]};const J=this.d.add(Q),$e={cacheId:J,symbols:[]};for(let ve=0;ve<Q.length;ve++){const Te=Q[ve];if(!Te||!Te.name){this.f.warn("INVALID SymbolInformation",Te);continue}$e.symbols.push({...n.WorkspaceSymbol.from(Te),cacheId:[J,ve]})}return $e}async resolveWorkspaceSymbol(q,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!q.cacheId)return q;const Q=this.d.get(...q.cacheId);if(Q){const J=await this.e.resolveWorkspaceSymbol(Q,W);return J&&(0,p.$On)(q,n.WorkspaceSymbol.from(J),!0)}}releaseWorkspaceSymbols(q){this.d.delete(q)}}class Z{static supportsResolving(q){return typeof q.prepareRename=="function"}constructor(q,W,Q){this.d=q,this.e=W,this.f=Q}async provideRenameEdits(q,W,Q,J){const $e=this.d.getDocument(q),ve=n.Position.to(W);try{const Te=await this.e.provideRenameEdits($e,ve,Q,J);return Te?n.WorkspaceEdit.from(Te):void 0}catch(Te){const He=Z.g(Te);return He?{rejectReason:He,edits:void 0}:Promise.reject(Te)}}async resolveRenameLocation(q,W,Q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const J=this.d.getDocument(q),$e=n.Position.to(W);try{const ve=await this.e.prepareRename(J,$e,Q);let Te,He;if(r.$bM.isRange(ve)?(Te=ve,He=J.getText(ve)):(0,C.$Vf)(ve)&&(Te=ve.range,He=ve.placeholder),!Te||!He)return;if(Te.start.line>$e.line||Te.end.line<$e.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Te),text:He}}catch(ve){const Te=Z.g(ve);return Te?{rejectReason:Te,range:void 0,text:void 0}:Promise.reject(ve)}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class X{constructor(q,W,Q){this.d=q,this.e=W,this.f=Q}async provideNewSymbolNames(q,W,Q){const J=this.d.getDocument(q),$e=n.Range.to(W);try{const ve=await this.e.provideNewSymbolNames(J,$e,Q);return ve?ve.map(Te=>typeof Te=="string"?{newSymbolName:Te}:{newSymbolName:Te.newSymbolName,tags:Te.tags}):void 0}catch(ve){this.f.error(X.g(ve)??JSON.stringify(ve,null,"	"));return}}static g(q){return typeof q=="string"?q:q instanceof Error&&typeof q.message=="string"?q.message:void 0}}class ae{constructor(q,W){this.resultId=q,this.tokens=W}}class _{constructor(q,W){this.f=q,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(q,W,Q){const J=this.f.getDocument(q),$e=W!==0?this.d.get(W):null;let ve=typeof $e?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(J,$e.resultId,Q):await this.g.provideDocumentSemanticTokens(J,Q);return $e&&this.d.delete(W),ve?(ve=_.h(ve),this.o(_.n($e,ve),ve)):null}async releaseDocumentSemanticColoring(q){this.d.delete(q)}static h(q){return _.j(q)?_.k(q)?q:new r.$sN(new Uint32Array(q.data),q.resultId):_.l(q)?_.m(q)?q:new r.$uN(q.edits.map(W=>new r.$tN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),q.resultId):q}static j(q){return q&&!!q.data}static k(q){return q.data instanceof Uint32Array}static l(q){return q&&Array.isArray(q.edits)}static m(q){for(const W of q.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(q,W){if(!_.j(W)||!q||!q.tokens)return W;const Q=q.tokens,J=Q.length,$e=W.data,ve=$e.length;let Te=0;const He=Math.min(J,ve);for(;Te<He&&Q[Te]===$e[Te];)Te++;if(Te===J&&Te===ve)return new r.$uN([],W.resultId);let Xe=0;const tt=He-Te;for(;Xe<tt&&Q[J-Xe-1]===$e[ve-Xe-1];)Xe++;return new r.$uN([{start:Te,deleteCount:J-Te-Xe,data:$e.subarray(Te,ve-Xe)}],W.resultId)}o(q,W){if(_.j(q)){const Q=this.e++;return this.d.set(Q,new ae(q.resultId,q.data)),(0,m.$eab)({id:Q,type:"full",data:q.data})}if(_.l(q)){const Q=this.e++;return _.j(W)?this.d.set(Q,new ae(W.resultId,W.data)):this.d.set(Q,new ae(q.resultId)),(0,m.$eab)({id:Q,type:"delta",deltas:(q.edits||[]).map(J=>({start:J.start,deleteCount:J.deleteCount,data:J.data}))})}return null}}class ge{constructor(q,W){this.d=q,this.e=W}async provideDocumentRangeSemanticTokens(q,W,Q){const J=this.d.getDocument(q),$e=await this.e.provideDocumentRangeSemanticTokens(J,n.Range.to(W),Q);return $e?this.f($e):null}f(q){return(0,m.$eab)({id:0,type:"full",data:q.data})}}class se{static supportsResolving(q){return typeof q.resolveCompletionItem=="function"}constructor(q,W,Q,J,$e){this.f=q,this.g=W,this.h=Q,this.j=J,this.k=$e,this.d=new t.$1hc("CompletionItem"),this.e=new Map}async provideCompletionItems(q,W,Q,J){const $e=this.f.getDocument(q),ve=n.Position.to(W),Te=$e.getWordRangeAtPosition(ve)||new r.$bM(ve,ve),He=Te.with({end:ve}),Xe=new E.$2d,tt=await this.h.provideCompletionItems($e,ve,J,n.CompletionContext.to(Q));if(!tt||J.isCancellationRequested)return;const st=Array.isArray(tt)?new r.$HM(tt):tt,ut=se.supportsResolving(this.h)?this.d.add(st.items):this.d.add([]),rt=new w.$Sc;this.e.set(ut,rt);const Ie=[],Be={x:ut,b:Ie,a:{replace:n.Range.from(Te),insert:n.Range.from(He)},c:st.isIncomplete||void 0,d:Xe.elapsed()};for(let Le=0;Le<st.items.length;Le++){const Ke=st.items[Le],ne=this.l(Ke,[ut,Le],He,Te);Ie.push(ne)}return Be}async resolveCompletionItem(q,W){if(typeof this.h.resolveCompletionItem!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=this.l(Q,q),$e=await this.h.resolveCompletionItem(Q,W);if(!$e)return;const ve=this.l($e,q);return(J.h!==ve.h||J.i!==ve.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(J.n!==ve.n||J.o!==ve.o||!(0,p.$Pn)(J.p,ve.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...J,d:ve.d,c:ve.c,l:ve.l,h:ve.h,i:ve.i,n:ve.n,o:ve.o,p:ve.p}}releaseCompletionItems(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W,Q,J){const $e=this.e.get(W[0]);if(!$e)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(q.command,$e),Te={x:W,a:q.label,b:q.kind!==void 0?n.CompletionItemKind.from(q.kind):void 0,m:q.tags&&q.tags.map(n.CompletionItemTag.from),c:q.detail,d:typeof q.documentation>"u"?void 0:n.MarkdownString.fromStrict(q.documentation),e:q.sortText!==q.label?q.sortText:void 0,f:q.filterText!==q.label?q.filterText:void 0,g:q.preselect||void 0,i:q.keepWhitespace?1:0,k:q.commitCharacters?.join(""),l:q.additionalTextEdits&&q.additionalTextEdits.map(n.TextEdit.from),n:ve?.$ident,o:ve?.id,p:ve?.$ident?void 0:ve?.arguments};q.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Te.h=q.textEdit.newText):typeof q.insertText=="string"?Te.h=q.insertText:q.insertText instanceof r.$kM&&(Te.h=q.insertText.value,Te.i|=4);let He;return q.textEdit?He=q.textEdit.range:q.range&&(He=q.range),r.$bM.isRange(He)?Te.j=n.Range.from(He):He&&(!Q?.isEqual(He.inserting)||!J?.isEqual(He.replacing))&&(Te.j={insert:n.Range.from(He.inserting),replace:n.Range.from(He.replacing)}),Te}}class re{async provideInlineCompletions(q,W,Q,J){}disposeCompletions(q){}handleDidShowCompletionItem(q,W,Q){}handlePartialAccept(q,W,Q){}}class B extends re{constructor(q,W,Q,J){super(),this.f=q,this.g=W,this.h=Q,this.j=J,this.d=new ke,this.e=(0,c.$ZF)(this.f,"inlineCompletionsAdditions"),this.k={[u.InlineCompletionTriggerKind.Automatic]:r.InlineCompletionTriggerKind.Automatic,[u.InlineCompletionTriggerKind.Explicit]:r.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,c.$ZF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(q,W,Q,J){const $e=this.g.getDocument(q),ve=n.Position.to(W),Te=await this.h.provideInlineCompletionItems($e,ve,{selectedCompletionInfo:Q.selectedSuggestionInfo?{range:n.Range.to(Q.selectedSuggestionInfo.range),text:Q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Q.triggerKind]},J);if(!Te||J.isCancellationRequested)return;const He=Array.isArray(Te)?Te:Te.items,Xe=this.e?Array.isArray(Te)?[]:Te.commands||[]:[],tt=this.e&&!Array.isArray(Te)?Te.enableForwardStability:void 0;let st;return{pid:this.d.createReferenceId({dispose(){st?.dispose()},items:He}),items:He.map((rt,Ie)=>{let Be;rt.command&&(st||(st=new w.$Sc),Be=this.j.toInternal(rt.command,st));const Le=rt.insertText;return{insertText:typeof Le=="string"?Le:{snippet:Le.value},filterText:rt.filterText,range:rt.range?n.Range.from(rt.range):void 0,command:Be,idx:Ie,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:Xe.map(rt=>(st||(st=new w.$Sc),this.j.toInternal(rt,st))),suppressSuggestions:!1,enableForwardStability:tt}}disposeCompletions(q){this.d.disposeReferenceId(q)?.dispose()}handleDidShowCompletionItem(q,W,Q){const J=this.d.get(q)?.items[W];J&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(J,Q)}handlePartialAccept(q,W,Q){const J=this.d.get(q)?.items[W];J&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(J,Q)}}class ie{async provideInlineEdits(q,W,Q){const J=this.f.getDocument(q),$e=await this.g.provideInlineEdit(J,{triggerKind:this.e[W.triggerKind]},Q);if(!$e||Q.isCancellationRequested)return;let ve;const Te=this.d.createReferenceId({dispose(){ve?.dispose()},item:$e});let He;$e.accepted&&(ve||(ve=new w.$Sc),He=this.h.toInternal($e.accepted,ve));let Xe;return $e.rejected&&(ve||(ve=new w.$Sc),Xe=this.h.toInternal($e.rejected,ve)),{pid:Te,text:$e.text,range:n.Range.from($e.range),accepted:He,rejected:Xe}}disposeEdit(q){this.d.disposeReferenceId(q)?.dispose()}constructor(q,W,Q,J){this.f=W,this.g=Q,this.h=J,this.d=new ke,this.e={[u.InlineEditTriggerKind.Automatic]:r.InlineEditTriggerKind.Automatic,[u.InlineEditTriggerKind.Invoke]:r.InlineEditTriggerKind.Invoke}}}class ke{constructor(){this.d=new Map,this.e=1}createReferenceId(q){const W=this.e++;return this.d.set(W,q),W}disposeReferenceId(q){const W=this.d.get(q);return this.d.delete(q),W}get(q){return this.d.get(q)}}class le{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1hc("SignatureHelp")}async provideSignatureHelp(q,W,Q,J){const $e=this.e.getDocument(q),ve=n.Position.to(W),Te=this.g(Q),He=await this.f.provideSignatureHelp($e,ve,J,Te);if(He){const Xe=this.d.add([He]);return{...n.SignatureHelp.from(He),id:Xe}}}g(q){let W;if(q.activeSignatureHelp){const Q=n.SignatureHelp.to(q.activeSignatureHelp),J=this.d.get(q.activeSignatureHelp.id,0);J?(W=J,W.activeSignature=Q.activeSignature,W.activeParameter=Q.activeParameter):W=Q}return{...q,activeSignatureHelp:W}}releaseSignatureHelp(q){this.d.delete(q)}}class ue{constructor(q,W,Q,J,$e){this.f=q,this.g=W,this.h=Q,this.j=J,this.k=$e,this.d=new t.$1hc("InlayHints"),this.e=new Map}async provideInlayHints(q,W,Q){const J=this.f.getDocument(q),$e=n.Range.to(W),ve=await this.h.provideInlayHints(J,$e,Q);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(Q.isCancellationRequested)return;const Te=this.d.add(ve);this.e.set(Te,new w.$Sc);const He={hints:[],cacheId:Te};for(let Xe=0;Xe<ve.length;Xe++)this.l(ve[Xe],$e)&&He.hints.push(this.m(ve[Xe],[Te,Xe]));return this.j.trace(`[InlayHints] ${He.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),He}async resolveInlayHint(q,W){if(typeof this.h.resolveInlayHint!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.h.resolveInlayHint(Q,W);if(J&&this.l(J))return this.m(J,q)}releaseHints(q){this.e.get(q)?.dispose(),this.e.delete(q),this.d.delete(q)}l(q,W){return q.label.length===0||Array.isArray(q.label)&&q.label.every(Q=>Q.value.length===0)?(console.log("INVALID inlay hint, empty label",q),!1):!(W&&!W.contains(q.position))}m(q,W){const Q=this.e.get(W[0]);if(!Q)throw Error("DisposableStore is missing...");const J={label:"",cacheId:W,tooltip:n.MarkdownString.fromStrict(q.tooltip),position:n.Position.from(q.position),textEdits:q.textEdits&&q.textEdits.map(n.TextEdit.from),kind:q.kind&&n.InlayHintKind.from(q.kind),paddingLeft:q.paddingLeft,paddingRight:q.paddingRight};if(typeof q.label=="string")J.label=q.label;else{const $e=[];J.label=$e;for(const ve of q.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Te={label:ve.value,tooltip:n.MarkdownString.fromStrict(ve.tooltip)};r.$lM.isLocation(ve.location)&&(Te.location=n.location.from(ve.location)),ve.command&&(Te.command=this.g.toInternal(ve.command,Q)),$e.push(Te)}}return J}}class ce{constructor(q,W){this.e=q,this.f=W,this.d=new t.$1hc("DocumentLink")}async provideLinks(q,W){const Q=this.e.getDocument(q),J=await this.f.provideDocumentLinks(Q,W);if(!(!Array.isArray(J)||J.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:J.filter(ce.g).map(n.DocumentLink.from)};{const $e=this.d.add(J),ve={links:[],cacheId:$e};for(let Te=0;Te<J.length;Te++){if(!ce.g(J[Te]))continue;const He=n.DocumentLink.from(J[Te]);He.cacheId=[$e,Te],ve.links.push(He)}return ve}}}static g(q){return q.target&&q.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(q,W){if(typeof this.f.resolveDocumentLink!="function")return;const Q=this.d.get(...q);if(!Q)return;const J=await this.f.resolveDocumentLink(Q,W);if(!(!J||!ce.g(J)))return n.DocumentLink.from(J)}releaseLinks(q){this.d.delete(q)}}class de{constructor(q,W){this.d=q,this.e=W}async provideColors(q,W){const Q=this.d.getDocument(q),J=await this.e.provideDocumentColors(Q,W);return Array.isArray(J)?J.map(ve=>({color:n.Color.from(ve.color),range:n.Range.from(ve.range)})):[]}async provideColorPresentations(q,W,Q){const J=this.d.getDocument(q),$e=n.Range.to(W.range),ve=n.Color.to(W.color),Te=await this.e.provideColorPresentations(ve,{document:J,range:$e},Q);if(Array.isArray(Te))return Te.map(n.ColorPresentation.from)}}class H{constructor(q,W){this.d=q,this.e=W}async provideFoldingRanges(q,W,Q){const J=this.d.getDocument(q),$e=await this.e.provideFoldingRanges(J,W,Q);if(Array.isArray($e))return $e.map(n.FoldingRange.from)}}class Y{constructor(q,W,Q){this.d=q,this.e=W,this.f=Q}async provideSelectionRanges(q,W,Q){const J=this.d.getDocument(q),$e=W.map(n.Position.to),ve=await this.e.provideSelectionRanges(J,$e,Q);if(!(0,l.$Lb)(ve))return[];if(ve.length!==$e.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Te=[];for(let He=0;He<$e.length;He++){const Xe=[];Te.push(Xe);let tt=$e[He],st=ve[He];for(;;){if(!st.range.contains(tt))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(n.SelectionRange.from(st)),!st.parent)break;tt=st.range,st=st.parent}}return Te}}class he{constructor(q,W){this.f=q,this.g=W,this.d=new R.$uO(""),this.e=new Map}async prepareSession(q,W,Q){const J=this.f.getDocument(q),$e=n.Position.to(W),ve=await this.g.prepareCallHierarchy(J,$e,Q);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(He=>this.h(Te,He)):[this.h(Te,ve)]}async provideCallsTo(q,W,Q){const J=this.j(q,W);if(!J)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyIncomingCalls(J,Q);if($e)return $e.map(ve=>({from:this.h(q,ve.from),fromRanges:ve.fromRanges.map(Te=>n.Range.from(Te))}))}async provideCallsFrom(q,W,Q){const J=this.j(q,W);if(!J)throw new Error("missing call hierarchy item");const $e=await this.g.provideCallHierarchyOutgoingCalls(J,Q);if($e)return $e.map(ve=>({to:this.h(q,ve.to),fromRanges:ve.fromRanges.map(Te=>n.Range.from(Te))}))}releaseSession(q){this.e.delete(q)}h(q,W){const Q=this.e.get(q),J=n.CallHierarchyItem.from(W,q,Q.size.toString(36));return Q.set(J._itemId,W),J}j(q,W){return this.e.get(q)?.get(W)}}class be{constructor(q,W){this.f=q,this.g=W,this.d=new R.$uO(""),this.e=new Map}async prepareSession(q,W,Q){const J=this.f.getDocument(q),$e=n.Position.to(W),ve=await this.g.prepareTypeHierarchy(J,$e,Q);if(!ve)return;const Te=this.d.nextId();return this.e.set(Te,new Map),Array.isArray(ve)?ve.map(He=>this.h(Te,He)):[this.h(Te,ve)]}async provideSupertypes(q,W,Q){const J=this.j(q,W);if(!J)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySupertypes(J,Q);if($e)return $e.map(ve=>this.h(q,ve))}async provideSubtypes(q,W,Q){const J=this.j(q,W);if(!J)throw new Error("missing type hierarchy item");const $e=await this.g.provideTypeHierarchySubtypes(J,Q);if($e)return $e.map(ve=>this.h(q,ve))}releaseSession(q){this.e.delete(q)}h(q,W){const Q=this.e.get(q),J=n.TypeHierarchyItem.from(W,q,Q.size.toString(36));return Q.set(J._itemId,W),J}j(q,W){return this.e.get(q)?.get(W)}}class Pe{static toInternalProviderId(q,W){return q+"."+W}constructor(q,W,Q,J,$e){this.d=q,this.e=W,this.f=Q,this.g=J,this.h=$e}async provideDocumentOnDropEdits(q,W,Q,J,$e){const ve=this.e.getDocument(W),Te=n.Position.to(Q),He=n.DataTransfer.toDataTransfer(J,async tt=>(await this.d.$resolveDocumentOnDropFileData(this.g,q,tt)).buffer),Xe=await this.f.provideDocumentDropEdits(ve,Te,He,$e);if(Xe)return{label:Xe.label??(0,o.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Xe.yieldTo?.map(tt=>"mimeType"in tt?tt:{providerId:Pe.toInternalProviderId(tt.extensionId,tt.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?n.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class we{constructor(q,W){this.d=q,this.e=W}async provideMappedEdits(q,W,Q,J){const $e=v.URI.revive(q),ve=this.d.getDocument($e),Te=Q.documents.map(tt=>tt.map(st=>({uri:v.URI.revive(st.uri),version:st.version,ranges:st.ranges.map(ut=>n.Range.to(ut))}))),He={documents:Te,selections:Te[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(ve,W,He,J);return Xe?n.WorkspaceEdit.from(Xe):null}}class Ae{constructor(q,W){this.adapter=q,this.extension=W}}class Oe{static{this.d=0}constructor(q,W,Q,J,$e,ve,Te,He){this.g=W,this.h=Q,this.j=J,this.k=$e,this.l=ve,this.m=Te,this.n=He,this.f=new Map,this.e=q.getProxy(f.$0L.MainThreadLanguageFeatures)}o(q,W){return n.DocumentSelector.from(q,this.g,W)}p(q){return new r.$_L(()=>{this.f.delete(q),this.e.$unregister(q)})}q(){return Oe.d++}async s(q,W,Q,J,$e,ve=!1){const Te=this.f.get(q);if(!Te||!(Te.adapter instanceof W))return J;const He=Date.now();ve||this.l.trace(`[${Te.extension.identifier.value}] INVOKE provider '${Q.toString().replace(/[\r\n]/g,"")}'`);const Xe=Q(Te.adapter,Te.extension);return Promise.resolve(Xe).catch(tt=>{(0,A.$4)(tt)||(this.l.error(`[${Te.extension.identifier.value}] provider FAILED`),this.l.error(tt),this.n.onExtensionError(Te.extension.identifier,tt))}).finally(()=>{ve||this.l.trace(`[${Te.extension.identifier.value}] provider DONE after ${Date.now()-He}ms`)}),L.CancellationToken.isCancellationToken($e)?(0,N.$8g)(Xe,$e):Xe}t(q,W){const Q=this.q();return this.f.set(Q,new Ae(q,W)),Q}static u(q){return q.displayName||q.name}registerDocumentSymbolProvider(q,W,Q,J){const $e=this.t(new h(this.h,Q),q),ve=J&&J.label||Oe.u(q);return this.e.$registerDocumentSymbolProvider($e,this.o(W,q),ve),this.p($e)}$provideDocumentSymbols(q,W,Q){return this.s(q,h,J=>J.provideDocumentSymbols(v.URI.revive(W),Q),void 0,Q)}registerCodeLensProvider(q,W,Q){const J=this.q(),$e=typeof Q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(J,new Ae(new s(this.h,this.j.converter,Q,q,this.n,this.l),q)),this.e.$registerCodeLensSupport(J,this.o(W,q),$e);let ve=this.p(J);if($e!==void 0){const Te=Q.onDidChangeCodeLenses(He=>this.e.$emitCodeLensEvent($e));ve=r.$_L.from(ve,Te)}return ve}$provideCodeLenses(q,W,Q){return this.s(q,s,J=>J.provideCodeLenses(v.URI.revive(W),Q),void 0,Q)}$resolveCodeLens(q,W,Q){return this.s(q,s,J=>J.resolveCodeLens(W,Q),void 0,void 0)}$releaseCodeLenses(q,W){this.s(q,s,Q=>Promise.resolve(Q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(q,W,Q){const J=this.t(new d(this.h,Q),q);return this.e.$registerDefinitionSupport(J,this.o(W,q)),this.p(J)}$provideDefinition(q,W,Q,J){return this.s(q,d,$e=>$e.provideDefinition(v.URI.revive(W),Q,J),[],J)}registerDeclarationProvider(q,W,Q){const J=this.t(new $(this.h,Q),q);return this.e.$registerDeclarationSupport(J,this.o(W,q)),this.p(J)}$provideDeclaration(q,W,Q,J){return this.s(q,$,$e=>$e.provideDeclaration(v.URI.revive(W),Q,J),[],J)}registerImplementationProvider(q,W,Q){const J=this.t(new D(this.h,Q),q);return this.e.$registerImplementationSupport(J,this.o(W,q)),this.p(J)}$provideImplementation(q,W,Q,J){return this.s(q,D,$e=>$e.provideImplementation(v.URI.revive(W),Q,J),[],J)}registerTypeDefinitionProvider(q,W,Q){const J=this.t(new b(this.h,Q),q);return this.e.$registerTypeDefinitionSupport(J,this.o(W,q)),this.p(J)}$provideTypeDefinition(q,W,Q,J){return this.s(q,b,$e=>$e.provideTypeDefinition(v.URI.revive(W),Q,J),[],J)}registerHoverProvider(q,W,Q,J){const $e=this.t(new g(this.h,Q),q);return this.e.$registerHoverProvider($e,this.o(W,q)),this.p($e)}$provideHover(q,W,Q,J){return this.s(q,g,$e=>$e.provideHover(v.URI.revive(W),Q,J),void 0,J)}registerEvaluatableExpressionProvider(q,W,Q,J){const $e=this.t(new k(this.h,Q),q);return this.e.$registerEvaluatableExpressionProvider($e,this.o(W,q)),this.p($e)}$provideEvaluatableExpression(q,W,Q,J){return this.s(q,k,$e=>$e.provideEvaluatableExpression(v.URI.revive(W),Q,J),void 0,J)}registerInlineValuesProvider(q,W,Q,J){const $e=typeof Q.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new P(this.h,Q),q);this.e.$registerInlineValuesProvider(ve,this.o(W,q),$e);let Te=this.p(ve);if($e!==void 0){const He=Q.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent($e));Te=r.$_L.from(Te,He)}return Te}$provideInlineValues(q,W,Q,J,$e){return this.s(q,P,ve=>ve.provideInlineValues(v.URI.revive(W),Q,J,$e),void 0,$e)}registerDocumentHighlightProvider(q,W,Q){const J=this.t(new F(this.h,Q),q);return this.e.$registerDocumentHighlightProvider(J,this.o(W,q)),this.p(J)}registerMultiDocumentHighlightProvider(q,W,Q){const J=this.t(new U(this.h,Q),q);return this.e.$registerMultiDocumentHighlightProvider(J,this.o(W,q)),this.p(J)}$provideDocumentHighlights(q,W,Q,J){return this.s(q,F,$e=>$e.provideDocumentHighlights(v.URI.revive(W),Q,J),void 0,J)}$provideMultiDocumentHighlights(q,W,Q,J,$e){return this.s(q,U,ve=>ve.provideMultiDocumentHighlights(v.URI.revive(W),Q,J.map(Te=>v.URI.revive(Te)),$e),void 0,$e)}registerLinkedEditingRangeProvider(q,W,Q){const J=this.t(new z(this.h,Q),q);return this.e.$registerLinkedEditingRangeProvider(J,this.o(W,q)),this.p(J)}$provideLinkedEditingRanges(q,W,Q,J){return this.s(q,z,async $e=>{const ve=await $e.provideLinkedEditingRanges(v.URI.revive(W),Q,J);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Oe.w(ve.wordPattern):void 0}},void 0,J)}registerReferenceProvider(q,W,Q){const J=this.t(new T(this.h,Q),q);return this.e.$registerReferenceSupport(J,this.o(W,q)),this.p(J)}$provideReferences(q,W,Q,J,$e){return this.s(q,T,ve=>ve.provideReferences(v.URI.revive(W),Q,J,$e),void 0,$e)}registerCodeActionProvider(q,W,Q,J){const $e=new w.$Sc,ve=this.t(new I(this.h,this.j.converter,this.k,Q,this.l,q,this.m),q);return this.e.$registerQuickFixSupport(ve,this.o(W,q),{providedKinds:J?.providedCodeActionKinds?.map(Te=>Te.value),documentation:J?.documentation?.map(Te=>({kind:Te.kind.value,command:this.j.converter.toInternal(Te.command,$e)}))},Oe.u(q),!!Q.resolveCodeAction),$e.add(this.p(ve)),$e}$provideCodeActions(q,W,Q,J,$e){return this.s(q,I,ve=>ve.provideCodeActions(v.URI.revive(W),Q,J,$e),void 0,$e)}$resolveCodeAction(q,W,Q){return this.s(q,I,J=>J.resolveCodeAction(W,Q),{},void 0)}$releaseCodeActions(q,W){this.s(q,I,Q=>Promise.resolve(Q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(q,W,Q){const J=this.t(new j(this.h,Q),q);return this.e.$registerDocumentFormattingSupport(J,this.o(W,q),q.identifier,q.displayName||q.name),this.p(J)}$provideDocumentFormattingEdits(q,W,Q,J){return this.s(q,j,$e=>$e.provideDocumentFormattingEdits(v.URI.revive(W),Q,J),void 0,J)}registerDocumentRangeFormattingEditProvider(q,W,Q){const J=typeof Q.provideDocumentRangesFormattingEdits=="function",$e=this.t(new G(this.h,Q),q);return this.e.$registerRangeFormattingSupport($e,this.o(W,q),q.identifier,q.displayName||q.name,J),this.p($e)}$provideDocumentRangeFormattingEdits(q,W,Q,J,$e){return this.s(q,G,ve=>ve.provideDocumentRangeFormattingEdits(v.URI.revive(W),Q,J,$e),void 0,$e)}$provideDocumentRangesFormattingEdits(q,W,Q,J,$e){return this.s(q,G,ve=>ve.provideDocumentRangesFormattingEdits(v.URI.revive(W),Q,J,$e),void 0,$e)}registerOnTypeFormattingEditProvider(q,W,Q,J){const $e=this.t(new te(this.h,Q),q);return this.e.$registerOnTypeFormattingSupport($e,this.o(W,q),J,q.identifier),this.p($e)}$provideOnTypeFormattingEdits(q,W,Q,J,$e,ve){return this.s(q,te,Te=>Te.provideOnTypeFormattingEdits(v.URI.revive(W),Q,J,$e,ve),void 0,ve)}registerWorkspaceSymbolProvider(q,W){const Q=this.t(new x(W,this.l),q);return this.e.$registerNavigateTypeSupport(Q,typeof W.resolveWorkspaceSymbol=="function"),this.p(Q)}$provideWorkspaceSymbols(q,W,Q){return this.s(q,x,J=>J.provideWorkspaceSymbols(W,Q),{symbols:[]},Q)}$resolveWorkspaceSymbol(q,W,Q){return this.s(q,x,J=>J.resolveWorkspaceSymbol(W,Q),void 0,void 0)}$releaseWorkspaceSymbols(q,W){this.s(q,x,Q=>Q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(q,W,Q){const J=this.t(new Z(this.h,Q,this.l),q);return this.e.$registerRenameSupport(J,this.o(W,q),Z.supportsResolving(Q)),this.p(J)}$provideRenameEdits(q,W,Q,J,$e){return this.s(q,Z,ve=>ve.provideRenameEdits(v.URI.revive(W),Q,J,$e),void 0,$e)}$resolveRenameLocation(q,W,Q,J){return this.s(q,Z,$e=>$e.resolveRenameLocation(v.URI.revive(W),Q,J),void 0,J)}registerNewSymbolNamesProvider(q,W,Q){const J=this.t(new X(this.h,Q,this.l),q);return this.e.$registerNewSymbolNamesProvider(J,this.o(W,q)),this.p(J)}$provideNewSymbolNames(q,W,Q,J){return this.s(q,X,$e=>$e.provideNewSymbolNames(v.URI.revive(W),Q,J),void 0,J)}registerDocumentSemanticTokensProvider(q,W,Q,J){const $e=this.t(new _(this.h,Q),q),ve=typeof Q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider($e,this.o(W,q),J,ve);let Te=this.p($e);if(ve){const He=Q.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(ve));Te=r.$_L.from(Te,He)}return Te}$provideDocumentSemanticTokens(q,W,Q,J){return this.s(q,_,$e=>$e.provideDocumentSemanticTokens(v.URI.revive(W),Q,J),null,J)}$releaseDocumentSemanticTokens(q,W){this.s(q,_,Q=>Q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(q,W,Q,J){const $e=this.t(new ge(this.h,Q),q);return this.e.$registerDocumentRangeSemanticTokensProvider($e,this.o(W,q),J),this.p($e)}$provideDocumentRangeSemanticTokens(q,W,Q,J){return this.s(q,ge,$e=>$e.provideDocumentRangeSemanticTokens(v.URI.revive(W),Q,J),null,J)}registerCompletionItemProvider(q,W,Q,J){const $e=this.t(new se(this.h,this.j.converter,Q,this.m,q),q);return this.e.$registerCompletionsProvider($e,this.o(W,q),J,se.supportsResolving(Q),q.identifier),this.p($e)}$provideCompletionItems(q,W,Q,J,$e){return this.s(q,se,ve=>ve.provideCompletionItems(v.URI.revive(W),Q,J,$e),void 0,$e)}$resolveCompletionItem(q,W,Q){return this.s(q,se,J=>J.resolveCompletionItem(W,Q),void 0,Q)}$releaseCompletionItems(q,W){this.s(q,se,Q=>Q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(q,W,Q,J){const $e=new B(q,this.h,Q,this.j.converter),ve=this.t($e,q);return this.e.$registerInlineCompletionsSupport(ve,this.o(W,q),$e.supportsHandleEvents,i.$Am.toKey(q.identifier.value),J?.yieldTo?.map(Te=>i.$Am.toKey(Te))||[]),this.p(ve)}$provideInlineCompletions(q,W,Q,J,$e){return this.s(q,re,ve=>ve.provideInlineCompletions(v.URI.revive(W),Q,J,$e),void 0,$e)}$handleInlineCompletionDidShow(q,W,Q,J){this.s(q,re,async $e=>{$e.handleDidShowCompletionItem(W,Q,J)},void 0,void 0)}$handleInlineCompletionPartialAccept(q,W,Q,J){this.s(q,re,async $e=>{$e.handlePartialAccept(W,Q,J)},void 0,void 0)}$freeInlineCompletionsList(q,W){this.s(q,re,async Q=>{Q.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(q,W,Q){const J=new ie(q,this.h,Q,this.j.converter),$e=this.t(J,q);return this.e.$registerInlineEditProvider($e,this.o(W,q),q.identifier),this.p($e)}$provideInlineEdit(q,W,Q,J){return this.s(q,ie,$e=>$e.provideInlineEdits(v.URI.revive(W),Q,J),void 0,J)}$freeInlineEdit(q,W){this.s(q,ie,async Q=>{Q.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(q,W,Q,J){const $e=Array.isArray(J)?{triggerCharacters:J,retriggerCharacters:[]}:J,ve=this.t(new le(this.h,Q),q);return this.e.$registerSignatureHelpProvider(ve,this.o(W,q),$e),this.p(ve)}$provideSignatureHelp(q,W,Q,J,$e){return this.s(q,le,ve=>ve.provideSignatureHelp(v.URI.revive(W),Q,J,$e),void 0,$e)}$releaseSignatureHelp(q,W){this.s(q,le,Q=>Q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(q,W,Q){const J=typeof Q.onDidChangeInlayHints=="function"?this.q():void 0,$e=this.t(new ue(this.h,this.j.converter,Q,this.l,q),q);this.e.$registerInlayHintsProvider($e,this.o(W,q),typeof Q.resolveInlayHint=="function",J,Oe.u(q));let ve=this.p($e);if(J!==void 0){const Te=Q.onDidChangeInlayHints(He=>this.e.$emitInlayHintsEvent(J));ve=r.$_L.from(ve,Te)}return ve}$provideInlayHints(q,W,Q,J){return this.s(q,ue,$e=>$e.provideInlayHints(v.URI.revive(W),Q,J),void 0,J)}$resolveInlayHint(q,W,Q){return this.s(q,ue,J=>J.resolveInlayHint(W,Q),void 0,Q)}$releaseInlayHints(q,W){this.s(q,ue,Q=>Q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(q,W,Q){const J=this.t(new ce(this.h,Q),q);return this.e.$registerDocumentLinkProvider(J,this.o(W,q),typeof Q.resolveDocumentLink=="function"),this.p(J)}$provideDocumentLinks(q,W,Q){return this.s(q,ce,J=>J.provideLinks(v.URI.revive(W),Q),void 0,Q,W.scheme==="output")}$resolveDocumentLink(q,W,Q){return this.s(q,ce,J=>J.resolveLink(W,Q),void 0,void 0,!0)}$releaseDocumentLinks(q,W){this.s(q,ce,Q=>Q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(q,W,Q){const J=this.t(new de(this.h,Q),q);return this.e.$registerDocumentColorProvider(J,this.o(W,q)),this.p(J)}$provideDocumentColors(q,W,Q){return this.s(q,de,J=>J.provideColors(v.URI.revive(W),Q),[],Q)}$provideColorPresentations(q,W,Q,J){return this.s(q,de,$e=>$e.provideColorPresentations(v.URI.revive(W),Q,J),void 0,J)}registerFoldingRangeProvider(q,W,Q){const J=this.q(),$e=typeof Q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(J,new Ae(new H(this.h,Q),q)),this.e.$registerFoldingRangeProvider(J,this.o(W,q),q.identifier,$e);let ve=this.p(J);if($e!==void 0){const Te=Q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent($e));ve=r.$_L.from(ve,Te)}return ve}$provideFoldingRanges(q,W,Q,J){return this.s(q,H,$e=>$e.provideFoldingRanges(v.URI.revive(W),Q,J),void 0,J)}registerSelectionRangeProvider(q,W,Q){const J=this.t(new Y(this.h,Q,this.l),q);return this.e.$registerSelectionRangeProvider(J,this.o(W,q)),this.p(J)}$provideSelectionRanges(q,W,Q,J){return this.s(q,Y,$e=>$e.provideSelectionRanges(v.URI.revive(W),Q,J),[],J)}registerCallHierarchyProvider(q,W,Q){const J=this.t(new he(this.h,Q),q);return this.e.$registerCallHierarchyProvider(J,this.o(W,q)),this.p(J)}$prepareCallHierarchy(q,W,Q,J){return this.s(q,he,$e=>Promise.resolve($e.prepareSession(v.URI.revive(W),Q,J)),void 0,J)}$provideCallHierarchyIncomingCalls(q,W,Q,J){return this.s(q,he,$e=>$e.provideCallsTo(W,Q,J),void 0,J)}$provideCallHierarchyOutgoingCalls(q,W,Q,J){return this.s(q,he,$e=>$e.provideCallsFrom(W,Q,J),void 0,J)}$releaseCallHierarchy(q,W){this.s(q,he,Q=>Promise.resolve(Q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(q,W,Q){const J=this.t(new be(this.h,Q),q);return this.e.$registerTypeHierarchyProvider(J,this.o(W,q)),this.p(J)}$prepareTypeHierarchy(q,W,Q,J){return this.s(q,be,$e=>Promise.resolve($e.prepareSession(v.URI.revive(W),Q,J)),void 0,J)}$provideTypeHierarchySupertypes(q,W,Q,J){return this.s(q,be,$e=>$e.provideSupertypes(W,Q,J),void 0,J)}$provideTypeHierarchySubtypes(q,W,Q,J){return this.s(q,be,$e=>$e.provideSubtypes(W,Q,J),void 0,J)}$releaseTypeHierarchy(q,W){this.s(q,be,Q=>Promise.resolve(Q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(q,W,Q,J){const $e=this.q();this.f.set($e,new Ae(new Pe(this.e,this.h,Q,$e,q),q));const ve=(0,c.$ZF)(q,"dropMetadata")&&J?Pe.toInternalProviderId(q.identifier.value,J.id):void 0;return this.e.$registerDocumentOnDropEditProvider($e,this.o(W,q),ve,(0,c.$ZF)(q,"dropMetadata")?J:void 0),this.p($e)}$provideDocumentOnDropEdits(q,W,Q,J,$e,ve){return this.s(q,Pe,Te=>Promise.resolve(Te.provideDocumentOnDropEdits(W,v.URI.revive(Q),J,$e,ve)),void 0,void 0)}registerMappedEditsProvider(q,W,Q){const J=this.t(new we(this.h,Q),q);return this.e.$registerMappedEditsProvider(J,this.o(W,q)),this.p(J)}$provideMappedEdits(q,W,Q,J,$e){return this.s(q,we,ve=>Promise.resolve(ve.provideMappedEdits(W,Q,J,$e)),null,$e)}registerDocumentPasteEditProvider(q,W,Q,J){const $e=this.q();this.f.set($e,new Ae(new O(this.e,this.h,Q,$e,q),q));const ve=O.toInternalProviderId(q.identifier.value,J.id);return this.e.$registerPasteEditProvider($e,this.o(W,q),ve,{supportsCopy:!!Q.prepareDocumentPaste,supportsPaste:!!Q.provideDocumentPasteEdits,copyMimeTypes:J.copyMimeTypes,pasteMimeTypes:J.pasteMimeTypes}),this.p($e)}$prepareDocumentPaste(q,W,Q,J,$e){return this.s(q,O,ve=>ve.prepareDocumentPaste(v.URI.revive(W),Q,J,$e),void 0,$e)}$providePasteEdits(q,W,Q,J,$e,ve){return this.s(q,O,Te=>Te.providePasteEdits(W,v.URI.revive(Q),J,$e,ve),void 0,ve)}static w(q){return{pattern:q.source,flags:q.flags}}static y(q){return{decreaseIndentPattern:Oe.w(q.decreaseIndentPattern),increaseIndentPattern:Oe.w(q.increaseIndentPattern),indentNextLinePattern:q.indentNextLinePattern?Oe.w(q.indentNextLinePattern):void 0,unIndentedLinePattern:q.unIndentedLinePattern?Oe.w(q.unIndentedLinePattern):void 0}}static z(q){return{beforeText:Oe.w(q.beforeText),afterText:q.afterText?Oe.w(q.afterText):void 0,previousLineText:q.previousLineText?Oe.w(q.previousLineText):void 0,action:q.action}}static B(q){return q.map(Oe.z)}static C(q){return{open:q.open,close:q.close,notIn:q.notIn?q.notIn.map(W=>r.SyntaxTokenType.toString(W)):void 0}}static D(q){return q.map(Oe.C)}setLanguageConfiguration(q,W,Q){const{wordPattern:J}=Q;if(J&&(0,M.$9e)(J))throw new Error(`Invalid language configuration: wordPattern '${J}' is not allowed to match the empty string.`);J?this.h.setWordDefinitionFor(W,J):this.h.setWordDefinitionFor(W,void 0),Q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",q,"Do not use."),Q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",q,"Do not use.");const $e=this.q(),ve={comments:Q.comments,brackets:Q.brackets,wordPattern:Q.wordPattern?Oe.w(Q.wordPattern):void 0,indentationRules:Q.indentationRules?Oe.y(Q.indentationRules):void 0,onEnterRules:Q.onEnterRules?Oe.B(Q.onEnterRules):void 0,__electricCharacterSupport:Q.__electricCharacterSupport,__characterPairSupport:Q.__characterPairSupport,autoClosingPairs:Q.autoClosingPairs?Oe.D(Q.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration($e,W,ve),this.p($e)}$setWordDefinitions(q){for(const W of q)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$$hc=Oe}),define(Se[121],De([1,0,3,6,16,7,108,25,8,4,219,145,13,5,20,120,12]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$gic=e.$fic=void 0,e.$fic=(0,S.$gi)("IExtHostLanguageModels");class i{constructor(t,f){this.option=t,this.stream=new p.$Jh,this.stream=f??new p.$Jh}}class n{constructor(){this.a=new Map,this.b=new p.$Jh,this.c=!1,this.d=!1;const t=this;this.apiObject={stream:t.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,t]of this.a)yield t.stream;else yield this.b}handleFragment(t){if(this.c)return;this.d=!0;let f=this.a.get(t.index);f||(this.a.size===0?f=new i(t.index,this.b):f=new i(t.index),this.a.set(t.index,f)),f.stream.emitOne(t.part)}get isStreaming(){return this.d}reject(t){this.c=!0;for(const f of this.f())f.reject(t)}resolve(){this.c=!0;for(const t of this.f())t.resolve()}}let r=class{static{o=this}static{this.a=1}constructor(t,f,h){this.j=f,this.k=h,this.c=new E.$6d,this.d=new E.$6d,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new w.$Cm,this.i=new Map,this.o=new Set,this.b=t.getProxy(N.$0L.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(t,f,h,s){const a=o.a++;this.f.set(a,{extension:t.identifier,provider:h,languageModelId:f});let d;return s.auth&&(d={providerLabel:t.displayName||t.name,accountLabel:typeof s.auth=="object"?s.auth.label:void 0}),this.b.$registerLanguageModelProvider(a,f,{extension:t.identifier,identifier:f,model:s.name??"",auth:d}),(0,l.$Rc)(()=>{this.f.delete(a),this.b.$unregisterProvider(a)})}async $provideLanguageModelResponse(t,f,h,s,a,d){const $=this.f.get(t);if(!$)return;const D=new R.$Lv(async b=>{if(d.isCancellationRequested){this.j.warn(`[CHAT](${$.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:b.index,part:b.part})});return $.provider.provideLanguageModelResponse2(s.map(L.LanguageModelMessage.to),a,w.$Am.toKey(h),D,d)}$updateLanguageModels(t){const f=[],h=[];if(t.added)for(const s of t.added)this.g.set(s.identifier,s),f.push(s.model);if(t.removed)for(const s of t.removed){this.g.delete(s),h.push(s);for(const[a,d]of this.i)d.languageModelId===s&&(d.res.reject(new v.$5),this.i.delete(a))}this.d.fire(Object.freeze({added:Object.freeze(f),removed:Object.freeze(h)})),t.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist(t){const f=new Array;for(const{from:h,to:s,enabled:a}of t){const d=this.h.get(h)??new w.$Bm;if(d.has(s)!==a){a?d.add(s):d.delete(s),this.h.set(h,d);const D={from:h,to:s};f.push(D),this.c.fire(D)}}}async sendChatRequest(t,f,h,s,a){const d=t.identifier,$=await this.b.$prepareChatAccess(d,f,s.justification);if(!$||!this.g.has(f))throw A.$dO.NotFound(`Language model '${f}' is unknown.`);if(this.m(d,$)&&(!await this.l(t,{identifier:$.extension,displayName:$.auth.providerLabel},s.justification,s.silent)||!this.h.get(d)?.has($.extension)))throw A.$dO.NoPermissions(`Language model '${f}' cannot be used by '${d.value}'.`);const D=Math.random()*1e6|0,b=this.b.$fetchResponse(d,f,D,h.map(L.LanguageModelMessage.from),s.modelOptions??{},a),g=new p.$fh,k=new n;this.i.set(D,{languageModelId:f,res:k});let P;if(b.catch(F=>{g.isOpen()?k.reject(F):P=F}).finally(()=>{this.i.delete(D),k.resolve(),g.open()}),await g.wait(),P)throw new A.$dO(`Language model '${f}' errored, check cause for more details`,"Unknown",P);return k.apiObject}async $handleResponseFragment(t,f){const h=this.i.get(t);h&&h.res.handleFragment(f)}async l(t,f,h,s){const a=C.$cL+f.identifier.value;if(await this.k.getSession(t,a,[],{silent:!0}))return this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0;if(s)return!1;try{const $=h?(0,M.localize)(0,null,f.displayName,h):(0,M.localize)(1,null,f.displayName);return await this.k.getSession(t,a,[],{forceNewSession:{detail:$}}),this.$updateModelAccesslist([{from:t.identifier,to:f.identifier,enabled:!0}]),!0}catch{return!1}}m(t,f){return!!f.auth&&!w.$Am.equals(f.extension,t)}async n(t){for(const f of this.o)try{await this.l(f,{identifier:t.extension,displayName:""},void 0,!0)}catch(h){this.j.error("Fake Auth request failed"),this.j.error(h)}}createLanguageModelAccessInformation(t){this.o.add(t);const f=this,h=E.Event.signal(E.Event.filter(this.c.event,a=>w.$Am.equals(a.from,t.identifier))),s=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(h,s)},canSendRequest(a){const d=f.g.get(a);if(!d)return;if(!f.m(t.identifier,d))return!0;const $=f.h.get(t.identifier);if($)return $.has(d.extension)}}}};e.$gic=r,e.$gic=r=o=Qe([Ve(0,y.$pO),Ve(1,m.$Aj),Ve(2,u.$aic)],r)}),define(Se[334],De([1,0,6,16,7,39,8,3,26]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class E{constructor(C,v,S,y){this.c=v,this.d=S,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(l.$0L.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,v){await this.a.$changeLanguage(C,v);const S=this.c.getDocumentData(C);if(!S)throw new Error(`document '${C.toString()}' NOT found`);return S.document}async tokenAtPosition(C,v){const S=C.version,y=N.Position.from(v),u=await this.a.$tokensAtPosition(C.uri,y),m={type:L.StandardTokenType.Other,range:C.getWordRangeAtPosition(v)??new L.$bM(v.line,v.character,v.line,v.character)};if(!u)return m;const o={range:N.Range.to(u.range),type:N.TokenType.to(u.type)};return!o.range.contains(v)||S!==C.version?m:o}createLanguageStatusItem(C,v,S){const y=this.f++,u=this.a,m=this.g,o=`${C.identifier.value}/${v}`;if(m.has(o))throw new Error(`LanguageStatusItem with id '${v}' ALREADY exists`);m.add(o);const i={selector:S,id:v,name:C.displayName??C.name,severity:L.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const r=new w.$Sc,c=()=>{if(n?.dispose(),!m.has(o)){console.warn(`LanguageStatusItem (${v}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,R.$ih)(()=>{r.clear(),this.a.$setLanguageStatus(y,{id:o,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===L.LanguageStatusSeverity.Error?A.default.Error:i.severity===L.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info,command:i.command&&this.d.toInternal(i.command,r),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){r.dispose(),n?.dispose(),u.$removeLanguageStatus(y),m.delete(o)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,c()},get selector(){return i.selector},set selector(f){i.selector=f,c()},get text(){return i.text},set text(f){i.text=f,c()},set text2(f){(0,p.$1F)(C,"languageStatusText"),i.text=f,c()},get text2(){return(0,p.$1F)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,c()},get severity(){return i.severity},set severity(f){i.severity=f,c()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,c()},get command(){return i.command},set command(f){i.command=f,c()},get busy(){return i.busy},set busy(f){i.busy=f,c()}};return c(),t}}e.$zjc=E}),define(Se[335],De([1,0,15,2,16,7,119]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=e.$kjc=void 0;class w{constructor(C,v,S,y){this.start=C,this.deletedCount=v,this.deletedItems=S,this.items=y}asApiEvent(){return{range:new A.$zN(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(C){return{EOL:C.eol,lines:C.source,languageId:C.language,uri:C.uri,isDirty:!1,versionId:1}}constructor(C,v,S){this.notebook=C,this.h=v,this.j=S,this.handle=S.handle,this.uri=N.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(L.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(L.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:L.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return C.g},set mime(y){C.g=y},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(S)}return this.f}setOutputs(C){this.a=C.map(L.NotebookCellOutput.to)}setOutputItems(C,v,S){const y=S.map(L.NotebookCellOutputItem.to),u=this.a.find(m=>m.id===C);if(u&&(v||(u.items.length=0),u.items.push(...y),u.items.length>1&&u.items.every(m=>R.$9J(m.mime)))){const m=new Map,o=[];u.items.forEach(i=>{let n;m.has(i.mime)?n=m.get(i.mime):(n=[],m.set(i.mime,n),o.push(i.mime)),n.push(i.data)}),u.items.length=0,o.forEach(i=>{const n=R.$0J(m.get(i));u.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(L.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$kjc=p;class E{static{this.a=0}constructor(C,v,S,y,u){this.k=C,this.l=v,this.m=S,this.uri=y,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=u.viewType,this.f=Object.freeze(u.metadata??Object.create(null)),this.r([[0,0,u.cells]],!0,void 0),this.g=u.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,v={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===l.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(S){return S=C.n(S),C.b[S].apiCell},getCells(S){return(S?C.p(S):C.b).map(u=>u.apiCell)},save(){return C.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,v,S){this.g=C.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:S});const y={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},u=[];for(const o of C.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,y.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,y.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),u.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?u.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),u.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),u.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const m=new Map;for(let o=0;o<u.length;o++){const i=u[o],n=m.get(i.cell);if(n===void 0){const r=y.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});m.set(i.cell,r-1)}else y.cellChanges[n]={...y.cellChanges[n],...i}}return Object.freeze(y),Object.freeze(y.cellChanges),Object.freeze(y.contentChanges),y}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let v=C.start|0,S=C.end|0;return v<0&&(v=0),S>this.b.length&&(S=this.b.length),C.with({start:v,end:S})}p(C){C=this.o(C);const v=[];for(let S=C.start;S<C.end;S++)v.push(this.b[S]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,v,S){if(this.j)return;const y=[],u=[],m=[];if(C.reverse().forEach(o=>{const n=o[2].map(t=>{const f=new p(this,this.l,t);return v||u.push(p.asModelAddData(t)),f}),r=new w(o[0],o[1],[],n),c=this.b.splice(o[0],o[1],...n);for(const t of c)m.push(t.uri),r.deletedItems.push(t.apiCell);y.push(r)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:u,removedDocuments:m}),S)for(const o of y)S.push(o.asApiEvent())}s(C,v,S,y){const u=this.b.splice(C,v);this.b.splice(S,0,...u);const m=[new w(C,v,u.map(o=>o.apiCell),[]),new w(S,0,[],u)];for(const o of m)y.push(o.asApiEvent())}t(C,v){this.b[C].setOutputs(v)}u(C,v,S,y){this.b[C].setOutputItems(v,S,y)}v(C,v){const S=this.b[C];S.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(S.uri,v)}w(C,v){const S=this.b[C];S.apiCell.mime=v}x(C,v){this.b[C].setMetadata(v)}y(C,v){this.b[C].setInternalMetadata(v)}getCellFromApiCell(C){return this.b.find(v=>v.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){if(N.URI.isUri(C)){const v=R.CellUri.parse(C);if(!v||v.notebook.toString()!==this.uri.toString())return;C=v.handle}return this.b.find(v=>v.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$ljc=E}),define(Se[336],De([1,0,4,2,16,7]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bjc=void 0;class R{constructor(p,E,M,C={timeout:1500,errors:3}){this.b=p,this.c=E,this.d=M,this.f=C,this.a=new l.$8d}dispose(){}getOnWillSaveNotebookDocumentEvent(p){return(E,M,C)=>{const v=function(y){E.call(M,y)};return v.extension=p,this.a.event(v,void 0,C)}}async $participateInSave(p,E,M){const C=N.URI.revive(p),v=this.c.getNotebookDocument(C);if(!v)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:v.apiNotebook,reason:L.TextDocumentSaveReason.to(E)},M,async(u,m)=>{const o=Date.now(),i=await await Promise.resolve(u);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier),!M.isCancellationRequested&&i&&(i instanceof A.$jM?S.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",m.extension.identifier,"ignored due to invalid data"))}),M.isCancellationRequested)return!1;if(S.length===0)return!0;const y={edits:[]};for(const u of S){const{edits:m}=L.WorkspaceEdit.from(u);y.edits=y.edits.concat(m)}return this.d.$tryApplyWorkspaceEdit(y)}}e.$Bjc=R}),define(Se[153],De([1,0,13,16,7]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;class A{static{this.apiEditorsToExtHost=new WeakMap}constructor(w,p,E,M,C,v){this.id=w,this.f=p,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=M,this.c=v}get apiEditor(){if(!this.e){const w=this;this.e={get notebook(){return w.notebookData.apiNotebook},get selection(){return w.a[0]},set selection(p){this.selections=[p]},get selections(){return w.a},set selections(p){if(!Array.isArray(p)||!p.every(L.$zN.isNotebookRange))throw(0,l.$7)("selections");w.a=p,w.g(p)},get visibleRanges(){return w.b},revealRange(p,E){w.f.$tryRevealRange(w.id,N.NotebookRange.from(p),E??L.NotebookEditorRevealType.Default)},get viewColumn(){return w.c}},A.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(w){this.d=w}_acceptVisibleRanges(w){this.b=w}_acceptSelections(w){this.a=w}g(w){this.f.$trySetSelections(this.id,w.map(N.NotebookRange.from))}_acceptViewColumn(w){this.c=w}}e.$mjc=A}),define(Se[337],De([1,0,4,12,16]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djc=void 0;let A=class{constructor(w,p){this.c=w,this.d=p,this.a=new l.$6d,this.b=new l.$6d,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(w,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",w,p);const E=this.d.getEditorById(w);p.visibleRanges&&E._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&E._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(w){for(const p in w)this.d.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(w[p]))}};e.$Djc=A,e.$Djc=A=Qe([Ve(0,N.$Aj)],A)}),define(Se[338],De([1,0,4,6,153]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gjc=void 0;class A{constructor(w,p){this.c=p,this.a=new Map,this.b=w.getProxy(N.$0L.MainThreadNotebookRenderers)}$postRendererMessage(w,p,E){const M=this.c.getEditorById(w);this.a.get(p)?.fire({editor:M.apiEditor,message:E})}createRendererMessaging(w,p){if(!w.contributes?.notebookRenderer?.some(M=>M.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(M,C,v)=>this.d(p).event(M,C,v),postMessage:(M,C)=>{L.$mjc.apiEditorsToExtHost.has(M)&&([M,C]=[C,M]);const v=C&&L.$mjc.apiEditorsToExtHost.get(C);return this.b.$postMessage(v?.id,p,M)}}}d(w){let p=this.a.get(w);return p||(p=new l.$6d({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(w)}}),this.a.set(w,p),p)}}e.$Gjc=A}),define(Se[339],De([1,0,16,108,22,53,13]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kjc=void 0;class w{constructor(C){this.b=0,this.c=new Map,this.a=C}async withProgress(C,v,S){const y=this.b++,{title:u,location:m,cancellable:o}=v,i={label:C.displayName||C.name,id:C.identifier.value};return this.a.$startProgress(y,{location:l.ProgressLocation.from(m),title:u,source:i,cancellable:o},C.isUnderDevelopment?void 0:C.identifier.value).catch(R.$2),this.d(y,S,!!o)}d(C,v,S){let y;S&&(y=new L.$de,this.c.set(C,y));const u=o=>{this.a.$progressEnd(o),this.c.delete(o),y?.dispose()};let m;try{m=v(new E(this.a,C),S&&y?y.token:L.CancellationToken.None)}catch(o){throw u(C),o}return m.then(o=>u(C),o=>u(C)),m}$acceptProgressCanceled(C){const v=this.c.get(C);v&&(v.cancel(),this.c.delete(C))}}e.$Kjc=w;function p(M,C){return M.message=C.message,typeof C.increment=="number"&&(typeof M.increment=="number"?M.increment+=C.increment:M.increment=C.increment),M}class E extends N.$Lv{constructor(C,v){super(S=>this.throttledReport(S)),this.c=C,this.d=v}throttledReport(C){this.c.$progressReport(this.d,C)}}Qe([(0,A.$Mh)(100,(M,C)=>p(M,C),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Se[340],De([1,0,2,6,8,16]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ljc=void 0;class R{static{this.a=0}constructor(p,E){this.d=E,this.c=new Map,this.b=p.getProxy(N.$0L.MainThreadQuickDiff)}$provideOriginalResource(p,E,M){const C=l.URI.revive(E),v=this.c.get(p);return v?(0,L.$$g)(()=>v.provideOriginalResource(C,M)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,E,M,C){const v=R.a++;return this.c.set(v,E),this.b.$registerQuickDiffProvider(v,A.DocumentSelector.from(p,this.d),M,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}e.$Ljc=R}),define(Se[341],De([1,0,22,4,3,6,2,7,13,19,39,55,26,16]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mjc=void 0;function y(u,m,o){const i=u.getProxy(A.$0L.MainThreadQuickOpen);class n{constructor($,D){this.e=new Map,this.f=0,this.a=$,this.b=D}showQuickPick($,D,b,g=l.CancellationToken.None){this.c=void 0;const k=Promise.resolve(D),P=++this.f,F=i.$show(P,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},g),U={},z=F.then(()=>U);return Promise.race([z,k]).then(T=>{if(T===U)return;const I=(0,v.$ZF)($,"quickPickItemTooltip");return k.then(O=>{const j=[];for(let G=0;G<O.length;G++){const te=O[G];if(typeof te=="string")j.push({label:te,handle:G});else if(te.kind===w.QuickPickItemKind.Separator)j.push({type:"separator",label:te.label});else{te.tooltip&&!I&&console.warn(`Extension '${$.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${$.identifier.value}`);const x=te.iconPath?h(te.iconPath):void 0;j.push({label:te.label,iconPath:x?.iconPath,iconClass:x?.iconClass,description:te.description,detail:te.detail,picked:te.picked,alwaysShow:te.alwaysShow,tooltip:I?S.MarkdownString.fromStrict(te.tooltip):void 0,handle:G})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=G=>{b.onDidSelectItem(O[G])}),i.$setItems(P,j),F.then(G=>{if(typeof G=="number")return O[G];if(Array.isArray(G))return G.map(te=>O[te])})})}).then(void 0,T=>{if(!(0,p.$4)(T))return i.$setError(P,T),Promise.reject(T)})}$onItemSelected($){this.c?.($)}showInput($,D=l.CancellationToken.None){return this.d=$?.validateInput,i.$input($,typeof this.d=="function",D).then(void 0,b=>{if(!(0,p.$4)(b))return Promise.reject(b)})}async $validateInput($){if(!this.d)return;const D=await this.d($);if(!D||typeof D=="string")return D;let b;switch(D.severity){case w.InputBoxValidationSeverity.Info:b=M.default.Info;break;case w.InputBoxValidationSeverity.Warning:b=M.default.Warning;break;case w.InputBoxValidationSeverity.Error:b=M.default.Error;break;default:b=D.message?M.default.Error:M.default.Ignore;break}return{content:D.message,severity:b}}async showWorkspaceFolderPick($,D=l.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[$]);if(!b)return;const g=await this.a.getWorkspaceFolders2();if(g)return g.find(k=>k.uri.toString()===b.uri.toString())}createQuickPick($){const D=new s($,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox($){const D=new a($,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue($,D){this.e.get($)?._fireDidChangeValue(D)}$onDidAccept($){this.e.get($)?._fireDidAccept()}$onDidChangeActive($,D){const b=this.e.get($);b instanceof s&&b._fireDidChangeActive(D)}$onDidChangeSelection($,D){const b=this.e.get($);b instanceof s&&b._fireDidChangeSelection(D)}$onDidTriggerButton($,D){this.e.get($)?._fireDidTriggerButton(D)}$onDidTriggerItemButton($,D,b){const g=this.e.get($);g instanceof s&&g._fireDidTriggerItemButton(D,b)}$onDidHide($){this.e.get($)?._fireDidHide()}}class r{static{this.a=1}constructor($,D){this.x=$,this.y=D,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$6d,this.q=new N.$6d,this.r=new N.$6d,this.s=new N.$6d,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title($){this.b=$,this.z({title:$})}get step(){return this.c}set step($){this.c=$,this.z({step:$})}get totalSteps(){return this.d}set totalSteps($){this.d=$,this.z({totalSteps:$})}get enabled(){return this.g}set enabled($){this.g=$,this.z({enabled:$})}get busy(){return this.j}set busy($){this.j=$,this.z({busy:$})}get ignoreFocusOut(){return this.k}set ignoreFocusOut($){this.k=$,this.z({ignoreFocusOut:$})}get value(){return this.l}set value($){this.l=$,this.z({value:$})}get placeholder(){return this.m}set placeholder($){this.m=$,this.z({placeholder:$})}get buttons(){return this.n}set buttons($){this.n=$.slice(),this.o.clear(),$.forEach((D,b)=>{const g=D===w.$wN.Back?-1:b;this.o.set(g,D)}),this.z({buttons:$.map((D,b)=>({...h(D.iconPath),tooltip:D.tooltip,handle:D===w.$wN.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue($){this.l=$,this.q.fire($)}_fireDidTriggerButton($){const D=this.o.get($);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,L.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z($){if(!this.v){for(const D of Object.keys($)){const b=$[D];this.u[D]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function c(d){if(d instanceof w.$7M)return{id:d.id};const $=f(d),D=t(d);return{dark:typeof $=="string"?R.URI.file($):$,light:typeof D=="string"?R.URI.file(D):D}}function t(d){return typeof d=="object"&&"light"in d?d.light:d}function f(d){return typeof d=="object"&&"dark"in d?d.dark:d}function h(d){const $=c(d);let D,b;return"id"in $?b=C.ThemeIcon.asClassName($):D=$,{iconPath:D,iconClass:b}}class s extends r{constructor($,D){super($.identifier,D),this.O=$,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$6d,this.L=[],this.M=new N.$6d,this.N=new N.$6d,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items($){this.B=$.slice(),this.C.clear(),this.D.clear(),$.forEach((g,k)=>{this.C.set(k,g),this.D.set(g,k)});const D=(0,v.$ZF)(this.O,"quickPickItemTooltip"),b=[];for(let g=0;g<$.length;g++){const k=$[g];if(k.kind===w.QuickPickItemKind.Separator)b.push({type:"separator",label:k.label});else{k.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=k.iconPath?h(k.iconPath):void 0;b.push({handle:g,label:k.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:D?S.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((F,U)=>({...h(F.iconPath),tooltip:F.tooltip,handle:U}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany($){this.E=$,this.z({canSelectMany:$})}get matchOnDescription(){return this.F}set matchOnDescription($){this.F=$,this.z({matchOnDescription:$})}get matchOnDetail(){return this.G}set matchOnDetail($){this.G=$,this.z({matchOnDetail:$})}get sortByLabel(){return this.H}set sortByLabel($){this.H=$,this.z({sortByLabel:$})}get keepScrollPosition(){return this.I}set keepScrollPosition($){this.I=$,this.z({keepScrollPosition:$})}get activeItems(){return this.J}set activeItems($){this.J=$.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems($){this.L=$.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive($){const D=(0,E.$Hb)($.map(b=>this.C.get(b)));this.J=D,this.K.fire(D)}_fireDidChangeSelection($){const D=(0,E.$Hb)($.map(b=>this.C.get(b)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton($,D){const b=this.C.get($);if(!b||!b.buttons||!b.buttons.length)return;const g=b.buttons[D];g&&this.N.fire({button:g,item:b})}}class a extends r{constructor($,D){super($.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password($){this.B=$,this.z({password:$})}get prompt(){return this.C}set prompt($){this.C=$,this.z({prompt:$})}get valueSelection(){return this.D}set valueSelection($){this.D=$,this.z({valueSelection:$})}get validationMessage(){return this.E}set validationMessage($){this.E=$,$?typeof $=="string"?this.z({validationMessage:$,severity:M.default.Error}):this.z({validationMessage:$.message,severity:$.severity??M.default.Error}):this.z({validationMessage:void 0,severity:M.default.Ignore})}}return new n(m,o)}e.$Mjc=y}),define(Se[342],De([1,0,2,4,53,3,8,6,19,131,12,25,55,16,26,15,11]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ojc=e.$Njc=void 0;function i(P){return P instanceof l.URI}function n(P,F){return P.scheme===u.Schemas.file&&F.scheme===u.Schemas.file&&m.$k?P.toString()===F.toString():P.toString().toLowerCase()===F.toString().toLowerCase()}function r(P){if(P)return typeof P.iconPath=="string"?l.URI.file(P.iconPath):l.URI.isUri(P.iconPath)||v.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function c(P){if(P.icon){if(l.URI.isUri(P.icon))return P.icon;if(v.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const F=P.icon;return{light:F.light,dark:F.dark}}}else return}function t(P,F){if(!P.iconPath&&!F.iconPath)return 0;if(P.iconPath){if(!F.iconPath)return 1}else return-1;const U=typeof P.iconPath=="string"?P.iconPath:l.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,z=typeof F.iconPath=="string"?F.iconPath:l.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,E.$8q)(U,z)}function f(P,F){let U=0;if(P.strikeThrough!==F.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==F.faded)return P.faded?1:-1;if(P.tooltip!==F.tooltip)return(P.tooltip||"").localeCompare(F.tooltip||"");if(U=t(P,F),U!==0)return U;if(P.light&&F.light)U=t(P.light,F.light);else{if(P.light)return 1;if(F.light)return-1}if(U!==0)return U;if(P.dark&&F.dark)U=t(P.dark,F.dark);else{if(P.dark)return 1;if(F.dark)return-1}return U}function h(P,F){if(P.command!==F.command)return P.command<F.command?-1:1;if(P.title!==F.title)return P.title<F.title?-1:1;if(P.tooltip!==F.tooltip){if(P.tooltip!==void 0&&F.tooltip!==void 0)return P.tooltip<F.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(P.arguments===F.arguments)return 0;if(P.arguments)if(F.arguments){if(P.arguments.length!==F.arguments.length)return P.arguments.length-F.arguments.length}else return 1;else return-1;for(let U=0;U<P.arguments.length;U++){const z=P.arguments[U],T=F.arguments[U];if(z!==T&&!(i(z)&&i(T)&&n(z,T)))return z<T?-1:1}return 0}function s(P,F){let U=(0,E.$8q)(P.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(U!==0)return U;if(P.command&&F.command)U=h(P.command,F.command);else{if(P.command)return 1;if(F.command)return-1}if(U!==0)return U;if(P.decorations&&F.decorations)U=f(P.decorations,F.decorations);else{if(P.decorations)return 1;if(F.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)U=(0,E.$8q)(P.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)U=(0,E.$8q)(P.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return U}function a(P,F){for(let U=0;U<P.length;U++)if(P[U]!==F[U])return!1;return!0}function d(P,F){return P.command===F.command&&P.title===F.title&&P.tooltip===F.tooltip&&(P.arguments&&F.arguments?a(P.arguments,F.arguments):P.arguments===F.arguments)}function $(P,F){return(0,p.$ub)(P,F,d)}class D{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.l,F),this.n(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.l,F),this.f=F}get validateInput(){return(0,y.$1F)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,y.$1F)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.l,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.l,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.l,F))}get document(){return(0,y.$1F)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(F,U,z,T,I){this.k=F,this.l=T,this.m=I,this.d="",this.e=new N.$6d,this.f="",this.h=!0,this.j=!0,this.#t=U,this.#e=z}showValidationMessage(F,U){(0,y.$1F)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,F,U)}$onInputBoxValueChange(F){this.n(F)}n(F){this.d=F,this.e.fire(F)}}e.$Njc=D;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,U,z,T,I,O,j){this.q=F,this.s=U,this.t=z,this.u=T,this.v=I,this.multiDiffEditorEnableViewChanges=O,this.w=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$6d,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$6d,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,U){const z=this.h.get(F);return z?(0,R.$$g)(()=>this.s.executeCommand(z.command,...z.arguments||[],U)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(s),z=(0,p.$Db)(this.o,F,s).map(O=>{const j=O.toInsert.map(G=>{const te=this.e++;this.g.set(te,G);const x=G.resourceUri;let Z;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"||G.command.command==="vscode.changes"){const de=new A.$Sc;Z=this.s.converter.toInternal(G.command,de),this.j.set(te,de)}else this.h.set(te,G.command);const X=(0,y.$ZF)(this.w,"scmMultiDiffEditor"),ae=X?G.multiDiffEditorOriginalUri:void 0,_=X?G.multiFileDiffEditorModifiedUri:void 0,ge=r(G.decorations),se=G.decorations&&r(G.decorations.light)||ge,re=G.decorations&&r(G.decorations.dark)||ge,B=[se,re],ie=G.decorations&&G.decorations.tooltip||"",ke=G.decorations&&!!G.decorations.strikeThrough,le=G.decorations&&!!G.decorations.faded,ue=G.contextValue||"";return{rawResource:[te,x,B,ie,ke,le,ue,Z,ae,_],handle:te}});return{start:O.start,deleteCount:O.deleteCount,toInsert:j}}),T=z.map(({start:O,deleteCount:j,toInsert:G})=>[O,j,G.map(te=>te.rawResource)]),I=z.reverse();for(const{start:O,deleteCount:j,toInsert:G}of I){const te=G.map(Z=>Z.handle),x=this.n.splice(O,j,...te);for(const Z of x)this.g.delete(Z),this.h.delete(Z),this.j.get(Z)?.dispose(),this.j.delete(Z)}return this.o=F,T}dispose(){this.l=!0,this.m.fire()}}class g{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.w,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let U;(0,y.$ZF)(this.x,"quickDiffProvider")&&(U=F?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!F,quickDiffLabel:U})}get historyProvider(){return(0,y.$1F)(this.x,"scmHistoryProvider"),this.j}set historyProvider(F){(0,y.$1F)(this.x,"scmHistoryProvider"),this.j=F,this.k.value=new A.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(F){F!==this.m&&(this.m=F,this.#e.$updateSourceControl(this.w,{commitTemplate:F}))}get acceptInputCommand(){return this.o}set acceptInputCommand(F){this.n.value=new A.$Sc,this.o=F;const U=this.y.converter.toInternal(F,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:U})}get actionButton(){return(0,y.$1F)(this.x,"scmActionButton"),this.q}set actionButton(F){(0,y.$1F)(this.x,"scmActionButton"),this.p.value=new A.$Sc,this.q=F;const U=F!==void 0?{command:this.y.converter.toInternal(F.command,this.p.value),secondaryCommands:F.secondaryCommands?.map(z=>z.map(T=>this.y.converter.toInternal(T,this.p.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:U??null})}get statusBarCommands(){return this.t}set statusBarCommands(F){if(this.t&&F&&$(this.t,F))return;this.s.value=new A.$Sc,this.t=F;const U=(F||[]).map(z=>this.y.converter.toInternal(z,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:U})}get selected(){return this.u}constructor(F,U,z,T,I,O,j){this.x=F,this.y=T,this.z=I,this.A=O,this.B=j,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new A.$Uc,this.m=void 0,this.n=new A.$Uc,this.o=void 0,this.p=new A.$Uc,this.s=new A.$Uc,this.t=void 0,this.u=!1,this.v=new N.$6d,this.onDidChangeSelection=this.v.event,this.w=g.d++,this.C=new Map,this.D=new Set,this.#e=z;const G=l.URI.from({scheme:u.Schemas.vscodeSourceControl,path:`${I}/scm${this.w}/input`,query:j?`rootUri=${encodeURIComponent(j.toString())}`:void 0});this.f=new D(F,U,this.#e,this.w,G),this.#e.$registerSourceControl(this.w,I,O,j,G)}createResourceGroup(F,U,z){const T=(0,y.$ZF)(this.x,"scmMultiDiffEditor")&&z?.multiDiffEditorEnableViewChanges===!0,I=new b(this.#e,this.y,this.w,F,U,T,this.x),O=N.Event.once(I.onDidDispose)(()=>this.C.delete(I));return this.C.set(I,O),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const F=[],U=[];for(const[z,T]of this.C){T.dispose();const I=z.onDidUpdateResourceStates(()=>{this.D.add(z),this.eventuallyUpdateResourceStates()});N.Event.once(z.onDidDispose)(()=>{this.D.delete(z),I.dispose(),this.e.delete(z.handle),this.#e.$unregisterGroup(this.w,z.handle)}),F.push([z.handle,z.id,z.label,z.features,z.multiDiffEditorEnableViewChanges]);const O=z._takeResourceStateSnapshot();O.length>0&&U.push([z.handle,O]),this.e.set(z.handle,z)}this.#e.$registerGroups(this.w,F,U),this.C.clear()}eventuallyUpdateResourceStates(){const F=[];this.D.forEach(U=>{const z=U._takeResourceStateSnapshot();z.length!==0&&F.push([U.handle,z])}),F.length>0&&this.#e.$spliceResourceStates(this.w,F),this.D.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.u=F,this.v.fire(F)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.w)}}Qe([(0,L.$Lh)(100)],g.prototype,"eventuallyAddResourceGroups",null),Qe([(0,L.$Lh)(100)],g.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,U,z,T){this.l=U,this.m=z,this.n=T,this.g=new Map,this.h=new C.$Cm,this.j=new N.$6d,this.e=F.getProxy(w.$0L.MainThreadSCM),this.f=F.getProxy(w.$0L.MainThreadTelemetry),U.registerArgumentProcessor({processArgument:I=>{if(I&&I.$mid===3){const O=this.g.get(I.sourceControlHandle);if(!O)return I;const j=O.getResourceGroup(I.groupHandle);return j?j.getResourceState(I.handle):I}else if(I&&I.$mid===4){const O=this.g.get(I.sourceControlHandle);return O?O.getResourceGroup(I.groupHandle):I}else if(I&&I.$mid===5){const O=this.g.get(I.handle);return O||I}return I}})}createSourceControl(F,U,z,T){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,U,z,T),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const I=o.d++,O=new g(F,this.m,this.e,this.l,U,z,T);this.g.set(I,O);const j=this.h.get(F.identifier)||[];return j.push(O),this.h.set(F.identifier,j),O}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const U=this.h.get(F.identifier),z=U&&U[U.length-1];return z&&z.inputBox}$provideOriginalResource(F,U,z){const T=l.URI.revive(U);this.n.trace("ExtHostSCM#$provideOriginalResource",F,T.toString());const I=this.g.get(F);return!I||!I.quickDiffProvider||!I.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$$g)(()=>I.quickDiffProvider.provideOriginalResource(T,z)).then(O=>O||null)}$onInputBoxValueChange(F,U){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const z=this.g.get(F);return z&&z.inputBox.$onInputBoxValueChange(U),Promise.resolve(void 0)}$executeResourceCommand(F,U,z,T){this.n.trace("ExtHostSCM#$executeResourceCommand",F,U,z);const I=this.g.get(F);if(!I)return Promise.resolve(void 0);const O=I.getResourceGroup(U);return O?O.$executeResourceCommand(z,T):Promise.resolve(void 0)}$validateInput(F,U,z){this.n.trace("ExtHostSCM#$validateInput",F);const T=this.g.get(F);return!T||!T.inputBox.validateInput?Promise.resolve(void 0):(0,R.$$g)(()=>T.inputBox.validateInput(U,z)).then(I=>{if(!I)return Promise.resolve(void 0);const O=S.MarkdownString.fromStrict(I.message);return O?Promise.resolve([O,I.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,U,z,T){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(U,z,T)??void 0}async $provideHistoryItems(F,U,z,T){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(U,z,T))?.map(j=>({...j,icon:c(j)}))??void 0}async $provideHistoryItemSummary(F,U,z,T){const I=this.g.get(F)?.historyProvider;if(typeof I?.provideHistoryItemSummary!="function")return;const O=await I.provideHistoryItemSummary(U,z,T);return O?{...O,icon:c(O)}:void 0}async $provideHistoryItemChanges(F,U,z,T){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(U,z,T)??void 0}};e.$Ojc=k,e.$Ojc=k=o=Qe([Ve(3,M.$Aj)],k)}),define(Se[343],De([1,0,6,16,2]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjc=void 0;class A{static{this.a=0}constructor(w,p){this.d=p,this.c=new Map,this.b=w.getProxy(l.$0L.MainThreadShare)}async $provideShare(w,p,E){return await this.c.get(w)?.provideShare({selection:N.Range.to(p.selection),resourceUri:L.URI.revive(p.resourceUri)},E)??void 0}registerShareProvider(w,p){const E=A.a++;return this.c.set(E,p),this.b.$registerShareProvider(E,N.DocumentSelector.from(w,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Pjc=A}),define(Se[344],De([1,0,7,6,222,3,16,18]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sjc=e.$Rjc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new l.$8M("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new l.$8M("statusBarItem.warningForeground")]])}#e;#t;constructor(v,S,y,u,m,o=l.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new A.$Sc,this.#e=v,this.#t=S,m&&u){this.c=(0,l.$KM)(u.identifier,m);const n=y.get(this.c);n&&(o=n.alignLeft?l.StatusBarAlignment.Left:l.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(p.a++);this.e=u,this.f=m,this.g=o,this.h=this.u(i)}u(v){if((0,w.$Xf)(v))return v===Number.POSITIVE_INFINITY?Number.MAX_VALUE:v===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:v}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(v){this.k=v,this.v()}set name(v){this.m=v,this.v()}set tooltip(v){this.l=v,this.v()}set color(v){this.n=v,this.v()}set backgroundColor(v){v&&!p.b.has(v.id)&&(v=void 0),this.o=v,this.v()}set command(v){this.r?.fromApi!==v&&(this.p&&this.q.add(this.p),this.p=new A.$Sc,typeof v=="string"?this.r={fromApi:v,internal:this.#t.toInternal({title:"",command:v},this.p)}:v?this.r={fromApi:v,internal:this.#t.toInternal(v,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(v){this.t=v,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let v;this.e?this.f?v=`${this.e.identifier.value}.${this.f}`:v=this.e.identifier.value:v=this.f;let S;this.m?S=this.m:S=(0,L.localize)(0,null,this.e.displayName||this.e.name);let y=this.n;this.o&&(y=p.b.get(this.o.id));const u=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,v,this.e?.identifier.value,S,this.k,u,this.r?.internal,y,this.o,this.g===l.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Rjc=p;class E{constructor(v){this.b=[],this.a=v.createStatusBarEntry(void 0,"status.extensionMessage",l.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,L.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(v){const S={message:v};return this.b.unshift(S),this.c(),new l.$_L(()=>{const y=this.b.indexOf(S);y>=0&&(this.b.splice(y,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class M{constructor(v,S){this.e=new Map,this.a=v.getProxy(N.$0L.MainThreadStatusBar),this.b=S,this.c=new E(this)}$acceptStaticEntries(v){for(const S of v)this.e.set(S.entryId,S)}createStatusBarEntry(v,S,y,u){return new p(this.a,this.b,this.e,v,S,y,u)}setStatusBarMessage(v,S){const y=this.c.setMessage(v);let u;return typeof S=="number"?u=setTimeout(()=>y.dispose(),S):typeof S<"u"&&S.then(()=>y.dispose(),()=>y.dispose()),new l.$_L(()=>{y.dispose(),clearTimeout(u)})}}e.$Sjc=M}),define(Se[154],De([1,0,29,144,66,112,89,16,2]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=e.$DO=e.$CO=e.$BO=void 0;const E=(n,r,c,t)=>{let f=r;return{enumerable:!0,configurable:!1,get(){return f},set(h){if(!c(f,h)){const s=f;f=h,n.listener?.(t(h,s))}}}},M=(n,r)=>n===r,C={range:(n,r)=>n===r?!0:!n||!r?!1:n.isEqual(r),label:M,description:M,sortText:M,busy:M,error:M,canResolveChildren:M,tags:(n,r)=>!(n.length!==r.length||n.some(c=>!r.find(t=>c.id===t.id)))},v=n=>r=>({op:4,update:n(r)}),S=(n,r)=>({range:(()=>{let c;const t=v(f=>({range:l.$0s.lift(w.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return c},set(f){n.listener?.({op:6}),C.range(c,f)||(c=f,n.listener?.(t(f)))}}})(),label:E(n,r,C.label,v(c=>({label:c}))),description:E(n,void 0,C.description,v(c=>({description:c}))),sortText:E(n,void 0,C.sortText,v(c=>({sortText:c}))),canResolveChildren:E(n,!1,C.canResolveChildren,c=>({op:2,state:c})),busy:E(n,!1,C.busy,v(c=>({busy:c}))),error:E(n,void 0,C.error,v(c=>({error:w.MarkdownString.fromStrict(c)||null}))),tags:E(n,[],C.tags,(c,t)=>({op:1,new:c.map(w.TestTag.from),old:t.map(w.TestTag.from)}))}),y=n=>{const r=L.$ZK.fromString(n.extId),c=new m(r.controllerId,r.localId,n.label,p.URI.revive(n.uri)||void 0);return c.range=w.Range.to(n.range||void 0),c.description=n.description||void 0,c.sortText=n.sortText||void 0,c.tags=n.tags.map(t=>w.TestTag.to({id:(0,R.$5K)(t).tagId})),c},u=n=>{let r;for(const c of n.tests){const t=y(c.item);(0,N.$lO)(t).parent=r,r=t}return r};e.$BO=u;class m{constructor(r,c,t,f){if(c.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(c)} symbol`);const h=(0,N.$kO)(this,r);Object.defineProperties(this,{id:{value:c,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof o?void 0:h.parent}},children:{value:(0,A.$jO)(h,N.$lO,m),enumerable:!0,writable:!1},...S(h,t)})}}e.$CO=m;class o extends m{constructor(r,c){super(r,r,c,void 0),this._isRoot=!0}}e.$DO=o;class i extends A.$fO{constructor(r,c,t){super({controllerId:r,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:N.$lO,getChildren:f=>f.children,root:new o(r,c),toITestItem:w.TestItem.from})}}e.$EO=i}),define(Se[33],De([1,0,18,7,16,24,6,19,12,56,29,49,2,3,5,20,154,21,67,44,38,87,90,30]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=void 0;let h=class{#e;#t;#i;constructor(b,g,k){this.b=new Map,this.c=new Map,this.#e=b.getProxy(R.$0L.MainThreadCommands),this.d=g,this.#i=k,this.#t=b.getProxy(R.$0L.MainThreadTelemetry),this.converter=new s(this,P=>{const F=this.c.get(P);return F?.result===d.Void?F:void 0},g),this.f=[{processArgument(P){return(0,E.$Ph)(P)}},{processArgument(P){return(0,A.$Nn)(P,function(F){if(M.$0s.isIRange(F))return L.Range.to(F);if(C.$9s.isIPosition(F))return L.Position.to(F);if(M.$0s.isIRange(F.range)&&v.URI.isUri(F.uri))return L.location.to(F);if(F instanceof o.$te)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const g=this.registerCommand(!1,b.id,async(...k)=>{const P=b.args.map((U,z)=>{if(!U.validate(k[z]))throw new Error(`Invalid argument '${U.name}' when running '${b.id}', received: ${typeof k[z]=="object"?JSON.stringify(k[z],null,"	"):k[z]} `);return U.convert(k[z])}),F=await this.executeCommand(b.internalId,...P);return b.result.convert(F,k,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new N.$_L(()=>{g.dispose(),this.c.delete(b.id)})}registerCommand(b,g,k,P,F,U){if(this.d.trace("ExtHostCommands#registerCommand",g),!g.trim().length)throw new Error("invalid id");if(this.b.has(g))throw new Error(`command '${g}' already exists`);return this.b.set(g,{callback:k,thisArg:P,metadata:F,extension:U}),b&&this.#e.$registerCommand(g),new N.$_L(()=>{this.b.delete(g)&&b&&this.#e.$unregisterCommand(g)})}executeCommand(b,...g){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,g,!0)}async g(b,g,k){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,g,!1);{let P=!1;const F=(0,A.$Nn)(g,function(U){if(U instanceof N.$aM)return L.Position.from(U);if(U instanceof N.$bM)return L.Range.from(U);if(U instanceof N.$lM)return L.location.from(U);if(N.$zN.isNotebookRange(U))return L.NotebookRange.from(U);if(U instanceof ArrayBuffer)return P=!0,o.$te.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return P=!0,o.$te.wrap(U);if(U instanceof o.$te)return P=!0,U;if(!Array.isArray(U))return U});try{const U=await this.#e.$executeCommand(b,P?new i.$0v(F):F,k);return(0,E.$Ph)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(b,g,!1);throw U}}}async h(b,g,k){const P=this.b.get(b);if(!P)throw new Error("Unknown command");const{callback:F,thisArg:U,metadata:z}=P;if(z?.args)for(let I=0;I<z.args.length;I++)try{(0,l.$$f)(g[I],z.args[I].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${z.args[I].name}' - ${z.args[I].description}`)}const T=r.$2d.create();try{return await F.apply(U,g)}catch(I){if(b===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...g);O&&(b=O.command)}if(this.d.error(I,b,P.extension?.identifier),!k)throw I;if(P.extension?.identifier){const O=this.#i.onExtensionError(P.extension.identifier,I);this.d.trace("forwarded error to extension?",O,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$4i)(I)),this.id=b,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,b,T.elapsed())}}j(b,g,k){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new c.$1o(g),duration:k})}$executeContributedCommand(b,...g){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const k=this.b.get(b);return k?(g=g.map(P=>this.f.reduce((F,U)=>U.processArgument(F,k.extension?.identifier),P)),this.h(b,g,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(g=>(b&&(g=g.filter(k=>k[0]!=="_")),g))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[g,k]of this.b){const{metadata:P}=k;P&&(b[g]=P)}return Promise.resolve(b)}};e.$KO=h,e.$KO=h=Qe([Ve(0,u.$pO),Ve(1,p.$Aj),Ve(2,t.$JO)],h),e.$LO=(0,y.$gi)("IExtHostCommands");class s{constructor(b,g,k){this.d=b,this.f=g,this.g=k,this.delegatingCommandId=`__vsc${(0,f.$Cg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,g){if(!b)return;const k={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return k;const P=this.f(b.command);if(P)k.id=P.internalId,k.arguments=P.args.map((F,U)=>F.convert(b.arguments&&b.arguments[U]));else if((0,w.$Lb)(b.arguments)){const F=`${b.command} /${++this.c}`;this.b.set(F,b),g.add((0,S.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),k.$ident=F,k.id=this.delegatingCommandId,k.arguments=[F],this.g.trace("CommandsConverter#CREATE",b.command,F)}return k}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const g=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],g?g.command:"MISSING"),g?this.d.executeCommand(g.command,...g.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$MO=s;class a{static{this.Uri=new a("uri","Uri of a text document",b=>v.URI.isUri(b),b=>b)}static{this.Position=new a("position","A position in a text document",b=>N.$aM.isPosition(b),L.Position.from)}static{this.Range=new a("range","A range in a text document",b=>N.$bM.isRange(b),L.Range.from)}static{this.Selection=new a("selection","A selection in a text document",b=>N.$cM.isSelection(b),L.Selection.from)}static{this.Number=new a("number","",b=>typeof b=="number",b=>b)}static{this.String=new a("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=a.Arr(a.String)}static Arr(b){return new a(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,g=>Array.isArray(g)&&g.every(k=>b.validate(k)),g=>g.map(k=>b.convert(k)))}static{this.CallHierarchyItem=new a("item","A call hierarchy item",b=>b instanceof N.$wM,L.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new a("item","A type hierarchy item",b=>b instanceof N.$SN,L.TypeHierarchyItem.from)}static{this.TestItem=new a("testItem","A VS Code TestItem",b=>b instanceof m.$CO,L.TestItem.from)}constructor(b,g,k,P){this.name=b,this.description=g,this.validate=k,this.convert=P}optional(){return new a(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,g){return new a(b??this.name,g??this.description,this.validate,this.convert)}}e.$NO=a;class d{static{this.Void=new d("no result",b=>b)}constructor(b,g){this.description=b,this.convert=g}}e.$OO=d;class ${constructor(b,g,k,P,F){this.id=b,this.internalId=g,this.description=k,this.args=P,this.result=F}}e.$PO=$}),define(Se[345],De([1,0,19,15,2,82,134,45,33,16,7]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;const C=[new p.$PO("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of DocumentHighlight-instances.",S(E.DocumentHighlight.to))),new p.$PO("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$NO.Uri],new p.$OO("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(u,m)=>{if((0,l.$Kb)(u))return;class o extends M.$rM{static to(n){const r=new o(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new M.$lM(m[0],E.Range.to(n.range)));return r.detail=n.detail,r.range=r.location.range,r.selectionRange=E.Range.to(n.selectionRange),r.children=n.children?n.children.map(o.to):[],r}}return u.map(o.to)})),new p.$PO("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$NO.Uri,new p.$NO("options","Formatting options",u=>!0,u=>u)],new p.$OO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$PO("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$NO.Uri,p.$NO.Range,new p.$NO("options","Formatting options",u=>!0,u=>u)],new p.$OO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$PO("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$NO.Uri,p.$NO.Position,new p.$NO("ch","Trigger character",u=>typeof u=="string",u=>u),new p.$NO("options","Formatting options",u=>!0,u=>u)],new p.$OO("A promise that resolves to an array of TextEdits.",S(E.TextEdit.to))),new p.$PO("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$PO("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$PO("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$PO("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Location or LocationLink instances.",y)),new p.$PO("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Location-instances.",S(E.location.to))),new p.$PO("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of Hover-instances.",S(E.Hover.to))),new p.$PO("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$NO.Uri,new p.$NO("position","A position in a text document",u=>Array.isArray(u)&&u.every(m=>M.$aM.isPosition(m)),u=>u.map(E.Position.from))],new p.$OO("A promise that resolves to an array of ranges.",u=>u.map(m=>{let o;for(const i of m.reverse())o=new M.$vM(E.Range.to(i),o);return o}))),new p.$PO("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$NO.String.with("query","Search string")],new p.$OO("A promise that resolves to an array of SymbolInformation-instances.",u=>u.map(E.WorkspaceSymbol.to))),new p.$PO("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of CallHierarchyItem-instances",u=>u.map(E.CallHierarchyItem.to))),new p.$PO("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$NO.CallHierarchyItem],new p.$OO("A promise that resolves to an array of CallHierarchyIncomingCall-instances",u=>u.map(E.CallHierarchyIncomingCall.to))),new p.$PO("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$NO.CallHierarchyItem],new p.$OO("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",u=>u.map(E.CallHierarchyOutgoingCall.to))),new p.$PO("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to a range and placeholder text.",u=>{if(u)return{range:E.Range.to(u.range),placeholder:u.text}})),new p.$PO("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$NO.Uri,p.$NO.Position,p.$NO.String.with("newName","The new symbol name")],new p.$OO("A promise that resolves to a WorkspaceEdit.",u=>{if(u){if(u.rejectReason)throw new Error(u.rejectReason);return E.WorkspaceEdit.to(u)}})),new p.$PO("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$NO.Uri,p.$NO.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$OO("A promise that resolves to an array of DocumentLink-instances.",u=>u.map(E.DocumentLink.to))),new p.$PO("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$NO.Uri],new p.$OO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$qN(u.tokenTypes,u.tokenModifiers)})),new p.$PO("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$NO.Uri],new p.$OO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$fab)(u);if(m.type==="full")return new M.$sN(m.data,void 0)})),new p.$PO("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$NO.Uri,p.$NO.Range.optional()],new p.$OO("A promise that resolves to SemanticTokensLegend.",u=>{if(u)return new M.$qN(u.tokenTypes,u.tokenModifiers)})),new p.$PO("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$NO.Uri,p.$NO.Range],new p.$OO("A promise that resolves to SemanticTokens.",u=>{if(!u)return;const m=(0,R.$fab)(u);if(m.type==="full")return new M.$sN(m.data,void 0)})),new p.$PO("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$NO.Uri,p.$NO.Position,p.$NO.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$NO.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$OO("A promise that resolves to a CompletionList-instance.",(u,m,o)=>{if(!u)return new M.$HM([]);const i=u.suggestions.map(n=>E.CompletionItem.to(n,o));return new M.$HM(i,u.incomplete)})),new p.$PO("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$NO.Uri,p.$NO.Position,p.$NO.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$OO("A promise that resolves to SignatureHelp.",u=>{if(u)return E.SignatureHelp.to(u)})),new p.$PO("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$NO.Uri,p.$NO.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$OO("A promise that resolves to an array of CodeLens-instances.",(u,m,o)=>S(i=>new M.$zM(E.Range.to(i.range),i.command&&o.fromInternal(i.command)))(u))),new p.$PO("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$NO.Uri,new p.$NO("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",u=>M.$bM.isRange(u),u=>M.$cM.isSelection(u)?E.Selection.from(u):E.Range.from(u)),p.$NO.String.with("kind","Code action kind to return code actions for").optional(),p.$NO.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$OO("A promise that resolves to an array of Command-instances.",(u,m,o)=>S(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const n=new M.$tM(i.title,i.kind?new M.$uM(i.kind):void 0);return i.edit&&(n.edit=E.WorkspaceEdit.to(i.edit)),i.command&&(n.command=o.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(u))),new p.$PO("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$NO.Uri],new p.$OO("A promise that resolves to an array of ColorInformation objects.",u=>u?u.map(m=>new M.$NM(E.Range.to(m.range),E.Color.to(m.color))):[])),new p.$PO("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$NO("color","The color to show and insert",u=>u instanceof M.$MM,E.Color.from),new p.$NO("context","Context object with uri and range",u=>!0,u=>({uri:u.uri,range:E.Range.from(u.range)}))],new p.$OO("A promise that resolves to an array of ColorPresentation objects.",u=>u?u.map(E.ColorPresentation.to):[])),new p.$PO("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$NO.Uri,p.$NO.Range],new p.$OO("A promise that resolves to an array of Inlay objects",(u,m,o)=>u.map(E.InlayHint.to.bind(void 0,o)))),new p.$PO("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$NO.Uri],new p.$OO("A promise that resolves to an array of FoldingRange objects",(u,m)=>{if(u)return u.map(E.FoldingRange.to)})),new p.$PO("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$OO("A promise that resolves to an array of NotebookContentProvider static info objects.",S(u=>({viewType:u.viewType,displayName:u.displayName,options:{transientOutputs:u.options.transientOutputs,transientCellMetadata:u.options.transientCellMetadata,transientDocumentMetadata:u.options.transientDocumentMetadata},filenamePattern:u.filenamePattern.map(m=>E.NotebookExclusiveDocumentPattern.to(m))})))),new p.$PO("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$NO.Uri,p.$NO.Range,new p.$NO("context","An InlineValueContext",u=>u&&typeof u.frameId=="number"&&u.stoppedLocation instanceof M.$bM,u=>E.InlineValueContext.from(u))],new p.$OO("A promise that resolves to an array of InlineValue objects",u=>u.map(E.InlineValue.to))),new p.$PO("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$NO("uriOrString","Uri-instance or string (only http/https)",u=>L.URI.isUri(u)||typeof u=="string"&&(0,N.$qg)(u,N.Schemas.http,N.Schemas.https),u=>u),new p.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[E.ViewColumn.from(u),void 0]:[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)])).optional(),p.$NO.String.with("label","").optional()],p.$OO.Void),new p.$PO("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$NO.Uri.with("resource","Resource to open"),p.$NO.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="number"||typeof u=="object",u=>u&&(typeof u=="number"?[E.ViewColumn.from(u),void 0]:[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)])).optional()],p.$OO.Void),new p.$PO("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$NO.Uri.with("left","Left-hand side resource of the diff editor"),p.$NO.Uri.with("right","Right-hand side resource of the diff editor"),p.$NO.String.with("title","Human readable title for the diff editor").optional(),new p.$NO("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",u=>u===void 0||typeof u=="object",u=>u&&[E.ViewColumn.from(u.viewColumn),E.TextEditorOpenOptions.from(u)]).optional()],p.$OO.Void),new p.$PO("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$NO.String.with("title","Human readable title for the changes editor"),new p.$NO("resourceList","List of resources to compare",u=>{for(const m of u){if(m.length!==3)return!1;const[o,i,n]=m;if(!L.URI.isUri(o)||!L.URI.isUri(i)&&i!==void 0&&i!==null||!L.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},u=>u)],p.$OO.Void),new p.$PO("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$NO.Uri,p.$NO.Position],new p.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new p.$PO("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$NO.TypeHierarchyItem],new p.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new p.$PO("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$NO.TypeHierarchyItem],new p.$OO("A promise that resolves to an array of TypeHierarchyItem-instances",u=>u.map(E.TypeHierarchyItem.to))),new p.$PO("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$NO.TestItem],p.$OO.Void),new p.$PO("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$NO.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$OO.Void),new p.$PO("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$NO.String.with("name","The context key name"),new p.$NO("value","The context key value",()=>!0,u=>u)],p.$OO.Void),new p.$PO("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$NO.Uri,p.$NO.StringArray,new p.$NO("MappedEditsContext","Mapped Edits Context",u=>E.MappedEditsContext.is(u),u=>E.MappedEditsContext.from(u))],new p.$OO("A promise that resolves to a workspace edit or null",u=>u?E.WorkspaceEdit.to(u):null))];class v{static register(m){C.forEach(m.registerApiCommand,m),this.a(m)}static a(m){m.registerCommand(!1,"_validateWhenClauses",w.$fj)}}e.$_hc=v;function S(u){return m=>{if(Array.isArray(m))return m.map(u)}}function y(u){if(!Array.isArray(u))return;const m=[];for(const o of u)A.$Wt(o)?m.push(E.DefinitionLink.to(o)):m.push(E.location.to(o));return m}}),define(Se[346],De([1,0,8,3,2,6,33,16,7]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;class E{static{this.a=0}constructor(S,y){this.extension=S,this.provider=y,this.handle=E.a++}}class M{constructor(S){this.session=S,this.responses=[]}}class C{static{this.a=0}constructor(S,y,u,m){this.f=u,this.g=m,this.b=new Map,this.d=new Map,this.e=S.getProxy(A.$0L.MainThreadInlineChat),y.registerApiCommand(new R.$PO("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new R.$NO("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?w.Range.from(o.initialRange):void 0,initialSelection:p.$cM.isSelection(o.initialSelection)?w.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?w.Position.from(o.position):void 0}})],R.$OO.Void))}registerProvider(S,y,u){const m=new E(S,y);return this.b.set(m.handle,m),this.e.$registerInteractiveEditorProvider(m.handle,u?.label??S.displayName??S.name,S.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function",typeof y.provideFollowups=="function",u?.supportReportIssue??!1),(0,N.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(m.handle),this.b.delete(m.handle)})}async $prepareSession(S,y,u,m){const o=this.b.get(S);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(L.URI.revive(y)),n=w.Selection.to(u),r=await o.provider.prepareInteractiveEditorSession({document:i,selection:n},m);if(!r)return;if(r.wholeRange&&!r.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const c=C.a++;return this.d.set(c,new M(r)),{id:c,placeholder:r.placeholder,input:r.input,slashCommands:r.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:w.Range.from(r.wholeRange),message:r.message}}async $provideResponse(S,y,u,m){const o=this.b.get(S);if(!o)return;const i=this.d.get(y.id);if(!i)return;const n={prompt:u.prompt,selection:w.Selection.to(u.selection),wholeRange:w.Range.to(u.wholeRange),attempt:u.attempt,live:u.live,previewDocument:this.f.getDocument(L.URI.revive(u.previewDocument)),withIntentDetection:u.withIntentDetection};let r=!1;const c={report:async D=>{if(!u.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");r||m.isCancellationRequested||await this.e.$handleProgressChunk(u.requestId,{message:D.message,edits:D.edits?.map(w.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:p.$AM.isMarkdownString(D.content)?D.content.value:D.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,n,c,m));let f;try{f=await(0,l.$7g)(t,m)}finally{r=!0}if(!f)return;const h=i.responses.push(f)-1,s={wholeRange:w.Range.from(f.wholeRange),placeholder:f.placeholder};if(!C.h(f))return{...s,id:h,type:"editorEdit",message:w.MarkdownString.from(f.contents),edits:[]};const{edits:a,contents:d}=f,$=d!==void 0?w.MarkdownString.from(d):void 0;return a instanceof p.$jM?{...s,id:h,type:"bulkEdit",edits:w.WorkspaceEdit.from(a),message:$}:{...s,id:h,type:"editorEdit",edits:a.map(w.TextEdit.from),message:$}}async $provideFollowups(S,y,u,m){const o=this.b.get(S),i=this.d.get(y),n=i?.responses[u];if(o&&n&&o.provider.provideFollowups){const r=Promise.resolve(o.provider.provideFollowups(i.session,n,m));return(await(0,l.$7g)(r,m))?.map(w.ChatInlineFollowup.from)}}$handleFeedback(S,y,u,m){const o=this.b.get(S),i=this.d.get(y),n=i?.responses[u];if(o&&n){const r=w.InteractiveEditorResponseFeedbackKind.to(m);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,r)}}$releaseSession(S,y){}static h(S){return typeof S=="object"&&typeof S.edits=="object"}}e.$jjc=C}),define(Se[347],De([1,0,2,33]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=void 0;class L{constructor(R,w,p,E,M){this.a=w,this.b=p,this.c=E;const C=new N.$PO("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$NO("showOptions","Show Options",v=>!0,v=>v),new N.$NO("resource","Interactive resource Uri",v=>!0,v=>v),new N.$NO("controllerId","Notebook controller Id",v=>!0,v=>v),new N.$NO("title","Interactive editor title",v=>!0,v=>v)],new N.$OO("Notebook and input URI",v=>{if(M.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const S=this.a.getEditorById(v.notebookEditorId);return M.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:l.URI.revive(v.notebookUri),inputUri:l.URI.revive(v.inputUri),notebookEditor:S.apiEditor}}return M.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:l.URI.revive(v.notebookUri),inputUri:l.URI.revive(v.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(R,w,p,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:w,lines:[""],languageId:p,uri:R,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(R,w){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$wjc=L}),define(Se[348],De([1,0,19,8,22,4,3,28,2,25,12,6,33,16,7,113,290,26,67,291]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fjc=e.$Ejc=void 0;let r=class{constructor($,D,b,g,k){this.m=D,this.n=b,this.o=g,this.q=k,this.b=new w.$Ac,this.c=new w.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new A.$6d,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=$.getProxy(C.$0L.MainThreadNotebookKernels);const P=new v.$PO("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new v.$NO("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const z=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:z}}else if(U&&"notebookEditor"in U){const z=this.n.getIdByEditor(U.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return U})],v.$OO.Void),F=new v.$PO("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[v.$NO.Uri],new v.$OO("A promise that resolves to an array of variables",(U,z)=>U.map(T=>({name:T.name,value:T.value,type:T.type,editable:!1}))));this.o.registerApiCommand(P),this.o.registerApiCommand(F)}createNotebookController($,D,b,g,k,P){for(const ge of this.j.values())if(ge.controller.id===D&&E.$Am.equals($.identifier,ge.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const F=this.k++,U=this;this.q.trace(`NotebookController[${F}], CREATED by ${$.identifier.value}, ${D}`);const z=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${$.identifier}'`);let T=!1;const I=new A.$6d,O=new A.$6d,j={id:a($.identifier,D),notebookType:b,extensionId:$.identifier,extensionLocation:$.extensionLocation,label:g||$.identifier.value,preloads:P?P.map(S.NotebookRendererScript.from):[]};let G=k??z,te,x;this.a.$addKernel(F,j).catch(ge=>{console.log(ge),T=!0});let Z=0;const X=()=>{if(T)return;const ge=++Z;Promise.resolve().then(()=>{ge===Z&&this.a.$updateKernel(F,j)})},ae=new w.$Ac,_={get id(){return D},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:I.event,get label(){return j.label},set label(ge){j.label=ge??$.displayName??$.name,X()},get detail(){return j.detail??""},set detail(ge){j.detail=ge,X()},get description(){return j.description??""},set description(ge){j.description=ge,X()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(ge){j.supportedLanguages=ge,X()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(ge){j.supportsExecutionOrder=ge,X()},get rendererScripts(){return j.preloads?j.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return G},set executeHandler(ge){G=ge??z},get interruptHandler(){return te},set interruptHandler(ge){te=ge,j.supportsInterrupt=!!ge,X()},set variableProvider(ge){(0,o.$1F)($,"notebookVariableProvider"),x=ge,j.hasVariableProvider=!!ge,ge?.onDidChangeVariables(se=>U.a.$variablesUpdated(se.uri)),X()},get variableProvider(){return x},createNotebookCellExecution(ge){if(T)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.notebook.uri))throw U.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.notebook.uri.toString()}`);return U._createNotebookCellExecution(ge,a($.identifier,this.id))},createNotebookExecution(ge){if((0,o.$1F)($,"notebookExecution"),T)throw new Error("notebook controller is DISPOSED");if(!ae.has(ge.uri))throw U.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(se=>se.toString())),new Error(`notebook controller is NOT associated to notebook: ${ge.uri.toString()}`);return U._createNotebookExecution(ge,a($.identifier,this.id))},dispose:()=>{T||(this.q.trace(`NotebookController[${F}], DISPOSED`),T=!0,this.j.delete(F),I.dispose(),O.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity(ge,se){se===y.NotebookControllerAffinity2.Hidden&&(0,o.$1F)($,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(F,ge.uri,se)},onDidReceiveMessage:O.event,postMessage(ge,se){return(0,o.$1F)($,"notebookMessaging"),U.a.$postMessage(F,se&&U.n.getIdByEditor(se),ge)},asWebviewUri(ge){return(0,o.$1F)($,"notebookMessaging"),(0,u.$Kxb)(ge,U.m.remote)}};return this.j.set(F,{extensionId:$.identifier,controller:_,onDidReceiveMessage:O,onDidChangeSelection:I,associatedNotebooks:ae}),_}getIdByController($){for(const[D,b]of this.j)if(b.controller===$)return a(b.extensionId,$.id);return null}createNotebookControllerDetectionTask($,D){const b=this.g++,g=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${$.identifier.value}`),this.a.$addKernelDetectionTask(b,D);const k={dispose:()=>{this.f.delete(b),g.a.$removeKernelDetectionTask(b)}};return this.f.set(b,k),k}registerKernelSourceActionProvider($,D,b){const g=this.i++,k=typeof b.onDidChangeNotebookKernelSourceActions=="function"?g:void 0,P=this;this.h.set(g,b),this.q.trace(`NotebookKernelSourceActionProvider[${g}], CREATED by ${$.identifier.value}`),this.a.$addKernelSourceActionProvider(g,g,D);let F;return k!==void 0&&(F=b.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(g),P.a.$removeKernelSourceActionProvider(g,g),F?.dispose()}}}async $provideKernelSourceActions($,D){const b=this.h.get($);if(b){const g=new R.$Sc;return(await b.provideNotebookKernelSourceActions(D)??[]).map(P=>S.NotebookKernelSourceAction.from(P,this.o.converter,g))}return[]}$acceptNotebookAssociation($,D,b){const g=this.j.get($);if(g){const k=this.n.getNotebookDocument(p.URI.revive(D));b?g.associatedNotebooks.set(k.uri,!0):g.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${$}] ASSOCIATE notebook`,k.uri.toString(),b),g.onDidChangeSelection.fire({selected:b,notebook:k.apiNotebook})}}async $executeCells($,D,b){const g=this.j.get($);if(!g)return;const k=this.n.getNotebookDocument(p.URI.revive(D)),P=[];for(const F of b){const U=k.getCell(F);U&&P.push(U.apiCell)}try{this.q.trace(`NotebookController[${$}] EXECUTE cells`,k.uri.toString(),P.length),await g.controller.executeHandler.call(g.controller,P,k.apiNotebook,g.controller)}catch(F){this.q.error(`NotebookController[${$}] execute cells FAILED`,F),console.error(F)}}async $cancelCells($,D,b){const g=this.j.get($);if(!g)return;const k=this.n.getNotebookDocument(p.URI.revive(D));if(g.controller.interruptHandler)await g.controller.interruptHandler.call(g.controller,k.apiNotebook);else for(const P of b){const F=k.getCell(P);F&&this.b.get(F.uri)?.cancel()}if(g.controller.interruptHandler){const P=this.c.get(k.uri);b.length&&Array.isArray(P)&&P.length&&P.forEach(F=>F.dispose())}}async $provideVariables($,D,b,g,k,P,F){const U=this.j.get($);if(!U)return;const z=this.n.getNotebookDocument(p.URI.revive(b)),T=U.controller.variableProvider;if(!T)return;let I;if(g!==void 0){if(I=this.s[g],!I)return}else this.s={};const O=k==="named"?y.NotebookVariablesRequestKind.Named:y.NotebookVariablesRequestKind.Indexed,j=T.provideVariables(z.apiNotebook,I,O,P,F);let G=0;for await(const te of j){if(F.isCancellationRequested)return;const x={id:this.r++,name:te.variable.name,value:te.variable.value,type:te.variable.type,hasNamedChildren:te.hasNamedChildren,indexedChildrenCount:te.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[x.id]=te.variable,this.a.$receiveVariable(D,x),G++>=n.$0gb)return}}$acceptKernelMessageFromRenderer($,D,b){const g=this.j.get($);if(!g)return;const k=this.n.getEditorById(D);g.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:b}))}$cellExecutionChanged($,D,b){const k=this.n.getNotebookDocument(p.URI.revive($)).getCell(D);if(k){const P=b?S.NotebookCellExecutionState.to(b):y.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:k.apiCell,state:P})}}_createNotebookCellExecution($,D){if($.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const g=this.n.getNotebookDocument($.notebook.uri).getCellFromApiCell($);if(!g)throw new Error("invalid cell");if(this.b.has(g.uri))throw new Error(`duplicate execution for ${g.uri}`);const k=new t(D,g,this.a);this.b.set(g.uri,k);const P=k.onDidChangeState(()=>{k.state===c.Resolved&&(k.dispose(),P.dispose(),this.b.delete(g.uri))});return k.asApiObject()}_createNotebookExecution($,D){const b=this.n.getNotebookDocument($.uri),g=$.getCells().find(F=>{const U=b.getCellFromApiCell(F);return U&&this.b.has(U.uri)});if(g)throw new Error(`duplicate cell execution for ${g.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const k=new h(D,b,this.a),P=k.onDidChangeState(()=>{k.state===f.Resolved&&(k.dispose(),P.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[k,P]),k.asApiObject()}};e.$Ejc=r,e.$Ejc=r=Qe([Ve(4,M.$Aj)],r);var c;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(c||(c={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,D,b){super(),this.m=D,this.n=b,this.b=t.a++,this.c=new A.$6d,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new L.$de),this.h=new s(10,g=>this.s(g)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,$,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r($){await this.h.addItem($)}async s($){const D=Array.isArray($)?$:[$];return this.n.$updateExecution(this.b,new i.$0v(D))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w($){let D=this.m;if($&&(D=this.m.notebook.getCellFromApiCell($)),!D)throw new Error("INVALID cell");return D.handle}y($){return $.map(D=>{const b=y.$DN.ensureUniqueMimeTypes(D.items,!0);return b===D.items?S.NotebookCellOutput.from(D):S.NotebookCellOutput.from({items:b,id:D.id,metadata:D.metadata})})}async z($,D,b){const g=this.w(D),k=this.y((0,l.$3b)($));return this.r({editType:m.CellExecutionUpdateType.Output,cellHandle:g,append:b,outputs:k})}async C($,D,b){return $=y.$DN.ensureUniqueMimeTypes((0,l.$3b)($),!0),this.r({editType:m.CellExecutionUpdateType.OutputItems,items:$.map(S.NotebookCellOutputItem.from),outputId:D.id,append:b})}asApiObject(){const $=this;return Object.freeze({get token(){return $.g.token},get cell(){return $.m.apiCell},get executionOrder(){return $.j},set executionOrder(b){$.j=b,$.s([{editType:m.CellExecutionUpdateType.ExecutionState,executionOrder:$.j}])},start(b){if($.f===c.Resolved||$.f===c.Started)throw new Error("Cannot call start again");$.f=c.Started,$.c.fire(),$.s({editType:m.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,g){if($.f===c.Resolved)throw new Error("Cannot call resolve twice");$.f=c.Resolved,$.c.fire(),$.h.flush(),$.n.$completeExecution($.b,new i.$0v({runEndTime:g,lastRunSuccess:b}))},clearOutput(b){return $.t(),$.z([],b,!1)},appendOutput(b,g){return $.t(),$.z(b,g,!0)},replaceOutput(b,g){return $.t(),$.z(b,g,!1)},appendOutputItems(b,g){return $.t(),$.C(b,g,!0)},replaceOutputItems(b,g){return $.t(),$.C(b,g,!1)}})}}var f;(function(d){d[d.Init=0]="Init",d[d.Started=1]="Started",d[d.Resolved=2]="Resolved"})(f||(f={}));class h extends R.$Tc{static{this.a=0}get state(){return this.f}constructor($,D,b){super(),this.h=D,this.j=b,this.b=h.a++,this.c=new A.$6d,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new L.$de),this.j.$createNotebookExecution(this.b,$,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class s{constructor($,D){this.f=$,this.g=D,this.a=[],this.b=Date.now()}addItem($){return this.a.push($),this.c||(this.c=new N.$Dh,this.b=Date.now(),(0,N.$hh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const $=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>$.complete())}}function a(d,$){return`${d.value}/${$}`}e.$Fjc=a}),define(Se[46],De([1,0,4,6,5,2,20,3,7,224,13,268,22,30,269,55,8,16,33]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=e.$Sic=e.$Ric=e.$Qic=void 0,e.$Qic=(0,L.$gi)("IExtHostTerminalService");class n{constructor(b,g,k,P){this.l=b,this._id=g,this.m=k,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(U=>this.f=U);const F=this;this.value={get name(){return F.n||""},get processId(){return F.b},get creationOptions(){return F.m},get exitStatus(){return F.h},get state(){return F.j},get selection(){return F.k},sendText(U,z=!0){F.q(),F.l.$sendText(F._id,U,z)},show(U){F.q(),F.l.$show(F._id,U)},hide(){F.q(),F.l.$hide(F._id)},dispose(){F.a||(F.a=!0,F.l.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(b,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??g?.cwd??void 0,env:b.env??void 0,icon:a(b.iconPath)??void 0,color:u.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,forceShellIntegration:g?.forceShellIntegration??void 0,isFeatureTerminal:g?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:g?.useShellEnvironment??void 0,location:g?.location||this.o(b.location,g?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,g,k,P,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:P,color:u.ThemeColor.isThemeColor(F)?F.id:void 0,location:g?.location||this.o(b,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,g){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&g?{parentTerminal:g}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,g){this.h=Object.freeze({code:b,reason:g})}setDimensions(b,g){return b===this.d&&g===this.g||b===0||g===0?!1:(this.d=b,this.g=g,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(g=>{g!==b&&(this.b=Promise.resolve(b))})}}e.$Ric=n;class r{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new l.$6d,this.onProcessData=this.a.event,this.b=new l.$6d,this.d=new l.$6d,this.onDidChangeProperty=this.d.event,this.f=new l.$6d,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,g){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${g}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,g){this.g.setDimensions?.({columns:b,rows:g})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(g=>this.a.fire(g)),this.g.onDidClose?.((g=void 0)=>{this.f.fire(g===void 0?void 0:g)}),this.g.onDidOverrideDimensions?.(g=>{g&&this.d.fire({type:"overrideDimensions",value:{cols:g.columns,rows:g.rows}})}),this.g.onDidChangeName?.(g=>{this.d.fire({type:"title",value:g})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,t=class extends w.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,g,k){super(),this.Q=g,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new w.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new l.$6d,this.onDidCloseTerminal=this.H.event,this.I=new l.$6d,this.onDidOpenTerminal=this.I.event,this.J=new l.$6d,this.onDidChangeActiveTerminal=this.J.event,this.L=new l.$6d,this.onDidChangeTerminalDimensions=this.L.event,this.M=new l.$6d,this.onDidChangeTerminalState=this.M.event,this.N=new l.$6d,this.onDidChangeShell=this.N.event,this.O=new l.$6d({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new l.$6d({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(N.$0L.MainThreadTerminalService),this.y=new y.$Qtb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:P=>{const F=U=>{const z=U;return this.W(z.instanceId)?.value};switch(P?.$mid){case 15:return F(P);default:{if(Array.isArray(P))for(let U=0;U<P.length&&P[U].$mid===15;U++)P[U]=F(P[U]);return P}}}}),this.B({dispose:()=>{for(const[P,F]of this.g)F.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,g){const k=new n(this.a,(0,S.$Cg)(),b,b.name),P=new r(b.pty);return k.createExtensionTerminal(b.location,g,this.R(b,g).resolvedExtHostIdentifier,a(b.iconPath),d(b.color)).then(F=>{const U=this.S(F,P);this.h[F]=U}),this.f.push(k),k.value}R(b,g){if(g=g||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const k=b.location.parentTerminal;if(k){const P=this.f.find(F=>F.value===k);P&&(g.resolvedExtHostIdentifier=P._id)}}else b.location&&typeof b.location!="object"?g.location=b.location:g.location&&typeof g.location=="object"&&"splitActiveTerminal"in g.location&&(g.location={splitActiveTerminal:!0});return g}attachPtyToTerminal(b,g){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const P=new r(g),F=this.S(b,P);this.h[b]=F}async $acceptActiveTerminalChanged(b){const g=this.b;if(b===null){this.b=void 0,g!==this.b&&this.J.fire(this.b);return}const k=this.W(b);k&&(this.b=k,g!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,g){const k=this.W(b);k&&this.O.fire({terminal:k.value,data:g})}async $acceptTerminalDimensions(b,g,k){const P=this.W(b);P&&P.setDimensions(g,k)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(b,g){const k=this.W(b);k&&this.P.fire({terminal:k.value,...g})}async $acceptTerminalMaximumDimensions(b,g,k){this.g.get(b)?.resize(g,k)}async $acceptTerminalTitleChange(b,g){const k=this.W(b);k&&(k.name=g)}async $acceptTerminalClosed(b,g,k){const P=this.Y(this.f,b);if(P!==null){const F=this.f.splice(P,1)[0];F.setExitStatus(g,k),this.H.fire(F.value)}}$acceptTerminalOpened(b,g,k,P){if(g){const z=this.Y(this.f,g);if(z!==null){this.f[z]._id=b,this.I.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const F={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:A.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},U=new n(this.a,b,F,k);this.f.push(U),this.I.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(b,g){this.W(b)?._setProcessId(g)}async $startExtensionTerminal(b,g){const k=this.W(b);if(!k)return{message:(0,E.localize)(0,null,b)};k.isOpen||await new Promise(F=>{const U=this.onDidOpenTerminal(async z=>{z===k.value&&(U.dispose(),F())})});const P=this.g.get(b);P?P.startSendingEvents(g):this.j[b]={initialDimensions:g}}S(b,g){const k=new w.$Sc;k.add(g.onProcessReady(F=>this.a.$sendProcessReady(b,F.pid,F.cwd,F.windowsPty))),k.add(g.onDidChangeProperty(F=>this.a.$sendProcessProperty(b,F))),this.y.startBuffering(b,g.onProcessData),k.add(g.onProcessExit(F=>this.U(b,F))),this.g.set(b,g);const P=this.j[b];return P&&g instanceof r&&(g.startSendingEvents(P.initialDimensions),delete this.j[b]),k}$acceptProcessAckDataEvent(b,g){this.g.get(b)?.acknowledgeDataEvent(g)}$acceptProcessInput(b,g){this.g.get(b)?.input(g)}$acceptTerminalInteraction(b){const g=this.W(b);g?.setInteractedWith()&&this.M.fire(g.value)}$acceptTerminalSelection(b,g){this.W(b)?.setSelection(g)}$acceptProcessResize(b,g,k){try{this.g.get(b)?.resize(g,k)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(b,g){this.g.get(b)?.shutdown(g)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(g=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:g}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(g=>this.a.$sendProcessProperty(b,{type:"cwd",value:g}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new p.$_L(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,g,k){if(this.C.has(g))throw new Error(`Terminal profile provider "${g}" already registered`);return this.C.set(g,k),this.a.$registerProfileProvider(g,b.identifier.value),new p.$_L(()=>{this.C.delete(g),this.a.$unregisterProfileProvider(g)})}registerTerminalQuickFixProvider(b,g,k){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,k),this.a.$registerQuickFixProvider(b,g),new p.$_L(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,g){const k=new v.$de().token;if(k.isCancellationRequested)return;const P=this.D.get(b);if(!P)return;const F=await P.provideTerminalQuickFixes(g,k);if(F===null||Array.isArray(F)&&F.length===0)return;const U=new w.$Sc;if(this.w.value=U,!Array.isArray(F))return F?o.TerminalQuickFix.from(F,this.Q.converter,U):void 0;const z=[];for(const T of F){const I=o.TerminalQuickFix.from(T,this.Q.converter,U);I&&z.push(I)}return z}async $createContributedProfileTerminal(b,g){const k=new v.$de().token;let P=await this.C.get(b)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,g);return}this.createTerminalFromOptions(P.options,g)}}async $provideLinks(b,g){const k=this.W(b);if(!k)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const F=new v.$de;this.G.set(b,F);const U=[],z={terminal:k.value,line:g},T=[];for(const j of this.z)T.push(m.Promises.withAsyncBody(async G=>{F.token.onCancellationRequested(()=>G({provider:j,links:[]}));const te=await j.provideTerminalLinks(z,F.token)||[];F.token.isCancellationRequested||G({provider:j,links:te})}));const I=await Promise.all(T);if(F.token.isCancellationRequested)return[];const O=new Map;for(const j of I)j&&j.links.length>0&&U.push(...j.links.map(G=>{const te={id:c++,startIndex:G.startIndex,length:G.length,label:G.tooltip};return O.set(te.id,{provider:j.provider,link:G}),te}));return this.F.set(b,O),U}$activateLink(b,g){const k=this.F.get(b)?.get(g);k&&k.provider.handleTerminalLink(k.link)}U(b,g){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const k=this.h[b];k&&(k.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,g)}W(b){return this.X(this.f,b)}X(b,g){const k=this.Y(b,g);return k!==null?b[k]:null}Y(b,g){const k=b.findIndex(P=>P._id===g);return k===-1?null:k}getEnvironmentVariableCollection(b){let g=this.n.get(b.identifier.value);return g||(g=new f,this.$(b.identifier.value,g)),g.getScopedEnvironmentVariableCollection(void 0)}Z(b,g){const k=(0,C.$2r)(g.map),P=(0,C.$3r)(g.descriptionMap);this.a.$setEnvironmentVariableCollection(b,g.persistent,k.length===0?void 0:k,P)}$initEnvironmentVariableCollections(b){b.forEach(g=>{const k=g[0],P=new f(g[1]);this.$(k,P)})}$acceptDefaultProfile(b,g){const k=this.s;this.s=b,this.u=g,k?.path!==b.path&&this.N.fire(b.path)}$(b,g){this.n.set(b,g),g.onDidChangeCollection(()=>{this.Z(b,g)})}};e.$Sic=t,e.$Sic=t=Qe([Ve(1,i.$LO),Ve(2,R.$pO)],t);class f{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new l.$6d,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const g=this.h(b);let k=this.a.get(g);return k||(k=new h(this,b),this.a.set(g,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(b,g,k,P){this.f(b,{value:g,type:p.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:P})}append(b,g,k,P){this.f(b,{value:g,type:p.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:P})}prepend(b,g,k,P){this.f(b,{value:g,type:p.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:P})}f(b,g){if(g.options&&g.options.applyAtProcessCreation===!1&&!g.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(b,g.scope),P=this.map.get(k),F=g.options?{applyAtProcessCreation:g.options.applyAtProcessCreation??!1,applyAtShellIntegration:g.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==g.value||P.type!==g.type||P.options?.applyAtProcessCreation!==F.applyAtProcessCreation||P.options?.applyAtShellIntegration!==F.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index){const U=this.g(b,g.scope),z={variable:b,...g,options:F};this.map.set(U,z),this.d.fire()}}get(b,g){const k=this.g(b,g),P=this.map.get(k);return P?$(P):void 0}g(b,g){const k=this.h(g);return k.length?`${b}:::${k}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const g=new Map;for(const[k,P]of this.map)this.h(P.scope)===this.h(b)&&g.set(P.variable,$(P));return g}delete(b,g){const k=this.g(b,g);this.map.delete(k),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[g,k]of this.map)k.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(g);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,g){const k=this.h(g),P=this.descriptionMap.get(k);if(!P||P.description!==b){let F;typeof b=="string"?F=b:F=b?.value.split(`

`)[0];const U={description:F,scope:g};this.descriptionMap.set(k,U),this.d.fire()}}getDescription(b){const g=this.h(b);return this.descriptionMap.get(g)?.description}k(b){const g=this.h(b);this.descriptionMap.delete(g)}}class h{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,g){this.b=b,this.d=g,this.a=new l.$6d}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,g,k){this.b.replace(b,g,k,this.d)}append(b,g,k){this.b.append(b,g,k,this.d)}prepend(b,g,k){this.b.prepend(b,g,k,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,g){this.b.getVariableMap(this.d).forEach((k,P)=>b.call(g,P,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let s=class extends t{constructor(b,g){super(!1,b,g)}createTerminal(b,g,k){throw new M.$_}createTerminalFromOptions(b,g){throw new M.$_}};e.$Tic=s,e.$Tic=s=Qe([Ve(0,i.$LO),Ve(1,R.$pO)],s);function a(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function d(D){return u.ThemeColor.isThemeColor(D)?D:void 0}function $(D){const b={...D};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(Se[349],De([1,0,8,21,22,4,73,54,3,24,18,30,12,6,20,154,16,7,66,112,89,26]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=e.$Yjc=e.$Xjc=e.$Wjc=void 0;let t=class extends p.$Tc{constructor(T,I,O,j){super(),this.w=j,this.f=this.B(new A.$6d),this.g=new Map,this.s=this.B(new A.$6d),this.onResultsChanged=this.f.event,this.results=[],this.h=T.getProxy(S.$0L.MainThreadTesting),this.m=new k(this.h),this.j=new a(this.h,I),O.registerArgumentProcessor({processArgument:G=>{switch(G?.$mid){case 16:{const te=G,x=te.tests[te.tests.length-1].item.extId;return this.g.get(i.$ZK.root(x))?.collection.tree.get(x)?.actual??(0,u.$BO)(G)}case 18:{const{extId:te,message:x}=G;return{test:this.g.get(i.$ZK.root(te))?.collection.tree.get(te)?.actual,message:m.TestMessage.to(x)}}default:return G}}}),O.registerCommand(!1,"testing.getExplorerSelection",async()=>{const G=await O.executeCommand("_testing.getExplorerSelection"),te=x=>{const Z=this.g.get(i.$ZK.root(x));if(Z)return i.$ZK.isRoot(x)?Z.controller:Z.collection.tree.get(x)?.actual};return{include:G?.include.map(te).filter(M.$2f)||[],exclude:G?.exclude.map(te).filter(M.$2f)||[]}})}createTestController(T,I,O,j){if(this.g.has(I))throw new Error(`Attempt to insert a duplicate controller with ID "${I}"`);const G=new p.$Sc,te=G.add(new u.$EO(I,O,this.w));te.root.label=O;const x=new Map,Z=new Set,X=this.h,ae={items:te.root.children,get label(){return O},set label(ge){O=ge,te.root.label=ge,X.$updateController(I,{label:O})},get refreshHandler(){return j},set refreshHandler(ge){j=ge,X.$updateController(I,{canRefresh:!!ge})},get id(){return I},createRunProfile:(ge,se,re,B,ie,ke)=>{let le=(0,w.$7i)(ge);for(;x.has(le);)le++;return new F(this.h,x,Z,this.s.event,I,le,ge,se,re,B,ie,ke)},createTestItem(ge,se,re){return new u.$CO(I,ge,se,re)},createTestRun:(ge,se,re=!0)=>this.j.createTestRun(T,I,te,ge,se,re),invalidateTestResults:ge=>{if(ge===void 0)this.h.$markTestRetired(void 0);else{const se=ge instanceof Array?ge:[ge];this.h.$markTestRetired(se.map(re=>i.$ZK.fromExtHostTestItem(re,I).toString()))}},set resolveHandler(ge){te.resolveHandler=ge},get resolveHandler(){return te.resolveHandler},dispose:()=>{G.dispose()}};X.$registerTestController(I,O,!!j),G.add((0,p.$Rc)(()=>X.$unregisterTestController(I)));const _={controller:ae,collection:te,profiles:x,extension:T,activeProfiles:Z};return this.g.set(I,_),G.add((0,p.$Rc)(()=>this.g.delete(I))),G.add(te.onDidGenerateDiff(ge=>X.$publishDiff(I,ge.map(r.TestsDiffOp.serialize)))),ae}createTestObserver(){return this.m.checkout()}async runTests(T,I=L.CancellationToken.None){const O=d(T);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.g.get(O.controllerId);if(!j)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:T.include?.map(G=>i.$ZK.fromExtHostTestItem(G,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:U[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:T.exclude?.map(G=>G.id)},I)}$syncTests(){for(const{collection:T}of this.g.values())T.flushDiff();return Promise.resolve()}async $provideFileCoverage(T,I,O){return await this.j.getCoverageReport(T,I)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(T,I,O,j){return await this.j.getCoverageReport(T,I)?.resolveFileCoverage(O,j)??[]}$configureRunProfile(T,I){this.g.get(T)?.profiles.get(I)?.configureHandler?.()}$setDefaultRunProfiles(T){const I=new Map;for(const[O,j]of Object.entries(T)){const G=this.g.get(O);if(!G)continue;const te=new Map,x=j.filter(X=>!G.activeProfiles.has(X)),Z=[...G.activeProfiles].filter(X=>!j.includes(X));for(const X of x)te.set(X,!0),G.activeProfiles.add(X);for(const X of Z)te.set(X,!1),G.activeProfiles.delete(X);te.size&&I.set(O,te)}this.s.fire(I)}async $refreshTests(T,I){await this.g.get(T)?.controller.refreshHandler?.(I)}$publishTestResults(T){this.results=Object.freeze(T.map(I=>(0,E.$Mn)(m.TestResults.to(I))).concat(this.results).sort((I,O)=>O.completedAt-I.completedAt).slice(0,32)),this.f.fire()}async $expandTest(T,I){const O=this.g.get(i.$ZK.fromString(T).controllerId)?.collection;O&&(await O.expand(T,I<0?1/0:I),O.flushDiff())}$acceptDiff(T){this.m.applyDiff(T.map(I=>r.TestsDiffOp.deserialize({asCanonicalUri:O=>O},I)))}async $runControllerTests(T,I){return Promise.all(T.map(O=>this.y(O,!1,I)))}async $startContinuousRun(T,I){const O=new L.$de(I),j=await Promise.all(T.map(G=>this.y(G,!0,O.token)));return!I.isCancellationRequested&&!j.some(G=>G.error)&&await new Promise(G=>I.onCancellationRequested(G)),O.dispose(!0),j}async y(T,I,O){const j=this.g.get(T.controllerId);if(!j)return{};const{collection:G,profiles:te,extension:x}=j,Z=te.get(T.profileId);if(!Z)return{};const X=T.testIds.map(se=>G.tree.get(se)).filter(M.$2f),ae=T.excludeExtIds.map(se=>j.collection.tree.get(se)).filter(M.$2f).filter(se=>X.some(re=>re.fullId.compare(se.fullId)===2));if(!X.length)return{};const _=new o.$KN(X.some(se=>se.actual instanceof u.$DO)?void 0:X.map(se=>se.actual),ae.map(se=>se.actual),Z,I),ge=(0,r.$2K)(T)&&this.j.prepareForMainThreadTestRun(_,$.fromInternal(T,j.collection),x,O);try{return await Z.runHandler(_,O),{}}catch(se){return{error:String(se)}}finally{ge&&(ge.hasRunningTasks&&!O.isCancellationRequested&&await A.Event.toPromise(ge.onEnd),ge.dispose())}}$cancelExtensionTestRun(T){T===void 0?this.j.cancelAllRuns():this.j.cancelRunById(T)}};e.$Wjc=t,e.$Wjc=t=Qe([Ve(0,y.$pO),Ve(1,v.$Aj)],t);const f=1e4;var h;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(h||(h={}));class s extends p.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(T,I,O,j,G){super(),this.s=T,this.w=I,this.y=O,this.z=j,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$6d),this.m=this.B(new A.$6d),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new L.$de(G));const te=this.B(new l.$sh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>te.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(T){const I=this.s.id,O=this.s.controllerId,j=(0,C.$Cg)(),G=this.y,te=this.m;let x;const Z=ge=>(se,...re)=>{if(ae){this.z.warn(`Setting the state of test "${se.id}" is a no-op after the run ends.`);return}this.s.isIncluded(se)&&(this.F(se),ge(se,...re))},X=(ge,se)=>{const re=se instanceof Array?se.map(m.TestMessage.from):[m.TestMessage.from(se)];if(ge.uri&&ge.range){const B={range:m.Range.from(ge.range),uri:ge.uri};for(const ie of re)ie.location=ie.location||B}this.w.$appendTestMessagesInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),re)};let ae=!1;const _={isPersisted:this.s.isPersisted,token:this.h.token,name:T,get coverageProvider(){return x?.provider},set coverageProvider(ge){(0,c.$1F)(G,"testCoverage"),x=ge&&new D(ge),te.fire({taskId:j,runId:I,coverage:x})},enqueued:Z(ge=>{this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),1)}),skipped:Z(ge=>{this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),5)}),started:Z(ge=>{this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),2)}),errored:Z((ge,se,re)=>{X(ge,se),this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),6,re)}),failed:Z((ge,se,re)=>{X(ge,se),this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,O).toString(),4,re)}),passed:Z((ge,se)=>{this.w.$updateTestStateInRun(I,j,i.$ZK.fromExtHostTestItem(ge,this.s.controllerId).toString(),3,se)}),appendOutput:(ge,se,re)=>{ae||(re&&(this.s.isIncluded(re)?this.F(re):re=void 0),this.w.$appendOutputToRun(I,j,N.$te.fromString(ge),se&&m.location.from(se),re&&i.$ZK.fromExtHostTestItem(re,O).toString()))},end:()=>{ae||(ae=!0,this.w.$finishedTestRunTask(I,j),this.f.delete(j),this.f.size||this.D())}};return this.f.set(j,{run:_}),this.w.$startedTestRunTask(I,{id:j,name:T,running:!0}),_}C(){for(const{run:T}of this.f.values())T.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(T){if(!(T instanceof u.$CO))throw new n.$hO(T.id);if(this.g.has(i.$ZK.fromExtHostTestItem(T,this.s.controllerId).toString()))return;const I=[],O=this.s.colllection.root;for(;;){const j=m.TestItem.from(T);if(I.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),T===O))break;T=T.parent||O}this.w.$addTestsToRun(this.s.controllerId,this.s.id,I)}dispose(){this.D(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(T,I){this.g=T,this.h=I,this.c=new Map,this.f=[]}getCoverageReport(T,I){return this.f.find(O=>O.runId===T)?.coverage.get(I)}prepareForMainThreadTestRun(T,I,O,j){return this.j(T,I,O,j)}cancelRunById(T){for(const I of this.c.values())if(I.id===T){I.cancel();return}}cancelAllRuns(){for(const T of this.c.values())T.cancel()}createTestRun(T,I,O,j,G,te){const x=this.c.get(j);if(x)return x.createRun(G);const Z=$.fromPublic(I,O,j,te),X=d(j);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!j.continuous,profile:X&&{group:U[X.kind],id:X.profileId},exclude:j.exclude?.map(_=>i.$ZK.fromExtHostTestItem(_,O.root.id).toString())??[],id:Z.id,include:j.include?.map(_=>i.$ZK.fromExtHostTestItem(_,O.root.id).toString())??[O.root.id],persist:te});const ae=this.j(j,Z,T);return A.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(Z.id),ae.dispose()}),ae.createRun(G)}j(T,I,O,j){const G=new s(I,this.g,O,this.h,j);this.c.set(T,G);let te;const x=G.onDidCoverage(({runId:Z,taskId:X,coverage:ae})=>{te||(te={runId:Z,coverage:new Map},this.f.unshift(te),this.f.length>r.$7K&&this.f.pop()),te.coverage.set(X,ae),this.g.$signalCoverageAvailable(Z,X,!!ae)});return A.Event.once(G.onEnd)(()=>{this.c.delete(T),x.dispose()}),G}}e.$Xjc=a;const d=z=>{if(z.profile){if(!(z.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class ${static fromPublic(T,I,O,j){return new $(T,(0,C.$Cg)(),O.include?.map(G=>i.$ZK.fromExtHostTestItem(G,T).toString())??[T],O.exclude?.map(G=>i.$ZK.fromExtHostTestItem(G,T).toString())??[],j,I)}static fromInternal(T,I){return new $(T.controllerId,T.runId,T.testIds,T.excludeExtIds,!0,I)}constructor(T,I,O,j,G,te){this.controllerId=T,this.id=I,this.isPersisted=G,this.colllection=te,this.c=O.map(x=>x+"\0"),this.f=j.map(x=>x+"\0")}isIncluded(T){const I=i.$ZK.fromExtHostTestItem(T,this.controllerId).toString()+"\0";for(const O of this.f)if(I===O||I.startsWith(O))return!1;for(const O of this.c)if(I===O||I.startsWith(O))return!0;return!1}}e.$Yjc=$;class D{constructor(T){this.provider=T}async provideFileCoverage(T){this.c||(this.c=(async()=>this.provider.provideFileCoverage(T))());try{return(await this.c)?.map(m.TestCoverage.fromFile)??[]}catch(I){throw this.c=void 0,I}}async resolveFileCoverage(T,I){const O=await this.c;let j=O?.[T];return!this.provider||!O||!j?[]:(j.detailedCoverage||(j=O[T]=await this.provider.resolveFileCoverage?.(j,I)??j),j.detailedCoverage?.map(m.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(T){this.j=T,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(T){this.c.add(T)}update(T){Object.assign(T.revived,m.TestItem.toPlain(T.item)),this.c.has(T)||this.f.add(T)}remove(T){if(this.c.has(T)){this.c.delete(T);return}this.f.delete(T);const I=i.$ZK.parentId(T.item.extId);if(I&&this.h.has(I.toString())){this.h.add(T.item.extId);return}this.g.add(T)}getChangeEvent(){const{c:T,f:I,g:O}=this;return{get added(){return[...T].map(j=>j.revived)},get updated(){return[...I].map(j=>j.revived)},get removed(){return[...O].map(j=>j.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class g extends r.$8K{constructor(){super(...arguments),this.s=new A.$6d,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(T){return this.f.get(T)}getMirroredTestDataByReference(T){return this.f.get(T.id)}w(T,I){return{...T,revived:m.TestItem.toPlain(T.item),depth:I?I.depth+1:0,children:new Set}}v(){return new b(this.s)}}class k{constructor(T){this.f=T}checkout(){this.c||(this.c=this.g());const T=this.c;return T.observers++,{onDidChangeTest:T.tests.onDidChangeTests,get tests(){return[...T.tests.rootTests].map(I=>I.revived)},dispose:(0,R.$db)(()=>{--T.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(T){return this.c?.tests.getMirroredTestDataByReference(T)}applyDiff(T){this.c?.tests.apply(T)}g(){const T=new g({asCanonicalUri:I=>I});return this.f.$subscribeToDiffs(),{observers:0,tests:T}}}const P=(z,T,I,O)=>{I?Object.assign(I,O):T.$updateTestRunConfig(z.controllerId,z.profileId,O)};class F{#e;#t;#i;#n;#s;get label(){return this.f}set label(T){T!==this.f&&(this.f=T,P(this,this.#e,this.#n,{label:T}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(T){T!==this.g&&(this.g=T,P(this,this.#e,this.#n,{supportsContinuousRun:T}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(T){T!==this.isDefault&&(T?this.#t.add(this.profileId):this.#t.delete(this.profileId),P(this,this.#e,this.#n,{isDefault:T}))}get tag(){return this._tag}set tag(T){T?.id!==this._tag?.id&&(this._tag=T,P(this,this.#e,this.#n,{tag:T?m.TestTag.namespace(this.controllerId,T.id):null}))}get configureHandler(){return this.c}set configureHandler(T){T!==this.c&&(this.c=T,P(this,this.#e,this.#n,{hasConfigurationHandler:!!T}))}get onDidChangeDefault(){return A.Event.chain(this.#i,T=>T.map(I=>I.get(this.controllerId)?.get(this.profileId)).filter(M.$2f))}constructor(T,I,O,j,G,te,x,Z,X,ae=!1,_=void 0,ge=!1){this.controllerId=G,this.profileId=te,this.f=x,this.kind=Z,this.runHandler=X,this._tag=_,this.g=ge,this.#e=T,this.#s=I,this.#t=O,this.#i=j,I.set(te,this);const se=U[Z];if(typeof se!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);ae&&O.add(te),this.#n={profileId:te,controllerId:G,tag:_?m.TestTag.namespace(this.controllerId,_.id):null,label:x,group:se,isDefault:ae,hasConfigurationHandler:!1,supportsContinuousRun:ge},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Zjc=F;const U={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Se[155],De([1,0,61,13,124,16,7]),function(fe,e,l,N,L,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yO=e.$xO=e.$wO=void 0;class w{static{this.c=new L.$uO("TextEditorDecorationType")}constructor(v,S,y){const u=w.c.nextId();v.$registerTextEditorDecorationType(S.identifier,u,A.DecorationRenderOptions.from(y)),this.value=Object.freeze({key:u,dispose(){v.$removeTextEditorDecorationType(u)}})}}e.$wO=w;class p{constructor(v,S){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,S){this.k();let y=null;if(v instanceof R.$aM)y=new R.$bM(v,v);else if(v instanceof R.$bM)y=v;else throw new Error("Unrecognized location");this.l(y,S,!1)}insert(v,S){this.k(),this.l(new R.$bM(v,v),S,!0)}delete(v){this.k();let S=null;if(v instanceof R.$bM)S=v;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(v,S,y){const u=this.c.validateRange(v);this.g.push({range:u,text:S,forceMoveMarkers:y})}setEndOfLine(v){if(this.k(),v!==R.EndOfLine.LF&&v!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=v}}class E{constructor(v,S,y,u){this.c=v,this.d=S,this._accept(y),this.e=u;const m=this;this.value={get tabSize(){return m.f},set tabSize(o){m.n(o)},get indentSize(){return m.g},set indentSize(o){m.p(o)},get insertSpaces(){return m.j},set insertSpaces(o){m.s(o)},get cursorStyle(){return m.k},set cursorStyle(o){m.t(o)},get lineNumbers(){return m.l},set lineNumbers(o){m.u(o)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.originalIndentSize,this.j=v.insertSpaces,this.k=v.cursorStyle,this.l=A.TextEditorLineNumbersStyle.to(v.lineNumbers)}m(v){if(v==="auto")return"auto";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}n(v){const S=this.m(v);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const S=Math.floor(v);return S>0?S:null}if(typeof v=="string"){const S=parseInt(v,10);return isNaN(S)?null:S>0?S:null}return null}p(v){const S=this.o(v);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(v){return v==="auto"?"auto":v==="false"?!1:!!v}s(v){const S=this.q(v);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(v){this.k!==v&&(this.k=v,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}u(v){this.l!==v&&(this.l=v,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:A.TextEditorLineNumbersStyle.from(v)})))}assign(v){const S={};let y=!1;if(typeof v.tabSize<"u"){const u=this.m(v.tabSize);u==="auto"?(y=!0,S.tabSize=u):typeof u=="number"&&this.f!==u&&(this.f=u,y=!0,S.tabSize=u)}if(typeof v.indentSize<"u"){const u=this.o(v.indentSize);u==="tabSize"?(y=!0,S.indentSize=u):typeof u=="number"&&this.h!==u&&(this.g=u,this.h=u,y=!0,S.indentSize=u)}if(typeof v.insertSpaces<"u"){const u=this.q(v.insertSpaces);u==="auto"?(y=!0,S.insertSpaces=u):this.j!==u&&(this.j=u,y=!0,S.insertSpaces=u)}typeof v.cursorStyle<"u"&&this.k!==v.cursorStyle&&(this.k=v.cursorStyle,y=!0,S.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.l!==v.lineNumbers&&(this.l=v.lineNumbers,y=!0,S.lineNumbers=A.TextEditorLineNumbersStyle.from(v.lineNumbers)),y&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(v,S){S.catch(y=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(y)})}}e.$xO=E;class M{constructor(v,S,y,u,m,o,i,n){this.id=v,this.j=S,this.k=y,this.g=!1,this.h=new Set,this.c=m,this.d=new E(this.j,this.id,o,y),this.e=i,this.f=n;const r=this;this.value=Object.freeze({get document(){return u.value},set document(c){throw new N.$9("document")},get selection(){return r.c&&r.c[0]},set selection(c){if(!(c instanceof R.$cM))throw(0,N.$7)("selection");r.c=[c],r.l()},get selections(){return r.c},set selections(c){if(!Array.isArray(c)||c.some(t=>!(t instanceof R.$cM)))throw(0,N.$7)("selections");r.c=c,r.l()},get visibleRanges(){return r.e},set visibleRanges(c){throw new N.$9("visibleRanges")},get options(){return r.d.value},set options(c){r.g||r.d.assign(c)},get viewColumn(){return r.f},set viewColumn(c){throw new N.$9("viewColumn")},edit(c,t={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new p(u.value,t);return c(f),r.m(f)},insertSnippet(c,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(r.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=r.c.map(s=>A.Range.from(s));else if(t instanceof R.$aM){const{lineNumber:s,column:a}=A.Position.from(t);h=[{startLineNumber:s,startColumn:a,endLineNumber:s,endColumn:a}]}else if(t instanceof R.$bM)h=[A.Range.from(t)];else{h=[];for(const s of t)if(s instanceof R.$bM)h.push(A.Range.from(s));else{const{lineNumber:a,column:d}=A.Position.from(s);h.push({startLineNumber:a,startColumn:d,endLineNumber:a,endColumn:d})}}return S.$tryInsertSnippet(v,u.value.version,c.value,h,f)},setDecorations(c,t){const f=t.length===0;f&&!r.h.has(c.key)||(f?r.h.delete(c.key):r.h.add(c.key),r.n(()=>{if(A.$mO(t))return S.$trySetDecorations(v,c.key,A.$nO(t));{const h=new Array(4*t.length);for(let s=0,a=t.length;s<a;s++){const d=t[s];h[4*s]=d.start.line+1,h[4*s+1]=d.start.character+1,h[4*s+2]=d.end.line+1,h[4*s+3]=d.end.character+1}return S.$trySetDecorationsFast(v,c.key,h)}}))},revealRange(c,t){r.n(()=>S.$tryRevealRange(v,A.Range.from(c),t||R.TextEditorRevealType.Default))},show(c){S.$tryShowEditor(v,A.ViewColumn.from(c))},hide(){S.$tryHideEditor(v)}})}dispose(){(0,l.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,l.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,l.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,l.ok)(!this.g),this.f=v}_acceptSelections(v){(0,l.ok)(!this.g),this.c=v}async l(){const v=this.c.map(A.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const S=v.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const y=S.edits.map(m=>m.range);y.sort((m,o)=>m.end.line===o.end.line?m.end.character===o.end.character?m.start.line===o.start.line?m.start.character-o.start.character:m.start.line-o.start.line:m.end.character-o.end.character:m.end.line-o.end.line);for(let m=0,o=y.length-1;m<o;m++){const i=y[m].end;if(y[m+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const u=S.edits.map(m=>({range:A.Range.from(m.range),text:m.text,forceMoveMarkers:m.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,u,{setEndOfLine:typeof S.setEndOfLine=="number"?A.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$yO=M}),define(Se[71],De([1,0,61,4,3,2,5,6,152,20,155,16,12,28,15,48,43]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=void 0;class o{constructor(r){this.value=r,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(r,c){this.h=r,this.i=c,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new N.$6d,this.e=new N.$6d,this.f=new N.$6d,this.g=new N.$6d,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(r){this.acceptDocumentsAndEditorsDelta(r)}acceptDocumentsAndEditorsDelta(r){const c=[],t=[],f=[];if(r.removedDocuments)for(const h of r.removedDocuments){const s=A.URI.revive(h),a=this.c.get(s);a?.unref()&&(this.c.delete(s),c.push(a.value))}if(r.addedDocuments)for(const h of r.addedDocuments){const s=A.URI.revive(h.uri);let a=this.c.get(s);if(a&&s.scheme!==y.Schemas.vscodeNotebookCell&&s.scheme!==y.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);a||(a=new o(new p.$sO(this.h.getProxy(w.$0L.MainThreadDocuments),s,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(s,a),t.push(a.value)),a.ref()}if(r.removedEditors)for(const h of r.removedEditors){const s=this.b.get(h);this.b.delete(h),s&&f.push(s)}if(r.addedEditors)for(const h of r.addedEditors){const s=A.URI.revive(h.documentUri);l.ok(this.c.has(s),`document '${s}' does not exist`),l.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const a=this.c.get(s).value,d=new M.$yO(h.id,this.h.getProxy(w.$0L.MainThreadTextEditors),this.i,new m.$V(()=>a.document),h.selections.map(C.Selection.to),h.options,h.visibleRanges.map($=>C.Range.to($)),typeof h.editorPosition=="number"?C.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,d)}r.newActiveEditor!==void 0&&(l.ok(r.newActiveEditor===null||this.b.has(r.newActiveEditor),`active editor '${r.newActiveEditor}' does not exist`),this.a=r.newActiveEditor),(0,L.$Oc)(c),(0,L.$Oc)(f),r.removedDocuments&&this.e.fire(c),r.addedDocuments&&this.d.fire(t),(r.removedEditors||r.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),r.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(r){return this.c.get(r)?.value}allDocuments(){return u.Iterable.map(this.c.values(),r=>r.value)}getEditor(r){return this.b.get(r)}activeEditor(r){if(!this.a)return;const c=this.b.get(this.a);return r?c:c?.value}allEditors(){return[...this.b.values()]}};e.$zO=i,e.$zO=i=Qe([Ve(0,E.$pO),Ve(1,v.$Aj)],i),e.$AO=(0,R.$gi)("IExtHostDocumentsAndEditors")}),define(Se[350],De([1,0,19,4,6,155,16,7]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=void 0;class p{constructor(M,C){this.i=C,this.a=new N.$6d,this.b=new N.$6d,this.c=new N.$6d,this.d=new N.$6d,this.f=new N.$6d,this.g=new N.$6d,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=M.getProxy(L.$0L.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(M){const C=this.i.allEditors();return M?C:C.map(v=>v.value)}async showTextDocument(M,C,v){let S;typeof C=="number"?S={position:R.ViewColumn.from(C),preserveFocus:v}:typeof C=="object"?S={position:R.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selection:typeof C.selection=="object"?R.Range.from(C.selection):void 0,pinned:typeof C.preview=="boolean"?!C.preview:void 0}:S={preserveFocus:!1};const y=await this.h.$tryShowTextDocument(M.uri,S),u=y&&this.i.getEditor(y);if(u)return u.value;throw y?new Error(`Could NOT open editor for "${M.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${M.uri.toString()}".`)}createTextEditorDecorationType(M,C){return new A.$wO(this.h,M,C).value}$acceptEditorPropertiesChanged(M,C){const v=this.i.getEditor(M);if(!v)throw new Error("unknown text editor");if(C.options&&v._acceptOptions(C.options),C.selections){const S=C.selections.selections.map(R.Selection.to);v._acceptSelections(S)}if(C.visibleRanges){const S=l.$Hb(C.visibleRanges.map(R.Range.to));v._acceptVisibleRanges(S)}if(C.options&&this.b.fire({textEditor:v.value,options:{...C.options,lineNumbers:R.TextEditorLineNumbersStyle.to(C.options.lineNumbers)}}),C.selections){const S=w.TextEditorSelectionChangeKind.fromValue(C.selections.source),y=C.selections.selections.map(R.Selection.to);this.a.fire({textEditor:v.value,selections:y,kind:S})}if(C.visibleRanges){const S=l.$Hb(C.visibleRanges.map(R.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(M){for(const C in M){const v=this.i.getEditor(C);if(!v)throw new Error("Unknown text editor");const S=R.ViewColumn.to(M[C]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(M){return Promise.resolve(this.h.$getDiffInformation(M))}}e.$jic=p}),define(Se[351],De([1,0,2,5,6,3,7,16,25,18]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3jc=e.$2jc=void 0,e.$2jc=(0,N.$gi)("IExtHostTimeline");class M{constructor(S,y){this.b=new Map,this.c=new Map,this.a=S.getProxy(L.$0L.MainThreadTimeline),y.registerArgumentProcessor({processArgument:(u,m)=>{if(u&&u.$mid===12)if(this.b.get(u.source)&&p.$Am.equals(m,this.b.get(u.source)?.extension)){const o=u.uri===void 0?void 0:l.URI.revive(u.uri);return this.c.get(u.source)?.get(C(o))?.get(u.handle)}else return;return u}})}async $getTimeline(S,y,u,m){return this.b.get(S)?.provider.provideTimeline(l.URI.revive(y),u,m)}registerTimelineProvider(S,y,u,m){const o=new A.$Sc,i=this.d(y.id,m,o).bind(this);let n;y.onDidChange&&(n=y.onDidChange(c=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...c,id:y.id}),this));const r=this.c;return this.f({...y,scheme:S,onDidChange:void 0,async provideTimeline(c,t,f){t?.resetCache&&(o.clear(),r.get(y.id)?.clear());const h=await y.provideTimeline(c,t,f);if(h==null)return;const s=i(c,t);return{...h,source:y.id,items:h.items.map(s)}},dispose(){for(const c of r.values())c.get(y.id)?.clear();n?.dispose(),o.dispose()}},u)}d(S,y,u){return(m,o)=>{let i;if(o?.cacheResults){let n=this.c.get(S);n===void 0&&(n=new Map,this.c.set(S,n));const r=C(m);i=n.get(r),i===void 0&&(i=new Map,n.set(r,i))}return n=>{const{iconPath:r,...c}=n,t=`${S}|${n.id??n.timestamp}`;i?.set(t,n);let f,h,s;n.iconPath&&(r instanceof R.$7M?s={id:r.id,color:r.color}:l.URI.isUri(r)?(f=r,h=r):{light:f,dark:h}=r);let a;return R.$AM.isMarkdownString(c.tooltip)?a=w.MarkdownString.from(c.tooltip):(0,E.$Tf)(c.tooltip)?a=c.tooltip:R.$AM.isMarkdownString(c.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=w.MarkdownString.from(c.detail)):(0,E.$Tf)(c.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),a=c.detail),{...c,id:c.id??void 0,handle:t,source:S,command:n.command?y.toInternal(n.command,u):void 0,icon:f,iconDark:h,themeIcon:s,tooltip:a,accessibilityInformation:n.accessibilityInformation}}}}f(S,y){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:y}),(0,A.$Rc)(()=>{for(const m of this.c.values())m.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$3jc=M;function C(v){return v?.toString()}}),define(Se[352],De([1,0,225,23,2,4,3,284,8,7,18,19,16,79,22,182,26]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4jc=void 0;function o(r,c){if((0,M.$Tf)(r))return{label:r};if(r&&typeof r=="object"&&typeof r.label=="string"){let t;return Array.isArray(r.highlights)&&(t=r.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:r.label,highlights:t}}}class i extends R.$Tc{constructor(c,t,f){super(),this.f=c,this.g=t,this.h=f,this.a=new Map,this.b=new u.$K9;function h(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>h(s)?this.r(s):Array.isArray(s)&&s.length>0?s.map(a=>h(a)?this.r(a):a):s})}registerTreeDataProvider(c,t,f){const h=this.createTreeView(c,{treeDataProvider:t},f);return{dispose:()=>h.dispose()}}createTreeView(c,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],a=!!t.dragAndDropController?.handleDrag,d=!!t.dragAndDropController?.handleDrop,$=this.m(c,t,f),D={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:s,hasHandleDrag:a,hasHandleDrop:d,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(c,D),g={get onDidCollapseElement(){return $.onDidCollapseElement},get onDidExpandElement(){return $.onDidExpandElement},get selection(){return $.selectedElements},get onDidChangeSelection(){return $.onDidChangeSelection},get activeItem(){return(0,m.$1F)(f,"treeViewActiveItem"),$.focusedElement},get onDidChangeActiveItem(){return(0,m.$1F)(f,"treeViewActiveItem"),$.onDidChangeActiveItem},get visible(){return $.visible},get onDidChangeVisibility(){return $.onDidChangeVisibility},get onDidChangeCheckboxState(){return $.onDidChangeCheckboxState},get message(){return $.message},set message(k){(0,S.$zk)(k)&&(0,m.$1F)(f,"treeViewMarkdownMessage"),$.message=k},get title(){return $.title},set title(k){$.title=k},get description(){return $.description},set description(k){$.description=k},get badge(){return $.badge},set badge(k){k!==void 0&&E.ViewBadge.isViewBadge(k)?$.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&($.badge=void 0)},reveal:(k,P)=>$.reveal(k,P),dispose:async()=>{await b,this.a.delete(c),$.dispose()}};return this.B(g),g}$getChildren(c,t){const f=this.a.get(c);return f?f.getChildren(t):Promise.reject(new w.$sF(c))}async $handleDrop(c,t,f,h,s,a,d,$){const D=this.a.get(c);if(!D)return Promise.reject(new w.$sF(c));const b=v.DataTransfer.toDataTransfer(f,async g=>(await this.f.$resolveDropFileData(c,t,g)).buffer);return d===c&&$&&await this.j(b,D,$,s,a),D.onDrop(b,h,s)}async j(c,t,f,h,s){const a=this.b.removeDragOperationTransfer(s);if(a)(await a)?.forEach((d,$)=>{d&&c.set($,d)});else if(s&&t.handleDrag){const d=t.handleDrag(f,c,h);this.b.addDragOperationTransfer(s,d),await d}return c}async $handleDrag(c,t,f,h){const s=this.a.get(c);if(!s)return Promise.reject(new w.$sF(c));const a=await this.j(new E.$4M,s,t,h,f);if(!(!a||h.isCancellationRequested))return v.DataTransfer.from(a)}async $hasResolve(c){const t=this.a.get(c);if(!t)throw new w.$sF(c);return t.hasResolve}$resolve(c,t,f){const h=this.a.get(c);if(!h)throw new w.$sF(c);return h.resolveTreeItem(t,f)}$setExpanded(c,t,f){const h=this.a.get(c);if(!h)throw new w.$sF(c);h.setExpanded(t,f)}$setSelectionAndFocus(c,t,f){const h=this.a.get(c);if(!h)throw new w.$sF(c);h.setSelectionAndFocus(t,f)}$setVisible(c,t){const f=this.a.get(c);if(!f){if(!t)return;throw new w.$sF(c)}f.setVisible(t)}$changeCheckboxState(c,t){const f=this.a.get(c);if(!f)throw new w.$sF(c);f.setCheckboxState(t)}m(c,t,f){const h=this.B(new n(c,t,this.f,this.g.converter,this.h,f));return this.a.set(c,h),h}r(c){const t=this.a.get(c.$treeViewId);return t&&"$treeItemHandle"in c?t.getExtensionElement(c.$treeItemHandle):t&&"$focusedTreeItem"in c&&c.$focusedTreeItem?t.focusedElement:null}}e.$4jc=i;class n extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(c=>this.getExtensionElement(c)).filter(c=>!(0,M.$3f)(c))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(c,t,f,h,s,a){if(super(),this.I=c,this.J=f,this.L=h,this.M=s,this.N=a,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new A.$6d),this.onDidExpandElement=this.u.event,this.w=this.B(new A.$6d),this.onDidCollapseElement=this.w.event,this.y=this.B(new A.$6d),this.onDidChangeSelection=this.y.event,this.z=this.B(new A.$6d),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new A.$6d),this.onDidChangeVisibility=this.C.event,this.D=this.B(new A.$6d),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new A.$6d),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new y.$de,a.contributes&&a.contributes.views)for(const b in a.contributes.views)for(const g of a.contributes.views[b])g.id===c&&(this.P=g.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let d,$;const D=A.Event.debounce(this.F.event,(b,g)=>(b||(b={message:!1,elements:[]}),g.element!==!1&&(d||(d=new Promise(k=>$=k),this.G=this.G.then(()=>d)),Array.isArray(g.element)?b.elements.push(...g.element):b.elements.push(g.element)),g.message&&(b.message=!0),b),200,!0);this.B(D(({message:b,elements:g})=>{g.length&&(this.H=this.H.then(()=>{const k=$;return d=null,this.$(g).then(()=>k())})),b&&this.J.$setMessage(this.I,v.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(c){const t=c?this.getExtensionElement(c):void 0;if(c&&!t)return this.M.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let f=this.X(c);return f||(f=await this.Y(t)),f?f.map(h=>h.item):void 0}getExtensionElement(c){return this.j.get(c)}reveal(c,t){t=t||{select:!0,focus:!1};const f=(0,M.$3f)(t.select)?!0:t.select,h=(0,M.$3f)(t.focus)?!1:t.focus,s=(0,M.$3f)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.G.then(()=>this.S(c)).then(a=>this.W(c,a[a.length-1]).then(d=>this.J.$reveal(this.I,{item:d.item,parentChain:a.map($=>$.item)},{select:f,focus:h,expand:s})),a=>this.M.error(a)):this.J.$reveal(this.I,void 0,{select:f,focus:h,expand:s})}get message(){return this.O}set message(c){this.O=c,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(c){this.P=c,this.J.$setTitle(this.I,c,this.Q)}get description(){return this.Q}set description(c){this.Q=c,this.J.$setTitle(this.I,this.P,c)}get badge(){return this.R}set badge(c){this.R?.value===c?.value&&this.R?.tooltip===c?.tooltip||(this.R=v.ViewBadge.from(c),this.J.$setBadge(this.I,c))}setExpanded(c,t){const f=this.getExtensionElement(c);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(c,t){const f=!(0,C.$ub)(this.s,c);this.s=c;const h=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(c){c!==this.r&&(this.r=c,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(c){const t=(await Promise.all(c.map(async f=>{const h=this.getExtensionElement(f.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(c,t,f){const h=[];for(const s of c){const a=this.getExtensionElement(s);a&&h.push(a)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(c,t,f){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,p.$$g)(()=>this.g?.handleDrop?this.g.handleDrop(h,c,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(c,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(c);if(f){const h=this.m.get(f);if(h){const s=await this.f.resolveTreeItem(h.extensionItem,f,t)??h.extensionItem;return this.hb(s),h.item.tooltip=this.eb(s.tooltip),h.item.command=this.fb(h.disposableStore,s.command),h.item}}}S(c){return this.U(c).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(h=>(f.push(h),f))):Promise.resolve([]))}U(c){const t=this.m.get(c);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$$g)(()=>this.f.getParent(c))}W(c,t){const f=this.m.get(c);return f?Promise.resolve(f):(0,p.$$g)(()=>this.f.getTreeItem(c)).then(h=>this.kb(c,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(h);if(s){const a=this.m.get(s);if(a)return Promise.resolve(a)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(c){if(c){let t;if(typeof c=="string"){const f=this.getExtensionElement(c);t=f?this.m.get(f):void 0}else t=c;return t&&t.children||void 0}return this.h}async Y(c){this.rb(c);const t=new y.$de(this.Z.token);try{const f=c?this.m.get(c):void 0,h=await this.f.getChildren(c);if(t.token.isCancellationRequested)return;const s=(0,C.$Hb)(h||[]),a=await Promise.all((0,C.$Hb)(s).map($=>this.f.getTreeItem($)));if(t.token.isCancellationRequested)return;const d=a.map(($,D)=>$?this.db(s[D],$,f):null);return(0,C.$Hb)(d)}finally{t.dispose()}}$(c){if(c.some(f=>!f))return this.Z.dispose(!0),this.Z=new y.$de,this.tb(),this.J.$refresh(this.I);{const f=this.ab(c);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(c){const t=new Set,f=c.map(s=>this.m.get(s));for(const s of f)if(s&&!t.has(s.item.handle)){let a=s;for(;a&&a.parent&&f.findIndex(d=>a&&a.parent&&d&&d.item.handle===a.parent.item.handle)===-1;){const d=this.j.get(a.parent.item.handle);a=d?this.m.get(d):void 0}a&&!a.parent&&t.add(s.item.handle)}const h=[];return t.forEach(s=>{const a=this.j.get(s);if(a){const d=this.m.get(a);d&&(!d.parent||!t.has(d.parent.item.handle))&&h.push(s)}}),h}bb(c){const t={};return Promise.all(c.map(f=>this.cb(f).then(h=>{h&&(t[f]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(c){const t=this.getExtensionElement(c);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,p.$$g)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const s=this.ib(t,h,f.parent);return this.pb(t,s,f,f.parent),f.dispose(),s}return null})}return Promise.resolve(null)}db(c,t,f){const h=this.ib(c,t,f);if(t.id&&this.j.has(h.item.handle))throw new Error((0,l.localize)(0,null,t.id));return this.ob(c,h),this.qb(h,f),h}eb(c){return E.$AM.isMarkdownString(c)?v.MarkdownString.from(c):c}fb(c,t){return t?{...this.L.toInternal(t,c),originalId:t.command}:void 0}gb(c){if(c.checkboxState===void 0)return;let t,f,h;return typeof c.checkboxState=="number"?t=c.checkboxState:(t=c.checkboxState.state,f=c.checkboxState.tooltip,h=c.checkboxState.accessibilityInformation),{isChecked:t===E.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:h}}hb(c){if(!E.$YM.isTreeItem(c,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(c,t,f){this.hb(t);const h=this.B(new R.$Sc),s=this.kb(c,t,f),a=this.lb(t);return{item:{handle:s,parentHandle:f?f.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:a,iconDark:this.mb(t)||a,themeIcon:this.jb(t),collapsibleState:(0,M.$3f)(t.collapsibleState)?E.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(c){return c.iconPath instanceof E.$7M?c.iconPath:void 0}kb(c,{id:t,label:f,resourceUri:h},s,a){if(t)return`${n.b}/${t}`;const d=o(f,this.N),$=s?s.item.handle:n.a;let D=d?d.label:h?(0,N.$Qg)(h):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const b=this.m.has(c)?this.m.get(c).item.handle:void 0,g=this.X(s)||[];let k,P=0;do{if(k=`${$}/${P}:${D}`,a||!this.j.has(k)||b===k)break;P++}while(P<=g.length);return k}lb(c){if(c.iconPath&&!(c.iconPath instanceof E.$7M))return typeof c.iconPath=="string"||L.URI.isUri(c.iconPath)?this.nb(c.iconPath):this.nb(c.iconPath.light)}mb(c){if(c.iconPath&&!(c.iconPath instanceof E.$7M)&&c.iconPath.dark)return this.nb(c.iconPath.dark)}nb(c){return L.URI.isUri(c)?c:L.URI.file(c)}ob(c,t){this.j.set(t.item.handle,c),this.m.set(c,t)}pb(c,t,f,h){this.j.delete(t.item.handle),this.m.delete(c),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(c,t);const s=this.X(h)||[],a=s.filter(d=>d.item.handle===f.item.handle)[0];a&&s.splice(s.indexOf(a),1,t)}qb(c,t){t?(t.children||(t.children=[]),t.children.push(c)):(this.h||(this.h=[]),this.h.push(c))}rb(c){if(c){const t=this.m.get(c);if(t){if(t.children)for(const f of t.children){const h=this.j.get(f.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(c){const t=this.m.get(c);if(t){if(t.children)for(const f of t.children){const h=this.j.get(f.item.handle);h&&this.sb(h)}this.m.delete(c),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(c=>c.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[353],De([1,0,4,3,2,30,16,92,6,7]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class M extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(y,u,m,o){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new l.$6d),this.onDidDispose=this.#d.event,this.#h=this.B(new l.$6d),this.onDidChangeViewState=this.#h.event,this.#e=y,this.#t=u,this.#n=m,this.#i=o.viewType,this.#s=o.panelOptions,this.#o=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(y){this.c(),this.#r!==y&&(this.#r=y,this.#t.$setTitle(this.#e,y))}get iconPath(){return this.c(),this.#a}set iconPath(y){this.c(),this.#a!==y&&(this.#a=y,this.#t.$setIconPath(this.#e,L.URI.isUri(y)?{light:y,dark:y}:y))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(y){this.#l||(this.active!==y.active||this.visible!==y.visible||this.viewColumn!==y.viewColumn)&&(this.#u=y.active,this.#c=y.visible,this.#o=y.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(y,u){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof y>"u"?void 0:R.ViewColumn.from(y),preserveFocus:!!u})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Tc{static c(){return(0,A.$Cg)()}constructor(y,u,m){super(),this.j=u,this.m=m,this.g=new Map,this.h=new Map,this.f=y.getProxy(p.$0L.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(y=>y.dispose()),this.g.clear()}createWebviewPanel(y,u,m,o,i={}){const n=typeof o=="object"?o.viewColumn:o,r={viewColumn:R.ViewColumn.from(n),preserveFocus:typeof o=="object"&&!!o.preserveFocus},c=(0,w.$yic)(y),t=C.c();this.f.$createWebviewPanel((0,w.$Aic)(y),t,u,{title:m,panelOptions:v(i),webviewOptions:(0,w.$Bic)(y,this.m,i),serializeBuffersForPostMessage:c},r);const f=this.j.createNewWebview(t,i,y);return this.createNewWebviewPanel(t,u,m,n,i,f,!0)}$onDidChangeWebviewPanelViewStates(y){const u=Object.keys(y);u.sort((m,o)=>{const i=y[m],n=y[o];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const m of u){const o=this.getWebviewPanel(m);if(!o)continue;const i=y[m];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(y){this.getWebviewPanel(y)?.dispose(),this.g.delete(y),this.j.deleteWebview(y)}registerWebviewPanelSerializer(y,u,m){if(this.h.has(u))throw new Error(`Serializer for '${u}' already registered`);return this.h.set(u,{serializer:m,extension:y}),this.f.$registerSerializer(u,{serializeBuffersForPostMessage:(0,w.$yic)(y)}),new E.$_L(()=>{this.h.delete(u),this.f.$unregisterSerializer(u)})}async $deserializeWebviewPanel(y,u,m,o){const i=this.h.get(u);if(!i)throw new Error(`No serializer found for '${u}'`);const{serializer:n,extension:r}=i,c=this.j.createNewWebview(y,m.webviewOptions,r),t=this.createNewWebviewPanel(y,u,m.title,o,m.panelOptions,c,m.active);await n.deserializeWebviewPanel(t,m.state)}createNewWebviewPanel(y,u,m,o,i,n,r){const c=new M(y,this.f,n,{viewType:u,title:m,viewColumn:o,panelOptions:i,active:r});return this.g.set(y,c),c}getWebviewPanel(y){return this.g.get(y)}}e.$Cic=C;function v(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Se[354],De([1,0,4,3,92,16,6,7]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7jc=void 0;class p extends N.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(C,v,S,y,u,m){super(),this.#s=!1,this.#u=this.B(new l.$6d),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new l.$6d),this.onDidDispose=this.#l.event,this.#i=S,this.#a=y,this.#e=C,this.#t=v,this.#n=u,this.#r=m}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#o}set description(C){this.a(),this.#o!==C&&(this.#o=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(C){C===this.#r||this.#s||(this.#r=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=A.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(C,v){this.d=v,this.b=new Map,this.c=new Map,this.a=C.getProxy(R.$0L.MainThreadWebviewViews)}registerWebviewViewProvider(C,v,S,y){if(this.b.has(v))throw new Error(`View provider for '${v}' already registered`);return this.b.set(v,{provider:S,extension:C}),this.a.$registerWebviewViewProvider((0,L.$Aic)(C),v,{retainContextWhenHidden:y?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,L.$yic)(C)}),new w.$_L(()=>{this.b.delete(v),this.a.$unregisterWebviewViewProvider(v)})}async $resolveWebviewView(C,v,S,y,u){const m=this.b.get(v);if(!m)throw new Error(`No view provider found for '${v}'`);const{provider:o,extension:i}=m,n=this.d.createNewWebview(C,{},i),r=new p(C,this.a,v,S,n,!0);this.c.set(C,r),await o.resolveWebviewView(r,{state:y},u)}async $onDidChangeWebviewViewVisibility(C,v){this.e(C)._setVisible(v)}async $disposeWebviewView(C){const v=this.e(C);this.c.delete(C),v.dispose(),this.d.deleteWebview(C)}e(C){const v=this.c.get(C);if(!v)throw new Error("No webview found");return v}}e.$7jc=E}),define(Se[355],De([1,0,68,15,12,255,32,11]),function(fe,e,l,N,L,A,R,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lkc=void 0;let p=class{constructor(C,v){C.addFileSystemProvider(N.Schemas.file,new E(v),{isCaseSensitive:w.$k})}};e.$Lkc=p,e.$Lkc=p=Qe([Ve(0,l.$uic),Ve(1,L.$Aj)],p);class E{constructor(C){this.b=C,this.a=new A.$Qq(this.b)}async stat(C){const v=await this.a.stat(C);return{type:v.type,ctime:v.ctime,mtime:v.mtime,size:v.size,permissions:v.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,v,S){return this.a.writeFile(C,v,{...S,unlock:!1,atomic:!1})}delete(C,v){return this.a.delete(C,{...v,useTrash:!1,atomic:!1})}rename(C,v,S){return this.a.rename(C,v,S)}copy(C,v,S){return this.a.copy(C,v,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,v){throw new Error("Method not implemented.")}}}),define(Se[356],De([1,0,17,63,30,33,3,6,2,20]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jkc=void 0;let M=class extends R.$Tc{constructor(v,S){super();const y=v.getProxy(w.$0L.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async u=>{const m=p.URI.file((0,l.$jc)((0,N.tmpdir)(),(0,L.$Cg)()));return await y.$download(u,m),m})}};e.$Jkc=M,e.$Jkc=M=Qe([Ve(0,E.$pO),Ve(1,A.$LO)],M)}),define(Se[357],De([1,0,57,17,2,93,3,15,8,31]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=void 0;class M extends A.$wic{constructor(){super(...arguments),this.i=null}async g(t){const f=await super.g(t);if(f.scheme!==w.Schemas.file)return f;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${f.fsPath}.`),f;const h=f.fsPath;let s=0;do{let a;s===0?a=h:a=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${s}`:`${h}-${s}`,await C(a);const d=N.$jc(a,"vscode.lock"),$=await u(this.d,d,!1);if($)return this.i=$,process.on("exit",()=>{$.dispose()}),L.URI.file(a);s++}while(s<10);return f}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Vkc=M;async function C(c){try{await E.Promises.stat(c);return}catch{}try{await E.Promises.mkdir(c,{recursive:!0})}catch{}}const v=1e3,S=10*60*1e3;class y extends R.$Tc{constructor(t,f){super(),this.b=t,this.c=f,this.a=this.B(new p.$rh),this.a.cancelAndSet(async()=>{const h=await m(t,f);(!h||h.pid!==process.pid)&&(t.info(`Lock '${f}': The lock was lost unexpectedly.`),this.a.cancel());try{await E.Promises.utimes(f,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${f}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{l.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const f={pid:process.pid,willReleaseAt:Date.now()+t};await E.Promises.writeFile(this.c,JSON.stringify(f),{flag:"w"})}catch(f){this.b.error(f)}}}async function u(c,t,f){try{const s={pid:process.pid,willReleaseAt:0};await E.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){c.error(s)}const h=await m(c,t);return!h||h.pid!==process.pid?f?(c.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(c.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(c,t)):(c.info(`Lock '${t}': Lock acquired.`),new y(c,t))}async function m(c,t){let f;try{f=await E.Promises.readFile(t)}catch(h){return c.error(h),null}try{return JSON.parse(String(f))}catch(h){return c.error(h),null}}async function o(c,t){let f;try{f=await E.Promises.stat(t)}catch(h){return c.error(h),0}return f.mtime.getTime()}function i(c){try{return process.kill(c,0),!0}catch{return!1}}async function n(c,t){const f=await m(c,t);if(!f)return c.info(`Lock '${t}': Could not read pid of lock holder.`),r(c,t);if(f.willReleaseAt){let $=f.willReleaseAt-Date.now();if($<5e3){for($>0?c.info(`Lock '${t}': The lockfile is scheduled to be released in ${$} ms.`):c.info(`Lock '${t}': The lockfile is scheduled to have been released.`);$>0;){if(await(0,p.$hh)(Math.min(100,$)),await o(c,t)===0)return r(c,t);$=f.willReleaseAt-Date.now()}return r(c,t)}}if(!i(f.pid))return c.info(`Lock '${t}': The pid ${f.pid} appears to be gone.`),r(c,t);const h=await o(c,t),s=Date.now()-h;if(s<=S)return c.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;c.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$hh)(2e3);const a=await o(c,t),d=Date.now()-a;return d<=S?(c.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null):(c.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),r(c,t))}async function r(c,t){c.info(`Lock '${t}': Deleting a stale lock.`);try{await E.Promises.unlink(t)}catch{}return u(c,t,!0)}}),define(Se[358],De([1,0,30,20,46,33]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ekc=void 0;let R=class extends L.$Sic{constructor(p,E){super(!0,p,E)}createTerminal(p,E,M){return this.createTerminalFromOptions({name:p,shellPath:E,shellArgs:M})}createTerminalFromOptions(p,E){const M=new L.$Ric(this.a,(0,l.$Cg)(),p,p.name);return this.f.push(M),M.create(p,this.R(p,E)),M.value}};e.$ekc=R,e.$ekc=R=Qe([Ve(0,A.$LO),Ve(1,N.$pO)],R)}),define(Se[359],De([1,0,4,37,45,5]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$sL=e.OutputChannelUpdateMode=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=void 0,e.$iL="text/x-code-output",e.$jL="output",e.$kL="Log",e.$lL="text/x-code-log-output",e.$mL="log",e.$nL="workbench.panel.output",e.$oL=new L.$xj("inOutput",!1),e.$pL=new L.$xj("activeLogOutput",!1),e.$qL=new L.$xj("outputView.scrollLock",!1),e.$rL=(0,A.$gi)("outputService");var R;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$sL={OutputChannels:"workbench.contributions.outputChannels"};class w{constructor(){this.a=new Map,this.b=new l.$6d,this.onDidRegisterChannel=this.b.event,this.c=new l.$6d,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(M=>E.push(M)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$Xn.add(e.$sL.OutputChannels,new w),e.$tL=new L.$xj("activeOutputChannel","")}),define(Se[156],De([1,0,6,5,20,25,12,359,68,27,59,187,21,18,32,4,3]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ijc=e.$Hjc=void 0;class o extends R.$Gj{get disposed(){return this.n}constructor(c,t,f,h,s){super(),this.id=c,this.name=t,this.r=f,this.s=h,this.extension=s,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(a=>this.setLevel(a)))}get logLevel(){return this.getLevel()}appendLine(c){this.append(c+`
`)}append(c){this.info(c)}clear(){const c=this.m;this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Clear,c)}replace(c){const t=this.m;this.info(c),this.s.$update(this.id,w.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(c,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof c=="boolean"?c:t))}hide(){this.s.$close(this.id)}g(c,t){this.m+=v.$te.fromString(t).byteLength,(0,R.log)(this.r,c,t),this.visible&&(this.r.flush(),this.s.$update(this.id,w.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(c){this.append(c)}}let n=class{constructor(c,t,f,h,s,a){this.i=t,this.j=f,this.k=h,this.l=s,this.m=a,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=c.getProxy(l.$0L.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$Mm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(c){this.h=c;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(c,t,f){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,s=(0,S.$Tf)(t)?t:void 0;if((0,S.$Tf)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let a;const d=this.i.environment.extensionLogLevel?.find(([D])=>A.$Am.equals(f.identifier,D))?.[1];d&&(a=(0,R.$Qj)(d));const $=h?this.o(c,a,f):this.n(c,s,f);return $.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),h?this.r(c,a??this.m.getLevel(),$):this.q(c,$)}async n(c,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,s=this.k.extUri.joinPath(h,`${this.f++}-${c.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),d=await this.a.$register(c,s,t,f.identifier.value);return new o(d,c,a,this.a,f)}async o(c,t,f){const h=await this.p(f),s=c.replace(/[\\/:\*\?"<>\|]/g,""),a=this.k.extUri.joinPath(h,`${s}.log`),d=`${f.identifier.value}.${s}`,$=this.l.createLogger(a,{id:d,name:c,logLevel:t,extensionId:f.identifier.value});return new i(d,c,$,this.a,f)}p(c){let t=this.d.get(c.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,c.identifier.value);this.d.set(c.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(h){if((0,y.$Wk)(h)!==y.FileSystemProviderErrorCode.FileExists)throw h}return f})())}return t}q(c,t){let f=!1;const h=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return c},append(s){h(),t.then(a=>a.append(s))},appendLine(s){h(),t.then(a=>a.appendLine(s))},clear(){h(),t.then(s=>s.clear())},replace(s){h(),t.then(a=>a.replace(s))},show(s,a){h(),t.then(d=>d.show(s,a))},hide(){h(),t.then(s=>s.hide())},dispose(){f=!0,t.then(s=>s.dispose())}}}r(c,t,f){const h=new m.$Sc,s=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},a=h.add(new u.$6d);function d($){t=$,a.fire($)}return f.then($=>{h.add($),$.logLevel!==t&&d($.logLevel),h.add($.onDidChangeLogLevel(D=>d(D)))}),{...this.q(c,f),get logLevel(){return t},onDidChangeLogLevel:a.event,trace($,...D){s(),f.then(b=>b.trace($,...D))},debug($,...D){s(),f.then(b=>b.debug($,...D))},info($,...D){s(),f.then(b=>b.info($,...D))},warn($,...D){s(),f.then(b=>b.warn($,...D))},error($,...D){s(),f.then(b=>b.error($,...D))},dispose(){h.dispose()}}}};e.$Hjc=n,e.$Hjc=n=Qe([Ve(0,L.$pO),Ve(1,E.$FO),Ve(2,p.$uic),Ve(3,M.$7hc),Ve(4,R.$Bj),Ve(5,R.$Aj)],n),e.$Ijc=(0,N.$gi)("IExtHostOutputService")}),define(Se[157],De([1,0,5,8]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3m=e.$2m=void 0,e.$2m=(0,l.$gi)("remoteAgentService"),e.$3m=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(L){let A=1/0;for(let w=0;w<this.maxSampleCount;w++){const p=await L.getRoundTripTime();if(p===void 0)return;A=Math.min(A,p/2),await(0,N.$hh)(this.sampleDelay)}this.average.push(A),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(A):R=this.initial.reduce((w,p)=>w+p,0)/this.initial.length,this.lastMeasurement={initial:R,current:A,average:this.average.reduce((w,p)=>w+p,0)/this.average.length,high:typeof R>"u"?!1:A>this.highLatencyMaxThreshold||A>this.highLatencyMinThreshold&&A>R*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[360],De([1,0,229,85,37,40,52,3,4,157,11,24,8]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=void 0,e.$MI=Object.freeze({id:"application",order:100,title:(0,l.localize)(0,null),type:"object"}),e.$NI=Object.freeze({id:"workbench",order:7,title:(0,l.localize)(1,null),type:"object"}),e.$OI=Object.freeze({id:"security",scope:1,title:(0,l.localize)(2,null),type:"object",order:7}),e.$PI=Object.freeze({id:"problems",title:(0,l.localize)(3,null),type:"object",order:101}),e.$QI={ConfigurationMigration:"base.contributions.configuration.migration"};class S{constructor(){this.migrations=[],this.a=new p.$6d,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const y=new S;L.$Xn.add(e.$QI.ConfigurationMigration,y);let u=class extends w.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,n){super(),this.a=i,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const c of r.added)await this.f(c,y.migrations)})),this.c(y.migrations),this.B(y.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(i){await this.f(void 0,i);for(const n of this.b.getWorkspace().folders)await this.f(n,i)}async f(i,n){await Promise.all([n.map(r=>this.g(r,i?.uri))])}async g(i,n){const r=this.a.inspect(i.key,{resource:n}),c=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of c){const h=r[t];if(!h)continue;const s=[];if(h.value!==void 0){const a=await this.h(i,t,h.value,n,void 0);for(const d of a??[])s.push([d,[]])}for(const{identifiers:a,value:d}of h.overrides??[])if(d!==void 0){const $=await this.h(i,t,d,n,a);for(const D of $??[])s.push([D,a])}s.length&&await Promise.allSettled(s.map(async([[a,d],$])=>this.a.updateValue(a,d.value,{resource:n,overrideIdentifiers:$},f)))}}async h(i,n,r,c,t){const f=s=>{const d=this.a.inspect(s,{resource:c})[n];if(d)return t?d.overrides?.find(({identifiers:$})=>(0,C.$Pn)($,t))?.value:d.value},h=await i.migrateFn(r,f);return Array.isArray(h)?h:[[i.key,h]]}};e.$RI=u,e.$RI=u=Qe([Ve(0,R.$Mi),Ve(1,A.$pi)],u);let m=class extends w.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new v.$Dh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!M.$i&&(await this.b.getEnvironment())?.os!==1)return;L.$Xn.as(N.$3n.Configuration).registerConfiguration({...e.$OI,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,l.localize)(4,null)},default:[],markdownDescription:(0,l.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,l.localize)(6,null),scope:2}}})}};e.$SI=m,e.$SI=m=Qe([Ve(0,E.$2m)],m)}),define(Se[361],De([1,0,35,15,17,23,238,360,85,5,37]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$eb=e.$0eb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$9eb=e.$8eb=void 0,e.$8eb=(0,E.$gi)("editorResolverService"),e.$9eb="workbench.editorAssociations";const C=M.$Xn.as(p.$3n.Configuration),v={...w.$NI,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(v);var S;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(S||(e.RegisteredEditorPriority=S={}));var y;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(y||(e.ResolvedStatus=y={}));function u(o){switch(o){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}e.$0eb=u;function m(o,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const c=typeof o=="string"&&o.indexOf(L.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,A.$Qg)(i);return l.$Yj(typeof o=="string"?o.toLowerCase():o,c.toLowerCase())}e.$$eb=m}),define(Se[362],De([1,0,34,15,17,11,23,2,5,273,40,147,157]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$ML=e.$LL=void 0,e.$LL=(0,p.$gi)("pathService");let y=S=class{constructor(m,o,i,n){this.d=m,this.e=o,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||A.OS)(),this.b=(async()=>{const r=await this.e.getEnvironment();return this.c=r?.userHome??m})()}hasValidBasename(m,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(n=>this.h(m,n,o)):this.h(m,o,i)}h(m,o,i){return m.scheme===N.Schemas.file||m.scheme===N.Schemas.vscodeRemote?(0,l.$eg)(i??(0,R.$Qg)(m),o===1):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(m,o){if(m.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,E.$IL)(o.getWorkspace());if(i)return i;const n=o.getWorkspace().folders[0];if(n)return n.uri.scheme;const r=o.getWorkspace().configuration;return r?r.scheme:N.Schemas.file}userHome(m){return m?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(m=>m===1?L.$fc:L.$gc)}async fileURI(m){let o="";if(await this.a===1&&(m=m.replace(/\\/g,"/")),m[0]==="/"&&m[1]==="/"){const n=m.indexOf("/",2);n===-1?(o=m.substring(2),m="/"):(o=m.substring(2,n),m=m.substring(n)||"/")}return w.URI.from({scheme:N.Schemas.file,authority:o,path:m,query:"",fragment:""})}};e.$ML=y,e.$ML=y=S=Qe([Ve(1,v.$2m),Ve(2,C.$uL),Ve(3,M.$pi)],y)}),define(Se[363],De([1,0,240,19,53,4,54,3,2,52,245,12,64,275,88,40,147,26,22,18,24,45]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=e.$DL=e.OnPortForward=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.TunnelSource=e.TunnelCloseReason=e.$xL=e.$wL=e.$vL=void 0;const t=10*1e3,f="remote.tunnels.toRestore",h="remote.tunnels.toRestoreExpiration",s=1e3*60*60*24*14;e.$vL="onTunnel",e.$wL=new c.$xj("forwardedPortsViewEnabled",!1,l.localize(0,null));function a(z){const T=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(T)return{host:T[1]?.substring(0,T[1].length-1)||"localhost",port:Number(T[2])}}e.$xL=a;var d;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var $;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})($||(e.TunnelSource=$={})),e.$yL={source:$.User,description:l.localize(1,null)},e.$zL={source:$.Auto,description:l.localize(2,null)};function D(z,T,I){const O=z.get(g(T,I));if(O)return O;if((0,y.$Vv)(T))for(const j of y.$Uv){const G=g(j,I);if(z.has(G))return z.get(G)}else if((0,y.$Xv)(T))for(const j of y.$Wv){const G=g(j,I);if(z.has(G))return z.get(G)}}e.$AL=D;function b(z,T,I){const O=D(z,T,I);if(O)return O;const j=(0,y.$Xv)(T)?"localhost":(0,y.$Vv)(T)?"0.0.0.0":void 0;if(j)return D(z,j,I)}e.$BL=b;function g(z,T){return z+":"+T}e.$CL=g;var k;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(k||(e.OnPortForward=k={}));function P(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$DL=P;class F extends w.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(T){super(),this.r=T,this.j=[],this.n=new A.$6d,this.onDidChangeAttributes=this.n.event,this.B(T.onDidChangeConfiguration(I=>{(I.affectsConfiguration(F.c)||I.affectsConfiguration(F.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(T,I,O){let j=this.w(T,I,O,this.j,0);const G={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;j>=0;){const te=this.j[j];te.key===T?(G.onAutoForward=te.onAutoForward??G.onAutoForward,G.elevateIfNeeded=te.elevateIfNeeded!==void 0?te.elevateIfNeeded:G.elevateIfNeeded,G.label=te.label??G.label,G.requireLocalPort=te.requireLocalPort,G.protocol=te.protocol):(G.onAutoForward=G.onAutoForward??te.onAutoForward,G.elevateIfNeeded=G.elevateIfNeeded!==void 0?G.elevateIfNeeded:te.elevateIfNeeded,G.label=G.label??te.label,G.requireLocalPort=G.requireLocalPort!==void 0?G.requireLocalPort:void 0,G.protocol=G.protocol??te.protocol),j=this.w(T,I,O,this.j,j+1)}return G.onAutoForward!==void 0||G.elevateIfNeeded!==void 0||G.label!==void 0||G.requireLocalPort!==void 0||G.protocol!==void 0?G:this.C()}t(T){return T.start!==void 0&&T.end!==void 0}u(T){return T.host!==void 0&&T.port!==void 0&&(0,n.$Tf)(T.host)&&(0,n.$Xf)(T.port)}w(T,I,O,j,G){if(G>=j.length)return-1;const te=!(0,y.$Vv)(I)&&!(0,y.$Xv)(I),Z=j.slice(G).findIndex(X=>(0,n.$Xf)(X.key)?te?!1:X.key===T:this.t(X.key)?te?!1:T>=X.key.start&&T<=X.key.end:this.u(X.key)?T===X.key.port&&I===X.key.host:O?X.key.test(O):!1);return Z>=0?Z+G:-1}y(){const T=this.r.getValue(F.c);if(!T||!(0,n.$Vf)(T))return[];const I=[];for(const j in T){if(j===void 0)continue;const G=T[j];let te;if(Number(j))te=Number(j);else if((0,n.$Tf)(j))if(F.g.test(j)){const x=j.match(F.g);te={start:Number(x[1]),end:Number(x[2])}}else if(F.h.test(j)){const x=j.match(F.h);te={host:x[1],port:Number(x[2])}}else{let x;try{x=RegExp(j)}catch{}x&&(te=x)}te&&I.push({key:te,elevateIfNeeded:G.elevateIfNeeded,onAutoForward:G.onAutoForward,label:G.label,requireLocalPort:G.requireLocalPort,protocol:G.protocol})}const O=this.r.getValue(F.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(I)}z(T){function I(O,j){return(0,n.$Xf)(O.key)?O.key:j.t(O.key)?O.key.start:j.u(O.key)?O.key.port:Number.MAX_VALUE}return T.sort((O,j)=>I(O,this)-I(j,this))}C(){return this.m}static providedActionToAction(T){switch(T){case y.ProvidedOnAutoForward.Notify:return k.Notify;case y.ProvidedOnAutoForward.OpenBrowser:return k.OpenBrowser;case y.ProvidedOnAutoForward.OpenBrowserOnce:return k.OpenBrowserOnce;case y.ProvidedOnAutoForward.OpenPreview:return k.OpenPreview;case y.ProvidedOnAutoForward.Silent:return k.Silent;case y.ProvidedOnAutoForward.Ignore:return k.Ignore;default:return}}async addAttributes(T,I,O){const G=this.r.inspect(F.c).userRemoteValue;let te;!G||!(0,n.$Vf)(G)?te={}:te=(0,r.$Ln)(G),te[`${T}`]||(te[`${T}`]={});for(const x in I)te[`${T}`][x]=I[x];return this.r.updateValue(F.c,te,O)}}e.$EL=F;let U=class extends w.$Tc{constructor(T,I,O,j,G,te,x,Z,X,ae){super(),this.H=T,this.I=I,this.J=O,this.L=j,this.M=G,this.N=te,this.O=x,this.P=Z,this.Q=X,this.R=ae,this.c=new Map,this.g=new A.$6d,this.onForwardPort=this.g.event,this.h=new A.$6d,this.onClosePort=this.h.event,this.j=new A.$6d,this.onPortName=this.j.event,this.n=new A.$6d,this.onCandidatesChanged=this.n.event,this.t=new A.$6d,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new A.$6d,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new F(O),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async _=>{const ge=await this.getAttributes(_.map(se=>({port:se.tunnelRemotePort,host:se.tunnelRemoteHost})));for(const se of _)if(se.localAddress){const re=g(se.tunnelRemoteHost,se.tunnelRemotePort),B=b(this.m??new Map,se.tunnelRemoteHost,se.tunnelRemotePort);this.forwarded.set(re,{remotePort:se.tunnelRemotePort,remoteHost:se.tunnelRemoteHost,localAddress:se.localAddress,protocol:ge?.get(se.tunnelRemotePort)?.protocol??y.TunnelProtocol.Http,localUri:await this.X(se.localAddress,ge?.get(se.tunnelRemotePort)),localPort:se.tunnelLocalPort,runningProcess:B?.detail,hasRunningProcess:!!B,pid:B?.pid,privacy:se.privacy,source:e.$yL}),this.f.set(re,se)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async _=>{const ge=g(_.tunnelRemoteHost,_.tunnelRemotePort);if(!b(this.forwarded,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.detected,_.tunnelRemoteHost,_.tunnelRemotePort)&&!b(this.c,_.tunnelRemoteHost,_.tunnelRemotePort)&&_.localAddress){const se=b(this.m??new Map,_.tunnelRemoteHost,_.tunnelRemotePort),re=(await this.getAttributes([{port:_.tunnelRemotePort,host:_.tunnelRemoteHost}]))?.get(_.tunnelRemotePort);this.forwarded.set(ge,{remoteHost:_.tunnelRemoteHost,remotePort:_.tunnelRemotePort,localAddress:_.localAddress,protocol:re?.protocol??y.TunnelProtocol.Http,localUri:await this.X(_.localAddress,re),localPort:_.tunnelLocalPort,closeable:!0,runningProcess:se?.detail,hasRunningProcess:!!se,pid:se?.pid,privacy:_.privacy,source:e.$yL})}await this.cb(),this.f.set(ge,_),this.g.fire(this.forwarded.get(ge))})),this.B(this.H.onTunnelClosed(_=>this.W(_,d.Other))),this.U()}S(){return this.Q.extensions.find(T=>T.activationEvents?.includes(e.$vL))?(this.R.createKey(e.$wL.key,!0),!0):!1}U(){if(this.S())return;const T=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&T.dispose()}))}async W(T,I){const O=g(T.host,T.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.cb(),this.h.fire(T))}X(T,I){if(T.startsWith("http"))return p.URI.parse(T);const O=I?.protocol??"http";return p.URI.parse(`${O}://${T}`)}async Y(T){const I=this.N.getWorkspace(),O=I.configuration?(0,R.$7i)(I.configuration.path):I.folders.length>0?(0,R.$7i)(I.folders[0].uri.path):void 0;if(O===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${T}.${this.L.remoteAuthority}.${O}`}async Z(){return this.Y(f)}async $(){return this.Y(h)}async ab(){const T=this.I.get(f,1);if(T)return this.I.remove(f,1),await this.cb(),T;const I=await this.Z();if(I)return this.I.get(I,0)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const T=await this.s;if(T&&T!==this.y){const I=JSON.parse(T)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${I.map(O=>O.remotePort).join(", ")}`);for(const O of I){const j=b(this.detected,O.remoteHost,O.remotePort);O.source.source!==$.Extension&&!j||O.source.source===$.Extension&&j?await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,elevateIfNeeded:!0,source:O.source}):O.source.source===$.Extension&&!j&&this.D.set(g(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const T=await this.Z();this.w=this.B(new w.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async I=>{I.key===T&&(this.s=Promise.resolve(this.I.get(T,0)),await this.restoreForwarded())}))}}bb(){const T=this.I.keys(0,0).filter(I=>I.startsWith(h));for(const I of T){const O=this.I.getNumber(I,0);if(O&&O<Date.now()){this.s=Promise.resolve(void 0);const j=I.replace(h,f);this.I.remove(I,0),this.I.remove(j,0)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const T=Array.from(this.forwarded.values()),I=T.map(te=>({remoteHost:te.remoteHost,remotePort:te.remotePort,localPort:te.localPort,name:te.name,localAddress:te.localAddress,localUri:te.localUri,protocol:te.protocol,source:te.source}));let O;T.length>0&&(O=JSON.stringify(I));const j=await this.Z(),G=await this.$();!O&&j&&G?(this.I.remove(j,0),this.I.remove(G,0)):O!==this.y&&j&&G&&(this.I.store(j,O,0,0),this.I.store(G,Date.now()+s,0,0)),this.y=O}}async eb(T,I,O){if(!T.tunnelLocalPort||!O?.requireLocalPort||T.tunnelLocalPort===I)return;const j=new Date;if(this.db.getTime()+t>j.getTime())return;this.db=j;const G=l.localize(3,null,I,T.tunnelRemotePort,T.tunnelLocalPort);return this.P.info(G)}async forward(T,I){return!this.z&&this.L.remoteAuthority&&await A.Event.toPromise(this.C.event),this.fb(T,I)}async fb(T,I){await this.Q.activateByEvent(e.$vL);const O=b(this.forwarded,T.remote.host,T.remote.port);I=I??(I!==null?(await this.getAttributes([T.remote]))?.get(T.remote.port):void 0);const j=T.local!==void 0?T.local:T.remote.port;let G;if(O)return this.hb(O,T,I);{const te=this.L.remoteAuthority,x=te?{getAddress:async()=>(await this.M.resolveAuthority(te)).authority}:void 0,Z=g(T.remote.host,T.remote.port);this.c.set(Z,!0),T=this.gb(Z,T);const X=await this.H.openTunnel(x,T.remote.host,T.remote.port,void 0,j,T.elevateIfNeeded?T.elevateIfNeeded:I?.elevateIfNeeded,T.privacy,I?.protocol);if(typeof X=="string")G=X;else if(X&&X.localAddress){const ae=b(this.m??new Map,T.remote.host,T.remote.port),_=X.protocol?X.protocol===y.TunnelProtocol.Https?y.TunnelProtocol.Https:y.TunnelProtocol.Http:I?.protocol??y.TunnelProtocol.Http,ge={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:I?.label??T.name,closeable:!0,localAddress:X.localAddress,protocol:_,localUri:await this.X(X.localAddress,I),runningProcess:ae?.detail,hasRunningProcess:!!ae,pid:ae?.pid,source:T.source??e.$yL,privacy:X.privacy};return this.forwarded.set(Z,ge),this.f.set(Z,X),this.c.delete(Z),await this.cb(),await this.eb(X,j,I),this.g.fire(ge),X}this.c.delete(Z)}return G}gb(T,I){const O=this.D.has(T)?this.D:this.F.has(T)?this.F:void 0;if(O){const j=O.get(T);O.delete(T),j&&(I.name=j.name??I.name,I.local=("local"in j?j.local:"localPort"in j?j.localPort:void 0)??I.local,I.privacy=I.privacy)}return I}async hb(T,I,O){const j=O?.label??I.name;let G;(function(x){x[x.None=0]="None",x[x.Fire=1]="Fire",x[x.Reopen=2]="Reopen"})(G||(G={}));let te=G.None;switch(j!==T.name&&(T.name=j,te=G.Fire),(O?.protocol||T.protocol!==y.TunnelProtocol.Http)&&O?.protocol!==T.protocol&&(I.source=T.source,te=G.Reopen),I.privacy&&T.privacy!==I.privacy&&(te=G.Reopen),te){case G.Fire:{this.g.fire();break}case G.Reopen:await this.close(T.remoteHost,T.remotePort,d.User),await this.fb(I,O)}return b(this.f,I.remote.host,I.remote.port)}async name(T,I,O){const j=b(this.forwarded,T,I),G=g(T,I);if(j){j.name=O,await this.cb(),this.j.fire({host:T,port:I});return}else this.detected.has(G)&&(this.detected.get(G).name=O,this.j.fire({host:T,port:I}))}async close(T,I,O){const j=g(T,I),G=this.forwarded.get(j);return O===d.AutoForwardEnd&&G&&G.source.source===$.Auto&&this.F.set(j,{local:G.localPort,name:G.name,privacy:G.privacy}),await this.H.closeTunnel(T,I),this.W({host:T,port:I},O)}address(T,I){const O=g(T,I);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(T){if(T)for(const I of T){const O=b(this.m??new Map,I.remoteAddress.host,I.remoteAddress.port),j=typeof I.localAddress=="string"?I.localAddress:g(I.localAddress.host,I.localAddress.port);this.detected.set(g(I.remoteAddress.host,I.remoteAddress.port),{remoteHost:I.remoteAddress.host,remotePort:I.remoteAddress.port,localAddress:j,protocol:y.TunnelProtocol.Http,localUri:this.X(j),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:y.TunnelPrivacyId.ConstantPrivate,source:{source:$.Extension,description:l.localize(4,null)}}),this.H.setEnvironmentTunnel(I.remoteAddress.host,I.remoteAddress.port,j,y.TunnelPrivacyId.ConstantPrivate,y.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(T){this.r=T}async setCandidates(T){let I=T;this.r&&(I=await this.r(T));const O=this.ib(I);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(j=>j.port).join(", ")}`),this.n.fire(O)}ib(T){const I=this.m??new Map,O=new Map;return this.m=O,T.forEach(j=>{const G=g(j.host,j.port);O.set(G,{host:j.host,port:j.port,detail:j.detail,pid:j.pid}),I.has(G)&&I.delete(G);const te=b(this.forwarded,j.host,j.port);te&&(te.runningProcess=j.detail,te.hasRunningProcess=!0,te.pid=j.pid)}),I.forEach((j,G)=>{const te=a(G);if(!te)return;const x=b(this.forwarded,te.host,te.port);x&&(x.runningProcess=void 0,x.hasRunningProcess=!1,x.pid=void 0);const Z=b(this.detected,te.host,te.port);Z&&(Z.runningProcess=void 0,Z.hasRunningProcess=!1,Z.pid=void 0)}),I}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const T=Array.from(this.forwarded.values()),I=await this.getAttributes(T.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(I)for(const O of T){const j=I.get(O.remotePort);(j?.protocol||O.protocol!==y.TunnelProtocol.Http)&&j?.protocol!==O.protocol&&await this.fb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},j),j&&j.label&&j.label!==O.name&&await this.name(O.remoteHost,O.remotePort,j.label)}}async getAttributes(T,I=!0){const O=new Map,j=new Map;T.forEach(X=>{const ae=b(this.m??new Map,y.$Uv[0],X.port)??X;if(ae){O.set(X.port,ae);const _=P(ae)?ae.pid:void 0;j.has(_)||j.set(_,[]),j.get(_)?.push(X.port)}});const G=new Map;if(T.forEach(X=>{const ae=this.configPortsAttributes.getAttributes(X.port,X.host,O.get(X.port)?.detail);ae&&G.set(X.port,ae)}),this.G.length===0||!I)return G.size>0?G:void 0;const te=await Promise.all((0,N.$Rb)(this.G.map(X=>Array.from(j.entries()).map(ae=>{const _=ae[1],ge=O.get(_[0]);return X.providePortAttributes(_,ge?.pid,ge?.detail,i.CancellationToken.None)})))),x=new Map;if(te.forEach(X=>X.forEach(ae=>{ae&&x.set(ae.port,ae)})),!G&&!x)return;const Z=new Map;return T.forEach(X=>{const ae=G.get(X.port),_=x.get(X.port);Z.set(X.port,{elevateIfNeeded:ae?.elevateIfNeeded,label:ae?.label,onAutoForward:ae?.onAutoForward??F.providedActionToAction(_?.autoForwardAction),requireLocalPort:ae?.requireLocalPort,protocol:ae?.protocol})}),Z}addAttributesProvider(T){this.G.push(T)}};e.$FL=U,Qe([(0,L.$Lh)(1e3)],U.prototype,"cb",null),e.$FL=U=Qe([Ve(0,y.$Qv),Ve(1,S.$Jp),Ve(2,E.$Mi),Ve(3,m.$uL),Ve(4,v.$ll),Ve(5,u.$pi),Ve(6,C.$Aj),Ve(7,M.$jw),Ve(8,o.$WF),Ve(9,c.$yj)],U)}),define(Se[94],De([1,0]),function(fe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$jK=e.$iK=void 0;class l{constructor(R,w){this.line=R,this.character=w}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,w){return new l(0,0)}with(R){return new l(0,0)}}e.$iK=l;class N{constructor(R,w,p,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new l(R,w),this.end=new l(p,E)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$jK=N;var L;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(L||(e.TextSearchCompleteMessageType=L={}))}),define(Se[36],De([1,0,19,35,24,34,14,5,17,13,94,8]),function(fe,e,l,N,L,A,R,w,p,E,M,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.SearchErrorCode=e.$yK=e.$xK=e.SearchSortOrder=e.ViewMode=e.$wK=e.$vK=e.$uK=e.$tK=e.SearchCompletionExitCode=e.$sK=e.$rK=e.$qK=e.QueryType=e.SearchProviderType=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return M.TextSearchCompleteMessageType}}),e.$kK="workbench.view.search",e.$lK="workbench.panel.search",e.$mK="workbench.view.search",e.$nK="search-result",e.$oK="search.exclude";const v="\u27EA ",S=" characters skipped \u27EB",y=(v.length+S.length+5)*2;e.$pK=(0,w.$gi)("searchService");var u;(function(X){X[X.file=0]="file",X[X.text=1]="text",X[X.aiText=2]="aiText"})(u||(e.SearchProviderType=u={}));var m;(function(X){X[X.File=1]="File",X[X.Text=2]="Text",X[X.aiText=3]="aiText"})(m||(e.QueryType=m={}));function o(X){return!!X.preview}e.$qK=o;function i(X){return!!X.resource}e.$rK=i;function n(X){return!!X.message}e.$sK=n;var r;(function(X){X[X.Normal=0]="Normal",X[X.NewSearchStarted=1]="NewSearchStarted"})(r||(e.SearchCompletionExitCode=r={}));class c{constructor(ae){this.resource=ae,this.results=[]}}e.$tK=c;class t{constructor(ae,_,ge,se){this.ranges=_,this.webviewIndex=se;const re=Array.isArray(_)?_:[_];if(ge&&ge.matchLines===1&&f(re)){ae=(0,R.$Mf)(ae,ge.matchLines);let B="",ie=0,ke=0;const le=Math.floor(ge.charsPerLine/5),ue=[];for(const ce of re){const de=Math.max(ce.startColumn-le,0),H=ce.startColumn+ge.charsPerLine;if(de>ke+le+y){const Y=v+(de-ke)+S;B+=Y+ae.slice(de,H),ie+=de-(ke+Y.length)}else B+=ae.slice(ke,H);ue.push(new s(0,ce.startColumn-ie,ce.endColumn-ie)),ke=H}this.preview={text:B,matches:Array.isArray(this.ranges)?ue:ue[0]}}else{const B=Array.isArray(_)?_[0].startLineNumber:_.startLineNumber;this.preview={text:ae,matches:(0,l.$2b)(_,ie=>new h(ie.startLineNumber-B,ie.startColumn,ie.endLineNumber-B,ie.endColumn))}}}}e.$uK=t;function f(X){const ae=X[0].startLineNumber;for(const _ of X)if(_.startLineNumber!==ae||_.endLineNumber!==ae)return!1;return!0}class h{constructor(ae,_,ge,se){this.startLineNumber=ae,this.startColumn=_,this.endLineNumber=ge,this.endColumn=se}}e.$vK=h;class s extends h{constructor(ae,_,ge){super(ae,_,ae,ge)}}e.$wK=s;var a;(function(X){X.List="list",X.Tree="tree"})(a||(e.ViewMode=a={}));var d;(function(X){X.Default="default",X.FileNames="fileNames",X.Type="type",X.Modified="modified",X.CountDescending="countDescending",X.CountAscending="countAscending"})(d||(e.SearchSortOrder=d={}));function $(X,ae=!0){const _=X&&X.files&&X.files.exclude,ge=ae&&X&&X.search&&X.search.exclude;if(!_&&!ge)return;if(!_||!ge)return _||ge;let se=Object.create(null);return se=L.$On(se,L.$Ln(_)),se=L.$On(se,L.$Ln(ge),!0),se}e.$xK=$;function D(X,ae){return X.excludePattern&&N.$Yj(X.excludePattern,ae)?!1:X.includePattern||X.usingSearchPaths?X.includePattern&&N.$Yj(X.includePattern,ae)?!0:X.usingSearchPaths?!!X.folderQueries&&X.folderQueries.some(_=>{const ge=_.folder.fsPath;if(A.$gg(ae,ge)){const se=p.$lc(ge,ae);return!_.includePattern||!!N.$Yj(_.includePattern,se)}else return!1}):!1:!0}e.$yK=D;var b;(function(X){X[X.unknownEncoding=1]="unknownEncoding",X[X.regexParseError=2]="regexParseError",X[X.globParseError=3]="globParseError",X[X.invalidLiteral=4]="invalidLiteral",X[X.rgProcessError=5]="rgProcessError",X[X.other=6]="other",X[X.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class g extends Error{constructor(ae,_){super(ae),this.code=_}}e.$zK=g;function k(X){const ae=X.message;if((0,E.$4)(X))return new g(ae,b.canceled);try{const _=JSON.parse(ae);return new g(_.message,_.code)}catch{return new g(ae,b.other)}}e.$AK=k;function P(X){const ae={message:X.message,code:X.code};return new Error(JSON.stringify(ae))}e.$BK=P;function F(X){return X.type==="error"?!0:X.type==="success"}e.$CK=F;function U(X){return X.type==="success"}e.$DK=U;function z(X){return!!X.path}e.$EK=z;function T(X,ae,_=!0){const ge=X.searchPath?X.searchPath:X.relativePath;return _?(0,R.$Jf)(ge,ae):N.$Yj(ae,ge)}e.$FK=T;class I{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$GK=I;function O(X,ae){const _={...X||{},...ae||{}};return Object.keys(_).filter(ge=>{const se=_[ge];return typeof se=="boolean"&&se})}e.$HK=O;class j{constructor(ae,_){this.c=null,this.a={...ae.excludePattern||{},..._.excludePattern||{}},this.b=N.$Zj(this.a);let ge=ae.includePattern;_.includePattern&&(ge?ge={...ge,..._.includePattern}:ge=_.includePattern),ge&&(this.c=N.$Zj(ge))}matchesExcludesSync(ae,_,ge){return!!(this.b&&this.b(ae,_,ge))}includedInQuerySync(ae,_,ge){return!(this.b&&this.b(ae,_,ge)||this.c&&!this.c(ae,_,ge))}includedInQuery(ae,_,ge){const se=this.b(ae,_,ge),re=()=>this.c?!!this.c(ae,_,ge):!0;return(0,C.$5g)(se)?se.then(B=>B?!1:re()):re()}hasSiblingExcludeClauses(){return G(this.a)}}e.$IK=j;function G(X){for(const ae in X)if(typeof X[ae]!="boolean")return!0;return!1}function te(X){if(!X)return;let ae;return _=>(ae||(ae=(X()||Promise.resolve([])).then(ge=>ge?Z(ge):{})),ae.then(ge=>!!ge[_]))}e.$JK=te;function x(X){if(!X)return;let ae;return _=>{if(!ae){const ge=X();ae=ge?Z(ge):{}}return!!ae[_]}}e.$KK=x;function Z(X){const ae={};for(const _ of X)ae[_]=!0;return ae}}),define(Se[41],De([1,0,19,8,22,4,3,76,15,125,23,14,2,227,5,12,258,40,59,27,20,16,7,65,36,6,56]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=e.$oic=void 0;function d(U,z,T){return new M.$Ig(I=>g(I,T)).isEqual(U,z)}function $(U,z,T){return d(U.uri,z.uri,T)?0:(0,C.$df)(U.uri.toString(),z.uri.toString())}function D(U,z,T){return U.index!==z.index?U.index<z.index?-1:1:d(U.uri,z.uri,T)?(0,C.$df)(U.name,z.name):(0,C.$df)(U.uri.toString(),z.uri.toString())}function b(U,z,T,I){const O=U.slice(0).sort((G,te)=>T(G,te,I)),j=z.slice(0).sort((G,te)=>T(G,te,I));return(0,l.$Eb)(O,j,(G,te)=>T(G,te,I))}function g(U,z){const T=z.getCapabilities(U.scheme);return!(T&&T&1024)}class k extends o.$zi{static toExtHostWorkspace(z,T,I,O){if(!z)return{workspace:null,added:[],removed:[]};const{id:j,name:G,folders:te,configuration:x,transient:Z,isUntitled:X}=z,ae=[],_=T;T?te.forEach((B,ie)=>{const ke=v.URI.revive(B.uri),le=k.o(I||T,ke,O);le?(le.name=B.name,le.index=B.index,ae.push(le)):ae.push({uri:ke,name:B.name,index:ie})}):ae.push(...te.map(({uri:B,name:ie,index:ke})=>({uri:v.URI.revive(B),name:ie,index:ke}))),ae.sort((B,ie)=>B.index<ie.index?-1:1);const ge=new k(j,G,ae,!!Z,x?v.URI.revive(x):null,!!X,B=>g(B,O)),{added:se,removed:re}=b(_?_.workspaceFolders:[],ge.workspaceFolders,$,O);return{workspace:ge,added:se,removed:re}}static o(z,T,I){for(let O=0;O<z.folders.length;O++){const j=z.workspaceFolders[O];if(d(j.uri,T,I))return j}}constructor(z,T,I,O,j,G,te){super(z,I.map(x=>new o.$Ai(x)),O,j,te),this.t=T,this.u=G,this.q=[],this.s=w.$mi.forUris(te),I.forEach(x=>{this.q.push(x),this.s.set(x.uri,x)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(z,T){return T&&this.s.get(z)&&(z=(0,M.$Sg)(z)),this.s.findSubstr(z)}resolveWorkspaceFolder(z){return this.s.get(z)}}let P=class{constructor(z,T,I,O,j){this.c=new A.$6d,this.onDidChangeWorkspace=this.c.event,this.g=new A.$6d,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new A.$8d,this.C=new Map,this.h=O,this.s=I,this.t=j,this.j=new E.$hm,this.k=new N.$fh,this.o=z.getProxy(s.$0L.MainThreadWorkspace),this.q=z.getProxy(s.$0L.MainThreadMessageService);const G=T.workspace;this.l=G?new k(G.id,G.name,[],!!G.transient,G.configuration?v.URI.revive(G.configuration):null,!!G.isUntitled,te=>g(te,I)):void 0}$initializeWorkspace(z,T){this.v=T,this.$acceptWorkspaceData(z),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?v.URI.from({scheme:p.Schemas.untitled,path:(0,M.$Qg)((0,M.$Sg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(z,T,I,...O){const j=[];if(Array.isArray(O)&&O.forEach(X=>{v.URI.isUri(X.uri)&&!j.some(ae=>d(ae.uri,X.uri,this.s))&&j.push({uri:X.uri,name:X.name||(0,M.$Pg)(X.uri)})}),this.n||[T,I].some(X=>typeof X!="number"||X<0)||I===0&&j.length===0)return!1;const G=this.x?this.x.workspaceFolders:[];if(T+I>G.length)return!1;const te=G.slice(0);te.splice(T,I,...j.map(X=>({uri:X.uri,name:X.name||(0,M.$Pg)(X.uri),index:void 0})));for(let X=0;X<te.length;X++){const ae=te[X];if(te.some((_,ge)=>ge!==X&&d(ae.uri,_.uri,this.s)))return!1}te.forEach((X,ae)=>X.index=ae);const{added:x,removed:Z}=b(G,te,D,this.s);if(x.length===0&&Z.length===0)return!1;if(this.o){const X=z.displayName||z.name;this.o.$updateWorkspaceFolders(X,T,I,j).then(void 0,ae=>{this.n=void 0;const _={source:{identifier:z.identifier,label:z.displayName||z.name}};this.q.$showMessage(m.Severity.Error,(0,S.localize)(0,null,X,ae.toString()),_,[])})}return this.y(te),!0}getWorkspaceFolder(z,T){if(this.x)return this.x.getWorkspaceFolder(z,T)}async getWorkspaceFolder2(z,T){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(z,T)}async resolveWorkspaceFolder(z){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(z)}getPath(){if(!this.x)return;const{folders:z}=this.x;if(z.length!==0)return z[0].uri.fsPath}getRelativePath(z,T){let I,O="";if(typeof z=="string"?(I=v.URI.file(z),O=z):typeof z<"u"&&(I=z,O=z.fsPath),!I)return O;const j=this.getWorkspaceFolder(I,!0);if(!j)return O;typeof T>"u"&&this.x&&(T=this.x.folders.length>1);let G=(0,M.$Vg)(j.uri,I);return T&&j.name&&(G=`${j.name}/${G}`),G}y(z){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:z,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(z){const{workspace:T,added:I,removed:O}=k.toExtHostWorkspace(z,this.l,this.n,this.s);this.l=T||void 0,this.n=void 0,this.c.fire(Object.freeze({added:I,removed:O}))}findFiles(z,T,I,O,j=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${O.value}, entryPoint: findFiles`);let G="",te=!0;return T===null?te=!1:T!==void 0&&(typeof T=="string"?G=T:G=T.pattern),this.z(z,void 0,{exclude:G,maxResults:I,useDefaultExcludes:te,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},j)}findFiles2(z,T={},I,O=L.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${I.value}, entryPoint: findFiles2`),this.z(void 0,z,T,O)}async z(z,T,I,O=L.CancellationToken.None){if(O&&O.isCancellationRequested)return Promise.resolve([]);const j=typeof I.exclude=="string"?I.exclude:I.exclude?I.exclude.pattern:void 0,G={ignoreSymlinks:typeof I.followSymlinks=="boolean"?!I.followSymlinks:void 0,disregardIgnoreFiles:typeof I.useIgnoreFiles=="boolean"?!I.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof I.useGlobalIgnoreFiles=="boolean"?!I.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof I.useParentIgnoreFiles=="boolean"?!I.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof I.useDefaultExcludes=="boolean"?!I.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof I.useDefaultSearchExcludes=="boolean"?!I.useDefaultSearchExcludes:!1,maxResults:I.maxResults,excludePattern:j,shouldGlobSearch:typeof I.fuzzy=="boolean"?!I.fuzzy:!0,_reason:"startFileSearch"};let te;if(z){const{includePattern:x,folder:Z}=F(c.GlobPattern.from(z));te=Z,G.includePattern=x}else{const{includePattern:x,folder:Z}=F(c.GlobPattern.from(T));te=Z,G.filePattern=x}return this.o.$startFileSearch(te??null,G,O).then(x=>Array.isArray(x)?x.map(Z=>v.URI.revive(Z)):[])}async findTextInFiles(z,T,I,O,j=L.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${O.value}, entryPoint: findTextInFiles`);const G=this.j.getNext(),te=typeof T.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:T.previewOptions,{includePattern:x,folder:Z}=F(c.GlobPattern.from(T.include)),X=typeof T.exclude=="string"?T.exclude:T.exclude?T.exclude.pattern:void 0,ae={ignoreSymlinks:typeof T.followSymlinks=="boolean"?!T.followSymlinks:void 0,disregardIgnoreFiles:typeof T.useIgnoreFiles=="boolean"?!T.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof T.useGlobalIgnoreFiles=="boolean"?!T.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof T.useParentIgnoreFiles=="boolean"?!T.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof T.useDefaultExcludes=="boolean"?!T.useDefaultExcludes:!0,fileEncoding:T.encoding,maxResults:T.maxResults,previewOptions:te,afterContext:T.afterContext,beforeContext:T.beforeContext,includePattern:x,excludePattern:X},_=!1;if(this.u[G]=ge=>{if(_)return;const se=v.URI.revive(ge.resource);ge.results.forEach(re=>{const B=(0,a.$Ph)(re);(0,h.$qK)(B)?I({uri:se,preview:{text:B.preview.text,matches:(0,l.$2b)(B.preview.matches,ie=>new t.$bM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,l.$2b)(B.ranges,ie=>new t.$bM(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):I({uri:se,text:B.text,lineNumber:B.lineNumber})})},j.isCancellationRequested)return{};try{const ge=await this.o.$startTextSearch(z,Z??null,ae,G,j);return delete this.u[G],ge||{}}catch(ge){throw delete this.u[G],ge}}$handleTextSearchResult(z,T){this.u[T]?.(z)}async save(z){const T=await this.o.$save(z,{saveAs:!1});return v.URI.revive(T)}async saveAs(z){const T=await this.o.$save(z,{saveAs:!0});return v.URI.revive(T)}saveAll(z){return this.o.$saveAll(z)}resolveProxy(z){return this.o.$resolveProxy(z)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(z){return this.o.$requestWorkspaceTrust(z)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(z,T){if(this.w.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.w.set(z,T);const I=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerEditSessionIdentityProvider(O,I),(0,R.$Rc)(()=>{this.w.delete(z),this.o.$unregisterEditSessionIdentityProvider(O)})}async $getEditSessionIdentifier(z,T){this.h.info("Getting edit session identifier for workspaceFolder",z);const I=await this.resolveWorkspaceFolder(v.URI.revive(z));if(!I){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",I);const O=this.w.get(I.uri.scheme);if(this.h.info(`Provider for scheme ${I.uri.scheme} is defined: `,!!O),!O)return;const j=await O.provideEditSessionIdentity(I,T);if(this.h.info("Provider returned edit session identifier: ",j),!!j)return j}async $provideEditSessionIdentityMatch(z,T,I,O){this.h.info("Getting edit session identifier for workspaceFolder",z);const j=await this.resolveWorkspaceFolder(v.URI.revive(z));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const G=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!G),!G)return;const te=await G.provideEditSessionIdentityMatch?.(T,I,O);if(this.h.info("Provider returned edit session identifier match result: ",te),!!te)return te}getOnWillCreateEditSessionIdentityEvent(z){return(T,I,O)=>{const j=function(te){T.call(I,te)};return j.extension=z,this.B.event(j,void 0,O)}}async $onWillCreateEditSessionIdentity(z,T,I){const O=await this.resolveWorkspaceFolder(v.URI.revive(z));if(O===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:O},T,async(j,G)=>{const te=Date.now();await Promise.resolve(j),Date.now()-te>I&&this.h.warn("SLOW edit session create-participant",G.extension.identifier)}),T.isCancellationRequested}registerCanonicalUriProvider(z,T){if(this.C.has(z))throw new Error(`A provider has already been registered for scheme ${z}`);this.C.set(z,T);const I=this.t.transformOutgoingScheme(z),O=this.A++;return this.o.$registerCanonicalUriProvider(O,I),(0,R.$Rc)(()=>{this.C.delete(z),this.o.$unregisterCanonicalUriProvider(O)})}async provideCanonicalUri(z,T,I){const O=this.C.get(z.scheme);if(!O)return;const j=await O.provideCanonicalUri?.(v.URI.revive(z),T,I);if(j)return j}async $provideCanonicalUri(z,T,I){return this.provideCanonicalUri(v.URI.revive(z),{targetScheme:T},I)}};e.$oic=P,e.$oic=P=Qe([Ve(0,r.$pO),Ve(1,n.$FO),Ve(2,i.$7hc),Ve(3,u.$Aj),Ve(4,f.$mic)],P),e.$pic=(0,y.$gi)("IExtHostWorkspace");function F(U){let z,T;return U&&(typeof U=="string"?z=U:(z=U.pattern,T=v.URI.revive(U.baseUri))),{includePattern:z,folder:T}}}),define(Se[42],De([1,0,24,4,41,6,7,260,85,18,8,5,20,12,2]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=e.$qic=void 0;function u(f,h){if(h){const s=h.split(".");let a=f;for(let d=0;a&&d<s.length;d++)a=a[s[d]];return a}}function m(f){return f instanceof y.URI}function o(f){return f&&f.uri instanceof y.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function n(f){return f&&f.uri instanceof y.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function r(f){if(m(f))return{resource:f};if(o(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(n(f))return{resource:f.uri};if(f===null)return{resource:null}}let c=class{constructor(h,s,a){this.a=h.getProxy(A.$0L.MainThreadConfiguration),this.c=s,this.b=a,this.d=new M.$fh,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,s){this.getConfigProvider().then(a=>a.$acceptConfigurationChanged(h,s))}};e.$qic=c,e.$qic=c=Qe([Ve(0,v.$pO),Ve(1,L.$pic),Ve(2,S.$Aj)],c);class t{constructor(h,s,a,d){this.a=new N.$6d,this.b=h,this.f=d,this.c=s,this.e=w.$jo.parse(a),this.d=this.k(a.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,s){const a={data:this.e.toData(),workspace:this.c.workspace};this.e=w.$jo.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(s,a))}getConfiguration(h,s,a){const d=r(s)||{},$=this.g(h?u(this.e.getValue(void 0,d,this.c.workspace),h):this.e.getValue(void 0,d,this.c.workspace));h&&this.h(h,d,a?.identifier);function D(g){if(g==null)return null;if(typeof g=="boolean")return g?2:5;switch(g){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(g){return typeof u($,g)<"u"},get:(g,k)=>{this.h(h?`${h}.${g}`:g,d,a?.identifier);let P=u($,g);if(typeof P>"u")P=k;else{let F;const U=(z,T)=>{if((0,E.$Vf)(z)){let I;const O=()=>{F=F||(0,l.$Ln)($),I=I||u(F,T)};return new Proxy(z,{get:(j,G)=>{if(typeof G=="string"&&G.toLowerCase()==="tojson")return O(),()=>I;if(F)return I=I||u(F,T),I[G];const te=j[G];return typeof G=="string"?U(te,`${T}.${G}`):te},set:(j,G,te)=>(O(),I&&(I[G]=te),!0),deleteProperty:(j,G)=>(O(),I&&delete I[G],!0),defineProperty:(j,G,te)=>(O(),I&&Object.defineProperty(I,G,te),!0)})}return Array.isArray(z)?(0,l.$Ln)(z):z};P=U(P,g)}return P},update:(g,k,P,F)=>{g=h?`${h}.${g}`:g;const U=D(P);return k!==void 0?this.b.$updateConfigurationOption(U,g,k,d,F):this.b.$removeConfigurationOption(U,g,d,F)},inspect:g=>{g=h?`${h}.${g}`:g;const k=this.e.inspect(g,d,this.c.workspace);if(k)return{key:g,defaultValue:(0,l.$Ln)(k.policy?.value??k.default?.value),globalValue:(0,l.$Ln)(k.user?.value??k.application?.value),workspaceValue:(0,l.$Ln)(k.workspace?.value),workspaceFolderValue:(0,l.$Ln)(k.workspaceFolder?.value),defaultLanguageValue:(0,l.$Ln)(k.default?.override),globalLanguageValue:(0,l.$Ln)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,l.$Ln)(k.workspace?.override),workspaceFolderLanguageValue:(0,l.$Ln)(k.workspaceFolder?.override),languageIds:(0,l.$Ln)(k.overrideIdentifiers)}}};return typeof $=="object"&&(0,l.$On)(b,$,!1),Object.freeze(b)}g(h){const s=a=>(0,E.$Vf)(a)?new Proxy(a,{get:(d,$)=>s(d[$]),set:(d,$,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String($)}' of object`)},deleteProperty:(d,$)=>{throw new Error(`TypeError: Cannot delete read only property '${String($)}' of object`)},defineProperty:(d,$)=>{throw new Error(`TypeError: Cannot define property '${String($)}' for a readonly object`)},setPrototypeOf:d=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):a;return s(h)}h(h,s,a){const d=p.$ao.test(h)?4:this.d.get(h),$=a?`[${a.value}] `:"";if(d===4){typeof s?.resource>"u"&&this.f.warn(`${$}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(d===3){s?.resource&&this.f.warn(`${$}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,s){const a=new w.$lo(h,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(d,$)=>a.affectsConfiguration(d,r($))})}k(h){return h.reduce((s,a)=>(s.set(a[0],a[1]),s),new Map)}}e.$ric=t,e.$sic=(0,C.$gi)("IExtHostConfiguration")}),define(Se[95],De([1,0,2,8,4,6,7,41,71,42,22,46,20,27,5,15,11,12,91,302,13]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vjc=e.$Ujc=e.$Tjc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var c;(function(U){function z(I){if(I!=null)return I}U.from=z;function T(I){if(I!=null)return I}U.to=T})(c||(c={}));var t;(function(U){function z(I){if(I!=null)return I}U.from=z;function T(I){if(I!=null)return I}U.to=T})(t||(t={}));var f;(function(U){function z(I){if(I!=null)return I}U.from=z;function T(I){if(I!=null)return I}U.to=T})(f||(f={}));var h;(function(U){function z(O){if(O){const j=O;return j&&!!j.process}else return!1}U.is=z;function T(O){if(O==null)return;const j={process:O.process,args:O.args};return O.options&&(j.options=f.from(O.options)),j}U.from=T;function I(O){if(O!=null)return new R.$UM(O.process,O.args,O.options)}U.to=I})(h||(h={}));var s;(function(U){function z(I){if(I!=null)return I}U.from=z;function T(I){if(I!=null)return I}U.to=T})(s||(s={}));var a;(function(U){function z(O){if(O){const j=O;return j&&(!!j.commandLine||!!j.command)}else return!1}U.is=z;function T(O){if(O==null)return;const j={};return O.commandLine!==void 0?j.commandLine=O.commandLine:(j.command=O.command,j.args=O.args),O.options&&(j.options=s.from(O.options)),j}U.from=T;function I(O){if(!(O==null||O.command===void 0&&O.commandLine===void 0))return O.commandLine?new R.$VM(O.commandLine,O.options):new R.$VM(O.command,O.args?O.args:[],O.options)}U.to=I})(a||(a={}));var d;(function(U){function z(O){if(O){const j=O;return j&&j.customExecution==="customExecution"}else return!1}U.is=z;function T(O){return{customExecution:"customExecution"}}U.from=T;function I(O,j){return j.get(O)}U.to=I})(d||(e.CustomExecutionDTO=d={}));var $;(function(U){function z(T,I){let O;return T.scope!==void 0&&typeof T.scope!="number"?O=T.scope.uri:T.scope!==void 0&&typeof T.scope=="number"&&(T.scope===R.TaskScope.Workspace&&I&&I.workspaceFile?O=I.workspaceFile:O=n.$jH),{id:T._id,workspaceFolder:O}}U.from=z})($||(e.TaskHandleDTO=$={}));var D;(function(U){function z(T){if(T!=null)return{_id:T.id,isDefault:T.isDefault}}U.from=z})(D||(D={}));var b;(function(U){function z(O,j){if(O==null)return[];const G=[];for(const te of O){const x=T(te,j);x&&G.push(x)}return G}U.fromMany=z;function T(O,j){if(O==null)return;let G;O.execution instanceof R.$UM?G=h.from(O.execution):O.execution instanceof R.$VM?G=a.from(O.execution):O.execution&&O.execution instanceof R.$WM&&(G=d.from(O.execution));const te=c.from(O.definition);let x;return O.scope?typeof O.scope=="number"?x=O.scope:x=O.scope.uri:x=R.TaskScope.Workspace,!te||!x?void 0:{_id:O._id,definition:te,name:O.name,source:{extensionId:j.identifier.value,label:O.source,scope:x},execution:G,isBackground:O.isBackground,group:D.from(O.group),presentationOptions:t.from(O.presentationOptions),problemMatchers:O.problemMatchers,hasDefinedMatchers:O.hasDefinedMatchers,runOptions:O.runOptions?O.runOptions:{reevaluateOnRerun:!0},detail:O.detail}}U.from=T;async function I(O,j,G){if(O==null)return;let te;h.is(O.execution)?te=h.to(O.execution):a.is(O.execution)?te=a.to(O.execution):d.is(O.execution)&&(te=d.to(O._id,G));const x=c.to(O.definition);let Z;if(O.source&&(O.source.scope!==void 0?typeof O.source.scope=="number"?Z=O.source.scope:Z=await j.resolveWorkspaceFolder(l.URI.revive(O.source.scope)):Z=R.TaskScope.Workspace),!x||!Z)return;const X=new R.$XM(x,Z,O.name,O.source.label,te,O.problemMatchers);return O.isBackground!==void 0&&(X.isBackground=O.isBackground),O.group!==void 0&&(X.group=R.$TM.from(O.group._id),X.group&&O.group.isDefault&&(X.group=new R.$TM(X.group.id,X.group.label),O.group.isDefault===!0&&(X.group.isDefault=O.group.isDefault))),O.presentationOptions&&(X.presentationOptions=t.to(O.presentationOptions)),O._id&&(X._id=O._id),O.detail&&(X.detail=O.detail),X}U.to=I})(b||(e.TaskDTO=b={}));var g;(function(U){function z(I){return I}U.from=z;function T(I){if(I)return Object.assign(Object.create(null),I)}U.to=T})(g||(g={}));class k{#e;constructor(z,T,I){this._id=T,this.a=I,this.#e=z}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(z){}fireDidEndProcess(z){}}let P=class{constructor(z,T,I,O,j,G,te,x){this.q=new L.$6d,this.r=new L.$6d,this.s=new L.$6d,this.u=new L.$6d,this.a=z.getProxy(A.$0L.MainThreadTask),this.b=I,this.c=O,this.d=j,this.e=G,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=te,this.g=x,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(z,T,I){if(!I)return new R.$_L(()=>{});const O=this.x();return this.j.set(O,{type:T,provider:I,extension:z}),this.a.$registerTaskProvider(O,T),new R.$_L(()=>{this.j.delete(O),this.a.$unregisterTaskProvider(O)})}registerTaskSystem(z,T){this.a.$registerTaskSystem(z,T)}fetchTasks(z){return this.a.$fetchTasks(g.from(z)).then(async T=>{const I=[];for(const O of T){const j=await b.to(O,this.b,this.m);j&&I.push(j)}return I})}get taskExecutions(){const z=[];return this.k.forEach(T=>z.push(T)),z}terminateTask(z){if(!(z instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(z._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(z,T,I){const O=this.m.get(z.id);O&&(this.o.set(z.id,O),this.e.attachPtyToTerminal(T,await O.callback(I))),this.p=z.id,this.q.fire({execution:await this.z(z)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(z){if(!this.l.has(z.id))return;const T=await this.z(z);this.l.delete(z.id),this.k.delete(z.id),this.B(z),this.r.fire({execution:T})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(z){const T=await this.z(z.id);this.s.fire({execution:T,processId:z.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(z){const T=await this.z(z.id);this.u.fire({execution:T,exitCode:z.exitCode})}$provideTasks(z,T){const I=this.j.get(z);if(!I)return Promise.reject(new Error("no handler found"));const O=[],j=(0,N.$$g)(()=>I.provider.provideTasks(M.CancellationToken.None)).then(G=>this.v(T,O,I,G));return new Promise(G=>{j.then(te=>{Promise.all(O).then(()=>{G(te)})})})}async $resolveTask(z,T){const I=this.j.get(z);if(!I)return Promise.reject(new Error("no handler found"));if(T.definition.type!==I.type)throw new Error(`Unexpected: Task of type [${T.definition.type}] cannot be resolved by provider of type [${I.type}].`);const O=await b.to(T,this.b,this.m);if(!O)throw new Error("Unexpected: Task cannot be resolved.");const j=await I.provider.resolveTask(O,M.CancellationToken.None);if(!j)return;this.A(j,I);const G=b.from(j,I.extension);if(!G)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==O.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return d.is(G.execution)&&await this.y(G,j,!0),await this.w(G)}x(){return this.h++}async y(z,T,I){const O=await this.a.$createTaskId(z);!I&&!this.m.has(O)&&(this.n.add(O),this.o.set(O,T.execution)),this.m.set(O,T.execution)}async z(z,T){if(typeof z=="string"){const j=this.l.get(z);if(!j)throw new r.$bb("Unexpected: The specified task is missing an execution");return j}const I=this.l.get(z.id);if(I)return I;let O;return T?O=Promise.resolve(new k(this,z.id,T)):O=b.to(z.task,this.b,this.m).then(j=>{if(!j)throw new r.$bb("Unexpected: Task does not exist.");return new k(this,z.id,j)}),this.l.set(z.id,O),O.then(j=>(this.k.set(z.id,j),j))}A(z,T){z._deprecated&&this.g.report("Task.constructor",T.extension,"Use the Task constructor that takes a `scope` instead.")}B(z){this.o.get(z.id)&&this.o.delete(z.id),this.n.has(z.id)&&this.p!==z.id&&(this.m.delete(z.id),this.n.delete(z.id));const I=this.n.values();let O=I.next();for(;!O.done;)!this.o.has(O.value)&&this.p!==O.value&&(this.m.delete(O.value),this.n.delete(O.value)),O=I.next()}};e.$Tjc=P,e.$Tjc=P=Qe([Ve(0,v.$pO),Ve(1,S.$FO),Ve(2,w.$pic),Ve(3,p.$AO),Ve(4,E.$sic),Ve(5,C.$Qic),Ve(6,o.$Aj),Ve(7,i.$3hc)],P);let F=class extends P{constructor(z,T,I,O,j,G,te,x){super(z,T,I,O,j,G,te,x),this.registerTaskSystem(u.Schemas.vscodeRemote,{scheme:u.Schemas.vscodeRemote,authority:"",platform:m.$h(0)})}async executeTask(z,T){if(!T.execution)throw new Error("Tasks to execute must include an execution");const I=b.from(T,z);if(I===void 0)throw new Error("Task is not valid");if(d.is(I.execution))await this.y(I,T,!1);else throw new r.$_;const O=await this.z(await this.a.$getTaskExecution(I),T);return this.a.$executeTask(I).catch(j=>{throw new Error(j)}),O}v(z,T,I,O){const j=[];if(O)for(const G of O){if(this.A(G,I),!G.definition||!z[G.definition.type]){const x=G.source?G.source:"No task source";this.f.warn(`The task [${x}, ${G.name}] uses an undefined task type. The task will be ignored in the future.`)}const te=b.from(G,I.extension);te&&d.is(te.execution)?(j.push(te),T.push(this.y(te,G,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:I.extension}}async w(z){if(d.is(z.execution))return z;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(z,T){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(z,T,I){}};e.$Ujc=F,e.$Ujc=F=Qe([Ve(0,v.$pO),Ve(1,S.$FO),Ve(2,w.$pic),Ve(3,p.$AO),Ve(4,E.$sic),Ve(5,C.$Qic),Ve(6,o.$Aj),Ve(7,i.$3hc)],F),e.$Vjc=(0,y.$gi)("IExtHostTask")}),define(Se[364],De([1,0,36,29]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SK=e.$RK=e.$QK=void 0;function L(R){return"cellResults"in R}e.$QK=L,e.$RK="rawCell#";function A(R,w){let p=-1;const E=[];let M=[];return R.forEach(v=>{v.range.startLineNumber!==p&&M.length>0&&(E.push([...M]),M=[]),M.push(v),p=v.range.endLineNumber}),M.length>0&&E.push([...M]),E.map(v=>{const S=[],y=v[0].range.startLineNumber,u=v[v.length-1].range.endLineNumber;for(let m=y;m<=u;m++)S.push(w.getLineContent(m));return new l.$uK(S.join(`
`)+`
`,v.map(m=>new N.$0s(m.range.startLineNumber-1,m.range.startColumn-1,m.range.endLineNumber-1,m.range.endColumn-1)))})}e.$SK=A}),define(Se[365],De([1,0,221,21,4,3,28,14,18,2,32,111,6,33,16,7,67,335,153,24,15,292,364,361]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vjc=void 0;class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(a=>a.apiEditor)}constructor(a,d,$,D,b,g){this.q=$,this.r=D,this.s=b,this.t=g,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new L.$6d,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.$6d,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.$6d,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.$6d,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$1hc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=a.getProxy(v.$0L.MainThreadNotebook),this.c=a.getProxy(v.$0L.MainThreadNotebookDocuments),this.d=a.getProxy(v.$0L.MainThreadNotebookEditors),this.i=d.converter,d.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const P=k.notebookEditor?.notebookUri,F=k.cell.handle,z=this.g.get(P)?.getCell(F);if(z)return z.apiCell}if(k&&k.$mid===14){const P=k.uri,F=this.g.get(P);if(F)return F.apiNotebook}return k}}),h.B(d)}getEditorById(a){const d=this.h.get(a);if(!d)throw new Error(`unknown text editor: ${a}. known editors: ${[...this.h.keys()]} `);return d}getIdByEditor(a){for(const[d,$]of this.h)if($.apiEditor===a)return d}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(a,d){const $=this.g.get(a);if(!$&&!d)throw new Error(`NO notebook document for '${a}'`);return $}static u(a,d){if(!d)return;const $=d.filenamePattern.map(D=>y.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(d.filenamePattern&&!$){console.warn(`Notebook content provider view options file name pattern is invalid ${d.filenamePattern}`);return}return{extension:a.identifier,providerDisplayName:a.displayName||a.name,displayName:d.displayName,filenamePattern:$,exclusive:d.exclusive||!1}}registerNotebookCellStatusBarItemProvider(a,d,$){const D=h.a++,b=typeof $.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(D,$),this.b.$registerNotebookCellStatusBarItemProvider(D,b,d);let g;return b!==void 0&&(g=$.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(b))),new u.$_L(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,b),g?.dispose()})}async createNotebookDocument(a){const d=await this.c.$tryCreateNotebook({viewType:a.viewType,content:a.content&&y.NotebookData.from(a.content)});return E.URI.revive(d)}async openNotebookDocument(a){const d=this.g.get(a);if(d)return d.apiNotebook;const $=await this.c.$tryOpenNotebook(a),D=this.g.get(E.URI.revive($));return(0,p.$5f)(D?.apiNotebook)}async showNotebookDocument(a,d){E.URI.isUri(a)&&(a=await this.openNotebookDocument(a));let $;typeof d=="object"?$={position:y.ViewColumn.from(d.viewColumn),preserveFocus:d.preserveFocus,selections:d.selections&&d.selections.map(y.NotebookRange.from),pinned:typeof d.preview=="boolean"?!d.preview:void 0}:$={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(a.uri,a.notebookType,$),b=D&&this.h.get(D)?.apiEditor;if(b)return b;throw D?new Error(`Could NOT open editor for "${a.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${a.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(a,d,$,D){const b=this.f.get(a),g=E.URI.revive(d),k=this.g.get(g);if(!k||!b)return;const P=k.getCellFromIndex($);if(!P)return;const F=await b.provideCellStatusBarItems(P.apiCell,D);if(!F)return;const U=new A.$Sc,z=this.p.add([U]),I=(Array.isArray(F)?F:[F]).map(O=>y.NotebookStatusBarItem.from(O,this.i,U));return{cacheId:z,items:I}}$releaseNotebookCellStatusBarItems(a){this.p.delete(a)}registerNotebookSerializer(a,d,$,D,b){if((0,w.$Te)(d))throw new Error("viewType cannot be empty or just whitespace");const g=this.w++;return this.x.set(g,{viewType:d,serializer:$,options:D}),this.b.$registerNotebookSerializer(g,{id:a.identifier,location:a.extensionLocation},d,y.NotebookDocumentContentOptions.from(D),h.u(a,b)),(0,A.$Rc)(()=>{this.b.$unregisterNotebookSerializer(g)})}async $dataToNotebook(a,d,$){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const b=await D.serializer.deserializeNotebook(d.buffer,$);return new m.$0v(y.NotebookData.from(b))}async $notebookToData(a,d,$){const D=this.x.get(a);if(!D)throw new Error("NO serializer found");const b=await D.serializer.serializeNotebook(y.NotebookData.to(d.value),$);return N.$te.wrap(b)}async $saveNotebook(a,d,$,D,b){const g=E.URI.revive(d),k=this.x.get(a);if(!k)throw new Error("NO serializer found");const P=this.g.get(g);if(!P)throw new Error("Document NOT found");if(P.versionId!==$)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(g.scheme))throw new M.$2k((0,l.localize)(0,null,this.z(g)),6);await this.y(g,D);const F={metadata:(0,n.$Tn)(P.apiNotebook.metadata,O=>!(k.options?.transientDocumentMetadata??{})[O]),cells:[]};for(const O of P.apiNotebook.getCells()){const j=new u.$AN(O.kind,O.document.getText(),O.document.languageId,O.mime,k.options?.transientOutputs?[]:[...O.outputs],O.metadata,O.executionSummary);j.metadata=(0,n.$Tn)(O.metadata,G=>!(k.options?.transientCellMetadata??{})[G]),F.cells.push(j)}const U=await k.serializer.serializeNotebook(F,b);await this.s.value.writeFile(g,U);const z=this.s.getFileSystemProviderExtUri(g.scheme),T=await this.s.value.stat(g);return{name:z.basename(g),isFile:(T.type&M.FileType.File)!==0,isDirectory:(T.type&M.FileType.Directory)!==0,isSymbolicLink:(T.type&M.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&M.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(g.scheme),locked:!!((T.permissions??0)&M.FilePermission.Locked),etag:M.$al({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(a,d,$,D,b){const g=this.x.get(a)?.serializer;if(!g)return{limitHit:!1,results:[]};const k=new R.$Bc;await(async(T,I,O)=>{await Promise.all(T.map(async j=>await Promise.all(j.filenamePatterns.map(G=>{const te={_reason:O._reason,folderQueries:O.folderQueries,includePattern:O.includePattern,excludePattern:O.excludePattern,maxResults:O.maxResults,type:1,filePattern:G};return this.t.doInternalFileSearchWithCustomCallback(te,I,x=>{x.forEach(Z=>{k.has(Z)||D.some(ae=>j.isFromSettings&&!ae.isFromSettings?!1:ae.filenamePatterns.some(_=>(0,f.$$eb)(_,Z)))||k.add(Z)})}).catch(x=>{if(x.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw x})}))))})($,b,d);const F=new R.$Ac;let U=!1;const z=Array.from(k).map(async T=>{const I=[];try{if(b.isCancellationRequested)return;if(d.maxResults&&[...F.values()].reduce((te,x)=>te+x.cellResults.length,0)>d.maxResults){U=!0;return}const O=[],j=this.g.get(T);if(j)j.apiNotebook.getCells().forEach(x=>O.push({input:x.document.getText(),outputs:x.outputs.flatMap(Z=>Z.items.map(X=>X.data.toString()))}));else{const te=await this.s.value.readFile(T),x=N.$te.fromString(te.toString()),Z=await g.deserializeNotebook(x.buffer,b);if(b.isCancellationRequested)return;y.NotebookData.from(Z).cells.forEach(ae=>O.push({input:ae.source,outputs:ae.outputs.flatMap(_=>_.items.map(ge=>ge.valueBytes.toString()))}))}if(b.isCancellationRequested)return;O.forEach((te,x)=>{const Z=d.contentPattern.pattern,X=new c.$FTb(te.input,void 0,te.outputs),ae=X.findInInputs(Z),_=X.findInOutputs(Z),ge=_.flatMap(se=>(0,t.$SK)(se.matches,se.textBuffer)).map((se,re)=>(se.webviewIndex=re,se));if(ae.length>0||_.length>0){const se={index:x,contentResults:(0,t.$SK)(ae,X.inputTextBuffer),webviewResults:ge};I.push(se)}});const G={resource:T,cellResults:I};F.set(T,G);return}catch{return}});return await Promise.all(z),{limitHit:U,results:[...F.values()]}}async y(a,d){const $=await this.s.value.stat(a);if(typeof d?.mtime=="number"&&typeof d.etag=="string"&&d.etag!==M.$_k&&typeof $.mtime=="number"&&typeof $.size=="number"&&d.mtime<$.mtime&&d.etag!==M.$al({mtime:d.mtime,size:$.size}))throw new M.$2k((0,l.localize)(1,null),3,d)}z(a){return a.scheme===r.Schemas.file?a.fsPath:a.toString()}A(a,d,$){if(this.h.has(d))throw new Error(`editor with id ALREADY EXSIST: ${d}`);const D=new i.$mjc(d,this.d,a,$.visibleRanges.map(y.NotebookRange.to),$.selections.map(y.NotebookRange.to),typeof $.viewColumn=="number"?y.ViewColumn.to($.viewColumn):void 0);this.h.set(d,D)}$acceptDocumentAndEditorsDelta(a){if(a.value.removedDocuments)for(const $ of a.value.removedDocuments){const D=E.URI.revive($),b=this.g.get(D);b&&(b.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(g=>g.document.uri)}),this.n.fire(b.apiNotebook));for(const g of this.h.values())g.notebookData.uri.toString()===D.toString()&&this.h.delete(g.id)}if(a.value.addedDocuments){const $=[];for(const D of a.value.addedDocuments){const b=E.URI.revive(D.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const g=new o.$ljc(this.c,this.q,this.r,b,D);$.push(...D.cells.map(k=>o.$kjc.asModelAddData(k))),this.g.get(b)?.dispose(),this.g.set(b,g),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:$}),this.m.fire(g.apiNotebook)}}if(a.value.addedEditors)for(const $ of a.value.addedEditors){if(this.h.has($.id))return;const D=E.URI.revive($.documentUri),b=this.g.get(D);b&&this.A(b,$.id,$)}const d=[];if(a.value.removedEditors)for(const $ of a.value.removedEditors){const D=this.h.get($);D&&(this.h.delete($),this.k?.id===D.id&&(this.k=void 0),d.push(D))}if(a.value.visibleEditors){this.l=a.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const $=new Set;this.l.forEach(D=>$.add(D.id));for(const D of this.h.values()){const b=$.has(D.id);D._acceptVisibility(b)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}a.value.newActiveEditor===null?this.k=void 0:a.value.newActiveEditor&&(this.h.get(a.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${a.value.newActiveEditor}`),this.k=this.h.get(a.value.newActiveEditor)),a.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(a){const d=S.$NO.String.with("notebookType","A notebook type"),$=new S.$PO("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[d,new S.$NO("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>N.$te.wrap(b))],new S.$OO("Notebook Data",b=>y.NotebookData.to(b.value))),D=new S.$PO("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[d,new S.$NO("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new m.$0v(y.NotebookData.from(b)))],new S.$OO("Bytes",b=>b.buffer));a.registerApiCommand($),a.registerApiCommand(D)}}e.$vjc=h}),define(Se[366],De([1,0,17,22,44,35,23,38,36]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;class E{constructor(v,S,y){this.k=v,this.l=S,this.o=y,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&A.$Zj(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&A.$Zj(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const S=this.k.folderQueries||[];return new Promise((y,u)=>{const m=o=>{this.f++,v(o)};if(this.g)return y({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),n=l.$nc(i);this.j&&this.j(i,n)||this.v(m,{base:o,basename:n})}),Promise.all(S.map(o=>this.p(o,m))).then(o=>{y({limitHit:this.e,stats:o[0]||void 0})},o=>{u(new Error((0,L.$4i)(o)))})})}async p(v,S){const y=new N.$de,u=this.q(v),m=this.r(),o=new p.$IK(this.k,v),i=!o.hasSiblingExcludeClauses();let n;try{this.h.add(y),n=w.$2d.create();const r=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},u,y.token),c=n.elapsed(),t=w.$2d.create();return this.g&&!this.e||(r&&r.forEach(f=>{const h=l.$gc.relative(v.folder.path,f.path);if(i){const s=l.$nc(f.path);this.v(S,{base:v.folder,relativePath:h,basename:s});return}this.s(m,v.folder,h,S)}),this.g&&!this.e)?null:(this.u(m,o,S),{providerTime:c,postProcessTime:t.elapsed()})}finally{y.dispose(),this.h.delete(y)}}q(v){const S=(0,p.$HK)(this.k.includePattern,v.includePattern),y=(0,p.$HK)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:y,includes:S,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},S,y,u){if(y===this.a){const o=l.$nc(this.a);this.v(u,{base:S,relativePath:this.a,basename:o})}function m(o){const i=l.$nc(o),n=l.$mc(o);let r=v[n];r||(r=v[n]=[],m(n)),r.push({base:S,relativePath:o,basename:i})}m(y)}u({rootEntries:v,pathToEntries:S},y,u){const m=this,o=this.a;function i(n){const r=(0,p.$KK)(()=>n.map(c=>c.basename));for(let c=0,t=n.length;c<t;c++){const f=n[c],{relativePath:h,basename:s}=f;if(y.matchesExcludesSync(h,s,o!==s?r:void 0))continue;const a=S[h];if(a)i(a);else{if(h===o)continue;m.v(u,f)}if(m.e)break}}i(v)}v(v,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(S))}}class M{constructor(){this.b=new Map}static{this.a=512}fileSearch(v,S,y,u){const m=this.c(v.cacheKey),o=new E(v,S,m&&m.token);let i=0;const n=r=>{i+=r.length,y(r.map(c=>this.d(c)))};return this.e(o,M.a,n,u).then(r=>({limitHit:r.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:r.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(v)return this.b.has(v)||this.b.set(v,new N.$de),this.b.get(v)}d(v){return v.relativePath?{resource:R.$Tg(v.base,v.relativePath)}:{resource:v.base}}e(v,S,y,u){const m=u.onCancellationRequested(()=>{v.cancel()}),o=n=>{n&&(i.push(n),S>0&&i.length>=S&&(y(i),i=[]))};let i=[];return v.search(o).then(n=>(i.length&&y(i),m.dispose(),n),n=>(i.length&&y(i),m.dispose(),Promise.reject(n)))}}e.$njc=M}),define(Se[367],De([1,0,19,72,35,103,28,15,17,23,14,18,2,100,241,52,12,40,146,362,36]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=void 0;let c=class{constructor(g,k,P,F,U){this.a=g,this.b=k,this.c=P,this.d=F,this.e=U}text(g,k,P={}){g=this.f(g,P);const F=this.a.getValue(),U=k&&k.some(T=>!this.a.getValue({resource:T}).search.useRipgrep);return{...this.h(k?.map(o.$Bi),P),type:2,contentPattern:g,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:F.search.usePCRE2||U||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(g,k){const P=this.a.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const F={...g,wordSeparators:P.editor.wordSeparators};return this.j(g,k)&&(F.isCaseSensitive=!0),this.k(g)&&(F.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),F}file(g,k={}){return{...this.h(g,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(g,k){return g?(g=Array.isArray(g)?g.map(a):a(g),k?this.parseSearchPaths(g):{pattern:f(...Array.isArray(g)?g:[g])}):{}}h(g=[],k={}){const P=this.g(k.includePattern,k.expandPatterns),F=this.g(k.excludePattern,k.expandPatterns),U=g.length>1,z=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(O=>this.q(O,k,F)):g.map(O=>this.r(O,k,F,U))).filter(O=>!!O),T={_reason:k._reason,folderQueries:z,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:F.pattern,includePattern:P.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const O=l.$Hb(l.$Rb(this.c.groups.map(te=>te.editors.map(x=>x.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(O));const j=O.filter(te=>(0,r.$yK)(T,te.fsPath)),G=this.i(j);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(G)),{...T,...G}}const I=k.extraFileResources&&k.extraFileResources.filter(O=>(0,r.$yK)(T,O.fsPath));return T.extraFileResources=I&&I.length?I:void 0,T}i(g){const k=[],P=new R.$Ac,F={};let U=!1;return g.forEach(z=>{if(z.scheme===w.Schemas.walkThrough)return;if((0,E.$Xg)(z)){const I=this.b.getWorkspaceFolder(z)?.uri??z.with({path:p.$mc(z.fsPath)});let O=P.get(I);O||(U=!0,O={folder:I,includePattern:{}},k.push(O),P.set(I,O));const j=p.$lc(I.fsPath,z.fsPath);(0,C.$5f)(O.includePattern)[j.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,F[z.fsPath]=!0)}),{folderQueries:k,includePattern:F,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(g,k){if(k.isSmartCase){if(g.isRegExp){if(M.$Kf(g.pattern,!0))return!0}else if(M.$Kf(g.pattern))return!0}return!!g.isCaseSensitive}k(g){return g.isMultiline||g.isRegExp&&(0,S.$hC)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const k=G=>p.$ic(G)||/^\.\.?([\/\\]|$)/.test(G),F=(Array.isArray(g)?g:h(g)).map(G=>{const te=this.e.resolvedUserHome;return te?(0,A.$cw)(G,te.scheme===w.Schemas.file?te.fsPath:te.path):G}),U=N.$K(F,G=>k(G)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(G=>M.$5e(G,"/")).map(G=>M.$5e(G,"\\")).map(G=>(G[0]==="."&&(G="*"+G),s(G))),T={},I=this.m(U.searchPaths||[]);I&&I.length&&(T.searchPaths=I);const O=l.$Rb(z),j=f(...O);return j&&(T.pattern=j),T}l(g,k){return k.disregardExcludeSettings?void 0:(0,r.$xK)(g,!k.disregardSearchExcludeSettings)}m(g){if(!g||!g.length)return[];const k=g.flatMap(F=>{let{pathPortion:U,globPortion:z}=t(F);return z&&(z=d(z)),this.n(U).flatMap(I=>this.o(I,z))}),P=new Map;return k.forEach(F=>{const U=F.searchPath.toString(),z=P.get(U);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):P.set(U,{searchPath:F.searchPath,pattern:F.pattern?f(F.pattern):void 0})}),Array.from(P.values())}n(g){if(p.$ic(g)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==w.Schemas.file?[{searchPath:k[0].uri.with({path:g})}]:[{searchPath:v.URI.file(p.$hc(g))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(g=a(g),g.startsWith("../")||g===".."){const F=p.$gc.resolve(k.path,g);return[{searchPath:k.with({path:F})}]}const P=d(g);return[{searchPath:k,pattern:P}]}else{if(g==="./"||g===".\\")return[];{const k=g.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(U=>{const z=k.match(new RegExp(`^${M.$Ye(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(C.$2f);if(F.length)return F.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&d(z)}});{const U=g.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:g,T=y.localize(0,null,z);throw new Error(T)}}}}o(g,k){const P=g.pattern&&k?`${g.pattern}/${k}`:g.pattern||k,F=[{searchPath:g.searchPath,pattern:P}];return P&&!P.endsWith("**")&&F.push({searchPath:g.searchPath,pattern:P+"/**"}),F}q(g,k,P){const F=this.r((0,o.$Bi)(g.searchPath),k,P,!1);return F?{...F,includePattern:g.pattern}:null}r(g,k,P,F){let U;const z=v.URI.isUri(g)?g:g.uri;if(P.searchPaths){const G=P.searchPaths.filter(te=>(0,E.$Mg)(te.searchPath,z))[0];if(G&&!G.pattern)return null;G&&(U=G.pattern)}const T=this.a.getValue({resource:z}),O={...this.l(T,k)||{},...U||{}},j=v.URI.isUri(g)?(0,E.$Qg)(g):g.name;return{folder:z,folderName:F?j:void 0,excludePattern:Object.keys(O).length>0?O:void 0,fileEncoding:T.files&&T.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!T.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!T.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!T.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!T.search.followSymlinks}}};e.$NL=c,e.$NL=c=Qe([Ve(0,u.$Mi),Ve(1,o.$pi),Ve(2,i.$oD),Ve(3,m.$Aj),Ve(4,n.$LL)],c);function t(b){const g=b.match(/[\*\{\}\(\)\[\]\?]/);if(g){const k=g.index,P=b.substr(0,k).match(/[/|\\][^/\\]*$/);if(P){let F=b.substr(0,P.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((P.index||0)+1)}}}return{pathPortion:b}}function f(...b){return b.length?b.reduce((g,k)=>(g[k]=!0,g),Object.create(null)):void 0}function h(b){return L.$Xj(b,",").map(g=>g.trim()).filter(g=>!!g.length)}function s(b){return[`**/${b}/**`,`**/${b}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function a(b){return b.replace(/\\/g,"/")}function d(b){return a(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function $(b){return b.replace(/([?*[\]])/g,"[$1]")}function D(b,g){b=l.$Mb(b,F=>F.toString());const k=[],P=g.getWorkspace();return b&&b.forEach(F=>{let U;if(g.getWorkbenchState()===2)U=(0,E.$Vg)(P.folders[0].uri,F),U&&U!=="."&&(U="./"+U);else{const z=g.getWorkspaceFolder(F);if(z){const T=z.name;if(P.folders.filter(O=>O.name===T).length===1){const O=(0,E.$Vg)(z.uri,F);O===""?U=`./${z.name}`:U=`./${z.name}/${O}`}else U=F.fsPath}}U&&k.push($(U))}),k}e.$OL=D}),define(Se[368],De([1,0,23,2,22,13,5,367,36,40,8]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xub=e.$wub=void 0;const C=7e3;function v(m,o){const i=o.activationEvents;if(!i)return Promise.resolve(void 0);const n=[],r=[];for(const a of i)if(/^workspaceContains:/.test(a)){const d=a.substr(18);d.indexOf("*")>=0||d.indexOf("?")>=0||m.forceUsingSearch?r.push(d):n.push(d)}if(n.length===0&&r.length===0)return Promise.resolve(void 0);const{promise:c,resolve:t}=(0,M.$_g)(),f=a=>t({activationEvent:a}),h=Promise.all(n.map(a=>S(m,a,f))).then(()=>{}),s=y(m,o.identifier,r,f);return Promise.all([h,s]).then(()=>{t(void 0)}),c}e.$wub=v;async function S(m,o,i){for(const n of m.folders)if(await m.exists(l.$Tg(N.URI.revive(n),o))){i(`workspaceContains:${o}`);return}}async function y(m,o,i,n){if(i.length===0)return Promise.resolve(void 0);const r=new L.$de,c=m.checkExists(m.folders,i,r.token),t=setTimeout(async()=>{r.cancel(),m.logService.info(`Not activating extension '${o.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},C);let f=!1;try{f=await c}catch(h){A.$4(h)||A.$1(h)}r.dispose(),clearTimeout(t),f&&n(`workspaceContains:${i.join(",")}`)}function u(m,o,i,n){const r=m.get(R.$fi),c=m.get(p.$pK),f=r.createInstance(w.$NL).file(o.map(h=>(0,E.$Bi)(N.URI.revive(h))),{_reason:"checkExists",includePattern:i,exists:!0});return c.fileSearch(f,n).then(h=>!!h.limitHit,h=>A.$4(h)?!1:Promise.reject(h))}e.$xub=u}),define(Se[47],De([1,0,217,17,58,23,8,3,76,2,12,6,42,298,118,41,26,148,13,25,21,277,7,64,5,27,93,20,107,69,46,121,4,368,117,279,15,115,38,11,116]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h,s,a,d,$,D,b,g,k,P,F,U,z,T,I,O,j){"use strict";var G;Object.defineProperty(e,"__esModule",{value:!0}),e.$6ic=e.$5ic=e.$4ic=e.$3ic=e.$2ic=void 0,e.$2ic=(0,h.$gi)("IHostUtils");let te=G=class extends w.$Tc{constructor(B,ie,ke,le,ue,ce,de,H,Y,he,be,Pe,we){super(),this.X=Pe,this.Y=we,this.a=this.B(new k.$6d),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=ie,this.g=ke,this.f=de,this.j=le,this.m=ue,this.s=ce,this.t=Y,this.u=he,this.w=be,this.y=this.g.getProxy(C.$0L.MainThreadWorkspace),this.z=this.g.getProxy(C.$0L.MainThreadTelemetry),this.C=this.g.getProxy(C.$0L.MainThreadExtensionService),this.D=new R.$fh,this.F=new R.$fh,this.G=new R.$fh,this.H=new R.$fh,this.I=new se(this.f.extensions.activationEvents),this.L=new o.$29b(this.I,this.f.extensions.allExtensions);const Ae=new n.$Bm(this.f.extensions.myExtensions);this.J=new o.$29b(this.I,_(this.L,Ae)),O.$t&&(this.s.info(`Creating extension host with the following global extensions: ${X(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${X(this.J)}`)),this.M=new y.$Mic(this.g,this.s),this.N=new F.$Uic(this.g),this.O=H,this.h=B.createChild(new $.$ei([y.$Nic,this.M],[F.$Vic,this.N])),this.P=this.B(new S.$Lic(this.J,this.L,{onExtensionActivationError:(Oe,ze,q)=>{this.C.$onExtensionActivationError(Oe,i.$3(ze),q)},actualActivateExtension:async(Oe,ze)=>{if(o.$29b.isHostExtension(Oe,this.J,this.L))return await this.C.$activateExtension(Oe,ze),new S.$Kic;const q=this.J.getExtensionDescription(Oe);return this.eb(q,ze)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.ub(),this.D.open(),await this.j.waitForInitializeCall(),L.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.sb()}catch(B){i.$1(B)}}async Z(){this.O.onWillDeactivateAll();let B=[];try{B=this.J.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this.db(ue))}catch{}await Promise.all(B)}terminate(B,ie=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${B}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ke=this.Z();Promise.race([(0,R.$hh)(5e3),ke]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ie}`):this.s.info(`Extension host exiting with code ${ie}`),this.s.flush(),this.s.dispose(),this.c.exit(ie)})}isActivated(B){return this.G.isOpen()?this.P.isActivated(B):!1}async getExtension(B){const ie=await this.C.$getExtension(B);return ie&&{...ie,identifier:new n.$Am(ie.identifier.value),extensionLocation:E.URI.revive(ie.extensionLocation)}}$(B,ie){return this.P.activateByEvent(B,ie)}ab(B,ie){return this.P.activateById(B,ie)}activateByIdWithErrors(B,ie){return this.ab(B,ie).then(()=>{const ke=this.P.getActivatedExtension(B);if(ke.activationFailed)return Promise.reject(ke.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(B=>this.J)}getExtensionExports(B){if(this.G.isOpen())return this.P.getActivatedExtension(B).exports;try{return this.P.getActivatedExtension(B).exports}catch{return null}}async bb(B){if(B.scheme===z.Schemas.file&&this.c.fsRealpath){const ie=await this.c.fsRealpath(B.fsPath);return E.URI.file(ie)}return B}async getExtensionPathIndex(){return this.Q||(this.Q=this.cb(this.J.getAllExtensionDescriptions()).then(B=>new ge(B))),this.Q}async cb(B){const ie=p.$mi.forUris(ke=>A.$Kg.ignorePathCasing(ke));return await Promise.all(B.map(async ke=>{if(this.vb(ke)){const le=await this.bb(ke.extensionLocation);ie.set(le,ke)}})),ie}db(B){let ie=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(B))return ie;const ke=this.P.getActivatedExtension(B);if(!ke)return ie;try{typeof ke.module.deactivate=="function"&&(ie=Promise.resolve(ke.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${B.value}':`),this.s.error(le)}try{(0,w.$Oc)(ke.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${B.value}':`),this.s.error(le)}return ie}async eb(B,ie){return this.f.remote.isRemote?this.C.$onWillActivateExtension(B.identifier):await this.C.$onWillActivateExtension(B.identifier),this.gb(B,ie).then(ke=>{const le=ke.activationTimes;return this.C.$onDidActivateExtension(B.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,ie),this.fb(B,ie,"success",le),ke},ke=>{throw this.fb(B,ie,"failure"),ke})}fb(B,ie,ke,le){const ue=Z(B,ie);this.z.$publicLog2("extensionActivationTimes",{...ue,...le||{},outcome:ke})}gb(B,ie){const ke=Z(B,ie);this.z.$publicLog2("activatePlugin",ke);const le=this.vb(B);if(!le)return Promise.resolve(new S.$Jic(S.$Gic.NONE));this.s.info(`ExtensionService#_doActivateExtension ${B.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${B.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this.s.flush();const ue=new S.$Hic(ie.startup);return Promise.all([this.wb(B,(0,A.$Tg)(B.extensionLocation,le),ue),this.hb(B)]).then(ce=>(L.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),G.ib(this.s,B.identifier,ce[0],ce[1],ue))).then(ce=>(L.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ce))}hb(B){const ie=this.Y.createLanguageModelAccessInformation(B),ke=new c.$Pic(B,this.M),le=new c.$Oic(B.identifier.value,!1,this.M),ue=new U.$Wic(B,this.N),ce=B.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,de=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([ke.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const H=this;let Y,he;const be=(0,m.$ZF)(B,"ipc")?this.f.messagePorts?.get(n.$Am.toKey(B.identifier)):void 0;return Object.freeze({globalState:ke,workspaceState:le,secrets:ue,subscriptions:[],get languageModelAccessInformation(){return ie},get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Pe){return N.$jc(B.extensionLocation.fsPath,Pe)},get storagePath(){return H.O.workspaceValue(B)?.fsPath},get globalStoragePath(){return H.O.globalValue(B).fsPath},get logPath(){return N.$jc(H.f.logsLocation.fsPath,B.identifier.value)},get logUri(){return E.URI.joinPath(H.f.logsLocation,B.identifier.value)},get storageUri(){return H.O.workspaceValue(B)},get globalStorageUri(){return H.O.globalValue(B)},get extensionMode(){return ce},get extension(){return Y===void 0&&(Y=new ae(H,B.identifier,B,de,!1)),Y},get extensionRuntime(){return(0,m.$1F)(B,"extensionRuntime"),H.extensionRuntime},get environmentVariableCollection(){return H.u.getEnvironmentVariableCollection(B)},get messagePassingProtocol(){if(!he){if(!be)return;const Pe=k.Event.buffer(k.Event.fromDOMEventEmitter(be,"message",we=>we.data));be.start(),he={onDidReceiveMessage:Pe,postMessage:be.postMessage.bind(be)}}return he}})})}static ib(B,ie,ke,le,ue){return ke=ke||{activate:void 0,deactivate:void 0},this.jb(B,ie,ke,le,ue).then(ce=>new S.$Iic(!1,null,ue.build(),ke,ce,le.subscriptions))}static jb(B,ie,ke,le,ue){if(typeof ke.activate=="function")try{ue.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const ce=typeof global=="object"?global:self,de=ke.activate.apply(ce,[le]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(de).then(H=>(ue.activateResolveStop(),H))}catch(ce){return Promise.reject(ce)}else return Promise.resolve(ke)}kb(B,ie){this.ab(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:ie}).then(void 0,ke=>{this.s.error(ke)})}lb(B,ie=0){const le=Date.now();(0,O.$B)(()=>{for(let ue=ie;ue<B.length;ue+=1){const ce=B[ue];for(const de of ce.activationEvents??[])if(de==="onStartupFinished")if(Date.now()-le>50){this.lb(B,ue);break}else this.kb(ce,de)}})}mb(){this.C.$setPerformanceMarks(L.getMarks()),this.m.getConfigProvider().then(B=>{const ie=B.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ke=this.J.getAllExtensionDescriptions();if(ie)this.lb(ke);else for(const le of ke)if(le.activationEvents)for(const ue of le.activationEvents)ue==="onStartupFinished"&&this.kb(le,ue)})}nb(){const B=this.$("*",!0).then(void 0,ce=>{this.s.error(ce)});this.B(this.j.onDidChangeWorkspace(ce=>this.ob(ce.added)));const ie=this.j.workspace?this.j.workspace.folders:[],ke=this.ob(ie),le=this.qb(),ue=Promise.all([le,B,ke]).then(()=>{});return Promise.race([ue,(0,R.$hh)(1e4)]).then(()=>{this.mb()}),ue}ob(B){return B.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ie=>this.pb(B,ie))).then(()=>{})}async pb(B,ie){if(this.isActivated(ie.identifier))return;const ke=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:B.map(ce=>ce.uri),forceUsingSearch:ke||!this.c.fsExists,exists:ce=>this.c.fsExists(ce.fsPath),checkExists:(ce,de,H)=>this.y.$checkExists(ce,de,H)},ue=await(0,P.$wub)(le,ie);if(ue)return this.ab(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ue.activationEvent}).then(void 0,ce=>this.s.error(ce))}async qb(){if(this.f.remote.authority)return this.$(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.rb()}catch(B){throw console.error(B),B}}async rb(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:ie}=this.f.environment;if(!B||!ie)throw new Error(l.localize(0,null));const ke=await this.wb(null,ie,new S.$Hic(!1));if(!ke||typeof ke.run!="function")throw new Error(l.localize(1,null,ie.toString()));return new Promise((le,ue)=>{const ce=(Y,he)=>{Y?(O.$t&&this.s.error("Test runner called back with error",Y),ue(Y)):(O.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof he=="number"&&he>0?1:0))},de=(0,A.$Hg)(ie),H=ke.run(de,ce);H&&H.then&&H.then(()=>{O.$t&&this.s.info("Test runner finished successfully."),le(0)}).catch(Y=>{O.$t&&this.s.error("Test runner finished with error",Y),ue(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}sb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$hh)(1e3)])).then(()=>this.nb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(B,ie){return this.R[B]=ie,(0,w.$Rc)(()=>{delete this.R[B]})}async getRemoteExecServer(B){const{resolver:ie}=await this.tb(B);return ie?.resolveExecServer?.(B,{resolveAttempt:0})}async tb(B){const ie=B.indexOf("+");if(ie===-1)throw new t.$fM("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ke=B.substr(0,ie);return await this.D.wait(),await this.$(`onResolveRemoteAuthority:${ke}`,!1),{authorityPrefix:ke,resolver:this.R[ke]}}async $resolveAuthority(B,ie){const ke=I.$2d.create(!1),le=()=>`[resolveAuthority(${(0,f.$pl)(B)},${ie})][${ke.elapsed()}ms] `,ue=W=>this.s.info(`${le()}${W}`),ce=W=>this.s.warn(`${le()}${W}`),de=(W,Q=void 0)=>this.s.error(`${le()}${W}`,Q),H=W=>{if(W instanceof t.$fM)return{type:"error",error:{code:W._code,message:W._message,detail:W._detail}};throw W},Y=async W=>{ue(`activating resolver for ${W}...`);const{resolver:Q,authorityPrefix:J}=await this.tb(W);if(!Q)throw de(`no resolver for ${J}`),new t.$fM(`No remote extension installed to resolve ${J}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:Q,authorityPrefix:J,remoteAuthority:W}},he=B.split(/@|%40/g).reverse();ue(`activating remote resolvers ${he.join(" -> ")}`);let be;try{be=await Promise.all(he.map(Y)).catch(async W=>{if(!(W instanceof t.$fM)||W._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw W;return ce(`resolving nested authorities failed: ${W.message}`),[await Y(B)]})}catch(W){return H(W)}const Pe=new R.$rh;Pe.cancelAndSet(()=>ue("waiting..."),1e3);let we,Ae;for(const[W,{authorityPrefix:Q,resolver:J,remoteAuthority:$e}]of be.entries())try{if(W===be.length-1)ue("invoking final resolve()..."),L.mark(`code/extHost/willResolveAuthority/${Q}`),we=await J.resolve($e,{resolveAttempt:ie,execServer:Ae}),L.mark(`code/extHost/didResolveAuthorityOK/${Q}`),ue("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(J,t.$eM.isManagedResolvedAuthority(we)?we:void 0));else{if(ue(`invoking resolveExecServer() for ${$e}`),L.mark(`code/extHost/willResolveExecServer/${Q}`),Ae=await J.resolveExecServer?.($e,{resolveAttempt:ie,execServer:Ae}),!Ae)throw new t.$fM(`Exec server was not available for ${$e}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);L.mark(`code/extHost/didResolveExecServerOK/${Q}`)}}catch(ve){return L.mark(`code/extHost/didResolveAuthorityError/${Q}`),de("returned an error",ve),Pe.dispose(),H(ve)}Pe.dispose();const Oe={environmentTunnels:we.environmentTunnels,features:we.tunnelFeatures?{elevation:we.tunnelFeatures.elevation,privacyOptions:we.tunnelFeatures.privacyOptions,protocol:we.tunnelFeatures.protocol===void 0?!0:we.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:we.extensionHostEnv,isTrusted:we.isTrusted,authenticationSession:we.authenticationSessionForInitializingExtensions?{id:we.authenticationSessionForInitializingExtensions.id,providerId:we.authenticationSessionForInitializingExtensions.providerId}:void 0};ue(`returned ${t.$eM.isManagedResolvedAuthority(we)?"managed authority":`${we.host}:${we.port}`}`);let q;if(t.$eM.isManagedResolvedAuthority(we)){const W=ie;this.X.setFactory(W,we.makeConnection),q={authority:B,connectTo:new f.$ml(W),connectionToken:we.connectionToken}}else q={authority:B,connectTo:new f.$nl(we.host,we.port),connectionToken:we.connectionToken};return{type:"ok",value:{authority:q,options:ze,tunnelInformation:Oe}}}async $getCanonicalURI(B,ie){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$pl)(B)})`);const{resolver:ke}=await this.tb(B);if(!ke)return null;const le=E.URI.revive(ie);if(typeof ke.getCanonicalURI>"u")return le;const ue=await(0,R.$$g)(()=>ke.getCanonicalURI(le));return ue||le}$startExtensionHost(B){B.toAdd.forEach(le=>le.extensionLocation=E.URI.revive(le.extensionLocation));const{globalRegistry:ie,myExtensions:ke}=x(this.I,this.L,this.J,B);return this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ke),O.$t&&(this.s.info(`$startExtensionHost: global extensions: ${X(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${X(this.J)}`)),this.sb()}$activateByEvent(B,ie){return ie===1?this.D.wait().then(ke=>this.$(B,!1)):this.G.wait().then(ke=>this.$(B,!1))}async $activate(B,ie){return await this.G.wait(),this.J.getExtensionDescription(B)?(await this.ab(B,ie),!0):!1}async $deltaExtensions(B){B.toAdd.forEach(ce=>ce.extensionLocation=E.URI.revive(ce.extensionLocation));const{globalRegistry:ie,myExtensions:ke}=x(this.I,this.L,this.J,B),le=await this.cb(ke);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(ie.getAllExtensionDescriptions()),this.J.set(ke),O.$t&&(this.s.info(`$deltaExtensions: global extensions: ${X(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${X(this.J)}`)),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){const ie=r.$te.alloc(B),ke=Math.random()%256;for(let le=0;le<B;le++)ie.writeUInt8(ke,le);return ie}async $updateRemoteConnectionData(B){this.W=B,this.a.fire()}};e.$3ic=te,e.$3ic=te=G=Qe([Ve(0,h.$fi),Ve(1,e.$2ic),Ve(2,d.$pO),Ve(3,u.$pic),Ve(4,v.$sic),Ve(5,M.$Aj),Ve(6,s.$FO),Ve(7,a.$vic),Ve(8,D.$AAb),Ve(9,b.$Qic),Ve(10,T.$Yic),Ve(11,j.$Zic),Ve(12,g.$fic)],te);function x(re,B,ie,ke){re.addActivationEvents(ke.addActivationEvents);const le=new o.$29b(re,B.getAllExtensionDescriptions());le.deltaExtensions(ke.toAdd,ke.toRemove);const ue=new n.$Bm(ie.getAllExtensionDescriptions().map(de=>de.identifier));for(const de of ke.myToRemove)ue.delete(de);for(const de of ke.myToAdd)ue.add(de);const ce=_(le,ue);return{globalRegistry:le,myExtensions:ce}}function Z(re,B){return{id:re.identifier.value,name:re.name,extensionVersion:re.version,publisherDisplayName:re.publisher,activationEvents:re.activationEvents?re.activationEvents.join(","):null,isBuiltin:re.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}function X(re){return re.getAllExtensionDescriptions().map(B=>B.identifier.value).join(",")}e.$4ic=(0,h.$gi)("IExtHostExtensionService");class ae{#e;#t;#i;constructor(B,ie,ke,le,ue){this.#e=B,this.#t=ie,this.#i=ke.identifier,this.id=ke.identifier.value,this.extensionUri=ke.extensionLocation,this.extensionPath=N.$hc((0,A.$Hg)(ke.extensionLocation)),this.packageJSON=ke,this.extensionKind=le,this.isFromDifferentExtensionHost=ue}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$5ic=ae;function _(re,B){return re.getAllExtensionDescriptions().filter(ie=>B.has(ie.identifier))}class ge{constructor(B){this.a=B}setSearchTree(B){this.a=B}findSubstr(B){return this.a.findSubstr(B)}forEach(B){return this.a.forEach(B)}}e.$6ic=ge;class se{constructor(B){this.a=new n.$Cm,this.addActivationEvents(B)}readActivationEvents(B){return this.a.get(B.identifier)??[]}addActivationEvents(B){for(const ie of Object.keys(B))this.a.set(ie,B[ie])}}}),define(Se[369],De([1,0,58,2,6,42,26,25,20,27,5,47,12,14]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$bkc=void 0;let u=class{constructor(r,c,t,f,h,s,a){this.c=r,this.d=c,this.e=t,this.f=f,this.g=h,this.h=s,this.i=a,this.a=new Map,this.b=[]}async install(){this.j(),l.mark("code/extHost/willWaitForConfig");const r=await this.f.getConfigProvider();l.mark("code/extHost/didWaitForConfig");const c=await this.g.getExtensionPathIndex();this.register(new o(this.c,c,this.d,r,this.i)),this.register(this.e.createInstance(m)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,c,this.h.environment.appUriScheme))}register(r){if("nodeModuleName"in r)if(Array.isArray(r.nodeModuleName))for(const c of r.nodeModuleName)this.a.set(c,r);else this.a.set(r.nodeModuleName,r);typeof r.alternativeModuleName=="function"&&this.b.push(c=>r.alternativeModuleName(c))}};e.$bkc=u,e.$bkc=u=Qe([Ve(2,M.$fi),Ve(3,A.$sic),Ve(4,C.$4ic),Ve(5,E.$FO),Ve(6,v.$Aj)],u);let m=class{static{y=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(r){if(r.environment.appRoot&&y.a.size){const c=(0,S.$Ye)(this.c(r.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${c}/${h}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(r){if(!this.b)return;const c=this.b.exec(this.c(r));if(!c)return;const[,t,f,h]=c,s=y.a.get(f);if(s!==void 0)return console.warn(`${f} as been renamed to ${s}, please update your imports`),t+s+h}c(r){return r.replace(/\\/g,"/")}};m=y=Qe([Ve(0,E.$FO)],m);class o{constructor(r,c,t,f,h){this.c=r,this.d=c,this.e=t,this.f=f,this.g=h,this.nodeModuleName="vscode",this.a=new w.$Cm}load(r,c){const t=this.d.findSubstr(c);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((h,s)=>f+=`	${s} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${c}. These are the extension path mappings: 
${f}`),this.b=this.c(R.$UF,this.e,this.f)}return this.b}}let i=class{constructor(r,c,t){this.e=r,this.f=c,this.nodeModuleName=["open","opn"],this.d=t.getProxy(L.$0L.MainThreadTelemetry);const f=t.getProxy(L.$0L.MainThreadWindow);this.c=(h,s)=>{const a=N.URI.parse(h);return s?this.g(h,s):a.scheme==="http"||a.scheme==="https"?f.$openUri(a,h,{allowTunneling:!0}):a.scheme==="mailto"||a.scheme===this.f?f.$openUri(a,h,{}):this.g(h,s)}}load(r,c,t){const f=this.e.findSubstr(c);return f&&(this.a=f.identifier.value,this.h()),this.b=t(r),this.c}g(r,c){return this.i(),this.b(r,c)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Qe([Ve(2,p.$pO)],i)}),define(Se[60],De([1,0,43,3,17,50,5,71,70,47,7,41,295,42]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=void 0,e.$7ic=(0,R.$gi)("IExtHostVariableResolverProvider");class y extends v.$rP{constructor(o,i,n,r,c,t,f){function h(){if(n){const s=n.activeEditor();if(s)return s.document.uri;const a=r.tabGroups.all.find(d=>d.isActive)?.activeTab;if(a!==void 0){if(a.input instanceof M.$UN||a.input instanceof M.$ZN)return a.input.modified;if(a.input instanceof M.$TN||a.input instanceof M.$YN||a.input instanceof M.$WN)return a.input.uri}}}super({getFolderUri:s=>{const a=t.folders.filter(d=>d.name===s);if(a&&a.length>0)return a[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,a)=>c.getConfiguration(void 0,s).get(a),getAppRoot:()=>A.cwd(),getExecPath:()=>A.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=h();if(s)return L.$hc(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const s=h();if(s){const a=i.getWorkspaceFolder(s);if(a)return L.$hc(a.uri.fsPath)}}},getSelectedText:()=>{if(n){const s=n.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(n){const s=n.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>o.getExtension(s)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(A.env))}}let u=class extends N.$Tc{constructor(o,i,n,r,c){super(),this.b=o,this.c=i,this.g=n,this.h=r,this.j=c,this.a=new l.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new y(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$8ic=u,e.$8ic=u=Qe([Ve(0,E.$4ic),Ve(1,C.$pic),Ve(2,w.$AO),Ve(3,S.$sic),Ve(4,p.$Eic)],u)}),define(Se[96],De([1,0,8,4,2,25,5,6,70,47,20,7,41,143,287,42,60,3,55,33,16]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ajc=e.$_ic=e.$$ic=e.$0ic=e.$9ic=void 0,e.$9ic=(0,R.$gi)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor($,D,b,g,k,P,F){this.N=D,this.O=b,this.P=g,this.Q=k,this.R=P,this.S=F,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$6d,this.o=new N.$6d,this.q=new N.$6d,this.w=new N.$6d,this.l=$.getProxy(w.$0L.MainThreadDebugService),this.A=new N.$6d,this.C=new N.$6d,this.y=new f(this.l),this.z=new Map,this.O.getExtensionRegistry().then(U=>{U.onDidChange(z=>{this.V(U)}),this.V(U)})}async $getVisualizerTreeItem($,D){const b=this.W(D);if(!b)return;const g=await this.H.get($)?.getTreeItem?.(b);return g?this.U($,g):void 0}registerDebugVisualizationTree($,D,b){const g=A.$Am.toKey($.identifier),k=this.jb(g,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(k,b),this.l.$registerDebugVisualizerTree(k,!!b.editItem),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizerTree(k),this.H.delete(D)})}async $getVisualizerTreeItemChildren($,D){const b=this.J.get(D)?.item;return b?(await this.H.get($)?.getChildren?.(b))?.map(k=>this.U($,k))||[]:[]}async $editVisualizerTreeItem($,D){const b=this.J.get($);if(!b)return;const g=await this.H.get(b.provider)?.editItem?.(b.item,D);return this.U(b.provider,g||b.item)}$disposeVisualizedTree($){const D=this.J.get($);if(!D)return;const b=[D.children];for(const g of b)if(g)for(const k of g)b.push(this.J.get(k)?.children),this.J.delete(k)}U($,D){let b=this.I.get(D);return b||(b=this.F++,this.I.set(D,b),this.J.set(b,{provider:$,item:D})),r.DebugTreeItem.from(D,b)}asDebugSourceUri($,D){const b=$;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let g=`debug:${encodeURIComponent(b.path||"")}`,k="?";return D&&(g+=`${k}session=${encodeURIComponent(D.id)}`,k="&"),g+=`${k}ref=${b.sourceReference}`,L.URI.parse(g)}else{if(b.path)return L.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V($){const D=[];for(const b of $.getAllExtensionDescriptions())if(b.contributes){const g=b.contributes.debuggers;if(g&&g.length>0)for(const k of g)(0,y.$zG)(k)&&D.push(k.type)}this.l.$registerDebugTypes(D)}get stackFrameFocus(){return this.B}get onDidChangeStackFrameFocus(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const $=[];return this.z.forEach(D=>$.push(D)),$}async $resolveDebugVisualizer($,D){const b=this.L.get($);if(!b)throw new Error(`No debug visualizer found with id '${$}'`);let{v:g,provider:k,extensionId:P}=b;if(g.visualization||(g=await k.resolveDebugVisualization?.(g,D)||g,b.v=g),!g.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${k}'`);return this.kb(P,g.visualization)}async $executeDebugVisualizerCommand($){const D=this.L.get($);if(!D)throw new Error(`No debug visualizer found with id '${$}'`);const b=D.v.visualization;b&&"command"in b&&this.S.executeCommand(b.command,...b.arguments||[])}W($){const D=this.m.get($.sessionId);return D&&{session:D.api,variable:$.variable,containerId:$.containerId,frameId:$.frameId,threadId:$.threadId}}async $provideDebugVisualizers($,D,b,g){const k=this.W(b),P=this.jb($,D),F=this.G.get(P);if(!k||!F)return[];const U=await F.provideDebugVisualization(k,g);return U?U.map(z=>{const T=++this.M;this.L.set(T,{v:z,provider:F,extensionId:$});const I=z.iconPath?this.lb(z.iconPath):void 0;return{id:T,name:z.name,iconClass:I?.iconClass,iconPath:I?.iconPath,visualization:this.kb($,z.visualization)}}):[]}$disposeDebugVisualizers($){for(const D of $)this.L.delete(D)}registerDebugVisualizationProvider($,D,b){if(!$.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const g=A.$Am.toKey($.identifier),k=this.jb(g,D);if(this.G.has(k))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(k,b),this.l.$registerDebugVisualizer(g,D),(0,o.$Rc)(()=>{this.l.$unregisterDebugVisualizer(g,D),this.G.delete(D)})}addBreakpoints($){const D=$.filter(k=>{const P=k.id;return this.z.has(P)?!1:(this.z.set(P,k),!0)});this.gb(D,[],[]);const b=[],g=new Map;for(const k of D)if(k instanceof C.$_M){let P=g.get(k.location.uri.toString());P||(P={type:"sourceMulti",uri:k.location.uri,lines:[]},g.set(k.location.uri.toString(),P),b.push(P)),P.lines.push({id:k.id,enabled:k.enabled,condition:k.condition,hitCondition:k.hitCondition,logMessage:k.logMessage,line:k.location.range.start.line,character:k.location.range.start.character,mode:k.mode})}else k instanceof C.$aN&&b.push({type:"function",id:k.id,enabled:k.enabled,hitCondition:k.hitCondition,logMessage:k.logMessage,condition:k.condition,functionName:k.functionName,mode:k.mode});return this.l.$registerBreakpoints(b)}removeBreakpoints($){const D=$.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const b=D.filter(P=>P instanceof C.$_M).map(P=>P.id),g=D.filter(P=>P instanceof C.$aN).map(P=>P.id),k=D.filter(P=>P instanceof C.$bN).map(P=>P.id);return this.l.$unregisterBreakpoints(b,g,k)}startDebugging($,D,b){return this.l.$startDebugging($?$.uri:void 0,D,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===C.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging($){return this.l.$stopDebugging($?$.id:void 0)}registerDebugConfigurationProvider($,D,b){if(!D)return new C.$_L(()=>{});const g=this.d++;return this.f.push({type:$,handle:g,provider:D}),this.l.$registerDebugConfigurationProvider($,b,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,g),new C.$_L(()=>{this.f=this.f.filter(k=>k.provider!==D),this.l.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory($,D,b){if(!b)return new C.$_L(()=>{});if(!this.cb($,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:D,handle:g,factory:b}),this.l.$registerDebugAdapterDescriptorFactory(D,g),new C.$_L(()=>{this.h=this.h.filter(k=>k.factory!==b),this.l.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory($,D){if(!D)return new C.$_L(()=>{});const b=this.j++;return this.k.push({type:$,handle:b,factory:D}),new C.$_L(()=>{this.k=this.k.filter(g=>g.factory!==D)})}async $runInTerminal($,D){return Promise.resolve(void 0)}async $substituteVariables($,D){let b;const g=await this.ib($);return g&&(b={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(b,D)}X($,D){if($.type==="implementation")return new s($.implementation)}Y(){}async $startDASession($,D){const b=this,g=await this.hb(D);return this.eb(this.$(g.type),g).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const P=this.Z(k),F=this.X(P,g);if(!F)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const U=F;return this.D.set($,U),this.db(g).then(z=>(z&&this.E.set($,z),U.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const I=T,O={type:"response",seq:0,command:I.command,request_seq:I.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const j=await this.K.sign(I.arguments.value);O.body={signature:j},U.sendResponse(O)}else throw new Error("no signer")}catch(j){O.success=!1,O.message=j.message,U.sendResponse(O)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(T),T=(0,y.$EG)(T,!0),b.l.$acceptDAMessage($,T)}),U.onError(T=>{z&&z.onError&&z.onError(T),this.l.$acceptDAError($,T.name,T.message,T.stack)}),U.onExit(T=>{z&&z.onExit&&z.onExit(T??void 0,void 0),this.l.$acceptDAExit($,T??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),U.startSession()))})}$sendDAMessage($,D){D=(0,y.$DG)(D,!1);const b=this.E.get($);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(D),this.D.get($)?.sendMessage(D)}$stopDASession($){const D=this.E.get($);this.E.delete($),D&&D.onWillStopSession&&D.onWillStopSession();const b=this.D.get($);return this.D.delete($),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta($){const D=[],b=[],g=[];if($.added)for(const k of $.added){const P=k.id;if(P&&!this.z.has(P)){let F;if(k.type==="function")F=new C.$aN(k.functionName,k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode);else if(k.type==="data")F=new C.$bN(k.label,k.dataId,k.canPersist,k.enabled,k.hitCondition,k.condition,k.logMessage,k.mode);else{const U=L.URI.revive(k.uri);F=new C.$_M(new C.$lM(U,new C.$aM(k.line,k.character)),k.enabled,k.condition,k.hitCondition,k.logMessage,k.mode)}(0,C.$0M)(F,P),this.z.set(P,F),D.push(F)}}if($.removed)for(const k of $.removed){const P=this.z.get(k);P&&(this.z.delete(k),b.push(P))}if($.changed){for(const k of $.changed)if(k.id){const P=this.z.get(k.id);if(P){if(P instanceof C.$aN&&k.type==="function"){const F=P;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.functionName=k.functionName}else if(P instanceof C.$_M&&k.type==="source"){const F=P;F.enabled=k.enabled,F.condition=k.condition,F.hitCondition=k.hitCondition,F.logMessage=k.logMessage,F.location=new C.$lM(L.URI.revive(k.uri),new C.$aM(k.line,k.character))}g.push(P)}}}this.gb(D,b,g)}async $acceptStackFrameFocus($){let D;const b=$.sessionId?await this.hb($.sessionId):void 0;if(!b)throw new Error("no DebugSession found for debug focus context");$.kind==="thread"?D=new C.$hN(b.api,$.threadId):D=new C.$gN(b.api,$.threadId,$.frameId),this.B=D,this.C.fire(this.B)}$provideDebugConfigurations($,D,b){return(0,l.$$g)(async()=>{const g=this.bb($);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const k=await this.ib(D);return g.provideDebugConfigurations(k,b)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration($,D,b,g){return(0,l.$$g)(async()=>{const k=this.bb($);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return k.resolveDebugConfiguration(P,b,g)})}$resolveDebugConfigurationWithSubstitutedVariables($,D,b,g){return(0,l.$$g)(async()=>{const k=this.bb($);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return k.resolveDebugConfigurationWithSubstitutedVariables(P,b,g)})}async $provideDebugAdapter($,D){const b=this.ab($);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.hb(D);return this.eb(b,g).then(k=>{if(!k)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.Z(k)})}async $acceptDebugSessionStarted($){const D=await this.hb($);this.n.fire(D.api)}async $acceptDebugSessionTerminated($){const D=await this.hb($);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged($){this.u=$?await this.hb($):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged($,D){(await this.hb($))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent($,D){const g={session:(await this.hb($)).api,event:D.event,body:D.body};this.w.fire(g)}Z($){if($ instanceof C.$cN)return{type:"executable",command:$.command,args:$.args,options:$.options};if($ instanceof C.$dN)return{type:"server",port:$.port,host:$.host};if($ instanceof C.$eN)return{type:"pipeServer",path:$.path};if($ instanceof C.$fN)return{type:"implementation",implementation:$.implementation};throw new Error("convertToDto unexpected type")}$($){const D=this.h.filter(b=>b.type===$);if(D.length>0)return D[0].factory}ab($){const D=this.h.filter(b=>b.handle===$);if(D.length>0)return D[0].factory}bb($){const D=this.f.filter(b=>b.handle===$);if(D.length>0)return D[0].provider}cb($,D){if($.contributes){const b=$.contributes.debuggers;if(b&&b.length>0){for(const g of b)if(g.label&&g.type&&g.type===D)return!0}}return!1}db($){const b=$.configuration.type,g=this.k.filter(k=>k.type===b||k.type==="*").map(k=>(0,l.$$g)(()=>k.factory.createDebugAdapterTracker($.api)).then(P=>P,P=>null));return Promise.race([Promise.all(g).then(k=>{const P=k.filter(F=>!!F);if(P.length>0)return new h(P)}),new Promise(k=>setTimeout(()=>k(void 0),1e3))]).catch(k=>{})}async eb($,D){const b=D.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new C.$dN(b));if($){const k=await this.O.getExtensionRegistry();return(0,l.$$g)(()=>$.createDebugAdapterDescriptor(D.api,this.fb(D,k))).then(P=>{if(P)return P})}const g=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,g))}fb($,D){}gb($,D,b){($.length>0||D.length>0||b.length>0)&&this.A.fire(Object.freeze({added:$,removed:D,changed:b}))}async hb($){if($)if(typeof $=="string"){const D=this.m.get($);if(D)return D}else{let D=this.m.get($.id);if(!D){const b=await this.ib($.folderUri),g=$.parent?this.m.get($.parent):void 0;D=new t(this.l,$.id,$.type,$.name,b,$.configuration,g?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib($){if($){const D=L.URI.revive($);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb($,D){return`${$}\0${D}`}kb($,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${$}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb($){const D=this.mb($);let b,g;return"id"in D?g=i.ThemeIcon.asClassName(D):b=D,{iconPath:b,iconClass:g}}mb($){if($ instanceof C.$7M)return{id:$.id};const D=typeof $=="object"&&"dark"in $?$.dark:$,b=typeof $=="object"&&"light"in $?$.light:$;return{dark:typeof D=="string"?L.URI.file(D):D,light:typeof b=="string"?L.URI.file(b):b}}};e.$0ic=c,e.$0ic=c=Qe([Ve(0,M.$pO),Ve(1,v.$pic),Ve(2,E.$4ic),Ve(3,u.$sic),Ve(4,p.$Eic),Ve(5,m.$7ic),Ve(6,n.$LO)],c);class t{constructor($,D,b,g,k,P,F){this.f=$,this.g=D,this.h=b,this.j=g,this.k=k,this.l=P,this.m=F}get api(){const $=this;return this.d??=Object.freeze({id:$.g,type:$.h,get name(){return $.j},set name(D){$.j=D,$.f.$setDebugSessionName($.g,D)},parentSession:$.m,workspaceFolder:$.k,configuration:$.l,customRequest(D,b){return $.f.$customDebugAdapterRequest($.g,D,b)},getDebugProtocolBreakpoint(D){return $.f.$getDebugProtocolBreakpoint($.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged($){this.j=$}get configuration(){return this.l}}e.$$ic=t;class f{constructor($){this.value=Object.freeze({append(D){$.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$_ic=f;class h{constructor($){this.d=$}onWillStartSession(){this.d.forEach($=>$.onWillStartSession?$.onWillStartSession():void 0)}onWillReceiveMessage($){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage($):void 0)}onDidSendMessage($){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage($):void 0)}onWillStopSession(){this.d.forEach($=>$.onWillStopSession?$.onWillStopSession():void 0)}onError($){this.d.forEach(D=>D.onError?D.onError($):void 0)}onExit($,D){this.d.forEach(b=>b.onExit?b.onExit($,D):void 0)}}class s extends S.$Pnb{constructor($){super(),this.h=$,$.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage($){this.h.handleMessage($)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends c{constructor($,D,b,g,k,P,F){super($,D,b,g,k,P,F)}};e.$ajc=a,e.$ajc=a=Qe([Ve(0,M.$pO),Ve(1,v.$pic),Ve(2,E.$4ic),Ve(3,u.$sic),Ve(4,p.$Eic),Ve(5,m.$7ic),Ve(6,n.$LO)],a)}),define(Se[370],De([1,0,13,58,2,6,316,12,83,107,27,253,20,65,47,90]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dkc=e.$ckc=void 0;class m{static async installEarlyHandler(n){Error.stackTraceLimit=100;const r=n.get(w.$Aj),t=n.get(v.$pO).getProxy(A.$0L.MainThreadErrors);l.setUnexpectedErrorHandler(f=>{r.error(f);const h=l.$3(f);t.$onUnexpectedError(h)})}static async installFullHandler(n){const r=n.get(w.$Aj),c=n.get(v.$pO),t=n.get(y.$4ic),f=n.get(u.$JO),h=c.getProxy(A.$0L.MainThreadExtensionService),s=c.getProxy(A.$0L.MainThreadErrors),a=await t.getExtensionPathIndex(),d=new WeakMap;function $(g,k){if(d.has(g))return d.get(g).stack;let P="",F,U;for(const T of k)P+=`
	at ${T.toString()}`,U=T.getFileName(),!F&&U&&(F=a.findSubstr(L.URI.file(U)));const z=`${g.name||"Error"}: ${g.message||""}${P}`;return d.set(g,{extensionIdentifier:F?.identifier,stack:z}),z}const D=Symbol("prepareStackTrace wrapped");let b=$;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(g){if(g===$||!g||g[D]){b=g||$;return}b=function(k,P){return $(k,P),g.call(Error,k,P)},Object.assign(b,{[D]:!0})}}),l.setUnexpectedErrorHandler(g=>{r.error(g);const k=l.$3(g),P=d.get(g);if(!P?.extensionIdentifier){s.$onUnexpectedError(k);return}h.$onExtensionRuntimeError(P.extensionIdentifier,k);const F=f.onExtensionError(P.extensionIdentifier,g);r.trace("forwarded error to extension?",F,P)})}}e.$ckc=m;class o{constructor(n,r,c,t,f){this.a=c,this.b=new R.$09b(n,null,t),r=o.e(r,this.b);const h=new E.$ei(...(0,p.$cs)());h.set(M.$FO,{_serviceBrand:void 0,...r,messagePorts:f}),h.set(v.$pO,new v.$qO(this.b)),h.set(S.$mic,new S.$nic(t)),h.set(y.$2ic,c);const s=new C.$Tq(h,!0);s.invokeFunction(m.installEarlyHandler),this.d=s.invokeFunction(a=>a.get(w.$Aj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",r),this.c=s.invokeFunction(a=>a.get(y.$4ic)),this.c.initialize(),s.invokeFunction(m.installFullHandler)}async asBrowserUri(n){const r=this.b.getProxy(A.$0L.MainThreadExtensionService);return L.URI.revive(await r.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,r){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=L.URI.revive(r.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=L.URI.revive(r.transformIncomingURIs(n.environment.appRoot));const c=n.environment.extensionDevelopmentLocationURI;return c&&(n.environment.extensionDevelopmentLocationURI=c.map(t=>L.URI.revive(r.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=L.URI.revive(r.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=L.URI.revive(r.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=L.URI.revive(r.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=L.URI.revive(r.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=L.URI.revive(r.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=L.URI.revive(r.transformIncomingURIs(n.logsLocation)),n.workspace=r.transformIncomingURIs(n.workspace),n}}e.$dkc=o}),define(Se[371],De([1,0,8,11,228,247,141,96,70,47,20,46,7,60,41,288,289,42,33,372]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nkc=void 0;let r=class extends w.$0ic{constructor(a,d,$,D,b,g,k,P){super(a,d,$,D,g,k,P),this.pb=b,this.nb=new h}X(a,d){switch(a.type){case"server":return new u.$ikc(a);case"pipeServer":return new u.$jkc(a);case"executable":return new u.$kkc(a,d.type)}return super.X(a,d)}fb(a,d){const $=u.$kkc.platformAdapterExecutable(d.getAllExtensionDescriptions(),a.type);if($)return new v.$cN($.command,$.args,$.options)}Y(){return new R.$Vac}async $runInTerminal(a,d){if(a.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(O=>{this.nb.onTerminalClosed(O)}));const $=await this.P.getConfigProvider(),D=this.pb.getDefaultShell(!0),b=this.pb.getDefaultShellArgs(!0),g=a.title||L.localize(0,null),k=c(D,b,a);let P=await this.nb.checkout(k,g),F,U=!1;if(P)F=a.cwd;else{const O={shellPath:D,shellArgs:b,cwd:a.cwd,name:g,iconPath:new v.$7M("debug"),env:a.env};U=!0,P=this.pb.createTerminalFromOptions(O,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(P,k)}P.show(!0);const z=await P.processId;U?await new Promise(O=>setTimeout(O,1e3)):$.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(D.indexOf("powershell")>=0||D.indexOf("pwsh")>=0||D.indexOf("cmd.exe")>=0?P.sendText("cls"):D.indexOf("bash")>=0?P.sendText("clear"):N.$i?P.sendText("cls"):P.sendText("clear"));const T=(0,m.$mkc)(D,a.args,!!a.argsCanBeInterpretedByShell,F);P.sendText(T);const I=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.nb.free(P),I.dispose())});return z}else if(a.kind==="external")return f(a,await this.P.getConfigProvider());return super.$runInTerminal(a,d)}};e.$nkc=r,e.$nkc=r=Qe([Ve(0,M.$pO),Ve(1,y.$pic),Ve(2,E.$4ic),Ve(3,o.$sic),Ve(4,C.$Qic),Ve(5,p.$Eic),Ve(6,S.$7ic),Ve(7,i.$LO)],r);function c(s,a,d){const $=(0,n.createHash)("sha256");return $.update(JSON.stringify({shell:s,shellArgs:a})),$.update(JSON.stringify(Object.entries(d.env||{}).sort(([D],[b])=>D.localeCompare(b)))),$.digest("base64")}let t;function f(s,a){if(!t)if(N.$i)t=new A.$G_b;else if(N.$j)t=new A.$H_b;else if(N.$k)t=new A.$I_b;else throw new Error("external terminals not supported on this platform");const d=a.getConfiguration("terminal");return t.runInTerminal(s.title,s.cwd,s.args,s.env||{},d.external||{})}class h{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,d){const D=[...this.b.entries()].map(([b,g])=>(0,l.$6g)(async k=>{if(b.name!==d||g.lastUsedAt!==-1&&await(0,m.$lkc)(await b.processId))return null;const P=Date.now();return g.lastUsedAt+h.a>P||k.isCancellationRequested||g.config!==a?null:(g.lastUsedAt=P,b)}));return await(0,l.$lh)(D,b=>!!b)}insert(a,d){this.b.set(a,{lastUsedAt:Date.now(),config:d})}free(a){const d=this.b.get(a);d&&(d.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(Se[373],De([1,0,17,2,105,41,71,42,40,46,20,27,95,15,12,91,23,63,60]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fkc=void 0;let n=class extends v.$Tjc{constructor(c,t,f,h,s,a,d,$,D){super(c,t,f,h,s,a,d,$),this.C=f,this.D=D,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(c,t){const f=t;if(!t.execution&&f._id===void 0)throw new Error("Tasks to execute must include an execution");if(f._id!==void 0){const h=v.TaskHandleDTO.from(f,this.C),s=await this.a.$getTaskExecution(h);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const a=await this.z(s,t);return this.a.$executeTask(h).catch(()=>{}),a}else{const h=v.TaskDTO.from(t,c);if(h===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const s=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),s}}v(c,t,f,h){const s=[];if(h)for(const a of h){this.A(a,f),(!a.definition||!c[a.definition.type])&&this.f.warn(`The task [${a.source}, ${a.name}] uses an undefined task type. The task will be ignored in the future.`);const d=v.TaskDTO.from(a,f.extension);d&&(s.push(d),v.CustomExecutionDTO.is(d.execution)&&t.push(this.y(d,a,!0)))}return{tasks:s,extension:f.extension}}async w(c){return c}async G(c){let t=c&&c.length>0?c[0]:void 0;if(!t){const f=N.URI.file((0,o.homedir)());t=new p.$Ai({uri:f,name:m.$Qg(f),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(c,t){const f=N.URI.revive(c),h={process:void 0,variables:Object.create(null)},s=await this.b.resolveWorkspaceFolder(f),a=await this.b.getWorkspaceFolders2()??[],d=await this.D.getResolver(),$=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(a);for(const D of t.variables)h.variables[D]=await d.resolveAsync($,D);if(t.process!==void 0){let D;if(t.process.path!==void 0){D=t.process.path.split(l.$tc);for(let b=0;b<D.length;b++)D[b]=await d.resolveAsync($,D[b])}h.process=await L.win32.findExecutable(await d.resolveAsync($,t.process.name),t.process.cwd!==void 0?await d.resolveAsync($,t.process.cwd):void 0,D)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(c,t,f){return L.win32.findExecutable(c,t,f)}};e.$fkc=n,e.$fkc=n=Qe([Ve(0,M.$pO),Ve(1,C.$FO),Ve(2,A.$pic),Ve(3,R.$AO),Ve(4,w.$sic),Ve(5,E.$Qic),Ve(6,y.$Aj),Ve(7,u.$3hc),Ve(8,i.$7ic)],n)}),define(Se[374],De([1,0,63,60]),function(fe,e,l,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=void 0;class L extends N.$8ic{m(){return(0,l.homedir)()}}e.$Xkc=L}),define(Se[158],De([1,0,19,8,22,44,15,17,23,2,36]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rjc=e.$qjc=e.$pjc=e.$ojc=void 0;class C{constructor(i,n,r){this.d=i,this.e=n,this.f=r,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(i,n){const r=this.g.folderQueries||[],c=new L.$de(n);return new Promise((t,f)=>{this.a=new S(i);let h=!1;const s=(a,d)=>{if(!h&&!this.b){const $=this.h(a);u(a)&&typeof this.g.maxResults=="number"&&this.c+$>this.g.maxResults&&(this.b=!0,h=!0,c.cancel(),a=this.j(a,this.g.maxResults-this.c));const D=this.h(a);this.c+=D,(D>0||!u(a))&&this.a.add(a,d)}};Promise.all(r.map((a,d)=>this.k(a,$=>s($,d),c.token))).then(a=>{c.dispose(),this.a.flush();const d=a.some($=>!!$&&!!$.limitHit);t({limitHit:this.b||d,messages:(0,l.$Rb)(a.map($=>$?.message?Array.isArray($.message)?$.message:[$.message]:[])),stats:{type:this.f}})},a=>{c.dispose();const d=(0,A.$4i)(a);f(new Error(d))})})}h(i){return u(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const r=Array.isArray(i.ranges)?i.ranges:[i.ranges],c=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:r.slice(0,n),preview:{matches:c.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,r){const c=new M.$IK(this.g,i),t=[],f={report:a=>{if(!this.l(a))return;const d=i.folder.scheme===R.Schemas.file?(0,M.$JK)(()=>this.e.readdir(p.$Sg(a.uri))):void 0,$=p.$Vg(i.folder,a.uri);if($){const D=c.includedInQuery($,w.$nc($),d);(0,N.$5g)(D)?t.push(D.then(b=>{b&&n(a)})):D&&n(a)}}},h=this.n(i);let s;return this.d.query.type===3?s=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,f,r):s=await this.d.provider.provideTextSearchResults(v(this.d.query.contentPattern),h,f,r),t.length&&await Promise.all(t),s}l(i){if(u(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,M.$HK)(this.g.includePattern,i.includePattern),r=(0,M.$HK)(this.g.excludePattern,i.excludePattern),c={folder:E.URI.from(i.folder),excludes:r,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.e.toCanonicalName(i.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(c.usePCRE2=this.g.usePCRE2),c}}e.$ojc=C;function v(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new m(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!p.$Mg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(y(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$pjc=S;function y(o){return u(o)?{preview:{matches:(0,l.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,l.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function u(o){return!!o.preview}e.$qjc=u;class m{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<m.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},m.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$rjc=m}),define(Se[97],De([1,0,3,6,5,366,20,65,12,2,158]),function(fe,e,l,N,L,A,R,w,p,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ujc=e.$tjc=e.$sjc=void 0,e.$sjc=(0,L.$gi)("IExtHostSearch");let C=class{constructor(u,m,o){this.n=u,this.o=m,this.q=o,this.c=this.n.getProxy(N.$0L.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new A.$njc}s(u){return this.o.transformOutgoingScheme(u)}registerTextSearchProvider(u,m){if(this.g.has(u))throw new Error(`a text search provider for the scheme '${u}' is already registered`);this.g.add(u);const o=this.d++;return this.e.set(o,m),this.c.$registerTextSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.g.delete(u),this.e.delete(o),this.c.$unregisterProvider(o)})}registerAITextSearchProvider(u,m){if(this.i.has(u))throw new Error(`an AI text search provider for the scheme '${u}'is already registered`);this.i.add(u);const o=this.d++;return this.h.set(o,m),this.c.$registerAITextSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.i.delete(u),this.h.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(u,m){if(this.k.has(u))throw new Error(`a file search provider for the scheme '${u}' is already registered`);this.k.add(u);const o=this.d++;return this.j.set(o,m),this.c.$registerFileSearchProvider(o,this.s(u)),(0,l.$Rc)(()=>{this.k.delete(u),this.j.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(u,m,o,i){const n=v(o),r=this.j.get(u);if(r)return this.l.fileSearch(n,r,c=>{this.c.$handleFileMatch(u,m,c.map(t=>t.resource))},i);throw new Error("3 unknown provider: "+u)}async doInternalFileSearchWithCustomCallback(u,m,o){return{messages:[]}}$clearCache(u){return this.l.clearCache(u),Promise.resolve(void 0)}$provideTextSearchResults(u,m,o,i){const n=this.e.get(u);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${u}`);const r=v(o);return this.t(r,n).search(t=>this.c.$handleTextMatch(u,m,t),i)}$provideAITextSearchResults(u,m,o,i){const n=this.h.get(u);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${u}`);const r=v(o);return this.v(r,n).search(t=>this.c.$handleTextMatch(u,m,t),i)}$enableExtensionHostSearch(){}t(u,m){return new M.$ojc({query:u,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}v(u,m){return new M.$ojc({query:u,provider:m},{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"aiTextSearchProvider")}};e.$tjc=C,e.$tjc=C=Qe([Ve(0,R.$pO),Ve(1,w.$mic),Ve(2,p.$Aj)],C);function v(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(S),extraFileResources:y.extraFileResources&&y.extraFileResources.map(u=>E.URI.revive(u))}}e.$ujc=v;function S(y){return{...y,folder:E.URI.revive(y.folder)}}}),define(Se[375],De([1,0,22,13,4,3,15,39,2,135,196,177,78,25,32,12,86,87,272,6,318,345,91,120,323,304,324,121,325,305,293,33,326,42,327,96,151,328,307,319,329,330,71,70,320,47,331,68,332,59,27,346,347,321,308,333,334,115,116,309,365,336,278,337,348,338,156,310,339,340,341,20,342,97,117,343,311,344,118,93,95,90,46,349,350,322,351,352,69,16,7,312,65,313,92,353,354,150,41,286,114,26,94]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h,s,a,d,$,D,b,g,k,P,F,U,z,T,I,O,j,G,te,x,Z,X,ae,_,ge,se,re,B,ie,ke,le,ue,ce,de,H,Y,he,be,Pe,we,Ae,Oe,ze,q,W,Q,J,$e,ve,Te,He,Xe,tt,st,ut,rt,Ie,Be,Le,Ke,ne,oe,Ce,Ge,xe,nt,Fe,$t,Dt,Pt,jt,Zt,Ct,Jt,Qt,_t,ni,et,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0jc=void 0;function ei(dt){const pt=dt.get(re.$FO),ti=dt.get(se.$7hc),Ht=dt.get(_.$uic),Ut=dt.get(X.$4ic),ft=dt.get(Qt.$pic),Rt=dt.get(Be.$JO),ii=dt.get(P.$sic),Yt=dt.get(Dt.$mic),Ze=dt.get($e.$pO),Lt=dt.get(ut.$Nic),Wt=dt.get(rt.$vic),ri=dt.get(u.$Bj),gt=dt.get(u.$Aj),Ot=dt.get(xe.$AAb),At=dt.get(t.$3hc),qt=dt.get(Jt.$9jc),si=dt.get(He.$Vic),zt=dt.get(x.$Eic),Kt=dt.get(H.$Zic),yt=dt.get(f.$aic),Nt=dt.get(d.$fic);Ze.set(n.$$L.ExtHostFileSystemInfo,ti),Ze.set(n.$$L.ExtHostLogLevelServiceShape,ri),Ze.set(n.$$L.ExtHostWorkspace,ft),Ze.set(n.$$L.ExtHostConfiguration,ii),Ze.set(n.$$L.ExtHostExtensionService,Ut),Ze.set(n.$$L.ExtHostStorage,Lt),Ze.set(n.$$L.ExtHostTunnelService,Ot),Ze.set(n.$$L.ExtHostWindow,qt),Ze.set(n.$$L.ExtHostSecretState,si),Ze.set(n.$$L.ExtHostTelemetry,Rt),Ze.set(n.$$L.ExtHostEditorTabs,zt),Ze.set(n.$$L.ExtHostManagedSockets,Kt),Ze.set(n.$$L.ExtHostAuthentication,yt),Ze.set(n.$$L.ExtHostChatProvider,Nt);const Xt=Ze.set(n.$$L.ExtHostDecorations,dt.get(z.$cjc)),Vt=Ze.set(n.$$L.ExtHostDocumentsAndEditors,dt.get(te.$AO)),kt=Ze.set(n.$$L.ExtHostCommands,dt.get(g.$LO)),It=Ze.set(n.$$L.ExtHostTerminalService,dt.get(Le.$Qic)),Et=Ze.set(n.$$L.ExtHostDebugService,dt.get(U.$9ic)),ci=Ze.set(n.$$L.ExtHostSearch,dt.get(Te.$sjc)),Re=Ze.set(n.$$L.ExtHostTask,dt.get(Ie.$Vjc)),je=Ze.set(n.$$L.ExtHostOutputService,dt.get(ze.$Ijc)),Ee=Ze.set(n.$$L.ExtHostLocalization,dt.get(de.$Yic)),ee=Ze.set(n.$$L.ExtHostUrls,new Pt.$6jc(Ze)),Me=Ze.set(n.$$L.ExtHostDocuments,new G.$0hc(Ze,Vt)),qe=Ze.set(n.$$L.ExtHostDocumentContentProviders,new O.$ejc(Ze,Vt,gt)),_e=Ze.set(n.$$L.ExtHostDocumentSaveParticipant,new j.$fjc(gt,Me,Ze.getProxy(n.$0L.MainThreadBulkEdits))),Je=Ze.set(n.$$L.ExtHostNotebook,new he.$vjc(Ze,kt,Vt,Me,Ht,ci)),ct=Ze.set(n.$$L.ExtHostNotebookDocuments,new Pe.$Cjc(Je)),vt=Ze.set(n.$$L.ExtHostNotebookEditors,new we.$Djc(gt,Je)),Ft=Ze.set(n.$$L.ExtHostNotebookKernels,new Ae.$Ejc(Ze,pt,Je,kt,gt)),xt=Ze.set(n.$$L.ExtHostNotebookRenderers,new Oe.$Gjc(Ze,Je)),Mt=Ze.set(n.$$L.ExtHostNotebookDocumentSaveParticipant,new be.$Bjc(gt,Je,Ze.getProxy(n.$0L.MainThreadBulkEdits))),St=Ze.set(n.$$L.ExtHostEditors,new ne.$jic(Ze,Vt)),vi=Ze.set(n.$$L.ExtHostTreeViews,new Ge.$4jc(Ze.getProxy(n.$0L.MainThreadTreeViews),kt,gt)),Pi=Ze.set(n.$$L.ExtHostEditorInsets,new b.$kic(Ze.getProxy(n.$0L.MainThreadEditorInsets),St,pt.remote)),bi=Ze.set(n.$$L.ExtHostDiagnostics,new T.$9hc(Ze,gt,ti,Vt)),pi=Ze.set(n.$$L.ExtHostLanguages,new ce.$zjc(Ze,Me,kt.converter,Yt)),ht=Ze.set(n.$$L.ExtHostLanguageFeatures,new ue.$$hc(Ze,Yt,Me,kt,bi,gt,At,Rt)),Ai=Ze.set(n.$$L.ExtHostFileSystem,new ae.$hjc(Ze,ht)),ui=Ze.set(n.$$L.ExtHostFileSystemEventService,new ge.$ijc(Ze,gt,Vt)),gi=Ze.set(n.$$L.ExtHostQuickOpen,(0,J.$Mjc)(Ze,ft,kt)),Ri=Ze.set(n.$$L.ExtHostSCM,new ve.$Ojc(Ze,kt,Me,gt)),ln=Ze.set(n.$$L.ExtHostQuickDiff,new Q.$Ljc(Ze,Yt)),Zi=Ze.set(n.$$L.ExtHostShare,new Xe.$Pjc(Ze,Yt)),Li=Ze.set(n.$$L.ExtHostComments,(0,k.$lic)(Ze,kt,Me)),ki=Ze.set(n.$$L.ExtHostProgress,new W.$Kjc(Ze.getProxy(n.$0L.MainThreadProgress))),Yi=Ze.set(n.$$L.ExtHostLabelService,new le.$yjc(Ze)),Mi=Ze.set(n.$$L.ExtHostTheming,new oe.$1jc(Ze)),xi=Ze.set(n.$$L.ExtHostTimeline,new Ce.$3jc(Ze,kt)),yi=Ze.set(n.$$L.ExtHostWebviews,new jt.$zic(Ze,pt.remote,ft,gt,At)),Ei=Ze.set(n.$$L.ExtHostWebviewPanels,new Zt.$Cic(Ze,yi,ft)),hn=Ze.set(n.$$L.ExtHostCustomEditors,new F.$Dic(Ze,Me,Wt,yi,Ei)),dn=Ze.set(n.$$L.ExtHostWebviewViews,new Ct.$7jc(Ze,yi)),mi=Ze.set(n.$$L.ExtHostTesting,new Ke.$Wjc(Ze,gt,kt,Vt)),Oi=Ze.set(n.$$L.ExtHostUriOpeners,new $t.$5jc(Ze)),fn=Ze.set(n.$$L.ExtHostProfileContentHandlers,new q.$Jjc(Ze));Ze.set(n.$$L.ExtHostInteractive,new ie.$wjc(Ze,Je,Vt,kt,gt));const gn=Ze.set(n.$$L.ExtHostInlineChat,new B.$jjc(Ze,kt,Me,gt)),_i=Ze.set(n.$$L.ExtHostChatAgents2,new a.$eic(Ze,gt,kt)),mn=Ze.set(n.$$L.ExtHostChatVariables,new $.$hic(Ze)),wi=Ze.set(n.$$L.ExtHostChat,new s.$dic(Ze)),Ni=Ze.set(n.$$L.ExtHostAiRelatedInformation,new r.$2hc(Ze)),en=Ze.set(n.$$L.ExtHostAiEmbeddingVector,new Z.$gjc(Ze)),Fi=Ze.set(n.$$L.ExtHostIssueReporter,new ke.$xjc(Ze)),tn=Ze.set(n.$$L.ExtHostStatusBar,new st.$Sjc(Ze,kt.converter)),Ti=Ze.set(n.$$L.ExtHostSpeech,new tt.$Qjc(Ze)),nn=Object.values(n.$$L);Ze.assertRegistered(nn);const di=new h.$cic(Ze,Vt),Si=new D.$iic(Ze),ji=new Y.$Ajc(Ze,gt),oi=new I.$djc(Ze);return c.$_hc.register(kt),function(Ue,li,zi){function ot(me){return(ye,We,at)=>{const wt=me(Tt=>{try{ye.call(We,Tt)}catch(Ji){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${Ji.toString()}`,{cause:Ji})),Rt.onExtensionError(Ue.identifier,Ji)}});return at?.push(wt),wt}}const bt=function(){let me=!Ue.isUnderDevelopment;function ye(){me||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),me=!0)}return function We(at){if(Array.isArray(at))at.forEach(We);else if(typeof at=="string")ye();else{const wt=at;typeof wt.scheme>"u"&&ye(),typeof wt.exclusive=="boolean"&&(0,et.$1F)(Ue,"documentFiltersExclusive")}return at}}(),$n={getSession(me,ye,We){return yt.getSession(Ue,me,ye,We)},getSessions(me,ye){return(0,et.$1F)(Ue,"authGetSessions"),yt.getSessions(Ue,me,ye)},async hasSession(me,ye){return(0,et.$1F)(Ue,"authSession"),!!await yt.getSession(Ue,me,ye,{silent:!0})},get onDidChangeSessions(){return ot(yt.onDidChangeSessions)},registerAuthenticationProvider(me,ye,We,at){return yt.registerAuthenticationProvider(me,ye,We,at)}},rn={registerCommand(me,ye,We){return kt.registerCommand(!0,me,ye,We,void 0,Ue)},registerTextEditorCommand(me,ye,We){return kt.registerCommand(!0,me,(...at)=>{const wt=St.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}return wt.edit(Tt=>{ye.apply(We,[wt,Tt,...at])}).then(Tt=>{Tt||gt.warn("Edits from command "+me+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+me,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(me,ye,We)=>((0,et.$1F)(Ue,"diffCommand"),kt.registerCommand(!0,me,async(...at)=>{const wt=Vt.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+me+" because there is no active text editor.");return}const Tt=await St.getDiffInformation(wt.id);ye.apply(We,[Tt,...at])},void 0,void 0,Ue)),executeCommand(me,...ye){return kt.executeCommand(me,...ye)},getCommands(me=!1){return kt.getCommands(me)}},Bi={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Si.value},get shell(){return It.getDefaultShell(!1)},get onDidChangeShell(){return ot(It.onDidChangeShell)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(Rt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$1F)(Ue,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$1F)(Ue,"telemetry"),ot(Rt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Be.$IO)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(me,ye){return Be.$HO.validateSender(me),Rt.instantiateLogger(Ue,me,ye)},openExternal(me,ye){return qt.openUri(me,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(me){if(me.scheme===pt.environment.appUriScheme)return ee.createAppUri(me);try{return await qt.asExternalUri(me,{allowTunneling:!!pt.remote.authority})}catch(ye){if((0,R.$pg)(me,R.Schemas.http)||(0,R.$pg)(me,R.Schemas.https))return me;throw ye}},get remoteName(){return(0,m.$rm)(pt.remote.authority)},get remoteAuthority(){return(0,et.$1F)(Ue,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(me){return(0,et.$1F)(Ue,"handleIssueUri"),Fi.registerIssueUriRequestHandler(Ue,me)},registerIssueDataProvider(me){return(0,et.$1F)(Ue,"handleIssueUri"),Fi.registerIssueDataProvider(Ue,me)},get appQuality(){return(0,et.$1F)(Ue,"resolvers"),pt.quality},get appCommit(){return(0,et.$1F)(Ue,"resolvers"),pt.commit}};pt.environment.extensionTestsLocationURI||Object.freeze(Bi);const bn={createTestController(me,ye,We){return mi.createTestController(Ue,me,ye,We)},createTestObserver(){return(0,et.$1F)(Ue,"testObserver"),mi.createTestObserver()},runTests(me){return(0,et.$1F)(Ue,"testObserver"),mi.runTests(me)},get onDidChangeTestResults(){return(0,et.$1F)(Ue,"testObserver"),ot(mi.onResultsChanged)},get testResults(){return(0,et.$1F)(Ue,"testObserver"),mi.results}},Di=pt.remote.isRemote?Fe.ExtensionKind.Workspace:Fe.ExtensionKind.UI,sn={getExtension(me,ye){(0,et.$ZF)(Ue,"extensionsAny")||(ye=!1);const We=li.mine.getExtensionDescription(me);if(We)return new X.$5ic(Ut,Ue.identifier,We,Di,!1);if(ye){const at=li.all.getExtensionDescription(me);if(at)return new X.$5ic(Ut,Ue.identifier,at,Di,!0)}},get all(){const me=[];for(const ye of li.mine.getAllExtensionDescriptions())me.push(new X.$5ic(Ut,Ue.identifier,ye,Di,!1));return me},get allAcrossExtensionHosts(){(0,et.$1F)(Ue,"extensionsAny");const me=new S.$Bm(li.mine.getAllExtensionDescriptions().map(We=>We.identifier)),ye=[];for(const We of li.all.getAllExtensionDescriptions()){const at=!me.has(We.identifier);ye.push(new X.$5ic(Ut,Ue.identifier,We,Di,at))}return ye},get onDidChange(){return(0,et.$ZF)(Ue,"extensionsAny")?ot(L.Event.any(li.mine.onDidChange,li.all.onDidChange)):ot(li.mine.onDidChange)}},Ui={createDiagnosticCollection(me){return bi.createDiagnosticCollection(Ue.identifier,me)},get onDidChangeDiagnostics(){return ot(bi.onDidChangeDiagnostics)},getDiagnostics:me=>bi.getDiagnostics(me),getLanguages(){return pi.getLanguages()},setTextDocumentLanguage(me,ye){return pi.changeLanguage(me.uri,ye)},match(me,ye){const We=nt.LanguageSelector.from(me);let at;return(0,M.$Rt)(We)&&(at=Je.notebookDocuments.find(wt=>!!wt.getCell(ye.uri))?.apiNotebook),(0,M.$Qt)(We,ye.uri,ye.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(me,ye,We){return ht.registerCodeActionProvider(Ue,bt(me),ye,We)},registerDocumentPasteEditProvider(me,ye,We){return(0,et.$1F)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,bt(me),ye,We)},registerCodeLensProvider(me,ye){return ht.registerCodeLensProvider(Ue,bt(me),ye)},registerDefinitionProvider(me,ye){return ht.registerDefinitionProvider(Ue,bt(me),ye)},registerDeclarationProvider(me,ye){return ht.registerDeclarationProvider(Ue,bt(me),ye)},registerImplementationProvider(me,ye){return ht.registerImplementationProvider(Ue,bt(me),ye)},registerTypeDefinitionProvider(me,ye){return ht.registerTypeDefinitionProvider(Ue,bt(me),ye)},registerHoverProvider(me,ye){return ht.registerHoverProvider(Ue,bt(me),ye,Ue.identifier)},registerEvaluatableExpressionProvider(me,ye){return ht.registerEvaluatableExpressionProvider(Ue,bt(me),ye,Ue.identifier)},registerInlineValuesProvider(me,ye){return ht.registerInlineValuesProvider(Ue,bt(me),ye,Ue.identifier)},registerDocumentHighlightProvider(me,ye){return ht.registerDocumentHighlightProvider(Ue,bt(me),ye)},registerMultiDocumentHighlightProvider(me,ye){return ht.registerMultiDocumentHighlightProvider(Ue,bt(me),ye)},registerLinkedEditingRangeProvider(me,ye){return ht.registerLinkedEditingRangeProvider(Ue,bt(me),ye)},registerReferenceProvider(me,ye){return ht.registerReferenceProvider(Ue,bt(me),ye)},registerRenameProvider(me,ye){return ht.registerRenameProvider(Ue,bt(me),ye)},registerNewSymbolNamesProvider(me,ye){return(0,et.$1F)(Ue,"newSymbolNamesProvider"),ht.registerNewSymbolNamesProvider(Ue,bt(me),ye)},registerDocumentSymbolProvider(me,ye,We){return ht.registerDocumentSymbolProvider(Ue,bt(me),ye,We)},registerWorkspaceSymbolProvider(me){return ht.registerWorkspaceSymbolProvider(Ue,me)},registerDocumentFormattingEditProvider(me,ye){return ht.registerDocumentFormattingEditProvider(Ue,bt(me),ye)},registerDocumentRangeFormattingEditProvider(me,ye){return ht.registerDocumentRangeFormattingEditProvider(Ue,bt(me),ye)},registerOnTypeFormattingEditProvider(me,ye,We,...at){return ht.registerOnTypeFormattingEditProvider(Ue,bt(me),ye,[We].concat(at))},registerDocumentSemanticTokensProvider(me,ye,We){return ht.registerDocumentSemanticTokensProvider(Ue,bt(me),ye,We)},registerDocumentRangeSemanticTokensProvider(me,ye,We){return ht.registerDocumentRangeSemanticTokensProvider(Ue,bt(me),ye,We)},registerSignatureHelpProvider(me,ye,We,...at){return typeof We=="object"?ht.registerSignatureHelpProvider(Ue,bt(me),ye,We):ht.registerSignatureHelpProvider(Ue,bt(me),ye,typeof We>"u"?[]:[We,...at])},registerCompletionItemProvider(me,ye,...We){return ht.registerCompletionItemProvider(Ue,bt(me),ye,We)},registerInlineCompletionItemProvider(me,ye,We){return ye.handleDidShowCompletionItem&&(0,et.$1F)(Ue,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,et.$1F)(Ue,"inlineCompletionsAdditions"),We&&(0,et.$1F)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,bt(me),ye,We)},registerInlineEditProvider(me,ye){return(0,et.$1F)(Ue,"inlineEdit"),ht.registerInlineEditProvider(Ue,bt(me),ye)},registerDocumentLinkProvider(me,ye){return ht.registerDocumentLinkProvider(Ue,bt(me),ye)},registerColorProvider(me,ye){return ht.registerColorProvider(Ue,bt(me),ye)},registerFoldingRangeProvider(me,ye){return ht.registerFoldingRangeProvider(Ue,bt(me),ye)},registerSelectionRangeProvider(me,ye){return ht.registerSelectionRangeProvider(Ue,me,ye)},registerCallHierarchyProvider(me,ye){return ht.registerCallHierarchyProvider(Ue,me,ye)},registerTypeHierarchyProvider(me,ye){return ht.registerTypeHierarchyProvider(Ue,me,ye)},setLanguageConfiguration:(me,ye)=>ht.setLanguageConfiguration(Ue,me,ye),getTokenInformationAtPosition(me,ye){return(0,et.$1F)(Ue,"tokenInformation"),pi.tokenAtPosition(me,ye)},registerInlayHintsProvider(me,ye){return ht.registerInlayHintsProvider(Ue,me,ye)},createLanguageStatusItem(me,ye){return pi.createLanguageStatusItem(Ue,me,ye)},registerDocumentDropEditProvider(me,ye,We){return ht.registerDocumentOnDropEditProvider(Ue,me,ye,(0,et.$ZF)(Ue,"dropMetadata")?We:void 0)}},on={get activeTextEditor(){return St.getActiveTextEditor()},get visibleTextEditors(){return St.getVisibleTextEditors()},get activeTerminal(){return It.activeTerminal},get terminals(){return It.terminals},async showTextDocument(me,ye,We){p.URI.isUri(me)&&me.scheme===R.Schemas.vscodeRemote&&!me.authority&&At.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(p.URI.isUri(me)?Promise.resolve(Wi.openTextDocument(me)):Promise.resolve(me));return St.showTextDocument(at,ye,We)},createTextEditorDecorationType(me){return St.createTextEditorDecorationType(Ue,me)},onDidChangeActiveTextEditor(me,ye,We){return ot(St.onDidChangeActiveTextEditor)(me,ye,We)},onDidChangeVisibleTextEditors(me,ye,We){return ot(St.onDidChangeVisibleTextEditors)(me,ye,We)},onDidChangeTextEditorSelection(me,ye,We){return ot(St.onDidChangeTextEditorSelection)(me,ye,We)},onDidChangeTextEditorOptions(me,ye,We){return ot(St.onDidChangeTextEditorOptions)(me,ye,We)},onDidChangeTextEditorVisibleRanges(me,ye,We){return ot(St.onDidChangeTextEditorVisibleRanges)(me,ye,We)},onDidChangeTextEditorViewColumn(me,ye,We){return ot(St.onDidChangeTextEditorViewColumn)(me,ye,We)},onDidCloseTerminal(me,ye,We){return ot(It.onDidCloseTerminal)(me,ye,We)},onDidOpenTerminal(me,ye,We){return ot(It.onDidOpenTerminal)(me,ye,We)},onDidChangeActiveTerminal(me,ye,We){return ot(It.onDidChangeActiveTerminal)(me,ye,We)},onDidChangeTerminalDimensions(me,ye,We){return(0,et.$1F)(Ue,"terminalDimensions"),ot(It.onDidChangeTerminalDimensions)(me,ye,We)},onDidChangeTerminalState(me,ye,We){return ot(It.onDidChangeTerminalState)(me,ye,We)},onDidWriteTerminalData(me,ye,We){return(0,et.$1F)(Ue,"terminalDataWriteEvent"),ot(It.onDidWriteTerminalData)(me,ye,We)},onDidExecuteTerminalCommand(me,ye,We){return(0,et.$1F)(Ue,"terminalExecuteCommandEvent"),ot(It.onDidExecuteTerminalCommand)(me,ye,We)},get state(){return qt.getState(Ue)},onDidChangeWindowState(me,ye,We){return ot(qt.onDidChangeWindowState)(me,ye,We)},showInformationMessage(me,...ye){return ji.showMessage(Ue,w.default.Info,me,ye[0],ye.slice(1))},showWarningMessage(me,...ye){return ji.showMessage(Ue,w.default.Warning,me,ye[0],ye.slice(1))},showErrorMessage(me,...ye){return ji.showMessage(Ue,w.default.Error,me,ye[0],ye.slice(1))},showQuickPick(me,ye,We){return gi.showQuickPick(Ue,me,ye,We)},showWorkspaceFolderPick(me){return gi.showWorkspaceFolderPick(me)},showInputBox(me,ye){return gi.showInput(me,ye)},showOpenDialog(me){return oi.showOpenDialog(Ue,me)},showSaveDialog(me){return oi.showSaveDialog(me)},createStatusBarItem(me,ye,We){let at,wt,Tt;return typeof me=="string"?(at=me,wt=ye,Tt=We):(wt=me,Tt=ye),tn.createStatusBarEntry(Ue,at,wt,Tt)},setStatusBarMessage(me,ye){return tn.setStatusBarMessage(me,ye)},withScmProgress(me){return At.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),ki.withProgress(Ue,{location:Fe.ProgressLocation.SourceControl},(ye,We)=>me({report(at){}}))},withProgress(me,ye){return ki.withProgress(Ue,me,ye)},createOutputChannel(me,ye){return je.createOutputChannel(me,ye,Ue)},createWebviewPanel(me,ye,We,at){return Ei.createWebviewPanel(Ue,me,ye,We,at)},createWebviewTextEditorInset(me,ye,We,at){return(0,et.$1F)(Ue,"editorInsets"),Pi.createWebviewEditorInset(me,ye,We,at,Ue)},createTerminal(me,ye,We){return typeof me=="object"?"pty"in me?It.createExtensionTerminal(me):It.createTerminalFromOptions(me):It.createTerminal(me,ye,We)},registerTerminalLinkProvider(me){return It.registerLinkProvider(me)},registerTerminalProfileProvider(me,ye){return It.registerProfileProvider(Ue,me,ye)},registerTerminalQuickFixProvider(me,ye){return(0,et.$1F)(Ue,"terminalQuickFixProvider"),It.registerTerminalQuickFixProvider(me,Ue.identifier.value,ye)},registerTreeDataProvider(me,ye){return vi.registerTreeDataProvider(me,ye,Ue)},createTreeView(me,ye){return vi.createTreeView(me,ye,Ue)},registerWebviewPanelSerializer:(me,ye)=>Ei.registerWebviewPanelSerializer(Ue,me,ye),registerCustomEditorProvider:(me,ye,We={})=>hn.registerCustomEditorProvider(Ue,me,ye,We),registerFileDecorationProvider(me){return Xt.registerFileDecorationProvider(me,Ue)},registerUriHandler(me){return ee.registerUriHandler(Ue,me)},createQuickPick(){return gi.createQuickPick(Ue)},createInputBox(){return gi.createInputBox(Ue)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(me,ye,We){return ot(Mi.onDidChangeActiveColorTheme)(me,ye,We)},registerWebviewViewProvider(me,ye,We){return dn.registerWebviewViewProvider(Ue,me,ye,We?.webviewOptions)},get activeNotebookEditor(){return Je.activeNotebookEditor},onDidChangeActiveNotebookEditor(me,ye,We){return ot(Je.onDidChangeActiveNotebookEditor)(me,ye,We)},get visibleNotebookEditors(){return Je.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Je.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(me,ye,We){return ot(vt.onDidChangeNotebookEditorSelection)(me,ye,We)},onDidChangeNotebookEditorVisibleRanges(me,ye,We){return ot(vt.onDidChangeNotebookEditorVisibleRanges)(me,ye,We)},showNotebookDocument(me,ye){return Je.showNotebookDocument(me,ye)},registerExternalUriOpener(me,ye,We){return(0,et.$1F)(Ue,"externalUriOpener"),Oi.registerExternalUriOpener(Ue.identifier,me,ye,We)},registerProfileContentHandler(me,ye){return(0,et.$1F)(Ue,"profileContentHandlers"),fn.registerProfileContentHandler(Ue,me,ye)},registerQuickDiffProvider(me,ye,We,at){return(0,et.$1F)(Ue,"quickDiffProvider"),ln.registerQuickDiffProvider(bt(me),ye,We,at)},get tabGroups(){return zt.tabGroups},registerShareProvider(me,ye){return(0,et.$1F)(Ue,"shareProvider"),Zi.registerShareProvider(bt(me),ye)}},Wi={get rootPath(){return At.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(me){throw new N.$9("rootPath")},getWorkspaceFolder(me){return ft.getWorkspaceFolder(me)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(me){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(me){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(me,ye,...We)=>ft.updateWorkspaceFolders(Ue,me,ye||0,...We),onDidChangeWorkspaceFolders:function(me,ye,We){return ot(ft.onDidChangeWorkspace)(me,ye,We)},asRelativePath:(me,ye)=>ft.getRelativePath(me,ye),findFiles:(me,ye,We,at)=>ft.findFiles(me,ye,We,Ue.identifier,at),findFiles2:(me,ye,We)=>((0,et.$1F)(Ue,"findFiles2"),ft.findFiles2(me,ye,Ue.identifier,We)),findTextInFiles:(me,ye,We,at)=>{(0,et.$1F)(Ue,"findTextInFiles");let wt,Tt;return typeof ye=="object"?(wt=ye,Tt=We):(wt={},Tt=ye,at=We),ft.findTextInFiles(me,wt||{},Tt,Ue.identifier,at)},save:me=>ft.save(me),saveAs:me=>ft.saveAs(me),saveAll:me=>ft.saveAll(me),applyEdit(me,ye){return di.applyWorkspaceEdit(me,Ue,ye)},createFileSystemWatcher:(me,ye,We,at)=>{let wt;return typeof ye=="boolean"?wt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!We,ignoreDeleteEvents:!!at,correlate:!1}:ye&&((0,et.$1F)(Ue,"createFileSystemWatcher"),wt={...ye,correlate:!0}),ui.createFileSystemWatcher(ft,Ue,me,wt)},get textDocuments(){return Me.getAllDocumentData().map(me=>me.document)},set textDocuments(me){throw new N.$9("textDocuments")},openTextDocument(me){let ye;const We=me;if(typeof me=="string")ye=Promise.resolve(p.URI.file(me));else if(p.URI.isUri(me))ye=Promise.resolve(me);else if(!We||typeof We=="object")ye=Me.createDocumentData(We);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(at=>(at.scheme===R.Schemas.vscodeRemote&&!at.authority&&At.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),Me.ensureDocumentData(at).then(wt=>wt.document)))},onDidOpenTextDocument:(me,ye,We)=>ot(Me.onDidAddDocument)(me,ye,We),onDidCloseTextDocument:(me,ye,We)=>ot(Me.onDidRemoveDocument)(me,ye,We),onDidChangeTextDocument:(me,ye,We)=>ot(Me.onDidChangeDocument)(me,ye,We),onDidSaveTextDocument:(me,ye,We)=>ot(Me.onDidSaveDocument)(me,ye,We),onWillSaveTextDocument:(me,ye,We)=>ot(_e.getOnWillSaveTextDocumentEvent(Ue))(me,ye,We),get notebookDocuments(){return Je.notebookDocuments.map(me=>me.apiNotebook)},async openNotebookDocument(me,ye){let We;if(p.URI.isUri(me))We=me,await Je.openNotebookDocument(me);else if(typeof me=="string")We=p.URI.revive(await Je.createNotebookDocument({viewType:me,content:ye}));else throw new Error("Invalid arguments");return Je.getNotebookDocument(We).apiNotebook},onDidSaveNotebookDocument(me,ye,We){return ot(ct.onDidSaveNotebookDocument)(me,ye,We)},onDidChangeNotebookDocument(me,ye,We){return ot(ct.onDidChangeNotebookDocument)(me,ye,We)},onWillSaveNotebookDocument(me,ye,We){return ot(Mt.getOnWillSaveNotebookDocumentEvent(Ue))(me,ye,We)},get onDidOpenNotebookDocument(){return ot(Je.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Je.onDidCloseNotebookDocument)},registerNotebookSerializer(me,ye,We,at){return Je.registerNotebookSerializer(Ue,me,ye,We,(0,et.$ZF)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(me,ye,We)=>ot(zi.onDidChangeConfiguration)(me,ye,We),getConfiguration(me,ye){return ye=arguments.length===1?void 0:ye,zi.getConfiguration(me,ye,Ue)},registerTextDocumentContentProvider(me,ye){return qe.registerTextDocumentContentProvider(me,ye)},registerTaskProvider:(me,ye)=>(At.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Re.registerTaskProvider(Ue,me,ye)),registerFileSystemProvider(me,ye,We){return(0,A.$Qc)(Ai.registerFileSystemProvider(Ue,me,ye,We),Ht.addFileSystemProvider(me,ye,We))},get fs(){return Ht.value},registerFileSearchProvider:(me,ye)=>((0,et.$1F)(Ue,"fileSearchProvider"),ci.registerFileSearchProvider(me,ye)),registerTextSearchProvider:(me,ye)=>((0,et.$1F)(Ue,"textSearchProvider"),ci.registerTextSearchProvider(me,ye)),registerAITextSearchProvider:(me,ye)=>((0,et.$1F)(Ue,"aiTextSearchProvider"),(0,et.$1F)(Ue,"textSearchProvider"),ci.registerAITextSearchProvider(me,ye)),registerRemoteAuthorityResolver:(me,ye)=>((0,et.$1F)(Ue,"resolvers"),Ut.registerRemoteAuthorityResolver(me,ye)),registerResourceLabelFormatter:me=>((0,et.$1F)(Ue,"resolvers"),Yi.$registerResourceLabelFormatter(me)),getRemoteExecServer:me=>((0,et.$1F)(Ue,"resolvers"),Ut.getRemoteExecServer(me)),onDidCreateFiles:(me,ye,We)=>ot(ui.onDidCreateFile)(me,ye,We),onDidDeleteFiles:(me,ye,We)=>ot(ui.onDidDeleteFile)(me,ye,We),onDidRenameFiles:(me,ye,We)=>ot(ui.onDidRenameFile)(me,ye,We),onWillCreateFiles:(me,ye,We)=>ot(ui.getOnWillCreateFileEvent(Ue))(me,ye,We),onWillDeleteFiles:(me,ye,We)=>ot(ui.getOnWillDeleteFileEvent(Ue))(me,ye,We),onWillRenameFiles:(me,ye,We)=>ot(ui.getOnWillRenameFileEvent(Ue))(me,ye,We),openTunnel:me=>((0,et.$1F)(Ue,"tunnels"),Ot.openTunnel(Ue,me).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,et.$1F)(Ue,"tunnels"),Ot.getTunnels()},onDidChangeTunnels:(me,ye,We)=>((0,et.$1F)(Ue,"tunnels"),ot(Ot.onDidChangeTunnels)(me,ye,We)),registerPortAttributesProvider:(me,ye)=>((0,et.$1F)(Ue,"portsAttributes"),Ot.registerPortsAttributesProvider(me,ye)),registerTunnelProvider:(me,ye)=>((0,et.$1F)(Ue,"tunnelFactory"),Ot.registerTunnelProvider(me,ye)),registerTimelineProvider:(me,ye)=>((0,et.$1F)(Ue,"timeline"),xi.registerTimelineProvider(me,ye,Ue.identifier,kt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:me=>((0,et.$1F)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(me)),onDidGrantWorkspaceTrust:(me,ye,We)=>ot(ft.onDidGrantWorkspaceTrust)(me,ye,We),registerEditSessionIdentityProvider:(me,ye)=>((0,et.$1F)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(me,ye)),onWillCreateEditSessionIdentity:(me,ye,We)=>((0,et.$1F)(Ue,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(me,ye,We)),registerCanonicalUriProvider:(me,ye)=>((0,et.$1F)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(me,ye)),getCanonicalUri:(me,ye,We)=>((0,et.$1F)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(me,ye,We))},an={get inputBox(){return At.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Ri.getLastInputBox(Ue)},createSourceControl(me,ye,We){return Ri.createSourceControl(Ue,me,ye,We)}},pn={createCommentController(me,ye){return Li.createCommentController(Ue,me,ye)}},wn={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},get stackFrameFocus(){return Et.stackFrameFocus},registerDebugVisualizationProvider(me,ye){return(0,et.$1F)(Ue,"debugVisualization"),Et.registerDebugVisualizationProvider(Ue,me,ye)},registerDebugVisualizationTreeProvider(me,ye){return(0,et.$1F)(Ue,"debugVisualization"),Et.registerDebugVisualizationTree(Ue,me,ye)},onDidStartDebugSession(me,ye,We){return ot(Et.onDidStartDebugSession)(me,ye,We)},onDidTerminateDebugSession(me,ye,We){return ot(Et.onDidTerminateDebugSession)(me,ye,We)},onDidChangeActiveDebugSession(me,ye,We){return ot(Et.onDidChangeActiveDebugSession)(me,ye,We)},onDidReceiveDebugSessionCustomEvent(me,ye,We){return ot(Et.onDidReceiveDebugSessionCustomEvent)(me,ye,We)},onDidChangeBreakpoints(me,ye,We){return ot(Et.onDidChangeBreakpoints)(me,ye,We)},onDidChangeStackFrameFocus(me,ye,We){return(0,et.$1F)(Ue,"debugFocus"),ot(Et.onDidChangeStackFrameFocus)(me,ye,We)},registerDebugConfigurationProvider(me,ye,We){return Et.registerDebugConfigurationProvider(me,ye,We||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(me,ye){return Et.registerDebugAdapterDescriptorFactory(Ue,me,ye)},registerDebugAdapterTrackerFactory(me,ye){return Et.registerDebugAdapterTrackerFactory(me,ye)},startDebugging(me,ye,We){return!We||typeof We=="object"&&"configuration"in We?Et.startDebugging(me,ye,{parentSession:We}):Et.startDebugging(me,ye,We||{})},stopDebugging(me){return Et.stopDebugging(me)},addBreakpoints(me){return Et.addBreakpoints(me)},removeBreakpoints(me){return Et.removeBreakpoints(me)},asDebugSourceUri(me,ye){return Et.asDebugSourceUri(me,ye)}},cn={registerTaskProvider:(me,ye)=>Re.registerTaskProvider(Ue,me,ye),fetchTasks:me=>Re.fetchTasks(me),executeTask:me=>Re.executeTask(Ue,me),get taskExecutions(){return Re.taskExecutions},onDidStartTask:(me,ye,We)=>ot(Re.onDidStartTask)(me,ye,We),onDidEndTask:(me,ye,We)=>ot(Re.onDidEndTask)(me,ye,We),onDidStartTaskProcess:(me,ye,We)=>ot(Re.onDidStartTaskProcess)(me,ye,We),onDidEndTaskProcess:(me,ye,We)=>ot(Re.onDidEndTaskProcess)(me,ye,We)},un={createNotebookController(me,ye,We,at,wt){return Ft.createNotebookController(Ue,me,ye,We,at,(0,et.$ZF)(Ue,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(me,ye)=>Je.registerNotebookCellStatusBarItemProvider(Ue,me,ye),createRendererMessaging(me){return xt.createRendererMessaging(Ue,me)},createNotebookControllerDetectionTask(me){return(0,et.$1F)(Ue,"notebookKernelSource"),Ft.createNotebookControllerDetectionTask(Ue,me)},registerKernelSourceActionProvider(me,ye){return(0,et.$1F)(Ue,"notebookKernelSource"),Ft.registerKernelSourceActionProvider(Ue,me,ye)},onDidChangeNotebookCellExecutionState(me,ye,We){return(0,et.$1F)(Ue,"notebookCellExecutionState"),ot(Ft.onDidChangeNotebookCellExecutionState)(me,ye,We)}},qi={t(...me){if(typeof me[0]=="string"){const ye=me.shift(),We=!me||typeof me[0]!="object"?me:me[0];return Ee.getMessage(Ue.identifier.value,{message:ye,args:We})}return Ee.getMessage(Ue.identifier.value,me[0])},get bundle(){return Ee.getBundle(Ue.identifier.value)},get uri(){return Ee.getBundleUri(Ue.identifier.value)}},Vi={_version:1,registerInteractiveEditorSessionProvider(me,ye){return(0,et.$1F)(Ue,"interactive"),gn.registerProvider(Ue,me,ye)},registerInteractiveSessionProvider(me,ye){return(0,et.$1F)(Ue,"interactive"),wi.registerChatProvider(Ue,me,ye)},sendInteractiveRequestToProvider(me,ye){return(0,et.$1F)(Ue,"interactive"),wi.sendInteractiveRequestToProvider(me,ye)},transferChatSession(me,ye){return(0,et.$1F)(Ue,"interactive"),wi.transferChatSession(me,ye)}},Hi={getRelatedInformation(me,ye){return(0,et.$1F)(Ue,"aiRelatedInformation"),Ni.getRelatedInformation(Ue,me,ye)},registerRelatedInformationProvider(me,ye){return(0,et.$1F)(Ue,"aiRelatedInformation"),Ni.registerRelatedInformationProvider(Ue,me,ye)},registerEmbeddingVectorProvider(me,ye){return(0,et.$1F)(Ue,"aiRelatedInformation"),en.registerEmbeddingVectorProvider(Ue,me,ye)}},Ci={registerChatResponseProvider(me,ye,We){return(0,et.$1F)(Ue,"chatProvider"),Nt.registerLanguageModel(Ue,me,ye,We)},registerChatVariableResolver(me,ye,We){return(0,et.$1F)(Ue,"chatVariableResolver"),mn.registerVariableResolver(Ue,me,ye,We)},registerMappedEditsProvider(me,ye){return(0,et.$1F)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,me,ye)},createChatParticipant(me,ye){return(0,et.$1F)(Ue,"chatParticipant"),_i.createChatAgent(Ue,me,ye)}},Ki={get languageModels(){return(0,et.$1F)(Ue,"languageModels"),Nt.getLanguageModelIds()},onDidChangeLanguageModels:(me,ye,We)=>((0,et.$1F)(Ue,"languageModels"),Nt.onDidChangeProviders(me,ye,We)),sendChatRequest(me,ye,We,at){return(0,et.$1F)(Ue,"languageModels"),Nt.sendChatRequest(Ue,me,ye,We,at)}},Gi={registerSpeechProvider(me,ye){return(0,et.$1F)(Ue,"speech"),Ti.registerProvider(Ue.identifier,me,ye)}};return{version:pt.version,ai:Hi,authentication:$n,commands:rn,comments:pn,chat:Ci,debug:wn,env:Bi,extensions:sn,interactive:Vi,l10n:qi,languages:Ui,lm:Ki,notebooks:un,scm:an,speech:Gi,tasks:cn,tests:bn,window:on,workspace:Wi,Breakpoint:Fe.$$M,TerminalOutputAnchor:Fe.TerminalOutputAnchor,ChatResultFeedbackKind:Fe.ChatResultFeedbackKind,ChatVariableLevel:Fe.ChatVariableLevel,ChatCompletionItem:Fe.$4N,CallHierarchyIncomingCall:Fe.$xM,CallHierarchyItem:Fe.$wM,CallHierarchyOutgoingCall:Fe.$yM,CancellationError:N.$5,CancellationTokenSource:l.$de,CandidatePortSource:n.CandidatePortSource,CodeAction:Fe.$tM,CodeActionKind:Fe.$uM,CodeActionTriggerKind:Fe.CodeActionTriggerKind,CodeLens:Fe.$zM,Color:Fe.$MM,ColorInformation:Fe.$NM,ColorPresentation:Fe.$OM,ColorThemeKind:Fe.ColorThemeKind,CommentMode:Fe.CommentMode,CommentState:Fe.CommentState,CommentThreadCollapsibleState:Fe.CommentThreadCollapsibleState,CommentThreadState:Fe.CommentThreadState,CompletionItem:Fe.$GM,CompletionItemKind:Fe.CompletionItemKind,CompletionItemTag:Fe.CompletionItemTag,CompletionList:Fe.$HM,CompletionTriggerKind:Fe.CompletionTriggerKind,ConfigurationTarget:Fe.ConfigurationTarget,CustomExecution:Fe.$WM,DebugAdapterExecutable:Fe.$cN,DebugAdapterInlineImplementation:Fe.$fN,DebugAdapterNamedPipeServer:Fe.$eN,DebugAdapterServer:Fe.$dN,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Fe.DebugConsoleMode,DebugVisualization:Fe.$vN,DecorationRangeBehavior:Fe.DecorationRangeBehavior,Diagnostic:Fe.$nM,DiagnosticRelatedInformation:Fe.$mM,DiagnosticSeverity:Fe.DiagnosticSeverity,DiagnosticTag:Fe.DiagnosticTag,Disposable:Fe.$_L,DocumentHighlight:Fe.$pM,DocumentHighlightKind:Fe.DocumentHighlightKind,MultiDocumentHighlight:Fe.$qM,DocumentLink:Fe.$LM,DocumentSymbol:Fe.$sM,EndOfLine:Fe.EndOfLine,EnvironmentVariableMutatorType:Fe.EnvironmentVariableMutatorType,EvaluatableExpression:Fe.$iN,InlineValueText:Fe.$jN,InlineValueVariableLookup:Fe.$kN,InlineValueEvaluatableExpression:Fe.$lN,InlineCompletionTriggerKind:Fe.InlineCompletionTriggerKind,EventEmitter:L.$6d,ExtensionKind:Fe.ExtensionKind,ExtensionMode:Fe.ExtensionMode,ExternalUriOpenerPriority:Fe.ExternalUriOpenerPriority,FileChangeType:Fe.FileChangeType,FileDecoration:Fe.$xN,FileDecoration2:Fe.$xN,FileSystemError:Fe.$oN,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:Fe.$pN,FoldingRangeKind:Fe.FoldingRangeKind,FunctionBreakpoint:Fe.$aN,InlineCompletionItem:Fe.$IM,InlineCompletionList:Fe.$JM,Hover:Fe.$oM,IndentAction:C.IndentAction,Location:Fe.$lM,MarkdownString:Fe.$AM,OverviewRulerLane:v.OverviewRulerLane,ParameterInformation:Fe.$BM,PortAutoForwardAction:Fe.PortAutoForwardAction,Position:Fe.$aM,ProcessExecution:Fe.$UM,ProgressLocation:Fe.ProgressLocation,QuickInputButtons:Fe.$wN,Range:Fe.$bM,RelativePattern:Fe.$9M,Selection:Fe.$cM,SelectionRange:Fe.$vM,SemanticTokens:Fe.$sN,SemanticTokensBuilder:Fe.$rN,SemanticTokensEdit:Fe.$tN,SemanticTokensEdits:Fe.$uN,SemanticTokensLegend:Fe.$qN,ShellExecution:Fe.$VM,ShellQuoting:Fe.ShellQuoting,SignatureHelp:Fe.$DM,SignatureHelpTriggerKind:Fe.SignatureHelpTriggerKind,SignatureInformation:Fe.$CM,SnippetString:Fe.$kM,SourceBreakpoint:Fe.$_M,StandardTokenType:Fe.StandardTokenType,StatusBarAlignment:Fe.StatusBarAlignment,SymbolInformation:Fe.$rM,SymbolKind:Fe.SymbolKind,SymbolTag:Fe.SymbolTag,Task:Fe.$XM,TaskGroup:Fe.$TM,TaskPanelKind:Fe.TaskPanelKind,TaskRevealKind:Fe.TaskRevealKind,TaskScope:Fe.TaskScope,TerminalLink:Fe.$PM,TerminalQuickFixTerminalCommand:Fe.$RM,TerminalQuickFixOpener:Fe.$QM,TerminalLocation:Fe.TerminalLocation,TerminalProfile:Fe.$SM,TerminalExitReason:Fe.TerminalExitReason,TextDocumentSaveReason:Fe.TextDocumentSaveReason,TextEdit:Fe.$gM,SnippetTextEdit:Fe.$iM,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:Fe.TextEditorLineNumbersStyle,TextEditorRevealType:Fe.TextEditorRevealType,TextEditorSelectionChangeKind:Fe.TextEditorSelectionChangeKind,SyntaxTokenType:Fe.SyntaxTokenType,TextDocumentChangeReason:Fe.TextDocumentChangeReason,ThemeColor:Fe.$8M,ThemeIcon:Fe.$7M,TreeItem:Fe.$YM,TreeItemCheckboxState:Fe.TreeItemCheckboxState,TreeItemCollapsibleState:Fe.TreeItemCollapsibleState,TypeHierarchyItem:Fe.$SN,UIKind:ni.UIKind,Uri:p.URI,ViewColumn:Fe.ViewColumn,WorkspaceEdit:Fe.$jM,DocumentDropEdit:Fe.$5M,DocumentPasteEdit:Fe.$6M,InlayHint:Fe.$FM,InlayHintLabelPart:Fe.$EM,InlayHintKind:Fe.InlayHintKind,RemoteAuthorityResolverError:Fe.$fM,ResolvedAuthority:Fe.$dM,ManagedResolvedAuthority:Fe.$eM,SourceControlInputBoxValidationType:Fe.SourceControlInputBoxValidationType,ExtensionRuntime:Fe.ExtensionRuntime,TimelineItem:Fe.$HN,NotebookRange:Fe.$zN,NotebookCellKind:Fe.NotebookCellKind,NotebookCellExecutionState:Fe.NotebookCellExecutionState,NotebookCellData:Fe.$AN,NotebookData:Fe.$BN,NotebookRendererScript:Fe.$FN,NotebookCellStatusBarAlignment:Fe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Fe.NotebookEditorRevealType,NotebookCellOutput:Fe.$DN,NotebookCellOutputItem:Fe.$CN,NotebookCellStatusBarItem:Fe.$EN,NotebookControllerAffinity:Fe.NotebookControllerAffinity,NotebookControllerAffinity2:Fe.NotebookControllerAffinity2,NotebookEdit:Fe.$hM,NotebookKernelSourceAction:Fe.$GN,NotebookVariablesRequestKind:Fe.NotebookVariablesRequestKind,PortAttributes:Fe.$JN,LinkedEditingRanges:Fe.$IN,TestResultState:Fe.TestResultState,TestRunRequest:Fe.$KN,TestMessage:Fe.$LN,TestTag:Fe.$MN,TestRunProfileKind:Fe.TestRunProfileKind,TextSearchCompleteMessageType:Bt.TextSearchCompleteMessageType,DataTransfer:Fe.$4M,DataTransferItem:Fe.$ZM,CoveredCount:Fe.$NN,FileCoverage:Fe.$ON,StatementCoverage:Fe.$PN,BranchCoverage:Fe.$QN,DeclarationCoverage:Fe.$RN,FunctionCoverage:Fe.$RN,WorkspaceTrustState:Fe.WorkspaceTrustState,LanguageStatusSeverity:Fe.LanguageStatusSeverity,QuickPickItemKind:Fe.QuickPickItemKind,InputBoxValidationSeverity:Fe.InputBoxValidationSeverity,TabInputText:Fe.$TN,TabInputTextDiff:Fe.$UN,TabInputTextMerge:Fe.$VN,TabInputCustom:Fe.$WN,TabInputNotebook:Fe.$YN,TabInputNotebookDiff:Fe.$ZN,TabInputWebview:Fe.$XN,TabInputTerminal:Fe.$1N,TabInputInteractiveWindow:Fe.$2N,TabInputChat:Fe.$3N,TelemetryTrustedValue:o.$1o,LogLevel:u.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Fe.InteractiveSessionVoteDirection,ChatCopyKind:Fe.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Fe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Fe.$gN,ThreadFocus:Fe.$hN,RelatedInformationType:Fe.RelatedInformationType,SpeechToTextStatus:Fe.SpeechToTextStatus,KeywordRecognitionStatus:Fe.KeywordRecognitionStatus,ChatResponseMarkdownPart:Fe.$5N,ChatResponseFileTreePart:Fe.$6N,ChatResponseAnchorPart:Fe.$7N,ChatResponseProgressPart:Fe.$8N,ChatResponseReferencePart:Fe.$0N,ChatResponseCommandButtonPart:Fe.$9N,ChatRequestTurn:Fe.$$N,ChatResponseTurn:Fe.$_N,LanguageModelChatSystemMessage:Fe.$aO,LanguageModelChatUserMessage:Fe.$bO,LanguageModelChatAssistantMessage:Fe.$cO,LanguageModelSystemMessage:Fe.$aO,LanguageModelUserMessage:Fe.$bO,LanguageModelAssistantMessage:Fe.$cO,LanguageModelError:Fe.$dO,NewSymbolName:Fe.$nN,NewSymbolNameTag:Fe.NewSymbolNameTag,InlineEdit:Fe.$eO,InlineEditTriggerKind:Fe.InlineEditTriggerKind}}}e.$0jc=ei}),define(Se[376],De([1,0,83,156,41,151,42,33,71,46,95,96,97,118,69,91,150,68,59,117,90,70,149,12,60,115,116,120,121]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h,s,a,d,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$bs)(s.$Yic,s.$Xic,1),(0,l.$bs)(f.$Bj,t.$$jc,1),(0,l.$bs)(u.$3hc,u.$4hc,1),(0,l.$bs)(w.$LO,w.$KO,0),(0,l.$bs)(d.$aic,d.$bic,0),(0,l.$bs)($.$fic,$.$gic,0),(0,l.$bs)(R.$sic,R.$qic,0),(0,l.$bs)(o.$uic,o.$tic,0),(0,l.$bs)(C.$9ic,C.$ajc,0),(0,l.$bs)(A.$cjc,A.$bjc,0),(0,l.$bs)(p.$AO,p.$zO,0),(0,l.$bs)(a.$Zic,a.$1ic,0),(0,l.$bs)(i.$7hc,i.$6hc,0),(0,l.$bs)(N.$Ijc,N.$Hjc,1),(0,l.$bs)(v.$sjc,v.$tjc,0),(0,l.$bs)(S.$Nic,S.$Mic,0),(0,l.$bs)(M.$Vjc,M.$Ujc,0),(0,l.$bs)(E.$Qic,E.$Tic,0),(0,l.$bs)(y.$AAb,y.$BAb,0),(0,l.$bs)(m.$9jc,m.$8jc,0),(0,l.$bs)(L.$pic,L.$oic,0),(0,l.$bs)(n.$Vic,n.$Uic,0),(0,l.$bs)(r.$JO,r.$GO,0),(0,l.$bs)(c.$Eic,c.$Fic,0),(0,l.$bs)(h.$7ic,h.$8ic,0)}),define(Se[122],De([1,0,19,12,36,94]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qkc=e.$pkc=e.$okc=void 0;function R(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$okc=R;function w(C,v,S,y){const u=(0,l.$2b)(S,p),m=new L.$uK(v,u,y),o=m.preview.matches;return{ranges:(0,l.$2b)(u,E),uri:C,preview:{text:m.preview.text,matches:(0,l.$2b)(o,E)}}}e.$pkc=w;function p(C){return new L.$vK(C.start.line,C.start.character,C.end.line,C.end.character)}function E(C){return new A.$jK(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let M=class{constructor(v,S){this.a=v,this.b=S}appendLine(v){this.b.debug(`${this.a}#search`,v)}};e.$qkc=M,e.$qkc=M=Qe([Ve(1,N.$Aj)],M)}),define(Se[377],De([1,0,51,17,75,34,11,14,122,378]),function(fe,e,l,N,L,A,R,w,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tkc=e.$skc=e.$rkc=void 0;const M=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,r,c,t){const f=v(n,r,c,t),h=r.folder.fsPath;return{cmd:l.spawn(M,f.args,{cwd:h}),rgDiskPath:M,siblingClauses:f.siblingClauses,rgArgs:f,cwd:h}}e.$rkc=C;function v(n,r,c,t){const f=["--files","--hidden","--case-sensitive","--no-require-git"];y([r],c,!1).forEach(s=>{const a=(0,p.$okc)(s);if(f.push("-g",a),R.$j){const d=(0,L.$Sl)(a);d!==a&&f.push("-g",d)}});const h=S([r],t,void 0,!1);return h.globArgs.forEach(s=>{const a=`!${(0,p.$okc)(s)}`;if(f.push("-g",a),R.$j){const d=(0,L.$Sl)(a);d!==a&&f.push("-g",d)}}),r.disregardIgnoreFiles!==!1?f.push("--no-ignore"):r.disregardParentIgnoreFiles!==!1&&f.push("--no-ignore-parent"),r.ignoreSymlinks||f.push("--follow"),n.exists&&f.push("--quiet"),f.push("--no-config"),r.disregardGlobalIgnoreFiles&&f.push("--no-ignore-global"),{args:f,siblingClauses:h.siblingClauses}}function S(n,r,c,t=!0){const f=[];let h={};return n.forEach(s=>{const a=Object.assign({},s.excludePattern||{},r||{}),d=u(a,t?s.folder.fsPath:void 0,c);f.push(...d.globArgs),d.siblingClauses&&(h=Object.assign(h,d.siblingClauses))}),{globArgs:f,siblingClauses:h}}function y(n,r,c=!0){const t=[];return n.forEach(f=>{const h=Object.assign({},r||{},f.includePattern||{}),s=u(h,c?f.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function u(n,r,c){const t=[],f={};return Object.keys(n).forEach(h=>{if(c&&c.has(h)||!h)return;const s=n[h];h=o(r?m(r,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof s=="boolean"&&s?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):s&&s.when&&(f[h]=s)}),{globArgs:t,siblingClauses:f}}function m(n,r){return N.$ic(r)?r:N.$jc(n,r)}e.$skc=m;function o(n){return n=w.$5e(n,"\\"),w.$5e(n,"/")}function i(n){return A.$cg(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$tkc=i}),define(Se[379],De([1,0,51,57,17,380,19,44,35,75,34,11,38,14,18,31,36,377,132]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vkc=e.$ukc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class r{constructor(s){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=s,this.b=s.filePattern||"",this.d=s.includePattern&&p.$Zj(s.includePattern),this.f=s.maxResults||null,this.g=!!s.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=s.shouldGlobMatchFilePattern?null:(0,i.$cr)(this.b).normalizedLowercase),this.u=s.excludePattern&&p.$Zj(s.excludePattern),this.t=new Map,s.folderQueries.forEach(a=>{const d=Object.assign({},a.excludePattern||{},this.a.excludePattern||{}),$=a.folder.fsPath;s.folderQueries.map(D=>D.folder.fsPath).filter(D=>D!==$).forEach(D=>{(0,M.$gg)(D,$)&&(d[L.$lc($,D)]=!0)}),this.t.set($,new t(d,$))})}cancel(){this.l=!0,n.forEach(s=>s())}walk(s,a,d,$,D){if(this.m=v.$2d.create(!1),this.l)return D(null,this.j);a.forEach(b=>{const g=L.$nc(b.fsPath);this.u&&this.u(b.fsPath,g)||this.J(d,{relativePath:b.fsPath,searchPath:void 0})}),this.r=v.$2d.create(!1),this.w(s,(b,g)=>{this.x(this.y,this,b,d,$,k=>{if(k){const P=(0,w.$4i)(k);console.error(P),this.q.push(P),g(k,void 0)}else g(null,void 0)})},(b,g)=>{this.m.stop();const k=b?R.$Hb(b)[0]:null;D(k,this.j)})}w(s,a,d){const $=new Array(s.length),D=new Array(s.length);let b=!1,g=0;if(s.length===0)return d(null,[]);s.forEach((k,P)=>{a(k,(F,U)=>{if(F?(b=!0,$[P]=null,D[P]=F):($[P]=U,D[P]=null),++g===s.length)return d(b?D:null,$)})})}x(s,a,...d){try{s.apply(a,d)}catch($){d[d.length-1]($)}}y(s,a,d,$){const D=s.folder.fsPath,b=C.$j,g=()=>z&&z.kill();n.add(g);let k=j=>{n.delete(g),k=()=>{},$(j)},P="";const F=this.D(),U=(0,o.$rkc)(this.a,s,this.a.includePattern,this.t.get(s.folder.fsPath).expression),z=U.cmd,T=!Object.keys(U.siblingClauses).length,I=U.rgArgs.args.map(j=>j.match(/^-/)?j:`'${j}'`).join(" ");let O=`${U.rgDiskPath} ${I}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(O+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),d({message:O}),this.s=0,this.z(z,"utf8",d,(j,G,te)=>{if(j){k(j);return}if(this.j){k();return}const Z=(P+(b?E.$Rl(G||""):G)).split(`
`);if(te){const X=Z.length;Z[X-1]=Z[X-1].trim(),Z[X-1]||Z.pop()}else P=Z.pop()||"";if(Z.length&&Z[0].indexOf(`
`)!==-1){k(new Error("Splitting up files failed"));return}if(this.s+=Z.length,T){for(const X of Z)if(this.J(a,{base:D,relativePath:X,searchPath:this.N(s,X)}),this.j){g();break}(te||this.j)&&k();return}this.G(s,F,D,Z,a),te&&(this.H(F,D,a),k())})}spawnFindCmd(s){const a=this.t.get(s.folder.fsPath),d=a.getBasenameTerms(),$=a.getPathTerms(),D=["-L","."];if(d.length||$.length){D.push("-not","(","(");for(const b of d)D.push("-name",b),D.push("-o");for(const b of $)D.push("-path",b),D.push("-o");D.pop(),D.push(")","-prune",")")}return D.push("-type","f"),l.spawn("find",D,{cwd:s.folder.fsPath})}readStdout(s,a,d){let $="";this.z(s,a,()=>{},(D,b,g)=>{if(D){d(D);return}$+=b,g&&d(null,$)})}z(s,a,d,$){let D=(k,P,F)=>{(k||F)&&(D=()=>{},this.r?.stop()),$(k,P,F)},b=!1;s.stdout?(this.A(s.stdout,a,D),s.stdout.once("data",()=>b=!0)):d({message:"stdout is null"});let g;s.stderr?g=this.B(s.stderr):d({message:"stderr is null"}),s.on("error",k=>{D(k)}),s.on("close",k=>{let P;!b&&(P=this.C(g,a))&&f(P)?D(new Error(`command failed with error code ${k}: ${this.C(g,a)}`)):(this.g&&k===0&&(this.j=!0),D(null,"",!0))})}A(s,a,d){const $=new A.StringDecoder(a);return s.on("data",D=>{d(null,$.write(D))}),$}B(s){const a=[];return s.on("data",d=>{a.push(d)}),a}C(s,a){const d=new A.StringDecoder(a);return s.map($=>d.write($)).join("")}D(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}G(s,{pathToEntries:a},d,$,D){$.indexOf(this.b)!==-1&&this.J(D,{base:d,relativePath:this.b,searchPath:this.N(s,this.b)});const b=g=>{const k=L.$nc(g),P=L.$mc(g);let F=a[P];F||(F=a[P]=[],b(P)),F.push({base:d,relativePath:g,basename:k,searchPath:this.N(s,g)})};$.forEach(b)}H({rootEntries:s,pathToEntries:a},d,$){const D=this,b=this.t.get(d),g=this.b;function k(P){D.o++;const F=(0,m.$KK)(()=>P.map(U=>U.basename));for(let U=0,z=P.length;U<z;U++){const T=P[U],{relativePath:I,basename:O}=T;if(b.test(I,O,g!==O?F:void 0))continue;const j=a[I];if(j)k(j);else{if(D.p++,I===g)continue;D.J($,T)}if(D.j)break}}k(s)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(s,a,d,$,D){const b=s.folder,g=(0,m.$KK)(()=>d);this.w(d,(k,P)=>{if(this.l||this.j)return P(null);const F=a?[a,k].join(L.sep):k;if(this.t.get(s.folder.fsPath).test(F,k,this.a.filePattern!==k?g:void 0))return P(null);const U=[b.fsPath,F].join(L.sep);N.lstat(U,(z,T)=>{if(z||this.l||this.j)return P(null);this.L(U,T,(I,O)=>I||this.l||this.j?P(null):O.isDirectory()?(this.o++,this.M(U,T,(j,G)=>j||this.l||this.j||(G=G||"",this.v[G])?P(null):(this.v[G]=!0,u.Promises.readdir(U).then(te=>{if(this.l||this.j)return P(null);this.I(s,F,te,$,x=>P(x||null))},te=>{P(null)})))):(this.p++,F===this.b||this.h&&y.$Xf(O.size)&&O.size>this.h||this.J($,{base:b.fsPath,relativePath:F,searchPath:this.N(s,F)}),P(null,void 0)))})},k=>{const P=k&&R.$Hb(k);return D(P&&P.length>0?P[0]:void 0)})}J(s,a){this.K(a)&&(!this.d||this.d(a.relativePath,L.$nc(a.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||s(a))}K(s){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,m.$FK)(s,this.c);if(this.b)return(0,m.$FK)(s,this.b,!1)}return!0}L(s,a,d){return a.isSymbolicLink()?N.stat(s,d):d(null,a)}M(s,a,d){return a.isSymbolicLink()?N.realpath(s,($,D)=>$?d($):d(null,D)):d(null,s)}N(s,a){return s.folderName?L.$jc(s.folderName,a):a}}e.$ukc=r;class c{constructor(s){this.a=s.folderQueries,this.b=s.extraFileResources||[],this.c=new r(s)}search(s,a,d){this.c.walk(this.a,this.b,s,a,($,D)=>{d($,{limitHit:D,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$vkc=c;class t{constructor(s,a){this.expression=s,this.c=a,this.d(s)}d(s){let a,d;Object.keys(s).filter($=>s[$]).forEach($=>{L.$ic($)?(a=a||p.$Uj(),a[$]=s[$]):(d=d||p.$Uj(),d[$]=s[$])}),this.a=a&&p.$Zj(a,{trimForExclusions:!0}),this.b=d&&p.$Zj(d,{trimForExclusions:!0})}test(s,a,d){return this.b&&this.b(s,a,d)||this.a&&this.a(L.$jc(this.c,s),a,d)}getBasenameTerms(){const s=[];return this.a&&s.push(...p.$2j(this.a)),this.b&&s.push(...p.$2j(this.b)),s}getPathTerms(){const s=[];return this.a&&s.push(...p.$3j(this.a)),this.b&&s.push(...p.$3j(this.b)),s}}function f(h){const s=h.trim().split(`
`),a=s[0].trim();if(a.startsWith("Error parsing regex"))return a;if(a.startsWith("regex parse error"))return S.$Lf(s[s.length-1].trim());if(a.startsWith("error parsing glob")||a.startsWith("unsupported encoding"))return a.charAt(0).toUpperCase()+a.substr(1);if(a==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(a.startsWith("Literal "))return a}}),define(Se[381],De([1,0,98,21,191,22]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OD=e.$ND=e.$MD=e.$LD=e.$KD=e.$JD=e.$ID=e.$HD=e.$GD=e.DecodeStreamErrorKind=e.$FD=e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=void 0,e.$yD="utf8",e.$zD="utf8bom",e.$AD="utf16be",e.$BD="utf16le";function R(a){return[e.$yD,e.$zD,e.$AD,e.$BD].some(d=>d===a)}e.$CD=R,e.$DD=[254,255],e.$ED=[255,254],e.$FD=[239,187,191];const w=512,p=512,E=512*8,M=512*128;var C;(function(a){a[a.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class v extends Error{constructor(d,$){super(d),this.decodeStreamErrorKind=$}}e.$GD=v;class S{static async create(d){let $;if(d!==e.$yD)$=(await(0,L.$xD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(d));else{const D=new TextDecoder;$={write(b){return D.decode(b,{stream:!0})},end(){return D.decode()}}}return new S($)}constructor(d){this.a=d}write(d){return this.a.write(d)}end(){return this.a.end()}}function y(a,d){const $=d.minBytesRequiredForDetection??d.guessEncoding?E:p;return new Promise((D,b)=>{const g=(0,l.$he)(T=>T.join("")),k=[];let P=0,F;const U=new A.$de,z=async()=>{try{const T=await s({buffer:N.$te.concat(k),bytesRead:P},d.guessEncoding);if(T.seemsBinary&&d.acceptTextOnly)throw new v("Stream is binary but only text is accepted for decoding",1);T.encoding=await d.overwriteEncoding(T.encoding),F=await S.create(T.encoding);const I=F.write(N.$te.concat(k).buffer);g.write(I),k.length=0,P=0,D({stream:g,detected:T})}catch(T){U.cancel(),g.destroy(),b(T)}};(0,l.$le)(a,{onData:async T=>{F?g.write(F.write(T.buffer)):(k.push(T),P+=T.byteLength,P>=$&&(a.pause(),await z(),setTimeout(()=>a.resume())))},onError:T=>g.error(T),onEnd:async()=>{F||await z(),g.end(F?.end())}},U.token)})}e.$HD=y;async function u(a,d,$){const b=(await(0,L.$xD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(d),$);let g=!1,k=!1;return{read(){if(k)return null;const P=a.read();if(typeof P!="string"){if(k=!0,!g&&$?.addBOM)switch(d){case e.$yD:case e.$zD:return N.$te.wrap(Uint8Array.from(e.$FD));case e.$AD:return N.$te.wrap(Uint8Array.from(e.$DD));case e.$BD:return N.$te.wrap(Uint8Array.from(e.$ED))}const F=b.end();return F&&F.length>0?(g=!0,N.$te.wrap(F)):null}return g=!0,N.$te.wrap(b.write(P))}}}e.$ID=u;async function m(a){return(await(0,L.$xD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(a))}e.$JD=m;function o(a){return a===e.$zD||a===null?e.$yD:a}e.$KD=o;function i(a,d){if(!a||d<e.$DD.length)return null;const $=a.readUInt8(0),D=a.readUInt8(1);if($===e.$DD[0]&&D===e.$DD[1])return e.$AD;if($===e.$ED[0]&&D===e.$ED[1])return e.$BD;if(d<e.$FD.length)return null;const b=a.readUInt8(2);return $===e.$FD[0]&&D===e.$FD[1]&&b===e.$FD[2]?e.$zD:null}e.$LD=i;const n=["ascii","utf-16","utf-32"];async function r(a){const d=await(0,L.$xD)("jschardet","dist/jschardet.min.js"),$=a.slice(0,M),D=f($.buffer),b=d.detect(D);if(!b||!b.encoding)return null;const g=b.encoding.toLowerCase();return 0<=n.indexOf(g)?null:t(b.encoding)}const c={ibm866:"cp866",big5:"cp950"};function t(a){const d=a.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return c[d]||d}function f(a){let d="";for(let $=0;$<a.length;$++)d+=String.fromCharCode(a[$]);return d}function h(a){switch(a){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const d=a.match(/windows(\d+)/);return d?"windows-"+d[1]:a}}}e.$MD=h;function s({buffer:a,bytesRead:d},$){let D=i(a,d),b=!1;if(D!==e.$AD&&D!==e.$BD&&a){let g=!0,k=!0,P=!1;for(let F=0;F<d&&F<w;F++){const U=F%2===1,z=a.readUInt8(F)===0;if(z&&(P=!0),g&&(U&&!z||!U&&z)&&(g=!1),k&&(U&&z||!U&&!z)&&(k=!1),z&&!g&&!k)break}P&&(g?D=e.$BD:k?D=e.$AD:b=!0)}return $&&!b&&!D&&a?r(a.slice(0,d)).then(g=>({seemsBinary:!1,encoding:g})):{seemsBinary:b,encoding:D}}e.$ND=s,e.$OD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Se[159],De([1,0,381,31,158]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dkc=void 0;class A extends L.$ojc{constructor(w,p,E=N,M="searchProcess"){super({query:w,provider:p},{readdir:C=>E.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,l.$MD)(C)},M)}}e.$Dkc=A}),define(Se[160],De([1,0,51,397,380,19,72,35,14,2,36,94,398,378,122]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ckc=e.$Bkc=e.$Akc=e.$zkc=e.$ykc=e.$xkc=e.$wkc=void 0;const u=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class m{constructor(g){this.a=g}provideTextSearchResults(g,k,P,F){return this.a.appendLine(`provideTextSearchResults ${g.pattern}, ${JSON.stringify({...k,folder:k.folder.toString()})}`),new Promise((U,z)=>{F.onCancellationRequested(()=>Z());const T=t(g,k),I=k.folder.fsPath,O=T.map(se=>se.match(/^-/)?se:`'${se}'`).join(" ");this.a.appendLine(`${u} ${O}
 - cwd: ${I}`);let j=l.spawn(u,T,{cwd:I});j.on("error",se=>{console.error(se),this.a.appendLine("Error: "+(se&&se.message)),z((0,M.$BK)(new M.$zK(se&&se.message,M.SearchErrorCode.rgProcessError)))});let G=!1;const te=new n(k.maxResults,k.folder,k.previewOptions);te.on("result",se=>{G=!0,ae="",P.report(se)});let x=!1;const Z=()=>{x=!0,j?.kill(),te?.cancel()};let X=!1;te.on("hitLimit",()=>{X=!0,Z()});let ae="";j.stdout.on("data",se=>{te.handleData(se),G||(ae+=se)});let _=!1;j.stdout.once("data",()=>_=!0);let ge="";j.stderr.on("data",se=>{const re=se.toString();this.a.appendLine(re),ge.length+re.length<1e6&&(ge+=re)}),j.on("close",()=>{if(this.a.appendLine(_?"Got data from stdout":"No data from stdout"),this.a.appendLine(G?"Got result from parser":"No result from parser"),ae&&this.a.appendLine(`Got data without result: ${ae}`),this.a.appendLine(""),x)U({limitHit:X});else{te.flush(),j=null;let se;ge&&!_&&(se=o(ge))?z((0,M.$BK)(new M.$zK(se.message,se.code))):U({limitHit:X})}})})}}e.$wkc=m;function o(b){const g=b.split(`
`),k=g[0].trim();if(g.some(F=>F.startsWith("regex parse error")))return new M.$zK(i(g),M.SearchErrorCode.regexParseError);const P=k.match(/grep config error: unknown encoding: (.*)/);if(P)return new M.$zK(`Unknown encoding: ${P[1]}`,M.SearchErrorCode.unknownEncoding);if(k.startsWith("error parsing glob"))return new M.$zK(k.charAt(0).toUpperCase()+k.substr(1),M.SearchErrorCode.globParseError);if(k.startsWith("the literal"))return new M.$zK(k.charAt(0).toUpperCase()+k.substr(1),M.SearchErrorCode.invalidLiteral);if(k.startsWith("PCRE2: error compiling pattern"))return new M.$zK(k,M.SearchErrorCode.regexParseError)}function i(b){const g=["Regex parse error"],k=b.filter(P=>P.startsWith("PCRE2:"));if(k.length>=1){const P=k[0].replace("PCRE2:","");if(P.indexOf(":")!==-1&&P.split(":").length>=2){const F=P.split(":")[1];g.push(":"+F)}}return g.join("")}class n extends N.EventEmitter{constructor(g,k,P){super(),this.g=g,this.h=k,this.j=P,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new L.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(g,k){return super.on(g,k),this}handleData(g){if(this.b)return;const k=typeof g=="string"?g:this.d.write(g);this.k(k)}k(g){let k=g.indexOf(`
`);const P=this.a+g;if(k>=0)k+=this.a.length;else{this.a=P;return}let F=0;for(;k>=0;)this.m(P.substring(F,k).trim()),F=k+1,k=P.indexOf(`
`,F);this.a=P.substring(F)}m(g){if(this.b||!g)return;let k;try{k=JSON.parse(g)}catch{throw new Error(`malformed line from rg: ${g}`)}if(k.type==="match"){const P=r(k.data.path),F=E.URI.joinPath(this.h,P),U=this.n(k.data,F);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(k.type==="context"){const P=r(k.data.path),F=E.URI.joinPath(this.h,P);this.o(k.data,F).forEach(z=>this.p(z))}}n(g,k){const P=g.line_number-1,F=r(g.lines),U=Buffer.from(F);let z=0,T=0,I=P;g.submatches.length===0&&g.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const O=(0,A.$Hb)(g.submatches.map((j,G)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const te=r(j.match),x=U.slice(z,j.start).toString(),Z=c(x),X=Z.numLines>0?Z.lastLineLength:Z.lastLineLength+T,ae=c(te),_=Z.numLines+I,ge=ae.numLines+_,se=ae.numLines>0?ae.lastLineLength:ae.lastLineLength+X;return z=j.end,T=se,I=ge,new C.$jK(_,X,ge,se)}));return(0,y.$pkc)(k,F,O,this.j)}o(g,k){const P=r(g.lines),F=g.line_number;return P.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:k,lineNumber:F+z}))}p(g){this.emit("result",g)}}e.$xkc=n;function r(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function c(b){const g=/\n/g;let k=0,P=-1,F;for(;F=g.exec(b);)k++,P=F.index;const U=P>=0?b.length-P-1:b.length;return{numLines:k,lastLineLength:U}}function t(b,g){const k=["--hidden","--no-require-git"];k.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:P,otherIncludes:F}=(0,R.$K)(g.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const z=new Set;F.forEach(T=>{z.add(T)}),k.push("-g","!*"),z.forEach(T=>{f(T).map(y.$okc).forEach(I=>{k.push("-g",I)})})}P&&P.length&&P.forEach(z=>{k.push("-g",z)}),g.excludes.map(y.$okc).forEach(z=>k.push("-g",`!${z}`)),g.maxFileSize&&k.push("--max-filesize",g.maxFileSize+""),g.useIgnoreFiles?g.useParentIgnoreFiles||k.push("--no-ignore-parent"):k.push("--no-ignore"),g.followSymlinks&&k.push("--follow"),g.encoding&&g.encoding!=="utf8"&&k.push("--encoding",g.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,p.$Ye)(b.pattern),b.isRegExp=!0),g.usePCRE2&&k.push("--pcre2"),k.push("--crlf"),b.isRegExp&&(b.pattern=h(b.pattern),k.push("--engine","auto"));let U;if(b.isWordMatch){const T=(0,p.$8e)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");k.push("--regexp",T)}else if(b.isRegExp){let z=a(b.pattern);z=d(z),k.push("--regexp",z)}else U=b.pattern,k.push("--fixed-strings");return k.push("--no-config"),g.useGlobalIgnoreFiles||k.push("--no-ignore-global"),k.push("--json"),b.isMultiline&&k.push("--multiline"),g.beforeContext&&k.push("--before-context",g.beforeContext+""),g.afterContext&&k.push("--after-context",g.afterContext+""),k.push("--"),U&&k.push(U),k.push("."),k}e.$ykc=t;function f(b){return D(b).flatMap(k=>{const P=(0,w.$Xj)(k,"/");return P.map((F,U)=>P.slice(0,U+1).join("/"))})}function h(b){const g=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(g);)b=b.replace(g,"$1\\x{$2}");const k=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(k);)b=b.replace(k,"$1\\x{$2}");return b}e.$zkc=h;const s=b=>b.type==="Assertion"&&b.kind==="lookbehind";function a(b){let g;try{g=new v.RegExpParser().parsePattern(b)}catch{return b}let k="",P=0;const F=(T,I,O)=>{k+=b.slice(P,T)+O,P=I},U=[];return new v.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const I=U[0];if(!I)F(T.start,T.end,"\\r?\\n");else if(!U.some(s))if(I.type==="CharacterClass")if(I.negate){const O=b.slice(I.start+2,T.start)+b.slice(T.end,I.end-1);I.parent?.type==="Quantifier"?F(I.start,I.end,O?`[^${O}]`:"."):F(I.start,I.end,"(?!\\r?\\n"+(O?`|[${O}]`:"")+")")}else{const O=b.slice(I.start+1,T.start)+b.slice(T.end,I.end-1);F(I.start,I.end,O===""?"\\r?\\n":`(?:[${O}]|\\r?\\n)`)}else I.type==="Quantifier"&&F(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){U.unshift(T)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(T){U.unshift(T)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(T){U.unshift(T)},onCharacterClassLeave(){U.shift()},onAssertionEnter(T){s(T)&&U.push(T)},onAssertionLeave(T){U[0]===T&&U.shift()}}).visit(g),k+=b.slice(P),k}e.$Akc=a;function d(b){return b.replace(/\n/g,"\\r?\\n")}e.$Bkc=d;function $(b){let g=!1,k=!1,P="",F="";for(let U=0;U<b.length;U++){const z=b[U];switch(z){case"\\":k?(g?F+="\\"+z:P+="\\"+z,k=!1):k=!0;break;case"{":if(k)g?F+=z:P+=z,k=!1;else{if(g)return{strInBraces:P+"{"+F+"{"+b.substring(U+1)};g=!0}break;case"}":if(k)g?F+=z:P+=z,k=!1;else{if(g)return{fixedStart:P,strInBraces:F,fixedEnd:b.substring(U+1)};P+=z}break;default:g?F+=(k?"\\":"")+z:P+=(k?"\\":"")+z,k=!1;break}}return{strInBraces:P+(g?"{"+F:"")}}function D(b){const{fixedStart:g,strInBraces:k,fixedEnd:P}=$(b);if(g===void 0||P===void 0)return[k];let F=(0,w.$Xj)(k,",");F.length||(F=[""]);const U=D(P);return F.flatMap(z=>{const T=g+z;return U.map(I=>T+I)})}e.$Ckc=D}),define(Se[382],De([1,0,22,160,108,15]),function(fe,e,l,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;class R{constructor(E){this.b=E,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(E,M,C,v){const S=new N.$wkc(this.b);if(M.folder.scheme===A.Schemas.vscodeUserData){const y={...M,folder:M.folder.with({scheme:A.Schemas.file})},u=new L.$Lv(m=>C.report({...m,uri:m.uri.with({scheme:M.folder.scheme})}));return this.c(v,m=>S.provideTextSearchResults(E,y,u,m))}else return this.c(v,y=>S.provideTextSearchResults(E,M,C,y))}async c(E,M){const C=w(E);this.a.add(C);const v=await M(C.token);return this.a.delete(C),v}d(){this.a.forEach(E=>E.cancel())}}e.$Gkc=R;function w(p){const E=new l.$de;return p.onCancellationRequested(()=>E.cancel()),E}}),define(Se[383],De([1,0,31,160,159]),function(fe,e,l,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;class A{constructor(p){this.a=p}search(p,E,M){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(S){M({message:S})}},v=new L.$Dkc(this.a,new N.$wkc(C),l);return new Promise((S,y)=>v.search(u=>{E(u.map(R))},p).then(u=>S({limitHit:u.limitHit,type:"success",stats:u.stats}),y))}}e.$Ekc=A;function R(w){return{path:w.resource&&w.resource.fsPath,results:w.results,numMatches:(w.results||[]).reduce((p,E)=>{if(E.ranges){const M=E;return p+(Array.isArray(M.ranges)?M.ranges.length:1)}else return p+1},0)}}}),define(Se[384],De([1,0,19,8,13,4,132,17,38,2,32,36,379,383]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class y{static{this.a=512}constructor(r="searchProcess"){this.d=r,this.b=Object.create(null)}fileSearch(r){let c;const t=o(r),f=new A.$6d({onDidAddFirstListener:()=>{c=(0,N.$6g)(h=>this.doFileSearchWithEngine(v.$vkc,t,s=>f.fire(s),h)),c.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return f.event}textSearch(r){let c;const t=o(r),f=new A.$6d({onDidAddFirstListener:()=>{c=(0,N.$6g)(h=>this.f(t,s=>f.fire(s),h)),c.then(h=>f.fire(h),h=>f.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{c.cancel()}});return f.event}f(r,c,t){return r.maxFileSize=this.g().maxFileSize,new S.$Ekc(r).search(t,c,c)}g(){return{maxFileSize:16*M.$cl.GB}}doFileSearch(r,c,t){return this.doFileSearchWithEngine(v.$vkc,r,c,t)}doFileSearchWithEngine(r,c,t,f,h=y.a){let s=0;const a=$=>{Array.isArray($)?(s+=$.length,t($.map(D=>this.h(D)))):$.relativePath?(s++,t(this.h($))):t($)};if(c.sortByScore){let $=this.l(c,a,f);if(!$){const D=c.maxResults?Object.assign({},c,{maxResults:null}):c,b=new r(D);$=this.j(b,c,t,a,f)}return new Promise((D,b)=>{$.then(([g,k])=>{const P=k.map(F=>this.h(F));this.o(P,t,h),D(g)},b)})}const d=new r(c);return this.r(d,a,h,f).then($=>({limitHit:$.limitHit,type:"success",stats:{detailStats:$.stats,type:this.d,fromCache:!1,resultCount:s,sortingTime:void 0}}))}h(r){return{path:r.base?(0,w.$jc)(r.base,r.relativePath):r.relativePath}}j(r,c,t,f,h){const s=new A.$6d;let a=(0,N.$6g)($=>{let D=[];const b=g=>{Array.isArray(g)?D=g:(f(g),s.fire(g))};return this.r(r,b,-1,$).then(g=>[g,D])}),d;if(c.cacheKey){d=this.k(c.cacheKey);const $={promise:a,event:s.event,resolved:!1};d.resultsToSearchCache[c.filePattern||""]=$,a.then(()=>{$.resolved=!0},D=>{delete d.resultsToSearchCache[c.filePattern||""]}),a=this.s(a)}return a.then(([$,D])=>{const b=d?d.scorerCache:Object.create(null),g=(typeof c.maxResults!="number"||c.maxResults>0)&&p.$2d.create(!1);return this.n(c,D,b,h).then(k=>{const P=g?g.elapsed():-1;return[{type:"success",stats:{detailStats:$.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:c.folderQueries.length,resultCount:k.length},messages:$.messages,limitHit:$.limitHit||typeof c.maxResults=="number"&&D.length>c.maxResults},k]})})}k(r){const c=this.b[r];return c||(this.b[r]=new u)}l(r,c,t){const f=r.cacheKey&&this.b[r.cacheKey];if(!f)return;const h=this.q(f,r.filePattern||"",c,t);if(h)return h.then(([s,a,d])=>{const $=p.$2d.create(!1);return this.n(r,a,f.scorerCache,t).then(D=>{const b=$.elapsed(),g={fromCache:!0,detailStats:d,type:this.d,resultCount:a.length,sortingTime:b};return[{type:"success",limitHit:s.limitHit||typeof r.maxResults=="number"&&a.length>r.maxResults,stats:g},D]})})}n(r,c,t,f){const h=(0,R.$cr)(r.filePattern||""),s=(d,$)=>(0,R.$br)(d,$,h,!0,m,t),a=typeof r.maxResults=="number"?r.maxResults:Number.MAX_VALUE;return l.$Gb(c,s,a,1e4,f)}o(r,c,t){if(t&&t>0)for(let f=0;f<r.length;f+=t)c(r.slice(f,f+t));else c(r)}q(r,c,t,f){const h=p.$2d.create(!1),s=c.indexOf(w.sep)>=0;let a;for(const b in r.resultsToSearchCache)if(c.startsWith(b)){if(s&&b.indexOf(w.sep)<0&&b!=="")continue;const g=r.resultsToSearchCache[b];a={promise:this.s(g.promise),event:g.event,resolved:g.resolved};break}if(!a)return null;const d=h.elapsed(),$=p.$2d.create(!1),D=a.event(t);return f&&f.onCancellationRequested(()=>{D.dispose()}),a.promise.then(([b,g])=>{if(f&&f.isCancellationRequested)throw(0,L.$6)();const k=[],P=(0,R.$cr)(c).normalizedLowercase;for(const F of g)(0,C.$FK)(F,P)&&k.push(F);return[b,k,{cacheWasResolved:a.resolved,cacheLookupTime:d,cacheFilterTime:$.elapsed(),cacheEntryCount:g.length}]})}r(r,c,t,f){return new Promise((h,s)=>{let a=[];f?.onCancellationRequested(()=>r.cancel()),r.search(d=>{d&&(t?(a.push(d),t>0&&a.length>=t&&(c(a),a=[])):c(d))},d=>{c(d)},(d,$)=>{a.length&&c(a),d?(c({message:"Search finished. Error: "+d.message}),s(d)):(c({message:"Search finished. Stats: "+JSON.stringify($.stats)}),h($))})})}clearCache(r){return delete this.b[r],Promise.resolve(void 0)}s(r){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(c,t){return r.then(c,t)}catch(c){return this.then(void 0,c)}finally(c){return r.finally(c)}}}}e.$Fkc=y;class u{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const m=new class{getItemLabel(n){return(0,w.$nc)(n.relativePath)}getItemDescription(n){return(0,w.$mc)(n.relativePath)}getItemPath(n){return n.relativePath}};function o(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(r=>E.URI.revive(r))}}function i(n){return{...n,folder:E.URI.revive(n.folder)}}}),define(Se[385],De([1,0,3,15,2,31,12,27,20,97,65,36,384,382,122,159]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hkc=void 0;let m=class extends E.$tjc{constructor(i,n,r,c){super(i,r,c),this.w=A,this.x=-1,this.y=null,this.z=!1,this.A=new l.$Sc;const t=new y.$qkc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new S.$Gkc(t))),n.remote.isRemote&&n.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const i=new y.$qkc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(N.Schemas.file,new S.$Gkc(i))),this.A.add(this.C(N.Schemas.file,new v.$Fkc("fileSearchProvider")))}C(i,n){const r=this.d++;return this.y=n,this.x=r,this.c.$registerFileSearchProvider(r,this.s(i)),(0,l.$Rc)(()=>{this.y=null,this.c.$unregisterProvider(r)})}$provideFileSearchResults(i,n,r,c){const t=(0,E.$ujc)(r);if(i===this.x){const f=Date.now();return this.D(i,n,t,c).then(h=>{const s=Date.now()-f;return this.q.debug(`Ext host file search time: ${s}ms`),h})}return super.$provideFileSearchResults(i,n,r,c)}doInternalFileSearchWithCustomCallback(i,n,r){const c=t=>{if((0,C.$EK)(t)&&(t=[t]),Array.isArray(t)){r(t.map(f=>L.URI.file(f.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch(i,c,n)}async D(i,n,r,c){return this.doInternalFileSearchWithCustomCallback(r,c,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.y?.clearCache(i),super.$clearCache(i)}t(i,n){return new u.$Dkc(i,n,void 0,"textSearchProvider")}};e.$Hkc=m,e.$Hkc=m=Qe([Ve(0,p.$pO),Ve(1,w.$FO),Ve(2,M.$mic),Ve(3,R.$Aj)],m)}),define(Se[123],De([1,0,372,62,63,399,21,13,4,3,17,11,30,80,81]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class u{traceSocketEvent(g,k){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,g,k)}constructor(g,k=""){this.f=!0,this.debugLabel=k,this.socket=g,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,w.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(g){const k=P=>{this.traceSocketEvent("read",P),g(R.$te.wrap(P))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(g){const k=P=>{g({type:0,hadError:P,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(g){const k=()=>{g()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(g){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",g),this.socket.write(g.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,w.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,w.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((g,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),g();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),g()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$8h=u;var m;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class i extends E.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(g,k){this.socket.traceSocketEvent(g,k)}constructor(g,k,P,F){super(),this.f=this.B(new p.$6d),this.g=this.B(new p.$6d),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=g,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:P?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new n(this,k,P,F,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,w.$1)(U),this.g.fire({type:0,hadError:!0,error:U})})),this.b=new y.$3h,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(g){return this.f.event(g)}onClose(g){return this.g.event(g)}onEnd(g){return this.socket.onEnd(g)}write(g){let k=0;for(;k<g.byteLength;)this.a.writeMessage(g.slice(k,Math.min(k+262144,g.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(g,{compressed:k,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",g);let F=2;g.byteLength<126?F+=0:g.byteLength<2**16?F+=2:F+=8;const U=R.$te.alloc(F),z=k?64:0,T=P&15;if(U.writeUInt8(128|z|T,0),g.byteLength<126)U.writeUInt8(g.byteLength,1);else if(g.byteLength<2**16){U.writeUInt8(126,1);let I=1;U.writeUInt8(g.byteLength>>>8&255,++I),U.writeUInt8(g.byteLength>>>0&255,++I)}else{U.writeUInt8(127,1);let I=1;U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(0,++I),U.writeUInt8(g.byteLength>>>24&255,++I),U.writeUInt8(g.byteLength>>>16&255,++I),U.writeUInt8(g.byteLength>>>8&255,++I),U.writeUInt8(g.byteLength>>>0&255,++I)}this.socket.write(R.$te.concat([U,g]))}end(){this.h=!0,this.socket.end()}n(g){if(g.byteLength!==0){for(this.b.acceptChunk(g);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),P=k.readUInt8(0),F=(P&128)>>>7,U=(P&64)>>>6,z=P&15,T=k.readUInt8(1),I=(T&128)>>>7,O=T&127;this.j.state=2,this.j.readLen=2+(I?4:0)+(O===126?2:0)+(O===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),P=k.readUInt8(1),F=(P&128)>>>7;let U=P&127,z=1;U===126?U=k.readUInt8(++z)*2**8+k.readUInt8(++z):U===127&&(U=k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*0+k.readUInt8(++z)*2**24+k.readUInt8(++z)*2**16+k.readUInt8(++z)*2**8+k.readUInt8(++z));let T=0;F&&(T=k.readUInt8(++z)*2**24+k.readUInt8(++z)*2**16+k.readUInt8(++z)*2**8+k.readUInt8(++z)),this.j.state=3,this.j.readLen=U,this.j.mask=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$9h=i;class n extends E.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$te.alloc(0)}constructor(g,k,P,F,U,z){super(),this.n=g,this.r=U,this.s=z,this.a=this.B(new p.$6d),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$6d),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$6d),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new r(this.n,F,P,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(T=>this.a.fire(T))),this.B(this.f.onError(T=>this.a.fire(T)))):(this.b=null,this.f=null)}writeMessage(g,k){this.g.push({data:g,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:g,options:k}=this.g.shift();if(this.f&&k.compressed){const P=await this.w(this.f,g);this.s(P,k)}else this.s(g,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(g,k){return new Promise((P,F)=>{g.write(k),g.flush(U=>P(U))})}acceptFrame(g,k,P){this.h.push({data:g,isCompressed:k,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const g=this.h.shift();if(this.b&&g.isCompressed){const k=await this.C(this.b,g.data,g.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(g.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(g,k,P){return new Promise((F,U)=>{g.write(k),P&&g.write(R.$te.fromByteArray([0,0,255,255])),g.flush(z=>F(z))})}}class r extends E.$Tc{get recordedInflateBytes(){return this.j?R.$te.concat(this.f):R.$te.alloc(0)}constructor(g,k,P,F){super(),this.h=g,this.j=k,this.a=this.B(new p.$6d),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(F),this.b.on("error",U=>{this.h.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent("zlibInflateData",U),this.g.push(R.$te.wrap(U))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(g){this.j&&this.f.push(g.clone()),this.h.traceSocketEvent("zlibInflateWrite",g),this.b.write(g.buffer)}flush(g){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=R.$te.concat(this.g);this.g.length=0,g(k)})}}class c extends E.$Tc{constructor(g,k){super(),this.g=g,this.a=this.B(new p.$6d),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(R.$te.wrap(P))})}write(g){this.g.traceSocketEvent("zlibDeflateWrite",g.buffer),this.b.write(g.buffer)}flush(g){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=R.$te.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),g(k)})}}function t(b,g){if(g===0)return;const k=b.byteLength>>>2;for(let I=0;I<k;I++){const O=b.readUInt32BE(I*4);b.writeUInt32BE(O^g,I*4)}const P=k*4,F=b.byteLength-P,U=g>>>24&255,z=g>>>16&255,T=g>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(P)^U,P),F>=2&&b.writeUInt8(b.readUInt8(P+1)^z,P+1),F>=3&&b.writeUInt8(b.readUInt8(P+2)^T,P+2)}e.$0h=process.env.XDG_RUNTIME_DIR;const f={2:107,1:103};function h(){const b=(0,v.$Cg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const g=process.platform!=="darwin"&&e.$0h?e.$0h:(0,L.tmpdir)(),k=(0,M.$jc)(g,`vscode-ipc-${b}.sock`);return a(k),k}e.$$h=h;function s(b,g,k){const F=(0,l.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${k}-${g}-sock`;const U=k.substr(0,4),z=g.substr(0,6);let T;return process.platform!=="darwin"&&e.$0h&&!process.env.VSCODE_PORTABLE?T=(0,M.$jc)(e.$0h,`vscode-${F}-${U}-${z}.sock`):T=(0,M.$jc)(b,`${U}-${z}.sock`),a(T),T}e.$_h=s;function a(b){const g=f[C.$u];typeof g=="number"&&b.length>=g&&console.warn(`WARNING: IPC handle "${b}" is longer than ${g} chars, try a shorter --user-data-dir`)}class d extends S.$Wh{static b(g){const k=p.Event.fromNodeEventEmitter(g,"connection");return p.Event.map(k,P=>({protocol:new y.$4h(new u(P,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(P,"close"))}))}constructor(g){super(d.b(g)),this.d=g}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ai=d;function $(b){return new Promise((g,k)=>{const P=(0,N.createServer)();P.on("error",k),P.listen(b,()=>{P.removeListener("error",k),g(new d(P))})})}e.$bi=$;function D(b,g){return new Promise((k,P)=>{const F=(0,N.createConnection)(b,()=>{F.removeListener("error",P),k(y.$5h.fromSocket(new u(F,`ipc-client${g}`),g))});F.once("error",P)})}e.$ci=D}),define(Se[386],De([1,0,62,63,171,123,8,3,11,52,12,139,262,263,110,88,21]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tac=e.$Sac=e.$Rac=e.$Qac=void 0;async function o(t,f,h,s,a){let d;for(let $=3;$&&(d?.dispose(),d=await new i(t,f,h,s,a).waitForReady(),!(a&&L.$Fg[a]||!L.$Fg[d.tunnelLocalPort]));$--);return d}class i extends w.$Tc{constructor(f,h,s,a,d){super(),this.m=h,this.n=d,this.privacy=u.TunnelPrivacyId.Private,this.j=new Map,this.a=f,this.b=l.createServer(),this.c=new R.$fh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=$=>this.r($),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=a,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const f=this.n??this.tunnelRemotePort,h=(0,u.$Xv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Gg)(f,2,1e3,h),a=null;return this.b.listen(s,this.m),await this.c.wait(),a=this.b.address(),a||(s=0,this.b.listen(s,this.m),await this.c.wait(),a=this.b.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async r(f){f.pause();const h=(0,u.$Vv)(this.tunnelRemoteHost)||(0,u.$Xv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,v.$wl)(this.a,h,this.tunnelRemotePort),a=s.getSocket(),d=s.readEntireBuffer();s.dispose(),d.byteLength>0&&f.write(d.buffer),f.on("end",()=>{f.localAddress&&this.j.delete(f.localAddress),a.end()}),f.on("close",()=>a.end()),f.on("error",()=>{f.localAddress&&this.j.delete(f.localAddress),a instanceof A.$8h?a.socket.destroy():a.end()}),a instanceof A.$8h?this.t(f,a):this.s(f,a),f.localAddress&&this.j.set(f.localAddress,()=>{f.end(),a.end()})}s(f,h){h.onClose(()=>f.destroy()),h.onEnd(()=>f.end()),h.onData(s=>f.write(s.buffer)),f.on("data",s=>h.write(m.$te.wrap(s))),f.resume()}t(f,h){const s=h.socket;s.on("end",()=>f.end()),s.on("close",()=>f.end()),s.on("error",()=>{f.destroy()}),s.pipe(f),f.pipe(s)}}e.$Qac=i;let n=class extends u.$1v{constructor(f,h,s,a,d){super(h,d),this.v=f,this.w=s,this.y=a}isPortPrivileged(f){return(0,u.$Yv)(f,this.m,p.OS,N.release())}t(f,h,s,a,d,$,D,b){const g=this.s(h,s);if(g)return++g.refcount,g.value;if((0,u.$Sv)(f))return this.u(f,h,s,d,$,D,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${s} on local port ${d}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:f,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},P=o(k,a,h,s,d);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,s,P),P}}};e.$Rac=n,e.$Rac=n=Qe([Ve(0,S.$ql),Ve(1,M.$Aj),Ve(2,y.$tl),Ve(3,C.$Sj),Ve(4,E.$Mi)],n);let r=class extends n{constructor(f,h,s,a,d){super(f,h,s,a,d)}};e.$Sac=r,e.$Sac=r=Qe([Ve(0,S.$ql),Ve(1,M.$Aj),Ve(2,y.$tl),Ve(3,C.$Sj),Ve(4,E.$Mi)],r);let c=class extends w.$Tc{constructor(f,h,s,a,d){super(),this.b=f,this.c=h,this.f=s,this.g=a,this.h=d,this.a=new Map}async openTunnel(f,h,s,a,d,$,D,b,g){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${a} on local port ${$}.`),!this.a.has(f)){const k=new r(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(f,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(f))})}return this.a.get(f).openTunnel(h,s,a,d,$,D,b,g)}};e.$Tac=c,e.$Tac=c=Qe([Ve(0,S.$ql),Ve(1,M.$Aj),Ve(2,C.$Sj),Ve(3,y.$tl),Ve(4,E.$Mi)],c)}),define(Se[387],De([1,0,123,282,57,33,2,12,40]),function(fe,e,l,N,L,A,R,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=e.$QO=void 0;class E{constructor(v,S,y){this.b=v,this.c=S,this.f=y,this.a=N.createServer((u,m)=>this.h(u,m)),this.g().catch(u=>(S.error(u),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,S){const y=(m,o)=>{S.writeHead(m,{"content-type":"application/json"}),S.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},u=[];v.setEncoding("utf8"),v.on("data",m=>u.push(m)),v.on("end",async()=>{try{const m=JSON.parse(u.join(""));let o;switch(m.type){case"open":o=await this.i(m);break;case"openExternal":o=await this.j(m);break;case"status":o=await this.l(m);break;case"extensionManagement":o=await this.k(m);break;default:y(404,`Unknown message type: ${m.type}`);break}y(200,o)}catch(m){const o=m instanceof Error?m.message:JSON.stringify(m);y(500,o),this.c.error("Error while processing pipe request",m)}})}async i(v){const{fileURIs:S,folderURIs:y,forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,forceReuseWindow:n,gotoLineMode:r,waitMarkerFilePath:c,remoteAuthority:t}=v,f=[];if(Array.isArray(y))for(const d of y)try{f.push({folderUri:R.URI.parse(d)})}catch{}if(Array.isArray(S))for(const d of S)try{(0,p.$Li)(d)?f.push({workspaceUri:R.URI.parse(d)}):f.push({fileUri:R.URI.parse(d)})}catch{}const h=c?R.URI.file(c):void 0,a={forceNewWindow:u,diffMode:m,mergeMode:o,addMode:i,gotoLineMode:r,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",f,a)}async j(v){for(const S of v.uris){const y=R.URI.parse(S),u=y.scheme==="file"?y:S;await this.b.executeCommand("_remoteCLI.openExternal",u)}}async k(v){const S=u=>u?.map(m=>/\.vsix$/i.test(m)?R.URI.parse(m):m),y={list:v.list,install:S(v.install),uninstall:S(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",y)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&L.existsSync(this.f)&&L.unlinkSync(this.f)}}e.$QO=E;let M=class extends E{constructor(v,S){super(v,S,(0,l.$$h)())}};e.$RO=M,e.$RO=M=Qe([Ve(0,A.$LO),Ve(1,w.$Aj)],M)}),define(Se[388],De([1,0,58,375,369,281,47,356,2,15,7,387,104,314,355]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mkc=void 0;class u extends L.$bkc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,r=n._load;n._load=function(h,s,a){return h=t(h),i.a.has(h)?i.a.get(h).load(h,p.URI.file((0,v.$Lq)(s.filename)),d=>r.apply(this,[d,s,a])):r.apply(this,arguments)};const c=n._resolveLookupPaths;n._resolveLookupPaths=(f,h)=>c.call(this,t(f),h);const t=f=>{for(const h of i.b){const s=h(f);if(s){f=s;break}}return f}}}class m extends R.$3ic{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Node}async ub(){this.h.createInstance(S.$Kkc);const i=this.h.invokeFunction(N.$0jc);if(this.h.createInstance(w.$Jkc),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(C.$RO);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(y.$Lkc),await this.h.createInstance(u,i,{mine:this.J,all:this.L}).install(),l.mark("code/extHost/didInitAPI");const r=await this.m.getConfigProvider();await(0,A.$Ikc)(this.j,r,this,this.s,this.z,this.f),l.mark("code/extHost/didInitProxyResolver")}vb(i){return i.main}async wb(i,n,r){if(n.scheme!==E.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let c=null;r.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&l.mark(`code/extHost/willLoadExtensionCode/${t}`),c=fe.__$__nodeRequire(n.fsPath)}finally{t&&l.mark(`code/extHost/didLoadExtensionCode/${t}`),r.codeLoadingStop()}return c}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const r=i[n];r===null?delete process.env[n]:process.env[n]=r}}}e.$Mkc=m}),define(Se[389],De([1,0,51,21,4,3,125,11,23,2,31,12,261,64,110,88,386,27,20,69,363]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ukc=e.$Tkc=e.$Skc=e.$Rkc=e.$Qkc=e.$Pkc=e.$Okc=e.$Nkc=void 0;function c(g){const k=g.trim().split(`
`),P=[];return k.forEach(U=>{const z=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(U);z&&z.length>=3&&P.push({pid:parseInt(z[1],10),socket:parseInt(z[2],10)})}),P.reduce((U,z)=>(U[z.socket]=z,U),{})}e.$Nkc=c;function t(...g){const k=[].concat(...g.map(h));return[...new Map(k.filter(P=>P.st==="0A").map(P=>{const F=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:f(F[0]),port:parseInt(F[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$Okc=t;function f(g){let k="";if(g.length===8)for(let P=g.length-2;P>=0;P-=2)k+=parseInt(g.substr(P,2),16),P!==0&&(k+=".");else for(let P=0;P<g.length;P+=8){const F=g.substring(P,P+8);let U="";for(let z=8;z>=2;z-=2)U+=F.substring(z-2,z),(z===6||z===2)&&(U=parseInt(U,16).toString(16),k+=`${U}`,U="",P+z!==g.length-6&&(k+=":"))}return k}e.$Pkc=f;function h(g){const k=g.trim().split(`
`),P=k.shift().trim().split(/\s+/).filter(U=>U!=="rx_queue"&&U!=="tm->when");return k.map(U=>U.trim().split(/\s+/).reduce((z,T,I)=>(z[P[I]||I]=T,z),{}))}e.$Qkc=h;function s(g){return!!g.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||g.indexOf("out/server-main.js")!==-1||g.indexOf("_productName=VSCode")!==-1}function a(g){const k=g.trim().split(`
`),P=[];return k.forEach(F=>{const U=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);U&&U.length>=4&&P.push({pid:parseInt(U[1],10),ppid:parseInt(U[2]),cmd:U[3]})}),P}e.$Rkc=a;async function d(g,k,P){const F=P.reduce((z,T)=>(z[T.pid]=T,z),{}),U=[];return g.forEach(({socket:z,ip:T,port:I})=>{const O=k[z]?k[z].pid:void 0,j=O?F[O]?.cmd:void 0;O&&j&&!s(j)&&U.push({host:T,port:I,detail:j,pid:O})}),U}e.$Skc=d;function $(g,k,P){const F=new Map,U=a(k);for(const z of g){const T=P.get(z.port);if(T){F.set(z.port,T);continue}const I=U.find(O=>O.cmd.includes(`${z.port}`));if(I){let O=I,j;do j=U.find(G=>G.ppid===O.pid),j&&(O=j);while(j);F.set(z.port,{host:z.ip,port:z.port,pid:O.pid,detail:O.cmd,ppid:O.ppid})}else F.set(z.port,{host:z.ip,port:z.port,ppid:Number.MAX_VALUE})}return F}e.$Tkc=$;let D=class extends n.$BAb{constructor(k,P,F,U){super(k,P,F),this.D=P,this.F=U,this.y=void 0,this.z=new Map,this.C=!1,w.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(k){if(k&&this.C)return;this.C=k;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new R.$im;let U=0;for(;this.C;){const z=new Date().getTime(),T=(await this.I()).filter(j=>(0,u.$Vv)(j.host)||(0,u.$Xv)(j.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map(j=>j.port).join(", ")}`);const I=new Date().getTime()-z;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${I} ms.`),U++>3&&F.update(I),(!P||JSON.stringify(P)!==JSON.stringify(T))&&(P=T,await this.a.$onFoundNewCandidates(P));const O=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${O} ms.`),await new Promise(j=>setTimeout(()=>j(),O))}}G(k){return Math.max(k*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(k=>k.port).join(", ")}`)}async I(){let k="",P="";try{k=await M.Promises.readFile("/proc/net/tcp","utf8"),P=await M.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(k,P),U=await new Promise(x=>{(0,l.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Z,X,ae)=>{x(X)})}),z=c(U),T=await M.Promises.readdir("/proc"),I=[];for(const x of T)try{const Z=Number(x),X=p.$Tg(E.URI.file("/proc"),x);if((await M.Promises.stat(X.fsPath)).isDirectory()&&!isNaN(Z)){const _=await M.Promises.readlink(p.$Tg(X,"cwd").fsPath),ge=await M.Promises.readFile(p.$Tg(X,"cmdline").fsPath,"utf8");I.push({pid:Z,cwd:_,cmd:ge})}}catch{}const O=[],j=F.filter(x=>{const Z=z[x.socket];return Z||O.push(x),Z}),G=d(j,z,I);let te;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${O.length}`),O.length>0){const x=await new Promise(Z=>{(0,l.exec)("ps -F -A -l | grep root",(X,ae,_)=>{Z(ae)})});this.z=$(O,x,this.z),te=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${te.map(Z=>Z.port).join(", ")}`)}return G.then(x=>te?x.concat(te):x)}w(k){return async P=>{const F=new m.$Qac({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(z,T,I,O){const j=await k.makeConnection();return b.connect(j,T,I,O)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new S.$ml(0),connectionToken:k.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await F.waitForReady();const U=new L.$6d;return{localAddress:(0,r.$xL)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:U.event,dispose:()=>{F.dispose(),U.fire(),U.dispose()}}}}};e.$Ukc=D,e.$Ukc=D=Qe([Ve(0,i.$pO),Ve(1,o.$FO),Ve(2,C.$Aj),Ve(3,y.$tl)],D);class b extends v.$ztb{static connect(k,P,F,U){const z=new A.$Sc,T={onClose:z.add(new L.$6d),onData:z.add(new L.$6d),onEnd:z.add(new L.$6d)};z.add(k.onDidReceiveMessage(O=>T.onData.fire(N.$te.wrap(O)))),z.add(k.onDidEnd(()=>T.onEnd.fire())),z.add(k.onDidClose(O=>T.onClose.fire({type:0,error:O,hadError:!!O})));const I=new b(k,U,T);return I.B(z),(0,v.$ytb)(I,P,F,U,T)}constructor(k,P,F){super(P,F),this.n=k}write(k){this.n.send(k.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Se[390],De([1,0,83,358,373,371,385,388,389,96,47,97,95,46,69,93,357,315,12,374,60,276,106,110,141]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o,i,n,r,c,t,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,l.$bs)(M.$4ic,w.$Mkc,0),(0,l.$bs)(i.$Bj,o.$Wkc,1),(0,l.$bs)(i.$Aj,new t.$di(c.$akc,[!1],!0)),(0,l.$bs)(f.$tl,h.$Vac,1),(0,l.$bs)(u.$vic,m.$Vkc,0),(0,l.$bs)(E.$9ic,A.$nkc,0),(0,l.$bs)(C.$sjc,R.$Hkc,0),(0,l.$bs)(v.$Vjc,L.$fkc,0),(0,l.$bs)(S.$Qic,N.$ekc,0),(0,l.$bs)(y.$AAb,p.$Ukc,0),(0,l.$bs)(r.$7ic,n.$Xkc,0)}),define(Se[400],De([1,0,62,401,58,13,81,123,259,114,370,21,31,104,8,135,283,297,376,390]),function(fe,e,l,N,L,A,R,w,p,E,M,C,v,S,y,u,m,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let $=0;$<process.execArgv.length;$++)process.execArgv[$]==="--inspect-port=0"&&(process.execArgv.splice($,1),$--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const d=globalThis._VSCODE_NODE_MODULES.module,$=d._load;d._load=function(D){if(D==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return $.apply(this,arguments)}})();const n=process.exit.bind(process),r=process.on.bind(process);function c(d){process.exit=function($){if(d)n($);else{const D=new Error("An extension called process.exit() and this was prevented.");console.warn(D.stack)}},process.crash=function(){const $=new Error("An extension called process.crash() and this was prevented.");console.warn($.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function($,D){$==="uncaughtException"&&(D=function(){try{return D.call(void 0,arguments)}catch{}}),r($,D)}}let t=function(d){n()};function f(){const d=(0,o.$0m)(process.env);if(d.type===3)return new Promise(($,D)=>{const b=g=>{const k=g[0],P=new R.$6h;k.on("message",F=>P.fire(C.$te.wrap(F.data))),k.on("close",()=>{t("renderer closed the MessagePort")}),k.start(),$({onMessage:P.event,send:F=>k.postMessage(F.buffer)})};process.parentPort.on("message",g=>b(g.ports))});if(d.type===2)return new Promise(($,D)=>{let b=null;const g=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),k=108e5,P=3e5,F=new y.$th(()=>t("renderer disconnected for too long (1)"),k),U=new y.$th(()=>t("renderer disconnected for too long (2)"),P);process.on("message",(T,I)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){I.setNoDelay(!0);const O=C.$te.wrap(Buffer.from(T.initialDataChunk,"base64"));let j;if(T.skipWebSocketFrames)j=new w.$8h(I,"extHost-socket");else{const G=C.$te.wrap(Buffer.from(T.inflateBytes,"base64"));j=new w.$9h(new w.$8h(I,"extHost-socket"),T.permessageDeflate,G,!1)}b?(F.cancel(),U.cancel(),b.beginAcceptReconnection(j,O),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(g),b=new R.$7h({socket:j,initialChunk:O}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),$(b),b.onSocketClose(()=>{F.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(U.isScheduled())return;F.isScheduled()&&U.schedule()}});const z={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(z)});{const $=d.pipeName;return new Promise((D,b)=>{const g=l.createConnection($,()=>{g.removeListener("error",b);const k=new R.$7h({socket:new w.$8h(g,"extHost-renderer")});k.sendResume(),D(k)});g.once("error",b),g.on("close",()=>{t("renderer closed the socket")})})}}async function h(){const d=await f();return new class{constructor(){this.a=new R.$6h,this.onMessage=this.a.event,this.b=!1,d.onMessage($=>{(0,E.$Jm)($,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire($)})}send($){this.b||d.send($)}async drain(){if(d.drain)return d.drain()}}}function s(d){return new Promise($=>{const D=d.onMessage(b=>{D.dispose();const g=JSON.parse(b.toString()),k=g.commit,P=p.default.commit;if(k&&P&&k!==P&&n(55),g.parentPid){let F=0;setInterval(function(){try{process.kill(g.parentPid,0),F=0}catch(z){z&&z.code==="EPERM"?(F++,F>=3&&t(`parent process ${g.parentPid} does not exist anymore (3 x EPERM): ${z.message} (code: ${z.code}) (errno: ${z.errno})`)):t(`parent process ${g.parentPid} does not exist anymore: ${z.message} (code: ${z.code}) (errno: ${z.errno})`)}},1e3);let U;try{U=globalThis._VSCODE_NODE_MODULES["native-watchdog"],U.start(g.parentPid)}catch(z){(0,A.$1)(z)}}d.send((0,E.$Im)(0)),$({protocol:d,initData:g})});d.send((0,E.$Im)(1))})}async function a(){const d=[];process.on("unhandledRejection",(F,U)=>{d.push(U),setTimeout(()=>{const z=d.indexOf(U);z>=0&&U.catch(T=>{d.splice(z,1),(0,A.$4)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),F&&(0,A.$1)(F))})},1e3)}),process.on("rejectionHandled",F=>{const U=d.indexOf(F);U>=0&&d.splice(U,1)}),process.on("uncaughtException",function(F){(0,A.$Z)(F)||(0,A.$1)(F)}),L.mark("code/extHost/willConnectToRenderer");const $=await h();L.mark("code/extHost/didConnectToRenderer");const D=await s($);L.mark("code/extHost/didWaitForInitData");const{initData:b}=D;c(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,u.boolean)(i.skipWorkspaceStorageLock,!1);const g=new class{constructor(){this.pid=process.pid}exit(U){n(U)}fsExists(U){return v.Promises.exists(U)}fsRealpath(U){return(0,S.$Kq)(U)}};let k=null;b.remote.authority&&i.transformURIs&&(k=(0,m.$fs)(b.remote.authority));const P=new M.$dkc(D.protocol,b,g,k);t=F=>P.terminate(F)}a().catch(d=>console.log(d))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b148975cafa8f034592310659f3dc989b124685c/core/vs/workbench/api/node/extensionHostProcess.js.map
